PROGRAM UNO;

DEVICE = mega328p;

{$I mega328P_Register.INC}



CONST

  // TaktFrequenz in KHz
  TaktFrequenz : WORD = 16000;

  // bei 16,000 MHz
  UBRR_VAL : Byte = 25;  // -> 38400 Baud
//  UBRR_VAL : Byte = 51;  // -> 19200 Baud



VAR

  LED_GELB[PortB, 5] : bit;

  Steuer_String : String[50];

{$I SYSTEM.INC}


// serielle Schnittstelle ohne Interrupt
{$I mega328P_UART_oI.INC}



procedure InitPorts;
begin
  DDRB:=  %11111111;
  DDRC:=  %11111111;
  DDRD:=  %11111100;
end InitPorts;









procedure procedure_a;
begin
  SetBit(LED_GELB);
  Write_String:='a gedrueckt';
  WriteLn_SER;
end procedure_a;




procedure procedure_b;
begin
  ClearBit(LED_GELB);
  Write_String:='b gedrueckt';
  WriteLn_SER;
end procedure_b;




procedure procedure_c;
begin

  Write_String:='c gedrueckt';
  WriteLn_SER;

end procedure_c;




procedure Steuer_String_auswerten;
var
  Buchstabe : Char;
  Zeichen_1 : Char;
  Zeichen_2 : Char;
  Laenge : Byte;
begin
  Laenge:=Length(Steuer_String);

  if Laenge>0 then
    Buchstabe:=Steuer_String[1];
    case Buchstabe of

            // a
      'a' : if Laenge=1 then
              procedure_a;
            else
              Write_String:='x01';
              WriteLn_SER;
            endif;
       |


            // b
      'b' : if Laenge=1 then
              procedure_b;
            else
              Write_String:='x02';
              WriteLn_SER;
            endif;
       |


            // c
      'c' : if Laenge=1 then
              procedure_c;
            else
              Write_String:='x03';
              WriteLn_SER;
            endif;
       |

    else
      Write_String:='x09';
      WriteLn_SER;
    endcase;

  endif; { if Laenge>0 then }

end Steuer_String_auswerten;






procedure Steuer_String_lesen;
var
  akt_Zeichen : Char;
begin
  if SER_Zeichen<>$0D then // 0D wird ignoriert

    if SER_Zeichen=$0A then  // bei 0A wird ausgerwertet
      Steuer_String_auswerten;
      Steuer_String:='';
    else
      akt_Zeichen:=ByteToChar(SER_Zeichen);
      Steuer_String:= Steuer_String + akt_Zeichen; // sonst nur abgespeichert
    endif; { if akt_Zeichen<>char($0A) }

  endif; { if akt_Zeichen<>char($0D) then }

end Steuer_String_lesen;








BEGIN


  InitPorts;

  INIT_SER_PORT;



  loop


    RX_Puffer_abfragen;

    if SER_Zeichen>0 then
      Steuer_String_lesen;
    endif;


  endloop;



END UNO.
