
// ******************************
// *** serielle Schnittstelle ***
// ******************************


VAR
  SER1_Zeichen : Byte;
  SER1_warten : Boolean;


procedure INIT_SER1_PORT;
begin

{
 Initialisieren der seriellen Schnittstelle
 ---------------------------------------------

; festlegen der Baudrate fuer die serielle Schnittstelle
}
    UBRR1H := 0;
    UBRR1L := UBRR_VAL;

{
Bit 4 RXEN: Receiver Enable
Bit 3 TXEN: Transmitter Enable
}
    UCSR1B := %00011000;

{
URSEL UMSEL UPM1 UPM0 USBS UCSZ1 UCSZ0 UCPOL
    1     0    0    0    0     1     1     0
}
    UCSR1C := %10000110;


    SER1_warten:=false;


end INIT_SER1_PORT;





procedure RX1_Puffer_abfragen;
begin
  // wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt
  // ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
  if BitHigh(RXC1) then
    SER1_Zeichen:=UDR1;
  else
    SER1_Zeichen:=0;
  endif; { if BitHigh(RXC0) then }
end RX1_Puffer_abfragen;





procedure sende_Zeichen1(s_Zeichen : Byte);
begin
  // wenn UDRE0 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE0 = 0
  while BitLow(UDRE1) do
//    SetBit(LED_GRUEN); // gruen ein
  endwhile;

 // ClearBit(LED_GRUEN); // gruen aus

  UDR1:=s_Zeichen;

end sende_Zeichen1;





procedure sende_Zeichen1_XON(s_Zeichen : Byte);
begin


  while SER1_warten do

    SetBit(LED_BL);

    RX1_Puffer_abfragen;

    if SER1_Zeichen=XON then

      SER1_warten:=false;

    endif;

  endwhile; { while SER1_warten do }

  ClearBit(LED_BL);


  // wenn UDRE0 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE0 = 0
  while BitLow(UDRE1) do
  endwhile;

  UDR1:=s_Zeichen;

  SER1_warten:=true;

end sende_Zeichen1_XON;





procedure sende_HEX_Zeichen1(h_Zeichen : Byte);
var
  HexLow : Byte;
  HexHigh : Byte;
begin

  HexHigh:=h_Zeichen and $F0;
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  if HexHigh>9 then
    HexHigh:=HexHigh+55;
  else
    HexHigh:=HexHigh+48;
  endif;

  sende_Zeichen1(HexHigh);

  HexLow:=h_Zeichen and $0F;
  if HexLow>9 then
    HexLow:=HexLow+55;
  else
    HexLow:=HexLow+48;
  endif;

  sende_Zeichen1(HexLow);

  sende_Zeichen1($48); // H

end sende_HEX_Zeichen1;



procedure sende_HEX_Zeichen1_Ln(Wert_Byte : Byte);
begin
  sende_HEX_Zeichen1(Wert_Byte);
  sende_Zeichen1($0D); // CR
  sende_Zeichen1($0A); // LF
end sende_HEX_Zeichen1_Ln;






procedure Write_SER1;
var
  c1 : Char;
  Laenge : Byte;
  b1 : Byte;
  b2 : Byte;
begin

  Laenge:=Length(Write_String);
  for b1:=1 to Laenge do
    c1:=Write_String[b1];
    b2:=CharToByte(c1);
    sende_Zeichen1(b2);
  endfor;

end Write_SER1;




procedure WriteLn_SER1;
begin
  Write_SER1;
  sende_Zeichen1($0D); // CR
  sende_Zeichen1($0A); // LF
end WriteLn_SER1;








procedure Write_SER1_XON;
var
  c1 : Char;
  Laenge : Byte;
  b1 : Byte;
  b2 : Byte;
begin

  Laenge:=Length(Write_String);
  for b1:=1 to Laenge do
    c1:=Write_String[b1];
    b2:=CharToByte(c1);
    sende_Zeichen1_XON(b2);
  endfor;

end Write_SER1_XON;




procedure WriteLn_SER1_XON;
begin
  Write_SER1_XON;
  sende_Zeichen1_XON($0D); // CR
  sende_Zeichen1_XON($0A); // LF
end WriteLn_SER1_XON;






