

ASM;


; Verwaltung der Ports
; ---------------------

.equ 	port_control_b	= portb
.equ 	port_control_c	= portc
.equ 	port_adr_hig	= portd

.equ 	ddr_control_b	= ddrb
.equ 	ddr_control_c	= ddrc
.equ 	ddr_adr_hig	= ddrd



; *** port_control_b ***
.equ 	A18		= 0			; Adresse A18
.equ	LED_GE		= 2			; LED_GE -> gelbe LED



; *** port_control_c ***
.equ 	HSYNC		= 0			; Horizontale Synchronimpulse Pin 13
.equ 	VSYNC		= 1			; Vertikale Synchronimpulse Pin 14

.equ	START_CNT	= 2			; /START_CNT = Start des Zaehlers -> Low active
.equ	RESET_CNT	= 3			; RESET_CNT = Ruecksetzen des Zaehlers auf 0 -> High active

.equ 	WE		= 4			; /WE fuer SRAM
.equ 	OE		= 5			; /OE fuer SRAM



; VERTICAL LINE CONTROL
.equ 	VL_RESET	= 0			;
.equ 	VL_VER_IMP	= 1			;
.equ 	VL_OUT_VA	= 2			;
.equ 	VL_INC_VA	= 3			;
.equ 	VL_A18	        = 4			;


	lds	R16,tcnt1l
	cpi	R16,12
	brlo	LATFIX1			

LATFIX1:
	cpi	R16,13
	brlo	LATFIX2			

LATFIX2:
	cpi	R16,14
	brlo	LATFIX3			

LATFIX3:
	cpi	R16,15
	brlo	LATFIX4			

LATFIX4:

; HORIZONTAL SYNC LOW
	cbi	port_control_c, HSYNC


	push	R17

	push	zl
	push	zh
	push	yl
	push	yh

	lds	yl, Wert_yl
	lds	yh, Wert_yh

	lds	R17, Wert_R17

;	sbi	port_control_b, LED_GE


; SET POINTER TO VLINE TABLE
	ldi	zl,low(2*VLINE)
	ldi	zh,high(2*VLINE)


; SET VLINE TABLE POSITION
	add	zl,yl
	adc	zh,yh


; READ VLINE TABLE BYTE
	lpm	R16,z


; INCREMENT VERTICAL ADDRESS
	sbrs	R16,VL_INC_VA
	inc	R17


; RESET VERTICAL ADDRESS
	sbrc	R16,VL_RESET
	ser	R17


; INCREMENT VLINE COUNTER
	adiw	yh:yl,1				


; RESET VLINE COUNTER
	sbrc	R16,VL_RESET			
	clr	yl
	sbrc	R16,VL_RESET			
	clr	yh

      	sts	Wert_yl, yl
	sts	Wert_yh, yh


; VERTICAL SYNC CONTROL
	sbrc	R16, VL_VER_IMP	
	cbi	port_control_c, VSYNC
	sbrs	R16, VL_VER_IMP		
	sbi	port_control_c, VSYNC


; HORIZONTAL SYNC HIGH
	sbi	port_control_c, HSYNC


; Setzen oder Ruecksetzen von A18
	sbrc	R16, VL_A18
	sbi	port_control_b, A18
	sbrs	R16, VL_A18
	cbi	port_control_b, A18



; SET VERTICAL ADDRESS
	sbrc	R16,VL_OUT_VA
	out	port_adr_hig,R17

	sts	Wert_R17, R17


; CONTROL ACTIVE LINES
	sbrs	R16,VL_OUT_VA
	rjmp	NOVID


; (4)

; Ruecksetzen des Zaehlers
	sbi		port_control_c, RESET_CNT	; 2

; SET SRAM TO READ
	cbi		port_control_c, OE		; 2
	cbi		port_control_c, RESET_CNT	; 2

; (10)

; Starten des Zaehlers
	sbi		port_control_c, START_CNT	; 2


	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

; (100)

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

; (200)


	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

 	nop
	nop									; 1
	nop
 	nop
	nop									; 1
	nop
	nop
 	nop
	nop									; 1
	nop

	nop
 	nop
	nop									; 1
	nop
	nop
 	nop
	nop									; 1
	nop
	nop
 	nop

; 300


	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop



 	nop
	nop									; 1
	nop
 	nop
	nop									; 1
	nop
	nop
 	nop
	nop									; 1
	nop

	nop
 	nop
	nop									; 1
	nop
	nop
 	nop
	nop									; 1
	nop
	nop
 	nop

; 400



	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

 	nop
	nop									; 1
	nop
 	nop
	nop									; 1
	nop
	nop
 	nop
	nop									; 1
	nop

	nop
 	nop
	nop									; 1
	nop
	nop
 	nop
	nop									; 1
	nop
	nop
 	nop

; 500


	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop												; 1

	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop
	nop									; 1
	nop

 	nop
	nop									; 1
	nop
 	nop
	nop									; 1
	nop
	nop
 	nop
	nop									; 1
	nop

	nop
 	nop
	nop									; 1
	nop
	nop
 	nop
	nop									; 1
	nop
;	nop
; 	nop

; 600



	cbi		port_control_c, START_CNT	; 2
	sbi		port_control_c, OE


; -----------------------------------------------



; BLANKING LINES EXIT POINT
NOVID:

	pop	yh
	pop	yl
	pop	zh
	pop	zl

	pop	r17
               

ENDASM;



