PROGRAM VIDEO2;

DEVICE = MEGA48;

{$I MEGA48_Register.INC}

{$I mega48_TC.INC}



CONST


  // TaktFrequenz in KHz
  TaktFrequenz : WORD = 22118;

  // TaktFrequenz in MHz
  TaktFrequenz_MHz : WORD = 22;



  // Frequenz = 22.1184 MHz;
  //CTC_WERT = 3175*22.1184/100 -> 22.1184 ist Frequenz in MHz
  // CTC_WERT : Word = 3175*TaktFrequenz_MHz/100;
  // 702 / 566; 744 / 600
  CTC_WERT : Word = 712;   // 744






{$I VLINE.INC}



VAR

  LED_GE[PortB, 2]  : bit; // A

  HSYNC[PortC, 0]  : bit; // A
  VSYNC[PortC, 1]  : bit; // A
  START_CNT[PortC, 2]  : bit; // A
  RESET_CNT[PortC, 3]  : bit; // A
  WE[PortC, 4]  : bit; // A
  OE[PortC, 5]  : bit; // A

  VCON_A10[PortD, 0]  : bit; // A
  VCON_A11[PortD, 1]  : bit; // A
  VCON_A12[PortD, 2]  : bit; // A
  VCON_A13[PortD, 3]  : bit; // A
  VCON_A14[PortD, 4]  : bit; // A
  VCON_A15[PortD, 5]  : bit; // A
  VCON_A16[PortD, 6]  : bit; // A
  VCON_A17[PortD, 7]  : bit; // A
  VCON_A18[PortB, 0]  : bit; // A

  Steuer_String : String[20];

  Wert_yl, Wert_yh,
  Wert_R17 : Byte;


// System (WaitMS)
{$I SYSTEM.INC}



procedure InitPorts;
begin

{
B0 - VCON_18 - A -> L
B2 - LED_GE  - A -> L
}
  //       EEEEEAAA
  DDRB:=  %00000111;

  // PORT B Voreinstellungen
  PORTB:= %00000000;


{
C0 - HSYNC     - A -> L
C1 - VSYNC     - A -> L
C2 - START_CNT - A -> L
C3 - RESET_CNT - A -> L
C4 - /WE       - A -> H
C5 - /OE       - A -> H
}
  // PORT C Voreinstellungen
  PortC:= %01001100;

  //       EEAAAAAA
  DDRC:=  %00111111;


{
D0..D7 = Daten
}
  // PORT D Voreinstellungen
  PortD:= %00000000;

  //       AAAAAAAA
  DDRD:=  %11111111;


end InitPorts;





isr TIMER1_COMPA;
begin

{$I VIDEO.INC}

end TIMER1_COMPA;





// ************************************



BEGIN

  InitPorts;

  Init_TIMER1_COMPA(CTC_WERT);
  Wert_yl:=0;
  Wert_yh:=0;
  Wert_R17:=0;


  ClearBit(LED_GE);

  ClearBit(HSYNC);
  ClearBit(VSYNC);
  ClearBit(START_CNT);
  ClearBit(RESET_CNT);

  SetBit(WE);
  SetBit(OE);

  ClearBit(VCON_A10);
  ClearBit(VCON_A11);
  ClearBit(VCON_A12);
  ClearBit(VCON_A13);
  ClearBit(VCON_A14);
  ClearBit(VCON_A15);
  ClearBit(VCON_A16);
  ClearBit(VCON_A17);
  ClearBit(VCON_A18);

  SetBit(LED_GE);
  SetBit(RESET_CNT);
  Wait_ms(150);
  ClearBit(RESET_CNT);
  ClearBit(LED_GE);

  EnableInts;


  loop


  endloop;



END VIDEO2.
