

  SetBit(WE);
  SetBit(OE);


  ASM;


; Vereinbarungsteil
; -----------------

.EQU  C_A16 = 2
.EQU  C_A17 = 3
.EQU  C_A18 = 4

.EQU  C_WE  = 5
.EQU  C_OE  = 6

; Uebergabeparameter durch Compiler nach R0
.def Parameter1    = R0
.def Parameter_ZH0 = R1
.def Parameter_ZH  = R2
.def Parameter_MZ  = R3

.def Farb_Speicher_01 = R4
.def Farb_Speicher_02 = R5
.def Farb_Speicher_03 = R6
.def Farb_Speicher_04 = R7
.def Farb_Speicher_05 = R8
.def Farb_Speicher_06 = R9
.def Farb_Speicher_07 = R10
.def Farb_Speicher_08 = R11

.def Wert_00H  = R12
.def Wert_88   = R13
.def Wert_FFH  = R14
.def Wert_1    = R15

.def TEMP01    = R16
.def CNT_Y     = R17
.def CNT_Y2    = R18

.def ADR_PORTB = R19
.def ADR_PORTC = R20
.def ADR_PORTD = R21

.def ADR_PORTB_von = R22
.def ADR_PORTC_von = R23
.def ADR_PORTD_von = R24

.def CNT_X     = R25


; Voreinstellungen
; ----------------


      LDI    TEMP01, 0x00
      MOV    Wert_00H, TEMP01
      LDI    TEMP01,  88
      MOV    Wert_88, TEMP01
      LDI    TEMP01, 0xFF
      MOV    Wert_FFH, TEMP01


      ; Loeschen von A16-A18
      CBI    PORTD, C_A16
      CBI    PORTD, C_A17
      CBI    PORTD, C_A18


      //  ADR_PORTC mit 0 laden
      MOV    ADR_PORTC, Wert_00H

      //  ADR_PORTD mit 0 laden
      MOV    ADR_PORTD, Wert_00H

      // PORTA auf Ausgang schalten
      OUT    DDRA, Wert_FFH
      OUT    PORTA, Parameter1


; Grosse Schleife fuer die 480 Zeilen
; -----------------------------------


      LDI    CNT_Y2, 8

      ; 7 x 64 Schleifen (=448) plus ...
clear_RAM_F:

      LDI    CNT_Y, 64
      CALL   clear_RAM_E

      DEC    CNT_Y2
      BRNE   clear_RAM_F


      ; ... 32 Schleifen sind 480 Zeilen
      LDI    CNT_Y, 32
      CALL   clear_RAM_E


      JMP    clear_RAM_Y



clear_RAM_E:

      // setzen vo A16-A18 nach dem Wert von ADR_PORTD
      SBRC   ADR_PORTD, 0
      SBI    PORTD, C_A16
      SBRS   ADR_PORTD, 0
      CBI    PORTD, C_A16

      SBRC   ADR_PORTD, 1
      SBI    PORTD, C_A17
      SBRS   ADR_PORTD, 1
      CBI    PORTD, C_A17

      SBRC   ADR_PORTD, 2
      SBI    PORTD, C_A18
      SBRS   ADR_PORTD, 2
      CBI    PORTD, C_A18



; Schreiben von CNT_Y Zeilen
; --------------------------

clear_RAM_D:
      //  ADR_PORTB mit 0 laden
      MOV    ADR_PORTB, Wert_00H


; Schreiben einer Zeile
; ---------------------

; Schleife 1 pro Zeile (256 Punkte)
; ---------------------------------

      OUT    PORTC, ADR_PORTC

clear_RAM_A:
      OUT    PORTB, ADR_PORTB

      ; ClearBit(WE);
      CBI    PORTD, C_WE

      NOP
      NOP
      NOP
      NOP

      ; SetBit(WE)
      SBI    PORTD, C_WE
      INC    ADR_PORTB
      BRNE   clear_RAM_A

      INC    ADR_PORTC


; Schleife 2 pro Zeile (256 Punkte)
; ---------------------------------

      OUT    PORTC, ADR_PORTC

clear_RAM_B:
      OUT    PORTB, ADR_PORTB

      ; ClearBit(WE);
      CBI    PORTD, C_WE

      NOP
      NOP
      NOP
      NOP

      ; SetBit(WE)
      SBI    PORTD, C_WE
      INC    ADR_PORTB
      BRNE   clear_RAM_B

      INC    ADR_PORTC


; Schleife 3 pro Zeile (88 Punkte)
; --------------------------------

      OUT    PORTC, ADR_PORTC

clear_RAM_C:
      OUT    PORTB, ADR_PORTB

      ; ClearBit(WE);
      CBI    PORTD, C_WE

      NOP
      NOP
      NOP
      NOP

      ; SetBit(WE)
      SBI    PORTD, C_WE
      INC    ADR_PORTB
      CP     ADR_PORTB, WERT_88
      BRNE   clear_RAM_C

      INC    ADR_PORTC
      INC    ADR_PORTC

; Ende - Schreiben einer Zeile
; ----------------------------

      DEC    CNT_Y
      BRNE   clear_RAM_D


; Ende - Schreiben von CNT_Y Zeilen
; ---------------------------------

      INC    ADR_PORTD


; Ende des Unterprogramms
; -----------------------

      RET

; -----------------------
; -----------------------




clear_RAM_Y:




  ENDASM;

  SetBit(WE);

  DDRA:= %00000000;








