PROGRAM VGA;

// Version 0.7 vom 17.02.2016



DEVICE = mega1284P;

{$I mega1284_Register.INC}


{$I mega1284_TC.INC}




CONST

  // bei 20 MHz ->
  // TaktFrequenz in KHz
  TaktFrequenz : WORD = 20000;


  // bei 20 MHz
  UBRR_VAL : Byte = 1; // ->  625000
//  UBRR_VAL : Byte = 10; // -> 115200


  XON  : Byte = $11;
  XOFF : Byte = $13;


  // Frequenz = 20 MHz;
  //CTC_WERT = 3175*20/100 -> 20.000 ist Frequenz in MHz
  // CTC_WERT : Word = 3175*TaktFrequenz_MHz/100;
  CTC_WERT : Word = 635;

  CTC_Umschalt_Wert : Word = 200;


  // CTC_WERT : Word = 702;

  Laenge_BWS : Word = 1999; // 80x25 = 2000 (1..2000) oder (0..1999)


  // Anzahl_Spalten0 : Word = 79;  // 0..79 = 80
  Anzahl_Spalten0 : Word = 41;
  Anzahl_Spalten : Word = Anzahl_Spalten0+1; // 0..79 = 80

  Anzahl_Zeilen0 : Word = 24;                // 0..24 = 25
  Anzahl_Zeilen : Word = Anzahl_Zeilen0+1;   // 1..25 = 25


  // Werte fuer Font_Bez
  fnt_6x8 : Byte = 1;
  fnt_8x8 : Byte = 2;



  // Festwerte fuer Farben
  cl_White    : Byte = $FF; // %11111111
  cl_Black    : Byte = $00; // %00000000
  cl_Red      : Byte = $43; // %11000011
  cl_Green    : Byte = $4C; // %11001100
  cl_Blue     : Byte = $B0; // %11110000
  cl_Yellow   : Byte = $4F; // %11001100
  cl_Purple   : Byte = $73; // %11001100
  cl_Aqua     : Byte = $7C; // %11001100
  cl_Gray     : Byte = $6A; // %01101010
  cl_DarkGray : Byte = $2A; // %00101010



  // TerminalMode
  Normal_TM            : Byte = 0;
  IBM_ESC_TM           : Byte = 1;
  IBM_CSI_TM           : Byte = 2;
  IBM_CSI_TM_Par_1     : Byte = 3;
  IBM_CSI_TM_Par_2     : Byte = 4;
  IBM_CSI_TM_Par_3     : Byte = 5;
  IBM_GRAFIK_Par_1_TM  : Byte = 6;
  IBM_GRAFIK_Par_2_TM  : Byte = 7;




  // Monitor-Steuerzeichen
  Monitor_leer   : Byte = 00;
  Monitor_links  : Byte = 01;
  Monitor_rechts : Byte = 02;




// Font fuer 6x8 Zeichen
{$I font6x8.INC}


// Font fuer 8x8 Zeichen
{$I font8x8.INC}


// Startbild: CP/M on Z80
{$I CPM_ON_Z80.INC}





{$I VLINE.INC}



VAR

  HSYNC[PortD, 2] : bit; // A
  VSYNC[PortD, 3] : bit; // A
  G[PortD, 4]     : bit; // A
  WE[PortD, 5]    : bit; // A
  OE[PortD, 6]    : bit; // A
  A16[PortD,7]    : bit; // A


  Steuer_String : String[20];

  // Sicherungsspeicher fuer die Video-Register
  Wert_yl, Wert_yh,
  Wert_R17 : Byte;

  // Sicherungsspeicher fuer die Text und Grafik Unterprogramm-
  // Register und
  Save_R16, Save_R17, Save_R28, Save_R29,
  Save_R30, Save_R31,
  Save_SREG, Save_SP01, Save_SP02,
  Save_port_adr_low, Save_port_adr_hig,
  Save_port_dat, Save_ddr_dat, Save_port_control : Byte;
  Endlos_SP01, Endlos_SP02,
  Endlos_port_control,
  Endlos_SREG, Endlos_R16 : Byte;

  UP_schleife_aktiv : Boolean;



  FCOLOR, BCOLOR, PIXCOLOR,
  Zeichen : Byte;

  X_KUR_POS, Y_KUR_POS,
  X_PIX_POS, Y_PIX_POS,
  X_END_POS, Y_END_POS,
  Kursor_Schleife: Word;

  Kursor_sichtbar, Kursor_Ein,
  KurArr_Aktuell : Boolean;


  // Variablen zum Font
  Zeichenbreite, Zeichenhoehe,
  X_ANF, Y_ANF,
  max_Spalten0, max_Zeilen0,
  max_Spalten, max_Zeilen : Word;
  Font_Bez : Byte;



  Fuellbyte : Byte;

  BWS : Array [0..1999] of Byte; // 80x25 = 2000 (1..2000) oder (0..1999)
  BWS_Pos : Word;
  BWS_FCOLOR : Array [0..1999] of Byte;

  BWS_Offset : Word;  // sichtbarer Bereich

  Escape_Sequenz : String[10];

  TermMode : Byte;

  CSI_Parameter1, CSI_Parameter2,
  CSI_Parameter3 : Word;

  // Startbildschirm zeigt das Startimage an
  Startbildschirm : Boolean;
  Grafik_im_BWS : Boolean;

// System (WaitMS)
{$I SYSTEM.INC}





procedure InitPorts;
begin

{
A0 bis A7 -> Ausgang auf 0
}
  //       AAAAAAAA
  DDRA:=  %11111111;

  // PORT A Voreinstellungen
  PORTA:= %00000000;


{
A8 bis A15 -> Ausgang auf 0
}
  //       AAAAAAAA
  DDRB:=  %11111111;

  // PORT A Voreinstellungen
  PORTB:= %00000000;


{
C0..C7 = Daten
}
  //       EEEEEEEE
  DDRC:=  %00000000;

  // PORT C Voreinstellungen
  PortC:= %00000000;


{
D0 - RXD0      - E -> L
D1 - TXD0      - A -> L
D2 - HSYNC     - A -> L
D3 - VSYNC     - A -> L
D4 - G         - A -> H
D5 - /WE       - A -> H
D6 - /OE       - A -> H
D7 - A16       - A -> L
}

  //       AAAAAAAE
  DDRD:=  %11111110;

  // PORT D Voreinstellungen
  //       AOWGVHTR
  PortD:= %01110000;


end InitPorts;







procedure INIT_SER0_PORT;
begin

{
 Initialisieren der seriellen Schnittstelle
 ---------------------------------------------

; festlegen der Baudrate fuer die serielle Schnittstelle
}

    UBRR0H := 0;
    UBRR0L := UBRR_VAL;

{
Bit 4 RXEN: Receiver Enable
Bit 3 TXEN: Transmitter Enable
}
    UCSR0B := %00011000;

{
URSEL UMSEL UPM1 UPM0 USBS UCSZ1 UCSZ0 UCPOL
    1     0    0    0    0     1     1     0
}
    UCSR0C := %10000110;


end INIT_SER0_PORT;






isr TIMER1_COMPA;
begin

{$I VIDEO.INC}

end TIMER1_COMPA;








isr TIMER3_COMPA;
begin

{$I VIDEO2.INC}

end TIMER3_COMPA;







procedure clear_RAM;
VAR
  x1: Word;
  x2 : Word;
  Adresse : Word;

begin

  DDRC:=%11111111;
  PortC:=%11111111;
  SetBit(WE);

  Adresse:=0;

  for x1:=1 to 256 do

    for x2:=1 to 240 do
      PORTA:= Low(Adresse);
      PORTB:= High(Adresse);
      ClearBit(WE);
      Inc(Adresse);
      SetBit(WE);
    endfor;

  endfor;

  SetBit(WE);

  DDRC:= %00000000;

end clear_RAM;






// *** Basis-Programme ***





procedure Reset_Form;
begin

  FCOLOR:= cl_Black;
  BCOLOR:= cl_White;
  X_KUR_POS:= 0;
  Y_KUR_POS:= 0;

  X_PIX_POS:= X_ANF;
  Y_PIX_POS:= Y_ANF;

  // clear_RAM;

end Reset_Form;






PROCEDURE setze_Font(FontGroesse : Byte);
BEGIN
  Font_Bez:=FontGroesse;

  CASE FontGroesse OF

    fnt_6x8 : Zeichenbreite := 6;
              Zeichenhoehe  := 9; // 6 + 3 = 9

              X_ANF := 1;
              Y_ANF := 5;

              max_Spalten0:= 41;  // 0..41 = 42
              max_Spalten := 42;  // 1..42 = 42
              max_Zeilen0 := 24;  // 0..24 = 25
              max_Zeilen  := 25;  // 1..25 = 25

    |

    fnt_8x8 : Zeichenbreite := 8;
              Zeichenhoehe  := 9; // 6 + 3 = 9

              X_ANF := 1;
              Y_ANF := 5;

              max_Spalten0:= 31;  // 0..31 = 32
              max_Spalten := 32;  // 1..32 = 32
              max_Zeilen0 := 24;  // 0..24 = 25
              max_Zeilen  := 25;  // 1..25 = 25

    |

    ELSE


    ENDCASE;

END setze_Font;






// *********************************
// ***      Grafik-Routinen      ***
// *********************************









// schreibt ein Bild an die Position: X_PIX_POS / Y_PIX_POS
// ohne Transparenz
procedure schreibe_IMAGE_oT;
VAR
  x1: Byte;
  y1 : Byte;
  x_bis : Byte;
  y_bis : Byte;
  B_Wert : Byte;
  Adresse : Word;
  B_Pointer : Word;
  Offset : Word;

begin

  SetBit(WE);
  SetBit(OE);
  DDRC:= %11111111;

  // Berechnung der Adresse (1.Pixel)
  Adresse:=Y_PIX_POS;
  Adresse:=Adresse*256;
  Adresse:=Adresse+X_PIX_POS;

  B_Pointer:=0;

  // Laden und Berechnen der Bild-Breite
  x_bis:=CPM_ON_Z80[B_Pointer];
  Inc(B_Pointer);

  Offset:=ByteToWord(x_bis);
  Offset:=256-Offset;

  Dec(x_bis);

  // Laden und Berechnen der Bild-Hoehe
  y_bis:=CPM_ON_Z80[B_Pointer];
  Inc(B_Pointer);
  Dec(y_bis);


  // Kopieren des Bildes
  for y1:=0 to y_bis do

    for x1:=0 to x_bis do

      B_Wert:=CPM_ON_Z80[B_Pointer];
      PortC:= B_Wert;

      PORTA:= Low(Adresse);
      PORTB:= High(Adresse);

      ClearBit(WE);
      Inc(Adresse);
      Inc(B_Pointer);
      SetBit(WE);

    endfor; { for x1:=0 to x_bis do }

    Adresse:=Adresse+Offset;

  endfor; { for x2:=0 to y_bis do }


  // Grundeinstellungen
  SetBit(WE);


end schreibe_IMAGE_oT;
















// ***********************
// *** Zeichen-Ausgabe ***
// ***********************




// schreibt ein Zeichen in die aktuelle RamPage
// ohne Kursorbewegung
procedure Write_Char_6x8;
var
  FontPtr : Word;
  x_cnt : Word;
  y_cnt : Word;
  FontColor : Byte;
  FontZeile : Byte;
  Adresse : Word;
begin

  DDRC:= %11111111;

  SetBit(WE);


  // Zeiger auf Zeichen in der Zeichentabelle
  FontPtr:=ByteToWord(Zeichen);
  FontPtr:=FontPtr-$20;
  FontPtr:=FontPtr*8;


  // Berechnung der Adresse (1.Pixel)
  Adresse:=Y_PIX_POS;
  Adresse:=Adresse*256;
  Adresse:=Adresse+X_PIX_POS;


  for y_cnt:=0 to 7 do

    FontZeile:=font6x8[FontPtr];
    INC(FontPtr);
    SHR(FontZeile);
    SHR(FontZeile);

    for x_cnt:=1 to Zeichenbreite do

      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        PORTC:= BCOLOR;
      else
        PORTC:= FCOLOR;
      endif;

      PORTA:= Low(Adresse);
      PORTB:= High(Adresse);

      ClearBit(WE);
      SHR(FontZeile);
      INC(Adresse);
      SetBit(WE);

    endfor; { for x_cnt:=0 to 5 do }

    Adresse:=Adresse+250; // Adresse + PixelProZeile - Zeichenbreite

  endfor; { for y_cnt:=0 to 7 do }



  // Grundeinstellungen
  SetBit(WE);
  DDRC:= %00000000;

end Write_Char_6x8;






// schreibt ein Zeichen in die aktuelle RamPage
// ohne Kursorbewegung
procedure Write_Char_8x8;
var
  FontPtr : Word;
  x_cnt : Word;
  y_cnt : Word;
  FontColor : Byte;
  FontZeile : Byte;
  Adresse : Word;
begin

  DDRC:= %11111111;

  SetBit(WE);


  // Zeiger auf Zeichen in der Zeichentabelle
  FontPtr:=ByteToWord(Zeichen);
  FontPtr:=FontPtr-$20;
  FontPtr:=FontPtr*8;


  // Berechnung der Adresse (1.Pixel)
  Adresse:=Y_PIX_POS;
  Adresse:=Adresse*256;
  Adresse:=Adresse+X_PIX_POS;


  for y_cnt:=0 to 7 do

    FontZeile:=font8x8[FontPtr];
    INC(FontPtr);

    for x_cnt:=1 to Zeichenbreite do

      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        PORTC:= BCOLOR;
      else
        PORTC:= FCOLOR;
      endif;

      PORTA:= Low(Adresse);
      PORTB:= High(Adresse);

      ClearBit(WE);
      SHR(FontZeile);
      INC(Adresse);
      SetBit(WE);

    endfor; { for x_cnt:=0 to 5 do }

    Adresse:=Adresse+248; // Adresse + PixelProZeile - Zeichenbreite

  endfor; { for y_cnt:=0 to 7 do }



  // Grundeinstellungen
  SetBit(WE);
  DDRC:= %00000000;

end Write_Char_8x8;







procedure Write_Char;
begin

  CASE Font_Bez OF
    fnt_6x8 : Write_Char_6x8;
    |
    fnt_8x8 : Write_Char_8x8;
    |
  ENDCASE;

end Write_Char;














// *** Hilfsprogramme fuer CONOUT ***




// Erhoeht die Kursorposition der aktuellen Zeile um 1
//     (wenn die max_Spalten noch nicht erreicht ist)
procedure CURSOR_RIGHT;
begin

  if X_KUR_POS<max_Spalten0 then
    Inc(X_KUR_POS);
    X_PIX_POS:=X_PIX_POS+Zeichenbreite;
  endif;

end CURSOR_RIGHT;





procedure CURSOR_UP;
begin
  if Y_KUR_POS>0 then
    DEC(Y_KUR_POS);
    Y_PIX_POS:=Y_PIX_POS-Zeichenhoehe;
  endif;
end CURSOR_UP;





// Erhoeht die Kursorposition der aktuellen Zeile um 1
//     (wenn die max_Spalten noch nicht erreicht ist)
procedure CURSOR_DOWN;
begin

  if Y_KUR_POS<max_Zeilen0 then
    Inc(Y_KUR_POS);
    Y_PIX_POS:=Y_PIX_POS+Zeichenhoehe;
  endif;

end CURSOR_DOWN;






procedure DELETE_EOL;
begin


end DELETE_EOL;





procedure ERASE_DOWN;
begin


end ERASE_DOWN;





procedure DELETE_LINE;
begin


end DELETE_LINE;




procedure DELETE_BOL;
begin


end DELETE_BOL;




procedure INSERT_LINE_SCR_ROLL;
begin


end INSERT_LINE_SCR_ROLL;




procedure DELETE_LINE_SCR_ROLL;
begin


end DELETE_LINE_SCR_ROLL;







procedure SET_CURSOR_POSITION(Zeile, Spalte : Word); // bezogen auf 0,0 !!!
begin

  // 1. Zeile setzen
  X_KUR_POS:=Spalte;

  if X_KUR_POS>max_Spalten0 then
    X_KUR_POS:=max_Spalten0;
  endif;

  X_PIX_POS:=X_KUR_POS*Zeichenbreite;
  X_PIX_POS:=X_PIX_POS+X_ANF;

  // 2. Spalte setzen
  Y_KUR_POS:=Zeile;

  if Y_KUR_POS>max_Zeilen0 then
    Y_KUR_POS:=max_Zeilen0;
  endif;

  Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  Y_PIX_POS:=Y_PIX_POS+Y_ANF;

end SET_CURSOR_POSITION;



















// ******************************************
//
//       Hilfsprogramme fuer BWS
//
// ******************************************




// 000..040, 041..079
// 080..120, 121..159

procedure Anzeige_BWS;
var
  x1 : Word;
  y1 : Word;
  Offset_Spalten : Word;
  Sicherung_FCOLOR : Byte;
begin

  Sicherung_FCOLOR:=FCOLOR;

  // clear_RAM;
  BWS_Offset:=0;
  Reset_Form;


  BWS_Pos:=BWS_Offset;  // 0
 // Offset_Spalten:=Anzahl_Spalten0-max_Spalten;  // x2=79-42=37
 Offset_Spalten:=0;


  for y1:=1 to max_Zeilen do

    for x1:=1 to max_Spalten do
      Zeichen:=BWS[BWS_Pos];
      FCOLOR:=BWS_FCOLOR[BWS_Pos];

      Write_Char;
      CURSOR_RIGHT;

      Inc(BWS_Pos);
    endfor;

    CURSOR_DOWN;
    X_KUR_POS:=0;
    X_PIX_POS:=X_ANF;

  //  Inc(BWS_Pos);

  endfor;

  Reset_Form;
  BWS_Pos:=BWS_Offset;  // 0
  FCOLOR:=Sicherung_FCOLOR;

end Anzeige_BWS;






procedure Schreibe_Zeichen_in_BWS;
begin
  BWS[BWS_Pos]:=Zeichen;
  BWS_FCOLOR[BWS_Pos]:=FCOLOR;

  if BWS_Pos<Laenge_BWS then
    Inc(BWS_Pos);
  endif;

end Schreibe_Zeichen_in_BWS;






procedure Screen_Roll_Up;
var
  w1 : Word;
  w2 : Word;
  w3 : Word;
  Kopie_Zeichen : Byte;
  Kopie_FCOLOR : Byte;
begin

  // 0..1049
  // 24*42=1008
  w3:=Anzahl_Zeilen0*Anzahl_Spalten;
  // 1008-1=1007
  DEC(w3);
  w2:=Anzahl_Spalten;

  // w3 = 1007 (erster Wert der letzten Zeile)
  // w2 = 42

  for w1:=0 to w3 do
    Kopie_Zeichen:=BWS[w2];
    Kopie_FCOLOR:=BWS_FCOLOR[w2];
    BWS[w1]:=Kopie_Zeichen;
    BWS_FCOLOR[w1]:=Kopie_FCOLOR;
    Inc(w2);
  endfor;

  Inc(w3);

  for w1:=w3+1 to Laenge_BWS do
    BWS[w1]:=Fuellbyte;
    BWS_FCOLOR[w1]:=cl_Black;
  endfor;

  BWS_Pos:=w3;

end Screen_Roll_Up;










procedure loesche_BWS;
var
  Zeichen_Zaehler : Word;
begin

  for Zeichen_Zaehler:=0 to Laenge_BWS do
    BWS[Zeichen_Zaehler]:=Fuellbyte;
    BWS_FCOLOR[Zeichen_Zaehler]:=cl_Black;
  endfor; { for Zeichen_Zaehler:=0 to Laenge_BWS do }

  BWS_Pos:=0;

end loesche_BWS;




procedure berechne_BWS_Pos;
var
  p1 : Word;
begin

  BWS_Pos:=Y_KUR_POS*max_Spalten;
  BWS_Pos:=BWS_Pos+X_KUR_POS;

end berechne_BWS_Pos;








procedure Schalte_Kursor_Ein;
begin

  // Kursor schreiben
  Zeichen:=$5F;

  Write_Char;

end Schalte_Kursor_Ein;





procedure Schalte_Kursor_Aus;
var
  altes_Zeichen : Byte;
begin

  altes_Zeichen:=Zeichen;

  berechne_BWS_Pos;

  // Zeichen schreiben
  Zeichen:=BWS[BWS_Pos];

  Write_Char;

  Zeichen:=altes_Zeichen;

end Schalte_Kursor_Aus;












// *********************
// *** TERMINAL MODE ***
// *********************










procedure Normal_Terminal_Mode;
var
  x1 : Word;
  y1 : Word;
begin

  case Zeichen of


   Monitor_links : FCOLOR:=cl_Black;
    |

   Monitor_rechts : FCOLOR:=cl_Red;
    |


    $0A :   // 0A = Zeilenschaltung (Line Feed)
            // Y_KUR_POS von 0..24 = 25 Zeilen pro Bildschirm
            if Y_KUR_POS<max_Zeilen0 then
              INC(Y_KUR_POS);
              Y_PIX_POS:= Y_PIX_POS+Zeichenhoehe;
            else


              UP_schleife_aktiv:=true;

              if Grafik_im_BWS then
                clear_RAM;
                Grafik_im_BWS:=false;
              endif;

              Screen_Roll_Up;
              Anzeige_BWS;

              UP_schleife_aktiv:=false;


              X_KUR_POS:=0;
              X_PIX_POS:=X_ANF;
              Y_KUR_POS:=max_Zeilen0;
              Y_PIX_POS:=max_Zeilen0*Zeichenhoehe;
              Y_PIX_POS:=Y_PIX_POS+Y_ANF;

            endif;
            berechne_BWS_Pos;

    |

   $0C :    // 0C = Bildschirm loeschen (Clear Screen)

            UP_schleife_aktiv:=true;

            loesche_BWS;
            Anzeige_BWS;
            Reset_Form;

            if Startbildschirm then

              schreibe_IMAGE_oT;

              Y_KUR_POS:= 5;
              Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
              Y_PIX_POS:=Y_PIX_POS+Y_ANF;

              Startbildschirm:=false;
              Grafik_im_BWS:=true;

            endif;

            berechne_BWS_Pos;

            UP_schleife_aktiv:=false;

    |

    $0D :   // 0D = Wagenruecklauf (Carridge Return)
            X_KUR_POS:=0;
            X_PIX_POS:=X_ANF;
            berechne_BWS_Pos;

    |

    $1B :   // ESC-Modus
            TermMode:=IBM_ESC_TM;

    |

  else


    if Zeichen>=$20 then
      if Zeichen<=$7F then
        if X_KUR_POS<max_Spalten0 then

          Schalte_Kursor_Aus;
          Kursor_sichtbar:=false;
          Kursor_Schleife:=0;
          KurArr_Aktuell:=true;

          Write_Char;
          CURSOR_RIGHT;

          Schreibe_Zeichen_in_BWS;

          berechne_BWS_Pos;

        endif; { if X_KUR_POS<80 then }




      endif; { if Zeichen<=$7F then }
    endif; { if Zeichen>=$20 then  }

  endcase; { case Zeichen of }


end Normal_Terminal_Mode;







procedure Escape_Reset;
begin
  CSI_Parameter1:=0;
  CSI_Parameter2:=0;
  CSI_Parameter3:=0;
  TermMode:=Normal_TM;
  Escape_Sequenz:='';
end Escape_Reset;






procedure Escape_Fehler;
var
  ESC_Zaehler : Byte;
  ESC_Laenge  : Byte;
  ESC_Zeichen : Char;
begin

  Zeichen:=$45; // E
  Write_Char;

  Zeichen:=$53; // S
  Write_Char;

  Zeichen:=$43; // C
  Write_Char;

  ESC_Laenge:=Length(Escape_Sequenz);

  for ESC_Zaehler:=1 to ESC_Laenge do
    ESC_Zeichen:=Escape_Sequenz[ESC_Zaehler];
    Zeichen:=CharToByte(ESC_Zeichen);
    Write_Char;
  endfor;

  Escape_Reset;
end Escape_Fehler;




procedure IBM_ESC_Terminal_Mode;
begin

  case Zeichen of

    $5B : TermMode:=IBM_CSI_TM; // Control Sequence Introducer (CSI) = ESC [
    |

    $47 : TermMode:=IBM_GRAFIK_Par_1_TM; // GRAFIK-Mode = ESC G
    |

  else

    Escape_Fehler;

  endcase;

end IBM_ESC_Terminal_Mode;







procedure Set_Display_Attributes(DispAttr : Word);
begin


  case DispAttr of

    // *** Textattribute ***


    // ESC [ 0 m = Alle Attribute AUS (Reset all attributes)
    0 : FCOLOR:=cl_Blue;
    |

    // ESC [ 1 m = Fett ein
    1 : FCOLOR:=cl_Gray;
    |

    // ESC [ 4 m = Unterstreichen
    4 : FCOLOR:=cl_Purple;
    |

    // ESC [ 5 m = Blinken EIN
    5 : FCOLOR:=cl_Red;
    |

    // ESC [ 7 m = Invertierte Darstellung
    7 : FCOLOR:=cl_Black;
    |

    // ESC [ 8 m = Versteckt ein
    8 : FCOLOR:=cl_White;
    |



   // *** Schriftgroesse ***

    // ESC [ 11 m = Font 6x8
    11 :   setze_Font(fnt_6x8);
    |

    // ESC [ 12 m = Font 8x8
    12 :   setze_Font(fnt_8x8);
    |


    // *** Vordergrundfarben ***

    // ESC [ 30 m = Vordergrundfarbe - 30 Schwarz
    30 : FCOLOR:=cl_Black;
    |

    // ESC [ 31 m = Vordergrundfarbe - 31 Rot
    31 : FCOLOR:=cl_Red;
    |

    // ESC [ 32 m = Vordergrundfarbe - 32 Grn
    32 : FCOLOR:=cl_Green;
    |

    // ESC [ 33 m = Vordergrundfarbe - 33 Gelb
    33 : FCOLOR:=cl_Yellow;
    |

    // ESC [ 34 m = Vordergrundfarbe - 34 Blau
    34 : FCOLOR:=cl_Blue;
    |

    // ESC [ 35 m = Vordergrundfarbe - 35 Karmesinrot (Purpur, lila)
    35 : FCOLOR:=cl_Purple;
    |

    // ESC [ 36 m = Vordergrundfarbe - 36 Cyanblau
    36 : FCOLOR:=cl_Aqua;
    |

    // ESC [ 37 m = Vordergrundfarbe - 37 Wei
    37 : FCOLOR:=cl_White;
    |



    // *** Hintergrundfarben ***

    // ESC [ 40 m = Hintergrundfarbe - 40 Schwarz
    40 : BCOLOR:=cl_Black;
    |

    // ESC [ 41 m = Hintergrundfarbe - 41 Rot
    41 : BCOLOR:=cl_Red;
    |

    // ESC [ 42 m = Hintergrundfarbe - 42 Grn
    42 : BCOLOR:=cl_Green;
    |

    // ESC [ 43 m = Hintergrundfarbe - 43 Gelb
    43 : BCOLOR:=cl_Yellow;
    |

    // ESC [ 44 m = Hintergrundfarbe - 44 Blau
    44 : BCOLOR:=cl_Blue;
    |

    // ESC [ 45 m = Hintergrundfarbe - 45 Karmesinrot (Purpur, lila)
    45 : BCOLOR:=cl_Purple;
    |

    // ESC [ 46 m = Hintergrundfarbe - 46 Cyanblau
    46 : BCOLOR:=cl_Aqua;
    |

    // ESC [ 47 m = Hintergrundfarbe - 47 Wei
    47 : BCOLOR:=cl_White;
    |

    else
      Escape_Fehler;
    endcase;

end Set_Display_Attributes;








procedure IBM_CSI_Terminal_Mode;
begin

  case Zeichen of

    48..57 : CSI_Parameter1:=ByteToWord(Zeichen)-$30;
             TermMode:=IBM_CSI_TM_Par_1;
    |

    $4B : // Loeschen bis Zeilenende = ESC [ K
          DELETE_EOL;
          Escape_Reset;
    |

    $66 : // Schirm loeschen = ESC [ f

          UP_schleife_aktiv:=true;

          loesche_BWS;
          Anzeige_BWS;
          Reset_Form;

          if Grafik_im_BWS then
            clear_RAM;
            Grafik_im_BWS:=false;
          endif;

          berechne_BWS_Pos;

          UP_schleife_aktiv:=false;

          Escape_Reset;
    |

    $6D : // Turn off character attributes = ESC [ m
          Set_Display_Attributes(0);
          Escape_Reset;
    |

    $3F : // Hide/Show the cursor = ESC [ ? 2 5 h
          CSI_Parameter1:=0;
          TermMode:=IBM_CSI_TM_Par_1;
    |

    $48 : // "H" -- MOVE CURSOR = ESC [ H
          SET_CURSOR_POSITION(0,0);
          Escape_Reset;
    |

    $4A : // "J" -- Erase Down = ESC [ J
          // Erases the screen from the current line down to the bottom of the screen.
          ERASE_DOWN;
          Escape_Reset;
    |

    $4D : // "M" -- Move the cursor up in scrolling region = ESC [ M
          DELETE_LINE;
          CURSOR_UP;
          DELETE_LINE;
          Escape_Reset;
    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }

end IBM_CSI_Terminal_Mode;










// IBM_CSI_TM_Par_1
procedure IBM_CSI_Par_1_Terminal_Mode;
var
  Zaehler : Word;
begin

  case Zeichen of

    48..57 : CSI_Parameter1:=CSI_Parameter1*10;
               CSI_Parameter1:=CSI_Parameter1+ByteToWord(Zeichen);
               CSI_Parameter1:=CSI_Parameter1-$30;

               TermMode:=IBM_CSI_TM_Par_1;
    |

    $3B :      // ";"
	       // ESC [ Pn1 ; PN2 H oder
	       // ESC [ Pn1 ; PN2 f oder
               // ESC [ Pn1 ; PN2 m oder
	       // Xterm 256 colors - ESC[48;5;BCOLOR m oder
	       // Xterm 256 colors - ESC[38;5;FCOLOR m
               TermMode:=IBM_CSI_TM_Par_2;

    |

    $4A : // Zeilen loeschen = ESC [ Pn J

          case CSI_Parameter1 of

            2 : // Loeschen gesammte zeile
                Reset_Form;

            |
          else
            Escape_Fehler;
          endcase;
          Escape_Reset;
    |


    $4B : // Zeilen loeschen = ESC [ Pn K

          case CSI_Parameter1 of

            0 : // Lschen bis Zeilenende
                DELETE_EOL;
            |

            1 : // Lschen von Anfang bis Kursor
                DELETE_BOL;
            |

            2 : // Lschen gesammte zeile
                DELETE_LINE;
            |

          else
            Escape_Fehler;
          endcase;
          Escape_Reset;
    |


    $4C : // INSERT_LINE_SCR_ROLL = ESC [ Pn L
          for Zaehler:=0 to CSI_Parameter1-1 do
            INSERT_LINE_SCR_ROLL;
          endfor;
          Escape_Reset;
    |


    $4D : // "M" DELETE_LINE_SCR_ROLL = ESC [ Pn M
          for Zaehler:=0 to CSI_Parameter1-1 do
            DELETE_LINE_SCR_ROLL;
          endfor;
          Escape_Reset;
    |


    $6D : // "m" Character Attributes = ESC [ Pn m
          Set_Display_Attributes(CSI_Parameter1);
          Escape_Reset;
    |



    $6C : // "l" ESC [ ? X X l

          case CSI_Parameter1 of

            // "l" Text_Kursor_Aus = ESC [ ? 2 5 l
            25 : if Kursor_sichtbar then
                   Kursor_sichtbar:=false;
                   Schalte_Kursor_Aus;
                 endif;

                 Kursor_Ein:=false;
                 Escape_Reset;

            |

            // "l" Kopie_BWS_Aus AUS = ESC [ ? 2 6 l
            26 :  // KopieBWS:=false;
                 Escape_Reset;

            |

          else
            Escape_Fehler;
          endcase; { case CSI_Parameter1 of }

    |


    $68 : // "h" ESC [ ? X X h

          case CSI_Parameter1 of

            // "h" Text_Kursor_Ein = ESC [ ? 2 5 h
            25 : Kursor_Schleife:=0;
                 Kursor_Ein:=true;
                 Escape_Reset;

            |

            // "h" Kopie_BWS_Ein EIN = ESC [ ? 2 6 h
            26 : // KopieBWS:=true;
                 Escape_Reset;

            |



          else
            Escape_Fehler;
          endcase; { case CSI_Parameter1 of }

    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }

end IBM_CSI_Par_1_Terminal_Mode;








// IBM_CSI_TM_Par_2
procedure IBM_CSI_Par_2_Terminal_Mode;
begin

  case Zeichen of

    48..57 : CSI_Parameter2:=CSI_Parameter2*10;
               CSI_Parameter2:=CSI_Parameter2+ByteToWord(Zeichen);
               CSI_Parameter2:=CSI_Parameter2-$30;

               TermMode:=IBM_CSI_TM_Par_2;
    |

    $3B : // ";"
          // Xterm 256 colors - ESC[48;5;BCOLOR m
          // Xterm 256 colors - ESC[38;5;FCOLOR m
          TermMode:=IBM_CSI_TM_Par_3;
    |


    $48 : // "H" -- MOVE CURSOR = ESC [ Pn1 ; PN2 H
          SET_CURSOR_POSITION(CSI_Parameter1,CSI_Parameter2);
          Escape_Reset;
    |

    $66 : // "f" -- MOVE CURSOR = ESC [ Pn1 ; PN2 f
          SET_CURSOR_POSITION(CSI_Parameter1,CSI_Parameter2);
          Escape_Reset;
    |

    $6D : // "m" -- 2 mal Character Attributes = ESC [ Pn1 ; PN2 m
          Set_Display_Attributes(CSI_Parameter1);
          Set_Display_Attributes(CSI_Parameter2);
          Escape_Reset;

    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }


end IBM_CSI_Par_2_Terminal_Mode;





procedure IBM_CSI_Par_3_Terminal_Mode;
begin


  case Zeichen of

    48..57 : CSI_Parameter3:=CSI_Parameter3*10;
               CSI_Parameter3:=CSI_Parameter3+ByteToWord(Zeichen);
               CSI_Parameter3:=CSI_Parameter3-$30;

               TermMode:=IBM_CSI_TM_Par_3;

    |


    $6D : // "m"

          case CSI_Parameter1 of

          48 : // Xterm 256 colors - ESC[48;5;BCOLOR m
               if CSI_Parameter2=5 then
                 BCOLOR:=Low(CSI_Parameter3);
               else
                 Escape_Fehler;
               endif;
          |

          38 : // Xterm 256 colors - ESC[38;5;FCOLOR m
               if CSI_Parameter2=5 then
                 FCOLOR:=Low(CSI_Parameter3);
               else
                 Escape_Fehler;
               endif;
          |

          else
            Set_Display_Attributes(CSI_Parameter1);
            Set_Display_Attributes(CSI_Parameter2);
            Set_Display_Attributes(CSI_Parameter3);
          endcase;

          Escape_Reset;

    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }


end IBM_CSI_Par_3_Terminal_Mode;





// ESC G - Auswertung der ESC-Grafik-Steuerzeichen



procedure IBM_GRAFIK_Par_1_Terminal_Mode;
begin

  case Zeichen of

    48..57 : CSI_Parameter1:=CSI_Parameter1*10;
               CSI_Parameter1:=CSI_Parameter1+ByteToWord(Zeichen);
               CSI_Parameter1:=CSI_Parameter1-$30;

               TermMode:=IBM_GRAFIK_Par_1_TM;

    |

    $3B : // ";"
          TermMode:=IBM_GRAFIK_Par_2_TM;

    |

    $43 : // "C" -- Grafik_setze_Farbe = ESC G Pn1 C
          PIXCOLOR:=Low(CSI_Parameter1);
          Escape_Reset;

    |

    $4B : // "K" -- Grafik_zeichne_Kreis = ESC G Pn1 K
          // Grafik_zeichne_Kreis(CSI_Parameter1);
          Escape_Reset;

    |

    $56 : // "V" -- Grafik_zeichne_vollen_Kreis = ESC G Pn1 V
          // Grafik_zeichne_vollen_Kreis(CSI_Parameter1);
          Escape_Reset;

    |


  else

    Escape_Fehler;

  endcase; { case Zeichen of }


end IBM_GRAFIK_Par_1_Terminal_Mode;





procedure IBM_GRAFIK_Par_2_Terminal_Mode;
begin

  case Zeichen of

    48..57 : CSI_Parameter2:=CSI_Parameter2*10;
               CSI_Parameter2:=CSI_Parameter2+ByteToWord(Zeichen);
               CSI_Parameter2:=CSI_Parameter2-$30;

               TermMode:=IBM_GRAFIK_Par_2_TM;

    |

    $47 : // "G" -- Grafik_setze_Position = ESC G Pn1 ; Pn2 G
          X_PIX_POS:=CSI_Parameter1;
          Y_PIX_POS:=CSI_Parameter2;
          Escape_Reset;

    |

    $50 : // "P" -- Grafik_zeichne_Punkt = ESC G Pn1 ; Pn2 P
          X_PIX_POS:=CSI_Parameter1;
          Y_PIX_POS:=CSI_Parameter2;
          // Grafik_setze_Punkt;
          Escape_Reset;

    |

    $4C : // "L" -- Grafik_zeichne_Linie = ESC G Pn1 ; Pn2 L
          X_END_POS:=CSI_Parameter1;
          Y_END_POS:=CSI_Parameter2;
          // Grafik_zeichne_Linie;
          Escape_Reset;

    |

    $52 : // "R" -- Grafik_zeichne_Rechteck = ESC G Pn1 ; Pn2 R
          X_END_POS:=CSI_Parameter1;
          Y_END_POS:=CSI_Parameter2;
          // Grafik_zeichne_Rechteck;
          Escape_Reset;

    |

    $46 : // "F" -- Grafik_zeichne_volles_Rechteck = ESC G Pn1 ; Pn2 F
          X_END_POS:=CSI_Parameter1;
          Y_END_POS:=CSI_Parameter2;
          // Grafik_zeichne_volles_Rechteck;
          Escape_Reset;

    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }


end IBM_GRAFIK_Par_2_Terminal_Mode;








procedure CONOUT;
var
  C_Zeichen : Char;
begin

  if Kursor_sichtbar then
    Schalte_Kursor_Aus;
    Kursor_sichtbar:=false;
  endif;
  Kursor_Schleife:=0;
  KurArr_Aktuell:=false;

  // Abspeichern der Escape-Steuerzeichen fuer die
  // Anzeige der nicht ausgewerteter Sequenzen im Fehlerfall
  if TermMode<>Normal_TM then
    C_Zeichen:=ByteToChar(Zeichen);
    Escape_Sequenz:=Escape_Sequenz+C_Zeichen;
  endif;

  case TermMode of

    Normal_TM            : Normal_Terminal_Mode;
    |

    IBM_ESC_TM           : IBM_ESC_Terminal_Mode;
    |

    IBM_CSI_TM           : IBM_CSI_Terminal_Mode;
    |

    IBM_CSI_TM_Par_1     : IBM_CSI_Par_1_Terminal_Mode;
    |

    IBM_CSI_TM_Par_2     : IBM_CSI_Par_2_Terminal_Mode;
    |

    IBM_CSI_TM_Par_3     : IBM_CSI_Par_3_Terminal_Mode;
    |

    IBM_GRAFIK_Par_1_TM  : IBM_GRAFIK_Par_1_Terminal_Mode;
    |

    IBM_GRAFIK_Par_2_TM  : IBM_GRAFIK_Par_2_Terminal_Mode;
    |

  else

    Escape_Fehler;

  endcase;

end CONOUT;





procedure Text_an_CONOUT;
var
  b1 : Byte;
  b2 : Byte;
  c1 : Char;
begin

  b1:=Length(Write_String);

  for b2:=1 to b1 do

    c1:=Write_String[b2];
    Zeichen:=CharToByte(c1);
    CONOUT;

  endfor;

  Zeichen:=$0D;
  CONOUT;

  Zeichen:=$0A;
  CONOUT;

end Text_an_CONOUT;











// ******************************
// *** serielle Schnittstelle ***
// ******************************



procedure sende_Zeichen(s_Zeichen : Byte);
begin
  // wenn UDRE0 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE0 = 0
  while BitLow(UDRE0) do
 //   SetBit(LED_GN); // gruen ein
  endwhile;

//  ClearBit(LED_GN); // gruen aus

  UDR0:=s_Zeichen;

end sende_Zeichen;





procedure RX_Puffer_abfragen;
begin
  // wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt
  // ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
  if BitHigh(RXC0) then
    Zeichen:=UDR0;
    CONOUT;
    sende_Zeichen(XON);
  endif; { if BitHigh(RXC0) then }
end RX_Puffer_abfragen;









// ************************************



BEGIN


  Wait_ms(5);

  InitPorts;

  INIT_SER0_PORT;


  UP_schleife_aktiv:=false;   // 0 -> UP_schleife_aktiv

  Init_TIMER1_COMPA(CTC_WERT);   // mit Interrupt
  Init_TIMER3_COMPA(CTC_WERT);   // ohne Interrupt

  Startbildschirm:=true;
  Grafik_im_BWS:=false;

ASM;

	lds        zl, tcnt1l
	lds        zh, tcnt1h
        ldi        yl, 12
        ldi        yh, 0
	add	  zl,yl
	adc	  zh,yh

        nop

        sts       tcnt3h, zh
        sts       tcnt3l, zl

ENDASM;



  Wert_yl:=0;
  Wert_yh:=0;
  Wert_R17:=0;

  ClearBit(HSYNC);
  ClearBit(VSYNC);
  SetBit(G);
  SetBit(WE);
  SetBit(OE);
  ClearBit(A16);

ASM;

        ldi       R16, low(Anfangsmarke)
      	sts	  Save_SP01, R16

        ldi       R16, high(Anfangsmarke)
      	sts	  Save_SP02, R16


        ldi       R16, low(Endlosschleife)
      	sts	  Endlos_SP01, R16

        ldi       R16, high(Endlosschleife)
      	sts	  Endlos_SP02, R16


        in        R16, port_control
        sts       Endlos_port_control, R16


        in        R16, port_adr_low
        sts       Save_port_adr_low, R16

        in        R16, port_adr_hig
        sts       Save_port_adr_hig, R16

        in        R16, port_dat
        sts       Save_port_dat, R16

        in        R16, ddr_dat
        sts       Save_ddr_dat, R16

        in        R16, port_control
        sts       Save_port_control, R16


ENDASM;


// Grundkonfigurationen

  // Fuellbyte:=$2E;    // .
  Fuellbyte:=$20;    // Leerzeichen
  BWS_Pos:=0;
  BWS_Offset:=0;

  setze_Font(fnt_6x8);

  Kursor_Ein:=true;
  Kursor_sichtbar:=false;
  KurArr_Aktuell:=false;
  Kursor_Schleife:=0;

  Reset_Form;
  clear_RAM;

  loesche_BWS;

  Escape_Reset;

  Write_String:='INIT VGA ...';
  Text_an_CONOUT;

  sende_Zeichen(XON);

  EnableInts;

ASM;

Anfangsmarke:

ENDASM;


  loop


    RX_Puffer_abfragen;


    Inc(Kursor_Schleife);

    if Kursor_Ein then
      if Kursor_Schleife=9000 then
        Kursor_Schleife:=0;
        if Kursor_sichtbar then
          Kursor_sichtbar:=false;
          Schalte_Kursor_Aus;
        else
          Kursor_sichtbar:=true;
          Schalte_Kursor_Ein;
        endif;
      endif;
    endif;



  endloop;





ASM;


Endlosschleife:

        rjmp      Endlosschleife


ENDASM;








END VGA.
