PROGRAM CONIO3;

// Version 0.52 vom 04.02.2016


// DEVICE = mega644P;
// {$I mega644P_Register.INC}



DEVICE = mega1284P;

{$I mega1284_Register.INC}

{$I mega644P_1284P_TC.INC}



CONST


  // Abtastrate 22 kHz
  // ((20000000/8)/22000) = 114 -> 114-1
  AbtastWert : Byte = 113;


  // ProcClock = 20000000;       {Hertz}
  // TaktFrequenz in KHz
  TaktFrequenz : WORD = 20000;


  // Serial0 = Verbindung zum Z80-Modul
  UBRR_VAL_S0 : Byte = 1;  // 625000 Baud
  // UBRR_VAL : Byte = 10;  // 115200 Baud

  // Serial1 = Verbindung zum PC
  UBRR_VAL_S1 : Byte = 10;  // 115200 Baud




  XON  : Byte = $11;
  XOFF : Byte = $13;


  Char_Null : Char = #0;



  // Befehlscode vom Z80-Modul
  PA_CONST  : Byte = 01;
  PA_CONIN  : Byte = 02;
  PA_CONOUT : Byte = 03;
  PA_LIST   : Byte = 04;
  PA_SOUND  : Byte = 05;
  PA_WRITE  : Byte = 06;
  PA_READ   : Byte = 07;
  PA_STD    : Byte = 08;
  PA_Kommentar: Byte = 09;
  PA_Dummy    : Byte = 10;
  PA_CPM_Start: Byte = 11;
  // XON  : Byte = $11; -> 17
  // XOFF : Byte = $13; -> 19



  // Monitor-Steuerzeichen
  Monitor_leer   : Byte = 00;
  Monitor_links  : Byte = 01;
  Monitor_rechts : Byte = 02;





// *** Tastatur-Konstanten ***


  // LedState
  no_LED_State : Byte = %00000000;
  LEDScroll    : Byte = %00000001;
  LEDNum       : Byte = %00000010;
  LEDCaps      : Byte = %00000100;


  // KeybState
  KeyStat_Byte1 : Byte = 1;  // KeyStat_Byte1 = normaler Tastaturcode (1 Byte)
  KeyStat_E0    : Byte = 2;  // KeyStat_E0 = erweiterter Tataturcode beginnt mit E0 (z.B. fuer INSERT, HOME, PRINT ...)
  KeyStat_F0    : Byte = 3;  // KeyStat_F0 = freigesetzt BREAK beginnt mit F0 (Taste wird losgelassen - auch nach Repetierung)

  // KbShiftState
  no_ShiftState : Byte = %00000000;
  shShift       : Byte = %00100000;
  shCtrl        : Byte = %00010000;
  shAlt         : Byte = %00001000;
  shCaps        : Byte = %00000100;
  shNum         : Byte = %00000010;
  shScroll      : Byte = %00000001;



  CodeTab_NORMAL : array[0..$7F] of Char =
  (
  { *** Tabelle SCAN-Code - ohne SHIFT *** }
  { 00-0F / 00-15 }
{  0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F  }
{      F9        F5   F3   F1   F2  F12       F10   F8   F6   F4  TAB   ^        }
  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0, #09, '^',  #0,
  { 10-1F / 16-31 }
{    LAlt  LSh      Strg   Q    1                   Y    S    A    W    2        }
  #0,  #0,  #0,  #0,  #0, 'q', '1',  #0,  #0,  #0, 'y', 's', 'a', 'w', '2',  #0,
  { 20-2F / 32-47 }
{      C    X    D    E    4    3            Spac   V    F    T    R    5        }
  #0, 'c', 'x', 'd', 'e', '4', '3',  #0,  #0, ' ', 'v', 'f', 't', 'r', '5',  #0,
  { 30-3F / 48-63 }
{      N    B    H    G    Z    6                   M    J    U    7    8        }
  #0, 'n', 'b', 'h', 'g', 'z', '6',  #0,  #0,  #0, 'm', 'j', 'u', '7', '8',  #0,
  { 40-4F / 64-79 }
{      ,    K    I    O    0    9              .    -    L    Ö    P    ß        }
  #0, ',', 'k', 'i', 'o', '0', '9',  #0,  #0, '.', '-', 'l', 'o', 'p', '\',  #0,
  { 50-5F / 80-95 }
{           Ä         Ü    ´            CaLo  RSh Retu   +         #             }
  #0,  #0, 'a',  #0, 'u', #39,  #0,  #0,  #0,  #0, #13, '+',  #0, '#',  #0,  #0,
  { 60-6F / 96-111 }
{                               BS                                               }
  #0,  #0,  #0,  #0,  #0,  #0,#127,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,
  { 70-7F / 112-127 }
{                              Esc  Num  F11                          Roll       }
  #0,  #0,  #0,  #0,  #0,  #0, #27,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0);



  CodeTab_SHIFT : array[0..$7F] of Char =
  (
  { *** Tabelle SCAN-Code - mit SHIFT *** }
  { 00-0F / 00-15 }
{  0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F  }
{      F9        F5   F3   F1   F2  F12       F10   F8   F6   F4  TAB   ^       }
  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0, #09, '^',  #0,
  { 10-1F / 16-31 }
{    LAlt  LSh      Strg   Q    1                   Y    S    A    W    2        }
  #0,  #0,  #0,  #0,  #0, 'Q', '!',  #0,  #0,  #0, 'Y', 'S', 'A', 'W', '"',  #0,
  { 20-2F / 32-47 }
{      C    X    D    E    4    3            Spac   V    F    T    R    5        }
  #0, 'C', 'X', 'D', 'E', '$', '#',  #0,  #0, ' ', 'V', 'F', 'T', 'R', '%',  #0,
  { 30-3F / 48-63 }
{      N    B    H    G    Z    6                   M    J    U    7    8        }
  #0, 'N', 'B', 'H', 'G', 'Z', '&',  #0,  #0,  #0, 'M', 'J', 'U', '/', '(',  #0,
  { 40-4F / 64-79 }
{      ,    K    I    O    0    9              .    -    L    Ö    P    ß        }
  #0, ';', 'K', 'I', 'O', '=', ')',  #0,  #0, ':', '_', 'L', 'O', 'P', '?',  #0,
  { 50-5F / 80-95 }
{           Ä         Ü    ´            CaLo  RSh Retu   +         #             }
  #0,  #0, 'A',  #0, 'U', #96,  #0,  #0,  #0,  #0, #13, '*',  #0, #39,  #0,  #0,
  { 60-6F / 96-111 }
{                               BS                                               }
  #0,  #0,  #0,  #0,  #0,  #0,#127,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,
  { 70-7F / 112-127 }
{                              Esc  Num  F11                          Roll       }
  #0,  #0,  #0,  #0,  #0,  #0, #27,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0);



  CodeTab_CTRL : array[0..$7F] of Char =
  (
  { *** Tabelle SCAN-Code - mit CTRL *** }
  { 00-0F / 00-15 }
{  0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F  }
{      F9        F5   F3   F1   F2  F12       F10   F8   F6   F4  TAB   ^       }
  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0, #09, #30,  #0,
  { 10-1F / 16-31 }
{    LAlt  LSh      Strg   Q    1                   Y    S    A    W    2        }
  #0,  #0,  #0,  #0,  #0, #17,  #0,  #0,  #0,  #0, #25, #19, #01, #23,  #0,  #0,
  { 20-2F / 32-47 }
{      C    X    D    E    4    3            Spac   V    F    T    R    5        }
  #0, #03, #24, #04, #05,  #0,  #0,  #0,  #0, ' ', #22, #06, #20, #18,  #0,  #0,
  { 30-3F / 48-63 }
{      N    B    H    G    Z    6                   M    J    U    7    8        }
  #0, #14, #02, #08, #07, #26,  #0,  #0,  #0,  #0, #13, #10, #21,  #0, #27,  #0,
  { 40-4F / 64-79 }
{      ,    K    I    O    0    9              .    -    L    Ö    P    ß        }
  #0,  #0, #11, #09, #15,  #0, #29,  #0,  #0,  #0,  #0, #12, #15, #16, #28,  #0,
  { 50-5F / 80-95 }
{           Ä         Ü    ´            CaLo  RSh Retu   +         #             }
  #0,  #0, #01,  #0, #21,  #0,  #0,  #0,  #0,  #0, #13,  #0,  #0,  #0,  #0,  #0,
  { 60-6F / 96-111 }
{                               BS                                               }
  #0,  #0,  #0,  #0,  #0,  #0,#127,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,
  { 70-7F / 112-127 }
{                              Esc  Num  F11                          Roll       }
  #0,  #0,  #0,  #0,  #0,  #0, #27,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0);



  CodeTab_ALT : array[0..$7F] of Char =
  (
  { *** Tabelle SCAN-Code - mit ALT *** }
  { 00-0F / 00-15 }
{  0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F  }
{      F9        F5   F3   F1   F2  F12       F10   F8   F6   F4  TAB   ^       }
  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0, #09,  #0,  #0,
  { 10-1F / 16-31 }
{    LAlt  LSh      Strg   Q    1                   Y    S    A    W    2        }
  #0,  #0,  #0,  #0,  #0, '@',  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,
  { 20-2F / 32-47 }
{      C    X    D    E    4    3            Spac   V    F    T    R    5        }
  #0,  #0,  #0,  #0, #36,  #0, '#',  #0,  #0, ' ',  #0,  #0,  #0,  #0,  #0,  #0,
  { 30-3F / 48-63 }
{      N    B    H    G    Z    6                   M    J    U    7    8        }
  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0, '{', '[',  #0,
  { 40-4F / 64-79 }
{      ,    K    I    O    0    9              .    -    L    Ö    P    ß        }
  #0,  #0,  #0,  #0,  #0, '}', ']',  #0,  #0,  #0,  #0,  #0,  #0,  #0, '\',  #0,
  { 50-5F / 80-95 }
{           Ä         Ü    ´            CaLo  RSh Retu   +         #             }
  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0, #13, '~',  #0,  #0,  #0,  #0,
  { 60-6F / 96-111 }
{                               BS                                               }
  #0,  #0,  #0,  #0,  #0,  #0,#127,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,
  { 70-7F / 112-127 }
{                              Esc  Num  F11                          Roll       }
  #0,  #0,  #0,  #0,  #0,  #0, #27,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0,  #0);



  // keyboard codes
  // 1 Byte
  kbdNum         : byte      = $77;
  kbdCaps        : byte      = $58;
  kbdScroll      : byte      = $7E;
  kbdAlt         : byte      = $11;
  kbdCtrl        : byte      = $14;
  kbdLShift      : byte      = $12;
  kbdRShift      : byte      = $59;

  kbdEnter       : Byte      = $5A;
  kbdSpace       : Byte      = $29;
  kbdBS          : Byte      = $66;
  kbdTab         : Byte      = $0D;
  kbdESC         : Byte      = $76;



  kbdF1          : byte      = $05;
  kbdF2          : byte      = $06;
  kbdF3          : byte      = $04;
  kbdF4          : byte      = $0C;
  kbdF5          : byte      = $03;
  kbdF6          : byte      = $0B;
  kbdF7          : byte      = $83;
  kbdF8          : byte      = $0A;
  kbdF9          : byte      = $01;
  kbdF10         : byte      = $09;
  kbdF11         : byte      = $78;
  kbdF12         : byte      = $07;



  // 2 Byte - E0 XX
  kbdRGUI        : byte      = $27;
  kbdLGUI        : byte      = $1F;
  kbdApps        : byte      = $2F;



  // 4 Byte - E0 12 E0 XX
  kbdEnd         : byte      = $69;  // Ende
  kbdHome        : byte      = $6C;  // Pos1

  kbdUp          : Byte      = $75;
  kbdDn          : Byte      = $72;
  kbdLeft        : Byte      = $6B;
  kbdRight       : Byte      = $74;

  kbdPgUp        : Byte      = $7D;
  kbdPgDn        : Byte      = $7A;

  kbdInsert      : byte      = $70;
  kbdDelete      : byte      = $71;

  kbdPrint       : byte      = $12;



  // E1 14 77 E1 F0 14 F0 77
  kbdPause       : byte      = $E1;



  scanBreak      : byte      = $F0;
  scanExt        : byte      = $E0;



  // special chars send to host
  hstScroll      : byte      = $00;

  hstPrint       : byte      = $10; // Ctrl-P
  hstIns         : byte      = $16; // Ctrl-V
  hstHome        : byte      = $00;
  hstPgUp        : byte      = $12; // Ctrl-R
  hstPgDn        : byte      = $03; // Ctrl-C
  hstDel         : byte      = $08; // Ctrl-H
  hstEnd         : byte      = $00;
  hstLeft        : byte      = $13;  // Ctrl-S
  hstRight       : byte      = $04;  // Ctrl-D
  hstUp          : byte      = $05;  // Ctrl-E
  hstDn          : byte      = $18;  // Ctrl-X
  hstRGUI        : byte      = $00;
  hstLGUI        : byte      = $00;
  hstApps        : byte      = $00;

  hstF1          : byte      = $80;
  hstF2          : byte      = $81;
  hstF3          : byte      = $82;
  hstF4          : byte      = $83;
  hstF5          : byte      = $84;
  hstF6          : byte      = $85;
  hstF7          : byte      = $86;
  hstF8          : byte      = $87;
  hstF9          : byte      = $88;
  hstF10         : byte      = $89;
  hstF11         : byte      = $8A;
  hstF12         : byte      = $8B;



  // Constanten-Tabellen fuer Toene
{$I PIPE_ORGAN_TAB.INC}

{$I SinTab.INC}



{$I CPM_Start.INC}



VAR

  SUMMER[PortD, 7]    : bit; // A

 // SUMMER[PortB, 0]    : bit; // A
  LED[PortB, 1]       : bit; // A

  KEY_CLK_A[PortB, 2] : bit; // A
  KEY_CLK_E[PinB, 2]  : bit; // E
  KEY_CLK_D[DDRB, 2]  : bit; // D

  KEY_DAT_A[PortB, 3] : bit; // A
  KEY_DAT_E[PinB, 3]  : bit; // E
  KEY_DAT_D[DDRB, 3]  : bit; // D




  Steuer_String : String[50];
  Text_String : String[15];



  // Sektor-Puffer
  Sektor_Puffer : Array [0..127] of Byte;
  Sektor_Puffer_Zeiger : Word;

  // STD
  SECTOR, TRACK_L, TRACK_H, DISKNO : Byte;

  Datum_gesetzt : Boolean;

  Anzeige_String : String[80];




  // PC keyboard Variablen
  BitCntr, KeybState,
  LedState, LocalByte,
  KbShiftState, tmpByte : Byte;

  CAPS_pressed, NUM_pressed,
  Scroll_pressed, doClick,
  InitFailed, LocalMode : Boolean;

  ch     : char;

  // Puffer fuer den SCAN-Code der Tastatur
  SCANBuffer      : array [0..32] of byte;
  SCANBufferPtr   : Word;

  // Puffer fuer die (aus dem SCAN-Code konvertierten) Tasten-Bytes
  KeyBuffer      : array [0..32] of byte;
  keyBufferPtr   : Word;

  SCAN_Zeichen : Byte;


  // sonstige Variablen
  TX_warten : Boolean;
  Tastatur_Zeichen : Byte;


  // Sound-Variablen
  SOUND_Byte : Byte;
  Abtast_Wert_T1 : Word;
  Wert_yl, Wert_yh : Byte;
  Zaehler_T1 : Word;

  // Monitor-Steuerung
  Monitor_verschieben : Byte;




// System (WaitMS)
{$I SYSTEM.INC}

// serielle Schnittstelle ohne Interrupt
{$I mega128_UART0_UART1_oI.INC}




procedure InitPorts;
begin

{
  PA0 -> Audio_0  // A
  PA1 -> Audio_1  // A
  PA2 -> Audio_2  // A
  PA3 -> Audio_3  // A
  PA4 -> Audio_4  // A
  PA5 -> Audio_5  // A
  PA6 -> Audio_6  // A
  PA7 -> Audio_7  // A
}
  //       AAAAAAAA
  DDRA:=  %11111111;
  PortA:= %00000000;


{
  PB0 -> SUMMER   // A
  PB1 -> LED      // A
  PB2 -> KEY_CLK  // E
  PB3 -> KEY_DAT  // E
  PB4 -> frei
  PB5 -> MOSI     //
  PB6 -> MISO     //
  PB7 -> SCK      //
}
  //       EEEEEEAA
  DDRB:=  %00000011;
  PortB:= %00000000;

{
  PD0 -> RXD0     // E
  PD1 -> TXD0     // A
  PD2 -> RXD1     // E
  PD3 -> TXD1     // A
}
  //       AAEEEEAE
  DDRD:=  %11000010;
  PortD:= %00000000;

end InitPorts;









procedure Init_INT2;
begin


//PCICR |= (1 << PCIE0);
// PCMSK0 |= (1 << PCINT0);



//  DDRD:= DDRD or %00100000;

  // init port interrupt INT0
  // Bit 1 -> ISC01 = 1
  // Bit 0 -> ISC00 = 0
  // 10 -> fallende Flanke löst den Interrupt aus
  //
  // MCUCR:= MCUCR or %00000010; // falling edge INT0
  EICRA := EICRA or %00100000; // falling edge INT2


  // When an INT2:0 bit is written to one and the I-bit in the Status Register (SREG)
  // is set (one), the corresponding external pin interrupt is enabled.
  // The Interrupt Sense Control bits in the External Interrupt Control Register,
  // EICRA, defines whether the external interrupt is activated on rising or
  // falling edge or level sensed. Activity on any of these pins will trigger
  // an interrupt request even if the pin is enabled as an output.
  // This provides a way of generating a software interrupt.
  EIMSK := EIMSK or %00000100;


  // When an edge or logic change on the INT2:0 pin triggers an interrupt request,
  // INTF2:0 becomes set (one). If the I-bit in SREG and the corresponding interrupt
  // enable bit, INT2:0 in EIMSK, are set (one), the MCU will jump to the interrupt vector.
  // The flag is cleared when the interrupt routine is executed. Alternatively,
  // the flag can be cleared by writing a logical one to it.
  // These flags are always cleared when INT2:0 are configured as level interrupt.
  EIFR := EIFR or %00000100;


end Init_INT2;












// *************************************************************


procedure Ton_Sirene(Dauer : Word);
var
  Frequenz : Word;
begin

  for Frequenz:=Dauer downto 1 do

    SetBit(SUMMER);
    wait_ms(Frequenz);
    ClearBit(SUMMER);
    wait_ms(Frequenz);

  endfor;

  for Frequenz:=1 to Dauer do

    SetBit(SUMMER);
    wait_ms(Frequenz);
    ClearBit(SUMMER);
    wait_ms(Frequenz);

  endfor;

end Ton_Sirene;



procedure Click;
begin
  Ton_Sirene(1);
end Click;



procedure Ton_Fehler;
begin
  Ton_Sirene(4);
  wait_ms(100);
  Ton_Sirene(4);
  wait_ms(100);
  Ton_Sirene(4);
  wait_ms(100);
end Ton_Fehler;







// *** Unterprogramme zum SCAN-Buffer ***



procedure write_SCAN(write_SCAN_value : byte);
begin
  if SCANBufferPtr<32 then
    inc(SCANBufferPtr);
    SCANBuffer[SCANBufferPtr]:=write_SCAN_value;
  endif;
end write_SCAN;





function read_SCAN : Byte;
var
  read_SCAN_value : Byte;
  SCAN_counter : Word;
  b1 : Byte;
begin
  read_SCAN_value:=SCANBuffer[1];
  dec(SCANBufferPtr);
  if SCANBufferPtr>0 then
    for SCAN_counter:=1 to SCANBufferPtr do
      b1 := SCANBuffer[SCAN_counter+1];
      SCANBuffer[SCAN_counter] := b1;
    endfor;
  endif;

  Result:=read_SCAN_value;

end  read_SCAN;








// *** Unterprogramme zum key-Buffer ***




function read_key : Byte;
var
  read_key_value : Byte;
  key_counter : Word;
  b1 : Byte;
begin
  DisableInts;
  read_key_value:=KeyBuffer[1];
  dec(keyBufferPtr);
  if keyBufferPtr>0 then
    for key_counter:=1 to keyBufferPtr do
      b1 := KeyBuffer[key_counter+1];
      KeyBuffer[key_counter] := b1;
    endfor;
  endif;
  EnableInts;

  Result:=read_key_value;

end read_key;





procedure write_key(write_key_value : byte);
begin
  DisableInts;
  if keyBufferPtr<32 then
    inc(keyBufferPtr);
    KeyBuffer[keyBufferPtr]:=write_key_value;
  endif;
  EnableInts;
end write_key;



procedure write_c_key(cKey : char);
var
  b1 : Byte;
begin
  b1:=CharToByte(cKey);
  write_key(b1);
end write_c_key;




procedure write_text;
var
  Zaehler : Byte;
  c1 : Char;
begin
  for zaehler:=1 to length(Text_String) do
    c1:=Text_String[Zaehler];
    write_c_key(c1);
  endfor;
end write_text;




procedure SendKey(sKey : byte);
var
  c1 : Char;
  b1 : Byte;
begin

  b1 := $0D;
  c1:=ByteToChar(b1);

  case sKey of

    $00 : Ton_Sirene(20);
      |

    $80 : Monitor_verschieben:=Monitor_links;  // F1
      |

    $81 : Monitor_verschieben:=Monitor_rechts; // F2
      |

    $82 : Text_String:='DIR'+c1;
          write_text; // F3
      |

    $83 : Text_String:='POWER'+c1;
          write_text; // F4
      |

    $84 : Text_String:='COPY'+c1;
          write_text; // F5

      |
    $85 : Text_String:='ERA'+c1;
          write_text; // F6

      |
    $86 : Text_String:='TYPEX'+c1;
          write_text; // F7

      |
    $87 : Text_String:='EXIT'+c1;
          write_text; // F8

      |
    $88 : Text_String:='TURBO'+c1;
          write_text; // F9

      |

    $89 : Text_String:='TURBO'+c1;
          write_text; // F10

      |


  else
    write_key(sKey);
  endcase;
end SendKey;


procedure SendKeyChar(sKey : char);
var
  b1 : Byte;
begin

  b1:=CharToByte(sKey);
  SendKey(b1);

end SendKeyChar;





// *********************************

// Tastatur - Hardware- Routinen

// *********************************









isr EI_INT2;
begin

ASM;
  PUSH   R18
ENDASM;


  if InitFailed then

  else


    // Bit 3 to 10 is data. Parity bit,
    // if (BitCntr in [3..10]) then
    if BitCntr>2 then
      if BitCntr<11 then

        // tmpByte:= tmpByte shr 1;  // start and stop bits are ignored.
        SHR(tmpByte);

        // setBit(tmpByte, 7, PinD.3);
        if BitHigh(KEY_DAT_E) then
          tmpByte:= tmpByte or %10000000;
        else
          tmpByte:= tmpByte and %01111111;
        endif;

      endif; //  if BitCnt<11 then
    endif; // if BitCnt>2 then


    dec (BitCntr);

    if BitCntr = 0 then                // All bits received
      BitCntr:= 11;
      if LocalMode then
        LocalByte:= tmpByte;
        LocalMode:= false;
      else

        ASM;
          PUSH   R0
          PUSH   R17
          PUSH   R19
          PUSH   R24
          PUSH   R25
          PUSH   ZL
          PUSH   ZH
        ENDASM;

        write_SCAN(tmpByte);

        ASM;
          POP   ZH
          POP   ZL
          POP   R25
          POP   R24
          POP   R19
          POP   R17
          POP   R0
        ENDASM;

      endif;
    endif;      // BitCntr = 0

  endif; // else InitFailed

ASM;
  POP   R18
ENDASM;

end EI_INT2;












// Grundeinstellungen der Variablen fuer
// die Tastarurabfrage
Procedure InitKeyb;
begin
  BitCntr:= 11;
  KeybState:= KeyStat_Byte1;

  SCANBufferPtr:=0;
end InitKeyb;




procedure Set_Kbd_clk;
begin
  BitCntr:= 11;

  // reset INT2
  EIFR := EIFR or %00000100;

  // PortB.2:= 1;
  SetBit(KEY_CLK_A);

  // DDRB.2:= 0; -> Taktleitung auf Eingang
  ClearBit(KEY_CLK_D);

  EnableInts;
end Set_Kbd_clk;



procedure Reset_Kbd_clk;
begin

  DisableInts;

  BitCntr:= 11;

  // PortB.2:= 0;
  ClearBit(KEY_CLK_A);

  // DDRB.2:= 1; -> Taktleitung auf Ausgang
  SetBit(KEY_CLK_D);

end Reset_Kbd_clk;




function NOT_PARITY(das_Byte : Byte) : Boolean;
var
  Ergebnis : Boolean;
  b2 : Byte;
  b3 : Byte;
  b4 : Byte;
begin

  b3 :=0;

  for b4:=0 to 7 do
    b2 := das_Byte and %00000001;
    if b2=%00000001 then
      Inc(b3);
    endif;
    SHR(das_Byte);
  endfor;

  b2 := b3 and %00000001;
  if b2=%00000001 then
    Ergebnis:=false;
  else
    Ergebnis:=true;
  endif;

  Result:=Ergebnis;
end NOT_PARITY;





// Transmit Byte to Keyboard
procedure SendToKbd(b1 : Byte);
var
  p    : boolean;
  w    : word;
  cnt  : byte;
  reg  : byte;
  test : byte;
begin

  DisableInts;

  // p := not Parity(b1);
  p:=NOT_PARITY(b1);

  // DDRB.2 := 0; -> Taktleitung auf Eingang
  ClearBit(KEY_CLK_D);

  // check clock line
  w:= 60000;

  {
  repeat
    dec(w);
  until PinB.2 and (w > 0);
  }
  while w>5 do

    dec(w);

    test := PinB and %00000100;

    if test=%00000100 then
      w:=2;
    endif;

  endwhile;

  // Ist die Datenleitung nun High -> dann gehts weiter
  if w=2 then


    // Bring the Clock line low for at least 100 microseconds.
    // DDRB.2 := 1;  -> Taktleitung auf Ausgang
    SetBit(KEY_CLK_D);

    // PortB.2 := 0;
    ClearBit(KEY_CLK_A);

    // mDelay(100);
    wait_ms(100);

    // Bring the Data line low.
    // PortB.3 := 0;
    ClearBit(KEY_DAT_A);

    // DDRB.3 := 1;  -> Datenleitung auf Ausgang
    SetBit(KEY_DAT_D);

    // Release the Clock line.
    // PortB.2 := 1;
    SetBit(KEY_CLK_A);

    // DDRB.2 := 0; -> Taktleitung auf Eingang
    ClearBit(KEY_CLK_D);


    // Wait for the device to bring the Clock line low.
    w:= 60000;

    {
    repeat
      dec(w);
    until not PinB.2 and (w > 0);
    }

    while w>5 do

      dec(w);

      test := PinB and %00000100;

      if test=%00000000 then
        w:=2;
      endif;

    endwhile;


    // Ist die Datenleitung nun Low -> dann gehts weiter
    if w=2 then


  // R16/R17 (_ACCA/_ACCB)


  ASM;

    // Sending the 8 bit data

    // R16:=B1
    MOV    R16, R0

    // Zaehler in R17
    LDI    R17, 8

M_tx_data:
    // Bit 0 in C
    ROR    R16

    // Set/reset the Data line to send the first data bit
    BRCS     M_tx_data0

    // set databit -> 0
    CBI    PortB, 3
    RJMP     M_tx_data1

M_tx_data0:
    // set databit -> 1
    SBI    PortB, 3

M_tx_data1:
    // Wait for the device to bring Clock high.
    SBIS   PINB, 2
    RJMP   M_tx_data1;         // wait till CLK rise

M_tx_data2:
    // Wait for the device to bring Clock low.
    SBIC   PINB, 2
    RJMP   M_tx_data2;         // now wait till CLK falls down

    // next bit please ...
    DEC    R17
    BRNE   M_tx_data


  ENDASM;


  // PARITY BIT
  // ????? even/odd ????????

  // _ACCA.0 := P;
  if P then
    reg := reg or %00000001;
  else
    reg := reg and %11111110;
  endif;

  ASM;

    // R16:=reg
    MOV    R16, R5

    ROR    R16
    BRCS   M_tx_data3

    // set databit -> 0
    CBI    PortB, 3
    RJMP   M_tx_data5

M_tx_data3:
    // set databit -> 1
    SBI    PortB, 3


M_tx_data5:
    // Wait for the device to bring Clock high.
    SBIS   PINB, 2
    RJMP   M_tx_data5;     // wait till CLK rise

    M_tx_data6:
    // Wait for the device to bring Clock low.
    SBIC   PINB, 2
    RJMP   M_tx_data6;     // now wait till CLK falls down

    // Getting stopbit
    SBI PortB, 3

    M_tx_data7:
    // waiting until clock will rise
    SBIS   PINB, 2
    RJMP   M_tx_data7;     // wait till CLK rise

    // Now release the Data line.
    //  DDRD.3 := 0;
    CBI    DDRB, 3;

  ENDASM;


  // Wait for the device to bring Data and Clock low.
  // repeat
  // until not PinB.3 and not PinB.2;

      w:=0;
      while w<2 do

        w:=0;

        test := PinB and %00000100;

        if test=%00000000 then
          Inc(w);
        endif;

        test := PinB and %00001000;

        if test=%00000000 then
          Inc(w);
        endif;

      endwhile;


  // Wait for the device to release Data and Clock
  // repeat
  // until PinB.2 and PinB.3;


      w:=0;
      while w<2 do

        w:=0;

        test := PinB and %00000100;

        if test=%00000100 then
          Inc(w);
        endif;

        test := PinB and %00001000;

        if test=%00001000 then
          Inc(w);
        endif;

      endwhile;


      Reset_Kbd_clk;
      LocalMode:= true;

      Set_Kbd_clk;  // enable the keyboard

      // ignore first byte
      // repeat
      // until not LocalMode;
      w:=0;
      while w=0 do

        if LocalMode then
          w:=0;
        else
          w:=1;
        endif;

      endwhile;


    else
      InitFailed:= true;
    endif;


  else
    InitFailed:= true;
  endif;

end SendToKbd;




// Set/Reset LEDs
procedure Set_Kbd_state;
begin
  SendToKbd($ED);
  SendToKbd(LedState);
End Set_Kbd_state;





procedure KbdReset;
var
  warten_auf_Tastatur : Boolean;
begin

  InitFailed:= false;

  Reset_Kbd_clk;          // disable the Keyboard

  wait_ms(500);

  LocalByte:= 0;

  // Wird die Tastatur zurückgesetzt (PC schickt Reset = $FF),
  // antwortet sie bei erfolgreichem Basic Assurance Test mit Bat = $AA

  // Wird die Tastatur zurückgesetzt und es gibt einen Fehlerfall,
  // klemmt beispielsweise eine Taste, reagiert sie mit BatE1 = $FC oder BatE2 = $FD.

  warten_auf_Tastatur:=true;

  while warten_auf_Tastatur do

    SendToKbd($FF);

    // Moegliche Ergebnisse auf das Ruecksetzkommando

    // 1. $AA -> erfolgreichem Basic Assurance Test
    if LocalByte=$AA then
      warten_auf_Tastatur:=false;
    endif;

    // 2. $FA -> Allgemein werden alle Kommandos zur Tastatur
    //           mit Acknowledge Ack = $FA von der Tastatur bestätigt.
    if LocalByte=$FA then
      warten_auf_Tastatur:=false;
    endif;

    if InitFailed then
      warten_auf_Tastatur:=false;
    endif;

  endwhile;


  if InitFailed then
    Set_Kbd_clk;
    LedState:= no_LED_State;
    KbShiftState:= no_ShiftState;
    KeybState:= KeyStat_Byte1;
  else
    // war die Initialisierung erfolgreich,
    // so wird die NUM-LED eingeschaltet
    LedState:= LEDNum;
    Set_Kbd_state;
    InitKeyb;
  endif;

end KbdReset;





procedure start_keyboard;
begin

  InitKeyb;

  KbdReset;

  if InitFailed then
    Ton_Sirene(20);
  else
    Ton_Sirene(4);
  endif;

end start_keyboard;











// *****************************************************

//   Konvertierung des SCAN-Codes in einen Tasten-Code

// *****************************************************


procedure Setze_Bit_in_KbShiftState(Shift_Taste : Byte);
begin
  KbShiftState:= KbShiftState or Shift_Taste;
end Setze_Bit_in_KbShiftState;



procedure Loesche_Bit_in_KbShiftState(Shift_Taste : Byte);
var
  b1 : Byte;
begin

  b1:=Negation_Byte(Shift_Taste);
  KbShiftState:= KbShiftState and b1;

end Loesche_Bit_in_KbShiftState;





procedure Setze_Bit_in_LedState(State_LED : Byte);
begin
  LedState:= LedState or State_LED;
end Setze_Bit_in_LedState;





procedure Loesche_Bit_in_LedState(State_LED : Byte);
var
  b1 : Byte;
begin

  b1:=Negation_Byte(State_LED);
  LedState:= LedState and b1;

end Loesche_Bit_in_LedState;






procedure SCAN_TO_KEY(curScan : Byte);
var
  b1 : Byte;
  curScan_Word : Word;
begin

  curScan_Word:=ByteToWord(curScan);

      // Decode scan codes into char
      case KeybState of
        KeyStat_Byte1 : doClick:= true;
                      case curScan of
                        scanExt    : KeybState:= KeyStat_E0;         // $E0
                                     doClick:= false;
                                   |
                        scanBreak  : KeybState:= KeyStat_F0;        // $F0
                                     doClick:= false;
                                   |

                        kbdAlt     : // left ALT pressed
                                     Setze_Bit_in_KbShiftState(shAlt);
                                     doClick:= false;
                                   |
                        kbdLShift  : // SHIFT pressed
                                     Setze_Bit_in_KbShiftState(shShift);
                                     doClick:= false;
                                   |

                        kbdRShift  : // SHIFT pressed
                                     Setze_Bit_in_KbShiftState(shShift);
                                     doClick:= false;
                                   |

                        kbdCtrl    : // left CTRL pressed
                                     Setze_Bit_in_KbShiftState(shCtrl);
                                     doClick:= false;
                                   |

                        kbdCaps    : // CAPS pressed

                                     if CAPS_pressed then
                                     else
                                       b1:=KbShiftState and shCaps;
                                       if b1=shCaps then
                                         // excl(KbShiftState, [shCaps]);
                                         Loesche_Bit_in_KbShiftState(shCaps);
                                         // excl(LedState, [LedCaps]);
                                         Loesche_Bit_in_LedState(LedCaps);
                                       else
                                         // incl(KbShiftState, [shCaps]);
                                         Setze_Bit_in_KbShiftState(shCaps);
                                         // incl(LedState, [LedCaps]);
                                         Setze_Bit_in_LedState(LedCaps);
                                       endif;
                                       Set_Kbd_state;
                                       CAPS_pressed:=true; // nur einmal annehmen
                                     endif;

                                     doClick:= false;

                                   |

                        kbdNum     : // NUM pressed
                                     if NUM_pressed then
                                     else
                                       b1:=KbShiftState and shNum;
                                       if b1=shNum then
                                         // excl(KbShiftState, [shNum]);
                                         Loesche_Bit_in_KbShiftState(shNum);
                                         // excl(LedState, [LedNum]);
                                         Loesche_Bit_in_LedState(LedNum);
                                       else
                                         // incl(KbShiftState, [shNum]);
                                         Setze_Bit_in_KbShiftState(shNum);
                                         // incl(LedState, [LedNum]);
                                         Setze_Bit_in_LedState(LedNum);
                                       endif;
                                       Set_Kbd_state;
                                       NUM_pressed:=true; // nur einmal annehmen
                                     endif;
                                     doClick:= false;
                                   |


                        kbdScroll  : // Scroll pressed
                                     if Scroll_pressed then
                                     else
                                       b1:=KbShiftState and shScroll;
                                       if b1=shScroll then
                                         // excl(KbShiftState, [shScroll]);
                                         Loesche_Bit_in_KbShiftState(shScroll);
                                         // excl(LedState, [LedScroll]);
                                         Loesche_Bit_in_LedState(LedScroll);
                                       else
                                         // incl(KbShiftState, [shScroll]);
                                         Setze_Bit_in_KbShiftState(shScroll);
                                         // incl(LedState, [LedScroll]);
                                         Setze_Bit_in_LedState(LedScroll);
                                        endif;
                                       Set_Kbd_state;
                                       Scroll_pressed:=true; // nur einmal annehmen
                                     endif;
                                     doClick:= false;
                                   |



                        // special keys which can not handled by the lookup table
                        kbdEnter   : // Enter
                                     SendKey($0D);
                                   |
                        kbdSpace   :
                                     SendKeyChar(' ');
                                   |
                        kbdBS      :
                                     SendKey($7F);
                                   |
                        kbdTab     :
                                     SendKey($09);
                                   |
                        kbdESC     :
                                     SendKey($1B);
                                   |

                        kbdF1      : // F1
                                     SendKey(hstF1);
                                   |
                        kbdF2      : // F2
                                     SendKey(hstF2);
                                   |
                        kbdF3      : // F3
                                     SendKey(hstF3);
                                   |
                        kbdF4      : // F4
                                     SendKey(hstF4);
                                   |
                        kbdF5      : // F5
                                     SendKey(hstF5);
                                   |
                        kbdF6      : // F6
                                     SendKey(hstF6);
                                   |
                        kbdF7      : // F7
                                     SendKey(hstF7);
                                   |
                        kbdF8      : // F8
                                     SendKey(hstF8);
                                   |
                        kbdF9      : // F9
                                     SendKey(hstF9);
                                   |
                        kbdF10     : // F10
                                     SendKey(hstF10);
                                   |
                        kbdF11     : // F11
                                     SendKey(hstF11);
                                   |
                        kbdF12     : // F12
                                     SendKey(hstF12);
                                   |
                        kbdPause   : // Pause/Break, special case with multiple chars
                                     // Taste Pause lieber nicht druecken
                                     // E1 14 77 E1 F0 14 F0 77
                                   |
                      else
                        // wir muessen den SHIFT, CTRL, ALT und CAPS Status einfuegen
                        // fuer die Deutsche Tastatur

                        ch:=Char_Null;

                        b1:=KbShiftState and shShift;
                        if b1=shShift then
                          b1:=KbShiftState and shCaps;
                          if b1=shCaps then
                            ch:= CodeTab_NORMAL[curScan_Word];
                          else
                            ch:= CodeTab_SHIFT[curScan_Word];
                          endif;
                        else
                          b1:=KbShiftState and shCaps;
                          if b1=shCaps then
                            ch:= CodeTab_SHIFT[curScan_Word];
                          else
                            ch:= CodeTab_NORMAL[curScan_Word];
                          endif;
                        endif;

                        b1:=KbShiftState and shCtrl;
                        if b1=shCtrl then
                          ch:= CodeTab_CTRL[curScan_Word];
                        endif;

                        b1:=KbShiftState and shAlt;
                        if b1=shAlt then
                          ch:= CodeTab_ALT[curScan_Word];
                        endif;

                        SendKeyChar(ch);

                      endcase;

                      if doClick then
                        Click;
                      endif;


                    |
        KeyStat_E0 : KeybState:= KeyStat_Byte1;
                      doClick:= true;

                      // der letzte Scan war $E0 = extended
                      case curScan of
                        scanBreak : KeybState:= KeyStat_F0;  // $F0
                                    doClick:= false;
                                  |
                        kbdAlt    : // ALT Gr pressed
                                    Setze_Bit_in_KbShiftState(shAlt);
                                    doClick:= false;
                                  |
                        kbdCtrl   : // right CTRL pressed
                                    Setze_Bit_in_KbShiftState(shCtrl);
                                    doClick:= false;
                                  |
                        kbdEnter  : // NumPad Enter
                                    SendKey($0D);
                                  |
                        kbdUp     :
                                    SendKey(hstUp);
                                  |
                        kbdDn     :
                                    SendKey(hstDn);
                                  |
                        kbdLeft   :
                                    SendKey(hstLeft);
                                  |
                        kbdRight  :
                                    SendKey(hstRight);
                                  |
                        kbdPgUp   :
                                    SendKey(hstPgUp);
                                  |
                        kbdPgDn   :
                                    SendKey(hstPgDn);
                                  |
                        kbdHome   :
                                    SendKey(hstHome);
                                  |
                        kbdInsert :
                                    SendKey(hstIns);
                                  |
                        kbdDelete :
                                    SendKey(hstDel);
                                  |
                        kbdEnd    :
                                    SendKey(hstEnd);
                                  |
                        kbdRGUI   :
                                    SendKey(hstRGUI);
                                  |
                        kbdLGUI   :
                                    SendKey(hstLGUI);
                                  |
                        kbdApps   :
                                    SendKey(hstApps);
                                  |
                        kbdPrint  : // Print Screen, special case with multiple chars
                                    // hstPrint
                                  |
                      endcase;

                      if doClick then
                        Click;
                      endif;


                    |
        KeyStat_F0 : case curScan of     // last scan was $F0 = break
                        kbdAlt    : // ALT released
                                    Loesche_Bit_in_KbShiftState(shAlt);
                                  |
                        kbdLShift : // SHIFT released
                                    Loesche_Bit_in_KbShiftState(shShift);
                                  |

                        kbdRShift : // SHIFT released
                                    Loesche_Bit_in_KbShiftState(shShift);
                                  |

                        kbdCtrl   : // CTRL released
                                    Loesche_Bit_in_KbShiftState(shCtrl);
                                  |

                        kbdCaps   : // CAPS released
                                    CAPS_pressed:=false;
                                  |
                        kbdNum    : // NUM released
                                    NUM_pressed:=false;
                                  |
                        kbdScroll : // Scroll released
                                    Scroll_pressed:=false;
                                  |

                      endcase;
                      KeybState:= KeyStat_Byte1;
                    |


      endcase;  // KeybState


end SCAN_TO_KEY;




// *******************************************
// *** STD, READ und WRITE fuer Z80 und PC ***
// *******************************************











// liest die Bytes aus der SteuerString in den Sektor_Puffer
procedure Steuer_String_To_Sector;
var
  b1 : Byte;
  b2 : Byte;
  b3 : Byte;
  c1 : Char;
begin
  b2:=2;
  for b1:=0 to 15 do
    c1:=Steuer_String[b2];
    Inc(b2);
    Write_String:=c1;
    c1:=Steuer_String[b2];
    Inc(b2);
    Write_String:=Write_String+c1;
    b3:=StringToByte;
    Sektor_Puffer[Sektor_Puffer_Zeiger]:=b3;
    Inc(Sektor_Puffer_Zeiger);
  endfor;

end Steuer_String_To_Sector;









// liest die Bytes aus der SteuerString in den Sektor_Puffer aber komprimiert
procedure Steuer_String_To_Sector_Komp;
var
 // x1 : Byte;
  x2 : Byte;
  DB7 : Byte;
  DB8 : Byte;
  BitPos_DB8 : Byte;
  BitPos_DB7 : Byte;
  c1 : Char;
  Pos_SS : Byte;
  ein_Bit : Boolean;

begin
  BitPos_DB8:=7;
  DB8:=$00;
  for Pos_SS:=2 to 38 do

    c1:=Steuer_String[Pos_SS];
    DB7:=CharToByte(c1);

    BitPos_DB7:=7;
    for x2:=0 to 6 do

      Dec(BitPos_DB7); // 6..0
      ein_Bit:=Read_Bit_in_Byte(DB7,BitPos_DB7);

      if ein_Bit then
        DB8:=Set_Bit_in_Byte(DB8,BitPos_DB8);
      else
        DB8:=Clear_Bit_in_Byte(DB8,BitPos_DB8);
      endif;

      if BitPos_DB8=0 then

        Sektor_Puffer[Sektor_Puffer_Zeiger]:=DB8;
        Inc(Sektor_Puffer_Zeiger);

        BitPos_DB8:=7;
        DB8:=$00;

      else
        Dec(BitPos_DB8);
      endif;

    endfor; { for x2:=0 to 6 do }

  endfor; { for x1:=1 to 18 do }

end Steuer_String_To_Sector_Komp;













// liest die Bytes aus der SteuerString in den DATE und TIME-Puffer
procedure Steuer_String_To_TIME;
var
  b1 : Byte;
  b2 : Byte;
  c1 : Char;
begin


  // warten bis /IORQ inaktiv wird (High)
 // warte_solange_IORQ_Low;


  // Date Low-Teil
  c1:=Steuer_String[4];
  Write_String:=c1;
  c1:=Steuer_String[5];
  Write_String:=Write_String+c1;
  b1:=StringToByte;


  // Das naechste Byte ist das einzulesende Zeichen
 // warte_solange_IORQ_High;

  DDRC:=%11111111;
  PortC:=b1;

  // warten bis /IORQ inaktiv wird (High)
 // warte_solange_IORQ_Low;

  DDRC:=%00000000;


  // Date High-Teil
  c1:=Steuer_String[2];
  Write_String:=c1;
  c1:=Steuer_String[3];
  Write_String:=Write_String+c1;
  b1:=StringToByte;


  // Das naechste Byte ist das einzulesende Zeichen
 // warte_solange_IORQ_High;

  DDRC:=%11111111;
  PortC:=b1;

  // warten bis /IORQ inaktiv wird (High)
 // warte_solange_IORQ_Low;

  DDRC:=%00000000;


  // HOUR
  c1:=Steuer_String[6];
  b1:=CharToByte(c1);
  b1:=b1-$30;
  SHL(b1);
  SHL(b1);
  SHL(b1);
  SHL(b1);
  c1:=Steuer_String[7];
  b2:=CharToByte(c1);
  b2:=b2-$30;
  b1:=b1+b2;


  // Das naechste Byte ist das einzulesende Zeichen
//  warte_solange_IORQ_High;

  DDRC:=%11111111;
  PortC:=b1;

  // warten bis /IORQ inaktiv wird (High)
//  warte_solange_IORQ_Low;

  DDRC:=%00000000;


  // MIN
  c1:=Steuer_String[8];
  b1:=CharToByte(c1);
  b1:=b1-$30;
  SHL(b1);
  SHL(b1);
  SHL(b1);
  SHL(b1);
  c1:=Steuer_String[9];
  b2:=CharToByte(c1);
  b2:=b2-$30;
  b1:=b1+b2;


  // Das naechste Byte ist das einzulesende Zeichen
 // warte_solange_IORQ_High;

  DDRC:=%11111111;
  PortC:=b1;

  // warten bis /IORQ inaktiv wird (High)
 // warte_solange_IORQ_Low;

  DDRC:=%00000000;


  // SEC
  c1:=Steuer_String[10];
  b1:=CharToByte(c1);
  b1:=b1-$30;
  SHL(b1);
  SHL(b1);
  SHL(b1);
  SHL(b1);
  c1:=Steuer_String[11];
  b2:=CharToByte(c1);
  b2:=b2-$30;
  b1:=b1+b2;


  // Das naechste Byte ist das einzulesende Zeichen
 // warte_solange_IORQ_High;

  DDRC:=%11111111;
  PortC:=b1;

  // warten bis /IORQ inaktiv wird (High)
//  warte_solange_IORQ_Low;

  DDRC:=%00000000;


  Datum_gesetzt:=true;

end Steuer_String_To_TIME;











procedure Steuer_String_auswerten;
var
  Buchstabe : Char;
  Zeichen_1 : Char;
  Zeichen_2 : Char;
  Laenge : Byte;
begin
  Laenge:=Length(Steuer_String);

  if Laenge>0 then
    Buchstabe:=Steuer_String[1];
    case Buchstabe of


            // UD0D1D2D3D4D5D6D7D8D9DADBDCDDDEDF  16*2+1
      'U' : if Laenge=33 then // ein Sektor-Abschnitt
              Steuer_String_To_Sector;
            else
              Write_String:='x03';
              WriteLn_SER1;
            endif;

      |

          // RB01B02B03B04..B36 36+1
      'R' : if Laenge=38 then // ein Sektor-Abschnitt
              Steuer_String_To_Sector_Komp;
            else
              Write_String:='x07';
              WriteLn_SER1;
            endif;
      |


          // D329B133357 = D + Datum(4) + Zeit(6)
      'D' : if Laenge=11 then
              Steuer_String_To_TIME;
            else
              Write_String:='x09';
              WriteLn_SER1;
            endif;
      |


    else
      Write_String:='x02';
      WriteLn_SER1;
    endcase;

  endif; { if Laenge>0 then }



end Steuer_String_auswerten;




procedure Steuer_String_lesen;
var
  akt_Zeichen : Char;
  empf_Zeichen : Byte;
begin
  empf_Zeichen:=UDR1;

  if empf_Zeichen<>$0D then // 0D wird ignoriert

    if empf_Zeichen=$0A then  // bei 0A wird ausgerwertet
      Steuer_String_auswerten;
      Steuer_String:='';
    else
      akt_Zeichen:=ByteToChar(empf_Zeichen);
      Steuer_String:= Steuer_String + akt_Zeichen; // sonst nur abgespeichert
    endif; { if akt_Zeichen<>char($0A) }

  endif; { if akt_Zeichen<>char($0D) then }


end Steuer_String_lesen;










procedure Sektor_von_PC_lesen;
var
  b1 : Byte;
  b2 : Byte;
  SPZ : Word;
  LeseSchleife : Word;
begin

  Sektor_Puffer_Zeiger:=0;
  SPZ:=0;

  for b1:=0 to 7 do
    ByteToString(b1);
    Write_String:='u'+Write_String;
    WriteLn_SER1;

    LeseSchleife:=60000;
    while LeseSchleife>5 do

      if BitHigh(RXC1) then
        Steuer_String_lesen;
        if SPZ=Sektor_Puffer_Zeiger then
          LeseSchleife:=60000;
        else
          LeseSchleife:=1;  // Ende
          SPZ:=Sektor_Puffer_Zeiger;
        endif;
      endif;

      Dec(LeseSchleife);
    endwhile;

    if LeseSchleife>0 then
      Write_String:='x04';
      WriteLn_SER1;
    endif;

  endfor;

end Sektor_von_PC_lesen;






procedure Sektor_von_PC_lesen_Komp;
var
  b1 : Byte;
  b2 : Byte;
  SPZ : Word;
  LeseSchleife : Word;
begin

  Sektor_Puffer_Zeiger:=0;
  SPZ:=0;

  for b1:=0 to 3 do
    ByteToString(b1);
    Write_String:='r'+Write_String;
    WriteLn_SER1;

    LeseSchleife:=60000;
    while LeseSchleife>5 do

      if BitHigh(RXC1) then
        Steuer_String_lesen;
        if SPZ=Sektor_Puffer_Zeiger then
          LeseSchleife:=60000;
        else
          LeseSchleife:=1;  // Ende
          SPZ:=Sektor_Puffer_Zeiger;
        endif;
      endif;

      Dec(LeseSchleife);
    endwhile;

    if LeseSchleife>0 then
      Write_String:='x08';
      WriteLn_SER1;
    endif;

  endfor;

end Sektor_von_PC_lesen_Komp;










procedure Sektor_an_PC_senden;
var
  b1 : Byte;
  b2 : Byte;
  b3 : Byte;
begin

  Sektor_Puffer_Zeiger:=0;

  for b1:=0 to 7 do

    ByteToString(b1);
    Anzeige_String:='v'+Write_String;

    for b2:=0 to 15 do
      b3:=Sektor_Puffer[Sektor_Puffer_Zeiger];
      Inc(Sektor_Puffer_Zeiger);
      ByteToString(b3);
      Anzeige_String:=Anzeige_String+Write_String;
    endfor; { for b2:=0 to 15 do }

    Write_String:=Anzeige_String;
    WriteLn_SER1;

  endfor; { for b1:=0 to 7 do }

end Sektor_an_PC_senden;









procedure warte_kurz;
begin

  NOP;
  NOP;
  NOP;
  NOP;
  NOP;

end warte_kurz;









procedure Z80_RECEIVE_Byte;
begin

// wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt
// ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
ASM;

M_ASM_warte_solange_RECEIVE_Byte:

        LDS        R16, UCSR0A
        BST        R16, 7
        BRTC       M_ASM_warte_solange_RECEIVE_Byte

ENDASM;

  SER0_Zeichen:=UDR0;

end Z80_RECEIVE_Byte;




// Daten enpfangen von Z80-Modul und weiterleiten
// als WRITE an PC
procedure Z80_RECEIVE_WRITE;
begin

  // Abschalten Interrupt
  DisableInts;

  sende_Zeichen0(XON);
  Z80_RECEIVE_Byte;

  for Sektor_Puffer_Zeiger:=0 to 127 do

// wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt
// ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
ASM;

M_ASM_warte_solange_RECEIVE_WRITE:

        LDS        R16, UCSR0A
        BST        R16, 7
        BRTC       M_ASM_warte_solange_RECEIVE_WRITE

ENDASM;

    SER0_Zeichen:=UDR0;
    Sektor_Puffer[Sektor_Puffer_Zeiger]:=SER0_Zeichen;

  endfor; { for Sektor_Puffer_Zeiger:=0 to 127 do }

  // Einschalten Interrupt
  EnableInts;

  Sektor_an_PC_senden;

  sende_Zeichen0(XON);

end Z80_RECEIVE_WRITE;





// Daten enpfangen als READ vom PC und weiterleiten
// an Z80-Modul
procedure Z80_RECEIVE_READ;
var
  b1 : Byte;

begin

  Sektor_von_PC_lesen_Komp;

  // Abschalten Interrupt
  DisableInts;

  for Sektor_Puffer_Zeiger:=0 to 127 do

    warte_kurz;
    b1:=Sektor_Puffer[Sektor_Puffer_Zeiger];
    sende_Zeichen0(b1);

  endfor; { for Sektor_Puffer_Zeiger:=0 to 127 do }

  // Einschalten Interrupt
  EnableInts;

  sende_Zeichen0(XON);

end Z80_RECEIVE_READ;






procedure STD_an_PC_senden;
begin

  // Sector, Track, Drive (STD) = s SE TH TL DR
  ByteToString(SECTOR);
  Anzeige_String:='s'+Write_String;
  ByteToString(TRACK_H);
  Anzeige_String:=Anzeige_String+Write_String;
  ByteToString(TRACK_L);
  Anzeige_String:=Anzeige_String+Write_String;
  ByteToString(DISKNO);
  Write_String:=Anzeige_String+Write_String;

  // Senden der STD
  WriteLn_SER1;

end STD_an_PC_senden;









procedure Z80_RECEIVE_STD;

begin
  sende_Zeichen0(XON);

  Z80_RECEIVE_Byte;
  SECTOR:=SER0_Zeichen;
  sende_Zeichen0(XON);


  Z80_RECEIVE_Byte;
  TRACK_H:=SER0_Zeichen;
  sende_Zeichen0(XON);


  Z80_RECEIVE_Byte;
  TRACK_L:=SER0_Zeichen;
  sende_Zeichen0(XON);


  Z80_RECEIVE_Byte;
  DISKNO:=SER0_Zeichen;

  STD_an_PC_senden;

  sende_Zeichen0(XON);

end Z80_RECEIVE_STD;






// ************************************






procedure Z80_RECEIVE_CONST;
var
  RECEIVE_MESSAGE : Byte;
begin
  if keyBufferPtr=0 then
    RECEIVE_MESSAGE:=$00;
  else
    RECEIVE_MESSAGE:=$FF;
  endif;

  sende_Zeichen0(RECEIVE_MESSAGE);

end Z80_RECEIVE_CONST;






procedure Z80_RECEIVE_CONIN;
var
  RECEIVE_MESSAGE : Byte;
begin

  if keyBufferPtr=0 then
    RECEIVE_MESSAGE:=$00;
  else
    RECEIVE_MESSAGE:=read_key;
  endif; { if keyBufferPtr=0 then }

  sende_Zeichen0(RECEIVE_MESSAGE);

end Z80_RECEIVE_CONIN;





// ************************************





procedure Z80_RECEIVE_Kommentar;
var
  Laenge : Byte;
  Laenge_Word : Word;
  b1 : Byte;
  c1 : Char;
begin


ASM;

M_ASM_warte_solange_RECEIVE_Kommentar_01:

        LDS        R16, UCSR0A
        BST        R16, 7
        BRTC       M_ASM_warte_solange_RECEIVE_Kommentar_01

ENDASM;

  Laenge:=UDR0;
  Dec(Laenge);

  Laenge_Word:=ByteToWord(Laenge);

  for Sektor_Puffer_Zeiger:=0 to Laenge_Word do

// wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt
// ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
ASM;

M_ASM_warte_solange_RECEIVE_Kommentar_02:

        LDS        R16, UCSR0A
        BST        R16, 7
        BRTC       M_ASM_warte_solange_RECEIVE_Kommentar_02

ENDASM;

    SER0_Zeichen:=UDR0;
    Sektor_Puffer[Sektor_Puffer_Zeiger]:=SER0_Zeichen;

  endfor; { for Sektor_Puffer_Zeiger:=0 to 127 do }


  Write_String:='y';
  for Sektor_Puffer_Zeiger:=0 to Laenge_Word do

    SER0_Zeichen:=Sektor_Puffer[Sektor_Puffer_Zeiger];
    c1:=ByteToChar(SER0_Zeichen);
    Write_String:=Write_String+c1;

  endfor; { for Sektor_Puffer_Zeiger:=0 to 127 do }

  WriteLn_SER1;

  sende_Zeichen0(XON);

end Z80_RECEIVE_Kommentar;







procedure Z80_RECEIVE_CPM_Start;
begin

  Zaehler_T1:=0;
  Init_TIMER1_COMPA(1250);

  sende_Zeichen0(XON);

end Z80_RECEIVE_CPM_Start;








procedure Z80_RECEIVE;
begin


  case SER0_Zeichen of

    PA_CONST  : Z80_RECEIVE_CONST;
    |

    PA_CONIN  : Z80_RECEIVE_CONIN;
    |

    PA_CONOUT : Ton_Fehler;
    |

    PA_LIST   : Ton_Fehler;
    |

    PA_SOUND  : Ton_Fehler;
    |

    PA_WRITE  : Z80_RECEIVE_WRITE;
    |

    PA_READ   : Z80_RECEIVE_READ;
    |

    PA_STD    : Z80_RECEIVE_STD;
    |

    PA_Kommentar : Z80_RECEIVE_Kommentar;
    |

    PA_CPM_Start : Z80_RECEIVE_CPM_Start;
    |

  else
    Ton_Fehler;
  endcase;


end Z80_RECEIVE;






// ************************************






isr TIMER0_COMPA;
begin


ASM;


.equ 	port_dac	= porta


	lds	  R16, SOUND_Byte
        out       port_dac, R16


ENDASM;


end TIMER0_COMPA;





         {

isr TIMER1_OVF;
begin


ASM;

	push	  zl
	push	  zh
	push	  yl
	push	  yh

; setzen des Zeigers auf die PIPE_ORGAN_TAB-Tabelle
	ldi	  zl,low(2*PIPE_ORGAN_TAB)
	ldi	  zh,high(2*PIPE_ORGAN_TAB)

; Laden des letzten Standes wichtiger Register
	lds	  yl, Wert_yl
	lds	  yh, Wert_yh

; berechnen der aktuellen Tabellen-Position
	add	  zl,yl
	adc	  zh,yh

; lesen des Bytes aus der PIPE_ORGAN_TAB-Tabelle in R16
	lpm	  R16,z

; Schreiben des TonWertes in das SOUND_Byte
      	sts	  SOUND_Byte, R16

; inkrementieren des Adress-Offsets der VLINE-Tabelle
; fuer den naechsten Durchlauf
	adiw	  yh:yl,1


        CPI        yl, 128
        BRNE       M_TIMER1_OVF_01


        LDI        yl, 0x00



M_TIMER1_OVF_01:



; Abspeichern des Wertes fuer den Adress-Offset
; fuer den naechsten Durchlauf
      	sts	  Wert_yl, yl
	sts	  Wert_yh, yh


	pop       yh
	pop       yl
	pop       zh
	pop       zl




ENDASM;


end TIMER1_OVF;

         }








isr  TIMER1_COMPA;
begin

ASM;
	push      R17
	push      R18
	push      R19
	push      R24
        push      R25
        push      R28
        push      R29
        push      zl
        push      zh
ENDASM;


  SOUND_Byte:=CPM_START_TAB[Zaehler_T1];

  INC(Zaehler_T1);
  if Zaehler_T1=CPM_START_TAB_Laenge then
    TIMER1_aus;
  endif;


ASM;
        pop       zh
        pop       zl
        pop       R29
        pop       R28
        pop       R25
        pop       R24
        pop       R19
        pop       R18
        pop       R17
ENDASM;


end  TIMER1_COMPA;










BEGIN

ASM;

.equ UBRR0 = UBRR0L
.equ UBRR1 = UBRR1L

ENDASM;

  wait_ms(10);


  // Initialisieren der Ports
  InitPorts;
  Init_INT2;
  INIT_SER0_PORT;
  INIT_SER1_PORT;

  // Initialisieren der Tastatur-Variablen
  CAPS_pressed:=false;
  NUM_pressed:=false;
  Scroll_pressed:=false;

  LedState:=no_LED_State;
  KeybState:=KeyStat_Byte1;
  KbShiftState:=no_ShiftState;

  keyBufferPtr:=0;

  TX_warten:=false;

  ClearBit(SUMMER);
  ClearBit(LED);

  // Sound-Einstellungen
  SOUND_Byte:=127;
  Wert_yl:=0;
  Wert_yh:=0;

  // Monitor-Einstellungen
  Monitor_verschieben:=Monitor_leer;


  start_keyboard;

  Init_TIMER0_COMPA(AbtastWert);

  sende_Zeichen0(XON);
  sende_Zeichen1(64);  // @  = Ruecksetzen der Hardware



  loop


    if SCANBufferPtr>0 then
      SCAN_Zeichen:=read_SCAN;
      SCAN_TO_KEY(SCAN_Zeichen);
    endif;  { if SCANBufferPtr<>0 then }



    RX0_Puffer_abfragen;

    if SER0_Zeichen>0 then
      Z80_RECEIVE;
    endif;



    if Monitor_verschieben>Monitor_leer then
      sende_Zeichen0(Monitor_verschieben);
      Monitor_verschieben:=Monitor_leer;
    endif;



  endloop;


END CONIO3.
