VAR

{
 Definitions marked "MEMORY MAPPED"are extended I/O ports
 and cannot be used with IN/OUT instructions
}

  // *** USART0 und USART1 ***
  // (UNIVERSAL SYNCHRONOUS and ASYNCHRONOUS RECEIVER and TRANSMITTER)

  // I/O Data Register
  UDR0, UDR1,
  // Baud Raten Register High Byte
  UBRR0H, UBRR1H,
  // Baud Raten Register Low Byte
  UBRR0L, UBRR1L,
  // Control Status Register A bis C
  UCSR0A, UCSR0B, UCSR0C,
  UCSR1A, UCSR1B, UCSR1C,


  // *** TWI (2-wire Serial Interface) ***

  // Slave Address Mask Register
  TWAMR,
  // Control Register
  TWCR,
  // Data Register
  TWDR,
  // Slave Address Register
  TWAR,
  // Status Register
  TWSR,
  // Bit Rate Register
  TWBR,



  // *** Timer/Counter 2 ***

  // Asynchronous Status Register
  ASSR,
  // Output Compare Register B
  OCR2B,
  // Output Compare Register A
  OCR2A,
  // Timer/Counter Register (8 Bit)
  TCNT2,
  // Timer/Counter Control Register B
  TCCR2B,
  // Timer/Counter Control Register A
  TCCR2A,



  // *** Timer/Counter 3 ***

  // Output Compare Register B Low Byte
  OCR3BL,
  // Output Compare Register B High Byte
  OCR3BH,

  // Output Compare Register A High Byte
  OCR3AH,
  // Output Compare Register A Low Byte
  OCR3AL,

  // Input Capture Register Low Byte
  ICR3L,
  // Input Capture Register High Byte
  ICR3H,

  // Timer/Counter Register Low Byte
  TCNT3L,
  // Timer/Counter Register High Byte
  TCNT3H,

  // Timer/Counter Control Register C
  TCCR3C,
  // Timer/Counter Control Register B
  TCCR3B,
  // Timer/Counter Control Register A
  TCCR3A,




  // *** Timer/Counter 1 ***

  // Output Compare Register B Low Byte
  OCR1BL,
  // Output Compare Register B High Byte
  OCR1BH,

  // Output Compare Register A High Byte
  OCR1AH,
  // Output Compare Register A Low Byte
  OCR1AL,

  // Input Capture Register Low Byte
  ICR1L,
  // Input Capture Register High Byte
  ICR1H,

  // Timer/Counter Register Low Byte
  TCNT1L,
  // Timer/Counter Register High Byte
  TCNT1H,

  // Timer/Counter Control Register C
  TCCR1C,
  // Timer/Counter Control Register B
  TCCR1B,
  // Timer/Counter Control Register A
  TCCR1A,





  // Timer/Counter Interrupt Mask Register
  TIMSK3, TIMSK2, TIMSK1, TIMSK0,



  // *** ADC (Analog-to-digital Converter) ***

  // Digital Input Disable Register 1
  DIDR1,
  // Digital Input Disable Register 0
  DIDR0,

  // Multiplexer Selection Register
  ADMUX,
  // Control and Status Register B
  ADCSRB,
  // Control and Status Register A
  ADCSRA,
  // Data Register High Byte
  ADCH,
  // Data Register Low Byte
  ADCL,


  // *** External Interrupts ***

  // Pin Change Mask Register 0 bis 3
  PCMSK0, PCMSK1, PCMSK2, PCMSK3,

  // External Interrupt Control Register
  EICRA,

  // Pin Change Interrupt Control Register
  PCICR,


  // *** sonstige Register ***

  // Oscillator Callibration Register
  OSCCAL,

  // Power Reduction Register 0 und 1
  PRR0, PRR1,

  // Clock Prescaler Register
  CLKPR,

  // Watchdog Timer Control Register
  WDTCSR,

   : ByteConVar;



{
  alle Register, die mit In/OUT angesprochen werden koennen
}

  // Status Register
  SREG,

  // Stack Pointer Low und High
  SPL, SPH,

  // Store Program Memory Control and Status Register
  SPMCSR,

  // MCU Control Register
  MCUCR,
  // MCU Status Register
  MCUSR,

  // Sleep Mode Control Register
  SMCR,

  // On-chip Debug Related Register in I/O Memory
  OCDR,

  // Analog Comparator Control and Status Register
  ACSR,

  // SPI Data Register
  SPDR,

  // SPI Status Register
  SPSR,

  // SPI Control Register
  SPCR,

  // General Purpose I/O Register 0 bis 2
  GPIOR0, GPIOR1, GPIOR2,


  // *** Timer/Counter 0 ***

  // Output Compare Register A und B
  OCR0A, OCR0B,

  // Timer/Counter Register
  TCNT0,

  // Timer/Counter Control Register A und B
  TCCR0A,  TCCR0B,



  // General Timer/Counter Control Register
  GTCCR,



  // *** EEPROM ***

  // The EEPROM Adress Register
  EEARH, EEARL,

  // The EEPROM Data Register
  EEDR,

  // The EEPROM Control Register
  EECR,



  // *** External Interrupt ***

  // External Interrupt Mask Register
  EIMSK,

  // External Interrupt Flag Register
  EIFR,

  // Pin Change Interrupt Flag Register
  PCIFR,



  // Timer/Counter Interrupt Flag Register 0 bis 3
  TIFR2, TIFR3, TIFR1, TIFR0,


  // *** PORT A ***

  // Data Register
  PORTA,
  // Data Direction Register
  DDRA,
  // Input Pins Adress
  PINA,


  // *** PORT B ***

  // Data Register
  PORTB,
  // Data Direction Register
  DDRB,
  // Input Pins Adress
  PINB,


    // *** PORT C ***

  // Data Register
  PORTC,
  // Data Direction Register
  DDRC,
  // Input Pins Adress
  PINC,


  // *** PORT D ***

  // Data Register
  PORTD,
  // Data Direction Register
  DDRD,
  // Input Pins Adress
  PIND

    : ByteConReg;




  RXC0[UCSR0A,7] : Bit;
  TXC0[UCSR0A,6] : Bit;
  UDRE0[UCSR0A,5] : Bit;



  RXC1[UCSR1A,7] : Bit;
  TXC1[UCSR1A,6] : Bit;
  UDRE1[UCSR1A,5] : Bit;




{
OCR0, OCR2, TCCR0,
TCNT1, OCR1A, OCR1B
ICR1, EEAR, ADC : WordConReg;
}



// *** ISR-Liste ***
//
ISR_LISTE( 2,'INT0addr' ,'EI_INT0'         ,'External Interrupt Request 0');
ISR_LISTE( 3,'INT1addr' ,'EI_INT1'         ,'External Interrupt Request 1');
ISR_LISTE( 4,'INT2addr' ,'EI_INT2'         ,'External Interrupt Request 1');

ISR_LISTE( 5,'PCI0addr' ,'PCINT0'       ,'Pin Change Interrupt Request 0');
ISR_LISTE( 6,'PCI1addr' ,'PCINT1'       ,'Pin Change Interrupt Request 1');
ISR_LISTE( 7,'PCI2addr' ,'PCINT2'       ,'Pin Change Interrupt Request 2');
ISR_LISTE( 8,'PCI3addr' ,'PCINT3'       ,'Pin Change Interrupt Request 3');

ISR_LISTE( 9,'WDTaddr'  ,'WDT'          ,'Watchdog Time-out Interrupt');

ISR_LISTE(10,'OC2Aaddr'  ,'TIMER2_COMPA','Timer/Counter2 Compare Match A');
ISR_LISTE(11,'OC2Baddr'  ,'TIMER2_COMPB','Timer/Counter2 Compare Match B');

ISR_LISTE(12,'OVF2addr' ,'TIMER2_OVF'   ,'Timer/Counter2 Overflow');

ISR_LISTE(13,'ICP1addr' ,'TIMER1_CAPT'  ,'Timer/Counter1 Capture Event');

ISR_LISTE(14,'OC1Aaddr' ,'TIMER1_COMPA' ,'Timer/Counter1 Compare Match A');
ISR_LISTE(15,'OC1Baddr' ,'TIMER1_COMPB' ,'Timer/Counter1 Compare Match B');

ISR_LISTE(16,'OVF1addr' ,'TIMER1_OVF'   ,'Timer/Counter1 Overflow');

ISR_LISTE(17,'OC0Aaddr' ,'TIMER0_COMPA' ,'Timer/Counter0 Compare Match A');
ISR_LISTE(18,'OC0Baddr' ,'TIMER0_COMPB' ,'Timer/Counter0 Compare Match B');

ISR_LISTE(19,'OVF0addr' ,'TIMER0_OVF'   ,'Timer/Counter0 Overflow');

ISR_LISTE(20,'SPIaddr'  ,'SPI_STC'      ,'Serial Transfer Complete');

ISR_LISTE(21,'URXC0addr','USART0_RXC'   ,'USART0, Rx Complete');
ISR_LISTE(22,'UDRE0addr','USART0_UDRE'  ,'USART0 Data Register Empty');
ISR_LISTE(23,'UTXC0addr','USART0_TXC'   ,'USART0, Tx Complete');

ISR_LISTE(24,'ACIaddr'  ,'ANA_COMP'     ,'Analog Comparator');
ISR_LISTE(25,'ADCCaddr' ,'ADC_CC'       ,'ADC Conversion Complete');

ISR_LISTE(26,'ERDYaddr' ,'EE_RDY'       ,'EEPROM Ready');

ISR_LISTE(27,'TWIaddr'  ,'TWI'          ,'Two-wire Serial Interface');
ISR_LISTE(28,'SPMRaddr' ,'SPM_RDY'      ,'Store Program Memory Ready');

ISR_LISTE(29,'URXC1addr','USART1_RXC'   ,'USART0, Rx Complete');
ISR_LISTE(30,'UDRE1addr','USART1_UDRE'  ,'USART0 Data Register Empty');
ISR_LISTE(31,'UTXC1addr','USART1_TXC'   ,'USART0, Tx Complete');

ISR_LISTE(32,'ICP3addr' ,'TIM3_CAPT'    ,'Timer/Counter3 Capture Event');

ISR_LISTE(33,'OC3Aaddr' ,'TIM3_COMPA'   ,'Timer/Counter3 Compare Match A');
ISR_LISTE(34,'OC3Baddr' ,'TIM3_COMPB'   ,'Timer/Counter3 Compare Match B');

ISR_LISTE(35,'OVF3addr' ,'TIM3_OVF'     ,'Timer/Counter3 Overflow');




