
CONST

  // Werte fuer Font_Bez
  fnt_6x8   : Byte = 1;
  fnt_8x8   : Byte = 2;
  fnt_8x12  : Byte = 3;
  fnt_10x16 : Byte = 4;
  fnt_12x20 : Byte = 5;




VAR
  Zeichen : Byte;
  Pixel_Farbe : Word;



procedure LCD_Write_COM(COM_Byte : Byte);
begin

  ClearBit(RS);

  PORTA := 0;
  PORTC := COM_Byte;

  ClearBit(WR);
  NOP;
  NOP;
  NOP;
  NOP;
  SetBit(WR);

end LCD_Write_COM;




procedure LCD_Write_DATA(DATA_Byte_High, DATA_Byte_Low : Byte);
begin

  SetBit(RS);

  PORTA := DATA_Byte_High;
  PORTC := DATA_Byte_Low;

  ClearBit(WR);
  NOP;
  NOP;
  NOP;
  NOP;
  SetBit(WR);

end LCD_Write_DATA;





procedure LCD_Write_DATA_Word(DATA_Byte : Word);
begin

  SetBit(RS);

  PORTA := High(DATA_Byte);
  PORTC := Low(DATA_Byte);

  ClearBit(WR);
  NOP;
  NOP;
  NOP;
  NOP;
  SetBit(WR);

end LCD_Write_DATA_Word;




procedure LCD_Write_COM_DATA(COM_Byte, DATA_Byte_High, DATA_Byte_Low : Byte);
begin

  LCD_Write_COM(COM_Byte);
  LCD_Write_DATA(DATA_Byte_High, DATA_Byte_Low);

end LCD_Write_COM_DATA;






procedure Init_SSD1289;
begin

  SetBit(RSET);
  wait_ms(5);
  ClearBit(RSET);
  wait_ms(15);
  SetBit(RSET);
  wait_ms(15);

  ClearBit(CS);

  // Einschalten des Oszillators
  LCD_Write_COM_DATA($00,$00,$01);

  //Power Control (1)
  LCD_Write_COM_DATA($03,$A8,$A4);

  //Power Control (2)
  LCD_Write_COM_DATA($0C,$00,$00);

  //Power Control (3)
  LCD_Write_COM_DATA($0D,$08,$0C);

  //Power Control (4)
  LCD_Write_COM_DATA($0E,$2B,$00);

  //Power Control (5)
  LCD_Write_COM_DATA($1E,$00,$B7);

  //Driver Output Control RL=0, REV=1, BGR=1, TB=1
  LCD_Write_COM_DATA($01,$2B,$3F);

  //Restore VSYNC mode from low power state
  LCD_Write_COM_DATA($02,$06,$00);

  //Sleep mode cancel
  LCD_Write_COM_DATA($10,$00,$00);

  //Entry Mode
  // DFM   0x4000 = 262L color
  // DFM   0x6000 = 65K color
  // AM    0x0000 = horizontal display
  // AM    0x0008 = Vertical display
  // ID[0] 0x0000 = horizontal decrement
  // ID[0] 0x0010 = horizontal increment
  // ID[1] 0x0000 = Vertical decrement
  // ID[1] 0x0020 = Vertical increment
  LCD_Write_COM_DATA($11,$60,$70);

  // Compare register
  LCD_Write_COM_DATA($05,$00,$00);

  // Compare register
  LCD_Write_COM_DATA($06,$00,$00);

  // Horizontal and Vertical porch are for DOTCLK mode operation
  // Horizontal Porch
  LCD_Write_COM_DATA($16,$EF,$1C);

  // Vertical Porch
  LCD_Write_COM_DATA($17,$00,$03);

  // Display Control
  // D1 0x0000 = display off
  // D1 0x0002 = display on
  // D0 0x0000 = internal display halt
  // D0 0x0001 = internal display operate
  LCD_Write_COM_DATA($07,$02,$33);

  // Frame cycle control
  LCD_Write_COM_DATA($0B,$00,$00);

  // Gate Scan Position
  LCD_Write_COM_DATA($0F,$00,$00);

  // Vertical Scroll Control
  LCD_Write_COM_DATA($41,$00,$00);
  LCD_Write_COM_DATA($42,$00,$00);

  // 1st Screen driving position
  // Start position. 0
  LCD_Write_COM_DATA($48,$00,$00);
  // End position.   319
  LCD_Write_COM_DATA($49,$01,$3F);



  // Source RAM address
  //Horizontal RAM address position start/end setup
  //dec 239
  //dec 0, i.e. horizontal ranges from 0 -> 239
  //POR value is 0xEF00 anyway. This address must be set before RAM write
  LCD_Write_COM_DATA($44,$EF,$00);

  //Vertical RAM address start position setting
  //0x0000 = dec 0
  LCD_Write_COM_DATA($45,$00,$00);

  //Vertical RAM address end position setting (0x013F = dec 319)
  LCD_Write_COM_DATA($46,$01,$3F);


  // 2nd Screen driving position
  // Start position. 0
  LCD_Write_COM_DATA($4A,$00,$00);
  // End position.   0
  LCD_Write_COM_DATA($4B,$00,$00);


  //gamma control
  LCD_Write_COM_DATA($30,$07,$07);
  LCD_Write_COM_DATA($31,$02,$04);
  LCD_Write_COM_DATA($32,$02,$04);
  LCD_Write_COM_DATA($33,$05,$02);
  LCD_Write_COM_DATA($34,$05,$07);
  LCD_Write_COM_DATA($35,$02,$04);
  LCD_Write_COM_DATA($36,$02,$04);
  LCD_Write_COM_DATA($37,$05,$02);
  LCD_Write_COM_DATA($3A,$03,$02);
  LCD_Write_COM_DATA($3B,$03,$02);


  LCD_Write_COM_DATA($23,$00,$00);
  LCD_Write_COM_DATA($24,$00,$00);
  LCD_Write_COM_DATA($25,$80,$00);
  LCD_Write_COM_DATA($4F,$00,$00);
  LCD_Write_COM_DATA($4E,$00,$00);
  LCD_Write_COM($22);

  SetBit(CS);

end Init_SSD1289;





procedure setze_Adresse_Quer(x1,y1,x2,y2 : Word);
var
  b1 : Byte;
  b2 : Byte;
  w1 : Word;
  w2 : Word;
begin

  w1:=x1;
  x1:=y1;
  y1:=w1;

  w1:=x2;
  x2:=y2;
  y2:=w1;

  y1:=319-y1;
  y2:=319-y2;

  w1:=y1;
  y1:=y2;
  y2:=w1;

  b1:=Low(x1);
  b2:=Low(x2);
  Lcd_Write_Com_Data($44,b2,b1);

  b1:=Low(y1);
  b2:=High(y1);
  Lcd_Write_Com_Data($45,b2,b1);

  b1:=Low(y2);
  b2:=High(y2);
  Lcd_Write_Com_Data($46,b2,b1);

  b1:=Low(x1);
  b2:=High(x1);
  Lcd_Write_Com_Data($4E,b2,b1);

  b1:=Low(y1);
  b2:=High(y1);
  Lcd_Write_Com_Data($4F,b2,b1);

  Lcd_Write_Com($22);

end setze_Adresse_Quer;







procedure setze_Adresse_Hoch(x1,y1,x2,y2 : Word);
var
  b1 : Byte;
  b2 : Byte;
begin

  b1:=Low(x1);
  b2:=Low(x2);
  Lcd_Write_Com_Data($44,b2,b1);

  b1:=Low(y1);
  b2:=High(y1);
  Lcd_Write_Com_Data($45,b2,b1);

  b1:=Low(y2);
  b2:=High(y2);
  Lcd_Write_Com_Data($46,b2,b1);

  b1:=Low(x1);
  b2:=High(x1);
  Lcd_Write_Com_Data($4E,b2,b1);

  b1:=Low(y1);
  b2:=High(y1);
  Lcd_Write_Com_Data($4F,b2,b1);

  Lcd_Write_Com($22);

end setze_Adresse_Hoch;






procedure clear_Screen;
var
  b1 : Word;
  b2 : Byte;
begin

  ClearBit(CS);
  setze_Adresse_Quer(0,0,319,239);

  SetBit(RS);

  PORTA := High(Pixel_Farbe);
  PORTC := Low(Pixel_Farbe);

  ClearBit(WR);

  for b1:=1 to 320 do

    for b2:=1 to 240 do

      SetBit(WR);

      ClearBit(WR);

    endfor;

  endfor;

  SetBit(WR);

  SetBit(CS);

end clear_Screen;










// nicht transparente Bilddarstellung
{
procedure draw_Picrure;
var
  w1 : Word;
  w2 : Word;
  w3 : Word;
  w4 : Word;
  Zeiger : Word;
  FarbWert : Word;
begin
  Zeiger:=0;
  w1:=KAEFER1[Zeiger];
  DEC(w1);
  INC(Zeiger);
  w2:=KAEFER1[Zeiger];
  DEC(w2);
  INC(Zeiger);

  ClearBit(CS);
  setze_Adresse_Hoch(0,0,w1,w2);

  for w3:=0 to w1 do

    for w4:=0 to w2 do

      FarbWert:=KAEFER1[Zeiger];
      INC(Zeiger);

      LCD_Write_DATA_Word(FarbWert);

    endfor;

  endfor;

  SetBit(CS);

end draw_Picrure;
}




procedure draw_2Picrure;
var
  w1 : Word;
  w2 : Word;
  w3 : Word;
  w4 : Word;
  Zeiger : Word;
  FarbWert : Word;
begin


  Zeiger:=0;
  w1:=KAEFER1[Zeiger];
  DEC(w1);
  INC(Zeiger);
  w2:=KAEFER1[Zeiger];
  DEC(w2);
  INC(Zeiger);

  ClearBit(CS);
  setze_Adresse_Hoch(0,0,w1,w2);

  for w3:=0 to w1 do

    for w4:=0 to w2 do

      FarbWert:=KAEFER1[Zeiger];
      INC(Zeiger);

      LCD_Write_DATA_Word(FarbWert);

    endfor;

  endfor;



  Zeiger:=0;
  w1:=KAEFER2[Zeiger];
  DEC(w1);
  INC(Zeiger);
  w2:=KAEFER2[Zeiger];
  DEC(w2);
  INC(Zeiger);

  w4:=w2+160;

  ClearBit(CS);
  setze_Adresse_Hoch(0,160,w1,w4);

  for w3:=0 to w1 do

    for w4:=0 to w2 do

      FarbWert:=KAEFER2[Zeiger];
      INC(Zeiger);

      LCD_Write_DATA_Word(FarbWert);

    endfor;

  endfor;

  SetBit(CS);

end draw_2Picrure;






{
procedure draw_2Picrure;
var
  w1 : Word;
  w2 : Word;
  w3 : Word;
  w4 : Word;
  Zeiger : Word;
  FarbWert : Word;
begin


  Zeiger:=0;
  w1:=KAEFER1[Zeiger];
  DEC(w1);
  INC(Zeiger);
  w2:=KAEFER1[Zeiger];
  DEC(w2);
  INC(Zeiger);

  ClearBit(CS);
  setze_Adresse_Hoch(0,0,w1,w2);

  for w3:=0 to w1 do

    for w4:=0 to w2 do

      FarbWert:=KAEFER1[Zeiger];
      INC(Zeiger);

      LCD_Write_DATA_Word(FarbWert);

    endfor;

  endfor;



  Zeiger:=0;
  w1:=KAEFER2[Zeiger];
  DEC(w1);
  INC(Zeiger);
  w2:=KAEFER2[Zeiger];
  DEC(w2);
  INC(Zeiger);

  w4:=w2+160;

  ClearBit(CS);
  setze_Adresse_Hoch(0,160,w1,w4);

  for w3:=0 to w1 do

    for w4:=0 to w2 do

      FarbWert:=KAEFER2[Zeiger];
      INC(Zeiger);

      LCD_Write_DATA_Word(FarbWert);

    endfor;

  endfor;

  SetBit(CS);

end draw_2Picrure;
     }





      {
procedure draw_4Picrure;
var
  w1 : Word;
  w2 : Word;
  w3 : Word;
  w4 : Word;
  Zeiger : Word;
  FarbWert : Word;
begin
  Zeiger:=0;
  w1:=POLDER[Zeiger];
  DEC(w1);
  INC(Zeiger);
  w2:=POLDER[Zeiger];
  DEC(w2);
  INC(Zeiger);

  ClearBit(CS);
  setze_Adresse_Hoch(0,0,w1,w2);

  for w3:=0 to w1 do

    for w4:=0 to w2 do

      FarbWert:=POLDER[Zeiger];
      INC(Zeiger);

      LCD_Write_DATA_Word(FarbWert);

    endfor;

  endfor;


  Zeiger:=2;
  w3:=w1+120;
  w4:=w2;
  setze_Adresse_Hoch(120,0,w3,w4);

  for w3:=0 to w1 do

    for w4:=0 to w2 do

      FarbWert:=POLDER[Zeiger];
      INC(Zeiger);

      LCD_Write_DATA_Word(FarbWert);

    endfor;

  endfor;



  Zeiger:=2;
  w3:=w1;
  w4:=w2+160;
  setze_Adresse_Hoch(0,160,w3,w4);

  for w3:=0 to w1 do

    for w4:=0 to w2 do

      FarbWert:=POLDER[Zeiger];
      INC(Zeiger);

      LCD_Write_DATA_Word(FarbWert);

    endfor;

  endfor;


  Zeiger:=2;
  w3:=w1+120;
  w4:=w2+160;
  setze_Adresse_Hoch(120,160,w3,w4);

  for w3:=0 to w1 do

    for w4:=0 to w2 do

      FarbWert:=POLDER[Zeiger];
      INC(Zeiger);

      LCD_Write_DATA_Word(FarbWert);

    endfor;

  endfor;


  SetBit(CS);

end draw_4Picrure;
        }







procedure Convert_Color(rot, gruen, blau : Byte);
var
  Farb_Byte : Byte;
  Pixel_Farbe_High : Byte;
  Pixel_Farbe_Low : Byte;
  Pixel_Farbe2 : Word;

begin
  Farb_Byte:=rot and $F8;
  Pixel_Farbe_High:=gruen;
  SHR(Pixel_Farbe_High);
  SHR(Pixel_Farbe_High);
  SHR(Pixel_Farbe_High);
  SHR(Pixel_Farbe_High);
  SHR(Pixel_Farbe_High);
  Pixel_Farbe_High:=Pixel_Farbe_High or Farb_Byte;
  Farb_Byte:=gruen and $1C;
  SHL(Farb_Byte);
  SHL(Farb_Byte);
  SHL(Farb_Byte);
  Pixel_Farbe_Low:=blau;
  SHR(Pixel_Farbe_Low);
  SHR(Pixel_Farbe_Low);
  SHR(Pixel_Farbe_Low);
  Pixel_Farbe_Low:=Pixel_Farbe_Low or Farb_Byte;

  Pixel_Farbe:=ByteToWord(Pixel_Farbe_High);
  SHL(Pixel_Farbe);
  SHL(Pixel_Farbe);
  SHL(Pixel_Farbe);
  SHL(Pixel_Farbe);
  SHL(Pixel_Farbe);
  SHL(Pixel_Farbe);
  SHL(Pixel_Farbe);
  SHL(Pixel_Farbe);
  Pixel_Farbe2:=ByteToWord(Pixel_Farbe_Low);
  Pixel_Farbe:=Pixel_Farbe or Pixel_Farbe2;

end Convert_Color;






procedure drawPixel_Hoch(Pos_x, Pos_y : Word);
var
  Pixel_x2 : Word;
  Pixel_y2 : Word;
begin
  Pixel_x2:=Pos_x+1;
  Pixel_y2:=Pos_y+1;
  ClearBit(CS);
  setze_Adresse_Hoch(Pos_x,Pos_y,Pixel_x2,Pixel_y2);
  LCD_Write_DATA_Word(Pixel_Farbe);
  SetBit(CS);

end drawPixel_Hoch;






procedure drawPixel_Quer(Pos_x, Pos_y : Word);
var
  Pixel_x2 : Word;
  Pixel_y2 : Word;
begin
  Pixel_x2:=Pos_x+1;
  Pixel_y2:=Pos_y+1;
  ClearBit(CS);
  setze_Adresse_Quer(Pos_x,Pos_y,Pixel_x2,Pixel_y2);
  LCD_Write_DATA_Word(Pixel_Farbe);
  SetBit(CS);

end drawPixel_Quer;




procedure drawVertikalLine_Quer(Pos_x, Pos_y1, Pos_y2 : Word);
var
  Line : Word;
begin

  ClearBit(CS);

  setze_Adresse_Quer(Pos_x,Pos_y1,Pos_x,Pos_y2);

  SetBit(RS);

  PORTA := High(Pixel_Farbe);
  PORTC := Low(Pixel_Farbe);

  ClearBit(WR);

  for Line:=Pos_y1 to Pos_y2 do

    SetBit(WR);
    ClearBit(WR);

  endfor;

  SetBit(WR);

  SetBit(CS);

end drawVertikalLine_Quer;







procedure drawHorizontalLine_Quer(Pos_x1, Pos_x2, Pos_y : Word);
var
  Line : Word;
  Pos_x : Word;
begin

  ClearBit(CS);

  Pos_x:=319-Pos_x1;
  Pos_x1:=Pos_x;
  Pos_x:=319-Pos_x2;
  Pos_x2:=Pos_x;
  setze_Adresse_Hoch(Pos_y,Pos_x2,Pos_y,Pos_x1);

  SetBit(RS);

  PORTA := High(Pixel_Farbe);
  PORTC := Low(Pixel_Farbe);

  ClearBit(WR);

  for Line:=Pos_x2 to Pos_x1-1 do
    SetBit(WR);
    ClearBit(WR);
  endfor;

  SetBit(WR);

  SetBit(CS);

end drawHorizontalLine_Quer;







procedure drawVertikalLine_Hoch(Pos_x, Pos_y1, Pos_y2 : Word);
var
  Line : Word;
begin

  ClearBit(CS);

  setze_Adresse_Hoch(Pos_x,Pos_y1,Pos_x,Pos_y2);

  SetBit(RS);

  PORTA := High(Pixel_Farbe);
  PORTC := Low(Pixel_Farbe);

  ClearBit(WR);

  for Line:=Pos_y1 to Pos_y2-1 do
    SetBit(WR);
    ClearBit(WR);
  endfor;

  SetBit(WR);

  SetBit(CS);

end drawVertikalLine_Hoch;












procedure drawRectangle_Quer(Pos_x1, Pos_y1, Pos_x2, Pos_y2 : Word);
var
  Line_h : Word;
  Line_v : Word;
begin

  ClearBit(CS);

  setze_Adresse_Quer(Pos_x1,Pos_y1,Pos_x2,Pos_y2);

  SetBit(RS);

  PORTA := High(Pixel_Farbe);
  PORTC := Low(Pixel_Farbe);

  ClearBit(WR);

  for Line_v:=Pos_y1 to Pos_y2 do

    for Line_h:=Pos_x1 to Pos_x2 do

      SetBit(WR);
      ClearBit(WR);

    endfor;

  endfor;

  SetBit(WR);

  SetBit(CS);

end drawRectangle_Quer;












// **********************
// *** FONT-Programme ***
// **********************




PROCEDURE setze_Font(FontGroesse : Byte);
BEGIN
  Font_Bez:=FontGroesse;

  CASE Font_Bez OF

    fnt_6x8 : Zeichenbreite := 6;
              Zeichenbreite0 := 5;
              Zeichenhoehe  := 10; // 8 + 2 = 10
              Zeichenhoehe0 := 7;

              X_ANF := 6;
              Y_ANF := 6;

              max_Spalten := 50;  // 0..99 = 100
              max_Zeilen := 22;   // 0..46 = 47

    |

    fnt_8x8 : Zeichenbreite := 8;
              Zeichenbreite0 := 7;
              Zeichenhoehe  := 10; // 8 + 2 = 10
              Zeichenhoehe0 := 7;

              X_ANF := 4;
              Y_ANF := 6;

              max_Spalten := 38;  // 0..73 = 74
              max_Zeilen := 22;  // 0..46 = 47

    |

    fnt_8x12 : Zeichenbreite := 8;
               Zeichenbreite0 := 7;
               Zeichenhoehe  := 13; // 12 + 3 = 20
               Zeichenhoehe0 := 11;

               X_ANF := 4;
               Y_ANF := 4;

               max_Spalten := 38;  // 0..73 = 74
               max_Zeilen := 17;  // 0..31 = 32

    |

    fnt_10x16 : Zeichenbreite := 10;
                Zeichenbreite0 := 9;
                Zeichenhoehe  := 16; // 16 + 2 = 18
                Zeichenhoehe0 := 15;

                X_ANF := 0;
                Y_ANF := 0;

                max_Spalten := 31;  // 0..58 = 59
                max_Zeilen := 14;  // 0..25 = 26

    |

    fnt_12x20 : Zeichenbreite := 12;
                Zeichenbreite0 := 11;
                Zeichenhoehe  := 20; // 20 + 2 = 22
                Zeichenhoehe0 := 19; // 0..19 = 20

                X_ANF := 4;
                Y_ANF := 0;

                max_Spalten := 25;  // 0..48 = 49
                max_Zeilen := 11;  // 0..20 = 21

    |

    ENDCASE;

    ZeichenbreiteDW := WordToDword(Zeichenbreite);


END setze_Font;






// schreibt ein Zeichen in das Display
// ohne Kursorbewegung
procedure Write_Char_6x8;
var
  FontPtr : Word;
  x_cnt : Byte;
  y_cnt : Byte;
  FontColor : Byte;
  FontZeile : Byte;

begin

  ClearBit(CS);
  LCD_Write_COM_DATA($44,$EF,$00);
  LCD_Write_COM_DATA($45,$00,$00);
  LCD_Write_COM_DATA($46,$01,$3F);
  LCD_Write_COM($22);
  SetBit(CS);


  // Zeiger auf Zeichen in der Zeichentabelle
  FontPtr:=ByteToWord(Zeichen);
  FontPtr:=FontPtr-$20;
  FontPtr:=FontPtr*8;

  for y_cnt:=0 to 7 do

//    FontZeile:=font6x8[FontPtr];
    INC(FontPtr);
    SHR(FontZeile);
    SHR(FontZeile);

    for x_cnt:=0 to 5 do

      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        Pixel_Farbe:=BCOLOR;
      else
        Pixel_Farbe:=FCOLOR;
      endif;

      // drawPixel_Hoch(X_PIX_POS,Y_PIX_POS);

      // LCD Anfang
      ClearBit(CS);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $4E;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Daten X-Position
      SetBit(RS);

      PORTA := HIGH(X_PIX_POS);
      PORTC := LOW(X_PIX_POS);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $4F;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Daten Y-Position
      SetBit(RS);

      PORTA := HIGH(Y_PIX_POS);
      PORTC := LOW(Y_PIX_POS);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $22;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Farbpunkt setzen
      SetBit(RS);

      PORTA := HIGH(Pixel_Farbe);
      PORTC := LOW(Pixel_Farbe);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);

      SetBit(CS);

      // LCD Ende

      SHR(FontZeile);

      Dec(Y_PIX_POS);

    endfor; { for x_cnt:=0 to 5 do }

    Inc(X_PIX_POS);
    Y_PIX_POS:=Y_PIX_POS+6;

  endfor; { for y_cnt:=0 to 7 do }

end Write_Char_6x8;





// schreibt ein Zeichen in das Display
// ohne Kursorbewegung
procedure Write_Char_8x8;
var
  FontPtr : Word;
  x_cnt : Byte;
  y_cnt : Byte;
  FontColor : Byte;
  FontZeile : Byte;

begin

  ClearBit(CS);
  LCD_Write_COM_DATA($44,$EF,$00);
  LCD_Write_COM_DATA($45,$00,$00);
  LCD_Write_COM_DATA($46,$01,$3F);
  LCD_Write_COM($22);
  SetBit(CS);

  // Zeiger auf Zeichen in der Zeichentabelle
  FontPtr:=ByteToWord(Zeichen);
  FontPtr:=FontPtr-$20;
  FontPtr:=FontPtr*8;

  for y_cnt:=0 to 7 do

  //  FontZeile:=font8x8[FontPtr];
    INC(FontPtr);

    for x_cnt:=0 to 7 do

      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        Pixel_Farbe:=BCOLOR;
      else
        Pixel_Farbe:=FCOLOR;
      endif;


      // LCD Anfang
      ClearBit(CS);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $4E;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Daten X-Position
      SetBit(RS);

      PORTA := HIGH(X_PIX_POS);
      PORTC := LOW(X_PIX_POS);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $4F;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Daten Y-Position
      SetBit(RS);

      PORTA := HIGH(Y_PIX_POS);
      PORTC := LOW(Y_PIX_POS);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $22;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Farbpunkt setzen
      SetBit(RS);

      PORTA := HIGH(Pixel_Farbe);
      PORTC := LOW(Pixel_Farbe);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);

      SetBit(CS);

      // LCD Ende


      SHR(FontZeile);

      Dec(Y_PIX_POS);

    endfor; { for x_cnt:=0 to 7 do }

    Inc(X_PIX_POS);
    Y_PIX_POS:=Y_PIX_POS+8;

  endfor; { for y_cnt:=0 to 7 do }

end Write_Char_8x8;






// schreibt ein Zeichen in das Display
// ohne Kursorbewegung
procedure Write_Char_8x12;
var
  FontPtr : Word;
  x_cnt : Byte;
  y_cnt : Byte;
  FontColor : Byte;
  FontZeile : Byte;

begin

  ClearBit(CS);
  LCD_Write_COM_DATA($44,$EF,$00);
  LCD_Write_COM_DATA($45,$00,$00);
  LCD_Write_COM_DATA($46,$01,$3F);
  LCD_Write_COM($22);
  SetBit(CS);

  // Zeiger auf Zeichen in der Zeichentabelle
  FontPtr:=ByteToWord(Zeichen);
  FontPtr:=FontPtr*12;

  for y_cnt:=0 to 11 do

 //   FontZeile:=font8x12[FontPtr];
    INC(FontPtr);

    for x_cnt:=0 to 7 do

      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        Pixel_Farbe:=BCOLOR;
      else
        Pixel_Farbe:=FCOLOR;
      endif;

      // drawPixel_Hoch(X_PIX_POS,Y_PIX_POS);


      // LCD Anfang
      ClearBit(CS);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $4E;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Daten X-Position
      SetBit(RS);

      PORTA := HIGH(X_PIX_POS);
      PORTC := LOW(X_PIX_POS);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $4F;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Daten Y-Position
      SetBit(RS);

      PORTA := HIGH(Y_PIX_POS);
      PORTC := LOW(Y_PIX_POS);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $22;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Farbpunkt setzen
      SetBit(RS);

      PORTA := HIGH(Pixel_Farbe);
      PORTC := LOW(Pixel_Farbe);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);

      SetBit(CS);

      // LCD Ende



      SHR(FontZeile);

      Dec(Y_PIX_POS);

    endfor; { for x_cnt:=0 to 7 do }

    Inc(X_PIX_POS);
    Y_PIX_POS:=Y_PIX_POS+8;

  endfor; { for y_cnt:=0 to 11 do }

end Write_Char_8x12;






// schreibt ein Zeichen in das Display
// ohne Kursorbewegung
procedure Write_Char_10x16;
var
  FontPtr : Word;
  x_cnt : Byte;
  y_cnt : Byte;
  FontColor : Byte;
  FontZeile : Byte;

begin

  ClearBit(CS);
  LCD_Write_COM_DATA($44,$EF,$00);
  LCD_Write_COM_DATA($45,$00,$00);
  LCD_Write_COM_DATA($46,$01,$3F);
  LCD_Write_COM($22);
  SetBit(CS);

  // Zeiger auf Zeichen in der Zeichentabelle
  FontPtr:=ByteToWord(Zeichen);
  FontPtr:=FontPtr*32;

  for y_cnt:=0 to 15 do

  //  FontZeile:=font10x16[FontPtr];
    INC(FontPtr);

    SHR(FontZeile);
    SHR(FontZeile);
    SHR(FontZeile);
    SHR(FontZeile);
    SHR(FontZeile);
    SHR(FontZeile);


    for x_cnt:=0 to 1 do

      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        Pixel_Farbe:=BCOLOR;
      else
        Pixel_Farbe:=FCOLOR;
      endif;

      //drawPixel_Hoch(X_PIX_POS,Y_PIX_POS);


      // LCD Anfang
      ClearBit(CS);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $4E;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Daten X-Position
      SetBit(RS);

      PORTA := HIGH(X_PIX_POS);
      PORTC := LOW(X_PIX_POS);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $4F;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Daten Y-Position
      SetBit(RS);

      PORTA := HIGH(Y_PIX_POS);
      PORTC := LOW(Y_PIX_POS);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $22;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Farbpunkt setzen
      SetBit(RS);

      PORTA := HIGH(Pixel_Farbe);
      PORTC := LOW(Pixel_Farbe);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);

      SetBit(CS);

      // LCD Ende


      SHR(FontZeile);

      Dec(Y_PIX_POS);

    endfor; { for x_cnt:=0 to 1 do }

  //  FontZeile:=font10x16[FontPtr];
    INC(FontPtr);

    for x_cnt:=0 to 7 do

      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        Pixel_Farbe:=BCOLOR;
      else
        Pixel_Farbe:=FCOLOR;
      endif;

      //drawPixel_Hoch(X_PIX_POS,Y_PIX_POS);


      // LCD Anfang
      ClearBit(CS);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $4E;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Daten X-Position
      SetBit(RS);

      PORTA := HIGH(X_PIX_POS);
      PORTC := LOW(X_PIX_POS);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $4F;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Daten Y-Position
      SetBit(RS);

      PORTA := HIGH(Y_PIX_POS);
      PORTC := LOW(Y_PIX_POS);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $22;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Farbpunkt setzen
      SetBit(RS);

      PORTA := HIGH(Pixel_Farbe);
      PORTC := LOW(Pixel_Farbe);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);

      SetBit(CS);

      // LCD Ende


      SHR(FontZeile);

      Dec(Y_PIX_POS);

    endfor; { for x_cnt:=0 to 7 do }

    Inc(X_PIX_POS);
    Y_PIX_POS:=Y_PIX_POS+10;

  endfor; { for y_cnt:=0 to 11 do }

end Write_Char_10x16;











// schreibt ein Zeichen in das Display
// ohne Kursorbewegung
procedure Write_Char_12x20;
var
  FontPtr : Word;
  x_cnt : Byte;
  y_cnt : Byte;
  FontColor : Byte;
  FontZeile : Byte;

begin

  ClearBit(CS);
  LCD_Write_COM_DATA($44,$EF,$00);
  LCD_Write_COM_DATA($45,$00,$00);
  LCD_Write_COM_DATA($46,$01,$3F);
  LCD_Write_COM($22);
  SetBit(CS);

  // Zeiger auf Zeichen in der Zeichentabelle
  FontPtr:=ByteToWord(Zeichen);
  FontPtr:=FontPtr*40;

  for y_cnt:=0 to 19 do

 //   FontZeile:=font12x20[FontPtr];
    INC(FontPtr);

    SHR(FontZeile);
    SHR(FontZeile);
    SHR(FontZeile);
    SHR(FontZeile);


    for x_cnt:=0 to 3 do

      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        Pixel_Farbe:=BCOLOR;
      else
        Pixel_Farbe:=FCOLOR;
      endif;

      // drawPixel_Hoch(X_PIX_POS,Y_PIX_POS);

      // LCD Anfang
      ClearBit(CS);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $4E;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Daten X-Position
      SetBit(RS);

      PORTA := HIGH(X_PIX_POS);
      PORTC := LOW(X_PIX_POS);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $4F;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Daten Y-Position
      SetBit(RS);

      PORTA := HIGH(Y_PIX_POS);
      PORTC := LOW(Y_PIX_POS);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $22;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Farbpunkt setzen
      SetBit(RS);

      PORTA := HIGH(Pixel_Farbe);
      PORTC := LOW(Pixel_Farbe);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);

      SetBit(CS);

      // LCD Ende


      SHR(FontZeile);

      Dec(Y_PIX_POS);

    endfor; { for x_cnt:=0 to 3 do }

 //   FontZeile:=font12x20[FontPtr];
    INC(FontPtr);

    for x_cnt:=0 to 7 do

      FontColor:=FontZeile and %00000001;
      if FontColor = 0 then
        Pixel_Farbe:=BCOLOR;
      else
        Pixel_Farbe:=FCOLOR;
      endif;


      // LCD Anfang
      ClearBit(CS);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $4E;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Daten X-Position
      SetBit(RS);

      PORTA := HIGH(X_PIX_POS);
      PORTC := LOW(X_PIX_POS);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $4F;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Daten Y-Position
      SetBit(RS);

      PORTA := HIGH(Y_PIX_POS);
      PORTC := LOW(Y_PIX_POS);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Kommando
      ClearBit(RS);

      PORTA := 0;
      PORTC := $22;

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);


      // Farbpunkt setzen
      SetBit(RS);

      PORTA := HIGH(Pixel_Farbe);
      PORTC := LOW(Pixel_Farbe);

      ClearBit(WR);
      NOP;
      NOP;
      NOP;
      NOP;
      SetBit(WR);

      SetBit(CS);

      // LCD Ende


      SHR(FontZeile);

      Dec(Y_PIX_POS);

    endfor; { for x_cnt:=0 to 7 do }

    Inc(X_PIX_POS);
    Y_PIX_POS:=Y_PIX_POS+12;

  endfor; { for y_cnt:=0 to 19 do }

end Write_Char_12x20;






procedure Write_Char;
var
  X_PIX_POS2 : Word;
  Y_PIX_POS2 : Word;

begin

  X_PIX_POS2 := X_PIX_POS;
  Y_PIX_POS2 := Y_PIX_POS;

  CASE Font_Bez OF
    fnt_6x8 : Write_Char_6x8;
    |
    fnt_8x8 : Write_Char_8x8;
    |
    fnt_8x12 : Write_Char_8x12;
    |
    fnt_10x16 : Write_Char_10x16;
    |
    fnt_12x20 : Write_Char_12x20;
    |
  ENDCASE;

  X_PIX_POS := X_PIX_POS2;
  Y_PIX_POS := Y_PIX_POS2;

end Write_Char;










