PROGRAM MEGA;

DEVICE = mega2560;

{$I mega2560_Register.INC}


CONST

  // TaktFrequenz in KHz
  TaktFrequenz : WORD = 16000;

  // bei 16,000 MHz ->
  UBRR_VAL : Byte = 5;


  // TerminalMode
  Normal_TM            : Byte = 0;
  IBM_ESC_TM           : Byte = 1;
  IBM_CSI_TM           : Byte = 2;
  IBM_CSI_TM_Par_1     : Byte = 3;
  IBM_CSI_TM_Par_2     : Byte = 4;
  IBM_CSI_TM_Par_3     : Byte = 5;
  IBM_GRAFIK_Par_1_TM  : Byte = 6;
  IBM_GRAFIK_Par_2_TM  : Byte = 7;



  // Festwerte fuer Farben
  cl_White    : Word = $FFFF;
  cl_Black    : Word = $0000;
  cl_Red      : Word = $F800;
  cl_Green    : Word = $0400;
  cl_Blue     : Word = $001F;
  cl_Yellow   : Word = $FFE0;
  cl_Purple   : Word = $8010;
  cl_Aqua     : Word = $07FF;
  cl_Gray     : Word = $8410;
  cl_DarkGray : Word = $8410;  // !!! Anpassen
  cl_Silver   : Word = $C618;
  cl_Maroon   : Word = $8000;
  cl_Olive    : Word = $8400;
  cl_Lime     : Word = $07E0;
  cl_Teal     : Word = $0410;
  cl_Navy     : Word = $0010;
  cl_Fuchsia  : Word = $F81F;


// Font fuer 6x8 Zeichen
//{$I font6x8.INC}

// Font fuer 8x8 Zeichen
//{$I font8x8.INC}

// Font fuer 8x12 Zeichen
{$I font8x12.INC}

// Font fuer 10x16 Zeichen
//{$I font10x16.INC}

// Font fuer 12x20 Zeichen
//{$I font12x20.INC}

// Bild
{$I KUGELN2.INC}






VAR

  LED_GELB[PortB, 7] : bit; // A
  RS[PortD, 7]       : bit; // A
  WR[PortG, 2]       : bit; // A
  CS[PortG, 1]       : bit; // A
  RSET[PortG, 0]     : bit; // A

  DIR_RS[DDRD, 7]    : bit; // A
  DIR_WR[DDRG, 2]    : bit; // A
  DIR_CS[DDRG, 1]    : bit; // A
  DIR_RSET[DDRG, 0]  : bit; // A



  Zeichenbreite, Zeichenhoehe,
  X_ANF, Y_ANF,
  X_PIX_POS, Y_PIX_POS,
  X_KUR_POS, Y_KUR_POS,
  X_END_POS, Y_END_POS,
  delta_x, delta_y : Word;

  Kursor_Schleife,
  ZeichenbreiteDW : DWord;

  Zeichenbreite0, Zeichenhoehe0 : Byte;

  Steuer_String : String[20];


  // Variablen zum Font
  max_Spalten, max_Zeilen : Word;
  Font_Bez : Byte;

  FCOLOR, BCOLOR : Word;

  TermMode : Byte;

  CSI_Parameter1, CSI_Parameter2,
  CSI_Parameter3 : Word;

  Escape_Sequenz : String[10];

  // Kursor-Variablen
  Kursor_sichtbar, Kursor_Ein,
  KurArr_Aktuell : Boolean;

  Kursor_Array : Array [0..239] of Byte;  // Breite*Hoehe = 12x20=240
  CHAR_Array   : Array [0..239] of Byte;



  xx1, xx2, xx3, xx4 : Word;
  yy1, yy2 : Byte;

// System
{$I SYSTEM.INC}

//
{$I LCD_SSD1289.INC}



{

DB0->DB7 to pin D37->D30
PORTC

DB8->DB15 to pin D22->D29
PORTA

RS -> D38
PORTD 7

WR -> D39
PORTG 2

CS(pin6) -> D40
PORTG 1

RSET-> D41
PORTG 0

}


procedure InitPorts;
begin

  // LED
  DDRB:=  %11111111;

  // DB8->DB15
  DDRA:=  %11111111;
  // DB0->DB7
  DDRC:=  %11111111;

  // Daten/Kommandos
  SetBit(RS);
  SetBit(DIR_RS);
  SetBit(RS);

  // Write Low-Aktiv
  SetBit(WR);
  SetBit(DIR_WR);
  SetBit(WR);

  // Chip-Select Low-Aktiv
  SetBit(CS);
  SetBit(DIR_CS);
  SetBit(CS);

  // Reset Low-Aktiv
  SetBit(RSET);
  SetBit(DIR_RSET);
  SetBit(RSET);

end InitPorts;





// *** Hilfsprogramme fuer CONOUT ***






procedure CURSOR_HOME;
begin

  X_KUR_POS:= 0;
  Y_KUR_POS:= 0;

  X_PIX_POS:=Y_ANF;
  Y_PIX_POS:=319-X_ANF;

end CURSOR_HOME;





procedure Reset_Form;
begin


  // setzen der Vordergrundfarbe
  FCOLOR:=cl_Black;

  // setzen der Hintergrundfarbe
  BCOLOR:=cl_White;

  Convert_Color($FF,$FF,$FF);
  clear_Screen;

  CURSOR_HOME;

end Reset_Form;






// Erhoeht die Kursorposition der aktuellen Zeile um 1
//     (wenn die max_Spalten noch nicht erreicht ist)
procedure CURSOR_RIGHT;
begin

  if X_KUR_POS<max_Spalten then
    Inc(X_KUR_POS);
    Y_PIX_POS:=Y_PIX_POS-Zeichenbreite;
  endif;

end CURSOR_RIGHT;





procedure CURSOR_UP;
begin
  if Y_KUR_POS>0 then
    DEC(Y_KUR_POS);
    X_PIX_POS:=X_PIX_POS-Zeichenhoehe;
  endif;
end CURSOR_UP;





// Erhoeht die Kursorposition der aktuellen Zeile um 1
//     (wenn die max_Spalten noch nicht erreicht ist)
procedure CURSOR_DOWN;
begin

  if Y_KUR_POS<max_Zeilen then
    Inc(Y_KUR_POS);
    X_PIX_POS:=X_PIX_POS+Zeichenhoehe;
  endif;

end CURSOR_DOWN;




// Loeschen von Kursorpossition bis zum Zeilenende
procedure DELETE_EOL;
var
  Kur_Pos_Cnt : Word;
  X_KUR_POS2 : Word;
  X_PIX_POS2 : Word;
begin

  Zeichen:=$20;

  X_KUR_POS2:=X_KUR_POS;
  X_PIX_POS2:=X_PIX_POS;

  for Kur_Pos_Cnt:=X_KUR_POS2 to max_Spalten do
    Write_Char;
    CURSOR_RIGHT;
  endfor; { for Kur_Pos_Cnt:=X_KUR_POS2 to 79 do }

  X_KUR_POS:=X_KUR_POS2;
  X_PIX_POS:=X_PIX_POS2;

end DELETE_EOL;






// Loeschen von Anfang bis Kursorpossition
procedure DELETE_BOL;
var
  Kur_Pos_Cnt : Word;
  X_KUR_POS2 : Word;
  X_PIX_POS2 : Word;

begin

  Zeichen:=$20;

  X_KUR_POS2:=X_KUR_POS;
  X_PIX_POS2:=X_PIX_POS;

  X_KUR_POS:=0;
  X_PIX_POS:=X_ANF;

  for Kur_Pos_Cnt:=0 to X_KUR_POS2 do
    Write_Char;
    CURSOR_RIGHT;
  endfor; { for Kur_Pos_Cnt:=0 to X_KUR_POS2 do }

  X_KUR_POS:=X_KUR_POS2;
  X_PIX_POS:=X_PIX_POS2;

end DELETE_BOL;







// Loeschen der gesammten Zeile auf Y-Kursorposition
procedure DELETE_LINE;
var
  Kur_Pos_Cnt : Word;
  X_KUR_POS2 : Word;
  X_PIX_POS2 : Word;

begin

  Zeichen:=$20;

  X_KUR_POS2:=X_KUR_POS;
  X_PIX_POS2:=X_PIX_POS;

  X_KUR_POS:=0;
  X_PIX_POS:=X_ANF;

  for Kur_Pos_Cnt:=0 to max_Spalten do
    Write_Char;
    CURSOR_RIGHT;
  endfor; { for Kur_Pos_Cnt:=0 to max_Spalten do }

  X_KUR_POS:=X_KUR_POS2;
  X_PIX_POS:=X_PIX_POS2;

end DELETE_LINE;





// Loeschen der gesammten Zeile auf Y-Kursorposition
procedure CLEAR_LINE_on_RAMPAGE;
var
  Kur_Pos_Cnt : Word;
  X_KUR_POS2 : Word;
  X_PIX_POS2 : Word;

begin

  Zeichen:=$20;

  X_KUR_POS2:=X_KUR_POS;
  X_PIX_POS2:=X_PIX_POS;

  X_KUR_POS:=0;
  X_PIX_POS:=X_ANF;

  for Kur_Pos_Cnt:=0 to max_Spalten do
    Write_Char;
    CURSOR_RIGHT;
  endfor; { for Kur_Pos_Cnt:=0 to 79 do }

  X_KUR_POS:=X_KUR_POS2;
  X_PIX_POS:=X_PIX_POS2;

end CLEAR_LINE_on_RAMPAGE;




// Loeschen der letzten Zeile
procedure DELETE_last_LINE_on_RAMPAGE;
var
  Kur_Pos_Cnt : Word;
  X_KUR_POS2 : Word;
  X_PIX_POS2 : Word;
  Y_KUR_POS2 : Word;
  Y_PIX_POS2 : Word;

begin

  Zeichen:=$20;

  X_KUR_POS2:=X_KUR_POS;
  X_PIX_POS2:=X_PIX_POS;
  Y_KUR_POS2:=Y_KUR_POS;
  Y_PIX_POS2:=Y_PIX_POS;

  X_KUR_POS:=0;
  X_PIX_POS:=X_ANF;
  Y_KUR_POS:=max_Zeilen;
  Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  Y_PIX_POS:=Y_PIX_POS+Y_ANF; // 231

  for Kur_Pos_Cnt:=0 to max_Spalten do
    Write_Char;
    CURSOR_RIGHT;
  endfor; { for Kur_Pos_Cnt:=0 to 79 do }

  X_KUR_POS:=X_KUR_POS2;
  X_PIX_POS:=X_PIX_POS2;
  Y_KUR_POS:=Y_KUR_POS2;
  Y_PIX_POS:=Y_PIX_POS2;

end DELETE_last_LINE_on_RAMPAGE;





// Loeschen der aktuellen Zeile auf der Kursorposition
// und ScreenRoll
procedure DELETE_LINE_SCR_ROLL_on_RAMPAGE;
var
  Kur_Pos_X_Cnt : Word;
  Kur_Pos_Y_Cnt : Word;
  Y_PIX_POS_von : Word;
  Y_PIX_POS_nach : Word;
  X_PIX_POS2 : Word;
  Y_PIX_POS2 : Word;

begin

  if Y_KUR_POS<=max_Zeilen then

    X_PIX_POS2:=X_PIX_POS;
    Y_PIX_POS2:=Y_PIX_POS;

    for Kur_Pos_Y_Cnt:=Y_KUR_POS to max_Zeilen do

      Y_PIX_POS_nach:=Kur_Pos_Y_Cnt*Zeichenhoehe;
      Y_PIX_POS_nach:=Y_PIX_POS_nach+Y_ANF;
      Y_PIX_POS_von:=Y_PIX_POS_nach+Zeichenhoehe;

      X_PIX_POS:=X_ANF;

      for Kur_Pos_X_Cnt:=0 to max_Spalten do
        Y_PIX_POS:=Y_PIX_POS_von;
    //    VRAM_to_CHAR_Array;
        Y_PIX_POS:=Y_PIX_POS_nach;
    //    CHAR_Array_to_VRAM;
        X_PIX_POS:= X_PIX_POS+Zeichenbreite;
      endfor; { for Kur_Pos_X_Cnt:=0 to max_Spalten do }

    endfor; { for Kur_Pos_Y_Cnt:=Y_KUR_POS to max_Zeilen2 do }

    X_PIX_POS:=X_PIX_POS2;
    Y_PIX_POS:=Y_PIX_POS2;

  endif; { if Y_KUR_POS<=22 then }

end DELETE_LINE_SCR_ROLL_on_RAMPAGE;





// Loeschen der aktuellen Zeile auf der Kursorposition
// und ScreenRoll
procedure DELETE_LINE_SCR_ROLL;
begin
  DELETE_LINE_SCR_ROLL_on_RAMPAGE;
  DELETE_last_LINE_on_RAMPAGE;

end DELETE_LINE_SCR_ROLL;






// neue Zeile der aktuellen Zeile auf der Kursorposition
// und ScreenRoll
procedure INSERT_LINE_SCR_ROLL_on_RAMPAGE;
var
  Kur_Pos_X_Cnt : Word;
  Kur_Pos_Y_Cnt : Word;
  Y_PIX_POS_von : Word;
  Y_PIX_POS_nach : Word;
  X_PIX_POS2 : Word;
  Y_PIX_POS2 : Word;


begin

  if Y_KUR_POS<=max_Zeilen then

    X_PIX_POS2:=X_PIX_POS;
    Y_PIX_POS2:=Y_PIX_POS;

    for Kur_Pos_Y_Cnt:=max_Zeilen downto Y_KUR_POS do

      Y_PIX_POS_von:=Kur_Pos_Y_Cnt*Zeichenhoehe;
      Y_PIX_POS_von:=Y_PIX_POS_von+Y_ANF;
      Y_PIX_POS_nach:=Y_PIX_POS_von+Zeichenhoehe;

      X_PIX_POS:=X_ANF;

      for Kur_Pos_X_Cnt:=0 to max_Spalten do
        Y_PIX_POS:=Y_PIX_POS_von;
     //   VRAM_to_CHAR_Array;
        Y_PIX_POS:=Y_PIX_POS_nach;
     //   CHAR_Array_to_VRAM;
        X_PIX_POS:= X_PIX_POS+Zeichenbreite;
      endfor; { for Kur_Pos_X_Cnt:=0 to max_Spalten do }

    endfor; { for Kur_Pos_Y_Cnt:=max_Zeilen2 downto Y_KUR_POS do }

    X_PIX_POS:=X_PIX_POS2;
    Y_PIX_POS:=Y_PIX_POS2;

  endif; { if Y_KUR_POS<=max_Zeilen2 then }

end INSERT_LINE_SCR_ROLL_on_RAMPAGE;





// neue Zeile der aktuellen Zeile auf der Kursorposition
// und ScreenRoll
procedure INSERT_LINE_SCR_ROLL;
begin
  INSERT_LINE_SCR_ROLL_on_RAMPAGE;
  CLEAR_LINE_on_RAMPAGE;

end INSERT_LINE_SCR_ROLL;





procedure ERASE_DOWN_on_RAMPAGE;
var
  Kur_Pos_X_Cnt : Byte;
  Kur_Pos_Y_Cnt : Word;
  X_KUR_POS2 : Word;
  X_PIX_POS2 : Word;
  Y_KUR_POS2 : Word;
  Y_PIX_POS2 : Word;

begin

  Zeichen:=$20;

  X_KUR_POS2:=X_KUR_POS;
  X_PIX_POS2:=X_PIX_POS;

  Y_KUR_POS2:=Y_KUR_POS;
  Y_PIX_POS2:=Y_PIX_POS;

  for Y_KUR_POS:=Y_KUR_POS2 to max_Zeilen do

    X_PIX_POS:=X_ANF;

    for X_KUR_POS:=0 to max_Spalten do
      Write_Char;
      CURSOR_RIGHT;
    endfor; { for Kur_Pos_Cnt:=0 to 79 do }

    Y_PIX_POS:=Y_PIX_POS+Zeichenhoehe;

  endfor;

  X_KUR_POS:=X_KUR_POS2;
  X_PIX_POS:=X_PIX_POS2;

  Y_KUR_POS:=Y_KUR_POS2;
  Y_PIX_POS:=Y_PIX_POS2;

end ERASE_DOWN_on_RAMPAGE;





// Erases the screen from the current line down to the bottom of the screen.
procedure ERASE_DOWN;
begin
  ERASE_DOWN_on_RAMPAGE;

end ERASE_DOWN;








procedure ScreenRoll_on_RAMPAGE;
var
  Kur_Pos_X_Cnt : Word;
  Kur_Pos_Y_Cnt : Word;
  Y_PIX_POS_von : Word;
  Y_PIX_POS_nach : Word;

begin

  // Dauer fuer 2 x RAMPAGE = 2,843s

  // Verschieben von Zeile 1 bis Ende-2 um 1 nach oben
  for Kur_Pos_Y_Cnt:=0 to max_Zeilen-1 do

    Y_PIX_POS_nach:=Kur_Pos_Y_Cnt*Zeichenhoehe;
    Y_PIX_POS_nach:=Y_PIX_POS_nach+Y_ANF;
    Y_PIX_POS_von:=Y_PIX_POS_nach+Zeichenhoehe;

    X_PIX_POS:=X_ANF;

    for Kur_Pos_X_Cnt:=0 to max_Spalten do

      Y_PIX_POS:=Y_PIX_POS_von;
   //   VRAM_to_CHAR_Array;
      Y_PIX_POS:=Y_PIX_POS_nach;
   //   CHAR_Array_to_VRAM;
      X_PIX_POS:= X_PIX_POS+Zeichenbreite;

    endfor; { for Kur_Pos_X_Cnt:=0 to max_Spalten2 do }

  endfor; { for Kur_Pos_Y_Cnt:=0 to max_Zeilen2-1 do }



  // Loeschen der letzten Zeile
  Zeichen:=$20;

  X_KUR_POS:= 0;
  Y_KUR_POS:= max_Zeilen;

  X_PIX_POS:=X_ANF;
  Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  Y_PIX_POS:=Y_PIX_POS+Y_ANF;

  for X_KUR_POS:=0 to max_Spalten do
    Write_Char;
    X_PIX_POS:=X_PIX_POS+Zeichenbreite;
  endfor; { for Kur_Pos_Cnt:=0 to 79 do }


  X_KUR_POS:= 0;
  Y_KUR_POS:= max_Zeilen;

  X_PIX_POS:=X_ANF;
  Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  Y_PIX_POS:=Y_PIX_POS+Y_ANF;


end ScreenRoll_on_RAMPAGE;









procedure SET_CURSOR_POSITION(Zeile, Spalte : Word); // bezogen auf 0,0 !!!
begin

  // 1. Zeile setzen
  X_KUR_POS:=Spalte;

  if X_KUR_POS>max_Spalten then
    X_KUR_POS:=max_Spalten;
  endif;

  Y_PIX_POS:=Y_KUR_POS*Zeichenbreite;
  Y_PIX_POS:=319-Y_PIX_POS;
  Y_PIX_POS:=Y_PIX_POS-X_ANF;

  // 2. Spalte setzen
  Y_KUR_POS:=Zeile;

  if Y_KUR_POS>max_Zeilen then
    Y_KUR_POS:=max_Zeilen;
  endif;

  X_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  X_PIX_POS:=X_PIX_POS+Y_ANF;

end SET_CURSOR_POSITION;




procedure Carridge_Return;
begin
  X_KUR_POS:=0;
  Y_PIX_POS:=319-X_ANF;

end Carridge_Return;




procedure Anzeige_Zeichensatz;
var
  Zaehler1 : Word;
  Zaehler2 : Word;
begin

  CURSOR_HOME;

  Zeichen:=$20;

  for Zaehler1:=0 to max_Zeilen do

    for Zaehler2:=0 to max_Spalten do

      Write_Char;
      CURSOR_RIGHT;

      Inc(Zeichen);

      if Zeichen=$80 then
        Zeichen:=$20;
      endif;

    endfor;

    CURSOR_DOWN;

    Carridge_Return;

  endfor;

  CURSOR_HOME;

end Anzeige_Zeichensatz;














// *********************
// *** TERMINAL MODE ***
// *********************









procedure Normal_Terminal_Mode;
begin

  case Zeichen of

    $0A :   // 0A = Zeilenschaltung (Line Feed)
            // Y_KUR_POS von 0..23 = 24 Zeilen pro Bildschirm
            if Y_KUR_POS<max_Zeilen then
              INC(Y_KUR_POS);
              X_PIX_POS:= X_PIX_POS+Zeichenhoehe;
            else
              ScreenRoll_on_RAMPAGE;
            endif;

    |

   $0C :    // 0C = Bildschirm loeschen (Clear Screen)
            Reset_Form;

    |

    $0D :   // 0D = Wagenruecklauf (Carridge Return)
            Carridge_Return;

    |

    $1B :   // ESC-Modus
            TermMode:=IBM_ESC_TM;

    |

  else


    if Zeichen>=$20 then
      if Zeichen<=$7F then
        if X_KUR_POS<=max_Spalten then

          Write_Char;
          CURSOR_RIGHT;

     //     VRAM_to_Kursor_Array;
          Kursor_sichtbar:=false;
          Kursor_Schleife:=0;
          KurArr_Aktuell:=true;

        endif; { if X_KUR_POS<80 then }
      endif; { if Zeichen<=$7F then }
    endif; { if Zeichen>=$20 then  }

  endcase; { case Zeichen of }


end Normal_Terminal_Mode;







procedure Escape_Reset;
begin
  CSI_Parameter1:=0;
  CSI_Parameter2:=0;
  CSI_Parameter3:=0;
  TermMode:=Normal_TM;
  Escape_Sequenz:='';
end Escape_Reset;






procedure Escape_Fehler;
var
  ESC_Zaehler : Byte;
  ESC_Laenge  : Byte;
  ESC_Zeichen : Char;
begin

  Zeichen:=$45; // E
  Write_Char;
  CURSOR_RIGHT;

  Zeichen:=$53; // S
  Write_Char;
  CURSOR_RIGHT;

  Zeichen:=$43; // C
  Write_Char;
  CURSOR_RIGHT;

  ESC_Laenge:=Length(Escape_Sequenz);

  for ESC_Zaehler:=1 to ESC_Laenge do
    ESC_Zeichen:=Escape_Sequenz[ESC_Zaehler];
    Zeichen:=CharToByte(ESC_Zeichen);
    Write_Char;
    CURSOR_RIGHT;
  endfor;

  Escape_Reset;
end Escape_Fehler;




procedure IBM_ESC_Terminal_Mode;
begin

  case Zeichen of

    $5B : TermMode:=IBM_CSI_TM; // Control Sequence Introducer (CSI) = ESC [
    |

    $47 : TermMode:=IBM_GRAFIK_Par_1_TM; // GRAFIK-Mode = ESC G
    |

  else

    Escape_Fehler;

  endcase;

end IBM_ESC_Terminal_Mode;







procedure Set_Display_Attributes(DispAttr : Word);
begin


  case DispAttr of

    // *** Textattribute ***


    // ESC [ 0 m = Alle Attribute AUS (Reset all attributes)
    0 : FCOLOR:=cl_Blue;
    |

    // ESC [ 1 m = Fett ein
    1 : FCOLOR:=cl_Gray;
    |

    // ESC [ 4 m = Unterstreichen
    4 : FCOLOR:=cl_Purple;
    |

    // ESC [ 5 m = Blinken EIN
    5 : FCOLOR:=cl_Red;

    |

    // ESC [ 7 m = Invertierte Darstellung
    7 : FCOLOR:=cl_Black;

    |

    // ESC [ 8 m = Versteckt ein
    8 : FCOLOR:=cl_White;

    |



   // *** Schriftgroesse ***

    // ESC [ 11 m = Font 6x8
    11 :   setze_Font(fnt_6x8);
    |

    // ESC [ 12 m = Font 8x8
    12 :   setze_Font(fnt_8x8);
    |

    // ESC [ 13 m = Font 8x12
    13 :   setze_Font(fnt_8x12);
    |

    // ESC [ 14 m = Font 10x16
    14 :   setze_Font(fnt_10x16);
    |

    // ESC [ 15 m = Font 12x20
    15 :   setze_Font(fnt_12x20);
    |



    // *** Vordergrundfarben ***

    // ESC [ 30 m = Vordergrundfarbe - 30 Schwarz
    30 : FCOLOR:=cl_Black;
    |

    // ESC [ 31 m = Vordergrundfarbe - 31 Rot
    31 : FCOLOR:=cl_Red;

    |

    // ESC [ 32 m = Vordergrundfarbe - 32 Grün
    32 : FCOLOR:=cl_Green;
    |

    // ESC [ 33 m = Vordergrundfarbe - 33 Gelb
    33 : FCOLOR:=cl_Yellow;
    |

    // ESC [ 34 m = Vordergrundfarbe - 34 Blau
    34 : FCOLOR:=cl_Blue;
    |

    // ESC [ 35 m = Vordergrundfarbe - 35 Karmesinrot (Purpur, lila)
    35 : FCOLOR:=cl_Purple;
    |

    // ESC [ 36 m = Vordergrundfarbe - 36 Cyanblau
    36 : FCOLOR:=cl_Aqua;
    |

    // ESC [ 37 m = Vordergrundfarbe - 37 Weiß
    37 : FCOLOR:=cl_White;
    |



    // *** Hintergrundfarben ***

    // ESC [ 40 m = Hintergrundfarbe - 40 Schwarz
    40 : BCOLOR:=cl_Black;
    |

    // ESC [ 41 m = Hintergrundfarbe - 41 Rot
    41 : BCOLOR:=cl_Red;
    |

    // ESC [ 42 m = Hintergrundfarbe - 42 Grün
    42 : BCOLOR:=cl_Green;
    |

    // ESC [ 43 m = Hintergrundfarbe - 43 Gelb
    43 : BCOLOR:=cl_Yellow;
    |

    // ESC [ 44 m = Hintergrundfarbe - 44 Blau
    44 : BCOLOR:=cl_Blue;
    |

    // ESC [ 45 m = Hintergrundfarbe - 45 Karmesinrot (Purpur, lila)
    45 : BCOLOR:=cl_Purple;
    |

    // ESC [ 46 m = Hintergrundfarbe - 46 Cyanblau
    46 : BCOLOR:=cl_Aqua;
    |

    // ESC [ 47 m = Hintergrundfarbe - 47 Weiß
    47 : BCOLOR:=cl_White;

    |

    else
      Escape_Fehler;
    endcase;

end Set_Display_Attributes;








procedure IBM_CSI_Terminal_Mode;
begin

  case Zeichen of

    $30..$39 : CSI_Parameter1:=ByteToWord(Zeichen)-$30;
               TermMode:=IBM_CSI_TM_Par_1;
    |

    $4B : // Loeschen bis Zeilenende = ESC [ K
          DELETE_EOL;
          Escape_Reset;
    |

    $66 : // Schirm loeschen = ESC [ f
          //Reset_Form;
          Escape_Reset;
    |

    $6D : // Turn off character attributes = ESC [ m
          Set_Display_Attributes(0);
          Escape_Reset;
    |

    $3F : // Hide/Show the cursor = ESC [ ? 2 5 h
          CSI_Parameter1:=0;
          TermMode:=IBM_CSI_TM_Par_1;
    |

    $48 : // "H" -- MOVE CURSOR = ESC [ H
          SET_CURSOR_POSITION(0,0);
          Escape_Reset;
    |

    $4A : // "J" -- Erase Down = ESC [ J
          // Erases the screen from the current line down to the bottom of the screen.
          ERASE_DOWN;
          Escape_Reset;
    |

    $4D : // "M" -- Move the cursor up in scrolling region = ESC [ M
          DELETE_LINE;
          CURSOR_UP;
          DELETE_LINE;
          Escape_Reset;
    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }

end IBM_CSI_Terminal_Mode;










// IBM_CSI_TM_Par_1
procedure IBM_CSI_Par_1_Terminal_Mode;
var
  Zaehler : Word;
begin

  case Zeichen of

    $30..$39 : CSI_Parameter1:=CSI_Parameter1*10;
               CSI_Parameter1:=CSI_Parameter1+ByteToWord(Zeichen);
               CSI_Parameter1:=CSI_Parameter1-$30;

               TermMode:=IBM_CSI_TM_Par_1;
    |

    $3B :      // ";"
	       // ESC [ Pn1 ; PN2 H oder
	       // ESC [ Pn1 ; PN2 f oder
               // ESC [ Pn1 ; PN2 m oder
	       // Xterm 256 colors - ESC[48;5;BCOLOR m oder
	       // Xterm 256 colors - ESC[38;5;FCOLOR m
               TermMode:=IBM_CSI_TM_Par_2;

    |

    $4A : // Zeilen loeschen = ESC [ Pn J

          case CSI_Parameter1 of

            2 : // Loeschen gesammte zeile
                //Reset_Form;

            |
          else
            Escape_Fehler;
          endcase;
          Escape_Reset;
    |


    $4B : // Zeilen loeschen = ESC [ Pn K

          case CSI_Parameter1 of

            0 : // Löschen bis Zeilenende
                DELETE_EOL;
            |

            1 : // Löschen von Anfang bis Kursor
                DELETE_BOL;
            |

            2 : // Löschen gesammte zeile
                DELETE_LINE;
            |

          else
            Escape_Fehler;
          endcase;
          Escape_Reset;
    |


    $4C : // INSERT_LINE_SCR_ROLL = ESC [ Pn L
          for Zaehler:=0 to CSI_Parameter1-1 do
            INSERT_LINE_SCR_ROLL;
          endfor;
          Escape_Reset;
    |


    $4D : // "M" DELETE_LINE_SCR_ROLL = ESC [ Pn M
          for Zaehler:=0 to CSI_Parameter1-1 do
            DELETE_LINE_SCR_ROLL;
          endfor;
          Escape_Reset;
    |


    $6D : // "m" Character Attributes = ESC [ Pn m
          Set_Display_Attributes(CSI_Parameter1);
          Escape_Reset;
    |



    $6C : // "l" ESC [ ? X X l

          case CSI_Parameter1 of

            // "l" Text_Kursor_Aus = ESC [ ? 2 5 l
            25 : if Kursor_sichtbar then
                   Kursor_sichtbar:=false;
                   //Schalte_Kursor_Aus;
                 endif;

                 Kursor_Ein:=false;
                 Escape_Reset;

            |


          else
            Escape_Fehler;
          endcase; { case CSI_Parameter1 of }

    |


    $68 : // "h" ESC [ ? X X h

          case CSI_Parameter1 of

            // "h" Text_Kursor_Ein = ESC [ ? 2 5 h
            25 : Kursor_Schleife:=0;
                 Kursor_Ein:=true;
                 Escape_Reset;

            |


          else
            Escape_Fehler;
          endcase; { case CSI_Parameter1 of }

    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }

end IBM_CSI_Par_1_Terminal_Mode;








// IBM_CSI_TM_Par_2
procedure IBM_CSI_Par_2_Terminal_Mode;
begin

  case Zeichen of

    $30..$39 : CSI_Parameter2:=CSI_Parameter2*10;
               CSI_Parameter2:=CSI_Parameter2+ByteToWord(Zeichen);
               CSI_Parameter2:=CSI_Parameter2-$30;

               TermMode:=IBM_CSI_TM_Par_2;
    |

    $3B : // ";"
          // Xterm 256 colors - ESC[48;5;BCOLOR m
          // Xterm 256 colors - ESC[38;5;FCOLOR m
          TermMode:=IBM_CSI_TM_Par_3;
    |


    $48 : // "H" -- MOVE CURSOR = ESC [ Pn1 ; PN2 H
          SET_CURSOR_POSITION(CSI_Parameter1,CSI_Parameter2);
          Escape_Reset;
    |

    $66 : // "f" -- MOVE CURSOR = ESC [ Pn1 ; PN2 f
          SET_CURSOR_POSITION(CSI_Parameter1,CSI_Parameter2);
          Escape_Reset;
    |

    $6D : // "m" -- 2 mal Character Attributes = ESC [ Pn1 ; PN2 m
          Set_Display_Attributes(CSI_Parameter1);
          Set_Display_Attributes(CSI_Parameter2);
          Escape_Reset;

    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }


end IBM_CSI_Par_2_Terminal_Mode;





procedure IBM_CSI_Par_3_Terminal_Mode;
begin


  case Zeichen of

    $30..$39 : CSI_Parameter3:=CSI_Parameter3*10;
               CSI_Parameter3:=CSI_Parameter3+ByteToWord(Zeichen);
               CSI_Parameter3:=CSI_Parameter3-$30;

               TermMode:=IBM_CSI_TM_Par_3;

    |


    $6D : // "m"

          case CSI_Parameter1 of

          48 : // Xterm 256 colors - ESC[48;5;BCOLOR m
               if CSI_Parameter2=5 then
                 BCOLOR:=CSI_Parameter3;
               else
                 Escape_Fehler;
               endif;
          |

          38 : // Xterm 256 colors - ESC[38;5;FCOLOR m
               if CSI_Parameter2=5 then
                 FCOLOR:=CSI_Parameter3;
               else
                 Escape_Fehler;
               endif;
          |

          else
            Set_Display_Attributes(CSI_Parameter1);
            Set_Display_Attributes(CSI_Parameter2);
            Set_Display_Attributes(CSI_Parameter3);
          endcase;

          Escape_Reset;

    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }


end IBM_CSI_Par_3_Terminal_Mode;





// ESC G - Auswertung der ESC-Grafik-Steuerzeichen



procedure IBM_GRAFIK_Par_1_Terminal_Mode;
begin

  case Zeichen of

    $30..$39 : CSI_Parameter1:=CSI_Parameter1*10;
               CSI_Parameter1:=CSI_Parameter1+ByteToWord(Zeichen);
               CSI_Parameter1:=CSI_Parameter1-$30;

               TermMode:=IBM_GRAFIK_Par_1_TM;

    |

    $3B : // ";"
          TermMode:=IBM_GRAFIK_Par_2_TM;

    |

    $43 : // "C" -- Grafik_setze_Farbe = ESC G Pn1 C
          //PIXCOLOR:=Low(CSI_Parameter1);
          Escape_Reset;

    |

    $4B : // "K" -- Grafik_zeichne_Kreis = ESC G Pn1 K
          //Grafik_zeichne_Kreis(CSI_Parameter1);
          Escape_Reset;

    |

    $56 : // "V" -- Grafik_zeichne_vollen_Kreis = ESC G Pn1 V
          //Grafik_zeichne_vollen_Kreis(CSI_Parameter1);
          Escape_Reset;

    |


  else

    Escape_Fehler;

  endcase; { case Zeichen of }


end IBM_GRAFIK_Par_1_Terminal_Mode;





procedure IBM_GRAFIK_Par_2_Terminal_Mode;
begin

  case Zeichen of

    $30..$39 : CSI_Parameter2:=CSI_Parameter2*10;
               CSI_Parameter2:=CSI_Parameter2+ByteToWord(Zeichen);
               CSI_Parameter2:=CSI_Parameter2-$30;

               TermMode:=IBM_GRAFIK_Par_2_TM;

    |

    $47 : // "G" -- Grafik_setze_Position = ESC G Pn1 ; Pn2 G
          X_PIX_POS:=CSI_Parameter1;
          Y_PIX_POS:=CSI_Parameter2;
          Escape_Reset;

    |

    $50 : // "P" -- Grafik_zeichne_Punkt = ESC G Pn1 ; Pn2 P
          X_PIX_POS:=CSI_Parameter1;
          Y_PIX_POS:=CSI_Parameter2;
          //Grafik_setze_Punkt;
          Escape_Reset;

    |

    $4C : // "L" -- Grafik_zeichne_Linie = ESC G Pn1 ; Pn2 L
          X_END_POS:=CSI_Parameter1;
          Y_END_POS:=CSI_Parameter2;
          //Grafik_zeichne_Linie;
          Escape_Reset;

    |

    $52 : // "R" -- Grafik_zeichne_Rechteck = ESC G Pn1 ; Pn2 R
          X_END_POS:=CSI_Parameter1;
          Y_END_POS:=CSI_Parameter2;
          //Grafik_zeichne_Rechteck;
          Escape_Reset;

    |

    $46 : // "F" -- Grafik_zeichne_volles_Rechteck = ESC G Pn1 ; Pn2 F
          X_END_POS:=CSI_Parameter1;
          Y_END_POS:=CSI_Parameter2;
          //Grafik_zeichne_volles_Rechteck;
          Escape_Reset;

    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }


end IBM_GRAFIK_Par_2_Terminal_Mode;








procedure CONOUT;
var
  C_Zeichen : Char;
begin

  if Kursor_sichtbar then
    //Schalte_Kursor_Aus;
    Kursor_sichtbar:=false;
  endif;
  Kursor_Schleife:=0;
  KurArr_Aktuell:=false;

  // Abspeichern der Escape-Steuerzeichen fuer die
  // Anzeige der nicht ausgewerteter Sequenzen im Fehlerfall
  if TermMode<>Normal_TM then
    C_Zeichen:=ByteToChar(Zeichen);
    Escape_Sequenz:=Escape_Sequenz+C_Zeichen;
  endif;

  case TermMode of

    Normal_TM            : Normal_Terminal_Mode;
    |

    IBM_ESC_TM           : IBM_ESC_Terminal_Mode;
    |

    IBM_CSI_TM           : IBM_CSI_Terminal_Mode;
    |

    IBM_CSI_TM_Par_1     : IBM_CSI_Par_1_Terminal_Mode;
    |

    IBM_CSI_TM_Par_2     : IBM_CSI_Par_2_Terminal_Mode;
    |

    IBM_CSI_TM_Par_3     : IBM_CSI_Par_3_Terminal_Mode;
    |

    IBM_GRAFIK_Par_1_TM  : IBM_GRAFIK_Par_1_Terminal_Mode;
    |

    IBM_GRAFIK_Par_2_TM  : IBM_GRAFIK_Par_2_Terminal_Mode;
    |

  else

    Escape_Fehler;

  endcase;

end CONOUT;





procedure Text_an_CONOUT;
var
  b1 : Byte;
  b2 : Byte;
  c1 : Char;
begin

  b1:=Length(Write_String);

  for b2:=1 to b1 do

    c1:=Write_String[b2];
    Zeichen:=CharToByte(c1);
    CONOUT;

  endfor;

  Zeichen:=$0D;
  CONOUT;

  Zeichen:=$0A;
  CONOUT;

end Text_an_CONOUT;













BEGIN

  InitPorts;

  SetBit(LED_GELB);
  wait_ms(100);
  ClearBit(LED_GELB);
  wait_ms(100);

  Init_SSD1289;

  Reset_Form;

  TermMode:=Normal_TM;

  setze_Font(fnt_12x20);


  draw_2Picrure;


  loop

    SetBit(LED_GELB);
    wait_ms(500);
    ClearBit(LED_GELB);
    wait_ms(500);

  endloop;



END MEGA.
