



procedure Init_ADC;
begin

  // ADC Control and Status Register A.

  {
  Name
  ADEN ADSC ADFR ADIF ADIE ADPS2 ADPS1 ADPS0 (Name)
  7    6    5    4    3    2     1     0     (Bit)
  1    0    1    0    0    1     1     1     (Belegung)

  ADPS2...ADPS0 (ADC Prescaler Select Bits)
  16.000.000 Hz / 200.000 Hz = 80
  16.000.000 Hz / 50.000 Hz = 320

  Teilungsfaktor 128 -> 16.000.000 / 128 = 125 KHz
  }
  ADCSRA := %11100111;



  // ADMUX ADC Multiplexer Select Register
  {
  Name
  REFS1 REFS0 ADLAR MUX4 MUX3 MUX2 MUX1 MUX0 (Name)
  7     6     5     4    3    2     1     0     (Bit)
  0     1     0     0    0    0     0     0     (Belegung)

  REFS1=0 und REFS0=1 -> AVCC als Referenz (interne Referenz: Avcc)
  ADLAR (ADC Left Adjust Result)=0 -> rechtsbuendig
  MUX4...MUX0
  }

  ADMUX:=%01000000;



end Init_ADC;







procedure ADC_starten(Kanal : Byte);
var
  Ergebnis_Low  : Byte;
  Ergebnis_High : Byte;

begin

  // ADMUX ADC Multiplexer Select Register
  {
  Name
  REFS1 REFS0 ADLAR MUX4 MUX3 MUX2 MUX1 MUX0 (Name)
  7     6     5     4    3    2     1     0     (Bit)
  0     1     0     0    0    0     0     0     (Belegung)

  REFS1=0 und REFS0=1 -> AVCC als Referenz (interne Referenz: Avcc)
  ADLAR (ADC Left Adjust Result)=0 -> rechtsbuendig
  MUX4...MUX0
  }

  Ergebnis_Low:=Kanal and %00000111;
  Ergebnis_Low:=Ergebnis_Low or %01000000;
  ADMUX:=Ergebnis_Low;



  // ADC Control and Status Register A.

  {
  Name
  ADEN ADSC ADFR ADIF ADIE ADPS2 ADPS1 ADPS0 (Name)
  7    6    5    4    3    2     1     0     (Bit)
  1    1    1    0    0    1     1     1     (Belegung)

  ADPS2...ADPS0 (ADC Prescaler Select Bits)
  16.000.000 Hz / 200.000 Hz = 80
  16.000.000 Hz / 50.000 Hz = 320

  Teilungsfaktor 128 -> 16.000.000 / 128 = 125 KHz
  }
  ADCSRA := %11000111;

  ClearBit(LED_BL);

end ADC_starten;





function ADC_bereit : Boolean;
var
  ADC_ok : Boolean;
begin

  if BitHigh(ADC_ADSC) then
    ADC_ok:=false;
  else
    ADC_ok:=true;
  endif;

  RESULT:=ADC_ok;

end ADC_bereit;






function ADC_lesen : Word;
var
  Ergebnis_Low  : Byte;
  Ergebnis_High : Byte;
  Ergebnis_Word : Word;
  Ergebnis_Word2 : Word;
begin

  SetBit(LED_BL);


  Ergebnis_Low:=ADCL;
  Ergebnis_High:=ADCH;

  Ergebnis_Word:=ByteToWord(Ergebnis_High);
  SHL(Ergebnis_Word);
  SHL(Ergebnis_Word);
  SHL(Ergebnis_Word);
  SHL(Ergebnis_Word);
  SHL(Ergebnis_Word);
  SHL(Ergebnis_Word);
  SHL(Ergebnis_Word);
  SHL(Ergebnis_Word);

  Ergebnis_Word2:=ByteToWord(Ergebnis_Low);

  Ergebnis_Word:=Ergebnis_Word or Ergebnis_Word2;

  RESULT:=Ergebnis_Word;

end ADC_lesen;







