PROGRAM ECHO;

DEVICE = mega1284P;


{$I mega1284_Register.INC}


{$I mega644P_1284P_TC.INC}




CONST

  // TaktFrequenz in KHz
  TaktFrequenz : WORD = 18432;

  // bei 18.432 MHz -> 115200
  UBRR_VAL : Byte = 9;

  SINTAB_Ende : Word = 15000;


VAR

  LED_WS[PortD, 6] : bit;  // -> A (High-Aktiv)
  LED_BL[PortD, 7] : bit;  // -> A (High-Aktiv)

  ADC_ADSC[ADCSRA, 6] : bit;  // -> A (High-Aktiv)



  Steuer_String : String[40];
  Sende_String : String[40];

  SINTAB : array[0..15000] of Byte;

  // interne Variablen fuer die
  Zaehler : Word;
  SIN_wert : Byte;


CONST

{$I SYSTEM.INC}

{$I mega8_128_ADC_ECHO.INC}

{$I mega16_128_UART0_oI.INC}




procedure InitPorts;
begin

  {
  A0 - ADC Eingang 8-Bit
  A1..A7 frei
  }
  DDRA:=  %00000000;
  PortA:= %00000000;

  {
  B0..B4 frei
  B5 = MOSI
  B6 = MISO
  B7 = SCK
  }
  DDRB:=  %00000000;
  PortB:= %00000000;

  {
  C0..C7 - DAC (Ausgang)
  }
  DDRC:=  %11111111;
  PortC:= %00000000;

  {
  D0 = RXD - UART (Eingang)
  D1 = TXD - UART (Ausgang)
  D2 = frei
  D3 = frei
  D4 = frei
  D5 = frei
  D6 = LED_BL (Ausgang)
  D7 = LED_WS (Ausgang)
  }
  //       LLXXXXTR
  DDRD:=  %11000010;
  PortD:= %00000000;

end InitPorts;





isr TIMER1_COMPA;
begin

ASM;

; Retten der benutzten Register
        PUSH       R17
        PUSH       R18
        PUSH       R19
        PUSH       R24
        PUSH       R25
        PUSH       ZL
        PUSH       ZH

ENDASM;

  SIN_wert:=SINTAB[Zaehler];
  PORTC:=SIN_wert;

  SIN_wert:=ADCL;
  SIN_wert:=ADCH;
  SINTAB[Zaehler]:=SIN_wert;

  INC(Zaehler);
  if Zaehler=SINTAB_Ende then
    Zaehler:=0;
  endif;


ASM;

; Rueckholen der benutzten Register
        POP        ZH
        POP        ZL
        POP        R25
        POP        R24
        POP        R19
        POP        R18
        POP        R17

ENDASM;


end TIMER1_COMPA;










procedure Steuer_String_auswerten;
var
  Buchstabe : Char;
  Zeichen_1 : Char;
  Zeichen_2 : Char;
  Laenge : Byte;
begin
  Laenge:=Length(Steuer_String);

  if Laenge>0 then
    Buchstabe:=Steuer_String[1];
    case Buchstabe of

            // a
      'a' : if Laenge=1 then
              SetBit(LED_BL);
            else
              Write_String:='x01';
              WriteLn_SER0;
            endif;

      |


           // b
      'b' : if Laenge=1 then
              ClearBit(LED_BL);
            else
              Write_String:='x01';
              WriteLn_SER0;
            endif;

      |


           // c
      'c' : if Laenge=1 then
              // ADC_senden;
            else
              Write_String:='x01';
              WriteLn_SER0;
            endif;

      |


    else
      Write_String:='x02';
      WriteLn_SER0;
    endcase;

  endif; { if Laenge>0 then }

end Steuer_String_auswerten;






procedure Steuer_String_lesen;
var
  akt_Zeichen : Char;
begin
  if SER0_Zeichen<>$0D then // 0D wird ignoriert

    if SER0_Zeichen=$0A then  // bei 0A wird ausgerwertet
      Steuer_String_auswerten;
      Steuer_String:='';
    else
      akt_Zeichen:=ByteToChar(SER0_Zeichen);
      Steuer_String:= Steuer_String + akt_Zeichen; // sonst nur abgespeichert
    endif; { if akt_Zeichen<>char($0A) }

  endif; { if akt_Zeichen<>char($0D) then }

end Steuer_String_lesen;








BEGIN

  // Initialisierung der Ports
  InitPorts;

  // Initialisierung der seriellen Schnittstelle
  INIT_SER0_PORT;

  // Initialisierung des AD-Wandlers
  Init_ADC;


  ClearBit(LED_BL);
  ClearBit(LED_WS);



  Zaehler:=0;

  // Frequenz = 18.432.000 Hz;
  // Frequenz / 20.000 Hz = 922;
  Init_TIMER1_COMPA(922);


  EnableInts;





  loop


    RX0_Puffer_abfragen;

    if SER0_Zeichen>0 then
      Steuer_String_lesen;
    endif;


  endloop;



END ECHO.
