



// **********************************************






procedure STD_an_UART_senden;
begin

  // Sector, Track, Drive (STD) = s SE TH TL DR
  ByteToString(SECTOR);
  Anzeige_String:='s'+Byte_String;
  ByteToString(TRACK_H);
  Anzeige_String:=Anzeige_String+Byte_String;
  ByteToString(TRACK_L);
  Anzeige_String:=Anzeige_String+Byte_String;
  ByteToString(DISKNO);
  SER0_String:=Anzeige_String+Byte_String;

  // Senden der STD
  WriteLn_SER0;

end STD_an_UART_senden;







// liest die Bytes aus der SteuerString in den Sektor_Puffer
procedure Steuer_String_To_Sector;
var
  b1 : Byte;
  b2 : Byte;
  b3 : Byte;
  c1 : Char;
begin
  b2:=2;
  for b1:=0 to 15 do
    c1:=Steuer_String[b2];
    Inc(b2);
    Byte_String:=c1;
    c1:=Steuer_String[b2];
    Inc(b2);
    Byte_String:=Byte_String+c1;
    b3:=StringToByte;
    Sektor_Puffer[Sektor_Puffer_Zeiger]:=b3;
    Inc(Sektor_Puffer_Zeiger);
  endfor;

end Steuer_String_To_Sector;







// liest die Bytes aus der SteuerString in den Sektor_Puffer aber komprimiert
procedure Steuer_String_To_Sector_Komp;
var
 // x1 : Byte;
  x2 : Byte;
  DB7 : Byte;
  DB8 : Byte;
  BitPos_DB8 : Byte;
  BitPos_DB7 : Byte;
  c1 : Char;
  Pos_SS : Byte;
  ein_Bit : Boolean;

begin
  BitPos_DB8:=7;
  DB8:=$00;
  for Pos_SS:=2 to 38 do

    c1:=Steuer_String[Pos_SS];
    DB7:=CharToByte(c1);

    BitPos_DB7:=7;
    for x2:=0 to 6 do

      Dec(BitPos_DB7); // 6..0
      ein_Bit:=Read_Bit_in_Byte(DB7,BitPos_DB7);

      if ein_Bit then
        DB8:=Set_Bit_in_Byte(DB8,BitPos_DB8);
      else
        DB8:=Clear_Bit_in_Byte(DB8,BitPos_DB8);
      endif;

      if BitPos_DB8=0 then

        Sektor_Puffer[Sektor_Puffer_Zeiger]:=DB8;
        Inc(Sektor_Puffer_Zeiger);

        BitPos_DB8:=7;
        DB8:=$00;

      else
        Dec(BitPos_DB8);
      endif;

    endfor; { for x2:=0 to 6 do }

  endfor; { for x1:=1 to 18 do }

end Steuer_String_To_Sector_Komp;








// **********************************************





procedure Steuer_String_auswerten;
var
  Buchstabe : Char;
  Zeichen_1 : Char;
  Zeichen_2 : Char;
  Laenge : Byte;
begin
  Laenge:=Length(Steuer_String);

  if Laenge>0 then
    Buchstabe:=Steuer_String[1];
    case Buchstabe of

            // T5B 2+1 Senden eines Zeichens an CONIN des Mikrocontrollers
      'T' : if Laenge=3 then
              Zeichen_1:=Steuer_String[2];
              Zeichen_2:=Steuer_String[3];
              Byte_String:=Zeichen_1+Zeichen_2;
              ConsoleIn:=StringToByte;
              ConsoleIn_gelesen:=true;
            else
              SER0_String:='x01';
              WriteLn_SER0;
            endif;

      |

            // UD0D1D2D3D4D5D6D7D8D9DADBDCDDDEDF  16*2+1
      'U' : if Laenge=33 then // ein Sektor-Abschnitt
              Steuer_String_To_Sector;
            else
              SER0_String:='x03';
              WriteLn_SER0;
            endif;

      |

          // RB01B02B03B04..B36 36+1
      'R' : if Laenge=38 then // ein Sektor-Abschnitt
              Steuer_String_To_Sector_Komp;
            else
              SER0_String:='x07';
              WriteLn_SER0;
            endif;
      |



    else
      SER0_String:='x02';
      WriteLn_SER0;
    endcase;

  endif; { if Laenge>0 then }



end Steuer_String_auswerten;




procedure Steuer_String_lesen;
var
  akt_Zeichen : Char;
  empf_Zeichen : Byte;
begin
  empf_Zeichen:=UDR;

  if empf_Zeichen<>$0D then // 0D wird ignoriert

    if empf_Zeichen=$0A then  // bei 0A wird ausgerwertet
      Steuer_String_auswerten;
      Steuer_String:='';
    else
      akt_Zeichen:=ByteToChar(empf_Zeichen);
      Steuer_String:= Steuer_String + akt_Zeichen; // sonst nur abgespeichert
    endif; { if akt_Zeichen<>char($0A) }

  endif; { if akt_Zeichen<>char($0D) then }

end Steuer_String_lesen;







// **********************************************





procedure Sektor_von_UART_lesen;
var
  b1 : Byte;
  b2 : Byte;
  SPZ : Word;
  LeseSchleife : Word;
begin

  Sektor_Puffer_Zeiger:=0;
  SPZ:=0;

  for b1:=0 to 7 do
    ByteToString(b1);
    SER0_String:='u'+Byte_String;
    WriteLn_SER0;

    LeseSchleife:=60000;
    while LeseSchleife>5 do

      if BitHigh(RXC0) then
        Steuer_String_lesen;
        if SPZ=Sektor_Puffer_Zeiger then
          LeseSchleife:=60000;
        else
          LeseSchleife:=1;  // Ende
          SPZ:=Sektor_Puffer_Zeiger;
        endif;
      endif;

      Dec(LeseSchleife);
    endwhile;

    if LeseSchleife>0 then
      SER0_String:='x04';
      WriteLn_SER0;
    endif;

  endfor;

end Sektor_von_UART_lesen;







procedure Sektor_von_UART_lesen_Komp;
var
  b1 : Byte;
  b2 : Byte;
  SPZ : Word;
  LeseSchleife : Word;
begin

  Sektor_Puffer_Zeiger:=0;
  SPZ:=0;

  for b1:=0 to 3 do
    ByteToString(b1);
    SER0_String:='r'+Byte_String;
    WriteLn_SER0;

    LeseSchleife:=60000;
    while LeseSchleife>5 do

      if BitHigh(RXC0) then
        Steuer_String_lesen;
        if SPZ=Sektor_Puffer_Zeiger then
          LeseSchleife:=60000;
        else
          LeseSchleife:=1;  // Ende
          SPZ:=Sektor_Puffer_Zeiger;
        endif;
      endif;

      Dec(LeseSchleife);
    endwhile;

    if LeseSchleife>0 then
      SER0_String:='x08';
      WriteLn_SER0;
    endif;

  endfor;

end Sektor_von_UART_lesen_Komp;








procedure Sektor_an_UART_senden;
var
  b1 : Byte;
  b2 : Byte;
  b3 : Byte;
begin

  Sektor_Puffer_Zeiger:=0;

  for b1:=0 to 7 do

    ByteToString(b1);
    Anzeige_String:='v'+Byte_String;

    for b2:=0 to 15 do
      b3:=Sektor_Puffer[Sektor_Puffer_Zeiger];
      Inc(Sektor_Puffer_Zeiger);
      ByteToString(b3);
      Anzeige_String:=Anzeige_String+Byte_String;
    endfor; { for b2:=0 to 15 do }

    SER0_String:=Anzeige_String;
    WriteLn_SER0;

  endfor; { for b1:=0 to 7 do }

end Sektor_an_UART_senden;







// **********************************************





procedure CONST_von_UART_lesen;
var
  LeseSchleife : Word;
begin

  SER0_String:='j';
  WriteLn_SER0;

  LeseSchleife:=60000;
  ConsoleIn_gelesen:=false;

  while LeseSchleife>5 do

    if BitHigh(RXC0) then

      Steuer_String_lesen;

      if ConsoleIn_gelesen then
        LeseSchleife:=2;  // Ende
      else
        LeseSchleife:=60000;
      endif; { if Datum_gesetzt then }

    endif;

    Dec(LeseSchleife);

  endwhile;

  if LeseSchleife>2 then
    SER0_String:='x11';
    WriteLn_SER0;
  endif;

end CONST_von_UART_lesen;









procedure CONIN_von_UART_lesen;
var
  LeseSchleife : Word;
begin

  SER0_String:='i';
  WriteLn_SER0;

  LeseSchleife:=60000;
  ConsoleIn_gelesen:=false;

  while LeseSchleife>5 do

    if BitHigh(RXC0) then

      Steuer_String_lesen;

      if ConsoleIn_gelesen then
        LeseSchleife:=2;  // Ende
      else
        LeseSchleife:=60000;
      endif; { if Datum_gesetzt then }

    endif;

    Dec(LeseSchleife);

  endwhile;

  if LeseSchleife>2 then
    SER0_String:='x12';
    WriteLn_SER0;
  endif;

end CONIN_von_UART_lesen;








procedure UART_CONIN_Schleife;
begin

  ConsoleIn:=0;

  while ConsoleIn=0 do
    CONST_von_UART_lesen;
  endwhile;

  CONIN_von_UART_lesen;

end UART_CONIN_Schleife;






procedure UART_CONOUT_senden;
begin

  // serial-CONOUT
  ByteToString(ConsoleOut);
  SER0_String:='o'+Byte_String;
  WriteLn_SER0;

end UART_CONOUT_senden;







procedure UART_Abfrageschleife_SER0;
begin

  while SER0_detected=false do

    wait_ms(100);

    // es wird ein nul an das serielle Geraet gesendet
    xon_aktiv:=false;
    sende_Zeichen0(nul);

    wait_ms(100);

    // wurde ein Zeichen an der seriellen Schnittstelle
    // empfangen, wird der Puffer ausgelesen
    // und SER0_detected auf true gesetzt
    while BitHigh(RXC0) do

      RX0_wait_before_sending_abfragen;

    endwhile;


  endwhile;


end UART_Abfrageschleife_SER0;





// **********************************************







