
// ******************************
// *** serielle Schnittstelle ***
// ******************************


VAR
  SER1_Zeichen : Byte;
  SER1_String : String[40];


procedure INIT_SER1_PORT;
begin

{
 Initialisieren der seriellen Schnittstelle
 ---------------------------------------------

; festlegen der Baudrate fuer die serielle Schnittstelle
}

    UBRR1H := 0;
    UBRR1L := UBRR_VAL;

{
Bit 4 RXEN: Receiver Enable
Bit 3 TXEN: Transmitter Enable
}
    UCSR1B := %00011000;

{
URSEL UMSEL UPM1 UPM0 USBS UCSZ1 UCSZ0 UCPOL
    1     0    0    0    0     1     1     0
}
    UCSR1C := %10000110;


end INIT_SER1_PORT;




procedure RX1_Puffer_abfragen;
begin
  // wurde ein Byte durch die UART empfangen, so ist das RXC1-Bit gesetzt
  // ist RXC1-Bit = 0, dann ist der Empfangs-Puffer leer
  if BitHigh(RXC1) then
    SER1_Zeichen:=UDR1;
  else
    SER1_Zeichen:=0;
  endif; { if BitHigh(RXC1) then }
end RX1_Puffer_abfragen;




function RX1_Byte_Lesen : Byte;
begin

  RX1_Puffer_abfragen;

  while SER1_Zeichen=0 do
    RX1_Puffer_abfragen;
  endwhile;

  Result:=SER1_Zeichen;

end RX1_Byte_Lesen;





function RX1_Zeichen_Lesen : Char;
var
  c1 : Char;
begin

  RX1_Puffer_abfragen;

  while SER1_Zeichen=0 do
    RX1_Puffer_abfragen;
  endwhile;

  c1:=ByteToChar(SER1_Zeichen);

  Result:=c1;

end RX1_Zeichen_Lesen;




procedure sende_Zeichen1(s_Zeichen1 : Byte);
begin
  // wenn UDRE1 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE1 = 0
  while BitLow(UDRE1) do
//    SetBit(LED_GRUEN); // gruen ein
  endwhile;

 // ClearBit(LED_GRUEN); // gruen aus

  UDR1:=s_Zeichen1;

end sende_Zeichen1;




// SER1_String an SER1
procedure Write_SER1;
var
  c1 : Char;
  Laenge : Byte;
  b1 : Byte;
  b2 : Byte;
begin

  Laenge:=Length(SER1_String);
  for b1:=1 to Laenge do
    c1:=SER1_String[b1];
    b2:=CharToByte(c1);
    sende_Zeichen1(b2);
  endfor;

end Write_SER1;




procedure WriteLn_SER1;
begin
  Write_SER1;
  sende_Zeichen1($0D); // CR
  sende_Zeichen1($0A); // LF
end WriteLn_SER1;



