

ASM;



; globale Konstanten
.equ   len_font_tab = 16
.equ   pos_font_tab = 32


; Verwaltung der Ports
; ---------------------

.equ 	port_control_b	= portb
.equ 	port_daten	= portd



; *** port_control_b ***

.equ 	VSYNC		= 0		;// Vertikale Synchronimpulse Pin 14
.equ 	HSYNC		= 1		;// Horizontale Synchronimpulse Pin 15
.equ	b_LED_GN	= 2		;// b_LED_GN -> gruene LED  Pin 16
.equ 	b_CE_CLK	= 3		;// /b_CI fuer 74HC165 - CLock Inhibit / Taktsperre Pin 17
.equ 	b_SL		= 4		;// /b_SL fuer 74HC165 - Shift / Load - Schieben / Laden Pin 18



; VERTICAL LINE CONTROL
.equ 	VL_RESET	= 0     ; 01
.equ 	VL_VER_IMP	= 1     ; 02
.equ 	VL_OUT_VA	= 2     ; 04
.equ 	VL_BWS          = 3     ; 08
.equ 	VL_LEER         = 4     ; 10




	lds	R16,tcnt1l
	cpi	R16,13
	brlo	LATFIX1

LATFIX1:
	cpi	R16,14
	brlo	LATFIX2

LATFIX2:
	cpi	R16,15
	brlo	LATFIX3

LATFIX3:
	cpi	R16,16
	brlo	LATFIX4

LATFIX4:



	push	R17
	push	R18

	push	zl
	push	zh
	push	yl
	push	yh


	lds	yl, Wert_yl
	lds	yh, Wert_yh




; HORIZONTAL SYNC LOW
	cbi	port_control_b, HSYNC




; SET POINTER TO VLINE TABLE
	ldi	zl,low(2*VLINE)
	ldi	zh,high(2*VLINE)



; SET VLINE TABLE POSITION
	add	zl,yl
	adc	zh,yh


; READ VLINE TABLE BYTE
	lpm	R16,z



; INCREMENT VLINE COUNTER
	adiw	yh:yl,1				



; RESET VLINE COUNTER
	sbrc	R16,VL_RESET			
	clr	yl
	sbrc	R16,VL_RESET			
	clr	yh


	sts	Wert_yl, yl
	sts	Wert_yh, yh


; VERTICAL SYNC CONTROL
	sbrc	R16, VL_VER_IMP	
	cbi	port_control_b, VSYNC
	sbrs	R16, VL_VER_IMP		
	sbi	port_control_b, VSYNC


; HORIZONTAL SYNC HIGH
	sbi	port_control_b, HSYNC


        lds	yl, Wert_BWS_L
        lds	yh, Wert_BWS_H






; BWS auf Anfang setzen
	sbrs	R16,VL_BWS
        rjmp	BWS_weiter

	ldi	yl, low(Zeichen_Matrix)
	ldi	yh, high(Zeichen_Matrix)

        sts     Wert_BWS_L, yl
        sts     Wert_BWS_H, yh

BWS_weiter:


; CONTROL ACTIVE LINES
	sbrs	R16,VL_OUT_VA
	rjmp	NOVID




; Ausgabe einer Leerzeile
	sbrc	R16,VL_LEER
	rjmp	NOMATRIX






; -----------------------------------------------
; ab hier wird eine Bildschirmzeile ausgegeben
; -----------------------------------------------

        lds	zh, Wert_zh

	in      R17, port_control_b      ;// 1
	cbr	R17, 0b00011000          ;// 1
        mov     R18, R17                 ;// 1 - R17 -> R18
        sbr     R18, 0b00010000          ;// 1
        ;// R17 -> /CE_CLK (3) aktiv, ShiftLoad (4) auf 0 -> Load
        ;// R18 -> /CE_CLK (3) aktiv, ShiftLoad (4) auf 1 -> Shift






; *** 0..7 ***


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1





; *** 8..15 ***

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1





; *** 16..23 ***

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1



; *** 24..31 ***

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1




; *** 32..39 ***

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1




; *** 40..47 ***

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1




; *** 48..55 ***

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1




; *** 56..63 ***

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


; *** 64..71 ***


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

       	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

       	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1





; *** 72..79 ***


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

       	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

       	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

       	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1



; *** 80 ***




;// *** nach XX Zeichen ***



	ldi	R16, 0x00               ; 1
	out	port_daten, R16         ; 1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1





	sbi	port_control_b, b_CE_CLK



        inc     zh
        cpi     zh, pos_font_tab+len_font_tab

	brne    video_zh

	ldi	zh, pos_font_tab
        sts     Wert_BWS_L, yl
        sts     Wert_BWS_H, yh

video_zh:


       	sts	Wert_zh, zh



; -----------------------------------------------





; BLANKING LINES EXIT POINT
NOVID:


	pop	yh
	pop	yl
	pop	zh
	pop	zl


	pop	r18
	pop	r17


        rjmp    video_end



NOMATRIX:

	in      R17, port_control_b      ;// 1
	cbr	R17, 0b00011000          ;// 1
        mov     R18, R17                 ;// 1 - R17 -> R18
        sbr     R18, 0b00010000          ;// 1
        ;// R17 -> /CE_CLK (3) aktiv, ShiftLoad (4) auf 0 -> Load
        ;// R18 -> /CE_CLK (3) aktiv, ShiftLoad (4) auf 1 -> Shift


        nop
        nop
        nop
        nop


        ldi     zl, 0

NOMATRIX_01:

	ldi	R16, 0xFF               ; 1
	out	port_daten, R16         ; 1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


        inc     zl                     ; 1
        cpi     zl, 79                 ; 1


	brne    NOMATRIX_01             ; 1


        nop
        nop
        nop
        nop
        nop


	ldi	R16, 0x00               ; 1
	out	port_daten, R16         ; 1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


    	sbi	port_control_b, b_CE_CLK



	pop	yh
	pop	yl
	pop	zh
	pop	zl


	pop	r18
	pop	r17



video_end:


ENDASM;



