

var
  C_FCOLOR, C_BCOLOR : Byte;




// *** Hilfsprogramme fuer CONOUT ***




procedure Convert_ColorByte_to_ColorWord;
var
  CC_Word : Word;
begin

  CC_Word:=ByteToWord(C_FCOLOR);
  L_FCOLOR:=COLOR_256[CC_Word];

  CC_Word:=ByteToWord(C_BCOLOR);
  L_BCOLOR:=COLOR_256[CC_Word];

end Convert_ColorByte_to_ColorWord;




procedure Matrix_to_Write_Char;
begin

  C_FCOLOR:=VG_Farb_Matrix[X_KUR_POS,Y_KUR_POS];

  C_BCOLOR:=HG_Farb_Matrix[X_KUR_POS,Y_KUR_POS];
  Convert_ColorByte_to_ColorWord;

  L_Zeichen:=Zeichen_Matrix[X_KUR_POS,Y_KUR_POS];

  Write_Char;

end Matrix_to_Write_Char;
















procedure Kursor_Ausschalten;
begin

  Kursor_sichtbar:=false;
  Matrix_to_Write_Char;
  Kursor_Schleife:=0;

end Kursor_Ausschalten;



procedure Kursor_Einschalten;
begin

  Kursor_sichtbar:=true;

  C_FCOLOR:=VG_Farb_Matrix[X_KUR_POS,Y_KUR_POS];

  C_BCOLOR:=HG_Farb_Matrix[X_KUR_POS,Y_KUR_POS];
  Convert_ColorByte_to_ColorWord;

  L_Zeichen:=$5F;  // '_';

  Write_Char;

  Kursor_Schleife:=0;

end Kursor_Einschalten;






procedure Kursor_Umschalten;
begin

  if Kursor_sichtbar then
    Kursor_Ausschalten;
  else
    Kursor_Einschalten;
  endif;
end Kursor_Umschalten;
















// schreibt die Zeile an der aktuellen Zeilenposition (Y_KUR_POS) neu
procedure Show_Line;
begin

  for X_KUR_POS:=0 to max_Spalten do

    Matrix_to_Write_Char;

  endfor;

end Show_Line;





procedure Show_Matrix;
begin

  for Y_KUR_POS:=0 to max_Zeilen do

    Show_Line;

  endfor;

  X_KUR_POS:= 0;
  Y_KUR_POS:= 0;

end Show_Matrix;





procedure Clear_Matrix;
begin

  for Y_KUR_POS:=0 to max_Zeilen do

    for X_KUR_POS:=0 to max_Spalten do

      VG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_VG;
      HG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_HG;
      Zeichen_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellzeichen;

    endfor;

  endfor;

  X_KUR_POS:= 0;
  Y_KUR_POS:= 0;

end Clear_Matrix;








procedure Fill_Color_Matrix;
var
  Color_Counter : Byte;
 begin

  Color_Counter:=0;

  for Y_KUR_POS:=0 to max_Zeilen do

    for X_KUR_POS:=0 to max_Spalten do

      VG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Color_Counter;
      HG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Color_Counter;
      Zeichen_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellzeichen;

      Inc(Color_Counter);

    endfor;

  endfor;

  X_KUR_POS:= 0;
  Y_KUR_POS:= 0;

end Fill_Color_Matrix;











procedure CURSOR_HOME;
begin

  Clear_Matrix;

  clear_Screen;

  X_KUR_POS:= 0;
  Y_KUR_POS:= 0;

  TermMode:=Normal_TM;

end CURSOR_HOME;





procedure RESET_DISPLAY;
begin

  // setzen der Vordergrundfarbe
  C_FCOLOR:=cl_Black;

  // setzen der Hintergrundfarbe
  C_BCOLOR:=cl_White;

  Convert_ColorByte_to_ColorWord;

  X_KUR_POS:= 0;
  Y_KUR_POS:= 0;

end RESET_DISPLAY;






// Erhoeht die Kursorposition der aktuellen Zeile um 1
//     (wenn die max_Spalten noch nicht erreicht ist)
procedure CURSOR_RIGHT;
begin

  if X_KUR_POS<max_Spalten then
    Inc(X_KUR_POS);
  endif;

  TermMode:=Normal_TM;

end CURSOR_RIGHT;




procedure CURSOR_LEFT;
begin

  if X_KUR_POS>0 then
    DEC(X_KUR_POS);
  endif;

  TermMode:=Normal_TM;

end CURSOR_LEFT;





procedure CURSOR_UP;
begin

  if Y_KUR_POS>0 then
    DEC(Y_KUR_POS);
  endif;

  TermMode:=Normal_TM;

end CURSOR_UP;





// Erhoeht die Kursorposition der aktuellen Zeile um 1
//     (wenn die max_Spalten noch nicht erreicht ist)
procedure CURSOR_DOWN;
begin

  if Y_KUR_POS<max_Zeilen then
    Inc(Y_KUR_POS);
  endif;

  TermMode:=Normal_TM;

end CURSOR_DOWN;





procedure CURSOR_TAB;
begin

  X_KUR_POS:=X_KUR_POS div 8;
  X_KUR_POS:=X_KUR_POS + 1;
  X_KUR_POS:=X_KUR_POS * 8;

  TermMode:=Normal_TM;

end CURSOR_TAB;





{ *** DELETE *** }



// Loeschen von Kursorpossition bis zum Zeilenende
procedure DELETE_EOL;
var
  X_KUR_POS2 : Word;

begin

  X_KUR_POS2:=X_KUR_POS;

  for X_KUR_POS:=X_KUR_POS2 to max_Spalten do

    VG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_VG;
    HG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_HG;
    Zeichen_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellzeichen;

  endfor; { for X_KUR_POS:=X_KUR_POS2 to max_Spalten do }

  Show_Line;

  X_KUR_POS:=X_KUR_POS2;

end DELETE_EOL;






// Loeschen von Anfang bis Kursorpossition
procedure DELETE_BOL;
var
  X_KUR_POS2 : Word;

begin

  X_KUR_POS2:=X_KUR_POS;

  for X_KUR_POS:=0 to X_KUR_POS2 do

    VG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_VG;
    HG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_HG;
    Zeichen_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellzeichen;

  endfor; { for X_KUR_POS:=0 to X_KUR_POS2 do }

  Show_Line;

  X_KUR_POS:=X_KUR_POS2;

end DELETE_BOL;





// Loeschen der gesammten Zeile auf Y-Kursorposition
procedure DELETE_LINE;
var
  X_KUR_POS2 : Word;

begin

  X_KUR_POS2:=X_KUR_POS;

  for X_KUR_POS:=0 to max_Spalten do

    VG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_VG;
    HG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_HG;
    Zeichen_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellzeichen;

  endfor; { for X_KUR_POS:=0 to max_Spalten do }

  Show_Line;

  X_KUR_POS:=X_KUR_POS2;

end DELETE_LINE;







// Loeschen der letzten Zeile
procedure DELETE_last_LINE;
var
  X_KUR_POS2 : Word;
  Y_KUR_POS2 : Word;

begin

  X_KUR_POS2:=X_KUR_POS;
  Y_KUR_POS2:=Y_KUR_POS;

  Y_KUR_POS:=max_Zeilen;

  for X_KUR_POS:=0 to max_Spalten do

    VG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_VG;
    HG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_HG;
    Zeichen_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellzeichen;

  endfor; { for X_KUR_POS:=0 to max_Spalten do }

  Show_Line;

  X_KUR_POS:=X_KUR_POS2;
  Y_KUR_POS:=Y_KUR_POS2;

end DELETE_last_LINE;





// Loeschen der aktuellen Zeile auf der Kursorposition
// und ScreenRoll
procedure DELETE_LINE_SCR_ROLL;
var
  X_KUR_POS2 : Word;
  Y_KUR_POS2 : Word;

begin

  X_KUR_POS2:=X_KUR_POS;
  Y_KUR_POS2:=Y_KUR_POS;

  if Y_KUR_POS<=max_Zeilen then

    for Y_KUR_POS:=Y_KUR_POS2 to max_Zeilen do

      for X_KUR_POS:=0 to max_Spalten do

        VG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_VG;
        HG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_HG;
        Zeichen_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellzeichen;

      endfor; { for Kur_Pos_X_Cnt:=0 to max_Spalten do }

    endfor; { for Kur_Pos_Y_Cnt:=Y_KUR_POS to max_Zeilen2 do }


  endif; { if Y_KUR_POS<=22 then }

  Show_Matrix;

  X_KUR_POS:=X_KUR_POS2;
  Y_KUR_POS:=Y_KUR_POS2;

end DELETE_LINE_SCR_ROLL;







// neue Zeile der aktuellen Zeile auf der Kursorposition
// und ScreenRoll
procedure INSERT_LINE_SCR_ROLL;
var
  X_KUR_POS2 : Word;
  Y_KUR_POS2 : Word;

begin

  X_KUR_POS2:=X_KUR_POS;
  Y_KUR_POS2:=Y_KUR_POS;

  if Y_KUR_POS<=max_Zeilen then

    for Y_KUR_POS:=max_Zeilen downto Y_KUR_POS2 do

      for X_KUR_POS:=0 to max_Spalten do

        VG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_VG;
        HG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_HG;
        Zeichen_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellzeichen;

      endfor; { for X_KUR_POS:=0 to max_Spalten do }

    endfor; { for Y_KUR_POS:=max_Zeilen downto Y_KUR_POS2 do }

  endif; { if Y_KUR_POS<=max_Zeilen then }

  Show_Matrix;

  X_KUR_POS:=X_KUR_POS2;
  Y_KUR_POS:=Y_KUR_POS2;

end INSERT_LINE_SCR_ROLL;






// Loeschen aller Zeilen von Kursorposition
// bis Bildschirmende
procedure ERASE_DOWN;
var
  X_KUR_POS2 : Word;
  Y_KUR_POS2 : Word;

begin

  X_KUR_POS2:=X_KUR_POS;
  Y_KUR_POS2:=Y_KUR_POS;

  for Y_KUR_POS:=Y_KUR_POS2 to max_Zeilen do

    for X_KUR_POS:=0 to max_Spalten do

      VG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_VG;
      HG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_HG;
      Zeichen_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellzeichen;

    endfor; { for Kur_Pos_Cnt:=0 to 79 do }

  endfor;

  Show_Matrix;

  X_KUR_POS:=X_KUR_POS2;
  Y_KUR_POS:=Y_KUR_POS2;

end ERASE_DOWN;






// Verschieben aller Zeilen um eins nach oben
// die erste Zeile wird ueberschrieben
procedure Screen_Roll;
var
  X_KUR_POS2 : Word;
  Y_KUR_POS2 : Word;
  one_Byte : Byte;

begin

  // Verschieben von Zeile 1 bis Ende-2 um 1 nach oben
  for Y_KUR_POS:=0 to max_Zeilen-1 do

    for X_KUR_POS:=0 to max_Spalten do

      one_Byte:=VG_Farb_Matrix[X_KUR_POS,Y_KUR_POS+1];
      VG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=one_Byte;

      one_Byte:=HG_Farb_Matrix[X_KUR_POS,Y_KUR_POS+1];
      HG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=one_Byte;

      one_Byte:=Zeichen_Matrix[X_KUR_POS,Y_KUR_POS+1];
      Zeichen_Matrix[X_KUR_POS,Y_KUR_POS]:=one_Byte;

    endfor; { for Kur_Pos_X_Cnt:=0 to max_Spalten2 do }

  endfor; { for Kur_Pos_Y_Cnt:=0 to max_Zeilen2-1 do }


  // Loeschen der letzten Zeile
  Y_KUR_POS:=max_Zeilen;

  for X_KUR_POS:=0 to max_Spalten do

    VG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_VG;
    HG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellfarbe_HG;
    Zeichen_Matrix[X_KUR_POS,Y_KUR_POS]:=Fuellzeichen;

  endfor; { for X_KUR_POS:=0 to max_Spalten do }

  Show_Matrix;

  X_KUR_POS:= 0;
  Y_KUR_POS:= max_Zeilen;

end Screen_Roll;









procedure SET_CURSOR_POSITION(Zeile, Spalte : Word); // bezogen auf 0,0 !!!
begin

  // 1. Zeile setzen
  X_KUR_POS:=Spalte;

  if X_KUR_POS>max_Spalten then
    X_KUR_POS:=max_Spalten;
  endif;

  // 2. Spalte setzen
  Y_KUR_POS:=Zeile;

  if Y_KUR_POS>max_Zeilen then
    Y_KUR_POS:=max_Zeilen;
  endif;

end SET_CURSOR_POSITION;




procedure Carridge_Return;
begin

  X_KUR_POS:=0;

end Carridge_Return;




procedure LINE_FEED;
begin

  if Y_KUR_POS<max_Zeilen then
    INC(Y_KUR_POS);
  else
    Screen_Roll;
  endif;

end LINE_FEED;







// *********************
// *** TERMINAL MODE ***
// *********************





procedure Normal_Terminal_Mode;
begin

  case L_Zeichen of

    $01 :    // 01 = Kursor auf Anfang (0,0)
             CURSOR_HOME;
     |

    $04 :    // 01 = Kursor nach Rechts
             CURSOR_RIGHT;
     |

    $05 :    // 01 = Kursor nach Oben
             CURSOR_UP;
     |

    $07 :    // 07 = BELL - Glocke
             //RUN_BELL;
     |

    $09 :    // 09 = Tabulator
             CURSOR_TAB;
     |

    $0A :   // 0AH = Zeilenschaltung (Line Feed)
            LINE_FEED;
     |

    $0C :   // 0CH = Bildschirm loeschen (Clear Screen)
            RESET_DISPLAY;
     |

    $0D :   // 0DH = Wagenruecklauf (Carridge Return)
            Carridge_Return;
     |

    $13 :   // 13H = Kursor nach Links
            CURSOR_LEFT;
     |

    $16 :   // ab Cursorposition bis Zeilenende loeschen
            DELETE_EOL;
     |

    $1B :   // ESC-Modus
            TermMode:=IBM_ESC_TM;

    |

  else


    if L_Zeichen>=$20 then
      if L_Zeichen<=$7F then
        if X_KUR_POS<=max_Spalten then

          VG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=C_FCOLOR;
          HG_Farb_Matrix[X_KUR_POS,Y_KUR_POS]:=C_BCOLOR;
          Zeichen_Matrix[X_KUR_POS,Y_KUR_POS]:=L_Zeichen;

          Convert_ColorByte_to_ColorWord;

          Write_Char;
          CURSOR_RIGHT;


        endif; { if X_KUR_POS<80 then }
      endif; { if Zeichen<=$7F then }
    endif; { if Zeichen>=$20 then  }

  endcase; { case Zeichen of }


end Normal_Terminal_Mode;







procedure Escape_Reset;
begin
  CSI_Parameter1:=0;
  CSI_Parameter2:=0;
  CSI_Parameter3:=0;
  TermMode:=Normal_TM;
  Escape_Sequenz:='';
end Escape_Reset;






procedure Escape_Fehler;
var
  ESC_Zaehler : Byte;
  ESC_Laenge  : Byte;
  ESC_Zeichen : Char;
begin

  L_Zeichen:=$45; // E
  Write_Char;
  CURSOR_RIGHT;

  L_Zeichen:=$53; // S
  Write_Char;
  CURSOR_RIGHT;

  L_Zeichen:=$43; // C
  Write_Char;
  CURSOR_RIGHT;

  ESC_Laenge:=Length(Escape_Sequenz);

  for ESC_Zaehler:=1 to ESC_Laenge do
    ESC_Zeichen:=Escape_Sequenz[ESC_Zaehler];
    L_Zeichen:=CharToByte(ESC_Zeichen);
    Write_Char;
    CURSOR_RIGHT;
  endfor;

  Escape_Reset;
end Escape_Fehler;




procedure IBM_ESC_Terminal_Mode;
begin

  case L_Zeichen of

    $5B : TermMode:=IBM_CSI_TM; // Control Sequence Introducer (CSI) = ESC [
    |

    $47 : TermMode:=IBM_GRAFIK_Par_1_TM; // GRAFIK-Mode = ESC G
    |

  else

    Escape_Fehler;

  endcase;

end IBM_ESC_Terminal_Mode;







procedure Set_Display_Attributes(DispAttr : Word);
begin


  case DispAttr of

    // *** Textattribute ***


    // ESC [ 0 m = Alle Attribute AUS (Reset all attributes)
    0 : C_FCOLOR:=cl_Blue;
    |

    // ESC [ 1 m = Fett ein
    1 : C_FCOLOR:=cl_Gray;
    |

    // ESC [ 4 m = Unterstreichen
    4 : C_FCOLOR:=cl_Purple;
    |

    // ESC [ 5 m = Blinken EIN
    5 : C_FCOLOR:=cl_Red;

    |

    // ESC [ 7 m = Invertierte Darstellung
    7 : C_FCOLOR:=cl_Black;

    |

    // ESC [ 8 m = Versteckt ein
    8 : C_FCOLOR:=cl_White;

    |



   // *** Schriftgroesse ***

    // ESC [ 11 m = Font 6x8
    11 :   setze_Font(fnt_6x8);
    |

    // ESC [ 12 m = Font 8x8
    12 :   setze_Font(fnt_8x8);
    |

    // ESC [ 13 m = Font 8x12
    13 :   setze_Font(fnt_8x12);
    |

    // ESC [ 14 m = Font 10x16
    14 :   setze_Font(fnt_10x16);
    |

    // ESC [ 15 m = Font 12x20
    15 :   setze_Font(fnt_12x20);
    |



    // *** Vordergrundfarben ***

    // ESC [ 30 m = Vordergrundfarbe - 30 Schwarz
    30 : C_FCOLOR:=cl_Black;
    |

    // ESC [ 31 m = Vordergrundfarbe - 31 Rot
    31 : C_FCOLOR:=cl_Red;

    |

    // ESC [ 32 m = Vordergrundfarbe - 32 Grn
    32 : C_FCOLOR:=cl_Green;
    |

    // ESC [ 33 m = Vordergrundfarbe - 33 Gelb
    33 : C_FCOLOR:=cl_Yellow;
    |

    // ESC [ 34 m = Vordergrundfarbe - 34 Blau
    34 : C_FCOLOR:=cl_Blue;
    |

    // ESC [ 35 m = Vordergrundfarbe - 35 Karmesinrot (Purpur, lila)
    35 : C_FCOLOR:=cl_Purple;
    |

    // ESC [ 36 m = Vordergrundfarbe - 36 Cyanblau
    36 : C_FCOLOR:=cl_Aqua;
    |

    // ESC [ 37 m = Vordergrundfarbe - 37 Wei
    37 : C_FCOLOR:=cl_White;
    |



    // *** Hintergrundfarben ***

    // ESC [ 40 m = Hintergrundfarbe - 40 Schwarz
    40 : C_BCOLOR:=cl_Black;
    |

    // ESC [ 41 m = Hintergrundfarbe - 41 Rot
    41 : C_BCOLOR:=cl_Red;
    |

    // ESC [ 42 m = Hintergrundfarbe - 42 Grn
    42 : C_BCOLOR:=cl_Green;
    |

    // ESC [ 43 m = Hintergrundfarbe - 43 Gelb
    43 : C_BCOLOR:=cl_Yellow;
    |

    // ESC [ 44 m = Hintergrundfarbe - 44 Blau
    44 : C_BCOLOR:=cl_Blue;
    |

    // ESC [ 45 m = Hintergrundfarbe - 45 Karmesinrot (Purpur, lila)
    45 : C_BCOLOR:=cl_Purple;
    |

    // ESC [ 46 m = Hintergrundfarbe - 46 Cyanblau
    46 : C_BCOLOR:=cl_Aqua;
    |

    // ESC [ 47 m = Hintergrundfarbe - 47 Wei
    47 : C_BCOLOR:=cl_White;

    |

    else
      Escape_Fehler;
    endcase;

end Set_Display_Attributes;








procedure IBM_CSI_Terminal_Mode;
begin

  case L_Zeichen of

    $30..$39 : CSI_Parameter1:=ByteToWord(L_Zeichen)-$30;
               TermMode:=IBM_CSI_TM_Par_1;
    |

    $4B : // Loeschen bis Zeilenende = ESC [ K
          DELETE_EOL;
          Escape_Reset;
    |



    $3F : // Hide/Show the cursor = ESC [ ? 2 5 h
          CSI_Parameter1:=0;
          TermMode:=IBM_CSI_TM_Par_1;
    |

    $48 : // "H" -- MOVE CURSOR = ESC [ H
          SET_CURSOR_POSITION(0,0);
          Escape_Reset;
    |

    $4A : // "J" -- Erase Down = ESC [ J
          // Erases the screen from the current line down to the bottom of the screen.
          ERASE_DOWN;
          Escape_Reset;
    |

    $4D : // "M" -- Move the cursor up in scrolling region = ESC [ M
          DELETE_LINE;
          CURSOR_UP;
          DELETE_LINE;
          Escape_Reset;
    |

    $66 : // Character Attributes = ESC [ f
          CURSOR_HOME;
          Escape_Reset;
    |

    $6D : // Turn off character attributes = ESC [ m
          Set_Display_Attributes(0);
          Escape_Reset;
    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }

end IBM_CSI_Terminal_Mode;










// IBM_CSI_TM_Par_1
procedure IBM_CSI_Par_1_Terminal_Mode;
var
  Zaehler : Word;
begin

  case L_Zeichen of

    $30..$39 : CSI_Parameter1:=CSI_Parameter1*10;
               CSI_Parameter1:=CSI_Parameter1+ByteToWord(L_Zeichen);
               CSI_Parameter1:=CSI_Parameter1-$30;

               TermMode:=IBM_CSI_TM_Par_1;
     |

    $3B :      // ";"
	       // ESC [ Pn1 ; PN2 H oder
	       // ESC [ Pn1 ; PN2 f oder
               // ESC [ Pn1 ; PN2 m oder
	       // Xterm 256 colors - ESC[48;5;BCOLOR m oder
	       // Xterm 256 colors - ESC[38;5;FCOLOR m
               TermMode:=IBM_CSI_TM_Par_2;

     |

    $4A : // Zeilen loeschen = ESC [ Pn J
         // ED -- Erase In Display = ESC [ Pn J
               // This sequence erases some or all of the characters in the
               // display according to the parameter. Any complete line
               // erased by this sequence will return that line to single
               // width mode.

               case CSI_Parameter1 of
                 0 : ERASE_DOWN;                      // Erase to End of Screen
                 |
                 1 : DELETE_BOL;                      // Erase from start of the screen
                                                      // to the active position, inclusive
                 |
                 2 : // Loeschen gesammte zeile
                     RESET_DISPLAY;
                 |
               else
                 Escape_Fehler;
               endcase;

               Escape_Reset;

     |

    $4B : // Zeilen loeschen = ESC [ Pn K

          case CSI_Parameter1 of

            0 : // Loeschen bis Zeilenende
                DELETE_EOL;
            |

            1 : // Loeschen von Anfang bis Kursor
                DELETE_BOL;
            |

            2 : // Loeschen gesammte zeile
                DELETE_LINE;
            |

          else
            Escape_Fehler;
          endcase;
          Escape_Reset;
     |


    $4C : // INSERT_LINE_SCR_ROLL = ESC [ Pn L
          for Zaehler:=0 to CSI_Parameter1-1 do
            INSERT_LINE_SCR_ROLL;
          endfor;
          Escape_Reset;
     |

    $4D : // "M" DELETE_LINE_SCR_ROLL = ESC [ Pn M
          for Zaehler:=0 to CSI_Parameter1-1 do
            DELETE_LINE_SCR_ROLL;
          endfor;
          Escape_Reset;
     |

    $6C : // "l" ESC [ ? X X l

          case CSI_Parameter1 of

            // "l" Text_Kursor_Aus = ESC [ ? 2 5 l
            25 : {if Kursor_sichtbar then
                   Kursor_sichtbar:=false;
                   //Schalte_Kursor_Aus;
                 endif;
                 Kursor_Ein:=false; }
                 Escape_Reset;
            |
          else
            Escape_Fehler;
          endcase; { case CSI_Parameter1 of }
     |

    $68 : // "h" ESC [ ? X X h

          case CSI_Parameter1 of

            // "h" Text_Kursor_Ein = ESC [ ? 2 5 h
            25 : {Kursor_Schleife:=0;
                 Kursor_Ein:=true; }
                 Escape_Reset;
            |
          else
            Escape_Fehler;
          endcase; { case CSI_Parameter1 of }
     |

    $6D : // "m" Character Attributes = ESC [ Pn m
          Set_Display_Attributes(CSI_Parameter1);
          Escape_Reset;
     |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }

end IBM_CSI_Par_1_Terminal_Mode;








// IBM_CSI_TM_Par_2
procedure IBM_CSI_Par_2_Terminal_Mode;
begin

  case L_Zeichen of

    $30..$39 : CSI_Parameter2:=CSI_Parameter2*10;
               CSI_Parameter2:=CSI_Parameter2+ByteToWord(L_Zeichen);
               CSI_Parameter2:=CSI_Parameter2-$30;

               TermMode:=IBM_CSI_TM_Par_2;
    |

    $3B : // ";"
          // Xterm 256 colors - ESC[48;5;BCOLOR m
          // Xterm 256 colors - ESC[38;5;FCOLOR m
          TermMode:=IBM_CSI_TM_Par_3;
    |


    $48 : // "H" -- MOVE CURSOR = ESC [ Pn1 ; PN2 H
          SET_CURSOR_POSITION(CSI_Parameter1,CSI_Parameter2);
          Escape_Reset;
    |

    $66 : // "f" -- MOVE CURSOR = ESC [ Pn1 ; PN2 f
          SET_CURSOR_POSITION(CSI_Parameter1,CSI_Parameter2);
          Escape_Reset;
    |

    $6D : // "m" -- 2 mal Character Attributes = ESC [ Pn1 ; PN2 m
          Set_Display_Attributes(CSI_Parameter1);
          Set_Display_Attributes(CSI_Parameter2);
          Escape_Reset;

    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }


end IBM_CSI_Par_2_Terminal_Mode;





procedure IBM_CSI_Par_3_Terminal_Mode;
begin


  case L_Zeichen of

    $30..$39 : CSI_Parameter3:=CSI_Parameter3*10;
               CSI_Parameter3:=CSI_Parameter3+ByteToWord(L_Zeichen);
               CSI_Parameter3:=CSI_Parameter3-$30;

               TermMode:=IBM_CSI_TM_Par_3;

    |


    $6D : // "m"

          case CSI_Parameter1 of

          48 : // Xterm 256 colors - ESC[48;5;BCOLOR m
               if CSI_Parameter2=5 then
                 C_BCOLOR:=Low(CSI_Parameter3);
               else
                 Escape_Fehler;
               endif;
          |

          38 : // Xterm 256 colors - ESC[38;5;FCOLOR m
               if CSI_Parameter2=5 then
                 C_FCOLOR:=Low(CSI_Parameter3);
               else
                 Escape_Fehler;
               endif;
          |

          else
            Set_Display_Attributes(CSI_Parameter1);
            Set_Display_Attributes(CSI_Parameter2);
            Set_Display_Attributes(CSI_Parameter3);
          endcase;

          Escape_Reset;

    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }


end IBM_CSI_Par_3_Terminal_Mode;





// ESC G - Auswertung der ESC-Grafik-Steuerzeichen



procedure IBM_GRAFIK_Par_1_Terminal_Mode;
begin

  case L_Zeichen of

    $30..$39 : CSI_Parameter1:=CSI_Parameter1*10;
               CSI_Parameter1:=CSI_Parameter1+ByteToWord(L_Zeichen);
               CSI_Parameter1:=CSI_Parameter1-$30;

               TermMode:=IBM_GRAFIK_Par_1_TM;

    |

    $3B : // ";"
          TermMode:=IBM_GRAFIK_Par_2_TM;

    |

    $43 : // "C" -- Grafik_setze_Farbe = ESC G Pn1 C
          //PIXCOLOR:=Low(CSI_Parameter1);
          Escape_Reset;

    |

    $4B : // "K" -- Grafik_zeichne_Kreis = ESC G Pn1 K
          //Grafik_zeichne_Kreis(CSI_Parameter1);
          Escape_Reset;

    |

    $56 : // "V" -- Grafik_zeichne_vollen_Kreis = ESC G Pn1 V
          //Grafik_zeichne_vollen_Kreis(CSI_Parameter1);
          Escape_Reset;

    |


  else

    Escape_Fehler;

  endcase; { case Zeichen of }


end IBM_GRAFIK_Par_1_Terminal_Mode;





procedure IBM_GRAFIK_Par_2_Terminal_Mode;
begin

  case L_Zeichen of

    $30..$39 : CSI_Parameter2:=CSI_Parameter2*10;
               CSI_Parameter2:=CSI_Parameter2+ByteToWord(L_Zeichen);
               CSI_Parameter2:=CSI_Parameter2-$30;

               TermMode:=IBM_GRAFIK_Par_2_TM;

    |

    $47 : // "G" -- Grafik_setze_Position = ESC G Pn1 ; Pn2 G
         // X_PIX_POS:=CSI_Parameter1;
         // Y_PIX_POS:=CSI_Parameter2;
          Escape_Reset;

    |

    $50 : // "P" -- Grafik_zeichne_Punkt = ESC G Pn1 ; Pn2 P
         // X_PIX_POS:=CSI_Parameter1;
         // Y_PIX_POS:=CSI_Parameter2;
          //Grafik_setze_Punkt;
          Escape_Reset;

    |

    $4C : // "L" -- Grafik_zeichne_Linie = ESC G Pn1 ; Pn2 L
        //  X_END_POS:=CSI_Parameter1;
        //  Y_END_POS:=CSI_Parameter2;
          //Grafik_zeichne_Linie;
          Escape_Reset;

    |

    $52 : // "R" -- Grafik_zeichne_Rechteck = ESC G Pn1 ; Pn2 R
         // X_END_POS:=CSI_Parameter1;
         // Y_END_POS:=CSI_Parameter2;
          //Grafik_zeichne_Rechteck;
          Escape_Reset;

    |

    $46 : // "F" -- Grafik_zeichne_volles_Rechteck = ESC G Pn1 ; Pn2 F
         // X_END_POS:=CSI_Parameter1;
         // Y_END_POS:=CSI_Parameter2;
          //Grafik_zeichne_volles_Rechteck;
          Escape_Reset;

    |

  else

    Escape_Fehler;

  endcase; { case Zeichen of }


end IBM_GRAFIK_Par_2_Terminal_Mode;








procedure CONOUT;
var
  CON_Zeichen : Char;
  L2_Zeichen : Byte;
begin

  Kursor_Schleife:=0;

  if Kursor_sichtbar then
    L2_Zeichen:=L_Zeichen;
    Kursor_Ausschalten;
    L_Zeichen:=L2_Zeichen;
  endif;

  // Abspeichern der Escape-Steuerzeichen fuer die
  // Anzeige der nicht ausgewerteter Sequenzen im Fehlerfall
  if TermMode<>Normal_TM then
    CON_Zeichen:=ByteToChar(L_Zeichen);
    Escape_Sequenz:=Escape_Sequenz+CON_Zeichen;
  endif;

  case TermMode of

    Normal_TM            : Normal_Terminal_Mode;
    |

    IBM_ESC_TM           : IBM_ESC_Terminal_Mode;
    |

    IBM_CSI_TM           : IBM_CSI_Terminal_Mode;
    |

    IBM_CSI_TM_Par_1     : IBM_CSI_Par_1_Terminal_Mode;
    |

    IBM_CSI_TM_Par_2     : IBM_CSI_Par_2_Terminal_Mode;
    |

    IBM_CSI_TM_Par_3     : IBM_CSI_Par_3_Terminal_Mode;
    |

    IBM_GRAFIK_Par_1_TM  : IBM_GRAFIK_Par_1_Terminal_Mode;
    |

    IBM_GRAFIK_Par_2_TM  : IBM_GRAFIK_Par_2_Terminal_Mode;
    |

  else

    Escape_Fehler;

  endcase;

end CONOUT;





procedure Text_an_CONOUT;
var
  b1 : Byte;
  b2 : Byte;
  c1 : Char;
begin

  C_FCOLOR:=Fuellfarbe_VG;
  C_BCOLOR:=Fuellfarbe_HG;

  Convert_ColorByte_to_ColorWord;

  b1:=Length(Write_String);

  for b2:=1 to b1 do

    c1:=Write_String[b2];
    L_Zeichen:=CharToByte(c1);
    CONOUT;

  endfor;

  L_Zeichen:=$0D;
  CONOUT;

  L_Zeichen:=$0A;
  CONOUT;

end Text_an_CONOUT;





procedure Anzeige_Zeichensatz;
var
  Zaehler1 : Word;
  Zaehler2 : Word;
begin

  CURSOR_HOME;

  C_FCOLOR:=Fuellfarbe_VG;
  C_BCOLOR:=Fuellfarbe_HG;

  Convert_ColorByte_to_ColorWord;

  L_Zeichen:=$20;

  for Zaehler1:=0 to max_Zeilen do

    for Zaehler2:=0 to max_Spalten do

      Write_Char;
      CURSOR_RIGHT;

      Inc(L_Zeichen);

      if L_Zeichen=$80 then
        L_Zeichen:=$20;
      endif;

    endfor;

    CURSOR_DOWN;

    Carridge_Return;

  endfor;

  CURSOR_HOME;

end Anzeige_Zeichensatz;






procedure INIT_CONOUT;
begin

  RESET_DISPLAY;

  TermMode:=Normal_TM;

  setze_Font(fnt_6x8);

  C_FCOLOR:=Fuellfarbe_VG;
  C_BCOLOR:=Fuellfarbe_HG;

end INIT_CONOUT;








              
