
CONST


  // Festwerte fuer Farben
  {
  cl_White    : Word = $FFFF;
  cl_Black    : Word = $0000;
  cl_Red      : Word = $F800;
  cl_Green    : Word = $0400;
  cl_Blue     : Word = $001F;
  cl_Yellow   : Word = $FFE0;
  cl_Purple   : Word = $8010;
  cl_Aqua     : Word = $07FF;
  cl_Gray     : Word = $8410;
  cl_DarkGray : Word = $8410;
  cl_Silver   : Word = $C618;
  cl_Maroon   : Word = $8000;
  cl_Olive    : Word = $8400;
  cl_Lime     : Word = $07E0;
  cl_Teal     : Word = $0410;
  cl_Navy     : Word = $0010;
  cl_Fuchsia  : Word = $F81F;
              }


  cl_White    : Byte = 255;
  cl_Black    : Byte = 000;
  cl_Red      : Byte = 214;
  cl_Green    : Byte = 040;
  cl_Blue     : Byte = 003;
  cl_Yellow   : Byte = 250;
  cl_Purple   : Byte = 133;   // ?
  cl_Aqua     : Byte = 045;
  cl_Gray     : Byte = 133;   // ?
  cl_DarkGray : Byte = 133;   // ?
  cl_Silver   : Byte = 202;   // ?
  cl_Maroon   : Byte = 130;   // ?
  cl_Olive    : Byte = 154;   // ?
  cl_Lime     : Byte = 040;
  cl_Teal     : Byte = 026;
  cl_Navy     : Byte = 001;
  cl_Fuchsia  : Byte = 219;



  // Werte fuer Font_Bez
  fnt_6x8   : Byte = 1;
  fnt_8x8   : Byte = 2;
  fnt_8x12  : Byte = 3;
  fnt_10x16 : Byte = 4;
  fnt_12x20 : Byte = 5;




VAR
  L_Zeichen : Byte;
  L_FCOLOR, L_BCOLOR : Word;

  // Hilfsvariable fuer die Pixel-Farbe (nur fuer diese INC)
  L_Pixel_Farbe : Word;
  L_X_PIX_POS, L_Y_PIX_POS : Word;






{ 111111111111111111111111111111111111111111111111111 }
{ *************************************************** }
{ *******     PORT spezifische Routinen       ******* }
{ *************************************************** }


procedure LCD_Write_PORT(Byte_High, Byte_Low : Byte);
begin
  PORTA := Byte_High;
  PORTC := Byte_Low;
end LCD_Write_PORT;




procedure LCD_Write_PORT_Word(PORT_Word : Word);
var
  Byte_High : Byte;
  Byte_Low : Byte;
begin
  PORTA := HIGH(PORT_Word);
  PORTC := LOW(PORT_Word);
end LCD_Write_PORT_Word;








{ 111111111111111111111111111111111111111111111111111 }
{ *************************************************** }
{ *******         PIN-Routins for LCD         ******* }
{ *************************************************** }




procedure LCD_Write;
begin
  ClearBit(LCD_WR);
  NOP;
  NOP;
  NOP;
  NOP;
  SetBit(LCD_WR);
end LCD_Write;



procedure LCD_Write_COM(COM_Byte : Byte);
begin

  // write command
  ClearBit(LCD_COM_DAT);

  LCD_Write_PORT(0,COM_Byte);

  LCD_Write;

end LCD_Write_COM;




procedure LCD_Write_DATA(DATA_Byte_High, DATA_Byte_Low : Byte);
begin

  // write data
  SetBit(LCD_COM_DAT);

  LCD_Write_PORT(DATA_Byte_High,DATA_Byte_Low);

  LCD_Write;

end LCD_Write_DATA;





procedure LCD_Write_DATA_Word(DATA_Word : Word);
begin

  // write data
  SetBit(LCD_COM_DAT);

  LCD_Write_PORT_Word(DATA_Word);

  LCD_Write;

end LCD_Write_DATA_Word;




procedure LCD_Write_COM_DATA(COM_Byte, DATA_Byte_High, DATA_Byte_Low : Byte);
begin

  LCD_Write_COM(COM_Byte);
  LCD_Write_DATA(DATA_Byte_High, DATA_Byte_Low);

end LCD_Write_COM_DATA;






procedure Init_SSD1289;
begin

  SetBit(LCD_RSET);
  wait_ms(5);
  ClearBit(LCD_RSET);
  wait_ms(15);
  SetBit(LCD_RSET);
  wait_ms(15);

  ClearBit(LCD_CS);

  // Einschalten des Oszillators
  LCD_Write_COM_DATA($00,$00,$01);

  //Power Control (1)
  LCD_Write_COM_DATA($03,$A8,$A4);

  //Power Control (2)
  LCD_Write_COM_DATA($0C,$00,$00);

  //Power Control (3)
  LCD_Write_COM_DATA($0D,$08,$0C);

  //Power Control (4)
  LCD_Write_COM_DATA($0E,$2B,$00);

  //Power Control (5)
  LCD_Write_COM_DATA($1E,$00,$B7);

  //Driver Output Control RL=0, REV=1, BGR=1, TB=1
  LCD_Write_COM_DATA($01,$2B,$3F);

  //Restore VSYNC mode from low power state
  LCD_Write_COM_DATA($02,$06,$00);

  //Sleep mode cancel
  LCD_Write_COM_DATA($10,$00,$00);

  //Entry Mode
  // DFM   0x4000 = 262L color
  // DFM   0x6000 = 65K color
  // AM    0x0000 = horizontal display
  // AM    0x0008 = Vertical display
  // ID[0] 0x0000 = horizontal decrement
  // ID[0] 0x0010 = horizontal increment
  // ID[1] 0x0000 = Vertical decrement
  // ID[1] 0x0020 = Vertical increment
  LCD_Write_COM_DATA($11,$60,$70);

  // Compare register
  LCD_Write_COM_DATA($05,$00,$00);

  // Compare register
  LCD_Write_COM_DATA($06,$00,$00);

  // Horizontal and Vertical porch are for DOTCLK mode operation
  // Horizontal Porch
  LCD_Write_COM_DATA($16,$EF,$1C);

  // Vertical Porch
  LCD_Write_COM_DATA($17,$00,$03);

  // Display Control
  // D1 0x0000 = display off
  // D1 0x0002 = display on
  // D0 0x0000 = internal display halt
  // D0 0x0001 = internal display operate
  LCD_Write_COM_DATA($07,$02,$33);

  // Frame cycle control
  LCD_Write_COM_DATA($0B,$00,$00);

  // Gate Scan Position
  LCD_Write_COM_DATA($0F,$00,$00);

  // Vertical Scroll Control
  LCD_Write_COM_DATA($41,$00,$00);
  LCD_Write_COM_DATA($42,$00,$00);

  // 1st Screen driving position
  // Start position. 0
  LCD_Write_COM_DATA($48,$00,$00);
  // End position.   319
  LCD_Write_COM_DATA($49,$01,$3F);



  // Source RAM address
  //Horizontal RAM address position start/end setup
  //dec 239
  //dec 0, i.e. horizontal ranges from 0 -> 239
  //POR value is 0xEF00 anyway. This address must be set before RAM write
  LCD_Write_COM_DATA($44,$EF,$00);

  //Vertical RAM address start position setting
  //0x0000 = dec 0
  LCD_Write_COM_DATA($45,$00,$00);

  //Vertical RAM address end position setting (0x013F = dec 319)
  LCD_Write_COM_DATA($46,$01,$3F);


  // 2nd Screen driving position
  // Start position. 0
  LCD_Write_COM_DATA($4A,$00,$00);
  // End position.   0
  LCD_Write_COM_DATA($4B,$00,$00);


  //gamma control
  LCD_Write_COM_DATA($30,$07,$07);
  LCD_Write_COM_DATA($31,$02,$04);
  LCD_Write_COM_DATA($32,$02,$04);
  LCD_Write_COM_DATA($33,$05,$02);
  LCD_Write_COM_DATA($34,$05,$07);
  LCD_Write_COM_DATA($35,$02,$04);
  LCD_Write_COM_DATA($36,$02,$04);
  LCD_Write_COM_DATA($37,$05,$02);
  LCD_Write_COM_DATA($3A,$03,$02);
  LCD_Write_COM_DATA($3B,$03,$02);


  LCD_Write_COM_DATA($23,$00,$00);
  LCD_Write_COM_DATA($24,$00,$00);
  LCD_Write_COM_DATA($25,$80,$00);
  LCD_Write_COM_DATA($4F,$00,$00);
  LCD_Write_COM_DATA($4E,$00,$00);
  LCD_Write_COM($22);

  SetBit(LCD_CS);

  L_FCOLOR:=$0000;
  L_BCOLOR:=$FFFF;

end Init_SSD1289;





procedure setze_Adresse_Quer(x1,y1,x2,y2 : Word);
var
  b1 : Byte;
  b2 : Byte;
  w1 : Word;
  w2 : Word;
begin

  w1:=x1;
  x1:=y1;
  y1:=w1;

  w1:=x2;
  x2:=y2;
  y2:=w1;

  y1:=319-y1;
  y2:=319-y2;

  w1:=y1;
  y1:=y2;
  y2:=w1;

  b1:=Low(x1);
  b2:=Low(x2);
  Lcd_Write_Com_Data($44,b2,b1);

  b1:=Low(y1);
  b2:=High(y1);
  Lcd_Write_Com_Data($45,b2,b1);

  b1:=Low(y2);
  b2:=High(y2);
  Lcd_Write_Com_Data($46,b2,b1);

  b1:=Low(x1);
  b2:=High(x1);
  Lcd_Write_Com_Data($4E,b2,b1);

  b1:=Low(y1);
  b2:=High(y1);
  Lcd_Write_Com_Data($4F,b2,b1);

  Lcd_Write_Com($22);

end setze_Adresse_Quer;







procedure setze_Adresse_Hoch(x1,y1,x2,y2 : Word);
var
  b1 : Byte;
  b2 : Byte;
begin

  b1:=Low(x1);
  b2:=Low(x2);
  Lcd_Write_Com_Data($44,b2,b1);

  b1:=Low(y1);
  b2:=High(y1);
  Lcd_Write_Com_Data($45,b2,b1);

  b1:=Low(y2);
  b2:=High(y2);
  Lcd_Write_Com_Data($46,b2,b1);

  b1:=Low(x1);
  b2:=High(x1);
  Lcd_Write_Com_Data($4E,b2,b1);

  b1:=Low(y1);
  b2:=High(y1);
  Lcd_Write_Com_Data($4F,b2,b1);

  Lcd_Write_Com($22);

end setze_Adresse_Hoch;






procedure clear_Screen;
var
  b1 : Word;
  b2 : Byte;
begin

  ClearBit(LCD_CS);
  setze_Adresse_Quer(0,0,319,239);

  // Umschalten auf Daten
  SetBit(LCD_COM_DAT);

  L_Pixel_Farbe:=L_BCOLOR;
  LCD_Write_PORT_Word(L_Pixel_Farbe);

  ClearBit(LCD_WR);

  for b1:=1 to 320 do

    for b2:=1 to 240 do

      SetBit(LCD_WR);

      ClearBit(LCD_WR);

    endfor;

  endfor;

  SetBit(LCD_WR);

  SetBit(LCD_CS);

  X_KUR_POS:= 0;
  Y_KUR_POS:= 0;

end clear_Screen;








procedure drawPixel_Hoch(Pos_x, Pos_y : Word);
var
  Pixel_x2 : Word;
  Pixel_y2 : Word;
begin
  Pixel_x2:=Pos_x+1;
  Pixel_y2:=Pos_y+1;
  ClearBit(LCD_CS);
  setze_Adresse_Hoch(Pos_x,Pos_y,Pixel_x2,Pixel_y2);
  LCD_Write_DATA_Word(L_Pixel_Farbe);
  SetBit(LCD_CS);

end drawPixel_Hoch;






procedure drawPixel_Quer(Pos_x, Pos_y : Word);
var
  Pixel_x2 : Word;
  Pixel_y2 : Word;
begin
  Pixel_x2:=Pos_x+1;
  Pixel_y2:=Pos_y+1;
  ClearBit(LCD_CS);
  setze_Adresse_Quer(Pos_x,Pos_y,Pixel_x2,Pixel_y2);
  LCD_Write_DATA_Word(L_Pixel_Farbe);
  SetBit(LCD_CS);

end drawPixel_Quer;




procedure drawVertikalLine_Quer(Pos_x, Pos_y1, Pos_y2 : Word);
var
  Line : Word;
begin

  ClearBit(LCD_CS);

  setze_Adresse_Quer(Pos_x,Pos_y1,Pos_x,Pos_y2);

  for Line:=Pos_y1 to Pos_y2 do
    LCD_Write_DATA_Word(L_Pixel_Farbe);
  endfor;

  SetBit(LCD_CS);

end drawVertikalLine_Quer;








procedure drawHorizontalLine_Quer(Pos_x1, Pos_x2, Pos_y : Word);
var
  Line : Word;
  Pixel_x2 : Word;
  Pixel_y2 : Word;
begin

  ClearBit(LCD_CS);

  for Line:=Pos_x1 to Pos_x2 do
    Pixel_x2:=Line+1;
    Pixel_y2:=Pos_y+1;
    setze_Adresse_Quer(Line,Pos_y,Pixel_x2,Pixel_y2);
    LCD_Write_DATA_Word(L_Pixel_Farbe);
  endfor;

  SetBit(LCD_CS);

end drawHorizontalLine_Quer;




// **********************
// *** FONT-Programme ***
// **********************




PROCEDURE setze_Font(FontGroesse : Byte);
BEGIN
  Font_Bez:=FontGroesse;

  CASE Font_Bez OF

    fnt_6x8 : Zeichenbreite := 6;
              Zeichenbreite0 := 5;
              Zeichenhoehe  := 10; // 8 + 2 = 10
              Zeichenhoehe0 := 7;

              X_ANF := 1;
              Y_ANF := 1;

              max_Spalten := 52;  // 0..52 = 53
              max_Zeilen := 23;   // 0..23 = 24

    |

    fnt_8x8 : Zeichenbreite := 8;
              Zeichenbreite0 := 7;
              Zeichenhoehe  := 10; // 8 + 2 = 10
              Zeichenhoehe0 := 7;

              X_ANF := 0;
              Y_ANF := 1;

              max_Spalten := 39;  // 0..39 = 40
              max_Zeilen := 23;   // 0..23 = 24

    |

    fnt_8x12 : Zeichenbreite := 8;
               Zeichenbreite0 := 7;
               Zeichenhoehe  := 13; // 12 + 1 = 13
               Zeichenhoehe0 := 11;

               X_ANF := 0;
               Y_ANF := 4;

               max_Spalten := 39;  // 0..39 = 40
               max_Zeilen := 17;   // 0..17 = 18

    |

    fnt_10x16 : Zeichenbreite := 10;
                Zeichenbreite0 := 9;
                Zeichenhoehe  := 16; // 16 + 0 = 16
                Zeichenhoehe0 := 15;

                X_ANF := 0;
                Y_ANF := 0;

                max_Spalten := 31;  // 0..31 = 32
                max_Zeilen := 14;  // 0..14 = 15

    |

    fnt_12x20 : Zeichenbreite := 12;
                Zeichenbreite0 := 11;
                Zeichenhoehe  := 20; // 20 + 0 = 20
                Zeichenhoehe0 := 19; // 0..19 = 20

                X_ANF := 4;
                Y_ANF := 0;

                max_Spalten := 25;  // 0..25 = 26
                max_Zeilen := 11;  // 0..11 = 12

    |

  ENDCASE;

 // ZeichenbreiteDW := WordToDword(Zeichenbreite);

  clear_Screen;

END setze_Font;







// schreibt ein Zeichen in das Display
// ohne Kursorbewegung
procedure Write_Char_6x8;
var
  x_cnt : Byte;
  y_cnt : Byte;
  w1 : Word;
  w2 : Word;
  Font_Color : Byte;
  Font_Mask : Byte;

begin

  // LCD Anfang
  ClearBit(LCD_CS);

  L_X_PIX_POS:=X_KUR_POS*Zeichenbreite;
  L_X_PIX_POS:=L_X_PIX_POS+X_ANF;

  w1:=L_X_PIX_POS+Zeichenbreite0;

  L_Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  L_Y_PIX_POS:=L_Y_PIX_POS+Y_ANF;

  w2:=L_Y_PIX_POS+Zeichenhoehe0;


  setze_Adresse_Quer(L_X_PIX_POS,L_Y_PIX_POS,w1,w2);


  // Zeiger auf Zeichen in der Zeichentabelle
  w1:=ByteToWord(L_Zeichen);
  w1:=w1-$20;
  w1:=w1*8;

  Font_Mask:=%10000000;

  for x_cnt:=0 to 5 do

    for y_cnt:=0 to 7 do

      Font_Color:=font6x8[w1];
      INC(w1);

      Font_Color:=Font_Color and Font_Mask;
      if Font_Color = 0 then
        L_Pixel_Farbe:=L_BCOLOR;
      else
        L_Pixel_Farbe:=L_FCOLOR;
      endif;

      // Farbpunkt setzen
      // Umschalten auf Daten
      SetBit(LCD_COM_DAT);

      LCD_Write_PORT_Word(L_Pixel_Farbe);

      // aktiviere Write PIN
      LCD_Write;

    endfor; { for x_cnt:=0 to 5 do }

    w1:=w1-8;

    SHR(Font_Mask);

  endfor; { for y_cnt:=0 to 7 do }

  SetBit(LCD_CS);

end Write_Char_6x8;









// schreibt ein Zeichen in das Display
// ohne Kursorbewegung
procedure Write_Char_8x8;
var
  x_cnt : Byte;
  y_cnt : Byte;
  w1 : Word;
  w2 : Word;
  Font_Color : Byte;
  Font_Mask : Byte;

begin

  // LCD Anfang
  ClearBit(LCD_CS);

  L_X_PIX_POS:=X_KUR_POS*Zeichenbreite;
  L_X_PIX_POS:=L_X_PIX_POS+X_ANF;

  w1:=L_X_PIX_POS+Zeichenbreite0;

  L_Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  L_Y_PIX_POS:=L_Y_PIX_POS+Y_ANF;

  w2:=L_Y_PIX_POS+Zeichenhoehe0;


  setze_Adresse_Quer(L_X_PIX_POS,L_Y_PIX_POS,w1,w2);


  // Zeiger auf Zeichen in der Zeichentabelle
  w1:=ByteToWord(L_Zeichen);
  w1:=w1-$20;
  w1:=w1*8;

  Font_Mask:=%10000000;

  for x_cnt:=0 to 7 do

    for y_cnt:=0 to 7 do

    //  Font_Color:=font8x8[w1];
      INC(w1);

      Font_Color:=Font_Color and Font_Mask;
      if Font_Color = 0 then
        L_Pixel_Farbe:=L_BCOLOR;
      else
        L_Pixel_Farbe:=L_FCOLOR;
      endif;

      // Farbpunkt setzen
      // Umschalten auf Daten
      SetBit(LCD_COM_DAT);

      LCD_Write_PORT_Word(L_Pixel_Farbe);

      // aktiviere Write PIN
      LCD_Write;

    endfor; { for x_cnt:=0 to 7 do }

    w1:=w1-8;

    SHR(Font_Mask);

  endfor; { for y_cnt:=0 to 7 do }

  SetBit(LCD_CS);

end Write_Char_8x8;







// schreibt ein Zeichen in das Display
// ohne Kursorbewegung
procedure Write_Char_8x12;
var
  x_cnt : Byte;
  y_cnt : Byte;
  w1 : Word;
  w2 : Word;
  Font_Color : Byte;
  Font_Mask : Byte;

begin

  // LCD Anfang
  ClearBit(LCD_CS);

  L_X_PIX_POS:=X_KUR_POS*Zeichenbreite;
  L_X_PIX_POS:=L_X_PIX_POS+X_ANF;

  w1:=L_X_PIX_POS+Zeichenbreite0;

  L_Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  L_Y_PIX_POS:=L_Y_PIX_POS+Y_ANF;

  w2:=L_Y_PIX_POS+Zeichenhoehe0;


  setze_Adresse_Quer(L_X_PIX_POS,L_Y_PIX_POS,w1,w2);


  // Zeiger auf Zeichen in der Zeichentabelle
  w1:=ByteToWord(L_Zeichen);
  w1:=w1*12;

  Font_Mask:=%10000000;

  for x_cnt:=0 to 7 do

    for y_cnt:=0 to 11 do

    //  Font_Color:=font8x12[w1];
      INC(w1);

      Font_Color:=Font_Color and Font_Mask;
      if Font_Color = 0 then
        L_Pixel_Farbe:=L_BCOLOR;
      else
        L_Pixel_Farbe:=L_FCOLOR;
      endif;

      // Farbpunkt setzen
      // Umschalten auf Daten
      SetBit(LCD_COM_DAT);

      LCD_Write_PORT_Word(L_Pixel_Farbe);

      // aktiviere Write PIN
      LCD_Write;

    endfor; { for x_cnt:=0 to 7 do }

    w1:=w1-12;

    SHR(Font_Mask);

  endfor; { for y_cnt:=0 to 7 do }

  SetBit(LCD_CS);

end Write_Char_8x12;









// schreibt ein Zeichen in das Display
// ohne Kursorbewegung
procedure Write_Char_10x16;
var
  x_cnt : Byte;
  y_cnt : Byte;
  w1 : Word;
  w2 : Word;
  Font_Color : Byte;
  Font_Mask : Byte;

begin

  // LCD Anfang
  ClearBit(LCD_CS);

  L_X_PIX_POS:=X_KUR_POS*Zeichenbreite;
  L_X_PIX_POS:=L_X_PIX_POS+X_ANF;

  w1:=L_X_PIX_POS+Zeichenbreite0;

  L_Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  L_Y_PIX_POS:=L_Y_PIX_POS+Y_ANF;

  w2:=L_Y_PIX_POS+Zeichenhoehe0;

  setze_Adresse_Quer(L_X_PIX_POS,L_Y_PIX_POS,w1,w2);


  // Zeiger auf Zeichen in der Zeichentabelle
  w1:=ByteToWord(L_Zeichen);
  w1:=w1*32;
  w2:=w1+1;

  Font_Mask:=%10000000;

  for x_cnt:=0 to 7 do

    for y_cnt:=0 to 15 do

    //  Font_Color:=font10x16[w2];
      INC(w2);
      INC(w2);

      Font_Color:=Font_Color and Font_Mask;
      if Font_Color = 0 then
        L_Pixel_Farbe:=L_BCOLOR;
      else
        L_Pixel_Farbe:=L_FCOLOR;
      endif;

      // Farbpunkt setzen
      // Umschalten auf Daten
      SetBit(LCD_COM_DAT);

      LCD_Write_PORT_Word(L_Pixel_Farbe);

      // aktiviere Write PIN
      LCD_Write;

    endfor; { for x_cnt:=0 to 15 do }

    w2:=w2-32;

    SHR(Font_Mask);

  endfor; { for y_cnt:=0 to 1 do }


  Font_Mask:=%10000000;

  for x_cnt:=0 to 1 do

    for y_cnt:=0 to 15 do

    //  Font_Color:=font10x16[w1];
      INC(w1);
      INC(w1);

      Font_Color:=Font_Color and Font_Mask;
      if Font_Color = 0 then
        L_Pixel_Farbe:=L_BCOLOR;
      else
        L_Pixel_Farbe:=L_FCOLOR;
      endif;

      // Farbpunkt setzen
      // Umschalten auf Daten
      SetBit(LCD_COM_DAT);

      LCD_Write_PORT_Word(L_Pixel_Farbe);

      // aktiviere Write PIN
      LCD_Write;

    endfor; { for x_cnt:=0 to 15 do }

    w1:=w1-32;

    SHR(Font_Mask);

  endfor; { for y_cnt:=0 to 1 do }

  SetBit(LCD_CS);

end Write_Char_10x16;





// schreibt ein Zeichen in das Display
// ohne Kursorbewegung
procedure Write_Char_12x20;
var
  x_cnt : Byte;
  y_cnt : Byte;
  w1 : Word;
  w2 : Word;
  Font_Color : Byte;
  Font_Mask : Byte;

begin

  // LCD Anfang
  ClearBit(LCD_CS);

  L_X_PIX_POS:=X_KUR_POS*Zeichenbreite;
  L_X_PIX_POS:=L_X_PIX_POS+X_ANF;

  w1:=L_X_PIX_POS+Zeichenbreite0;

  L_Y_PIX_POS:=Y_KUR_POS*Zeichenhoehe;
  L_Y_PIX_POS:=L_Y_PIX_POS+Y_ANF;

  w2:=L_Y_PIX_POS+Zeichenhoehe0;

  setze_Adresse_Quer(L_X_PIX_POS,L_Y_PIX_POS,w1,w2);


  // Zeiger auf Zeichen in der Zeichentabelle
  w1:=ByteToWord(L_Zeichen);
  w1:=w1*40;
  w2:=w1+1;

  Font_Mask:=%10000000;

  for x_cnt:=0 to 7 do

    for y_cnt:=0 to 19 do

   //   Font_Color:=font12x20[w2];
      INC(w2);
      INC(w2);

      Font_Color:=Font_Color and Font_Mask;
      if Font_Color = 0 then
        L_Pixel_Farbe:=L_BCOLOR;
      else
        L_Pixel_Farbe:=L_FCOLOR;
      endif;

      // Farbpunkt setzen
      // Umschalten auf Daten
      SetBit(LCD_COM_DAT);

      LCD_Write_PORT_Word(L_Pixel_Farbe);

      // aktiviere Write PIN
      LCD_Write;

    endfor; { for x_cnt:=0 to 15 do }

    w2:=w2-40;

    SHR(Font_Mask);

  endfor; { for y_cnt:=0 to 1 do }


  Font_Mask:=%10000000;

  for x_cnt:=0 to 3 do

    for y_cnt:=0 to 19 do

   //   Font_Color:=font12x20[w1];
      INC(w1);
      INC(w1);

      Font_Color:=Font_Color and Font_Mask;
      if Font_Color = 0 then
        L_Pixel_Farbe:=L_BCOLOR;
      else
        L_Pixel_Farbe:=L_FCOLOR;
      endif;

      // Farbpunkt setzen
      // Umschalten auf Daten
      SetBit(LCD_COM_DAT);

      LCD_Write_PORT_Word(L_Pixel_Farbe);

      // aktiviere Write PIN
      LCD_Write;

    endfor; { for x_cnt:=0 to 15 do }

    w1:=w1-40;

    SHR(Font_Mask);

  endfor; { for y_cnt:=0 to 1 do }

  SetBit(LCD_CS);

end Write_Char_12x20;




// ****************************************
// Hauptprogramm zur Anzeige eines Zeichens
// ****************************************
//
// Uebergabeparameter:
// L_Zeichen (Byte) - das auszugebende Zeichen
// L_FCOLOR (Word)  - die Vordergrundfarbe des Zeichens
// L_BCOLOR (Word)  - die Hintergrundfarbe des Zeichens
// X_KUR_POS, Y_KUR_POS (Word) - die genaue Position des auszugebenden Zeichens
//                               beginnend mit 0,0
//
procedure Write_Char;
begin

  CASE Font_Bez OF
    fnt_6x8 : Write_Char_6x8;
    |
    fnt_8x8 : Write_Char_8x8;
    |
    fnt_8x12 : Write_Char_8x12;
    |
    fnt_10x16 : Write_Char_10x16;
    |
    fnt_12x20 : Write_Char_12x20;
    |
  ENDCASE;

end Write_Char;










