 VAR

{
 Definitions marked "MEMORY MAPPED"are extended I/O ports
 and cannot be used with IN/OUT instructions
}


  // *** USART0 (UNIVERSAL SYNCHRONOUS and ASYNCHRONOUS RECEIVER and TRANSMITTER) ***

  // I/O Data Register
  UDR0,
  // Baud Raten Register High Byte
  UBRR0H,
  // Baud Raten Register Low Byte
  UBRR0L,
  // Control Status Register A bis C
  UCSR0A, UCSR0B, UCSR0C,



  // I/O Data Register - 1
  UDR1,
  // Baud Raten Register High Byte
  UBRR1H,
  // Baud Raten Register Low Byte
  UBRR1L,
  // Control Status Register A bis C
  UCSR1A, UCSR1B, UCSR1C,



  // I/O Data Register - 2
  UDR2,
  // Baud Raten Register High Byte
  UBRR2H,
  // Baud Raten Register Low Byte
  UBRR2L,
  // Control Status Register A bis C
  UCSR2A, UCSR2B, UCSR2C,


  // I/O Data Register - 3
  UDR3,
  // Baud Raten Register High Byte
  UBRR3H,
  // Baud Raten Register Low Byte
  UBRR3L,
  // Control Status Register A bis C
  UCSR3A, UCSR3B, UCSR3C,




  // *** TWI (2-wire Serial Interface) ***

  // Slave Address Mask Register
  TWAMR,
  // Control Register
  TWCR,
  // Data Register
  TWDR,
  // Slave Address Register
  TWAR,
  // Status Register
  TWSR,
  // Bit Rate Register
  TWBR,



  // *** Timer/Counter 1 ***


  // Output Compare Register A High Byte
  OCR1AH,
  // Output Compare Register A Low Byte
  OCR1AL,

  // Output Compare Register B Low Byte
  OCR1BL,
  // Output Compare Register B High Byte
  OCR1BH,

  // Output Compare Register C Low Byte
  OCR1CL,
  // Output Compare Register C High Byte
  OCR1CH,

  // Input Capture Register Low Byte
  ICR1L,
  // Input Capture Register High Byte
  ICR1H,

  // Timer/Counter Register Low Byte
  TCNT1L,
  // Timer/Counter Register High Byte
  TCNT1H,

  // Timer/Counter Control Register C
  TCCR1C,
  // Timer/Counter Control Register B
  TCCR1B,
  // Timer/Counter Control Register A
  TCCR1A,



  // *** Timer/Counter 2 ***

  // Asynchronous Status Register
  ASSR,

  // Output Compare Register B
  OCR2B,
  // Output Compare Register A
  OCR2A,
  // Timer/Counter Register (8 Bit)
  TCNT2,
  // Timer/Counter Control Register B
  TCCR2B,
  // Timer/Counter Control Register A
  TCCR2A,



  // *** Timer/Counter 3 ***

  // Output Compare Register A Low Byte
  OCR3AL,
  // Output Compare Register A High Byte
  OCR3AH,

  // Output Compare Register B Low Byte
  OCR3BL,
  // Output Compare Register B High Byte
  OCR3BH,

  // Output Compare Register C Low Byte
  OCR3CL,
  // Output Compare Register C High Byte
  OCR3CH,


  // Input Capture Register Low Byte
  ICR3L,
  // Input Capture Register High Byte
  ICR3H,

  // Timer/Counter Register Low Byte
  TCNT3L,
  // Timer/Counter Register High Byte
  TCNT3H,

  // Timer/Counter Control Register A
  TCCR3A,
  // Timer/Counter Control Register B
  TCCR3B,
  // Timer/Counter Control Register C
  TCCR3C,



  // *** Timer/Counter 4 ***

  // Output Compare Register A Low Byte
  OCR4AL,
  // Output Compare Register A High Byte
  OCR4AH,

  // Output Compare Register B Low Byte
  OCR4BL,
  // Output Compare Register B High Byte
  OCR4BH,

  // Output Compare Register C Low Byte
  OCR4CL,
  // Output Compare Register C High Byte
  OCR4CH,

  // Input Capture Register Low Byte
  ICR4L,
  // Input Capture Register High Byte
  ICR4H,

  // Timer/Counter Register Low Byte
  TCNT4L,
  // Timer/Counter Register High Byte
  TCNT4H,

  // Timer/Counter Control Register A
  TCCR4A,
  // Timer/Counter Control Register B
  TCCR4B,
  // Timer/Counter Control Register C
  TCCR4C,



  // *** Timer/Counter 5 ***

  // Output Compare Register A Low Byte
  OCR5AL,
  // Output Compare Register A High Byte
  OCR5AH,

  // Output Compare Register B Low Byte
  OCR5BL,
  // Output Compare Register B High Byte
  OCR5BH,

  // Output Compare Register C Low Byte
  OCR5CL,
  // Output Compare Register C High Byte
  OCR5CH,

  // Input Capture Register Low Byte
  ICR5L,
  // Input Capture Register High Byte
  ICR5H,

  // Timer/Counter Register Low Byte
  TCNT5L,
  // Timer/Counter Register High Byte
  TCNT5H,

  // Timer/Counter Control Register A
  TCCR5A,
  // Timer/Counter Control Register B
  TCCR5B,
  // Timer/Counter Control Register C
  TCCR5C,


  // Timer/Counter Interrupt Mask Register
  TIMSK0, TIMSK1, TIMSK2, TIMSK3, TIMSK4, TIMSK5,



  // *** ADC (Analog-to-digital Converter) ***

  // Digital Input Disable Register 0
  DIDR0,
  // Digital Input Disable Register 1
  DIDR1,
  // Digital Input Disable Register 2
  DIDR2,



  // Multiplexer Selection Register
  ADMUX,
  // Control and Status Register B
  ADCSRB,
  // Control and Status Register A
  ADCSRA,
  // Data Register High Byte
  ADCH,
  // Data Register Low Byte
  ADCL,



  // *** External Interrupts ***

  // Pin Change Mask Register 0 bis 2
  PCMSK0, PCMSK1, PCMSK2,

  // External Interrupt Control Register A
  EICRA,

  // External Interrupt Control Register B
  EICRB,

  // Pin Change Interrupt Control Register
  PCICR,


  // *** External Memory Interface ***

  // External Memory Control Register A
  XMCRA,

  // External Memory Control Register B
  XMCRB,


  // *** PORT H ***

  // Data Register
  PORTH,
  // Data Direction Register
  DDRH,
  // Input Pins Adress
  PINH,


  // *** PORT J ***

  // Data Register
  PORTJ,
  // Data Direction Register
  DDRJ,
  // Input Pins Adress
  PINJ,


  // *** PORT K ***

  // Data Register
  PORTK,
  // Data Direction Register
  DDRK,
  // Input Pins Adress
  PINK,


  // *** PORT L ***

  // Data Register
  PORTL,
  // Data Direction Register
  DDRL,
  // Input Pins Adress
  PINL,



  // *** sonstige Register ***

  // Oscillator Callibration Register
  OSCCAL,

  // Power Reduction Register 0
  PRR0,

  // Power Reduction Register 1
  PRR1,

  // Clock Prescaler Register
  CLKPR,

  // Watchdog Timer Control Register
  WDTCSR,



   : ByteConVar;






{
  alle Register, die mit In/OUT angesprochen werden koennen
}

  // Status Register
  SREG,

  // Stack Pointer Low und High
  SPL, SPH,

  // Store Program Memory Control and Status Register
  SPMCSR,

  // MCU Control Register
  MCUCR,
  // MCU Status Register
  MCUSR,

  // Sleep Mode Control Register
  SMCR,

  // On-chip Debug Related Register in I/O Memory
  OCDR,

  // Analog Comparator Control and Status Register
  ACSR,

  // SPI Data Register
  SPDR,

  // SPI Status Register
  SPSR,

  // SPI Control Register
  SPCR,

  // General Purpose I/O Register 0 bis 2
  GPIOR0, GPIOR1, GPIOR2,



  // *** Timer/Counter 0 ***

  // Output Compare Register A und B
  OCR0A, OCR0B,

  // Timer/Counter Register
  TCNT0,

  // Timer/Counter Control Register A und B
  TCCR0A,  TCCR0B,


  // General Timer/Counter Control Register
  GTCCR,



  // *** EEPROM ***

  // The EEPROM Adress Register
  EEARL, EEARH,

  // The EEPROM Data Register
  EEDR,

  // The EEPROM Control Register
  EECR,



  // *** External Interrupt ***

  // External Interrupt Mask Register
  EIMSK,

  // External Interrupt Flag Register
  EIFR,

  // Pin Change Interrupt Flag Register
  PCIFR,



  // Timer/Counter Interrupt Flag Register 0 bis 5
  TIFR0, TIFR1, TIFR2, TIFR3, TIFR4, TIFR5,



  // *** PORT A ***

  // Data Register
  PORTA,
  // Data Direction Register
  DDRA,
  // Input Pins Adress
  PINA,


  // *** PORT B ***

  // Data Register
  PORTB,
  // Data Direction Register
  DDRB,
  // Input Pins Adress
  PINB,


   // *** PORT C ***

  // Data Register
  PORTC,
  // Data Direction Register
  DDRC,
  // Input Pins Adress
  PINC,


  // *** PORT D ***

  // Data Register
  PORTD,
  // Data Direction Register
  DDRD,
  // Input Pins Adress
  PIND,


  // *** PORT E ***

  // Data Register
  PORTE,
  // Data Direction Register
  DDRE,
  // Input Pins Adress
  PINE,


  // *** PORT F ***

  // Data Register
  PORTF,
  // Data Direction Register
  DDRF,
  // Input Pins Adress
  PINF,


  // *** PORT G ***

  // Data Register
  PORTG,
  // Data Direction Register
  DDRG,
  // Input Pins Adress
  PING,



  // *** sonstige Register ***

  // RAMPZ  Extended Z-pointer Register for ELPM/SPM
  RAMPZ,

  // EIND  Extended Indirect Register
  EIND,



    : ByteConReg;


     {
  RXC0[UCSR0A,7] : Bit;
  TXC0[UCSR0A,6] : Bit;
  UDRE0[UCSR0A,5] : Bit;
     }


// *** ISR-Liste ***
//
ISR_LISTE( 2,'INT0addr' ,'EI_INT0'      ,'External Interrupt Request 0');
ISR_LISTE( 3,'INT1addr' ,'EI_INT1'      ,'External Interrupt Request 1');
ISR_LISTE( 4,'INT2addr' ,'EI_INT2'      ,'External Interrupt Request 2');
ISR_LISTE( 5,'INT3addr' ,'EI_INT3'      ,'External Interrupt Request 3');
ISR_LISTE( 6,'INT4addr' ,'EI_INT4'      ,'External Interrupt Request 4');
ISR_LISTE( 7,'INT5addr' ,'EI_INT5'      ,'External Interrupt Request 5');
ISR_LISTE( 8,'INT6addr' ,'EI_INT6'      ,'External Interrupt Request 6');
ISR_LISTE( 9,'INT7addr' ,'EI_INT7'      ,'External Interrupt Request 7');

ISR_LISTE(10,'PCI0addr' ,'PCINT0'       ,'Pin Change Interrupt Request 0');
ISR_LISTE(11,'PCI1addr' ,'PCINT1'       ,'Pin Change Interrupt Request 1');
ISR_LISTE(12,'PCI2addr' ,'PCINT2'       ,'Pin Change Interrupt Request 2');

ISR_LISTE(13,'WDTaddr'  ,'WDT'          ,'Watchdog Time-out Interrupt');

ISR_LISTE(14,'OC2Aaddr' ,'TIMER2_COMPA' ,'Timer/Counter2 Compare Match A');
ISR_LISTE(15,'OC2Baddr' ,'TIMER2_COMPB' ,'Timer/Counter2 Compare Match B');
ISR_LISTE(16,'OVF2addr' ,'TIMER2_OVF'   ,'Timer/Counter2 Overflow');

ISR_LISTE(17,'ICP1addr' ,'TIMER1_CAPT'  ,'Timer/Counter1 Capture Event');
ISR_LISTE(18,'OC1Aaddr' ,'TIMER1_COMPA' ,'Timer/Counter1 Compare Match A');
ISR_LISTE(19,'OC1Baddr' ,'TIMER1_COMPB' ,'Timer/Counter1 Compare Match B');
ISR_LISTE(20,'OC1Caddr' ,'TIMER1_COMPC' ,'Timer/Counter1 Compare Match C');
ISR_LISTE(21,'OVF1addr' ,'TIMER1_OVF'   ,'Timer/Counter1 Overflow');

ISR_LISTE(22,'OC0Aaddr' ,'TIMER0_COMPA' ,'Timer/Counter0 Compare Match A');
ISR_LISTE(23,'OC0Baddr' ,'TIMER0_COMPB' ,'Timer/Counter0 Compare Match B');
ISR_LISTE(24,'OVF0addr' ,'TIMER0_OVF'   ,'Timer/Counter0 Overflow');

ISR_LISTE(25,'SPIaddr'  ,'SPI_STC'      ,'Serial Transfer Complete');

ISR_LISTE(26,'URXC0addr','USART0_RX'    ,'USART0 Rx Complete');
ISR_LISTE(27,'UDRE0addr','USART0_UDRE'  ,'USART0 Data Register Empty');
ISR_LISTE(28,'UTXC0addr','USART0_TX'    ,'USART0 Tx Complete');

ISR_LISTE(29,'ACIaddr'  ,'ANA_COMP'     ,'Analog Comparator');

ISR_LISTE(30,'ADCCaddr' ,'ADC_CC'       ,'ADC Conversion Complete');
ISR_LISTE(31,'ERDYaddr' ,'EE_RDY'       ,'EEPROM Ready');

ISR_LISTE(32,'ICP3addr' ,'TIMER3_CAPT'  ,'Timer/Counter3 Capture Event');
ISR_LISTE(33,'OC3Aaddr' ,'TIMER3_COMPA' ,'Timer/Counter3 Compare Match A');
ISR_LISTE(34,'OC3Baddr' ,'TIMER3_COMPB' ,'Timer/Counter3 Compare Match B');
ISR_LISTE(35,'OC3Caddr' ,'TIMER3_COMPC' ,'Timer/Counter3 Compare Match C');
ISR_LISTE(36,'OVF3addr' ,'TIMER3_OVF'   ,'Timer/Counter3 Overflow');

ISR_LISTE(37,'URXC1addr','USART1_RX'    ,'USART1 Rx Complete');
ISR_LISTE(38,'UDRE1addr','USART1_UDRE'  ,'USART1 Data Register Empty');
ISR_LISTE(39,'UTXC1addr','USART1_TX'    ,'USART1 Tx Complete');

ISR_LISTE(40,'TWIaddr'  ,'TWI'          ,'Two-wire Serial Interface');
ISR_LISTE(41,'SPMRaddr' ,'SPM_RDY'      ,'Store Program Memory Ready');

ISR_LISTE(42,'ICP4addr' ,'TIMER4_CAPT'  ,'Timer/Counter4 Capture Event');
ISR_LISTE(43,'OC4Aaddr' ,'TIMER4_COMPA' ,'Timer/Counter4 Compare Match A');
ISR_LISTE(44,'OC4Baddr' ,'TIMER4_COMPB' ,'Timer/Counter4 Compare Match B');
ISR_LISTE(45,'OC4Caddr' ,'TIMER4_COMPC' ,'Timer/Counter4 Compare Match C');
ISR_LISTE(46,'OVF4addr' ,'TIMER4_OVF'   ,'Timer/Counter4 Overflow');

ISR_LISTE(47,'ICP5addr' ,'TIMER5_CAPT'  ,'Timer/Counter5 Capture Event');
ISR_LISTE(48,'OC5Aaddr' ,'TIMER5_COMPA' ,'Timer/Counter5 Compare Match A');
ISR_LISTE(49,'OC5Baddr' ,'TIMER5_COMPB' ,'Timer/Counter5 Compare Match B');
ISR_LISTE(50,'OC5Caddr' ,'TIMER5_COMPC' ,'Timer/Counter5 Compare Match C');
ISR_LISTE(51,'OVF5addr' ,'TIMER5_OVF'   ,'Timer/Counter5 Overflow');

ISR_LISTE(52,'URXC2addr','USART2_RX'    ,'USART2 Rx Complete');
ISR_LISTE(53,'UDRE2addr','USART2_UDRE'  ,'USART2 Data Register Empty');
ISR_LISTE(54,'UTXC2addr','USART2_TX'    ,'USART2 Tx Complete');

ISR_LISTE(55,'URXC3addr','USART3_RX'    ,'USART3 Rx Complete');
ISR_LISTE(56,'UDRE3addr','USART3_UDRE'  ,'USART3 Data Register Empty');
ISR_LISTE(57,'UTXC3addr','USART3_TX'    ,'USART3 Tx Complete');





