

const

  TastenTabelle_NORMAL : array[0..47] of Byte = (
  {   1    2    3    4    5    6    7    8    9    0   SH   CT }
    $31, $32, $33, $34, $35, $36, $37, $38, $39, $30, $00, $00,

  {   q    w    e    r    t    z    u    i    o    p   PO  ESC }
    $71, $77, $65, $72, $74, $7A, $75, $69, $6F, $70, $05, $1B,

  {   a    s    d    f    g    h    j    k    l   PL   CR   PR }
    $61, $73, $64, $66, $67, $68, $6A, $6B, $6C, $19, $0D, $06,

  {   y    x    c    v    b    n    m  DEL  INS  TAB   PU   SP }
    $79, $78, $63, $76, $62, $6E, $6D, $7F, $16, $09, $03, $20

    );



  TastenTabelle_SHIFT : array[0..47] of Byte = (
  {   +    -    *    /    (    )    ,    .    =    ?   SH   CT }
    $2B, $2D, $2A, $2F, $28, $29, $2C, $2E, $3D, $3F, $00, $00,

  {   Q    W    E    R    T    Z    U    I    O    P   PO    @ }
    $51, $57, $45, $52, $54, $5A, $55, $49, $4F, $50, $05, $40,

  {   A    S    D    F    G    H    J    K    L   PL   CR   PR }
    $41, $53, $44, $46, $47, $48, $4A, $4B, $4C, $19, $0D, $06,

  {   Y    X    C    V    B    N    M    %    &    $   PU   SP }
    $59, $58, $43, $56, $42, $4E, $4D, $25, $26, $24, $03, $20

    );



  TastenTabelle_CTRL : array[0..47] of Byte = (
  {   >    <    ;    :    !    "  GKA    [    ]  GKZ   SH   CT }
    $3E, $3C, $3B, $3A, $21, $22, $7B, $5B, $5D, $7D, $00, $00,

  {  ^Q   ^W   ^E   ^R   ^T   ^Z   ^U   ^I   ^O   ^P    '    | }
    $11, $17, $05, $12, $14, $1A, $15, $09, $0F, $10, $27, $7C,

  {  ^A   ^S   ^D   ^F   ^G   ^H   ^J   ^K   ^L    ~   CR    ^ }
    $01, $13, $04, $06, $07, $08, $0A, $0B, $0C, $7E, $0D, $5E,

  {  ^Y   ^X   ^C   ^V   ^B   ^N   ^M    _    #    \    `   SP }
    $19, $18, $03, $16, $02, $0E, $0D, $5F, $23, $5C, $60, $20

    );



var
  WD_Word : Word;

  // Puffer fuer die (aus dem SCAN-Code konvertierten) Tasten-Bytes
  KeyBuffer      : array [0..32] of Byte;
  KeyBufferPtr   : Word;

  Tasten_Nummer,
  letzte_Tasten_Nummer,
  Entprell_Zaehler : Byte;

  Text_String : String[15];

  SHIFT_ist_aktiv,
  CTRL_ist_aktiv : Boolean;




procedure KBD_Init;
begin

  // alle Steuerleitungen auf low
  ClearBit(SERIAL_DATA);
  ClearBit(SHIFT_CLOCK);
  ClearBit(LATCH_CLOCK);

  Status_LED_Gelb:=false;
  Status_LED_Gruen:=false;

  Status_LED_Rot_L:=false;
  Status_LED_Rot_R:=false;



  KeyBufferPtr:=0;
  letzte_Tasten_Nummer:=48;

  SHIFT_ist_aktiv:=false;
  CTRL_ist_aktiv:=false;

end KBD_Init;






// *** Unterprogramme zum key-Buffer ***




function read_key : Byte;
var
  read_key_value : Byte;
  key_counter : Word;
  b1 : Byte;
begin

  if KeyBufferPtr>0 then

    read_key_value:=KeyBuffer[0];
    dec(KeyBufferPtr);

    for key_counter:=0 to KeyBufferPtr do
      b1 := KeyBuffer[key_counter+1];
      KeyBuffer[key_counter] := b1;
    endfor;

  else

    read_key_value:=0;

  endif;

  Result:=read_key_value;

end read_key;





procedure write_key(write_key_value : byte);
begin

  KeyBuffer[KeyBufferPtr]:=write_key_value;

  if KeyBufferPtr<32 then
    inc(KeyBufferPtr);
  endif;

end write_key;







procedure write_c_key(cKey : char);
var
  b1 : Byte;
begin
  b1:=CharToByte(cKey);
  write_key(b1);
end write_c_key;




procedure write_text;
var
  Zaehler : Byte;
  c1 : Char;
begin
  for zaehler:=1 to length(Text_String) do
    c1:=Text_String[Zaehler];
    write_c_key(c1);
  endfor;
end write_text;






// ***************************************







procedure Write_Data_Word;
var
  R_Word_Latch : Word;
  R_counter : Byte;
begin

  for R_counter:=1 to 16 do

    ClearBit(SHIFT_CLOCK);

    R_Word_Latch:=WD_Word and %0000000000000001;

    if R_Word_Latch=0 then
      ClearBit(SERIAL_DATA);  // Data-Bit=0
    else
      SetBit(SERIAL_DATA); // Data-Bit=1
    endif;

    // Shift IN Data-Bit
    SetBit(SHIFT_CLOCK);

    SHR(WD_Word);

  endfor; { for R_counter:=1 to 16 do }

  SetBit(LATCH_CLOCK);
  ClearBit(LATCH_CLOCK);


end Write_Data_Word;











procedure TastenNummer_zu_TastenZeichen;
var
  Tasten_Zeichen : Byte;
  TN_Word : Word;
begin

  Tasten_Zeichen:=0;

  case Tasten_Nummer of

    10 : SHIFT_ist_aktiv:=true;
         Status_LED_Gruen:=true;
    |

    11 : CTRL_ist_aktiv:=true;
         Status_LED_Rot_L:=true;
         Status_LED_Rot_R:=true;
    |

  else

    TN_Word:=ByteToWord(Tasten_Nummer);

    if SHIFT_ist_aktiv then
      Tasten_Zeichen:=TastenTabelle_SHIFT[TN_Word];
      SHIFT_ist_aktiv:=false;
      Status_LED_Gruen:=false;
    else

      if CTRL_ist_aktiv then
        Tasten_Zeichen:=TastenTabelle_CTRL[TN_Word];
        CTRL_ist_aktiv:=false;
        Status_LED_Rot_L:=false;
        Status_LED_Rot_R:=false;
      else
        Tasten_Zeichen:=TastenTabelle_NORMAL[TN_Word];
      endif;

    endif;
  endcase;

  if Tasten_Zeichen>0 then
    write_key(Tasten_Zeichen);
  endif;

end TastenNummer_zu_TastenZeichen;












procedure Anzeige_Status_LEDs;
begin

  if Status_LED_Gelb then
    WD_Word:=WD_Word or  %1000000000000000;
  else
    WD_Word:=WD_Word and %0111111111111111;
  endif;

  if Status_LED_Gruen then
    WD_Word:=WD_Word or  %0000000100000000;
  else
    WD_Word:=WD_Word and %1111111011111111;
  endif;

  if Status_LED_Rot_L then
    WD_Word:=WD_Word or  %0000000010000000;
  else
    WD_Word:=WD_Word and %1111111101111111;
  endif;

  if Status_LED_Rot_R then
    WD_Word:=WD_Word or  %0000000000000001;
  else
    WD_Word:=WD_Word and %1111111111111110;
  endif;

  Write_Data_Word;

end Anzeige_Status_LEDs;







procedure Tastatur_lesen;
var
  w2 : Byte;
begin

  Tasten_Nummer:=48;

  for w2:=0 to 11 do

    case w2 of

      00 : WD_Word:=%0011111001111110;
      |

      01 : WD_Word:=%0101111001111110;
      |

      02 : WD_Word:=%0110111001111110;
      |

      03 : WD_Word:=%0111011001111110;
      |

      04 : WD_Word:=%0111101001111110;
      |

      05 : WD_Word:=%0111110001111110;
      |

      06 : WD_Word:=%0111111000111110;
      |

      07 : WD_Word:=%0111111001011110;
      |

      08 : WD_Word:=%0111111001101110;
      |

      09 : WD_Word:=%0111111001110110;
      |

      10 : WD_Word:=%0111111001111010;
      |

      11 : WD_Word:=%0111111001111100;
      |

    endcase;

    Anzeige_Status_LEDs;

    if BitLow(TZ_00) then
      Tasten_Nummer:=w2;
    endif;

    if BitLow(TZ_01) then
      Tasten_Nummer:=w2+12;
    endif;

    if BitLow(TZ_02) then
      Tasten_Nummer:=w2+24;
    endif;

    if BitLow(TZ_03) then
      Tasten_Nummer:=w2+36;
    endif;

  endfor;

  // Entprellung !!!

  if Tasten_Nummer=letzte_Tasten_Nummer then

    if Entprell_Zaehler>0 then

      Dec(Entprell_Zaehler);

      if Entprell_Zaehler=1 then

        if Tasten_Nummer<48 then
          TastenNummer_zu_TastenZeichen;
          Click;
        endif;

      endif;

    endif;

  else
    // hier Aenderung der Taste (Taste gedrueckt oder losgelassen)
    letzte_Tasten_Nummer:=Tasten_Nummer;
    Entprell_Zaehler:=10;
  endif;




end Tastatur_lesen;


















