PROGRAM CH376B;


// Arduino Nano
DEVICE = MEGA328P;

{$I mega328P_Register.INC}


CONST
  // Arduino Nano
  // TaktFrequenz in KHz
  TaktFrequenz : WORD = 16000;


  // bei 16,000 MHz -> 9.600
  UBRR_VAL : Byte = 103;


  Write_Zaehler_Ende : Word = 2000;
  LED_Gruen_Zaehler_Ende : Word = 4000;
  LED_Rot_Zaehler_Ende : Word = 4000;


VAR

  UBRR_VAL_VAR : Byte;

  Write_Zaehler : Word;
  Write_Schalter : Boolean;



  // Status LEDs
  LED_Gelb[PortD, 2] : bit;  // Gelb
  LED_Gruen[PortD,3] : bit;  // Gruen
  LED_Rot[PortD,  4] : bit;  // Rot
  LED_Blau[PortD, 5] : bit;  // Blau

  // DDR zur Initialisierung
  LED_Gelb_D[DDRD, 2] : bit;  // Gelb
  LED_Gruen_D[DDRD,3] : bit;  // Gruen
  LED_Rot_D[DDRD,  4] : bit;  // Rot
  LED_Blau_D[DDRD, 5] : bit;  // Blau

  WHO_AM_I_Schleife : Boolean;

  LED_Gruen_Zaehler,
  LED_Rot_Zaehler : Word;
  LED_Gruen_Schalter,
  LED_Rot_Schalter : Boolean;


{$I SYSTEM.INC}

{$I mega328P_UART_oI.INC}

{$I CH376B.INC}


// ITP3
{$I ITP3_CLI_PORT.INC}
{$I ITP3_CLI_PRG.INC}





procedure InitPorts;
begin
{
Konfiguration:

// alle Ports C werden vom ITP3
// genutzt und dort auch konfiguriert
//
C0..C3 - D0..D3 - ITP3-Daten
C4 - DS - Device Select
C5 - DR - Device Receive

// die serielle Schnittstelle an den
// CH376B wird ueber INIT_SER0_PORT
// aktiviert PD0 und PD1

// zur Programmierung werden die Pins
// PB3 bis PB5 reserviert

// fuer die 4 LED (Gelb, Gruen, Rot, Blau)
// werden folgende PINs genutzt:
LED_Gelb[PortD, 2]
LED_Gruen[PortD,3]
LED_Rot[PortD,  4]
LED_Blau[PortD, 5]

}

// Initialisierung der LEDs als Ausgang
  SetBit(LED_Gelb_D);
  SetBit(LED_Gruen_D);
  SetBit(LED_Rot_D);
  SetBit(LED_Blau_D);

// Status LEDs ausschalten
  SetBit(LED_Gelb);
  SetBit(LED_Gruen);
  SetBit(LED_Rot);
  SetBit(LED_Blau);

end InitPorts;








BEGIN


  InitPorts;

  ITP3_Client_Init;



  // zuerst muss
  WHO_AM_I_Schleife:=true;

  while WHO_AM_I_Schleife do

     ITP3_Server_Abfrage;
     wait_ms(1);

  endwhile;





  UBRR_VAL_VAR:=UBRR_VAL;
  INIT_SER0_PORT;

  CH376B_Init;


  Write_Zaehler:=0;
  Write_Schalter:=false;

  LED_Gruen_Zaehler:=0;
  LED_Gruen_Schalter:=false;

  LED_Rot_Zaehler:=0;
  LED_Rot_Schalter:=false;


  loop

    ITP3_Server_Abfrage;

    if Write_Schalter then

      Inc(Write_Zaehler);

      if Write_Zaehler>Write_Zaehler_Ende then

        CH376B_CMD_FILE_CLOSE_WR;
        SER0_String:='DRIVE_D.IMG';
        CH376B_CMD_SET_FILE_NAME;
        CH376B_CMD_FILE_OPEN;

        Write_Zaehler:=0;
        Write_Schalter:=false;

      endif;

    endif;


    if LED_Gruen_Schalter then

      Inc(LED_Gruen_Zaehler);

      if LED_Gruen_Zaehler>LED_Gruen_Zaehler_Ende then

        // LED-Gruen aus
        SetBit(LED_Gruen);
        // LED-Gelb ein
        ClearBit(LED_Gelb);

        LED_Gruen_Zaehler:=0;
        LED_Gruen_Schalter:=false;

      endif; // if LED_Gruen_Zaehler>LED_Gruen_Zaehler_Ende then

    endif;  // LED_Gruen_Schalter then



    if LED_Rot_Schalter then

      Inc(LED_Rot_Zaehler);

      if LED_Rot_Zaehler>LED_Rot_Zaehler_Ende then

        // LED-Rot aus
        SetBit(LED_Rot);
        // LED-Gelb ein
        ClearBit(LED_Gelb);

        LED_Rot_Zaehler:=0;
        LED_Rot_Schalter:=false;

      endif; // if LED_Rot_Zaehler>LED_Rot_Zaehler_Ende then

    endif;  // LED_Rot_Schalter then


  endloop;




END CH376B.
