; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: GCON.PAS
 
.nolist
.INCLUDE "m644Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        BAUDRATE  =  0x62A5 ; WORD
.equ        UBRR_VAL  =  0x0031 ; WORD
.equ        XON  =  0x11 ; BYTE
.equ        XOFF  =  0x13 ; BYTE
.equ        FNT_6X8  =  0x01 ; BYTE
.equ        FNT_8X8  =  0x02 ; BYTE
.equ        CL_WHITE  =  0xFF ; BYTE
.equ        CL_BLACK  =  0x00 ; BYTE
.equ        CL_RED  =  0x43 ; BYTE
.equ        CL_GREEN  =  0x4C ; BYTE
.equ        CL_BLUE  =  0xB0 ; BYTE
.equ        CL_YELLOW  =  0x4F ; BYTE
.equ        CL_PURPLE  =  0x73 ; BYTE
.equ        CL_AQUA  =  0x7C ; BYTE
.equ        CL_GRAY  =  0x6A ; BYTE
.equ        CL_DARKGRAY  =  0x2A ; BYTE
.equ        NORMAL_TM  =  0x00 ; BYTE
.equ        IBM_ESC_TM  =  0x01 ; BYTE
.equ        IBM_CSI_TM  =  0x02 ; BYTE
.equ        IBM_CSI_TM_PAR_1  =  0x03 ; BYTE
.equ        IBM_CSI_TM_PAR_2  =  0x04 ; BYTE
.equ        IBM_CSI_TM_PAR_3  =  0x05 ; BYTE
.equ        IBM_GRAFIK_PAR_1_TM  =  0x06 ; BYTE
.equ        IBM_GRAFIK_PAR_2_TM  =  0x07 ; BYTE
 
; *** Variablentabelle ***
 
.dseg
 
FCOLOR:   ; Byte
.byte     1
BCOLOR:   ; Byte
.byte     1
PIXCOLOR:   ; Byte
.byte     1
ZEICHEN:   ; Byte
.byte     1
X_KUR_POS:   ; Word
.byte     2
Y_KUR_POS:   ; Word
.byte     2
X_PIX_POS:   ; Word
.byte     2
Y_PIX_POS:   ; Word
.byte     2
X_END_POS:   ; Word
.byte     2
Y_END_POS:   ; Word
.byte     2
KURSOR_SCHLEIFE:   ; Word
.byte     2
KURSOR_SICHTBAR:   ; Boolean
.byte     1
KURSOR_EIN:   ; Boolean
.byte     1
KURARR_AKTUELL:   ; Boolean
.byte     1
E1_X_PIX_POS:   ; Word
.byte     2
E1_Y_PIX_POS:   ; Word
.byte     2
E2_X_PIX_POS:   ; Word
.byte     2
E2_Y_PIX_POS:   ; Word
.byte     2
ICON_ADRESS:   ; Adresse
.byte     2
TERMMODE:   ; Byte
.byte     1
CSI_PARAMETER1:   ; Word
.byte     2
CSI_PARAMETER2:   ; Word
.byte     2
CSI_PARAMETER3:   ; Word
.byte     2
DELTA_X:   ; Word
.byte     2
DELTA_Y:   ; Word
.byte     2
SIN_DW1:
.byte     4
SIN_DW2:
.byte     4
ESCAPE_SEQUENZ:   ; String(10)
.byte     1     ; STRING-Laenge
.byte     10
ZEICHENBREITE:   ; Word
.byte     2
ZEICHENHOEHE:   ; Word
.byte     2
MAX_SPALTEN2:   ; Word
.byte     2
MAX_ZEILEN2:   ; Word
.byte     2
X_ANF:   ; Word
.byte     2
Y_ANF:   ; Word
.byte     2
MAX_SPALTEN:   ; Word
.byte     2
MAX_ZEILEN:   ; Word
.byte     2
FONT_BEZ:   ; Byte
.byte     1
ZEICHENBREITE0:   ; Byte
.byte     1
KOPIEBWS:   ; Boolean
.byte     1
BILD_ADRESSE:   ; Adresse
.byte     2
 
KURSOR_ARRAY:
 .byte     64
CHAR_ARRAY:
 .byte     64
EBENE1_ARRAY:
 .byte     416
EBENE2_ARRAY:
 .byte     416
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFE)
        LDI        R16, 0xFE
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x58)
        LDI        R16, 0x58
 
; Zuweisung Ziel /  VAR (PORTD)
        OUT        PORTD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; PROCEDURE - Anfang (INIT_SER_PORT)
INIT_SER_PORT:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (UBRR_VAL)
        LDI        R16, LOW(0x0031)
        LDI        R17, HIGH(0x0031)
 
; Zuweisung Ziel /  VAR (UBRR0)
        STS        UBRR0, R16
        STS        UBRR0+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x18)
        LDI        R16, 0x18
 
; Zuweisung Ziel /  VAR (UCSR0B)
        STS        UCSR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x86)
        LDI        R16, 0x86
 
; Zuweisung Ziel /  VAR (UCSR0C)
        STS        UCSR0C, R16
 
; PROCEDURE - Ende (INIT_SER_PORT)
        RET
 
; PROCEDURE - Anfang (INIT_BILD_ADRESSE)
INIT_BILD_ADRESSE:
 
; Zuweisung Quelle - Ausdruck / ArrayToAdress(BILD5_256)
        LDI        R16, LOW(2*BILD5_256)
        LDI        R17, HIGH(2*BILD5_256)
 
; Zuweisung Ziel /  VAR (BILD_ADRESSE)
        STS        BILD_ADRESSE, R16
        STS        BILD_ADRESSE+1, R17
 
; Zuweisung Quelle - Ausdruck / ArrayToAdress(EBENE1_ARRAY)
        LDI        R16, LOW(EBENE1_ARRAY)
        LDI        R17, HIGH(EBENE1_ARRAY)
 
; Zuweisung Ziel /  VAR (ICON_ADRESS)
        STS        ICON_ADRESS, R16
        STS        ICON_ADRESS+1, R17
 
; PROCEDURE - Ende (INIT_BILD_ADRESSE)
        RET
 
; PROCEDURE - Anfang (SETZE_FONT)
SETZE_FONT:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (FONTGROESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (FONT_BEZ)
        STS        FONT_BEZ, R16
 
; CASE OF - lokaler Uebergabeparameter (FONTGROESSE)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (FNT_6X8)
        CPI        R16, 0x01
        BREQ       M_CASE_03
        RJMP       M_CASE_02
M_CASE_03:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0006)
        LDI        R16, LOW(0x0006)
        LDI        R17, HIGH(0x0006)
 
; Zuweisung Ziel /  VAR (ZEICHENBREITE)
        STS        ZEICHENBREITE, R16
        STS        ZEICHENBREITE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (ZEICHENBREITE0)
        STS        ZEICHENBREITE0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x000A)
        LDI        R16, LOW(0x000A)
        LDI        R17, HIGH(0x000A)
 
; Zuweisung Ziel /  VAR (ZEICHENHOEHE)
        STS        ZEICHENHOEHE, R16
        STS        ZEICHENHOEHE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x000C)
        LDI        R16, LOW(0x000C)
        LDI        R17, HIGH(0x000C)
 
; Zuweisung Ziel /  VAR (X_ANF)
        STS        X_ANF, R16
        STS        X_ANF+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  VAR (Y_ANF)
        STS        Y_ANF, R16
        STS        Y_ANF+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x004F)
        LDI        R16, LOW(0x004F)
        LDI        R17, HIGH(0x004F)
 
; Zuweisung Ziel /  VAR (MAX_SPALTEN)
        STS        MAX_SPALTEN, R16
        STS        MAX_SPALTEN+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x004E)
        LDI        R16, LOW(0x004E)
        LDI        R17, HIGH(0x004E)
 
; Zuweisung Ziel /  VAR (MAX_SPALTEN2)
        STS        MAX_SPALTEN2, R16
        STS        MAX_SPALTEN2+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0017)
        LDI        R16, LOW(0x0017)
        LDI        R17, HIGH(0x0017)
 
; Zuweisung Ziel /  VAR (MAX_ZEILEN)
        STS        MAX_ZEILEN, R16
        STS        MAX_ZEILEN+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0016)
        LDI        R16, LOW(0x0016)
        LDI        R17, HIGH(0x0016)
 
; Zuweisung Ziel /  VAR (MAX_ZEILEN2)
        STS        MAX_ZEILEN2, R16
        STS        MAX_ZEILEN2+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_02:
 
; CASE OF - vergleiche Einzel-Element (FNT_8X8)
        CPI        R16, 0x02
        BREQ       M_CASE_05
        RJMP       M_CASE_04
M_CASE_05:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0008)
        LDI        R16, LOW(0x0008)
        LDI        R17, HIGH(0x0008)
 
; Zuweisung Ziel /  VAR (ZEICHENBREITE)
        STS        ZEICHENBREITE, R16
        STS        ZEICHENBREITE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (ZEICHENBREITE0)
        STS        ZEICHENBREITE0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x000A)
        LDI        R16, LOW(0x000A)
        LDI        R17, HIGH(0x000A)
 
; Zuweisung Ziel /  VAR (ZEICHENHOEHE)
        STS        ZEICHENHOEHE, R16
        STS        ZEICHENHOEHE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  VAR (X_ANF)
        STS        X_ANF, R16
        STS        X_ANF+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  VAR (Y_ANF)
        STS        Y_ANF, R16
        STS        Y_ANF+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x003F)
        LDI        R16, LOW(0x003F)
        LDI        R17, HIGH(0x003F)
 
; Zuweisung Ziel /  VAR (MAX_SPALTEN)
        STS        MAX_SPALTEN, R16
        STS        MAX_SPALTEN+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x003E)
        LDI        R16, LOW(0x003E)
        LDI        R17, HIGH(0x003E)
 
; Zuweisung Ziel /  VAR (MAX_SPALTEN2)
        STS        MAX_SPALTEN2, R16
        STS        MAX_SPALTEN2+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0017)
        LDI        R16, LOW(0x0017)
        LDI        R17, HIGH(0x0017)
 
; Zuweisung Ziel /  VAR (MAX_ZEILEN)
        STS        MAX_ZEILEN, R16
        STS        MAX_ZEILEN+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0016)
        LDI        R16, LOW(0x0016)
        LDI        R17, HIGH(0x0016)
 
; Zuweisung Ziel /  VAR (MAX_ZEILEN2)
        STS        MAX_ZEILEN2, R16
        STS        MAX_ZEILEN2+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
 
; CASE OF ELSE
M_CASE_04:
 
; ENDCASE;
M_CASE_01:
 
; PROCEDURE - Ende (SETZE_FONT)
        RET
 
; PROCEDURE - Anfang (WAIT_MS)
WAIT_MS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (ZEIT)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_06:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_07
        RJMP       M_FTD_08
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_07:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x02D0)
        LDI        R16, LOW(0x02D0)
        LDI        R17, HIGH(0x02D0)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_09:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_010
        RJMP       M_FTD_011
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_010:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_09
 
; FOR TO DO - Ende
M_FTD_011:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_06
 
; FOR TO DO - Ende
M_FTD_08:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (WAIT_MS)
        RET
 
; PROCEDURE - Anfang (CLEAR_RAM)
CLEAR_RAM:
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (BCOLOR)
        LDS        R16, BCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x00FF)
        LDI        R16, LOW(0x00FF)
        LDI        R17, HIGH(0x00FF)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_012:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_013
        RJMP       M_FTD_014
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_013:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X2)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x01FF)
        LDI        R16, LOW(0x01FF)
        LDI        R17, HIGH(0x01FF)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_015:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_016
        RJMP       M_FTD_017
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_016:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R5
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_015
 
; FOR TO DO - Ende
M_FTD_017:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_021
        CLR        R16
        RJMP       M_VERGL_022
M_VERGL_021:
        SER        R16
M_VERGL_022:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_018
        RJMP       M_IF_019
M_IF_018:
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN - Ende
M_IF_019:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_012
 
; FOR TO DO - Ende
M_FTD_014:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (CLEAR_RAM)
        RET
 
; PROCEDURE - Anfang (SCREENROLL)
SCREENROLL:
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ASM
; Vereinbarungsteil
; -----------------
.EQU  C_A16 = 2
.EQU  C_WE  = 3
.EQU  C_OE  = 4
.EQU  C_DIR = 6

; Voreinstellungen
; ----------------

      ; Loeschen von A16
      CBI    PORTD, C_A16



      ; R19=0 (Eingang)
      CLR    R19

      ; R20=FF (Ausgang)
      SER    R20
 

      CALL   ScreenRoll1_ANF

      CALL   ScreenRoll2_ANF

      ; Setzen von A16
      SBI    PORTD, C_A16

      CALL   ScreenRoll1_ANF

      RJMP   ScreenRoll_END

; -----------------------------

ScreenRoll1_ANF:
      
      ; R17 = Y_POS_Ziel
      CLR    R17 

      ; R18 = Y_POS_Quelle
      LDI    R18, 20 

ScreenRoll1_Y:

      ; R16 = X_POS
      CLR    R16

ScreenRoll1_X:

      ; Setzen der Y-Speicheradresse (Y_POS_Quelle)
      OUT    PORTC, R18

      ; Setzen der X-Speicheradresse 
      OUT    PORTB, R16

      ; SRAM OUTPUT ENABLE
      CBI    PORTD, C_OE


      NOP
      NOP
      NOP
      NOP

      ; X_POS + 1
      INC     R16


      ; READ DATA BYTE
      IN     R21 ,PINA

      ; SRAM OUTPUT DISABLE
      SBI    PORTD, C_OE

     ; Setzen der Y-Speicheradresse (Y_POS_Ziel)
      OUT    PORTC, R17

     ; DIR auf Schreiben
      CBI    PORTD, C_DIR

      ; Daten-Port auf Ausgang programmieren
      OUT    DDRA, R20

     ; Ausgabe des Farbbytes fuer den Pixel an den Datenport des SRAM 
     OUT     PORTA, R21

     ; und Uebernahme des Wertes in den RAM durch aktivieren von WE
     CBI     PORTD, C_WE 

     NOP
     NOP
     NOP
     NOP
     NOP
     NOP

     SBI     PORTD, C_WE 

      ; Daten-Port auf Eingang programmieren
      OUT    DDRA, R19

    ; DIR auf Lesen
      SBI    PORTD, C_DIR

     ; XEND erreicht
     CP      R16, R19

     ; Wenn nicht, X-Schleife nochmal durchlaufen
     BRNE    ScreenRoll1_X

     ;
     INC     R17
     INC     R18

     ; YEND erreicht
     CP      R18, R19

    ; Wenn nicht, Y-Schleife nochmal durchlaufen
     BRNE    ScreenRoll1_Y

    ; Ruecksprung
    RET




ScreenRoll2_ANF:
      
      ; R17 = Y_POS_Ziel
      LDI    R17, 236 

      ; R18 = Y_POS_Quelle
      CLR    R18 


ScreenRoll2_Y:

      ; R16 = X_POS
      CLR    R16

ScreenRoll2_X:

      ; Setzen von A16
      SBI    PORTD, C_A16

      ; Setzen der Y-Speicheradresse (Y_POS_Quelle)
      OUT    PORTC, R18

      ; Setzen der X-Speicheradresse 
      OUT    PORTB, R16

      ; SRAM OUTPUT ENABLE
      CBI    PORTD, C_OE


      NOP
      NOP
      NOP
      NOP

      ; X_POS + 1
      INC     R16


      ; READ DATA BYTE
      IN     R21 ,PINA

      ; SRAM OUTPUT DISABLE
      SBI    PORTD, C_OE


      ; Loeschen von A16
      CBI    PORTD, C_A16


     ; Setzen der Y-Speicheradresse (Y_POS_Ziel)
      OUT    PORTC, R17

     ; DIR auf Schreiben
      CBI    PORTD, C_DIR

      ; Daten-Port auf Ausgang programmieren
      OUT    DDRA, R20

     ; Ausgabe des Farbbytes fuer den Pixel an den Datenport des SRAM 
     OUT     PORTA, R21

     ; und Uebernahme des Wertes in den RAM durch aktivieren von WE
     CBI     PORTD, C_WE 

     NOP
     NOP
     NOP
     NOP
     NOP
     NOP

     SBI     PORTD, C_WE 

      ; Daten-Port auf Eingang programmieren
      OUT    DDRA, R19

    ; DIR auf Lesen
      SBI    PORTD, C_DIR

     ; XEND erreicht
     CP      R16, R19

     ; Wenn nicht, X-Schleife nochmal durchlaufen
     BRNE    ScreenRoll2_X

     ;
     INC     R17
     INC     R18

     ; YEND erreicht
     CP      R17, R19

    ; Wenn nicht, Y-Schleife nochmal durchlaufen
     BRNE    ScreenRoll2_Y

    ; Ruecksprung
    RET




ScreenRoll_END:



 
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (SCREENROLL)
        RET
 
; PROCEDURE - Anfang (UMSCHALTEN_SPEICHERSEITE)
UMSCHALTEN_SPEICHERSEITE:
 
; IF THEN - Ausdruck /; BitHigh(VS1_GS2)
        IN         R16, PORTD
        BST        R16, 5
        BRTS       M_VERGL_026
        CLR        R16
        RJMP       M_VERGL_027
M_VERGL_026:
        SER        R16
M_VERGL_027:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_023
        RJMP       M_IF_024
M_IF_023:
 
; ClearBit(VS1_GS2)
        CBI        PORTD, 5
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_025
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_024:
 
; SetBit(VS1_GS2)
        SBI        PORTD, 5
 
; IF_THEN_ELSE - Ende
M_IF_025:
 
; PROCEDURE - Ende (UMSCHALTEN_SPEICHERSEITE)
        RET
 
; PROCEDURE - Anfang (RESET_FORM)
RESET_FORM:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLACK)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_WHITE)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_ANF)
        LDS        R16, Y_ANF
        LDS        R17, Y_ANF+1
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (CLEAR_RAM)
        CALL       CLEAR_RAM
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_028
        RJMP       M_IF_029
M_IF_028:
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Aufruf PROCEDURE (CLEAR_RAM)
        CALL       CLEAR_RAM
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; IF_THEN - Ende
M_IF_029:
 
; PROCEDURE - Ende (RESET_FORM)
        RET
 
; PROCEDURE - Anfang (SCHREIBE_BILD)
SCHREIBE_BILD:
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_034
        CLR        R16
        RJMP       M_VERGL_035
M_VERGL_034:
        SER        R16
M_VERGL_035:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_031
        RJMP       M_IF_032
M_IF_031:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_033
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_032:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_033:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_POINTER)
        MOV        R9, R16
        MOV        R10, R17
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B_POINTER)
        MOV        R16, R9
        MOV        R17, R10
 
; Zuweisung Quelle - Ausdruck / ReadAdrArray (BILD_ADRESSE)
        LDS        ZL, BILD_ADRESSE
        LDS        ZH, BILD_ADRESSE+1
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT)
        MOV        R6, R16
 
; INC(B_POINTER) - Word
        MOV        R24, R9
        MOV        R25, R10
        ADIW       R25:R24, 1
        MOV        R9, R24
        MOV        R10, R25
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(B_WERT)
        MOV        R16, R6
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_BIS)
        MOV        R3, R16
        MOV        R4, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (X_BIS)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0100)
        LDI        R18, LOW(0x0100)
        LDI        R19, HIGH(0x0100)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_BIS)
        MOV        R3, R16
        MOV        R4, R17
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B_POINTER)
        MOV        R16, R9
        MOV        R17, R10
 
; Zuweisung Quelle - Ausdruck / ReadAdrArray (BILD_ADRESSE)
        LDS        ZL, BILD_ADRESSE
        LDS        ZH, BILD_ADRESSE+1
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT)
        MOV        R6, R16
 
; INC(B_POINTER) - Word
        MOV        R24, R9
        MOV        R25, R10
        ADIW       R25:R24, 1
        MOV        R9, R24
        MOV        R10, R25
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(B_WERT)
        MOV        R16, R6
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (X_BIS)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (X1)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_BIS)
        MOV        R3, R16
        MOV        R4, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Zahlenwert (0x0200)
        LDI        R16, LOW(0x0200)
        LDI        R17, HIGH(0x0200)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (X_BIS)
        MOV        R18, R3
        MOV        R19, R4
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (OFFSET)
        MOV        R11, R16
        MOV        R12, R17
 
; DEC(X_BIS) - Word
        MOV        R24, R3
        MOV        R25, R4
        SBIW       R25:R24, 1
        MOV        R3, R24
        MOV        R4, R25
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B_POINTER)
        MOV        R16, R9
        MOV        R17, R10
 
; Zuweisung Quelle - Ausdruck / ReadAdrArray (BILD_ADRESSE)
        LDS        ZL, BILD_ADRESSE
        LDS        ZH, BILD_ADRESSE+1
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_BIS)
        MOV        R5, R16
 
; INC(B_POINTER) - Word
        MOV        R24, R9
        MOV        R25, R10
        ADIW       R25:R24, 1
        MOV        R9, R24
        MOV        R10, R25
 
; DEC(Y_BIS) - Byte
        DEC        R5
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X2)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (Y_BIS)
        MOV        R16, R5
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_036:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_037
        RJMP       M_FTD_038
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_037:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (X_BIS)
        MOV        R16, R3
        MOV        R17, R4
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_039:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_040
        RJMP       M_FTD_041
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_040:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B_POINTER)
        MOV        R16, R9
        MOV        R17, R10
 
; Zuweisung Quelle - Ausdruck / ReadAdrArray (BILD_ADRESSE)
        LDS        ZL, BILD_ADRESSE
        LDS        ZH, BILD_ADRESSE+1
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B_WERT)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xFF)
        LDI        R18, 0xFF
 
; Operator <
        CP         R16, R18
        BRCS       M_VERGL_045
        CLR        R16
        RJMP       M_VERGL_046
M_VERGL_045:
        SER        R16
M_VERGL_046:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_042
        RJMP       M_IF_043
M_IF_042:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT)
        MOV        R16, R6
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R7
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R8
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R7
        MOV        R25, R8
        ADIW       R25:R24, 1
        MOV        R7, R24
        MOV        R8, R25
 
; INC(B_POINTER) - Word
        MOV        R24, R9
        MOV        R25, R10
        ADIW       R25:R24, 1
        MOV        R9, R24
        MOV        R10, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_044
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_043:
 
; INC(ADRESSE) - Word
        MOV        R24, R7
        MOV        R25, R8
        ADIW       R25:R24, 1
        MOV        R7, R24
        MOV        R8, R25
 
; INC(B_POINTER) - Word
        MOV        R24, R9
        MOV        R25, R10
        ADIW       R25:R24, 1
        MOV        R9, R24
        MOV        R10, R25
 
; IF_THEN_ELSE - Ende
M_IF_044:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_039
 
; FOR TO DO - Ende
M_FTD_041:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xFE00)
        LDI        R18, LOW(0xFE00)
        LDI        R19, HIGH(0xFE00)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_050
        CLR        R16
        RJMP       M_VERGL_051
M_VERGL_050:
        SER        R16
M_VERGL_051:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_047
        RJMP       M_IF_048
M_IF_047:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_049
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_048:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_055
        CLR        R16
        RJMP       M_VERGL_056
M_VERGL_055:
        SER        R16
M_VERGL_056:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_052
        RJMP       M_IF_053
M_IF_052:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_054
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_053:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (OFFSET)
        MOV        R18, R11
        MOV        R19, R12
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; IF_THEN_ELSE - Ende
M_IF_054:
 
; IF_THEN_ELSE - Ende
M_IF_049:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_036
 
; FOR TO DO - Ende
M_FTD_038:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (SCHREIBE_BILD)
        RET
 
; PROCEDURE - Anfang (VRAM_TO_ICON_ARRAY)
VRAM_TO_ICON_ARRAY:
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF THEN - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_PIXEL_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_060
        CLR        R16
        RJMP       M_VERGL_061
M_VERGL_060:
        SER        R16
M_VERGL_061:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_057
        RJMP       M_IF_058
M_IF_057:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_PIXEL_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (X_PIXEL_POS)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_059
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_058:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_PIXEL_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (X_PIXEL_POS)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_059:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R7, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0F)
        LDI        R16, 0x0F
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R7
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_062:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_063
        RJMP       M_FTD_064
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_063:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R6, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x19)
        LDI        R16, 0x19
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R6
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_065:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_066
        RJMP       M_FTD_067
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_066:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R5
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(OE)
        CBI        PORTD, 4
 
; INC(ADRESSE) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; WriteAdrArray POSITION - Ausdruck / lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R16, R8
        MOV        R17, R9
 
; WriteAdrArray Ziel Zeiger berechnen (ICON_ADRESS)
        LDS        ZL, ICON_ADRESS
        LDS        ZH, ICON_ADRESS+1
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINA
        IN         R16, PINA
 
; Zuweisung Ziel /  WriteAdrArray (ICON_ADRESS)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(ARRAY_POS) - Word
        MOV        R24, R8
        MOV        R25, R9
        ADIW       R25:R24, 1
        MOV        R8, R24
        MOV        R9, R25
 
; SetBit(OE)
        SBI        PORTD, 4
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R6
        INC        R17
        MOV        R6, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_065
 
; FOR TO DO - Ende
M_FTD_067:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xFE00)
        LDI        R18, LOW(0xFE00)
        LDI        R19, HIGH(0xFE00)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_071
        CLR        R16
        RJMP       M_VERGL_072
M_VERGL_071:
        SER        R16
M_VERGL_072:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_068
        RJMP       M_IF_069
M_IF_068:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (X_PIXEL_POS)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_070
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_069:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_076
        CLR        R16
        RJMP       M_VERGL_077
M_VERGL_076:
        SER        R16
M_VERGL_077:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_073
        RJMP       M_IF_074
M_IF_073:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (X_PIXEL_POS)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_075
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_074:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01E6)
        LDI        R18, LOW(0x01E6)
        LDI        R19, HIGH(0x01E6)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; IF_THEN_ELSE - Ende
M_IF_075:
 
; IF_THEN_ELSE - Ende
M_IF_070:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R7
        INC        R17
        MOV        R7, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_062
 
; FOR TO DO - Ende
M_FTD_064:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (VRAM_TO_ICON_ARRAY)
        RET
 
; PROCEDURE - Anfang (RETTE_ICON)
RETTE_ICON:
 
; IF THEN - Ausdruck /; BitHigh(VS1_GS2)
        IN         R16, PORTD
        BST        R16, 5
        BRTS       M_VERGL_081
        CLR        R16
        RJMP       M_VERGL_082
M_VERGL_081:
        SER        R16
M_VERGL_082:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_078
        RJMP       M_IF_079
M_IF_078:
 
; Zuweisung Quelle - Ausdruck / ArrayToAdress(EBENE1_ARRAY)
        LDI        R16, LOW(EBENE1_ARRAY)
        LDI        R17, HIGH(EBENE1_ARRAY)
 
; Zuweisung Ziel /  VAR (ICON_ADRESS)
        STS        ICON_ADRESS, R16
        STS        ICON_ADRESS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  VAR (E1_X_PIX_POS)
        STS        E1_X_PIX_POS, R16
        STS        E1_X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  VAR (E1_Y_PIX_POS)
        STS        E1_Y_PIX_POS, R16
        STS        E1_Y_PIX_POS+1, R17
 
; Word-Parameter(1) fuer PROCEDURE (VRAM_TO_ICON_ARRAY)
        LDS        R0, E1_X_PIX_POS
        LDS        R1, E1_X_PIX_POS+1
 
; Word-Parameter(2) fuer PROCEDURE (VRAM_TO_ICON_ARRAY)
        LDS        R2, E1_Y_PIX_POS
        LDS        R3, E1_Y_PIX_POS+1
 
; Aufruf PROCEDURE (VRAM_TO_ICON_ARRAY)
        CALL       VRAM_TO_ICON_ARRAY
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_080
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_079:
 
; Zuweisung Quelle - Ausdruck / ArrayToAdress(EBENE2_ARRAY)
        LDI        R16, LOW(EBENE2_ARRAY)
        LDI        R17, HIGH(EBENE2_ARRAY)
 
; Zuweisung Ziel /  VAR (ICON_ADRESS)
        STS        ICON_ADRESS, R16
        STS        ICON_ADRESS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  VAR (E2_X_PIX_POS)
        STS        E2_X_PIX_POS, R16
        STS        E2_X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  VAR (E2_Y_PIX_POS)
        STS        E2_Y_PIX_POS, R16
        STS        E2_Y_PIX_POS+1, R17
 
; Word-Parameter(1) fuer PROCEDURE (VRAM_TO_ICON_ARRAY)
        LDS        R0, E2_X_PIX_POS
        LDS        R1, E2_X_PIX_POS+1
 
; Word-Parameter(2) fuer PROCEDURE (VRAM_TO_ICON_ARRAY)
        LDS        R2, E2_Y_PIX_POS
        LDS        R3, E2_Y_PIX_POS+1
 
; Aufruf PROCEDURE (VRAM_TO_ICON_ARRAY)
        CALL       VRAM_TO_ICON_ARRAY
 
; IF_THEN_ELSE - Ende
M_IF_080:
 
; PROCEDURE - Ende (RETTE_ICON)
        RET
 
; PROCEDURE - Anfang (ICON_ARRAY_TO_VRAM)
ICON_ARRAY_TO_VRAM:
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; IF THEN - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_PIXEL_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_086
        CLR        R16
        RJMP       M_VERGL_087
M_VERGL_086:
        SER        R16
M_VERGL_087:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_083
        RJMP       M_IF_084
M_IF_083:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_PIXEL_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (X_PIXEL_POS)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_085
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_084:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_PIXEL_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (X_PIXEL_POS)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_085:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R7, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0F)
        LDI        R16, 0x0F
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R7
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_088:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_089
        RJMP       M_FTD_090
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_089:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R6, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x19)
        LDI        R16, 0x19
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R6
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_091:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_092
        RJMP       M_FTD_093
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_092:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck / ReadAdrArray (ICON_ADRESS)
        LDS        ZL, ICON_ADRESS
        LDS        ZH, ICON_ADRESS+1
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R5
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; INC(ARRAY_POS) - Word
        MOV        R24, R8
        MOV        R25, R9
        ADIW       R25:R24, 1
        MOV        R8, R24
        MOV        R9, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R6
        INC        R17
        MOV        R6, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_091
 
; FOR TO DO - Ende
M_FTD_093:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xFE00)
        LDI        R18, LOW(0xFE00)
        LDI        R19, HIGH(0xFE00)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_097
        CLR        R16
        RJMP       M_VERGL_098
M_VERGL_097:
        SER        R16
M_VERGL_098:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_094
        RJMP       M_IF_095
M_IF_094:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (X_PIXEL_POS)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_096
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_095:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0102
        CLR        R16
        RJMP       M_VERGL_0103
M_VERGL_0102:
        SER        R16
M_VERGL_0103:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_099
        RJMP       M_IF_0100
M_IF_099:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (X_PIXEL_POS)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0101
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0100:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01E6)
        LDI        R18, LOW(0x01E6)
        LDI        R19, HIGH(0x01E6)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; IF_THEN_ELSE - Ende
M_IF_0101:
 
; IF_THEN_ELSE - Ende
M_IF_096:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R7
        INC        R17
        MOV        R7, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_088
 
; FOR TO DO - Ende
M_FTD_090:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (ICON_ARRAY_TO_VRAM)
        RET
 
; PROCEDURE - Anfang (ZURUECK_ICON)
ZURUECK_ICON:
 
; IF THEN - Ausdruck /; BitHigh(VS1_GS2)
        IN         R16, PORTD
        BST        R16, 5
        BRTS       M_VERGL_0107
        CLR        R16
        RJMP       M_VERGL_0108
M_VERGL_0107:
        SER        R16
M_VERGL_0108:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0104
        RJMP       M_IF_0105
M_IF_0104:
 
; Zuweisung Quelle - Ausdruck / ArrayToAdress(EBENE1_ARRAY)
        LDI        R16, LOW(EBENE1_ARRAY)
        LDI        R17, HIGH(EBENE1_ARRAY)
 
; Zuweisung Ziel /  VAR (ICON_ADRESS)
        STS        ICON_ADRESS, R16
        STS        ICON_ADRESS+1, R17
 
; Word-Parameter(1) fuer PROCEDURE (ICON_ARRAY_TO_VRAM)
        LDS        R0, E1_X_PIX_POS
        LDS        R1, E1_X_PIX_POS+1
 
; Word-Parameter(2) fuer PROCEDURE (ICON_ARRAY_TO_VRAM)
        LDS        R2, E1_Y_PIX_POS
        LDS        R3, E1_Y_PIX_POS+1
 
; Aufruf PROCEDURE (ICON_ARRAY_TO_VRAM)
        CALL       ICON_ARRAY_TO_VRAM
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0106
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0105:
 
; Zuweisung Quelle - Ausdruck / ArrayToAdress(EBENE2_ARRAY)
        LDI        R16, LOW(EBENE2_ARRAY)
        LDI        R17, HIGH(EBENE2_ARRAY)
 
; Zuweisung Ziel /  VAR (ICON_ADRESS)
        STS        ICON_ADRESS, R16
        STS        ICON_ADRESS+1, R17
 
; Word-Parameter(1) fuer PROCEDURE (ICON_ARRAY_TO_VRAM)
        LDS        R0, E2_X_PIX_POS
        LDS        R1, E2_X_PIX_POS+1
 
; Word-Parameter(2) fuer PROCEDURE (ICON_ARRAY_TO_VRAM)
        LDS        R2, E2_Y_PIX_POS
        LDS        R3, E2_Y_PIX_POS+1
 
; Aufruf PROCEDURE (ICON_ARRAY_TO_VRAM)
        CALL       ICON_ARRAY_TO_VRAM
 
; IF_THEN_ELSE - Ende
M_IF_0106:
 
; PROCEDURE - Ende (ZURUECK_ICON)
        RET
 
; PROCEDURE - Anfang (KOPIERE_KREIS)
KOPIERE_KREIS:
 
; Zuweisung Quelle - Ausdruck / ArrayToAdress(KREIS2A)
        LDI        R16, LOW(2*KREIS2A)
        LDI        R17, HIGH(2*KREIS2A)
 
; Zuweisung Ziel /  VAR (BILD_ADRESSE)
        STS        BILD_ADRESSE, R16
        STS        BILD_ADRESSE+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (KOPIERE_KREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (RETTE_ICON)
        CALL       RETTE_ICON
 
; Retten der Parameter-Register fuer PROCEDURE (KOPIERE_KREIS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (KOPIERE_KREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Retten der Parameter-Register fuer PROCEDURE (KOPIERE_KREIS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (KOPIERE_KREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (RETTE_ICON)
        CALL       RETTE_ICON
 
; Retten der Parameter-Register fuer PROCEDURE (KOPIERE_KREIS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (KOPIERE_KREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Retten der Parameter-Register fuer PROCEDURE (KOPIERE_KREIS)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0014)
        LDI        R16, LOW(0x0014)
        LDI        R17, HIGH(0x0014)
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x000A)
        LDI        R16, LOW(0x000A)
        LDI        R17, HIGH(0x000A)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (K_ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x00FA)
        LDI        R16, LOW(0x00FA)
        LDI        R17, HIGH(0x00FA)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0109:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0110
        RJMP       M_FTD_0111
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0110:
 
; Retten der lokalen Parameter fuer PROCEDURE (KOPIERE_KREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ZURUECK_ICON)
        CALL       ZURUECK_ICON
 
; Retten der Parameter-Register fuer PROCEDURE (KOPIERE_KREIS)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (K_ZAEHLER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (KOPIERE_KREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (RETTE_ICON)
        CALL       RETTE_ICON
 
; Retten der Parameter-Register fuer PROCEDURE (KOPIERE_KREIS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (KOPIERE_KREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (SCHREIBE_BILD)
        CALL       SCHREIBE_BILD
 
; Retten der Parameter-Register fuer PROCEDURE (KOPIERE_KREIS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (KOPIERE_KREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Retten der Parameter-Register fuer PROCEDURE (KOPIERE_KREIS)
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0109
 
; FOR TO DO - Ende
M_FTD_0111:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (KOPIERE_KREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ZURUECK_ICON)
        CALL       ZURUECK_ICON
 
; Retten der Parameter-Register fuer PROCEDURE (KOPIERE_KREIS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (KOPIERE_KREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Retten der Parameter-Register fuer PROCEDURE (KOPIERE_KREIS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (KOPIERE_KREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ZURUECK_ICON)
        CALL       ZURUECK_ICON
 
; Retten der Parameter-Register fuer PROCEDURE (KOPIERE_KREIS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (KOPIERE_KREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Retten der Parameter-Register fuer PROCEDURE (KOPIERE_KREIS)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0008)
        LDI        R16, LOW(0x0008)
        LDI        R17, HIGH(0x0008)
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (Y_ANF)
        LDS        R18, Y_ANF
        LDS        R19, Y_ANF+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; PROCEDURE - Ende (KOPIERE_KREIS)
        RET
 
; PROCEDURE - Anfang (KOPIERE_HINTERGRUNDBILD)
KOPIERE_HINTERGRUNDBILD:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (SCHREIBE_BILD)
        CALL       SCHREIBE_BILD
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0080)
        LDI        R16, LOW(0x0080)
        LDI        R17, HIGH(0x0080)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (SCHREIBE_BILD)
        CALL       SCHREIBE_BILD
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0100)
        LDI        R16, LOW(0x0100)
        LDI        R17, HIGH(0x0100)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (SCHREIBE_BILD)
        CALL       SCHREIBE_BILD
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0180)
        LDI        R16, LOW(0x0180)
        LDI        R17, HIGH(0x0180)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (SCHREIBE_BILD)
        CALL       SCHREIBE_BILD
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0112
        RJMP       M_IF_0113
M_IF_0112:
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (SCHREIBE_BILD)
        CALL       SCHREIBE_BILD
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0080)
        LDI        R16, LOW(0x0080)
        LDI        R17, HIGH(0x0080)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (SCHREIBE_BILD)
        CALL       SCHREIBE_BILD
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0100)
        LDI        R16, LOW(0x0100)
        LDI        R17, HIGH(0x0100)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (SCHREIBE_BILD)
        CALL       SCHREIBE_BILD
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0180)
        LDI        R16, LOW(0x0180)
        LDI        R17, HIGH(0x0180)
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (SCHREIBE_BILD)
        CALL       SCHREIBE_BILD
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; IF_THEN - Ende
M_IF_0113:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x000E)
        LDI        R16, LOW(0x000E)
        LDI        R17, HIGH(0x000E)
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (Y_ANF)
        LDS        R18, Y_ANF
        LDS        R19, Y_ANF+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; PROCEDURE - Ende (KOPIERE_HINTERGRUNDBILD)
        RET
 
; PROCEDURE - Anfang (SET_POINT)
SET_POINT:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0118
        CLR        R16
        RJMP       M_VERGL_0119
M_VERGL_0118:
        SER        R16
M_VERGL_0119:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0115
        RJMP       M_IF_0116
M_IF_0115:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0117
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0116:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0117:
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (PIXCOLOR)
        LDS        R16, PIXCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (SET_POINT)
        RET
 
; PROCEDURE - Anfang (GRAFIKDRAWPOINT)
GRAFIKDRAWPOINT:
 
; Aufruf PROCEDURE (SET_POINT)
        CALL       SET_POINT
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0120
        RJMP       M_IF_0121
M_IF_0120:
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Aufruf PROCEDURE (SET_POINT)
        CALL       SET_POINT
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; IF_THEN - Ende
M_IF_0121:
 
; PROCEDURE - Ende (GRAFIKDRAWPOINT)
        RET
 
; PROCEDURE - Anfang (SET_POINT_POS)
SET_POINT_POS:
 
; IF THEN - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_POINT_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0126
        CLR        R16
        RJMP       M_VERGL_0127
M_VERGL_0126:
        SER        R16
M_VERGL_0127:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0123
        RJMP       M_IF_0124
M_IF_0123:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_POINT_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (X_POINT_POS)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0125
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0124:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_POINT_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (X_POINT_POS)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0125:
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (PIXCOLOR)
        LDS        R16, PIXCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R5
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (SET_POINT_POS)
        RET
 
; PROCEDURE - Anfang (LINE_TO)
LINE_TO:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (X_END_POS)
        LDS        R18, X_END_POS
        LDS        R19, X_END_POS+1
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0131
        CLR        R16
        RJMP       M_VERGL_0132
M_VERGL_0131:
        SER        R16
M_VERGL_0132:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0128
        RJMP       M_IF_0129
M_IF_0128:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (DELTA_X)
        STS        DELTA_X, R16
        STS        DELTA_X+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (XP_ANF)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (XP_END)
        MOV        R4, R16
        MOV        R5, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0130
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0129:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_END_POS)
        LDS        R18, X_END_POS
        LDS        R19, X_END_POS+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (DELTA_X)
        STS        DELTA_X, R16
        STS        DELTA_X+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (XP_ANF)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (XP_END)
        MOV        R4, R16
        MOV        R5, R17
 
; IF_THEN_ELSE - Ende
M_IF_0130:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (Y_END_POS)
        LDS        R18, Y_END_POS
        LDS        R19, Y_END_POS+1
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0136
        CLR        R16
        RJMP       M_VERGL_0137
M_VERGL_0136:
        SER        R16
M_VERGL_0137:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0133
        RJMP       M_IF_0134
M_IF_0133:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (Y_PIX_POS)
        LDS        R18, Y_PIX_POS
        LDS        R19, Y_PIX_POS+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (DELTA_Y)
        STS        DELTA_Y, R16
        STS        DELTA_Y+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YP_ANF)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YP_END)
        MOV        R10, R16
        MOV        R11, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0135
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0134:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (Y_END_POS)
        LDS        R18, Y_END_POS
        LDS        R19, Y_END_POS+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (DELTA_Y)
        STS        DELTA_Y, R16
        STS        DELTA_Y+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YP_ANF)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YP_END)
        MOV        R10, R16
        MOV        R11, R17
 
; IF_THEN_ELSE - Ende
M_IF_0135:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (DELTA_X)
        LDS        R16, DELTA_X
        LDS        R17, DELTA_X+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (DELTA_Y)
        LDS        R18, DELTA_Y
        LDS        R19, DELTA_Y+1
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0141
        CLR        R16
        RJMP       M_VERGL_0142
M_VERGL_0141:
        SER        R16
M_VERGL_0142:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0138
        RJMP       M_IF_0139
M_IF_0138:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (DELTA_Y)
        LDS        R16, DELTA_Y
        LDS        R17, DELTA_Y+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0146
        CLR        R16
        RJMP       M_VERGL_0147
M_VERGL_0146:
        SER        R16
M_VERGL_0147:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0143
        RJMP       M_IF_0144
M_IF_0143:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (XP_ANF)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (XP_END)
        MOV        R16, R4
        MOV        R17, R5
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0148:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0149
        RJMP       M_FTD_0150
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0149:
 
; Retten der lokalen Parameter fuer PROCEDURE (LINE_TO)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
        PUSH       R11
 
; Word-Parameter(2) fuer PROCEDURE (SET_POINT_POS)
        LDS        R2, Y_PIX_POS
        LDS        R3, Y_PIX_POS+1
 
; Aufruf PROCEDURE (SET_POINT_POS)
        CALL       SET_POINT_POS
 
; Retten der Parameter-Register fuer PROCEDURE (LINE_TO)
        POP        R11
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0148
 
; FOR TO DO - Ende
M_FTD_0150:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0145
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0144:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (DELTA_Y)
        LDS        R16, DELTA_Y
        LDS        R17, DELTA_Y+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0154
        CLR        R16
        RJMP       M_VERGL_0155
M_VERGL_0154:
        SER        R16
M_VERGL_0155:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0151
        RJMP       M_IF_0152
M_IF_0151:
 
; SHR(DELTA_X) - Word
        LDS        R16, DELTA_X
        LDS        R17, DELTA_X+1
        LSR        R17
        ROR        R16
        STS        DELTA_X, R16
        STS        DELTA_X+1, R17
 
; SHR(DELTA_Y) - Word
        LDS        R16, DELTA_Y
        LDS        R17, DELTA_Y+1
        LSR        R17
        ROR        R16
        STS        DELTA_Y, R16
        STS        DELTA_Y+1, R17
 
; IF_THEN - Ende
M_IF_0152:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (DELTA_X)
        LDS        R16, DELTA_X
        LDS        R17, DELTA_X+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0159
        CLR        R16
        RJMP       M_VERGL_0160
M_VERGL_0159:
        SER        R16
M_VERGL_0160:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0156
        RJMP       M_IF_0157
M_IF_0156:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (XP_ANF)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (XP_END)
        MOV        R16, R4
        MOV        R17, R5
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0161:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0162
        RJMP       M_FTD_0163
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0162:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (X1)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (DELTA_Y)
        LDS        R18, DELTA_Y
        LDS        R19, DELTA_Y+1
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (Y1)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (DELTA_X)
        LDS        R18, DELTA_X
        LDS        R19, DELTA_X+1
 
; Operator DIV
        CALL       ASM_UP_MDIV16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_ANF)
        LDS        R16, Y_ANF
        LDS        R17, Y_ANF+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (Y1)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R6, R16
        MOV        R7, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (LINE_TO)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
        PUSH       R11
 
; Parameter (Y1) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (Y1) an Prozedur (SET_POINT_POS)
        MOV        R2, R22
        MOV        R3, R23
 
; Aufruf PROCEDURE (SET_POINT_POS)
        CALL       SET_POINT_POS
 
; Retten der Parameter-Register fuer PROCEDURE (LINE_TO)
        POP        R11
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0161
 
; FOR TO DO - Ende
M_FTD_0163:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN - Ende
M_IF_0157:
 
; IF_THEN_ELSE - Ende
M_IF_0145:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0140
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0139:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (DELTA_X)
        LDS        R16, DELTA_X
        LDS        R17, DELTA_X+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0167
        CLR        R16
        RJMP       M_VERGL_0168
M_VERGL_0167:
        SER        R16
M_VERGL_0168:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0164
        RJMP       M_IF_0165
M_IF_0164:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (YP_ANF)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (YP_END)
        MOV        R16, R10
        MOV        R17, R11
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0169:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0170
        RJMP       M_FTD_0171
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0170:
 
; Retten der lokalen Parameter fuer PROCEDURE (LINE_TO)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
        PUSH       R11
 
; Parameter (Y1) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (Y1) an Prozedur (SET_POINT_POS)
        MOV        R2, R22
        MOV        R3, R23
 
; Word-Parameter(1) fuer PROCEDURE (SET_POINT_POS)
        LDS        R0, X_PIX_POS
        LDS        R1, X_PIX_POS+1
 
; Aufruf PROCEDURE (SET_POINT_POS)
        CALL       SET_POINT_POS
 
; Retten der Parameter-Register fuer PROCEDURE (LINE_TO)
        POP        R11
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0169
 
; FOR TO DO - Ende
M_FTD_0171:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0166
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0165:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (DELTA_X)
        LDS        R16, DELTA_X
        LDS        R17, DELTA_X+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0175
        CLR        R16
        RJMP       M_VERGL_0176
M_VERGL_0175:
        SER        R16
M_VERGL_0176:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0172
        RJMP       M_IF_0173
M_IF_0172:
 
; SHR(DELTA_X) - Word
        LDS        R16, DELTA_X
        LDS        R17, DELTA_X+1
        LSR        R17
        ROR        R16
        STS        DELTA_X, R16
        STS        DELTA_X+1, R17
 
; SHR(DELTA_Y) - Word
        LDS        R16, DELTA_Y
        LDS        R17, DELTA_Y+1
        LSR        R17
        ROR        R16
        STS        DELTA_Y, R16
        STS        DELTA_Y+1, R17
 
; IF_THEN - Ende
M_IF_0173:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (DELTA_Y)
        LDS        R16, DELTA_Y
        LDS        R17, DELTA_Y+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0180
        CLR        R16
        RJMP       M_VERGL_0181
M_VERGL_0180:
        SER        R16
M_VERGL_0181:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0177
        RJMP       M_IF_0178
M_IF_0177:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (YP_ANF)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (YP_END)
        MOV        R16, R10
        MOV        R17, R11
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0182:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0183
        RJMP       M_FTD_0184
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0183:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (Y1)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (DELTA_X)
        LDS        R18, DELTA_X
        LDS        R19, DELTA_X+1
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (X1)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (DELTA_Y)
        LDS        R18, DELTA_Y
        LDS        R19, DELTA_Y+1
 
; Operator DIV
        CALL       ASM_UP_MDIV16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (X1)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R0, R16
        MOV        R1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (LINE_TO)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
        PUSH       R11
 
; Parameter (Y1) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (Y1) an Prozedur (SET_POINT_POS)
        MOV        R2, R22
        MOV        R3, R23
 
; Aufruf PROCEDURE (SET_POINT_POS)
        CALL       SET_POINT_POS
 
; Retten der Parameter-Register fuer PROCEDURE (LINE_TO)
        POP        R11
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0182
 
; FOR TO DO - Ende
M_FTD_0184:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN - Ende
M_IF_0178:
 
; IF_THEN_ELSE - Ende
M_IF_0166:
 
; IF_THEN_ELSE - Ende
M_IF_0140:
 
; PROCEDURE - Ende (LINE_TO)
        RET
 
; PROCEDURE - Anfang (GRAFIKDRAWLINE)
GRAFIKDRAWLINE:
 
; Aufruf PROCEDURE (LINE_TO)
        CALL       LINE_TO
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0185
        RJMP       M_IF_0186
M_IF_0185:
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Aufruf PROCEDURE (LINE_TO)
        CALL       LINE_TO
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; IF_THEN - Ende
M_IF_0186:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; PROCEDURE - Ende (GRAFIKDRAWLINE)
        RET
 
; PROCEDURE - Anfang (DRAW_REC)
DRAW_REC:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0191
        CLR        R16
        RJMP       M_VERGL_0192
M_VERGL_0191:
        SER        R16
M_VERGL_0192:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0188
        RJMP       M_IF_0189
M_IF_0188:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YR_POS)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (YR_POS)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0190
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0189:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YR_POS)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0190:
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (PIXCOLOR)
        LDS        R16, PIXCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0193:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0194
        RJMP       M_FTD_0195
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0194:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R0
        MOV        R25, R1
        ADIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0193
 
; FOR TO DO - Ende
M_FTD_0195:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; DEC(ADRESSE) - Word
        MOV        R24, R0
        MOV        R25, R1
        SBIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0196:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0197
        RJMP       M_FTD_0198
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0197:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; INC(YR_POS) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (YR_POS)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0202
        CLR        R16
        RJMP       M_VERGL_0203
M_VERGL_0202:
        SER        R16
M_VERGL_0203:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0199
        RJMP       M_IF_0200
M_IF_0199:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YR_POS)
        MOV        R4, R16
        MOV        R5, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; IF_THEN - Ende
M_IF_0200:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0196
 
; FOR TO DO - Ende
M_FTD_0198:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0207
        CLR        R16
        RJMP       M_VERGL_0208
M_VERGL_0207:
        SER        R16
M_VERGL_0208:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0204
        RJMP       M_IF_0205
M_IF_0204:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YR_POS)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (YR_POS)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0206
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0205:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YR_POS)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0206:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0209:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0210
        RJMP       M_FTD_0211
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0210:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; INC(YR_POS) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (YR_POS)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0215
        CLR        R16
        RJMP       M_VERGL_0216
M_VERGL_0215:
        SER        R16
M_VERGL_0216:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0212
        RJMP       M_IF_0213
M_IF_0212:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (YR_POS)
        MOV        R4, R16
        MOV        R5, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; IF_THEN - Ende
M_IF_0213:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0209
 
; FOR TO DO - Ende
M_FTD_0211:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0217:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0218
        RJMP       M_FTD_0219
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0218:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R0
        MOV        R25, R1
        ADIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0217
 
; FOR TO DO - Ende
M_FTD_0219:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (DRAW_REC)
        RET
 
; PROCEDURE - Anfang (GRAFIKDRAWRECTANGLE)
GRAFIKDRAWRECTANGLE:
 
; Aufruf PROCEDURE (DRAW_REC)
        CALL       DRAW_REC
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0220
        RJMP       M_IF_0221
M_IF_0220:
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Aufruf PROCEDURE (DRAW_REC)
        CALL       DRAW_REC
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; IF_THEN - Ende
M_IF_0221:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; PROCEDURE - Ende (GRAFIKDRAWRECTANGLE)
        RET
 
; PROCEDURE - Anfang (DRAW_FULL_REC)
DRAW_FULL_REC:
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (PIXCOLOR)
        LDS        R16, PIXCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0223:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0224
        RJMP       M_FTD_0225
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0224:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W2)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0229
        CLR        R16
        RJMP       M_VERGL_0230
M_VERGL_0229:
        SER        R16
M_VERGL_0230:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0226
        RJMP       M_IF_0227
M_IF_0226:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0228
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0227:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0228:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0231:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0232
        RJMP       M_FTD_0233
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0232:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R0
        MOV        R25, R1
        ADIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0231
 
; FOR TO DO - Ende
M_FTD_0233:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0223
 
; FOR TO DO - Ende
M_FTD_0225:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (DRAW_FULL_REC)
        RET
 
; PROCEDURE - Anfang (GRAFIKDRAWFULLRECTANGLE)
GRAFIKDRAWFULLRECTANGLE:
 
; Aufruf PROCEDURE (DRAW_FULL_REC)
        CALL       DRAW_FULL_REC
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0234
        RJMP       M_IF_0235
M_IF_0234:
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Aufruf PROCEDURE (DRAW_FULL_REC)
        CALL       DRAW_FULL_REC
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; IF_THEN - Ende
M_IF_0235:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_END_POS)
        LDS        R16, Y_END_POS
        LDS        R17, Y_END_POS+1
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; PROCEDURE - Ende (GRAFIKDRAWFULLRECTANGLE)
        RET
 
; FUNCTION - Anfang (SINUS)
SINUS:
 
; ARRAY - Ausdruck / lokaler Uebergabeparameter (WINKEL)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (SINTAB)
        LDI        ZL, LOW(2*SINTAB)
        LDI        ZH, HIGH(2*SINTAB)
        LSL        R16
        ROL        R17
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z+
        LPM        R17, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck / WordToDW(W1)
        MOV        R16, R6
        MOV        R17, R7
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (SIN_DW1)
        STS        SIN_DW1, R16
        STS        SIN_DW1+1, R17
        STS        SIN_DW1+2, R18
        STS        SIN_DW1+3, R19
 
; Zuweisung Quelle - Ausdruck / WordToDW(RADIUS)
        MOV        R16, R2
        MOV        R17, R3
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  VAR (SIN_DW2)
        STS        SIN_DW2, R16
        STS        SIN_DW2+1, R17
        STS        SIN_DW2+2, R18
        STS        SIN_DW2+3, R19
 
; Zuweisung Quelle - Ausdruck erster Faktor / DWord-VAR (SIN_DW1)
        LDS        R16, SIN_DW1
        LDS        R17, SIN_DW1+1
        LDS        R18, SIN_DW1+2
        LDS        R19, SIN_DW1+3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / DWord-VAR (SIN_DW2)
        LDS        R20, SIN_DW2
        LDS        R21, SIN_DW2+1
        LDS        R22, SIN_DW2+2
        LDS        R23, SIN_DW2+3
 
; Operator *
        CALL       ASM_UP_MUL32
 
; Zuweisung Ziel /  VAR (SIN_DW1)
        STS        SIN_DW1, R16
        STS        SIN_DW1+1, R17
        STS        SIN_DW1+2, R18
        STS        SIN_DW1+3, R19
 
; Zuweisung Quelle - Ausdruck erster Faktor / DWord-VAR (SIN_DW1)
        LDS        R16, SIN_DW1
        LDS        R17, SIN_DW1+1
        LDS        R18, SIN_DW1+2
        LDS        R19, SIN_DW1+3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0000FFFF)
        LDI        R20, 0xFF
        LDI        R21, 0xFF
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator DIV
        CALL       ASM_UP_MDIV32
 
; Zuweisung Ziel /  VAR (SIN_DW1)
        STS        SIN_DW1, R16
        STS        SIN_DW1+1, R17
        STS        SIN_DW1+2, R18
        STS        SIN_DW1+3, R19
 
; Zuweisung Quelle - Ausdruck / DWLow(SIN_DW1)
        LDS        R16, SIN_DW1
        LDS        R17, SIN_DW1+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R6, R16
        MOV        R7, R17
 
; RESULT Word-Variable - FUNCTION (SINUS)
        MOV        R4, R6
        MOV        R5, R7
 
; Ende Word - FUNCTION (SINUS)
        MOV        R16, R4
        MOV        R17, R5
 
; FUNCTION - Ende (SINUS)
        RET
 
; PROCEDURE - Anfang (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
GRAFIKZEICHNEKREIS_ON_RAMPAGE:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (RADIUS)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0022)
        LDI        R18, LOW(0x0022)
        LDI        R19, HIGH(0x0022)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_RADIUS)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (X_RADIUS)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0015)
        LDI        R18, LOW(0x0015)
        LDI        R19, HIGH(0x0015)
 
; Operator DIV
        CALL       ASM_UP_MDIV16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_RADIUS)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WINKEL)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x00C7)
        LDI        R16, LOW(0x00C7)
        LDI        R17, HIGH(0x00C7)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0237:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0238
        RJMP       M_FTD_0239
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0238:
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (WINKEL) retten
        MOV        R22, R6
        MOV        R23, R7
 
; Parameter (X_RADIUS) retten
        MOV        R24, R8
        MOV        R25, R9
 
; lokalen Parameter (WINKEL) an Funktion (SINUS)
        MOV        R0, R22
        MOV        R1, R23
 
; lokalen Parameter (X_RADIUS) an Funktion (SINUS)
        MOV        R2, R24
        MOV        R3, R25
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Zahlenwert (0x00C8)
        LDI        R16, LOW(0x00C8)
        LDI        R17, HIGH(0x00C8)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (WINKEL)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (RADIUS) retten
        MOV        R16, R0
        MOV        R17, R1
 
; Parameter (Y1) retten
        MOV        R20, R4
        MOV        R21, R5
 
; lokalen Parameter (RADIUS) an Funktion (SINUS)
        MOV        R2, R16
        MOV        R3, R17
 
; lokalen Parameter (Y1) an Funktion (SINUS)
        MOV        R0, R20
        MOV        R1, R21
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (X1)
        MOV        R18, R2
        MOV        R19, R3
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (Y1)
        MOV        R18, R4
        MOV        R19, R5
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (X1) retten
        MOV        R18, R2
        MOV        R19, R3
 
; Parameter (Y1) retten
        MOV        R20, R4
        MOV        R21, R5
 
; lokalen Parameter (X1) an Prozedur (SET_POINT_POS)
        MOV        R0, R18
        MOV        R1, R19
 
; lokalen Parameter (Y1) an Prozedur (SET_POINT_POS)
        MOV        R2, R20
        MOV        R3, R21
 
; Aufruf PROCEDURE (SET_POINT_POS)
        CALL       SET_POINT_POS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0237
 
; FOR TO DO - Ende
M_FTD_0239:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WINKEL)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x00C7)
        LDI        R16, LOW(0x00C7)
        LDI        R17, HIGH(0x00C7)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0240:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0241
        RJMP       M_FTD_0242
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0241:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Zahlenwert (0x00C8)
        LDI        R16, LOW(0x00C8)
        LDI        R17, HIGH(0x00C8)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (WINKEL)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (X1) retten
        MOV        R18, R2
        MOV        R19, R3
 
; Parameter (X_RADIUS) retten
        MOV        R24, R8
        MOV        R25, R9
 
; lokalen Parameter (X1) an Funktion (SINUS)
        MOV        R0, R18
        MOV        R1, R19
 
; lokalen Parameter (X_RADIUS) an Funktion (SINUS)
        MOV        R2, R24
        MOV        R3, R25
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (RADIUS) retten
        MOV        R16, R0
        MOV        R17, R1
 
; Parameter (WINKEL) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (RADIUS) an Funktion (SINUS)
        MOV        R2, R16
        MOV        R3, R17
 
; lokalen Parameter (WINKEL) an Funktion (SINUS)
        MOV        R0, R22
        MOV        R1, R23
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (X1)
        MOV        R18, R2
        MOV        R19, R3
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (Y1)
        MOV        R18, R4
        MOV        R19, R5
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (X1) retten
        MOV        R18, R2
        MOV        R19, R3
 
; Parameter (Y1) retten
        MOV        R20, R4
        MOV        R21, R5
 
; lokalen Parameter (X1) an Prozedur (SET_POINT_POS)
        MOV        R0, R18
        MOV        R1, R19
 
; lokalen Parameter (Y1) an Prozedur (SET_POINT_POS)
        MOV        R2, R20
        MOV        R3, R21
 
; Aufruf PROCEDURE (SET_POINT_POS)
        CALL       SET_POINT_POS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0240
 
; FOR TO DO - Ende
M_FTD_0242:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WINKEL)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x00C7)
        LDI        R16, LOW(0x00C7)
        LDI        R17, HIGH(0x00C7)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0243:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0244
        RJMP       M_FTD_0245
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0244:
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (WINKEL) retten
        MOV        R22, R6
        MOV        R23, R7
 
; Parameter (X_RADIUS) retten
        MOV        R24, R8
        MOV        R25, R9
 
; lokalen Parameter (WINKEL) an Funktion (SINUS)
        MOV        R0, R22
        MOV        R1, R23
 
; lokalen Parameter (X_RADIUS) an Funktion (SINUS)
        MOV        R2, R24
        MOV        R3, R25
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Zahlenwert (0x00C8)
        LDI        R16, LOW(0x00C8)
        LDI        R17, HIGH(0x00C8)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (WINKEL)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (RADIUS) retten
        MOV        R16, R0
        MOV        R17, R1
 
; Parameter (Y1) retten
        MOV        R20, R4
        MOV        R21, R5
 
; lokalen Parameter (RADIUS) an Funktion (SINUS)
        MOV        R2, R16
        MOV        R3, R17
 
; lokalen Parameter (Y1) an Funktion (SINUS)
        MOV        R0, R20
        MOV        R1, R21
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (X1)
        MOV        R18, R2
        MOV        R19, R3
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (Y1)
        MOV        R18, R4
        MOV        R19, R5
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (X1) retten
        MOV        R18, R2
        MOV        R19, R3
 
; Parameter (Y1) retten
        MOV        R20, R4
        MOV        R21, R5
 
; lokalen Parameter (X1) an Prozedur (SET_POINT_POS)
        MOV        R0, R18
        MOV        R1, R19
 
; lokalen Parameter (Y1) an Prozedur (SET_POINT_POS)
        MOV        R2, R20
        MOV        R3, R21
 
; Aufruf PROCEDURE (SET_POINT_POS)
        CALL       SET_POINT_POS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0243
 
; FOR TO DO - Ende
M_FTD_0245:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WINKEL)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x00C7)
        LDI        R16, LOW(0x00C7)
        LDI        R17, HIGH(0x00C7)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0246:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0247
        RJMP       M_FTD_0248
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0247:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Zahlenwert (0x00C8)
        LDI        R16, LOW(0x00C8)
        LDI        R17, HIGH(0x00C8)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (WINKEL)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (X1) retten
        MOV        R18, R2
        MOV        R19, R3
 
; Parameter (X_RADIUS) retten
        MOV        R24, R8
        MOV        R25, R9
 
; lokalen Parameter (X1) an Funktion (SINUS)
        MOV        R0, R18
        MOV        R1, R19
 
; lokalen Parameter (X_RADIUS) an Funktion (SINUS)
        MOV        R2, R24
        MOV        R3, R25
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (RADIUS) retten
        MOV        R16, R0
        MOV        R17, R1
 
; Parameter (WINKEL) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (RADIUS) an Funktion (SINUS)
        MOV        R2, R16
        MOV        R3, R17
 
; lokalen Parameter (WINKEL) an Funktion (SINUS)
        MOV        R0, R22
        MOV        R1, R23
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (X1)
        MOV        R18, R2
        MOV        R19, R3
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (Y1)
        MOV        R18, R4
        MOV        R19, R5
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R4, R16
        MOV        R5, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (X1) retten
        MOV        R18, R2
        MOV        R19, R3
 
; Parameter (Y1) retten
        MOV        R20, R4
        MOV        R21, R5
 
; lokalen Parameter (X1) an Prozedur (SET_POINT_POS)
        MOV        R0, R18
        MOV        R1, R19
 
; lokalen Parameter (Y1) an Prozedur (SET_POINT_POS)
        MOV        R2, R20
        MOV        R3, R21
 
; Aufruf PROCEDURE (SET_POINT_POS)
        CALL       SET_POINT_POS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0246
 
; FOR TO DO - Ende
M_FTD_0248:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        RET
 
; PROCEDURE - Anfang (GRAFIKZEICHNEKREIS)
GRAFIKZEICHNEKREIS:
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        CALL       GRAFIKZEICHNEKREIS_ON_RAMPAGE
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS)
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0249
        RJMP       M_IF_0250
M_IF_0249:
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (GRAFIKZEICHNEKREIS_ON_RAMPAGE)
        CALL       GRAFIKZEICHNEKREIS_ON_RAMPAGE
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEKREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEKREIS)
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0250:
 
; PROCEDURE - Ende (GRAFIKZEICHNEKREIS)
        RET
 
; PROCEDURE - Anfang (ZEICHNE_WAAGERECHTEN_STRICH)
ZEICHNE_WAAGERECHTEN_STRICH:
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (PIXCOLOR)
        LDS        R16, PIXCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x007F)
        LDI        R18, LOW(0x007F)
        LDI        R19, HIGH(0x007F)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0255
        CLR        R16
        RJMP       M_VERGL_0256
M_VERGL_0255:
        SER        R16
M_VERGL_0256:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0252
        RJMP       M_IF_0253
M_IF_0252:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0254
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0253:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0254:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (X_END_POS)
        LDS        R16, X_END_POS
        LDS        R17, X_END_POS+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0257:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0258
        RJMP       M_FTD_0259
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0258:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R0
        MOV        R25, R1
        ADIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0257
 
; FOR TO DO - Ende
M_FTD_0259:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (ZEICHNE_WAAGERECHTEN_STRICH)
        RET
 
; PROCEDURE - Anfang (GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE)
GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (RADIUS)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0022)
        LDI        R18, LOW(0x0022)
        LDI        R19, HIGH(0x0022)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_RADIUS)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (X_RADIUS)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0015)
        LDI        R18, LOW(0x0015)
        LDI        R19, HIGH(0x0015)
 
; Operator DIV
        CALL       ASM_UP_MDIV16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_RADIUS)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_PIX_POS2)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WINKEL)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x00C7)
        LDI        R16, LOW(0x00C7)
        LDI        R17, HIGH(0x00C7)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0260:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0261
        RJMP       M_FTD_0262
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0261:
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (WINKEL) retten
        MOV        R22, R6
        MOV        R23, R7
 
; Parameter (X_RADIUS) retten
        MOV        R24, R8
        MOV        R25, R9
 
; lokalen Parameter (WINKEL) an Funktion (SINUS)
        MOV        R0, R22
        MOV        R1, R23
 
; lokalen Parameter (X_RADIUS) an Funktion (SINUS)
        MOV        R2, R24
        MOV        R3, R25
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_END_POS)
        STS        X_END_POS, R16
        STS        X_END_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Zahlenwert (0x00C8)
        LDI        R16, LOW(0x00C8)
        LDI        R17, HIGH(0x00C8)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (WINKEL)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (RADIUS) retten
        MOV        R16, R0
        MOV        R17, R1
 
; lokalen Parameter (RADIUS) an Funktion (SINUS)
        MOV        R2, R16
        MOV        R3, R17
 
; Word-Parameter(1) fuer FUNCTION (SINUS)
        LDS        R0, Y_PIX_POS
        LDS        R1, Y_PIX_POS+1
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (Y_PIX_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (Y_PIX_POS)
        LDS        R18, Y_PIX_POS
        LDS        R19, Y_PIX_POS+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Aufruf PROCEDURE (ZEICHNE_WAAGERECHTEN_STRICH)
        CALL       ZEICHNE_WAAGERECHTEN_STRICH
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0260
 
; FOR TO DO - Ende
M_FTD_0262:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WINKEL)
        MOV        R6, R16
        MOV        R7, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x00C7)
        LDI        R16, LOW(0x00C7)
        LDI        R17, HIGH(0x00C7)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R6
        MOV        R19, R7
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0263:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0264
        RJMP       M_FTD_0265
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0264:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Zahlenwert (0x00C8)
        LDI        R16, LOW(0x00C8)
        LDI        R17, HIGH(0x00C8)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (WINKEL)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (X_RADIUS) retten
        MOV        R24, R8
        MOV        R25, R9
 
; lokalen Parameter (X_RADIUS) an Funktion (SINUS)
        MOV        R2, R24
        MOV        R3, R25
 
; Word-Parameter(1) fuer FUNCTION (SINUS)
        LDS        R0, X_PIX_POS
        LDS        R1, X_PIX_POS+1
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_END_POS)
        STS        X_END_POS, R16
        STS        X_END_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (RADIUS) retten
        MOV        R16, R0
        MOV        R17, R1
 
; Parameter (WINKEL) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (RADIUS) an Funktion (SINUS)
        MOV        R2, R16
        MOV        R3, R17
 
; lokalen Parameter (WINKEL) an Funktion (SINUS)
        MOV        R0, R22
        MOV        R1, R23
 
; Aufruf Funktion (SINUS)
        CALL       SINUS
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (Y_PIX_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (Y_PIX_POS)
        LDS        R18, Y_PIX_POS
        LDS        R19, Y_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Aufruf PROCEDURE (ZEICHNE_WAAGERECHTEN_STRICH)
        CALL       ZEICHNE_WAAGERECHTEN_STRICH
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R6
        MOV        R19, R7
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R6, R18
        MOV        R7, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0263
 
; FOR TO DO - Ende
M_FTD_0265:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (Y_PIX_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; PROCEDURE - Ende (GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE)
        RET
 
; PROCEDURE - Anfang (GRAFIKZEICHNEVOLLENKREIS)
GRAFIKZEICHNEVOLLENKREIS:
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE)
        CALL       GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS)
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0266
        RJMP       M_IF_0267
M_IF_0266:
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE)
        CALL       GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Retten der Parameter-Register fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS)
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0267:
 
; PROCEDURE - Ende (GRAFIKZEICHNEVOLLENKREIS)
        RET
 
; PROCEDURE - Anfang (WRITE_CHAR_6X8)
WRITE_CHAR_6X8:
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R16, ZEICHEN
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTPTR)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0020)
        LDI        R18, LOW(0x0020)
        LDI        R19, HIGH(0x0020)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTPTR)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0008)
        LDI        R18, LOW(0x0008)
        LDI        R19, HIGH(0x0008)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTPTR)
        MOV        R0, R16
        MOV        R1, R17
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x000C)
        LDI        R18, LOW(0x000C)
        LDI        R19, HIGH(0x000C)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0272
        CLR        R16
        RJMP       M_VERGL_0273
M_VERGL_0272:
        SER        R16
M_VERGL_0273:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0269
        RJMP       M_IF_0270
M_IF_0269:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R3, R16
        MOV        R4, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0006)
        LDI        R16, LOW(0x0006)
        LDI        R17, HIGH(0x0006)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R3
        MOV        R19, R4
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0274:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0275
        RJMP       M_FTD_0276
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0275:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (FONT6X8)
        LDI        ZL, LOW(2*FONT6X8)
        LDI        ZH, HIGH(2*FONT6X8)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R6, R16
 
; INC(FONTPTR) - Word
        MOV        R24, R0
        MOV        R25, R1
        ADIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; SHR(FONTZEILE) - Byte
        LSR        R6
 
; SHR(FONTZEILE) - Byte
        LSR        R6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0277:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0278
        RJMP       M_FTD_0279
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0278:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R16, R6
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R5, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R16, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0283
        CLR        R16
        RJMP       M_VERGL_0284
M_VERGL_0283:
        SER        R16
M_VERGL_0284:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0280
        RJMP       M_IF_0281
M_IF_0280:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (BCOLOR)
        LDS        R16, BCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0282
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0281:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FCOLOR)
        LDS        R16, FCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Ende
M_IF_0282:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R7
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R8
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; SHR(FONTZEILE) - Byte
        LSR        R6
 
; INC(ADRESSE) - Word
        MOV        R24, R7
        MOV        R25, R8
        ADIW       R25:R24, 1
        MOV        R7, R24
        MOV        R8, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0277
 
; FOR TO DO - Ende
M_FTD_0279:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01FA)
        LDI        R18, LOW(0x01FA)
        LDI        R19, HIGH(0x01FA)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R3
        MOV        R19, R4
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R3, R18
        MOV        R4, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0274
 
; FOR TO DO - Ende
M_FTD_0276:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (FONT6X8)
        LDI        ZL, LOW(2*FONT6X8)
        LDI        ZH, HIGH(2*FONT6X8)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R6, R16
 
; SHR(FONTZEILE) - Byte
        LSR        R6
 
; SHR(FONTZEILE) - Byte
        LSR        R6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0285:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0286
        RJMP       M_FTD_0287
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0286:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R16, R6
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R5, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R16, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0291
        CLR        R16
        RJMP       M_VERGL_0292
M_VERGL_0291:
        SER        R16
M_VERGL_0292:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0288
        RJMP       M_IF_0289
M_IF_0288:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (BCOLOR)
        LDS        R16, BCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0290
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0289:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FCOLOR)
        LDS        R16, FCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Ende
M_IF_0290:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R7
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R8
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; SHR(FONTZEILE) - Byte
        LSR        R6
 
; INC(ADRESSE) - Word
        MOV        R24, R7
        MOV        R25, R8
        ADIW       R25:R24, 1
        MOV        R7, R24
        MOV        R8, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0285
 
; FOR TO DO - Ende
M_FTD_0287:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0271
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0270:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x000C)
        LDI        R18, LOW(0x000C)
        LDI        R19, HIGH(0x000C)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0296
        CLR        R16
        RJMP       M_VERGL_0297
M_VERGL_0296:
        SER        R16
M_VERGL_0297:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0293
        RJMP       M_IF_0294
M_IF_0293:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0295
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0294:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0295:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R3, R16
        MOV        R4, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0007)
        LDI        R16, LOW(0x0007)
        LDI        R17, HIGH(0x0007)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R3
        MOV        R19, R4
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0298:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0299
        RJMP       M_FTD_0300
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0299:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (FONT6X8)
        LDI        ZL, LOW(2*FONT6X8)
        LDI        ZH, HIGH(2*FONT6X8)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R6, R16
 
; INC(FONTPTR) - Word
        MOV        R24, R0
        MOV        R25, R1
        ADIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; SHR(FONTZEILE) - Byte
        LSR        R6
 
; SHR(FONTZEILE) - Byte
        LSR        R6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0301:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0302
        RJMP       M_FTD_0303
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0302:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R16, R6
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R5, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R16, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0307
        CLR        R16
        RJMP       M_VERGL_0308
M_VERGL_0307:
        SER        R16
M_VERGL_0308:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0304
        RJMP       M_IF_0305
M_IF_0304:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (BCOLOR)
        LDS        R16, BCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0306
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0305:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FCOLOR)
        LDS        R16, FCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Ende
M_IF_0306:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R7
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R8
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; SHR(FONTZEILE) - Byte
        LSR        R6
 
; INC(ADRESSE) - Word
        MOV        R24, R7
        MOV        R25, R8
        ADIW       R25:R24, 1
        MOV        R7, R24
        MOV        R8, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0301
 
; FOR TO DO - Ende
M_FTD_0303:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01FA)
        LDI        R18, LOW(0x01FA)
        LDI        R19, HIGH(0x01FA)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R3
        MOV        R19, R4
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R3, R18
        MOV        R4, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0298
 
; FOR TO DO - Ende
M_FTD_0300:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN_ELSE - Ende
M_IF_0271:
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (WRITE_CHAR_6X8)
        RET
 
; PROCEDURE - Anfang (WRITE_CHAR_8X8)
WRITE_CHAR_8X8:
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R16, ZEICHEN
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTPTR)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0020)
        LDI        R18, LOW(0x0020)
        LDI        R19, HIGH(0x0020)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTPTR)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0008)
        LDI        R18, LOW(0x0008)
        LDI        R19, HIGH(0x0008)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTPTR)
        MOV        R0, R16
        MOV        R1, R17
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x000C)
        LDI        R18, LOW(0x000C)
        LDI        R19, HIGH(0x000C)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0312
        CLR        R16
        RJMP       M_VERGL_0313
M_VERGL_0312:
        SER        R16
M_VERGL_0313:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0309
        RJMP       M_IF_0310
M_IF_0309:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R3, R16
        MOV        R4, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0006)
        LDI        R16, LOW(0x0006)
        LDI        R17, HIGH(0x0006)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R3
        MOV        R19, R4
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0314:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0315
        RJMP       M_FTD_0316
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0315:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (FONT8X8)
        LDI        ZL, LOW(2*FONT8X8)
        LDI        ZH, HIGH(2*FONT8X8)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R6, R16
 
; INC(FONTPTR) - Word
        MOV        R24, R0
        MOV        R25, R1
        ADIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0317:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0318
        RJMP       M_FTD_0319
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0318:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R16, R6
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R5, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R16, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0323
        CLR        R16
        RJMP       M_VERGL_0324
M_VERGL_0323:
        SER        R16
M_VERGL_0324:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0320
        RJMP       M_IF_0321
M_IF_0320:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (BCOLOR)
        LDS        R16, BCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0322
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0321:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FCOLOR)
        LDS        R16, FCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Ende
M_IF_0322:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R7
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R8
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; SHR(FONTZEILE) - Byte
        LSR        R6
 
; INC(ADRESSE) - Word
        MOV        R24, R7
        MOV        R25, R8
        ADIW       R25:R24, 1
        MOV        R7, R24
        MOV        R8, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0317
 
; FOR TO DO - Ende
M_FTD_0319:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01F8)
        LDI        R18, LOW(0x01F8)
        LDI        R19, HIGH(0x01F8)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R3
        MOV        R19, R4
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R3, R18
        MOV        R4, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0314
 
; FOR TO DO - Ende
M_FTD_0316:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (FONT8X8)
        LDI        ZL, LOW(2*FONT8X8)
        LDI        ZH, HIGH(2*FONT8X8)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R6, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0325:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0326
        RJMP       M_FTD_0327
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0326:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R16, R6
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R5, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R16, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0331
        CLR        R16
        RJMP       M_VERGL_0332
M_VERGL_0331:
        SER        R16
M_VERGL_0332:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0328
        RJMP       M_IF_0329
M_IF_0328:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (BCOLOR)
        LDS        R16, BCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0330
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0329:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FCOLOR)
        LDS        R16, FCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Ende
M_IF_0330:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R7
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R8
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; SHR(FONTZEILE) - Byte
        LSR        R6
 
; INC(ADRESSE) - Word
        MOV        R24, R7
        MOV        R25, R8
        ADIW       R25:R24, 1
        MOV        R7, R24
        MOV        R8, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0325
 
; FOR TO DO - Ende
M_FTD_0327:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0311
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0310:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x000C)
        LDI        R18, LOW(0x000C)
        LDI        R19, HIGH(0x000C)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0336
        CLR        R16
        RJMP       M_VERGL_0337
M_VERGL_0336:
        SER        R16
M_VERGL_0337:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0333
        RJMP       M_IF_0334
M_IF_0333:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0335
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0334:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0335:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R3, R16
        MOV        R4, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0007)
        LDI        R16, LOW(0x0007)
        LDI        R17, HIGH(0x0007)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R3
        MOV        R19, R4
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0338:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0339
        RJMP       M_FTD_0340
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0339:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (FONT8X8)
        LDI        ZL, LOW(2*FONT8X8)
        LDI        ZH, HIGH(2*FONT8X8)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R6, R16
 
; INC(FONTPTR) - Word
        MOV        R24, R0
        MOV        R25, R1
        ADIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0341:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0342
        RJMP       M_FTD_0343
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0342:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R16, R6
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R5, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R16, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0347
        CLR        R16
        RJMP       M_VERGL_0348
M_VERGL_0347:
        SER        R16
M_VERGL_0348:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0344
        RJMP       M_IF_0345
M_IF_0344:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (BCOLOR)
        LDS        R16, BCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0346
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0345:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FCOLOR)
        LDS        R16, FCOLOR
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; IF_THEN_ELSE - Ende
M_IF_0346:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R7
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R8
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; SHR(FONTZEILE) - Byte
        LSR        R6
 
; INC(ADRESSE) - Word
        MOV        R24, R7
        MOV        R25, R8
        ADIW       R25:R24, 1
        MOV        R7, R24
        MOV        R8, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0341
 
; FOR TO DO - Ende
M_FTD_0343:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01F8)
        LDI        R18, LOW(0x01F8)
        LDI        R19, HIGH(0x01F8)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R7, R16
        MOV        R8, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R3
        MOV        R19, R4
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R3, R18
        MOV        R4, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0338
 
; FOR TO DO - Ende
M_FTD_0340:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN_ELSE - Ende
M_IF_0311:
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (WRITE_CHAR_8X8)
        RET
 
; PROCEDURE - Anfang (WRITE_CHAR)
WRITE_CHAR:
 
; CASE OF - Byte-VAR (FONT_BEZ)
        LDS        R16, FONT_BEZ
 
; CASE OF - vergleiche Einzel-Element (FNT_6X8)
        CPI        R16, 0x01
        BREQ       M_CASE_0351
        RJMP       M_CASE_0350
M_CASE_0351:
 
; Aufruf PROCEDURE (WRITE_CHAR_6X8)
        CALL       WRITE_CHAR_6X8
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0349
M_CASE_0350:
 
; CASE OF - vergleiche Einzel-Element (FNT_8X8)
        CPI        R16, 0x02
        BREQ       M_CASE_0353
        RJMP       M_CASE_0352
M_CASE_0353:
 
; Aufruf PROCEDURE (WRITE_CHAR_8X8)
        CALL       WRITE_CHAR_8X8
 
; ENDCASE;
M_CASE_0352:
M_CASE_0349:
 
; PROCEDURE - Ende (WRITE_CHAR)
        RET
 
; PROCEDURE - Anfang (VRAM_TO_KURSOR_ARRAY)
VRAM_TO_KURSOR_ARRAY:
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x000C)
        LDI        R18, LOW(0x000C)
        LDI        R19, HIGH(0x000C)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0357
        CLR        R16
        RJMP       M_VERGL_0358
M_VERGL_0357:
        SER        R16
M_VERGL_0358:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0354
        RJMP       M_IF_0355
M_IF_0354:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R3, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x06)
        LDI        R16, 0x06
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R3
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0359:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0360
        RJMP       M_FTD_0361
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0360:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0362:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0363
        RJMP       M_FTD_0364
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0363:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(OE)
        CBI        PORTD, 4
 
; INC(ADRESSE) - Word
        MOV        R24, R0
        MOV        R25, R1
        ADIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R16, R4
        MOV        R17, R5
 
; VAR ARRAY Ziel Zeiger berechnen (KURSOR_ARRAY)
        LDI        ZL, LOW(KURSOR_ARRAY)
        LDI        ZH, HIGH(KURSOR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINA
        IN         R16, PINA
 
; Zuweisung Ziel /  VAR ARRAY (KURSOR_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(ARRAY_POS) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; SetBit(OE)
        SBI        PORTD, 4
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0362
 
; FOR TO DO - Ende
M_FTD_0364:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R3
        INC        R17
        MOV        R3, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0359
 
; FOR TO DO - Ende
M_FTD_0361:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0365:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0366
        RJMP       M_FTD_0367
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0366:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(OE)
        CBI        PORTD, 4
 
; INC(ADRESSE) - Word
        MOV        R24, R0
        MOV        R25, R1
        ADIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R16, R4
        MOV        R17, R5
 
; VAR ARRAY Ziel Zeiger berechnen (KURSOR_ARRAY)
        LDI        ZL, LOW(KURSOR_ARRAY)
        LDI        ZH, HIGH(KURSOR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINA
        IN         R16, PINA
 
; Zuweisung Ziel /  VAR ARRAY (KURSOR_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(ARRAY_POS) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; SetBit(OE)
        SBI        PORTD, 4
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0365
 
; FOR TO DO - Ende
M_FTD_0367:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0356
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0355:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x000C)
        LDI        R18, LOW(0x000C)
        LDI        R19, HIGH(0x000C)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0371
        CLR        R16
        RJMP       M_VERGL_0372
M_VERGL_0371:
        SER        R16
M_VERGL_0372:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0368
        RJMP       M_IF_0369
M_IF_0368:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0370
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0369:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0370:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R3, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R3
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0373:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0374
        RJMP       M_FTD_0375
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0374:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0376:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0377
        RJMP       M_FTD_0378
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0377:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; NOP
        NOP
 
; NOP
        NOP
 
; ClearBit(OE)
        CBI        PORTD, 4
 
; INC(ADRESSE) - Word
        MOV        R24, R0
        MOV        R25, R1
        ADIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R16, R4
        MOV        R17, R5
 
; VAR ARRAY Ziel Zeiger berechnen (KURSOR_ARRAY)
        LDI        ZL, LOW(KURSOR_ARRAY)
        LDI        ZH, HIGH(KURSOR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINA
        IN         R16, PINA
 
; Zuweisung Ziel /  VAR ARRAY (KURSOR_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(ARRAY_POS) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; SetBit(OE)
        SBI        PORTD, 4
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0376
 
; FOR TO DO - Ende
M_FTD_0378:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R3
        INC        R17
        MOV        R3, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0373
 
; FOR TO DO - Ende
M_FTD_0375:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; IF_THEN_ELSE - Ende
M_IF_0356:
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (KURARR_AKTUELL)
        STS        KURARR_AKTUELL, R16
 
; PROCEDURE - Ende (VRAM_TO_KURSOR_ARRAY)
        RET
 
; PROCEDURE - Anfang (KURSOR_ARRAY_TO_VRAM)
KURSOR_ARRAY_TO_VRAM:
 
; IF THEN - Ausdruck / Byte-VAR (KURARR_AKTUELL)
        LDS        R16, KURARR_AKTUELL
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0379
        RJMP       M_IF_0380
M_IF_0379:
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x000C)
        LDI        R18, LOW(0x000C)
        LDI        R19, HIGH(0x000C)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0385
        CLR        R16
        RJMP       M_VERGL_0386
M_VERGL_0385:
        SER        R16
M_VERGL_0386:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0382
        RJMP       M_IF_0383
M_IF_0382:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R3, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x06)
        LDI        R16, 0x06
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R3
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0387:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0388
        RJMP       M_FTD_0389
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0388:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0390:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0391
        RJMP       M_FTD_0392
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0391:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (KURSOR_ARRAY)
        LDI        ZL, LOW(KURSOR_ARRAY)
        LDI        ZH, HIGH(KURSOR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R0
        MOV        R25, R1
        ADIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; INC(ARRAY_POS) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0390
 
; FOR TO DO - Ende
M_FTD_0392:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R3
        INC        R17
        MOV        R3, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0387
 
; FOR TO DO - Ende
M_FTD_0389:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0393:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0394
        RJMP       M_FTD_0395
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0394:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (KURSOR_ARRAY)
        LDI        ZL, LOW(KURSOR_ARRAY)
        LDI        ZH, HIGH(KURSOR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R0
        MOV        R25, R1
        ADIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; INC(ARRAY_POS) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0393
 
; FOR TO DO - Ende
M_FTD_0395:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0384
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0383:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x000C)
        LDI        R18, LOW(0x000C)
        LDI        R19, HIGH(0x000C)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0399
        CLR        R16
        RJMP       M_VERGL_0400
M_VERGL_0399:
        SER        R16
M_VERGL_0400:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0396
        RJMP       M_IF_0397
M_IF_0396:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0398
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0397:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0398:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R3, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R3
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0401:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0402
        RJMP       M_FTD_0403
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0402:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0404:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0405
        RJMP       M_FTD_0406
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0405:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (KURSOR_ARRAY)
        LDI        ZL, LOW(KURSOR_ARRAY)
        LDI        ZH, HIGH(KURSOR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R0
        MOV        R25, R1
        ADIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; INC(ARRAY_POS) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0404
 
; FOR TO DO - Ende
M_FTD_0406:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R3
        INC        R17
        MOV        R3, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0401
 
; FOR TO DO - Ende
M_FTD_0403:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; IF_THEN_ELSE - Ende
M_IF_0384:
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN - Ende
M_IF_0380:
 
; PROCEDURE - Ende (KURSOR_ARRAY_TO_VRAM)
        RET
 
; PROCEDURE - Anfang (SCHALTE_KURSOR_EIN)
SCHALTE_KURSOR_EIN:
 
; Aufruf PROCEDURE (VRAM_TO_KURSOR_ARRAY)
        CALL       VRAM_TO_KURSOR_ARRAY
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x5F)
        LDI        R16, 0x5F
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0407
        RJMP       M_IF_0408
M_IF_0407:
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; IF_THEN - Ende
M_IF_0408:
 
; PROCEDURE - Ende (SCHALTE_KURSOR_EIN)
        RET
 
; PROCEDURE - Anfang (SCHALTE_KURSOR_AUS)
SCHALTE_KURSOR_AUS:
 
; Aufruf PROCEDURE (KURSOR_ARRAY_TO_VRAM)
        CALL       KURSOR_ARRAY_TO_VRAM
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0410
        RJMP       M_IF_0411
M_IF_0410:
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Aufruf PROCEDURE (KURSOR_ARRAY_TO_VRAM)
        CALL       KURSOR_ARRAY_TO_VRAM
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; IF_THEN - Ende
M_IF_0411:
 
; PROCEDURE - Ende (SCHALTE_KURSOR_AUS)
        RET
 
; PROCEDURE - Anfang (VRAM_TO_CHAR_ARRAY)
VRAM_TO_CHAR_ARRAY:
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF THEN - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_PIXEL_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0079)
        LDI        R18, LOW(0x0079)
        LDI        R19, HIGH(0x0079)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0416
        CLR        R16
        RJMP       M_VERGL_0417
M_VERGL_0416:
        SER        R16
M_VERGL_0417:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0413
        RJMP       M_IF_0414
M_IF_0413:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_PIXEL_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (X_PIXEL_POS)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R7, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x06)
        LDI        R16, 0x06
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R7
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0418:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0419
        RJMP       M_FTD_0420
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0419:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R6, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R6
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0421:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0422
        RJMP       M_FTD_0423
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0422:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R5
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(OE)
        CBI        PORTD, 4
 
; INC(ADRESSE) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R16, R8
        MOV        R17, R9
 
; VAR ARRAY Ziel Zeiger berechnen (CHAR_ARRAY)
        LDI        ZL, LOW(CHAR_ARRAY)
        LDI        ZH, HIGH(CHAR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINA
        IN         R16, PINA
 
; Zuweisung Ziel /  VAR ARRAY (CHAR_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(ARRAY_POS) - Word
        MOV        R24, R8
        MOV        R25, R9
        ADIW       R25:R24, 1
        MOV        R8, R24
        MOV        R9, R25
 
; SetBit(OE)
        SBI        PORTD, 4
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R6
        INC        R17
        MOV        R6, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0421
 
; FOR TO DO - Ende
M_FTD_0423:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R7
        INC        R17
        MOV        R7, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0418
 
; FOR TO DO - Ende
M_FTD_0420:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (X_PIXEL_POS)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R6, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R6
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0424:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0425
        RJMP       M_FTD_0426
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0425:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R5
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(OE)
        CBI        PORTD, 4
 
; INC(ADRESSE) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R16, R8
        MOV        R17, R9
 
; VAR ARRAY Ziel Zeiger berechnen (CHAR_ARRAY)
        LDI        ZL, LOW(CHAR_ARRAY)
        LDI        ZH, HIGH(CHAR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINA
        IN         R16, PINA
 
; Zuweisung Ziel /  VAR ARRAY (CHAR_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(ARRAY_POS) - Word
        MOV        R24, R8
        MOV        R25, R9
        ADIW       R25:R24, 1
        MOV        R8, R24
        MOV        R9, R25
 
; SetBit(OE)
        SBI        PORTD, 4
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R6
        INC        R17
        MOV        R6, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0424
 
; FOR TO DO - Ende
M_FTD_0426:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0415
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0414:
 
; IF THEN - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_PIXEL_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0079)
        LDI        R18, LOW(0x0079)
        LDI        R19, HIGH(0x0079)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0430
        CLR        R16
        RJMP       M_VERGL_0431
M_VERGL_0430:
        SER        R16
M_VERGL_0431:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0427
        RJMP       M_IF_0428
M_IF_0427:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_PIXEL_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (X_PIXEL_POS)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0429
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0428:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_PIXEL_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (X_PIXEL_POS)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0429:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R7, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R7
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0432:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0433
        RJMP       M_FTD_0434
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0433:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R6, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R6
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0435:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0436
        RJMP       M_FTD_0437
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0436:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R5
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; NOP
        NOP
 
; NOP
        NOP
 
; ClearBit(OE)
        CBI        PORTD, 4
 
; INC(ADRESSE) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R16, R8
        MOV        R17, R9
 
; VAR ARRAY Ziel Zeiger berechnen (CHAR_ARRAY)
        LDI        ZL, LOW(CHAR_ARRAY)
        LDI        ZH, HIGH(CHAR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINA
        IN         R16, PINA
 
; Zuweisung Ziel /  VAR ARRAY (CHAR_ARRAY)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(ARRAY_POS) - Word
        MOV        R24, R8
        MOV        R25, R9
        ADIW       R25:R24, 1
        MOV        R8, R24
        MOV        R9, R25
 
; SetBit(OE)
        SBI        PORTD, 4
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R6
        INC        R17
        MOV        R6, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0435
 
; FOR TO DO - Ende
M_FTD_0437:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R7
        INC        R17
        MOV        R7, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0432
 
; FOR TO DO - Ende
M_FTD_0434:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; IF_THEN_ELSE - Ende
M_IF_0415:
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (VRAM_TO_CHAR_ARRAY)
        RET
 
; PROCEDURE - Anfang (CHAR_ARRAY_TO_VRAM)
CHAR_ARRAY_TO_VRAM:
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; ClearBit(DIR)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; IF THEN - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_PIXEL_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0079)
        LDI        R18, LOW(0x0079)
        LDI        R19, HIGH(0x0079)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0441
        CLR        R16
        RJMP       M_VERGL_0442
M_VERGL_0441:
        SER        R16
M_VERGL_0442:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0438
        RJMP       M_IF_0439
M_IF_0438:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_PIXEL_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (X_PIXEL_POS)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R7, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x06)
        LDI        R16, 0x06
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R7
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0443:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0444
        RJMP       M_FTD_0445
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0444:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R6, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R6
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0446:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0447
        RJMP       M_FTD_0448
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0447:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (CHAR_ARRAY)
        LDI        ZL, LOW(CHAR_ARRAY)
        LDI        ZH, HIGH(CHAR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R5
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; INC(ARRAY_POS) - Word
        MOV        R24, R8
        MOV        R25, R9
        ADIW       R25:R24, 1
        MOV        R8, R24
        MOV        R9, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R6
        INC        R17
        MOV        R6, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0446
 
; FOR TO DO - Ende
M_FTD_0448:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R7
        INC        R17
        MOV        R7, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0443
 
; FOR TO DO - Ende
M_FTD_0445:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (X_PIXEL_POS)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R6, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R6
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0449:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0450
        RJMP       M_FTD_0451
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0450:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (CHAR_ARRAY)
        LDI        ZL, LOW(CHAR_ARRAY)
        LDI        ZH, HIGH(CHAR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R5
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; INC(ARRAY_POS) - Word
        MOV        R24, R8
        MOV        R25, R9
        ADIW       R25:R24, 1
        MOV        R8, R24
        MOV        R9, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R6
        INC        R17
        MOV        R6, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0449
 
; FOR TO DO - Ende
M_FTD_0451:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0440
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0439:
 
; IF THEN - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_PIXEL_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0079)
        LDI        R18, LOW(0x0079)
        LDI        R19, HIGH(0x0079)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0455
        CLR        R16
        RJMP       M_VERGL_0456
M_VERGL_0455:
        SER        R16
M_VERGL_0456:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0452
        RJMP       M_IF_0453
M_IF_0452:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_PIXEL_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (X_PIXEL_POS)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; SetBit(A16)
        SBI        PORTD, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0454
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0453:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (Y_PIXEL_POS)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (X_PIXEL_POS)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; IF_THEN_ELSE - Ende
M_IF_0454:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R7, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R7
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0457:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0458
        RJMP       M_FTD_0459
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0458:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R6, R16
 
; FOR TO DO - Ausdruck / Byte-VAR (ZEICHENBREITE0)
        LDS        R16, ZEICHENBREITE0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R6
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0460:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0461
        RJMP       M_FTD_0462
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0461:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ARRAY_POS)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (CHAR_ARRAY)
        LDI        ZL, LOW(CHAR_ARRAY)
        LDI        ZH, HIGH(CHAR_ARRAY)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R5
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE)
        CBI        PORTD, 3
 
; INC(ADRESSE) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; INC(ARRAY_POS) - Word
        MOV        R24, R8
        MOV        R25, R9
        ADIW       R25:R24, 1
        MOV        R8, R24
        MOV        R9, R25
 
; SetBit(WE)
        SBI        PORTD, 3
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R6
        INC        R17
        MOV        R6, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0460
 
; FOR TO DO - Ende
M_FTD_0462:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0200)
        LDI        R18, LOW(0x0200)
        LDI        R19, HIGH(0x0200)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R7
        INC        R17
        MOV        R7, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0457
 
; FOR TO DO - Ende
M_FTD_0459:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; IF_THEN_ELSE - Ende
M_IF_0440:
 
; SetBit(WE)
        SBI        PORTD, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (CHAR_ARRAY_TO_VRAM)
        RET
 
; PROCEDURE - Anfang (CURSOR_UP)
CURSOR_UP:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0466
        CLR        R16
        RJMP       M_VERGL_0467
M_VERGL_0466:
        SER        R16
M_VERGL_0467:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0463
        RJMP       M_IF_0464
M_IF_0463:
 
; DEC(Y_KUR_POS) - Word
        LDS        R24, Y_KUR_POS
        LDS        R25, Y_KUR_POS+1
        SBIW       R25:R24, 1
        STS        Y_KUR_POS, R24
        STS        Y_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENHOEHE)
        LDS        R18, ZEICHENHOEHE
        LDS        R19, ZEICHENHOEHE+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; IF_THEN - Ende
M_IF_0464:
 
; PROCEDURE - Ende (CURSOR_UP)
        RET
 
; PROCEDURE - Anfang (DELETE_EOL)
DELETE_EOL:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x20)
        LDI        R16, 0x20
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_CNT)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Word-VAR (MAX_SPALTEN)
        LDS        R16, MAX_SPALTEN
        LDS        R17, MAX_SPALTEN+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0468:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0469
        RJMP       M_FTD_0470
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0469:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_EOL)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_EOL)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0468
 
; FOR TO DO - Ende
M_FTD_0470:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0471
        RJMP       M_IF_0472
M_IF_0471:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_EOL)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_EOL)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_CNT)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Word-VAR (MAX_SPALTEN)
        LDS        R16, MAX_SPALTEN
        LDS        R17, MAX_SPALTEN+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0474:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0475
        RJMP       M_FTD_0476
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0475:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_EOL)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_EOL)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0474
 
; FOR TO DO - Ende
M_FTD_0476:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_EOL)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_EOL)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0472:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; PROCEDURE - Ende (DELETE_EOL)
        RET
 
; PROCEDURE - Anfang (DELETE_BOL)
DELETE_BOL:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x20)
        LDI        R16, 0x20
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_CNT)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R2
        MOV        R17, R3
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0477:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0478
        RJMP       M_FTD_0479
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0478:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_BOL)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_BOL)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0477
 
; FOR TO DO - Ende
M_FTD_0479:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0480
        RJMP       M_IF_0481
M_IF_0480:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_BOL)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_BOL)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_CNT)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R2
        MOV        R17, R3
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0483:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0484
        RJMP       M_FTD_0485
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0484:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_BOL)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_BOL)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0483
 
; FOR TO DO - Ende
M_FTD_0485:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_BOL)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_BOL)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0481:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; PROCEDURE - Ende (DELETE_BOL)
        RET
 
; PROCEDURE - Anfang (DELETE_LINE)
DELETE_LINE:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x20)
        LDI        R16, 0x20
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_CNT)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Word-VAR (MAX_SPALTEN)
        LDS        R16, MAX_SPALTEN
        LDS        R17, MAX_SPALTEN+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0486:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0487
        RJMP       M_FTD_0488
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0487:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_LINE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_LINE)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0486
 
; FOR TO DO - Ende
M_FTD_0488:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0489
        RJMP       M_IF_0490
M_IF_0489:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_LINE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_LINE)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_CNT)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Word-VAR (MAX_SPALTEN)
        LDS        R16, MAX_SPALTEN
        LDS        R17, MAX_SPALTEN+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0492:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0493
        RJMP       M_FTD_0494
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0493:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_LINE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_LINE)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0492
 
; FOR TO DO - Ende
M_FTD_0494:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_LINE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_LINE)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0490:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; PROCEDURE - Ende (DELETE_LINE)
        RET
 
; PROCEDURE - Anfang (CLEAR_LINE_ON_RAMPAGE)
CLEAR_LINE_ON_RAMPAGE:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x20)
        LDI        R16, 0x20
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_CNT)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Word-VAR (MAX_SPALTEN2)
        LDS        R16, MAX_SPALTEN2
        LDS        R17, MAX_SPALTEN2+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0495:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0496
        RJMP       M_FTD_0497
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0496:
 
; Retten der lokalen Parameter fuer PROCEDURE (CLEAR_LINE_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (CLEAR_LINE_ON_RAMPAGE)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0495
 
; FOR TO DO - Ende
M_FTD_0497:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; PROCEDURE - Ende (CLEAR_LINE_ON_RAMPAGE)
        RET
 
; PROCEDURE - Anfang (DELETE_LAST_LINE_ON_RAMPAGE)
DELETE_LAST_LINE_ON_RAMPAGE:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x20)
        LDI        R16, 0x20
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_KUR_POS2)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_PIX_POS2)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (MAX_ZEILEN)
        LDS        R16, MAX_ZEILEN
        LDS        R17, MAX_ZEILEN+1
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Zahlenwert (0x00F0)
        LDI        R16, LOW(0x00F0)
        LDI        R17, HIGH(0x00F0)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENHOEHE)
        LDS        R18, ZEICHENHOEHE
        LDS        R19, ZEICHENHOEHE+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (Y_ANF)
        LDS        R18, Y_ANF
        LDS        R19, Y_ANF+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_CNT)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Word-VAR (MAX_SPALTEN)
        LDS        R16, MAX_SPALTEN
        LDS        R17, MAX_SPALTEN+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0498:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0499
        RJMP       M_FTD_0500
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0499:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_LAST_LINE_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_LAST_LINE_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0498
 
; FOR TO DO - Ende
M_FTD_0500:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (Y_KUR_POS2)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (Y_PIX_POS2)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; PROCEDURE - Ende (DELETE_LAST_LINE_ON_RAMPAGE)
        RET
 
; PROCEDURE - Anfang (DELETE_LINE_SCR_ROLL_ON_RAMPAGE)
DELETE_LINE_SCR_ROLL_ON_RAMPAGE:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (MAX_ZEILEN2)
        LDS        R18, MAX_ZEILEN2
        LDS        R19, MAX_ZEILEN2+1
 
; Operator <=
        CP         R18, R16
        CPC        R19, R17
        BRCC       M_VERGL_0504
        CLR        R16
        RJMP       M_VERGL_0505
M_VERGL_0504:
        SER        R16
M_VERGL_0505:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0501
        RJMP       M_IF_0502
M_IF_0501:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_Y_CNT)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (MAX_ZEILEN2)
        LDS        R16, MAX_ZEILEN2
        LDS        R17, MAX_ZEILEN2+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0506:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0507
        RJMP       M_FTD_0508
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0507:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (KUR_POS_Y_CNT)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENHOEHE)
        LDS        R18, ZEICHENHOEHE
        LDS        R19, ZEICHENHOEHE+1
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_PIX_POS_NACH)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (Y_PIX_POS_NACH)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (Y_ANF)
        LDS        R18, Y_ANF
        LDS        R19, Y_ANF+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_PIX_POS_NACH)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (Y_PIX_POS_NACH)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENHOEHE)
        LDS        R18, ZEICHENHOEHE
        LDS        R19, ZEICHENHOEHE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_PIX_POS_VON)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_PIXEL_POS)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_X_CNT)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Word-VAR (MAX_SPALTEN)
        LDS        R16, MAX_SPALTEN
        LDS        R17, MAX_SPALTEN+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0509:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0510
        RJMP       M_FTD_0511
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0510:
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_LINE_SCR_ROLL_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (X_PIXEL_POS) retten
        MOV        R20, R4
        MOV        R21, R5
 
; Parameter (Y_PIX_POS_VON) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (X_PIXEL_POS) an Prozedur (VRAM_TO_CHAR_ARRAY)
        MOV        R0, R20
        MOV        R1, R21
 
; lokalen Parameter (Y_PIX_POS_VON) an Prozedur (VRAM_TO_CHAR_ARRAY)
        MOV        R2, R22
        MOV        R3, R23
 
; Aufruf PROCEDURE (VRAM_TO_CHAR_ARRAY)
        CALL       VRAM_TO_CHAR_ARRAY
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_LINE_SCR_ROLL_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DELETE_LINE_SCR_ROLL_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (X_PIXEL_POS) retten
        MOV        R20, R4
        MOV        R21, R5
 
; Parameter (Y_PIX_POS_NACH) retten
        MOV        R24, R8
        MOV        R25, R9
 
; lokalen Parameter (X_PIXEL_POS) an Prozedur (CHAR_ARRAY_TO_VRAM)
        MOV        R0, R20
        MOV        R1, R21
 
; lokalen Parameter (Y_PIX_POS_NACH) an Prozedur (CHAR_ARRAY_TO_VRAM)
        MOV        R2, R24
        MOV        R3, R25
 
; Aufruf PROCEDURE (CHAR_ARRAY_TO_VRAM)
        CALL       CHAR_ARRAY_TO_VRAM
 
; Retten der Parameter-Register fuer PROCEDURE (DELETE_LINE_SCR_ROLL_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (X_PIXEL_POS)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_PIXEL_POS)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0509
 
; FOR TO DO - Ende
M_FTD_0511:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0506
 
; FOR TO DO - Ende
M_FTD_0508:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN - Ende
M_IF_0502:
 
; PROCEDURE - Ende (DELETE_LINE_SCR_ROLL_ON_RAMPAGE)
        RET
 
; PROCEDURE - Anfang (DELETE_LINE_SCR_ROLL)
DELETE_LINE_SCR_ROLL:
 
; Aufruf PROCEDURE (DELETE_LINE_SCR_ROLL_ON_RAMPAGE)
        CALL       DELETE_LINE_SCR_ROLL_ON_RAMPAGE
 
; Aufruf PROCEDURE (DELETE_LAST_LINE_ON_RAMPAGE)
        CALL       DELETE_LAST_LINE_ON_RAMPAGE
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0512
        RJMP       M_IF_0513
M_IF_0512:
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Aufruf PROCEDURE (DELETE_LINE_SCR_ROLL_ON_RAMPAGE)
        CALL       DELETE_LINE_SCR_ROLL_ON_RAMPAGE
 
; Aufruf PROCEDURE (DELETE_LAST_LINE_ON_RAMPAGE)
        CALL       DELETE_LAST_LINE_ON_RAMPAGE
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; IF_THEN - Ende
M_IF_0513:
 
; PROCEDURE - Ende (DELETE_LINE_SCR_ROLL)
        RET
 
; PROCEDURE - Anfang (INSERT_LINE_SCR_ROLL_ON_RAMPAGE)
INSERT_LINE_SCR_ROLL_ON_RAMPAGE:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (MAX_ZEILEN2)
        LDS        R18, MAX_ZEILEN2
        LDS        R19, MAX_ZEILEN2+1
 
; Operator <=
        CP         R18, R16
        CPC        R19, R17
        BRCC       M_VERGL_0518
        CLR        R16
        RJMP       M_VERGL_0519
M_VERGL_0518:
        SER        R16
M_VERGL_0519:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0515
        RJMP       M_IF_0516
M_IF_0515:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (MAX_ZEILEN2)
        LDS        R16, MAX_ZEILEN2
        LDS        R17, MAX_ZEILEN2+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_Y_CNT)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0520:
 
; FOR TO DO - Word-Vergleichsteil (DOWNTO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R18, R16
        CPC        R19, R17
        BRCC       M_FTD_0521
        RJMP       M_FTD_0522
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0521:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (KUR_POS_Y_CNT)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENHOEHE)
        LDS        R18, ZEICHENHOEHE
        LDS        R19, ZEICHENHOEHE+1
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_PIX_POS_VON)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (Y_PIX_POS_VON)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (Y_ANF)
        LDS        R18, Y_ANF
        LDS        R19, Y_ANF+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_PIX_POS_VON)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (Y_PIX_POS_VON)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENHOEHE)
        LDS        R18, ZEICHENHOEHE
        LDS        R19, ZEICHENHOEHE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_PIX_POS_NACH)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_PIXEL_POS)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KUR_POS_X_CNT)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Word-VAR (MAX_SPALTEN)
        LDS        R16, MAX_SPALTEN
        LDS        R17, MAX_SPALTEN+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0523:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0524
        RJMP       M_FTD_0525
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0524:
 
; Retten der lokalen Parameter fuer PROCEDURE (INSERT_LINE_SCR_ROLL_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (X_PIXEL_POS) retten
        MOV        R20, R4
        MOV        R21, R5
 
; Parameter (Y_PIX_POS_VON) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (X_PIXEL_POS) an Prozedur (VRAM_TO_CHAR_ARRAY)
        MOV        R0, R20
        MOV        R1, R21
 
; lokalen Parameter (Y_PIX_POS_VON) an Prozedur (VRAM_TO_CHAR_ARRAY)
        MOV        R2, R22
        MOV        R3, R23
 
; Aufruf PROCEDURE (VRAM_TO_CHAR_ARRAY)
        CALL       VRAM_TO_CHAR_ARRAY
 
; Retten der Parameter-Register fuer PROCEDURE (INSERT_LINE_SCR_ROLL_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (INSERT_LINE_SCR_ROLL_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (X_PIXEL_POS) retten
        MOV        R20, R4
        MOV        R21, R5
 
; Parameter (Y_PIX_POS_NACH) retten
        MOV        R24, R8
        MOV        R25, R9
 
; lokalen Parameter (X_PIXEL_POS) an Prozedur (CHAR_ARRAY_TO_VRAM)
        MOV        R0, R20
        MOV        R1, R21
 
; lokalen Parameter (Y_PIX_POS_NACH) an Prozedur (CHAR_ARRAY_TO_VRAM)
        MOV        R2, R24
        MOV        R3, R25
 
; Aufruf PROCEDURE (CHAR_ARRAY_TO_VRAM)
        CALL       CHAR_ARRAY_TO_VRAM
 
; Retten der Parameter-Register fuer PROCEDURE (INSERT_LINE_SCR_ROLL_ON_RAMPAGE)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (X_PIXEL_POS)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_PIXEL_POS)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0523
 
; FOR TO DO - Ende
M_FTD_0525:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-DEC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        SUB        R18, R20
        CLR        R20
        SBC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0520
 
; FOR TO DO - Ende
M_FTD_0522:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN - Ende
M_IF_0516:
 
; PROCEDURE - Ende (INSERT_LINE_SCR_ROLL_ON_RAMPAGE)
        RET
 
; PROCEDURE - Anfang (INSERT_LINE_SCR_ROLL)
INSERT_LINE_SCR_ROLL:
 
; Aufruf PROCEDURE (INSERT_LINE_SCR_ROLL_ON_RAMPAGE)
        CALL       INSERT_LINE_SCR_ROLL_ON_RAMPAGE
 
; Aufruf PROCEDURE (CLEAR_LINE_ON_RAMPAGE)
        CALL       CLEAR_LINE_ON_RAMPAGE
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0526
        RJMP       M_IF_0527
M_IF_0526:
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Aufruf PROCEDURE (INSERT_LINE_SCR_ROLL_ON_RAMPAGE)
        CALL       INSERT_LINE_SCR_ROLL_ON_RAMPAGE
 
; Aufruf PROCEDURE (CLEAR_LINE_ON_RAMPAGE)
        CALL       CLEAR_LINE_ON_RAMPAGE
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; IF_THEN - Ende
M_IF_0527:
 
; PROCEDURE - Ende (INSERT_LINE_SCR_ROLL)
        RET
 
; PROCEDURE - Anfang (ERASE_DOWN_ON_RAMPAGE)
ERASE_DOWN_ON_RAMPAGE:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x20)
        LDI        R16, 0x20
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R3, R16
        MOV        R4, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R5, R16
        MOV        R6, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_KUR_POS2)
        MOV        R7, R16
        MOV        R8, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_PIX_POS2)
        MOV        R9, R16
        MOV        R10, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (Y_KUR_POS2)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; FOR TO DO - Ausdruck / Word-VAR (MAX_ZEILEN)
        LDS        R16, MAX_ZEILEN
        LDS        R17, MAX_ZEILEN+1
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, Y_KUR_POS
        LDS        R19, Y_KUR_POS+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0529:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0530
        RJMP       M_FTD_0531
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0530:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; FOR TO DO - Ausdruck / Word-VAR (MAX_SPALTEN2)
        LDS        R16, MAX_SPALTEN2
        LDS        R17, MAX_SPALTEN2+1
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, X_KUR_POS
        LDS        R19, X_KUR_POS+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0532:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0533
        RJMP       M_FTD_0534
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0533:
 
; Retten der lokalen Parameter fuer PROCEDURE (ERASE_DOWN_ON_RAMPAGE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (ERASE_DOWN_ON_RAMPAGE)
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, X_KUR_POS
        LDS        R19, X_KUR_POS+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        X_KUR_POS, R18
        STS        X_KUR_POS+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0532
 
; FOR TO DO - Ende
M_FTD_0534:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENHOEHE)
        LDS        R18, ZEICHENHOEHE
        LDS        R19, ZEICHENHOEHE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, Y_KUR_POS
        LDS        R19, Y_KUR_POS+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        Y_KUR_POS, R18
        STS        Y_KUR_POS+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0529
 
; FOR TO DO - Ende
M_FTD_0531:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_KUR_POS2)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (X_PIX_POS2)
        MOV        R16, R5
        MOV        R17, R6
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (Y_KUR_POS2)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (Y_PIX_POS2)
        MOV        R16, R9
        MOV        R17, R10
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; PROCEDURE - Ende (ERASE_DOWN_ON_RAMPAGE)
        RET
 
; PROCEDURE - Anfang (ERASE_DOWN)
ERASE_DOWN:
 
; Aufruf PROCEDURE (ERASE_DOWN_ON_RAMPAGE)
        CALL       ERASE_DOWN_ON_RAMPAGE
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0535
        RJMP       M_IF_0536
M_IF_0535:
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Aufruf PROCEDURE (ERASE_DOWN_ON_RAMPAGE)
        CALL       ERASE_DOWN_ON_RAMPAGE
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; IF_THEN - Ende
M_IF_0536:
 
; PROCEDURE - Ende (ERASE_DOWN)
        RET
 
; PROCEDURE - Anfang (SET_CURSOR_POSITION)
SET_CURSOR_POSITION:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (SPALTE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (MAX_SPALTEN)
        LDS        R18, MAX_SPALTEN
        LDS        R19, MAX_SPALTEN+1
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0541
        CLR        R16
        RJMP       M_VERGL_0542
M_VERGL_0541:
        SER        R16
M_VERGL_0542:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0538
        RJMP       M_IF_0539
M_IF_0538:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (MAX_SPALTEN)
        LDS        R16, MAX_SPALTEN
        LDS        R17, MAX_SPALTEN+1
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; IF_THEN - Ende
M_IF_0539:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_ANF)
        LDS        R18, X_ANF
        LDS        R19, X_ANF+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (ZEILE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (MAX_ZEILEN)
        LDS        R18, MAX_ZEILEN
        LDS        R19, MAX_ZEILEN+1
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0546
        CLR        R16
        RJMP       M_VERGL_0547
M_VERGL_0546:
        SER        R16
M_VERGL_0547:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0543
        RJMP       M_IF_0544
M_IF_0543:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (MAX_ZEILEN)
        LDS        R16, MAX_ZEILEN
        LDS        R17, MAX_ZEILEN+1
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; IF_THEN - Ende
M_IF_0544:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENHOEHE)
        LDS        R18, ZEICHENHOEHE
        LDS        R19, ZEICHENHOEHE+1
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (Y_ANF)
        LDS        R18, Y_ANF
        LDS        R19, Y_ANF+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; PROCEDURE - Ende (SET_CURSOR_POSITION)
        RET
 
; PROCEDURE - Anfang (CURSOR_RIGHT)
CURSOR_RIGHT:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (MAX_SPALTEN)
        LDS        R18, MAX_SPALTEN
        LDS        R19, MAX_SPALTEN+1
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0551
        CLR        R16
        RJMP       M_VERGL_0552
M_VERGL_0551:
        SER        R16
M_VERGL_0552:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0548
        RJMP       M_IF_0549
M_IF_0548:
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; IF_THEN - Ende
M_IF_0549:
 
; PROCEDURE - Ende (CURSOR_RIGHT)
        RET
 
; PROCEDURE - Anfang (WRITE_CHAR_IN_BEIDE_RP)
WRITE_CHAR_IN_BEIDE_RP:
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0553
        RJMP       M_IF_0554
M_IF_0553:
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; IF_THEN - Ende
M_IF_0554:
 
; Aufruf PROCEDURE (CURSOR_RIGHT)
        CALL       CURSOR_RIGHT
 
; PROCEDURE - Ende (WRITE_CHAR_IN_BEIDE_RP)
        RET
 
; PROCEDURE - Anfang (NORMAL_TERMINAL_MODE)
NORMAL_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Einzel-Element ($0A)
        CPI        R16, 0x0A
        BREQ       M_CASE_0558
        RJMP       M_CASE_0557
M_CASE_0558:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (MAX_ZEILEN)
        LDS        R18, MAX_ZEILEN
        LDS        R19, MAX_ZEILEN+1
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0562
        CLR        R16
        RJMP       M_VERGL_0563
M_VERGL_0562:
        SER        R16
M_VERGL_0563:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0559
        RJMP       M_IF_0560
M_IF_0559:
 
; INC(Y_KUR_POS) - Word
        LDS        R24, Y_KUR_POS
        LDS        R25, Y_KUR_POS+1
        ADIW       R25:R24, 1
        STS        Y_KUR_POS, R24
        STS        Y_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENHOEHE)
        LDS        R18, ZEICHENHOEHE
        LDS        R19, ZEICHENHOEHE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0561
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0560:
 
; Aufruf PROCEDURE (SCREENROLL)
        CALL       SCREENROLL
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0564
        RJMP       M_IF_0565
M_IF_0564:
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Aufruf PROCEDURE (SCREENROLL)
        CALL       SCREENROLL
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; IF_THEN - Ende
M_IF_0565:
 
; IF_THEN_ELSE - Ende
M_IF_0561:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0556
M_CASE_0557:
 
; CASE OF - vergleiche Einzel-Element ($0C)
        CPI        R16, 0x0C
        BREQ       M_CASE_0568
        RJMP       M_CASE_0567
M_CASE_0568:
 
; Aufruf PROCEDURE (CLEAR_RAM)
        CALL       CLEAR_RAM
 
; IF THEN - Ausdruck / Byte-VAR (KOPIEBWS)
        LDS        R16, KOPIEBWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0569
        RJMP       M_IF_0570
M_IF_0569:
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Aufruf PROCEDURE (CLEAR_RAM)
        CALL       CLEAR_RAM
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; IF_THEN - Ende
M_IF_0570:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0556
M_CASE_0567:
 
; CASE OF - vergleiche Einzel-Element ($0D)
        CPI        R16, 0x0D
        BREQ       M_CASE_0573
        RJMP       M_CASE_0572
M_CASE_0573:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0556
M_CASE_0572:
 
; CASE OF - vergleiche Einzel-Element ($1B)
        CPI        R16, 0x1B
        BREQ       M_CASE_0575
        RJMP       M_CASE_0574
M_CASE_0575:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_ESC_TM)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0556
 
; CASE OF ELSE
M_CASE_0574:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x20)
        LDI        R18, 0x20
 
; Operator >=
        CP         R16, R18
        BRCC       M_VERGL_0579
        CLR        R16
        RJMP       M_VERGL_0580
M_VERGL_0579:
        SER        R16
M_VERGL_0580:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0576
        RJMP       M_IF_0577
M_IF_0576:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x7F)
        LDI        R18, 0x7F
 
; Operator <=
        CP         R18, R16
        BRCC       M_VERGL_0584
        CLR        R16
        RJMP       M_VERGL_0585
M_VERGL_0584:
        SER        R16
M_VERGL_0585:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0581
        RJMP       M_IF_0582
M_IF_0581:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (MAX_SPALTEN)
        LDS        R18, MAX_SPALTEN
        LDS        R19, MAX_SPALTEN+1
 
; Operator <=
        CP         R18, R16
        CPC        R19, R17
        BRCC       M_VERGL_0589
        CLR        R16
        RJMP       M_VERGL_0590
M_VERGL_0589:
        SER        R16
M_VERGL_0590:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0586
        RJMP       M_IF_0587
M_IF_0586:
 
; Aufruf PROCEDURE (WRITE_CHAR_IN_BEIDE_RP)
        CALL       WRITE_CHAR_IN_BEIDE_RP
 
; Aufruf PROCEDURE (VRAM_TO_KURSOR_ARRAY)
        CALL       VRAM_TO_KURSOR_ARRAY
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_SICHTBAR)
        STS        KURSOR_SICHTBAR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KURSOR_SCHLEIFE)
        STS        KURSOR_SCHLEIFE, R16
        STS        KURSOR_SCHLEIFE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (KURARR_AKTUELL)
        STS        KURARR_AKTUELL, R16
 
; IF_THEN - Ende
M_IF_0587:
 
; IF_THEN - Ende
M_IF_0582:
 
; IF_THEN - Ende
M_IF_0577:
 
; ENDCASE;
M_CASE_0556:
 
; PROCEDURE - Ende (NORMAL_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (ESCAPE_RESET)
ESCAPE_RESET:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER3)
        STS        CSI_PARAMETER3, R16
        STS        CSI_PARAMETER3+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (ESCAPE_SEQUENZ)=10
        LDI        R16, 10
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('')
        LDI        ZL, LOW(2*M_CONST_STRING_0)
        LDI        ZH, HIGH(2*M_CONST_STRING_0)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0591
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0591:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0593
M_PRG_CONST_STRING_0592:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0592
M_PRG_CONST_STRING_0593:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ESCAPE_SEQUENZ) - Laenge in R17
        LDI        ZL, LOW(ESCAPE_SEQUENZ)
        LDI        ZH, HIGH(ESCAPE_SEQUENZ)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0595
        MOV        R16, R17
M_PRG_CONST_STRING_0594:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0594
M_PRG_CONST_STRING_0595:
        ST         -Z, R17
 
; PROCEDURE - Ende (ESCAPE_RESET)
        RET
 
; PROCEDURE - Anfang (ESCAPE_FEHLER)
ESCAPE_FEHLER:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x45)
        LDI        R16, 0x45
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ESCAPE_FEHLER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_CHAR_IN_BEIDE_RP)
        CALL       WRITE_CHAR_IN_BEIDE_RP
 
; Retten der Parameter-Register fuer PROCEDURE (ESCAPE_FEHLER)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x53)
        LDI        R16, 0x53
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ESCAPE_FEHLER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_CHAR_IN_BEIDE_RP)
        CALL       WRITE_CHAR_IN_BEIDE_RP
 
; Retten der Parameter-Register fuer PROCEDURE (ESCAPE_FEHLER)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x43)
        LDI        R16, 0x43
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ESCAPE_FEHLER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_CHAR_IN_BEIDE_RP)
        CALL       WRITE_CHAR_IN_BEIDE_RP
 
; Retten der Parameter-Register fuer PROCEDURE (ESCAPE_FEHLER)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Length(ESCAPE_SEQUENZ)
        LDI        ZL, LOW(ESCAPE_SEQUENZ)
        LDI        ZH, HIGH(ESCAPE_SEQUENZ)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ESC_LAENGE)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ESC_ZAEHLER)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (ESC_LAENGE)
        MOV        R16, R1
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0596:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0597
        RJMP       M_FTD_0598
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0597:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ESC_ZAEHLER)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (ESCAPE_SEQUENZ)
        CLR        R17
        LDI        ZL, LOW(ESCAPE_SEQUENZ)
        LDI        ZH, HIGH(ESCAPE_SEQUENZ)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ESC_ZEICHEN)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(ESC_ZEICHEN)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ESCAPE_FEHLER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_CHAR_IN_BEIDE_RP)
        CALL       WRITE_CHAR_IN_BEIDE_RP
 
; Retten der Parameter-Register fuer PROCEDURE (ESCAPE_FEHLER)
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0596
 
; FOR TO DO - Ende
M_FTD_0598:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ESCAPE_FEHLER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (ESCAPE_FEHLER)
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (ESCAPE_FEHLER)
        RET
 
; PROCEDURE - Anfang (IBM_ESC_TERMINAL_MODE)
IBM_ESC_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Einzel-Element ($5B)
        CPI        R16, 0x5B
        BREQ       M_CASE_0601
        RJMP       M_CASE_0600
M_CASE_0601:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0599
M_CASE_0600:
 
; CASE OF - vergleiche Einzel-Element ($47)
        CPI        R16, 0x47
        BREQ       M_CASE_0603
        RJMP       M_CASE_0602
M_CASE_0603:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_GRAFIK_PAR_1_TM)
        LDI        R16, 0x06
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0599
 
; CASE OF ELSE
M_CASE_0602:
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; ENDCASE;
M_CASE_0599:
 
; PROCEDURE - Ende (IBM_ESC_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (SET_DISPLAY_ATTRIBUTES)
SET_DISPLAY_ATTRIBUTES:
 
; CASE OF - lokaler Uebergabeparameter (DISPATTR)
        MOV        R16, R0
        MOV        R17, R1
 
; CASE OF - vergleiche Einzel-Element (0)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0606
        RJMP       M_CASE_0605
M_CASE_0606:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLUE)
        LDI        R16, 0xB0
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0605:
 
; CASE OF - vergleiche Einzel-Element (1)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0608
        RJMP       M_CASE_0607
M_CASE_0608:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_GRAY)
        LDI        R16, 0x6A
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0607:
 
; CASE OF - vergleiche Einzel-Element (4)
        LDI        R18, LOW(0x0004)
        LDI        R19, HIGH(0x0004)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0610
        RJMP       M_CASE_0609
M_CASE_0610:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_PURPLE)
        LDI        R16, 0x73
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0609:
 
; CASE OF - vergleiche Einzel-Element (5)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0612
        RJMP       M_CASE_0611
M_CASE_0612:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_RED)
        LDI        R16, 0x43
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0611:
 
; CASE OF - vergleiche Einzel-Element (7)
        LDI        R18, LOW(0x0007)
        LDI        R19, HIGH(0x0007)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0614
        RJMP       M_CASE_0613
M_CASE_0614:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLACK)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0613:
 
; CASE OF - vergleiche Einzel-Element (8)
        LDI        R18, LOW(0x0008)
        LDI        R19, HIGH(0x0008)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0616
        RJMP       M_CASE_0615
M_CASE_0616:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_WHITE)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0615:
 
; CASE OF - vergleiche Einzel-Element (10)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0618
        RJMP       M_CASE_0617
M_CASE_0618:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_FONT)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_FONT)
        CALL       SETZE_FONT
 
; Retten der Parameter-Register fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0617:
 
; CASE OF - vergleiche Einzel-Element (11)
        LDI        R18, LOW(0x000B)
        LDI        R19, HIGH(0x000B)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0620
        RJMP       M_CASE_0619
M_CASE_0620:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_FONT)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_FONT)
        CALL       SETZE_FONT
 
; Retten der Parameter-Register fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0619:
 
; CASE OF - vergleiche Einzel-Element (30)
        LDI        R18, LOW(0x001E)
        LDI        R19, HIGH(0x001E)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0622
        RJMP       M_CASE_0621
M_CASE_0622:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLACK)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0621:
 
; CASE OF - vergleiche Einzel-Element (31)
        LDI        R18, LOW(0x001F)
        LDI        R19, HIGH(0x001F)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0624
        RJMP       M_CASE_0623
M_CASE_0624:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_RED)
        LDI        R16, 0x43
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0623:
 
; CASE OF - vergleiche Einzel-Element (32)
        LDI        R18, LOW(0x0020)
        LDI        R19, HIGH(0x0020)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0626
        RJMP       M_CASE_0625
M_CASE_0626:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_GREEN)
        LDI        R16, 0x4C
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0625:
 
; CASE OF - vergleiche Einzel-Element (33)
        LDI        R18, LOW(0x0021)
        LDI        R19, HIGH(0x0021)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0628
        RJMP       M_CASE_0627
M_CASE_0628:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_YELLOW)
        LDI        R16, 0x4F
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0627:
 
; CASE OF - vergleiche Einzel-Element (34)
        LDI        R18, LOW(0x0022)
        LDI        R19, HIGH(0x0022)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0630
        RJMP       M_CASE_0629
M_CASE_0630:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLUE)
        LDI        R16, 0xB0
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0629:
 
; CASE OF - vergleiche Einzel-Element (35)
        LDI        R18, LOW(0x0023)
        LDI        R19, HIGH(0x0023)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0632
        RJMP       M_CASE_0631
M_CASE_0632:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_PURPLE)
        LDI        R16, 0x73
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0631:
 
; CASE OF - vergleiche Einzel-Element (36)
        LDI        R18, LOW(0x0024)
        LDI        R19, HIGH(0x0024)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0634
        RJMP       M_CASE_0633
M_CASE_0634:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_AQUA)
        LDI        R16, 0x7C
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0633:
 
; CASE OF - vergleiche Einzel-Element (37)
        LDI        R18, LOW(0x0025)
        LDI        R19, HIGH(0x0025)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0636
        RJMP       M_CASE_0635
M_CASE_0636:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_WHITE)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0635:
 
; CASE OF - vergleiche Einzel-Element (40)
        LDI        R18, LOW(0x0028)
        LDI        R19, HIGH(0x0028)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0638
        RJMP       M_CASE_0637
M_CASE_0638:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLACK)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0637:
 
; CASE OF - vergleiche Einzel-Element (41)
        LDI        R18, LOW(0x0029)
        LDI        R19, HIGH(0x0029)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0640
        RJMP       M_CASE_0639
M_CASE_0640:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_RED)
        LDI        R16, 0x43
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0639:
 
; CASE OF - vergleiche Einzel-Element (42)
        LDI        R18, LOW(0x002A)
        LDI        R19, HIGH(0x002A)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0642
        RJMP       M_CASE_0641
M_CASE_0642:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_GREEN)
        LDI        R16, 0x4C
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0641:
 
; CASE OF - vergleiche Einzel-Element (43)
        LDI        R18, LOW(0x002B)
        LDI        R19, HIGH(0x002B)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0644
        RJMP       M_CASE_0643
M_CASE_0644:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_YELLOW)
        LDI        R16, 0x4F
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0643:
 
; CASE OF - vergleiche Einzel-Element (44)
        LDI        R18, LOW(0x002C)
        LDI        R19, HIGH(0x002C)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0646
        RJMP       M_CASE_0645
M_CASE_0646:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLUE)
        LDI        R16, 0xB0
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0645:
 
; CASE OF - vergleiche Einzel-Element (45)
        LDI        R18, LOW(0x002D)
        LDI        R19, HIGH(0x002D)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0648
        RJMP       M_CASE_0647
M_CASE_0648:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_PURPLE)
        LDI        R16, 0x73
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0647:
 
; CASE OF - vergleiche Einzel-Element (46)
        LDI        R18, LOW(0x002E)
        LDI        R19, HIGH(0x002E)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0650
        RJMP       M_CASE_0649
M_CASE_0650:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_AQUA)
        LDI        R16, 0x7C
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
M_CASE_0649:
 
; CASE OF - vergleiche Einzel-Element (47)
        LDI        R18, LOW(0x002F)
        LDI        R19, HIGH(0x002F)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0652
        RJMP       M_CASE_0651
M_CASE_0652:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_WHITE)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0604
 
; CASE OF ELSE
M_CASE_0651:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; Retten der Parameter-Register fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0604:
 
; PROCEDURE - Ende (SET_DISPLAY_ATTRIBUTES)
        RET
 
; PROCEDURE - Anfang (IBM_CSI_TERMINAL_MODE)
IBM_CSI_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Byte-Element-Bereich <von> ($30)
        CPI        R16, 0x30
        BRCC       M_CASE_0656
        RJMP       M_CASE_0654
M_CASE_0656:
 
; CASE OF - vergleiche Byte-Element-Bereich <bis> ($39)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0655
        RJMP       M_CASE_0654
M_CASE_0655:
 
; Zuweisung Quelle - Ausdruck erster Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R16, ZEICHEN
        CLR        R17
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_1)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0653
M_CASE_0654:
 
; CASE OF - vergleiche Einzel-Element ($4B)
        CPI        R16, 0x4B
        BREQ       M_CASE_0658
        RJMP       M_CASE_0657
M_CASE_0658:
 
; Aufruf PROCEDURE (DELETE_EOL)
        CALL       DELETE_EOL
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0653
M_CASE_0657:
 
; CASE OF - vergleiche Einzel-Element ($66)
        CPI        R16, 0x66
        BREQ       M_CASE_0660
        RJMP       M_CASE_0659
M_CASE_0660:
 
; Aufruf PROCEDURE (RESET_FORM)
        CALL       RESET_FORM
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0653
M_CASE_0659:
 
; CASE OF - vergleiche Einzel-Element ($6D)
        CPI        R16, 0x6D
        BREQ       M_CASE_0662
        RJMP       M_CASE_0661
M_CASE_0662:
 
; Word-Parameter(1) fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        LDI        R16, LOW(0x0000)
        MOV        R0, R16
        LDI        R17, HIGH(0x0000)
        MOV        R1, R17
 
; Aufruf PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        CALL       SET_DISPLAY_ATTRIBUTES
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0653
M_CASE_0661:
 
; CASE OF - vergleiche Einzel-Element ($3F)
        CPI        R16, 0x3F
        BREQ       M_CASE_0664
        RJMP       M_CASE_0663
M_CASE_0664:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_1)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0653
M_CASE_0663:
 
; CASE OF - vergleiche Einzel-Element ($48)
        CPI        R16, 0x48
        BREQ       M_CASE_0666
        RJMP       M_CASE_0665
M_CASE_0666:
 
; Word-Parameter(1) fuer PROCEDURE (SET_CURSOR_POSITION)
        LDI        R16, LOW(0x0000)
        MOV        R0, R16
        LDI        R17, HIGH(0x0000)
        MOV        R1, R17
 
; Word-Parameter(2) fuer PROCEDURE (SET_CURSOR_POSITION)
        LDI        R16, LOW(0x0000)
        MOV        R2, R16
        LDI        R17, HIGH(0x0000)
        MOV        R3, R17
 
; Aufruf PROCEDURE (SET_CURSOR_POSITION)
        CALL       SET_CURSOR_POSITION
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0653
M_CASE_0665:
 
; CASE OF - vergleiche Einzel-Element ($4A)
        CPI        R16, 0x4A
        BREQ       M_CASE_0668
        RJMP       M_CASE_0667
M_CASE_0668:
 
; Aufruf PROCEDURE (ERASE_DOWN)
        CALL       ERASE_DOWN
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0653
M_CASE_0667:
 
; CASE OF - vergleiche Einzel-Element ($4D)
        CPI        R16, 0x4D
        BREQ       M_CASE_0670
        RJMP       M_CASE_0669
M_CASE_0670:
 
; Aufruf PROCEDURE (DELETE_LINE)
        CALL       DELETE_LINE
 
; Aufruf PROCEDURE (CURSOR_UP)
        CALL       CURSOR_UP
 
; Aufruf PROCEDURE (DELETE_LINE)
        CALL       DELETE_LINE
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0653
 
; CASE OF ELSE
M_CASE_0669:
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; ENDCASE;
M_CASE_0653:
 
; PROCEDURE - Ende (IBM_CSI_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_CSI_PAR_1_TERMINAL_MODE)
IBM_CSI_PAR_1_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Byte-Element-Bereich <von> ($30)
        CPI        R16, 0x30
        BRCC       M_CASE_0674
        RJMP       M_CASE_0672
M_CASE_0674:
 
; CASE OF - vergleiche Byte-Element-Bereich <bis> ($39)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0673
        RJMP       M_CASE_0672
M_CASE_0673:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R18, ZEICHEN
        CLR        R19
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_1)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0671
M_CASE_0672:
 
; CASE OF - vergleiche Einzel-Element ($3B)
        CPI        R16, 0x3B
        BREQ       M_CASE_0676
        RJMP       M_CASE_0675
M_CASE_0676:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_2)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0671
M_CASE_0675:
 
; CASE OF - vergleiche Einzel-Element ($4A)
        CPI        R16, 0x4A
        BREQ       M_CASE_0678
        RJMP       M_CASE_0677
M_CASE_0678:
 
; CASE OF - Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; CASE OF - vergleiche Einzel-Element (2)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0681
        RJMP       M_CASE_0680
M_CASE_0681:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (RESET_FORM)
        CALL       RESET_FORM
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0679
 
; CASE OF ELSE
M_CASE_0680:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0679:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0671
M_CASE_0677:
 
; CASE OF - vergleiche Einzel-Element ($4B)
        CPI        R16, 0x4B
        BREQ       M_CASE_0683
        RJMP       M_CASE_0682
M_CASE_0683:
 
; CASE OF - Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; CASE OF - vergleiche Einzel-Element (0)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0686
        RJMP       M_CASE_0685
M_CASE_0686:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DELETE_EOL)
        CALL       DELETE_EOL
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0684
M_CASE_0685:
 
; CASE OF - vergleiche Einzel-Element (1)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0688
        RJMP       M_CASE_0687
M_CASE_0688:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DELETE_BOL)
        CALL       DELETE_BOL
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0684
M_CASE_0687:
 
; CASE OF - vergleiche Einzel-Element (2)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0690
        RJMP       M_CASE_0689
M_CASE_0690:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DELETE_LINE)
        CALL       DELETE_LINE
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0684
 
; CASE OF ELSE
M_CASE_0689:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0684:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0671
M_CASE_0682:
 
; CASE OF - vergleiche Einzel-Element ($4C)
        CPI        R16, 0x4C
        BREQ       M_CASE_0692
        RJMP       M_CASE_0691
M_CASE_0692:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; FOR TO DO - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0693:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0694
        RJMP       M_FTD_0695
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0694:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (INSERT_LINE_SCR_ROLL)
        CALL       INSERT_LINE_SCR_ROLL
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0693
 
; FOR TO DO - Ende
M_FTD_0695:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0671
M_CASE_0691:
 
; CASE OF - vergleiche Einzel-Element ($4D)
        CPI        R16, 0x4D
        BREQ       M_CASE_0697
        RJMP       M_CASE_0696
M_CASE_0697:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; FOR TO DO - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0698:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0699
        RJMP       M_FTD_0700
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0699:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DELETE_LINE_SCR_ROLL)
        CALL       DELETE_LINE_SCR_ROLL
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0698
 
; FOR TO DO - Ende
M_FTD_0700:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0671
M_CASE_0696:
 
; CASE OF - vergleiche Einzel-Element ($6D)
        CPI        R16, 0x6D
        BREQ       M_CASE_0702
        RJMP       M_CASE_0701
M_CASE_0702:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Word-Parameter(1) fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        LDS        R0, CSI_PARAMETER1
        LDS        R1, CSI_PARAMETER1+1
 
; Aufruf PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        CALL       SET_DISPLAY_ATTRIBUTES
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0671
M_CASE_0701:
 
; CASE OF - vergleiche Einzel-Element ($6C)
        CPI        R16, 0x6C
        BREQ       M_CASE_0704
        RJMP       M_CASE_0703
M_CASE_0704:
 
; CASE OF - Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; CASE OF - vergleiche Einzel-Element (25)
        LDI        R18, LOW(0x0019)
        LDI        R19, HIGH(0x0019)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0707
        RJMP       M_CASE_0706
M_CASE_0707:
 
; IF THEN - Ausdruck / Byte-VAR (KURSOR_SICHTBAR)
        LDS        R16, KURSOR_SICHTBAR
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0708
        RJMP       M_IF_0709
M_IF_0708:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_SICHTBAR)
        STS        KURSOR_SICHTBAR, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (SCHALTE_KURSOR_AUS)
        CALL       SCHALTE_KURSOR_AUS
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0709:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_EIN)
        STS        KURSOR_EIN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0705
M_CASE_0706:
 
; CASE OF - vergleiche Einzel-Element (26)
        LDI        R18, LOW(0x001A)
        LDI        R19, HIGH(0x001A)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0712
        RJMP       M_CASE_0711
M_CASE_0712:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KOPIEBWS)
        STS        KOPIEBWS, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0705
 
; CASE OF ELSE
M_CASE_0711:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0705:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0671
M_CASE_0703:
 
; CASE OF - vergleiche Einzel-Element ($68)
        CPI        R16, 0x68
        BREQ       M_CASE_0714
        RJMP       M_CASE_0713
M_CASE_0714:
 
; CASE OF - Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; CASE OF - vergleiche Einzel-Element (25)
        LDI        R18, LOW(0x0019)
        LDI        R19, HIGH(0x0019)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0717
        RJMP       M_CASE_0716
M_CASE_0717:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KURSOR_SCHLEIFE)
        STS        KURSOR_SCHLEIFE, R16
        STS        KURSOR_SCHLEIFE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (KURSOR_EIN)
        STS        KURSOR_EIN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0715
M_CASE_0716:
 
; CASE OF - vergleiche Einzel-Element (26)
        LDI        R18, LOW(0x001A)
        LDI        R19, HIGH(0x001A)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0719
        RJMP       M_CASE_0718
M_CASE_0719:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (KOPIEBWS)
        STS        KOPIEBWS, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0715
M_CASE_0718:
 
; CASE OF - vergleiche Einzel-Element (27)
        LDI        R18, LOW(0x001B)
        LDI        R19, HIGH(0x001B)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0721
        RJMP       M_CASE_0720
M_CASE_0721:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (UMSCHALTEN_SPEICHERSEITE)
        CALL       UMSCHALTEN_SPEICHERSEITE
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0715
 
; CASE OF ELSE
M_CASE_0720:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0715:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0671
 
; CASE OF ELSE
M_CASE_0713:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0671:
 
; PROCEDURE - Ende (IBM_CSI_PAR_1_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_CSI_PAR_2_TERMINAL_MODE)
IBM_CSI_PAR_2_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Byte-Element-Bereich <von> ($30)
        CPI        R16, 0x30
        BRCC       M_CASE_0725
        RJMP       M_CASE_0723
M_CASE_0725:
 
; CASE OF - vergleiche Byte-Element-Bereich <bis> ($39)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0724
        RJMP       M_CASE_0723
M_CASE_0724:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R18, ZEICHEN
        CLR        R19
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_2)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0722
M_CASE_0723:
 
; CASE OF - vergleiche Einzel-Element ($3B)
        CPI        R16, 0x3B
        BREQ       M_CASE_0727
        RJMP       M_CASE_0726
M_CASE_0727:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_3)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0722
M_CASE_0726:
 
; CASE OF - vergleiche Einzel-Element ($48)
        CPI        R16, 0x48
        BREQ       M_CASE_0729
        RJMP       M_CASE_0728
M_CASE_0729:
 
; Word-Parameter(1) fuer PROCEDURE (SET_CURSOR_POSITION)
        LDS        R0, CSI_PARAMETER1
        LDS        R1, CSI_PARAMETER1+1
 
; Word-Parameter(2) fuer PROCEDURE (SET_CURSOR_POSITION)
        LDS        R2, CSI_PARAMETER2
        LDS        R3, CSI_PARAMETER2+1
 
; Aufruf PROCEDURE (SET_CURSOR_POSITION)
        CALL       SET_CURSOR_POSITION
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0722
M_CASE_0728:
 
; CASE OF - vergleiche Einzel-Element ($66)
        CPI        R16, 0x66
        BREQ       M_CASE_0731
        RJMP       M_CASE_0730
M_CASE_0731:
 
; Word-Parameter(1) fuer PROCEDURE (SET_CURSOR_POSITION)
        LDS        R0, CSI_PARAMETER1
        LDS        R1, CSI_PARAMETER1+1
 
; Word-Parameter(2) fuer PROCEDURE (SET_CURSOR_POSITION)
        LDS        R2, CSI_PARAMETER2
        LDS        R3, CSI_PARAMETER2+1
 
; Aufruf PROCEDURE (SET_CURSOR_POSITION)
        CALL       SET_CURSOR_POSITION
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0722
M_CASE_0730:
 
; CASE OF - vergleiche Einzel-Element ($6D)
        CPI        R16, 0x6D
        BREQ       M_CASE_0733
        RJMP       M_CASE_0732
M_CASE_0733:
 
; Word-Parameter(1) fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        LDS        R0, CSI_PARAMETER1
        LDS        R1, CSI_PARAMETER1+1
 
; Aufruf PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        CALL       SET_DISPLAY_ATTRIBUTES
 
; Word-Parameter(1) fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        LDS        R0, CSI_PARAMETER2
        LDS        R1, CSI_PARAMETER2+1
 
; Aufruf PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        CALL       SET_DISPLAY_ATTRIBUTES
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0722
 
; CASE OF ELSE
M_CASE_0732:
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; ENDCASE;
M_CASE_0722:
 
; PROCEDURE - Ende (IBM_CSI_PAR_2_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_CSI_PAR_3_TERMINAL_MODE)
IBM_CSI_PAR_3_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Byte-Element-Bereich <von> ($30)
        CPI        R16, 0x30
        BRCC       M_CASE_0737
        RJMP       M_CASE_0735
M_CASE_0737:
 
; CASE OF - vergleiche Byte-Element-Bereich <bis> ($39)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0736
        RJMP       M_CASE_0735
M_CASE_0736:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER3)
        LDS        R16, CSI_PARAMETER3
        LDS        R17, CSI_PARAMETER3+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER3)
        STS        CSI_PARAMETER3, R16
        STS        CSI_PARAMETER3+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER3)
        LDS        R16, CSI_PARAMETER3
        LDS        R17, CSI_PARAMETER3+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R18, ZEICHEN
        CLR        R19
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER3)
        STS        CSI_PARAMETER3, R16
        STS        CSI_PARAMETER3+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER3)
        LDS        R16, CSI_PARAMETER3
        LDS        R17, CSI_PARAMETER3+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER3)
        STS        CSI_PARAMETER3, R16
        STS        CSI_PARAMETER3+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_3)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0734
M_CASE_0735:
 
; CASE OF - vergleiche Einzel-Element ($6D)
        CPI        R16, 0x6D
        BREQ       M_CASE_0739
        RJMP       M_CASE_0738
M_CASE_0739:
 
; CASE OF - Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; CASE OF - vergleiche Einzel-Element (48)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0742
        RJMP       M_CASE_0741
M_CASE_0742:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0746
        CLR        R16
        RJMP       M_VERGL_0747
M_VERGL_0746:
        SER        R16
M_VERGL_0747:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0743
        RJMP       M_IF_0744
M_IF_0743:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(CSI_PARAMETER3)
        LDS        R16, CSI_PARAMETER3
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0745
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0744:
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; IF_THEN_ELSE - Ende
M_IF_0745:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0740
M_CASE_0741:
 
; CASE OF - vergleiche Einzel-Element (38)
        LDI        R18, LOW(0x0026)
        LDI        R19, HIGH(0x0026)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0749
        RJMP       M_CASE_0748
M_CASE_0749:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0753
        CLR        R16
        RJMP       M_VERGL_0754
M_VERGL_0753:
        SER        R16
M_VERGL_0754:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0750
        RJMP       M_IF_0751
M_IF_0750:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(CSI_PARAMETER3)
        LDS        R16, CSI_PARAMETER3
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0752
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0751:
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; IF_THEN_ELSE - Ende
M_IF_0752:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0740
 
; CASE OF ELSE
M_CASE_0748:
 
; Word-Parameter(1) fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        LDS        R0, CSI_PARAMETER1
        LDS        R1, CSI_PARAMETER1+1
 
; Aufruf PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        CALL       SET_DISPLAY_ATTRIBUTES
 
; Word-Parameter(1) fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        LDS        R0, CSI_PARAMETER2
        LDS        R1, CSI_PARAMETER2+1
 
; Aufruf PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        CALL       SET_DISPLAY_ATTRIBUTES
 
; Word-Parameter(1) fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        LDS        R0, CSI_PARAMETER3
        LDS        R1, CSI_PARAMETER3+1
 
; Aufruf PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        CALL       SET_DISPLAY_ATTRIBUTES
 
; ENDCASE;
M_CASE_0740:
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0734
 
; CASE OF ELSE
M_CASE_0738:
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; ENDCASE;
M_CASE_0734:
 
; PROCEDURE - Ende (IBM_CSI_PAR_3_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_GRAFIK_PAR_1_TERMINAL_MODE)
IBM_GRAFIK_PAR_1_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Byte-Element-Bereich <von> ($30)
        CPI        R16, 0x30
        BRCC       M_CASE_0758
        RJMP       M_CASE_0756
M_CASE_0758:
 
; CASE OF - vergleiche Byte-Element-Bereich <bis> ($39)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0757
        RJMP       M_CASE_0756
M_CASE_0757:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R18, ZEICHEN
        CLR        R19
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_GRAFIK_PAR_1_TM)
        LDI        R16, 0x06
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0755
M_CASE_0756:
 
; CASE OF - vergleiche Einzel-Element ($3B)
        CPI        R16, 0x3B
        BREQ       M_CASE_0760
        RJMP       M_CASE_0759
M_CASE_0760:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_GRAFIK_PAR_2_TM)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0755
M_CASE_0759:
 
; CASE OF - vergleiche Einzel-Element ($43)
        CPI        R16, 0x43
        BREQ       M_CASE_0762
        RJMP       M_CASE_0761
M_CASE_0762:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
 
; Zuweisung Ziel /  VAR (PIXCOLOR)
        STS        PIXCOLOR, R16
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0755
M_CASE_0761:
 
; CASE OF - vergleiche Einzel-Element ($4B)
        CPI        R16, 0x4B
        BREQ       M_CASE_0764
        RJMP       M_CASE_0763
M_CASE_0764:
 
; Word-Parameter(1) fuer PROCEDURE (GRAFIKZEICHNEKREIS)
        LDS        R0, CSI_PARAMETER1
        LDS        R1, CSI_PARAMETER1+1
 
; Aufruf PROCEDURE (GRAFIKZEICHNEKREIS)
        CALL       GRAFIKZEICHNEKREIS
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0755
M_CASE_0763:
 
; CASE OF - vergleiche Einzel-Element ($56)
        CPI        R16, 0x56
        BREQ       M_CASE_0766
        RJMP       M_CASE_0765
M_CASE_0766:
 
; Word-Parameter(1) fuer PROCEDURE (GRAFIKZEICHNEVOLLENKREIS)
        LDS        R0, CSI_PARAMETER1
        LDS        R1, CSI_PARAMETER1+1
 
; Aufruf PROCEDURE (GRAFIKZEICHNEVOLLENKREIS)
        CALL       GRAFIKZEICHNEVOLLENKREIS
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0755
 
; CASE OF ELSE
M_CASE_0765:
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; ENDCASE;
M_CASE_0755:
 
; PROCEDURE - Ende (IBM_GRAFIK_PAR_1_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_GRAFIK_PAR_2_TERMINAL_MODE)
IBM_GRAFIK_PAR_2_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Byte-Element-Bereich <von> ($30)
        CPI        R16, 0x30
        BRCC       M_CASE_0770
        RJMP       M_CASE_0768
M_CASE_0770:
 
; CASE OF - vergleiche Byte-Element-Bereich <bis> ($39)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0769
        RJMP       M_CASE_0768
M_CASE_0769:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R18, ZEICHEN
        CLR        R19
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_GRAFIK_PAR_2_TM)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0767
M_CASE_0768:
 
; CASE OF - vergleiche Einzel-Element ($47)
        CPI        R16, 0x47
        BREQ       M_CASE_0772
        RJMP       M_CASE_0771
M_CASE_0772:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0767
M_CASE_0771:
 
; CASE OF - vergleiche Einzel-Element ($50)
        CPI        R16, 0x50
        BREQ       M_CASE_0774
        RJMP       M_CASE_0773
M_CASE_0774:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (GRAFIKDRAWPOINT)
        CALL       GRAFIKDRAWPOINT
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0767
M_CASE_0773:
 
; CASE OF - vergleiche Einzel-Element ($4C)
        CPI        R16, 0x4C
        BREQ       M_CASE_0776
        RJMP       M_CASE_0775
M_CASE_0776:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Ziel /  VAR (X_END_POS)
        STS        X_END_POS, R16
        STS        X_END_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Ziel /  VAR (Y_END_POS)
        STS        Y_END_POS, R16
        STS        Y_END_POS+1, R17
 
; Aufruf PROCEDURE (GRAFIKDRAWLINE)
        CALL       GRAFIKDRAWLINE
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0767
M_CASE_0775:
 
; CASE OF - vergleiche Einzel-Element ($52)
        CPI        R16, 0x52
        BREQ       M_CASE_0778
        RJMP       M_CASE_0777
M_CASE_0778:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Ziel /  VAR (X_END_POS)
        STS        X_END_POS, R16
        STS        X_END_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Ziel /  VAR (Y_END_POS)
        STS        Y_END_POS, R16
        STS        Y_END_POS+1, R17
 
; Aufruf PROCEDURE (GRAFIKDRAWRECTANGLE)
        CALL       GRAFIKDRAWRECTANGLE
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0767
M_CASE_0777:
 
; CASE OF - vergleiche Einzel-Element ($46)
        CPI        R16, 0x46
        BREQ       M_CASE_0780
        RJMP       M_CASE_0779
M_CASE_0780:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Ziel /  VAR (X_END_POS)
        STS        X_END_POS, R16
        STS        X_END_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Ziel /  VAR (Y_END_POS)
        STS        Y_END_POS, R16
        STS        Y_END_POS+1, R17
 
; Aufruf PROCEDURE (GRAFIKDRAWFULLRECTANGLE)
        CALL       GRAFIKDRAWFULLRECTANGLE
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0767
 
; CASE OF ELSE
M_CASE_0779:
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; ENDCASE;
M_CASE_0767:
 
; PROCEDURE - Ende (IBM_GRAFIK_PAR_2_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (CONOUT)
CONOUT:
 
; IF THEN - Ausdruck / Byte-VAR (KURSOR_SICHTBAR)
        LDS        R16, KURSOR_SICHTBAR
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0781
        RJMP       M_IF_0782
M_IF_0781:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (SCHALTE_KURSOR_AUS)
        CALL       SCHALTE_KURSOR_AUS
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_SICHTBAR)
        STS        KURSOR_SICHTBAR, R16
 
; IF_THEN - Ende
M_IF_0782:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KURSOR_SCHLEIFE)
        STS        KURSOR_SCHLEIFE, R16
        STS        KURSOR_SCHLEIFE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURARR_AKTUELL)
        STS        KURARR_AKTUELL, R16
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (TERMMODE)
        LDS        R16, TERMMODE
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NORMAL_TM)
        LDI        R18, 0x00
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0787
        CLR        R16
        RJMP       M_VERGL_0788
M_VERGL_0787:
        SER        R16
M_VERGL_0788:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0784
        RJMP       M_IF_0785
M_IF_0784:
 
; Zuweisung Quelle - Ausdruck / Char-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C_ZEICHEN)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ESCAPE_SEQUENZ)=10
        LDI        R16, 10
        CLR        R17
        LDI        ZL, LOW(ESCAPE_SEQUENZ)
        LDI        ZH, HIGH(ESCAPE_SEQUENZ)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0789
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0789:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0791
M_PRG_CONST_STRING_0790:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0790
M_PRG_CONST_STRING_0791:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C_ZEICHEN)
        MOV        R19, R0
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0792
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0792:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ESCAPE_SEQUENZ) - Laenge in R17
        LDI        ZL, LOW(ESCAPE_SEQUENZ)
        LDI        ZH, HIGH(ESCAPE_SEQUENZ)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0794
        MOV        R16, R17
M_PRG_CONST_STRING_0793:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0793
M_PRG_CONST_STRING_0794:
        ST         -Z, R17
 
; IF_THEN - Ende
M_IF_0785:
 
; CASE OF - Byte-VAR (TERMMODE)
        LDS        R16, TERMMODE
 
; CASE OF - vergleiche Einzel-Element (NORMAL_TM)
        CPI        R16, 0x00
        BREQ       M_CASE_0797
        RJMP       M_CASE_0796
M_CASE_0797:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (NORMAL_TERMINAL_MODE)
        CALL       NORMAL_TERMINAL_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0795
M_CASE_0796:
 
; CASE OF - vergleiche Einzel-Element (IBM_ESC_TM)
        CPI        R16, 0x01
        BREQ       M_CASE_0799
        RJMP       M_CASE_0798
M_CASE_0799:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (IBM_ESC_TERMINAL_MODE)
        CALL       IBM_ESC_TERMINAL_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0795
M_CASE_0798:
 
; CASE OF - vergleiche Einzel-Element (IBM_CSI_TM)
        CPI        R16, 0x02
        BREQ       M_CASE_0801
        RJMP       M_CASE_0800
M_CASE_0801:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (IBM_CSI_TERMINAL_MODE)
        CALL       IBM_CSI_TERMINAL_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0795
M_CASE_0800:
 
; CASE OF - vergleiche Einzel-Element (IBM_CSI_TM_PAR_1)
        CPI        R16, 0x03
        BREQ       M_CASE_0803
        RJMP       M_CASE_0802
M_CASE_0803:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        CALL       IBM_CSI_PAR_1_TERMINAL_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0795
M_CASE_0802:
 
; CASE OF - vergleiche Einzel-Element (IBM_CSI_TM_PAR_2)
        CPI        R16, 0x04
        BREQ       M_CASE_0805
        RJMP       M_CASE_0804
M_CASE_0805:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (IBM_CSI_PAR_2_TERMINAL_MODE)
        CALL       IBM_CSI_PAR_2_TERMINAL_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0795
M_CASE_0804:
 
; CASE OF - vergleiche Einzel-Element (IBM_CSI_TM_PAR_3)
        CPI        R16, 0x05
        BREQ       M_CASE_0807
        RJMP       M_CASE_0806
M_CASE_0807:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (IBM_CSI_PAR_3_TERMINAL_MODE)
        CALL       IBM_CSI_PAR_3_TERMINAL_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0795
M_CASE_0806:
 
; CASE OF - vergleiche Einzel-Element (IBM_GRAFIK_PAR_1_TM)
        CPI        R16, 0x06
        BREQ       M_CASE_0809
        RJMP       M_CASE_0808
M_CASE_0809:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (IBM_GRAFIK_PAR_1_TERMINAL_MODE)
        CALL       IBM_GRAFIK_PAR_1_TERMINAL_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0795
M_CASE_0808:
 
; CASE OF - vergleiche Einzel-Element (IBM_GRAFIK_PAR_2_TM)
        CPI        R16, 0x07
        BREQ       M_CASE_0811
        RJMP       M_CASE_0810
M_CASE_0811:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (IBM_GRAFIK_PAR_2_TERMINAL_MODE)
        CALL       IBM_GRAFIK_PAR_2_TERMINAL_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0795
 
; CASE OF ELSE
M_CASE_0810:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; ENDCASE;
M_CASE_0795:
 
; PROCEDURE - Ende (CONOUT)
        RET
 
; PROCEDURE - Anfang (SENDE_ZEICHEN)
SENDE_ZEICHEN:
 
; WHILE DO ...
M_WHILE_0812:
 
; WHILE - Ausdruck /; BitLow(UDRE0)
        LDS        R16, UCSR0A
        BST        R16, 5
        BRTC       M_VERGL_0815
        CLR        R16
        RJMP       M_VERGL_0816
M_VERGL_0815:
        SER        R16
M_VERGL_0816:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0813
        RJMP       M_WHILE_0814
M_WHILE_0813:
 
; SetBit(LED_GN)
        SBI        PORTD, 7
 
; WHILE DO ...
        RJMP       M_WHILE_0812
M_WHILE_0814:
 
; ClearBit(LED_GN)
        CBI        PORTD, 7
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (S_ZEICHEN)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (UDR0)
        STS        UDR0, R16
 
; PROCEDURE - Ende (SENDE_ZEICHEN)
        RET
 
; PROCEDURE - Anfang (RX_PUFFER_ABFRAGEN)
RX_PUFFER_ABFRAGEN:
 
; IF THEN - Ausdruck /; BitHigh(RXC0)
        LDS        R16, UCSR0A
        BST        R16, 7
        BRTS       M_VERGL_0820
        CLR        R16
        RJMP       M_VERGL_0821
M_VERGL_0820:
        SER        R16
M_VERGL_0821:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0817
        RJMP       M_IF_0818
M_IF_0817:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (UDR0)
        LDS        R16, UDR0
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Aufruf PROCEDURE (CONOUT)
        CALL       CONOUT
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x11
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; IF_THEN - Ende
M_IF_0818:
 
; PROCEDURE - Ende (RX_PUFFER_ABFRAGEN)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; ASM
.equ UBRR0 = UBRR0L

 
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_FONT)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_FONT)
        CALL       SETZE_FONT
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (KOPIEBWS)
        STS        KOPIEBWS, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (KURSOR_EIN)
        STS        KURSOR_EIN, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_SICHTBAR)
        STS        KURSOR_SICHTBAR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURARR_AKTUELL)
        STS        KURARR_AKTUELL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KURSOR_SCHLEIFE)
        STS        KURSOR_SCHLEIFE, R16
        STS        KURSOR_SCHLEIFE+1, R17
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (ESCAPE_SEQUENZ)=10
        LDI        R16, 10
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('')
        LDI        ZL, LOW(2*M_CONST_STRING_1)
        LDI        ZH, HIGH(2*M_CONST_STRING_1)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0822
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0822:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0824
M_PRG_CONST_STRING_0823:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0823
M_PRG_CONST_STRING_0824:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ESCAPE_SEQUENZ) - Laenge in R17
        LDI        ZL, LOW(ESCAPE_SEQUENZ)
        LDI        ZH, HIGH(ESCAPE_SEQUENZ)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0826
        MOV        R16, R17
M_PRG_CONST_STRING_0825:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0825
M_PRG_CONST_STRING_0826:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER3)
        STS        CSI_PARAMETER3, R16
        STS        CSI_PARAMETER3+1, R17
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; Aufruf PROCEDURE (INIT_SER_PORT)
        CALL       INIT_SER_PORT
 
; Aufruf PROCEDURE (INIT_BILD_ADRESSE)
        CALL       INIT_BILD_ADRESSE
 
; ClearBit(LED_GN)
        CBI        PORTD, 7
 
; ClearBit(VS1_GS2)
        CBI        PORTD, 5
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(WE)
        SBI        PORTD, 3
 
; SetBit(DIR)
        SBI        PORTD, 6
 
; SetBit(OE)
        SBI        PORTD, 4
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(A16)
        CBI        PORTD, 2
 
; Aufruf PROCEDURE (RESET_FORM)
        CALL       RESET_FORM
 
; Zuweisung Quelle - Ausdruck / ArrayToAdress(BILD5_256)
        LDI        R16, LOW(2*BILD5_256)
        LDI        R17, HIGH(2*BILD5_256)
 
; Zuweisung Ziel /  VAR (BILD_ADRESSE)
        STS        BILD_ADRESSE, R16
        STS        BILD_ADRESSE+1, R17
 
; Aufruf PROCEDURE (KOPIERE_HINTERGRUNDBILD)
        CALL       KOPIERE_HINTERGRUNDBILD
 
; Aufruf PROCEDURE (KOPIERE_KREIS)
        CALL       KOPIERE_KREIS
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x11
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; LOOP - Start_Marke
M_LOOP_0827:
 
; Aufruf PROCEDURE (RX_PUFFER_ABFRAGEN)
        CALL       RX_PUFFER_ABFRAGEN
 
; INC(KURSOR_SCHLEIFE) - Word
        LDS        R24, KURSOR_SCHLEIFE
        LDS        R25, KURSOR_SCHLEIFE+1
        ADIW       R25:R24, 1
        STS        KURSOR_SCHLEIFE, R24
        STS        KURSOR_SCHLEIFE+1, R25
 
; IF THEN - Ausdruck / Byte-VAR (KURSOR_EIN)
        LDS        R16, KURSOR_EIN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0828
        RJMP       M_IF_0829
M_IF_0828:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KURSOR_SCHLEIFE)
        LDS        R16, KURSOR_SCHLEIFE
        LDS        R17, KURSOR_SCHLEIFE+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xF618)
        LDI        R18, LOW(0xF618)
        LDI        R19, HIGH(0xF618)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0834
        CLR        R16
        RJMP       M_VERGL_0835
M_VERGL_0834:
        SER        R16
M_VERGL_0835:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0831
        RJMP       M_IF_0832
M_IF_0831:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KURSOR_SCHLEIFE)
        STS        KURSOR_SCHLEIFE, R16
        STS        KURSOR_SCHLEIFE+1, R17
 
; IF THEN - Ausdruck / Byte-VAR (KURSOR_SICHTBAR)
        LDS        R16, KURSOR_SICHTBAR
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0836
        RJMP       M_IF_0837
M_IF_0836:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_SICHTBAR)
        STS        KURSOR_SICHTBAR, R16
 
; Aufruf PROCEDURE (SCHALTE_KURSOR_AUS)
        CALL       SCHALTE_KURSOR_AUS
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0838
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0837:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (KURSOR_SICHTBAR)
        STS        KURSOR_SICHTBAR, R16
 
; Aufruf PROCEDURE (SCHALTE_KURSOR_EIN)
        CALL       SCHALTE_KURSOR_EIN
 
; IF_THEN_ELSE - Ende
M_IF_0838:
 
; IF_THEN - Ende
M_IF_0832:
 
; IF_THEN - Ende
M_IF_0829:
 
; LOOP - Ende
        RJMP       M_LOOP_0827
 
; *** Unterprogramm Bibliothek ***
; Division von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 24.01.2013
;
; Uebergabe: R16 Divident Low
;            R17 Divident High
;            R18 Divisor Low
;            R19 Divisor High
; Ergebnis:  R16 Quotient Low
;            R17 Quotient High
;            R18 Rest Low 
;            R19 Rest High 
; Temporaere Register: R20,R21,R22


ASM_UP_MDIV16:

        LDI        R20, 16   ; 16 Schritte 

        MOV        R21, R18  ; R21 = Divisor Low
        MOV        R22, R19  ; R22 = Divisor High

        CLR        R18       ; R18 = Rest Low loeschen
        CLR        R19       ; R19 = Rest High loeschen
ASM_UP_MDIV16a:
			      
        LSL        R16       ; Divident Low links Quotient links Bit_0 <- 0   
        ROL        R17       ; Divident High
        ROL        R18       ; Rest Low
        ROL        R19       ; Rest High

        CP         R18, R21  ; Test Rest Low - Divisor Low
        CPC        R19, R22  ; Test Rest High - Divisor High

        BRLO       ASM_UP_MDIV16b   ; Rest < Divisor : Quotient Bit_0 bleibt 0

        SUB        R18, R21  ; Rest Low >= Divisor Low abziehen
        SBC        R19, R22  ; Rest High >= Divisor High abziehen

        INC        R16       ; Quotient Bit_0 wird 1
ASM_UP_MDIV16b:

        DEC        R20       ; Zaehler - 1
        BRNE       ASM_UP_MDIV16a   ; wiederhole 16 mal



        RET






; Division von 2 32-Bit Zahlen (DWORD)
; Version 1.0, Stand 28.05.2013
;
; Uebergabe: R16 Divident D0
;            R17 Divident D1
;            R18 Divident D2
;            R19 Divident D3
;            R20 Divisor D0
;            R21 Divisor D1
;            R22 Divisor D2
;            R23 Divisor D3
;
;  Ergebnis: R16 Quotient D0
;            R17 Quotient D1
;            R18 Quotient D2
;            R19 Quotient D3
;            R20 Rest D0
;            R21 Rest D1
;            R22 Rest D2
;            R23 Rest D3
;
; Temporaere Register: R24,R25,R26,R27,R28


ASM_UP_MDIV32:

        LDI        R24, 32   ; 32 Schritte 

        MOV        R25, R20  ; R25 = Divisor D0
        MOV        R26, R21  ; R26 = Divisor D1
        MOV        R27, R22  ; R27 = Divisor D2
        MOV        R28, R23  ; R28 = Divisor D3

        CLR        R20       ; R20 = Rest D0 loeschen
        CLR        R21       ; R21 = Rest D1 loeschen
        CLR        R22       ; R22 = Rest D2 loeschen
        CLR        R23       ; R23 = Rest D3 loeschen

ASM_UP_MDIV32a:
			      
        LSL        R16       ; Divident D0 links Quotient links Bit_0 <- 0   
        ROL        R17       ; Divident D1
        ROL        R18       ; Divident D2
        ROL        R19       ; Divident D3
        ROL        R20       ; Rest D0
        ROL        R21       ; Rest D1
        ROL        R22       ; Rest D2
        ROL        R23       ; Rest D3

        CP         R20, R25  ; Test Rest D0 - Divisor D0
        CPC        R21, R26  ; Test Rest D1 - Divisor D1
        CPC        R22, R27  ; Test Rest D2 - Divisor D2
        CPC        R23, R28  ; Test Rest D3 - Divisor D3

        BRLO       ASM_UP_MDIV32b   ; Rest < Divisor : Quotient Bit_0 bleibt 0

        SUB        R20, R25  ; Rest D0 >= Divisor D0 abziehen
        SBC        R21, R26  ; Rest D1 >= Divisor D1 abziehen
        SBC        R22, R27  ; Rest D2 >= Divisor D2 abziehen
        SBC        R23, R28  ; Rest D3 >= Divisor D3 abziehen

        INC        R16       ; Quotient Bit_0 wird 1
ASM_UP_MDIV32b:

        DEC        R24       ; Zaehler - 1
        BRNE       ASM_UP_MDIV32a   ; wiederhole 32 mal



        RET






; Multiplikation von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17 erster Faktor
;            R18:R19 zweiter Faktor
; Temporaere Register: R20,R21,R22,R23,R24 
;                      R2 ,R3  R4  R5  R6
ASM_UP_MUL16:
 
        PUSH       R0
        PUSH       R1

        CLR        R24
        MUL        R19, R17
        MOVW       R23:R22, R1:R0
        MUL        R18, R16
        MOVW       R21:R20, R1:R0
        MUL        R19, R16
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MUL        R17, R18
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MOVW       R17:R16, R21:R20       ; Produkt Low
        MOVW       R19:R18, R23:R22       ; Produkt High

        POP        R1
        POP        R0		

        RET






; Multiplikation von 2 32-Bit Zahlen (DWORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17:18:19 erster Faktor
;            R20:R21:22:23 zweiter Faktor
; Temporaere Register: R24,R25,R26,R27,R28
;                      R20,R21,R22,R23,R24
ASM_UP_MUL32:

        PUSH       R0
        PUSH       R1

        CLR        R28
        MUL        R21, R17
        MOVW       R27:R26, R1:R0
        MUL        R20, R16
        MOVW       R25:R24, R1:R0
        MUL        R21, R16
        ADD        R25, R0
        ADC        R26, R1
        ADC        R27, R28
        MUL        R17, R20
        ADD        R25, R0
        ADC        R26, R1
        ADC        R27, R28
        MOVW       R17:R16, R25:R24       ; Produkt Low
        MOVW       R19:R18, R27:R26       ; Produkt High

        POP        R1
        POP        R0		

        RET






 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; PCMSK3 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; UBRR0 (V) WORDCONVAR
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; BAUDRATE (C) WORD Wert=0x62A5
; UBRR_VAL (C) WORD Wert=0x0031
; XON (C) BYTE Wert=0x11
; XOFF (C) BYTE Wert=0x13
; FNT_6X8 (C) BYTE Wert=0x01
; FNT_8X8 (C) BYTE Wert=0x02
; CL_WHITE (C) BYTE Wert=0xFF
; CL_BLACK (C) BYTE Wert=0x00
; CL_RED (C) BYTE Wert=0x43
; CL_GREEN (C) BYTE Wert=0x4C
; CL_BLUE (C) BYTE Wert=0xB0
; CL_YELLOW (C) BYTE Wert=0x4F
; CL_PURPLE (C) BYTE Wert=0x73
; CL_AQUA (C) BYTE Wert=0x7C
; CL_GRAY (C) BYTE Wert=0x6A
; CL_DARKGRAY (C) BYTE Wert=0x2A
; NORMAL_TM (C) BYTE Wert=0x00
; IBM_ESC_TM (C) BYTE Wert=0x01
; IBM_CSI_TM (C) BYTE Wert=0x02
; IBM_CSI_TM_PAR_1 (C) BYTE Wert=0x03
; IBM_CSI_TM_PAR_2 (C) BYTE Wert=0x04
; IBM_CSI_TM_PAR_3 (C) BYTE Wert=0x05
; IBM_GRAFIK_PAR_1_TM (C) BYTE Wert=0x06
; IBM_GRAFIK_PAR_2_TM (C) BYTE Wert=0x07
; FONT6X8 (A) 
; FONT8X8 (A) 
; BILD5_256 (A) 
; KREIS2A (A) 
; SINTAB (A) 
; A16 (B) BIT
; WE (B) BIT
; OE (B) BIT
; VS1_GS2 (B) BIT
; DIR (B) BIT
; LED_GN (B) BIT
; FCOLOR (V) BYTE
; BCOLOR (V) BYTE
; PIXCOLOR (V) BYTE
; ZEICHEN (V) BYTE
; X_KUR_POS (V) WORD
; Y_KUR_POS (V) WORD
; X_PIX_POS (V) WORD
; Y_PIX_POS (V) WORD
; X_END_POS (V) WORD
; Y_END_POS (V) WORD
; KURSOR_SCHLEIFE (V) WORD
; KURSOR_SICHTBAR (V) BOOLEAN
; KURSOR_EIN (V) BOOLEAN
; KURARR_AKTUELL (V) BOOLEAN
; KURSOR_ARRAY (Y) BYTE
; CHAR_ARRAY (Y) BYTE
; EBENE1_ARRAY (Y) BYTE
; E1_X_PIX_POS (V) WORD
; E1_Y_PIX_POS (V) WORD
; EBENE2_ARRAY (Y) BYTE
; E2_X_PIX_POS (V) WORD
; E2_Y_PIX_POS (V) WORD
; ICON_ADRESS (V) ADRESS
; TERMMODE (V) BYTE
; CSI_PARAMETER1 (V) WORD
; CSI_PARAMETER2 (V) WORD
; CSI_PARAMETER3 (V) WORD
; DELTA_X (V) WORD
; DELTA_Y (V) WORD
; SIN_DW1 (V) DWORD
; SIN_DW2 (V) DWORD
; ESCAPE_SEQUENZ (V) STRING
; ZEICHENBREITE (V) WORD
; ZEICHENHOEHE (V) WORD
; MAX_SPALTEN2 (V) WORD
; MAX_ZEILEN2 (V) WORD
; X_ANF (V) WORD
; Y_ANF (V) WORD
; MAX_SPALTEN (V) WORD
; MAX_ZEILEN (V) WORD
; FONT_BEZ (V) BYTE
; ZEICHENBREITE0 (V) BYTE
; KOPIEBWS (V) BOOLEAN
; BILD_ADRESSE (V) ADRESS
; INITPORTS (P) 
; INIT_SER_PORT (P) 
; INIT_BILD_ADRESSE (P) 
; SETZE_FONT (P) 
; WAIT_MS (P) 
; CLEAR_RAM (P) 
; SCREENROLL (P) 
; UMSCHALTEN_SPEICHERSEITE (P) 
; RESET_FORM (P) 
; SCHREIBE_BILD (P) 
; VRAM_TO_ICON_ARRAY (P) 
; RETTE_ICON (P) 
; ICON_ARRAY_TO_VRAM (P) 
; ZURUECK_ICON (P) 
; KOPIERE_KREIS (P) 
; KOPIERE_HINTERGRUNDBILD (P) 
; SET_POINT (P) 
; GRAFIKDRAWPOINT (P) 
; SET_POINT_POS (P) 
; LINE_TO (P) 
; GRAFIKDRAWLINE (P) 
; DRAW_REC (P) 
; GRAFIKDRAWRECTANGLE (P) 
; DRAW_FULL_REC (P) 
; GRAFIKDRAWFULLRECTANGLE (P) 
; SINUS (F) 
; GRAFIKZEICHNEKREIS_ON_RAMPAGE (P) 
; GRAFIKZEICHNEKREIS (P) 
; ZEICHNE_WAAGERECHTEN_STRICH (P) 
; GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE (P) 
; GRAFIKZEICHNEVOLLENKREIS (P) 
; WRITE_CHAR_6X8 (P) 
; WRITE_CHAR_8X8 (P) 
; WRITE_CHAR (P) 
; VRAM_TO_KURSOR_ARRAY (P) 
; KURSOR_ARRAY_TO_VRAM (P) 
; SCHALTE_KURSOR_EIN (P) 
; SCHALTE_KURSOR_AUS (P) 
; VRAM_TO_CHAR_ARRAY (P) 
; CHAR_ARRAY_TO_VRAM (P) 
; CURSOR_UP (P) 
; DELETE_EOL (P) 
; DELETE_BOL (P) 
; DELETE_LINE (P) 
; CLEAR_LINE_ON_RAMPAGE (P) 
; DELETE_LAST_LINE_ON_RAMPAGE (P) 
; DELETE_LINE_SCR_ROLL_ON_RAMPAGE (P) 
; DELETE_LINE_SCR_ROLL (P) 
; INSERT_LINE_SCR_ROLL_ON_RAMPAGE (P) 
; INSERT_LINE_SCR_ROLL (P) 
; ERASE_DOWN_ON_RAMPAGE (P) 
; ERASE_DOWN (P) 
; SET_CURSOR_POSITION (P) 
; CURSOR_RIGHT (P) 
; WRITE_CHAR_IN_BEIDE_RP (P) 
; NORMAL_TERMINAL_MODE (P) 
; ESCAPE_RESET (P) 
; ESCAPE_FEHLER (P) 
; IBM_ESC_TERMINAL_MODE (P) 
; SET_DISPLAY_ATTRIBUTES (P) 
; IBM_CSI_TERMINAL_MODE (P) 
; IBM_CSI_PAR_1_TERMINAL_MODE (P) 
; IBM_CSI_PAR_2_TERMINAL_MODE (P) 
; IBM_CSI_PAR_3_TERMINAL_MODE (P) 
; IBM_GRAFIK_PAR_1_TERMINAL_MODE (P) 
; IBM_GRAFIK_PAR_2_TERMINAL_MODE (P) 
; CONOUT (P) 
; SENDE_ZEICHEN (P) 
; RX_PUFFER_ABFRAGEN (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE INITPORTS;
; PROCEDURE INIT_SER_PORT;
; PROCEDURE INIT_BILD_ADRESSE;
; PROCEDURE SETZE_FONT (FONTGROESSE : BYTE);
; PROCEDURE WAIT_MS (ZEIT : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE CLEAR_RAM (X1 : WORD) (X2 : WORD) (ADRESSE : WORD);
; PROCEDURE SCREENROLL;
; PROCEDURE UMSCHALTEN_SPEICHERSEITE;
; PROCEDURE RESET_FORM;
; PROCEDURE SCHREIBE_BILD (X1 : WORD) (X2 : BYTE) (X_BIS : WORD) (Y_BIS : BYTE) (B_WERT : BYTE) (ADRESSE : WORD) (B_POINTER : WORD) (OFFSET : WORD);
; PROCEDURE VRAM_TO_ICON_ARRAY (X_PIXEL_POS : WORD) (Y_PIXEL_POS : WORD) (ADRESSE : WORD) (X_CNT : BYTE) (Y_CNT : BYTE) (ARRAY_POS : WORD);
; PROCEDURE RETTE_ICON;
; PROCEDURE ICON_ARRAY_TO_VRAM (X_PIXEL_POS : WORD) (Y_PIXEL_POS : WORD) (ADRESSE : WORD) (X_CNT : BYTE) (Y_CNT : BYTE) (ARRAY_POS : WORD);
; PROCEDURE ZURUECK_ICON;
; PROCEDURE KOPIERE_KREIS (K_ZAEHLER : WORD);
; PROCEDURE KOPIERE_HINTERGRUNDBILD;
; PROCEDURE SET_POINT (ADRESSE : WORD);
; PROCEDURE GRAFIKDRAWPOINT;
; PROCEDURE SET_POINT_POS (X_POINT_POS : WORD) (Y_POINT_POS : WORD) (ADRESSE : WORD);
; PROCEDURE LINE_TO (X1 : WORD) (XP_ANF : WORD) (XP_END : WORD) (Y1 : WORD) (YP_ANF : WORD) (YP_END : WORD);
; PROCEDURE GRAFIKDRAWLINE;
; PROCEDURE DRAW_REC (ADRESSE : WORD) (W1 : WORD) (YR_POS : WORD);
; PROCEDURE GRAFIKDRAWRECTANGLE;
; PROCEDURE DRAW_FULL_REC (ADRESSE : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE GRAFIKDRAWFULLRECTANGLE;
; FUNCTION SINUS (WINKEL : WORD) (RADIUS : WORD) (W1 : WORD) : WORD;
; PROCEDURE GRAFIKZEICHNEKREIS_ON_RAMPAGE (RADIUS : WORD) (X1 : WORD) (Y1 : WORD) (WINKEL : WORD) (X_RADIUS : WORD);
; PROCEDURE GRAFIKZEICHNEKREIS (RADIUS : WORD);
; PROCEDURE ZEICHNE_WAAGERECHTEN_STRICH (ADRESSE : WORD) (W1 : WORD);
; PROCEDURE GRAFIKZEICHNEVOLLENKREIS_ON_RAMPAGE (RADIUS : WORD) (X_PIX_POS2 : WORD) (Y_PIX_POS2 : WORD) (WINKEL : WORD) (X_RADIUS : WORD);
; PROCEDURE GRAFIKZEICHNEVOLLENKREIS (RADIUS : WORD);
; PROCEDURE WRITE_CHAR_6X8 (FONTPTR : WORD) (X_CNT : BYTE) (Y_CNT : WORD) (FONTCOLOR : BYTE) (FONTZEILE : BYTE) (ADRESSE : WORD);
; PROCEDURE WRITE_CHAR_8X8 (FONTPTR : WORD) (X_CNT : BYTE) (Y_CNT : WORD) (FONTCOLOR : BYTE) (FONTZEILE : BYTE) (ADRESSE : WORD);
; PROCEDURE WRITE_CHAR;
; PROCEDURE VRAM_TO_KURSOR_ARRAY (ADRESSE : WORD) (X_CNT : BYTE) (Y_CNT : BYTE) (ARRAY_POS : WORD);
; PROCEDURE KURSOR_ARRAY_TO_VRAM (ADRESSE : WORD) (X_CNT : BYTE) (Y_CNT : BYTE) (ARRAY_POS : WORD);
; PROCEDURE SCHALTE_KURSOR_EIN;
; PROCEDURE SCHALTE_KURSOR_AUS;
; PROCEDURE VRAM_TO_CHAR_ARRAY (X_PIXEL_POS : WORD) (Y_PIXEL_POS : WORD) (ADRESSE : WORD) (X_CNT : BYTE) (Y_CNT : BYTE) (ARRAY_POS : WORD);
; PROCEDURE CHAR_ARRAY_TO_VRAM (X_PIXEL_POS : WORD) (Y_PIXEL_POS : WORD) (ADRESSE : WORD) (X_CNT : BYTE) (Y_CNT : BYTE) (ARRAY_POS : WORD);
; PROCEDURE CURSOR_UP;
; PROCEDURE DELETE_EOL (KUR_POS_CNT : WORD) (X_KUR_POS2 : WORD) (X_PIX_POS2 : WORD);
; PROCEDURE DELETE_BOL (KUR_POS_CNT : WORD) (X_KUR_POS2 : WORD) (X_PIX_POS2 : WORD);
; PROCEDURE DELETE_LINE (KUR_POS_CNT : WORD) (X_KUR_POS2 : WORD) (X_PIX_POS2 : WORD);
; PROCEDURE CLEAR_LINE_ON_RAMPAGE (KUR_POS_CNT : WORD) (X_KUR_POS2 : WORD) (X_PIX_POS2 : WORD);
; PROCEDURE DELETE_LAST_LINE_ON_RAMPAGE (KUR_POS_CNT : WORD) (X_KUR_POS2 : WORD) (X_PIX_POS2 : WORD) (Y_KUR_POS2 : WORD) (Y_PIX_POS2 : WORD);
; PROCEDURE DELETE_LINE_SCR_ROLL_ON_RAMPAGE (KUR_POS_X_CNT : WORD) (KUR_POS_Y_CNT : WORD) (X_PIXEL_POS : WORD) (Y_PIX_POS_VON : WORD) (Y_PIX_POS_NACH : WORD);
; PROCEDURE DELETE_LINE_SCR_ROLL;
; PROCEDURE INSERT_LINE_SCR_ROLL_ON_RAMPAGE (KUR_POS_X_CNT : WORD) (KUR_POS_Y_CNT : WORD) (X_PIXEL_POS : WORD) (Y_PIX_POS_VON : WORD) (Y_PIX_POS_NACH : WORD);
; PROCEDURE INSERT_LINE_SCR_ROLL;
; PROCEDURE ERASE_DOWN_ON_RAMPAGE (KUR_POS_X_CNT : BYTE) (KUR_POS_Y_CNT : WORD) (X_KUR_POS2 : WORD) (X_PIX_POS2 : WORD) (Y_KUR_POS2 : WORD) (Y_PIX_POS2 : WORD);
; PROCEDURE ERASE_DOWN;
; PROCEDURE SET_CURSOR_POSITION (ZEILE : WORD) (SPALTE : WORD);
; PROCEDURE CURSOR_RIGHT;
; PROCEDURE WRITE_CHAR_IN_BEIDE_RP;
; PROCEDURE NORMAL_TERMINAL_MODE;
; PROCEDURE ESCAPE_RESET;
; PROCEDURE ESCAPE_FEHLER (ESC_ZAEHLER : BYTE) (ESC_LAENGE : BYTE) (ESC_ZEICHEN : CHAR);
; PROCEDURE IBM_ESC_TERMINAL_MODE;
; PROCEDURE SET_DISPLAY_ATTRIBUTES (DISPATTR : WORD);
; PROCEDURE IBM_CSI_TERMINAL_MODE;
; PROCEDURE IBM_CSI_PAR_1_TERMINAL_MODE (ZAEHLER : WORD);
; PROCEDURE IBM_CSI_PAR_2_TERMINAL_MODE;
; PROCEDURE IBM_CSI_PAR_3_TERMINAL_MODE;
; PROCEDURE IBM_GRAFIK_PAR_1_TERMINAL_MODE;
; PROCEDURE IBM_GRAFIK_PAR_2_TERMINAL_MODE;
; PROCEDURE CONOUT (C_ZEICHEN : CHAR);
; PROCEDURE SENDE_ZEICHEN (S_ZEICHEN : BYTE);
; PROCEDURE RX_PUFFER_ABFRAGEN;
 
; *** Konstanten-ARRAYs ***
;
 
FONT6X8:
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x20,0x70
 .db    0x70,0x20
 .db    0x20,0x00
 .db    0x20,0x00
 .db    0xD8,0xD8
 .db    0x48,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x50
 .db    0xF8,0x50
 .db    0x50,0xF8
 .db    0x50,0x00
 .db    0x10,0x70
 .db    0x08,0x30
 .db    0x40,0x38
 .db    0x20,0x00
 .db    0x98,0x98
 .db    0x40,0x20
 .db    0x10,0xC8
 .db    0xC8,0x00
 .db    0x10,0x28
 .db    0x28,0x10
 .db    0xA8,0x48
 .db    0xB0,0x00
 .db    0x30,0x30
 .db    0x10,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x20,0x10
 .db    0x10,0x10
 .db    0x10,0x10
 .db    0x20,0x00
 .db    0x10,0x20
 .db    0x20,0x20
 .db    0x20,0x20
 .db    0x10,0x00
 .db    0x00,0x50
 .db    0x70,0xF8
 .db    0x70,0x50
 .db    0x00,0x00
 .db    0x00,0x20
 .db    0x20,0xF8
 .db    0x20,0x20
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x30
 .db    0x30,0x10
 .db    0x00,0x00
 .db    0x00,0xF8
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x30
 .db    0x30,0x00
 .db    0x00,0x80
 .db    0x40,0x20
 .db    0x10,0x08
 .db    0x00,0x00
 .db    0x70,0x88
 .db    0xC8,0xA8
 .db    0x98,0x88
 .db    0x70,0x00
 .db    0x20,0x30
 .db    0x20,0x20
 .db    0x20,0x20
 .db    0x70,0x00
 .db    0x70,0x88
 .db    0x80,0x60
 .db    0x10,0x08
 .db    0xF8,0x00
 .db    0x70,0x88
 .db    0x80,0x70
 .db    0x80,0x88
 .db    0x70,0x00
 .db    0x40,0x60
 .db    0x50,0x48
 .db    0xF8,0x40
 .db    0x40,0x00
 .db    0xF8,0x08
 .db    0x08,0x78
 .db    0x80,0x88
 .db    0x70,0x00
 .db    0x60,0x10
 .db    0x08,0x78
 .db    0x88,0x88
 .db    0x70,0x00
 .db    0xF8,0x80
 .db    0x40,0x20
 .db    0x10,0x10
 .db    0x10,0x00
 .db    0x70,0x88
 .db    0x88,0x70
 .db    0x88,0x88
 .db    0x70,0x00
 .db    0x70,0x88
 .db    0x88,0xF0
 .db    0x80,0x40
 .db    0x30,0x00
 .db    0x00,0x00
 .db    0x30,0x30
 .db    0x00,0x30
 .db    0x30,0x00
 .db    0x00,0x00
 .db    0x30,0x30
 .db    0x00,0x30
 .db    0x30,0x10
 .db    0x40,0x20
 .db    0x10,0x08
 .db    0x10,0x20
 .db    0x40,0x00
 .db    0x00,0x00
 .db    0xF8,0x00
 .db    0x00,0xF8
 .db    0x00,0x00
 .db    0x10,0x20
 .db    0x40,0x80
 .db    0x40,0x20
 .db    0x10,0x00
 .db    0x70,0x88
 .db    0x80,0x60
 .db    0x20,0x00
 .db    0x20,0x00
 .db    0x70,0x88
 .db    0xE8,0xA8
 .db    0xE8,0x08
 .db    0x70,0x00
 .db    0x70,0x88
 .db    0x88,0x88
 .db    0xF8,0x88
 .db    0x88,0x00
 .db    0x78,0x88
 .db    0x88,0x78
 .db    0x88,0x88
 .db    0x78,0x00
 .db    0x70,0x88
 .db    0x08,0x08
 .db    0x08,0x88
 .db    0x70,0x00
 .db    0x78,0x88
 .db    0x88,0x88
 .db    0x88,0x88
 .db    0x78,0x00
 .db    0xF8,0x08
 .db    0x08,0x78
 .db    0x08,0x08
 .db    0xF8,0x00
 .db    0xF8,0x08
 .db    0x08,0x78
 .db    0x08,0x08
 .db    0x08,0x00
 .db    0x70,0x88
 .db    0x08,0xE8
 .db    0x88,0x88
 .db    0xF0,0x00
 .db    0x88,0x88
 .db    0x88,0xF8
 .db    0x88,0x88
 .db    0x88,0x00
 .db    0x70,0x20
 .db    0x20,0x20
 .db    0x20,0x20
 .db    0x70,0x00
 .db    0x80,0x80
 .db    0x80,0x80
 .db    0x88,0x88
 .db    0x70,0x00
 .db    0x88,0x48
 .db    0x28,0x18
 .db    0x28,0x48
 .db    0x88,0x00
 .db    0x08,0x08
 .db    0x08,0x08
 .db    0x08,0x08
 .db    0xF8,0x00
 .db    0x88,0xD8
 .db    0xA8,0x88
 .db    0x88,0x88
 .db    0x88,0x00
 .db    0x88,0x98
 .db    0xA8,0xC8
 .db    0x88,0x88
 .db    0x88,0x00
 .db    0x70,0x88
 .db    0x88,0x88
 .db    0x88,0x88
 .db    0x70,0x00
 .db    0x78,0x88
 .db    0x88,0x78
 .db    0x08,0x08
 .db    0x08,0x00
 .db    0x70,0x88
 .db    0x88,0x88
 .db    0xA8,0x48
 .db    0xB0,0x00
 .db    0x78,0x88
 .db    0x88,0x78
 .db    0x48,0x88
 .db    0x88,0x00
 .db    0x70,0x88
 .db    0x08,0x70
 .db    0x80,0x88
 .db    0x70,0x00
 .db    0xF8,0x20
 .db    0x20,0x20
 .db    0x20,0x20
 .db    0x20,0x00
 .db    0x88,0x88
 .db    0x88,0x88
 .db    0x88,0x88
 .db    0x70,0x00
 .db    0x88,0x88
 .db    0x88,0x88
 .db    0x88,0x50
 .db    0x20,0x00
 .db    0x88,0x88
 .db    0xA8,0xA8
 .db    0xA8,0xA8
 .db    0x50,0x00
 .db    0x88,0x88
 .db    0x50,0x20
 .db    0x50,0x88
 .db    0x88,0x00
 .db    0x88,0x88
 .db    0x88,0x50
 .db    0x20,0x20
 .db    0x20,0x00
 .db    0x78,0x40
 .db    0x20,0x10
 .db    0x08,0x08
 .db    0x78,0x00
 .db    0x70,0x10
 .db    0x10,0x10
 .db    0x10,0x10
 .db    0x70,0x00
 .db    0x00,0x08
 .db    0x10,0x20
 .db    0x40,0x80
 .db    0x00,0x00
 .db    0x70,0x40
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x70,0x00
 .db    0x20,0x50
 .db    0x88,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0xFC
 .db    0x30,0x30
 .db    0x20,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x70,0x80
 .db    0xF0,0x88
 .db    0xF0,0x00
 .db    0x08,0x08
 .db    0x78,0x88
 .db    0x88,0x88
 .db    0x78,0x00
 .db    0x00,0x00
 .db    0x70,0x88
 .db    0x08,0x88
 .db    0x70,0x00
 .db    0x80,0x80
 .db    0xF0,0x88
 .db    0x88,0x88
 .db    0xF0,0x00
 .db    0x00,0x00
 .db    0x70,0x88
 .db    0x78,0x08
 .db    0x70,0x00
 .db    0x60,0x10
 .db    0x10,0x78
 .db    0x10,0x10
 .db    0x10,0x00
 .db    0x00,0x00
 .db    0xF0,0x88
 .db    0x88,0xF0
 .db    0x80,0x70
 .db    0x08,0x08
 .db    0x38,0x48
 .db    0x48,0x48
 .db    0x48,0x00
 .db    0x20,0x00
 .db    0x20,0x20
 .db    0x20,0x20
 .db    0x60,0x00
 .db    0x40,0x00
 .db    0x60,0x40
 .db    0x40,0x40
 .db    0x48,0x30
 .db    0x08,0x08
 .db    0x48,0x28
 .db    0x18,0x28
 .db    0x48,0x00
 .db    0x20,0x20
 .db    0x20,0x20
 .db    0x20,0x20
 .db    0x60,0x00
 .db    0x00,0x00
 .db    0x58,0xA8
 .db    0xA8,0x88
 .db    0x88,0x00
 .db    0x00,0x00
 .db    0x38,0x48
 .db    0x48,0x48
 .db    0x48,0x00
 .db    0x00,0x00
 .db    0x70,0x88
 .db    0x88,0x88
 .db    0x70,0x00
 .db    0x00,0x00
 .db    0x78,0x88
 .db    0x88,0x88
 .db    0x78,0x08
 .db    0x00,0x00
 .db    0xF0,0x88
 .db    0x88,0x88
 .db    0xF0,0x80
 .db    0x00,0x00
 .db    0x68,0x90
 .db    0x10,0x10
 .db    0x38,0x00
 .db    0x00,0x00
 .db    0x70,0x08
 .db    0x70,0x80
 .db    0x70,0x00
 .db    0x00,0x10
 .db    0x78,0x10
 .db    0x10,0x50
 .db    0x20,0x00
 .db    0x00,0x00
 .db    0x48,0x48
 .db    0x48,0x68
 .db    0x50,0x00
 .db    0x00,0x00
 .db    0x88,0x88
 .db    0x88,0x50
 .db    0x20,0x00
 .db    0x00,0x00
 .db    0x88,0x88
 .db    0xA8,0xF8
 .db    0x50,0x00
 .db    0x00,0x00
 .db    0x48,0x48
 .db    0x30,0x48
 .db    0x48,0x00
 .db    0x00,0x00
 .db    0x48,0x48
 .db    0x48,0x70
 .db    0x20,0x18
 .db    0x00,0x00
 .db    0x78,0x40
 .db    0x30,0x08
 .db    0x78,0x00
 .db    0x60,0x10
 .db    0x10,0x18
 .db    0x10,0x10
 .db    0x60,0x00
 .db    0x20,0x20
 .db    0x20,0x00
 .db    0x20,0x20
 .db    0x20,0x00
 .db    0x30,0x40
 .db    0x40,0xC0
 .db    0x40,0x40
 .db    0x30,0x00
 .db    0x50,0x28
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x20,0x70
 .db    0xD8,0x88
 .db    0x88,0xF8
 .db    0x00,0x00
 
FONT8X8:
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x0C,0x1E
 .db    0x1E,0x0C
 .db    0x0C,0x00
 .db    0x0C,0x00
 .db    0x36,0x36
 .db    0x36,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x36,0x36
 .db    0x7F,0x36
 .db    0x7F,0x36
 .db    0x36,0x00
 .db    0x0C,0x3E
 .db    0x03,0x1E
 .db    0x30,0x1F
 .db    0x0C,0x00
 .db    0x00,0x63
 .db    0x33,0x18
 .db    0x0C,0x66
 .db    0x63,0x00
 .db    0x1C,0x36
 .db    0x1C,0x6E
 .db    0x3B,0x33
 .db    0x6E,0x00
 .db    0x06,0x06
 .db    0x03,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x18,0x0C
 .db    0x06,0x06
 .db    0x06,0x0C
 .db    0x18,0x00
 .db    0x06,0x0C
 .db    0x18,0x18
 .db    0x18,0x0C
 .db    0x06,0x00
 .db    0x00,0x66
 .db    0x3C,0xFF
 .db    0x3C,0x66
 .db    0x00,0x00
 .db    0x00,0x0C
 .db    0x0C,0x3F
 .db    0x0C,0x0C
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x0E
 .db    0x0C,0x06
 .db    0x00,0x00
 .db    0x00,0x3F
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x0C
 .db    0x0C,0x00
 .db    0x60,0x30
 .db    0x18,0x0C
 .db    0x06,0x03
 .db    0x01,0x00
 .db    0x1E,0x33
 .db    0x3B,0x3F
 .db    0x37,0x33
 .db    0x1E,0x00
 .db    0x0C,0x0F
 .db    0x0C,0x0C
 .db    0x0C,0x0C
 .db    0x3F,0x00
 .db    0x1E,0x33
 .db    0x30,0x1C
 .db    0x06,0x33
 .db    0x3F,0x00
 .db    0x1E,0x33
 .db    0x30,0x1C
 .db    0x30,0x33
 .db    0x1E,0x00
 .db    0x38,0x3C
 .db    0x36,0x33
 .db    0x7F,0x30
 .db    0x30,0x00
 .db    0x3F,0x03
 .db    0x1F,0x30
 .db    0x30,0x33
 .db    0x1E,0x00
 .db    0x1C,0x06
 .db    0x03,0x1F
 .db    0x33,0x33
 .db    0x1E,0x00
 .db    0x3F,0x33
 .db    0x30,0x18
 .db    0x0C,0x06
 .db    0x06,0x00
 .db    0x1E,0x33
 .db    0x33,0x1E
 .db    0x33,0x33
 .db    0x1E,0x00
 .db    0x1E,0x33
 .db    0x33,0x3E
 .db    0x30,0x18
 .db    0x0E,0x00
 .db    0x00,0x00
 .db    0x0C,0x0C
 .db    0x00,0x0C
 .db    0x0C,0x00
 .db    0x00,0x00
 .db    0x0C,0x0C
 .db    0x00,0x0E
 .db    0x0C,0x06
 .db    0x18,0x0C
 .db    0x06,0x03
 .db    0x06,0x0C
 .db    0x18,0x00
 .db    0x00,0x00
 .db    0x3F,0x00
 .db    0x3F,0x00
 .db    0x00,0x00
 .db    0x06,0x0C
 .db    0x18,0x30
 .db    0x18,0x0C
 .db    0x06,0x00
 .db    0x1E,0x33
 .db    0x30,0x18
 .db    0x0C,0x00
 .db    0x0C,0x00
 .db    0x3E,0x63
 .db    0x7B,0x7B
 .db    0x7B,0x03
 .db    0x1E,0x00
 .db    0x0C,0x1E
 .db    0x33,0x33
 .db    0x3F,0x33
 .db    0x33,0x00
 .db    0x3F,0x66
 .db    0x66,0x3E
 .db    0x66,0x66
 .db    0x3F,0x00
 .db    0x3C,0x66
 .db    0x03,0x03
 .db    0x03,0x66
 .db    0x3C,0x00
 .db    0x3F,0x36
 .db    0x66,0x66
 .db    0x66,0x36
 .db    0x3F,0x00
 .db    0x7F,0x46
 .db    0x16,0x1E
 .db    0x16,0x46
 .db    0x7F,0x00
 .db    0x7F,0x46
 .db    0x16,0x1E
 .db    0x16,0x06
 .db    0x0F,0x00
 .db    0x3C,0x66
 .db    0x03,0x03
 .db    0x73,0x66
 .db    0x7C,0x00
 .db    0x33,0x33
 .db    0x33,0x3F
 .db    0x33,0x33
 .db    0x33,0x00
 .db    0x1E,0x0C
 .db    0x0C,0x0C
 .db    0x0C,0x0C
 .db    0x1E,0x00
 .db    0x78,0x30
 .db    0x30,0x30
 .db    0x33,0x33
 .db    0x1E,0x00
 .db    0x67,0x66
 .db    0x36,0x1E
 .db    0x36,0x66
 .db    0x67,0x00
 .db    0x0F,0x06
 .db    0x06,0x06
 .db    0x46,0x66
 .db    0x7F,0x00
 .db    0x63,0x77
 .db    0x7F,0x6B
 .db    0x63,0x63
 .db    0x63,0x00
 .db    0x63,0x67
 .db    0x6F,0x7B
 .db    0x73,0x63
 .db    0x63,0x00
 .db    0x1C,0x36
 .db    0x63,0x63
 .db    0x63,0x36
 .db    0x1C,0x00
 .db    0x3F,0x66
 .db    0x66,0x3E
 .db    0x06,0x06
 .db    0x0F,0x00
 .db    0x1E,0x33
 .db    0x33,0x33
 .db    0x3B,0x1E
 .db    0x38,0x00
 .db    0x3F,0x66
 .db    0x66,0x3E
 .db    0x1E,0x36
 .db    0x67,0x00
 .db    0x1E,0x33
 .db    0x07,0x1C
 .db    0x38,0x33
 .db    0x1E,0x00
 .db    0x3F,0x2D
 .db    0x0C,0x0C
 .db    0x0C,0x0C
 .db    0x1E,0x00
 .db    0x33,0x33
 .db    0x33,0x33
 .db    0x33,0x33
 .db    0x3F,0x00
 .db    0x33,0x33
 .db    0x33,0x33
 .db    0x33,0x1E
 .db    0x0C,0x00
 .db    0x63,0x63
 .db    0x63,0x6B
 .db    0x7F,0x77
 .db    0x63,0x00
 .db    0x63,0x63
 .db    0x36,0x1C
 .db    0x36,0x63
 .db    0x63,0x00
 .db    0x33,0x33
 .db    0x33,0x1E
 .db    0x0C,0x0C
 .db    0x1E,0x00
 .db    0x7F,0x33
 .db    0x19,0x0C
 .db    0x46,0x63
 .db    0x7F,0x00
 .db    0x1E,0x06
 .db    0x06,0x06
 .db    0x06,0x06
 .db    0x1E,0x00
 .db    0x03,0x06
 .db    0x0C,0x18
 .db    0x30,0x60
 .db    0x40,0x00
 .db    0x1E,0x18
 .db    0x18,0x18
 .db    0x18,0x18
 .db    0x1E,0x00
 .db    0x08,0x1C
 .db    0x36,0x63
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0xFF
 .db    0x0C,0x0C
 .db    0x18,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x1E,0x30
 .db    0x3E,0x33
 .db    0x6E,0x00
 .db    0x07,0x06
 .db    0x3E,0x66
 .db    0x66,0x66
 .db    0x3D,0x00
 .db    0x00,0x00
 .db    0x1E,0x33
 .db    0x03,0x33
 .db    0x1E,0x00
 .db    0x38,0x30
 .db    0x30,0x3E
 .db    0x33,0x33
 .db    0x6E,0x00
 .db    0x00,0x00
 .db    0x1E,0x33
 .db    0x3F,0x03
 .db    0x1E,0x00
 .db    0x1C,0x36
 .db    0x06,0x0F
 .db    0x06,0x06
 .db    0x0F,0x00
 .db    0x00,0x00
 .db    0x6E,0x33
 .db    0x33,0x3E
 .db    0x30,0x1F
 .db    0x07,0x06
 .db    0x36,0x6E
 .db    0x66,0x66
 .db    0x67,0x00
 .db    0x0C,0x00
 .db    0x0E,0x0C
 .db    0x0C,0x0C
 .db    0x1E,0x00
 .db    0x18,0x00
 .db    0x1E,0x18
 .db    0x18,0x18
 .db    0x1B,0x0E
 .db    0x07,0x06
 .db    0x66,0x36
 .db    0x1E,0x36
 .db    0x67,0x00
 .db    0x0E,0x0C
 .db    0x0C,0x0C
 .db    0x0C,0x0C
 .db    0x1E,0x00
 .db    0x00,0x00
 .db    0x37,0x7F
 .db    0x6B,0x63
 .db    0x63,0x00
 .db    0x00,0x00
 .db    0x1F,0x33
 .db    0x33,0x33
 .db    0x33,0x00
 .db    0x00,0x00
 .db    0x1E,0x33
 .db    0x33,0x33
 .db    0x1E,0x00
 .db    0x00,0x00
 .db    0x3B,0x66
 .db    0x66,0x3E
 .db    0x06,0x0F
 .db    0x00,0x00
 .db    0x6E,0x33
 .db    0x33,0x3E
 .db    0x30,0x78
 .db    0x00,0x00
 .db    0x1B,0x36
 .db    0x36,0x06
 .db    0x0F,0x00
 .db    0x00,0x00
 .db    0x3E,0x03
 .db    0x1E,0x30
 .db    0x1F,0x00
 .db    0x08,0x0C
 .db    0x3E,0x0C
 .db    0x0C,0x2C
 .db    0x18,0x00
 .db    0x00,0x00
 .db    0x33,0x33
 .db    0x33,0x33
 .db    0x6E,0x00
 .db    0x00,0x00
 .db    0x33,0x33
 .db    0x33,0x1E
 .db    0x0C,0x00
 .db    0x00,0x00
 .db    0x63,0x63
 .db    0x6B,0x7F
 .db    0x36,0x00
 .db    0x00,0x00
 .db    0x63,0x36
 .db    0x1C,0x36
 .db    0x63,0x00
 .db    0x00,0x00
 .db    0x33,0x33
 .db    0x33,0x3E
 .db    0x30,0x1F
 .db    0x00,0x00
 .db    0x3F,0x19
 .db    0x0C,0x26
 .db    0x3F,0x00
 .db    0x38,0x0C
 .db    0x0C,0x07
 .db    0x0C,0x0C
 .db    0x38,0x00
 .db    0x18,0x18
 .db    0x18,0x00
 .db    0x18,0x18
 .db    0x18,0x00
 .db    0x07,0x0C
 .db    0x0C,0x38
 .db    0x0C,0x0C
 .db    0x07,0x00
 .db    0x6E,0x3B
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x08,0x1C
 .db    0x36,0x63
 .db    0x63,0x63
 .db    0x7F,0x00
 
BILD5_256:
 .db    0x00,0x80
 .db    0xF0,0x45
 .db    0x45,0x19
 .db    0x44,0x40
 .db    0x40,0x40
 .db    0x15,0x45
 .db    0x45,0x44
 .db    0x44,0x44
 .db    0x44,0x44
 .db    0x19,0x45
 .db    0x1A,0x49
 .db    0x1A,0x45
 .db    0x45,0x45
 .db    0x45,0x19
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0x19,0x44
 .db    0x44,0x19
 .db    0x19,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x44
 .db    0x40,0x40
 .db    0x15,0x45
 .db    0x45,0x6B
 .db    0x7F,0x7B
 .db    0x7F,0x7B
 .db    0x7B,0xD1
 .db    0xC0,0x1E
 .db    0x49,0x45
 .db    0x45,0x49
 .db    0x49,0x45
 .db    0x45,0x45
 .db    0x49,0x49
 .db    0x1E,0x1E
 .db    0x49,0x49
 .db    0x1E,0x1A
 .db    0x1A,0x49
 .db    0x49,0x49
 .db    0x0E,0x0E
 .db    0x49,0x49
 .db    0x1E,0x1B
 .db    0x92,0x63
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x52,0x53
 .db    0x63,0x63
 .db    0x63,0x53
 .db    0x53,0x27
 .db    0x4A,0x4E
 .db    0x4E,0x4E
 .db    0x4E,0x4E
 .db    0x4E,0x4E
 .db    0xC5,0x7B
 .db    0x7B,0xE2
 .db    0xD2,0xD2
 .db    0xE2,0x7F
 .db    0x2F,0x1E
 .db    0x1E,0x89
 .db    0xC4,0x3F
 .db    0xD0,0x49
 .db    0x49,0x45
 .db    0x44,0x40
 .db    0x40,0x40
 .db    0x15,0x45
 .db    0x45,0x19
 .db    0x44,0x44
 .db    0x44,0x44
 .db    0x19,0x19
 .db    0x45,0x1A
 .db    0x1A,0x45
 .db    0x45,0x45
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0x19,0x44
 .db    0x19,0x19
 .db    0x19,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x44
 .db    0x40,0x40
 .db    0x15,0x45
 .db    0x1A,0x6B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x96
 .db    0x85,0x49
 .db    0x49,0x45
 .db    0x45,0x49
 .db    0x49,0x45
 .db    0x45,0x45
 .db    0x45,0x49
 .db    0x1E,0x1E
 .db    0x49,0x49
 .db    0x1E,0x1A
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x0E,0x49
 .db    0x49,0x1E
 .db    0x1E,0x4A
 .db    0xC1,0x92
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x52,0x53
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x53,0x2B
 .db    0x1E,0x4E
 .db    0x4E,0x4E
 .db    0x4E,0x4E
 .db    0x4E,0x5E
 .db    0x7B,0x7B
 .db    0xE2,0x77
 .db    0xA3,0x77
 .db    0xE2,0x7B
 .db    0x3F,0x1E
 .db    0x2F,0xC5
 .db    0xD5,0x7B
 .db    0x7B,0x49
 .db    0x49,0x49
 .db    0x45,0x40
 .db    0x05,0x40
 .db    0x15,0x15
 .db    0x19,0x45
 .db    0x44,0x44
 .db    0x44,0x44
 .db    0x19,0x19
 .db    0x45,0x1A
 .db    0x49,0x1A
 .db    0x45,0x45
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0x19,0x44
 .db    0x44,0x44
 .db    0x19,0x19
 .db    0x19,0x45
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x1E
 .db    0x49,0x44
 .db    0x40,0x40
 .db    0x15,0x1A
 .db    0x2B,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0xD1
 .db    0x6B,0x2F
 .db    0x1E,0x1E
 .db    0x49,0x1A
 .db    0x49,0x1A
 .db    0x49,0x45
 .db    0x45,0x45
 .db    0x45,0x49
 .db    0x1E,0x1E
 .db    0x49,0x1E
 .db    0x1A,0x1A
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x0E,0x49
 .db    0x1E,0x1E
 .db    0x1E,0x1E
 .db    0xC0,0x63
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x2B,0x4A
 .db    0x4D,0x4D
 .db    0x4E,0x4E
 .db    0x4E,0x4E
 .db    0x89,0x6F
 .db    0x7B,0xE2
 .db    0x77,0x77
 .db    0x77,0xB2
 .db    0xE2,0x7B
 .db    0x6B,0x2F
 .db    0x3F,0x7B
 .db    0xE1,0xB6
 .db    0xB6,0x49
 .db    0x49,0x49
 .db    0x45,0x40
 .db    0x05,0x40
 .db    0x15,0x15
 .db    0x45,0x19
 .db    0x44,0x44
 .db    0x44,0x44
 .db    0x44,0x44
 .db    0x19,0x1A
 .db    0x49,0x1A
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x19,0x19
 .db    0x19,0x44
 .db    0x09,0x44
 .db    0x19,0x19
 .db    0x19,0x45
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x1E
 .db    0x1E,0x19
 .db    0x40,0x40
 .db    0x15,0x80
 .db    0x3B,0xD1
 .db    0xD1,0x7B
 .db    0xD1,0xC1
 .db    0xC0,0x1E
 .db    0x1E,0x84
 .db    0xC0,0x7A
 .db    0xC0,0x84
 .db    0x1A,0x45
 .db    0x45,0x45
 .db    0x45,0x49
 .db    0x1E,0x1E
 .db    0x49,0x1E
 .db    0x1A,0x45
 .db    0x45,0x49
 .db    0x09,0x0E
 .db    0x0E,0x49
 .db    0x1E,0x1E
 .db    0x1E,0x1E
 .db    0x2B,0x63
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x63,0x73
 .db    0x73,0x63
 .db    0x4A,0x1E
 .db    0x4D,0x4D
 .db    0x4E,0x4E
 .db    0x4E,0x4E
 .db    0xC5,0x7B
 .db    0xE2,0xB3
 .db    0x77,0x77
 .db    0xA3,0xB2
 .db    0xB3,0xA7
 .db    0x6B,0xC1
 .db    0xD1,0x7B
 .db    0xB2,0xB2
 .db    0xB2,0x1A
 .db    0x49,0x49
 .db    0x1A,0x44
 .db    0x05,0x40
 .db    0x40,0x15
 .db    0x45,0x19
 .db    0x44,0x44
 .db    0x44,0x44
 .db    0x44,0x44
 .db    0x44,0x1A
 .db    0x49,0x1A
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x19,0x19
 .db    0x19,0x44
 .db    0x09,0x44
 .db    0x19,0x19
 .db    0x19,0x45
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x1E
 .db    0x1E,0x19
 .db    0x40,0x40
 .db    0x15,0x2A
 .db    0x3B,0xA2
 .db    0xD1,0xA6
 .db    0xC1,0xC0
 .db    0x84,0x49
 .db    0x85,0xD5
 .db    0xFA,0xFF
 .db    0xFA,0xE5
 .db    0x84,0x45
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x1E,0x1E
 .db    0x1E,0x1E
 .db    0x1A,0x1A
 .db    0x45,0x0A
 .db    0x49,0x49
 .db    0x0E,0x49
 .db    0x1E,0x1E
 .db    0x1E,0x1E
 .db    0x2B,0x63
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x63
 .db    0x63,0x73
 .db    0x73,0x92
 .db    0x4A,0x4D
 .db    0x4D,0x4D
 .db    0x4E,0x89
 .db    0x4E,0x89
 .db    0xD5,0xE2
 .db    0xE2,0xB3
 .db    0x77,0x77
 .db    0xA3,0xE2
 .db    0xB3,0xE2
 .db    0xA6,0xD1
 .db    0x77,0xA2
 .db    0x77,0xB2
 .db    0xB2,0x45
 .db    0x49,0x49
 .db    0x49,0x19
 .db    0x40,0x40
 .db    0x40,0x15
 .db    0x45,0x45
 .db    0x19,0x44
 .db    0x44,0x44
 .db    0x44,0x44
 .db    0x44,0x45
 .db    0x49,0x49
 .db    0x1A,0x45
 .db    0x45,0x45
 .db    0x45,0x19
 .db    0x19,0x44
 .db    0x44,0x44
 .db    0x19,0x48
 .db    0x19,0x19
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x0E,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x1E
 .db    0x1E,0x19
 .db    0x40,0x40
 .db    0x19,0x2B
 .db    0x3B,0xA2
 .db    0xD1,0xD1
 .db    0x2F,0x84
 .db    0x1A,0x3F
 .db    0xFA,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xBA,0x1A
 .db    0x1A,0x49
 .db    0x45,0x1A
 .db    0x49,0x1E
 .db    0x1E,0x1E
 .db    0x45,0x1A
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x0E,0x1E
 .db    0x1E,0x1E
 .db    0x3B,0x63
 .db    0x63,0x53
 .db    0x53,0x63
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0xA2,0xC1
 .db    0x2F,0x89
 .db    0x4E,0x89
 .db    0xC4,0xC5
 .db    0xC5,0xC5
 .db    0x7B,0xE2
 .db    0xE2,0xE2
 .db    0x77,0x77
 .db    0xE2,0xE2
 .db    0xB2,0xE1
 .db    0xA6,0xA2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x45
 .db    0x1A,0x49
 .db    0x49,0x45
 .db    0x40,0x05
 .db    0x40,0x15
 .db    0x45,0x45
 .db    0x19,0x44
 .db    0x44,0x44
 .db    0x44,0x44
 .db    0x45,0x45
 .db    0x49,0x49
 .db    0x1A,0x1A
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x45,0x44
 .db    0x44,0x44
 .db    0x19,0x48
 .db    0x19,0x19
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x0D,0x09
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x84,0x45
 .db    0x15,0x15
 .db    0x80,0x91
 .db    0x92,0xA2
 .db    0xD1,0x3F
 .db    0x1E,0x84
 .db    0xD0,0xFA
 .db    0xFF,0xFB
 .db    0xFB,0xFB
 .db    0xFB,0xFA
 .db    0xFF,0xC0
 .db    0x1A,0x49
 .db    0x49,0x49
 .db    0x1E,0x1E
 .db    0x85,0x1E
 .db    0x45,0x1A
 .db    0x49,0x49
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x0E,0x1E
 .db    0x1E,0x1E
 .db    0x3B,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x77,0x6B
 .db    0x3F,0x3F
 .db    0xC4,0xC5
 .db    0xD5,0x7B
 .db    0x7B,0x7B
 .db    0xE2,0xE2
 .db    0xE2,0xE2
 .db    0xE2,0xD2
 .db    0xE2,0xE2
 .db    0xE2,0xB2
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x45
 .db    0x1A,0x49
 .db    0x49,0x45
 .db    0x15,0x00
 .db    0x40,0x16
 .db    0x45,0x45
 .db    0x45,0x44
 .db    0x44,0x44
 .db    0x44,0x44
 .db    0x45,0x45
 .db    0x1A,0x49
 .db    0x1A,0x1A
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x19,0x44
 .db    0x44,0x44
 .db    0x19,0x48
 .db    0x44,0x19
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x09,0x09
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x2A,0x80
 .db    0x80,0x80
 .db    0x2A,0x3B
 .db    0x92,0x92
 .db    0xC1,0x85
 .db    0x1E,0x7E
 .db    0xFA,0xFB
 .db    0xFA,0xF6
 .db    0xF6,0xF6
 .db    0xF6,0xF2
 .db    0xFB,0xFA
 .db    0x85,0x85
 .db    0x85,0x85
 .db    0x4A,0x85
 .db    0x85,0x1A
 .db    0x45,0x1A
 .db    0x49,0x45
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x0E,0x1E
 .db    0x1E,0x85
 .db    0xA2,0x73
 .db    0x73,0x63
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x77,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0xE2
 .db    0xE2,0xE2
 .db    0xE2,0xE2
 .db    0xE2,0xE2
 .db    0xE2,0xE2
 .db    0xE2,0xE2
 .db    0xE2,0xB2
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x73,0x73
 .db    0x73,0x1A
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x44,0x04
 .db    0x40,0x45
 .db    0x1A,0x1A
 .db    0x45,0x44
 .db    0x44,0x40
 .db    0x15,0x44
 .db    0x45,0x45
 .db    0x1A,0x49
 .db    0x49,0x1A
 .db    0x19,0x45
 .db    0x45,0x45
 .db    0x19,0x44
 .db    0x44,0x19
 .db    0x49,0x48
 .db    0x44,0x19
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x0D,0x09
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x1A
 .db    0x2A,0x2A
 .db    0x2A,0x2A
 .db    0x3B,0xA2
 .db    0xA2,0x92
 .db    0x2B,0x1A
 .db    0xD5,0xFA
 .db    0xFA,0xBB
 .db    0xB7,0xF2
 .db    0xF2,0xF6
 .db    0xF2,0xF2
 .db    0xF6,0xFF
 .db    0xE5,0xC5
 .db    0xC5,0x2F
 .db    0x85,0x85
 .db    0x1E,0x45
 .db    0x16,0x1A
 .db    0x49,0x45
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x1E
 .db    0x2F,0xC1
 .db    0xA2,0xA2
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0x77,0x77
 .db    0xA6,0xE1
 .db    0xB6,0xE2
 .db    0xE2,0xE2
 .db    0xE2,0xE2
 .db    0xE2,0xE2
 .db    0xB7,0xE2
 .db    0xE2,0xE2
 .db    0xB7,0xB7
 .db    0xB2,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x49
 .db    0x49,0x49
 .db    0x49,0x1A
 .db    0x44,0x05
 .db    0x40,0x45
 .db    0x2A,0x1A
 .db    0x45,0x44
 .db    0x44,0x40
 .db    0x40,0x44
 .db    0x45,0x45
 .db    0x45,0x49
 .db    0x1E,0x1A
 .db    0x19,0x44
 .db    0x45,0x45
 .db    0x19,0x19
 .db    0x44,0x19
 .db    0x49,0x48
 .db    0x44,0x44
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x09
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x80
 .db    0x2A,0x3A
 .db    0x3A,0x65
 .db    0x3B,0xB2
 .db    0xA2,0x3B
 .db    0x2A,0x2A
 .db    0xFA,0xFA
 .db    0xE2,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xB3
 .db    0xB3,0xFB
 .db    0xFF,0x7F
 .db    0xC5,0x2F
 .db    0x1A,0x49
 .db    0x45,0x41
 .db    0x16,0x1A
 .db    0x49,0x45
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x1E,0x6A
 .db    0x3F,0xA2
 .db    0xA2,0xA2
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0xA3,0x73
 .db    0x73,0x73
 .db    0x73,0xA2
 .db    0xA2,0xB2
 .db    0xE2,0xB7
 .db    0xE2,0xE2
 .db    0xE2,0xE2
 .db    0xE2,0xE2
 .db    0xB7,0xB7
 .db    0xE2,0xE6
 .db    0xE6,0xB7
 .db    0xB2,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x63,0x73
 .db    0x73,0x49
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x19,0x05
 .db    0x40,0x80
 .db    0x84,0x49
 .db    0x45,0x44
 .db    0x44,0x44
 .db    0x44,0x44
 .db    0x45,0x45
 .db    0x45,0x49
 .db    0x49,0x45
 .db    0x45,0x44
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0x44,0x45
 .db    0x49,0x49
 .db    0x44,0x44
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x80
 .db    0x2A,0x94
 .db    0x66,0x91
 .db    0xA2,0xB2
 .db    0xA2,0x56
 .db    0x2A,0xFA
 .db    0xFA,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xF6
 .db    0xFB,0xFA
 .db    0x6B,0x3F
 .db    0x2A,0x1A
 .db    0x45,0x15
 .db    0x16,0x1A
 .db    0x49,0x45
 .db    0x45,0x45
 .db    0x49,0x1E
 .db    0x3F,0xD1
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xB3
 .db    0xA3,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB6,0xE2
 .db    0xE2,0xE2
 .db    0xE1,0xB2
 .db    0xB2,0xE2
 .db    0xE2,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0x73,0x49
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x19,0x05
 .db    0x40,0x45
 .db    0x2A,0x1A
 .db    0x45,0x19
 .db    0x44,0x44
 .db    0x44,0x44
 .db    0x45,0x45
 .db    0x19,0x49
 .db    0x49,0x49
 .db    0x19,0x44
 .db    0x44,0x44
 .db    0x45,0x45
 .db    0x44,0x45
 .db    0x49,0x49
 .db    0x44,0x44
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x19
 .db    0x2A,0x3E
 .db    0x3B,0x91
 .db    0x77,0x77
 .db    0x3B,0x2A
 .db    0xBA,0xFF
 .db    0xB7,0xF2
 .db    0xB3,0xB2
 .db    0xB2,0xB3
 .db    0xB2,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xFB
 .db    0xBA,0xD1
 .db    0xC0,0x1A
 .db    0x45,0x15
 .db    0x45,0x1A
 .db    0x49,0x45
 .db    0x45,0x45
 .db    0x1E,0x6A
 .db    0xD1,0x77
 .db    0x73,0x63
 .db    0x63,0x73
 .db    0x73,0xB2
 .db    0xB2,0xB3
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0xB2,0xE2
 .db    0xB6,0xB2
 .db    0x77,0x77
 .db    0x77,0xB2
 .db    0xE2,0xE2
 .db    0xE2,0xB7
 .db    0xF2,0xF2
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x73,0x45
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x19,0x40
 .db    0x05,0x15
 .db    0x55,0x1A
 .db    0x45,0x19
 .db    0x19,0x19
 .db    0x19,0x44
 .db    0x45,0x45
 .db    0x44,0x45
 .db    0x49,0x49
 .db    0x45,0x19
 .db    0x19,0x19
 .db    0x45,0x49
 .db    0x09,0x45
 .db    0x49,0x49
 .db    0x44,0x44
 .db    0x1A,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x19
 .db    0x2A,0x3E
 .db    0x66,0x91
 .db    0xA2,0x92
 .db    0x81,0x7A
 .db    0xFF,0xFA
 .db    0xB3,0xB3
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xF6
 .db    0xFF,0xE5
 .db    0x3F,0x49
 .db    0x49,0x41
 .db    0x1A,0x85
 .db    0x1E,0x45
 .db    0x45,0x49
 .db    0xC0,0xD1
 .db    0x77,0x73
 .db    0x73,0x37
 .db    0x37,0x73
 .db    0x73,0xB2
 .db    0xB2,0xB3
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0xB2,0xB6
 .db    0xE1,0xB2
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xE2
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xB2,0xE2
 .db    0xE1,0x77
 .db    0x73,0x73
 .db    0x73,0x45
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x44,0x40
 .db    0x05,0x15
 .db    0x45,0x1A
 .db    0x45,0x19
 .db    0x19,0x19
 .db    0x19,0x44
 .db    0x44,0x45
 .db    0x44,0x19
 .db    0x49,0x49
 .db    0x45,0x19
 .db    0x19,0x45
 .db    0x45,0x49
 .db    0x0A,0x49
 .db    0x49,0x49
 .db    0x44,0x44
 .db    0x1A,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x19
 .db    0x80,0x90
 .db    0x91,0x91
 .db    0x3B,0x56
 .db    0x2A,0xFA
 .db    0xFB,0xB7
 .db    0xB2,0xB3
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xB2
 .db    0xB3,0xB3
 .db    0xB2,0xB3
 .db    0xF2,0xF2
 .db    0xFB,0xFA
 .db    0xD1,0x49
 .db    0x49,0x45
 .db    0x1A,0x85
 .db    0x4A,0x45
 .db    0x45,0x5A
 .db    0xD1,0x77
 .db    0x73,0x73
 .db    0x73,0x37
 .db    0x33,0x37
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x73
 .db    0x73,0xB2
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB6,0xB2
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xB3
 .db    0xE2,0xF2
 .db    0xE2,0xE2
 .db    0xE2,0xE2
 .db    0xB6,0x77
 .db    0xA2,0x73
 .db    0x73,0x45
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x19,0x40
 .db    0x05,0x40
 .db    0x15,0x45
 .db    0x45,0x45
 .db    0x44,0x19
 .db    0x19,0x19
 .db    0x44,0x44
 .db    0x44,0x44
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x19,0x45
 .db    0x45,0x49
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x19,0x44
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x1A,0x49
 .db    0x49,0x49
 .db    0x45,0x19
 .db    0x80,0x2A
 .db    0x80,0x80
 .db    0x55,0x80
 .db    0xE5,0xF6
 .db    0xFB,0xB3
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xB2
 .db    0xB3,0x73
 .db    0xB3,0x73
 .db    0xB2,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0xFF
 .db    0xD5,0x49
 .db    0x49,0x1A
 .db    0x1A,0x85
 .db    0x85,0x1A
 .db    0x59,0xD1
 .db    0xA6,0x73
 .db    0x73,0x73
 .db    0x72,0x33
 .db    0x33,0x37
 .db    0x73,0x73
 .db    0x77,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x73
 .db    0xA2,0xB2
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB6,0xB2
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xB2
 .db    0xB3,0xE2
 .db    0xE2,0xE2
 .db    0xE2,0xE2
 .db    0xE2,0xE1
 .db    0x77,0xA2
 .db    0x73,0x45
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x19,0x05
 .db    0x05,0x40
 .db    0x15,0x45
 .db    0x45,0x19
 .db    0x19,0x19
 .db    0x19,0x44
 .db    0x44,0x44
 .db    0x44,0x44
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x45,0x45
 .db    0x49,0x49
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x44,0x05
 .db    0x1A,0x49
 .db    0x49,0x0E
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x45,0x19
 .db    0x15,0x19
 .db    0x15,0x15
 .db    0x45,0xC0
 .db    0xFA,0xF6
 .db    0xBB,0xB2
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xB2
 .db    0xB3,0x73
 .db    0xB3,0xB2
 .db    0xB3,0xB3
 .db    0xF2,0xB3
 .db    0xB7,0xFA
 .db    0xFA,0x84
 .db    0x49,0x49
 .db    0x1A,0x85
 .db    0x2F,0x85
 .db    0xD1,0xE1
 .db    0xA2,0x73
 .db    0x73,0x73
 .db    0x72,0x37
 .db    0x37,0x37
 .db    0x37,0x73
 .db    0x73,0x73
 .db    0x77,0x77
 .db    0xB2,0x73
 .db    0xB2,0xA2
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB6,0xE1
 .db    0x77,0x73
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xB2
 .db    0xB2,0xB3
 .db    0xE2,0xE2
 .db    0xE2,0xE2
 .db    0xE2,0xB6
 .db    0x77,0xA2
 .db    0xA2,0x49
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x19,0x44
 .db    0x05,0x40
 .db    0x15,0x45
 .db    0x1A,0x45
 .db    0x19,0x19
 .db    0x19,0x44
 .db    0x44,0x15
 .db    0x44,0x19
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x45,0x45
 .db    0x49,0x45
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x19,0x44
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x0A,0x49
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x80,0xFA
 .db    0xF6,0xF6
 .db    0xB3,0xB3
 .db    0xB2,0xB2
 .db    0xB2,0xB3
 .db    0xB3,0x73
 .db    0xB3,0xB2
 .db    0xB3,0xB3
 .db    0xB3,0xB2
 .db    0xF2,0xB3
 .db    0xB3,0xB7
 .db    0xFB,0x7A
 .db    0x49,0x49
 .db    0x1E,0x5A
 .db    0xC1,0x3F
 .db    0xE1,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x33,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x37,0x73
 .db    0xA2,0x73
 .db    0xA2,0x73
 .db    0xA2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xE1
 .db    0x77,0x73
 .db    0x77,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0xE2,0xB7
 .db    0xE2,0xE2
 .db    0xE2,0xB6
 .db    0x77,0xA2
 .db    0xA2,0x49
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x19,0x44
 .db    0x05,0x40
 .db    0x40,0x19
 .db    0x1A,0x49
 .db    0x19,0x09
 .db    0x19,0x19
 .db    0x44,0x15
 .db    0x44,0x45
 .db    0x49,0x1E
 .db    0x49,0x45
 .db    0x45,0x49
 .db    0x49,0x45
 .db    0x09,0x0E
 .db    0x0E,0x49
 .db    0x19,0x44
 .db    0x1A,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x0A,0x49
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x15,0x40
 .db    0x15,0x15
 .db    0x7A,0xFA
 .db    0xF2,0xB3
 .db    0x73,0xF6
 .db    0xB3,0xB3
 .db    0xB2,0xB3
 .db    0xB2,0xB2
 .db    0xB3,0x73
 .db    0xB2,0xB2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xBB,0xFA
 .db    0x1E,0x1E
 .db    0x4A,0x2F
 .db    0x6F,0x7B
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x37,0x73
 .db    0xA2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xE1
 .db    0x77,0x77
 .db    0x77,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xE2
 .db    0xE2,0xE2
 .db    0xE2,0xE1
 .db    0x77,0x77
 .db    0xA2,0x49
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x45,0x44
 .db    0x05,0x05
 .db    0x40,0x15
 .db    0x1A,0x49
 .db    0x19,0x09
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x1A,0x49
 .db    0x49,0x49
 .db    0x09,0x0E
 .db    0x0E,0x49
 .db    0x49,0x45
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x1A
 .db    0x15,0x40
 .db    0x40,0x80
 .db    0xFB,0xB7
 .db    0xB3,0xB3
 .db    0xB3,0xF6
 .db    0xB2,0xB2
 .db    0xB3,0xB3
 .db    0xB2,0xB2
 .db    0xB3,0x73
 .db    0xB3,0xB2
 .db    0xB3,0xB7
 .db    0xB2,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xFB
 .db    0x3F,0x1F
 .db    0x1F,0x2F
 .db    0x7F,0xE1
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x37,0x73
 .db    0xA2,0x73
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xE1
 .db    0x77,0x77
 .db    0x77,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0x73,0xB2
 .db    0xB2,0xB6
 .db    0xE2,0xE2
 .db    0x7B,0x7B
 .db    0x7B,0x77
 .db    0x77,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x44
 .db    0x15,0x05
 .db    0x40,0x15
 .db    0x1A,0x49
 .db    0x19,0x19
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x49,0x1E
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x0E
 .db    0x0E,0x0E
 .db    0x49,0x49
 .db    0x49,0x1E
 .db    0x1E,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x15,0x40
 .db    0x15,0x7A
 .db    0xFB,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xB3
 .db    0xB2,0xB2
 .db    0x77,0xB3
 .db    0xB3,0xB2
 .db    0xB3,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB2,0x73
 .db    0xB2,0xB3
 .db    0xB3,0xB7
 .db    0xEA,0x85
 .db    0x1F,0x2F
 .db    0x7F,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x37,0x73
 .db    0x73,0x73
 .db    0x63,0x63
 .db    0x63,0x73
 .db    0xA2,0x73
 .db    0x73,0x73
 .db    0xB2,0xE1
 .db    0x77,0x77
 .db    0x77,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xE2,0xE2
 .db    0x7B,0x7B
 .db    0xA6,0x77
 .db    0x77,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x19
 .db    0x44,0x05
 .db    0x40,0x15
 .db    0x45,0x49
 .db    0x45,0x19
 .db    0x45,0x45
 .db    0x1A,0x45
 .db    0x45,0x45
 .db    0x49,0x1E
 .db    0x1E,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x0E
 .db    0x0E,0x49
 .db    0x49,0x1E
 .db    0x49,0x49
 .db    0x1E,0x49
 .db    0x49,0x49
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x15,0x15
 .db    0x15,0xFB
 .db    0xE2,0xB3
 .db    0xB3,0xF6
 .db    0xF2,0xB2
 .db    0xB3,0xB2
 .db    0x73,0xB7
 .db    0xB2,0xB3
 .db    0xB7,0xF2
 .db    0xB2,0xB2
 .db    0xB3,0xB3
 .db    0xB3,0x73
 .db    0xB2,0xB3
 .db    0xB3,0xE2
 .db    0xFF,0x95
 .db    0x1F,0x6B
 .db    0xE1,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x37,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x73,0xA2
 .db    0x77,0x77
 .db    0x73,0x73
 .db    0xB2,0xE1
 .db    0x7B,0x77
 .db    0x7B,0x77
 .db    0xB2,0xB2
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xE2,0xB6
 .db    0xA6,0x7B
 .db    0x7B,0x7B
 .db    0x77,0x49
 .db    0x49,0x45
 .db    0x49,0x49
 .db    0x45,0x19
 .db    0x44,0x40
 .db    0x05,0x40
 .db    0x45,0x49
 .db    0x49,0x09
 .db    0x45,0x45
 .db    0x49,0x45
 .db    0x44,0x45
 .db    0x49,0x1E
 .db    0x1E,0x1E
 .db    0x1E,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x0E,0x0E
 .db    0x49,0x1E
 .db    0x1E,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x49
 .db    0x49,0x1E
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x40,0x15
 .db    0x3A,0xF6
 .db    0xB3,0xB3
 .db    0xB3,0xB7
 .db    0xE2,0xB2
 .db    0xB3,0x73
 .db    0xB3,0xF2
 .db    0xB3,0xF2
 .db    0xB3,0xF6
 .db    0xB2,0x73
 .db    0xF2,0xE2
 .db    0xF2,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xFB,0x7F
 .db    0x85,0x7B
 .db    0x77,0x73
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x37
 .db    0x37,0x37
 .db    0x62,0x37
 .db    0x37,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0xA2,0xA2
 .db    0x77,0x77
 .db    0xB2,0xB2
 .db    0x73,0xE1
 .db    0x7B,0x77
 .db    0x77,0x77
 .db    0xB2,0xB2
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB6,0xB6
 .db    0x7B,0x7B
 .db    0x7B,0xE1
 .db    0x77,0x49
 .db    0x45,0x45
 .db    0x49,0x49
 .db    0x45,0x19
 .db    0x44,0x40
 .db    0x05,0x40
 .db    0x19,0x49
 .db    0x49,0x19
 .db    0x19,0x45
 .db    0x49,0x45
 .db    0x45,0x45
 .db    0x49,0x49
 .db    0x1E,0x2E
 .db    0x1E,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x0E,0x49
 .db    0x49,0x1E
 .db    0x1E,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x45
 .db    0x49,0x1E
 .db    0x49,0x49
 .db    0x1E,0x45
 .db    0x15,0x15
 .db    0xFA,0xF2
 .db    0xB3,0xB2
 .db    0xB3,0x73
 .db    0xB2,0xB2
 .db    0xB3,0x73
 .db    0xF2,0xF2
 .db    0xE2,0xF2
 .db    0xB3,0xF2
 .db    0xB2,0xB2
 .db    0xF2,0xE2
 .db    0xF2,0x73
 .db    0xB2,0xB3
 .db    0xB3,0xB3
 .db    0xF6,0xFB
 .db    0x3F,0x7B
 .db    0x73,0x73
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x37
 .db    0x37,0x37
 .db    0x62,0x37
 .db    0x63,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0xA2,0x77
 .db    0x77,0x77
 .db    0xB2,0xB2
 .db    0x73,0xE1
 .db    0x7B,0x77
 .db    0x77,0xE1
 .db    0x77,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xA2
 .db    0xE1,0xB6
 .db    0x7B,0x7B
 .db    0xB6,0xE1
 .db    0x77,0x49
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x44,0x15
 .db    0x40,0x40
 .db    0x15,0x1A
 .db    0x49,0x19
 .db    0x09,0x45
 .db    0x49,0x1A
 .db    0x45,0x19
 .db    0x49,0x49
 .db    0x49,0x88
 .db    0x1E,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x0E
 .db    0x49,0x1E
 .db    0x4D,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x45
 .db    0x49,0x1E
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x15,0x2A
 .db    0xF6,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0x73
 .db    0xB3,0xF2
 .db    0xB2,0xB2
 .db    0xB3,0xF2
 .db    0x67,0xF6
 .db    0xF2,0xE2
 .db    0xE2,0xB3
 .db    0xF2,0xA3
 .db    0xB7,0xB2
 .db    0xB3,0x73
 .db    0xB3,0xB3
 .db    0xE2,0xFB
 .db    0x7F,0x77
 .db    0x73,0x77
 .db    0x77,0xA2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xA2,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x77,0xD1
 .db    0xD1,0x77
 .db    0xE1,0xB2
 .db    0x73,0xE1
 .db    0x7B,0xA2
 .db    0x77,0x7B
 .db    0xB2,0x77
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x77,0x7B
 .db    0xA6,0x77
 .db    0xE1,0xE1
 .db    0xE1,0x49
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x19,0x44
 .db    0x40,0x40
 .db    0x15,0x45
 .db    0x49,0x19
 .db    0x09,0x45
 .db    0x49,0x49
 .db    0x45,0x44
 .db    0x45,0x49
 .db    0x49,0x88
 .db    0x1E,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x0E
 .db    0x49,0x4D
 .db    0x4E,0x1E
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x45
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x15,0xBA
 .db    0xE2,0xB3
 .db    0xB3,0xB3
 .db    0xF2,0xB3
 .db    0xF6,0xF6
 .db    0xB3,0xB3
 .db    0xB3,0xF6
 .db    0x53,0xF6
 .db    0xB7,0x63
 .db    0xE2,0xB3
 .db    0xF6,0xA2
 .db    0xF6,0xB3
 .db    0xB3,0x73
 .db    0xB2,0xB3
 .db    0xB3,0xFA
 .db    0xFA,0xA2
 .db    0x73,0x77
 .db    0x77,0xA2
 .db    0xA2,0xA2
 .db    0x73,0xA2
 .db    0x63,0x37
 .db    0x37,0x62
 .db    0x37,0x37
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0xA2,0x77
 .db    0x77,0x77
 .db    0xE1,0x77
 .db    0x73,0xE1
 .db    0x7B,0xA2
 .db    0x77,0x7B
 .db    0x77,0x77
 .db    0xA2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x77,0xA6
 .db    0xA2,0x77
 .db    0xE1,0xE1
 .db    0xB6,0x49
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x45,0x44
 .db    0x40,0x40
 .db    0x15,0x45
 .db    0x49,0x19
 .db    0x19,0x45
 .db    0x49,0x49
 .db    0x45,0x44
 .db    0x45,0x19
 .db    0x49,0x4D
 .db    0x1E,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x0E
 .db    0x49,0x4D
 .db    0x4E,0x1E
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x1A,0x45
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x19
 .db    0x25,0xFB
 .db    0xB3,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xFA,0xD2
 .db    0xB7,0xB2
 .db    0xB3,0xF6
 .db    0x63,0xF6
 .db    0xB7,0x63
 .db    0xE2,0xB3
 .db    0xF6,0xE2
 .db    0xE6,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB2,0xF2
 .db    0xFB,0xA2
 .db    0x73,0x77
 .db    0x77,0x77
 .db    0x77,0xA2
 .db    0xA2,0xA2
 .db    0x63,0x92
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x73,0xA2
 .db    0x73,0x63
 .db    0x63,0x92
 .db    0xA2,0xA2
 .db    0x7B,0x7B
 .db    0xE1,0x77
 .db    0x73,0xE1
 .db    0x7B,0xA2
 .db    0xD1,0x7B
 .db    0x7B,0x77
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x77,0x77
 .db    0xA2,0x77
 .db    0xB2,0xE1
 .db    0xB6,0x49
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x45,0x19
 .db    0x40,0x40
 .db    0x15,0x45
 .db    0x49,0x19
 .db    0x45,0x45
 .db    0x1A,0x49
 .db    0x45,0x44
 .db    0x19,0x19
 .db    0x49,0x4D
 .db    0x1E,0x49
 .db    0x49,0x49
 .db    0x45,0x49
 .db    0x0E,0x0E
 .db    0x49,0x4D
 .db    0x4E,0x1E
 .db    0x1E,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x19
 .db    0x3B,0xF6
 .db    0xB3,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xFA,0x63
 .db    0xE2,0xB2
 .db    0xB3,0xF6
 .db    0xB2,0xF6
 .db    0xB7,0x73
 .db    0xF2,0xB3
 .db    0xF2,0xE2
 .db    0x63,0xF6
 .db    0xF2,0xB3
 .db    0xB3,0xB3
 .db    0xB2,0xB3
 .db    0xF6,0xE6
 .db    0x73,0x77
 .db    0x77,0x77
 .db    0x77,0xA2
 .db    0xA2,0xA2
 .db    0x37,0x92
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0xA2,0xA2
 .db    0x63,0x63
 .db    0x63,0xA2
 .db    0xA2,0xD1
 .db    0x7B,0x7B
 .db    0xE1,0x77
 .db    0x73,0x7B
 .db    0x7B,0xA2
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x77,0x77
 .db    0xA2,0x77
 .db    0xB2,0xB2
 .db    0xB2,0x49
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x15,0x05
 .db    0x40,0x45
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x45,0x49
 .db    0x1A,0x44
 .db    0x45,0x19
 .db    0x49,0x1E
 .db    0x1E,0x49
 .db    0x49,0x49
 .db    0x45,0x45
 .db    0x0E,0x49
 .db    0x0E,0x4D
 .db    0x4E,0x4D
 .db    0x1E,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x1E,0x1E
 .db    0x49,0x19
 .db    0xFA,0xF2
 .db    0xB3,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xF6,0x63
 .db    0xE2,0xB3
 .db    0xB3,0xF2
 .db    0xB3,0xF2
 .db    0xB3,0xE2
 .db    0xB7,0xB3
 .db    0xB3,0x77
 .db    0x63,0xF6
 .db    0xF6,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xFB
 .db    0x73,0x77
 .db    0x77,0x77
 .db    0x77,0x77
 .db    0xA2,0xA2
 .db    0x92,0x92
 .db    0x63,0x37
 .db    0x62,0x92
 .db    0xA2,0xA2
 .db    0x63,0x63
 .db    0x92,0x77
 .db    0xA2,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0x77
 .db    0x73,0x7B
 .db    0x7B,0x67
 .db    0xD1,0x7B
 .db    0xD1,0x7B
 .db    0x77,0x73
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x77,0xA2
 .db    0x77,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x49
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x44,0x05
 .db    0x40,0x45
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x19,0x49
 .db    0x1A,0x45
 .db    0x19,0x19
 .db    0x45,0x1E
 .db    0x1E,0x1E
 .db    0x49,0x49
 .db    0x45,0x45
 .db    0x49,0x1E
 .db    0x1E,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0x1E
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x1E
 .db    0x1E,0x1E
 .db    0x49,0x2A
 .db    0xF6,0xB3
 .db    0xB3,0xF6
 .db    0xF2,0xB2
 .db    0xB3,0xB3
 .db    0xF2,0x73
 .db    0xE2,0xB3
 .db    0xB3,0xF2
 .db    0xB3,0xF2
 .db    0xB2,0xE2
 .db    0xB3,0xB3
 .db    0xB2,0xE2
 .db    0x73,0xB7
 .db    0xA3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xFB
 .db    0x77,0xD1
 .db    0x77,0xA2
 .db    0x77,0x77
 .db    0xA2,0x77
 .db    0x67,0x92
 .db    0x37,0x63
 .db    0x62,0x63
 .db    0xA2,0xA2
 .db    0x63,0x63
 .db    0x92,0x77
 .db    0xA2,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0x77
 .db    0x73,0x7B
 .db    0x7B,0x92
 .db    0xD1,0x7B
 .db    0x77,0x77
 .db    0x77,0x73
 .db    0x63,0x63
 .db    0x73,0xB2
 .db    0xA2,0xA2
 .db    0x77,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x49
 .db    0x45,0x45
 .db    0x45,0x1A
 .db    0x1A,0x45
 .db    0x45,0x45
 .db    0x44,0x05
 .db    0x40,0x45
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x09,0x45
 .db    0x49,0x1A
 .db    0x45,0x45
 .db    0x19,0x49
 .db    0x1E,0x1E
 .db    0x1E,0x49
 .db    0x45,0x49
 .db    0x49,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0x1E
 .db    0x49,0x49
 .db    0x1E,0x1E
 .db    0x1E,0x1E
 .db    0x1E,0x49
 .db    0x1A,0xE5
 .db    0xF6,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xB2
 .db    0xB3,0xB2
 .db    0xF2,0xF6
 .db    0xB7,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0x73,0xB3
 .db    0xB2,0xFA
 .db    0xE6,0xE2
 .db    0x63,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xFB
 .db    0xBB,0x77
 .db    0xA2,0xA2
 .db    0x77,0xD1
 .db    0x77,0xD1
 .db    0xD1,0x92
 .db    0x37,0x37
 .db    0x62,0x63
 .db    0xA2,0xA2
 .db    0x63,0x63
 .db    0x92,0x67
 .db    0x67,0xD1
 .db    0xD1,0xD1
 .db    0xD1,0xA2
 .db    0x73,0x77
 .db    0x7B,0x92
 .db    0x67,0xD1
 .db    0x77,0x77
 .db    0xA2,0x63
 .db    0x63,0x63
 .db    0xA2,0xB2
 .db    0xA2,0xA2
 .db    0x77,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x49
 .db    0x45,0x45
 .db    0x45,0x49
 .db    0x1A,0x45
 .db    0x45,0x45
 .db    0x45,0x40
 .db    0x40,0x45
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x45
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x19,0x49
 .db    0x1E,0x4D
 .db    0x4D,0x1E
 .db    0x49,0x49
 .db    0x49,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0x1E
 .db    0x49,0x1E
 .db    0x4D,0x4D
 .db    0x4D,0x1E
 .db    0x1E,0x49
 .db    0x80,0xFB
 .db    0xF2,0xB3
 .db    0xF2,0xB2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xF2,0xFA
 .db    0xF6,0xB3
 .db    0xF2,0xE2
 .db    0xF6,0xB7
 .db    0xA2,0xF6
 .db    0x73,0x73
 .db    0xB3,0xBF
 .db    0xFA,0xF6
 .db    0xB2,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xB7
 .db    0xFF,0x77
 .db    0x77,0x77
 .db    0xD1,0x77
 .db    0xD1,0xD1
 .db    0x67,0x92
 .db    0x63,0x37
 .db    0x62,0x63
 .db    0x67,0xA2
 .db    0x92,0x63
 .db    0x67,0x92
 .db    0x67,0xA2
 .db    0x77,0x77
 .db    0x77,0xA2
 .db    0x73,0x77
 .db    0xD1,0x92
 .db    0x67,0xD1
 .db    0xA2,0x77
 .db    0xA2,0x63
 .db    0x63,0x73
 .db    0xB2,0xA2
 .db    0x92,0xA2
 .db    0xA2,0x73
 .db    0xB2,0xB2
 .db    0xB2,0x49
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x1A,0x45
 .db    0x45,0x45
 .db    0x45,0x15
 .db    0x40,0x19
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x45
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x45,0x49
 .db    0x1E,0x4D
 .db    0x4D,0x1E
 .db    0x49,0x0E
 .db    0x1E,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0x1E
 .db    0x49,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0x1E
 .db    0x1E,0x49
 .db    0xC0,0xFA
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xF6,0xF6
 .db    0xF2,0xB3
 .db    0xF2,0xBB
 .db    0xFA,0xB3
 .db    0xB7,0x63
 .db    0xF6,0xBB
 .db    0x67,0xF6
 .db    0xB2,0x73
 .db    0xB3,0x77
 .db    0xD2,0xFA
 .db    0xF6,0xF2
 .db    0xF2,0xF6
 .db    0x77,0xE2
 .db    0xF6,0x77
 .db    0xFF,0xD1
 .db    0x77,0xA2
 .db    0xD1,0xD1
 .db    0xD1,0x67
 .db    0x92,0x92
 .db    0x63,0x37
 .db    0x27,0x63
 .db    0x92,0x67
 .db    0x92,0x92
 .db    0xA2,0x67
 .db    0x67,0xA2
 .db    0xA2,0x77
 .db    0x77,0x73
 .db    0x73,0x77
 .db    0xD1,0x92
 .db    0x67,0xA2
 .db    0x67,0xA2
 .db    0x63,0x63
 .db    0x63,0xA2
 .db    0x77,0xA2
 .db    0x63,0xA2
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xB2,0x49
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x49,0x45
 .db    0x45,0x45
 .db    0x45,0x44
 .db    0x05,0x44
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x45
 .db    0x49,0x1E
 .db    0x49,0x45
 .db    0x49,0x49
 .db    0x49,0x1E
 .db    0x4D,0x4E
 .db    0x1E,0x49
 .db    0x1E,0x4D
 .db    0x4E,0x4E
 .db    0x4E,0x4D
 .db    0x4D,0x1E
 .db    0x0E,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0x4D
 .db    0x49,0x49
 .db    0xBB,0xF6
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xFA,0xFB
 .db    0xF6,0xB2
 .db    0xF6,0x67
 .db    0xFA,0xF2
 .db    0xB7,0x63
 .db    0xFA,0xFA
 .db    0xB7,0xB7
 .db    0xB3,0xB3
 .db    0xF2,0x63
 .db    0x63,0xFB
 .db    0xFB,0xF6
 .db    0xF6,0xF6
 .db    0x73,0x77
 .db    0xFB,0xB2
 .db    0xFA,0xD1
 .db    0xA2,0xA2
 .db    0x7B,0x77
 .db    0xD1,0x92
 .db    0x92,0x92
 .db    0x63,0x27
 .db    0x27,0x63
 .db    0x92,0x67
 .db    0x63,0x67
 .db    0xD1,0xD1
 .db    0xD1,0xA2
 .db    0xA2,0x77
 .db    0x77,0x73
 .db    0x73,0x77
 .db    0xA2,0x92
 .db    0x67,0x67
 .db    0x63,0x67
 .db    0x63,0x63
 .db    0x63,0x77
 .db    0x77,0x92
 .db    0x92,0xA2
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xB2,0x49
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x49,0x49
 .db    0x1A,0x45
 .db    0x49,0x19
 .db    0x05,0x15
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x45,0x45
 .db    0x49,0x1E
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x1E
 .db    0x4D,0x4E
 .db    0x4E,0x49
 .db    0x1E,0x4D
 .db    0x4D,0x4E
 .db    0x4E,0x4D
 .db    0x4D,0x1E
 .db    0x49,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0x4D
 .db    0x1E,0x49
 .db    0xFB,0xF2
 .db    0xB2,0xB3
 .db    0xB3,0xF2
 .db    0xBB,0xA7
 .db    0xFA,0x63
 .db    0xFB,0x92
 .db    0xBB,0xE2
 .db    0xBB,0x73
 .db    0xFA,0xD2
 .db    0xE6,0xB3
 .db    0xB2,0xE2
 .db    0xF2,0x73
 .db    0x63,0xBB
 .db    0xFA,0xE6
 .db    0xBB,0xF6
 .db    0xB2,0xF6
 .db    0xFA,0xF2
 .db    0xF2,0xBB
 .db    0xA2,0xA2
 .db    0xD1,0x67
 .db    0xA2,0x92
 .db    0x92,0x92
 .db    0x92,0x27
 .db    0x27,0x63
 .db    0x63,0x92
 .db    0x63,0x92
 .db    0xA2,0xD1
 .db    0x67,0x92
 .db    0x77,0x77
 .db    0xA2,0x73
 .db    0x73,0x77
 .db    0x92,0x92
 .db    0x67,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x92,0x77
 .db    0xA2,0x63
 .db    0x92,0xA2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0x49
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x40,0x15
 .db    0x1A,0x1E
 .db    0x49,0x19
 .db    0x19,0x45
 .db    0x49,0x49
 .db    0x1E,0x49
 .db    0x49,0x49
 .db    0x49,0x1E
 .db    0x4D,0x4E
 .db    0x4E,0x1E
 .db    0x1E,0x4D
 .db    0x4D,0x4E
 .db    0x4E,0x4E
 .db    0x4D,0x4D
 .db    0x1E,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0x4D
 .db    0x1E,0x2E
 .db    0xF6,0xB3
 .db    0xB3,0xB3
 .db    0xF2,0xF6
 .db    0x77,0x63
 .db    0xBB,0x63
 .db    0xFA,0x92
 .db    0xBB,0xB2
 .db    0xF2,0xF2
 .db    0xFA,0x63
 .db    0xD2,0xB3
 .db    0xB3,0x73
 .db    0xF2,0xB3
 .db    0xE2,0x67
 .db    0xE6,0x63
 .db    0xD2,0xF6
 .db    0xF6,0xF6
 .db    0xF6,0xF2
 .db    0xF2,0xFF
 .db    0xA2,0xA2
 .db    0x77,0x63
 .db    0xA2,0x67
 .db    0x92,0x92
 .db    0xA2,0x63
 .db    0x27,0x63
 .db    0x63,0x63
 .db    0x63,0x92
 .db    0x67,0x92
 .db    0x92,0x67
 .db    0x77,0x77
 .db    0x77,0x73
 .db    0x73,0xA2
 .db    0x63,0x92
 .db    0x67,0x63
 .db    0x63,0xA2
 .db    0x63,0x63
 .db    0x92,0x67
 .db    0x92,0x27
 .db    0x63,0xA2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x49
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x40,0x40
 .db    0x1A,0x1E
 .db    0x49,0x09
 .db    0x09,0x45
 .db    0x1A,0x49
 .db    0x1E,0x1E
 .db    0x1E,0x1E
 .db    0x49,0x49
 .db    0x0E,0x4E
 .db    0x4E,0x4D
 .db    0x1E,0x4D
 .db    0x4D,0x4E
 .db    0x4E,0x4E
 .db    0x4E,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0xD5
 .db    0xF6,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xF6
 .db    0xB3,0x77
 .db    0xF6,0x63
 .db    0xFB,0x7B
 .db    0xFA,0xB3
 .db    0xF2,0xF6
 .db    0xF6,0x77
 .db    0xA3,0xF2
 .db    0xE6,0x73
 .db    0xB2,0xF6
 .db    0xF6,0x63
 .db    0xBB,0x63
 .db    0xE2,0xF6
 .db    0xFA,0xF6
 .db    0x73,0xF2
 .db    0xF2,0xFF
 .db    0xD1,0xA2
 .db    0xA2,0x37
 .db    0x67,0x92
 .db    0x37,0x92
 .db    0x92,0x92
 .db    0x27,0x63
 .db    0x92,0x63
 .db    0x63,0x92
 .db    0x92,0x53
 .db    0x92,0xD1
 .db    0x7B,0x77
 .db    0x77,0x73
 .db    0xA2,0x92
 .db    0x63,0x63
 .db    0x92,0x63
 .db    0x92,0x77
 .db    0xA2,0x63
 .db    0x92,0x92
 .db    0x63,0x27
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0x49
 .db    0x1A,0x45
 .db    0x45,0x45
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x1A
 .db    0x44,0x40
 .db    0x45,0x1E
 .db    0x49,0x09
 .db    0x44,0x19
 .db    0x45,0x49
 .db    0x1E,0x1E
 .db    0x1E,0x1E
 .db    0x1E,0x1E
 .db    0x0E,0x4E
 .db    0x4E,0x4E
 .db    0x1E,0x4D
 .db    0x4D,0x4E
 .db    0x4E,0x4E
 .db    0x4E,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0x4D
 .db    0x4D,0xFA
 .db    0xB3,0xF2
 .db    0xB3,0xB3
 .db    0xE2,0xF6
 .db    0xF6,0xF6
 .db    0xFA,0xE2
 .db    0xFB,0xFA
 .db    0xFB,0xB3
 .db    0xF6,0xF6
 .db    0xF6,0xB7
 .db    0xB7,0xF2
 .db    0xFB,0xB7
 .db    0xB3,0xF6
 .db    0xF6,0xE2
 .db    0xFA,0x77
 .db    0xF6,0xF2
 .db    0xF2,0xB7
 .db    0x73,0xF2
 .db    0xB2,0xFB
 .db    0x7B,0xA2
 .db    0x67,0x63
 .db    0x63,0x63
 .db    0x27,0x27
 .db    0x92,0x67
 .db    0x63,0x63
 .db    0x67,0x92
 .db    0x92,0x63
 .db    0x53,0x53
 .db    0x67,0xA6
 .db    0x7B,0x77
 .db    0x77,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x67,0x77
 .db    0xA2,0xA2
 .db    0xA2,0x63
 .db    0x63,0x37
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0x49
 .db    0x49,0x45
 .db    0x45,0x45
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x44,0x05
 .db    0x45,0x1E
 .db    0x0E,0x45
 .db    0x19,0x44
 .db    0x19,0x49
 .db    0x49,0x1E
 .db    0x1E,0x1E
 .db    0x1E,0x1E
 .db    0x1E,0x4D
 .db    0x89,0x5E
 .db    0xC4,0x5E
 .db    0x89,0x4E
 .db    0x89,0x89
 .db    0x89,0x89
 .db    0x89,0x4E
 .db    0x4E,0x4D
 .db    0x1E,0x4D
 .db    0x2F,0xFB
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0x73,0xF2
 .db    0xFB,0xFA
 .db    0xFB,0xFA
 .db    0xFF,0xFA
 .db    0xFB,0xF2
 .db    0xF6,0xB7
 .db    0xF6,0xB3
 .db    0xB3,0xF2
 .db    0xFA,0xFB
 .db    0xF2,0xFA
 .db    0xF6,0xFB
 .db    0xFB,0xFA
 .db    0xF6,0xF2
 .db    0xB3,0xB7
 .db    0xE2,0xFA
 .db    0xB2,0xFB
 .db    0xFA,0xD1
 .db    0x67,0x92
 .db    0x63,0x37
 .db    0x27,0x27
 .db    0x27,0xD1
 .db    0x67,0x92
 .db    0xA2,0xA2
 .db    0x77,0x92
 .db    0x53,0x92
 .db    0x67,0x7B
 .db    0x7B,0x77
 .db    0xB2,0x73
 .db    0x73,0x27
 .db    0x27,0x27
 .db    0x63,0x63
 .db    0x67,0xA2
 .db    0x77,0x7B
 .db    0x77,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xB2,0x49
 .db    0x49,0x45
 .db    0x45,0x45
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x05
 .db    0x44,0x49
 .db    0x49,0x49
 .db    0x45,0x19
 .db    0x44,0x49
 .db    0x49,0x1E
 .db    0x1E,0x1E
 .db    0x1E,0x1E
 .db    0x1E,0x89
 .db    0xAA,0xBA
 .db    0xE6,0xE6
 .db    0x7F,0xD5
 .db    0x7F,0x7F
 .db    0x7F,0x7F
 .db    0xD5,0xD5
 .db    0xD5,0xD5
 .db    0xC5,0xC5
 .db    0xE5,0xF6
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xB2,0xF2
 .db    0xD2,0xFB
 .db    0xFA,0x67
 .db    0xFB,0xBF
 .db    0xFB,0xF6
 .db    0xD2,0x63
 .db    0xF7,0xB2
 .db    0xB3,0xF6
 .db    0x7B,0xA7
 .db    0xF2,0xE6
 .db    0xA7,0xFA
 .db    0xFA,0xF2
 .db    0xB7,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xF6
 .db    0xF6,0xFA
 .db    0xFF,0x7B
 .db    0x77,0xA2
 .db    0xA2,0x92
 .db    0x27,0x27
 .db    0x53,0xD1
 .db    0xD1,0xA2
 .db    0x77,0x7B
 .db    0x7B,0x92
 .db    0x92,0x67
 .db    0xD1,0x7B
 .db    0x7B,0xE1
 .db    0xB2,0xB2
 .db    0x63,0x52
 .db    0x27,0x27
 .db    0x63,0x92
 .db    0x92,0x92
 .db    0xD1,0xE2
 .db    0xE2,0x77
 .db    0x67,0x63
 .db    0x63,0x63
 .db    0x73,0x77
 .db    0xB2,0xE1
 .db    0xE1,0x49
 .db    0x49,0x1A
 .db    0x45,0x45
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x05
 .db    0x15,0x45
 .db    0x49,0x49
 .db    0x49,0x19
 .db    0x44,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x1E,0x4E
 .db    0xC5,0xE5
 .db    0xBB,0xE6
 .db    0xE6,0xE6
 .db    0xE6,0xBB
 .db    0xBB,0xBB
 .db    0xBB,0xBB
 .db    0xBB,0xBB
 .db    0xBB,0xBB
 .db    0xBB,0xBB
 .db    0xFA,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xF6,0xFB
 .db    0x63,0xBB
 .db    0xFA,0x63
 .db    0xBB,0xA7
 .db    0xFB,0xFA
 .db    0x63,0x63
 .db    0xFB,0x73
 .db    0xF2,0xF6
 .db    0x53,0x92
 .db    0xF6,0x63
 .db    0x92,0xFA
 .db    0xFB,0xF2
 .db    0x73,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xF2
 .db    0xFB,0x7B
 .db    0xD1,0xA2
 .db    0xA6,0x67
 .db    0x92,0x27
 .db    0x92,0x67
 .db    0xD1,0x77
 .db    0x67,0xA7
 .db    0x7B,0x92
 .db    0x67,0x67
 .db    0xD1,0x7B
 .db    0x7B,0xB2
 .db    0xB2,0xA2
 .db    0x27,0x52
 .db    0x27,0x37
 .db    0x63,0x92
 .db    0x92,0x27
 .db    0x77,0xE2
 .db    0xE2,0x77
 .db    0xA2,0x92
 .db    0x63,0x73
 .db    0x73,0x77
 .db    0xE1,0xB6
 .db    0xB6,0x49
 .db    0x49,0x1A
 .db    0x45,0x45
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x05
 .db    0x40,0x45
 .db    0x49,0x49
 .db    0x49,0x45
 .db    0x19,0x49
 .db    0x49,0x49
 .db    0x49,0x1E
 .db    0x4D,0xD5
 .db    0xBB,0xBB
 .db    0xE6,0xE2
 .db    0xB3,0xB2
 .db    0xE2,0xE2
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xB7
 .db    0xB7,0xE2
 .db    0xFB,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xF6,0xBB
 .db    0x73,0x73
 .db    0xFA,0xE2
 .db    0x63,0xB3
 .db    0xFB,0xFA
 .db    0x92,0x73
 .db    0xFA,0xB2
 .db    0xB3,0xF6
 .db    0x53,0x92
 .db    0xFB,0x63
 .db    0x92,0xFA
 .db    0xFB,0xB7
 .db    0x73,0xF2
 .db    0xF2,0xB7
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xD1
 .db    0x77,0x77
 .db    0x7B,0xD1
 .db    0xD1,0x27
 .db    0x92,0x27
 .db    0x67,0x67
 .db    0x67,0xD2
 .db    0xC1,0x67
 .db    0x67,0x67
 .db    0xD1,0x77
 .db    0x77,0xB2
 .db    0xB2,0x73
 .db    0x27,0x62
 .db    0x37,0x63
 .db    0x63,0xA2
 .db    0x73,0x27
 .db    0x77,0xE2
 .db    0xE2,0x77
 .db    0x7B,0xA2
 .db    0x73,0x77
 .db    0x73,0x77
 .db    0xE1,0xB6
 .db    0xB6,0x49
 .db    0x49,0x45
 .db    0x45,0x1A
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x45,0x05
 .db    0x40,0x45
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x1E
 .db    0xC4,0xE6
 .db    0xB7,0xE2
 .db    0xE2,0xB3
 .db    0xB2,0xB2
 .db    0xB2,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xE2,0xE2
 .db    0xF6,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xB3
 .db    0xF2,0xA2
 .db    0xF6,0xB3
 .db    0xF6,0xFA
 .db    0x63,0xBB
 .db    0xE6,0xD6
 .db    0xE6,0xB7
 .db    0xFB,0xA2
 .db    0xB3,0xF6
 .db    0x63,0xD2
 .db    0xFB,0x77
 .db    0xE2,0xFB
 .db    0xE6,0xA3
 .db    0xB3,0xF2
 .db    0xF2,0x73
 .db    0xB3,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0x7B
 .db    0x77,0x67
 .db    0xD1,0xD1
 .db    0xD1,0x2B
 .db    0x92,0x52
 .db    0x92,0x67
 .db    0x63,0x77
 .db    0x92,0xC1
 .db    0x67,0x67
 .db    0x77,0x77
 .db    0x77,0x77
 .db    0x73,0x63
 .db    0x62,0x37
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0x73,0x63
 .db    0x77,0xB3
 .db    0xE2,0x77
 .db    0xE2,0xB6
 .db    0x77,0x77
 .db    0x73,0x77
 .db    0xB6,0xE6
 .db    0xB6,0x49
 .db    0x49,0x45
 .db    0x45,0x1A
 .db    0x49,0x45
 .db    0x49,0x49
 .db    0x1E,0x49
 .db    0x49,0x05
 .db    0x40,0x45
 .db    0x1A,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0xC5
 .db    0xE6,0xB7
 .db    0xB3,0xB3
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xE2,0xE2
 .db    0xB7,0xBB
 .db    0xE6,0xB7
 .db    0xE2,0xBB
 .db    0xF6,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xB3
 .db    0xF2,0x63
 .db    0xF6,0xFA
 .db    0xF6,0xFB
 .db    0x63,0xFB
 .db    0x7B,0x63
 .db    0xFA,0xF6
 .db    0xF2,0x73
 .db    0xF2,0xFA
 .db    0xBB,0xFA
 .db    0xFB,0xFA
 .db    0xFB,0xFA
 .db    0x63,0xE2
 .db    0xF6,0xB7
 .db    0xF6,0xB2
 .db    0xB3,0xF6
 .db    0x73,0xF2
 .db    0xF2,0xBF
 .db    0x77,0x92
 .db    0x92,0x92
 .db    0xC1,0x92
 .db    0x3B,0x42
 .db    0x53,0x73
 .db    0x73,0xA2
 .db    0x92,0xD1
 .db    0x67,0x67
 .db    0x67,0xA2
 .db    0xA2,0xB2
 .db    0x73,0x63
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xA2,0xA2
 .db    0xB3,0xB3
 .db    0xB2,0x7B
 .db    0xE6,0xE6
 .db    0xE1,0xB2
 .db    0xA2,0x77
 .db    0xB6,0xE6
 .db    0xB6,0x49
 .db    0x49,0x45
 .db    0x1A,0x49
 .db    0x49,0x45
 .db    0x45,0x49
 .db    0x1E,0x1E
 .db    0x49,0x40
 .db    0x40,0x15
 .db    0x1A,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x1E,0xE6
 .db    0xE6,0xB3
 .db    0xB2,0xB3
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB3
 .db    0xE2,0xE6
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0xFB
 .db    0xBF,0xFB
 .db    0xF2,0xB3
 .db    0xF2,0xB3
 .db    0xB7,0xF2
 .db    0xF6,0x73
 .db    0xFA,0xFB
 .db    0xBB,0xFA
 .db    0xA7,0xFF
 .db    0x7B,0x63
 .db    0xFB,0xF6
 .db    0xF2,0xB2
 .db    0xFA,0xFA
 .db    0xFB,0xFB
 .db    0xBB,0xFB
 .db    0xFA,0x77
 .db    0x73,0xB7
 .db    0xFA,0x73
 .db    0xF6,0xF2
 .db    0xB3,0xF2
 .db    0xB7,0xF2
 .db    0xF2,0xFB
 .db    0xA2,0x92
 .db    0x37,0x91
 .db    0x92,0x2B
 .db    0x27,0x42
 .db    0x27,0x73
 .db    0x73,0x73
 .db    0x67,0xD1
 .db    0x67,0x67
 .db    0x92,0xA2
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0xA2
 .db    0xA2,0x7B
 .db    0xF2,0xF2
 .db    0xB2,0x7B
 .db    0xE6,0xE2
 .db    0x7B,0x77
 .db    0x73,0x7B
 .db    0xB6,0xB6
 .db    0xB6,0x49
 .db    0x49,0x45
 .db    0x49,0x49
 .db    0x49,0x1A
 .db    0x45,0x49
 .db    0x1E,0x49
 .db    0x49,0x15
 .db    0x40,0x15
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x48
 .db    0x49,0x49
 .db    0xC0,0xBB
 .db    0xE2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xB3
 .db    0xB2,0xE2
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xF6,0xFA
 .db    0xFB,0xFB
 .db    0xF6,0xB7
 .db    0xF2,0xB3
 .db    0x73,0xF6
 .db    0xF6,0xB2
 .db    0xFA,0xBB
 .db    0x67,0xE6
 .db    0x67,0xFF
 .db    0xFA,0xA3
 .db    0xEB,0xF6
 .db    0xF2,0xF2
 .db    0xFB,0xFA
 .db    0xBF,0xFB
 .db    0x77,0xD2
 .db    0xF6,0x77
 .db    0xE2,0xA2
 .db    0xE7,0x73
 .db    0xFB,0xF6
 .db    0xF2,0xF2
 .db    0xF6,0xF6
 .db    0xF2,0xFB
 .db    0x67,0x92
 .db    0x37,0x92
 .db    0x92,0x52
 .db    0x52,0x52
 .db    0x53,0x73
 .db    0x73,0x73
 .db    0xA2,0x67
 .db    0x92,0x92
 .db    0x63,0x73
 .db    0x73,0xA2
 .db    0x63,0x63
 .db    0x33,0x33
 .db    0x33,0x33
 .db    0x63,0xA2
 .db    0xD1,0xE6
 .db    0xF2,0xF2
 .db    0xB2,0x77
 .db    0x7F,0x7B
 .db    0x77,0xA2
 .db    0x73,0x7B
 .db    0xB6,0xB6
 .db    0xB6,0x49
 .db    0x49,0x45
 .db    0x49,0x49
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x49,0x49
 .db    0x49,0x15
 .db    0x05,0x40
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x48
 .db    0x49,0x49
 .db    0x7F,0xE2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xE2
 .db    0xBB,0xFB
 .db    0xFA,0xFA
 .db    0xF6,0xF6
 .db    0xF6,0xF6
 .db    0xF6,0xF6
 .db    0xF6,0xFA
 .db    0xFA,0xFA
 .db    0xF6,0xF7
 .db    0x73,0xF6
 .db    0xFA,0xF2
 .db    0xFA,0xE2
 .db    0x63,0xD2
 .db    0x63,0xBB
 .db    0xFB,0xBB
 .db    0x92,0xFB
 .db    0xF6,0xF6
 .db    0xD2,0xA7
 .db    0x92,0xFB
 .db    0xE6,0x63
 .db    0xE6,0xF6
 .db    0xFB,0x63
 .db    0xBB,0xB7
 .db    0xFB,0xA2
 .db    0xF7,0xF6
 .db    0xB3,0xF6
 .db    0xF2,0xFA
 .db    0x67,0x7B
 .db    0xA6,0xC1
 .db    0x2B,0x27
 .db    0x27,0x27
 .db    0x92,0x73
 .db    0x73,0x73
 .db    0x77,0xA2
 .db    0x63,0xA2
 .db    0x73,0x73
 .db    0x73,0x92
 .db    0x63,0x63
 .db    0x33,0x33
 .db    0x23,0x23
 .db    0x53,0x92
 .db    0xD6,0xF6
 .db    0xF6,0xF2
 .db    0x77,0x63
 .db    0x27,0x92
 .db    0xA2,0x92
 .db    0x63,0xD1
 .db    0x7B,0x7B
 .db    0xA6,0x49
 .db    0x49,0x45
 .db    0x49,0x49
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x49,0x49
 .db    0x49,0x15
 .db    0x40,0x40
 .db    0x45,0x49
 .db    0x49,0x49
 .db    0x49,0x48
 .db    0x49,0x85
 .db    0xE6,0xB3
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xBB,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xF6
 .db    0xF2,0xF6
 .db    0xFA,0xFB
 .db    0xB2,0xF6
 .db    0xFB,0xF2
 .db    0xF6,0xE6
 .db    0x63,0xBB
 .db    0x73,0xA2
 .db    0xFA,0xBB
 .db    0x63,0xFB
 .db    0xBB,0xFA
 .db    0x63,0xA3
 .db    0x63,0xBF
 .db    0xFA,0x63
 .db    0xD2,0xFA
 .db    0xFB,0xE2
 .db    0xFB,0xFA
 .db    0xBB,0x73
 .db    0xF2,0xF6
 .db    0x73,0xF2
 .db    0xF6,0xFA
 .db    0xEA,0xFA
 .db    0xFA,0xBF
 .db    0xBB,0xBB
 .db    0xE6,0x7B
 .db    0x67,0x63
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x92,0x92
 .db    0x63,0x62
 .db    0x23,0x23
 .db    0x23,0x23
 .db    0x52,0x92
 .db    0xD6,0xBB
 .db    0xBB,0xE2
 .db    0xA2,0x63
 .db    0x52,0x92
 .db    0xA2,0x63
 .db    0x92,0x77
 .db    0x77,0xD1
 .db    0x77,0x49
 .db    0x1A,0x1A
 .db    0x49,0x45
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x49,0x49
 .db    0x49,0x44
 .db    0x40,0x40
 .db    0x19,0x49
 .db    0x49,0x49
 .db    0x49,0x48
 .db    0x49,0x7B
 .db    0xB7,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xE6
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xF6,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xF6
 .db    0xF6,0xF6
 .db    0xD2,0xB7
 .db    0xF6,0xFA
 .db    0xE2,0xFB
 .db    0x77,0xE2
 .db    0xA3,0xE7
 .db    0xE6,0xFB
 .db    0x63,0xBB
 .db    0x63,0xB7
 .db    0x63,0xE6
 .db    0xFB,0x77
 .db    0xA7,0xFA
 .db    0xF6,0xFB
 .db    0xF6,0xFB
 .db    0xF6,0xB3
 .db    0xB2,0xF6
 .db    0xB7,0xFB
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xF6,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0x92
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x92
 .db    0x92,0x92
 .db    0x63,0x23
 .db    0x23,0x23
 .db    0x23,0x52
 .db    0x13,0x27
 .db    0x6B,0xE6
 .db    0xE6,0x7B
 .db    0x67,0x63
 .db    0x27,0x91
 .db    0x67,0x92
 .db    0x67,0x77
 .db    0x77,0xA2
 .db    0x77,0x49
 .db    0x1A,0x45
 .db    0x49,0x45
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x1A,0x49
 .db    0x49,0x44
 .db    0x40,0x05
 .db    0x44,0x1A
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0x1E,0xE5
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB3
 .db    0xE2,0xFA
 .db    0xF6,0xF6
 .db    0xF6,0xF6
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xFB,0xFA
 .db    0xA2,0xA2
 .db    0xFA,0xFB
 .db    0xFB,0xFF
 .db    0xFB,0xFB
 .db    0x63,0xD2
 .db    0xFB,0xFB
 .db    0x63,0xE6
 .db    0xBB,0xFB
 .db    0x63,0xE6
 .db    0xFF,0xBF
 .db    0xFB,0xFB
 .db    0xFB,0xFF
 .db    0xD2,0xFB
 .db    0xFB,0xF6
 .db    0xF6,0xFB
 .db    0xFB,0xFA
 .db    0xFA,0xFB
 .db    0xF6,0xF6
 .db    0xF6,0xFA
 .db    0xF6,0xF6
 .db    0xF6,0xF6
 .db    0xF6,0xFA
 .db    0x7B,0x77
 .db    0x73,0x77
 .db    0x73,0x73
 .db    0x73,0x67
 .db    0x3B,0x63
 .db    0x62,0x23
 .db    0x23,0x23
 .db    0x27,0x52
 .db    0x12,0x17
 .db    0x2B,0x6B
 .db    0x7B,0xD1
 .db    0x92,0x73
 .db    0x62,0x91
 .db    0x92,0x92
 .db    0x67,0xA2
 .db    0x77,0x92
 .db    0xA2,0x45
 .db    0x45,0x45
 .db    0x49,0x1A
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x1A,0x49
 .db    0x49,0x19
 .db    0x40,0x40
 .db    0x15,0x45
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0xC0,0xB7
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xE2
 .db    0xFA,0xFA
 .db    0xF2,0xF2
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xF6,0xFA
 .db    0xE6,0x73
 .db    0xFB,0xFB
 .db    0xFF,0xBF
 .db    0xFF,0xFF
 .db    0x63,0xA2
 .db    0xFB,0xFB
 .db    0x63,0xE6
 .db    0xFF,0xFB
 .db    0xE6,0xFB
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFB,0xFF
 .db    0x63,0xFB
 .db    0xBF,0xBB
 .db    0xFB,0xF6
 .db    0xF6,0xF2
 .db    0xF6,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xF6,0xF2
 .db    0xF6,0xF2
 .db    0xF6,0xF6
 .db    0xFA,0xFA
 .db    0x77,0x77
 .db    0x77,0x73
 .db    0x73,0xA2
 .db    0x92,0x63
 .db    0x62,0x23
 .db    0x23,0x23
 .db    0x52,0x52
 .db    0x42,0x16
 .db    0x52,0x2B
 .db    0x92,0x67
 .db    0x67,0x73
 .db    0x37,0x92
 .db    0x3B,0x91
 .db    0x67,0xA2
 .db    0xA2,0x63
 .db    0x67,0x49
 .db    0x45,0x45
 .db    0x49,0x1A
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x1A,0x49
 .db    0x1E,0x2A
 .db    0x80,0x15
 .db    0x15,0x45
 .db    0x49,0x49
 .db    0x49,0x49
 .db    0xD5,0xE2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xFA
 .db    0xF6,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xB3,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xF6
 .db    0xFB,0xE2
 .db    0xFB,0xFB
 .db    0xBB,0x92
 .db    0xFF,0xFB
 .db    0xBB,0xBB
 .db    0xFB,0xFB
 .db    0xBB,0x63
 .db    0xE6,0xFF
 .db    0xFA,0xFB
 .db    0xFB,0xE6
 .db    0xFF,0xD2
 .db    0x67,0xFB
 .db    0xA2,0xFB
 .db    0x7B,0xFB
 .db    0xF6,0xF2
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xF6
 .db    0xF6,0xFA
 .db    0xFA,0xE2
 .db    0xD2,0x63
 .db    0x73,0xA2
 .db    0x92,0x63
 .db    0x63,0x23
 .db    0x13,0x13
 .db    0x52,0x27
 .db    0x17,0x41
 .db    0x16,0x26
 .db    0x81,0x92
 .db    0x67,0x73
 .db    0x37,0x3B
 .db    0x91,0x2B
 .db    0x67,0xD1
 .db    0x77,0x92
 .db    0xA2,0x49
 .db    0x45,0x45
 .db    0x1A,0x1A
 .db    0x1A,0x1A
 .db    0x1A,0x55
 .db    0x85,0x3F
 .db    0xD5,0x7F
 .db    0xBA,0xD5
 .db    0xC0,0x2B
 .db    0x85,0x59
 .db    0x1E,0x1E
 .db    0xE5,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xBB,0xFA
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xB3,0xB3
 .db    0xF2,0xB3
 .db    0xB3,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xFA,0xFB
 .db    0xFF,0xFF
 .db    0xA7,0x67
 .db    0xFF,0xFB
 .db    0xFF,0xFF
 .db    0xFF,0xD2
 .db    0xE7,0x63
 .db    0xD2,0xFF
 .db    0xFB,0xFF
 .db    0x77,0x63
 .db    0xFB,0xA2
 .db    0x63,0xFB
 .db    0xF6,0xFF
 .db    0xFB,0xFB
 .db    0xF6,0xF2
 .db    0xF6,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xFA,0xFA
 .db    0xA7,0x63
 .db    0x73,0xA2
 .db    0x92,0x63
 .db    0x63,0x23
 .db    0x13,0x13
 .db    0x17,0x27
 .db    0x17,0x41
 .db    0x41,0x41
 .db    0x16,0x92
 .db    0x92,0x63
 .db    0x37,0x91
 .db    0x27,0x2B
 .db    0x67,0xA2
 .db    0xA2,0xA2
 .db    0xA2,0x45
 .db    0x45,0x45
 .db    0x1A,0x1A
 .db    0x85,0x3F
 .db    0x7B,0xE5
 .db    0xBB,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xBB,0xE5
 .db    0xE6,0x7F
 .db    0xD5,0xD1
 .db    0xE6,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB7
 .db    0xFA,0xFA
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xFA
 .db    0xFF,0xBF
 .db    0xBB,0xE2
 .db    0xFF,0xFB
 .db    0xFF,0xBF
 .db    0xFF,0x63
 .db    0xBB,0xD2
 .db    0xFB,0xFB
 .db    0xE6,0xFF
 .db    0x63,0x63
 .db    0xBB,0x77
 .db    0x73,0xFB
 .db    0xFA,0xFB
 .db    0xF7,0xF6
 .db    0xF2,0xF2
 .db    0xFB,0xF6
 .db    0xF2,0xB3
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xF6,0xFA
 .db    0xFA,0x92
 .db    0x63,0x73
 .db    0xA2,0x63
 .db    0x63,0x52
 .db    0x13,0x13
 .db    0x17,0x52
 .db    0x17,0x41
 .db    0x40,0x41
 .db    0x41,0x27
 .db    0x27,0x37
 .db    0x62,0x27
 .db    0x52,0x2B
 .db    0x92,0x92
 .db    0xA2,0xA2
 .db    0xD1,0x45
 .db    0x45,0x1A
 .db    0x2B,0xD1
 .db    0xBA,0xBB
 .db    0xFA,0xFA
 .db    0xFA,0xBF
 .db    0xBB,0xE6
 .db    0xE6,0xB7
 .db    0xB7,0xE2
 .db    0xE2,0xE2
 .db    0xE6,0xE6
 .db    0xBB,0xE2
 .db    0xB2,0xB3
 .db    0xE2,0xFB
 .db    0xF6,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xB3
 .db    0xB3,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xF6
 .db    0xFB,0xE2
 .db    0xFB,0xF6
 .db    0xBF,0xFF
 .db    0xFB,0x63
 .db    0xE6,0x77
 .db    0xBB,0xFB
 .db    0xFF,0xD2
 .db    0x63,0xFF
 .db    0xE2,0xA3
 .db    0xFB,0xFA
 .db    0xBB,0xFF
 .db    0xFB,0xFA
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xB2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xF2,0xF6
 .db    0xFA,0xBF
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x63,0x52
 .db    0x13,0x13
 .db    0x17,0x17
 .db    0x42,0x12
 .db    0x11,0x41
 .db    0x41,0x16
 .db    0x52,0x37
 .db    0x62,0x52
 .db    0x52,0x2B
 .db    0x92,0x67
 .db    0xD1,0xD1
 .db    0x7B,0x1A
 .db    0x1A,0xC0
 .db    0x7B,0xBB
 .db    0xF6,0xFA
 .db    0xBB,0xBB
 .db    0xB7,0xE2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB2,0xB2
 .db    0xB2,0xB3
 .db    0xE2,0xE2
 .db    0xE2,0xB7
 .db    0xE2,0xE2
 .db    0xFA,0xFA
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xB3,0xF6
 .db    0xF2,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xFB,0xFB
 .db    0xFB,0xFF
 .db    0xA2,0xEB
 .db    0xE6,0x63
 .db    0x77,0xFA
 .db    0xA3,0xE6
 .db    0xFF,0x67
 .db    0x63,0xFF
 .db    0xFB,0xFB
 .db    0xFF,0xFF
 .db    0xFB,0xFF
 .db    0xFB,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xB3
 .db    0xB3,0xB2
 .db    0xF2,0xB3
 .db    0xF2,0xB2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xFA
 .db    0x7B,0x73
 .db    0x73,0x73
 .db    0x63,0x27
 .db    0x52,0x13
 .db    0x42,0x42
 .db    0x12,0x12
 .db    0x11,0x41
 .db    0x41,0x41
 .db    0x42,0x37
 .db    0x37,0x52
 .db    0x16,0x27
 .db    0x91,0x67
 .db    0xD1,0xD1
 .db    0x7B,0x1A
 .db    0xC1,0xE6
 .db    0xE6,0xF6
 .db    0xBB,0xB7
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB2,0xB3
 .db    0xB2,0xB3
 .db    0xE2,0xB3
 .db    0xB2,0xB2
 .db    0xB2,0xFA
 .db    0xFA,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xB3
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0x73
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xF6,0xFB
 .db    0xBB,0xEB
 .db    0x63,0x67
 .db    0xA7,0x63
 .db    0xA3,0xFF
 .db    0x67,0xE6
 .db    0xFF,0xE6
 .db    0x63,0xB7
 .db    0xE6,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFB
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xB3,0xB3
 .db    0xF2,0xB2
 .db    0xF2,0xB2
 .db    0xF2,0xB3
 .db    0xF2,0xB2
 .db    0xF2,0xB2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xFA,0x77
 .db    0x73,0x73
 .db    0x63,0x53
 .db    0x52,0x13
 .db    0x13,0x13
 .db    0x12,0x12
 .db    0x12,0x16
 .db    0x42,0x16
 .db    0x52,0x37
 .db    0x37,0x52
 .db    0x16,0x52
 .db    0x2B,0x92
 .db    0xD1,0xD1
 .db    0x7B,0xD1
 .db    0xE2,0xBB
 .db    0xBB,0xBB
 .db    0xB7,0xB2
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB2,0xB3
 .db    0xB3,0xB3
 .db    0xB2,0xB2
 .db    0xE1,0xFB
 .db    0xF6,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xB3
 .db    0xF6,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xF6,0x73
 .db    0xF2,0xB3
 .db    0xF2,0xB2
 .db    0xF6,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xFB
 .db    0xFB,0xD1
 .db    0x73,0x63
 .db    0xBB,0x63
 .db    0xFB,0xFF
 .db    0xBB,0xEB
 .db    0xD2,0xFB
 .db    0xBB,0x63
 .db    0x93,0xFF
 .db    0xBB,0xFF
 .db    0xFF,0xF7
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xB2
 .db    0xB3,0xB2
 .db    0xF2,0xF2
 .db    0xF2,0xB2
 .db    0xF2,0xB2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xFA,0xFA
 .db    0xA2,0x63
 .db    0x63,0x53
 .db    0x52,0x13
 .db    0x13,0x13
 .db    0x12,0x12
 .db    0x12,0x42
 .db    0x52,0x17
 .db    0x52,0x37
 .db    0x37,0x52
 .db    0x16,0x52
 .db    0x27,0x2B
 .db    0x67,0xD1
 .db    0xD1,0xB7
 .db    0xB7,0xBB
 .db    0xBB,0xB7
 .db    0x77,0xB2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB2,0xB2
 .db    0xB2,0x77
 .db    0xFA,0xFA
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xB3
 .db    0xB3,0xF2
 .db    0xB2,0xF2
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0x73
 .db    0xF2,0xB3
 .db    0xF2,0x73
 .db    0xF6,0xB2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xF6
 .db    0xFB,0xE6
 .db    0xBB,0xE2
 .db    0xFF,0xBB
 .db    0xFF,0xFF
 .db    0xFF,0xD2
 .db    0x63,0xFB
 .db    0xFF,0x63
 .db    0x63,0xFB
 .db    0x73,0xFF
 .db    0xFA,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0x73,0xF2
 .db    0xB3,0xB2
 .db    0xF2,0xB2
 .db    0xF2,0xB2
 .db    0xF2,0xF2
 .db    0xF2,0xB2
 .db    0xF2,0xF2
 .db    0xF6,0xFA
 .db    0xBB,0x63
 .db    0x63,0x53
 .db    0x23,0x13
 .db    0x13,0x13
 .db    0x12,0x12
 .db    0x41,0x17
 .db    0x27,0x52
 .db    0x52,0x37
 .db    0x37,0x52
 .db    0x12,0x52
 .db    0x52,0x2B
 .db    0x2B,0x92
 .db    0xD1,0xE2
 .db    0xB7,0xBB
 .db    0xE2,0xB2
 .db    0xB2,0xB3
 .db    0xE2,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xE2
 .db    0xE2,0xB2
 .db    0x77,0xBB
 .db    0xFA,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xB2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xB2
 .db    0xF2,0xB2
 .db    0xF6,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xFA,0xFF
 .db    0xFB,0xEB
 .db    0xFF,0xFB
 .db    0xA3,0xFF
 .db    0xA7,0x73
 .db    0x63,0xFB
 .db    0xFF,0xD2
 .db    0x63,0xFB
 .db    0xE6,0xFF
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xB2,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0x73
 .db    0xF2,0xB2
 .db    0xB2,0xB3
 .db    0xF2,0xB2
 .db    0xF2,0xB2
 .db    0xF2,0xF6
 .db    0xFA,0xD1
 .db    0x63,0x53
 .db    0x23,0x13
 .db    0x13,0x13
 .db    0x12,0x12
 .db    0x41,0x42
 .db    0x52,0x52
 .db    0x52,0x37
 .db    0x37,0x52
 .db    0x12,0x52
 .db    0x52,0x27
 .db    0x27,0x27
 .db    0x92,0xB7
 .db    0xBB,0xE2
 .db    0xB2,0xB2
 .db    0xB2,0xB3
 .db    0xE2,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB2
 .db    0xB3,0xB3
 .db    0xB3,0xE2
 .db    0xE2,0xE2
 .db    0xE2,0xE1
 .db    0xBB,0xFA
 .db    0xFA,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xB2
 .db    0xB3,0xF2
 .db    0xF6,0xF6
 .db    0xF2,0xF6
 .db    0xB2,0xF6
 .db    0xF2,0xB3
 .db    0xB2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xF6,0xFB
 .db    0xA7,0xA3
 .db    0xFF,0xBF
 .db    0x63,0xE7
 .db    0x63,0x73
 .db    0x63,0xFB
 .db    0xFA,0xFB
 .db    0xA3,0xFF
 .db    0xFF,0xFB
 .db    0xF6,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF7
 .db    0xF6,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xB2,0xF6
 .db    0xF6,0xB2
 .db    0xF2,0xB3
 .db    0xB2,0xB2
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0xF2,0xF2
 .db    0xF6,0xFA
 .db    0x63,0x23
 .db    0x23,0x13
 .db    0x13,0x13
 .db    0x12,0x12
 .db    0x13,0x42
 .db    0x17,0x42
 .db    0x27,0x63
 .db    0x37,0x52
 .db    0x52,0x52
 .db    0x52,0x27
 .db    0x27,0x27
 .db    0x92,0xBB
 .db    0xE2,0x77
 .db    0x77,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xB3
 .db    0x77,0x77
 .db    0x77,0x77
 .db    0x77,0x77
 .db    0xD2,0xE2
 .db    0xB7,0xE2
 .db    0xE2,0xE6
 .db    0xFA,0xFA
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xB3
 .db    0xB3,0xB3
 .db    0xF2,0xF6
 .db    0xF2,0xF2
 .db    0x73,0xF6
 .db    0xB2,0xB3
 .db    0xB3,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0x73
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xFB
 .db    0x67,0x63
 .db    0xFF,0xA7
 .db    0x63,0xE6
 .db    0x63,0xE7
 .db    0xA3,0xFB
 .db    0xFB,0xFF
 .db    0xFF,0xBB
 .db    0xBB,0xF6
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xFB
 .db    0xE1,0xFB
 .db    0xB2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xF2,0xF6
 .db    0xF2,0xB2
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0xF2,0xB2
 .db    0xF2,0xF2
 .db    0xF6,0xFA
 .db    0x3B,0x27
 .db    0x52,0x23
 .db    0x13,0x13
 .db    0x13,0x13
 .db    0x13,0x13
 .db    0x42,0x13
 .db    0x63,0x73
 .db    0x37,0x27
 .db    0x52,0x52
 .db    0x52,0x52
 .db    0x27,0x27
 .db    0x92,0xB7
 .db    0x77,0x77
 .db    0x77,0x77
 .db    0x77,0x77
 .db    0x77,0x77
 .db    0x77,0xA2
 .db    0xA2,0x77
 .db    0x77,0x77
 .db    0xD2,0xE2
 .db    0xE2,0xE2
 .db    0xE2,0xFA
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xB2
 .db    0xF2,0xF2
 .db    0xB3,0xB7
 .db    0xF2,0xF2
 .db    0xB2,0xF6
 .db    0xB2,0xF2
 .db    0xF2,0x73
 .db    0xF2,0xE2
 .db    0xF2,0x73
 .db    0xF6,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xFA
 .db    0xE6,0x73
 .db    0xBF,0xE6
 .db    0x63,0xFB
 .db    0x77,0xBB
 .db    0xFB,0xFB
 .db    0xFF,0xFF
 .db    0xFF,0x93
 .db    0xBB,0xF6
 .db    0xF2,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xFA
 .db    0x73,0xFB
 .db    0xF2,0xF6
 .db    0xF2,0xF2
 .db    0xB3,0xFA
 .db    0x73,0xFA
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xB2,0xB2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xE6,0x27
 .db    0x53,0x52
 .db    0x13,0x13
 .db    0x13,0x13
 .db    0x13,0x13
 .db    0x13,0x42
 .db    0x63,0x73
 .db    0x37,0x27
 .db    0x27,0x52
 .db    0x27,0x27
 .db    0x27,0x37
 .db    0x92,0x77
 .db    0x73,0x77
 .db    0x77,0x77
 .db    0x77,0x77
 .db    0xA2,0xA2
 .db    0xA2,0xA2
 .db    0xA2,0xA2
 .db    0x77,0x77
 .db    0xD2,0xD2
 .db    0xE2,0xE2
 .db    0xBB,0xFF
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xB3,0xB2
 .db    0xF2,0xF2
 .db    0xB2,0x73
 .db    0xF6,0xF6
 .db    0xF2,0xFA
 .db    0xF2,0xF2
 .db    0xF2,0xB2
 .db    0xF2,0x73
 .db    0xF2,0x73
 .db    0xF6,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xF6,0xF6
 .db    0xFB,0xE6
 .db    0x63,0xFB
 .db    0xE6,0xFF
 .db    0x63,0x63
 .db    0xFF,0xD2
 .db    0xD2,0xFF
 .db    0xFF,0x63
 .db    0xFB,0xF6
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xF6
 .db    0xF6,0xF6
 .db    0x73,0xFB
 .db    0xFA,0xFA
 .db    0xF2,0xF2
 .db    0x73,0xF6
 .db    0x73,0xFA
 .db    0xB2,0xF6
 .db    0xF2,0xF2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xFA,0x7B
 .db    0x53,0x53
 .db    0x13,0x13
 .db    0x13,0x13
 .db    0x13,0x13
 .db    0x13,0x52
 .db    0x63,0x73
 .db    0x62,0x27
 .db    0x62,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x92,0x77
 .db    0x77,0x77
 .db    0x77,0x77
 .db    0xA2,0xA2
 .db    0xA2,0xA2
 .db    0x63,0x63
 .db    0xA2,0xA2
 .db    0x77,0x77
 .db    0x77,0xD2
 .db    0xA7,0xBB
 .db    0xFB,0xFA
 .db    0xF6,0xF6
 .db    0xF2,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xB2
 .db    0xF6,0xF2
 .db    0xF6,0xFB
 .db    0xFA,0xF6
 .db    0xF6,0xF6
 .db    0xF6,0x73
 .db    0xF6,0x73
 .db    0xF6,0xF2
 .db    0xF6,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xF6,0xF6
 .db    0xFB,0xBB
 .db    0x63,0xFB
 .db    0xFB,0xFB
 .db    0xA3,0x63
 .db    0xFF,0x63
 .db    0x63,0xA7
 .db    0xE6,0x77
 .db    0xF6,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xF6
 .db    0xB3,0xFB
 .db    0xE6,0xF6
 .db    0xF2,0xF2
 .db    0x73,0xF6
 .db    0xB2,0xFA
 .db    0x73,0xF6
 .db    0xB2,0xE2
 .db    0xF2,0xB2
 .db    0xB3,0xB2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xFA
 .db    0x92,0x53
 .db    0x52,0x13
 .db    0x13,0x13
 .db    0x13,0x13
 .db    0x13,0x52
 .db    0x63,0x37
 .db    0x62,0x62
 .db    0x37,0x73
 .db    0xA2,0xA2
 .db    0x63,0x63
 .db    0x67,0x77
 .db    0x77,0x77
 .db    0x77,0x77
 .db    0xA2,0x73
 .db    0x73,0xA2
 .db    0x73,0x63
 .db    0xA2,0xA2
 .db    0xA2,0x77
 .db    0xD2,0xD2
 .db    0xD6,0xFB
 .db    0xFA,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xB2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xE2
 .db    0xFB,0xF6
 .db    0xF6,0xFF
 .db    0xE6,0xF6
 .db    0xB7,0xF6
 .db    0xF6,0xB3
 .db    0xF6,0x73
 .db    0xF7,0x73
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xFB,0xA7
 .db    0x63,0xE2
 .db    0xA7,0xA3
 .db    0xA3,0xE6
 .db    0xFF,0x63
 .db    0x63,0x73
 .db    0xA3,0xFA
 .db    0xF6,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xB2
 .db    0xB3,0xF2
 .db    0xF6,0xB2
 .db    0xBB,0xFB
 .db    0xF6,0xFF
 .db    0x73,0xB7
 .db    0xB3,0xF2
 .db    0xB2,0xF2
 .db    0xF2,0xFA
 .db    0x73,0xF6
 .db    0x73,0xB3
 .db    0xF2,0xB2
 .db    0xF2,0xB2
 .db    0xB2,0xF2
 .db    0xB3,0xF2
 .db    0xF6,0xFA
 .db    0xBB,0x53
 .db    0x53,0x52
 .db    0x52,0x13
 .db    0x13,0x13
 .db    0x13,0x52
 .db    0x37,0x62
 .db    0x62,0x37
 .db    0x73,0xA2
 .db    0xB2,0xB2
 .db    0xA2,0x63
 .db    0xA2,0x7B
 .db    0x73,0x73
 .db    0x77,0x77
 .db    0xA2,0x73
 .db    0x73,0xA2
 .db    0xA2,0xA2
 .db    0xA2,0xA2
 .db    0xA2,0x77
 .db    0x7B,0xE6
 .db    0xFA,0xFA
 .db    0xF6,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xB7,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xF6,0x73
 .db    0xFB,0xFB
 .db    0xF6,0xFB
 .db    0x63,0xF6
 .db    0x73,0xE2
 .db    0xF6,0xF2
 .db    0xF6,0x73
 .db    0xF7,0x73
 .db    0xF6,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xFA,0xA7
 .db    0x63,0x73
 .db    0xA3,0x63
 .db    0x63,0xFF
 .db    0xFF,0xE2
 .db    0xB7,0xA3
 .db    0xA3,0xFB
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xB2
 .db    0xF6,0x73
 .db    0xF6,0x73
 .db    0xE2,0xFB
 .db    0xFB,0xFB
 .db    0x73,0xE2
 .db    0x73,0xB3
 .db    0xF2,0xF2
 .db    0xF6,0xF6
 .db    0xB7,0xF6
 .db    0xB2,0xF2
 .db    0xB3,0xB2
 .db    0xB3,0xB2
 .db    0xB2,0xF2
 .db    0xF2,0xB2
 .db    0xF2,0xF6
 .db    0xFA,0x92
 .db    0x63,0x53
 .db    0x27,0x52
 .db    0x13,0x13
 .db    0x42,0x52
 .db    0x27,0x27
 .db    0x62,0x73
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x77
 .db    0xA2,0xE2
 .db    0x73,0x73
 .db    0x77,0x77
 .db    0xA2,0x73
 .db    0xA2,0xA2
 .db    0xA2,0xA2
 .db    0xA2,0x77
 .db    0x77,0x77
 .db    0x7B,0xFA
 .db    0xFA,0xF6
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xF6
 .db    0xFB,0xF7
 .db    0x73,0xF2
 .db    0x73,0xFA
 .db    0xA2,0x73
 .db    0xF6,0xA3
 .db    0xF6,0xBB
 .db    0x73,0xF6
 .db    0x63,0x73
 .db    0xB7,0x73
 .db    0xF2,0x73
 .db    0xF2,0x73
 .db    0xF2,0xF6
 .db    0xB3,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xF6,0xFA
 .db    0xA3,0x63
 .db    0x63,0xA3
 .db    0x73,0xFB
 .db    0xBB,0xE2
 .db    0xFB,0xFB
 .db    0xA3,0xFA
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xF7,0x73
 .db    0xF7,0x73
 .db    0xF7,0xFA
 .db    0xFB,0xF2
 .db    0xB2,0xF6
 .db    0xB2,0xF2
 .db    0xF2,0xB2
 .db    0xB7,0x77
 .db    0xF6,0xF2
 .db    0xF2,0xB7
 .db    0xB3,0xB2
 .db    0xB2,0xB3
 .db    0xB3,0xF2
 .db    0xB2,0xF2
 .db    0xF6,0xF6
 .db    0xFA,0xE6
 .db    0x63,0x63
 .db    0x53,0x27
 .db    0x52,0x52
 .db    0x52,0x52
 .db    0x52,0x52
 .db    0x37,0x73
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xA2,0xE2
 .db    0x73,0x73
 .db    0x73,0xA2
 .db    0xA2,0x73
 .db    0xA2,0xA2
 .db    0x77,0x77
 .db    0xA2,0x77
 .db    0xD1,0xD1
 .db    0xBB,0xFA
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0x73
 .db    0xFB,0xFA
 .db    0x73,0xF2
 .db    0xB2,0xFB
 .db    0x73,0xF2
 .db    0xBB,0x73
 .db    0xB2,0xBB
 .db    0x73,0xF6
 .db    0x73,0x73
 .db    0xB7,0x73
 .db    0xE2,0xB2
 .db    0xF2,0x73
 .db    0xB2,0xF7
 .db    0x73,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xFB
 .db    0xFB,0x73
 .db    0x63,0xEB
 .db    0xBB,0xA7
 .db    0x63,0x63
 .db    0xA7,0xFB
 .db    0xFF,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF7,0x73
 .db    0xB3,0xB3
 .db    0xFB,0xE2
 .db    0xFB,0x73
 .db    0xF6,0xFB
 .db    0xF2,0xF2
 .db    0xF2,0xB2
 .db    0xF2,0x73
 .db    0xFA,0xB2
 .db    0xF6,0xB2
 .db    0xF2,0xB2
 .db    0xB2,0xF2
 .db    0xF2,0xF2
 .db    0xB2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xFA
 .db    0x67,0x63
 .db    0x63,0x63
 .db    0x27,0x27
 .db    0x52,0x27
 .db    0x52,0x52
 .db    0x37,0x73
 .db    0x77,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0x77,0xE6
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xA2,0xA2
 .db    0x77,0x77
 .db    0x77,0x77
 .db    0x77,0x7B
 .db    0xFA,0xFA
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xF7,0x73
 .db    0xF7,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xFB
 .db    0xE2,0xFA
 .db    0xE6,0x73
 .db    0xB2,0xFB
 .db    0xB2,0xF6
 .db    0x73,0xB2
 .db    0xF6,0x73
 .db    0xB3,0xB7
 .db    0xF6,0x73
 .db    0x73,0xF6
 .db    0x73,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xFB
 .db    0xE6,0xB7
 .db    0xBB,0xFF
 .db    0xFB,0x63
 .db    0x63,0x63
 .db    0x63,0xA3
 .db    0xFF,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xF2,0xF2
 .db    0xF6,0xB3
 .db    0x73,0xE2
 .db    0xFB,0x73
 .db    0xF7,0x73
 .db    0xFB,0xFF
 .db    0xFA,0xF6
 .db    0xF2,0xB3
 .db    0xF6,0x73
 .db    0xF6,0x73
 .db    0xF6,0xB2
 .db    0xF2,0xB2
 .db    0xF2,0xF2
 .db    0x73,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xBB,0x63
 .db    0x73,0x63
 .db    0x63,0x27
 .db    0x27,0x27
 .db    0x52,0x52
 .db    0x62,0x63
 .db    0x77,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xE6
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0xA2,0xA2
 .db    0xA2,0xA2
 .db    0x77,0x77
 .db    0x7B,0x7B
 .db    0x7B,0xFA
 .db    0xFA,0xF6
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xB3
 .db    0xF2,0xB7
 .db    0xF6,0xF6
 .db    0xF6,0xFA
 .db    0xFB,0xB7
 .db    0xE2,0x73
 .db    0xF2,0xFB
 .db    0xF6,0xB3
 .db    0xF2,0xF6
 .db    0xFA,0xB3
 .db    0xB2,0xFA
 .db    0xFA,0xF2
 .db    0x73,0xF2
 .db    0xF2,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xBF
 .db    0x63,0xA3
 .db    0xFF,0xFF
 .db    0xA7,0x73
 .db    0x63,0x73
 .db    0x63,0xA2
 .db    0xFF,0xF6
 .db    0xF2,0xB3
 .db    0xF6,0xBB
 .db    0xB3,0xF2
 .db    0xF6,0xF6
 .db    0x73,0x73
 .db    0xF7,0x73
 .db    0xFB,0xF2
 .db    0xFB,0xFB
 .db    0xBB,0xF2
 .db    0xE2,0x73
 .db    0xF6,0xF2
 .db    0xB6,0x77
 .db    0xB7,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0x73,0xF2
 .db    0xB2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xFB,0x92
 .db    0x73,0x63
 .db    0x62,0x27
 .db    0x27,0x52
 .db    0x52,0x52
 .db    0x27,0x63
 .db    0x77,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x7B
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0xA2,0xA2
 .db    0xA2,0x77
 .db    0x77,0x77
 .db    0x7B,0x7B
 .db    0xFA,0xFA
 .db    0xF6,0xF2
 .db    0xF6,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xB2,0xF6
 .db    0xB7,0xB3
 .db    0xB3,0xF6
 .db    0xF7,0x73
 .db    0xB7,0x73
 .db    0xB7,0xB2
 .db    0xB3,0xBB
 .db    0xFB,0x73
 .db    0xB7,0xB7
 .db    0xF6,0xF6
 .db    0xB2,0xFB
 .db    0xFB,0xFA
 .db    0xB3,0xF2
 .db    0xB3,0xF6
 .db    0xB3,0xF6
 .db    0xF6,0xF2
 .db    0xF6,0x7B
 .db    0x63,0x63
 .db    0xFB,0xBF
 .db    0x63,0x73
 .db    0x73,0xB7
 .db    0x63,0xBB
 .db    0xBB,0xF6
 .db    0xF2,0xB3
 .db    0xF7,0xBB
 .db    0xB3,0xF2
 .db    0xF6,0xF2
 .db    0xF2,0xB2
 .db    0xF6,0x73
 .db    0xF6,0xB7
 .db    0xFF,0xBB
 .db    0x73,0xB2
 .db    0xB2,0x73
 .db    0xF6,0xF6
 .db    0xB2,0xF6
 .db    0x73,0xF6
 .db    0xF2,0xF2
 .db    0xB2,0xF2
 .db    0xB2,0xF2
 .db    0xB2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xFA,0xBF
 .db    0x92,0x37
 .db    0x27,0x27
 .db    0x52,0x52
 .db    0x52,0x52
 .db    0x27,0x37
 .db    0x77,0x77
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xE1,0x67
 .db    0xE2,0x73
 .db    0x73,0xA2
 .db    0xA2,0x77
 .db    0x77,0x77
 .db    0x77,0x77
 .db    0x7B,0xFA
 .db    0xFA,0xF6
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xF6,0xF6
 .db    0xF2,0xF6
 .db    0xB2,0xB7
 .db    0xF6,0xB3
 .db    0x73,0xF6
 .db    0xFB,0x73
 .db    0xB3,0x73
 .db    0xFB,0xF6
 .db    0x77,0x73
 .db    0xF6,0x73
 .db    0xB2,0x73
 .db    0xF6,0xF6
 .db    0xF6,0xBB
 .db    0xE2,0xFB
 .db    0xB3,0xB3
 .db    0x73,0xB3
 .db    0x73,0xF6
 .db    0xF6,0xF2
 .db    0xF6,0x92
 .db    0x63,0x63
 .db    0xBB,0xE2
 .db    0x63,0xA3
 .db    0xB7,0xFB
 .db    0xE6,0xFF
 .db    0xE6,0xF2
 .db    0xF2,0xB3
 .db    0xF7,0xE6
 .db    0x73,0xF2
 .db    0xFB,0xB2
 .db    0xF2,0xB3
 .db    0xF7,0xB2
 .db    0xB3,0x77
 .db    0xFB,0x77
 .db    0x73,0xB7
 .db    0xE2,0x73
 .db    0xF6,0xF2
 .db    0xF2,0xF6
 .db    0x73,0xF6
 .db    0xF6,0xF6
 .db    0x73,0xF6
 .db    0xF2,0xB2
 .db    0xB2,0xB3
 .db    0xB3,0xB3
 .db    0xF2,0xF2
 .db    0xF6,0xFA
 .db    0xE6,0x27
 .db    0x52,0x27
 .db    0x27,0x52
 .db    0x52,0x52
 .db    0x27,0x62
 .db    0xA2,0x77
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xE1,0x92
 .db    0x7B,0x63
 .db    0x73,0xA2
 .db    0xA2,0x77
 .db    0x77,0x77
 .db    0x77,0x77
 .db    0xE6,0xFA
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xFA
 .db    0xFB,0xFB
 .db    0xE2,0xFB
 .db    0xFA,0x73
 .db    0xF6,0xE2
 .db    0x73,0xF6
 .db    0xFB,0xB2
 .db    0xB3,0xB2
 .db    0xFF,0xFA
 .db    0xE2,0x73
 .db    0xE2,0xB2
 .db    0xF2,0x73
 .db    0xF6,0xFA
 .db    0xFB,0x77
 .db    0x73,0xFB
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xF6
 .db    0xF6,0xF2
 .db    0xF6,0xA6
 .db    0x63,0x73
 .db    0xBB,0xBB
 .db    0x63,0xE7
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xE6,0xF2
 .db    0xF2,0xF2
 .db    0xFB,0xB2
 .db    0x73,0x73
 .db    0xF6,0x73
 .db    0xB3,0xB2
 .db    0xF6,0xF2
 .db    0x73,0x73
 .db    0xFF,0xB2
 .db    0x73,0xFA
 .db    0xF6,0xE2
 .db    0xB7,0x73
 .db    0xF6,0xF6
 .db    0xB2,0xB7
 .db    0xF6,0xF6
 .db    0x73,0xF2
 .db    0xF2,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xFA,0x3B
 .db    0x52,0x27
 .db    0x27,0x52
 .db    0x52,0x52
 .db    0x52,0x27
 .db    0xA2,0x77
 .db    0x77,0xB2
 .db    0x73,0x73
 .db    0xB6,0x92
 .db    0x77,0x63
 .db    0x73,0xA2
 .db    0xA2,0x77
 .db    0x77,0x77
 .db    0x77,0x7B
 .db    0xFA,0xFA
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xF6,0xFB
 .db    0xF2,0xFB
 .db    0xBB,0xFF
 .db    0x73,0xFB
 .db    0xFB,0xB2
 .db    0xF6,0xF6
 .db    0xB3,0xF6
 .db    0xE6,0xF6
 .db    0xF6,0xF2
 .db    0xFF,0xFB
 .db    0xFB,0x73
 .db    0x73,0xF6
 .db    0xF6,0x73
 .db    0xB3,0xFA
 .db    0xFF,0x73
 .db    0x73,0xFB
 .db    0xB3,0x73
 .db    0x73,0xE2
 .db    0x73,0xF6
 .db    0xF6,0xF2
 .db    0xF6,0xBF
 .db    0xA3,0xBB
 .db    0xFB,0xFB
 .db    0x73,0xA3
 .db    0xA7,0xFF
 .db    0xFB,0xA3
 .db    0xE6,0xF6
 .db    0xF6,0xF6
 .db    0xFB,0xB2
 .db    0x73,0x73
 .db    0xB3,0x73
 .db    0xB3,0xB2
 .db    0xB7,0xF6
 .db    0xB2,0xE2
 .db    0xFA,0xF6
 .db    0xB7,0xFA
 .db    0xFA,0xF6
 .db    0x73,0x73
 .db    0xF6,0xF6
 .db    0xF6,0xF2
 .db    0x77,0xF6
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xB2,0xB2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xF6,0xEA
 .db    0x52,0x27
 .db    0x27,0x52
 .db    0x52,0x52
 .db    0x52,0x27
 .db    0x92,0xA2
 .db    0x77,0xB2
 .db    0x73,0x73
 .db    0xE1,0x67
 .db    0x77,0xA2
 .db    0x63,0xA2
 .db    0x77,0x77
 .db    0x77,0x77
 .db    0xD1,0xEA
 .db    0xFA,0xF6
 .db    0xF2,0xF2
 .db    0xB2,0xF2
 .db    0xF2,0xE6
 .db    0xB2,0xBB
 .db    0x73,0xFB
 .db    0x73,0xFB
 .db    0xB7,0xF2
 .db    0xF2,0xF6
 .db    0xFA,0xF6
 .db    0x73,0xF6
 .db    0xFB,0x77
 .db    0xFF,0xFB
 .db    0xFF,0x77
 .db    0x73,0xFB
 .db    0xB7,0x73
 .db    0x73,0xF6
 .db    0xB7,0x73
 .db    0xB2,0xFB
 .db    0xF6,0x73
 .db    0x73,0xF2
 .db    0x73,0xB3
 .db    0xF2,0xF2
 .db    0xF6,0xFB
 .db    0xFB,0xFB
 .db    0xA3,0xBB
 .db    0xA2,0x73
 .db    0x63,0xFF
 .db    0xD2,0x63
 .db    0xE2,0xFA
 .db    0xF6,0xF6
 .db    0xFB,0xF6
 .db    0xB3,0x73
 .db    0xB3,0x73
 .db    0xF6,0xF6
 .db    0xB2,0xB7
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0xE1
 .db    0x77,0xFA
 .db    0xB2,0x73
 .db    0xB3,0xBB
 .db    0xFA,0xB7
 .db    0x73,0xF6
 .db    0xF2,0xF2
 .db    0xF6,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xB2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xFA
 .db    0xD1,0x27
 .db    0x27,0x52
 .db    0x52,0x52
 .db    0x52,0x27
 .db    0x63,0xA2
 .db    0x77,0x77
 .db    0x73,0x73
 .db    0x77,0xA2
 .db    0xA2,0xA2
 .db    0x63,0xA2
 .db    0xA2,0xA2
 .db    0xA2,0x77
 .db    0xEA,0xFA
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xE2
 .db    0xE2,0xFA
 .db    0x73,0xFB
 .db    0xF6,0xFB
 .db    0x73,0xB3
 .db    0xF6,0xFB
 .db    0xFB,0xE6
 .db    0x73,0xF2
 .db    0xFA,0x73
 .db    0xE6,0xD2
 .db    0xFF,0xE6
 .db    0x73,0xFB
 .db    0xA2,0x73
 .db    0xB3,0xB7
 .db    0x73,0x73
 .db    0xF2,0xFB
 .db    0xFA,0x73
 .db    0x73,0xF2
 .db    0x73,0xF2
 .db    0xF2,0xF2
 .db    0xFB,0xFB
 .db    0xE6,0xB7
 .db    0x63,0x93
 .db    0x73,0x73
 .db    0x63,0xFB
 .db    0x63,0x63
 .db    0x77,0xFA
 .db    0xB2,0xB3
 .db    0xBB,0xF6
 .db    0xFA,0xF6
 .db    0xF6,0xF6
 .db    0xFB,0xFB
 .db    0xB2,0xE2
 .db    0xFB,0xE2
 .db    0xBB,0xFB
 .db    0xFA,0x73
 .db    0x63,0xFA
 .db    0xF6,0xE2
 .db    0x73,0xBB
 .db    0xE6,0xB2
 .db    0x73,0xF6
 .db    0xE2,0xE2
 .db    0xF6,0xF6
 .db    0xF2,0xB3
 .db    0xB3,0xB2
 .db    0xF2,0xB2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xFA,0x27
 .db    0x27,0x52
 .db    0x52,0x52
 .db    0x52,0x27
 .db    0x92,0x77
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0x77,0xA2
 .db    0xA2,0x77
 .db    0xA2,0x63
 .db    0x73,0xA2
 .db    0xA2,0x7B
 .db    0xFA,0xFA
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xF6
 .db    0xF6,0xFA
 .db    0xFA,0xFB
 .db    0xF6,0xFB
 .db    0xBB,0xF7
 .db    0x73,0xB3
 .db    0xF6,0xBB
 .db    0xE6,0xFA
 .db    0xB2,0xF6
 .db    0xFB,0xE2
 .db    0x73,0x73
 .db    0xFF,0xFA
 .db    0xB2,0xFB
 .db    0x73,0x73
 .db    0xF2,0xE2
 .db    0x73,0x73
 .db    0xFB,0xE2
 .db    0xFB,0xBB
 .db    0xF2,0xFA
 .db    0xB3,0xF6
 .db    0xF6,0xF6
 .db    0xFB,0xE2
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0xA3,0x63
 .db    0x63,0xE7
 .db    0x73,0x63
 .db    0xD2,0xFB
 .db    0xB2,0x73
 .db    0xB2,0xB3
 .db    0xFB,0xFA
 .db    0xFA,0xFB
 .db    0xBB,0xFB
 .db    0xB2,0xF6
 .db    0xF6,0x73
 .db    0xE2,0xFF
 .db    0xFA,0x73
 .db    0x63,0xFA
 .db    0xFA,0xF6
 .db    0x73,0xB7
 .db    0x73,0xB7
 .db    0xB3,0xF6
 .db    0xB2,0xE2
 .db    0xB2,0xF6
 .db    0xB2,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0xB2
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0xFA,0x91
 .db    0x52,0x52
 .db    0x52,0x52
 .db    0x52,0x37
 .db    0x92,0x77
 .db    0xA2,0x73
 .db    0x73,0x73
 .db    0xA2,0xA2
 .db    0xA2,0x77
 .db    0xA2,0x63
 .db    0x63,0xA2
 .db    0xA2,0xFA
 .db    0xFA,0xF6
 .db    0xF2,0xB3
 .db    0xF2,0xB3
 .db    0xB3,0xF2
 .db    0xFB,0xFB
 .db    0xFA,0xFA
 .db    0xFF,0xFA
 .db    0xB3,0xF6
 .db    0xF6,0xF6
 .db    0xF6,0x73
 .db    0x73,0xFB
 .db    0xFB,0xF6
 .db    0xB7,0xFB
 .db    0x73,0x73
 .db    0xFF,0xFF
 .db    0xF6,0xB3
 .db    0x73,0xB3
 .db    0xFB,0xBB
 .db    0x73,0x73
 .db    0xFB,0x73
 .db    0xFA,0xFF
 .db    0xFB,0xFB
 .db    0xFB,0xFF
 .db    0xFB,0xF6
 .db    0xFB,0x73
 .db    0x73,0x63
 .db    0x73,0xA3
 .db    0xBB,0x73
 .db    0xB3,0xB7
 .db    0x73,0x73
 .db    0xE6,0xFB
 .db    0xB2,0xB7
 .db    0x73,0x73
 .db    0xFB,0xB7
 .db    0xFB,0xF6
 .db    0x73,0xFF
 .db    0xF6,0xFB
 .db    0xBB,0x73
 .db    0x77,0xFA
 .db    0xFA,0x73
 .db    0xB3,0xE1
 .db    0x77,0xFA
 .db    0xB2,0x73
 .db    0x73,0xFB
 .db    0xE2,0xF6
 .db    0xF2,0xB3
 .db    0x73,0xF6
 .db    0xB2,0xB3
 .db    0xB2,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xFA,0x7B
 .db    0x52,0x52
 .db    0x52,0x27
 .db    0x27,0x37
 .db    0x92,0x77
 .db    0xA2,0x73
 .db    0xA2,0x73
 .db    0xA2,0x73
 .db    0xA2,0x77
 .db    0xA2,0x92
 .db    0x63,0xA2
 .db    0x7B,0xFA
 .db    0xF6,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xE2
 .db    0xBB,0xB3
 .db    0xFB,0xF6
 .db    0xE2,0xF6
 .db    0xFB,0xB7
 .db    0xF7,0x73
 .db    0x73,0xBB
 .db    0xFB,0xD2
 .db    0x73,0xFB
 .db    0x73,0x73
 .db    0xE6,0xFF
 .db    0xA3,0x73
 .db    0x73,0xFB
 .db    0xFA,0xF6
 .db    0x73,0xB3
 .db    0xE2,0x73
 .db    0xE2,0xFF
 .db    0xFA,0xE2
 .db    0xFF,0xFB
 .db    0xFF,0xFA
 .db    0xA7,0x63
 .db    0x73,0x63
 .db    0x73,0xFB
 .db    0xFB,0x73
 .db    0xB7,0x63
 .db    0x73,0x73
 .db    0xFA,0xFB
 .db    0xF6,0xFB
 .db    0x73,0x73
 .db    0xF6,0x73
 .db    0xF7,0xB2
 .db    0x73,0xFB
 .db    0xFB,0xFF
 .db    0xFA,0x73
 .db    0x73,0xE2
 .db    0xFA,0xF6
 .db    0xF6,0x73
 .db    0x63,0xBB
 .db    0xF6,0x73
 .db    0x73,0xFA
 .db    0x73,0xB3
 .db    0xBB,0xB2
 .db    0x63,0xF6
 .db    0xF2,0xF2
 .db    0xB2,0xF2
 .db    0xB2,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xFA
 .db    0x52,0x52
 .db    0x27,0x27
 .db    0x27,0x37
 .db    0x92,0xA2
 .db    0xA2,0xA2
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x77,0xD1
 .db    0xA2,0x67
 .db    0x63,0x63
 .db    0xBF,0xFA
 .db    0xF6,0xF2
 .db    0xB3,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xB3
 .db    0xB3,0x73
 .db    0xF7,0x73
 .db    0xBB,0x77
 .db    0xF6,0xFB
 .db    0xFB,0x73
 .db    0xF7,0xE2
 .db    0x73,0x77
 .db    0xF6,0xA2
 .db    0x73,0xFB
 .db    0xE6,0x73
 .db    0x73,0xFB
 .db    0x73,0x73
 .db    0x73,0xFB
 .db    0xA3,0x73
 .db    0xF6,0xFA
 .db    0x77,0x73
 .db    0x73,0xBB
 .db    0xA3,0x73
 .db    0xFB,0xE2
 .db    0xFF,0xFB
 .db    0x77,0x63
 .db    0x73,0x63
 .db    0xA3,0xFF
 .db    0xFF,0xF6
 .db    0xB3,0x63
 .db    0x63,0x63
 .db    0xFB,0xF7
 .db    0xFB,0xFF
 .db    0xB2,0xB3
 .db    0xB2,0x73
 .db    0xF6,0x73
 .db    0x73,0xFB
 .db    0xFF,0xFF
 .db    0xFB,0xB7
 .db    0x73,0x73
 .db    0xB7,0xBF
 .db    0xFA,0x73
 .db    0x73,0x77
 .db    0xBB,0x73
 .db    0xBB,0xF6
 .db    0x73,0x73
 .db    0x77,0xB7
 .db    0xB7,0xFA
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xB3,0xB2
 .db    0xB2,0xB3
 .db    0xF2,0xF2
 .db    0xF6,0xFA
 .db    0x27,0x52
 .db    0x27,0x27
 .db    0x62,0x37
 .db    0x37,0xA2
 .db    0xA2,0xA2
 .db    0xA2,0x73
 .db    0x73,0xA2
 .db    0x77,0x7B
 .db    0xA2,0x67
 .db    0x92,0x67
 .db    0xFA,0xF6
 .db    0xF2,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xB2
 .db    0xF6,0xB2
 .db    0xB7,0x73
 .db    0xFB,0xFB
 .db    0xFB,0x73
 .db    0xF6,0xF6
 .db    0xF6,0x73
 .db    0xE2,0x77
 .db    0x73,0xFB
 .db    0xFF,0xA2
 .db    0x73,0xFB
 .db    0x73,0x73
 .db    0xB3,0xFB
 .db    0x73,0x73
 .db    0xFF,0xFF
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB7,0x73
 .db    0xFF,0xFB
 .db    0x67,0x63
 .db    0x73,0x73
 .db    0xE2,0xA3
 .db    0xA3,0xE2
 .db    0x73,0x73
 .db    0x63,0x63
 .db    0xBB,0xF6
 .db    0xF6,0xFF
 .db    0xFA,0xFB
 .db    0x73,0x73
 .db    0xF7,0x73
 .db    0x73,0xFB
 .db    0xFB,0xBB
 .db    0xB3,0xFA
 .db    0xB7,0x73
 .db    0x73,0x73
 .db    0xFA,0xB2
 .db    0x73,0x73
 .db    0x73,0xB7
 .db    0xFA,0xF6
 .db    0xB2,0x73
 .db    0x73,0xFA
 .db    0xFA,0xFA
 .db    0xF6,0xF2
 .db    0x73,0xF2
 .db    0xB2,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xF6
 .db    0xF6,0xFA
 .db    0xE6,0x27
 .db    0x27,0x27
 .db    0x27,0x37
 .db    0x63,0xA2
 .db    0xA2,0xA2
 .db    0xA2,0x73
 .db    0x73,0xA2
 .db    0xA2,0x77
 .db    0x67,0x92
 .db    0x92,0xE6
 .db    0xFA,0xF6
 .db    0xF2,0xB2
 .db    0xB3,0xB3
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xFA,0xF6
 .db    0xF6,0xF6
 .db    0xF6,0x73
 .db    0xF6,0xA3
 .db    0xFB,0xB2
 .db    0xF6,0xB2
 .db    0xFB,0xD2
 .db    0xB7,0xF6
 .db    0xF2,0xE6
 .db    0xFB,0xA2
 .db    0x73,0xBB
 .db    0xE6,0x73
 .db    0xFA,0xFB
 .db    0x73,0x73
 .db    0xFF,0xFF
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xFF,0xFB
 .db    0x77,0xA3
 .db    0x73,0xB3
 .db    0x73,0x63
 .db    0x73,0x73
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0xF6
 .db    0xFA,0xFF
 .db    0xFF,0xFF
 .db    0x73,0x73
 .db    0xF7,0x73
 .db    0x73,0xFB
 .db    0xF6,0x73
 .db    0x73,0xBB
 .db    0xBB,0x73
 .db    0x73,0x73
 .db    0xBB,0xF6
 .db    0xB7,0x73
 .db    0x63,0xFA
 .db    0xB2,0xE2
 .db    0xF6,0xB7
 .db    0xE2,0xFA
 .db    0xFA,0xE2
 .db    0xF6,0xB2
 .db    0xB3,0xF2
 .db    0xB2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xFA
 .db    0xF6,0xF6
 .db    0xFA,0x3B
 .db    0x27,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x63,0xA2
 .db    0xA2,0x73
 .db    0x73,0x77
 .db    0xA2,0xA2
 .db    0x67,0x63
 .db    0x92,0xBF
 .db    0xF6,0xF2
 .db    0xF2,0xB3
 .db    0xB2,0xF2
 .db    0xF6,0xF6
 .db    0xF2,0xF6
 .db    0xFB,0xFB
 .db    0xF2,0xFB
 .db    0xFB,0xB7
 .db    0xF6,0x73
 .db    0xF2,0xFA
 .db    0xF6,0x73
 .db    0xFB,0xFA
 .db    0xF7,0xB7
 .db    0xFB,0x73
 .db    0xE6,0x7B
 .db    0x63,0x77
 .db    0xFF,0xBB
 .db    0xFF,0xFF
 .db    0x73,0x73
 .db    0xFF,0xFF
 .db    0xE2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xFB,0xFA
 .db    0xFA,0xE6
 .db    0x63,0xBB
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0xA3
 .db    0xA3,0xB7
 .db    0x63,0xF6
 .db    0xFB,0xFF
 .db    0xFB,0xFF
 .db    0x73,0x73
 .db    0xF6,0x73
 .db    0x73,0xF6
 .db    0xB2,0x73
 .db    0x73,0x77
 .db    0xF6,0x73
 .db    0x73,0x73
 .db    0xFA,0xFA
 .db    0xFA,0xE1
 .db    0x73,0xFA
 .db    0x73,0xA3
 .db    0xFA,0xFA
 .db    0xBB,0xE6
 .db    0xE2,0x63
 .db    0xF2,0xF2
 .db    0xF6,0xF2
 .db    0xF2,0xB3
 .db    0xF6,0xF6
 .db    0xFA,0xFA
 .db    0xFA,0xF2
 .db    0xFA,0xBB
 .db    0x27,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x63,0x73
 .db    0x73,0x77
 .db    0x77,0xA2
 .db    0x92,0x92
 .db    0x7B,0xFA
 .db    0xF6,0xF2
 .db    0xF2,0xB2
 .db    0xF2,0xF2
 .db    0xF6,0xB2
 .db    0xF2,0xF7
 .db    0xE6,0xFB
 .db    0xF6,0xFB
 .db    0xFF,0xFB
 .db    0xFB,0x73
 .db    0xF6,0xFB
 .db    0xF6,0xE2
 .db    0xB7,0xB7
 .db    0xE2,0x73
 .db    0xFB,0x63
 .db    0x73,0xFA
 .db    0x63,0xB7
 .db    0xFF,0xFF
 .db    0xFF,0xBB
 .db    0x73,0x73
 .db    0xFF,0xFB
 .db    0xB3,0xE2
 .db    0xB7,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB7,0xFA
 .db    0xD2,0x73
 .db    0x73,0xBB
 .db    0x63,0x63
 .db    0x73,0x63
 .db    0x73,0xFB
 .db    0xFB,0xE6
 .db    0x63,0xF6
 .db    0xFF,0xF6
 .db    0xB3,0xB7
 .db    0x73,0xB3
 .db    0xB7,0x73
 .db    0x73,0xF6
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0xBB,0xB2
 .db    0x73,0x73
 .db    0xF6,0x77
 .db    0xBB,0xFA
 .db    0x73,0xFA
 .db    0x73,0x73
 .db    0xFA,0xFA
 .db    0xE1,0x73
 .db    0x73,0x63
 .db    0xF6,0xFA
 .db    0xF6,0xB2
 .db    0xF6,0x73
 .db    0xF6,0xFA
 .db    0xB2,0xE2
 .db    0xF6,0xF2
 .db    0xF6,0xFA
 .db    0x27,0x27
 .db    0x37,0x62
 .db    0x37,0x62
 .db    0x37,0x37
 .db    0x63,0x73
 .db    0x73,0x77
 .db    0x77,0xA2
 .db    0x92,0x92
 .db    0xBF,0xFA
 .db    0xF6,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xE2
 .db    0xF6,0x73
 .db    0xF6,0xFB
 .db    0x63,0xF6
 .db    0xFA,0xBF
 .db    0xFB,0xFF
 .db    0xFB,0xF6
 .db    0xFB,0xFB
 .db    0xFA,0xFB
 .db    0x73,0x73
 .db    0x77,0x73
 .db    0xF7,0x63
 .db    0x73,0xFF
 .db    0xE2,0xFA
 .db    0xFF,0xFF
 .db    0xFF,0xA2
 .db    0x73,0xB2
 .db    0xFF,0xE2
 .db    0x73,0xFB
 .db    0xFF,0xB7
 .db    0x73,0xB3
 .db    0x73,0x73
 .db    0xB7,0xFA
 .db    0x63,0x63
 .db    0xB3,0xF6
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x63,0xBB
 .db    0xFB,0x63
 .db    0x63,0xFA
 .db    0xFF,0xB3
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xE2,0x73
 .db    0x73,0xFB
 .db    0xE2,0x73
 .db    0x73,0x73
 .db    0x73,0xF6
 .db    0xB2,0x77
 .db    0xE1,0x63
 .db    0xA2,0xFA
 .db    0x73,0xFA
 .db    0x73,0xA2
 .db    0xFA,0xFA
 .db    0x77,0x73
 .db    0xB2,0x77
 .db    0xFA,0xFA
 .db    0xF6,0xF6
 .db    0xFB,0xB2
 .db    0xFB,0xFA
 .db    0xB2,0xE2
 .db    0xF6,0xF2
 .db    0xF6,0xFA
 .db    0xD1,0x27
 .db    0x27,0x27
 .db    0x27,0x62
 .db    0x62,0x37
 .db    0x63,0x73
 .db    0x73,0x67
 .db    0x67,0x92
 .db    0x92,0x67
 .db    0xFA,0xF6
 .db    0xF6,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0x73
 .db    0xF6,0xB2
 .db    0xFB,0xFB
 .db    0x63,0xE2
 .db    0xFB,0x77
 .db    0xB3,0xB7
 .db    0xB3,0xE2
 .db    0xFB,0xBB
 .db    0xB3,0xFB
 .db    0x73,0x73
 .db    0xBB,0x73
 .db    0xBB,0x73
 .db    0xB7,0xFF
 .db    0xFF,0xFA
 .db    0x77,0xE6
 .db    0xFF,0x73
 .db    0x73,0xE2
 .db    0xFB,0x73
 .db    0x73,0xFF
 .db    0xFF,0xFB
 .db    0xF6,0xFB
 .db    0xB2,0xE2
 .db    0xFA,0xE6
 .db    0x63,0x73
 .db    0xB7,0xA3
 .db    0xA3,0x73
 .db    0x73,0x63
 .db    0x63,0x73
 .db    0xA3,0x63
 .db    0x63,0xFF
 .db    0xFF,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xFB,0x73
 .db    0x73,0xFB
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xB3
 .db    0xF6,0xF6
 .db    0x73,0x63
 .db    0x73,0xFA
 .db    0x73,0xFA
 .db    0xB6,0xFA
 .db    0xFA,0xFA
 .db    0xB6,0x73
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0xFB
 .db    0xFB,0xFA
 .db    0xFA,0xFA
 .db    0xF2,0xFA
 .db    0xF2,0xB3
 .db    0xF2,0xFA
 .db    0xFA,0x27
 .db    0x27,0x27
 .db    0x27,0x27
 .db    0x62,0x37
 .db    0x63,0x73
 .db    0xA2,0x67
 .db    0x67,0x92
 .db    0x67,0x7B
 .db    0xFA,0xF6
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xB3
 .db    0xF7,0xF6
 .db    0xFB,0xFB
 .db    0xE2,0xFB
 .db    0xFF,0xD2
 .db    0xB3,0xA2
 .db    0x73,0x73
 .db    0xF7,0xA2
 .db    0x73,0xFF
 .db    0xE6,0x73
 .db    0xFB,0xBB
 .db    0xE2,0x73
 .db    0xB7,0xFF
 .db    0xFB,0xA2
 .db    0x73,0x73
 .db    0xFB,0x73
 .db    0x73,0xE2
 .db    0xE6,0x73
 .db    0x73,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFA,0xFA
 .db    0xFA,0x67
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0xA3,0x73
 .db    0x73,0x63
 .db    0x63,0x73
 .db    0x73,0x63
 .db    0x63,0xFF
 .db    0xFA,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xFB,0xB2
 .db    0xB2,0xB7
 .db    0x73,0x73
 .db    0xE2,0x73
 .db    0xB3,0x73
 .db    0xE6,0xFA
 .db    0x73,0x63
 .db    0x77,0xFA
 .db    0x73,0xFA
 .db    0xFA,0xFA
 .db    0x77,0xA7
 .db    0xF6,0xE2
 .db    0xFA,0xFA
 .db    0xFA,0xE2
 .db    0xFB,0xFA
 .db    0xBB,0xFA
 .db    0xFA,0xF6
 .db    0xFA,0xFB
 .db    0xB3,0xB3
 .db    0xF2,0xF6
 .db    0xFA,0xD1
 .db    0x52,0x52
 .db    0x27,0x27
 .db    0x62,0x37
 .db    0x63,0x73
 .db    0x77,0x77
 .db    0x77,0xA2
 .db    0xA2,0xEA
 .db    0xFA,0xF6
 .db    0xF2,0xF2
 .db    0xB2,0xB3
 .db    0xF2,0xF6
 .db    0xF6,0xF6
 .db    0xE2,0xF6
 .db    0xFB,0xFB
 .db    0xFF,0xFB
 .db    0xFA,0xA7
 .db    0xB7,0x73
 .db    0xF7,0x63
 .db    0x73,0xFF
 .db    0xFB,0xF6
 .db    0xFB,0xFF
 .db    0xE6,0xF2
 .db    0x73,0xFF
 .db    0x7B,0x73
 .db    0x73,0x73
 .db    0xFB,0x73
 .db    0x73,0xBB
 .db    0x77,0x73
 .db    0x73,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xF6,0x63
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0xA3,0x63
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0xE2,0xFF
 .db    0xE2,0x73
 .db    0x73,0x73
 .db    0x73,0xB3
 .db    0xFB,0xB3
 .db    0xF6,0x73
 .db    0x73,0xA2
 .db    0xF6,0x73
 .db    0xF6,0x73
 .db    0xE6,0xE2
 .db    0x73,0x73
 .db    0xBB,0xFA
 .db    0x73,0xBB
 .db    0xFA,0xE6
 .db    0x63,0x63
 .db    0xFA,0xE6
 .db    0x77,0xFB
 .db    0xA2,0x73
 .db    0xFB,0xB2
 .db    0x73,0xE2
 .db    0xF6,0xF6
 .db    0xFA,0xFA
 .db    0xB3,0xB3
 .db    0xF6,0xE2
 .db    0xFA,0xFA
 .db    0x52,0x52
 .db    0x52,0x27
 .db    0x62,0x63
 .db    0x73,0x73
 .db    0x77,0x67
 .db    0x67,0xA2
 .db    0x7B,0xFA
 .db    0xFA,0xF6
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0x77
 .db    0xB2,0xF6
 .db    0xA2,0xE2
 .db    0xF6,0xF6
 .db    0xFB,0xBB
 .db    0xFF,0xFB
 .db    0xF7,0x73
 .db    0xFB,0xA2
 .db    0x77,0xFF
 .db    0xFF,0xFF
 .db    0xA2,0xFB
 .db    0xFB,0xFB
 .db    0x73,0xFF
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xFB,0x77
 .db    0x73,0xFB
 .db    0xB2,0x73
 .db    0x73,0xFB
 .db    0xE6,0xBB
 .db    0xFB,0xFF
 .db    0xFF,0xFF
 .db    0xBB,0x63
 .db    0xA3,0x73
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0xFB,0x73
 .db    0xB3,0x63
 .db    0x63,0x63
 .db    0xBB,0xFB
 .db    0xB3,0x73
 .db    0x73,0x73
 .db    0xB3,0xF6
 .db    0xB3,0x73
 .db    0xF7,0x73
 .db    0x73,0xE2
 .db    0xFB,0xF6
 .db    0xB2,0x73
 .db    0xB7,0x73
 .db    0x73,0xE6
 .db    0xFA,0xFA
 .db    0x73,0xA2
 .db    0xFA,0xB6
 .db    0x63,0x63
 .db    0xFA,0xA2
 .db    0x73,0xE2
 .db    0x73,0x73
 .db    0xFA,0xE2
 .db    0x73,0xA2
 .db    0xF6,0xF6
 .db    0xB2,0xB7
 .db    0xF2,0xF2
 .db    0xF6,0xB3
 .db    0xF6,0xFA
 .db    0x3B,0x51
 .db    0x52,0x52
 .db    0x37,0x63
 .db    0x73,0x73
 .db    0x77,0x67
 .db    0x92,0x67
 .db    0xBB,0xFA
 .db    0xFA,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0x77
 .db    0xB3,0xFB
 .db    0xA2,0xB3
 .db    0x73,0xFB
 .db    0xB7,0x73
 .db    0xFF,0xFB
 .db    0xE2,0xF6
 .db    0xFF,0xBF
 .db    0xFA,0xFF
 .db    0xBF,0xBB
 .db    0x73,0xE2
 .db    0xFF,0xFB
 .db    0x73,0xFB
 .db    0xA2,0x73
 .db    0x73,0xB3
 .db    0xFB,0xFA
 .db    0x73,0xB3
 .db    0xF6,0x73
 .db    0xB3,0xB7
 .db    0x73,0x73
 .db    0xE2,0xFF
 .db    0xFF,0xFF
 .db    0xFA,0x63
 .db    0xBB,0x77
 .db    0x73,0xA3
 .db    0xBB,0xBB
 .db    0xFB,0x73
 .db    0xB3,0x73
 .db    0x73,0x63
 .db    0xA3,0xE2
 .db    0xB3,0x73
 .db    0x73,0x73
 .db    0xFB,0xE6
 .db    0x73,0x73
 .db    0xF2,0x73
 .db    0x73,0xBB
 .db    0xFF,0xFA
 .db    0x73,0x73
 .db    0xBB,0x73
 .db    0x63,0xFA
 .db    0xE6,0xD2
 .db    0x73,0x63
 .db    0xBB,0xBB
 .db    0x73,0xA2
 .db    0xFA,0x73
 .db    0x63,0xB3
 .db    0x73,0xE2
 .db    0xFA,0xF6
 .db    0xE2,0xE6
 .db    0xFA,0xFA
 .db    0x73,0xE2
 .db    0xF6,0xF6
 .db    0xFA,0xF6
 .db    0xF2,0xF6
 .db    0xFA,0x52
 .db    0x52,0x52
 .db    0x37,0x73
 .db    0x73,0x73
 .db    0xB2,0x92
 .db    0x92,0xD1
 .db    0xBF,0xFA
 .db    0xF6,0xF2
 .db    0xF2,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xFA
 .db    0xF6,0xF6
 .db    0xF6,0xB7
 .db    0x73,0xFB
 .db    0xA3,0x73
 .db    0xFB,0x73
 .db    0x73,0xFB
 .db    0xFF,0xFF
 .db    0xFF,0xBF
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xA2,0xFB
 .db    0xBB,0x73
 .db    0xE6,0x73
 .db    0x73,0xE2
 .db    0x73,0xFB
 .db    0x73,0x73
 .db    0xB7,0xB7
 .db    0xB3,0x73
 .db    0x73,0x73
 .db    0x73,0xFF
 .db    0xFF,0xFB
 .db    0xFA,0x73
 .db    0xBB,0xBB
 .db    0x73,0xA3
 .db    0xFB,0xBB
 .db    0xB7,0x73
 .db    0x73,0xF7
 .db    0x63,0x63
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xFF,0xB2
 .db    0x73,0x73
 .db    0xF6,0xB3
 .db    0x73,0xFB
 .db    0xFF,0xE6
 .db    0x73,0x73
 .db    0xFA,0x73
 .db    0x63,0xBF
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0xE6,0xFA
 .db    0x73,0xBB
 .db    0xFA,0xB6
 .db    0x77,0xFA
 .db    0xF6,0xFA
 .db    0xE1,0xE2
 .db    0xFA,0xF6
 .db    0xE2,0xF6
 .db    0xE2,0xF6
 .db    0xA2,0xBB
 .db    0xFA,0xF6
 .db    0xF2,0xF2
 .db    0xFA,0x7B
 .db    0x52,0x52
 .db    0x62,0x63
 .db    0x73,0xA2
 .db    0x7B,0x92
 .db    0x92,0xE6
 .db    0xFA,0xFA
 .db    0xF6,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xF6
 .db    0x77,0xFB
 .db    0xF6,0xF6
 .db    0xF6,0xFB
 .db    0xE6,0xF6
 .db    0x73,0xF6
 .db    0xF7,0x73
 .db    0xB3,0xFB
 .db    0xFB,0xBB
 .db    0xFF,0xE6
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xFB
 .db    0xA7,0x73
 .db    0xF7,0x63
 .db    0xB3,0x73
 .db    0x73,0xF2
 .db    0x73,0x73
 .db    0xE2,0xFF
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xFF
 .db    0xFF,0xE6
 .db    0xFA,0x73
 .db    0xA3,0xEB
 .db    0x73,0xA3
 .db    0xFF,0xA3
 .db    0x73,0x63
 .db    0x63,0xFB
 .db    0x63,0x63
 .db    0x63,0xB3
 .db    0x73,0xB2
 .db    0xB3,0xF6
 .db    0xFF,0xB2
 .db    0x73,0x73
 .db    0xFB,0xFA
 .db    0x73,0xFF
 .db    0xFF,0xE1
 .db    0x73,0x73
 .db    0xBB,0x73
 .db    0x63,0xE2
 .db    0x63,0x73
 .db    0xE2,0x63
 .db    0xA7,0xFA
 .db    0x73,0xBB
 .db    0xFA,0xFA
 .db    0xF6,0xFA
 .db    0xFA,0xFA
 .db    0x73,0xE2
 .db    0xBB,0xF2
 .db    0x73,0xFA
 .db    0xFA,0xF6
 .db    0x73,0xB7
 .db    0xE2,0xF2
 .db    0xF2,0xF2
 .db    0xF6,0xFA
 .db    0x66,0x52
 .db    0x27,0x37
 .db    0x63,0xA2
 .db    0x7B,0x92
 .db    0x92,0xBF
 .db    0xFA,0xF6
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xF7
 .db    0x73,0xF3
 .db    0xB3,0xF7
 .db    0xF6,0xFF
 .db    0xFF,0xFB
 .db    0x73,0xFB
 .db    0xFB,0x73
 .db    0xF6,0xE2
 .db    0x7B,0x73
 .db    0xFB,0xFB
 .db    0xA3,0xA3
 .db    0xF6,0x73
 .db    0x73,0xE7
 .db    0x73,0x73
 .db    0xFB,0x73
 .db    0xB3,0x73
 .db    0x73,0xF2
 .db    0x73,0x73
 .db    0xFB,0xFF
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xFF
 .db    0xFA,0x73
 .db    0xBB,0x73
 .db    0x63,0xA3
 .db    0x73,0xBB
 .db    0xFF,0x73
 .db    0x63,0x63
 .db    0x63,0xE7
 .db    0x63,0x73
 .db    0x73,0xB3
 .db    0x73,0xB2
 .db    0xFB,0xFF
 .db    0xFF,0xB2
 .db    0x73,0x73
 .db    0xFF,0xFB
 .db    0x73,0xBB
 .db    0xFF,0xE1
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xA2,0xA2
 .db    0x63,0x77
 .db    0xFA,0x73
 .db    0x73,0xE6
 .db    0x73,0xA3
 .db    0xFA,0xFF
 .db    0xFA,0xFF
 .db    0xFA,0xFA
 .db    0xB2,0xF6
 .db    0x73,0xF2
 .db    0xB2,0xBB
 .db    0xFA,0xFA
 .db    0xE2,0xF2
 .db    0x73,0xF2
 .db    0xB3,0xB3
 .db    0xF6,0xFA
 .db    0xB6,0xA2
 .db    0x27,0x62
 .db    0x37,0xA2
 .db    0xEA,0x92
 .db    0x67,0xFA
 .db    0xFA,0xFA
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xE2,0xB7
 .db    0x73,0xF2
 .db    0xFB,0xFF
 .db    0xFB,0xFB
 .db    0xB7,0xFB
 .db    0xE6,0x73
 .db    0xF6,0xB7
 .db    0xA2,0x73
 .db    0xBB,0xFF
 .db    0xFB,0xFB
 .db    0xFF,0x77
 .db    0xB3,0x73
 .db    0xB3,0x73
 .db    0xFB,0x73
 .db    0xB7,0x73
 .db    0x63,0xF2
 .db    0x73,0x73
 .db    0xF6,0xFF
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xFF
 .db    0xE2,0x73
 .db    0xB7,0x73
 .db    0x63,0x73
 .db    0x73,0xFB
 .db    0xFB,0x73
 .db    0x63,0x63
 .db    0x73,0xA3
 .db    0x63,0x63
 .db    0x73,0xB3
 .db    0x73,0xB3
 .db    0xFF,0xFF
 .db    0xFF,0xB7
 .db    0xB3,0xB3
 .db    0xFF,0xBB
 .db    0x73,0x73
 .db    0xFF,0xF6
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xBB,0x73
 .db    0x63,0xE6
 .db    0xFA,0x73
 .db    0x73,0xB3
 .db    0x73,0x73
 .db    0xFA,0xFF
 .db    0xFA,0xFA
 .db    0xFB,0x77
 .db    0xF6,0xF2
 .db    0x73,0xFA
 .db    0xF6,0x73
 .db    0xD2,0xFA
 .db    0xF6,0xF2
 .db    0xB2,0xB3
 .db    0xB3,0xB3
 .db    0xF2,0xFA
 .db    0xBB,0xB2
 .db    0x37,0x37
 .db    0x37,0x92
 .db    0xFF,0x67
 .db    0xD1,0xFA
 .db    0xFA,0xF6
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xFB,0xFB
 .db    0xB3,0xF6
 .db    0xFB,0xBB
 .db    0xA3,0xFB
 .db    0xFB,0xFB
 .db    0xA2,0x73
 .db    0xFB,0xF7
 .db    0xA2,0x73
 .db    0xFB,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFA
 .db    0xFB,0x73
 .db    0xF2,0x73
 .db    0xB7,0xBB
 .db    0xEB,0x73
 .db    0x73,0xF7
 .db    0x73,0x73
 .db    0xFB,0xFF
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xFF
 .db    0x77,0x73
 .db    0xA3,0x73
 .db    0x73,0x73
 .db    0x73,0xE7
 .db    0xA3,0x73
 .db    0x73,0x63
 .db    0x73,0x73
 .db    0x63,0x63
 .db    0x63,0xB3
 .db    0x73,0xF6
 .db    0xFB,0xFA
 .db    0xFF,0xFA
 .db    0xF6,0xFB
 .db    0xFF,0xB7
 .db    0x73,0x73
 .db    0xFF,0xFB
 .db    0xE2,0x73
 .db    0x63,0xA3
 .db    0xFA,0x73
 .db    0x73,0xBB
 .db    0xFA,0x73
 .db    0x73,0xE2
 .db    0x73,0x73
 .db    0xBB,0xFF
 .db    0xD2,0xE2
 .db    0xFB,0x73
 .db    0xFA,0xF2
 .db    0xB2,0xF6
 .db    0xF2,0x73
 .db    0xA3,0xF2
 .db    0xF6,0xF2
 .db    0xF6,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xFA
 .db    0xFA,0xB2
 .db    0x92,0x63
 .db    0x63,0xD1
 .db    0xFF,0x92
 .db    0xE6,0xFF
 .db    0xFF,0xF6
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xF2,0xFB
 .db    0xBB,0xA3
 .db    0xFB,0x92
 .db    0x73,0xFB
 .db    0xFF,0xFB
 .db    0x77,0xE2
 .db    0xFB,0x73
 .db    0x73,0x73
 .db    0xFB,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFB
 .db    0xFB,0x73
 .db    0xB3,0x73
 .db    0x73,0xFF
 .db    0xFF,0x73
 .db    0xB3,0xB7
 .db    0x73,0x73
 .db    0xFF,0xFF
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xFF
 .db    0x73,0x73
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x63,0xB3
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0xB2
 .db    0x73,0xFB
 .db    0xE2,0x73
 .db    0xB7,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xB7
 .db    0x73,0x73
 .db    0xFB,0xFF
 .db    0xFA,0xA2
 .db    0x63,0x77
 .db    0xFB,0x73
 .db    0x73,0xE6
 .db    0xFA,0x73
 .db    0x73,0xBB
 .db    0xB6,0x73
 .db    0xF6,0xFA
 .db    0x73,0xA2
 .db    0xFA,0x63
 .db    0xFA,0xF6
 .db    0xF2,0xB2
 .db    0xF6,0xE2
 .db    0xF6,0xF6
 .db    0xF2,0x73
 .db    0xF6,0xB2
 .db    0xB2,0xB3
 .db    0xF2,0xF6
 .db    0xFA,0xE1
 .db    0x77,0x63
 .db    0x63,0xB7
 .db    0xB7,0x92
 .db    0xFA,0xFF
 .db    0xFF,0xF6
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xFF
 .db    0x77,0x73
 .db    0xFB,0x77
 .db    0x73,0xFB
 .db    0xFB,0xBB
 .db    0xF6,0xFA
 .db    0xE6,0x73
 .db    0x73,0x73
 .db    0xEB,0xE2
 .db    0xFF,0xFF
 .db    0xE2,0xA3
 .db    0xFB,0xB3
 .db    0xA3,0x73
 .db    0x73,0xFF
 .db    0xFB,0xB3
 .db    0xFB,0xA2
 .db    0x73,0x73
 .db    0xFF,0xFF
 .db    0xE2,0x73
 .db    0xB3,0xB3
 .db    0xB7,0xFF
 .db    0x73,0x73
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x63,0xB3
 .db    0xE2,0xA3
 .db    0x73,0x63
 .db    0x73,0x73
 .db    0x67,0xB2
 .db    0xB3,0xFB
 .db    0x73,0x73
 .db    0x73,0xFB
 .db    0xFF,0xFF
 .db    0xFA,0xB7
 .db    0x73,0x73
 .db    0xFA,0xFE
 .db    0xFA,0xE6
 .db    0x73,0x73
 .db    0xBB,0x73
 .db    0x73,0xA2
 .db    0xBB,0x73
 .db    0x73,0xFA
 .db    0xF6,0x77
 .db    0xFA,0xF6
 .db    0x63,0xA2
 .db    0xFA,0x63
 .db    0xFA,0xE2
 .db    0xB7,0xB3
 .db    0xFB,0xF6
 .db    0xE2,0xFA
 .db    0xB7,0x73
 .db    0xF6,0xB2
 .db    0xB2,0xB3
 .db    0xF2,0xF2
 .db    0xF6,0xF6
 .db    0xB3,0x77
 .db    0xD2,0xE2
 .db    0xA3,0x67
 .db    0xFF,0xFA
 .db    0xFA,0xF2
 .db    0xF2,0xB3
 .db    0xB3,0xB3
 .db    0xB2,0xB3
 .db    0xF2,0xFA
 .db    0xA2,0x73
 .db    0xFB,0xBF
 .db    0xE6,0xFF
 .db    0xD2,0x73
 .db    0xFB,0xFA
 .db    0x73,0x73
 .db    0x63,0x73
 .db    0xA3,0x73
 .db    0xFB,0xFF
 .db    0xA3,0x73
 .db    0xFB,0xFB
 .db    0x77,0x63
 .db    0x73,0xF7
 .db    0xA3,0x77
 .db    0xFF,0x73
 .db    0x73,0x73
 .db    0xFB,0xFF
 .db    0xFB,0xB7
 .db    0xFB,0xFB
 .db    0xFF,0xFB
 .db    0x73,0x73
 .db    0x23,0x73
 .db    0x73,0xE2
 .db    0xB3,0x73
 .db    0x63,0x73
 .db    0xFB,0xFB
 .db    0x73,0x63
 .db    0x73,0xE2
 .db    0xE6,0xB2
 .db    0xF6,0xBB
 .db    0x73,0x73
 .db    0x73,0xB7
 .db    0xFF,0xFF
 .db    0xB2,0x73
 .db    0x73,0xE2
 .db    0xFE,0xBF
 .db    0x77,0xBB
 .db    0xE2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB3,0x73
 .db    0x73,0xE6
 .db    0xD2,0xFA
 .db    0xFA,0xF6
 .db    0x73,0xE6
 .db    0xFA,0x77
 .db    0xFB,0x73
 .db    0x73,0xF6
 .db    0xFA,0xB7
 .db    0x73,0xFB
 .db    0xF6,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xF6,0xFB
 .db    0xF2,0xF3
 .db    0xB3,0xA3
 .db    0x93,0xC1
 .db    0xFF,0xFA
 .db    0xF6,0xF2
 .db    0xB3,0xB3
 .db    0xB2,0xB3
 .db    0xB3,0xB3
 .db    0xF6,0x77
 .db    0xB7,0xE2
 .db    0xFF,0xFB
 .db    0xFF,0xFF
 .db    0x63,0x73
 .db    0xFB,0x7B
 .db    0x73,0xE2
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0xB7,0xFF
 .db    0x63,0x73
 .db    0xB7,0xBB
 .db    0xB7,0x73
 .db    0x73,0xA3
 .db    0x63,0x73
 .db    0xFF,0x73
 .db    0x73,0x73
 .db    0xFB,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xBB
 .db    0x73,0xA3
 .db    0x63,0x73
 .db    0x73,0xFB
 .db    0xBB,0x73
 .db    0x73,0xB7
 .db    0xFF,0xFB
 .db    0x73,0x63
 .db    0x63,0xFB
 .db    0xFB,0x73
 .db    0xB7,0xB3
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xFF,0xBB
 .db    0x73,0x73
 .db    0x73,0xFA
 .db    0xFE,0x77
 .db    0x73,0x77
 .db    0xFA,0x73
 .db    0x73,0xB7
 .db    0xB3,0x73
 .db    0xB7,0x73
 .db    0x73,0x73
 .db    0x73,0xBB
 .db    0xF6,0xE2
 .db    0xB2,0xFA
 .db    0xFA,0xF6
 .db    0xFB,0x73
 .db    0x73,0xF6
 .db    0xFA,0xF6
 .db    0x77,0xFA
 .db    0xF6,0xF2
 .db    0xB3,0xB2
 .db    0xB3,0xB3
 .db    0xB3,0xB2
 .db    0xF2,0xFA
 .db    0xF2,0xF2
 .db    0xB3,0xA3
 .db    0xA3,0x96
 .db    0xFF,0xFA
 .db    0xF6,0xF2
 .db    0xB3,0xB3
 .db    0xB2,0xB3
 .db    0xF2,0xB3
 .db    0xF2,0x73
 .db    0xFB,0xFB
 .db    0xFB,0xE6
 .db    0xFB,0xFF
 .db    0x73,0x77
 .db    0xFF,0x67
 .db    0x73,0xFB
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0xB2,0xFF
 .db    0x63,0x73
 .db    0xB3,0x73
 .db    0xB3,0x73
 .db    0xB3,0x73
 .db    0x73,0x73
 .db    0xFF,0xE6
 .db    0xB7,0x73
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xBB
 .db    0x73,0x73
 .db    0x63,0x73
 .db    0xA3,0xFB
 .db    0xFB,0xA3
 .db    0x73,0xFB
 .db    0xFF,0xE6
 .db    0x73,0x73
 .db    0x63,0xBB
 .db    0xFB,0x73
 .db    0xB3,0xB3
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xFF,0x77
 .db    0x73,0x73
 .db    0x73,0xBB
 .db    0xFF,0x73
 .db    0x73,0x73
 .db    0xBB,0x73
 .db    0x73,0xA7
 .db    0xFA,0xE2
 .db    0xFA,0x73
 .db    0x73,0x73
 .db    0x73,0xBB
 .db    0xE2,0x73
 .db    0xA2,0xFA
 .db    0xBB,0xBB
 .db    0xBB,0xB3
 .db    0xB2,0xFA
 .db    0xFA,0xFA
 .db    0xE2,0xFA
 .db    0xF6,0xF6
 .db    0xF2,0xB3
 .db    0xB3,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xFA
 .db    0xB7,0xF2
 .db    0xA3,0x93
 .db    0xBB,0xC1
 .db    0xFF,0xFA
 .db    0xF6,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB2,0xB3
 .db    0xF2,0x73
 .db    0xF6,0xFA
 .db    0xF6,0x73
 .db    0xFB,0xFB
 .db    0xE2,0xFA
 .db    0xFF,0x92
 .db    0x73,0xFF
 .db    0xE2,0x73
 .db    0x73,0x73
 .db    0xBB,0xFB
 .db    0x63,0x73
 .db    0xB3,0x63
 .db    0x73,0xF6
 .db    0xFB,0x73
 .db    0x73,0x73
 .db    0xF6,0xFF
 .db    0xFF,0xB7
 .db    0xFF,0xFB
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0x73,0x73
 .db    0x63,0x73
 .db    0x73,0xA3
 .db    0xFF,0xA7
 .db    0xA3,0xFF
 .db    0xFF,0x7B
 .db    0x73,0x73
 .db    0x63,0x77
 .db    0xB7,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xFB,0x73
 .db    0x73,0x73
 .db    0x63,0x77
 .db    0xFE,0x73
 .db    0x73,0x73
 .db    0xA2,0x73
 .db    0x73,0x73
 .db    0xBB,0xFB
 .db    0xFF,0x73
 .db    0x73,0x73
 .db    0x73,0xBB
 .db    0xE1,0x73
 .db    0x73,0xBB
 .db    0x63,0x73
 .db    0x63,0xF6
 .db    0xB3,0xBB
 .db    0xFF,0xFA
 .db    0x63,0xA3
 .db    0xE2,0xA7
 .db    0xF6,0xB2
 .db    0xB3,0xB3
 .db    0xB2,0xF2
 .db    0xF2,0xF6
 .db    0xF6,0xF2
 .db    0x73,0x93
 .db    0xD6,0xC1
 .db    0xFF,0xFA
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB2
 .db    0xF2,0xB3
 .db    0xF6,0xF6
 .db    0xF6,0x73
 .db    0xF6,0xFA
 .db    0xFA,0xFA
 .db    0xE6,0x77
 .db    0xE2,0xFF
 .db    0x7B,0x73
 .db    0xE2,0xE2
 .db    0xFA,0xFB
 .db    0x63,0x73
 .db    0x73,0x63
 .db    0x73,0xF6
 .db    0xFF,0x77
 .db    0x73,0x73
 .db    0xB3,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFB
 .db    0xBF,0xFF
 .db    0xFF,0xFF
 .db    0xB3,0x73
 .db    0x73,0x63
 .db    0x73,0x73
 .db    0xFF,0xA3
 .db    0xA3,0xFF
 .db    0xFF,0xBB
 .db    0x73,0x73
 .db    0x63,0xBB
 .db    0xB3,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xE2
 .db    0xFB,0x73
 .db    0x73,0x73
 .db    0x63,0x73
 .db    0xFA,0x73
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x73,0x73
 .db    0xA2,0xFF
 .db    0xFF,0xBB
 .db    0xBB,0xB2
 .db    0x73,0x77
 .db    0xBB,0x73
 .db    0x77,0xBB
 .db    0x73,0x73
 .db    0x63,0xFB
 .db    0x73,0x77
 .db    0xFF,0xF6
 .db    0x73,0xE2
 .db    0x73,0x63
 .db    0xF6,0xB2
 .db    0xB3,0xB2
 .db    0xB3,0xF2
 .db    0xF2,0xFA
 .db    0xFA,0xF2
 .db    0x73,0xD2
 .db    0xD2,0x96
 .db    0xFF,0xFA
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xF2,0xB2
 .db    0xB3,0xF2
 .db    0xE2,0xF6
 .db    0xFB,0xE2
 .db    0xF6,0xF6
 .db    0xFB,0x77
 .db    0x63,0xB7
 .db    0xFA,0xFF
 .db    0xE6,0x73
 .db    0xF6,0xE6
 .db    0xB7,0xFB
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x73,0xF6
 .db    0xFF,0xFA
 .db    0x77,0x73
 .db    0xB3,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xB3
 .db    0x73,0xB7
 .db    0xFF,0xFF
 .db    0xBB,0x73
 .db    0xA3,0x63
 .db    0x73,0x73
 .db    0xFB,0x63
 .db    0xA3,0xFB
 .db    0xFF,0xFB
 .db    0xD2,0x73
 .db    0x63,0xBF
 .db    0xB3,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xF6
 .db    0xFA,0x73
 .db    0x73,0x63
 .db    0x63,0x73
 .db    0xE2,0xB2
 .db    0x73,0xB3
 .db    0x73,0x63
 .db    0x73,0x73
 .db    0x73,0xFB
 .db    0xFF,0xFA
 .db    0xFA,0xF6
 .db    0x73,0x63
 .db    0xBB,0xE2
 .db    0xE6,0xF6
 .db    0x73,0xB7
 .db    0x77,0xFB
 .db    0x73,0x63
 .db    0xFF,0xFA
 .db    0xB2,0xFA
 .db    0xB2,0x77
 .db    0xF6,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xFA
 .db    0xFA,0xFB
 .db    0xA7,0xFB
 .db    0xA7,0xC1
 .db    0xFF,0xF6
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xB2,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xF6
 .db    0x73,0xF2
 .db    0xFA,0xD2
 .db    0x77,0xFA
 .db    0xFB,0x73
 .db    0x63,0xBB
 .db    0xFA,0xFA
 .db    0x77,0x73
 .db    0xFB,0x67
 .db    0x63,0xFB
 .db    0xB7,0xB7
 .db    0x73,0x73
 .db    0x73,0xFB
 .db    0xBB,0xFF
 .db    0x73,0x63
 .db    0x77,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0x73
 .db    0x73,0x73
 .db    0xFB,0xFF
 .db    0xFB,0x73
 .db    0xB3,0x73
 .db    0x73,0xE2
 .db    0xD2,0x73
 .db    0x73,0xBB
 .db    0xBB,0xE7
 .db    0xBB,0x73
 .db    0x63,0xBB
 .db    0xB3,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xFB
 .db    0xFB,0xB2
 .db    0x73,0x63
 .db    0x73,0xB3
 .db    0x73,0x73
 .db    0x73,0xBB
 .db    0x73,0x63
 .db    0xE2,0x63
 .db    0x63,0xBB
 .db    0xE2,0xE6
 .db    0xFA,0xE2
 .db    0x73,0x63
 .db    0xFB,0xFA
 .db    0xB7,0xB7
 .db    0xB3,0xFA
 .db    0xFA,0xFA
 .db    0xE2,0xE2
 .db    0xFB,0xFA
 .db    0xF6,0xFA
 .db    0xF6,0xBB
 .db    0xFA,0xB2
 .db    0xB3,0x73
 .db    0xB3,0xB3
 .db    0xF2,0xF6
 .db    0xFA,0xBB
 .db    0xBF,0xFB
 .db    0x77,0xC1
 .db    0xFA,0xF6
 .db    0xF6,0xE2
 .db    0xB3,0xB3
 .db    0xB2,0xB3
 .db    0xB2,0xB3
 .db    0xB3,0xF6
 .db    0x73,0xF2
 .db    0xF6,0x73
 .db    0x73,0x77
 .db    0xF6,0xA3
 .db    0x73,0xF6
 .db    0xBB,0xBB
 .db    0xA2,0x73
 .db    0xFB,0x63
 .db    0x63,0xE2
 .db    0x73,0xB7
 .db    0x73,0x73
 .db    0xBB,0xFB
 .db    0x73,0xFB
 .db    0x63,0x73
 .db    0xA3,0xFB
 .db    0xFB,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0x73
 .db    0x73,0x73
 .db    0xB7,0xFF
 .db    0xFF,0xE2
 .db    0xB3,0x77
 .db    0x73,0xBB
 .db    0x77,0x73
 .db    0x73,0xB3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0x73,0xF7
 .db    0xB3,0x73
 .db    0x73,0xB3
 .db    0x73,0x73
 .db    0xB7,0xFF
 .db    0xFA,0x63
 .db    0x63,0x63
 .db    0x77,0xB7
 .db    0x63,0x63
 .db    0x63,0xFA
 .db    0x73,0xA2
 .db    0xFA,0x73
 .db    0x73,0xB3
 .db    0x73,0x77
 .db    0xE2,0x73
 .db    0x73,0x63
 .db    0xFA,0xBB
 .db    0x73,0x73
 .db    0xFA,0xFA
 .db    0xFA,0xBB
 .db    0xFA,0xFA
 .db    0xE2,0xFA
 .db    0xF6,0xFA
 .db    0xE2,0xD2
 .db    0xFA,0xF2
 .db    0xB3,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xF6
 .db    0xFA,0xBF
 .db    0x67,0xB7
 .db    0xA7,0xC1
 .db    0xFA,0xF6
 .db    0xF6,0x77
 .db    0xF2,0xF6
 .db    0xB3,0xB2
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xB3,0xF2
 .db    0xF6,0xE6
 .db    0xBB,0x73
 .db    0xF6,0xFA
 .db    0xBB,0x67
 .db    0xD2,0x77
 .db    0x77,0xB2
 .db    0xFA,0x73
 .db    0x73,0x73
 .db    0x63,0xB3
 .db    0x73,0xF6
 .db    0xFA,0xFA
 .db    0x73,0xD2
 .db    0x73,0x73
 .db    0xB7,0xE2
 .db    0xA3,0xE6
 .db    0xFF,0xFF
 .db    0xFF,0x73
 .db    0x73,0x73
 .db    0xB3,0xFF
 .db    0xFF,0xFB
 .db    0xB2,0xBB
 .db    0xB2,0xF7
 .db    0xA3,0x63
 .db    0x73,0xB3
 .db    0x73,0x73
 .db    0x73,0xD2
 .db    0x63,0xFB
 .db    0x73,0x73
 .db    0xB3,0xF6
 .db    0xF6,0xFA
 .db    0xFB,0xFF
 .db    0xBB,0x63
 .db    0x63,0xB7
 .db    0xFA,0xE6
 .db    0x63,0x63
 .db    0x63,0xFA
 .db    0xB7,0xFA
 .db    0xFA,0xB6
 .db    0x73,0x73
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0xB7,0xE2
 .db    0xFA,0xE2
 .db    0x63,0x63
 .db    0xFA,0xFA
 .db    0xFA,0x73
 .db    0xFB,0xB7
 .db    0x63,0xE2
 .db    0xFA,0xF6
 .db    0x73,0x63
 .db    0xFA,0xF6
 .db    0xF6,0xF2
 .db    0xB2,0xB2
 .db    0xB3,0xF6
 .db    0xFA,0xFA
 .db    0x67,0xB7
 .db    0xBB,0xC1
 .db    0xFA,0xF6
 .db    0xF2,0xF2
 .db    0xFA,0xE6
 .db    0xB3,0xF2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xF6,0xFA
 .db    0xFA,0xE6
 .db    0xFA,0xFA
 .db    0xFA,0x63
 .db    0xB7,0x73
 .db    0xBB,0xFA
 .db    0xFA,0xA2
 .db    0xE2,0x63
 .db    0x63,0x63
 .db    0xB3,0xB7
 .db    0xE2,0xBB
 .db    0x73,0x63
 .db    0x63,0x73
 .db    0xF7,0x63
 .db    0x73,0x73
 .db    0xFF,0xFF
 .db    0xFF,0x73
 .db    0x73,0x73
 .db    0xA3,0xFF
 .db    0xFF,0xFF
 .db    0xE2,0xF6
 .db    0xF6,0xFB
 .db    0xE6,0x73
 .db    0x73,0xB3
 .db    0x73,0x73
 .db    0xA3,0xA2
 .db    0x92,0xFF
 .db    0xB3,0xB3
 .db    0xF6,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xE2,0x73
 .db    0x73,0xBB
 .db    0xFA,0xFA
 .db    0x73,0x63
 .db    0x77,0xE6
 .db    0xBB,0xFA
 .db    0xFF,0xE6
 .db    0xE2,0x73
 .db    0x63,0x73
 .db    0x73,0x63
 .db    0xBB,0xFA
 .db    0xBB,0x77
 .db    0x63,0x63
 .db    0xFA,0xE2
 .db    0xBB,0xE2
 .db    0xF6,0xE2
 .db    0x63,0x63
 .db    0xFA,0xFA
 .db    0x73,0x63
 .db    0xBB,0xB7
 .db    0xF6,0xF2
 .db    0xF2,0xB2
 .db    0xB3,0xF2
 .db    0xF6,0xFB
 .db    0x7F,0xE6
 .db    0xE6,0xC1
 .db    0xFA,0xF6
 .db    0xF2,0xF2
 .db    0xFA,0x73
 .db    0xB2,0xFB
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xF2,0xFB
 .db    0xBB,0xFB
 .db    0xFA,0xD2
 .db    0xFA,0xE2
 .db    0xFA,0xE6
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0x67
 .db    0x53,0x63
 .db    0xE2,0x67
 .db    0x63,0xBB
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0xA3,0x63
 .db    0x63,0x73
 .db    0xFB,0xFF
 .db    0xBF,0xB3
 .db    0x73,0x73
 .db    0xA3,0xFF
 .db    0xFF,0xFF
 .db    0xFA,0xE2
 .db    0xFF,0xFF
 .db    0xFB,0x73
 .db    0xB3,0xB7
 .db    0x73,0xA3
 .db    0xE6,0x63
 .db    0xD6,0xFF
 .db    0xFA,0xFB
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFA,0xFF
 .db    0xF6,0xB7
 .db    0x73,0xBB
 .db    0xBF,0xFA
 .db    0xB3,0x63
 .db    0xBB,0x73
 .db    0x73,0xFA
 .db    0xBB,0x73
 .db    0x77,0xE2
 .db    0x63,0xA3
 .db    0x73,0x73
 .db    0xFA,0xFF
 .db    0x77,0x73
 .db    0x73,0xE2
 .db    0xFA,0x73
 .db    0x63,0xFA
 .db    0xF6,0xB2
 .db    0x63,0x77
 .db    0xF6,0xFA
 .db    0xE2,0xB2
 .db    0xB7,0x73
 .db    0xF6,0xB2
 .db    0xF2,0xB2
 .db    0xB3,0xF2
 .db    0xF6,0xFA
 .db    0xFA,0x67
 .db    0x77,0xC1
 .db    0xEA,0xE6
 .db    0xB2,0xF2
 .db    0x77,0x73
 .db    0xB2,0xF6
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xF2
 .db    0xF2,0xF6
 .db    0x73,0xFB
 .db    0xE6,0x73
 .db    0xFA,0xFB
 .db    0xD2,0xB7
 .db    0xFF,0xFA
 .db    0xFF,0xFF
 .db    0xFE,0xBF
 .db    0x67,0xD2
 .db    0xBF,0x63
 .db    0x63,0xBF
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x73,0x63
 .db    0x63,0x73
 .db    0xB3,0xFB
 .db    0x73,0xB3
 .db    0xA3,0x73
 .db    0xE2,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0x77
 .db    0xFF,0xFF
 .db    0xFB,0x73
 .db    0xB7,0xF7
 .db    0x73,0xA3
 .db    0xEB,0x92
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xB2,0xFA
 .db    0xE6,0xFA
 .db    0x73,0xA3
 .db    0x77,0xE6
 .db    0xA2,0x63
 .db    0xE2,0x63
 .db    0x63,0xE6
 .db    0xE2,0x63
 .db    0x63,0xBB
 .db    0x77,0xE6
 .db    0xA2,0x73
 .db    0xBB,0xFA
 .db    0x73,0x63
 .db    0xBB,0xFA
 .db    0xFA,0x63
 .db    0x63,0xBB
 .db    0xF6,0xBB
 .db    0xD2,0xBB
 .db    0xF6,0xF6
 .db    0xF6,0xFA
 .db    0xB2,0x63
 .db    0xF2,0x73
 .db    0xF2,0xB2
 .db    0xB3,0xF2
 .db    0xF2,0xFA
 .db    0xFA,0x92
 .db    0x92,0x67
 .db    0xEA,0xF6
 .db    0xF2,0xF2
 .db    0x73,0xF6
 .db    0xF6,0xF6
 .db    0xF6,0xF6
 .db    0xB7,0xF2
 .db    0xB3,0xB3
 .db    0xF2,0xF2
 .db    0x73,0xFB
 .db    0x77,0x73
 .db    0xFA,0xFF
 .db    0x63,0x77
 .db    0xFF,0x77
 .db    0xFF,0xFF
 .db    0xFF,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0x63
 .db    0x73,0xFA
 .db    0x77,0x63
 .db    0x63,0x63
 .db    0x73,0x63
 .db    0x63,0x73
 .db    0x73,0xA3
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0x67
 .db    0xFB,0xBB
 .db    0xE2,0x73
 .db    0xA3,0xE2
 .db    0xA3,0x73
 .db    0xEB,0x92
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xB2,0xB3
 .db    0xB2,0xFA
 .db    0x73,0x63
 .db    0x63,0x73
 .db    0x63,0x63
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x77,0x63
 .db    0x63,0xB7
 .db    0xE6,0xFA
 .db    0x73,0x63
 .db    0xA2,0xFA
 .db    0xE2,0x77
 .db    0xFA,0xFA
 .db    0xFA,0x63
 .db    0x63,0xBB
 .db    0x77,0xA7
 .db    0xFA,0xFA
 .db    0xFA,0xF6
 .db    0xFA,0xFA
 .db    0xB2,0x73
 .db    0xF6,0xB2
 .db    0xF2,0xB2
 .db    0xB3,0xB3
 .db    0xF2,0xFA
 .db    0xFA,0x67
 .db    0x92,0xC1
 .db    0xE6,0xFA
 .db    0xF2,0xF2
 .db    0xB2,0xF6
 .db    0xF6,0xE2
 .db    0x73,0xF2
 .db    0xFA,0xF6
 .db    0xF2,0xB3
 .db    0xF2,0xF2
 .db    0xB2,0xFB
 .db    0x73,0x73
 .db    0xFB,0xFF
 .db    0x63,0x77
 .db    0xFF,0x63
 .db    0xB7,0xFA
 .db    0xD2,0xE6
 .db    0xFF,0xFF
 .db    0xBF,0x63
 .db    0xE6,0xFA
 .db    0xFA,0xD2
 .db    0x63,0x63
 .db    0x73,0x63
 .db    0x63,0xB3
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x73,0xA3
 .db    0xFF,0xFF
 .db    0xFF,0xA7
 .db    0xD2,0xA3
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xE6,0x92
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xB2,0x73
 .db    0x73,0xFA
 .db    0x73,0x63
 .db    0x63,0x73
 .db    0x63,0x63
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x73,0x63
 .db    0x63,0x73
 .db    0x63,0xFA
 .db    0x73,0x63
 .db    0x63,0xFA
 .db    0xFA,0xE2
 .db    0x73,0xFA
 .db    0xBF,0xE1
 .db    0xD2,0xFA
 .db    0x63,0x63
 .db    0xFA,0xFA
 .db    0xD2,0xBB
 .db    0xFA,0xE1
 .db    0x77,0xF2
 .db    0xF2,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xF6,0xFA
 .db    0xFA,0xD1
 .db    0xBB,0x67
 .db    0x7F,0xFA
 .db    0xF2,0xB2
 .db    0xF2,0xF2
 .db    0xF6,0xE2
 .db    0x73,0xF2
 .db    0xFB,0xFB
 .db    0xBB,0xF2
 .db    0xF6,0xFA
 .db    0xF6,0xFA
 .db    0xE2,0xBB
 .db    0xFF,0xFF
 .db    0x73,0xB7
 .db    0xFB,0x63
 .db    0xB7,0x7B
 .db    0x63,0x63
 .db    0xFF,0xFF
 .db    0x7B,0x63
 .db    0xE2,0xFA
 .db    0xBF,0xBF
 .db    0x77,0x63
 .db    0xA2,0x63
 .db    0x63,0xBB
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0xBB,0xFF
 .db    0xF7,0xBB
 .db    0x73,0xA3
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xE6,0xD2
 .db    0xFF,0xFF
 .db    0xFF,0xFB
 .db    0xBB,0xBB
 .db    0xE6,0xFB
 .db    0xB7,0x73
 .db    0x73,0xFA
 .db    0x73,0x63
 .db    0x63,0x73
 .db    0x63,0x63
 .db    0x63,0x73
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x73,0x63
 .db    0x63,0xFA
 .db    0x77,0x63
 .db    0x73,0x77
 .db    0x77,0x77
 .db    0x73,0xE2
 .db    0xA2,0xE2
 .db    0xFA,0xFA
 .db    0x73,0x63
 .db    0xFA,0xE6
 .db    0x63,0x77
 .db    0xFA,0x73
 .db    0x63,0xF6
 .db    0xB2,0xB2
 .db    0xB2,0xB3
 .db    0xB3,0xB3
 .db    0xF6,0xFA
 .db    0xFA,0xEA
 .db    0xA7,0x67
 .db    0x7B,0xFA
 .db    0xF2,0xB2
 .db    0xF6,0xF2
 .db    0xF6,0xFA
 .db    0x77,0xF6
 .db    0xB7,0xF6
 .db    0x77,0xB2
 .db    0xFB,0xFA
 .db    0xFA,0xFF
 .db    0xFA,0xFA
 .db    0xFF,0xBB
 .db    0xBB,0xE6
 .db    0xBB,0x73
 .db    0xBB,0x63
 .db    0x63,0x63
 .db    0xFB,0xFF
 .db    0x67,0x63
 .db    0xE2,0xA7
 .db    0xA7,0xFA
 .db    0xBF,0x77
 .db    0xBB,0x63
 .db    0xD2,0xFA
 .db    0x63,0x63
 .db    0x53,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x73,0xFB
 .db    0xB3,0xB7
 .db    0xA3,0xA3
 .db    0xB3,0xB3
 .db    0xB3,0xA3
 .db    0x73,0x63
 .db    0xB7,0xBF
 .db    0xFF,0xFF
 .db    0xFB,0xA3
 .db    0x73,0xB3
 .db    0x73,0xFB
 .db    0xFA,0xB7
 .db    0xB7,0xFA
 .db    0xB3,0x63
 .db    0x63,0xB2
 .db    0x63,0x63
 .db    0x63,0xA3
 .db    0x77,0x63
 .db    0x63,0x63
 .db    0xB3,0x63
 .db    0x63,0xFA
 .db    0xBB,0xA2
 .db    0xB2,0x63
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x63,0x67
 .db    0xFA,0xFA
 .db    0x63,0x63
 .db    0xFA,0xB7
 .db    0x63,0xA2
 .db    0xFA,0xB2
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xF2
 .db    0xF6,0xFA
 .db    0xFA,0xFA
 .db    0x92,0xC1
 .db    0xD1,0xFA
 .db    0xB6,0xB2
 .db    0xF6,0xE1
 .db    0xFA,0xFA
 .db    0xFA,0xBB
 .db    0x73,0xB2
 .db    0xB3,0xB7
 .db    0xFF,0xD2
 .db    0x77,0xFB
 .db    0x77,0xFB
 .db    0xBB,0x73
 .db    0xFB,0x73
 .db    0xE2,0x73
 .db    0xFA,0x63
 .db    0x63,0x63
 .db    0xFA,0xBF
 .db    0x63,0x63
 .db    0xE6,0x67
 .db    0x63,0xBF
 .db    0xFA,0xBF
 .db    0xBF,0xE6
 .db    0xFA,0xFA
 .db    0x63,0x63
 .db    0x53,0x53
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0xB3
 .db    0xB3,0xF6
 .db    0xB7,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xA3,0x63
 .db    0xA3,0xBB
 .db    0xFB,0xFB
 .db    0xE2,0x73
 .db    0x73,0x73
 .db    0x73,0xE6
 .db    0xFF,0xFA
 .db    0xFA,0xFA
 .db    0x73,0x73
 .db    0x73,0xBB
 .db    0x63,0x63
 .db    0x63,0xA3
 .db    0xE2,0x63
 .db    0x63,0x63
 .db    0xB7,0x63
 .db    0x63,0xBB
 .db    0xFA,0xE6
 .db    0x77,0x63
 .db    0x63,0x73
 .db    0xA3,0xA2
 .db    0x63,0x63
 .db    0xFA,0xFA
 .db    0x63,0x63
 .db    0xFA,0xF6
 .db    0x73,0xB7
 .db    0xFA,0xF6
 .db    0xF2,0xB2
 .db    0xB3,0xB3
 .db    0xB2,0xB2
 .db    0xB3,0xB3
 .db    0xF2,0xFA
 .db    0xFA,0xFA
 .db    0x67,0x67
 .db    0xD1,0xFA
 .db    0xB6,0xF2
 .db    0xE2,0x73
 .db    0xFA,0xFA
 .db    0xFA,0xBB
 .db    0x63,0xB2
 .db    0xF6,0xF6
 .db    0xFF,0x73
 .db    0x73,0xFB
 .db    0x73,0xF6
 .db    0x73,0x73
 .db    0xFB,0x77
 .db    0xFA,0xA2
 .db    0xFA,0x67
 .db    0x63,0x63
 .db    0xFB,0xA2
 .db    0x63,0x63
 .db    0xBB,0x63
 .db    0x63,0xE6
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xA7,0x53
 .db    0x53,0x63
 .db    0x53,0x53
 .db    0x63,0x63
 .db    0x63,0x73
 .db    0xB3,0xF7
 .db    0xFB,0xF7
 .db    0xF7,0xF3
 .db    0xF7,0xF7
 .db    0xB3,0xA3
 .db    0xB3,0xB3
 .db    0xF7,0xB3
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x77
 .db    0xFF,0xFF
 .db    0xFF,0xBB
 .db    0x73,0xB3
 .db    0x73,0xE2
 .db    0x63,0x63
 .db    0x63,0xA2
 .db    0x77,0x63
 .db    0x63,0x63
 .db    0xBB,0x63
 .db    0x63,0xE6
 .db    0xE6,0xA2
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0xBF,0xE6
 .db    0x63,0xA2
 .db    0xFA,0xFA
 .db    0xA2,0x63
 .db    0xFA,0xFA
 .db    0xE6,0xF6
 .db    0xF6,0xF6
 .db    0xFA,0xB3
 .db    0xB3,0xB2
 .db    0xB2,0x73
 .db    0xB2,0xB3
 .db    0xF2,0xFA
 .db    0xFA,0xFA
 .db    0xE6,0x92
 .db    0x3F,0xFA
 .db    0xF6,0xF2
 .db    0xBB,0x77
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xE2,0xF6
 .db    0xFB,0x73
 .db    0xFB,0xA2
 .db    0xB7,0xFA
 .db    0x73,0xB7
 .db    0x73,0xE2
 .db    0xFF,0x77
 .db    0xFA,0xB7
 .db    0xFA,0xEA
 .db    0x73,0xBB
 .db    0xFF,0x63
 .db    0x63,0x63
 .db    0xBB,0x63
 .db    0x63,0x77
 .db    0xBB,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0xBF
 .db    0xBB,0x63
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x63,0x73
 .db    0x73,0xF7
 .db    0xFF,0xFB
 .db    0xF7,0xF3
 .db    0xF3,0xF7
 .db    0xFB,0xF7
 .db    0xF2,0xB3
 .db    0xB3,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0xA3
 .db    0xFA,0xFF
 .db    0xFE,0x77
 .db    0x63,0x73
 .db    0x77,0x73
 .db    0x63,0x63
 .db    0x63,0xE2
 .db    0x77,0x63
 .db    0x63,0x63
 .db    0xBB,0x63
 .db    0x53,0xBB
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0xE6
 .db    0xFA,0xFA
 .db    0xE2,0xE2
 .db    0xFA,0xFA
 .db    0xBB,0xBB
 .db    0xFA,0xFA
 .db    0xF6,0xF6
 .db    0xF6,0x77
 .db    0xBB,0xE2
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xF2,0xF6
 .db    0xFA,0xFA
 .db    0xFA,0x3B
 .db    0x6A,0xFA
 .db    0xF6,0xB2
 .db    0xFA,0xBB
 .db    0xFA,0xA2
 .db    0xF6,0xFA
 .db    0xFA,0xF6
 .db    0xFA,0x63
 .db    0xE2,0xBB
 .db    0xFA,0xFA
 .db    0xE2,0xE6
 .db    0x73,0xFA
 .db    0xBF,0x73
 .db    0xFB,0x73
 .db    0xE2,0xBF
 .db    0x73,0xBB
 .db    0xFF,0x63
 .db    0x63,0x63
 .db    0xFB,0x63
 .db    0x63,0xA2
 .db    0xA2,0xE6
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xBF,0xA7
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x63
 .db    0x73,0xF6
 .db    0xFB,0xF7
 .db    0xF7,0xF7
 .db    0xF7,0xF7
 .db    0xFB,0xFB
 .db    0xB3,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0xFA,0xFE
 .db    0xFA,0x73
 .db    0x63,0x63
 .db    0x63,0x77
 .db    0x63,0x63
 .db    0x73,0xBB
 .db    0xE6,0x63
 .db    0x63,0x7B
 .db    0xEA,0x63
 .db    0x53,0xBB
 .db    0x63,0x63
 .db    0xA2,0xE6
 .db    0xE6,0xFA
 .db    0xFA,0xFA
 .db    0xBB,0xA2
 .db    0xBB,0xFA
 .db    0xFA,0xBB
 .db    0xFA,0xFA
 .db    0xE2,0xF2
 .db    0xB3,0x63
 .db    0x77,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xF2,0xF6
 .db    0xBB,0xFA
 .db    0xBB,0x3B
 .db    0x3B,0xBF
 .db    0xBB,0xB2
 .db    0xB7,0xF6
 .db    0xF6,0x77
 .db    0xF6,0xE6
 .db    0xFA,0x77
 .db    0xBB,0x73
 .db    0x73,0xB7
 .db    0xFA,0xBF
 .db    0xA2,0xFA
 .db    0xBB,0xFF
 .db    0x7B,0x73
 .db    0xFB,0x63
 .db    0xB2,0xA7
 .db    0x63,0x77
 .db    0xFF,0x77
 .db    0x63,0x73
 .db    0xFB,0x63
 .db    0x63,0xB7
 .db    0x63,0x73
 .db    0xE6,0xFA
 .db    0xFA,0xFA
 .db    0xBF,0xBF
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x63
 .db    0x73,0xF6
 .db    0xF7,0xF7
 .db    0xF7,0xF7
 .db    0xF7,0xF7
 .db    0xF6,0xF6
 .db    0xB3,0x73
 .db    0x63,0x63
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x63,0x73
 .db    0xFA,0xFE
 .db    0xFA,0x63
 .db    0x63,0x63
 .db    0x63,0xBF
 .db    0x73,0x63
 .db    0xD2,0xBF
 .db    0xEA,0x77
 .db    0xA7,0xEA
 .db    0xBF,0x7B
 .db    0x63,0xBF
 .db    0x77,0x63
 .db    0xBB,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xBB,0x63
 .db    0xBB,0xFA
 .db    0x7B,0x63
 .db    0x7B,0xE6
 .db    0x63,0xF6
 .db    0xB7,0x73
 .db    0x73,0xB2
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xF2
 .db    0xF6,0xFA
 .db    0x7B,0x2B
 .db    0x3B,0xBB
 .db    0xBB,0xB2
 .db    0xB2,0xF2
 .db    0xF6,0xF6
 .db    0xE2,0x73
 .db    0xF6,0x73
 .db    0xF6,0xE2
 .db    0x73,0xB6
 .db    0xFA,0x7B
 .db    0x73,0xF6
 .db    0xFB,0xFF
 .db    0x7B,0x73
 .db    0xFA,0x73
 .db    0xB7,0xD1
 .db    0x63,0x77
 .db    0xFF,0xFA
 .db    0xE2,0xB7
 .db    0xFB,0x73
 .db    0x73,0xBF
 .db    0x63,0x63
 .db    0x77,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0xBF
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x63
 .db    0x73,0xF7
 .db    0xFB,0xFB
 .db    0xF7,0xF7
 .db    0xF7,0xF7
 .db    0xF6,0xBB
 .db    0x73,0x63
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0xA3
 .db    0xFA,0xFA
 .db    0xFA,0x63
 .db    0x63,0x63
 .db    0x63,0xBB
 .db    0xE6,0xE2
 .db    0xEA,0xBF
 .db    0xBF,0xE6
 .db    0xBB,0xBF
 .db    0xFA,0xBF
 .db    0xEA,0xFA
 .db    0xBF,0xEA
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0x77
 .db    0xBF,0xFA
 .db    0x73,0x63
 .db    0x67,0xE6
 .db    0x73,0xF6
 .db    0xF2,0xB2
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0x73,0x73
 .db    0xB2,0xB3
 .db    0xB3,0xF2
 .db    0xF6,0xFA
 .db    0xD1,0x2B
 .db    0x2B,0xE6
 .db    0xBB,0xE2
 .db    0xB2,0xF2
 .db    0xB7,0xFA
 .db    0x7B,0x73
 .db    0xF6,0x77
 .db    0xB7,0xFA
 .db    0x73,0xF6
 .db    0xFA,0xE6
 .db    0x73,0xFA
 .db    0xFA,0xBF
 .db    0xE6,0xE2
 .db    0xFA,0x63
 .db    0xE2,0xE6
 .db    0x63,0xB7
 .db    0xFF,0xBF
 .db    0xE6,0xE2
 .db    0xFA,0xE2
 .db    0xE2,0xFA
 .db    0x63,0x63
 .db    0x73,0xFF
 .db    0xF6,0xFA
 .db    0xFE,0xBB
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x63
 .db    0x63,0x73
 .db    0xB3,0xFB
 .db    0xFB,0xFB
 .db    0xFB,0xFB
 .db    0xF7,0xF7
 .db    0xF6,0xB7
 .db    0x73,0x63
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x63
 .db    0xFA,0xFA
 .db    0xFA,0x73
 .db    0x63,0x63
 .db    0x63,0xA2
 .db    0xE6,0xBF
 .db    0xFA,0xFA
 .db    0xFA,0x92
 .db    0x77,0xE6
 .db    0x7B,0xBF
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xFE,0xFA
 .db    0xE6,0xBB
 .db    0xFA,0xFA
 .db    0xFA,0xBB
 .db    0xFA,0xFA
 .db    0x77,0x63
 .db    0x77,0xFA
 .db    0xB2,0xB7
 .db    0xB3,0xE2
 .db    0xB3,0xB2
 .db    0xB3,0xB2
 .db    0xB2,0x73
 .db    0xB2,0xB3
 .db    0xB3,0xF2
 .db    0xF6,0xFA
 .db    0xE6,0x2B
 .db    0x2B,0xE5
 .db    0xBB,0xF2
 .db    0xF2,0xF2
 .db    0x73,0xFA
 .db    0xFA,0xE6
 .db    0xFA,0xA6
 .db    0xE2,0xFA
 .db    0x77,0xBB
 .db    0xFE,0xFA
 .db    0xBB,0xFA
 .db    0xE6,0x63
 .db    0xE6,0xFA
 .db    0xFA,0x63
 .db    0x77,0xFA
 .db    0xA2,0x77
 .db    0xFB,0xA2
 .db    0x73,0x63
 .db    0xD2,0xFA
 .db    0xFA,0xBB
 .db    0x63,0x63
 .db    0xE2,0xFE
 .db    0xE6,0xF2
 .db    0xBB,0xE6
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0x73
 .db    0x73,0xB3
 .db    0xBB,0xFF
 .db    0xFB,0xFB
 .db    0xFB,0xFB
 .db    0xFB,0xF7
 .db    0xF6,0xB3
 .db    0x73,0x63
 .db    0x63,0x53
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0x63
 .db    0xBF,0xFA
 .db    0xFA,0x7B
 .db    0xA3,0x63
 .db    0x77,0x63
 .db    0x63,0xBF
 .db    0xBF,0xBF
 .db    0xBF,0x63
 .db    0x63,0x63
 .db    0x63,0xA2
 .db    0xBF,0xFA
 .db    0x77,0xE2
 .db    0xFA,0xBF
 .db    0x73,0x63
 .db    0xFA,0xFA
 .db    0x77,0x77
 .db    0xFA,0xFA
 .db    0xFA,0x73
 .db    0xBB,0xF6
 .db    0x73,0xE2
 .db    0xB2,0xB2
 .db    0xB2,0xF2
 .db    0x73,0xB2
 .db    0xB2,0x73
 .db    0xB2,0xB2
 .db    0xB2,0xF6
 .db    0xFA,0xFA
 .db    0xFA,0x2B
 .db    0x2B,0x7B
 .db    0xBB,0xB7
 .db    0xB2,0xF2
 .db    0xE2,0xFA
 .db    0xFA,0xFA
 .db    0xE6,0xA2
 .db    0xE2,0xFA
 .db    0x63,0x7B
 .db    0xFF,0xE6
 .db    0xE6,0xFA
 .db    0xA2,0x63
 .db    0x77,0xFA
 .db    0xFA,0x63
 .db    0xA2,0xFA
 .db    0x63,0x63
 .db    0xBB,0x63
 .db    0x63,0x63
 .db    0x73,0xFA
 .db    0xE6,0x63
 .db    0x63,0x63
 .db    0xBB,0xFF
 .db    0xE6,0xF2
 .db    0xE2,0xE6
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0x73
 .db    0xB3,0xF2
 .db    0xFB,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFB
 .db    0xFB,0xF7
 .db    0xF6,0xB3
 .db    0x73,0x73
 .db    0x63,0x63
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0x63
 .db    0xBF,0xFA
 .db    0xFA,0xBF
 .db    0xBB,0x63
 .db    0xE6,0x63
 .db    0x63,0xA7
 .db    0xBF,0xBF
 .db    0xBF,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0xFA,0xBF
 .db    0x63,0x63
 .db    0xBF,0xE6
 .db    0x63,0x63
 .db    0xBB,0xFA
 .db    0x73,0x73
 .db    0xE6,0xFA
 .db    0xFA,0xE2
 .db    0xFA,0xF6
 .db    0x73,0xB3
 .db    0xB2,0xB2
 .db    0xB2,0xF2
 .db    0x63,0x73
 .db    0xB2,0xB2
 .db    0xB3,0xB3
 .db    0xB3,0xF2
 .db    0xFA,0xBF
 .db    0xE6,0x2B
 .db    0x2B,0xD1
 .db    0xBB,0xF6
 .db    0xB2,0xB2
 .db    0xF6,0xE6
 .db    0xFA,0xFA
 .db    0x92,0xE2
 .db    0x73,0xE2
 .db    0x63,0xE2
 .db    0xFF,0x77
 .db    0xA2,0xFA
 .db    0x77,0x63
 .db    0xE6,0xFE
 .db    0xFA,0x63
 .db    0x73,0xFA
 .db    0x63,0x63
 .db    0x77,0x63
 .db    0x63,0x63
 .db    0xE6,0xFA
 .db    0xA2,0x63
 .db    0x73,0xA7
 .db    0xFB,0xFF
 .db    0xE6,0xF6
 .db    0xB3,0x63
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x63,0x63
 .db    0xB3,0xF7
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFF
 .db    0xFF,0xFB
 .db    0xF6,0xE2
 .db    0xB3,0x73
 .db    0x63,0x63
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0xBF,0xBF
 .db    0xFA,0xBF
 .db    0xFA,0xE6
 .db    0xE2,0x53
 .db    0x63,0x63
 .db    0xBF,0xBF
 .db    0xBF,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0xFA,0xBB
 .db    0x63,0x63
 .db    0xD2,0xBB
 .db    0x63,0x63
 .db    0xE2,0xFA
 .db    0xA2,0x73
 .db    0xE6,0xFA
 .db    0xFA,0xBB
 .db    0xFA,0xF6
 .db    0x73,0xE2
 .db    0xB3,0xB2
 .db    0xB3,0xF2
 .db    0x73,0xB2
 .db    0xB3,0xF2
 .db    0xF2,0xF2
 .db    0xB3,0xF2
 .db    0xF6,0xBB
 .db    0x3B,0x2B
 .db    0x2B,0xC0
 .db    0xBB,0xF2
 .db    0xF2,0xB2
 .db    0xF6,0x92
 .db    0xD1,0xFA
 .db    0xA2,0xE6
 .db    0x73,0x73
 .db    0x73,0xF6
 .db    0xFE,0xE6
 .db    0xE2,0xFA
 .db    0xBB,0x63
 .db    0xFA,0xFA
 .db    0xBB,0x63
 .db    0x77,0xFA
 .db    0x63,0x63
 .db    0x77,0xE2
 .db    0x77,0x63
 .db    0xE2,0xFA
 .db    0xE6,0x63
 .db    0x77,0xFA
 .db    0xFF,0xFE
 .db    0xBB,0xF6
 .db    0xB2,0x77
 .db    0x53,0x53
 .db    0x63,0x53
 .db    0x63,0x63
 .db    0xB3,0xFB
 .db    0xFF,0xFF
 .db    0xEF,0xFF
 .db    0xEF,0xFF
 .db    0xFF,0xFB
 .db    0xF6,0xE6
 .db    0xB3,0xB3
 .db    0x73,0x73
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0xEA,0xBF
 .db    0xBF,0xFA
 .db    0xBF,0xBF
 .db    0xA6,0x63
 .db    0x63,0x63
 .db    0xBF,0x7B
 .db    0xBF,0x7B
 .db    0xA7,0xD2
 .db    0x63,0x63
 .db    0xEA,0xBF
 .db    0x63,0x63
 .db    0xA2,0xBF
 .db    0xA2,0x63
 .db    0x73,0xA7
 .db    0xBB,0xE2
 .db    0xFA,0xFA
 .db    0xFA,0xA2
 .db    0xBB,0xF2
 .db    0xE2,0xF2
 .db    0xF2,0xB3
 .db    0xF2,0xF6
 .db    0xB2,0xF2
 .db    0xF2,0xE2
 .db    0xB3,0xB2
 .db    0xB2,0xE2
 .db    0xF6,0xE6
 .db    0xD6,0x81
 .db    0x2B,0x3B
 .db    0xBB,0xF2
 .db    0xF2,0xB2
 .db    0xF6,0x92
 .db    0x63,0xFA
 .db    0xD1,0xBB
 .db    0x63,0x77
 .db    0xE6,0xFA
 .db    0xBB,0xA2
 .db    0xE2,0xBB
 .db    0xBB,0x73
 .db    0xFA,0xE2
 .db    0xFA,0x63
 .db    0xBB,0xFA
 .db    0x7B,0x63
 .db    0xE6,0xFA
 .db    0xBF,0x63
 .db    0xA2,0xBF
 .db    0xA7,0x73
 .db    0xE6,0xFE
 .db    0xFE,0xFE
 .db    0xFA,0xB3
 .db    0x73,0xB7
 .db    0xA3,0x63
 .db    0x53,0x53
 .db    0x53,0x63
 .db    0xB2,0xFF
 .db    0xFF,0xEF
 .db    0xAF,0xD6
 .db    0xEA,0xEB
 .db    0xFB,0xFF
 .db    0xF6,0xBB
 .db    0xE6,0xB3
 .db    0x73,0x73
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0xBB,0xBF
 .db    0xFA,0xFA
 .db    0x7B,0xE6
 .db    0x77,0x63
 .db    0x63,0x63
 .db    0xE6,0x63
 .db    0xA2,0xBF
 .db    0xFA,0xBB
 .db    0x63,0x63
 .db    0xD2,0xFA
 .db    0x92,0x63
 .db    0xA7,0xBF
 .db    0xBB,0xE2
 .db    0x73,0x63
 .db    0xFA,0xFA
 .db    0xBB,0xBB
 .db    0xFA,0x77
 .db    0xB3,0xF2
 .db    0xF6,0xF6
 .db    0xF6,0xF6
 .db    0x73,0xFA
 .db    0xF2,0xB3
 .db    0xF2,0x73
 .db    0x73,0xE2
 .db    0xB2,0xB7
 .db    0xFA,0x7B
 .db    0xBF,0x81
 .db    0x56,0x2B
 .db    0xEA,0xB7
 .db    0xF2,0xB2
 .db    0xF2,0xBB
 .db    0xE2,0xFA
 .db    0x7B,0xF6
 .db    0xE2,0xF6
 .db    0xFA,0xFA
 .db    0xD1,0x63
 .db    0x73,0x73
 .db    0xBB,0x73
 .db    0xA7,0x73
 .db    0xBB,0xE6
 .db    0xFA,0xBB
 .db    0xFA,0xE6
 .db    0xE6,0xBF
 .db    0xBF,0x63
 .db    0x77,0x92
 .db    0x63,0x63
 .db    0xE6,0xFE
 .db    0xFA,0xFB
 .db    0xB7,0xB3
 .db    0x73,0xB3
 .db    0xF2,0xF2
 .db    0xA7,0x67
 .db    0x63,0x63
 .db    0xB3,0xFF
 .db    0xFF,0xEE
 .db    0x9B,0x86
 .db    0xAB,0x87
 .db    0xAB,0xFB
 .db    0xFB,0xE6
 .db    0xBB,0xE2
 .db    0xB2,0x73
 .db    0x63,0x67
 .db    0xD2,0xD2
 .db    0x92,0x63
 .db    0xEA,0xBF
 .db    0xFA,0xFA
 .db    0x73,0x77
 .db    0x77,0x63
 .db    0x63,0x77
 .db    0x63,0x63
 .db    0x63,0xE6
 .db    0xFA,0xBF
 .db    0x63,0x63
 .db    0xA7,0xFA
 .db    0xBB,0x77
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0x63,0x63
 .db    0xBF,0xFA
 .db    0xA2,0x63
 .db    0xFA,0xF6
 .db    0xB2,0x73
 .db    0xFA,0xFA
 .db    0xF6,0xB2
 .db    0x73,0xE2
 .db    0xF6,0xF2
 .db    0xF2,0x73
 .db    0x77,0xE2
 .db    0xB2,0xE2
 .db    0xBB,0x92
 .db    0xD1,0x81
 .db    0x81,0x85
 .db    0xEA,0xBB
 .db    0xF2,0xB2
 .db    0xB3,0xF6
 .db    0xFA,0xBB
 .db    0xBB,0xB7
 .db    0xBB,0xBB
 .db    0xBB,0xFA
 .db    0xE6,0x63
 .db    0xB3,0x63
 .db    0xBB,0xA2
 .db    0x63,0x73
 .db    0x67,0xA2
 .db    0xFA,0x92
 .db    0xE6,0xD1
 .db    0x67,0x77
 .db    0xE6,0x63
 .db    0xE2,0x63
 .db    0x63,0x63
 .db    0xE2,0xFA
 .db    0xFA,0xF6
 .db    0xB2,0xB3
 .db    0x73,0xB3
 .db    0xB3,0xF2
 .db    0xB7,0xD1
 .db    0x63,0x63
 .db    0xB2,0xFB
 .db    0xFF,0xEF
 .db    0x8B,0x86
 .db    0xDA,0x5B
 .db    0x5B,0xEB
 .db    0xFB,0xB7
 .db    0xBB,0xB7
 .db    0xB2,0x63
 .db    0x53,0xBB
 .db    0xE2,0xB3
 .db    0xE2,0xE2
 .db    0xEA,0xBF
 .db    0xFA,0xBF
 .db    0x77,0xE6
 .db    0xBB,0x63
 .db    0x63,0x73
 .db    0x63,0x63
 .db    0x63,0xA2
 .db    0xFA,0xFA
 .db    0xD1,0x63
 .db    0xE2,0xFA
 .db    0xBF,0xEA
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0x7B,0xA2
 .db    0xFA,0xFA
 .db    0x63,0x63
 .db    0xFA,0xFA
 .db    0xB2,0x63
 .db    0xFA,0xFA
 .db    0xF6,0xB2
 .db    0x73,0x77
 .db    0xF2,0xF2
 .db    0xF2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB7
 .db    0xBB,0x92
 .db    0x7B,0x80
 .db    0x81,0x85
 .db    0xBA,0xF6
 .db    0xF2,0xF2
 .db    0xB2,0xF2
 .db    0xBB,0xB2
 .db    0xB7,0x63
 .db    0xE2,0x77
 .db    0x73,0xFA
 .db    0xBB,0x77
 .db    0xE2,0x77
 .db    0xEA,0x67
 .db    0x23,0xE2
 .db    0x63,0x63
 .db    0xBB,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0xE6,0x63
 .db    0x63,0x63
 .db    0xE2,0xFA
 .db    0xE2,0xB3
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0xB3,0xB3
 .db    0xF2,0xD1
 .db    0x27,0x63
 .db    0x77,0xFA
 .db    0xBF,0xEF
 .db    0x8B,0x5B
 .db    0xAF,0xAF
 .db    0x86,0xEA
 .db    0xBB,0xE2
 .db    0xBB,0xB7
 .db    0x73,0x63
 .db    0x53,0xF6
 .db    0xB3,0xB2
 .db    0xB2,0xB3
 .db    0xEA,0xBF
 .db    0xBF,0xFA
 .db    0x7B,0xBB
 .db    0xBF,0x73
 .db    0x63,0xE2
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0xFA,0xFA
 .db    0xFA,0x73
 .db    0x73,0xBB
 .db    0xE6,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xFA,0xEA
 .db    0xFA,0xFA
 .db    0xA2,0x67
 .db    0xFA,0xE6
 .db    0xB7,0x73
 .db    0xBB,0xE6
 .db    0xF6,0xB7
 .db    0x73,0xBB
 .db    0xB2,0x73
 .db    0xF6,0xE2
 .db    0xB2,0xB2
 .db    0xB2,0xE6
 .db    0xBB,0xE6
 .db    0xEA,0x1A
 .db    0x55,0x81
 .db    0x3F,0xEA
 .db    0xF6,0xF2
 .db    0xF2,0xB3
 .db    0xB2,0xE2
 .db    0xE6,0x63
 .db    0x73,0x63
 .db    0x73,0xE2
 .db    0xA2,0x77
 .db    0x77,0x73
 .db    0xE2,0x7B
 .db    0x92,0xBF
 .db    0x63,0x63
 .db    0xBB,0x63
 .db    0x63,0x63
 .db    0x63,0x77
 .db    0x63,0x63
 .db    0xA7,0x63
 .db    0x67,0xE6
 .db    0xF2,0xF2
 .db    0xB3,0xB3
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xB3
 .db    0xB3,0xA6
 .db    0x13,0x13
 .db    0x63,0xBB
 .db    0xBB,0xAF
 .db    0x8B,0x4B
 .db    0xDA,0xAF
 .db    0x6B,0xE6
 .db    0xB7,0xE2
 .db    0xE6,0xA7
 .db    0x73,0x23
 .db    0x67,0xF2
 .db    0xB3,0xB2
 .db    0x73,0xB2
 .db    0xEA,0xFA
 .db    0xBF,0xBF
 .db    0xA2,0xE6
 .db    0xBF,0x73
 .db    0xE6,0xEA
 .db    0x77,0x63
 .db    0x63,0x73
 .db    0xFA,0xFA
 .db    0xFA,0x73
 .db    0x63,0x63
 .db    0x63,0xBF
 .db    0xFA,0xFA
 .db    0x7B,0xEA
 .db    0xFA,0xBB
 .db    0x7B,0xFA
 .db    0xBB,0xBB
 .db    0xFA,0x73
 .db    0xB3,0xBB
 .db    0xB2,0x73
 .db    0xBB,0xFA
 .db    0xBB,0xFA
 .db    0x73,0x73
 .db    0xF6,0xB7
 .db    0xB2,0xB2
 .db    0xB2,0xE6
 .db    0xE6,0xFA
 .db    0xE6,0x1A
 .db    0x1A,0x81
 .db    0x2B,0xBF
 .db    0xF6,0xB2
 .db    0xF2,0xF2
 .db    0xB2,0xF6
 .db    0xB2,0xD2
 .db    0xE1,0x77
 .db    0x73,0xB2
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0xBB
 .db    0xBB,0xFA
 .db    0x92,0x63
 .db    0xEA,0x63
 .db    0x63,0x63
 .db    0xD1,0xE6
 .db    0x63,0x53
 .db    0x73,0x63
 .db    0xB7,0xE2
 .db    0xB3,0xB2
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xB3
 .db    0xB2,0x7B
 .db    0x12,0x12
 .db    0x42,0xBB
 .db    0xBB,0x9B
 .db    0x4B,0x47
 .db    0x9B,0x6B
 .db    0xD2,0xE2
 .db    0xE2,0xE2
 .db    0x7B,0x77
 .db    0x63,0x23
 .db    0x27,0xB7
 .db    0xF2,0xB2
 .db    0x73,0x73
 .db    0xBF,0xBF
 .db    0xBF,0xFA
 .db    0x7B,0xBB
 .db    0xBF,0x63
 .db    0x7B,0xBF
 .db    0xBB,0x63
 .db    0x63,0xA7
 .db    0x7B,0xFA
 .db    0xFA,0xA2
 .db    0x63,0x63
 .db    0x63,0xE6
 .db    0xFA,0xBB
 .db    0x73,0xA2
 .db    0xFA,0x77
 .db    0x73,0xBB
 .db    0xE6,0xFA
 .db    0xFA,0x73
 .db    0x77,0xFA
 .db    0xB2,0x73
 .db    0xE2,0xF6
 .db    0xFA,0xF6
 .db    0x73,0xD2
 .db    0xBB,0x73
 .db    0xB7,0xB2
 .db    0xB2,0xE2
 .db    0xE6,0xFB
 .db    0xBB,0x1A
 .db    0x1A,0x1A
 .db    0x80,0xEA
 .db    0xF6,0xB2
 .db    0xF2,0xB2
 .db    0xB2,0xE2
 .db    0x77,0xBB
 .db    0xF6,0x77
 .db    0x63,0xB7
 .db    0x7B,0x73
 .db    0x63,0x23
 .db    0x63,0xE2
 .db    0x7B,0xBB
 .db    0xA7,0xE6
 .db    0xBF,0x67
 .db    0x63,0x63
 .db    0xEA,0xE6
 .db    0x27,0x53
 .db    0x92,0xB7
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB2,0x7B
 .db    0x12,0x12
 .db    0x12,0xE6
 .db    0xBB,0xD6
 .db    0x4B,0x47
 .db    0x86,0x5B
 .db    0xA7,0xE2
 .db    0xE2,0xD2
 .db    0x67,0x63
 .db    0x23,0x23
 .db    0x52,0xB7
 .db    0xB3,0xB2
 .db    0x73,0xB7
 .db    0xBF,0xFA
 .db    0xBF,0xFA
 .db    0xBF,0xFA
 .db    0xBF,0x63
 .db    0x63,0xBF
 .db    0xBF,0x7B
 .db    0xA2,0xA2
 .db    0x63,0xA7
 .db    0xFA,0xE6
 .db    0x63,0x63
 .db    0x63,0x7B
 .db    0xFA,0xFA
 .db    0x63,0x63
 .db    0x77,0x73
 .db    0x73,0xE1
 .db    0xA2,0xFA
 .db    0xF6,0x73
 .db    0x7B,0xFA
 .db    0xB2,0x73
 .db    0xB7,0xF6
 .db    0xF6,0xE2
 .db    0xB7,0xF6
 .db    0xB2,0x63
 .db    0xB7,0xB2
 .db    0xB2,0xB7
 .db    0x7B,0xFB
 .db    0xE6,0x1A
 .db    0x1A,0x1A
 .db    0x45,0xE5
 .db    0xF6,0xF2
 .db    0xF2,0xB2
 .db    0xB2,0xE2
 .db    0xF6,0x77
 .db    0xBB,0x63
 .db    0x63,0xE6
 .db    0xBB,0xE1
 .db    0x7B,0x92
 .db    0x77,0x92
 .db    0x63,0x67
 .db    0xE6,0xEA
 .db    0xBF,0x77
 .db    0xD2,0x63
 .db    0xE6,0xBB
 .db    0x63,0x53
 .db    0x63,0xB7
 .db    0xB2,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0x77
 .db    0x12,0x12
 .db    0x12,0xBB
 .db    0xE6,0xAB
 .db    0x5B,0x86
 .db    0x86,0x97
 .db    0xA7,0xB3
 .db    0xB3,0xD1
 .db    0x27,0x23
 .db    0x13,0x13
 .db    0x13,0xB7
 .db    0xB3,0xB3
 .db    0x73,0xE6
 .db    0xEA,0xBF
 .db    0xBF,0xFA
 .db    0xFA,0xFA
 .db    0xBF,0x63
 .db    0x63,0xBF
 .db    0xBF,0xBF
 .db    0xE6,0x63
 .db    0x63,0x92
 .db    0xBF,0xBB
 .db    0x7B,0x7B
 .db    0x63,0xBB
 .db    0xFA,0xFA
 .db    0xA2,0x63
 .db    0x73,0x73
 .db    0xE2,0xBB
 .db    0x77,0xFA
 .db    0xE2,0xE2
 .db    0xBB,0xFA
 .db    0x73,0xB7
 .db    0xE1,0xB2
 .db    0xB7,0x73
 .db    0xF6,0xF6
 .db    0x77,0x77
 .db    0xB7,0x73
 .db    0xB2,0xE6
 .db    0xA6,0xBF
 .db    0x77,0x45
 .db    0x45,0x45
 .db    0x16,0x91
 .db    0xBB,0xF2
 .db    0xF2,0xB2
 .db    0xB2,0xF2
 .db    0xF6,0x63
 .db    0xB7,0x92
 .db    0x63,0x77
 .db    0x7B,0xE6
 .db    0x7B,0xBB
 .db    0xBB,0x67
 .db    0x63,0x53
 .db    0x7B,0xBF
 .db    0x7B,0x53
 .db    0x92,0x52
 .db    0x92,0x77
 .db    0x77,0x63
 .db    0xE2,0xB2
 .db    0xB2,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x73,0x73
 .db    0x73,0x77
 .db    0x12,0x12
 .db    0x12,0xA7
 .db    0xBB,0xE6
 .db    0x6B,0x5B
 .db    0x96,0xA7
 .db    0xA7,0xE2
 .db    0xE2,0x67
 .db    0x23,0x12
 .db    0x13,0x13
 .db    0x52,0xE2
 .db    0xB7,0xBB
 .db    0x73,0x7B
 .db    0x67,0xE6
 .db    0xBF,0xBF
 .db    0xFA,0xFA
 .db    0xEA,0x63
 .db    0x63,0xBF
 .db    0xBF,0xBF
 .db    0xBF,0x63
 .db    0x63,0x63
 .db    0xEA,0xA2
 .db    0x67,0xBB
 .db    0xE6,0xBF
 .db    0xFA,0xFA
 .db    0xE6,0x77
 .db    0x63,0x63
 .db    0xFA,0xFA
 .db    0xF6,0xE2
 .db    0x73,0xE2
 .db    0xF6,0xE6
 .db    0x73,0xB3
 .db    0x73,0x73
 .db    0xB7,0x73
 .db    0xB7,0xF6
 .db    0xE2,0xB7
 .db    0xB2,0x73
 .db    0xB2,0xE6
 .db    0xE6,0xBF
 .db    0xE2,0x45
 .db    0x1A,0x1A
 .db    0x2A,0xC0
 .db    0xEA,0xF6
 .db    0xF2,0xB2
 .db    0xB2,0xB2
 .db    0xF6,0x77
 .db    0xF6,0xE6
 .db    0x77,0x63
 .db    0x63,0xB7
 .db    0x73,0xE6
 .db    0xBB,0xA7
 .db    0x77,0x53
 .db    0x63,0xE6
 .db    0x92,0x23
 .db    0x52,0x23
 .db    0x27,0x63
 .db    0x77,0x77
 .db    0xB7,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x73,0x73
 .db    0x77,0x77
 .db    0x12,0x12
 .db    0x12,0x52
 .db    0xBB,0xAB
 .db    0x6B,0x5B
 .db    0x6B,0xA7
 .db    0xE2,0xE2
 .db    0xD2,0x92
 .db    0x52,0x12
 .db    0x13,0x13
 .db    0x67,0xB3
 .db    0xB7,0xB7
 .db    0xE2,0x63
 .db    0x53,0x92
 .db    0xD6,0xBF
 .db    0xA7,0xD6
 .db    0xBB,0x63
 .db    0xD2,0xE6
 .db    0x7B,0xBF
 .db    0xBF,0x63
 .db    0x63,0xD1
 .db    0x77,0x63
 .db    0x63,0xE6
 .db    0xD1,0x7B
 .db    0xBF,0xFA
 .db    0xD1,0x77
 .db    0xA2,0xA2
 .db    0xFA,0xFA
 .db    0xE1,0x73
 .db    0x63,0x73
 .db    0xB6,0x63
 .db    0x73,0x63
 .db    0x73,0xA2
 .db    0xE6,0xBB
 .db    0xE2,0xB2
 .db    0xE2,0xB2
 .db    0xB2,0x73
 .db    0xB2,0xE6
 .db    0xBF,0xBB
 .db    0xE2,0x2A
 .db    0x85,0x85
 .db    0x2F,0x3F
 .db    0xBF,0xF6
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xF2,0xB7
 .db    0xF6,0xE6
 .db    0xE6,0x63
 .db    0xA2,0xE2
 .db    0x63,0xE2
 .db    0xA7,0x63
 .db    0xE2,0x53
 .db    0x53,0x63
 .db    0xD1,0x27
 .db    0x52,0x27
 .db    0x63,0x27
 .db    0x92,0xBB
 .db    0xB3,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x73,0x77
 .db    0x77,0x7B
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x92,0xD6
 .db    0x6B,0x86
 .db    0x6B,0xD2
 .db    0xE2,0xA7
 .db    0xD1,0x92
 .db    0x13,0x12
 .db    0x13,0x13
 .db    0x7B,0xF2
 .db    0xB2,0xB3
 .db    0xB7,0x27
 .db    0x53,0x63
 .db    0x63,0xE6
 .db    0x63,0x63
 .db    0xBB,0x77
 .db    0xE6,0xA2
 .db    0x63,0xBF
 .db    0xBF,0x77
 .db    0x63,0xE2
 .db    0x63,0x63
 .db    0x63,0xA6
 .db    0x63,0x63
 .db    0xD2,0xBF
 .db    0x63,0x63
 .db    0xE6,0xBB
 .db    0xFA,0xFA
 .db    0x73,0x73
 .db    0x63,0x77
 .db    0xB6,0x63
 .db    0x77,0x63
 .db    0xE2,0xB7
 .db    0xF6,0xF6
 .db    0xB2,0x73
 .db    0xB2,0xB2
 .db    0x73,0xB2
 .db    0xE2,0x7B
 .db    0xBB,0xD1
 .db    0xE2,0x2F
 .db    0x2F,0x3F
 .db    0x3F,0x3F
 .db    0xE5,0xF6
 .db    0xB6,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xE2
 .db    0xBB,0x63
 .db    0x77,0x77
 .db    0x77,0xE6
 .db    0x73,0xB7
 .db    0x63,0x63
 .db    0x77,0x53
 .db    0x23,0x63
 .db    0x7B,0x23
 .db    0x63,0xD6
 .db    0x77,0x23
 .db    0x77,0xBB
 .db    0xB2,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x77,0x7B
 .db    0x7B,0x96
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x42,0x92
 .db    0x6B,0x92
 .db    0x6B,0x6B
 .db    0xD2,0x6B
 .db    0x92,0x53
 .db    0x13,0x12
 .db    0x13,0x13
 .db    0xBB,0xF2
 .db    0x73,0x73
 .db    0xB2,0x67
 .db    0x23,0x52
 .db    0x53,0xA2
 .db    0x63,0x63
 .db    0xA2,0xBB
 .db    0x7B,0x63
 .db    0x63,0x77
 .db    0xEA,0xBB
 .db    0xE6,0x7B
 .db    0x63,0x63
 .db    0xD2,0x7B
 .db    0x63,0x63
 .db    0x63,0x7B
 .db    0xA2,0x63
 .db    0xBF,0xFA
 .db    0x7B,0x7B
 .db    0xE2,0xE6
 .db    0xB6,0xE6
 .db    0xE6,0x77
 .db    0xE6,0x77
 .db    0xE6,0xF6
 .db    0xF6,0xF6
 .db    0x73,0xB2
 .db    0x73,0xB2
 .db    0x73,0xB2
 .db    0xE6,0x7B
 .db    0xFA,0xBB
 .db    0xF6,0x2F
 .db    0xC5,0x3F
 .db    0x3F,0x3F
 .db    0xD5,0xEA
 .db    0xB6,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xF2,0x63
 .db    0x77,0x63
 .db    0x73,0xE2
 .db    0x77,0xE6
 .db    0x63,0x53
 .db    0xE2,0x67
 .db    0x63,0xA7
 .db    0x63,0x23
 .db    0xD1,0xE6
 .db    0x7B,0x23
 .db    0xE2,0xB7
 .db    0x73,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x63,0x63
 .db    0xA7,0x7B
 .db    0x7B,0x2B
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x13,0x82
 .db    0xC1,0x6B
 .db    0x6B,0xC1
 .db    0xC1,0x67
 .db    0x92,0x52
 .db    0x13,0x13
 .db    0x52,0x27
 .db    0xBB,0xBB
 .db    0xB2,0x73
 .db    0x73,0xE2
 .db    0x92,0x27
 .db    0x23,0x63
 .db    0x53,0x53
 .db    0x63,0xBB
 .db    0xA2,0x63
 .db    0x53,0x63
 .db    0xD1,0xD1
 .db    0xE6,0x63
 .db    0x63,0xA7
 .db    0xBF,0xEA
 .db    0x92,0x63
 .db    0x63,0x63
 .db    0x73,0xA2
 .db    0xBF,0xEA
 .db    0x63,0x63
 .db    0xBB,0xBB
 .db    0xE1,0xE6
 .db    0xE6,0xE6
 .db    0xBB,0xE6
 .db    0xBB,0xF6
 .db    0xE1,0xE2
 .db    0x77,0xB2
 .db    0xB2,0x73
 .db    0x73,0xB2
 .db    0xBB,0x67
 .db    0xFB,0xFA
 .db    0xFA,0xC5
 .db    0xC5,0x3F
 .db    0x6B,0x3F
 .db    0xD5,0xEA
 .db    0xB6,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xE2,0xE2
 .db    0xBB,0x73
 .db    0xB2,0x63
 .db    0x63,0xB2
 .db    0x7B,0x77
 .db    0x77,0x7B
 .db    0xE6,0xE6
 .db    0x52,0x23
 .db    0x63,0x92
 .db    0x27,0x23
 .db    0xE2,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x63,0xA3
 .db    0xD6,0x7B
 .db    0x7B,0x27
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x13,0x52
 .db    0xC1,0x7B
 .db    0x6B,0xC1
 .db    0x67,0x92
 .db    0x82,0x13
 .db    0x13,0x52
 .db    0xC1,0x92
 .db    0xBB,0xBB
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0xB7,0xA7
 .db    0x23,0x23
 .db    0x23,0x23
 .db    0x53,0xE6
 .db    0x63,0x63
 .db    0x53,0x63
 .db    0x63,0x53
 .db    0xA7,0x63
 .db    0x63,0xEA
 .db    0xFA,0xFA
 .db    0xE6,0x67
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0xBF,0xEA
 .db    0x63,0x63
 .db    0x7B,0xE6
 .db    0x63,0x77
 .db    0xB6,0xBB
 .db    0xBB,0xE6
 .db    0xBB,0xE2
 .db    0x63,0x63
 .db    0xE6,0xB2
 .db    0xB2,0xB2
 .db    0x73,0xB2
 .db    0xBB,0xA2
 .db    0xFB,0xF6
 .db    0xFA,0xC5
 .db    0xC5,0x3F
 .db    0x3F,0x3F
 .db    0xC0,0xE5
 .db    0xE6,0xF2
 .db    0xB2,0xF2
 .db    0xB2,0xB2
 .db    0xB2,0xF2
 .db    0xF6,0xB2
 .db    0xB7,0x63
 .db    0x63,0xA2
 .db    0x7B,0xE6
 .db    0x63,0x63
 .db    0xBB,0xD6
 .db    0x23,0x63
 .db    0x52,0x23
 .db    0x23,0x23
 .db    0xE2,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x63,0xA7
 .db    0xAA,0x7B
 .db    0x7B,0x42
 .db    0x13,0x27
 .db    0x12,0x12
 .db    0x13,0x13
 .db    0xC1,0xD1
 .db    0x6B,0xC1
 .db    0x67,0x92
 .db    0x53,0x13
 .db    0x13,0x52
 .db    0x27,0xC1
 .db    0xE6,0xBB
 .db    0xD2,0x73
 .db    0x73,0x73
 .db    0xB2,0xE2
 .db    0xD1,0x27
 .db    0x53,0x53
 .db    0x92,0xE6
 .db    0xA2,0x63
 .db    0x53,0x63
 .db    0x63,0x23
 .db    0x77,0x63
 .db    0x63,0xEA
 .db    0xBF,0xFA
 .db    0x7B,0xD2
 .db    0xA2,0x63
 .db    0x63,0x63
 .db    0xBB,0xBB
 .db    0xA2,0x63
 .db    0x7B,0xE6
 .db    0x63,0x63
 .db    0xB2,0xE2
 .db    0x7B,0x63
 .db    0x7B,0xE1
 .db    0x33,0x63
 .db    0xE6,0x73
 .db    0x73,0x73
 .db    0x73,0xB6
 .db    0xE6,0x7B
 .db    0xBB,0xB7
 .db    0xFA,0xC5
 .db    0xC5,0x5A
 .db    0x2A,0x2A
 .db    0x1A,0xC0
 .db    0xF6,0xF6
 .db    0xB2,0xF2
 .db    0xB2,0xB2
 .db    0xB2,0xE2
 .db    0xB7,0x77
 .db    0xBB,0x77
 .db    0x77,0x63
 .db    0x63,0xBB
 .db    0x53,0x63
 .db    0xD6,0xD6
 .db    0x23,0x27
 .db    0x23,0x27
 .db    0x23,0x2B
 .db    0xB7,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x63,0xD6
 .db    0x92,0x92
 .db    0x6B,0x42
 .db    0x42,0x6B
 .db    0x12,0x13
 .db    0x52,0x13
 .db    0x6B,0xA6
 .db    0x6B,0xC1
 .db    0x67,0x92
 .db    0x27,0x13
 .db    0x13,0x13
 .db    0x13,0x27
 .db    0xE6,0xBB
 .db    0xA7,0x63
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB7,0xA7
 .db    0x63,0x63
 .db    0xD2,0x7B
 .db    0xE6,0x63
 .db    0x67,0x7B
 .db    0x63,0x63
 .db    0x73,0x63
 .db    0x92,0xBB
 .db    0x7F,0xEA
 .db    0x63,0x67
 .db    0xBB,0x77
 .db    0x63,0x63
 .db    0xE6,0xBB
 .db    0xE6,0x77
 .db    0xE6,0xBB
 .db    0xA2,0x63
 .db    0x73,0x63
 .db    0x73,0x63
 .db    0x63,0xE2
 .db    0xA2,0xE1
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x73,0xE1
 .db    0xE5,0xB6
 .db    0xE6,0xE6
 .db    0xE5,0x8A
 .db    0x2F,0x1A
 .db    0x16,0x16
 .db    0x15,0x45
 .db    0xFA,0xF6
 .db    0xF2,0xF2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0x73
 .db    0xE6,0xE6
 .db    0xE6,0x63
 .db    0xA2,0xA7
 .db    0x23,0x92
 .db    0x53,0x7B
 .db    0x53,0x23
 .db    0x67,0x67
 .db    0x27,0xD2
 .db    0xB2,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x6B
 .db    0x13,0x13
 .db    0xC1,0x42
 .db    0x27,0x6B
 .db    0x52,0xC1
 .db    0x92,0x13
 .db    0x6B,0x7B
 .db    0x6B,0xC1
 .db    0x67,0x92
 .db    0x42,0x13
 .db    0x13,0x13
 .db    0x13,0x13
 .db    0xAB,0xAB
 .db    0xD2,0x63
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xB3
 .db    0xE6,0x7B
 .db    0xA7,0x63
 .db    0x67,0x7B
 .db    0xE6,0xBB
 .db    0x77,0x67
 .db    0x63,0x63
 .db    0x92,0xE6
 .db    0x63,0xE2
 .db    0x53,0x63
 .db    0xFA,0xBF
 .db    0xA2,0x77
 .db    0x77,0x77
 .db    0xE6,0x7B
 .db    0xBB,0xEA
 .db    0xB6,0x73
 .db    0x63,0x63
 .db    0xA2,0x63
 .db    0x67,0xE6
 .db    0xB6,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xB6
 .db    0xD1,0xE2
 .db    0xE2,0xFA
 .db    0xE1,0x2F
 .db    0x1B,0x45
 .db    0x15,0x40
 .db    0x40,0x15
 .db    0x7B,0xF6
 .db    0xF2,0xF2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x77
 .db    0x77,0xE2
 .db    0xE6,0xA2
 .db    0xE2,0x63
 .db    0x27,0x63
 .db    0x23,0x63
 .db    0x63,0x27
 .db    0x7B,0xE6
 .db    0x2B,0xA2
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x93,0x53
 .db    0x13,0x12
 .db    0x52,0x52
 .db    0x27,0x96
 .db    0x27,0xC1
 .db    0x6B,0x13
 .db    0x6B,0x6B
 .db    0xC1,0x67
 .db    0x92,0x92
 .db    0x52,0x13
 .db    0x92,0x13
 .db    0x13,0x13
 .db    0xD6,0xD6
 .db    0x67,0x63
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xE2,0xA7
 .db    0x7B,0x23
 .db    0x23,0x63
 .db    0xE6,0xEA
 .db    0xE6,0xE6
 .db    0xA2,0x63
 .db    0x92,0xA2
 .db    0x63,0xA2
 .db    0x92,0x92
 .db    0xBF,0xFA
 .db    0xBB,0xE2
 .db    0x63,0x63
 .db    0x77,0x63
 .db    0xD6,0xBB
 .db    0x77,0x63
 .db    0x63,0x77
 .db    0xE2,0x7B
 .db    0xE6,0xB7
 .db    0xB6,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xBA
 .db    0x91,0xF6
 .db    0xE6,0xE6
 .db    0xA2,0x1B
 .db    0x16,0x41
 .db    0x40,0x40
 .db    0x40,0x15
 .db    0x55,0xFA
 .db    0xB6,0xF1
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xE2,0xBB
 .db    0x63,0xB2
 .db    0xE1,0xA2
 .db    0xA2,0x23
 .db    0x63,0x53
 .db    0x23,0x63
 .db    0x23,0x63
 .db    0x92,0x7B
 .db    0x52,0xE2
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x73,0x63
 .db    0x63,0x53
 .db    0xC2,0x13
 .db    0x12,0x12
 .db    0x13,0x53
 .db    0x6B,0x52
 .db    0x12,0x52
 .db    0x6B,0x27
 .db    0xC1,0xC1
 .db    0x67,0x67
 .db    0x67,0x67
 .db    0x52,0x13
 .db    0xD2,0x13
 .db    0x13,0x53
 .db    0x7F,0x6B
 .db    0x92,0x63
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xE2
 .db    0xD1,0x23
 .db    0x23,0x23
 .db    0xD6,0xBB
 .db    0xE6,0xE6
 .db    0x92,0x53
 .db    0x77,0x92
 .db    0x63,0x63
 .db    0xE6,0xE6
 .db    0xE6,0xBF
 .db    0xEA,0xA2
 .db    0x63,0x63
 .db    0xA2,0x53
 .db    0x63,0xE2
 .db    0x73,0x33
 .db    0x63,0xE6
 .db    0xE6,0xBB
 .db    0xBB,0xE2
 .db    0xE2,0x77
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0xB2,0xE6
 .db    0x91,0xF6
 .db    0xBB,0xE1
 .db    0x67,0x16
 .db    0x41,0x15
 .db    0x40,0x41
 .db    0x41,0x16
 .db    0x2A,0xE6
 .db    0xB6,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xE6
 .db    0x73,0xE2
 .db    0xE1,0x63
 .db    0x63,0x63
 .db    0xA2,0x67
 .db    0x53,0x63
 .db    0x23,0x27
 .db    0x23,0x63
 .db    0x52,0xE2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x53
 .db    0x93,0x13
 .db    0x12,0x12
 .db    0x12,0x82
 .db    0x7B,0x13
 .db    0x12,0x12
 .db    0xC1,0x6B
 .db    0x53,0x92
 .db    0x57,0x92
 .db    0x92,0x92
 .db    0x42,0x13
 .db    0xC2,0xC1
 .db    0x52,0xD6
 .db    0x7B,0x92
 .db    0x82,0x63
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xE2
 .db    0x63,0x13
 .db    0x13,0x23
 .db    0x92,0x6B
 .db    0x6B,0x7B
 .db    0x92,0x23
 .db    0xA7,0xA2
 .db    0x63,0x63
 .db    0xEA,0x7B
 .db    0x92,0xBB
 .db    0xBB,0x62
 .db    0x53,0x63
 .db    0xA2,0x63
 .db    0x23,0xD2
 .db    0x77,0x63
 .db    0x53,0xE6
 .db    0xE6,0xE1
 .db    0x77,0x77
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xE1,0xBB
 .db    0xC1,0xE6
 .db    0xFA,0x3B
 .db    0x92,0x16
 .db    0x41,0x41
 .db    0x16,0x1A
 .db    0x45,0x45
 .db    0x81,0x3F
 .db    0xBB,0xB6
 .db    0xB2,0xB2
 .db    0xB2,0x73
 .db    0x73,0xB2
 .db    0xB6,0xB6
 .db    0x77,0x63
 .db    0xA2,0xA2
 .db    0x63,0x63
 .db    0xA2,0x37
 .db    0x23,0x23
 .db    0x23,0x62
 .db    0xA2,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x53
 .db    0x53,0x13
 .db    0x13,0x12
 .db    0x12,0x52
 .db    0x7B,0x13
 .db    0x13,0x13
 .db    0x27,0x6B
 .db    0x52,0x53
 .db    0x27,0x27
 .db    0x82,0x92
 .db    0x52,0x13
 .db    0xC2,0x6B
 .db    0x57,0xD6
 .db    0x82,0x27
 .db    0x27,0x63
 .db    0x63,0x63
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0xE2
 .db    0x27,0x13
 .db    0x13,0x23
 .db    0x52,0x27
 .db    0x27,0x53
 .db    0xA2,0x63
 .db    0xA7,0xA2
 .db    0x63,0x63
 .db    0xEA,0xA2
 .db    0x63,0x7B
 .db    0xBB,0x37
 .db    0x63,0xD2
 .db    0xE1,0xA2
 .db    0x63,0xE2
 .db    0xE6,0x63
 .db    0x23,0xA2
 .db    0x77,0x63
 .db    0x63,0xB2
 .db    0x73,0x73
 .db    0x77,0xB2
 .db    0x73,0xB2
 .db    0xE6,0x7B
 .db    0xD1,0xE1
 .db    0xE6,0x52
 .db    0xC1,0x1A
 .db    0x16,0x16
 .db    0x80,0x81
 .db    0x80,0x1A
 .db    0x81,0xC0
 .db    0xE6,0xE6
 .db    0xB6,0xB2
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0xE1,0x63
 .db    0x63,0x77
 .db    0xA2,0x63
 .db    0x33,0x23
 .db    0x92,0x23
 .db    0x37,0x52
 .db    0x23,0x67
 .db    0xE6,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x53,0x53
 .db    0x13,0x13
 .db    0x12,0x12
 .db    0x12,0x13
 .db    0xD6,0x27
 .db    0x52,0x52
 .db    0x52,0x57
 .db    0x13,0x52
 .db    0x13,0x13
 .db    0x17,0x27
 .db    0x52,0x13
 .db    0xD2,0x13
 .db    0x13,0xD6
 .db    0x42,0x13
 .db    0x13,0x63
 .db    0x63,0x63
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0x23,0x13
 .db    0x13,0x13
 .db    0x23,0x23
 .db    0x23,0x27
 .db    0x92,0xA7
 .db    0x63,0x63
 .db    0x63,0x67
 .db    0xEA,0x77
 .db    0x53,0x63
 .db    0xEA,0x7B
 .db    0xA2,0xE6
 .db    0x77,0xA2
 .db    0x7B,0xE6
 .db    0x7B,0xE2
 .db    0x77,0x37
 .db    0x63,0x23
 .db    0x77,0xB2
 .db    0x73,0xB2
 .db    0xB2,0x73
 .db    0xB2,0xB6
 .db    0xE6,0xA6
 .db    0xA7,0xB7
 .db    0xA2,0x52
 .db    0x67,0x1A
 .db    0x45,0x16
 .db    0x80,0x81
 .db    0x2A,0x80
 .db    0x81,0xD1
 .db    0xA2,0xBB
 .db    0xB2,0xB2
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0xB2,0x63
 .db    0x73,0x77
 .db    0x53,0x23
 .db    0x63,0x23
 .db    0x92,0x23
 .db    0x92,0x52
 .db    0x62,0xA2
 .db    0xE1,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x53,0x53
 .db    0x13,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x92,0x6B
 .db    0x6B,0x27
 .db    0x13,0x27
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x12,0x52
 .db    0x53,0x27
 .db    0x6B,0x13
 .db    0x13,0x57
 .db    0x13,0x13
 .db    0x13,0x63
 .db    0x63,0x63
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0x52,0x13
 .db    0x13,0x13
 .db    0x23,0x13
 .db    0x13,0x23
 .db    0x27,0xD1
 .db    0x63,0x23
 .db    0x23,0xA7
 .db    0xBF,0xBB
 .db    0x53,0x63
 .db    0xEA,0xBB
 .db    0x7B,0xE6
 .db    0x63,0x63
 .db    0xB7,0xA2
 .db    0x63,0xE2
 .db    0xE6,0xA2
 .db    0x63,0x63
 .db    0xE2,0xB6
 .db    0x73,0xB2
 .db    0x73,0x73
 .db    0xB2,0xB6
 .db    0xBB,0xD1
 .db    0xBB,0xFA
 .db    0x37,0x92
 .db    0x92,0x1A
 .db    0x1A,0x16
 .db    0x45,0x80
 .db    0x81,0x1A
 .db    0x81,0xBF
 .db    0x92,0xE6
 .db    0xB6,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xA2
 .db    0x77,0xA2
 .db    0x23,0x63
 .db    0x77,0x63
 .db    0x7B,0x92
 .db    0x92,0x23
 .db    0x27,0x27
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x53,0x53
 .db    0x52,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x42,0xD5
 .db    0x6B,0x17
 .db    0x12,0x27
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x12,0x13
 .db    0x92,0x52
 .db    0x67,0x13
 .db    0x13,0x17
 .db    0x12,0x12
 .db    0x13,0x92
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x67,0x13
 .db    0x13,0x13
 .db    0x23,0x13
 .db    0x13,0x23
 .db    0x27,0x53
 .db    0x63,0x53
 .db    0x53,0xEA
 .db    0xBF,0xBF
 .db    0xA2,0xA2
 .db    0xFA,0xBB
 .db    0x63,0xD2
 .db    0x63,0x63
 .db    0xE2,0x63
 .db    0x53,0x67
 .db    0xE2,0xB6
 .db    0xE1,0xA2
 .db    0xE2,0xB6
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xBA
 .db    0xBA,0xD1
 .db    0xE6,0xBB
 .db    0x62,0x27
 .db    0x92,0x1A
 .db    0x1A,0x45
 .db    0x16,0x1A
 .db    0x80,0x1A
 .db    0x80,0xFB
 .db    0xA2,0x63
 .db    0xE6,0xB2
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x77,0x63
 .db    0x23,0x7B
 .db    0x27,0x77
 .db    0x7B,0xA2
 .db    0x92,0x23
 .db    0x37,0x52
 .db    0xE2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x53,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x12,0x2B
 .db    0x6B,0x42
 .db    0x13,0x42
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x27,0x13
 .db    0x52,0x92
 .db    0x13,0x13
 .db    0x12,0x13
 .db    0x13,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0xE2,0x13
 .db    0x13,0x52
 .db    0x92,0x23
 .db    0x23,0x23
 .db    0x27,0x23
 .db    0x23,0x63
 .db    0x92,0xEA
 .db    0xEA,0xE6
 .db    0x7B,0x7B
 .db    0xBB,0xA6
 .db    0x62,0xA2
 .db    0x73,0x77
 .db    0xA2,0x77
 .db    0x53,0x77
 .db    0x73,0x92
 .db    0xE2,0xB6
 .db    0xA2,0xB2
 .db    0x73,0x73
 .db    0xB2,0x73
 .db    0xB6,0xBB
 .db    0x7A,0x3B
 .db    0xE6,0xB6
 .db    0x63,0x52
 .db    0x67,0x1A
 .db    0x45,0x16
 .db    0x16,0x16
 .db    0x45,0x1A
 .db    0x2A,0xFA
 .db    0xA2,0x73
 .db    0xE2,0xE1
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xA2,0x63
 .db    0x63,0xD1
 .db    0x23,0x77
 .db    0xA2,0x27
 .db    0xD1,0x62
 .db    0xA2,0x27
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x67
 .db    0x57,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x92,0x17
 .db    0x42,0x41
 .db    0x12,0x12
 .db    0x11,0x11
 .db    0x12,0x12
 .db    0x42,0x13
 .db    0x13,0xD2
 .db    0x17,0x12
 .db    0x12,0x13
 .db    0x12,0x63
 .db    0x53,0x63
 .db    0x63,0x63
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x77,0x13
 .db    0x13,0x52
 .db    0xD1,0x92
 .db    0x63,0x63
 .db    0x92,0x23
 .db    0x23,0x67
 .db    0x7B,0xEA
 .db    0x7B,0x63
 .db    0x67,0x63
 .db    0xD2,0x63
 .db    0x53,0x63
 .db    0xA2,0x77
 .db    0x73,0x73
 .db    0xA2,0xE1
 .db    0x37,0x63
 .db    0xE2,0xB6
 .db    0x33,0x73
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xB6,0xBB
 .db    0xC0,0x91
 .db    0xBF,0x7B
 .db    0x37,0x63
 .db    0xD1,0x16
 .db    0x41,0x16
 .db    0x41,0x16
 .db    0x16,0x16
 .db    0x3F,0xE6
 .db    0xB3,0x73
 .db    0x73,0xE6
 .db    0xA2,0x73
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0xA2,0x92
 .db    0xA2,0xA2
 .db    0x27,0xA2
 .db    0x62,0x52
 .db    0xA2,0x92
 .db    0x27,0x92
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x53,0x53
 .db    0x63,0x77
 .db    0x67,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x41,0x52
 .db    0x17,0x41
 .db    0x16,0x41
 .db    0x41,0x41
 .db    0x11,0x12
 .db    0x12,0x13
 .db    0x13,0xD6
 .db    0x12,0x12
 .db    0x12,0x42
 .db    0x42,0x53
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x77,0x13
 .db    0x13,0x27
 .db    0xD1,0x92
 .db    0x27,0x53
 .db    0x77,0x23
 .db    0x23,0x7B
 .db    0xD1,0xBB
 .db    0x37,0x23
 .db    0x27,0x23
 .db    0x92,0x63
 .db    0x23,0x92
 .db    0x63,0x63
 .db    0x73,0x7B
 .db    0xB7,0xB6
 .db    0xE1,0x73
 .db    0xE1,0xB6
 .db    0x63,0xB2
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xB6,0xE5
 .db    0x2A,0x62
 .db    0xE6,0x3B
 .db    0x52,0x23
 .db    0xD1,0x16
 .db    0x15,0x41
 .db    0x41,0x41
 .db    0x41,0x16
 .db    0xE6,0xE6
 .db    0xB3,0x73
 .db    0x73,0x7B
 .db    0x7B,0xB2
 .db    0x73,0x73
 .db    0x73,0x37
 .db    0x73,0x37
 .db    0xA2,0xA2
 .db    0x63,0x77
 .db    0x23,0x37
 .db    0xA2,0x92
 .db    0x23,0x67
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x53,0x53
 .db    0x63,0xD1
 .db    0x67,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x12,0x41
 .db    0x16,0x26
 .db    0x16,0x16
 .db    0x41,0x41
 .db    0x11,0x12
 .db    0x12,0x52
 .db    0x27,0x6B
 .db    0x12,0x12
 .db    0x41,0x42
 .db    0x42,0x53
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB3,0x27
 .db    0x52,0x92
 .db    0x92,0x23
 .db    0x13,0x13
 .db    0x63,0x53
 .db    0x23,0x63
 .db    0x52,0xE6
 .db    0x23,0x53
 .db    0x23,0x53
 .db    0x67,0xA2
 .db    0x63,0xE6
 .db    0x92,0x63
 .db    0x77,0xE6
 .db    0xBB,0xA2
 .db    0xB6,0xB2
 .db    0xB2,0xB2
 .db    0x73,0xB2
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xE6,0x2A
 .db    0x80,0x91
 .db    0xB6,0x37
 .db    0x27,0x63
 .db    0xD1,0x41
 .db    0x15,0x15
 .db    0x15,0x41
 .db    0x16,0x16
 .db    0xFA,0xB2
 .db    0xB2,0x73
 .db    0x73,0x63
 .db    0xA7,0xB2
 .db    0xA2,0x73
 .db    0x73,0x37
 .db    0x37,0x73
 .db    0x73,0x72
 .db    0x63,0xA2
 .db    0x52,0x27
 .db    0x63,0x92
 .db    0x27,0x27
 .db    0xA2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x63,0x63
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0xD1
 .db    0xC1,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x12,0x16
 .db    0x16,0x2B
 .db    0x41,0x16
 .db    0x41,0x41
 .db    0x40,0x41
 .db    0x12,0x16
 .db    0x81,0x12
 .db    0x12,0x12
 .db    0x12,0x42
 .db    0x13,0x53
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB2,0x92
 .db    0x92,0x67
 .db    0x27,0x13
 .db    0x13,0x13
 .db    0x23,0x23
 .db    0x23,0x23
 .db    0x23,0x77
 .db    0x23,0x23
 .db    0x53,0x77
 .db    0x7B,0xE6
 .db    0xE6,0xBB
 .db    0xE6,0x77
 .db    0x63,0xE6
 .db    0xBB,0x62
 .db    0xA2,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0x73
 .db    0xB2,0xB6
 .db    0xBB,0x40
 .db    0x80,0x7F
 .db    0xB6,0x37
 .db    0x63,0x73
 .db    0x77,0x41
 .db    0x15,0x15
 .db    0x15,0x41
 .db    0x16,0x51
 .db    0xFF,0xB2
 .db    0xB2,0xB2
 .db    0x63,0x63
 .db    0x63,0x7B
 .db    0x77,0x73
 .db    0x73,0x37
 .db    0x37,0x37
 .db    0x72,0x37
 .db    0x37,0x73
 .db    0x63,0x62
 .db    0x63,0x37
 .db    0x92,0x52
 .db    0x37,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x63,0x63
 .db    0x63,0x23
 .db    0x53,0x53
 .db    0x53,0x6B
 .db    0x6B,0x17
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x41,0x80
 .db    0x16,0x2A
 .db    0x41,0x41
 .db    0x41,0x41
 .db    0x40,0x40
 .db    0x12,0x12
 .db    0x41,0x12
 .db    0x12,0x12
 .db    0x12,0x42
 .db    0x42,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB2,0x62
 .db    0x27,0x27
 .db    0x27,0x13
 .db    0x13,0x13
 .db    0x52,0x27
 .db    0x52,0x23
 .db    0x23,0x63
 .db    0x53,0x53
 .db    0x92,0x7B
 .db    0x77,0xE6
 .db    0x7B,0xA7
 .db    0xE6,0xE6
 .db    0x27,0x92
 .db    0xBB,0x63
 .db    0x73,0xB2
 .db    0xB2,0x73
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB6
 .db    0xBA,0x40
 .db    0x81,0xBB
 .db    0xE2,0x52
 .db    0x63,0x63
 .db    0xD1,0x16
 .db    0x41,0x15
 .db    0x15,0x41
 .db    0x16,0x80
 .db    0xFB,0xB2
 .db    0xB3,0xB2
 .db    0x63,0x63
 .db    0x63,0x67
 .db    0xA2,0x73
 .db    0x73,0x37
 .db    0x37,0x37
 .db    0x73,0x37
 .db    0x63,0x63
 .db    0x37,0x63
 .db    0x63,0x52
 .db    0x92,0x13
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x63,0x63
 .db    0x53,0x23
 .db    0x53,0x53
 .db    0x53,0x6B
 .db    0x6B,0x57
 .db    0x12,0x12
 .db    0x41,0x12
 .db    0x12,0x12
 .db    0x41,0x26
 .db    0x26,0x81
 .db    0x41,0x12
 .db    0x41,0x41
 .db    0x40,0x11
 .db    0x11,0x41
 .db    0x41,0x12
 .db    0x12,0x12
 .db    0x12,0x42
 .db    0x42,0x77
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB2,0xE2
 .db    0x13,0x13
 .db    0x23,0x13
 .db    0x13,0x13
 .db    0x23,0x63
 .db    0x67,0x27
 .db    0x23,0x63
 .db    0x7B,0x7B
 .db    0xD6,0xA2
 .db    0x53,0xE6
 .db    0x72,0x63
 .db    0x7B,0xBB
 .db    0x63,0x53
 .db    0xBB,0x77
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xE6
 .db    0x3A,0x40
 .db    0x3B,0xE6
 .db    0xB7,0x27
 .db    0x63,0x63
 .db    0x7B,0x41
 .db    0x41,0x15
 .db    0x40,0x15
 .db    0x16,0x91
 .db    0xFA,0xB2
 .db    0xB2,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x77,0xA2
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x33,0x37
 .db    0x37,0x62
 .db    0x37,0x62
 .db    0x92,0x73
 .db    0x73,0x63
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x6B
 .db    0x6B,0xC1
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x41,0x81
 .db    0x16,0x16
 .db    0x41,0x12
 .db    0x41,0x41
 .db    0x41,0x01
 .db    0x41,0x41
 .db    0x41,0x12
 .db    0x12,0x12
 .db    0x12,0x42
 .db    0x27,0xD2
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0x52,0x12
 .db    0x12,0x27
 .db    0x27,0x92
 .db    0x52,0x23
 .db    0x92,0xD1
 .db    0x23,0x7B
 .db    0xE6,0xE6
 .db    0xE6,0xA2
 .db    0x23,0xA7
 .db    0x77,0x62
 .db    0x27,0xBB
 .db    0x67,0x67
 .db    0xE6,0xB6
 .db    0xB2,0x73
 .db    0xB2,0xB2
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xB6,0xBB
 .db    0x50,0x15
 .db    0x92,0xB6
 .db    0xE2,0x63
 .db    0x63,0x73
 .db    0xA7,0x16
 .db    0x15,0x40
 .db    0x40,0x15
 .db    0x16,0xAA
 .db    0xBB,0xB2
 .db    0xB2,0x73
 .db    0xA2,0x63
 .db    0x63,0x63
 .db    0x63,0xA2
 .db    0x63,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x62,0x37
 .db    0x62,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x37,0x73
 .db    0x73,0x63
 .db    0x33,0x63
 .db    0x63,0x63
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x67
 .db    0x6B,0x6B
 .db    0x17,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x16,0x41
 .db    0x41,0x16
 .db    0x41,0x12
 .db    0x41,0x41
 .db    0x41,0x11
 .db    0x16,0x41
 .db    0x41,0x12
 .db    0x12,0x12
 .db    0x12,0x42
 .db    0xC1,0xA7
 .db    0x73,0x63
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0x77,0x12
 .db    0x12,0x92
 .db    0x67,0xD1
 .db    0x23,0x13
 .db    0x52,0x67
 .db    0x23,0x7B
 .db    0xD6,0xE6
 .db    0xA2,0x63
 .db    0x63,0x77
 .db    0x7B,0x37
 .db    0x27,0xE6
 .db    0xE6,0xE6
 .db    0xB6,0x77
 .db    0xB2,0x73
 .db    0xB2,0xA2
 .db    0xB2,0xB2
 .db    0xB2,0xB6
 .db    0xE6,0x7A
 .db    0x15,0x2A
 .db    0x92,0xE1
 .db    0x77,0x63
 .db    0x23,0x73
 .db    0xD6,0x16
 .db    0x15,0x40
 .db    0x40,0x41
 .db    0x16,0xFA
 .db    0xBF,0xE2
 .db    0xB2,0x73
 .db    0x73,0xA2
 .db    0x63,0x53
 .db    0x53,0x63
 .db    0xA2,0x37
 .db    0x72,0x37
 .db    0x37,0x37
 .db    0x62,0x37
 .db    0x62,0x62
 .db    0x62,0x62
 .db    0x62,0x62
 .db    0x62,0x73
 .db    0x73,0x73
 .db    0x33,0x63
 .db    0x63,0x63
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x63
 .db    0x6B,0x6B
 .db    0xC1,0x1B
 .db    0x17,0x17
 .db    0x42,0x42
 .db    0x17,0x16
 .db    0x41,0x81
 .db    0x41,0x12
 .db    0x41,0x41
 .db    0x41,0x41
 .db    0x16,0x41
 .db    0x41,0x12
 .db    0x12,0x12
 .db    0x12,0x42
 .db    0xAB,0xE6
 .db    0xA2,0x63
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xE2,0x12
 .db    0x13,0x92
 .db    0x27,0x92
 .db    0x23,0x13
 .db    0x13,0x27
 .db    0x23,0x67
 .db    0x92,0x7B
 .db    0x23,0x23
 .db    0x63,0x23
 .db    0xD6,0x77
 .db    0x63,0x77
 .db    0xBB,0xBB
 .db    0x7B,0x63
 .db    0xB2,0x73
 .db    0xB2,0x73
 .db    0xB2,0xB2
 .db    0xB2,0xB6
 .db    0xBB,0x25
 .db    0x15,0xC1
 .db    0x67,0xE1
 .db    0x3B,0x62
 .db    0x23,0x63
 .db    0xD6,0x16
 .db    0x41,0x15
 .db    0x15,0x16
 .db    0x80,0xFE
 .db    0xFA,0xE2
 .db    0xB2,0xA2
 .db    0x73,0x63
 .db    0x63,0x23
 .db    0x23,0x23
 .db    0xA2,0xA2
 .db    0x73,0x37
 .db    0x37,0x37
 .db    0x62,0x37
 .db    0x62,0x62
 .db    0x62,0x62
 .db    0x62,0x62
 .db    0x23,0x37
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x67,0x6B
 .db    0x6B,0x5B
 .db    0x86,0x4B
 .db    0x47,0x1B
 .db    0x1B,0x16
 .db    0x17,0x81
 .db    0x41,0x12
 .db    0x41,0x41
 .db    0x41,0x41
 .db    0x41,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x12,0x27
 .db    0xE6,0xBB
 .db    0xA2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0x12
 .db    0x13,0x27
 .db    0x13,0x13
 .db    0x13,0x13
 .db    0x23,0x63
 .db    0x23,0x53
 .db    0x23,0x67
 .db    0x23,0x53
 .db    0x77,0x23
 .db    0x77,0xE2
 .db    0x7B,0x77
 .db    0xD2,0xBB
 .db    0x77,0x63
 .db    0xB2,0x73
 .db    0x73,0xB2
 .db    0x73,0xB2
 .db    0xB2,0xB6
 .db    0x7A,0x15
 .db    0x15,0xC1
 .db    0xD1,0xE1
 .db    0x37,0x63
 .db    0x63,0x73
 .db    0x7F,0x16
 .db    0x16,0x15
 .db    0x41,0x16
 .db    0x80,0xFA
 .db    0xFA,0xE2
 .db    0xB2,0x73
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x67
 .db    0xA2,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x62,0x62
 .db    0x62,0x62
 .db    0x62,0x62
 .db    0x62,0x62
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x92,0xC1
 .db    0x96,0x96
 .db    0xC1,0x5B
 .db    0x5B,0x5B
 .db    0x81,0x42
 .db    0x81,0x81
 .db    0x41,0x12
 .db    0x41,0x16
 .db    0x41,0x41
 .db    0x41,0x12
 .db    0x12,0x12
 .db    0x12,0x12
 .db    0x12,0xC1
 .db    0xE6,0xBB
 .db    0xA2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x52
 .db    0x27,0x27
 .db    0x12,0x12
 .db    0x23,0x13
 .db    0x92,0x77
 .db    0x63,0x23
 .db    0x23,0x63
 .db    0xA2,0x67
 .db    0x7B,0x63
 .db    0x77,0xB6
 .db    0xB6,0xE2
 .db    0xA2,0xA2
 .db    0x73,0xB2
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0x73,0xB2
 .db    0xB2,0xBB
 .db    0x51,0x19
 .db    0x80,0xD1
 .db    0x7B,0xE1
 .db    0x62,0x63
 .db    0x73,0x73
 .db    0xD6,0x45
 .db    0x16,0x16
 .db    0x45,0x16
 .db    0x16,0xBA
 .db    0xFF,0xE2
 .db    0x73,0xA2
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x27
 .db    0x27,0xA2
 .db    0x92,0x37
 .db    0x37,0x37
 .db    0x62,0x62
 .db    0x62,0x62
 .db    0x62,0x62
 .db    0x62,0x92
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x57
 .db    0xC1,0xC1
 .db    0xC1,0xC1
 .db    0xC1,0xC5
 .db    0x2B,0x17
 .db    0x53,0x17
 .db    0x41,0x42
 .db    0x41,0x16
 .db    0x17,0x41
 .db    0x41,0x12
 .db    0x12,0x41
 .db    0x42,0x42
 .db    0x12,0xD6
 .db    0xBB,0xE6
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x67
 .db    0xC1,0x92
 .db    0x12,0x12
 .db    0x53,0x23
 .db    0x92,0xA2
 .db    0x77,0x63
 .db    0x23,0x23
 .db    0x77,0xE6
 .db    0x62,0x63
 .db    0xE2,0xB6
 .db    0xB2,0xE2
 .db    0x77,0x63
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xB6,0xE5
 .db    0x15,0x15
 .db    0x2B,0xD1
 .db    0xE6,0xE1
 .db    0x62,0x73
 .db    0x63,0x73
 .db    0xD6,0x1A
 .db    0x1A,0x45
 .db    0x45,0x16
 .db    0x15,0x3B
 .db    0xFE,0xE6
 .db    0xA2,0x77
 .db    0x73,0x77
 .db    0xB2,0x63
 .db    0x63,0x63
 .db    0x37,0x92
 .db    0x27,0xD1
 .db    0xA2,0x92
 .db    0x37,0x37
 .db    0x37,0x62
 .db    0x62,0x62
 .db    0x62,0x62
 .db    0x62,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0xC1,0xC1
 .db    0xC1,0xC1
 .db    0xC5,0xC5
 .db    0x2B,0x53
 .db    0x82,0x43
 .db    0x42,0x42
 .db    0x16,0x52
 .db    0x17,0x16
 .db    0x41,0x41
 .db    0x42,0x46
 .db    0x1B,0x42
 .db    0x17,0xD6
 .db    0xAB,0xE2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB2,0x67
 .db    0x96,0x67
 .db    0x13,0x13
 .db    0x67,0x92
 .db    0x23,0x92
 .db    0x63,0x63
 .db    0x63,0x23
 .db    0x63,0x7B
 .db    0x27,0x63
 .db    0xB6,0x63
 .db    0xE1,0xB2
 .db    0x77,0xA2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xE1
 .db    0xE6,0x80
 .db    0x15,0x15
 .db    0xC1,0xA2
 .db    0xBB,0xB2
 .db    0x73,0x63
 .db    0x63,0x7B
 .db    0x7F,0x1A
 .db    0x1A,0x1A
 .db    0x1A,0x45
 .db    0x15,0x26
 .db    0xFE,0xBF
 .db    0x77,0x73
 .db    0x73,0xB2
 .db    0xB2,0x73
 .db    0x63,0x63
 .db    0x73,0x77
 .db    0x7B,0xD1
 .db    0xA2,0xD1
 .db    0xA2,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x62,0x62
 .db    0x62,0x37
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x13,0x13
 .db    0x86,0xC1
 .db    0x96,0x6B
 .db    0xC5,0xC5
 .db    0x82,0x82
 .db    0x47,0x17
 .db    0x42,0x42
 .db    0x16,0x52
 .db    0x81,0x16
 .db    0x52,0x17
 .db    0x2B,0x57
 .db    0x86,0x57
 .db    0xC1,0xD6
 .db    0x92,0xD2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB3,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB2,0x92
 .db    0x92,0x67
 .db    0x27,0x52
 .db    0xA2,0x92
 .db    0x23,0x27
 .db    0x23,0x23
 .db    0x77,0x92
 .db    0x92,0xA2
 .db    0xA2,0x67
 .db    0x7B,0x23
 .db    0xA2,0x73
 .db    0x77,0xA2
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB2,0xB6
 .db    0xD1,0x15
 .db    0x15,0x15
 .db    0xD1,0xA2
 .db    0xE6,0xE1
 .db    0x63,0x63
 .db    0x63,0xD6
 .db    0x7F,0x81
 .db    0x81,0x81
 .db    0x1A,0x1A
 .db    0x16,0x16
 .db    0xEA,0xFA
 .db    0xB2,0x73
 .db    0x73,0xB2
 .db    0x73,0xB2
 .db    0x73,0x73
 .db    0x73,0x77
 .db    0x77,0x63
 .db    0xA2,0xD1
 .db    0x7B,0x92
 .db    0x37,0x92
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0x37,0x37
 .db    0xA2,0x63
 .db    0x63,0x63
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x13
 .db    0x13,0x43
 .db    0x82,0x5B
 .db    0x96,0x6B
 .db    0xC5,0xC5
 .db    0x82,0x47
 .db    0x17,0x13
 .db    0x13,0x17
 .db    0x41,0x16
 .db    0x81,0x26
 .db    0x2B,0x2B
 .db    0x2B,0x86
 .db    0xC1,0xC1
 .db    0xC1,0xD6
 .db    0x67,0xA3
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB3,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0x77,0x52
 .db    0x52,0x92
 .db    0x92,0x92
 .db    0x92,0x52
 .db    0x52,0x23
 .db    0x13,0x63
 .db    0x63,0x7B
 .db    0xA2,0x63
 .db    0xA2,0x77
 .db    0xA2,0x63
 .db    0x63,0xA2
 .db    0xB2,0xA2
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xE1,0xE5
 .db    0x51,0x15
 .db    0x15,0x80
 .db    0xA2,0xA2
 .db    0xE6,0xE1
 .db    0x63,0x73
 .db    0x63,0x7F
 .db    0xD5,0x81
 .db    0x81,0x81
 .db    0x1A,0x45
 .db    0x16,0x16
 .db    0xC0,0xFA
 .db    0xB6,0xB2
 .db    0xB2,0x73
 .db    0x73,0xB2
 .db    0xE2,0x77
 .db    0xA2,0x77
 .db    0x53,0x23
 .db    0x73,0xA2
 .db    0x7B,0x52
 .db    0x52,0x67
 .db    0x92,0x92
 .db    0x92,0x37
 .db    0x92,0x91
 .db    0x67,0x63
 .db    0x63,0x63
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x23,0x53
 .db    0x13,0x43
 .db    0x82,0x86
 .db    0xC1,0x6B
 .db    0x6B,0xC5
 .db    0x82,0x43
 .db    0x42,0x12
 .db    0x12,0x17
 .db    0x16,0x41
 .db    0x16,0x81
 .db    0x2B,0x2B
 .db    0x57,0xC1
 .db    0xC1,0xC1
 .db    0x6B,0xAB
 .db    0xD1,0xA3
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xA2,0x12
 .db    0x12,0x27
 .db    0x37,0x27
 .db    0x27,0x12
 .db    0x27,0x23
 .db    0x13,0x63
 .db    0x23,0x92
 .db    0x63,0x23
 .db    0xA2,0x77
 .db    0x23,0x77
 .db    0x73,0x77
 .db    0x77,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xE2,0x91
 .db    0x15,0x15
 .db    0x15,0x3B
 .db    0x77,0xA2
 .db    0xE6,0xB2
 .db    0x63,0x73
 .db    0xA2,0x7F
 .db    0x7B,0x46
 .db    0x46,0x81
 .db    0x55,0x45
 .db    0x16,0x16
 .db    0x80,0xBF
 .db    0xEA,0xB6
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xE2,0x63
 .db    0xE2,0xB6
 .db    0x67,0x52
 .db    0x77,0xA2
 .db    0xD1,0x52
 .db    0x27,0x67
 .db    0x92,0x27
 .db    0x52,0x52
 .db    0x13,0x13
 .db    0x67,0x92
 .db    0x33,0x33
 .db    0x53,0x53
 .db    0x53,0x23
 .db    0x23,0x53
 .db    0x23,0x13
 .db    0x13,0x53
 .db    0x27,0x52
 .db    0x52,0xC1
 .db    0x6B,0x6B
 .db    0x81,0x42
 .db    0x12,0x12
 .db    0x12,0x42
 .db    0x42,0x16
 .db    0x16,0x16
 .db    0x2B,0x2B
 .db    0x86,0xC1
 .db    0xC1,0xC1
 .db    0x6B,0xD6
 .db    0x93,0xA3
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x23,0x42
 .db    0x12,0x27
 .db    0x27,0x13
 .db    0x13,0x13
 .db    0x23,0x27
 .db    0x52,0xA2
 .db    0x23,0x27
 .db    0xA2,0x53
 .db    0xA2,0xA2
 .db    0x62,0x77
 .db    0x77,0x77
 .db    0x73,0x77
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xE1
 .db    0xD1,0x41
 .db    0x15,0x15
 .db    0x15,0xD1
 .db    0xD1,0xA2
 .db    0xB7,0xB2
 .db    0x33,0x33
 .db    0x77,0x7B
 .db    0x7B,0x45
 .db    0x45,0x1A
 .db    0x80,0x45
 .db    0x16,0x16
 .db    0x16,0xC0
 .db    0xBF,0xE6
 .db    0xA2,0xB2
 .db    0xB2,0xB2
 .db    0xE2,0x63
 .db    0xB7,0xB6
 .db    0xE2,0x77
 .db    0x7B,0x63
 .db    0x27,0xD1
 .db    0xD1,0xD1
 .db    0xD1,0x92
 .db    0x92,0x52
 .db    0x13,0x13
 .db    0x67,0xD1
 .db    0x33,0x33
 .db    0x53,0x53
 .db    0x23,0x23
 .db    0x53,0x53
 .db    0x53,0x13
 .db    0x17,0x92
 .db    0x52,0x52
 .db    0x52,0x82
 .db    0x6B,0xC1
 .db    0x81,0x16
 .db    0x41,0x12
 .db    0x12,0x12
 .db    0x17,0x16
 .db    0x16,0x41
 .db    0x2B,0x2B
 .db    0x86,0xC1
 .db    0x6B,0x6B
 .db    0x6B,0xD2
 .db    0x93,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x23,0x27
 .db    0x12,0x2B
 .db    0x27,0x13
 .db    0x23,0x52
 .db    0x27,0x27
 .db    0x63,0xA2
 .db    0x23,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0xA2,0xA2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB2,0x7B
 .db    0x16,0x15
 .db    0x15,0x15
 .db    0x80,0xD1
 .db    0xD1,0xA2
 .db    0xB7,0xB2
 .db    0x33,0x33
 .db    0x7B,0x7B
 .db    0x7F,0x41
 .db    0x41,0x45
 .db    0x55,0x1A
 .db    0x45,0x16
 .db    0x16,0x81
 .db    0xD5,0xBF
 .db    0xD1,0xB2
 .db    0xB2,0x73
 .db    0xA2,0x63
 .db    0xE2,0xE2
 .db    0xE2,0x77
 .db    0x53,0x27
 .db    0x27,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0x27
 .db    0x77,0xD1
 .db    0x52,0x13
 .db    0xD1,0x92
 .db    0x63,0x23
 .db    0x23,0x53
 .db    0x23,0x23
 .db    0x53,0x53
 .db    0x53,0x52
 .db    0x13,0x27
 .db    0x52,0x52
 .db    0x92,0x7F
 .db    0x7F,0xD5
 .db    0x17,0x16
 .db    0x41,0x12
 .db    0x11,0x12
 .db    0x16,0x16
 .db    0x16,0x27
 .db    0x2B,0x2B
 .db    0x86,0xC1
 .db    0x6B,0x6B
 .db    0x6B,0x96
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x52,0x92
 .db    0x12,0x92
 .db    0x23,0x52
 .db    0x37,0x37
 .db    0x63,0x23
 .db    0x92,0x63
 .db    0x63,0x62
 .db    0x63,0x23
 .db    0x63,0x77
 .db    0xA2,0x73
 .db    0x73,0x33
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x77
 .db    0x7B,0x80
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x3B,0xD1
 .db    0xD1,0xA2
 .db    0xE6,0xB2
 .db    0x73,0x63
 .db    0x7B,0x7B
 .db    0x7F,0x15
 .db    0x15,0x45
 .db    0x2A,0x2A
 .db    0x45,0x45
 .db    0x1A,0x81
 .db    0x2B,0xBA
 .db    0xEA,0x77
 .db    0x63,0x63
 .db    0xE1,0xB2
 .db    0x73,0xE2
 .db    0x67,0x53
 .db    0x53,0x63
 .db    0x92,0xE6
 .db    0xA2,0x7B
 .db    0x92,0x13
 .db    0x67,0x7B
 .db    0xD1,0x82
 .db    0x67,0x52
 .db    0x63,0x23
 .db    0x23,0x53
 .db    0x23,0x53
 .db    0x53,0x53
 .db    0x23,0xC1
 .db    0x23,0x52
 .db    0x52,0x92
 .db    0x7F,0xEA
 .db    0xBF,0xC1
 .db    0x27,0x27
 .db    0x16,0x12
 .db    0x11,0x41
 .db    0x41,0x16
 .db    0x16,0x2B
 .db    0x56,0x27
 .db    0x2B,0xC1
 .db    0xC1,0xC1
 .db    0xC1,0x57
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x27,0x27
 .db    0x27,0x92
 .db    0x12,0x62
 .db    0x37,0x27
 .db    0x92,0x13
 .db    0x37,0x37
 .db    0x63,0x23
 .db    0x63,0x63
 .db    0x27,0x77
 .db    0x73,0x33
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x77
 .db    0x7B,0x15
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x67,0xD1
 .db    0xD1,0xA2
 .db    0xE6,0x72
 .db    0x63,0x63
 .db    0x77,0x7B
 .db    0x7F,0x15
 .db    0x15,0x16
 .db    0x55,0x2A
 .db    0x45,0x1A
 .db    0x80,0x2B
 .db    0x56,0x81
 .db    0xBA,0xE6
 .db    0x63,0x63
 .db    0xB2,0x77
 .db    0x63,0xA2
 .db    0x63,0x53
 .db    0x92,0xD2
 .db    0x67,0xE6
 .db    0x27,0x92
 .db    0xC1,0x52
 .db    0x92,0x7B
 .db    0x7B,0x7B
 .db    0x27,0x52
 .db    0x63,0x53
 .db    0x23,0x53
 .db    0x53,0x53
 .db    0x53,0x23
 .db    0x92,0xD6
 .db    0x27,0x92
 .db    0x27,0xD6
 .db    0xEA,0xBF
 .db    0x7F,0x82
 .db    0x53,0x53
 .db    0x92,0x42
 .db    0x16,0x41
 .db    0x41,0x16
 .db    0x27,0x27
 .db    0x27,0x42
 .db    0x57,0x17
 .db    0x92,0x42
 .db    0xC1,0x53
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xA2
 .db    0x23,0x23
 .db    0x27,0x91
 .db    0x52,0x27
 .db    0x62,0x13
 .db    0x92,0x23
 .db    0x23,0x23
 .db    0x63,0x37
 .db    0x63,0x73
 .db    0x63,0x77
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xA2,0xA2
 .db    0xA2,0x15
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0xA2,0xD1
 .db    0x7B,0xA2
 .db    0xE6,0x33
 .db    0x33,0x77
 .db    0x67,0x7F
 .db    0xE6,0x41
 .db    0x15,0x16
 .db    0x1A,0x1A
 .db    0x45,0x1A
 .db    0x2A,0x85
 .db    0x2B,0x2A
 .db    0x81,0xBF
 .db    0xE6,0xA2
 .db    0xB2,0x63
 .db    0x53,0x63
 .db    0x92,0x67
 .db    0x63,0xA2
 .db    0x53,0xA2
 .db    0x53,0x92
 .db    0xD6,0x92
 .db    0x53,0x92
 .db    0x92,0xB6
 .db    0x7F,0x92
 .db    0xA6,0x53
 .db    0x23,0x23
 .db    0x23,0x23
 .db    0x53,0x53
 .db    0xE6,0x77
 .db    0x67,0xD6
 .db    0x7B,0xBF
 .db    0xFE,0x7F
 .db    0x27,0x53
 .db    0x53,0x53
 .db    0x82,0x17
 .db    0x82,0x12
 .db    0x17,0x17
 .db    0x27,0x27
 .db    0x27,0x17
 .db    0x92,0x12
 .db    0x92,0x12
 .db    0xC1,0x53
 .db    0x53,0x63
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x23,0x52
 .db    0x52,0x52
 .db    0x27,0x52
 .db    0x27,0x23
 .db    0x37,0x37
 .db    0x52,0x62
 .db    0x62,0x62
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x77,0x62
 .db    0x63,0x41
 .db    0x15,0x15
 .db    0x15,0x1A
 .db    0xD1,0xD1
 .db    0x7B,0x77
 .db    0xF6,0x33
 .db    0x33,0x7B
 .db    0x67,0xD6
 .db    0xE6,0x16
 .db    0x41,0x45
 .db    0x1A,0x1A
 .db    0x16,0x45
 .db    0x2A,0x2B
 .db    0x56,0x81
 .db    0x55,0x7A
 .db    0xBF,0xE6
 .db    0xB6,0x63
 .db    0x63,0x63
 .db    0xA2,0x77
 .db    0x53,0xA2
 .db    0x53,0xD2
 .db    0x53,0x67
 .db    0xBB,0x92
 .db    0x92,0x63
 .db    0x63,0xA6
 .db    0xFA,0xE6
 .db    0xBF,0xE6
 .db    0x27,0x53
 .db    0x53,0x53
 .db    0x53,0x92
 .db    0xBB,0x63
 .db    0xBB,0xFA
 .db    0xFA,0xBF
 .db    0x7F,0x53
 .db    0x53,0x53
 .db    0x52,0x52
 .db    0x53,0x52
 .db    0x82,0x12
 .db    0x81,0x17
 .db    0x27,0x52
 .db    0x27,0x27
 .db    0x92,0x52
 .db    0x92,0x27
 .db    0x92,0x13
 .db    0x53,0x63
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x62
 .db    0x52,0x52
 .db    0x23,0x23
 .db    0x23,0x23
 .db    0x52,0x52
 .db    0x27,0x27
 .db    0x62,0x62
 .db    0x62,0x33
 .db    0x62,0x37
 .db    0x37,0x73
 .db    0x73,0x73
 .db    0xA2,0x73
 .db    0x73,0x73
 .db    0x73,0x77
 .db    0x37,0x23
 .db    0x62,0x26
 .db    0x15,0x15
 .db    0x15,0x3B
 .db    0xD1,0xA6
 .db    0x7B,0x77
 .db    0xF6,0x33
 .db    0x63,0x77
 .db    0x67,0xD6
 .db    0xE6,0x45
 .db    0x45,0x80
 .db    0x81,0x1A
 .db    0x45,0x1A
 .db    0x80,0x2A
 .db    0x81,0x2A
 .db    0x1A,0x80
 .db    0xA6,0xBF
 .db    0xFA,0x7B
 .db    0x7B,0xA2
 .db    0x63,0x63
 .db    0x63,0x77
 .db    0x53,0xBB
 .db    0x67,0xE2
 .db    0xBB,0xE2
 .db    0xA6,0x92
 .db    0x63,0xA2
 .db    0xFA,0xFA
 .db    0xFA,0xFA
 .db    0xE6,0x63
 .db    0x63,0x63
 .db    0x63,0x92
 .db    0xFA,0x63
 .db    0xFA,0xFA
 .db    0x7F,0xC1
 .db    0x27,0x53
 .db    0x53,0x17
 .db    0x17,0x17
 .db    0x53,0x52
 .db    0x82,0x12
 .db    0x81,0x17
 .db    0x52,0x52
 .db    0x52,0x27
 .db    0xC1,0xC1
 .db    0xC1,0xC1
 .db    0x2B,0x13
 .db    0x53,0x53
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x73,0x73
 .db    0x73,0x27
 .db    0x27,0x27
 .db    0x52,0x23
 .db    0x23,0x23
 .db    0x23,0x23
 .db    0x27,0x52
 .db    0x23,0x33
 .db    0x33,0x62
 .db    0x33,0x37
 .db    0x33,0x33
 .db    0x63,0x73
 .db    0x62,0xA2
 .db    0x73,0x63
 .db    0xA2,0x63
 .db    0x23,0x23
 .db    0x23,0x92
 .db    0x15,0x15
 .db    0x16,0xC1
 .db    0xA6,0x7B
 .db    0x7B,0xB2
 .db    0x7B,0x33
 .db    0x63,0x92
 .db    0x67,0xD6
 .db    0xE6,0x45
 .db    0x45,0x2A
 .db    0x81,0x81
 .db    0x1A,0x80
 .db    0x80,0x1A
 .db    0x1A,0x1A
 .db    0x1A,0x80
 .db    0x2A,0xBA
 .db    0xFA,0xBF
 .db    0xBB,0x92
 .db    0x63,0xA2
 .db    0x77,0xE2
 .db    0x67,0xF6
 .db    0xBB,0xF6
 .db    0xF6,0xF6
 .db    0xBB,0xE6
 .db    0x63,0x77
 .db    0xE6,0x77
 .db    0xFA,0x7B
 .db    0xA2,0x63
 .db    0x63,0x77
 .db    0x63,0xD1
 .db    0xBF,0x92
 .db    0x7B,0x92
 .db    0x82,0x53
 .db    0x53,0x53
 .db    0x17,0x13
 .db    0x17,0x17
 .db    0x53,0x27
 .db    0x17,0x12
 .db    0x82,0x17
 .db    0x27,0x52
 .db    0x27,0x52
 .db    0x57,0x86
 .db    0xC1,0xC1
 .db    0x27,0x52
 .db    0x92,0x53
 .db    0x53,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x73
 .db    0x73,0x52
 .db    0x27,0x27
 .db    0x27,0x52
 .db    0x23,0x23
 .db    0x23,0x23
 .db    0x23,0x52
 .db    0x23,0x62
 .db    0x23,0x62
 .db    0x62,0x37
 .db    0x37,0x37
 .db    0x63,0x73
 .db    0x63,0xA2
 .db    0x73,0xA2
 .db    0x63,0x23
 .db    0x23,0x23
 .db    0x62,0xD1
 .db    0x15,0x15
 .db    0x1A,0xD1
 .db    0x7B,0x7B
 .db    0xA6,0xE2
 .db    0x62,0x33
 .db    0xA2,0x92
 .db    0x92,0x7B
 .db    0x7F,0x1A
 .db    0x1A,0x55
 .db    0x81,0x81
 .db    0x81,0x81
 .db    0x81,0x1A
 .db    0x16,0x16
 .db    0x45,0x80
 .db    0x81,0x2B
 .db    0xE5,0xFA
 .db    0xFA,0xE6
 .db    0x92,0xB7
 .db    0x73,0xE2
 .db    0xB7,0xF2
 .db    0x77,0xB2
 .db    0xF6,0xF6
 .db    0xF6,0xF6
 .db    0x92,0x7B
 .db    0xA2,0x92
 .db    0xFA,0x63
 .db    0x63,0xA2
 .db    0xE2,0xE2
 .db    0x67,0x77
 .db    0x67,0x67
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x17
 .db    0x13,0x13
 .db    0x43,0x53
 .db    0x53,0x82
 .db    0x17,0x12
 .db    0x82,0x17
 .db    0x53,0x13
 .db    0x53,0x17
 .db    0x82,0x82
 .db    0x82,0x92
 .db    0x52,0x92
 .db    0xD1,0x53
 .db    0x53,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0xA2,0x12
 .db    0x52,0x27
 .db    0x27,0x27
 .db    0x52,0x52
 .db    0x23,0x52
 .db    0x23,0x23
 .db    0x23,0x23
 .db    0x62,0x62
 .db    0x62,0x62
 .db    0x62,0x62
 .db    0x37,0x37
 .db    0x73,0xA2
 .db    0x77,0x63
 .db    0x62,0x23
 .db    0x23,0x23
 .db    0x63,0xD1
 .db    0x16,0x16
 .db    0x3B,0xD1
 .db    0x7B,0x7B
 .db    0xD1,0xBB
 .db    0x33,0x33
 .db    0x7B,0x92
 .db    0x92,0xA6
 .db    0x7B,0x1A
 .db    0x1A,0x80
 .db    0x81,0x81
 .db    0x81,0x81
 .db    0x81,0x45
 .db    0x41,0x16
 .db    0x41,0x80
 .db    0x81,0x2A
 .db    0x2A,0x3F
 .db    0xBB,0xBF
 .db    0xFA,0xFA
 .db    0x7B,0xF6
 .db    0xF6,0xF6
 .db    0x63,0xB2
 .db    0xF6,0x63
 .db    0xB2,0xFA
 .db    0xD6,0xBB
 .db    0x67,0x92
 .db    0xFA,0x63
 .db    0x63,0xA2
 .db    0xA2,0xA2
 .db    0x63,0x67
 .db    0x67,0x63
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x13,0x43
 .db    0x43,0x53
 .db    0x53,0x82
 .db    0x42,0x42
 .db    0x82,0x13
 .db    0x53,0x13
 .db    0x53,0x52
 .db    0x82,0x53
 .db    0x53,0x82
 .db    0x27,0xA6
 .db    0xA6,0x6B
 .db    0x53,0x53
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x27,0x13
 .db    0x12,0x52
 .db    0x91,0x91
 .db    0x27,0x27
 .db    0x52,0x27
 .db    0x23,0x23
 .db    0x23,0x23
 .db    0x62,0x33
 .db    0x62,0x62
 .db    0x33,0x62
 .db    0x62,0x37
 .db    0x63,0x92
 .db    0x63,0x62
 .db    0x62,0x23
 .db    0x23,0x23
 .db    0x27,0xD1
 .db    0xD1,0xC1
 .db    0x6B,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0x7B
 .db    0x33,0x63
 .db    0x92,0x52
 .db    0x67,0xD1
 .db    0x7B,0x1A
 .db    0x1A,0x80
 .db    0x80,0x1A
 .db    0x1A,0x1A
 .db    0x1A,0x16
 .db    0x41,0x15
 .db    0x41,0x80
 .db    0x81,0x81
 .db    0x2A,0x80
 .db    0xD1,0x7B
 .db    0xBB,0xFA
 .db    0xFA,0xFA
 .db    0xF6,0xFA
 .db    0x67,0xBB
 .db    0xFA,0x63
 .db    0x77,0xFA
 .db    0xFA,0xFA
 .db    0xD1,0x67
 .db    0xF6,0x7B
 .db    0x77,0x77
 .db    0x77,0x77
 .db    0x73,0xA3
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x13,0x43
 .db    0x53,0x53
 .db    0x53,0x82
 .db    0x42,0x41
 .db    0x86,0x13
 .db    0x53,0x13
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x27,0x96
 .db    0xA6,0x7B
 .db    0x27,0x53
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x42,0x52
 .db    0x27,0x42
 .db    0x52,0x67
 .db    0x92,0x37
 .db    0x62,0x62
 .db    0x27,0x52
 .db    0x23,0x52
 .db    0x62,0x62
 .db    0x62,0x62
 .db    0x62,0x37
 .db    0x62,0x63
 .db    0x63,0x27
 .db    0x23,0x23
 .db    0x23,0x23
 .db    0x23,0x23
 .db    0x23,0xA2
 .db    0x7B,0xE1
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x37
 .db    0x33,0xA2
 .db    0x52,0x52
 .db    0x92,0x7B
 .db    0xAA,0x1A
 .db    0x55,0x80
 .db    0x1A,0x45
 .db    0x16,0x16
 .db    0x16,0x16
 .db    0x15,0x15
 .db    0x16,0x1A
 .db    0x2A,0x2A
 .db    0x80,0x56
 .db    0xA2,0xD1
 .db    0xA6,0x7F
 .db    0xE6,0xEA
 .db    0xFA,0xFA
 .db    0xEA,0xFA
 .db    0xFA,0xE6
 .db    0xBB,0xFE
 .db    0xFE,0xFE
 .db    0xFA,0xE6
 .db    0xFA,0xD1
 .db    0x77,0x77
 .db    0x77,0x77
 .db    0x77,0xA2
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x57
 .db    0x42,0x17
 .db    0x6B,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x27
 .db    0xC1,0x7B
 .db    0x52,0x13
 .db    0x63,0x53
 .db    0x63,0x63
 .db    0x67,0x92
 .db    0x52,0x7B
 .db    0x7F,0x2B
 .db    0x52,0x92
 .db    0xD1,0x67
 .db    0x37,0x37
 .db    0x62,0x27
 .db    0x27,0x52
 .db    0x27,0x27
 .db    0x62,0x62
 .db    0x37,0x92
 .db    0x62,0x63
 .db    0x23,0x63
 .db    0x23,0x23
 .db    0x63,0x23
 .db    0x23,0x62
 .db    0x23,0xA2
 .db    0xA2,0x77
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0xE6,0x73
 .db    0x63,0xA7
 .db    0x12,0x27
 .db    0x92,0x7B
 .db    0x7F,0x1A
 .db    0x2A,0x1A
 .db    0x45,0x16
 .db    0x16,0x15
 .db    0x15,0x16
 .db    0x41,0x41
 .db    0x16,0x1A
 .db    0x80,0x80
 .db    0x80,0x3B
 .db    0xA2,0xD1
 .db    0x7B,0xA6
 .db    0x7B,0x7F
 .db    0x7F,0xE6
 .db    0xBB,0xEA
 .db    0xEA,0xEA
 .db    0xEA,0xFA
 .db    0xFA,0xBF
 .db    0xEA,0xBF
 .db    0xEA,0xB2
 .db    0xB2,0x77
 .db    0x77,0xA2
 .db    0x77,0x63
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x82,0x57
 .db    0x42,0x27
 .db    0xC2,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x82
 .db    0x67,0x67
 .db    0x13,0x13
 .db    0x7B,0x7B
 .db    0xE6,0x63
 .db    0xA2,0x7B
 .db    0x27,0xEA
 .db    0xEA,0xA6
 .db    0x27,0x27
 .db    0x7F,0xD1
 .db    0x27,0x92
 .db    0x92,0x37
 .db    0x37,0x27
 .db    0x27,0x37
 .db    0x37,0x92
 .db    0x92,0x27
 .db    0x23,0x27
 .db    0x27,0x62
 .db    0x23,0x23
 .db    0x63,0x62
 .db    0x63,0x63
 .db    0x63,0xA2
 .db    0xD1,0x77
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x73
 .db    0x63,0x7B
 .db    0x12,0x2B
 .db    0x92,0xAA
 .db    0x7F,0x2A
 .db    0x1A,0x45
 .db    0x41,0x16
 .db    0x41,0x15
 .db    0x15,0x45
 .db    0x45,0x16
 .db    0x41,0x16
 .db    0x45,0x1A
 .db    0x45,0xC1
 .db    0xA2,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0x7F
 .db    0xA6,0xC1
 .db    0x67,0x67
 .db    0x92,0x92
 .db    0x92,0x7B
 .db    0xD5,0x7B
 .db    0xAB,0xBB
 .db    0xD6,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xA2
 .db    0xA2,0x63
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x63,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x63,0x53
 .db    0x92,0xC1
 .db    0x52,0x53
 .db    0x93,0x63
 .db    0x92,0x53
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x53,0x63
 .db    0x92,0x67
 .db    0x67,0x92
 .db    0x52,0x27
 .db    0x7B,0xBB
 .db    0xBB,0x53
 .db    0x92,0xE6
 .db    0x27,0xEA
 .db    0xFA,0xBB
 .db    0x27,0x27
 .db    0xEA,0xBA
 .db    0x6B,0x92
 .db    0x63,0x92
 .db    0x67,0x67
 .db    0x92,0x92
 .db    0x92,0x92
 .db    0x37,0x23
 .db    0x23,0x23
 .db    0x23,0x63
 .db    0x23,0x62
 .db    0x63,0x73
 .db    0x77,0xA2
 .db    0x73,0x7B
 .db    0x7F,0x77
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x77,0x73
 .db    0xA6,0xC1
 .db    0x12,0x92
 .db    0x92,0xD5
 .db    0x7F,0x2A
 .db    0x1A,0x15
 .db    0x40,0x15
 .db    0x16,0x15
 .db    0x45,0x80
 .db    0x1A,0x45
 .db    0x16,0x41
 .db    0x16,0x16
 .db    0x16,0xA2
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7F
 .db    0xD1,0xC1
 .db    0x92,0x92
 .db    0x92,0x27
 .db    0x92,0xD1
 .db    0x7B,0x6B
 .db    0xD6,0xAB
 .db    0xE6,0xB6
 .db    0xB2,0xB2
 .db    0xB2,0xA2
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x53,0x63
 .db    0x63,0x63
 .db    0x63,0x53
 .db    0x67,0x93
 .db    0x53,0x53
 .db    0x63,0x93
 .db    0xA3,0x93
 .db    0x53,0x53
 .db    0x63,0x63
 .db    0x93,0x93
 .db    0x93,0x93
 .db    0xD2,0x67
 .db    0x52,0x27
 .db    0x77,0xB6
 .db    0xA2,0x27
 .db    0x92,0xB6
 .db    0x27,0x7B
 .db    0xEA,0xFA
 .db    0x92,0x82
 .db    0xEA,0xE6
 .db    0xE6,0x7F
 .db    0x92,0x92
 .db    0xD1,0x67
 .db    0xD1,0x67
 .db    0x92,0x52
 .db    0x92,0x23
 .db    0x23,0x23
 .db    0x23,0x23
 .db    0x62,0x63
 .db    0x73,0x73
 .db    0xB2,0x73
 .db    0x73,0x77
 .db    0xBB,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0xA2,0x73
 .db    0xD6,0x92
 .db    0x52,0x27
 .db    0x67,0x7B
 .db    0x7F,0x1A
 .db    0x41,0x40
 .db    0x40,0x41
 .db    0x45,0x45
 .db    0x1A,0x81
 .db    0x55,0x1A
 .db    0x16,0x16
 .db    0x45,0x16
 .db    0x2B,0xA2
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0xC1
 .db    0x92,0x92
 .db    0x92,0x27
 .db    0x67,0x7B
 .db    0xD5,0x6B
 .db    0x7B,0xD6
 .db    0xBB,0xB6
 .db    0xB2,0xB2
 .db    0x77,0x73
 .db    0x63,0x63
 .db    0x63,0x73
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x93,0x93
 .db    0x53,0x63
 .db    0x93,0x93
 .db    0xA3,0xA3
 .db    0x93,0x93
 .db    0x93,0x93
 .db    0x93,0x93
 .db    0xA3,0xA3
 .db    0xA3,0x77
 .db    0x53,0x52
 .db    0x27,0x67
 .db    0x27,0x52
 .db    0x67,0xA2
 .db    0x23,0x67
 .db    0x67,0xFA
 .db    0xE5,0xD1
 .db    0xEA,0x92
 .db    0xD1,0xBB
 .db    0x77,0x7B
 .db    0x7B,0xD1
 .db    0xD1,0x67
 .db    0x37,0x12
 .db    0x63,0x27
 .db    0x23,0x23
 .db    0x23,0x23
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xBB,0xD1
 .db    0x7B,0xAA
 .db    0x7B,0x7B
 .db    0x7B,0xA2
 .db    0xE6,0x92
 .db    0x63,0x27
 .db    0x67,0x7B
 .db    0x7B,0x1A
 .db    0x41,0x40
 .db    0x40,0x45
 .db    0x1A,0x1A
 .db    0x1A,0x1A
 .db    0x81,0x1A
 .db    0x45,0x1A
 .db    0x1A,0x16
 .db    0xC1,0xA2
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0xD1
 .db    0x67,0x67
 .db    0x91,0x27
 .db    0xD1,0x7B
 .db    0x7F,0x6B
 .db    0x6B,0x6B
 .db    0xAB,0xE2
 .db    0xB2,0xB2
 .db    0x73,0x63
 .db    0x63,0xA2
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x93,0x63
 .db    0x93,0x92
 .db    0x53,0x93
 .db    0x93,0x93
 .db    0xA3,0xA3
 .db    0x93,0x93
 .db    0xA3,0xA3
 .db    0x93,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0x67,0x52
 .db    0x52,0x27
 .db    0x23,0x13
 .db    0xA2,0x92
 .db    0x12,0x63
 .db    0x27,0xBB
 .db    0xFA,0xEA
 .db    0xBB,0x92
 .db    0x27,0xA7
 .db    0x63,0x7B
 .db    0xEA,0xD1
 .db    0x7F,0xD1
 .db    0x92,0x52
 .db    0x63,0x27
 .db    0x23,0x23
 .db    0x23,0x27
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0x73
 .db    0x73,0xB2
 .db    0xEA,0x7B
 .db    0x7F,0x7F
 .db    0x7B,0x7B
 .db    0xB2,0xB7
 .db    0xD6,0x92
 .db    0x27,0x27
 .db    0xC1,0xD1
 .db    0x6B,0x1A
 .db    0x45,0x41
 .db    0x41,0x80
 .db    0x2A,0x1A
 .db    0x1A,0x1A
 .db    0x81,0x1A
 .db    0x45,0x1A
 .db    0x1A,0x16
 .db    0x67,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0xD1
 .db    0x7B,0x7B
 .db    0xD1,0x96
 .db    0x67,0x92
 .db    0x2B,0x2B
 .db    0x7B,0x7B
 .db    0x7F,0x6B
 .db    0xC1,0xC1
 .db    0xD6,0xE2
 .db    0xB2,0xB2
 .db    0x63,0x63
 .db    0x77,0xA3
 .db    0x73,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x93
 .db    0x93,0x63
 .db    0x63,0x63
 .db    0x53,0x93
 .db    0x63,0x93
 .db    0xA3,0xA3
 .db    0x93,0xA3
 .db    0xA3,0xA3
 .db    0x93,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0x53
 .db    0x27,0x52
 .db    0x52,0x52
 .db    0x67,0x91
 .db    0x13,0x63
 .db    0x27,0x7F
 .db    0xFA,0xE6
 .db    0x67,0x92
 .db    0x27,0x77
 .db    0x92,0x67
 .db    0xEA,0x27
 .db    0x7B,0xE6
 .db    0x7B,0xA2
 .db    0x77,0x77
 .db    0x92,0x62
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xEA,0x7F
 .db    0x7F,0x7F
 .db    0xAA,0x7B
 .db    0xA2,0xFA
 .db    0x7B,0x63
 .db    0x52,0x52
 .db    0x6B,0x6B
 .db    0x6B,0x81
 .db    0x80,0x1A
 .db    0x45,0x2A
 .db    0x2A,0x1A
 .db    0x81,0x81
 .db    0x81,0x1A
 .db    0x1A,0x1A
 .db    0x16,0x80
 .db    0x67,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0xA6
 .db    0x7B,0x7B
 .db    0xD1,0xC1
 .db    0x92,0x92
 .db    0x2B,0x92
 .db    0x7B,0x7F
 .db    0x7F,0x7B
 .db    0xC1,0xC1
 .db    0x7B,0x7B
 .db    0xB2,0xB2
 .db    0x73,0x77
 .db    0x77,0xA3
 .db    0xA3,0x73
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x93
 .db    0x93,0x93
 .db    0x93,0x63
 .db    0x63,0x63
 .db    0x53,0x93
 .db    0x63,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0x73
 .db    0xA3,0xA2
 .db    0x53,0x27
 .db    0x52,0x27
 .db    0x92,0x27
 .db    0x52,0x37
 .db    0x27,0xD1
 .db    0xFA,0xE6
 .db    0x53,0x7B
 .db    0x92,0xA6
 .db    0x92,0x53
 .db    0xE6,0x52
 .db    0x2B,0xBB
 .db    0xE1,0xB6
 .db    0xA2,0xB6
 .db    0xB6,0xA2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0x73,0xB2
 .db    0xEA,0x7F
 .db    0x7F,0x7F
 .db    0x7F,0x7B
 .db    0x77,0xFA
 .db    0xD1,0x92
 .db    0x52,0x52
 .db    0x6B,0xC1
 .db    0x6B,0x81
 .db    0x2A,0x2A
 .db    0x2A,0x2A
 .db    0x80,0x1A
 .db    0x81,0x81
 .db    0x81,0x1A
 .db    0x45,0x16
 .db    0x41,0x67
 .db    0xA2,0xD1
 .db    0x7B,0x7B
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0xC1
 .db    0x92,0x92
 .db    0x2B,0xD1
 .db    0x7B,0xAB
 .db    0x7F,0xD5
 .db    0xC1,0xC1
 .db    0x6B,0xD1
 .db    0xB2,0xB2
 .db    0x77,0xB3
 .db    0xB3,0xA3
 .db    0x73,0x63
 .db    0x63,0x63
 .db    0x63,0x93
 .db    0x93,0x63
 .db    0x63,0x63
 .db    0x63,0x63
 .db    0x63,0x67
 .db    0x92,0x93
 .db    0x63,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0x73
 .db    0x73,0x77
 .db    0x63,0x53
 .db    0x27,0x27
 .db    0x63,0x12
 .db    0x12,0x52
 .db    0x92,0x53
 .db    0x77,0xE6
 .db    0x92,0xA7
 .db    0x7B,0xBB
 .db    0x7B,0x92
 .db    0xE6,0x53
 .db    0x92,0xB7
 .db    0x63,0x77
 .db    0x53,0x77
 .db    0xE6,0xB2
 .db    0x73,0xB2
 .db    0x73,0x73
 .db    0x77,0x73
 .db    0xA2,0xB2
 .db    0x73,0xB2
 .db    0xFA,0x7F
 .db    0x7F,0x7F
 .db    0xAA,0xA2
 .db    0xBB,0xFA
 .db    0x66,0x92
 .db    0x2B,0x2B
 .db    0xC1,0xC1
 .db    0xC1,0x80
 .db    0x55,0x2A
 .db    0x2A,0x80
 .db    0x1A,0x45
 .db    0x81,0x2B
 .db    0x2A,0x1A
 .db    0x16,0x41
 .db    0x41,0x67
 .db    0xA2,0xD1
 .db    0x7B,0x7B
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0x67
 .db    0x92,0x92
 .db    0x2B,0x7B
 .db    0x7F,0xE6
 .db    0xAA,0xD5
 .db    0xC1,0xC1
 .db    0x6B,0x6B
 .db    0xB2,0xB2
 .db    0xB2,0xB3
 .db    0xB3,0x73
 .db    0x73,0x63
 .db    0x63,0x73
 .db    0x73,0xA3
 .db    0xA3,0x63
 .db    0x63,0x93
 .db    0x93,0x63
 .db    0x63,0x67
 .db    0x92,0x63
 .db    0x63,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0x77
 .db    0x77,0x63
 .db    0x27,0x27
 .db    0x63,0x12
 .db    0x12,0x27
 .db    0x63,0x27
 .db    0x63,0xE6
 .db    0x92,0x63
 .db    0x77,0xE6
 .db    0xBB,0xE5
 .db    0xBB,0x92
 .db    0x6B,0xE6
 .db    0x53,0x53
 .db    0x53,0x63
 .db    0xD1,0xB6
 .db    0xB2,0xB2
 .db    0x73,0x73
 .db    0x73,0x77
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xEA,0x7F
 .db    0x7F,0x7F
 .db    0x7B,0xA2
 .db    0xFA,0xEA
 .db    0x27,0x92
 .db    0x92,0x92
 .db    0x6B,0xC1
 .db    0xC1,0x45
 .db    0x1A,0x80
 .db    0x80,0x1A
 .db    0x16,0x16
 .db    0x2A,0x81
 .db    0x1A,0x45
 .db    0x41,0x41
 .db    0x81,0x67
 .db    0x77,0xA6
 .db    0x7B,0xA6
 .db    0xA6,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0x67
 .db    0x92,0x92
 .db    0x91,0x7B
 .db    0xD6,0xE6
 .db    0xD5,0xD5
 .db    0x6B,0xC1
 .db    0xC1,0x6B
 .db    0xA2,0xB2
 .db    0xB2,0xB2
 .db    0x73,0x73
 .db    0x63,0x73
 .db    0x73,0x73
 .db    0xA3,0x73
 .db    0x63,0x63
 .db    0x63,0xA3
 .db    0x93,0x63
 .db    0x93,0x63
 .db    0x92,0x63
 .db    0x93,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xE2,0xA3
 .db    0xA3,0x73
 .db    0xA3,0x77
 .db    0x77,0xA2
 .db    0x63,0x62
 .db    0x63,0x12
 .db    0x27,0x92
 .db    0x92,0x27
 .db    0x63,0xE6
 .db    0x37,0x53
 .db    0x63,0xE2
 .db    0xA2,0x67
 .db    0xBB,0xBB
 .db    0x7B,0xBB
 .db    0x67,0x53
 .db    0x77,0x63
 .db    0x53,0xE2
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0x73,0x77
 .db    0xB2,0xE2
 .db    0xEA,0xAA
 .db    0x7F,0x7F
 .db    0x7B,0x73
 .db    0xFA,0x7B
 .db    0x27,0x53
 .db    0x92,0x92
 .db    0x7B,0x96
 .db    0x67,0x16
 .db    0x16,0x45
 .db    0x45,0x45
 .db    0x15,0x16
 .db    0x80,0x80
 .db    0x1A,0x16
 .db    0x15,0x41
 .db    0xC1,0xA2
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0x7B
 .db    0x7F,0x7B
 .db    0xD1,0x67
 .db    0x92,0x66
 .db    0x92,0x7B
 .db    0xE6,0xAB
 .db    0xD5,0xD5
 .db    0xA6,0xC1
 .db    0xC1,0x6B
 .db    0x3B,0xB2
 .db    0xB3,0xB2
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0x73,0xA2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xA3,0xA3
 .db    0x63,0x63
 .db    0x93,0x53
 .db    0x63,0x63
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xB3
 .db    0xA3,0xA3
 .db    0xA3,0x73
 .db    0x73,0x73
 .db    0x77,0xB2
 .db    0x63,0x62
 .db    0x92,0x2B
 .db    0x3B,0x3B
 .db    0xA2,0x27
 .db    0x63,0xE6
 .db    0x92,0x53
 .db    0x53,0xBB
 .db    0x63,0x53
 .db    0xE6,0xF6
 .db    0x63,0x77
 .db    0xE6,0x7B
 .db    0xB6,0x63
 .db    0x53,0xE2
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0x73,0xA2
 .db    0xB2,0xB6
 .db    0xEA,0xAA
 .db    0x7F,0x7F
 .db    0xA6,0xA2
 .db    0xFA,0xD1
 .db    0x27,0x27
 .db    0x27,0x27
 .db    0xD6,0xD5
 .db    0xD1,0x16
 .db    0x41,0x16
 .db    0x16,0x16
 .db    0x41,0x45
 .db    0x45,0x16
 .db    0x80,0x45
 .db    0x15,0x41
 .db    0xD1,0xA2
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0x7B
 .db    0x7F,0x7B
 .db    0xD1,0x67
 .db    0x92,0x91
 .db    0x92,0xD6
 .db    0xE6,0x7F
 .db    0xAA,0xD5
 .db    0x7B,0xC1
 .db    0xC1,0x6B
 .db    0x2B,0x77
 .db    0xB2,0xB2
 .db    0xB2,0x73
 .db    0xA2,0xA2
 .db    0x73,0xA2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xA3,0xA3
 .db    0x63,0x63
 .db    0x93,0x53
 .db    0x63,0x63
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xB3
 .db    0x73,0x73
 .db    0xB2,0x73
 .db    0xB2,0xB2
 .db    0x77,0x63
 .db    0x26,0xC0
 .db    0x3F,0x91
 .db    0x7B,0x92
 .db    0x53,0xE6
 .db    0x7B,0x63
 .db    0xD1,0xBB
 .db    0x63,0x53
 .db    0xB7,0xE6
 .db    0x53,0x63
 .db    0xB6,0xB6
 .db    0xB2,0x63
 .db    0x53,0xB2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x77,0xE6
 .db    0xBF,0xAA
 .db    0x7F,0x7F
 .db    0xA2,0xE2
 .db    0xFA,0xD1
 .db    0x27,0x52
 .db    0x52,0x81
 .db    0xE6,0x7F
 .db    0x7F,0x16
 .db    0x15,0x16
 .db    0x41,0x41
 .db    0x16,0x45
 .db    0x15,0x15
 .db    0x45,0x16
 .db    0x15,0x16
 .db    0xA2,0xD1
 .db    0xA6,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0x7B
 .db    0x7F,0x7B
 .db    0xD1,0x67
 .db    0x92,0x91
 .db    0x92,0xE6
 .db    0xE6,0x7F
 .db    0x7F,0xD5
 .db    0xD5,0x6B
 .db    0xC1,0x6B
 .db    0xC1,0x3B
 .db    0xB2,0xB2
 .db    0xB2,0xA2
 .db    0x73,0xA2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0xA3,0xA3
 .db    0x63,0x63
 .db    0x63,0x53
 .db    0x93,0x93
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x77
 .db    0x40,0x15
 .db    0x2B,0x91
 .db    0xD1,0x7F
 .db    0x7B,0xE6
 .db    0xF6,0xE5
 .db    0xBB,0xB6
 .db    0x63,0x53
 .db    0xE2,0xA2
 .db    0x63,0x63
 .db    0xA2,0xB2
 .db    0x63,0x63
 .db    0x77,0xA2
 .db    0x63,0x77
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xE6,0xFA
 .db    0xBB,0x7F
 .db    0x7F,0x7F
 .db    0x73,0xBB
 .db    0xEA,0x67
 .db    0x27,0x52
 .db    0x42,0x81
 .db    0xBB,0x7F
 .db    0xD5,0x16
 .db    0x15,0x41
 .db    0x15,0x41
 .db    0x16,0x45
 .db    0x15,0x15
 .db    0x16,0x16
 .db    0x16,0x2B
 .db    0xA2,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0xD1
 .db    0xA6,0x7B
 .db    0x7B,0x7B
 .db    0x6B,0x67
 .db    0x66,0x91
 .db    0x67,0xE6
 .db    0xD6,0xD5
 .db    0x7F,0xD5
 .db    0xD5,0xD5
 .db    0xC1,0x6B
 .db    0x96,0x91
 .db    0x77,0xB2
 .db    0xB2,0xA2
 .db    0x73,0x77
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0x73,0xA3
 .db    0xA3,0xA3
 .db    0x63,0x63
 .db    0x63,0x53
 .db    0x63,0x93
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xB3
 .db    0xA3,0x73
 .db    0xA3,0x73
 .db    0x73,0x73
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x77
 .db    0x15,0x40
 .db    0x15,0x80
 .db    0x3F,0xD5
 .db    0xEA,0xB6
 .db    0xE6,0xF6
 .db    0xE1,0xA2
 .db    0x77,0x63
 .db    0xB7,0x63
 .db    0x63,0x63
 .db    0x63,0x73
 .db    0x63,0x53
 .db    0xB2,0xB2
 .db    0x63,0x73
 .db    0xB2,0xB2
 .db    0x73,0x73
 .db    0x73,0xE1
 .db    0xBF,0xFA
 .db    0xE5,0x7F
 .db    0x7F,0x7B
 .db    0x73,0xBF
 .db    0x7F,0x67
 .db    0x27,0x52
 .db    0x16,0x2B
 .db    0xBB,0xD6
 .db    0x6B,0x45
 .db    0x41,0x41
 .db    0x15,0x41
 .db    0x45,0x45
 .db    0x15,0x15
 .db    0x15,0x45
 .db    0x80,0xC1
 .db    0xA2,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0xC1,0x67
 .db    0x91,0x2B
 .db    0xC1,0xE6
 .db    0x7F,0xD5
 .db    0x7F,0xD5
 .db    0xD5,0x7F
 .db    0x6B,0x6B
 .db    0x6B,0x2B
 .db    0x67,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xA2
 .db    0x73,0x77
 .db    0x73,0xA3
 .db    0x73,0xA3
 .db    0xA3,0xA3
 .db    0x73,0xA3
 .db    0x63,0x53
 .db    0x63,0x63
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0x73
 .db    0xA3,0x73
 .db    0x73,0x77
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x26
 .db    0x41,0x40
 .db    0x40,0x40
 .db    0x15,0xC0
 .db    0xD5,0xD5
 .db    0xE5,0xE1
 .db    0x63,0x63
 .db    0xA2,0xE1
 .db    0xA2,0x63
 .db    0x63,0x77
 .db    0x53,0x53
 .db    0x53,0x53
 .db    0x77,0xB2
 .db    0x63,0x73
 .db    0xB2,0xB2
 .db    0x73,0x73
 .db    0xE1,0xBB
 .db    0xFA,0xBB
 .db    0x7F,0x7F
 .db    0x7F,0xD1
 .db    0x77,0xFA
 .db    0xD1,0x67
 .db    0x27,0x52
 .db    0x16,0xC1
 .db    0xEA,0xE6
 .db    0x6B,0x45
 .db    0x41,0x15
 .db    0x15,0x41
 .db    0x45,0x45
 .db    0x41,0x15
 .db    0x15,0x1A
 .db    0x81,0xD1
 .db    0x77,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0xA6
 .db    0x7B,0x7B
 .db    0x7B,0xD1
 .db    0xC1,0x92
 .db    0x2B,0x27
 .db    0x6B,0xE6
 .db    0x7F,0xD5
 .db    0x7F,0xD5
 .db    0xD5,0x7F
 .db    0xD1,0x6B
 .db    0xD1,0x81
 .db    0x3B,0x77
 .db    0xB2,0xB2
 .db    0xB2,0xA2
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0xA3,0xA3
 .db    0x73,0xA3
 .db    0x63,0x63
 .db    0x93,0x93
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xA3
 .db    0xB3,0x73
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x15
 .db    0x16,0x40
 .db    0x40,0x15
 .db    0x40,0x15
 .db    0x16,0xC0
 .db    0xD5,0xE1
 .db    0x63,0x63
 .db    0x63,0x77
 .db    0x63,0x63
 .db    0x67,0xB6
 .db    0x53,0x53
 .db    0x67,0xA2
 .db    0x77,0x63
 .db    0x63,0x27
 .db    0x63,0x73
 .db    0x73,0xE1
 .db    0xBB,0xFA
 .db    0xEA,0xD5
 .db    0x7B,0xAA
 .db    0x7F,0x67
 .db    0xB2,0xFA
 .db    0xD1,0x67
 .db    0x27,0x52
 .db    0x41,0x96
 .db    0xEA,0xE6
 .db    0x6B,0x16
 .db    0x41,0x41
 .db    0x41,0x16
 .db    0x1A,0x1A
 .db    0x16,0x15
 .db    0x15,0x80
 .db    0x2B,0xD1
 .db    0xD1,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0xA6
 .db    0x7B,0x7B
 .db    0x7B,0xD1
 .db    0xC1,0x91
 .db    0x2B,0x27
 .db    0x7B,0xE6
 .db    0x7F,0xAA
 .db    0x7F,0xD5
 .db    0xD5,0xD6
 .db    0x7B,0xD1
 .db    0x7B,0x2A
 .db    0x81,0xD1
 .db    0xB2,0xB2
 .db    0xB2,0x77
 .db    0xA2,0x73
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0xA3,0xA3
 .db    0x73,0xA3
 .db    0x63,0x63
 .db    0x93,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0x26,0x40
 .db    0x45,0x15
 .db    0x40,0x15
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x55,0x7F
 .db    0x7F,0x7B
 .db    0x67,0x92
 .db    0xA2,0x63
 .db    0xE6,0xB6
 .db    0x63,0x63
 .db    0xE1,0xA2
 .db    0x63,0x27
 .db    0x53,0x27
 .db    0x63,0x7B
 .db    0x7B,0xE6
 .db    0xEA,0xEA
 .db    0x7B,0x7B
 .db    0x7B,0x7F
 .db    0x7F,0xA2
 .db    0xE6,0xBF
 .db    0x6B,0x92
 .db    0x27,0x52
 .db    0x41,0x6F
 .db    0xBB,0xE6
 .db    0x6B,0x41
 .db    0x41,0x16
 .db    0x1A,0x1A
 .db    0x1A,0x1A
 .db    0x16,0x15
 .db    0x41,0x81
 .db    0x2B,0xD1
 .db    0xD1,0xA6
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0xD1
 .db    0xC1,0x66
 .db    0x2B,0x2B
 .db    0xD6,0xD6
 .db    0xD5,0xAA
 .db    0x7F,0xD5
 .db    0xD5,0x7F
 .db    0x7F,0x7B
 .db    0x7B,0x56
 .db    0x45,0x6B
 .db    0x77,0xB2
 .db    0xB2,0x77
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0xA3,0xA3
 .db    0x73,0xA3
 .db    0x63,0x63
 .db    0x93,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB2
 .db    0xB3,0xB2
 .db    0xB2,0x62
 .db    0x40,0x40
 .db    0x80,0x16
 .db    0x15,0x41
 .db    0x45,0x45
 .db    0x15,0x15
 .db    0x40,0x15
 .db    0x7A,0xBF
 .db    0xBF,0xE6
 .db    0xBB,0xD1
 .db    0xEA,0xFA
 .db    0x7B,0x7B
 .db    0xE1,0x63
 .db    0x53,0x53
 .db    0x53,0xD1
 .db    0x7B,0xEA
 .db    0xEA,0xEA
 .db    0xBA,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0x7F
 .db    0x7B,0xA2
 .db    0xBB,0x7B
 .db    0xC1,0x92
 .db    0x27,0x52
 .db    0x16,0xD5
 .db    0xE6,0xBB
 .db    0xC1,0x41
 .db    0x41,0x1A
 .db    0x1A,0x1A
 .db    0x1A,0x1A
 .db    0x16,0x15
 .db    0x16,0x80
 .db    0x2B,0xD1
 .db    0xD1,0x7B
 .db    0x7B,0x7F
 .db    0x7B,0x7B
 .db    0xA6,0x7B
 .db    0x7B,0xD1
 .db    0x96,0x3B
 .db    0x2B,0x2B
 .db    0xD6,0x7F
 .db    0x7B,0xD5
 .db    0x7F,0xD5
 .db    0xD5,0x7F
 .db    0xD6,0x7B
 .db    0xA6,0x85
 .db    0x15,0xC0
 .db    0xD1,0xB2
 .db    0xB2,0xB2
 .db    0x77,0x73
 .db    0x77,0x73
 .db    0x73,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0x63,0x63
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xB3,0xB3
 .db    0xB3,0xB2
 .db    0xB2,0xB3
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0xE2,0xB2
 .db    0x72,0x11
 .db    0x40,0x40
 .db    0x80,0x1A
 .db    0x41,0x41
 .db    0x45,0x1A
 .db    0x16,0x15
 .db    0x15,0x40
 .db    0x40,0x3A
 .db    0x7F,0xBF
 .db    0xFA,0xBF
 .db    0xFA,0xFA
 .db    0xFA,0xEA
 .db    0xE6,0x92
 .db    0x67,0x67
 .db    0xD1,0xE6
 .db    0xEA,0xBA
 .db    0x7F,0xD1
 .db    0xD1,0xA2
 .db    0x7B,0x7B
 .db    0x7B,0x7F
 .db    0xD1,0x73
 .db    0xFA,0xD1
 .db    0xC1,0x92
 .db    0x27,0x52
 .db    0x52,0x7F
 .db    0xE6,0xBB
 .db    0xC1,0x16
 .db    0x45,0x1A
 .db    0x81,0x81
 .db    0x55,0x1A
 .db    0x16,0x16
 .db    0x45,0x80
 .db    0x2B,0xD1
 .db    0xD1,0x7B
 .db    0x7B,0xD6
 .db    0x7B,0x7B
 .db    0xA6,0x7B
 .db    0x7B,0x7B
 .db    0x6B,0x66
 .db    0x91,0x56
 .db    0xAB,0xAA
 .db    0xD5,0xAA
 .db    0x7F,0x7B
 .db    0xD5,0x7F
 .db    0xAB,0xD5
 .db    0xD1,0x6A
 .db    0x40,0x55
 .db    0x3B,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x73
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0xA3,0x73
 .db    0xA3,0xA3
 .db    0x63,0x93
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB2
 .db    0xB2,0xB3
 .db    0x73,0xB2
 .db    0xB2,0xB3
 .db    0xB2,0xB2
 .db    0x11,0x01
 .db    0x40,0x40
 .db    0x80,0x1A
 .db    0x16,0x15
 .db    0x16,0x45
 .db    0x45,0x15
 .db    0x15,0x40
 .db    0x05,0x15
 .db    0x45,0xD4
 .db    0xE9,0xBF
 .db    0xBF,0xBF
 .db    0xFA,0xFA
 .db    0xFA,0xE6
 .db    0xEA,0xEA
 .db    0xEA,0xBA
 .db    0xC0,0x91
 .db    0x92,0x37
 .db    0xD1,0xA2
 .db    0x7B,0x7B
 .db    0x7B,0x7F
 .db    0x77,0xA2
 .db    0xFA,0xD1
 .db    0x67,0x91
 .db    0x27,0x52
 .db    0x52,0xAA
 .db    0xBB,0xE6
 .db    0xC1,0x45
 .db    0x1A,0x1A
 .db    0x1A,0x1A
 .db    0x80,0x1A
 .db    0x45,0x45
 .db    0x45,0x1A
 .db    0x2B,0x67
 .db    0x7B,0x7B
 .db    0xD6,0x7F
 .db    0x7B,0x7B
 .db    0xD1,0x7B
 .db    0x7B,0xA6
 .db    0x6B,0x91
 .db    0x2B,0x27
 .db    0xD6,0xAA
 .db    0xD5,0x7F
 .db    0x7F,0x7B
 .db    0xD5,0x7F
 .db    0xAB,0x7F
 .db    0xD1,0x3F
 .db    0x40,0x15
 .db    0x2B,0x77
 .db    0xB2,0xB2
 .db    0xB2,0x77
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0xA3,0x73
 .db    0xA3,0xA3
 .db    0x63,0x93
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xB3
 .db    0xB3,0xB3
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0x73,0xB2
 .db    0xB3,0xB3
 .db    0xB2,0x26
 .db    0x00,0x00
 .db    0x40,0x40
 .db    0x1A,0x1A
 .db    0x16,0x15
 .db    0x15,0x16
 .db    0x15,0x15
 .db    0x15,0x40
 .db    0x40,0x15
 .db    0x45,0x2E
 .db    0xC4,0x6E
 .db    0x7E,0x7F
 .db    0xE9,0xEA
 .db    0xBE,0xBE
 .db    0xBE,0xBA
 .db    0xD0,0x80
 .db    0x15,0x81
 .db    0x37,0x37
 .db    0xD1,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x73,0x77
 .db    0xBF,0xD1
 .db    0x67,0x91
 .db    0x27,0x52
 .db    0x52,0x6B
 .db    0xBB,0xE6
 .db    0x3B,0x45
 .db    0x1A,0x1A
 .db    0x45,0x1A
 .db    0x1A,0x1A
 .db    0x80,0x1A
 .db    0x45,0x1A
 .db    0xC1,0x92
 .db    0x7B,0xD6
 .db    0x7F,0x7B
 .db    0xA6,0xD1
 .db    0xD1,0x7B
 .db    0x7B,0xA6
 .db    0x6B,0x91
 .db    0x2B,0x27
 .db    0xD6,0x7F
 .db    0xD5,0x7F
 .db    0xAA,0x7B
 .db    0xD5,0x7F
 .db    0xAB,0x7F
 .db    0xA6,0x3F
 .db    0x40,0x40
 .db    0x2B,0xD1
 .db    0xB2,0xB2
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0x63,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xB3
 .db    0xB3,0xB3
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x11
 .db    0x00,0x00
 .db    0x01,0x40
 .db    0x16,0x16
 .db    0x41,0x15
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x15,0x40
 .db    0x40,0x15
 .db    0x45,0x2E
 .db    0x5E,0x89
 .db    0x89,0x2E
 .db    0x2E,0xC4
 .db    0x6E,0x3F
 .db    0x3A,0x80
 .db    0x15,0x40
 .db    0x40,0x81
 .db    0x37,0x37
 .db    0xD1,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0xA2,0x7B
 .db    0xEA,0xD1
 .db    0x67,0x91
 .db    0x27,0x52
 .db    0x52,0xC1
 .db    0xE6,0x7F
 .db    0x3B,0x45
 .db    0x1A,0x45
 .db    0x45,0x1A
 .db    0x80,0x1A
 .db    0x80,0x45
 .db    0x45,0x45
 .db    0x6B,0x67
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0xA6,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0xD1
 .db    0x6B,0x27
 .db    0x27,0x52
 .db    0x7F,0x7F
 .db    0x7F,0x7F
 .db    0xAA,0x7B
 .db    0x7B,0x7F
 .db    0xAB,0x7F
 .db    0xD5,0x3F
 .db    0x40,0x05
 .db    0x81,0x3F
 .db    0x77,0x73
 .db    0x73,0x77
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0xA3,0xA3
 .db    0xB3,0xA3
 .db    0x63,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0x26,0x00
 .db    0x00,0x00
 .db    0x40,0x40
 .db    0x16,0x16
 .db    0x16,0x15
 .db    0x40,0x15
 .db    0x15,0x15
 .db    0x40,0x05
 .db    0x40,0x15
 .db    0x45,0x2E
 .db    0x5E,0x89
 .db    0x89,0x5D
 .db    0x2E,0x2E
 .db    0x89,0x2E
 .db    0x19,0x40
 .db    0x40,0x40
 .db    0x40,0x80
 .db    0x37,0x92
 .db    0xD1,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x73,0xE6
 .db    0x7F,0xD1
 .db    0x67,0x66
 .db    0x27,0x52
 .db    0x52,0x2B
 .db    0xE6,0xD6
 .db    0xC1,0x45
 .db    0x1A,0x45
 .db    0x45,0x1A
 .db    0x55,0x80
 .db    0x80,0x16
 .db    0x16,0x45
 .db    0xD1,0xD1
 .db    0xA6,0x7B
 .db    0x7B,0x7B
 .db    0xA6,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0xD1
 .db    0x96,0x27
 .db    0x27,0x27
 .db    0xD6,0x7F
 .db    0xAA,0x7F
 .db    0xD5,0xD1
 .db    0xD1,0x7F
 .db    0xAB,0x7F
 .db    0xD5,0x3F
 .db    0x40,0x05
 .db    0x80,0x6A
 .db    0xD1,0x73
 .db    0xA2,0x77
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0xA3,0xA3
 .db    0xB3,0xA3
 .db    0x63,0xA3
 .db    0xA3,0xA3
 .db    0x73,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB3
 .db    0xB2,0xB2
 .db    0x11,0x00
 .db    0x00,0x00
 .db    0x40,0x40
 .db    0x16,0x16
 .db    0x16,0x15
 .db    0x40,0x15
 .db    0x15,0x40
 .db    0x40,0x40
 .db    0x40,0x15
 .db    0x45,0x89
 .db    0x5E,0x5D
 .db    0x5D,0x5D
 .db    0x2E,0x2E
 .db    0x2E,0x84
 .db    0x15,0x40
 .db    0x40,0x40
 .db    0x15,0x80
 .db    0x92,0x67
 .db    0xD1,0xD1
 .db    0x7F,0x7B
 .db    0x7B,0x7B
 .db    0x73,0xEA
 .db    0xD5,0xD1
 .db    0x67,0x92
 .db    0x27,0x52
 .db    0x52,0x81
 .db    0xE6,0x7F
 .db    0xC1,0x1A
 .db    0x1A,0x1A
 .db    0x1A,0x81
 .db    0x2A,0x2A
 .db    0x80,0x16
 .db    0x41,0x80
 .db    0xD1,0xA2
 .db    0xD1,0xD1
 .db    0xA6,0x7B
 .db    0xA6,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0xC1,0x27
 .db    0x27,0x27
 .db    0xE6,0x7F
 .db    0x7F,0x7F
 .db    0xD5,0xD1
 .db    0xD1,0x7F
 .db    0xAB,0xD6
 .db    0xD5,0x3F
 .db    0x40,0x05
 .db    0x40,0x81
 .db    0x95,0xA2
 .db    0xA2,0xA2
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0xA3,0xB3
 .db    0xA3,0xA3
 .db    0x93,0xA3
 .db    0xA3,0xB3
 .db    0x73,0x73
 .db    0xB3,0xB3
 .db    0xB2,0xB2
 .db    0xB2,0x73
 .db    0xB2,0xB2
 .db    0xB2,0xB3
 .db    0xB2,0x51
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x40,0x40
 .db    0x45,0x45
 .db    0x45,0x16
 .db    0x15,0x15
 .db    0x16,0x15
 .db    0x40,0x40
 .db    0x15,0x15
 .db    0x1A,0x89
 .db    0xC4,0x5D
 .db    0x5D,0x2E
 .db    0x2E,0x2E
 .db    0x2E,0x55
 .db    0x15,0x40
 .db    0x40,0x40
 .db    0x15,0x80
 .db    0x92,0x6B
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x77,0xBF
 .db    0x7B,0xD1
 .db    0x67,0x66
 .db    0x27,0x52
 .db    0x27,0x81
 .db    0xE6,0x7F
 .db    0x6B,0x1A
 .db    0x81,0x81
 .db    0x81,0x81
 .db    0x2A,0x80
 .db    0x80,0x15
 .db    0x15,0x2B
 .db    0xD1,0xA2
 .db    0xD1,0xD1
 .db    0x7B,0x7B
 .db    0xD1,0xA6
 .db    0x7B,0x7B
 .db    0xD5,0x7B
 .db    0xC1,0x91
 .db    0x27,0x27
 .db    0xE6,0xD5
 .db    0xD5,0x7F
 .db    0xD5,0xD1
 .db    0xD1,0x7F
 .db    0xD6,0xD6
 .db    0xD5,0xC0
 .db    0x40,0x40
 .db    0x40,0x15
 .db    0x80,0x91
 .db    0x77,0x77
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0xA3,0xB3
 .db    0xB3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xB3
 .db    0x73,0x73
 .db    0xB3,0xB3
 .db    0xB2,0xB2
 .db    0xB2,0x73
 .db    0xB2,0xB2
 .db    0xB2,0xE2
 .db    0x91,0x40
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x40,0x40
 .db    0x45,0x1A
 .db    0x45,0x16
 .db    0x41,0x16
 .db    0x16,0x40
 .db    0x40,0x40
 .db    0x15,0x15
 .db    0x1A,0x89
 .db    0xC4,0x5D
 .db    0x5D,0x2E
 .db    0x2E,0x84
 .db    0x84,0x80
 .db    0x40,0x40
 .db    0x15,0x40
 .db    0x15,0x80
 .db    0x91,0x6B
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0x7F,0xD1
 .db    0x7B,0xBF
 .db    0x7B,0xD1
 .db    0x67,0x91
 .db    0x27,0x52
 .db    0x52,0x81
 .db    0xE6,0x7F
 .db    0xD1,0x1B
 .db    0x85,0x85
 .db    0x81,0x81
 .db    0x2A,0x1A
 .db    0x45,0x15
 .db    0x15,0x3F
 .db    0xA2,0xA2
 .db    0xD1,0xD1
 .db    0x7B,0x7B
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0xA6
 .db    0xC1,0x91
 .db    0x27,0x27
 .db    0xE6,0xAA
 .db    0xD5,0x7F
 .db    0xD5,0xA6
 .db    0x7B,0x7F
 .db    0x7F,0xD6
 .db    0xD5,0xC0
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x40,0x41
 .db    0xA2,0x77
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0xA3,0xB3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0x73,0x73
 .db    0xB3,0xB3
 .db    0x73,0x73
 .db    0xB2,0x73
 .db    0xB2,0xB2
 .db    0xB2,0x91
 .db    0x15,0x01
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x40,0x40
 .db    0x1A,0x1A
 .db    0x45,0x45
 .db    0x16,0x16
 .db    0x16,0x15
 .db    0x40,0x40
 .db    0x15,0x15
 .db    0x1A,0x89
 .db    0x89,0x5D
 .db    0x88,0x2E
 .db    0x84,0x84
 .db    0x84,0x19
 .db    0x40,0x40
 .db    0x15,0x40
 .db    0x19,0x1A
 .db    0x91,0xD1
 .db    0xA2,0xD1
 .db    0x7B,0x7B
 .db    0x7F,0x7B
 .db    0xE6,0xBF
 .db    0x7B,0xD1
 .db    0x92,0x91
 .db    0x27,0x52
 .db    0x52,0x81
 .db    0xBB,0x7F
 .db    0xD1,0x85
 .db    0x86,0x85
 .db    0x81,0x2A
 .db    0x80,0x16
 .db    0x15,0x15
 .db    0x16,0xC1
 .db    0xA2,0xD1
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0xA6,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0xD1
 .db    0xC1,0x91
 .db    0x27,0x81
 .db    0xBB,0x7F
 .db    0xD5,0x7F
 .db    0x7F,0xD1
 .db    0x7B,0x7F
 .db    0x7F,0xAB
 .db    0xAA,0xC0
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x05,0x40
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xA3
 .db    0xA3,0xB3
 .db    0xA3,0xA3
 .db    0xA3,0xA3
 .db    0xA3,0xB3
 .db    0x73,0x73
 .db    0xB3,0xB3
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB2,0xE2
 .db    0xE1,0x15
 .db    0x40,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x40,0x40
 .db    0x1A,0x1A
 .db    0x1A,0x45
 .db    0x45,0x45
 .db    0x45,0x15
 .db    0x40,0x40
 .db    0x15,0x15
 .db    0x84,0xC4
 .db    0x89,0x88
 .db    0x88,0x2E
 .db    0x84,0x80
 .db    0x1A,0x15
 .db    0x40,0x40
 .db    0x15,0x15
 .db    0x19,0x45
 .db    0x91,0xD1
 .db    0xA2,0xD1
 .db    0x7B,0x7B
 .db    0x7F,0x7F
 .db    0xBF,0xBA
 .db    0x7B,0xD1
 .db    0x92,0x91
 .db    0x27,0x27
 .db    0x52,0x27
 .db    0xBB,0x7F
 .db    0xA6,0x86
 .db    0x86,0x2F
 .db    0x56,0x1A
 .db    0x45,0x15
 .db    0x40,0x15
 .db    0x45,0x6B
 .db    0xA2,0xD1
 .db    0xA6,0x7B
 .db    0x7B,0x7B
 .db    0xA6,0xD1
 .db    0x7B,0x7B
 .db    0x7B,0xA6
 .db    0x92,0x2B
 .db    0x27,0x27
 .db    0xBB,0x7F
 .db    0xAA,0x7F
 .db    0x7F,0xD1
 .db    0x7B,0xD5
 .db    0x7F,0x7F
 .db    0xD5,0x2B
 .db    0x40,0x40
 .db    0x01,0x40
 .db    0x05,0x40
 .db    0x77,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xA3,0xB3
 .db    0xB3,0xA3
 .db    0xA3,0xB3
 .db    0xB3,0xB3
 .db    0x73,0x73
 .db    0x73,0xB3
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0xB2,0xBB
 .db    0x51,0x15
 .db    0x40,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x40,0x40
 .db    0x2A,0x2A
 .db    0x1A,0x1A
 .db    0x1A,0x45
 .db    0x45,0x15
 .db    0x40,0x40
 .db    0x15,0x15
 .db    0x84,0xC4
 .db    0x89,0x88
 .db    0x2E,0x2E
 .db    0x84,0x1A
 .db    0x19,0x15
 .db    0x05,0x40
 .db    0x15,0x15
 .db    0x19,0x45
 .db    0x2B,0xD1
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0x7F,0x7F
 .db    0xEA,0x7F
 .db    0x7B,0xD1
 .db    0x92,0x91
 .db    0x27,0x27
 .db    0x52,0x27
 .db    0xBB,0x7F
 .db    0x7B,0x86
 .db    0x86,0x2F
 .db    0x81,0x1A
 .db    0x15,0x40
 .db    0x40,0x41
 .db    0x1A,0x6B
 .db    0x67,0xD1
 .db    0x7B,0x7F
 .db    0x7B,0x7B
 .db    0xD1,0xD1
 .db    0xA6,0x7B
 .db    0x7B,0xA6
 .db    0x3B,0x2B
 .db    0x27,0x27
 .db    0xE6,0x7F
 .db    0x7F,0x7F
 .db    0xD5,0x6B
 .db    0x7B,0x7B
 .db    0x7F,0x7F
 .db    0xD5,0x2A
 .db    0x01,0x01
 .db    0x05,0x40
 .db    0x40,0x40
 .db    0x7B,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xA3,0xB3
 .db    0xB3,0xA3
 .db    0xA3,0xB3
 .db    0xB3,0x73
 .db    0x73,0x73
 .db    0x73,0xB3
 .db    0x73,0xB2
 .db    0xB2,0xB2
 .db    0xE6,0x2A
 .db    0x40,0x41
 .db    0x15,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x01,0x15
 .db    0x81,0x2A
 .db    0x1A,0x1A
 .db    0x1A,0x45
 .db    0x45,0x15
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x2E,0xC4
 .db    0x89,0x88
 .db    0x2E,0x84
 .db    0x49,0x45
 .db    0x19,0x40
 .db    0x40,0x15
 .db    0x15,0x44
 .db    0x19,0x19
 .db    0x2B,0x7B
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0x7F,0x7F
 .db    0x7F,0x7F
 .db    0x7B,0xD1
 .db    0x67,0x91
 .db    0x27,0x27
 .db    0x52,0x27
 .db    0xE6,0x7F
 .db    0x7B,0x5B
 .db    0x86,0x85
 .db    0x1A,0x16
 .db    0x40,0x40
 .db    0x40,0x16
 .db    0x1A,0xD1
 .db    0x92,0xD1
 .db    0x7B,0x7F
 .db    0x7B,0x7B
 .db    0xD1,0xD1
 .db    0xA6,0x7B
 .db    0x7B,0xD1
 .db    0x3B,0x27
 .db    0x27,0x27
 .db    0xE6,0x7F
 .db    0x7F,0x7F
 .db    0xD5,0xD1
 .db    0x7B,0xA6
 .db    0x7F,0x7F
 .db    0xD5,0x1A
 .db    0x01,0x2A
 .db    0xC0,0x40
 .db    0x40,0x40
 .db    0x7B,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xA3,0xB3
 .db    0xB3,0x73
 .db    0xB3,0xB3
 .db    0xB3,0x73
 .db    0x73,0x73
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xE2
 .db    0x95,0x40
 .db    0x40,0x41
 .db    0x15,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x01,0x15
 .db    0x2A,0x80
 .db    0x1A,0x81
 .db    0x1A,0x1A
 .db    0x45,0x15
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x2E,0xC4
 .db    0x5D,0x2E
 .db    0x2E,0x84
 .db    0x19,0x19
 .db    0x19,0x40
 .db    0x40,0x15
 .db    0x44,0x44
 .db    0x19,0x19
 .db    0x2A,0xD1
 .db    0xA2,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7F
 .db    0x7F,0x7F
 .db    0x7B,0xD1
 .db    0x67,0x91
 .db    0x27,0x27
 .db    0x52,0x27
 .db    0xE6,0x7F
 .db    0x7B,0x86
 .db    0x85,0x81
 .db    0x1A,0x41
 .db    0x15,0x40
 .db    0x15,0x16
 .db    0x1A,0x6B
 .db    0x92,0xD1
 .db    0x7F,0x7F
 .db    0x7B,0x7B
 .db    0xD1,0xD1
 .db    0xD1,0x7B
 .db    0xA6,0x96
 .db    0x3B,0x2B
 .db    0x27,0x27
 .db    0xE2,0x7F
 .db    0x7F,0x7F
 .db    0xD5,0x7B
 .db    0x7B,0x7B
 .db    0x7F,0x7F
 .db    0xD5,0x41
 .db    0x01,0x80
 .db    0xC0,0x40
 .db    0x40,0x40
 .db    0x3B,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xB3
 .db    0xB3,0xA3
 .db    0xB3,0xB3
 .db    0xB3,0x73
 .db    0x73,0x73
 .db    0xB3,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0x7F
 .db    0x15,0x40
 .db    0x40,0x15
 .db    0x15,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x40,0x40
 .db    0x80,0x45
 .db    0x1A,0x81
 .db    0x1A,0x80
 .db    0x45,0x15
 .db    0x15,0x45
 .db    0x45,0x44
 .db    0x2E,0xC4
 .db    0x5D,0x2E
 .db    0x2E,0x84
 .db    0x19,0x19
 .db    0x15,0x40
 .db    0x40,0x44
 .db    0x19,0x44
 .db    0x19,0x19
 .db    0x80,0xA6
 .db    0xA2,0xD1
 .db    0x7B,0x7B
 .db    0x7F,0x7B
 .db    0x7F,0x7B
 .db    0x7B,0xD1
 .db    0x92,0x92
 .db    0x27,0x27
 .db    0x52,0x27
 .db    0x7B,0x7F
 .db    0x7B,0x2B
 .db    0x81,0x81
 .db    0x1A,0x45
 .db    0x15,0x15
 .db    0x41,0x16
 .db    0x80,0x6B
 .db    0x77,0x77
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0xD1
 .db    0xD1,0x7B
 .db    0xD1,0xC1
 .db    0x3B,0x27
 .db    0x27,0x27
 .db    0x7B,0x7F
 .db    0x7F,0x7F
 .db    0xD5,0x7B
 .db    0x7B,0xD5
 .db    0xD5,0x7F
 .db    0x6B,0x40
 .db    0x40,0x40
 .db    0x25,0x15
 .db    0x40,0x40
 .db    0x51,0x73
 .db    0x73,0x73
 .db    0xA3,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xA3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0x73,0x73
 .db    0xB2,0x73
 .db    0x73,0xB2
 .db    0x7B,0x80
 .db    0x40,0x40
 .db    0x40,0x15
 .db    0x15,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x40
 .db    0x80,0x16
 .db    0x1A,0x1A
 .db    0x1A,0x81
 .db    0x1A,0x15
 .db    0x45,0x45
 .db    0x45,0x15
 .db    0x84,0x89
 .db    0x2E,0x2E
 .db    0x84,0x1A
 .db    0x19,0x19
 .db    0x15,0x40
 .db    0x40,0x19
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0x45,0xD1
 .db    0xA2,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7F
 .db    0x7B,0xD1
 .db    0x67,0xC1
 .db    0x91,0x27
 .db    0x27,0x27
 .db    0x7B,0x7F
 .db    0x7B,0x81
 .db    0x81,0x81
 .db    0x1A,0x1A
 .db    0x15,0x15
 .db    0x41,0x45
 .db    0x1A,0x6B
 .db    0xA2,0x77
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0xD1
 .db    0xD1,0x7B
 .db    0xD1,0xC1
 .db    0x91,0x27
 .db    0x27,0x91
 .db    0xB6,0x7F
 .db    0x7F,0x7F
 .db    0x7B,0xA6
 .db    0x7B,0xD5
 .db    0xD5,0x7F
 .db    0x6B,0x40
 .db    0x40,0x40
 .db    0x15,0x15
 .db    0x40,0x40
 .db    0x11,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xA3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0x73,0xB3
 .db    0xB2,0x73
 .db    0x73,0xE6
 .db    0x3B,0x15
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x80,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x40
 .db    0x1A,0x16
 .db    0x1A,0x1A
 .db    0x1A,0x2A
 .db    0x80,0x15
 .db    0x15,0x45
 .db    0x45,0x44
 .db    0x84,0x2E
 .db    0x2E,0x2E
 .db    0x84,0x19
 .db    0x19,0x19
 .db    0x15,0x40
 .db    0x40,0x19
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0x19,0xD1
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7F
 .db    0x7B,0xD1
 .db    0x67,0x96
 .db    0x91,0x27
 .db    0x27,0x91
 .db    0x7B,0xE5
 .db    0x7B,0x55
 .db    0x81,0x81
 .db    0x81,0x1A
 .db    0x15,0x15
 .db    0x41,0x16
 .db    0x1A,0xC1
 .db    0xA2,0x77
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0xD1
 .db    0xA6,0x7B
 .db    0x7B,0xC1
 .db    0x91,0x27
 .db    0x27,0x91
 .db    0xE6,0x7F
 .db    0xD6,0x7F
 .db    0x7B,0xD1
 .db    0x7B,0xD5
 .db    0xA6,0xD5
 .db    0x3F,0x40
 .db    0x40,0x40
 .db    0x3F,0x40
 .db    0x40,0x01
 .db    0x11,0x73
 .db    0x73,0x73
 .db    0x73,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xA3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0x77,0xD1
 .db    0x16,0x15
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x2A,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x01,0x40
 .db    0x1A,0x16
 .db    0x45,0x1A
 .db    0x1A,0x2A
 .db    0x1A,0x15
 .db    0x15,0x45
 .db    0x45,0x19
 .db    0x84,0x2E
 .db    0x2E,0x2E
 .db    0x84,0x19
 .db    0x19,0x44
 .db    0x15,0x40
 .db    0x15,0x19
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0x19,0x6B
 .db    0xD1,0x7B
 .db    0x7B,0x7F
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0xD1
 .db    0x6B,0x96
 .db    0x91,0x27
 .db    0x27,0x92
 .db    0xA6,0x7F
 .db    0x7B,0x80
 .db    0x81,0x81
 .db    0x1A,0x45
 .db    0x15,0x15
 .db    0x41,0x16
 .db    0x16,0x3B
 .db    0xA2,0x77
 .db    0x7B,0x7B
 .db    0x7B,0xD1
 .db    0xD1,0xD1
 .db    0xD1,0x7B
 .db    0x7B,0xC1
 .db    0x3B,0x91
 .db    0x27,0x27
 .db    0xE6,0x7F
 .db    0x7F,0x7F
 .db    0xD1,0xD1
 .db    0x7B,0x7B
 .db    0xD1,0xD5
 .db    0xC0,0x40
 .db    0x40,0x40
 .db    0xEA,0x40
 .db    0x40,0x01
 .db    0x40,0x73
 .db    0x73,0x73
 .db    0x73,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xA3
 .db    0xB3,0xB3
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0xB2
 .db    0x7B,0x80
 .db    0x15,0x15
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x2A,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x40
 .db    0x16,0x45
 .db    0x16,0x45
 .db    0x1A,0x80
 .db    0x1A,0x15
 .db    0x15,0x45
 .db    0x19,0x19
 .db    0x2E,0x2E
 .db    0x84,0x84
 .db    0x49,0x19
 .db    0x19,0x15
 .db    0x15,0x40
 .db    0x15,0x15
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0x19,0x3F
 .db    0x7B,0x7B
 .db    0x7F,0x7F
 .db    0x7B,0x7B
 .db    0x7F,0x7B
 .db    0x7B,0xD1
 .db    0xD1,0xC1
 .db    0x37,0x27
 .db    0x27,0x67
 .db    0xA2,0x7F
 .db    0xD5,0x1A
 .db    0x55,0x1A
 .db    0x45,0x16
 .db    0x41,0x15
 .db    0x41,0x16
 .db    0x41,0x81
 .db    0xA2,0x77
 .db    0x7B,0x7B
 .db    0x7B,0xD1
 .db    0xD1,0xD1
 .db    0xD1,0x7B
 .db    0x7B,0x6B
 .db    0x3B,0x91
 .db    0x27,0x37
 .db    0xE6,0x7F
 .db    0x7F,0x7F
 .db    0xD1,0xA6
 .db    0xA6,0xA6
 .db    0xA6,0xA6
 .db    0x81,0x40
 .db    0x40,0x40
 .db    0xEA,0x40
 .db    0x40,0x01
 .db    0x40,0x77
 .db    0x73,0x73
 .db    0x73,0xB3
 .db    0xB3,0xB3
 .db    0xA3,0xA3
 .db    0xB3,0xB3
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x77
 .db    0x3F,0x16
 .db    0x15,0x15
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x15,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x40
 .db    0x15,0x2A
 .db    0x16,0x16
 .db    0x45,0x1A
 .db    0x45,0x15
 .db    0x15,0x45
 .db    0x44,0x45
 .db    0x2E,0x2E
 .db    0x84,0x1E
 .db    0x1A,0x19
 .db    0x44,0x15
 .db    0x40,0x40
 .db    0x15,0x15
 .db    0x19,0x19
 .db    0x19,0x44
 .db    0x19,0x2F
 .db    0x7B,0x7B
 .db    0x7F,0x7F
 .db    0x7B,0x7B
 .db    0x7F,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x67
 .db    0x27,0x27
 .db    0x27,0x67
 .db    0x73,0x7F
 .db    0xD5,0x1A
 .db    0x1A,0x16
 .db    0x40,0x15
 .db    0x16,0x16
 .db    0x16,0x16
 .db    0x15,0x80
 .db    0xA2,0xA2
 .db    0x7B,0x7B
 .db    0x7B,0xD1
 .db    0xD1,0xD1
 .db    0xD1,0x7B
 .db    0x7B,0xC1
 .db    0x3B,0x3B
 .db    0x91,0x91
 .db    0xE6,0x7F
 .db    0x7F,0x7F
 .db    0x7B,0x7B
 .db    0xD1,0xA6
 .db    0xD1,0x6B
 .db    0x1A,0x40
 .db    0x40,0x40
 .db    0xEA,0x40
 .db    0x40,0x01
 .db    0x40,0x77
 .db    0x73,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xA3,0xB3
 .db    0xB3,0xB3
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0x73,0x7B
 .db    0x16,0x15
 .db    0x15,0x15
 .db    0xC0,0x15
 .db    0x40,0x40
 .db    0x40,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x40,0x2B
 .db    0x16,0x16
 .db    0x45,0x1A
 .db    0x45,0x15
 .db    0x15,0x19
 .db    0x15,0x45
 .db    0x98,0x2E
 .db    0x84,0x1A
 .db    0x45,0x19
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0x19,0x84
 .db    0x7B,0x7B
 .db    0x7F,0x7B
 .db    0x7B,0x7B
 .db    0x7F,0x7F
 .db    0x7B,0xD6
 .db    0x7B,0x67
 .db    0x91,0x27
 .db    0x52,0x77
 .db    0x73,0x7F
 .db    0xD5,0x1A
 .db    0x45,0x41
 .db    0x40,0x15
 .db    0x16,0x1A
 .db    0x1A,0x45
 .db    0x41,0x16
 .db    0xD1,0xA2
 .db    0x7B,0x7B
 .db    0x7B,0xD1
 .db    0xA2,0xD1
 .db    0xD1,0x7B
 .db    0x7B,0xC1
 .db    0x3B,0x66
 .db    0x91,0x92
 .db    0xBB,0x7F
 .db    0x7F,0x7F
 .db    0x7B,0x7B
 .db    0xD1,0xA6
 .db    0xD1,0x6B
 .db    0x16,0x40
 .db    0x40,0x40
 .db    0xE6,0x40
 .db    0x40,0x05
 .db    0x40,0x77
 .db    0x73,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xA3,0xB3
 .db    0xB3,0xB3
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xB2,0xC1
 .db    0x16,0x15
 .db    0x40,0x2A
 .db    0x6A,0x15
 .db    0x40,0x40
 .db    0x40,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x40,0x2A
 .db    0x1A,0x16
 .db    0x16,0x1A
 .db    0x45,0x15
 .db    0x15,0x19
 .db    0x15,0x19
 .db    0x98,0xC4
 .db    0x84,0x1A
 .db    0x19,0x19
 .db    0x15,0x19
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0x19,0x1A
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7F,0xD6
 .db    0x7F,0xE6
 .db    0xD6,0x67
 .db    0x91,0x37
 .db    0x27,0xD1
 .db    0xA2,0x7F
 .db    0x7F,0x1A
 .db    0x1A,0x41
 .db    0x15,0x16
 .db    0x1A,0x1A
 .db    0x1A,0x1A
 .db    0x16,0x41
 .db    0xC1,0xA2
 .db    0x7B,0xD1
 .db    0xD1,0xA2
 .db    0xA2,0xD1
 .db    0xD1,0x7B
 .db    0x7B,0x3B
 .db    0x3B,0x91
 .db    0x91,0x92
 .db    0xBB,0x7F
 .db    0x7F,0xD5
 .db    0x7B,0x7B
 .db    0xD1,0x7B
 .db    0xD1,0x3F
 .db    0x41,0x40
 .db    0x15,0x40
 .db    0xE6,0x40
 .db    0x40,0x40
 .db    0x40,0x77
 .db    0xB2,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xA3,0xB3
 .db    0xB3,0xB3
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xE6,0x81
 .db    0x41,0x40
 .db    0x40,0xEA
 .db    0x15,0x40
 .db    0x40,0x40
 .db    0x40,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x40,0x55
 .db    0x55,0x16
 .db    0x16,0x1A
 .db    0x45,0x15
 .db    0x15,0x19
 .db    0x15,0x19
 .db    0x98,0xC4
 .db    0x84,0x1A
 .db    0x19,0x15
 .db    0x19,0x19
 .db    0x15,0x15
 .db    0x15,0x44
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0x19,0x1A
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7F,0xD6
 .db    0xD6,0xAB
 .db    0xD6,0xC1
 .db    0x3B,0x91
 .db    0x27,0x67
 .db    0x92,0x7F
 .db    0x7F,0x1A
 .db    0x45,0x16
 .db    0x41,0x16
 .db    0x1A,0x1A
 .db    0x1A,0x1A
 .db    0x45,0x16
 .db    0x3B,0xA2
 .db    0x77,0x77
 .db    0xD1,0xA2
 .db    0xA2,0xA2
 .db    0xD1,0x7B
 .db    0xD1,0x67
 .db    0x3B,0x91
 .db    0x37,0x92
 .db    0xBB,0x7F
 .db    0x7F,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0x7B
 .db    0xD1,0xC0
 .db    0x15,0x40
 .db    0x40,0x40
 .db    0xE6,0x40
 .db    0x40,0x40
 .db    0x40,0x77
 .db    0xB2,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0x73
 .db    0x73,0x73
 .db    0x73,0x73
 .db    0xD1,0x81
 .db    0x1A,0x15
 .db    0x41,0xBA
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x40,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x80
 .db    0x80,0x16
 .db    0x45,0x1A
 .db    0x45,0x15
 .db    0x15,0x19
 .db    0x15,0x19
 .db    0x98,0xC4
 .db    0x84,0x1A
 .db    0x44,0x44
 .db    0x19,0x45
 .db    0x15,0x15
 .db    0x15,0x44
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0x19,0x1A
 .db    0x95,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7F,0xE6
 .db    0xD6,0xD6
 .db    0xE6,0xD1
 .db    0x3B,0x3B
 .db    0x91,0x63
 .db    0x37,0x7F
 .db    0xE6,0x1A
 .db    0x45,0x16
 .db    0x41,0x41
 .db    0x16,0x1A
 .db    0x1A,0x1A
 .db    0x1A,0x45
 .db    0x81,0xA2
 .db    0xA2,0xA2
 .db    0xA2,0xA2
 .db    0xA2,0xA2
 .db    0xD1,0xA6
 .db    0xD1,0x92
 .db    0x3B,0x91
 .db    0x37,0x92
 .db    0xBB,0x7F
 .db    0x7F,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0x7B
 .db    0xD1,0x56
 .db    0x15,0x40
 .db    0x40,0x40
 .db    0xE6,0x01
 .db    0x40,0x40
 .db    0x40,0x77
 .db    0xB3,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0x73
 .db    0x73,0x73
 .db    0xB2,0x73
 .db    0x2B,0x1B
 .db    0x1B,0x41
 .db    0xC1,0x91
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x40,0x01
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x15
 .db    0x80,0x45
 .db    0x45,0x1A
 .db    0x45,0x15
 .db    0x15,0x15
 .db    0x15,0x19
 .db    0x98,0xC4
 .db    0x84,0x19
 .db    0x15,0x19
 .db    0x1A,0x45
 .db    0x19,0x15
 .db    0x15,0x19
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0x84,0x1A
 .db    0x2E,0x7B
 .db    0x7B,0x7F
 .db    0x7B,0x7F
 .db    0x7F,0xE6
 .db    0xAB,0xD6
 .db    0x7F,0x7F
 .db    0x6B,0xC1
 .db    0x92,0x63
 .db    0x37,0x7F
 .db    0xE6,0x1A
 .db    0x45,0x41
 .db    0x15,0x15
 .db    0x41,0x45
 .db    0x1A,0x1A
 .db    0x81,0x1A
 .db    0x80,0xA2
 .db    0xA2,0xA2
 .db    0xA2,0x92
 .db    0x92,0xD1
 .db    0xD1,0xD1
 .db    0xD1,0x3B
 .db    0x3B,0x91
 .db    0x62,0x37
 .db    0xBB,0x7F
 .db    0xD6,0x7B
 .db    0x7B,0xA6
 .db    0xD1,0xD1
 .db    0xD1,0x2A
 .db    0x15,0x40
 .db    0x40,0x01
 .db    0xE6,0x40
 .db    0x40,0x40
 .db    0x01,0x77
 .db    0xB2,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0x73
 .db    0x73,0x73
 .db    0xB2,0x77
 .db    0x1A,0x1A
 .db    0x1A,0x16
 .db    0xD1,0x16
 .db    0x40,0x40
 .db    0x05,0x40
 .db    0x40,0x40
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x40,0x15
 .db    0x2A,0x45
 .db    0x45,0x1A
 .db    0x1A,0x45
 .db    0x15,0x15
 .db    0x15,0x19
 .db    0x98,0x98
 .db    0x84,0x19
 .db    0x44,0x19
 .db    0x80,0x19
 .db    0x19,0x15
 .db    0x15,0x19
 .db    0x19,0x19
 .db    0x19,0x2A
 .db    0x3F,0x3F
 .db    0xC0,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x7F
 .db    0x7F,0xE6
 .db    0xE6,0xD6
 .db    0x7B,0x7F
 .db    0xAA,0xD1
 .db    0xD1,0x63
 .db    0x37,0x7F
 .db    0xEA,0x80
 .db    0x45,0x41
 .db    0x15,0x15
 .db    0x41,0x16
 .db    0x1A,0x1A
 .db    0x81,0x1A
 .db    0x16,0xD1
 .db    0xA2,0xA2
 .db    0xA2,0x37
 .db    0x3B,0xA2
 .db    0xA2,0xD1
 .db    0xA2,0x66
 .db    0x91,0x37
 .db    0x27,0x37
 .db    0xBB,0xD6
 .db    0xD6,0x7B
 .db    0xD5,0xD1
 .db    0xD1,0xD1
 .db    0x96,0x80
 .db    0x41,0x15
 .db    0x40,0x05
 .db    0xD1,0x3B
 .db    0x05,0x40
 .db    0x01,0x77
 .db    0xB3,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0x73
 .db    0x73,0x73
 .db    0xB2,0x7B
 .db    0x16,0x1A
 .db    0x1A,0x16
 .db    0x7B,0x15
 .db    0x15,0x40
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x40,0x40
 .db    0x2A,0x1A
 .db    0x45,0x1A
 .db    0x1A,0x1A
 .db    0x19,0x15
 .db    0x15,0x19
 .db    0x5D,0x98
 .db    0x1E,0x44
 .db    0x44,0x19
 .db    0x80,0x19
 .db    0x15,0x15
 .db    0x15,0x19
 .db    0x19,0x19
 .db    0x80,0x3F
 .db    0x7B,0xD1
 .db    0xC0,0xA6
 .db    0x7B,0x7B
 .db    0x7B,0x7F
 .db    0x7F,0xE6
 .db    0xAB,0xD6
 .db    0xD1,0xD1
 .db    0xE5,0xD5
 .db    0xD1,0x37
 .db    0x63,0x7F
 .db    0xEA,0x2A
 .db    0x80,0x45
 .db    0x16,0x16
 .db    0x16,0x16
 .db    0x45,0x1A
 .db    0x81,0x1A
 .db    0x16,0x3B
 .db    0xA2,0xA2
 .db    0xA2,0x3B
 .db    0x3B,0x92
 .db    0xA2,0xA2
 .db    0xA2,0x37
 .db    0x37,0x37
 .db    0x27,0x37
 .db    0xBB,0xD6
 .db    0xD6,0x7B
 .db    0xD5,0xA6
 .db    0xD1,0xD1
 .db    0xC0,0x80
 .db    0x16,0x15
 .db    0x40,0x40
 .db    0x26,0x7B
 .db    0x40,0x40
 .db    0x01,0x77
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0x73
 .db    0x73,0xB2
 .db    0xB2,0x3B
 .db    0x16,0x1A
 .db    0x45,0x81
 .db    0x7B,0x15
 .db    0x15,0x15
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x01,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x15,0x40
 .db    0x2A,0x1A
 .db    0x1A,0x1A
 .db    0x81,0x1A
 .db    0x45,0x19
 .db    0x44,0x19
 .db    0x2E,0x5D
 .db    0x49,0x44
 .db    0x19,0x84
 .db    0x80,0x15
 .db    0x15,0x40
 .db    0x44,0x19
 .db    0x19,0x19
 .db    0x91,0x7B
 .db    0x7A,0x2E
 .db    0x80,0x3F
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0xD6,0xE6
 .db    0xD6,0xD6
 .db    0xD1,0x67
 .db    0x7F,0xBA
 .db    0x7B,0x37
 .db    0x63,0x7F
 .db    0xEA,0x80
 .db    0x80,0x1A
 .db    0x1A,0x1A
 .db    0x1A,0x16
 .db    0x16,0x1A
 .db    0x81,0x1A
 .db    0x41,0x2A
 .db    0xC1,0xA2
 .db    0xA2,0x3B
 .db    0x37,0x37
 .db    0x3B,0xA2
 .db    0x92,0x37
 .db    0x37,0x62
 .db    0x27,0x37
 .db    0xBB,0xD6
 .db    0xD6,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0xD1
 .db    0x56,0x80
 .db    0x45,0x41
 .db    0x40,0x40
 .db    0x15,0xE1
 .db    0x6A,0x40
 .db    0x01,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0x73
 .db    0x73,0xB2
 .db    0xB2,0x16
 .db    0x41,0x16
 .db    0x16,0x7B
 .db    0x3B,0x80
 .db    0x15,0x15
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x40,0x40
 .db    0x80,0x81
 .db    0x1A,0x1A
 .db    0x1A,0x1A
 .db    0x45,0x15
 .db    0x44,0x19
 .db    0x2E,0x2E
 .db    0x1A,0x15
 .db    0x19,0x84
 .db    0x1A,0x15
 .db    0x15,0x40
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0xA2,0xE5
 .db    0xC0,0x1A
 .db    0x1A,0x84
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0xD6,0xE6
 .db    0xD6,0xD6
 .db    0xD1,0x92
 .db    0xD1,0xBA
 .db    0xE5,0x63
 .db    0x63,0x7F
 .db    0xEA,0x45
 .db    0x1A,0x45
 .db    0x1A,0x81
 .db    0x1A,0x45
 .db    0x16,0x1A
 .db    0x81,0x1A
 .db    0x15,0x80
 .db    0x3B,0xD1
 .db    0xA2,0x92
 .db    0x37,0x37
 .db    0x37,0xA2
 .db    0x92,0x37
 .db    0x62,0x62
 .db    0x27,0x37
 .db    0xBB,0xD6
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0xA6,0xD1
 .db    0x81,0x80
 .db    0x1A,0x41
 .db    0x40,0x40
 .db    0x40,0xD1
 .db    0xE1,0x40
 .db    0x41,0x73
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0x73
 .db    0x73,0xB2
 .db    0xB2,0x41
 .db    0x41,0x41
 .db    0x41,0xE1
 .db    0x2A,0x2A
 .db    0x15,0x15
 .db    0x40,0x40
 .db    0x40,0x05
 .db    0x01,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x01
 .db    0x16,0x81
 .db    0x1A,0x1A
 .db    0x1A,0x45
 .db    0x19,0x15
 .db    0x44,0x19
 .db    0x2E,0x2E
 .db    0x19,0x44
 .db    0x84,0x84
 .db    0x45,0x40
 .db    0x40,0x40
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0xA2,0xE5
 .db    0x84,0x1A
 .db    0x19,0x1A
 .db    0xD1,0x7B
 .db    0x7B,0x7B
 .db    0xD6,0xE6
 .db    0xAB,0xD6
 .db    0xD1,0x66
 .db    0x92,0x7F
 .db    0xBA,0x63
 .db    0x63,0xD6
 .db    0xBB,0x45
 .db    0x16,0x41
 .db    0x80,0x81
 .db    0x1A,0x45
 .db    0x41,0x1A
 .db    0x81,0x45
 .db    0x15,0x45
 .db    0x80,0x3B
 .db    0xD1,0x67
 .db    0x3B,0x37
 .db    0x37,0x37
 .db    0x37,0x62
 .db    0x62,0x62
 .db    0x27,0x37
 .db    0xBB,0xD6
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0x6B
 .db    0x1A,0x80
 .db    0x1A,0x16
 .db    0x40,0x40
 .db    0x40,0x51
 .db    0xB2,0x77
 .db    0x77,0xB2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0x73
 .db    0xB2,0xB2
 .db    0x27,0x41
 .db    0x15,0x41
 .db    0x16,0xB2
 .db    0x16,0x2A
 .db    0x80,0x40
 .db    0x40,0x40
 .db    0x05,0x05
 .db    0x05,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x15,0x81
 .db    0x45,0x1A
 .db    0x1A,0x45
 .db    0x15,0x15
 .db    0x44,0x19
 .db    0x2E,0x2E
 .db    0x19,0x19
 .db    0x84,0x84
 .db    0x19,0x40
 .db    0x40,0x40
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0xA2,0xE5
 .db    0x84,0x1A
 .db    0x1A,0x1A
 .db    0xD1,0xD1
 .db    0x7B,0x7B
 .db    0xD6,0xE6
 .db    0xD6,0xD6
 .db    0xD1,0x66
 .db    0x3B,0xC1
 .db    0xE5,0x37
 .db    0x92,0xD6
 .db    0xE6,0x16
 .db    0x15,0x15
 .db    0x80,0x2B
 .db    0x1A,0x16
 .db    0x41,0x45
 .db    0x1A,0x16
 .db    0x15,0x16
 .db    0x45,0x80
 .db    0x3B,0x67
 .db    0x3B,0x37
 .db    0x37,0x37
 .db    0x37,0x62
 .db    0x62,0x62
 .db    0x27,0x37
 .db    0xBB,0x7F
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0x7B,0xC0
 .db    0x1A,0x1A
 .db    0x1A,0x16
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x77,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0x73
 .db    0xB2,0xB2
 .db    0x41,0x15
 .db    0x40,0x41
 .db    0x26,0xB2
 .db    0x41,0x80
 .db    0x55,0x15
 .db    0x40,0x40
 .db    0x05,0x05
 .db    0x01,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x40,0x81
 .db    0x45,0x45
 .db    0x45,0x45
 .db    0x15,0x15
 .db    0x44,0x19
 .db    0x84,0x2E
 .db    0x19,0x1A
 .db    0x84,0x84
 .db    0x15,0x40
 .db    0x40,0x15
 .db    0x19,0x19
 .db    0x19,0x45
 .db    0xA2,0xB6
 .db    0x84,0x1A
 .db    0x1A,0x80
 .db    0xD1,0xD1
 .db    0x7B,0x7B
 .db    0xD6,0xE6
 .db    0xD6,0xD6
 .db    0x7B,0x66
 .db    0x91,0x91
 .db    0x7B,0x37
 .db    0x92,0xD6
 .db    0x7F,0x16
 .db    0x15,0x15
 .db    0x2A,0x85
 .db    0x1A,0x16
 .db    0x41,0x41
 .db    0x16,0x16
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x45,0xC0
 .db    0xC1,0x3B
 .db    0x37,0x37
 .db    0x37,0x62
 .db    0x62,0x62
 .db    0x27,0x37
 .db    0xEA,0xD6
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0x81
 .db    0x1A,0x1A
 .db    0x45,0x41
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x51,0x77
 .db    0xB2,0xB3
 .db    0xB3,0xA3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0x73
 .db    0xB2,0xB2
 .db    0x40,0x40
 .db    0x40,0x15
 .db    0xC1,0xE2
 .db    0x16,0x41
 .db    0x80,0x80
 .db    0x15,0x05
 .db    0x05,0x05
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x40,0x80
 .db    0x45,0x45
 .db    0x1A,0x1A
 .db    0x45,0x15
 .db    0x44,0x19
 .db    0x84,0x84
 .db    0x44,0x84
 .db    0x84,0x1A
 .db    0x15,0x40
 .db    0x40,0x44
 .db    0x19,0x19
 .db    0x19,0x45
 .db    0x63,0x77
 .db    0xD0,0x2A
 .db    0x81,0x27
 .db    0x92,0xD1
 .db    0xD1,0x7B
 .db    0xD6,0xBB
 .db    0xAB,0xD6
 .db    0xA6,0x91
 .db    0x37,0x37
 .db    0x92,0x37
 .db    0x6B,0x7F
 .db    0x7F,0x16
 .db    0x41,0x16
 .db    0x2A,0x85
 .db    0x81,0x45
 .db    0x41,0x15
 .db    0x15,0x41
 .db    0x41,0x41
 .db    0x15,0x40
 .db    0x15,0x85
 .db    0xC0,0x3B
 .db    0x3B,0x3B
 .db    0x37,0x62
 .db    0x62,0x27
 .db    0x27,0x37
 .db    0xEA,0xD6
 .db    0x7B,0x7B
 .db    0x7B,0x7B
 .db    0xC1,0x80
 .db    0x1A,0x45
 .db    0x16,0x15
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x40,0xA2
 .db    0x73,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0x40,0x40
 .db    0x15,0x41
 .db    0x7B,0xE2
 .db    0x45,0x41
 .db    0x15,0x80
 .db    0x45,0x40
 .db    0x00,0x01
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x01,0x15
 .db    0x16,0x16
 .db    0x16,0x16
 .db    0x45,0x15
 .db    0x19,0x19
 .db    0x19,0x19
 .db    0x44,0x84
 .db    0x84,0x19
 .db    0x40,0x40
 .db    0x40,0x19
 .db    0x19,0x19
 .db    0x19,0x1A
 .db    0x62,0x63
 .db    0xA2,0x3B
 .db    0x37,0x27
 .db    0x27,0xD1
 .db    0xD1,0x7B
 .db    0xD6,0xBB
 .db    0xE6,0xD6
 .db    0xD1,0x91
 .db    0x37,0x37
 .db    0x37,0x63
 .db    0x6B,0xD6
 .db    0x7F,0x41
 .db    0x41,0x45
 .db    0x81,0x85
 .db    0x81,0x1A
 .db    0x16,0x15
 .db    0x15,0x41
 .db    0x16,0x45
 .db    0x41,0x15
 .db    0x1A,0x85
 .db    0x85,0x81
 .db    0x2B,0x3B
 .db    0x3B,0x37
 .db    0x62,0x62
 .db    0x27,0x91
 .db    0xEA,0xD6
 .db    0x7B,0x7B
 .db    0xD5,0x7B
 .db    0x3B,0x45
 .db    0x45,0x41
 .db    0x15,0x40
 .db    0x40,0x15
 .db    0x40,0x40
 .db    0x40,0x51
 .db    0xB2,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0x73
 .db    0xB3,0x77
 .db    0x41,0x40
 .db    0x15,0x16
 .db    0x77,0x67
 .db    0x1A,0x45
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x05,0x01
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x01
 .db    0x00,0x40
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x19,0x19
 .db    0x19,0x44
 .db    0x15,0x84
 .db    0x84,0x19
 .db    0x40,0x40
 .db    0x40,0x19
 .db    0x19,0x19
 .db    0x19,0x80
 .db    0x27,0x27
 .db    0x63,0x37
 .db    0x27,0x52
 .db    0x52,0xD1
 .db    0xD1,0xA6
 .db    0xD6,0xE6
 .db    0xAB,0xD6
 .db    0xD1,0x91
 .db    0x37,0x37
 .db    0x37,0x63
 .db    0xD1,0xD6
 .db    0xAA,0x40
 .db    0x41,0x80
 .db    0x2B,0x85
 .db    0x85,0x1A
 .db    0x45,0x41
 .db    0x15,0x15
 .db    0x16,0x45
 .db    0x16,0x16
 .db    0x1A,0x85
 .db    0x85,0x1A
 .db    0x81,0x2F
 .db    0x2B,0x2B
 .db    0x2B,0x56
 .db    0x81,0x91
 .db    0xBB,0xD6
 .db    0x7B,0x7B
 .db    0x7B,0xD1
 .db    0x80,0x16
 .db    0x16,0x15
 .db    0x40,0x40
 .db    0x15,0x16
 .db    0x15,0x15
 .db    0x40,0x40
 .db    0x62,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB2
 .db    0xB3,0x92
 .db    0x41,0x41
 .db    0x16,0x7B
 .db    0xB2,0x81
 .db    0x1A,0x80
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x15,0x00
 .db    0x05,0x01
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x40
 .db    0x00,0x05
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x15,0x19
 .db    0x44,0x40
 .db    0x15,0x1A
 .db    0x1A,0x44
 .db    0x40,0x40
 .db    0x40,0x19
 .db    0x19,0x19
 .db    0x19,0x80
 .db    0x52,0x23
 .db    0x23,0x23
 .db    0x23,0x23
 .db    0x23,0xC1
 .db    0xD1,0x77
 .db    0xD6,0xE6
 .db    0xD6,0xA7
 .db    0x7B,0x37
 .db    0x37,0x62
 .db    0x37,0x62
 .db    0x6B,0xD6
 .db    0x7B,0x40
 .db    0x45,0x2A
 .db    0x85,0x85
 .db    0x85,0x81
 .db    0x1A,0x45
 .db    0x41,0x15
 .db    0x41,0x41
 .db    0x41,0x16
 .db    0x1A,0x85
 .db    0x1A,0x1A
 .db    0x85,0x2F
 .db    0x85,0x80
 .db    0x2A,0x80
 .db    0x80,0x81
 .db    0xBB,0xE6
 .db    0x7B,0xD1
 .db    0x7B,0xC1
 .db    0x16,0x41
 .db    0x16,0x15
 .db    0x40,0x15
 .db    0x16,0x16
 .db    0x15,0x40
 .db    0x40,0x40
 .db    0x40,0xA1
 .db    0xA2,0x73
 .db    0xB3,0xB3
 .db    0xB2,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB2
 .db    0xB3,0xA2
 .db    0x41,0x41
 .db    0xC0,0xB6
 .db    0xD1,0x16
 .db    0x16,0x80
 .db    0x40,0x15
 .db    0x40,0x15
 .db    0x15,0x40
 .db    0x05,0x01
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x01,0x40
 .db    0x05,0x01
 .db    0x01,0x00
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x40,0x15
 .db    0x15,0x40
 .db    0x44,0x1A
 .db    0x45,0x15
 .db    0x40,0x40
 .db    0x15,0x19
 .db    0x19,0x19
 .db    0x19,0x80
 .db    0x27,0x23
 .db    0x23,0x23
 .db    0x23,0x23
 .db    0x52,0x27
 .db    0xD1,0xA2
 .db    0x7B,0xD6
 .db    0xA7,0x7B
 .db    0x7B,0x37
 .db    0x62,0x62
 .db    0x62,0x62
 .db    0x6B,0xD6
 .db    0x7B,0x15
 .db    0x80,0x81
 .db    0x85,0x85
 .db    0x85,0x1A
 .db    0x1A,0x1A
 .db    0x1A,0x16
 .db    0x15,0x40
 .db    0x40,0x41
 .db    0x1A,0x1B
 .db    0x1A,0x4A
 .db    0x2F,0x2F
 .db    0x1E,0x1A
 .db    0x1A,0x45
 .db    0x45,0x56
 .db    0xEA,0xE6
 .db    0x7B,0x7B
 .db    0x7B,0x2B
 .db    0x15,0x15
 .db    0x41,0x15
 .db    0x15,0x16
 .db    0x45,0x16
 .db    0x15,0x40
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x15,0x11
 .db    0xB3,0xB2
 .db    0xB2,0xB3
 .db    0xB3,0xB3
 .db    0xB3,0xB3
 .db    0xF2,0xE6
 .db    0x16,0x80
 .db    0xBB,0xB2
 .db    0x26,0x41
 .db    0x16,0x45
 .db    0x40,0x15
 .db    0x40,0x40
 .db    0x15,0x15
 .db    0x05,0x01
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x40,0x15
 .db    0x40,0x40
 .db    0x00,0x00
 .db    0x01,0x40
 .db    0x05,0x40
 .db    0x40,0x15
 .db    0x15,0x40
 .db    0x19,0x84
 .db    0x19,0x15
 .db    0x40,0x40
 .db    0x44,0x19
 .db    0x19,0x19
 .db    0x19,0x2A
 .db    0x52,0x23
 .db    0x23,0x23
 .db    0x23,0x52
 .db    0x52,0x52
 .db    0xD1,0xA2
 .db    0xA6,0xA7
 .db    0x7B,0x7B
 .db    0xD1,0x37
 .db    0x27,0x27
 .db    0x62,0x62
 .db    0x7B,0x7F
 .db    0x7B,0x45
 .db    0x2A,0x2B
 .db    0x85,0x85
 .db    0x81,0x1A
 .db    0x1A,0x1A
 .db    0x80,0x45
 .db    0x15,0x40
 .db    0x40,0x15
 .db    0x45,0x1A
 .db    0x4A,0x89
 .db    0x8A,0x2F
 .db    0x1A,0x1A
 .db    0x45,0x16
 .db    0x45,0x2B
 .db    0xEA,0xE6
 .db    0x7B,0x7B
 .db    0x6B,0x16
 .db    0x15,0x15
 .db    0x41,0x15
 .db    0x15,0x45
 .db    0x45,0x16
 .db    0x41,0x40
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x40,0x01
 .db    0xA2,0xB2
 .db    0xB2,0xB3
 .db    0xB2,0xB3
 .db    0xB3,0xB3
 .db    0xF2,0xF2
 .db    0xBA,0xE6
 .db    0xB2,0xD1
 .db    0x41,0x41
 .db    0x41,0x16
 .db    0x40,0x15
 .db    0x40,0x40
 .db    0x40,0x15
 .db    0x15,0x40
 .db    0x40,0x40
 .db    0x40,0x15
 .db    0x2A,0x3F
 .db    0x15,0x40
 .db    0x05,0x00
 .db    0x00,0x00
 .db    0x01,0x01
 .db    0x40,0x40
 .db    0x15,0x15
 .db    0x84,0x84
 .db    0x19,0x40
 .db    0x40,0x40
 .db    0x44,0x19
 .db    0x19,0x19
 .db    0x80,0x81
 .db    0x52,0x23
 .db    0x23,0x23
 .db    0x52,0x52
 .db    0x52,0x27
 .db    0xC1,0xA2
 .db    0x77,0x7B
 .db    0x7B,0x7B
 .db    0xD1,0x37
 .db    0x27,0x27
 .db    0x62,0x37
 .db    0x7B,0x7F
 .db    0x7B,0x1A
 .db    0x2A,0x85
 .db    0x85,0x2B
 .db    0x2A,0x45
 .db    0x1A,0x81
 .db    0x80,0x1A
 .db    0x45,0x15
 .db    0x40,0x15
 .db    0x45,0x1A
 .db    0x85,0x8A
 .db    0x8A,0x2F
 .db    0x1A,0x1A
 .db    0x16,0x16
 .db    0x1A,0x2B
 .db    0xEA,0xE6
 .db    0xA6,0x7B
 .db    0x3B,0x15
 .db    0x15,0x15
 .db    0x41,0x41
 .db    0x41,0x16
 .db    0x16,0x16
 .db    0x41,0x40
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x01,0x01
 .db    0x51,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB3,0xB3
 .db    0xE2,0xB2
 .db    0xB2,0x27
 .db    0x40,0x15
 .db    0x41,0x15
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x80,0x15
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0xD5,0x7F
 .db    0x2B,0x40
 .db    0x40,0x40
 .db    0x40,0x00
 .db    0x00,0x40
 .db    0x05,0x40
 .db    0x15,0x44
 .db    0x84,0x84
 .db    0x19,0x40
 .db    0x40,0x40
 .db    0x44,0x19
 .db    0x44,0x19
 .db    0x80,0x91
 .db    0x27,0x27
 .db    0x27,0x27
 .db    0x27,0x27
 .db    0x27,0x52
 .db    0x2A,0xD1
 .db    0xD1,0x7B
 .db    0xA6,0x7B
 .db    0x77,0x37
 .db    0x27,0x27
 .db    0x27,0x37
 .db    0x7B,0x7F
 .db    0x7B,0x55
 .db    0x2B,0x85
 .db    0x2B,0x2A
 .db    0x45,0x16
 .db    0x45,0x1A
 .db    0x1A,0x45
 .db    0x1A,0x45
 .db    0x15,0x15
 .db    0x45,0x1A
 .db    0x85,0x8A
 .db    0x8A,0x2F
 .db    0x1A,0x45
 .db    0x15,0x1A
 .db    0x85,0xC1
 .db    0xEA,0xE6
 .db    0xA6,0xA6
 .db    0x80,0x15
 .db    0x15,0x15
 .db    0x41,0x41
 .db    0x15,0x41
 .db    0x16,0x45
 .db    0x16,0x40
 .db    0x40,0x40
 .db    0x05,0x40
 .db    0x01,0x01
 .db    0x40,0x77
 .db    0xB2,0xE1
 .db    0x62,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0xB2,0xB2
 .db    0x91,0x16
 .db    0x40,0x15
 .db    0x41,0x15
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x7F,0xD5
 .db    0xD5,0x15
 .db    0x40,0x40
 .db    0x40,0x00
 .db    0x01,0x40
 .db    0x01,0x40
 .db    0x15,0x19
 .db    0x84,0x84
 .db    0x19,0x40
 .db    0x40,0x40
 .db    0x44,0x19
 .db    0x44,0x19
 .db    0x84,0x85
 .db    0x3B,0x91
 .db    0x91,0x81
 .db    0x81,0x81
 .db    0x55,0x1A
 .db    0x45,0x3F
 .db    0xA6,0x7B
 .db    0x77,0x7B
 .db    0xA2,0x62
 .db    0x27,0x27
 .db    0x62,0x62
 .db    0x7B,0x7B
 .db    0x7B,0x2A
 .db    0x56,0x85
 .db    0x2A,0x45
 .db    0x41,0x41
 .db    0x45,0x45
 .db    0x16,0x15
 .db    0x45,0x1A
 .db    0x15,0x15
 .db    0x45,0x1A
 .db    0x85,0x8A
 .db    0x8A,0x89
 .db    0x85,0x45
 .db    0x15,0x1A
 .db    0x2F,0xC1
 .db    0xEA,0xE6
 .db    0xD1,0x6B
 .db    0x15,0x41
 .db    0x41,0x15
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0x16,0x1A
 .db    0x16,0x15
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x01,0x01
 .db    0x40,0x26
 .db    0xD1,0x26
 .db    0x15,0x26
 .db    0xA1,0xB2
 .db    0xB2,0xB2
 .db    0x77,0x27
 .db    0x16,0x16
 .db    0x40,0x15
 .db    0x41,0x15
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x15,0x16
 .db    0x15,0x15
 .db    0x15,0x15
 .db    0xEA,0x7F
 .db    0xD5,0x15
 .db    0x40,0x40
 .db    0x01,0x40
 .db    0x40,0x15
 .db    0x05,0x40
 .db    0x40,0x19
 .db    0x84,0x84
 .db    0x19,0x40
 .db    0x40,0x40
 .db    0x44,0x19
 .db    0x44,0x19
 .db    0x84,0x84
 .db    0xC0,0x2E
 .db    0x2E,0x84
 .db    0x84,0x55
 .db    0x1A,0x45
 .db    0x45,0x80
 .db    0x7B,0x7B
 .db    0x77,0xA6
 .db    0xA2,0x62
 .db    0x27,0x52
 .db    0x62,0x37
 .db    0x7B,0x7B
 .db    0x7B,0x80
 .db    0x2A,0x81
 .db    0x80,0x15
 .db    0x15,0x15
 .db    0x16,0x15
 .db    0x40,0x40
 .db    0x45,0x1A
 .db    0x16,0x41
 .db    0x1A,0x1A
 .db    0x4A,0x8A
 .db    0x8A,0x89
 .db    0x85,0x45
 .db    0x15,0x85
 .db    0x8A,0x6B
 .db    0xEA,0xE6
 .db    0x7B,0xC0
 .db    0x40,0x41
 .db    0x16,0x15
 .db    0x15,0x15
 .db    0x15,0x40
 .db    0x16,0x1A
 .db    0x16,0x15
 .db    0x15,0x15
 .db    0x15,0x40
 .db    0x01,0x01
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x15,0x81
 .db    0x91,0x91
 .db    0x16,0x41
 .db    0x41,0x41
 .db    0x40,0x15
 .db    0x41,0x40
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x15,0x80
 .db    0x16,0x15
 .db    0x15,0x15
 .db    0xD5,0xE6
 .db    0x81,0x15
 .db    0x15,0x15
 .db    0x15,0x80
 .db    0x80,0x16
 .db    0x40,0x40
 .db    0x40,0x19
 .db    0x84,0x84
 .db    0x44,0x40
 .db    0x40,0x40
 .db    0x44,0x44
 .db    0x19,0x19
 .db    0x84,0x84
 .db    0x2E,0x2E
 .db    0x2E,0x2E
 .db    0x2E,0x49
 .db    0x1A,0x19
 .db    0x1A,0x45
 .db    0x3F,0x7B
 .db    0xD1,0xA6
 .db    0xA2,0x37
 .db    0x27,0x27
 .db    0x37,0x37
 .db    0xD6,0x7B
 .db    0x7B,0x45
 .db    0x80,0x80
 .db    0x41,0x40
 .db    0x40,0x15
 .db    0x15,0x40
 .db    0x05,0x40
 .db    0x45,0x1A
 .db    0x16,0x16
 .db    0x2A,0x1A
 .db    0x85,0x89
 .db    0x89,0x5E
 .db    0x2F,0x45
 .db    0x45,0x85
 .db    0x8A,0xC1
 .db    0xEA,0xE6
 .db    0x7B,0x80
 .db    0x40,0x15
 .db    0x41,0x15
 .db    0x15,0x15
 .db    0x40,0x40
 .db    0x16,0x45
 .db    0x16,0x41
 .db    0x16,0x16
 .db    0x41,0x40
 .db    0x01,0x01
 .db    0x05,0x01
 .db    0x01,0x40
 .db    0x40,0x40
 .db    0x40,0x15
 .db    0x16,0x15
 .db    0x15,0x16
 .db    0x41,0x40
 .db    0x40,0x40
 .db    0x15,0x40
 .db    0x15,0x40
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x15,0x80
 .db    0x16,0x16
 .db    0x16,0x40
 .db    0x80,0x80
 .db    0x80,0x45
 .db    0x15,0x15
 .db    0x80,0x16
 .db    0x15,0x40
 .db    0x40,0x40
 .db    0x40,0x19
 .db    0x84,0x84
 .db    0x15,0x40
 .db    0x40,0x15
 .db    0x44,0x44
 .db    0x19,0x1D
 .db    0x84,0x84
 .db    0x84,0x59
 .db    0x2E,0x2E
 .db    0x84,0x84
 .db    0x1A,0x45
 .db    0x1A,0x45
 .db    0x45,0x96
 .db    0x7B,0x7B
 .db    0xA2,0x37
 .db    0x27,0x27
 .db    0x62,0x37
 .db    0xD6,0x7B
 .db    0x7B,0x45
 .db    0x80,0x80
 .db    0x41,0x40
 .db    0x40,0x15
 .db    0x15,0x40
 .db    0x05,0x40
 .db    0x45,0x1A
 .db    0x16,0x16
 .db    0x2A,0x1A
 .db    0x85,0x89
 .db    0x89,0x5E
 .db    0x2F,0x45
 .db    0x45,0x85
 .db    0x8A,0xC1
 .db    0xEA,0xE6
 .db    0x7B,0x80
 .db    0x40,0x15
 .db    0x41,0x15
 .db    0x15,0x15
 .db    0x40,0x40
 .db    0x16,0x45
 .db    0x16,0x41
 .db    0x16,0x16
 .db    0x41,0x40
 .db    0x01,0x01
 .db    0x05,0x01
 .db    0x01,0x40
 .db    0x40,0x40
 .db    0x40,0x15
 .db    0x16,0x15
 .db    0x15,0x16
 .db    0x41,0x40
 .db    0x40,0x40
 .db    0x15,0x40
 .db    0x15,0x40
 .db    0x40,0x40
 .db    0x40,0x40
 .db    0x15,0x80
 .db    0x16,0x16
 .db    0x16,0x40
 .db    0x80,0x80
 .db    0x80,0x45
 .db    0x15,0x15
 .db    0x80,0x16
 .db    0x15,0x40
 .db    0x40,0x40
 .db    0x40,0x19
 .db    0x84,0x84
 .db    0x15,0x40
 .db    0x40,0x15
 .db    0x44,0x44
 .db    0x19,0x1D
 .db    0x84,0x84
 .db    0x84,0x59
 .db    0x2E,0x2E
 .db    0x84,0x84
 .db    0x1A,0x45
 .db    0x1A,0x45
 .db    0x45,0x96
 .db    0x7B,0x7B
 .db    0xA2,0x37
 .db    0x27,0x27
 .db    0x62,0x37
 .db    0xD6,0x7B
 .db    0x7B,0x00
 
KREIS2A:
 .db    0x00,0x1A
 .db    0x10,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0xFB,0xFB
 .db    0xF7,0xF7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0xFB
 .db    0xFB,0xFB
 .db    0xFB,0xF7
 .db    0xF7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0xFB,0xFB
 .db    0xFB,0xF7
 .db    0xF7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0xFB
 .db    0xFB,0xF7
 .db    0xF7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0x00
 .db    0x00,0x00
 .db    0xFB,0xFB
 .db    0xF7,0xF7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0x00,0x00
 .db    0xA7,0xF7
 .db    0xF7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0x00,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0x00
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0x63,0x63
 .db    0x00,0x00
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0x63
 .db    0x22,0x22
 .db    0x00,0x00
 .db    0x00,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0x63,0x22
 .db    0x22,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0x63,0x63
 .db    0x22,0x22
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0x63,0x63
 .db    0x63,0x22
 .db    0x22,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0xA7,0x63
 .db    0x63,0x22
 .db    0x22,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0xA7,0xA7
 .db    0xA7,0xA7
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 .db    0x00,0x00
 
SINTAB:
 .dw    0x0000,0x0203
 .dw    0x0405,0x0608
 .dw    0x080B,0x0A0D
 .dw    0x0C0F,0x0E11
 .dw    0x1013,0x1215
 .dw    0x1416,0x1617
 .dw    0x1817,0x1A18
 .dw    0x1C17,0x1E17
 .dw    0x2016,0x2214
 .dw    0x2412,0x260F
 .dw    0x280C,0x2A08
 .dw    0x2C03,0x2DFE
 .dw    0x2FF8,0x31F1
 .dw    0x33EA,0x35E1
 .dw    0x37D8,0x39CE
 .dw    0x3BC3,0x3DB7
 .dw    0x3FAA,0x419C
 .dw    0x438D,0x457D
 .dw    0x476C,0x4959
 .dw    0x4B46,0x4D31
 .dw    0x4F1B,0x5104
 .dw    0x52EC,0x54D2
 .dw    0x56B7,0x589B
 .dw    0x5A7D,0x5C5E
 .dw    0x5E3D,0x601B
 .dw    0x61F7,0x63D2
 .dw    0x65AB,0x6783
 .dw    0x6959,0x6B2D
 .dw    0x6CFF,0x6ED0
 .dw    0x709F,0x726D
 .dw    0x7438,0x7602
 .dw    0x77CA,0x7990
 .dw    0x7B54,0x7D16
 .dw    0x7ED6,0x8094
 .dw    0x8250,0x840A
 .dw    0x85C2,0x8778
 .dw    0x892B,0x8ADD
 .dw    0x8C8C,0x8E39
 .dw    0x8FE4,0x918D
 .dw    0x9333,0x94D7
 .dw    0x9679,0x9818
 .dw    0x99B5,0x9B4F
 .dw    0x9CE7,0x9E7C
 .dw    0xA00F,0xA1A0
 .dw    0xA32E,0xA4B9
 .dw    0xA642,0xA7C8
 .dw    0xA94B,0xAACC
 .dw    0xAC4A,0xADC5
 .dw    0xAF3E,0xB0B4
 .dw    0xB227,0xB397
 .dw    0xB504,0xB66F
 .dw    0xB7D6,0xB93B
 .dw    0xBA9D,0xBBFC
 .dw    0xBD58,0xBEB1
 .dw    0xC007,0xC159
 .dw    0xC2A9,0xC3F6
 .dw    0xC540,0xC686
 .dw    0xC7CA,0xC90A
 .dw    0xCA47,0xCB81
 .dw    0xCCB7,0xCDEB
 .dw    0xCF1B,0xD048
 .dw    0xD171,0xD298
 .dw    0xD3BB,0xD4DA
 .dw    0xD5F7,0xD710
 .dw    0xD825,0xD937
 .dw    0xDA46,0xDB51
 .dw    0xDC59,0xDD5D
 .dw    0xDE5E,0xDF5B
 .dw    0xE055,0xE14B
 .dw    0xE23E,0xE32D
 .dw    0xE418,0xE500
 .dw    0xE5E4,0xE6C5
 .dw    0xE7A2,0xE87B
 .dw    0xE951,0xEA23
 .dw    0xEAF1,0xEBBC
 .dw    0xEC82,0xED46
 .dw    0xEE05,0xEEC0
 .dw    0xEF78,0xF02C
 .dw    0xF0DD,0xF189
 .dw    0xF232,0xF2D7
 .dw    0xF377,0xF415
 .dw    0xF4AE,0xF543
 .dw    0xF5D5,0xF663
 .dw    0xF6EC,0xF772
 .dw    0xF7F4,0xF872
 .dw    0xF8EC,0xF962
 .dw    0xF9D5,0xFA43
 .dw    0xFAAD,0xFB14
 .dw    0xFB76,0xFBD5
 .dw    0xFC2F,0xFC86
 .dw    0xFCD8,0xFD27
 .dw    0xFD71,0xFDB8
 .dw    0xFDFA,0xFE39
 .dw    0xFE73,0xFEAA
 .dw    0xFEDC,0xFF0B
 .dw    0xFF35,0xFF5B
 .dw    0xFF7E,0xFF9C
 .dw    0xFFB6,0xFFCC
 .dw    0xFFDF,0xFFED
 .dw    0xFFF7,0xFFFD
 .dw    0xFFFF,0x0000
 
; *** Konstanten-STRING-Liste ***
;
 
M_CONST_STRING_0:
 .db    0, " "
 
M_CONST_STRING_1:
 .db    0, " "
 
