; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: BC.PAS
 
.nolist
.INCLUDE "m1284Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        UBRR_VAL  =  0x0008 ; WORD
.equ        XON  =  0x11 ; BYTE
.equ        XOFF  =  0x13 ; BYTE
.equ        KEIN_CODE  =  0x00 ; BYTE
.equ        LOAD_ADRESS  =  0x01 ; BYTE
.equ        INC_ADRESS  =  0x02 ; BYTE
.equ        ADRESS_TRISTATE  =  0x03 ; BYTE
.equ        WAIT_Z80TOBUF  =  0x04 ; BYTE
.equ        WAIT_BUFTOBC  =  0x05 ; BYTE
.equ        BC_CONIN  =  0x01 ; BYTE
.equ        BC_CONST  =  0x02 ; BYTE
.equ        BC_CONOUT  =  0x03 ; BYTE
.equ        BC_LIST  =  0x04 ; BYTE
.equ        BC_COPY_BDOS  =  0x05 ; BYTE
.equ        BC_COPY_CCP  =  0x06 ; BYTE
.equ        BC_READ_SEC  =  0x07 ; BYTE
.equ        BC_WRITE_SEC  =  0x08 ; BYTE
.equ        BC_TRACE_Z80  =  0x09 ; BYTE
.equ        BC_SET_TIME  =  0x0A ; BYTE
.equ        CPM_SPT  =  0x48 ; BYTE
.equ        RF_FUELLBYTE  =  0xE5 ; BYTE
.equ        BB_LAENGE  =  0x0384 ; WORD
.equ        BB_LAENGE_DIV_3  =  0x012C ; WORD
.equ        RAM_Z80_HIGH  =  0xF4 ; BYTE
.equ        RAM_Z80CALL_MD  =  0xC6 ; BYTE
.equ        RAM_Z80CALL_P1  =  0xC7 ; BYTE
.equ        RAM_Z80CALL_P2  =  0xC8 ; BYTE
.equ        RAM_Z80CALL_P3  =  0xC9 ; BYTE
.equ        RAM_Z80CALL_P4  =  0xCA ; BYTE
.equ        RAM_Z80CALL_P5  =  0xCB ; BYTE
.equ        RAM_Z80CALL_P6  =  0xCC ; BYTE
.equ        SECTOR_ADRESS_HI  =  0xF4 ; BYTE
.equ        SECTOR_ADRESS_LO  =  0x3A ; BYTE
.equ        BDOS_ADRESS_HI  =  0xE6 ; BYTE
.equ        CCP_ADRESS_HI  =  0xDE ; BYTE
.equ        LAENGE_CPD5_ARRAY  =  0x0B7F ; WORD
.equ        LAENGE_ZSDOS_ARRAY  =  0x0DFF ; WORD
.equ        LAENGE_CCP_ARRAY  =  0x07FF ; WORD
.equ        LAENGE_DISK_ARRAY  =  0x641F ; WORD
 
; *** Variablentabelle ***
 
.dseg
 
ZEICHEN:   ; Byte
.byte     1
LOOP_IN:   ; Boolean
.byte     1
CONSOLEIN:   ; Byte
.byte     1
STEUER_STRING:   ; String(50)
.byte     1     ; STRING-Laenge
.byte     50
ANZEIGE_STRING:   ; String(50)
.byte     1     ; STRING-Laenge
.byte     50
SECTOR:   ; Byte
.byte     1
TRACK_L:   ; Byte
.byte     1
TRACK_H:   ; Byte
.byte     1
DISKNO:   ; Byte
.byte     1
DMAAD_L:   ; Byte
.byte     1
DMAAD_H:   ; Byte
.byte     1
SEKTOR_PUFFER_ZEIGER:   ; Word
.byte     2
RF_15:   ; Byte
.byte     1
RF_08:   ; Byte
.byte     1
RF_00:   ; Byte
.byte     1
DATUM_GESETZT:   ; Boolean
.byte     1
SCB_DATE_HI:   ; Byte
.byte     1
SCB_DATE_LO:   ; Byte
.byte     1
DATEN_ARRAY:   ; Adresse
.byte     3
LAENGE_ARRAY:   ; Word
.byte     2
WRITE_STRING:   ; String(50)
.byte     1     ; STRING-Laenge
.byte     50
 
SEKTOR_PUFFER:
.byte     128
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; FUNCTION - Anfang (BYTEPOSTOORMASKE)
BYTEPOSTOORMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_03
        RJMP       M_CASE_02
M_CASE_03:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_02:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_05
        RJMP       M_CASE_04
M_CASE_05:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x02
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_04:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_07
        RJMP       M_CASE_06
M_CASE_07:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x04
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_06:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_09
        RJMP       M_CASE_08
M_CASE_09:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x08
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_08:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_011
        RJMP       M_CASE_010
M_CASE_011:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x10
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_010:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_013
        RJMP       M_CASE_012
M_CASE_013:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x20
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_012:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_015
        RJMP       M_CASE_014
M_CASE_015:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x40
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_014:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_017
        RJMP       M_CASE_016
M_CASE_017:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x80
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
 
; CASE OF ELSE
M_CASE_016:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; ENDCASE;
M_CASE_01:
 
; Ende Byte - FUNCTION (BYTEPOSTOORMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOORMASKE)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOANDMASKE)
BYTEPOSTOANDMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_020
        RJMP       M_CASE_019
M_CASE_020:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_019:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_022
        RJMP       M_CASE_021
M_CASE_022:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFD
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_021:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_024
        RJMP       M_CASE_023
M_CASE_024:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFB
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_023:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_026
        RJMP       M_CASE_025
M_CASE_026:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xF7
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_025:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_028
        RJMP       M_CASE_027
M_CASE_028:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xEF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_027:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_030
        RJMP       M_CASE_029
M_CASE_030:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xDF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_029:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_032
        RJMP       M_CASE_031
M_CASE_032:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xBF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_031:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_034
        RJMP       M_CASE_033
M_CASE_034:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0x7F
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
 
; CASE OF ELSE
M_CASE_033:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; ENDCASE;
M_CASE_018:
 
; Ende Byte - FUNCTION (BYTEPOSTOANDMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOANDMASKE)
        RET
 
; FUNCTION - Anfang (READ_BIT_IN_BYTE)
READ_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (READ_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (READ_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_038
        CLR        R16
        RJMP       M_VERGL_039
M_VERGL_038:
        SER        R16
M_VERGL_039:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_035
        RJMP       M_IF_036
M_IF_035:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0x00
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_037
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_036:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0xFF
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_037:
 
; Ende Byte - FUNCTION (READ_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (READ_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (SET_BIT_IN_BYTE)
SET_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (SET_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (SET_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (CLEAR_BIT_IN_BYTE)
CLEAR_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOANDMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOANDMASKE)
        CALL       BYTEPOSTOANDMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (CLEAR_BIT_IN_BYTE)
        RET
 
; PROCEDURE - Anfang (WAIT_MS)
WAIT_MS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (ZEIT)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_040:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_041
        RJMP       M_FTD_042
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_041:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x02D0)
        LDI        R16, LOW(0x02D0)
        LDI        R17, HIGH(0x02D0)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_043:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_044
        RJMP       M_FTD_045
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_044:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_043
 
; FOR TO DO - Ende
M_FTD_045:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_040
 
; FOR TO DO - Ende
M_FTD_042:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (WAIT_MS)
        RET
 
; PROCEDURE - Anfang (INIT_SER_PORT)
INIT_SER_PORT:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (UBRR_VAL)
        LDI        R16, LOW(0x0008)
        LDI        R17, HIGH(0x0008)
 
; Zuweisung Ziel /  VAR (UBRR0)
        STS        UBRR0, R16
        STS        UBRR0+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x18)
        LDI        R16, 0x18
 
; Zuweisung Ziel /  VAR (UCSR0B)
        STS        UCSR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x86)
        LDI        R16, 0x86
 
; Zuweisung Ziel /  VAR (UCSR0C)
        STS        UCSR0C, R16
 
; PROCEDURE - Ende (INIT_SER_PORT)
        RET
 
; PROCEDURE - Anfang (RX_PUFFER_ABFRAGEN)
RX_PUFFER_ABFRAGEN:
 
; IF THEN - Ausdruck /; BitHigh(RXC0)
        LDS        R16, UCSR0A
        BST        R16, 7
        BRTS       M_VERGL_049
        CLR        R16
        RJMP       M_VERGL_050
M_VERGL_049:
        SER        R16
M_VERGL_050:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_046
        RJMP       M_IF_047
M_IF_046:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (UDR0)
        LDS        R16, UDR0
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_048
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_047:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; IF_THEN_ELSE - Ende
M_IF_048:
 
; PROCEDURE - Ende (RX_PUFFER_ABFRAGEN)
        RET
 
; PROCEDURE - Anfang (SENDE_ZEICHEN)
SENDE_ZEICHEN:
 
; WHILE DO ...
M_WHILE_051:
 
; WHILE - Ausdruck /; BitLow(UDRE0)
        LDS        R16, UCSR0A
        BST        R16, 5
        BRTC       M_VERGL_054
        CLR        R16
        RJMP       M_VERGL_055
M_VERGL_054:
        SER        R16
M_VERGL_055:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_052
        RJMP       M_WHILE_053
M_WHILE_052:
 
; SetBit(LED_GRUEN)
        SBI        PORTD, 6
 
; WHILE DO ...
        RJMP       M_WHILE_051
M_WHILE_053:
 
; ClearBit(LED_GRUEN)
        CBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (S_ZEICHEN)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (UDR0)
        STS        UDR0, R16
 
; PROCEDURE - Ende (SENDE_ZEICHEN)
        RET
 
; PROCEDURE - Anfang (SENDE_HEX_ZEICHEN)
SENDE_HEX_ZEICHEN:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_ZEICHEN)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_059
        CLR        R16
        RJMP       M_VERGL_060
M_VERGL_059:
        SER        R16
M_VERGL_060:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_056
        RJMP       M_IF_057
M_IF_056:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_058
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_057:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_058:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (HEXHIGH) retten
        MOV        R18, R2
 
; lokalen Parameter (HEXHIGH) an Prozedur (SENDE_ZEICHEN)
        MOV        R0, R18
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_ZEICHEN)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_064
        CLR        R16
        RJMP       M_VERGL_065
M_VERGL_064:
        SER        R16
M_VERGL_065:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_061
        RJMP       M_IF_062
M_IF_061:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_063
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_062:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_063:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (HEXLOW) retten
        MOV        R17, R1
 
; lokalen Parameter (HEXLOW) an Prozedur (SENDE_ZEICHEN)
        MOV        R0, R17
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x48
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN)
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (SENDE_HEX_ZEICHEN)
        RET
 
; PROCEDURE - Anfang (SENDE_HEX_ZEICHEN_LN)
SENDE_HEX_ZEICHEN_LN:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        PUSH       R0
 
; Aufruf PROCEDURE (SENDE_HEX_ZEICHEN)
        CALL       SENDE_HEX_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x0A
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_HEX_ZEICHEN_LN)
        POP        R0
 
; PROCEDURE - Ende (SENDE_HEX_ZEICHEN_LN)
        RET
 
; PROCEDURE - Anfang (WRITE)
WRITE:
 
; Zuweisung Quelle - Ausdruck / Length(WRITE_STRING)
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R1
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_066:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_067
        RJMP       M_FTD_068
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_067:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (B2) retten
        MOV        R19, R3
 
; lokalen Parameter (B2) an Prozedur (SENDE_ZEICHEN)
        MOV        R0, R19
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_066
 
; FOR TO DO - Ende
M_FTD_068:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (WRITE)
        RET
 
; PROCEDURE - Anfang (WRITELN)
WRITELN:
 
; Aufruf PROCEDURE (WRITE)
        CALL       WRITE
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x0A
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; PROCEDURE - Ende (WRITELN)
        RET
 
; PROCEDURE - Anfang (BYTETOSTRING)
BYTETOSTRING:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_072
        CLR        R16
        RJMP       M_VERGL_073
M_VERGL_072:
        SER        R16
M_VERGL_073:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_069
        RJMP       M_IF_070
M_IF_069:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_071
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_070:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_071:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_074
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_074:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_076
        MOV        R16, R17
M_PRG_CONST_STRING_075:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_075
M_PRG_CONST_STRING_076:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_080
        CLR        R16
        RJMP       M_VERGL_081
M_VERGL_080:
        SER        R16
M_VERGL_081:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_077
        RJMP       M_IF_078
M_IF_077:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_079
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_078:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_079:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXLOW)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_082
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_082:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_084
M_PRG_CONST_STRING_083:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_083
M_PRG_CONST_STRING_084:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_085
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_085:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_087
        MOV        R16, R17
M_PRG_CONST_STRING_086:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_086
M_PRG_CONST_STRING_087:
        ST         -Z, R17
 
; PROCEDURE - Ende (BYTETOSTRING)
        RET
 
; FUNCTION - Anfang (STRINGTOBYTE)
STRINGTOBYTE:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_091
        CLR        R16
        RJMP       M_VERGL_092
M_VERGL_091:
        SER        R16
M_VERGL_092:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_088
        RJMP       M_IF_089
M_IF_088:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN - Ende
M_IF_089:
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_096
        CLR        R16
        RJMP       M_VERGL_097
M_VERGL_096:
        SER        R16
M_VERGL_097:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_093
        RJMP       M_IF_094
M_IF_093:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_094:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (STRINGTOBYTE)
        MOV        R0, R3
 
; Ende Byte - FUNCTION (STRINGTOBYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (STRINGTOBYTE)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0E)
        LDI        R16, 0x0E
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x3E)
        LDI        R16, 0x3E
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x7E)
        LDI        R16, 0x7E
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x3E)
        LDI        R16, 0x3E
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x24)
        LDI        R16, 0x24
 
; Zuweisung Ziel /  VAR (PORTD)
        OUT        PORTD, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xE6)
        LDI        R16, 0xE6
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x24)
        LDI        R16, 0x24
 
; Zuweisung Ziel /  VAR (PORTD)
        OUT        PORTD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; PROCEDURE - Anfang (INIT_DATEN_ARRAY)
INIT_DATEN_ARRAY:
 
; Zuweisung Quelle - Ausdruck / ArrayToAdress(CPD5_ARR)
        LDI        R16, LOW(2*CPD5_ARR)
        LDI        R17, HIGH(2*CPD5_ARR)
        LDI        R18, Byte3(2*CPD5_ARR)
 
; Zuweisung Ziel /  VAR (DATEN_ARRAY)
        STS        DATEN_ARRAY, R16
        STS        DATEN_ARRAY+1, R17
        STS        DATEN_ARRAY+2, R18
 
; PROCEDURE - Ende (INIT_DATEN_ARRAY)
        RET
 
; PROCEDURE - Anfang (AE_WRITE_BYTE)
AE_WRITE_BYTE:
 
; WHILE DO ...
M_WHILE_098:
 
; WHILE - Ausdruck /; BitLow(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTC       M_VERGL_0101
        CLR        R16
        RJMP       M_VERGL_0102
M_VERGL_0101:
        SER        R16
M_VERGL_0102:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_099
        RJMP       M_WHILE_0100
M_WHILE_099:
 
; WHILE DO ...
        RJMP       M_WHILE_098
M_WHILE_0100:
 
; ClearBit(AECMD_A)
        CBI        PORTB, 1
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (WR_BYTE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; ClearBit(AECS_A)
        CBI        PORTD, 2
 
; WHILE DO ...
M_WHILE_0103:
 
; WHILE - Ausdruck /; BitHigh(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTS       M_VERGL_0106
        CLR        R16
        RJMP       M_VERGL_0107
M_VERGL_0106:
        SER        R16
M_VERGL_0107:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0104
        RJMP       M_WHILE_0105
M_WHILE_0104:
 
; WHILE DO ...
        RJMP       M_WHILE_0103
M_WHILE_0105:
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(AECMD_A)
        SBI        PORTB, 1
 
; PROCEDURE - Ende (AE_WRITE_BYTE)
        RET
 
; PROCEDURE - Anfang (AE_WRITE_ADRESS)
AE_WRITE_ADRESS:
 
; Retten der lokalen Parameter fuer PROCEDURE (AE_WRITE_ADRESS)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_BYTE)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (AE_WRITE_BYTE)
        CALL       AE_WRITE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (AE_WRITE_ADRESS)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AE_WRITE_ADRESS)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (A00) retten
        MOV        R18, R2
 
; lokalen Parameter (A00) an Prozedur (AE_WRITE_BYTE)
        MOV        R0, R18
 
; Aufruf PROCEDURE (AE_WRITE_BYTE)
        CALL       AE_WRITE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (AE_WRITE_ADRESS)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AE_WRITE_ADRESS)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (A08) retten
        MOV        R17, R1
 
; lokalen Parameter (A08) an Prozedur (AE_WRITE_BYTE)
        MOV        R0, R17
 
; Aufruf PROCEDURE (AE_WRITE_BYTE)
        CALL       AE_WRITE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (AE_WRITE_ADRESS)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AE_WRITE_ADRESS)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (AE_WRITE_BYTE)
        CALL       AE_WRITE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (AE_WRITE_ADRESS)
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (AE_WRITE_ADRESS)
        RET
 
; PROCEDURE - Anfang (RAM_LOESCHEN)
RAM_LOESCHEN:
 
; SetBit(LED_ROT)
        SBI        PORTD, 7
 
; Retten der lokalen Parameter fuer PROCEDURE (RAM_LOESCHEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R1, R16
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R2, R16
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (RAM_LOESCHEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(RD_A)
        SBI        PORTC, 3
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; SetBit(MREQ_A)
        SBI        PORTC, 1
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; SetBit(AECMD_A)
        SBI        PORTB, 1
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE_00_15)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE_16_18)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LOOP_IN)
        STS        LOOP_IN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (RAM_LOESCHEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_BYTE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (AE_WRITE_BYTE)
        CALL       AE_WRITE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (RAM_LOESCHEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (RF_FUELLBYTE)
        LDI        R16, 0xE5
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE_16_18)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0F)
        LDI        R16, 0x0F
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0108:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0109
        RJMP       M_FTD_0110
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0109:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE_00_15)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x8FFF)
        LDI        R16, LOW(0x8FFF)
        LDI        R17, HIGH(0x8FFF)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0111:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0112
        RJMP       M_FTD_0113
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0112:
 
; IF THEN - Ausdruck / Byte-VAR (LOOP_IN)
        LDS        R16, LOOP_IN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0114
        RJMP       M_IF_0115
M_IF_0114:
 
; WHILE DO ...
M_WHILE_0117:
 
; WHILE - Ausdruck /; BitHigh(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTS       M_VERGL_0120
        CLR        R16
        RJMP       M_VERGL_0121
M_VERGL_0120:
        SER        R16
M_VERGL_0121:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0118
        RJMP       M_WHILE_0119
M_WHILE_0118:
 
; WHILE DO ...
        RJMP       M_WHILE_0117
M_WHILE_0119:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0116
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0115:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (LOOP_IN)
        STS        LOOP_IN, R16
 
; IF_THEN_ELSE - Ende
M_IF_0116:
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; ClearBit(MREQ_A)
        CBI        PORTC, 1
 
; ClearBit(WR_A)
        CBI        PORTC, 4
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(MREQ_A)
        SBI        PORTC, 1
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; WHILE DO ...
M_WHILE_0122:
 
; WHILE - Ausdruck /; BitLow(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTC       M_VERGL_0125
        CLR        R16
        RJMP       M_VERGL_0126
M_VERGL_0125:
        SER        R16
M_VERGL_0126:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0123
        RJMP       M_WHILE_0124
M_WHILE_0123:
 
; WHILE DO ...
        RJMP       M_WHILE_0122
M_WHILE_0124:
 
; ClearBit(AECS_A)
        CBI        PORTD, 2
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0111
 
; FOR TO DO - Ende
M_FTD_0113:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0108
 
; FOR TO DO - Ende
M_FTD_0110:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; WHILE DO ...
M_WHILE_0127:
 
; WHILE - Ausdruck /; BitHigh(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTS       M_VERGL_0130
        CLR        R16
        RJMP       M_VERGL_0131
M_VERGL_0130:
        SER        R16
M_VERGL_0131:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0128
        RJMP       M_WHILE_0129
M_WHILE_0128:
 
; WHILE DO ...
        RJMP       M_WHILE_0127
M_WHILE_0129:
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; SetBit(RD_A)
        SBI        PORTC, 3
 
; WHILE DO ...
M_WHILE_0132:
 
; WHILE - Ausdruck /; BitLow(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTC       M_VERGL_0135
        CLR        R16
        RJMP       M_VERGL_0136
M_VERGL_0135:
        SER        R16
M_VERGL_0136:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0133
        RJMP       M_WHILE_0134
M_WHILE_0133:
 
; WHILE DO ...
        RJMP       M_WHILE_0132
M_WHILE_0134:
 
; ClearBit(LED_ROT)
        CBI        PORTD, 7
 
; PROCEDURE - Ende (RAM_LOESCHEN)
        RET
 
; PROCEDURE - Anfang (COPY_ARRAY_TO_RAM)
COPY_ARRAY_TO_RAM:
 
; SetBit(LED_ROT)
        SBI        PORTD, 7
 
; Retten der lokalen Parameter fuer PROCEDURE (COPY_ARRAY_TO_RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (ADR_HI) retten
        MOV        R16, R0
 
; lokalen Parameter (ADR_HI) an Prozedur (AE_WRITE_ADRESS)
        MOV        R1, R16
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R2, R16
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (COPY_ARRAY_TO_RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(RD_A)
        SBI        PORTC, 3
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; SetBit(MREQ_A)
        SBI        PORTC, 1
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; SetBit(AECMD_A)
        SBI        PORTB, 1
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LOOP_IN)
        STS        LOOP_IN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (COPY_ARRAY_TO_RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_BYTE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (AE_WRITE_BYTE)
        CALL       AE_WRITE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (COPY_ARRAY_TO_RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (LAENGE_ARRAY)
        LDS        R16, LAENGE_ARRAY
        LDS        R17, LAENGE_ARRAY+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0137:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0138
        RJMP       M_FTD_0139
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0138:
 
; IF THEN - Ausdruck / Byte-VAR (LOOP_IN)
        LDS        R16, LOOP_IN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0140
        RJMP       M_IF_0141
M_IF_0140:
 
; WHILE DO ...
M_WHILE_0143:
 
; WHILE - Ausdruck /; BitHigh(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTS       M_VERGL_0146
        CLR        R16
        RJMP       M_VERGL_0147
M_VERGL_0146:
        SER        R16
M_VERGL_0147:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0144
        RJMP       M_WHILE_0145
M_WHILE_0144:
 
; WHILE DO ...
        RJMP       M_WHILE_0143
M_WHILE_0145:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0142
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0141:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (LOOP_IN)
        STS        LOOP_IN, R16
 
; IF_THEN_ELSE - Ende
M_IF_0142:
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck / ReadAdrArray (DATEN_ARRAY)
        LDS        ZL, DATEN_ARRAY
        LDS        ZH, DATEN_ARRAY+1
        LDS        R29, DATEN_ARRAY+2
        CLR        R28
        ADD        ZL, R16
        ADC        ZH, R17
        ADC        R29, R28
        OUT        RAMPZ, R29
        ELPM       R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_DATA)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (READ_DATA)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; ClearBit(MREQ_A)
        CBI        PORTC, 1
 
; ClearBit(WR_A)
        CBI        PORTC, 4
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(MREQ_A)
        SBI        PORTC, 1
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; WHILE DO ...
M_WHILE_0148:
 
; WHILE - Ausdruck /; BitLow(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTC       M_VERGL_0151
        CLR        R16
        RJMP       M_VERGL_0152
M_VERGL_0151:
        SER        R16
M_VERGL_0152:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0149
        RJMP       M_WHILE_0150
M_WHILE_0149:
 
; WHILE DO ...
        RJMP       M_WHILE_0148
M_WHILE_0150:
 
; ClearBit(AECS_A)
        CBI        PORTD, 2
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0137
 
; FOR TO DO - Ende
M_FTD_0139:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; WHILE DO ...
M_WHILE_0153:
 
; WHILE - Ausdruck /; BitHigh(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTS       M_VERGL_0156
        CLR        R16
        RJMP       M_VERGL_0157
M_VERGL_0156:
        SER        R16
M_VERGL_0157:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0154
        RJMP       M_WHILE_0155
M_WHILE_0154:
 
; WHILE DO ...
        RJMP       M_WHILE_0153
M_WHILE_0155:
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; SetBit(RD_A)
        SBI        PORTC, 3
 
; WHILE DO ...
M_WHILE_0158:
 
; WHILE - Ausdruck /; BitLow(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTC       M_VERGL_0161
        CLR        R16
        RJMP       M_VERGL_0162
M_VERGL_0161:
        SER        R16
M_VERGL_0162:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0159
        RJMP       M_WHILE_0160
M_WHILE_0159:
 
; WHILE DO ...
        RJMP       M_WHILE_0158
M_WHILE_0160:
 
; ClearBit(LED_ROT)
        CBI        PORTD, 7
 
; PROCEDURE - Ende (COPY_ARRAY_TO_RAM)
        RET
 
; PROCEDURE - Anfang (COPY_DISK_TO_RAM)
COPY_DISK_TO_RAM:
 
; SetBit(LED_ROT)
        SBI        PORTD, 7
 
; Retten der lokalen Parameter fuer PROCEDURE (COPY_DISK_TO_RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R1, R16
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R2, R16
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (COPY_DISK_TO_RAM)
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(RD_A)
        SBI        PORTC, 3
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; SetBit(MREQ_A)
        SBI        PORTC, 1
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; SetBit(AECMD_A)
        SBI        PORTB, 1
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R1, R16
        MOV        R2, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LOOP_IN)
        STS        LOOP_IN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (COPY_DISK_TO_RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_BYTE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (AE_WRITE_BYTE)
        CALL       AE_WRITE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (COPY_DISK_TO_RAM)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R1, R16
        MOV        R2, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LAENGE_DISK_ARRAY)
        LDI        R16, LOW(0x641F)
        LDI        R17, HIGH(0x641F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R1
        MOV        R19, R2
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0163:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0164
        RJMP       M_FTD_0165
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0164:
 
; IF THEN - Ausdruck / Byte-VAR (LOOP_IN)
        LDS        R16, LOOP_IN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0166
        RJMP       M_IF_0167
M_IF_0166:
 
; WHILE DO ...
M_WHILE_0169:
 
; WHILE - Ausdruck /; BitHigh(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTS       M_VERGL_0172
        CLR        R16
        RJMP       M_VERGL_0173
M_VERGL_0172:
        SER        R16
M_VERGL_0173:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0170
        RJMP       M_WHILE_0171
M_WHILE_0170:
 
; WHILE DO ...
        RJMP       M_WHILE_0169
M_WHILE_0171:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0168
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0167:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (LOOP_IN)
        STS        LOOP_IN, R16
 
; IF_THEN_ELSE - Ende
M_IF_0168:
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R1
        MOV        R17, R2
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (DISK_ARR)
        CLR        R28
        LDI        R29, Byte3(2*DISK_ARR)
        LDI        ZL, LOW(2*DISK_ARR)
        LDI        ZH, HIGH(2*DISK_ARR)
        ADD        ZL, R16
        ADC        ZH, R17
        ADC        R29, R28
        OUT        RAMPZ, R29
        ELPM       R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_DATA)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (READ_DATA)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; ClearBit(MREQ_A)
        CBI        PORTC, 1
 
; ClearBit(WR_A)
        CBI        PORTC, 4
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(MREQ_A)
        SBI        PORTC, 1
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; WHILE DO ...
M_WHILE_0174:
 
; WHILE - Ausdruck /; BitLow(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTC       M_VERGL_0177
        CLR        R16
        RJMP       M_VERGL_0178
M_VERGL_0177:
        SER        R16
M_VERGL_0178:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0175
        RJMP       M_WHILE_0176
M_WHILE_0175:
 
; WHILE DO ...
        RJMP       M_WHILE_0174
M_WHILE_0176:
 
; ClearBit(AECS_A)
        CBI        PORTD, 2
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R1
        MOV        R19, R2
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R1, R18
        MOV        R2, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0163
 
; FOR TO DO - Ende
M_FTD_0165:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; WHILE DO ...
M_WHILE_0179:
 
; WHILE - Ausdruck /; BitHigh(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTS       M_VERGL_0182
        CLR        R16
        RJMP       M_VERGL_0183
M_VERGL_0182:
        SER        R16
M_VERGL_0183:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0180
        RJMP       M_WHILE_0181
M_WHILE_0180:
 
; WHILE DO ...
        RJMP       M_WHILE_0179
M_WHILE_0181:
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; SetBit(RD_A)
        SBI        PORTC, 3
 
; WHILE DO ...
M_WHILE_0184:
 
; WHILE - Ausdruck /; BitLow(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTC       M_VERGL_0187
        CLR        R16
        RJMP       M_VERGL_0188
M_VERGL_0187:
        SER        R16
M_VERGL_0188:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0185
        RJMP       M_WHILE_0186
M_WHILE_0185:
 
; WHILE DO ...
        RJMP       M_WHILE_0184
M_WHILE_0186:
 
; ClearBit(LED_ROT)
        CBI        PORTD, 7
 
; PROCEDURE - Ende (COPY_DISK_TO_RAM)
        RET
 
; PROCEDURE - Anfang (COPY_SEKTOR_PUFFER_TO_RAM)
COPY_SEKTOR_PUFFER_TO_RAM:
 
; SetBit(LED_ROT)
        SBI        PORTD, 7
 
; Retten der lokalen Parameter fuer PROCEDURE (COPY_SEKTOR_PUFFER_TO_RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (COPY_SEKTOR_PUFFER_TO_RAM)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(RD_A)
        SBI        PORTC, 3
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; SetBit(MREQ_A)
        SBI        PORTC, 1
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; SetBit(AECMD_A)
        SBI        PORTB, 1
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LOOP_IN)
        STS        LOOP_IN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (COPY_SEKTOR_PUFFER_TO_RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_BYTE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (AE_WRITE_BYTE)
        CALL       AE_WRITE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (COPY_SEKTOR_PUFFER_TO_RAM)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0189:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0190
        RJMP       M_FTD_0191
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0190:
 
; IF THEN - Ausdruck / Byte-VAR (LOOP_IN)
        LDS        R16, LOOP_IN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0192
        RJMP       M_IF_0193
M_IF_0192:
 
; WHILE DO ...
M_WHILE_0195:
 
; WHILE - Ausdruck /; BitHigh(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTS       M_VERGL_0198
        CLR        R16
        RJMP       M_VERGL_0199
M_VERGL_0198:
        SER        R16
M_VERGL_0199:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0196
        RJMP       M_WHILE_0197
M_WHILE_0196:
 
; WHILE DO ...
        RJMP       M_WHILE_0195
M_WHILE_0197:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0194
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0193:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (LOOP_IN)
        STS        LOOP_IN, R16
 
; IF_THEN_ELSE - Ende
M_IF_0194:
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_DATA)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (READ_DATA)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; ClearBit(MREQ_A)
        CBI        PORTC, 1
 
; ClearBit(WR_A)
        CBI        PORTC, 4
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(MREQ_A)
        SBI        PORTC, 1
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; WHILE DO ...
M_WHILE_0200:
 
; WHILE - Ausdruck /; BitLow(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTC       M_VERGL_0203
        CLR        R16
        RJMP       M_VERGL_0204
M_VERGL_0203:
        SER        R16
M_VERGL_0204:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0201
        RJMP       M_WHILE_0202
M_WHILE_0201:
 
; WHILE DO ...
        RJMP       M_WHILE_0200
M_WHILE_0202:
 
; ClearBit(AECS_A)
        CBI        PORTD, 2
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0189
 
; FOR TO DO - Ende
M_FTD_0191:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; WHILE DO ...
M_WHILE_0205:
 
; WHILE - Ausdruck /; BitHigh(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTS       M_VERGL_0208
        CLR        R16
        RJMP       M_VERGL_0209
M_VERGL_0208:
        SER        R16
M_VERGL_0209:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0206
        RJMP       M_WHILE_0207
M_WHILE_0206:
 
; WHILE DO ...
        RJMP       M_WHILE_0205
M_WHILE_0207:
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; SetBit(RD_A)
        SBI        PORTC, 3
 
; WHILE DO ...
M_WHILE_0210:
 
; WHILE - Ausdruck /; BitLow(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTC       M_VERGL_0213
        CLR        R16
        RJMP       M_VERGL_0214
M_VERGL_0213:
        SER        R16
M_VERGL_0214:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0211
        RJMP       M_WHILE_0212
M_WHILE_0211:
 
; WHILE DO ...
        RJMP       M_WHILE_0210
M_WHILE_0212:
 
; ClearBit(LED_ROT)
        CBI        PORTD, 7
 
; PROCEDURE - Ende (COPY_SEKTOR_PUFFER_TO_RAM)
        RET
 
; PROCEDURE - Anfang (COPY_RAM_TO_SEKTOR_PUFFER)
COPY_RAM_TO_SEKTOR_PUFFER:
 
; SetBit(LED_ROT)
        SBI        PORTD, 7
 
; Retten der lokalen Parameter fuer PROCEDURE (COPY_RAM_TO_SEKTOR_PUFFER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (COPY_RAM_TO_SEKTOR_PUFFER)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(RD_A)
        SBI        PORTC, 3
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; SetBit(MREQ_A)
        SBI        PORTC, 1
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; SetBit(AECMD_A)
        SBI        PORTB, 1
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LOOP_IN)
        STS        LOOP_IN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (COPY_RAM_TO_SEKTOR_PUFFER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_BYTE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (AE_WRITE_BYTE)
        CALL       AE_WRITE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (COPY_RAM_TO_SEKTOR_PUFFER)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0215:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0216
        RJMP       M_FTD_0217
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0216:
 
; IF THEN - Ausdruck / Byte-VAR (LOOP_IN)
        LDS        R16, LOOP_IN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0218
        RJMP       M_IF_0219
M_IF_0218:
 
; WHILE DO ...
M_WHILE_0221:
 
; WHILE - Ausdruck /; BitHigh(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTS       M_VERGL_0224
        CLR        R16
        RJMP       M_VERGL_0225
M_VERGL_0224:
        SER        R16
M_VERGL_0225:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0222
        RJMP       M_WHILE_0223
M_WHILE_0222:
 
; WHILE DO ...
        RJMP       M_WHILE_0221
M_WHILE_0223:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0220
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0219:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (LOOP_IN)
        STS        LOOP_IN, R16
 
; IF_THEN_ELSE - Ende
M_IF_0220:
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; ClearBit(MREQ_A)
        CBI        PORTC, 1
 
; ClearBit(RD_A)
        CBI        PORTC, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINA
        IN         R16, PINA
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_DATA)
        MOV        R3, R16
 
; SetBit(RD_A)
        SBI        PORTC, 3
 
; SetBit(MREQ_A)
        SBI        PORTC, 1
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R4
        MOV        R17, R5
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (READ_DATA)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR ARRAY (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; WHILE DO ...
M_WHILE_0226:
 
; WHILE - Ausdruck /; BitLow(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTC       M_VERGL_0229
        CLR        R16
        RJMP       M_VERGL_0230
M_VERGL_0229:
        SER        R16
M_VERGL_0230:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0227
        RJMP       M_WHILE_0228
M_WHILE_0227:
 
; WHILE DO ...
        RJMP       M_WHILE_0226
M_WHILE_0228:
 
; ClearBit(AECS_A)
        CBI        PORTD, 2
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0215
 
; FOR TO DO - Ende
M_FTD_0217:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; WHILE DO ...
M_WHILE_0231:
 
; WHILE - Ausdruck /; BitHigh(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTS       M_VERGL_0234
        CLR        R16
        RJMP       M_VERGL_0235
M_VERGL_0234:
        SER        R16
M_VERGL_0235:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0232
        RJMP       M_WHILE_0233
M_WHILE_0232:
 
; WHILE DO ...
        RJMP       M_WHILE_0231
M_WHILE_0233:
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; SetBit(RD_A)
        SBI        PORTC, 3
 
; WHILE DO ...
M_WHILE_0236:
 
; WHILE - Ausdruck /; BitLow(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTC       M_VERGL_0239
        CLR        R16
        RJMP       M_VERGL_0240
M_VERGL_0239:
        SER        R16
M_VERGL_0240:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0237
        RJMP       M_WHILE_0238
M_WHILE_0237:
 
; WHILE DO ...
        RJMP       M_WHILE_0236
M_WHILE_0238:
 
; ClearBit(LED_ROT)
        CBI        PORTD, 7
 
; PROCEDURE - Ende (COPY_RAM_TO_SEKTOR_PUFFER)
        RET
 
; FUNCTION - Anfang (LESE_RAM_ZELLE)
LESE_RAM_ZELLE:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; SetBit(RD_A)
        SBI        PORTC, 3
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; SetBit(AECMD_A)
        SBI        PORTB, 1
 
; WHILE DO ...
M_WHILE_0241:
 
; WHILE - Ausdruck /; BitLow(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTC       M_VERGL_0244
        CLR        R16
        RJMP       M_VERGL_0245
M_VERGL_0244:
        SER        R16
M_VERGL_0245:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0242
        RJMP       M_WHILE_0243
M_WHILE_0242:
 
; WHILE DO ...
        RJMP       M_WHILE_0241
M_WHILE_0243:
 
; ClearBit(MREQ_A)
        CBI        PORTC, 1
 
; ClearBit(RD_A)
        CBI        PORTC, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINA
        IN         R16, PINA
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_ZELLE)
        MOV        R1, R16
 
; SetBit(RD_A)
        SBI        PORTC, 3
 
; SetBit(MREQ_A)
        SBI        PORTC, 1
 
; RESULT Byte-Variable - FUNCTION (LESE_RAM_ZELLE)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (LESE_RAM_ZELLE)
        MOV        R16, R0
 
; FUNCTION - Ende (LESE_RAM_ZELLE)
        RET
 
; PROCEDURE - Anfang (INC_ADRESSE)
INC_ADRESSE:
 
; ClearBit(AECS_A)
        CBI        PORTD, 2
 
; WHILE DO ...
M_WHILE_0246:
 
; WHILE - Ausdruck /; BitHigh(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTS       M_VERGL_0249
        CLR        R16
        RJMP       M_VERGL_0250
M_VERGL_0249:
        SER        R16
M_VERGL_0250:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0247
        RJMP       M_WHILE_0248
M_WHILE_0247:
 
; WHILE DO ...
        RJMP       M_WHILE_0246
M_WHILE_0248:
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; WHILE DO ...
M_WHILE_0251:
 
; WHILE - Ausdruck /; BitLow(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTC       M_VERGL_0254
        CLR        R16
        RJMP       M_VERGL_0255
M_VERGL_0254:
        SER        R16
M_VERGL_0255:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0252
        RJMP       M_WHILE_0253
M_WHILE_0252:
 
; WHILE DO ...
        RJMP       M_WHILE_0251
M_WHILE_0253:
 
; PROCEDURE - Ende (INC_ADRESSE)
        RET
 
; FUNCTION - Anfang (LESE_RAM_ZELLE_INC)
LESE_RAM_ZELLE_INC:
 
; Retten der lokalen Parameter fuer PROCEDURE (LESE_RAM_ZELLE_INC)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (LESE_RAM_ZELLE)
        CALL       LESE_RAM_ZELLE
 
; Retten der Parameter-Register fuer PROCEDURE (LESE_RAM_ZELLE_INC)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_ZELLE)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (LESE_RAM_ZELLE_INC)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (INC_ADRESSE)
        CALL       INC_ADRESSE
 
; Retten der Parameter-Register fuer PROCEDURE (LESE_RAM_ZELLE_INC)
        POP        R1
        POP        R0
 
; RESULT Byte-Variable - FUNCTION (LESE_RAM_ZELLE_INC)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (LESE_RAM_ZELLE_INC)
        MOV        R16, R0
 
; FUNCTION - Ende (LESE_RAM_ZELLE_INC)
        RET
 
; PROCEDURE - Anfang (SCHREIBE_RAM_ZELLE)
SCHREIBE_RAM_ZELLE:
 
; SetBit(RD_A)
        SBI        PORTC, 3
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; SetBit(MREQ_A)
        SBI        PORTC, 1
 
; SetBit(AECS_A)
        SBI        PORTD, 2
 
; SetBit(AECMD_A)
        SBI        PORTB, 1
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; WHILE DO ...
M_WHILE_0256:
 
; WHILE - Ausdruck /; BitLow(AERQ_E)
        IN         R16, PIND
        BST        R16, 3
        BRTC       M_VERGL_0259
        CLR        R16
        RJMP       M_VERGL_0260
M_VERGL_0259:
        SER        R16
M_VERGL_0260:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0257
        RJMP       M_WHILE_0258
M_WHILE_0257:
 
; WHILE DO ...
        RJMP       M_WHILE_0256
M_WHILE_0258:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (WERT_ZELLE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; ClearBit(MREQ_A)
        CBI        PORTC, 1
 
; ClearBit(WR_A)
        CBI        PORTC, 4
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(MREQ_A)
        SBI        PORTC, 1
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; PROCEDURE - Ende (SCHREIBE_RAM_ZELLE)
        RET
 
; PROCEDURE - Anfang (BC_BUS_ANFORDERN)
BC_BUS_ANFORDERN:
 
; SetBit(LED_ROT)
        SBI        PORTD, 7
 
; ClearBit(BUSRQ_A)
        CBI        PORTC, 6
 
; WHILE DO ...
M_WHILE_0261:
 
; WHILE - Ausdruck /; BitHigh(BUSAK_E)
        IN         R16, PINC
        BST        R16, 7
        BRTS       M_VERGL_0264
        CLR        R16
        RJMP       M_VERGL_0265
M_VERGL_0264:
        SER        R16
M_VERGL_0265:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0262
        RJMP       M_WHILE_0263
M_WHILE_0262:
 
; WHILE DO ...
        RJMP       M_WHILE_0261
M_WHILE_0263:
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(MREQ_A)
        SBI        PORTC, 1
 
; SetBit(IORQ_A)
        SBI        PORTC, 2
 
; SetBit(RD_A)
        SBI        PORTC, 3
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; SetBit(MREQ_D)
        SBI        DDRC, 1
 
; SetBit(IORQ_D)
        SBI        DDRC, 2
 
; SetBit(RD_D)
        SBI        DDRC, 3
 
; SetBit(WR_D)
        SBI        DDRC, 4
 
; SetBit(MREQ_A)
        SBI        PORTC, 1
 
; SetBit(IORQ_A)
        SBI        PORTC, 2
 
; SetBit(RD_A)
        SBI        PORTC, 3
 
; SetBit(WR_A)
        SBI        PORTC, 4
 
; ClearBit(LED_ROT)
        CBI        PORTD, 7
 
; PROCEDURE - Ende (BC_BUS_ANFORDERN)
        RET
 
; PROCEDURE - Anfang (BC_BUS_FREIGEBEN)
BC_BUS_FREIGEBEN:
 
; SetBit(LED_ROT)
        SBI        PORTD, 7
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; ClearBit(MREQ_D)
        CBI        DDRC, 1
 
; ClearBit(IORQ_D)
        CBI        DDRC, 2
 
; ClearBit(RD_D)
        CBI        DDRC, 3
 
; ClearBit(WR_D)
        CBI        DDRC, 4
 
; ClearBit(MREQ_A)
        CBI        PORTC, 1
 
; ClearBit(IORQ_A)
        CBI        PORTC, 2
 
; ClearBit(RD_A)
        CBI        PORTC, 3
 
; ClearBit(WR_A)
        CBI        PORTC, 4
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(BUSRQ_A)
        SBI        PORTC, 6
 
; WHILE DO ...
M_WHILE_0266:
 
; WHILE - Ausdruck /; BitLow(BUSAK_E)
        IN         R16, PINC
        BST        R16, 7
        BRTC       M_VERGL_0269
        CLR        R16
        RJMP       M_VERGL_0270
M_VERGL_0269:
        SER        R16
M_VERGL_0270:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0267
        RJMP       M_WHILE_0268
M_WHILE_0267:
 
; WHILE DO ...
        RJMP       M_WHILE_0266
M_WHILE_0268:
 
; ClearBit(LED_ROT)
        CBI        PORTD, 7
 
; PROCEDURE - Ende (BC_BUS_FREIGEBEN)
        RET
 
; PROCEDURE - Anfang (STARTE_Z80)
STARTE_Z80:
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_BYTE)
        LDI        R16, 0x03
        MOV        R0, R16
 
; Aufruf PROCEDURE (AE_WRITE_BYTE)
        CALL       AE_WRITE_BYTE
 
; Aufruf PROCEDURE (BC_BUS_FREIGEBEN)
        CALL       BC_BUS_FREIGEBEN
 
; SetBit(LED_GRUEN)
        SBI        PORTD, 6
 
; ClearBit(RESET_A)
        CBI        PORTC, 5
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(RESET_A)
        SBI        PORTC, 5
 
; PROCEDURE - Ende (STARTE_Z80)
        RET
 
; PROCEDURE - Anfang (SEKTOR_DER_RAMFLOPPY_BERECHNEN)
SEKTOR_DER_RAMFLOPPY_BERECHNEN:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CPM_SPT)
        LDI        R16, 0x48
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R8, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(B1)
        MOV        R16, R8
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (TRACK_L)
        LDS        R16, TRACK_L
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R8, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(B1)
        MOV        R16, R8
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W1)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (W2)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (SECTOR)
        LDS        R16, SECTOR
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R8, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(B1)
        MOV        R16, R8
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W1)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (W2)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / WordToDW(W1)
        MOV        R16, R4
        MOV        R17, R5
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RF_ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; SHL(RF_ADRESSE) - DWord
        LSL        R0
        ROL        R1
        ROL        R2
        ROL        R3
 
; SHL(RF_ADRESSE) - DWord
        LSL        R0
        ROL        R1
        ROL        R2
        ROL        R3
 
; SHL(RF_ADRESSE) - DWord
        LSL        R0
        ROL        R1
        ROL        R2
        ROL        R3
 
; SHL(RF_ADRESSE) - DWord
        LSL        R0
        ROL        R1
        ROL        R2
        ROL        R3
 
; SHL(RF_ADRESSE) - DWord
        LSL        R0
        ROL        R1
        ROL        R2
        ROL        R3
 
; SHL(RF_ADRESSE) - DWord
        LSL        R0
        ROL        R1
        ROL        R2
        ROL        R3
 
; SHL(RF_ADRESSE) - DWord
        LSL        R0
        ROL        R1
        ROL        R2
        ROL        R3
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RF_ADRESSE)
        MOV        R16, R0
        MOV        R17, R1
        MOV        R18, R2
        MOV        R19, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (00010000)
        LDI        R20, 0x00
        LDI        R21, 0x00
        LDI        R22, 0x01
        LDI        R23, 0x00
 
; Operator +
        ADD        R16, R20
        ADC        R17, R21
        ADC        R18, R22
        ADC        R19, R23
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RF_ADRESSE)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; Zuweisung Quelle - Ausdruck / DWByte(0,RF_ADRESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (RF_00)
        STS        RF_00, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(1,RF_ADRESSE)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (RF_08)
        STS        RF_08, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(2,RF_ADRESSE)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (RF_15)
        STS        RF_15, R16
 
; PROCEDURE - Ende (SEKTOR_DER_RAMFLOPPY_BERECHNEN)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_TO_SECTOR)
STEUER_STRING_TO_SECTOR:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0F)
        LDI        R16, 0x0F
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0271:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0272
        RJMP       M_FTD_0273
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0272:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B2)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; INC(B2) - Byte
        INC        R1
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0274
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0274:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0276
        MOV        R16, R17
M_PRG_CONST_STRING_0275:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0275
M_PRG_CONST_STRING_0276:
        ST         -Z, R17
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B2)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; INC(B2) - Byte
        INC        R1
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0277
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0277:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0279
M_PRG_CONST_STRING_0278:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0278
M_PRG_CONST_STRING_0279:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0280
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0280:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0282
        MOV        R16, R17
M_PRG_CONST_STRING_0281:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0281
M_PRG_CONST_STRING_0282:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_SECTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (STRINGTOBYTE)
        CALL       STRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_SECTOR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B3)
        MOV        R2, R16
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B3)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR ARRAY (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(SEKTOR_PUFFER_ZEIGER) - Word
        LDS        R24, SEKTOR_PUFFER_ZEIGER
        LDS        R25, SEKTOR_PUFFER_ZEIGER+1
        ADIW       R25:R24, 1
        STS        SEKTOR_PUFFER_ZEIGER, R24
        STS        SEKTOR_PUFFER_ZEIGER+1, R25
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0271
 
; FOR TO DO - Ende
M_FTD_0273:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (STEUER_STRING_TO_SECTOR)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_TO_SECTOR_KOMP)
STEUER_STRING_TO_SECTOR_KOMP:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BITPOS_DB8)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB8)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (POS_SS)
        MOV        R6, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x26)
        LDI        R16, 0x26
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R6
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0283:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0284
        RJMP       M_FTD_0285
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0284:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (POS_SS)
        MOV        R16, R6
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R5
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB7)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BITPOS_DB7)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X2)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x06)
        LDI        R16, 0x06
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0286:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0287
        RJMP       M_FTD_0288
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0287:
 
; DEC(BITPOS_DB7) - Byte
        DEC        R4
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (DB7) retten
        MOV        R17, R1
 
; Parameter (BITPOS_DB7) retten
        MOV        R20, R4
 
; lokalen Parameter (DB7) an Funktion (READ_BIT_IN_BYTE)
        MOV        R0, R17
 
; lokalen Parameter (BITPOS_DB7) an Funktion (READ_BIT_IN_BYTE)
        MOV        R1, R20
 
; Aufruf Funktion (READ_BIT_IN_BYTE)
        CALL       READ_BIT_IN_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EIN_BIT)
        MOV        R7, R16
 
; IF THEN - Ausdruck / lokale, dynamische Variable VAR (EIN_BIT)
        MOV        R16, R7
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0289
        RJMP       M_IF_0290
M_IF_0289:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (DB8) retten
        MOV        R18, R2
 
; Parameter (BITPOS_DB8) retten
        MOV        R19, R3
 
; lokalen Parameter (DB8) an Funktion (SET_BIT_IN_BYTE)
        MOV        R0, R18
 
; lokalen Parameter (BITPOS_DB8) an Funktion (SET_BIT_IN_BYTE)
        MOV        R1, R19
 
; Aufruf Funktion (SET_BIT_IN_BYTE)
        CALL       SET_BIT_IN_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB8)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0291
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0290:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (DB8) retten
        MOV        R18, R2
 
; Parameter (BITPOS_DB8) retten
        MOV        R19, R3
 
; lokalen Parameter (DB8) an Funktion (CLEAR_BIT_IN_BYTE)
        MOV        R0, R18
 
; lokalen Parameter (BITPOS_DB8) an Funktion (CLEAR_BIT_IN_BYTE)
        MOV        R1, R19
 
; Aufruf Funktion (CLEAR_BIT_IN_BYTE)
        CALL       CLEAR_BIT_IN_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB8)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_0291:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (BITPOS_DB8)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0295
        CLR        R16
        RJMP       M_VERGL_0296
M_VERGL_0295:
        SER        R16
M_VERGL_0296:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0292
        RJMP       M_IF_0293
M_IF_0292:
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (DB8)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR ARRAY (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(SEKTOR_PUFFER_ZEIGER) - Word
        LDS        R24, SEKTOR_PUFFER_ZEIGER
        LDS        R25, SEKTOR_PUFFER_ZEIGER+1
        ADIW       R25:R24, 1
        STS        SEKTOR_PUFFER_ZEIGER, R24
        STS        SEKTOR_PUFFER_ZEIGER+1, R25
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BITPOS_DB8)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB8)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0294
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0293:
 
; DEC(BITPOS_DB8) - Byte
        DEC        R3
 
; IF_THEN_ELSE - Ende
M_IF_0294:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0286
 
; FOR TO DO - Ende
M_FTD_0288:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R6
        INC        R17
        MOV        R6, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0283
 
; FOR TO DO - Ende
M_FTD_0285:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (STEUER_STRING_TO_SECTOR_KOMP)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_TO_TIME)
STEUER_STRING_TO_TIME:
 
; ARRAY - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0297
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0297:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0299
        MOV        R16, R17
M_PRG_CONST_STRING_0298:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0298
M_PRG_CONST_STRING_0299:
        ST         -Z, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0300
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0300:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0302
M_PRG_CONST_STRING_0301:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0301
M_PRG_CONST_STRING_0302:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0303
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0303:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0305
        MOV        R16, R17
M_PRG_CONST_STRING_0304:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0304
M_PRG_CONST_STRING_0305:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_TIME)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (STRINGTOBYTE)
        CALL       STRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_TIME)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_TIME)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDS        R1, SCB_DATE_HI
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDS        R2, SCB_DATE_LO
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_TIME)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_TIME)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCHREIBE_RAM_ZELLE)
        CALL       SCHREIBE_RAM_ZELLE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_TIME)
        POP        R2
        POP        R1
        POP        R0
 
; INC(SCB_DATE_LO) - Byte
        LDS        R16, SCB_DATE_LO
        INC        R16
        STS        SCB_DATE_LO, R16
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0306
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0306:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0308
        MOV        R16, R17
M_PRG_CONST_STRING_0307:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0307
M_PRG_CONST_STRING_0308:
        ST         -Z, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0309
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0309:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0311
M_PRG_CONST_STRING_0310:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0310
M_PRG_CONST_STRING_0311:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0312
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0312:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0314
        MOV        R16, R17
M_PRG_CONST_STRING_0313:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0313
M_PRG_CONST_STRING_0314:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_TIME)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (STRINGTOBYTE)
        CALL       STRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_TIME)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_TIME)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDS        R1, SCB_DATE_HI
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDS        R2, SCB_DATE_LO
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_TIME)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_TIME)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCHREIBE_RAM_ZELLE)
        CALL       SCHREIBE_RAM_ZELLE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_TIME)
        POP        R2
        POP        R1
        POP        R0
 
; INC(SCB_DATE_LO) - Byte
        LDS        R16, SCB_DATE_LO
        INC        R16
        STS        SCB_DATE_LO, R16
 
; ARRAY - Ausdruck / Zahlenwert (0x06)
        LDI        R16, 0x06
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; ARRAY - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_TIME)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDS        R1, SCB_DATE_HI
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDS        R2, SCB_DATE_LO
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_TIME)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_TIME)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCHREIBE_RAM_ZELLE)
        CALL       SCHREIBE_RAM_ZELLE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_TIME)
        POP        R2
        POP        R1
        POP        R0
 
; INC(SCB_DATE_LO) - Byte
        LDS        R16, SCB_DATE_LO
        INC        R16
        STS        SCB_DATE_LO, R16
 
; ARRAY - Ausdruck / Zahlenwert (0x08)
        LDI        R16, 0x08
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; ARRAY - Ausdruck / Zahlenwert (0x09)
        LDI        R16, 0x09
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_TIME)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDS        R1, SCB_DATE_HI
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDS        R2, SCB_DATE_LO
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_TIME)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_TIME)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCHREIBE_RAM_ZELLE)
        CALL       SCHREIBE_RAM_ZELLE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_TIME)
        POP        R2
        POP        R1
        POP        R0
 
; INC(SCB_DATE_LO) - Byte
        LDS        R16, SCB_DATE_LO
        INC        R16
        STS        SCB_DATE_LO, R16
 
; ARRAY - Ausdruck / Zahlenwert (0x0A)
        LDI        R16, 0x0A
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; ARRAY - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_TIME)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDS        R1, SCB_DATE_HI
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDS        R2, SCB_DATE_LO
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_TIME)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_TIME)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCHREIBE_RAM_ZELLE)
        CALL       SCHREIBE_RAM_ZELLE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_TIME)
        POP        R2
        POP        R1
        POP        R0
 
; INC(SCB_DATE_LO) - Byte
        LDS        R16, SCB_DATE_LO
        INC        R16
        STS        SCB_DATE_LO, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DATUM_GESETZT)
        STS        DATUM_GESETZT, R16
 
; PROCEDURE - Ende (STEUER_STRING_TO_TIME)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_AUSWERTEN)
STEUER_STRING_AUSWERTEN:
 
; Zuweisung Quelle - Ausdruck / Length(STEUER_STRING)
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0318
        CLR        R16
        RJMP       M_VERGL_0319
M_VERGL_0318:
        SER        R16
M_VERGL_0319:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0315
        RJMP       M_IF_0316
M_IF_0315:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BUCHSTABE)
        MOV        R0, R16
 
; CASE OF - lokale, dynamische Variable VAR (BUCHSTABE)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (T)
        CPI        R16, 'T'
        BREQ       M_CASE_0322
        RJMP       M_CASE_0321
M_CASE_0322:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x03)
        LDI        R18, 0x03
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0326
        CLR        R16
        RJMP       M_VERGL_0327
M_VERGL_0326:
        SER        R16
M_VERGL_0327:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0323
        RJMP       M_IF_0324
M_IF_0323:
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEICHEN_1)
        MOV        R1, R16
 
; ARRAY - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEICHEN_2)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ZEICHEN_1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0328
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0328:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (ZEICHEN_2)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0329
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0329:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0331
        MOV        R16, R17
M_PRG_CONST_STRING_0330:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0330
M_PRG_CONST_STRING_0331:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (STRINGTOBYTE)
        CALL       STRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0325
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0324:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x01')
        LDI        ZL, LOW(2*M_CONST_STRING_0)
        LDI        ZH, HIGH(2*M_CONST_STRING_0)
        LDI        R29, Byte3(2*M_CONST_STRING_0)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0332
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0332:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0334
M_PRG_CONST_STRING_0333:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0333
M_PRG_CONST_STRING_0334:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0336
        MOV        R16, R17
M_PRG_CONST_STRING_0335:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0335
M_PRG_CONST_STRING_0336:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0325:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0320
M_CASE_0321:
 
; CASE OF - vergleiche Einzel-Element (U)
        CPI        R16, 'U'
        BREQ       M_CASE_0338
        RJMP       M_CASE_0337
M_CASE_0338:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x21)
        LDI        R18, 0x21
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0342
        CLR        R16
        RJMP       M_VERGL_0343
M_VERGL_0342:
        SER        R16
M_VERGL_0343:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0339
        RJMP       M_IF_0340
M_IF_0339:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (STEUER_STRING_TO_SECTOR)
        CALL       STEUER_STRING_TO_SECTOR
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0341
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0340:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x03')
        LDI        ZL, LOW(2*M_CONST_STRING_1)
        LDI        ZH, HIGH(2*M_CONST_STRING_1)
        LDI        R29, Byte3(2*M_CONST_STRING_1)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0344
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0344:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0346
M_PRG_CONST_STRING_0345:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0345
M_PRG_CONST_STRING_0346:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0348
        MOV        R16, R17
M_PRG_CONST_STRING_0347:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0347
M_PRG_CONST_STRING_0348:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0341:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0320
M_CASE_0337:
 
; CASE OF - vergleiche Einzel-Element (R)
        CPI        R16, 'R'
        BREQ       M_CASE_0350
        RJMP       M_CASE_0349
M_CASE_0350:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x26)
        LDI        R18, 0x26
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0354
        CLR        R16
        RJMP       M_VERGL_0355
M_VERGL_0354:
        SER        R16
M_VERGL_0355:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0351
        RJMP       M_IF_0352
M_IF_0351:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        CALL       STEUER_STRING_TO_SECTOR_KOMP
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0353
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0352:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x07')
        LDI        ZL, LOW(2*M_CONST_STRING_2)
        LDI        ZH, HIGH(2*M_CONST_STRING_2)
        LDI        R29, Byte3(2*M_CONST_STRING_2)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0356
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0356:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0358
M_PRG_CONST_STRING_0357:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0357
M_PRG_CONST_STRING_0358:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0360
        MOV        R16, R17
M_PRG_CONST_STRING_0359:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0359
M_PRG_CONST_STRING_0360:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0353:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0320
M_CASE_0349:
 
; CASE OF - vergleiche Einzel-Element (D)
        CPI        R16, 'D'
        BREQ       M_CASE_0362
        RJMP       M_CASE_0361
M_CASE_0362:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0B)
        LDI        R18, 0x0B
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0366
        CLR        R16
        RJMP       M_VERGL_0367
M_VERGL_0366:
        SER        R16
M_VERGL_0367:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0363
        RJMP       M_IF_0364
M_IF_0363:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (STEUER_STRING_TO_TIME)
        CALL       STEUER_STRING_TO_TIME
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0365
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0364:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x09')
        LDI        ZL, LOW(2*M_CONST_STRING_3)
        LDI        ZH, HIGH(2*M_CONST_STRING_3)
        LDI        R29, Byte3(2*M_CONST_STRING_3)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0368
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0368:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0370
M_PRG_CONST_STRING_0369:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0369
M_PRG_CONST_STRING_0370:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0372
        MOV        R16, R17
M_PRG_CONST_STRING_0371:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0371
M_PRG_CONST_STRING_0372:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0365:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0320
 
; CASE OF ELSE
M_CASE_0361:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x02')
        LDI        ZL, LOW(2*M_CONST_STRING_4)
        LDI        ZH, HIGH(2*M_CONST_STRING_4)
        LDI        R29, Byte3(2*M_CONST_STRING_4)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0373
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0373:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0375
M_PRG_CONST_STRING_0374:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0374
M_PRG_CONST_STRING_0375:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0377
        MOV        R16, R17
M_PRG_CONST_STRING_0376:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0376
M_PRG_CONST_STRING_0377:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0320:
 
; IF_THEN - Ende
M_IF_0316:
 
; PROCEDURE - Ende (STEUER_STRING_AUSWERTEN)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_LESEN)
STEUER_STRING_LESEN:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0D)
        LDI        R18, 0x0D
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0381
        CLR        R16
        RJMP       M_VERGL_0382
M_VERGL_0381:
        SER        R16
M_VERGL_0382:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0378
        RJMP       M_IF_0379
M_IF_0378:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0A)
        LDI        R18, 0x0A
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0386
        CLR        R16
        RJMP       M_VERGL_0387
M_VERGL_0386:
        SER        R16
M_VERGL_0387:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0383
        RJMP       M_IF_0384
M_IF_0383:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_LESEN)
        PUSH       R0
 
; Aufruf PROCEDURE (STEUER_STRING_AUSWERTEN)
        CALL       STEUER_STRING_AUSWERTEN
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_LESEN)
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (STEUER_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('')
        LDI        ZL, LOW(2*M_CONST_STRING_5)
        LDI        ZH, HIGH(2*M_CONST_STRING_5)
        LDI        R29, Byte3(2*M_CONST_STRING_5)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0388
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0388:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0390
M_PRG_CONST_STRING_0389:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0389
M_PRG_CONST_STRING_0390:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (STEUER_STRING) - Laenge in R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0392
        MOV        R16, R17
M_PRG_CONST_STRING_0391:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0391
M_PRG_CONST_STRING_0392:
        ST         -Z, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0385
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0384:
 
; Zuweisung Quelle - Ausdruck / Char-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (AKT_ZEICHEN)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (STEUER_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0393
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0393:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0395
M_PRG_CONST_STRING_0394:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0394
M_PRG_CONST_STRING_0395:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (AKT_ZEICHEN)
        MOV        R19, R0
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0396
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0396:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (STEUER_STRING) - Laenge in R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0398
        MOV        R16, R17
M_PRG_CONST_STRING_0397:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0397
M_PRG_CONST_STRING_0398:
        ST         -Z, R17
 
; IF_THEN_ELSE - Ende
M_IF_0385:
 
; IF_THEN - Ende
M_IF_0379:
 
; PROCEDURE - Ende (STEUER_STRING_LESEN)
        RET
 
; PROCEDURE - Anfang (STD_LESEN)
STD_LESEN:
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xF4
        MOV        R1, R16
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x3A
        MOV        R2, R16
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Aufruf Funktion (LESE_RAM_ZELLE_INC)
        CALL       LESE_RAM_ZELLE_INC
 
; Zuweisung Ziel /  VAR (SECTOR)
        STS        SECTOR, R16
 
; Aufruf Funktion (LESE_RAM_ZELLE_INC)
        CALL       LESE_RAM_ZELLE_INC
 
; Zuweisung Ziel /  VAR (TRACK_L)
        STS        TRACK_L, R16
 
; Aufruf Funktion (LESE_RAM_ZELLE_INC)
        CALL       LESE_RAM_ZELLE_INC
 
; Zuweisung Ziel /  VAR (TRACK_H)
        STS        TRACK_H, R16
 
; Aufruf Funktion (LESE_RAM_ZELLE_INC)
        CALL       LESE_RAM_ZELLE_INC
 
; Zuweisung Ziel /  VAR (DISKNO)
        STS        DISKNO, R16
 
; Aufruf Funktion (LESE_RAM_ZELLE_INC)
        CALL       LESE_RAM_ZELLE_INC
 
; Zuweisung Ziel /  VAR (DMAAD_L)
        STS        DMAAD_L, R16
 
; Aufruf Funktion (LESE_RAM_ZELLE_INC)
        CALL       LESE_RAM_ZELLE_INC
 
; Zuweisung Ziel /  VAR (DMAAD_H)
        STS        DMAAD_H, R16
 
; PROCEDURE - Ende (STD_LESEN)
        RET
 
; PROCEDURE - Anfang (STD_AN_PC_SENDEN)
STD_AN_PC_SENDEN:
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOSTRING)
        LDS        R0, SECTOR
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('s')
        LDI        ZL, LOW(2*M_CONST_STRING_6)
        LDI        ZH, HIGH(2*M_CONST_STRING_6)
        LDI        R29, Byte3(2*M_CONST_STRING_6)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0399
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0399:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0401
M_PRG_CONST_STRING_0400:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0400
M_PRG_CONST_STRING_0401:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0402
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0402:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0404
M_PRG_CONST_STRING_0403:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0403
M_PRG_CONST_STRING_0404:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0406
        MOV        R16, R17
M_PRG_CONST_STRING_0405:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0405
M_PRG_CONST_STRING_0406:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOSTRING)
        LDS        R0, TRACK_H
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0407
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0407:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0409
M_PRG_CONST_STRING_0408:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0408
M_PRG_CONST_STRING_0409:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0410
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0410:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0412
M_PRG_CONST_STRING_0411:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0411
M_PRG_CONST_STRING_0412:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0414
        MOV        R16, R17
M_PRG_CONST_STRING_0413:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0413
M_PRG_CONST_STRING_0414:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOSTRING)
        LDS        R0, TRACK_L
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0415
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0415:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0417
M_PRG_CONST_STRING_0416:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0416
M_PRG_CONST_STRING_0417:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0418
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0418:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0420
M_PRG_CONST_STRING_0419:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0419
M_PRG_CONST_STRING_0420:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0422
        MOV        R16, R17
M_PRG_CONST_STRING_0421:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0421
M_PRG_CONST_STRING_0422:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOSTRING)
        LDS        R0, DISKNO
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0423
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0423:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0425
M_PRG_CONST_STRING_0424:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0424
M_PRG_CONST_STRING_0425:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0426
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0426:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0428
M_PRG_CONST_STRING_0427:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0427
M_PRG_CONST_STRING_0428:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0430
        MOV        R16, R17
M_PRG_CONST_STRING_0429:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0429
M_PRG_CONST_STRING_0430:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; PROCEDURE - Ende (STD_AN_PC_SENDEN)
        RET
 
; PROCEDURE - Anfang (SEKTOR_VON_PC_LESEN)
SEKTOR_VON_PC_LESEN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPZ)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0431:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0432
        RJMP       M_FTD_0433
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0432:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('u')
        LDI        ZL, LOW(2*M_CONST_STRING_7)
        LDI        ZH, HIGH(2*M_CONST_STRING_7)
        LDI        R29, Byte3(2*M_CONST_STRING_7)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0434
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0434:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0436
M_PRG_CONST_STRING_0435:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0435
M_PRG_CONST_STRING_0436:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0437
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0437:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0439
M_PRG_CONST_STRING_0438:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0438
M_PRG_CONST_STRING_0439:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0441
        MOV        R16, R17
M_PRG_CONST_STRING_0440:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0440
M_PRG_CONST_STRING_0441:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; WHILE DO ...
M_WHILE_0442:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R4
        MOV        R17, R5
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0445
        CLR        R16
        RJMP       M_VERGL_0446
M_VERGL_0445:
        SER        R16
M_VERGL_0446:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0443
        RJMP       M_WHILE_0444
M_WHILE_0443:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (RX_PUFFER_ABFRAGEN)
        CALL       RX_PUFFER_ABFRAGEN
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0450
        CLR        R16
        RJMP       M_VERGL_0451
M_VERGL_0450:
        SER        R16
M_VERGL_0451:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0447
        RJMP       M_IF_0448
M_IF_0447:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (SPZ)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0455
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0456
M_VERGL_0455:
        SER        R16
M_VERGL_0456:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0452
        RJMP       M_IF_0453
M_IF_0452:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0454
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0453:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPZ)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN_ELSE - Ende
M_IF_0454:
 
; IF_THEN - Ende
M_IF_0448:
 
; DEC(LESESCHLEIFE) - Word
        MOV        R24, R4
        MOV        R25, R5
        SBIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; WHILE DO ...
        RJMP       M_WHILE_0442
M_WHILE_0444:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0460
        CLR        R16
        RJMP       M_VERGL_0461
M_VERGL_0460:
        SER        R16
M_VERGL_0461:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0457
        RJMP       M_IF_0458
M_IF_0457:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x04')
        LDI        ZL, LOW(2*M_CONST_STRING_8)
        LDI        ZH, HIGH(2*M_CONST_STRING_8)
        LDI        R29, Byte3(2*M_CONST_STRING_8)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0462
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0462:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0464
M_PRG_CONST_STRING_0463:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0463
M_PRG_CONST_STRING_0464:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0466
        MOV        R16, R17
M_PRG_CONST_STRING_0465:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0465
M_PRG_CONST_STRING_0466:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0458:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0431
 
; FOR TO DO - Ende
M_FTD_0433:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (SEKTOR_VON_PC_LESEN)
        RET
 
; PROCEDURE - Anfang (SEKTOR_VON_PC_LESEN_KOMP)
SEKTOR_VON_PC_LESEN_KOMP:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPZ)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0467:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0468
        RJMP       M_FTD_0469
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0468:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('r')
        LDI        ZL, LOW(2*M_CONST_STRING_9)
        LDI        ZH, HIGH(2*M_CONST_STRING_9)
        LDI        R29, Byte3(2*M_CONST_STRING_9)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0470
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0470:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0472
M_PRG_CONST_STRING_0471:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0471
M_PRG_CONST_STRING_0472:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0473
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0473:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0475
M_PRG_CONST_STRING_0474:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0474
M_PRG_CONST_STRING_0475:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0477
        MOV        R16, R17
M_PRG_CONST_STRING_0476:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0476
M_PRG_CONST_STRING_0477:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; WHILE DO ...
M_WHILE_0478:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R4
        MOV        R17, R5
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0481
        CLR        R16
        RJMP       M_VERGL_0482
M_VERGL_0481:
        SER        R16
M_VERGL_0482:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0479
        RJMP       M_WHILE_0480
M_WHILE_0479:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (RX_PUFFER_ABFRAGEN)
        CALL       RX_PUFFER_ABFRAGEN
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0486
        CLR        R16
        RJMP       M_VERGL_0487
M_VERGL_0486:
        SER        R16
M_VERGL_0487:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0483
        RJMP       M_IF_0484
M_IF_0483:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (SPZ)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0491
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0492
M_VERGL_0491:
        SER        R16
M_VERGL_0492:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0488
        RJMP       M_IF_0489
M_IF_0488:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0490
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0489:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPZ)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN_ELSE - Ende
M_IF_0490:
 
; IF_THEN - Ende
M_IF_0484:
 
; DEC(LESESCHLEIFE) - Word
        MOV        R24, R4
        MOV        R25, R5
        SBIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; WHILE DO ...
        RJMP       M_WHILE_0478
M_WHILE_0480:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0496
        CLR        R16
        RJMP       M_VERGL_0497
M_VERGL_0496:
        SER        R16
M_VERGL_0497:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0493
        RJMP       M_IF_0494
M_IF_0493:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x08')
        LDI        ZL, LOW(2*M_CONST_STRING_10)
        LDI        ZH, HIGH(2*M_CONST_STRING_10)
        LDI        R29, Byte3(2*M_CONST_STRING_10)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0498
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0498:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0500
M_PRG_CONST_STRING_0499:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0499
M_PRG_CONST_STRING_0500:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0502
        MOV        R16, R17
M_PRG_CONST_STRING_0501:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0501
M_PRG_CONST_STRING_0502:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0494:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0467
 
; FOR TO DO - Ende
M_FTD_0469:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (SEKTOR_VON_PC_LESEN_KOMP)
        RET
 
; PROCEDURE - Anfang (SEKTOR_AN_PC_SENDEN)
SEKTOR_AN_PC_SENDEN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0503:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0504
        RJMP       M_FTD_0505
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0504:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_AN_PC_SENDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_AN_PC_SENDEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('v')
        LDI        ZL, LOW(2*M_CONST_STRING_11)
        LDI        ZH, HIGH(2*M_CONST_STRING_11)
        LDI        R29, Byte3(2*M_CONST_STRING_11)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0506
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0506:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0508
M_PRG_CONST_STRING_0507:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0507
M_PRG_CONST_STRING_0508:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0509
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0509:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0511
M_PRG_CONST_STRING_0510:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0510
M_PRG_CONST_STRING_0511:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0513
        MOV        R16, R17
M_PRG_CONST_STRING_0512:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0512
M_PRG_CONST_STRING_0513:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0F)
        LDI        R16, 0x0F
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R1
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0514:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0515
        RJMP       M_FTD_0516
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0515:
 
; ARRAY - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B3)
        MOV        R2, R16
 
; INC(SEKTOR_PUFFER_ZEIGER) - Word
        LDS        R24, SEKTOR_PUFFER_ZEIGER
        LDS        R25, SEKTOR_PUFFER_ZEIGER+1
        ADIW       R25:R24, 1
        STS        SEKTOR_PUFFER_ZEIGER, R24
        STS        SEKTOR_PUFFER_ZEIGER+1, R25
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_AN_PC_SENDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (B3) retten
        MOV        R18, R2
 
; lokalen Parameter (B3) an Prozedur (BYTETOSTRING)
        MOV        R0, R18
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_AN_PC_SENDEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0517
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0517:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0519
M_PRG_CONST_STRING_0518:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0518
M_PRG_CONST_STRING_0519:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0520
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0520:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0522
M_PRG_CONST_STRING_0521:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0521
M_PRG_CONST_STRING_0522:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0524
        MOV        R16, R17
M_PRG_CONST_STRING_0523:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0523
M_PRG_CONST_STRING_0524:
        ST         -Z, R17
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R1
        INC        R17
        MOV        R1, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0514
 
; FOR TO DO - Ende
M_FTD_0516:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0525
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0525:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0527
M_PRG_CONST_STRING_0526:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0526
M_PRG_CONST_STRING_0527:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0529
        MOV        R16, R17
M_PRG_CONST_STRING_0528:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0528
M_PRG_CONST_STRING_0529:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_AN_PC_SENDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_AN_PC_SENDEN)
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0503
 
; FOR TO DO - Ende
M_FTD_0505:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (SEKTOR_AN_PC_SENDEN)
        RET
 
; PROCEDURE - Anfang (UP_READ_SEC)
UP_READ_SEC:
 
; Aufruf PROCEDURE (STD_LESEN)
        CALL       STD_LESEN
 
; CASE OF - Byte-VAR (DISKNO)
        LDS        R16, DISKNO
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_0532
        RJMP       M_CASE_0531
M_CASE_0532:
 
; Aufruf PROCEDURE (SEKTOR_DER_RAMFLOPPY_BERECHNEN)
        CALL       SEKTOR_DER_RAMFLOPPY_BERECHNEN
 
; Byte-Parameter(1) fuer PROCEDURE (COPY_RAM_TO_SEKTOR_PUFFER)
        LDS        R0, RF_15
 
; Byte-Parameter(2) fuer PROCEDURE (COPY_RAM_TO_SEKTOR_PUFFER)
        LDS        R1, RF_08
 
; Byte-Parameter(3) fuer PROCEDURE (COPY_RAM_TO_SEKTOR_PUFFER)
        LDS        R2, RF_00
 
; Aufruf PROCEDURE (COPY_RAM_TO_SEKTOR_PUFFER)
        CALL       COPY_RAM_TO_SEKTOR_PUFFER
 
; Byte-Parameter(1) fuer PROCEDURE (COPY_SEKTOR_PUFFER_TO_RAM)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (COPY_SEKTOR_PUFFER_TO_RAM)
        LDS        R1, DMAAD_H
 
; Byte-Parameter(3) fuer PROCEDURE (COPY_SEKTOR_PUFFER_TO_RAM)
        LDS        R2, DMAAD_L
 
; Aufruf PROCEDURE (COPY_SEKTOR_PUFFER_TO_RAM)
        CALL       COPY_SEKTOR_PUFFER_TO_RAM
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0530
M_CASE_0531:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_0534
        RJMP       M_CASE_0533
M_CASE_0534:
 
; Aufruf PROCEDURE (STD_AN_PC_SENDEN)
        CALL       STD_AN_PC_SENDEN
 
; Aufruf PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        CALL       SEKTOR_VON_PC_LESEN_KOMP
 
; Byte-Parameter(1) fuer PROCEDURE (COPY_SEKTOR_PUFFER_TO_RAM)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (COPY_SEKTOR_PUFFER_TO_RAM)
        LDS        R1, DMAAD_H
 
; Byte-Parameter(3) fuer PROCEDURE (COPY_SEKTOR_PUFFER_TO_RAM)
        LDS        R2, DMAAD_L
 
; Aufruf PROCEDURE (COPY_SEKTOR_PUFFER_TO_RAM)
        CALL       COPY_SEKTOR_PUFFER_TO_RAM
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0530
 
; CASE OF ELSE
M_CASE_0533:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x05')
        LDI        ZL, LOW(2*M_CONST_STRING_12)
        LDI        ZH, HIGH(2*M_CONST_STRING_12)
        LDI        R29, Byte3(2*M_CONST_STRING_12)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0535
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0535:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0537
M_PRG_CONST_STRING_0536:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0536
M_PRG_CONST_STRING_0537:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0539
        MOV        R16, R17
M_PRG_CONST_STRING_0538:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0538
M_PRG_CONST_STRING_0539:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; ENDCASE;
M_CASE_0530:
 
; PROCEDURE - Ende (UP_READ_SEC)
        RET
 
; PROCEDURE - Anfang (UP_WRITE_SEC)
UP_WRITE_SEC:
 
; Aufruf PROCEDURE (STD_LESEN)
        CALL       STD_LESEN
 
; CASE OF - Byte-VAR (DISKNO)
        LDS        R16, DISKNO
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_0542
        RJMP       M_CASE_0541
M_CASE_0542:
 
; Aufruf PROCEDURE (SEKTOR_DER_RAMFLOPPY_BERECHNEN)
        CALL       SEKTOR_DER_RAMFLOPPY_BERECHNEN
 
; Byte-Parameter(1) fuer PROCEDURE (COPY_RAM_TO_SEKTOR_PUFFER)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (COPY_RAM_TO_SEKTOR_PUFFER)
        LDS        R1, DMAAD_H
 
; Byte-Parameter(3) fuer PROCEDURE (COPY_RAM_TO_SEKTOR_PUFFER)
        LDS        R2, DMAAD_L
 
; Aufruf PROCEDURE (COPY_RAM_TO_SEKTOR_PUFFER)
        CALL       COPY_RAM_TO_SEKTOR_PUFFER
 
; Byte-Parameter(1) fuer PROCEDURE (COPY_SEKTOR_PUFFER_TO_RAM)
        LDS        R0, RF_15
 
; Byte-Parameter(2) fuer PROCEDURE (COPY_SEKTOR_PUFFER_TO_RAM)
        LDS        R1, RF_08
 
; Byte-Parameter(3) fuer PROCEDURE (COPY_SEKTOR_PUFFER_TO_RAM)
        LDS        R2, RF_00
 
; Aufruf PROCEDURE (COPY_SEKTOR_PUFFER_TO_RAM)
        CALL       COPY_SEKTOR_PUFFER_TO_RAM
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0540
M_CASE_0541:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_0544
        RJMP       M_CASE_0543
M_CASE_0544:
 
; Aufruf PROCEDURE (STD_AN_PC_SENDEN)
        CALL       STD_AN_PC_SENDEN
 
; Byte-Parameter(1) fuer PROCEDURE (COPY_RAM_TO_SEKTOR_PUFFER)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (COPY_RAM_TO_SEKTOR_PUFFER)
        LDS        R1, DMAAD_H
 
; Byte-Parameter(3) fuer PROCEDURE (COPY_RAM_TO_SEKTOR_PUFFER)
        LDS        R2, DMAAD_L
 
; Aufruf PROCEDURE (COPY_RAM_TO_SEKTOR_PUFFER)
        CALL       COPY_RAM_TO_SEKTOR_PUFFER
 
; Aufruf PROCEDURE (SEKTOR_AN_PC_SENDEN)
        CALL       SEKTOR_AN_PC_SENDEN
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0540
 
; CASE OF ELSE
M_CASE_0543:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x06')
        LDI        ZL, LOW(2*M_CONST_STRING_13)
        LDI        ZH, HIGH(2*M_CONST_STRING_13)
        LDI        R29, Byte3(2*M_CONST_STRING_13)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0545
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0545:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0547
M_PRG_CONST_STRING_0546:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0546
M_PRG_CONST_STRING_0547:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0549
        MOV        R16, R17
M_PRG_CONST_STRING_0548:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0548
M_PRG_CONST_STRING_0549:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; ENDCASE;
M_CASE_0540:
 
; PROCEDURE - Ende (UP_WRITE_SEC)
        RET
 
; PROCEDURE - Anfang (UP_SET_TIME)
UP_SET_TIME:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('d')
        LDI        ZL, LOW(2*M_CONST_STRING_14)
        LDI        ZH, HIGH(2*M_CONST_STRING_14)
        LDI        R29, Byte3(2*M_CONST_STRING_14)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0550
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0550:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0552
M_PRG_CONST_STRING_0551:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0551
M_PRG_CONST_STRING_0552:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0554
        MOV        R16, R17
M_PRG_CONST_STRING_0553:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0553
M_PRG_CONST_STRING_0554:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (UP_SET_TIME)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (UP_SET_TIME)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DATUM_GESETZT)
        STS        DATUM_GESETZT, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
 
; WHILE DO ...
M_WHILE_0555:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R0
        MOV        R17, R1
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0558
        CLR        R16
        RJMP       M_VERGL_0559
M_VERGL_0558:
        SER        R16
M_VERGL_0559:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0556
        RJMP       M_WHILE_0557
M_WHILE_0556:
 
; Retten der lokalen Parameter fuer PROCEDURE (UP_SET_TIME)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (RX_PUFFER_ABFRAGEN)
        CALL       RX_PUFFER_ABFRAGEN
 
; Retten der Parameter-Register fuer PROCEDURE (UP_SET_TIME)
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0563
        CLR        R16
        RJMP       M_VERGL_0564
M_VERGL_0563:
        SER        R16
M_VERGL_0564:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0560
        RJMP       M_IF_0561
M_IF_0560:
 
; Retten der lokalen Parameter fuer PROCEDURE (UP_SET_TIME)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (UP_SET_TIME)
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck / Byte-VAR (DATUM_GESETZT)
        LDS        R16, DATUM_GESETZT
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0565
        RJMP       M_IF_0566
M_IF_0565:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0567
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0566:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
 
; IF_THEN_ELSE - Ende
M_IF_0567:
 
; IF_THEN - Ende
M_IF_0561:
 
; DEC(LESESCHLEIFE) - Word
        MOV        R24, R0
        MOV        R25, R1
        SBIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; WHILE DO ...
        RJMP       M_WHILE_0555
M_WHILE_0557:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R0
        MOV        R17, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0571
        CLR        R16
        RJMP       M_VERGL_0572
M_VERGL_0571:
        SER        R16
M_VERGL_0572:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0568
        RJMP       M_IF_0569
M_IF_0568:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x10')
        LDI        ZL, LOW(2*M_CONST_STRING_15)
        LDI        ZH, HIGH(2*M_CONST_STRING_15)
        LDI        R29, Byte3(2*M_CONST_STRING_15)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0573
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0573:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0575
M_PRG_CONST_STRING_0574:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0574
M_PRG_CONST_STRING_0575:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0577
        MOV        R16, R17
M_PRG_CONST_STRING_0576:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0576
M_PRG_CONST_STRING_0577:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (UP_SET_TIME)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (UP_SET_TIME)
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0569:
 
; PROCEDURE - Ende (UP_SET_TIME)
        RET
 
; PROCEDURE - Anfang (Z80CALL_ABFRAGEN)
Z80CALL_ABFRAGEN:
 
; IF THEN - Ausdruck /; BitLow(Z80CALL_E)
        IN         R16, PIND
        BST        R16, 4
        BRTC       M_VERGL_0581
        CLR        R16
        RJMP       M_VERGL_0582
M_VERGL_0581:
        SER        R16
M_VERGL_0582:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0578
        RJMP       M_IF_0579
M_IF_0578:
 
; ClearBit(LED_GRUEN)
        CBI        PORTD, 6
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (BC_BUS_ANFORDERN)
        CALL       BC_BUS_ANFORDERN
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xF4
        MOV        R1, R16
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xC6
        MOV        R2, R16
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (LESE_RAM_ZELLE)
        CALL       LESE_RAM_ZELLE
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MODE)
        MOV        R0, R16
 
; CASE OF - lokale, dynamische Variable VAR (MODE)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (BC_CONST)
        CPI        R16, 0x02
        BREQ       M_CASE_0585
        RJMP       M_CASE_0584
M_CASE_0585:
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xF4
        MOV        R1, R16
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xC7
        MOV        R2, R16
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (SCHREIBE_RAM_ZELLE)
        LDS        R0, CONSOLEIN
 
; Aufruf PROCEDURE (SCHREIBE_RAM_ZELLE)
        CALL       SCHREIBE_RAM_ZELLE
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0583
M_CASE_0584:
 
; CASE OF - vergleiche Einzel-Element (BC_CONIN)
        CPI        R16, 0x01
        BREQ       M_CASE_0587
        RJMP       M_CASE_0586
M_CASE_0587:
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xF4
        MOV        R1, R16
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xC7
        MOV        R2, R16
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (SCHREIBE_RAM_ZELLE)
        LDS        R0, CONSOLEIN
 
; Aufruf PROCEDURE (SCHREIBE_RAM_ZELLE)
        CALL       SCHREIBE_RAM_ZELLE
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0583
M_CASE_0586:
 
; CASE OF - vergleiche Einzel-Element (BC_CONOUT)
        CPI        R16, 0x03
        BREQ       M_CASE_0589
        RJMP       M_CASE_0588
M_CASE_0589:
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xF4
        MOV        R1, R16
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xC7
        MOV        R2, R16
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (LESE_RAM_ZELLE)
        CALL       LESE_RAM_ZELLE
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_ZELLE)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Parameter (RAM_ZELLE) retten
        MOV        R17, R1
 
; lokalen Parameter (RAM_ZELLE) an Prozedur (BYTETOSTRING)
        MOV        R0, R17
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('o')
        LDI        ZL, LOW(2*M_CONST_STRING_16)
        LDI        ZH, HIGH(2*M_CONST_STRING_16)
        LDI        R29, Byte3(2*M_CONST_STRING_16)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0590
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0590:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0592
M_PRG_CONST_STRING_0591:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0591
M_PRG_CONST_STRING_0592:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0593
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0593:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0595
M_PRG_CONST_STRING_0594:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0594
M_PRG_CONST_STRING_0595:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0597
        MOV        R16, R17
M_PRG_CONST_STRING_0596:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0596
M_PRG_CONST_STRING_0597:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0583
M_CASE_0588:
 
; CASE OF - vergleiche Einzel-Element (BC_LIST)
        CPI        R16, 0x04
        BREQ       M_CASE_0599
        RJMP       M_CASE_0598
M_CASE_0599:
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xF4
        MOV        R1, R16
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xC7
        MOV        R2, R16
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (LESE_RAM_ZELLE)
        CALL       LESE_RAM_ZELLE
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_ZELLE)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Parameter (RAM_ZELLE) retten
        MOV        R17, R1
 
; lokalen Parameter (RAM_ZELLE) an Prozedur (BYTETOSTRING)
        MOV        R0, R17
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('l')
        LDI        ZL, LOW(2*M_CONST_STRING_17)
        LDI        ZH, HIGH(2*M_CONST_STRING_17)
        LDI        R29, Byte3(2*M_CONST_STRING_17)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0600
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0600:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0602
M_PRG_CONST_STRING_0601:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0601
M_PRG_CONST_STRING_0602:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0603
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0603:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0605
M_PRG_CONST_STRING_0604:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0604
M_PRG_CONST_STRING_0605:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0607
        MOV        R16, R17
M_PRG_CONST_STRING_0606:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0606
M_PRG_CONST_STRING_0607:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0583
M_CASE_0598:
 
; CASE OF - vergleiche Einzel-Element (BC_COPY_BDOS)
        CPI        R16, 0x05
        BREQ       M_CASE_0609
        RJMP       M_CASE_0608
M_CASE_0609:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (LAENGE_ZSDOS_ARRAY)
        LDI        R16, LOW(0x0DFF)
        LDI        R17, HIGH(0x0DFF)
 
; Zuweisung Ziel /  VAR (LAENGE_ARRAY)
        STS        LAENGE_ARRAY, R16
        STS        LAENGE_ARRAY+1, R17
 
; Zuweisung Quelle - Ausdruck / ArrayToAdress(ZSDOS_ARR)
        LDI        R16, LOW(2*ZSDOS_ARR)
        LDI        R17, HIGH(2*ZSDOS_ARR)
        LDI        R18, Byte3(2*ZSDOS_ARR)
 
; Zuweisung Ziel /  VAR (DATEN_ARRAY)
        STS        DATEN_ARRAY, R16
        STS        DATEN_ARRAY+1, R17
        STS        DATEN_ARRAY+2, R18
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (COPY_ARRAY_TO_RAM)
        LDI        R16, 0xE6
        MOV        R0, R16
 
; Aufruf PROCEDURE (COPY_ARRAY_TO_RAM)
        CALL       COPY_ARRAY_TO_RAM
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0583
M_CASE_0608:
 
; CASE OF - vergleiche Einzel-Element (BC_COPY_CCP)
        CPI        R16, 0x06
        BREQ       M_CASE_0611
        RJMP       M_CASE_0610
M_CASE_0611:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (LAENGE_CCP_ARRAY)
        LDI        R16, LOW(0x07FF)
        LDI        R17, HIGH(0x07FF)
 
; Zuweisung Ziel /  VAR (LAENGE_ARRAY)
        STS        LAENGE_ARRAY, R16
        STS        LAENGE_ARRAY+1, R17
 
; Zuweisung Quelle - Ausdruck / ArrayToAdress(CCP_ARR)
        LDI        R16, LOW(2*CCP_ARR)
        LDI        R17, HIGH(2*CCP_ARR)
        LDI        R18, Byte3(2*CCP_ARR)
 
; Zuweisung Ziel /  VAR (DATEN_ARRAY)
        STS        DATEN_ARRAY, R16
        STS        DATEN_ARRAY+1, R17
        STS        DATEN_ARRAY+2, R18
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (COPY_ARRAY_TO_RAM)
        LDI        R16, 0xDE
        MOV        R0, R16
 
; Aufruf PROCEDURE (COPY_ARRAY_TO_RAM)
        CALL       COPY_ARRAY_TO_RAM
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0583
M_CASE_0610:
 
; CASE OF - vergleiche Einzel-Element (BC_READ_SEC)
        CPI        R16, 0x07
        BREQ       M_CASE_0613
        RJMP       M_CASE_0612
M_CASE_0613:
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (UP_READ_SEC)
        CALL       UP_READ_SEC
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0583
M_CASE_0612:
 
; CASE OF - vergleiche Einzel-Element (BC_WRITE_SEC)
        CPI        R16, 0x08
        BREQ       M_CASE_0615
        RJMP       M_CASE_0614
M_CASE_0615:
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (UP_WRITE_SEC)
        CALL       UP_WRITE_SEC
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0583
M_CASE_0614:
 
; CASE OF - vergleiche Einzel-Element (BC_SET_TIME)
        CPI        R16, 0x0A
        BREQ       M_CASE_0617
        RJMP       M_CASE_0616
M_CASE_0617:
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xF4
        MOV        R1, R16
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xC7
        MOV        R2, R16
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (LESE_RAM_ZELLE)
        CALL       LESE_RAM_ZELLE
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  VAR (SCB_DATE_LO)
        STS        SCB_DATE_LO, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xF4
        MOV        R1, R16
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xC8
        MOV        R2, R16
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (LESE_RAM_ZELLE)
        CALL       LESE_RAM_ZELLE
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  VAR (SCB_DATE_HI)
        STS        SCB_DATE_HI, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (UP_SET_TIME)
        CALL       UP_SET_TIME
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0583
 
; CASE OF ELSE
M_CASE_0616:
 
; SetBit(LED_ROT)
        SBI        PORTD, 7
 
; ENDCASE;
M_CASE_0583:
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_BYTE)
        LDI        R16, 0x03
        MOV        R0, R16
 
; Aufruf PROCEDURE (AE_WRITE_BYTE)
        CALL       AE_WRITE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80CALL_ABFRAGEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (BC_BUS_FREIGEBEN)
        CALL       BC_BUS_FREIGEBEN
 
; Retten der Parameter-Register fuer PROCEDURE (Z80CALL_ABFRAGEN)
        POP        R1
        POP        R0
 
; ClearBit(Z80AK_A)
        CBI        PORTD, 5
 
; WHILE DO ...
M_WHILE_0618:
 
; WHILE - Ausdruck /; BitLow(Z80CALL_E)
        IN         R16, PIND
        BST        R16, 4
        BRTC       M_VERGL_0621
        CLR        R16
        RJMP       M_VERGL_0622
M_VERGL_0621:
        SER        R16
M_VERGL_0622:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0619
        RJMP       M_WHILE_0620
M_WHILE_0619:
 
; WHILE DO ...
        RJMP       M_WHILE_0618
M_WHILE_0620:
 
; SetBit(Z80AK_A)
        SBI        PORTD, 5
 
; SetBit(LED_GRUEN)
        SBI        PORTD, 6
 
; IF_THEN - Ende
M_IF_0579:
 
; PROCEDURE - Ende (Z80CALL_ABFRAGEN)
        RET
 
; FUNCTION - Anfang (RF_LEER)
RF_LEER:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RF_IST_LEER)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (RF_LEER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xFF
        MOV        R0, R16
 
; Byte-Parameter(2) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xFF
        MOV        R1, R16
 
; Byte-Parameter(3) fuer PROCEDURE (AE_WRITE_ADRESS)
        LDI        R16, 0xFE
        MOV        R2, R16
 
; Aufruf PROCEDURE (AE_WRITE_ADRESS)
        CALL       AE_WRITE_ADRESS
 
; Retten der Parameter-Register fuer PROCEDURE (RF_LEER)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (RF_LEER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (LESE_RAM_ZELLE_INC)
        CALL       LESE_RAM_ZELLE_INC
 
; Retten der Parameter-Register fuer PROCEDURE (RF_LEER)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WERT_ZELLE)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (WERT_ZELLE)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (RF_FUELLBYTE)
        LDI        R18, 0xE5
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0626
        CLR        R16
        RJMP       M_VERGL_0627
M_VERGL_0626:
        SER        R16
M_VERGL_0627:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0623
        RJMP       M_IF_0624
M_IF_0623:
 
; Retten der lokalen Parameter fuer PROCEDURE (RF_LEER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (LESE_RAM_ZELLE_INC)
        CALL       LESE_RAM_ZELLE_INC
 
; Retten der Parameter-Register fuer PROCEDURE (RF_LEER)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WERT_ZELLE)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (WERT_ZELLE)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (RF_FUELLBYTE)
        LDI        R18, 0xE5
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0631
        CLR        R16
        RJMP       M_VERGL_0632
M_VERGL_0631:
        SER        R16
M_VERGL_0632:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0628
        RJMP       M_IF_0629
M_IF_0628:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RF_IST_LEER)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0629:
 
; IF_THEN - Ende
M_IF_0624:
 
; RESULT Byte-Variable - FUNCTION (RF_LEER)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (RF_LEER)
        MOV        R16, R0
 
; FUNCTION - Ende (RF_LEER)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; ASM
.equ UBRR0 = UBRR0L

 
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x000A)
        MOV        R0, R16
        LDI        R17, HIGH(0x000A)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; Aufruf PROCEDURE (INIT_DATEN_ARRAY)
        CALL       INIT_DATEN_ARRAY
 
; Aufruf PROCEDURE (INIT_SER_PORT)
        CALL       INIT_SER_PORT
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; ClearBit(LED_GRUEN)
        CBI        PORTD, 6
 
; ClearBit(LED_ROT)
        CBI        PORTD, 7
 
; ClearBit(BCWA_A)
        CBI        PORTB, 3
 
; SetBit(BCWCLR_A)
        SBI        PORTB, 2
 
; Aufruf Funktion (RF_LEER)
        CALL       RF_LEER
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0633
        RJMP       M_IF_0634
M_IF_0633:
 
; Aufruf PROCEDURE (RAM_LOESCHEN)
        CALL       RAM_LOESCHEN
 
; Aufruf PROCEDURE (COPY_DISK_TO_RAM)
        CALL       COPY_DISK_TO_RAM
 
; IF_THEN - Ende
M_IF_0634:
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x000A)
        MOV        R0, R16
        LDI        R17, HIGH(0x000A)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (LAENGE_CPD5_ARRAY)
        LDI        R16, LOW(0x0B7F)
        LDI        R17, HIGH(0x0B7F)
 
; Zuweisung Ziel /  VAR (LAENGE_ARRAY)
        STS        LAENGE_ARRAY, R16
        STS        LAENGE_ARRAY+1, R17
 
; Zuweisung Quelle - Ausdruck / ArrayToAdress(CPD5_ARR)
        LDI        R16, LOW(2*CPD5_ARR)
        LDI        R17, HIGH(2*CPD5_ARR)
        LDI        R18, Byte3(2*CPD5_ARR)
 
; Zuweisung Ziel /  VAR (DATEN_ARRAY)
        STS        DATEN_ARRAY, R16
        STS        DATEN_ARRAY+1, R17
        STS        DATEN_ARRAY+2, R18
 
; Byte-Parameter(1) fuer PROCEDURE (COPY_ARRAY_TO_RAM)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (COPY_ARRAY_TO_RAM)
        CALL       COPY_ARRAY_TO_RAM
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x000A)
        MOV        R0, R16
        LDI        R17, HIGH(0x000A)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x40
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x000A)
        MOV        R0, R16
        LDI        R17, HIGH(0x000A)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Aufruf PROCEDURE (STARTE_Z80)
        CALL       STARTE_Z80
 
; LOOP - Start_Marke
M_LOOP_0636:
 
; Aufruf PROCEDURE (RX_PUFFER_ABFRAGEN)
        CALL       RX_PUFFER_ABFRAGEN
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0640
        CLR        R16
        RJMP       M_VERGL_0641
M_VERGL_0640:
        SER        R16
M_VERGL_0641:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0637
        RJMP       M_IF_0638
M_IF_0637:
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; IF_THEN - Ende
M_IF_0638:
 
; Aufruf PROCEDURE (Z80CALL_ABFRAGEN)
        CALL       Z80CALL_ABFRAGEN
 
; LOOP - Ende
        RJMP       M_LOOP_0636
 
; *** Unterprogramm Bibliothek ***
; Multiplikation von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17 erster Faktor
;            R18:R19 zweiter Faktor
; Temporaere Register: R20,R21,R22,R23,R24 
;                      R2 ,R3  R4  R5  R6
ASM_UP_MUL16:
 
        PUSH       R0
        PUSH       R1

        CLR        R24
        MUL        R19, R17
        MOVW       R23:R22, R1:R0
        MUL        R18, R16
        MOVW       R21:R20, R1:R0
        MUL        R19, R16
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MUL        R17, R18
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MOVW       R17:R16, R21:R20       ; Produkt Low
        MOVW       R19:R18, R23:R22       ; Produkt High

        POP        R1
        POP        R0		

        RET






 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UDR1 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR1H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UBRR1L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; UCSR1A (V) BYTECONVAR
; UCSR1B (V) BYTECONVAR
; UCSR1C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; OCR3BL (V) BYTECONVAR
; OCR3BH (V) BYTECONVAR
; OCR3AH (V) BYTECONVAR
; OCR3AL (V) BYTECONVAR
; ICR3L (V) BYTECONVAR
; ICR3H (V) BYTECONVAR
; TCNT3L (V) BYTECONVAR
; TCNT3H (V) BYTECONVAR
; TCCR3C (V) BYTECONVAR
; TCCR3B (V) BYTECONVAR
; TCCR3A (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; TIMSK3 (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; PCMSK3 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; PRR1 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR3 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; UBRR0 (V) WORDCONVAR
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; UBRR_VAL (C) WORD Wert=0x0008
; XON (C) BYTE Wert=0x11
; XOFF (C) BYTE Wert=0x13
; KEIN_CODE (C) BYTE Wert=0x00
; LOAD_ADRESS (C) BYTE Wert=0x01
; INC_ADRESS (C) BYTE Wert=0x02
; ADRESS_TRISTATE (C) BYTE Wert=0x03
; WAIT_Z80TOBUF (C) BYTE Wert=0x04
; WAIT_BUFTOBC (C) BYTE Wert=0x05
; BC_CONIN (C) BYTE Wert=0x01
; BC_CONST (C) BYTE Wert=0x02
; BC_CONOUT (C) BYTE Wert=0x03
; BC_LIST (C) BYTE Wert=0x04
; BC_COPY_BDOS (C) BYTE Wert=0x05
; BC_COPY_CCP (C) BYTE Wert=0x06
; BC_READ_SEC (C) BYTE Wert=0x07
; BC_WRITE_SEC (C) BYTE Wert=0x08
; BC_TRACE_Z80 (C) BYTE Wert=0x09
; BC_SET_TIME (C) BYTE Wert=0x0A
; CPM_SPT (C) BYTE Wert=0x48
; RF_FUELLBYTE (C) BYTE Wert=0xE5
; BB_LAENGE (C) WORD Wert=0x0384
; BB_LAENGE_DIV_3 (C) WORD Wert=0x012C
; TASTE_E (B) BIT
; AECMD_A (B) BIT
; BCWCLR_A (B) BIT
; BCWA_A (B) BIT
; Z80WA_E (B) BIT
; WAIT_E (B) BIT
; MREQ_A (B) BIT
; MREQ_E (B) BIT
; MREQ_D (B) BIT
; IORQ_A (B) BIT
; IORQ_E (B) BIT
; IORQ_D (B) BIT
; RD_A (B) BIT
; RD_E (B) BIT
; RD_D (B) BIT
; WR_A (B) BIT
; WR_E (B) BIT
; WR_D (B) BIT
; RESET_A (B) BIT
; BUSRQ_A (B) BIT
; BUSAK_E (B) BIT
; AECS_A (B) BIT
; AERQ_E (B) BIT
; Z80CALL_E (B) BIT
; Z80AK_A (B) BIT
; LED_GRUEN (B) BIT
; LED_ROT (B) BIT
; ZEICHEN (V) BYTE
; LOOP_IN (V) BOOLEAN
; CONSOLEIN (V) BYTE
; STEUER_STRING (V) STRING
; ANZEIGE_STRING (V) STRING
; SECTOR (V) BYTE
; TRACK_L (V) BYTE
; TRACK_H (V) BYTE
; DISKNO (V) BYTE
; DMAAD_L (V) BYTE
; DMAAD_H (V) BYTE
; SEKTOR_PUFFER (Y) BYTE
; SEKTOR_PUFFER_ZEIGER (V) WORD
; RF_15 (V) BYTE
; RF_08 (V) BYTE
; RF_00 (V) BYTE
; DATUM_GESETZT (V) BOOLEAN
; SCB_DATE_HI (V) BYTE
; SCB_DATE_LO (V) BYTE
; DATEN_ARRAY (V) ADRESS
; LAENGE_ARRAY (V) WORD
; RAM_Z80_HIGH (C) BYTE Wert=0xF4
; RAM_Z80CALL_MD (C) BYTE Wert=0xC6
; RAM_Z80CALL_P1 (C) BYTE Wert=0xC7
; RAM_Z80CALL_P2 (C) BYTE Wert=0xC8
; RAM_Z80CALL_P3 (C) BYTE Wert=0xC9
; RAM_Z80CALL_P4 (C) BYTE Wert=0xCA
; RAM_Z80CALL_P5 (C) BYTE Wert=0xCB
; RAM_Z80CALL_P6 (C) BYTE Wert=0xCC
; SECTOR_ADRESS_HI (C) BYTE Wert=0xF4
; SECTOR_ADRESS_LO (C) BYTE Wert=0x3A
; BDOS_ADRESS_HI (C) BYTE Wert=0xE6
; CCP_ADRESS_HI (C) BYTE Wert=0xDE
; LAENGE_CPD5_ARRAY (C) WORD Wert=0x0B7F
; CPD5_ARR (A) 
; LAENGE_ZSDOS_ARRAY (C) WORD Wert=0x0DFF
; ZSDOS_ARR (A) 
; LAENGE_CCP_ARRAY (C) WORD Wert=0x07FF
; CCP_ARR (A) 
; LAENGE_DISK_ARRAY (C) WORD Wert=0x641F
; DISK_ARR (A) 
; WRITE_STRING (V) STRING
; BYTEPOSTOORMASKE (F) 
; BYTEPOSTOANDMASKE (F) 
; READ_BIT_IN_BYTE (F) 
; SET_BIT_IN_BYTE (F) 
; CLEAR_BIT_IN_BYTE (F) 
; WAIT_MS (P) 
; INIT_SER_PORT (P) 
; RX_PUFFER_ABFRAGEN (P) 
; SENDE_ZEICHEN (P) 
; SENDE_HEX_ZEICHEN (P) 
; SENDE_HEX_ZEICHEN_LN (P) 
; WRITE (P) 
; WRITELN (P) 
; BYTETOSTRING (P) 
; STRINGTOBYTE (F) 
; INITPORTS (P) 
; INIT_DATEN_ARRAY (P) 
; AE_WRITE_BYTE (P) 
; AE_WRITE_ADRESS (P) 
; RAM_LOESCHEN (P) 
; COPY_ARRAY_TO_RAM (P) 
; COPY_DISK_TO_RAM (P) 
; COPY_SEKTOR_PUFFER_TO_RAM (P) 
; COPY_RAM_TO_SEKTOR_PUFFER (P) 
; LESE_RAM_ZELLE (F) 
; INC_ADRESSE (P) 
; LESE_RAM_ZELLE_INC (F) 
; SCHREIBE_RAM_ZELLE (P) 
; BC_BUS_ANFORDERN (P) 
; BC_BUS_FREIGEBEN (P) 
; STARTE_Z80 (P) 
; SEKTOR_DER_RAMFLOPPY_BERECHNEN (P) 
; STEUER_STRING_TO_SECTOR (P) 
; STEUER_STRING_TO_SECTOR_KOMP (P) 
; STEUER_STRING_TO_TIME (P) 
; STEUER_STRING_AUSWERTEN (P) 
; STEUER_STRING_LESEN (P) 
; STD_LESEN (P) 
; STD_AN_PC_SENDEN (P) 
; SEKTOR_VON_PC_LESEN (P) 
; SEKTOR_VON_PC_LESEN_KOMP (P) 
; SEKTOR_AN_PC_SENDEN (P) 
; UP_READ_SEC (P) 
; UP_WRITE_SEC (P) 
; UP_SET_TIME (P) 
; Z80CALL_ABFRAGEN (P) 
; RF_LEER (F) 
 
; *** Prozedur/Function-Liste ***
;
; FUNCTION BYTEPOSTOORMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION BYTEPOSTOANDMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION READ_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (VERGLEICH : BYTE) (MASKE : BYTE) : BOOLEAN;
; FUNCTION SET_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION CLEAR_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; PROCEDURE WAIT_MS (ZEIT : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE INIT_SER_PORT;
; PROCEDURE RX_PUFFER_ABFRAGEN;
; PROCEDURE SENDE_ZEICHEN (S_ZEICHEN : BYTE);
; PROCEDURE SENDE_HEX_ZEICHEN (H_ZEICHEN : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE);
; PROCEDURE SENDE_HEX_ZEICHEN_LN (WERT_BYTE : BYTE);
; PROCEDURE WRITE (C1 : CHAR) (LAENGE : BYTE) (B1 : BYTE) (B2 : BYTE);
; PROCEDURE WRITELN;
; PROCEDURE BYTETOSTRING (WERT_BYTE : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE) (C1 : CHAR);
; FUNCTION STRINGTOBYTE (HEXLOW : BYTE) (HEXHIGH : BYTE) (S2B : BYTE) (C1 : CHAR) : BYTE;
; PROCEDURE INITPORTS;
; PROCEDURE INIT_DATEN_ARRAY;
; PROCEDURE AE_WRITE_BYTE (WR_BYTE : BYTE);
; PROCEDURE AE_WRITE_ADRESS (A16 : BYTE) (A08 : BYTE) (A00 : BYTE);
; PROCEDURE RAM_LOESCHEN (ADRESSE_00_15 : WORD) (ADRESSE_16_18 : BYTE) (B1 : BYTE);
; PROCEDURE COPY_ARRAY_TO_RAM (ADR_HI : BYTE) (READ_DATA : BYTE) (ADRESSE : WORD);
; PROCEDURE COPY_DISK_TO_RAM (READ_DATA : BYTE) (ADRESSE : WORD);
; PROCEDURE COPY_SEKTOR_PUFFER_TO_RAM (SA15 : BYTE) (SA08 : BYTE) (SA00 : BYTE) (READ_DATA : BYTE) (ADRESSE : WORD);
; PROCEDURE COPY_RAM_TO_SEKTOR_PUFFER (SA15 : BYTE) (SA08 : BYTE) (SA00 : BYTE) (READ_DATA : BYTE) (ADRESSE : WORD);
; FUNCTION LESE_RAM_ZELLE (RAM_ZELLE : BYTE) : BYTE;
; PROCEDURE INC_ADRESSE;
; FUNCTION LESE_RAM_ZELLE_INC (RAM_ZELLE : BYTE) : BYTE;
; PROCEDURE SCHREIBE_RAM_ZELLE (WERT_ZELLE : BYTE);
; PROCEDURE BC_BUS_ANFORDERN;
; PROCEDURE BC_BUS_FREIGEBEN;
; PROCEDURE STARTE_Z80;
; PROCEDURE SEKTOR_DER_RAMFLOPPY_BERECHNEN (RF_ADRESSE : DWORD) (W1 : WORD) (W2 : WORD) (B1 : BYTE) (B2 : BYTE) (B3 : BYTE);
; PROCEDURE STEUER_STRING_TO_SECTOR (B1 : BYTE) (B2 : BYTE) (B3 : BYTE) (C1 : CHAR);
; PROCEDURE STEUER_STRING_TO_SECTOR_KOMP (X2 : BYTE) (DB7 : BYTE) (DB8 : BYTE) (BITPOS_DB8 : BYTE) (BITPOS_DB7 : BYTE) (C1 : CHAR) (POS_SS : BYTE) (EIN_BIT : BOOLEAN);
; PROCEDURE STEUER_STRING_TO_TIME (B1 : BYTE) (B2 : BYTE) (C1 : CHAR);
; PROCEDURE STEUER_STRING_AUSWERTEN (BUCHSTABE : CHAR) (ZEICHEN_1 : CHAR) (ZEICHEN_2 : CHAR) (LAENGE : BYTE);
; PROCEDURE STEUER_STRING_LESEN (AKT_ZEICHEN : CHAR);
; PROCEDURE STD_LESEN;
; PROCEDURE STD_AN_PC_SENDEN;
; PROCEDURE SEKTOR_VON_PC_LESEN (B1 : BYTE) (B2 : BYTE) (SPZ : WORD) (LESESCHLEIFE : WORD);
; PROCEDURE SEKTOR_VON_PC_LESEN_KOMP (B1 : BYTE) (B2 : BYTE) (SPZ : WORD) (LESESCHLEIFE : WORD);
; PROCEDURE SEKTOR_AN_PC_SENDEN (B1 : BYTE) (B2 : BYTE) (B3 : BYTE);
; PROCEDURE UP_READ_SEC;
; PROCEDURE UP_WRITE_SEC;
; PROCEDURE UP_SET_TIME (LESESCHLEIFE : WORD);
; PROCEDURE Z80CALL_ABFRAGEN (MODE : BYTE) (RAM_ZELLE : BYTE);
; FUNCTION RF_LEER (RF_IST_LEER : BOOLEAN) (WERT_ZELLE : BYTE) : BOOLEAN;
 
; *** Konstanten-ARRAYs ***
;
 
CPD5_ARR:
.db    0xF3,0x31
.db    0xFE,0xFF
.db    0x21,0x12
.db    0x00,0x11
.db    0x00,0xF4
.db    0x01,0x44
.db    0x0B,0xED
.db    0xB0,0xC3
.db    0x00,0xF4
.db    0xC3,0x6A
.db    0xF9,0xC3
.db    0x99,0xF9
.db    0xC3,0xC7
.db    0xF9,0xC3
.db    0xED,0xF9
.db    0xC3,0x15
.db    0xFA,0xC3
.db    0x40,0xFA
.db    0xC3,0x46
.db    0xFA,0xC3
.db    0x6A,0xFA
.db    0xC3,0x6B
.db    0xFA,0xC3
.db    0x71,0xFA
.db    0xC3,0x87
.db    0xFA,0xC3
.db    0x8C,0xFA
.db    0xC3,0x91
.db    0xFA,0xC3
.db    0x96,0xFA
.db    0xC3,0x9D
.db    0xFA,0xC3
.db    0xA4,0xFA
.db    0xC3,0xA7
.db    0xFA,0xC3
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x02
.db    0x00,0x00
.db    0x80,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0xFA,0xF4
.db    0xF6,0xFB
.db    0xF5,0xF7
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x0C
.db    0x43,0x50
.db    0x2F,0x4D
.db    0x20,0x32
.db    0x2E,0x32
.db    0x20,0x43
.db    0x6F,0x70
.db    0x79,0x72
.db    0x69,0x67
.db    0x68,0x74
.db    0x20,0x31
.db    0x39,0x37
.db    0x39,0x20
.db    0x28,0x63
.db    0x29,0x20
.db    0x62,0x79
.db    0x20,0x44
.db    0x69,0x67
.db    0x69,0x74
.db    0x61,0x6C
.db    0x20,0x52
.db    0x65,0x73
.db    0x65,0x61
.db    0x72,0x63
.db    0x68,0x0D
.db    0x0A,0x42
.db    0x49,0x4F
.db    0x53,0x2D
.db    0x4D,0x6F
.db    0x6E,0x69
.db    0x74,0x6F
.db    0x72,0x20
.db    0x32,0x30
.db    0x31,0x33
.db    0x20,0x77
.db    0x72,0x69
.db    0x74,0x74
.db    0x65,0x6E
.db    0x20,0x62
.db    0x79,0x20
.db    0x52,0x6F
.db    0x6E,0x61
.db    0x6C,0x64
.db    0x20,0x44
.db    0x61,0x6C
.db    0x65,0x73
.db    0x6B,0x65
.db    0x0D,0x0A
.db    0x0D,0x0A
.db    0x00,0x5A
.db    0x65,0x69
.db    0x63,0x68
.db    0x65,0x6E
.db    0x3D,0x00
.db    0x0D,0x0A
.db    0x00,0x0D
.db    0x0A,0x41
.db    0x6E,0x7A
.db    0x61,0x68
.db    0x6C,0x20
.db    0x64,0x65
.db    0x72,0x20
.db    0x53,0x65
.db    0x6B,0x74
.db    0x6F,0x72
.db    0x65,0x6E
.db    0x20,0x64
.db    0x65,0x72
.db    0x20,0x42
.db    0x4F,0x4F
.db    0x54,0x2D
.db    0x44,0x61
.db    0x74,0x65
.db    0x69,0x3D
.db    0x00,0x53
.db    0x65,0x6B
.db    0x74,0x6F
.db    0x72,0x3D
.db    0x00,0x0D
.db    0x0A,0x53
.db    0x70,0x75
.db    0x72,0x3D
.db    0x00,0x0D
.db    0x0A,0x4C
.db    0x61,0x75
.db    0x66,0x77
.db    0x65,0x72
.db    0x6B,0x3D
.db    0x00,0x53
.db    0x3D,0x00
.db    0x20,0x54
.db    0x3D,0x00
.db    0x20,0x44
.db    0x3D,0x00
.db    0x20,0x42
.db    0x3D,0x00
.db    0x20,0x41
.db    0x3D,0x00
.db    0x43,0x6F
.db    0x6E,0x6E
.db    0x65,0x63
.db    0x74,0x6F
.db    0x72,0x28
.db    0x31,0x29
.db    0x20,0x2D
.db    0x3E,0x20
.db    0x00,0x50
.db    0x43,0x2D
.db    0x43,0x50
.db    0x2F,0x4D
.db    0x2D,0x45
.db    0x6D,0x75
.db    0x6C,0x61
.db    0x74,0x6F
.db    0x72,0x0D
.db    0x0A,0x00
.db    0x54,0x61
.db    0x73,0x74
.db    0x61,0x74
.db    0x75,0x72
.db    0x0D,0x0A
.db    0x00,0x4C
.db    0x43,0x2D
.db    0x44,0x69
.db    0x73,0x70
.db    0x6C,0x61
.db    0x79,0x0D
.db    0x0A,0x00
.db    0x52,0x41
.db    0x4D,0x2D
.db    0x46,0x6C
.db    0x6F,0x70
.db    0x70,0x79
.db    0x0D,0x0A
.db    0x00,0x54
.db    0x61,0x73
.db    0x74,0x61
.db    0x74,0x75
.db    0x72,0x20
.db    0x75,0x6E
.db    0x64,0x20
.db    0x56,0x47
.db    0x41,0x0D
.db    0x0A,0x00
.db    0x54,0x6F
.db    0x6E,0x61
.db    0x75,0x73
.db    0x67,0x61
.db    0x62,0x65
.db    0x0D,0x0A
.db    0x00,0x0D
.db    0x0A,0x00
.db    0x00,0x00
.db    0x00,0x04
.db    0x00,0x04
.db    0x00,0x80
.db    0x00,0x8A
.db    0xF6,0x45
.db    0xF6,0x8A
.db    0xF7,0x0A
.db    0xF7,0x00
.db    0x00,0x04
.db    0x00,0x04
.db    0x00,0x80
.db    0x00,0x8A
.db    0xF6,0x5C
.db    0xF6,0x4A
.db    0xF8,0xCA
.db    0xF7,0x00
.db    0x00,0x04
.db    0x00,0x04
.db    0x00,0x80
.db    0x00,0x8A
.db    0xF6,0x73
.db    0xF6,0x0A
.db    0xF9,0x8A
.db    0xF8,0x48
.db    0x00,0x04
.db    0x0F,0x00
.db    0xC6,0x02
.db    0xFF,0x00
.db    0xF0,0x00
.db    0x40,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x48,0x00
.db    0x04,0x0F
.db    0x00,0xC6
.db    0x02,0xFF
.db    0x00,0xF0
.db    0x00,0x40
.db    0x00,0x02
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x48
.db    0x00,0x04
.db    0x0F,0x00
.db    0xC6,0x02
.db    0xFF,0x00
.db    0xF0,0x00
.db    0x40,0x00
.db    0x02,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x31,0xFE
.db    0xFF,0xCD
.db    0xF5,0xFD
.db    0xCD,0x75
.db    0xFB,0xCD
.db    0xE6,0xFD
.db    0xCD,0x41
.db    0xFE,0xCD
.db    0x67,0xFE
.db    0xCD,0x83
.db    0xFE,0x3E
.db    0x07,0x32
.db    0xCD,0xF4
.db    0x21,0xE5
.db    0xF4,0xCD
.db    0x17,0xFB
.db    0xCD,0xAA
.db    0xFA,0x0E
.db    0x0C,0xCD
.db    0x46,0xFA
.db    0xAF,0x32
.db    0x03,0x00
.db    0x32,0x04
.db    0x00,0x31
.db    0xFE,0xFF
.db    0x06,0x05
.db    0xCD,0x4F
.db    0xFB,0x06
.db    0x06,0xCD
.db    0x4F,0xFB
.db    0x3E,0xC3
.db    0x32,0x00
.db    0x00,0x21
.db    0x03,0xF4
.db    0x22,0x01
.db    0x00,0x32
.db    0x05,0x00
.db    0x21,0x06
.db    0xE6,0x22
.db    0x06,0x00
.db    0x01,0x80
.db    0x00,0xCD
.db    0x91,0xFA
.db    0x3A,0x04
.db    0x00,0x4F
.db    0xC3,0x03
.db    0xDE,0x3A
.db    0xDD,0xF4
.db    0xFE,0x00
.db    0x28,0x1E
.db    0x32,0xD0
.db    0xF4,0xCD
.db    0xD8,0xFC
.db    0x06,0x01
.db    0xCD,0x87
.db    0xFD,0xCD
.db    0x83,0xFC
.db    0xCD,0x2D
.db    0xFD,0x18
.db    0x0B,0x06
.db    0x02,0xCD
.db    0x4F,0xFB
.db    0xFE,0x00
.db    0x28,0x02
.db    0x3E,0xFF
.db    0xC9,0x3A
.db    0xDD,0xF4
.db    0xFE,0x00
.db    0x28,0x17
.db    0x32,0xD0
.db    0xF4,0xCD
.db    0xD8,0xFC
.db    0x06,0x02
.db    0xCD,0x87
.db    0xFD,0xCD
.db    0x83,0xFC
.db    0xCD,0x2D
.db    0xFD,0xFE
.db    0x00,0x28
.db    0xE4,0x18
.db    0x09,0x06
.db    0x01,0xCD
.db    0x4F,0xFB
.db    0xFE,0x00
.db    0x28,0xD9
.db    0xC9,0x3A
.db    0xDB,0xF4
.db    0xFE,0x00
.db    0x28,0x1E
.db    0x32,0xD0
.db    0xF4,0xDD
.db    0xE5,0xFD
.db    0xE5,0xC5
.db    0xCD,0xD8
.db    0xFC,0x06
.db    0x03,0xCD
.db    0x87,0xFD
.db    0xC1,0x41
.db    0xCD,0x87
.db    0xFD,0xCD
.db    0x83,0xFC
.db    0xFD,0xE1
.db    0xDD,0xE1
.db    0x18,0x05
.db    0x06,0x03
.db    0xCD,0x4F
.db    0xFB,0xC9
.db    0x06,0x04
.db    0xCD,0x4F
.db    0xFB,0xC9
.db    0x3A,0xE2
.db    0xF4,0xFE
.db    0x00,0x28
.db    0x1C,0x32
.db    0xD0,0xF4
.db    0xDD,0xE5
.db    0xFD,0xE5
.db    0xC5,0xCD
.db    0xD8,0xFC
.db    0x06,0x0F
.db    0xCD,0x87
.db    0xFD,0xC1
.db    0x41,0xCD
.db    0x87,0xFD
.db    0xCD,0x83
.db    0xFC,0xFD
.db    0xE1,0xDD
.db    0xE1,0xC9
.db    0xC9,0x0E
.db    0x00,0xCD
.db    0x87,0xFA
.db    0xC9,0x21
.db    0x00,0x00
.db    0x79,0xFE
.db    0x03,0xD0
.db    0x32,0x3D
.db    0xF4,0x6F
.db    0x26,0x00
.db    0x29,0x29
.db    0x29,0x29
.db    0x11,0x15
.db    0xF6,0x19
.db    0xC9,0xED
.db    0x43,0x3B
.db    0xF4,0xC9
.db    0x79,0x32
.db    0x3A,0xF4
.db    0xC9,0xED
.db    0x43,0x3E
.db    0xF4,0xC9
.db    0x06,0x07
.db    0xCD,0x4F
.db    0xFB,0xAF
.db    0xC9,0x06
.db    0x08,0xCD
.db    0x4F,0xFB
.db    0xAF,0xC9
.db    0x3E,0xFF
.db    0xC9,0x60
.db    0x69,0xC9
.db    0x21,0xD6
.db    0xF4,0x06
.db    0x03,0x0E
.db    0x31,0x7E
.db    0xFE,0x00
.db    0x28,0x56
.db    0xE5,0xC5
.db    0xF5,0x79
.db    0x32,0xB2
.db    0xF5,0x21
.db    0xA8,0xF5
.db    0xCD,0x17
.db    0xFB,0xF1
.db    0xFE,0x02
.db    0x20,0x08
.db    0x21,0xB9
.db    0xF5,0xCD
.db    0x17,0xFB
.db    0x18,0x3A
.db    0xFE,0x03
.db    0x20,0x08
.db    0x21,0xCC
.db    0xF5,0xCD
.db    0x17,0xFB
.db    0x18,0x2E
.db    0xFE,0x04
.db    0x20,0x08
.db    0x21,0xD7
.db    0xF5,0xCD
.db    0x17,0xFB
.db    0x18,0x22
.db    0xFE,0x05
.db    0x20,0x08
.db    0x21,0xE4
.db    0xF5,0xCD
.db    0x17,0xFB
.db    0x18,0x16
.db    0xFE,0x06
.db    0x20,0x08
.db    0x21,0xF1
.db    0xF5,0xCD
.db    0x17,0xFB
.db    0x18,0x0A
.db    0xFE,0x07
.db    0x20,0x06
.db    0x21,0x04
.db    0xF6,0xCD
.db    0x17,0xFB
.db    0xC1,0xE1
.db    0x23,0x0C
.db    0x10,0xA1
.db    0x21,0x11
.db    0xF6,0xCD
.db    0x17,0xFB
.db    0xC9,0x7E
.db    0xB7,0xC8
.db    0x4F,0xE5
.db    0xCD,0x15
.db    0xFA,0xE1
.db    0x23,0x18
.db    0xF4,0x0E
.db    0x0D,0xCD
.db    0x15,0xFA
.db    0x0E,0x0A
.db    0xCD,0x15
.db    0xFA,0xC9
.db    0x3A,0xCD
.db    0xF4,0xD3
.db    0xF8,0xCB
.db    0x5F,0x28
.db    0x04,0xCB
.db    0x9F,0x18
.db    0x02,0xCB
.db    0xDF,0x32
.db    0xCD,0xF4
.db    0xC9,0x0E
.db    0xD4,0x06
.db    0xFE,0x05
.db    0x20,0xFD
.db    0x0D,0x20
.db    0xF8,0x3D
.db    0x20,0xF3
.db    0xC9,0xDB
.db    0xF8,0xCB
.db    0x4F,0x28
.db    0xFA,0x78
.db    0x32,0xC6
.db    0xF4,0x79
.db    0x32,0xC7
.db    0xF4,0x3A
.db    0xCD,0xF4
.db    0xCB,0x87
.db    0xD3,0xF8
.db    0xDB,0xF8
.db    0xCB,0x4F
.db    0x20,0xFA
.db    0x3A,0xCD
.db    0xF4,0xCB
.db    0xC7,0xD3
.db    0xF8,0x3A
.db    0xC7,0xF4
.db    0xC9,0x21
.db    0x81,0xFB
.db    0x06,0x12
.db    0x4E,0x23
.db    0xED,0xA3
.db    0x20,0xFA
.db    0xC9,0xF9
.db    0x03,0xFB
.db    0x03,0xF8
.db    0x07,0xF9
.db    0xCF,0xF9
.db    0xF2,0xF8
.db    0x07,0xFA
.db    0x30,0xFB
.db    0xCF,0xFB
.db    0xEF,0xFA
.db    0x30,0xF4
.db    0x30,0xF5
.db    0xCF,0xF5
.db    0xEF,0xF4
.db    0x30,0xF6
.db    0x30,0xF7
.db    0xCF,0xF7
.db    0xEF,0xF6
.db    0x30,0xC5
.db    0xCD,0xD8
.db    0xFC,0x06
.db    0x0E,0xCD
.db    0x87,0xFD
.db    0xC1,0xCD
.db    0x87,0xFD
.db    0xCD,0x83
.db    0xFC,0xC9
.db    0xCD,0xD8
.db    0xFC,0x06
.db    0x04,0xCD
.db    0x87,0xFD
.db    0xCD,0x83
.db    0xFC,0xCD
.db    0x2D,0xFD
.db    0xC9,0xCD
.db    0xD8,0xFC
.db    0x06,0x0B
.db    0xCD,0x87
.db    0xFD,0xCD
.db    0x83,0xFC
.db    0xC9,0xCD
.db    0xD8,0xFC
.db    0x06,0x0C
.db    0xCD,0x87
.db    0xFD,0xCD
.db    0x83,0xFC
.db    0xC9,0xCD
.db    0xD8,0xFC
.db    0x06,0x0A
.db    0xCD,0x87
.db    0xFD,0xCD
.db    0x83,0xFC
.db    0xCD,0x2D
.db    0xFD,0x67
.db    0xE5,0xCD
.db    0x2D,0xFD
.db    0xE1,0x6F
.db    0xC9,0xCD
.db    0xD8,0xFC
.db    0x06,0x14
.db    0xCD,0x87
.db    0xFD,0xCD
.db    0x83,0xFC
.db    0xCD,0x2D
.db    0xFD,0xC9
.db    0xDD,0x21
.db    0xC0,0xF4
.db    0xFD,0x21
.db    0xC3,0xF4
.db    0x21,0xD1
.db    0xF4,0x3A
.db    0xD0,0xF4
.db    0x3D,0x28
.db    0x08,0x47
.db    0xDD,0x23
.db    0xFD,0x23
.db    0x23,0x10
.db    0xF9,0xC9
.db    0xCD,0x02
.db    0xFC,0x7E
.db    0xCB,0xA7
.db    0xDD,0x4E
.db    0x00,0xED
.db    0x79,0x77
.db    0x3A,0xCD
.db    0xF4,0xCB
.db    0xDF,0xD3
.db    0xF8,0x32
.db    0xCD,0xF4
.db    0x3E,0x00
.db    0x32,0xCE
.db    0xF4,0x3E
.db    0x00,0x32
.db    0xCF,0xF4
.db    0x3A,0xCE
.db    0xF4,0x3D
.db    0x32,0xCE
.db    0xF4,0x20
.db    0x09,0x3A
.db    0xCF,0xF4
.db    0x3D,0x32
.db    0xCF,0xF4
.db    0x28,0x32
.db    0xDD,0x4E
.db    0x00,0xED
.db    0x78,0xCB
.db    0x6F,0x20
.db    0xE5,0x3A
.db    0xCD,0xF4
.db    0xCB,0x9F
.db    0xD3,0xF8
.db    0x32,0xCD
.db    0xF4,0x7E
.db    0xCB,0xBF
.db    0xCB,0xB7
.db    0xDD,0x4E
.db    0x00,0xED
.db    0x79,0x77
.db    0xFD,0x4E
.db    0x00,0x3E
.db    0xCF,0xED
.db    0x79,0x3E
.db    0x6F,0xED
.db    0x79,0x7E
.db    0xDD,0x4E
.db    0x00,0xED
.db    0x79,0x3E
.db    0x01,0xC9
.db    0x3E,0x00
.db    0xC9,0xCD
.db    0x02,0xFC
.db    0x7E,0xCB
.db    0x67,0xC8
.db    0xFD,0x4E
.db    0x00,0x3E
.db    0xCF,0xED
.db    0x79,0x3E
.db    0xEF,0xED
.db    0x79,0x7E
.db    0xCB,0xA7
.db    0xDD,0x4E
.db    0x00,0xED
.db    0x79,0x77
.db    0x3A,0xCD
.db    0xF4,0xCB
.db    0xDF,0xD3
.db    0xF8,0x32
.db    0xCD,0xF4
.db    0xDD,0x4E
.db    0x00,0xED
.db    0x78,0xCB
.db    0x6F,0x20
.db    0xFA,0x3A
.db    0xCD,0xF4
.db    0xCB,0x9F
.db    0xD3,0xF8
.db    0x32,0xCD
.db    0xF4,0x7E
.db    0xCB,0xBF
.db    0xCB,0xB7
.db    0xDD,0x4E
.db    0x00,0xED
.db    0x79,0x77
.db    0xFD,0x4E
.db    0x00,0x3E
.db    0xCF,0xED
.db    0x79,0x3E
.db    0x6F,0xED
.db    0x79,0x7E
.db    0xDD,0x4E
.db    0x00,0xED
.db    0x79,0xC9
.db    0xCD,0x02
.db    0xFC,0x7E
.db    0xCB,0x67
.db    0xC0,0xFD
.db    0x4E,0x00
.db    0x3E,0xCF
.db    0xED,0x79
.db    0x3E,0xEF
.db    0xED,0x79
.db    0x7E,0xCB
.db    0xE7,0xDD
.db    0x4E,0x00
.db    0xED,0x79
.db    0x77,0x3A
.db    0xCD,0xF4
.db    0xCB,0xDF
.db    0xD3,0xF8
.db    0x32,0xCD
.db    0xF4,0xDD
.db    0x4E,0x00
.db    0xED,0x78
.db    0xCB,0x6F
.db    0x28,0xFA
.db    0x3A,0xCD
.db    0xF4,0xCB
.db    0x9F,0xD3
.db    0xF8,0x32
.db    0xCD,0xF4
.db    0x7E,0xCB
.db    0xBF,0xCB
.db    0xB7,0xDD
.db    0x4E,0x00
.db    0xED,0x79
.db    0x77,0xFD
.db    0x4E,0x00
.db    0x3E,0xCF
.db    0xED,0x79
.db    0x3E,0xA0
.db    0xED,0x79
.db    0x7E,0xDD
.db    0x4E,0x00
.db    0xED,0x79
.db    0xC9,0xCD
.db    0x02,0xFC
.db    0xCD,0x42
.db    0xFD,0xF5
.db    0xCD,0x42
.db    0xFD,0xC1
.db    0xCB,0x27
.db    0xCB,0x27
.db    0xCB,0x27
.db    0xCB,0x27
.db    0x80,0xC9
.db    0x3A,0xCD
.db    0xF4,0xCB
.db    0xDF,0xD3
.db    0xF8,0x32
.db    0xCD,0xF4
.db    0x7E,0xCB
.db    0xBF,0xDD
.db    0x4E,0x00
.db    0xED,0x79
.db    0x77,0xED
.db    0x78,0xCB
.db    0x77,0x28
.db    0xFA,0x00
.db    0x00,0x00
.db    0x00,0xED
.db    0x78,0x47
.db    0x7E,0xCB
.db    0xFF,0xED
.db    0x79,0x77
.db    0xED,0x78
.db    0xCB,0x77
.db    0x20,0xFA
.db    0x3A,0xCD
.db    0xF4,0xCB
.db    0x9F,0xD3
.db    0xF8,0x32
.db    0xCD,0xF4
.db    0x7E,0xCB
.db    0xBF,0xCB
.db    0xB7,0xDD
.db    0x4E,0x00
.db    0xED,0x79
.db    0x77,0x78
.db    0xE6,0x0F
.db    0xC9,0xC5
.db    0xCD,0x02
.db    0xFC,0xC1
.db    0xC5,0x78
.db    0xE6,0x0F
.db    0x47,0xCD
.db    0xA1,0xFD
.db    0xC1,0xCB
.db    0x38,0xCB
.db    0x38,0xCB
.db    0x38,0xCB
.db    0x38,0xCD
.db    0xA1,0xFD
.db    0xC9,0x3A
.db    0xCD,0xF4
.db    0xCB,0xDF
.db    0xD3,0xF8
.db    0x32,0xCD
.db    0xF4,0x7E
.db    0xCB,0xB7
.db    0xDD,0x4E
.db    0x00,0xED
.db    0x79,0x77
.db    0xED,0x78
.db    0xCB,0x7F
.db    0x20,0xFA
.db    0x7E,0xE6
.db    0xF0,0xB0
.db    0xED,0x79
.db    0x00,0x00
.db    0x00,0xCB
.db    0xF7,0xED
.db    0x79,0x77
.db    0x00,0x00
.db    0xED,0x78
.db    0xCB,0x7F
.db    0x28,0xFA
.db    0x3A,0xCD
.db    0xF4,0xCB
.db    0x9F,0xD3
.db    0xF8,0x32
.db    0xCD,0xF4
.db    0x7E,0xCB
.db    0xBF,0xCB
.db    0xB7,0xDD
.db    0x4E,0x00
.db    0xED,0x79
.db    0x77,0xC9
.db    0x06,0x03
.db    0xC5,0xCD
.db    0x2E,0xFB
.db    0x3E,0x01
.db    0xCD,0x41
.db    0xFB,0xC1
.db    0x10,0xF4
.db    0xC9,0x3E
.db    0x30,0x21
.db    0xD1,0xF4
.db    0x77,0x23
.db    0x77,0x23
.db    0x77,0x06
.db    0x03,0x21
.db    0xC3,0xF4
.db    0x4E,0x3E
.db    0xCF,0xED
.db    0x79,0x3E
.db    0xFF,0xED
.db    0x79,0x23
.db    0x10,0xF4
.db    0x06,0x03
.db    0x21,0xC0
.db    0xF4,0x11
.db    0xD6,0xF4
.db    0x4E,0xED
.db    0x78,0x12
.db    0x23,0x13
.db    0x10,0xF8
.db    0x21,0xD6
.db    0xF4,0x23
.db    0x23,0x3E
.db    0x01,0x32
.db    0xD0,0xF4
.db    0x06,0x03
.db    0x0E,0x00
.db    0x7E,0x71
.db    0xE6,0xF0
.db    0xFE,0x30
.db    0x20,0x07
.db    0x3E,0x01
.db    0x77,0x78
.db    0x32,0xD0
.db    0xF4,0x2B
.db    0x10,0xEE
.db    0xC9,0x3E
.db    0x01,0x32
.db    0xD0,0xF4
.db    0x21,0xD6
.db    0xF4,0x23
.db    0x23,0x06
.db    0x03,0x7E
.db    0xFE,0x00
.db    0x28,0x11
.db    0x78,0x32
.db    0xD0,0xF4
.db    0xC5,0xE5
.db    0xCD,0x1C
.db    0xFC,0xE1
.db    0xC1,0xFE
.db    0x01,0x28
.db    0x02,0xAF
.db    0x77,0x2B
.db    0x10,0xE7
.db    0xC9,0x21
.db    0xD6,0xF4
.db    0x23,0x23
.db    0x06,0x03
.db    0x7E,0xFE
.db    0x00,0x28
.db    0x0C,0x78
.db    0x32,0xD0
.db    0xF4,0xC5
.db    0xE5,0xCD
.db    0xF3,0xFB
.db    0xE1,0xC1
.db    0x77,0x2B
.db    0x10,0xEC
.db    0xC9,0xAF
.db    0x32,0xDB
.db    0xF4,0x32
.db    0xDC,0xF4
.db    0x32,0xDD
.db    0xF4,0x32
.db    0xDE,0xF4
.db    0x32,0xDF
.db    0xF4,0x32
.db    0xE0,0xF4
.db    0x32,0xE1
.db    0xF4,0x32
.db    0xE2,0xF4
.db    0x21,0xD6
.db    0xF4,0x23
.db    0x23,0x06
.db    0x03,0x7E
.db    0xFE,0x00
.db    0xCA,0x3D
.db    0xFF,0xFE
.db    0x02,0x20
.db    0x28,0x3A
.db    0xDB,0xF4
.db    0xFE,0x00
.db    0x28,0x03
.db    0x32,0xDC
.db    0xF4,0x78
.db    0x32,0xDB
.db    0xF4,0x3A
.db    0xDE,0xF4
.db    0xFE,0x00
.db    0x28,0x03
.db    0x32,0xDF
.db    0xF4,0x78
.db    0x32,0xDE
.db    0xF4,0x78
.db    0x32,0xDD
.db    0xF4,0x32
.db    0xE0,0xF4
.db    0x32,0xE1
.db    0xF4,0x18
.db    0x68,0xFE
.db    0x03,0x20
.db    0x06,0x78
.db    0x32,0xDD
.db    0xF4,0x18
.db    0x5E,0xFE
.db    0x04,0x20
.db    0x13,0x3A
.db    0xDB,0xF4
.db    0xFE,0x00
.db    0x20,0x06
.db    0x78,0x32
.db    0xDB,0xF4
.db    0x18,0x4D
.db    0x78,0x32
.db    0xDC,0xF4
.db    0x18,0x47
.db    0xFE,0x05
.db    0x20,0x20
.db    0x3A,0xDE
.db    0xF4,0xFE
.db    0x00,0x28
.db    0x03,0x32
.db    0xDF,0xF4
.db    0x78,0x32
.db    0xDE,0xF4
.db    0x78,0x32
.db    0xE0,0xF4
.db    0x32,0xD0
.db    0xF4,0xF5
.db    0xC5,0xE5
.db    0xCD,0xD1
.db    0xFB,0xE1
.db    0xC1,0xF1
.db    0x18,0x23
.db    0xFE,0x06
.db    0x20,0x17
.db    0x3A,0xDB
.db    0xF4,0xFE
.db    0x00,0x20
.db    0x06,0x78
.db    0x32,0xDB
.db    0xF4,0x18
.db    0x04,0x78
.db    0x32,0xDC
.db    0xF4,0x78
.db    0x32,0xDD
.db    0xF4,0x18
.db    0x08,0xFE
.db    0x07,0x20
.db    0x04,0x78
.db    0x32,0xE2
.db    0xF4,0x2B
.db    0x10,0x01
.db    0xC9,0xC3
.db    0xA3,0xFE
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
ZSDOS_ARR:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0xC3,0x9B
.db    0xE6,0x4C
.db    0xE9,0x4C
.db    0xE9,0x4C
.db    0xE9,0x4C
.db    0xE9,0xF1
.db    0xF3,0x00
.db    0x00,0x6D
.db    0xDD,0xF3
.db    0xDD,0xF3
.db    0xDD,0xF3
.db    0xDD,0xF3
.db    0xDD,0xF3
.db    0xDD,0xF3
.db    0xDD,0xF3
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x80,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x5A
.db    0x53,0x44
.db    0x4F,0x53
.db    0x20,0x31
.db    0x2E,0x31
.db    0x20,0x43
.db    0x6F,0x70
.db    0x79,0x72
.db    0x69,0x67
.db    0x68,0x74
.db    0x20,0x28
.db    0x63,0x29
.db    0x20,0x31
.db    0x39,0x38
.db    0x37,0x2C
.db    0x38,0x38
.db    0x20,0x20
.db    0x43,0x2E
.db    0x57,0x2E
.db    0x43,0x6F
.db    0x74,0x72
.db    0x69,0x6C
.db    0x6C,0x20
.db    0x26,0x20
.db    0x48,0x2E
.db    0x46,0x2E
.db    0x42,0x6F
.db    0x77,0x65
.db    0x72,0xAF
.db    0x47,0x6F
.db    0x67,0x22
.db    0x4C,0xE6
.db    0x22,0x4E
.db    0xE6,0xED
.db    0x73,0x61
.db    0xE6,0x31
.db    0x9B,0xE6
.db    0xDD,0xE5
.db    0xD5,0xDD
.db    0xE1,0xDD
.db    0x22,0x5D
.db    0xE6,0xDD
.db    0x22,0x5F
.db    0xE6,0x21
.db    0xE6,0xE9
.db    0xE5,0x79
.db    0x32,0x4B
.db    0xE6,0xFE
.db    0x0C,0x38
.db    0x0D,0xFE
.db    0x31,0x38
.db    0x0D,0xFE
.db    0x62,0xD8
.db    0xFE,0x68
.db    0xD0,0xD6
.db    0x31,0x4F
.db    0x21,0xBB
.db    0xEA,0xE5
.db    0x21,0xE2
.db    0xE6,0x09
.db    0x09,0x7E
.db    0x23,0x66
.db    0x6F,0x4B
.db    0x7B,0xE9
.db    0xCA,0xE9
.db    0x50,0xE7
.db    0x64,0xE8
.db    0x15,0xF4
.db    0x12,0xF4
.db    0x0F,0xF4
.db    0x5A,0xE7
.db    0x91,0xE7
.db    0x8E,0xE7
.db    0xD5,0xE8
.db    0x95,0xE7
.db    0xB7,0xE8
.db    0xCF,0xEA
.db    0x0A,0xEA
.db    0x7A,0xEB
.db    0xB4,0xF0
.db    0xA8,0xED
.db    0x6E,0xEA
.db    0x95,0xEA
.db    0xA5,0xEA
.db    0xBE,0xF1
.db    0xFF,0xF1
.db    0x02,0xF1
.db    0xB0,0xEA
.db    0xE8,0xEA
.db    0xB8,0xEA
.db    0x33,0xEE
.db    0xE4,0xEA
.db    0x03,0xED
.db    0xDC,0xEA
.db    0xC7,0xEA
.db    0xEC,0xEA
.db    0xFB,0xEA
.db    0xB4,0xF1
.db    0xF4,0xF1
.db    0x07,0xEB
.db    0x0F,0xEB
.db    0x1A,0xEA
.db    0xBE,0xEA
.db    0xE0,0xEA
.db    0xF4,0xF1
.db    0xBE,0xEA
.db    0xBE,0xEA
.db    0xBE,0xEA
.db    0xBE,0xEA
.db    0xF7,0xEA
.db    0xBE,0xEA
.db    0xF0,0xEA
.db    0xD8,0xEA
.db    0xD7,0xF3
.db    0xD4,0xF3
.db    0xC2,0xEA
.db    0xBF,0xEA
.db    0xA4,0xF3
.db    0xA4,0xF3
.db    0xCD,0x75
.db    0xE7,0xD8
.db    0xE5,0xCD
.db    0x64,0xE8
.db    0xE1,0xC9
.db    0x1C,0x28
.db    0x14,0x1C
.db    0x28,0x06
.db    0x1C,0x28
.db    0x12,0xC3
.db    0x0C,0xF4
.db    0x3A,0x29
.db    0xE6,0xB7
.db    0x3E,0x01
.db    0xCC,0x06
.db    0xF4,0xA7
.db    0xC9,0xCD
.db    0x66,0xE7
.db    0xC8,0x21
.db    0x29,0xE6
.db    0x7E,0x36
.db    0x00,0xB7
.db    0xCC,0x09
.db    0xF4,0xFE
.db    0x0D,0xC8
.db    0xFE,0x0A
.db    0xC8,0xFE
.db    0x09,0xC8
.db    0xFE,0x08
.db    0xC8,0xFE
.db    0x20,0xC9
.db    0x32,0x03
.db    0x00,0x3A
.db    0x03,0x00
.db    0xC9,0x3A
.db    0x26,0xE6
.db    0x32,0x27
.db    0xE6,0x13
.db    0xAF,0x12
.db    0x13,0xD5
.db    0xCD,0x75
.db    0xE7,0xD1
.db    0x21,0x9F
.db    0xE7,0xE5
.db    0x2A,0x5D
.db    0xE6,0x4E
.db    0x23,0xFE
.db    0x0D,0x28
.db    0x02,0xFE
.db    0x0A,0xCA
.db    0x4E,0xE8
.db    0xFE,0x7F
.db    0x28,0x04
.db    0xFE,0x08
.db    0x20,0x36
.db    0x7E,0xA7
.db    0xC8,0x1B
.db    0x35,0xD5
.db    0x46,0x23
.db    0xEB,0x21
.db    0x26,0xE6
.db    0x4E,0x23
.db    0x7E,0x2B
.db    0x77,0x04
.db    0x18,0x05
.db    0x1A,0xCD
.db    0x93,0xE8
.db    0x13,0x10
.db    0xF9,0x79
.db    0x96,0x47
.db    0x71,0xD1
.db    0xD5,0x0E
.db    0x08,0xC5
.db    0xCD,0x0C
.db    0xF4,0x0E
.db    0x20,0xCD
.db    0x0C,0xF4
.db    0x3E,0x08
.db    0xCD,0x64
.db    0xE8,0xC1
.db    0x10,0xED
.db    0xD1,0xC9
.db    0xFE,0x15
.db    0x28,0x04
.db    0xFE,0x18
.db    0x20,0x0A
.db    0xAF,0xB6
.db    0xC8,0xE5
.db    0xCD,0xC1
.db    0xE7,0xE1
.db    0x18,0xF6
.db    0xFE,0x12
.db    0x20,0x24
.db    0xE5,0xCD
.db    0xD2,0xE8
.db    0x21,0x26
.db    0xE6,0x36
.db    0x00,0x23
.db    0x46,0x3E
.db    0x20,0x04
.db    0x18,0x03
.db    0xCD,0x64
.db    0xE8,0x10
.db    0xFB,0xE1
.db    0x46,0x23
.db    0xEB,0x04
.db    0x18,0x05
.db    0x1A,0xCD
.db    0x53,0xE8
.db    0x13,0x10
.db    0xF9,0xC9
.db    0xFE,0x10
.db    0x20,0x07
.db    0x21,0x28
.db    0xE6,0x7E
.db    0x2F,0x77
.db    0xC9,0x12
.db    0xE5,0xCD
.db    0x53,0xE8
.db    0xE1,0x34
.db    0x7E,0xB9
.db    0x28,0x0A
.db    0x3D,0x1A
.db    0x13,0xC0
.db    0xFE,0x03
.db    0xC0,0xC3
.db    0xCA,0xE9
.db    0xE1,0x3E
.db    0x0D,0x18
.db    0x11,0xFE
.db    0x20,0x30
.db    0x0D,0xFE
.db    0x09,0x28
.db    0x0D,0xF5
.db    0x3E,0x5E
.db    0xCD,0x77
.db    0xE8,0xF1
.db    0xC6,0x40
.db    0xFE,0x09
.db    0x20,0x0F
.db    0x3E,0x20
.db    0xCD,0x77
.db    0xE8,0x3A
.db    0x26,0xE6
.db    0xE6,0x07
.db    0x20,0xF4
.db    0x3E,0x09
.db    0xC9,0xC5
.db    0xD5,0x4F
.db    0xC5,0xCD
.db    0xB7,0xE8
.db    0xC1,0xC5
.db    0xCD,0x0C
.db    0xF4,0xC1
.db    0xC5,0x3A
.db    0x28,0xE6
.db    0xB7,0xC4
.db    0x0F,0xF4
.db    0xC1,0x79
.db    0xD1,0xC1
.db    0x21,0x26
.db    0xE6,0x34
.db    0xFE,0x7F
.db    0x28,0x15
.db    0xFE,0x20
.db    0xD0,0xFE
.db    0x09,0x28
.db    0x11,0xFE
.db    0x08,0x28
.db    0x0A,0x34
.db    0xFE,0x0A
.db    0x28,0x05
.db    0xFE,0x0D
.db    0xC0,0x36
.db    0x02,0x35
.db    0x35,0xC9
.db    0x3E,0x07
.db    0x86,0xE6
.db    0xF8,0x77
.db    0xC9,0xCD
.db    0x66,0xE7
.db    0xC8,0xCD
.db    0x75,0xE7
.db    0xFE,0x13
.db    0x20,0x0A
.db    0xCD,0x09
.db    0xF4,0xFE
.db    0x03,0x20
.db    0xEE,0xC3
.db    0xCA,0xE9
.db    0x32,0x29
.db    0xE6,0x3E
.db    0x01,0xC9
.db    0x11,0x49
.db    0xE9,0x1A
.db    0xFE,0x24
.db    0xC8,0x13
.db    0xCD,0x64
.db    0xE8,0x18
.db    0xF6,0x01
.db    0x64,0x00
.db    0xCD,0xED
.db    0xE8,0x0E
.db    0x0A,0xCD
.db    0xED,0xE8
.db    0x01,0x01
.db    0x01,0x16
.db    0xFF,0x14
.db    0x91,0x30
.db    0xFC,0x81
.db    0xF5,0x7A
.db    0xB0,0x28
.db    0x07,0x47
.db    0x7A,0xC6
.db    0x30,0xCD
.db    0x54,0xE7
.db    0xF1,0xC9
.db    0x43,0x68
.db    0x61,0x6E
.db    0x67,0x65
.db    0x64,0x24
.db    0x42,0x61
.db    0x64,0x20
.db    0x53,0x65
.db    0x63,0x74
.db    0x6F,0x72
.db    0x24,0x4E
.db    0x6F,0x20
.db    0x44,0x72
.db    0x69,0x76
.db    0x65,0x24
.db    0x46,0x69
.db    0x6C,0x65
.db    0x20,0x57
.db    0x2F,0x50
.db    0x24,0x5A
.db    0x53,0x44
.db    0x4F,0x53
.db    0x20,0x65
.db    0x72,0x72
.db    0x6F,0x72
.db    0x20,0x6F
.db    0x6E,0x20
.db    0x24,0x0D
.db    0x0A,0x43
.db    0x61,0x6C
.db    0x6C,0x3A
.db    0x20,0x24
.db    0x20,0x20
.db    0x46,0x69
.db    0x6C,0x65
.db    0x3A,0x20
.db    0x24,0x0D
.db    0x0A,0x24
.db    0x3A,0x5C
.db    0xE6,0x4F
.db    0x0F,0x38
.db    0x5C,0xC5
.db    0xD5,0xCD
.db    0xD2,0xE8
.db    0x11,0x27
.db    0xE9,0xCD
.db    0xD5,0xE8
.db    0x3A,0x2B
.db    0xE6,0xC6
.db    0x41,0xCD
.db    0x64,0xE8
.db    0x11,0x3D
.db    0xE9,0xCD
.db    0xD5,0xE8
.db    0xD1,0xCD
.db    0xD5,0xE8
.db    0x11,0x37
.db    0xE9,0xCD
.db    0xD5,0xE8
.db    0x3A,0x4B
.db    0xE6,0xCD
.db    0xDF,0xE8
.db    0x3A,0x4E
.db    0xE6,0xA7
.db    0x28,0x29
.db    0xC1,0xC5
.db    0xDD,0xE5
.db    0x3A,0x4B
.db    0xE6,0xFE
.db    0x13,0x20
.db    0x04,0xCD
.db    0xF1,0xEC
.db    0xE3,0x11
.db    0x40,0xE9
.db    0xCD,0xD5
.db    0xE8,0xE1
.db    0x06,0x0B
.db    0x23,0x3E
.db    0x03,0xB8
.db    0x3E,0x2E
.db    0xCC,0x54
.db    0xE7,0x7E
.db    0xE6,0x7F
.db    0xCD,0x54
.db    0xE7,0x10
.db    0xEF,0xCD
.db    0xD2,0xE8
.db    0xC1,0x3E
.db    0x04,0x90
.db    0x20,0x0D
.db    0x21,0x2C
.db    0xE6,0x7E
.db    0x2B,0xBE
.db    0x28,0x05
.db    0xC5,0xCD
.db    0x81,0xEB
.db    0xC1,0xCB
.db    0x49,0x20
.db    0x18,0x3E
.db    0x01,0x90
.db    0x30,0x05
.db    0xAF,0x32
.db    0x5C,0xE6
.db    0xC7,0xCD
.db    0x71,0xE7
.db    0xA7,0x20
.db    0xFA,0xCD
.db    0x75,0xE7
.db    0xFE,0x03
.db    0xC0,0x18
.db    0xED,0x78
.db    0x67,0xA7
.db    0xC8,0x2E
.db    0xFF,0x22
.db    0x4C,0xE6
.db    0x3A,0x4E
.db    0xE6,0xB7
.db    0x28,0x0C
.db    0x3A,0x2D
.db    0xE6,0xDD
.db    0x77,0x00
.db    0x3A,0x2C
.db    0xE6,0xCD
.db    0x81,0xEB
.db    0xED,0x7B
.db    0x61,0xE6
.db    0xDD,0x2A
.db    0x99,0xE6
.db    0x2A,0x4C
.db    0xE6,0xED
.db    0x5B,0x5F
.db    0xE6,0x7D
.db    0x44,0xC9
.db    0x21,0x80
.db    0x00,0x22
.db    0x2E,0xE6
.db    0xCD,0x37
.db    0xEE,0xAF
.db    0x32,0x2B
.db    0xE6,0x11
.db    0xFF,0xFF
.db    0xCD,0x5D
.db    0xEA,0x3A
.db    0x15,0xE6
.db    0xCB,0x57
.db    0x20,0x06
.db    0x21,0xFC
.db    0xF3,0xCD
.db    0x66,0xEA
.db    0x3A,0x4B
.db    0xE6,0xFE
.db    0x0D,0x21
.db    0xFE,0xF3
.db    0xC4,0x66
.db    0xEA,0x2A
.db    0xFE,0xF3
.db    0xCD,0x58
.db    0xEC,0xEB
.db    0x21,0xF8
.db    0xF3,0xCD
.db    0x66,0xEA
.db    0x3A,0x2B
.db    0xE6,0xF5
.db    0x00,0x00
.db    0x00,0xF1
.db    0xCD,0x81
.db    0xEB,0x3A
.db    0x57,0xE6
.db    0x18,0x69
.db    0x23,0x7E
.db    0x2B,0xD6
.db    0x24,0xC0
.db    0x3D,0x32
.db    0x57,0xE6
.db    0xC9,0x7B
.db    0x2F,0x5F
.db    0x7A,0x2F
.db    0x57,0x21
.db    0xFA,0xF3
.db    0x7B,0xA6
.db    0x77,0x23
.db    0x7A,0xA6
.db    0x77,0xC9
.db    0xCD,0x1F
.db    0xEB,0xDD
.db    0x7E,0x00
.db    0xD6,0x3F
.db    0x28,0x0D
.db    0xDD,0x7E
.db    0x0E,0xFE
.db    0x3F,0x28
.db    0x04,0xDD
.db    0x36,0x0E
.db    0x00,0x3E
.db    0x0F,0xCD
.db    0xF3,0xEE
.db    0x2A,0x34
.db    0xE6,0x01
.db    0x80,0x00
.db    0xED,0x5B
.db    0x2E,0xE6
.db    0xED,0xB0
.db    0xC9,0xDD
.db    0x2A,0x58
.db    0xE6,0xDD
.db    0x22,0x5D
.db    0xE6,0xCD
.db    0x1F,0xEB
.db    0xCD,0x0A
.db    0xEF,0x18
.db    0xE3,0xCD
.db    0x1F,0xEB
.db    0xCD,0x6D
.db    0xEE,0x3A
.db    0x5A,0xE6
.db    0x18,0x0B
.db    0xCD,0x1F
.db    0xEB,0xCD
.db    0xD7,0xEF
.db    0x18,0xF3
.db    0x3A,0x2B
.db    0xE6,0x32
.db    0x4C,0xE6
.db    0xC9,0x32
.db    0x15,0xE6
.db    0x3A,0x15
.db    0xE6,0x18
.db    0xF4,0xCD
.db    0x1F,0xEB
.db    0xCD,0x02
.db    0xF0,0x18
.db    0xDC,0x21
.db    0x22,0x00
.db    0xED,0x53
.db    0x5F,0xE6
.db    0x18,0x1B
.db    0x21,0x11
.db    0x53,0xDD
.db    0x2A,0xFC
.db    0xF3,0xDD
.db    0x2A,0xFE
.db    0xF3,0xDD
.db    0x2A,0x3A
.db    0xE6,0xDD
.db    0x2A,0xFA
.db    0xF3,0xDD
.db    0x2A,0x36
.db    0xE6,0xDD
.db    0x2A,0x2E
.db    0xE6,0x22
.db    0x4C,0xE6
.db    0xC9,0x32
.db    0x5C,0xE6
.db    0xC9,0x21
.db    0x2A,0xE6
.db    0x3C,0x7E
.db    0x28,0xB9
.db    0x7B,0xE6
.db    0x1F,0x77
.db    0xC9,0xCD
.db    0x2D,0xEB
.db    0xCD,0x2B
.db    0xF0,0x18
.db    0x9C,0x21
.db    0x20,0x00
.db    0xCD,0x7F
.db    0xF3,0xDD
.db    0x72,0x21
.db    0xDD,0x71
.db    0x22,0xDD
.db    0x70,0x23
.db    0xC9,0x3A
.db    0x5C,0xE6
.db    0xA7,0x20
.db    0x08,0x2A
.db    0x5D,0xE6
.db    0x01,0x0D
.db    0x00,0x09
.db    0x77,0x3E
.db    0xFF,0x32
.db    0x4E,0xE6
.db    0x3A,0x2B
.db    0xE6,0x5F
.db    0x2A,0x5D
.db    0xE6,0x7E
.db    0x32,0x2D
.db    0xE6,0xFE
.db    0x3F,0x28
.db    0x39,0xDD
.db    0xE5,0xDD
.db    0x2A,0x5D
.db    0xE6,0xE6
.db    0x1F,0xE5
.db    0x28,0x02
.db    0x5E,0x1D
.db    0xCD,0x7A
.db    0xEB,0xE1
.db    0xDD,0x7E
.db    0x0D,0xCB
.db    0x7F,0x20
.db    0x07,0x3A
.db    0x2A,0xE6
.db    0x18,0x02
.db    0xDD,0xE5
.db    0xDD,0x2A
.db    0x5D,0xE6
.db    0xE6,0x1F
.db    0xDD,0x77
.db    0x00,0xF6
.db    0x80,0xDD
.db    0x77,0x0D
.db    0xDD,0xE1
.db    0xC9,0x2A
.db    0x0B,0xE6
.db    0x06,0x04
.db    0x11,0x15
.db    0xE9,0xE9
.db    0x3A,0x2B
.db    0xE6,0x32
.db    0x2C,0xE6
.db    0x7B,0x2A
.db    0xFA,0xF3
.db    0xE6,0x0F
.db    0x47,0xC4
.db    0x61,0xEC
.db    0xEB,0x21
.db    0x2B,0xE6
.db    0xCB,0x43
.db    0x28,0x02
.db    0xBE,0xC8
.db    0x77,0xD5
.db    0x4F,0xCD
.db    0x1B,0xF4
.db    0x7C,0xB5
.db    0x28,0xD3
.db    0x11,0x30
.db    0xE6,0x01
.db    0x02,0x00
.db    0xED,0xB0
.db    0x22,0x32
.db    0xE6,0x0E
.db    0x06,0x09
.db    0x11,0x34
.db    0xE6,0x0E
.db    0x08,0xED
.db    0xB0,0x2A
.db    0x36,0xE6
.db    0x0E,0x0F
.db    0xED,0xB0
.db    0xD1,0xCB
.db    0x43,0xC0
.db    0xCD,0x47
.db    0xEC,0xEB
.db    0x2A,0xFA
.db    0xF3,0xCD
.db    0x58,0xEC
.db    0x22,0xFA
.db    0xF3,0x3A
.db    0x15,0xE6
.db    0xCB,0x5F
.db    0x28,0x2A
.db    0x2A,0x47
.db    0xE6,0x7C
.db    0xB5,0x4F
.db    0x2A,0xFE
.db    0xF3,0x7B
.db    0xA5,0x6F
.db    0x7A,0xA4
.db    0xB5,0x3E
.db    0xFF,0x28
.db    0x01,0x3C
.db    0x47,0xB1
.db    0xC8,0xAF
.db    0x67,0x6F
.db    0xB0,0x28
.db    0x0A,0x79
.db    0xB7,0x20
.db    0x09,0x2A
.db    0xFE,0xF3
.db    0xCD,0x58
.db    0xEC,0x22
.db    0xFE,0xF3
.db    0x2A,0x41
.db    0xE6,0xCD
.db    0x5F,0xEC
.db    0x44,0x4D
.db    0x2A,0x3A
.db    0xE6,0xE5
.db    0x54,0x5D
.db    0x13,0xAF
.db    0x77,0xED
.db    0xB0,0xE1
.db    0xED,0x5B
.db    0x45,0xE6
.db    0x73,0x23
.db    0x72,0x2A
.db    0x32,0xE6
.db    0x77,0x23
.db    0x77,0xCD
.db    0xFC,0xEC
.db    0x3E,0xFF
.db    0xCD,0x30
.db    0xED,0xCD
.db    0x1C,0xED
.db    0xCA,0x4D
.db    0xEA,0xCD
.db    0xF1,0xEC
.db    0x7E,0xFE
.db    0xE5,0x28
.db    0xED,0xFE
.db    0x21,0x28
.db    0xE9,0xCD
.db    0x52,0xEA
.db    0x0E,0x01
.db    0xCD,0x83
.db    0xEE,0xCD
.db    0x23,0xED
.db    0xD4,0x14
.db    0xED,0x18
.db    0xD9,0x21
.db    0x00,0x00
.db    0xEB,0x21
.db    0x01,0x00
.db    0x3A,0x2B
.db    0xE6,0xB7
.db    0x28,0x04
.db    0x29,0x3D
.db    0x20,0xFC
.db    0x7A,0xB4
.db    0x67,0x7B
.db    0xB5,0x6F
.db    0xC9,0x06
.db    0x03,0xCB
.db    0x3C,0xCB
.db    0x1D,0x10
.db    0xFA,0xC9
.db    0x2A,0x54
.db    0xE6,0xCB
.db    0x3C,0xCB
.db    0x1D,0xCB
.db    0x3C,0xCB
.db    0x1D,0x22
.db    0x52,0xE6
.db    0xEB,0x21
.db    0x00,0x00
.db    0xED,0x4B
.db    0x3C,0xE6
.db    0x3E,0x11
.db    0xB7,0xED
.db    0x42,0x3F
.db    0x38,0x02
.db    0x09,0xB7
.db    0xCB,0x13
.db    0xCB,0x12
.db    0x3D,0x28
.db    0x04,0xED
.db    0x6A,0x18
.db    0xED,0xE5
.db    0x2A,0x49
.db    0xE6,0x19
.db    0x44,0x4D
.db    0xCD,0x1E
.db    0xF4,0xC1
.db    0xED,0x5B
.db    0x30,0xE6
.db    0xCD,0x30
.db    0xF4,0x44
.db    0x4D,0xC3
.db    0x21,0xF4
.db    0xDD,0x6E
.db    0x20,0xCB
.db    0x15,0x3A
.db    0x40,0xE6
.db    0xDD,0xA6
.db    0x0C,0x67
.db    0x3A,0x3E
.db    0xE6,0x47
.db    0x04,0xCD
.db    0x61,0xEC
.db    0x50,0x7D
.db    0x2A,0x5D
.db    0xE6,0x0E
.db    0x10,0x09
.db    0x4F,0x09
.db    0x3A,0x42
.db    0xE6,0xB7
.db    0x5E,0x28
.db    0x05,0x09
.db    0x5E,0x23
.db    0x56,0x2B
.db    0x7A,0xB3
.db    0xC9,0x21
.db    0x00,0x00
.db    0x3A,0x3E
.db    0xE6,0x47
.db    0xEB,0x29
.db    0xCB,0x13
.db    0x10,0xFB
.db    0xEB,0x3A
.db    0x3F,0xE6
.db    0xDD,0xA6
.db    0x20,0xB3
.db    0x5F,0xC9
.db    0xCD,0xAC
.db    0xEE,0x3A
.db    0x56,0xE6
.db    0x2A,0x34
.db    0xE6,0x85
.db    0x6F,0xD0
.db    0x24,0xC9
.db    0x21,0xFF
.db    0xFF,0x22
.db    0x54,0xE6
.db    0xC9,0x2A
.db    0xFC,0xF3
.db    0xCD,0x4A
.db    0xEC,0x22
.db    0xFC,0xF3
.db    0xED,0x5B
.db    0x43,0xE6
.db    0x2A,0x32
.db    0xE6,0x23
.db    0x13,0x72
.db    0x2B,0x73
.db    0xC9,0xCD
.db    0xF1,0xEE
.db    0x2A,0x54
.db    0xE6,0x7C
.db    0xA5,0x3C
.db    0xC9,0x2A
.db    0x32,0xE6
.db    0xED,0x5B
.db    0x54,0xE6
.db    0x7B,0x96
.db    0x23,0x7A
.db    0x9E,0xC9
.db    0x4F,0x2A
.db    0x54,0xE6
.db    0x23,0x22
.db    0x54,0xE6
.db    0xED,0x5B
.db    0x43,0xE6
.db    0x7B,0x95
.db    0x7A,0x9C
.db    0x38,0xBA
.db    0x7D,0x0F
.db    0x0F,0x0F
.db    0xE6,0x60
.db    0x32,0x56
.db    0xE6,0xC0
.db    0xC5,0xCD
.db    0x68,0xEC
.db    0xCD,0x3D
.db    0xEE,0xCD
.db    0x95,0xED
.db    0xCD,0x37
.db    0xEE,0xC1
.db    0x2A,0x47
.db    0xE6,0xED
.db    0x5B,0x52
.db    0xE6,0xAF
.db    0xED,0x52
.db    0xC8,0xD8
.db    0x2A,0x34
.db    0xE6,0xCD
.db    0xE0,0xF3
.db    0x86,0x2A
.db    0x38,0xE6
.db    0x19,0x0C
.db    0x20,0x02
.db    0x77,0xC9
.db    0xBE,0xC8
.db    0x3A,0x15
.db    0xE6,0xCB
.db    0x67,0x06
.db    0x00,0x11
.db    0x02,0xE9
.db    0xC4,0x4C
.db    0xE9,0xCD
.db    0x47,0xEC
.db    0xEB,0xCD
.db    0x5D,0xEA
.db    0xCD,0x35
.db    0xEA,0xCD
.db    0xFC,0xEC
.db    0xAF,0x18
.db    0x9B,0xCD
.db    0x27,0xF4
.db    0x18,0x03
.db    0xCD,0x2A
.db    0xF4,0xB7
.db    0xC8,0x06
.db    0x01,0x11
.db    0x0A,0xE9
.db    0x2A,0x09
.db    0xE6,0xE9
.db    0xCD,0x2D
.db    0xEB,0xDD
.db    0xCB,0x0E
.db    0x7E,0xC0
.db    0xCD,0xD8
.db    0xEE,0xCD
.db    0x19,0xED
.db    0xC8,0xCD
.db    0xEE,0xEC
.db    0x01,0x10
.db    0x00,0x09
.db    0xEB,0x2A
.db    0x5D,0xE6
.db    0x09,0xEB
.db    0x41,0x34
.db    0x35,0x1A
.db    0x28,0x04
.db    0xBE,0xC2
.db    0x7A,0xF1
.db    0x77,0x13
.db    0x23,0x10
.db    0xF2,0x11
.db    0xEC,0xFF
.db    0x19,0xDD
.db    0x7E,0x0C
.db    0xBE,0x38
.db    0x08,0x77
.db    0x23,0x23
.db    0x23,0xDD
.db    0x7E,0x0F
.db    0x77,0xCD
.db    0x08,0xEE
.db    0xCD,0xA6
.db    0xF1,0x28
.db    0x0D,0xC5
.db    0x01,0x00
.db    0x00,0xCD
.db    0x9E,0xF1
.db    0xCD,0x19
.db    0xED,0xC1
.db    0x28,0x0B
.db    0xC5,0xCD
.db    0x08,0xEE
.db    0x2A,0x1C
.db    0xE6,0xCD
.db    0xB9,0xF3
.db    0xC1,0xC3
.db    0x9E,0xF1
.db    0xCD,0xF1
.db    0xEC,0x01
.db    0x0B,0x00
.db    0x09,0xCB
.db    0xBE,0xDD
.db    0xCB,0x0B
.db    0xBE,0x18
.db    0x00,0xCD
.db    0xF1,0xEC
.db    0x3E,0x0D
.db    0xCD,0xF7
.db    0xEC,0x36
.db    0x00,0xCD
.db    0x68,0xEC
.db    0x0E,0xFF
.db    0xCD,0x5A
.db    0xED,0xCD
.db    0x3D,0xEE
.db    0x0E,0x01
.db    0xCD,0x9A
.db    0xED,0x18
.db    0x04,0xED
.db    0x53,0x2E
.db    0xE6,0xED
.db    0x4B,0x2E
.db    0xE6,0x18
.db    0x04,0xED
.db    0x4B,0x34
.db    0xE6,0xC3
.db    0x24,0xF4
.db    0x7B,0xE6
.db    0x07,0x3C
.db    0x4F,0xCB
.db    0x3A,0xCB
.db    0x1B,0xCB
.db    0x3A,0xCB
.db    0x1B,0xCB
.db    0x3A,0xCB
.db    0x1B,0x47
.db    0x2A,0x3A
.db    0xE6,0x19
.db    0x7E,0x07
.db    0x10,0xFD
.db    0x41,0xC9
.db    0xC5,0xCD
.db    0x44,0xEE
.db    0xE6,0xFE
.db    0xD1,0xB3
.db    0x0F,0x10
.db    0xFD,0x77
.db    0xC9,0xCD
.db    0xBD,0xEF
.db    0xCD,0xEE
.db    0xEC,0x36
.db    0xE5,0x23
.db    0x7E,0xD6
.db    0x24,0x20
.db    0x03,0x32
.db    0x57,0xE6
.db    0x23,0xCB
.db    0xBE,0x0E
.db    0x00,0xCD
.db    0xF1,0xEC
.db    0x11,0x10
.db    0x00,0x19
.db    0x43,0x5E
.db    0x23,0x16
.db    0x00,0x3A
.db    0x42,0xE6
.db    0xB7,0x28
.db    0x03,0x05
.db    0x56,0x23
.db    0x7A,0xB3
.db    0x28,0x0D
.db    0xE5,0xC5
.db    0x2A,0x41
.db    0xE6,0xB7
.db    0xED,0x52
.db    0xD4,0x60
.db    0xEE,0xC1
.db    0xE1,0x10
.db    0xE0,0xC9
.db    0xCD,0xF1
.db    0xEC,0x11
.db    0x08,0x00
.db    0x19,0xED
.db    0x5B,0x13
.db    0xE6,0x1A
.db    0xA7,0x20
.db    0x04,0xCB
.db    0x7E,0x20
.db    0x10,0x23
.db    0xCB,0x7E
.db    0x20,0x0B
.db    0xDD,0xCB
.db    0x07,0x7E
.db    0xC8,0x3A
.db    0x15,0xE6
.db    0xE6,0x02
.db    0xC0,0x2A
.db    0x0F,0xE6
.db    0x06,0x03
.db    0x11,0x1E
.db    0xE9,0xE9
.db    0xCD,0xE5
.db    0xEE,0xC0
.db    0x06,0x02
.db    0x11,0x23
.db    0xE9,0x2A
.db    0x0D,0xE6
.db    0xE9,0x2A
.db    0xFC,0xF3
.db    0xCD,0x4A
.db    0xEC,0xED
.db    0x52,0xC9
.db    0x3E,0x0C
.db    0x21,0x3E
.db    0x0F,0x32
.db    0x5B,0xE6
.db    0x3E,0xFF
.db    0x32,0x5A
.db    0xE6,0xDD
.db    0x22,0x58
.db    0xE6,0xCD
.db    0xFC,0xEC
.db    0x2A,0x47
.db    0xE6,0x7C
.db    0xB5,0xC4
.db    0x18,0xF4
.db    0xAF,0x67
.db    0x6F,0x22
.db    0x50,0xE6
.db    0xDD,0xCB
.db    0x07,0xBE
.db    0xCD,0x30
.db    0xED,0xCD
.db    0x1C,0xED
.db    0x28,0x0E
.db    0xED,0x5B
.db    0x58,0xE6
.db    0x1A,0xFE
.db    0xE5,0x28
.db    0x07,0xD5
.db    0xCD,0x23
.db    0xED,0xD1
.db    0x30,0x6B
.db    0xCD,0xF1
.db    0xEC,0x7E
.db    0xFE,0x21
.db    0x28,0xD6
.db    0x0E,0x00
.db    0x3A,0x5B
.db    0xE6,0x47
.db    0x78,0xB7
.db    0x28,0x5F
.db    0x1A,0xEE
.db    0x3F,0xE6
.db    0x7F,0x28
.db    0x3B,0x79
.db    0xB7,0x20
.db    0x22,0x3A
.db    0x15,0xE6
.db    0x1F,0x30
.db    0x1C,0x23
.db    0x23,0xCB
.db    0x7E,0x2B
.db    0x2B,0x28
.db    0x14,0x1A
.db    0xFE,0xE5
.db    0x28,0x0F
.db    0xAE,0xE6
.db    0x7F,0x28
.db    0x19,0x3E
.db    0xFF,0x32
.db    0x51,0xE6
.db    0xCD,0xAF
.db    0xF0,0x18
.db    0x0F,0x79
.db    0xFE,0x0D
.db    0x28,0x0A
.db    0xFE,0x0C
.db    0x1A,0x28
.db    0x11,0xAE
.db    0xE6,0x7F
.db    0x20,0x90
.db    0x13,0x23
.db    0x0C,0x05
.db    0x18,0xBA
.db    0x3D,0x32
.db    0x50,0xE6
.db    0x18,0xF4
.db    0xAE,0xCD
.db    0x8C,0xEF
.db    0x18,0xEC
.db    0xC5,0x47
.db    0x3A,0x40
.db    0xE6,0x2F
.db    0xE6,0x1F
.db    0xA0,0xC1
.db    0xC9,0xCD
.db    0xFC,0xEC
.db    0xC3,0x7A
.db    0xF1,0x2A
.db    0x50,0xE6
.db    0x7C,0xA5
.db    0x20,0xD4
.db    0xCD,0x23
.db    0xED,0xD4
.db    0x14,0xED
.db    0x2A,0x52
.db    0xE6,0x22
.db    0x5F,0xE6
.db    0x3A,0x54
.db    0xE6,0xE6
.db    0x03,0x32
.db    0x4C,0xE6
.db    0xAF,0x32
.db    0x5A,0xE6
.db    0xC9,0xCD
.db    0xD8,0xEE
.db    0xCD,0xEE
.db    0xEE,0xCD
.db    0x1C,0xED
.db    0xE1,0xC8
.db    0xE5,0xE5
.db    0x21,0xCF
.db    0xEF,0xE3
.db    0xE9,0xCD
.db    0x17,0xEE
.db    0xCD,0x0A
.db    0xEF,0x18
.db    0xEC,0xCD
.db    0xBD,0xEF
.db    0xCD,0xAC
.db    0xEE,0x2A
.db    0x5D,0xE6
.db    0x11,0x10
.db    0x00,0x19
.db    0xEB,0xCD
.db    0xF1,0xEC
.db    0x23,0x23
.db    0xCB,0xBE
.db    0x2B,0x2B
.db    0x06,0x0B
.db    0x23,0x13
.db    0x1A,0xE6
.db    0x7F,0xFE
.db    0x3F,0x20
.db    0x01,0x7E
.db    0x17,0xCB
.db    0x16,0x1F
.db    0x77,0x10
.db    0xEF,0xC9
.db    0xCD,0xBD
.db    0xEF,0xDD
.db    0xE5,0xD1
.db    0xCD,0xF1
.db    0xEC,0x06
.db    0x0B,0x23
.db    0x13,0x3E
.db    0x04,0xB8
.db    0x20,0x0E
.db    0xE5,0x2A
.db    0x13,0xE6
.db    0x7E,0xE1
.db    0xA7,0x20
.db    0x05,0xCB
.db    0x7E,0xC2
.db    0xCF,0xEE
.db    0x1A,0xCB
.db    0x16,0x17
.db    0xCB,0x1E
.db    0x10,0xE3
.db    0xC9,0x01
.db    0x00,0x00
.db    0x51,0xCD
.db    0x15,0xEB
.db    0xCD,0xEE
.db    0xEE,0xCD
.db    0x1C,0xED
.db    0xC8,0xCD
.db    0xF1,0xEC
.db    0xEB,0x21
.db    0x0F,0x00
.db    0xCD,0x7F
.db    0xF3,0x7A
.db    0xDD,0x96
.db    0x21,0x79
.db    0xDD,0x9E
.db    0x22,0x78
.db    0xDD,0x9E
.db    0x23,0xD4
.db    0x15,0xEB
.db    0xCD,0x0A
.db    0xEF,0x18
.db    0xDE,0xCD
.db    0x19,0xED
.db    0xC0,0x3A
.db    0x15,0xE6
.db    0xCB,0x6F
.db    0xC8,0x2A
.db    0x11,0xE6
.db    0x7C,0xB5
.db    0xC8,0x7E
.db    0x23,0xB7
.db    0xCA,0x97
.db    0xEF,0xE6
.db    0x7F,0xFE
.db    0x24,0x20
.db    0x04,0x3A
.db    0x2C,0xE6
.db    0x3C,0x3D
.db    0xE5,0xCD
.db    0x81,0xEB
.db    0xE1,0x7E
.db    0x23,0xE6
.db    0x7F,0xFE
.db    0x24,0x20
.db    0x03,0x3A
.db    0x2A,0xE6
.db    0xE6,0x1F
.db    0xE5,0xCD
.db    0x5E,0xEB
.db    0xCD,0x19
.db    0xED,0xE1
.db    0x28,0xD3
.db    0xE5,0xCD
.db    0xF1,0xEC
.db    0x11,0x0A
.db    0x00,0x19
.db    0xCB,0x7E
.db    0x3A,0x15
.db    0xE6,0x17
.db    0x17,0xE1
.db    0x38,0x02
.db    0x28,0xBF
.db    0x3A,0x2B
.db    0xE6,0x3C
.db    0x32,0x2D
.db    0xE6,0xDD
.db    0xCB,0x07
.db    0xFE,0xC9
.db    0xCD,0x1F
.db    0xEB,0xDD
.db    0x36,0x0E
.db    0x00,0xCD
.db    0x57,0xF0
.db    0xCD,0x1C
.db    0xED,0xC8
.db    0xDD,0x7E
.db    0x07,0xF5
.db    0xDD,0x7E
.db    0x0C,0xF5
.db    0xCD,0xF1
.db    0xEC,0x7E
.db    0xF6,0x80
.db    0xDD,0xE5
.db    0xD1,0x01
.db    0x20,0x00
.db    0xED,0xB0
.db    0xDD,0x77
.db    0x0D,0xCD
.db    0x7A,0xF3
.db    0xDD,0x46
.db    0x0C,0xDD
.db    0x4E,0x0F
.db    0xF1,0xDD
.db    0x77,0x0C
.db    0xB8,0x28
.db    0x04,0x0E
.db    0x00,0xCB
.db    0x19,0xDD
.db    0x71,0x0F
.db    0xF1,0xDD
.db    0xCB,0x07
.db    0x16,0x17
.db    0xDD,0xCB
.db    0x07,0x1E
.db    0x2A,0x18
.db    0xE6,0xC3
.db    0xB9,0xF3
.db    0xCD,0x1F
.db    0xEB,0xDD
.db    0x36,0x0E
.db    0x00,0xCD
.db    0xD8,0xEE
.db    0x2A,0x5D
.db    0xE6,0x7E
.db    0xF5,0x36
.db    0xE5,0x3E
.db    0x01,0xCD
.db    0xF3,0xEE
.db    0xF1,0xDD
.db    0x77,0x00
.db    0xCD,0x1C
.db    0xED,0xC8
.db    0x2A,0x5D
.db    0xE6,0xCD
.db    0x52,0xEA
.db    0x11,0x0F
.db    0x00,0x19
.db    0x06,0x11
.db    0xAF,0x77
.db    0x23,0x10
.db    0xFC,0xDD
.db    0xCB,0x07
.db    0xBE,0xDD
.db    0xCB,0x0B
.db    0xBE,0xCD
.db    0xF1,0xEC
.db    0xDD,0xE5
.db    0xD1,0xEB
.db    0x01,0x20
.db    0x00,0xED
.db    0xB0,0xCD
.db    0x17,0xEE
.db    0xCD,0x7A
.db    0xF3,0x2A
.db    0x1A,0xE6
.db    0xC3,0xB9
.db    0xF3,0xDD
.db    0xCB,0x0E
.db    0x7E,0x20
.db    0x08,0xCD
.db    0xAB,0xED
.db    0x3A,0x4C
.db    0xE6,0x3C
.db    0xC8,0xCD
.db    0x85,0xF1
.db    0x38,0x13
.db    0xCD,0x19
.db    0xED,0x20
.db    0x16,0x3A
.db    0x4F,0xE6
.db    0xB7,0x28
.db    0x08,0xCD
.db    0x09,0xF1
.db    0xCD,0x1C
.db    0xED,0x20
.db    0x0B,0xCD
.db    0x7A,0xF3
.db    0x3E,0xFF
.db    0xC3,0xBB
.db    0xEA,0xCD
.db    0xC2,0xF0
.db    0xAF,0x18
.db    0xF7,0xCD
.db    0xA6,0xF1
.db    0xCB,0x70
.db    0x37,0xC0
.db    0x0C,0x79
.db    0xE6,0x1F
.db    0x4F,0x20
.db    0x07,0x04
.db    0x78,0xE6
.db    0x3F,0x47
.db    0x37,0xC8
.db    0xDD,0x36
.db    0x20,0x00
.db    0xDD,0x71
.db    0x0C,0xDD
.db    0x70,0x0E
.db    0xA7,0xC9
.db    0xDD,0x4E
.db    0x0C,0xDD
.db    0x46,0x0E
.db    0x79,0xCD
.db    0x8C,0xEF
.db    0xCB,0xB8
.db    0xB0,0xC9
.db    0xCD,0x2D
.db    0xEB,0xAF
.db    0xCD,0xF6
.db    0xF2,0x28
.db    0x04,0xC9
.db    0xCD,0x2D
.db    0xEB,0xAF
.db    0x32,0x4F
.db    0xE6,0xDD
.db    0x7E,0x20
.db    0xFE,0x80
.db    0x28,0x09
.db    0xDD,0xBE
.db    0x0F,0x38
.db    0x07,0x3E
.db    0x01,0x18
.db    0xA7,0xCD
.db    0xE9,0xF1
.db    0xCD,0xAA
.db    0xEC,0x28
.db    0xF4,0xCD
.db    0xD7,0xEC
.db    0xCD,0x7A
.db    0xEC,0xCD
.db    0x95,0xED
.db    0xC3,0xE4
.db    0xF2,0xCD
.db    0x51,0xF1
.db    0x3A,0x4C
.db    0xE6,0xB7
.db    0xC8,0xE1
.db    0x18,0xDD
.db    0xCD,0x2D
.db    0xEB,0x3E
.db    0xFF,0xCD
.db    0xF6,0xF2
.db    0x28,0x04
.db    0xC9,0xCD
.db    0x2D,0xEB
.db    0x3E,0xFF
.db    0x32,0x4F
.db    0xE6,0xCD
.db    0xD8,0xEE
.db    0xDD,0xCB
.db    0x09,0x7E
.db    0x20,0x0E
.db    0xCD,0xC4
.db    0xEE,0x2A
.db    0x13,0xE6
.db    0x7E,0xA7
.db    0x20,0x07
.db    0xDD,0xCB
.db    0x08,0x7E
.db    0xC2,0xCF
.db    0xEE,0xDD
.db    0xCB,0x20
.db    0x7E,0xC4
.db    0xE9,0xF1
.db    0xCD,0xAA
.db    0xEC,0xC2
.db    0xC3,0xF2
.db    0xE5,0x79
.db    0xB7,0x28
.db    0x04,0x3D
.db    0xCD,0xC0
.db    0xEC,0x62
.db    0x6B,0x7A
.db    0xB3,0x28
.db    0x0B,0x1B
.db    0xE5,0xD5
.db    0xCD,0x44
.db    0xEE,0x1F
.db    0x30,0x20
.db    0xD1,0xE1
.db    0xED,0x4B
.db    0x41,0xE6
.db    0x7D,0x91
.db    0x7C,0x98
.db    0x30,0x0E
.db    0x23,0xD5
.db    0xE5,0xEB
.db    0xCD,0x44
.db    0xEE,0x1F
.db    0x30,0x0A
.db    0xE1,0xD1
.db    0x18,0xD9
.db    0x7A,0xB3
.db    0x20,0xD5
.db    0x18,0x07
.db    0x37,0x17
.db    0xCD,0x68
.db    0xEE,0xD1
.db    0xE1,0xE1
.db    0x7A,0xB3
.db    0x28,0x7F
.db    0xDD,0xCB
.db    0x0E,0xBE
.db    0x73,0x3A
.db    0x42,0xE6
.db    0xB7,0x28
.db    0x02,0x23
.db    0x72,0x0E
.db    0x02,0x3A
.db    0x3F,0xE6
.db    0xDD,0xA6
.db    0x20,0x28
.db    0x02,0x0E
.db    0x00,0x3A
.db    0x4B,0xE6
.db    0xD6,0x28
.db    0x20,0x33
.db    0xD5,0x2A
.db    0x34,0xE6
.db    0x06,0x80
.db    0x77,0x23
.db    0x10,0xFC
.db    0xCD,0xD7
.db    0xEC,0x3A
.db    0x3F,0xE6
.db    0x47,0x04
.db    0x2F,0xA3
.db    0x5F,0x0E
.db    0x02,0xE5
.db    0xD5,0xC5
.db    0xCD,0x7A
.db    0xEC,0xCD
.db    0x3D,0xEE
.db    0xC1,0xC5
.db    0xCD,0x9A
.db    0xED,0xC1
.db    0xD1,0xE1
.db    0x0E,0x00
.db    0x1C,0x10
.db    0xEA,0xCD
.db    0x37,0xEE
.db    0xD1,0x0E
.db    0x00,0xDD
.db    0xCB,0x0E
.db    0xBE,0xC5
.db    0xCD,0xD7
.db    0xEC,0xCD
.db    0x7A,0xEC
.db    0xC1,0xCD
.db    0x9A,0xED
.db    0xDD,0x7E
.db    0x20,0xDD
.db    0xBE,0x0F
.db    0x38,0x08
.db    0x3C,0xDD
.db    0x77,0x0F
.db    0xDD,0xCB
.db    0x0E,0xBE
.db    0x3A,0x4B
.db    0xE6,0xFE
.db    0x14,0xD8
.db    0xFE,0x16
.db    0xD0,0xDD
.db    0x34,0x20
.db    0xC9,0x3E
.db    0x02,0xC3
.db    0xBB,0xEA
.db    0x32,0x4F
.db    0xE6,0xDD
.db    0x7E,0x21
.db    0x57,0xCB
.db    0xBA,0x17
.db    0xDD,0x7E
.db    0x22,0x17
.db    0xF5,0xE6
.db    0x1F,0x4F
.db    0xF1,0x17
.db    0x17,0x17
.db    0x17,0xE6
.db    0x0F,0x47
.db    0xDD,0x7E
.db    0x23,0x1E
.db    0x06,0xFE
.db    0x04,0x30
.db    0x5C,0x07
.db    0x07,0x07
.db    0x07,0x80
.db    0x47,0xDD
.db    0x72,0x20
.db    0xDD,0x56
.db    0x0E,0xCB
.db    0x72,0x20
.db    0x0E,0x79
.db    0xDD,0xBE
.db    0x0C,0x20
.db    0x08,0x78
.db    0xDD,0xAE
.db    0x0E,0xE6
.db    0x3F,0x28
.db    0x37,0xCB
.db    0x7A,0x20
.db    0x0F,0xD5
.db    0xC5,0xCD
.db    0xAB,0xED
.db    0xC1,0xD1
.db    0x1E,0x03
.db    0x3A,0x4C
.db    0xE6,0x3C
.db    0x28,0x27
.db    0xCD,0x9E
.db    0xF1,0xCD
.db    0xF1,0xEE
.db    0x3A,0x4C
.db    0xE6,0x3C
.db    0x20,0x15
.db    0x3A,0x4F
.db    0xE6,0x1E
.db    0x04,0x3C
.db    0x20,0x13
.db    0xCD,0x09
.db    0xF1,0x1E
.db    0x05,0x3A
.db    0x4C,0xE6
.db    0x3C,0x28
.db    0x08,0x18
.db    0x03,0xCD
.db    0xC2,0xF0
.db    0xC3,0x82
.db    0xF1,0xDD
.db    0x36,0x0E
.db    0xC0,0x7B
.db    0x32,0x4C
.db    0xE6,0xB7
.db    0xDD,0xCB
.db    0x0E,0xFE
.db    0xC9,0x19
.db    0x7E,0x21
.db    0x0C,0x00
.db    0x19,0x57
.db    0x7E,0xE6
.db    0x1F,0xCB
.db    0x12,0xCE
.db    0x00,0x1F
.db    0xCB,0x1A
.db    0x4F,0x23
.db    0x23,0x7E
.db    0x0F,0x0F
.db    0x0F,0x0F
.db    0xF5,0xE6
.db    0x03,0x47
.db    0xF1,0xE6
.db    0xF0,0x81
.db    0x4F,0xD0
.db    0x04,0xC9
.db    0xCD,0x1F
.db    0xEB,0xCD
.db    0x19,0xED
.db    0x28,0x31
.db    0x2A,0x1E
.db    0xE6,0x3A
.db    0x4B,0xE6
.db    0xFE,0x66
.db    0x28,0x0A
.db    0x2A,0x20
.db    0xE6,0xE5
.db    0xCD,0xE5
.db    0xEE,0xE1
.db    0x28,0x1D
.db    0xCD,0xA6
.db    0xF1,0x20
.db    0x18,0x3A
.db    0x56,0xE6
.db    0xED,0x5B
.db    0x34,0xE6
.db    0x01,0x17
.db    0xEE,0xE5
.db    0x2A,0x2E
.db    0xE6,0xC9
.db    0x0E,0x01
.db    0x21,0x0E
.db    0x00,0x2A
.db    0x16,0xE6
.db    0xE5,0xF6
.db    0xFF,0xC9
.db    0x06,0x7F
.db    0x86,0x23
.db    0x10,0xFC
.db    0xC9,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x01
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
CCP_ARR:
.db    0xC3,0x5C
.db    0xE1,0xC3
.db    0x58,0xE1
.db    0x7F,0x00
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x43,0x4F
.db    0x50,0x59
.db    0x52,0x49
.db    0x47,0x48
.db    0x54,0x20
.db    0x28,0x43
.db    0x29,0x20
.db    0x31,0x39
.db    0x37,0x39
.db    0x2C,0x20
.db    0x44,0x49
.db    0x47,0x49
.db    0x54,0x41
.db    0x4C,0x20
.db    0x52,0x45
.db    0x53,0x45
.db    0x41,0x52
.db    0x43,0x48
.db    0x20,0x20
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x08,0xDE
.db    0x00,0x00
.db    0x5F,0x0E
.db    0x02,0xC3
.db    0x05,0x00
.db    0xC5,0xCD
.db    0x8C,0xDE
.db    0xC1,0xC9
.db    0x3E,0x0D
.db    0xCD,0x92
.db    0xDE,0x3E
.db    0x0A,0xC3
.db    0x92,0xDE
.db    0x3E,0x20
.db    0xC3,0x92
.db    0xDE,0xC5
.db    0xCD,0x98
.db    0xDE,0xE1
.db    0x7E,0xB7
.db    0xC8,0x23
.db    0xE5,0xCD
.db    0x8C,0xDE
.db    0xE1,0xC3
.db    0xAC,0xDE
.db    0x0E,0x0D
.db    0xC3,0x05
.db    0x00,0x5F
.db    0x0E,0x0E
.db    0xC3,0x05
.db    0x00,0xCD
.db    0x05,0x00
.db    0x32,0xEE
.db    0xE5,0x3C
.db    0xC9,0x0E
.db    0x0F,0xC3
.db    0xC3,0xDE
.db    0xAF,0x32
.db    0xED,0xE5
.db    0x11,0xCD
.db    0xE5,0xC3
.db    0xCB,0xDE
.db    0x0E,0x10
.db    0xC3,0xC3
.db    0xDE,0x0E
.db    0x11,0xC3
.db    0xC3,0xDE
.db    0x0E,0x12
.db    0xC3,0xC3
.db    0xDE,0x11
.db    0xCD,0xE5
.db    0xC3,0xDF
.db    0xDE,0x0E
.db    0x13,0xC3
.db    0x05,0x00
.db    0xCD,0x05
.db    0x00,0xB7
.db    0xC9,0x0E
.db    0x14,0xC3
.db    0xF4,0xDE
.db    0x11,0xCD
.db    0xE5,0xC3
.db    0xF9,0xDE
.db    0x0E,0x15
.db    0xC3,0xF4
.db    0xDE,0x0E
.db    0x16,0xC3
.db    0xC3,0xDE
.db    0x0E,0x17
.db    0xC3,0x05
.db    0x00,0x1E
.db    0xFF,0x0E
.db    0x20,0xC3
.db    0x05,0x00
.db    0xCD,0x13
.db    0xDF,0x87
.db    0x87,0x87
.db    0x87,0x21
.db    0xEF,0xE5
.db    0xB6,0x32
.db    0x04,0x00
.db    0xC9,0x3A
.db    0xEF,0xE5
.db    0x32,0x04
.db    0x00,0xC9
.db    0xFE,0x61
.db    0xD8,0xFE
.db    0x7B,0xD0
.db    0xE6,0x5F
.db    0xC9,0x3A
.db    0xAB,0xE5
.db    0xB7,0xCA
.db    0x96,0xDF
.db    0x3A,0xEF
.db    0xE5,0xB7
.db    0x3E,0x00
.db    0xC4,0xBD
.db    0xDE,0x11
.db    0xAC,0xE5
.db    0xCD,0xCB
.db    0xDE,0xCA
.db    0x96,0xDF
.db    0x3A,0xBB
.db    0xE5,0x3D
.db    0x32,0xCC
.db    0xE5,0x11
.db    0xAC,0xE5
.db    0xCD,0xF9
.db    0xDE,0xC2
.db    0x96,0xDF
.db    0x11,0x07
.db    0xDE,0x21
.db    0x80,0x00
.db    0x06,0x80
.db    0xCD,0x42
.db    0xE2,0x21
.db    0xBA,0xE5
.db    0x36,0x00
.db    0x23,0x35
.db    0x11,0xAC
.db    0xE5,0xCD
.db    0xDA,0xDE
.db    0xCA,0x96
.db    0xDF,0x3A
.db    0xEF,0xE5
.db    0xB7,0xC4
.db    0xBD,0xDE
.db    0x21,0x08
.db    0xDE,0xCD
.db    0xAC,0xDE
.db    0xCD,0xC2
.db    0xDF,0xCA
.db    0xA7,0xDF
.db    0xCD,0xDD
.db    0xDF,0xC3
.db    0x82,0xE1
.db    0xCD,0xDD
.db    0xDF,0xCD
.db    0x1A,0xDF
.db    0x0E,0x0A
.db    0x11,0x06
.db    0xDE,0xCD
.db    0x05,0x00
.db    0xCD,0x29
.db    0xDF,0x21
.db    0x07,0xDE
.db    0x46,0x23
.db    0x78,0xB7
.db    0xCA,0xBA
.db    0xDF,0x7E
.db    0xCD,0x30
.db    0xDF,0x77
.db    0x05,0xC3
.db    0xAB,0xDF
.db    0x77,0x21
.db    0x08,0xDE
.db    0x22,0x88
.db    0xDE,0xC9
.db    0x0E,0x0B
.db    0xCD,0x05
.db    0x00,0xB7
.db    0xC8,0x0E
.db    0x01,0xCD
.db    0x05,0x00
.db    0xB7,0xC9
.db    0x0E,0x19
.db    0xC3,0x05
.db    0x00,0x11
.db    0x80,0x00
.db    0x0E,0x1A
.db    0xC3,0x05
.db    0x00,0x21
.db    0xAB,0xE5
.db    0x7E,0xB7
.db    0xC8,0x36
.db    0x00,0xAF
.db    0xCD,0xBD
.db    0xDE,0x11
.db    0xAC,0xE5
.db    0xCD,0xEF
.db    0xDE,0x3A
.db    0xEF,0xE5
.db    0xC3,0xBD
.db    0xDE,0x11
.db    0x28,0xE1
.db    0x21,0x00
.db    0xE6,0x06
.db    0x06,0x1A
.db    0xBE,0xC2
.db    0xCF,0xE1
.db    0x13,0x23
.db    0x05,0xC2
.db    0xFD,0xDF
.db    0xC9,0xCD
.db    0x98,0xDE
.db    0x2A,0x8A
.db    0xDE,0x7E
.db    0xFE,0x20
.db    0xCA,0x22
.db    0xE0,0xB7
.db    0xCA,0x22
.db    0xE0,0xE5
.db    0xCD,0x8C
.db    0xDE,0xE1
.db    0x23,0xC3
.db    0x0F,0xE0
.db    0x3E,0x3F
.db    0xCD,0x8C
.db    0xDE,0xCD
.db    0x98,0xDE
.db    0xCD,0xDD
.db    0xDF,0xC3
.db    0x82,0xE1
.db    0x1A,0xB7
.db    0xC8,0xFE
.db    0x20,0xDA
.db    0x09,0xE0
.db    0xC8,0xFE
.db    0x3D,0xC8
.db    0xFE,0x5F
.db    0xC8,0xFE
.db    0x2E,0xC8
.db    0xFE,0x3A
.db    0xC8,0xFE
.db    0x3B,0xC8
.db    0xFE,0x3C
.db    0xC8,0xFE
.db    0x3E,0xC8
.db    0xC9,0x1A
.db    0xB7,0xC8
.db    0xFE,0x20
.db    0xC0,0x13
.db    0xC3,0x4F
.db    0xE0,0x85
.db    0x6F,0xD0
.db    0x24,0xC9
.db    0x3E,0x00
.db    0x21,0xCD
.db    0xE5,0xCD
.db    0x59,0xE0
.db    0xE5,0xE5
.db    0xAF,0x32
.db    0xF0,0xE5
.db    0x2A,0x88
.db    0xDE,0xEB
.db    0xCD,0x4F
.db    0xE0,0xEB
.db    0x22,0x8A
.db    0xDE,0xEB
.db    0xE1,0x1A
.db    0xB7,0xCA
.db    0x89,0xE0
.db    0xDE,0x40
.db    0x47,0x13
.db    0x1A,0xFE
.db    0x3A,0xCA
.db    0x90,0xE0
.db    0x1B,0x3A
.db    0xEF,0xE5
.db    0x77,0xC3
.db    0x96,0xE0
.db    0x78,0x32
.db    0xF0,0xE5
.db    0x70,0x13
.db    0x06,0x08
.db    0xCD,0x30
.db    0xE0,0xCA
.db    0xB9,0xE0
.db    0x23,0xFE
.db    0x2A,0xC2
.db    0xA9,0xE0
.db    0x36,0x3F
.db    0xC3,0xAB
.db    0xE0,0x77
.db    0x13,0x05
.db    0xC2,0x98
.db    0xE0,0xCD
.db    0x30,0xE0
.db    0xCA,0xC0
.db    0xE0,0x13
.db    0xC3,0xAF
.db    0xE0,0x23
.db    0x36,0x20
.db    0x05,0xC2
.db    0xB9,0xE0
.db    0x06,0x03
.db    0xFE,0x2E
.db    0xC2,0xE9
.db    0xE0,0x13
.db    0xCD,0x30
.db    0xE0,0xCA
.db    0xE9,0xE0
.db    0x23,0xFE
.db    0x2A,0xC2
.db    0xD9,0xE0
.db    0x36,0x3F
.db    0xC3,0xDB
.db    0xE0,0x77
.db    0x13,0x05
.db    0xC2,0xC8
.db    0xE0,0xCD
.db    0x30,0xE0
.db    0xCA,0xF0
.db    0xE0,0x13
.db    0xC3,0xDF
.db    0xE0,0x23
.db    0x36,0x20
.db    0x05,0xC2
.db    0xE9,0xE0
.db    0x06,0x03
.db    0x23,0x36
.db    0x00,0x05
.db    0xC2,0xF2
.db    0xE0,0xEB
.db    0x22,0x88
.db    0xDE,0xE1
.db    0x01,0x0B
.db    0x00,0x23
.db    0x7E,0xFE
.db    0x3F,0xC2
.db    0x09,0xE1
.db    0x04,0x0D
.db    0xC2,0x01
.db    0xE1,0x78
.db    0xB7,0xC9
.db    0x44,0x49
.db    0x52,0x20
.db    0x45,0x52
.db    0x41,0x20
.db    0x54,0x59
.db    0x50,0x45
.db    0x53,0x41
.db    0x56,0x45
.db    0x52,0x45
.db    0x4E,0x20
.db    0x55,0x53
.db    0x45,0x52
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x21,0x10
.db    0xE1,0x0E
.db    0x00,0x79
.db    0xFE,0x06
.db    0xD0,0x11
.db    0xCE,0xE5
.db    0x06,0x04
.db    0x1A,0xBE
.db    0xC2,0x4F
.db    0xE1,0x13
.db    0x23,0x05
.db    0xC2,0x3C
.db    0xE1,0x1A
.db    0xFE,0x20
.db    0xC2,0x54
.db    0xE1,0x79
.db    0xC9,0x23
.db    0x05,0xC2
.db    0x4F,0xE1
.db    0x0C,0xC3
.db    0x33,0xE1
.db    0xAF,0x32
.db    0x07,0xDE
.db    0x31,0xAB
.db    0xE5,0xC5
.db    0x79,0x1F
.db    0x1F,0x1F
.db    0x1F,0xE6
.db    0x0F,0x5F
.db    0xCD,0x15
.db    0xDF,0xCD
.db    0xB8,0xDE
.db    0x32,0xAB
.db    0xE5,0xC1
.db    0x79,0xE6
.db    0x0F,0x32
.db    0xEF,0xE5
.db    0xCD,0xBD
.db    0xDE,0x3A
.db    0x07,0xDE
.db    0xB7,0xC2
.db    0x98,0xE1
.db    0x31,0xAB
.db    0xE5,0xCD
.db    0x98,0xDE
.db    0xCD,0xD0
.db    0xDF,0xC6
.db    0x41,0xCD
.db    0x8C,0xDE
.db    0x3E,0x3E
.db    0xCD,0x8C
.db    0xDE,0xCD
.db    0x39,0xDF
.db    0x11,0x80
.db    0x00,0xCD
.db    0xD8,0xDF
.db    0xCD,0xD0
.db    0xDF,0x32
.db    0xEF,0xE5
.db    0xCD,0x5E
.db    0xE0,0xC4
.db    0x09,0xE0
.db    0x3A,0xF0
.db    0xE5,0xB7
.db    0xC2,0xA5
.db    0xE4,0xCD
.db    0x2E,0xE1
.db    0x21,0xC1
.db    0xE1,0x5F
.db    0x16,0x00
.db    0x19,0x19
.db    0x7E,0x23
.db    0x66,0x6F
.db    0xE9,0x77
.db    0xE2,0x1F
.db    0xE3,0x5D
.db    0xE3,0xAD
.db    0xE3,0x10
.db    0xE4,0x8E
.db    0xE4,0xA5
.db    0xE4,0x21
.db    0xF3,0x76
.db    0x22,0x00
.db    0xDE,0x21
.db    0x00,0xDE
.db    0xE9,0x01
.db    0xDF,0xE1
.db    0xC3,0xA7
.db    0xDE,0x52
.db    0x45,0x41
.db    0x44,0x20
.db    0x45,0x52
.db    0x52,0x4F
.db    0x52,0x00
.db    0x01,0xF0
.db    0xE1,0xC3
.db    0xA7,0xDE
.db    0x4E,0x4F
.db    0x20,0x46
.db    0x49,0x4C
.db    0x45,0x00
.db    0xCD,0x5E
.db    0xE0,0x3A
.db    0xF0,0xE5
.db    0xB7,0xC2
.db    0x09,0xE0
.db    0x21,0xCE
.db    0xE5,0x01
.db    0x0B,0x00
.db    0x7E,0xFE
.db    0x20,0xCA
.db    0x33,0xE2
.db    0x23,0xD6
.db    0x30,0xFE
.db    0x0A,0xD2
.db    0x09,0xE0
.db    0x57,0x78
.db    0xE6,0xE0
.db    0xC2,0x09
.db    0xE0,0x78
.db    0x07,0x07
.db    0x07,0x80
.db    0xDA,0x09
.db    0xE0,0x80
.db    0xDA,0x09
.db    0xE0,0x82
.db    0xDA,0x09
.db    0xE0,0x47
.db    0x0D,0xC2
.db    0x08,0xE2
.db    0xC9,0x7E
.db    0xFE,0x20
.db    0xC2,0x09
.db    0xE0,0x23
.db    0x0D,0xC2
.db    0x33,0xE2
.db    0x78,0xC9
.db    0x06,0x03
.db    0x7E,0x12
.db    0x23,0x13
.db    0x05,0xC2
.db    0x42,0xE2
.db    0xC9,0x21
.db    0x80,0x00
.db    0x81,0xCD
.db    0x59,0xE0
.db    0x7E,0xC9
.db    0xAF,0x32
.db    0xCD,0xE5
.db    0x3A,0xF0
.db    0xE5,0xB7
.db    0xC8,0x3D
.db    0x21,0xEF
.db    0xE5,0xBE
.db    0xC8,0xC3
.db    0xBD,0xDE
.db    0x3A,0xF0
.db    0xE5,0xB7
.db    0xC8,0x3D
.db    0x21,0xEF
.db    0xE5,0xBE
.db    0xC8,0x3A
.db    0xEF,0xE5
.db    0xC3,0xBD
.db    0xDE,0xCD
.db    0x5E,0xE0
.db    0xCD,0x54
.db    0xE2,0x21
.db    0xCE,0xE5
.db    0x7E,0xFE
.db    0x20,0xC2
.db    0x8F,0xE2
.db    0x06,0x0B
.db    0x36,0x3F
.db    0x23,0x05
.db    0xC2,0x88
.db    0xE2,0x1E
.db    0x00,0xD5
.db    0xCD,0xE9
.db    0xDE,0xCC
.db    0xEA,0xE1
.db    0xCA,0x1B
.db    0xE3,0x3A
.db    0xEE,0xE5
.db    0x0F,0x0F
.db    0x0F,0xE6
.db    0x60,0x4F
.db    0x3E,0x0A
.db    0xCD,0x4B
.db    0xE2,0x17
.db    0xDA,0x0F
.db    0xE3,0xD1
.db    0x7B,0x1C
.db    0xD5,0xE6
.db    0x03,0xF5
.db    0xC2,0xCC
.db    0xE2,0xCD
.db    0x98,0xDE
.db    0xC5,0xCD
.db    0xD0,0xDF
.db    0xC1,0xC6
.db    0x41,0xCD
.db    0x92,0xDE
.db    0x3E,0x3A
.db    0xCD,0x92
.db    0xDE,0xC3
.db    0xD4,0xE2
.db    0xCD,0xA2
.db    0xDE,0x3E
.db    0x3A,0xCD
.db    0x92,0xDE
.db    0xCD,0xA2
.db    0xDE,0x06
.db    0x01,0x78
.db    0xCD,0x4B
.db    0xE2,0xE6
.db    0x7F,0xFE
.db    0x20,0xC2
.db    0xF9,0xE2
.db    0xF1,0xF5
.db    0xFE,0x03
.db    0xC2,0xF7
.db    0xE2,0x3E
.db    0x09,0xCD
.db    0x4B,0xE2
.db    0xE6,0x7F
.db    0xFE,0x20
.db    0xCA,0x0E
.db    0xE3,0x3E
.db    0x20,0xCD
.db    0x92,0xDE
.db    0x04,0x78
.db    0xFE,0x0C
.db    0xD2,0x0E
.db    0xE3,0xFE
.db    0x09,0xC2
.db    0xD9,0xE2
.db    0xCD,0xA2
.db    0xDE,0xC3
.db    0xD9,0xE2
.db    0xF1,0xCD
.db    0xC2,0xDF
.db    0xC2,0x1B
.db    0xE3,0xCD
.db    0xE4,0xDE
.db    0xC3,0x98
.db    0xE2,0xD1
.db    0xC3,0x86
.db    0xE5,0xCD
.db    0x5E,0xE0
.db    0xFE,0x0B
.db    0xC2,0x42
.db    0xE3,0x01
.db    0x52,0xE3
.db    0xCD,0xA7
.db    0xDE,0xCD
.db    0x39,0xDF
.db    0x21,0x07
.db    0xDE,0x35
.db    0xC2,0x82
.db    0xE1,0x23
.db    0x7E,0xFE
.db    0x59,0xC2
.db    0x82,0xE1
.db    0x23,0x22
.db    0x88,0xDE
.db    0xCD,0x54
.db    0xE2,0x11
.db    0xCD,0xE5
.db    0xCD,0xEF
.db    0xDE,0x3C
.db    0xCC,0xEA
.db    0xE1,0xC3
.db    0x86,0xE5
.db    0x41,0x4C
.db    0x4C,0x20
.db    0x28,0x59
.db    0x2F,0x4E
.db    0x29,0x3F
.db    0x00,0xCD
.db    0x5E,0xE0
.db    0xC2,0x09
.db    0xE0,0xCD
.db    0x54,0xE2
.db    0xCD,0xD0
.db    0xDE,0xCA
.db    0xA7,0xE3
.db    0xCD,0x98
.db    0xDE,0x21
.db    0xF1,0xE5
.db    0x36,0xFF
.db    0x21,0xF1
.db    0xE5,0x7E
.db    0xFE,0x80
.db    0xDA,0x87
.db    0xE3,0xE5
.db    0xCD,0xFE
.db    0xDE,0xE1
.db    0xC2,0xA0
.db    0xE3,0xAF
.db    0x77,0x34
.db    0x21,0x80
.db    0x00,0xCD
.db    0x59,0xE0
.db    0x7E,0xFE
.db    0x1A,0xCA
.db    0x86,0xE5
.db    0xCD,0x8C
.db    0xDE,0xCD
.db    0xC2,0xDF
.db    0xC2,0x86
.db    0xE5,0xC3
.db    0x74,0xE3
.db    0x3D,0xCA
.db    0x86,0xE5
.db    0xCD,0xD9
.db    0xE1,0xCD
.db    0x66,0xE2
.db    0xC3,0x09
.db    0xE0,0xCD
.db    0xF8,0xE1
.db    0xF5,0xCD
.db    0x5E,0xE0
.db    0xC2,0x09
.db    0xE0,0xCD
.db    0x54,0xE2
.db    0x11,0xCD
.db    0xE5,0xD5
.db    0xCD,0xEF
.db    0xDE,0xD1
.db    0xCD,0x09
.db    0xDF,0xCA
.db    0xFB,0xE3
.db    0xAF,0x32
.db    0xED,0xE5
.db    0xF1,0x6F
.db    0x26,0x00
.db    0x29,0x11
.db    0x00,0x01
.db    0x7C,0xB5
.db    0xCA,0xF1
.db    0xE3,0x2B
.db    0xE5,0x21
.db    0x80,0x00
.db    0x19,0xE5
.db    0xCD,0xD8
.db    0xDF,0x11
.db    0xCD,0xE5
.db    0xCD,0x04
.db    0xDF,0xD1
.db    0xE1,0xC2
.db    0xFB,0xE3
.db    0xC3,0xD4
.db    0xE3,0x11
.db    0xCD,0xE5
.db    0xCD,0xDA
.db    0xDE,0x3C
.db    0xC2,0x01
.db    0xE4,0x01
.db    0x07,0xE4
.db    0xCD,0xA7
.db    0xDE,0xCD
.db    0xD5,0xDF
.db    0xC3,0x86
.db    0xE5,0x4E
.db    0x4F,0x20
.db    0x53,0x50
.db    0x41,0x43
.db    0x45,0x00
.db    0xCD,0x5E
.db    0xE0,0xC2
.db    0x09,0xE0
.db    0x3A,0xF0
.db    0xE5,0xF5
.db    0xCD,0x54
.db    0xE2,0xCD
.db    0xE9,0xDE
.db    0xC2,0x79
.db    0xE4,0x21
.db    0xCD,0xE5
.db    0x11,0xDD
.db    0xE5,0x06
.db    0x10,0xCD
.db    0x42,0xE2
.db    0x2A,0x88
.db    0xDE,0xEB
.db    0xCD,0x4F
.db    0xE0,0xFE
.db    0x3D,0xCA
.db    0x3F,0xE4
.db    0xFE,0x5F
.db    0xC2,0x73
.db    0xE4,0xEB
.db    0x23,0x22
.db    0x88,0xDE
.db    0xCD,0x5E
.db    0xE0,0xC2
.db    0x73,0xE4
.db    0xF1,0x47
.db    0x21,0xF0
.db    0xE5,0x7E
.db    0xB7,0xCA
.db    0x59,0xE4
.db    0xB8,0x70
.db    0xC2,0x73
.db    0xE4,0x70
.db    0xAF,0x32
.db    0xCD,0xE5
.db    0xCD,0xE9
.db    0xDE,0xCA
.db    0x6D,0xE4
.db    0x11,0xCD
.db    0xE5,0xCD
.db    0x0E,0xDF
.db    0xC3,0x86
.db    0xE5,0xCD
.db    0xEA,0xE1
.db    0xC3,0x86
.db    0xE5,0xCD
.db    0x66,0xE2
.db    0xC3,0x09
.db    0xE0,0x01
.db    0x82,0xE4
.db    0xCD,0xA7
.db    0xDE,0xC3
.db    0x86,0xE5
.db    0x46,0x49
.db    0x4C,0x45
.db    0x20,0x45
.db    0x58,0x49
.db    0x53,0x54
.db    0x53,0x00
.db    0xCD,0xF8
.db    0xE1,0xFE
.db    0x10,0xD2
.db    0x09,0xE0
.db    0x5F,0x3A
.db    0xCE,0xE5
.db    0xFE,0x20
.db    0xCA,0x09
.db    0xE0,0xCD
.db    0x15,0xDF
.db    0xC3,0x89
.db    0xE5,0xCD
.db    0xF5,0xDF
.db    0x3A,0xCE
.db    0xE5,0xFE
.db    0x20,0xC2
.db    0xC4,0xE4
.db    0x3A,0xF0
.db    0xE5,0xB7
.db    0xCA,0x89
.db    0xE5,0x3D
.db    0x32,0xEF
.db    0xE5,0xCD
.db    0x29,0xDF
.db    0xCD,0xBD
.db    0xDE,0xC3
.db    0x89,0xE5
.db    0x11,0xD6
.db    0xE5,0x1A
.db    0xFE,0x20
.db    0xC2,0x09
.db    0xE0,0xD5
.db    0xCD,0x54
.db    0xE2,0xD1
.db    0x21,0x83
.db    0xE5,0xCD
.db    0x40,0xE2
.db    0xCD,0xD0
.db    0xDE,0xCA
.db    0x6B,0xE5
.db    0x21,0x00
.db    0x01,0xE5
.db    0xEB,0xCD
.db    0xD8,0xDF
.db    0x11,0xCD
.db    0xE5,0xCD
.db    0xF9,0xDE
.db    0xC2,0x01
.db    0xE5,0xE1
.db    0x11,0x80
.db    0x00,0x19
.db    0x11,0x00
.db    0xDE,0x7D
.db    0x93,0x7C
.db    0x9A,0xD2
.db    0x71,0xE5
.db    0xC3,0xE1
.db    0xE4,0xE1
.db    0x3D,0xC2
.db    0x71,0xE5
.db    0xCD,0x66
.db    0xE2,0xCD
.db    0x5E,0xE0
.db    0x21,0xF0
.db    0xE5,0xE5
.db    0x7E,0x32
.db    0xCD,0xE5
.db    0x3E,0x10
.db    0xCD,0x60
.db    0xE0,0xE1
.db    0x7E,0x32
.db    0xDD,0xE5
.db    0xAF,0x32
.db    0xED,0xE5
.db    0x11,0x5C
.db    0x00,0x21
.db    0xCD,0xE5
.db    0x06,0x21
.db    0xCD,0x42
.db    0xE2,0x21
.db    0x08,0xDE
.db    0x7E,0xB7
.db    0xCA,0x3E
.db    0xE5,0xFE
.db    0x20,0xCA
.db    0x3E,0xE5
.db    0x23,0xC3
.db    0x30,0xE5
.db    0x06,0x00
.db    0x11,0x81
.db    0x00,0x7E
.db    0x12,0xB7
.db    0xCA,0x4F
.db    0xE5,0x04
.db    0x23,0x13
.db    0xC3,0x43
.db    0xE5,0x78
.db    0x32,0x80
.db    0x00,0xCD
.db    0x98,0xDE
.db    0xCD,0xD5
.db    0xDF,0xCD
.db    0x1A,0xDF
.db    0xCD,0x00
.db    0x01,0x31
.db    0xAB,0xE5
.db    0xCD,0x29
.db    0xDF,0xCD
.db    0xBD,0xDE
.db    0xC3,0x82
.db    0xE1,0xCD
.db    0x66,0xE2
.db    0xC3,0x09
.db    0xE0,0x01
.db    0x7A,0xE5
.db    0xCD,0xA7
.db    0xDE,0xC3
.db    0x86,0xE5
.db    0x42,0x41
.db    0x44,0x20
.db    0x4C,0x4F
.db    0x41,0x44
.db    0x00,0x43
.db    0x4F,0x4D
.db    0xCD,0x66
.db    0xE2,0xCD
.db    0x5E,0xE0
.db    0x3A,0xCE
.db    0xE5,0xD6
.db    0x20,0x21
.db    0xF0,0xE5
.db    0xB6,0xC2
.db    0x09,0xE0
.db    0xC3,0x82
.db    0xE1,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x24
.db    0x24,0x24
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x53
.db    0x55,0x42
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7A,0xE5
.db    0xCD,0xA7
.db    0xDE,0xC3
.db    0x86,0xE5
.db    0x42,0x41
.db    0x44,0x20
.db    0x4C,0x4F
 
DISK_ARR:
.db    0x00,0x50
.db    0x4F,0x57
.db    0x45,0x52
.db    0x20,0x20
.db    0x20,0x43
.db    0x4F,0x4D
.db    0x00,0x00
.db    0x00,0x7A
.db    0x04,0x00
.db    0x05,0x00
.db    0x06,0x00
.db    0x07,0x00
.db    0x08,0x00
.db    0x09,0x00
.db    0x0A,0x00
.db    0x0B,0x00
.db    0x00,0x52
.db    0x54,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x43
.db    0x4F,0x4D
.db    0x00,0x00
.db    0x00,0x08
.db    0x0C,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xC3,0x10
.db    0x03,0x00
.db    0x02,0x18
.db    0x0B,0x3D
.db    0x2E,0x7E
.db    0x3D,0x1B
.db    0x01,0xFF
.db    0x00,0x13
.db    0xFE,0xAC
.db    0x00,0x7C
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x01,0xE5
.db    0x00,0x7F
.db    0x00,0x0A
.db    0x00,0x2A
.db    0x01,0x00
.db    0x54,0x21
.db    0x2E,0x01
.db    0x46,0x7E
.db    0x2F,0x77
.db    0xBE,0x70
.db    0xC2,0x38
.db    0x01,0x23
.db    0x7C,0xBA
.db    0xC2,0x28
.db    0x01,0xC9
.db    0x1E,0x3F
.db    0x0E,0x02
.db    0xC3,0x05
.db    0x00,0xFF
.db    0xC9,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xC3,0x65
.db    0x04,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xC3,0x6A
.db    0x04,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xC3,0x2E
.db    0x05,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x00,0x0F
.db    0x02,0x00
.db    0x04,0xFF
.db    0xFF,0x80
.db    0x48,0x00
.db    0x01,0x81
.db    0x00,0xFF
.db    0x00,0x00
.db    0x00,0x1B
.db    0x5B,0x31
.db    0x6D,0x00
.db    0x00,0x00
.db    0x00,0x1B
.db    0x5B,0x6D
.db    0x00,0x00
.db    0x00,0x00
.db    0x3E,0xC6
.db    0x06,0x96
.db    0x2E,0x00
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x00,0x02
.db    0x01,0x08
.db    0x00,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x44,0x49
.db    0x52,0x20
.db    0x43,0x4F
.db    0x50,0x59
.db    0x20,0x52
.db    0x45,0x4E
.db    0x20,0x45
.db    0x52,0x41
.db    0x20,0x54
.db    0x59,0x50
.db    0x45,0x20
.db    0x54,0x59
.db    0x50,0x45
.db    0x58,0x20
.db    0x54,0x59
.db    0x50,0x45
.db    0x48,0x20
.db    0x54,0x59
.db    0x50,0x45
.db    0x41,0x20
.db    0x52,0x55
.db    0x4E,0x20
.db    0x45,0x58
.db    0x49,0x54
.db    0x20,0x53
.db    0x49,0x5A
.db    0x45,0x20
.db    0x43,0x48
.db    0x45,0x43
.db    0x4B,0x20
.db    0x53,0x54
.db    0x41,0x54
.db    0x20,0x41
.db    0x55,0x54
.db    0x4F,0x20
.db    0x54,0x45
.db    0x53,0x54
.db    0x20,0x53
.db    0x45,0x54
.db    0x20,0x53
.db    0x45,0x54
.db    0x44,0x49
.db    0x52,0x20
.db    0x53,0x45
.db    0x54,0x53
.db    0x59,0x53
.db    0x20,0x53
.db    0x45,0x54
.db    0x52,0x4F
.db    0x20,0x53
.db    0x45,0x54
.db    0x57,0x52
.db    0x20,0x52
.db    0x45,0x43
.db    0x4C,0x41
.db    0x49,0x4D
.db    0x20,0x44
.db    0x49,0x53
.db    0x4B,0x20
.db    0x47,0x52
.db    0x4F,0x55
.db    0x50,0x20
.db    0x4C,0x4F
.db    0x47,0x20
.db    0x52,0x45
.db    0x53,0x45
.db    0x54,0x20
.db    0x44,0x53
.db    0x20,0x53
.db    0x50,0x45
.db    0x45,0x44
.db    0x20,0x53
.db    0x41,0x56
.db    0x45,0x20
.db    0x4C,0x4F
.db    0x41,0x44
.db    0x20,0x52
.db    0x45,0x41
.db    0x44,0x20
.db    0x57,0x52
.db    0x49,0x54
.db    0x45,0x20
.db    0x52,0x45
.db    0x41,0x44
.db    0x47,0x52
.db    0x20,0x57
.db    0x52,0x49
.db    0x54,0x45
.db    0x47,0x52
.db    0x20,0x44
.db    0x55,0x4D
.db    0x50,0x20
.db    0x44,0x55
.db    0x4D,0x50
.db    0x58,0x20
.db    0x44,0x55
.db    0x4D,0x50
.db    0x48,0x20
.db    0x44,0x55
.db    0x4D,0x50
.db    0x41,0x20
.db    0x4D,0x4F
.db    0x56,0x45
.db    0x20,0x46
.db    0x49,0x4C
.db    0x4C,0x20
.db    0x43,0x4D
.db    0x20,0x53
.db    0x45,0x41
.db    0x52,0x43
.db    0x48,0x20
.db    0x4A,0x50
.db    0x20,0x45
.db    0x58,0x20
.db    0x47,0x4F
.db    0x20,0x55
.db    0x52,0x31
.db    0x20,0x55
.db    0x52,0x32
.db    0x20,0x55
.db    0x52,0x33
.db    0x20,0x55
.db    0x52,0x34
.db    0x20,0x53
.db    0x4F,0x52
.db    0x54,0x20
.db    0x50,0x41
.db    0x53,0x53
.db    0x20,0x3F
.db    0x20,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x01,0x50
.db    0x57,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0xC3,0xF5
.db    0x39,0xC3
.db    0x5A,0x3A
.db    0xC3,0x2C
.db    0x3B,0xC3
.db    0x2B,0x38
.db    0xAB,0x3E
.db    0xAB,0x3E
.db    0xC3,0x20
.db    0x03,0x51
.db    0x3E,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x21,0x00
.db    0x00,0x39
.db    0x22,0x10
.db    0x01,0x2A
.db    0x0C,0x03
.db    0xF9,0xAF
.db    0xC6,0x03
.db    0xEA,0x76
.db    0x20,0x2A
.db    0x06,0x00
.db    0x2E,0x00
.db    0xE5,0x3A
.db    0x6D,0x01
.db    0xB7,0x28
.db    0x09,0x5F
.db    0x3C,0x20
.db    0x02,0x1E
.db    0x08,0x7C
.db    0x93,0x67
.db    0x22,0x58
.db    0x14,0x3A
.db    0x15,0x01
.db    0xB7,0x28
.db    0x01,0x67
.db    0x22,0x58
.db    0x14,0x22
.db    0x4D,0x32
.db    0x3A,0x17
.db    0x01,0xB7
.db    0x28,0x1A
.db    0x32,0x00
.db    0x00,0x4F
.db    0x3E,0xFF
.db    0x91,0x4F
.db    0x3E,0x38
.db    0x91,0x16
.db    0x00,0x5F
.db    0x3E,0xC3
.db    0x12,0x21
.db    0x6A,0x04
.db    0x13,0x7D
.db    0x12,0x13
.db    0x7C,0x12
.db    0xAF,0x32
.db    0x55,0x05
.db    0x32,0xF9
.db    0x06,0x67
.db    0x6F,0x22
.db    0x3C,0x2E
.db    0x0E,0x0C
.db    0xCD,0x05
.db    0x00,0x7D
.db    0x32,0xA9
.db    0x04,0x7C
.db    0xB5,0x32
.db    0x67,0x0E
.db    0xCA,0x62
.db    0x20,0x3E
.db    0xFF,0x32
.db    0x57,0x06
.db    0x5F,0xCD
.db    0xCE,0x34
.db    0xF6,0x80
.db    0x32,0x9D
.db    0x11,0x32
.db    0x50,0x0F
.db    0x32,0xA3
.db    0x38,0x2A
.db    0x01,0x00
.db    0xCD,0x59
.db    0x0E,0x38
.db    0x2D,0x21
.db    0x54,0x3D
.db    0x22,0x86
.db    0x34,0x22
.db    0x68,0x32
.db    0x22,0x42
.db    0x34,0x22
.db    0x68,0x28
.db    0x22,0xB7
.db    0x35,0x22
.db    0xFC,0x35
.db    0x22,0x01
.db    0x3C,0x22
.db    0x34,0x28
.db    0x0E,0x31
.db    0x11,0xDA
.db    0x03,0xCD
.db    0x05,0x00
.db    0x7C,0xB5
.db    0x32,0xCD
.db    0x04,0xC3
.db    0x04,0x04
.db    0x5D,0x00
.db    0x11,0x15
.db    0x00,0x19
.db    0x11,0x03
.db    0x00,0x22
.db    0x86,0x34
.db    0x19,0x22
.db    0x68,0x32
.db    0x19,0x22
.db    0x42,0x34
.db    0x19,0x22
.db    0x68,0x28
.db    0x19,0x19
.db    0x22,0xB7
.db    0x35,0x19
.db    0x22,0xFC
.db    0x35,0x19
.db    0x22,0x01
.db    0x3C,0x19
.db    0x22,0x34
.db    0x28,0xE1
.db    0x3A,0x0D
.db    0x01,0x5F
.db    0xCD,0x59
.db    0x0E,0x0E
.db    0x2D,0xD4
.db    0x05,0x00
.db    0x3A,0x69
.db    0x01,0xF5
.db    0xCD,0xF5
.db    0x39,0xF1
.db    0x32,0x69
.db    0x01,0xED
.db    0x5B,0x0E
.db    0x03,0x13
.db    0x21,0x80
.db    0x00,0x46
.db    0x78,0x32
.db    0x05,0x06
.db    0x23,0x3A
.db    0x5D,0x00
.db    0xFE,0x20
.db    0xC4,0xEE
.db    0x39,0xEB
.db    0x36,0x20
.db    0x23,0x36
.db    0x00,0x3A
.db    0x5C,0x00
.db    0xB7,0xCC
.db    0xE7,0x37
.db    0x32,0x5C
.db    0x00,0x32
.db    0x44,0x26
.db    0x3A,0x6A
.db    0x01,0x32
.db    0x43,0x38
.db    0xB7,0xFA
.db    0x6A,0x04
.db    0xB7,0x20
.db    0x03,0x3A
.db    0x5C,0x00
.db    0x32,0xCB
.db    0x3D,0xCD
.db    0xC6,0x33
.db    0x11,0xCB
.db    0x3D,0xCD
.db    0x1A,0x33
.db    0x32,0x43
.db    0x38,0x18
.db    0x05,0x3E
.db    0xFF,0x32
.db    0xAF,0x31
.db    0x2A,0x0C
.db    0x03,0xF9
.db    0x3E,0xFF
.db    0x32,0x92
.db    0x3B,0x3A
.db    0xAF,0x31
.db    0x6F,0xCD
.db    0xA4,0x31
.db    0x3A,0x05
.db    0x06,0xB7
.db    0xC2,0x2E
.db    0x05,0x3A
.db    0x1E,0x01
.db    0xB7,0xFA
.db    0x2E,0x05
.db    0xA5,0xC2
.db    0x2E,0x05
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x0D,0x09
.db    0x50,0x4F
.db    0x57,0x45
.db    0x52,0x20
.db    0x33,0x2E
.db    0x30,0x37
.db    0x20,0x6F
.db    0x6E,0x20
.db    0x43,0x50
.db    0x2F,0x4D
.db    0xA0,0xCD
.db    0x24,0x0D
.db    0x3E,0x22
.db    0x1F,0x1F
.db    0x1F,0x1F
.db    0xE6,0x0F
.db    0xC6,0x30
.db    0xCD,0x2C
.db    0x3B,0x3E
.db    0x2E,0xCD
.db    0x2C,0x3B
.db    0x3A,0xA9
.db    0x04,0xE6
.db    0x0F,0xC6
.db    0x30,0xCD
.db    0x2C,0x3B
.db    0xCD,0x2A
.db    0x3B,0xCD
.db    0x59,0x0E
.db    0x38,0x0D
.db    0x3E,0x00
.db    0xB7,0x3E
.db    0x4E,0xCC
.db    0x2C,0x3B
.db    0x3E,0x42
.db    0xCD,0x2C
.db    0x3B,0xCD
.db    0xA7,0x3A
.db    0x20,0x5A
.db    0x0D,0x0D
.db    0x43,0x6F
.db    0x70,0x79
.db    0x72,0x69
.db    0x67,0x68
.db    0x74,0x20
.db    0x28,0x63
.db    0x29,0x20
.db    0x31,0x39
.db    0x38,0x31
.db    0x2C,0x20
.db    0x31,0x39
.db    0x38,0x32
.db    0x2C,0x20
.db    0x31,0x39
.db    0x38,0x33
.db    0x20,0x62
.db    0x79,0x20
.db    0x50,0x41
.db    0x56,0x45
.db    0x4C,0x20
.db    0x42,0x52
.db    0x45,0x44
.db    0x45,0x52
.db    0x0D,0x09
.db    0x43,0x48
.db    0x45,0x43
.db    0x4B,0x20
.db    0x66,0x61
.db    0x73,0x74
.db    0x65,0x72
.db    0x20,0x62
.db    0x79,0x20
.db    0x57,0x44
.db    0x20,0x20
.db    0x20,0x31
.db    0x32,0x2F
.db    0x30,0x36
.db    0x2F,0x38
.db    0x33,0x8D
.db    0x2A,0x0C
.db    0x03,0xF9
.db    0x3A,0x05
.db    0x06,0xB7
.db    0x20,0x0F
.db    0x3A,0x92
.db    0x01,0xB7
.db    0xF2,0x47
.db    0x05,0x3E
.db    0x20,0x32
.db    0x45,0x3B
.db    0xC3,0x08
.db    0x23,0x2A
.db    0x0C,0x03
.db    0xF9,0xCD
.db    0x1E,0x0D
.db    0x3A,0x0D
.db    0x01,0x32
.db    0x7B,0x36
.db    0x3E,0x00
.db    0xB7,0x28
.db    0x0A,0x32
.db    0x5C,0x00
.db    0x3A,0x16
.db    0x01,0x3D
.db    0xCC,0xA4
.db    0x31,0x3A
.db    0x16,0x01
.db    0x3D,0x20
.db    0x04,0x2F
.db    0x32,0xAF
.db    0x31,0x3A
.db    0x57,0x06
.db    0xFE,0xFF
.db    0x28,0x0B
.db    0xF6,0x80
.db    0x32,0x50
.db    0x0F,0x32
.db    0x9D,0x11
.db    0xCD,0xCB
.db    0x34,0x3A
.db    0xEF,0x08
.db    0xB7,0x3A
.db    0x9D,0x11
.db    0xC4,0xCB
.db    0x34,0x1E
.db    0xFF,0xCD
.db    0xCE,0x34
.db    0xF6,0x80
.db    0x32,0x9D
.db    0x11,0x32
.db    0xE8,0x0F
.db    0x3A,0x05
.db    0x06,0x3C
.db    0xCA,0x41
.db    0x20,0x21
.db    0x5D,0x00
.db    0x11,0x0A
.db    0x3E,0x06
.db    0x0B,0x3E
.db    0x3F,0x77
.db    0x12,0x23
.db    0x13,0x10
.db    0xFA,0x2A
.db    0x0E,0x03
.db    0x22,0xEA
.db    0x1E,0x3E
.db    0xFF,0x32
.db    0xC9,0x08
.db    0x32,0x87
.db    0x14,0x3C
.db    0x32,0x91
.db    0x1F,0x32
.db    0x3F,0x1E
.db    0x32,0xF2
.db    0x0B,0x32
.db    0xF8,0x11
.db    0x32,0xAB
.db    0x16,0x32
.db    0x15,0x0A
.db    0x32,0xEF
.db    0x08,0x32
.db    0xED,0x08
.db    0x32,0x10
.db    0x09,0x32
.db    0x1B,0x0F
.db    0x32,0x55
.db    0x05,0x32
.db    0x5D,0x0F
.db    0x32,0xBE
.db    0x17,0x32
.db    0xDB,0x1E
.db    0x32,0x21
.db    0x31,0x32
.db    0xB3,0x1B
.db    0x32,0x50
.db    0x1F,0x32
.db    0xE3,0x10
.db    0x32,0x7C
.db    0x00,0x67
.db    0x6F,0x22
.db    0xB1,0x1C
.db    0x22,0x10
.db    0x2B,0x3A
.db    0x5C,0x00
.db    0x32,0x44
.db    0x26,0x4F
.db    0x3E,0x00
.db    0xB7,0x28
.db    0x07,0x3E
.db    0xFF,0x32
.db    0x05,0x06
.db    0x18,0x1F
.db    0xCD,0xA2
.db    0x3A,0xAF
.db    0x32,0x59
.db    0x3B,0x32
.db    0x45,0x3B
.db    0x79,0xCD
.db    0xAD,0x37
.db    0x3A,0x9D
.db    0x11,0xE6
.db    0x7F,0xCD
.db    0xF7,0x30
.db    0x3A,0x07
.db    0x01,0xCD
.db    0x2C,0x3B
.db    0xCD,0x2B
.db    0x38,0x2A
.db    0x0E,0x03
.db    0x23,0xE5
.db    0xCD,0x41
.db    0x0D,0xE1
.db    0xCD,0x48
.db    0x0E,0x3A
.db    0x59,0x3B
.db    0x3D,0x32
.db    0x59,0x3B
.db    0xCD,0xDB
.db    0x30,0xCA
.db    0x7B,0x06
.db    0xFE,0x5B
.db    0x28,0x2F
.db    0xCD,0x82
.db    0x06,0x3E
.db    0x00,0xB7
.db    0xE5,0xC4
.db    0xA7,0x31
.db    0x3E,0xFF
.db    0xFE,0xFF
.db    0x28,0x0B
.db    0xF6,0x80
.db    0x32,0x50
.db    0x0F,0x32
.db    0x9D,0x11
.db    0xCD,0xCB
.db    0x34,0xE1
.db    0xAF,0x32
.db    0x50,0x06
.db    0x3D,0x32
.db    0x57,0x06
.db    0x3A,0x5C
.db    0x00,0x32
.db    0x44,0x26
.db    0xCD,0xDC
.db    0x30,0x20
.db    0x54,0xAF
.db    0x32,0x05
.db    0x06,0xC3
.db    0x2E,0x05
.db    0xAF,0x32
.db    0x50,0x06
.db    0x3D,0x32
.db    0x57,0x06
.db    0xE5,0x7E
.db    0xCD,0x4A
.db    0x3A,0xFE
.db    0x41,0x38
.db    0x04,0xFE
.db    0x51,0x38
.db    0x06,0x7E
.db    0xCD,0x2E
.db    0x3A,0x38
.db    0x03,0x23
.db    0x18,0xF7
.db    0xE1,0xCD
.db    0xD9,0x0E
.db    0xC0,0x7E
.db    0xCD,0x4A
.db    0x3A,0xFE
.db    0x41,0x38
.db    0x0C,0xD6
.db    0x40,0x32
.db    0x50,0x06
.db    0x23,0x7E
.db    0xCD,0xD9
.db    0x0E,0x28
.db    0x14,0xD5
.db    0xC5,0xCD
.db    0xDB,0x10
.db    0xAF,0x32
.db    0xE3,0x10
.db    0x7D,0xEB
.db    0x5F,0xCD
.db    0xC9,0x22
.db    0xC1,0xD1
.db    0x32,0x57
.db    0x06,0x23
.db    0xC9,0xE5
.db    0x06,0x00
.db    0x11,0xD0
.db    0x01,0xAF
.db    0x32,0xF3
.db    0x06,0x7E
.db    0xCD,0x4A
.db    0x3A,0xEB
.db    0xBE,0x28
.db    0x09,0x4F
.db    0x7E,0xE6
.db    0x7F,0xCD
.db    0x4A,0x3A
.db    0xB9,0x79
.db    0xEB,0xC2
.db    0x5A,0x07
.db    0xFE,0x20
.db    0x20,0x5C
.db    0x3E,0x00
.db    0xB7,0xCA
.db    0x71,0x07
.db    0x3E,0x00
.db    0xB7,0xC2
.db    0x71,0x07
.db    0xCD,0xA7
.db    0x3A,0x09
.db    0x07,0x70
.db    0x61,0x73
.db    0x73,0x77
.db    0x6F,0x72
.db    0x64,0x20
.db    0x72,0x65
.db    0x71,0x75
.db    0x69,0x72
.db    0x65,0x64
.db    0x00,0xAF
.db    0x32,0xF9
.db    0x06,0xCD
.db    0xDC,0x30
.db    0xE5,0x11
.db    0x80,0x01
.db    0xCD,0x35
.db    0x07,0xCD
.db    0xA7,0x3A
.db    0x09,0x07
.db    0x62,0x61
.db    0x64,0x20
.db    0x70,0x61
.db    0x73,0x73
.db    0x77,0x6F
.db    0x72,0x64
.db    0x00,0x1A
.db    0xB7,0x28
.db    0x0B,0x0F
.db    0x0F,0x0F
.db    0xEE,0x97
.db    0xBE,0xC0
.db    0x13,0x23
.db    0x18,0xF1
.db    0x7E,0xFE
.db    0x20,0xC0
.db    0x32,0xF9
.db    0x06,0xC3
.db    0x2E,0x05
.db    0x1A,0x07
.db    0x30,0x03
.db    0x32,0xF3
.db    0x06,0x23
.db    0x13,0xC3
.db    0xD9,0x06
.db    0x1A,0xB7
.db    0x28,0x0A
.db    0x13,0xFE
.db    0x20,0x20
.db    0xF7,0xEB
.db    0xCD,0xDC
.db    0x30,0xEB
.db    0xCA,0x82
.db    0x0E,0x04
.db    0xE1,0xE5
.db    0xC3,0xD5
.db    0x06,0x78
.db    0x3C,0x32
.db    0x23,0x16
.db    0xE5,0xFE
.db    0x09,0x20
.db    0x51,0xE5
.db    0x2A,0x58
.db    0x14,0x22
.db    0x6E,0x14
.db    0x25,0x25
.db    0x75,0x22
.db    0xA5,0x07
.db    0x23,0x36
.db    0x20,0xE1
.db    0xCD,0xDC
.db    0x30,0x28
.db    0x3B,0x23
.db    0x7E,0xCD
.db    0xD9,0x0E
.db    0xCC,0xDB
.db    0x30,0x28
.db    0x31,0xFE
.db    0x20,0x20
.db    0xF2,0xCD
.db    0xDC,0x30
.db    0x28,0x28
.db    0x11,0x00
.db    0x00,0x13
.db    0x01,0x00
.db    0x00,0x13
.db    0x7E,0x12
.db    0xB7,0x28
.db    0x14,0xCD
.db    0xD9,0x0E
.db    0x20,0x04
.db    0xCD,0xDB
.db    0x30,0x2B
.db    0x23,0x13
.db    0x0C,0x18
.db    0xED,0x4E
.db    0x23,0x46
.db    0xEB,0xC5
.db    0xC9,0x2A
.db    0xA5,0x07
.db    0x71,0x09
.db    0x23,0x70
.db    0xE1,0xD1
.db    0xCD,0xDC
.db    0x30,0x28
.db    0x75,0xFE
.db    0x3D,0x20
.db    0x0B,0x3A
.db    0x5C,0x00
.db    0x32,0x5D
.db    0x0F,0xCD
.db    0xDB,0x30
.db    0x28,0x66
.db    0xCD,0x82
.db    0x06,0x3A
.db    0x9D,0x11
.db    0xF5,0x3A
.db    0x57,0x06
.db    0xFE,0xFF
.db    0x28,0x12
.db    0xF6,0x80
.db    0x32,0x50
.db    0x0F,0x32
.db    0x9D,0x11
.db    0xE5,0xCD
.db    0xCB,0x34
.db    0xE1,0xF1
.db    0x32,0x57
.db    0x06,0xF5
.db    0xF1,0x3A
.db    0x50,0x06
.db    0xB7,0x28
.db    0x3F,0x3A
.db    0x55,0x05
.db    0xB7,0x20
.db    0x06,0x3A
.db    0x5C,0x00
.db    0x32,0x55
.db    0x05,0x3A
.db    0x50,0x06
.db    0x32,0x5C
.db    0x00,0x3A
.db    0x23,0x16
.db    0xFE,0x19
.db    0xCA,0x66
.db    0x0E,0xCD
.db    0xA4,0x31
.db    0xCD,0xDC
.db    0x30,0x28
.db    0x1D,0xFE
.db    0x3D,0x20
.db    0x19,0xCD
.db    0xDB,0x30
.db    0x3A,0x5C
.db    0x00,0x32
.db    0x5D,0x0F
.db    0x28,0x08
.db    0x23,0x7E
.db    0x2B,0xCD
.db    0xD9,0x0E
.db    0x28,0xA0
.db    0x3A,0x55
.db    0x05,0x32
.db    0x5C,0x00
.db    0xEB,0x21
.db    0x6D,0x3D
.db    0x3A,0x23
.db    0x16,0xBE
.db    0x7E,0x23
.db    0xCA,0xBF
.db    0x07,0x23
.db    0x23,0x3C
.db    0x20,0xF2
.db    0xEB,0x3A
.db    0x23,0x16
.db    0xFE,0x10
.db    0x20,0x0B
.db    0x3A,0x15
.db    0x0A,0xB7
.db    0x28,0x05
.db    0xC6,0x80
.db    0x32,0x15
.db    0x0A,0xCD
.db    0xDC,0x30
.db    0xC4,0xAB
.db    0x22,0x01
.db    0x5C,0x00
.db    0xC5,0xC4
.db    0x6C,0x22
.db    0x22,0x9A
.db    0x30,0xE1
.db    0x06,0x0B
.db    0x23,0x7E
.db    0xFE,0x3F
.db    0x28,0x02
.db    0x10,0xF8
.db    0x32,0x15
.db    0x0F,0x3A
.db    0x23,0x16
.db    0xFE,0x1D
.db    0xCA,0xF4
.db    0x2C,0xFE
.db    0x1C,0xCA
.db    0x54,0x2D
.db    0xFE,0x2C
.db    0xCA,0xD7
.db    0x2D,0xF5
.db    0xCD,0xA2
.db    0x3A,0xF1
.db    0xFE,0x09
.db    0x28,0x0E
.db    0xFE,0x01
.db    0x28,0x15
.db    0xAF,0x32
.db    0xEF,0x08
.db    0x32,0xED
.db    0x08,0xC3
.db    0x4B,0x09
.db    0x21,0x65
.db    0x00,0x36
.db    0x43,0x23
.db    0x36,0x4F
.db    0x23,0x36
.db    0x4D,0xCD
.db    0xEC,0x08
.db    0x28,0xED
.db    0x7B,0xB7
.db    0x28,0x41
.db    0x3E,0xFF
.db    0x3C,0x32
.db    0xC9,0x08
.db    0x5F,0x3A
.db    0x61,0x01
.db    0xBB,0x7B
.db    0x30,0x1C
.db    0x3E,0xFF
.db    0x32,0xC9
.db    0x08,0x3A
.db    0xED,0x08
.db    0xB7,0x20
.db    0xDE,0x3A
.db    0x23,0x16
.db    0xFE,0x09
.db    0xCA,0x08
.db    0x33,0xC3
.db    0x2E,0x05
.db    0x3E,0x00
.db    0x1E,0x00
.db    0xB3,0xC9
.db    0xFE,0x10
.db    0x38,0x07
.db    0x3A,0xF9
.db    0x06,0xB7
.db    0x7B,0x28
.db    0xD9,0x32
.db    0xF2,0x0B
.db    0xCD,0xCB
.db    0x34,0x3A
.db    0xC9,0x08
.db    0xB7,0x20
.db    0x42,0x3A
.db    0xED,0x08
.db    0xB7,0x28
.db    0x3C,0x3E
.db    0x00,0x5F
.db    0x3C,0x32
.db    0x10,0x09
.db    0x32,0x5C
.db    0x00,0x3A
.db    0x7B,0x36
.db    0xB7,0x28
.db    0x06,0x3A
.db    0x60,0x01
.db    0xB7,0x20
.db    0x23,0xD5
.db    0x0E,0x18
.db    0xCD,0x05
.db    0x00,0xD1
.db    0x01,0x10
.db    0x00,0x0D
.db    0xFA,0xE1
.db    0x08,0x22
.db    0x3F,0x09
.db    0xCD,0xD4
.db    0x30,0x78
.db    0x04,0xBB
.db    0x20,0xF1
.db    0x21,0x00
.db    0x00,0xCD
.db    0xD4,0x30
.db    0x30,0xC9
.db    0x18,0x03
.db    0xBB,0x38
.db    0xDA,0x2A
.db    0x0E,0x03
.db    0x22,0xEA
.db    0x1E,0x21
.db    0x00,0x00
.db    0x22,0x05
.db    0x11,0x22
.db    0x75,0x0A
.db    0xCD,0xA4
.db    0x31,0x3E
.db    0x00,0xB7
.db    0xC2,0xC1
.db    0x32,0x11
.db    0x5C,0x00
.db    0x1A,0x32
.db    0x09,0x3E
.db    0x3A,0x15
.db    0x0F,0xFE
.db    0x3F,0x28
.db    0x5D,0x3A
.db    0x23,0x16
.db    0xFE,0x09
.db    0x20,0x56
.db    0x3A,0xEF
.db    0x08,0xB7
.db    0x20,0x50
.db    0x3A,0x55
.db    0x05,0xB7
.db    0x20,0x4A
.db    0xCD,0x1A
.db    0x33,0x20
.db    0x48,0x3A
.db    0x90,0x01
.db    0xB7,0xFA
.db    0xC4,0x09
.db    0x32,0x87
.db    0x14,0x5F
.db    0xCD,0xC9
.db    0x22,0x3A
.db    0x9D,0x11
.db    0xB7,0x28
.db    0x11,0xE6
.db    0x7F,0xBB
.db    0x28,0x0C
.db    0x7B,0xCD
.db    0xCB,0x34
.db    0x11,0x5C
.db    0x00,0xCD
.db    0x1D,0x33
.db    0x20,0x23
.db    0x3A,0x5C
.db    0x00,0x5F
.db    0x3A,0x91
.db    0x01,0xBB
.db    0x28,0x0C
.db    0x32,0x5C
.db    0x00,0x7B
.db    0x32,0x55
.db    0x05,0x11
.db    0x5C,0x00
.db    0x18,0xC0
.db    0x3A,0x9D
.db    0x11,0xB7
.db    0xC4,0xCB
.db    0x34,0xC3
.db    0x08,0x33
.db    0xCD,0xFB
.db    0x32,0xCD
.db    0x86,0x31
.db    0x54,0x5D
.db    0x21,0x09
.db    0x00,0x19
.db    0x46,0x3A
.db    0x23,0x16
.db    0x23,0x4E
.db    0xFE,0x13
.db    0x28,0x20
.db    0xFE,0x14
.db    0x20,0x06
.db    0x78,0xEE
.db    0xFF,0x47
.db    0x18,0x16
.db    0x41,0xFE
.db    0x11,0x28
.db    0xF5,0xFE
.db    0x12,0x28
.db    0x0D,0xFE
.db    0x09,0x28
.db    0x19,0x3A
.db    0x15,0x0F
.db    0xFE,0x3F
.db    0x20,0x12
.db    0xAF,0x47
.db    0x38,0x57
.db    0x3A,0x65
.db    0x01,0xB7
.db    0x20,0x04
.db    0x79,0x17
.db    0x38,0x4D
.db    0x78,0x17
.db    0x38,0x49
.db    0x3E,0x00
.db    0xB7,0x28
.db    0x1A,0xF5
.db    0xD5,0x11
.db    0xF6,0xFF
.db    0x19,0xE6
.db    0x0F,0x5F
.db    0x16,0x00
.db    0x19,0xD1
.db    0xF1,0x7E
.db    0xFA,0x30
.db    0x0A,0x17
.db    0x38,0x2F
.db    0x18,0x03
.db    0x17,0x30
.db    0x2A,0x2A
.db    0xEA,0x1E
.db    0x06,0x0B
.db    0x13,0x36
.db    0x00,0x23
.db    0x36,0x00
.db    0x23,0x1A
.db    0x77,0x23
.db    0x13,0x10
.db    0xFA,0x22
.db    0xEA,0x1E
.db    0xEB,0x2A
.db    0x75,0x0A
.db    0x23,0x22
.db    0x75,0x0A
.db    0x29,0x19
.db    0x24,0xEB
.db    0x2A,0x58
.db    0x14,0xCD
.db    0xDC,0x2C
.db    0xDA,0xC2
.db    0x30,0x2A
.db    0xEA,0x1E
.db    0x36,0xFF
.db    0x23,0x36
.db    0xFF,0xCD
.db    0xA8,0x33
.db    0xC2,0xD1
.db    0x09,0x2A
.db    0x0E,0x03
.db    0x23,0x7E
.db    0x3C,0xCA
.db    0xFF,0x32
.db    0x21,0x01
.db    0x00,0x23
.db    0x22,0x96
.db    0x0A,0xED
.db    0x5B,0x0E
.db    0x03,0x2A
.db    0xEA,0x1E
.db    0x22,0xEA
.db    0x0A,0x22
.db    0x23,0x0B
.db    0x23,0x23
.db    0x01,0x0D
.db    0x00,0x73
.db    0x23,0x72
.db    0x23,0xEB
.db    0x09,0xEB
.db    0xE5,0x21
.db    0x00,0x00
.db    0x2B,0x22
.db    0x96,0x0A
.db    0x7D,0xB4
.db    0xE1,0x20
.db    0xEC,0x2A
.db    0x75,0x0A
.db    0x23,0x22
.db    0x10,0x0B
.db    0x2B,0x7D
.db    0xB4,0x28
.db    0x04,0x3A
.db    0x04,0x01
.db    0xB7,0xCA
.db    0xAC,0x0B
.db    0xCD,0xD4
.db    0x30,0xB4
.db    0x28,0xF7
.db    0x7D,0xF6
.db    0x01,0x6F
.db    0x22,0x01
.db    0x0B,0x23
.db    0x22,0x13
.db    0x0B,0xEB
.db    0x2A,0x01
.db    0x0B,0x7B
.db    0x95,0x6F
.db    0x7A,0x9C
.db    0x67,0x22
.db    0xFE,0x0A
.db    0xEB,0x2A
.db    0x01,0x0B
.db    0x19,0x22
.db    0xE7,0x0A
.db    0x3E,0x0C
.db    0xCD,0x22
.db    0x0B,0xF2
.db    0x0F,0x0B
.db    0xED,0x5B
.db    0xFE,0x0A
.db    0x21,0x34
.db    0x00,0x01
.db    0xB8,0x3E
.db    0x29,0x09
.db    0xEB,0x29
.db    0x09,0x4E
.db    0x1A,0xEB
.db    0x71,0x12
.db    0x23,0x13
.db    0x4E,0x1A
.db    0xEB,0x71
.db    0x12,0x11
.db    0x33,0x00
.db    0x21,0x01
.db    0x00,0x7B
.db    0x95,0x6F
.db    0x7A,0x9C
.db    0x67,0xFA
.db    0x0F,0x0B
.db    0xB5,0x20
.db    0xC0,0x11
.db    0x02,0x00
.db    0x21,0x34
.db    0x00,0x23
.db    0x7B,0x95
.db    0x7A,0x9C
.db    0xF2,0xC2
.db    0x0A,0x2A
.db    0x01,0x0B
.db    0x18,0x92
.db    0x01,0xB8
.db    0x3E,0x29
.db    0x09,0xEB
.db    0x29,0x09
.db    0xEB,0x4E
.db    0x23,0x46
.db    0xEB,0x5E
.db    0x23,0x56
.db    0xEB,0x5F
.db    0x0A,0xFE
.db    0xFF,0xC8
.db    0xE5,0xD5
.db    0x11,0x0B
.db    0x00,0x19
.db    0x7E,0xD1
.db    0xE1,0x17
.db    0x3E,0x00
.db    0xCE,0x00
.db    0x57,0x3A
.db    0x23,0x16
.db    0xFE,0x33
.db    0x3A,0x04
.db    0x01,0x20
.db    0x06,0xFE
.db    0x03,0x38
.db    0x02,0xD6
.db    0x02,0xFE
.db    0x01,0x28
.db    0x31,0xFE
.db    0x03,0x28
.db    0x19,0xFE
.db    0x05,0x30
.db    0x29,0xE5
.db    0x21,0x0B
.db    0x00,0x09
.db    0x7E,0xE1
.db    0x17,0x3E
.db    0x00,0xCE
.db    0x00,0x92
.db    0xC0,0x3A
.db    0x04,0x01
.db    0xFE,0x02
.db    0x28,0x14
.db    0xE5,0xC5
.db    0x16,0x0A
.db    0x7B,0x92
.db    0x5F,0x23
.db    0x03,0x15
.db    0x20,0xFB
.db    0xCD,0x8C
.db    0x0B,0xC1
.db    0xE1,0xC0
.db    0x1E,0x0A
.db    0x7E,0xE6
.db    0x7F,0x57
.db    0x0A,0xE6
.db    0x7F,0xBA
.db    0x03,0x23
.db    0xC0,0x1D
.db    0x20,0xF2
.db    0xC9,0xCD
.db    0xDC,0x30
.db    0xCD,0x2E
.db    0x3A,0xDA
.db    0x3E,0x3D
.db    0xD6,0x30
.db    0x32,0x04
.db    0x01,0xC3
.db    0x2E,0x05
.db    0x2A,0x10
.db    0x0B,0x29
.db    0xEB,0x2A
.db    0xEA,0x1E
.db    0x19,0x22
.db    0xEA,0x1E
.db    0xCD,0xEC
.db    0x08,0x28
.db    0x03,0xCD
.db    0xA2,0x3A
.db    0x3A,0x23
.db    0x16,0xFE
.db    0x01,0x28
.db    0x0C,0xFE
.db    0x33,0x28
.db    0x37,0x3A
.db    0x15,0x0F
.db    0xFE,0x3F
.db    0xC2,0xDF
.db    0x0E,0x3A
.db    0x5C,0x00
.db    0xCD,0xAD
.db    0x37,0x3A
.db    0xEF,0x08
.db    0xB7,0x20
.db    0x12,0x3A
.db    0x9D,0x11
.db    0xE6,0x7F
.db    0x20,0x0D
.db    0x3A,0x50
.db    0x0F,0xE6
.db    0x7F,0x20
.db    0x04,0x3A
.db    0x1C,0x01
.db    0xB7,0x3E
.db    0x00,0xF5
.db    0xC4,0xF7
.db    0x30,0xCD
.db    0xAB,0x37
.db    0xF1,0x28
.db    0x05,0xFE
.db    0x0A,0xDC
.db    0x2A,0x3B
.db    0x3A,0x23
.db    0x16,0xFE
.db    0x01,0x3A
.db    0x64,0x01
.db    0x20,0x05
.db    0xB7,0xF2
.db    0x11,0x0C
.db    0x3C,0xE6
.db    0x7F,0x32
.db    0x21,0x31
.db    0xED,0x5B
.db    0x05,0x11
.db    0x2A,0x75
.db    0x0A,0xCD
.db    0xDC,0x2C
.db    0xDA,0xE5
.db    0x0E,0x2A
.db    0x05,0x11
.db    0x29,0xEB
.db    0x2A,0xEA
.db    0x0A,0x23
.db    0x23,0x19
.db    0x5E,0x23
.db    0x56,0xEB
.db    0xE5,0x2A
.db    0x05,0x11
.db    0x23,0x22
.db    0x05,0x11
.db    0xE1,0x3A
.db    0x23,0x16
.db    0xFE,0x33
.db    0x28,0x25
.db    0xFE,0x01
.db    0x20,0x12
.db    0x3A,0x0E
.db    0x01,0xB7
.db    0x28,0x1B
.db    0xFA,0x58
.db    0x0C,0xCD
.db    0xA7,0x3A
.db    0x20,0x20
.db    0x20,0xA0
.db    0x18,0x0F
.db    0xE5,0x2A
.db    0x05,0x11
.db    0x0E,0x30
.db    0xCD,0x48
.db    0x31,0xE1
.db    0x3E,0x3D
.db    0xCD,0x2C
.db    0x3B,0xE5
.db    0x11,0x0A
.db    0x00,0x19
.db    0x7E,0x32
.db    0x8F,0x0C
.db    0x23,0x3A
.db    0x70,0x01
.db    0xB7,0x7E
.db    0x32,0xA0
.db    0x0C,0xE1
.db    0x28,0x04
.db    0xB7,0xFC
.db    0x24,0x0D
.db    0xB7,0x3E
.db    0x28,0xFC
.db    0x2C,0x3B
.db    0xF4,0x2A
.db    0x3B,0x23
.db    0x23,0xCD
.db    0xD1,0x0C
.db    0x3E,0x43
.db    0xB7,0x3E
.db    0x2A,0xFC
.db    0x2C,0x3B
.db    0xFA,0xAA
.db    0x0C,0x3A
.db    0x70,0x01
.db    0xB7,0x20
.db    0x02,0x3E
.db    0x4F,0xB7
.db    0x3E,0x29
.db    0xFC,0x2C
.db    0x3B,0xF4
.db    0x2A,0x3B
.db    0xCD,0x1E
.db    0x0D,0xE5
.db    0xD5,0xED
.db    0x5B,0x75
.db    0x0A,0x2A
.db    0x05,0x11
.db    0xCD,0xDC
.db    0x2C,0xD1
.db    0xE1,0xD2
.db    0xE5,0x0E
.db    0x3A,0x21
.db    0x31,0x3D
.db    0x32,0x21
.db    0x31,0xCA
.db    0xBD,0x0B
.db    0x3A,0x13
.db    0x01,0xCD
.db    0x2C,0x3B
.db    0xC3,0x16
.db    0x0C,0xE5
.db    0xD1,0xE5
.db    0xC1,0x3A
.db    0x6B,0x01
.db    0xE6,0x07
.db    0x28,0x13
.db    0xE5,0xD5
.db    0x5F,0x16
.db    0x00,0x19
.db    0x7E,0x17
.db    0x38,0x07
.db    0x2B,0x7E
.db    0x17,0x3F
.db    0x30,0x01
.db    0xAF,0xD1
.db    0xE1,0xF5
.db    0x3E,0x08
.db    0xCD,0x0F
.db    0x0D,0x3A
.db    0x23,0x16
.db    0xFE,0x33
.db    0x20,0x03
.db    0xF1,0x18
.db    0x0E,0xF1
.db    0x3E,0x2E
.db    0x28,0x06
.db    0x3E,0x3E
.db    0x30,0x02
.db    0x3E,0x3C
.db    0xCD,0x2C
.db    0x3B,0x3E
.db    0x03,0xF5
.db    0x7E,0x12
.db    0x02,0xCD
.db    0x7A,0x39
.db    0x23,0x13
.db    0x03,0xF1
.db    0x3D,0x20
.db    0xF2,0xC9
.db    0xE5,0x21
.db    0x78,0x01
.db    0x18,0x04
.db    0xE5,0x21
.db    0x70,0x01
.db    0xC5,0x46
.db    0x23,0x05
.db    0xFA,0x3D
.db    0x0D,0xE5
.db    0xD5,0xC5
.db    0x5E,0x0E
.db    0x02,0xCD
.db    0x05,0x00
.db    0xC1,0xD1
.db    0xE1,0x18
.db    0xED,0xC1
.db    0xE1,0xAF
.db    0xC9,0x5E
.db    0x1C,0x23
.db    0x7E,0x1D
.db    0xC8,0xFE
.db    0x5B,0x20
.db    0xF8,0x22
.db    0x33,0x0E
.db    0xCD,0xDB
.db    0x30,0xC8
.db    0xFE,0x5D
.db    0xC8,0x01
.db    0x4E,0x0D
.db    0xC5,0xCD
.db    0x4A,0x3A
.db    0xFE,0x2B
.db    0x28,0x29
.db    0xFE,0x2D
.db    0x28,0x1E
.db    0xFE,0x22
.db    0xCA,0x1E
.db    0x0E,0xFE
.db    0x31,0x38
.db    0x47,0xFE
.db    0x3A,0x30
.db    0x43,0xE6
.db    0x0F,0x47
.db    0x3A,0x64
.db    0x01,0xB7
.db    0x78,0xF2
.db    0x7E,0x0D
.db    0xF6,0x80
.db    0x32,0x64
.db    0x01,0xC9
.db    0xCD,0x90
.db    0x0D,0x32
.db    0x15,0x0A
.db    0xC9,0xCD
.db    0x90,0x0D
.db    0xC6,0x80
.db    0x18,0xF5
.db    0x23,0x7E
.db    0xCD,0x4A
.db    0x3A,0x0E
.db    0x09,0xFE
.db    0x52,0x28
.db    0x17,0x0C
.db    0xFE,0x53
.db    0x28,0x12
.db    0x0C,0xFE
.db    0x58,0x28
.db    0x0D,0xFE
.db    0x31,0xDA
.db    0x3E,0x3D
.db    0xFE,0x39
.db    0xD2,0x3E
.db    0x3D,0xE6
.db    0x0F,0xC9
.db    0x79,0xC9
.db    0xE5,0xFE
.db    0x56,0x21
.db    0x67,0x01
.db    0x28,0x5C
.db    0xFE,0x52
.db    0x21,0x63
.db    0x01,0x28
.db    0x55,0xFE
.db    0x53,0x21
.db    0x65,0x01
.db    0x28,0x4E
.db    0xFE,0x54
.db    0x21,0x66
.db    0x01,0x28
.db    0x47,0xFE
.db    0x50,0x21
.db    0x05,0x01
.db    0x28,0x40
.db    0xFE,0x55
.db    0x21,0xEF
.db    0x08,0x28
.db    0x39,0xFE
.db    0x58,0x28
.db    0x5A,0xFE
.db    0x4D,0x21
.db    0x6B,0x01
.db    0x28,0x2E
.db    0xFE,0x51
.db    0x21,0xF8
.db    0x11,0x28
.db    0x2A,0xFE
.db    0x24,0x21
.db    0xF0,0x02
.db    0x28,0x20
.db    0xFE,0x46
.db    0x21,0x90
.db    0x01,0x28
.db    0x19,0xFE
.db    0x5A,0x21
.db    0x91,0x1F
.db    0x28,0x15
.db    0xFE,0x2F
.db    0x28,0x27
.db    0xE1,0xFE
.db    0x41,0xD8
.db    0xFE,0x45
.db    0xD0,0xE6
.db    0x0F,0x3D
.db    0x32,0x62
.db    0x01,0xC9
.db    0x7E,0xC6
.db    0x80,0x77
.db    0xE1,0xC9
.db    0x23,0x7E
.db    0xFE,0x22
.db    0xC8,0xB7
.db    0x2B,0xC8
.db    0x23,0xFE
.db    0x0E,0xC4
.db    0x2C,0x3B
.db    0xCC,0xA2
.db    0x3A,0x18
.db    0xED,0xE5
.db    0x21,0xAD
.db    0x3E,0x36
.db    0x20,0x23
.db    0x36,0x00
.db    0xE1,0x18
.db    0xDF,0x32
.db    0xED,0x08
.db    0x3A,0x5C
.db    0x00,0x32
.db    0x55,0x05
.db    0xE1,0xC9
.db    0x3A,0x05
.db    0x01,0xB7
.db    0xC8,0xE6
.db    0x7F,0x3C
.db    0x32,0x59
.db    0x3B,0x3E
.db    0x20,0x32
.db    0x45,0x3B
.db    0xC9,0x3A
.db    0x67,0x0E
.db    0xB7,0x28
.db    0x03,0xFE
.db    0x30,0xD8
.db    0xB7,0xC0
.db    0x37,0xC9
.db    0x3E,0x22
.db    0xFE,0x16
.db    0x38,0x16
.db    0x3A,0x5C
.db    0x00,0x21
.db    0x01,0x00
.db    0xCD,0x79
.db    0x0E,0xC3
.db    0x2E,0x05
.db    0x29,0x3D
.db    0x20,0xFC
.db    0xEB,0x0E
.db    0x25,0xC3
.db    0x05,0x00
.db    0xAF,0x32
.db    0x05,0x06
.db    0xCD,0xA7
.db    0x3A,0x09
.db    0x07,0x63
.db    0x6F,0x6D
.db    0x6D,0x61
.db    0x6E,0x64
.db    0x73,0xBA
.db    0x3A,0x92
.db    0x01,0xB7
.db    0xFA,0x2E
.db    0x05,0xC2
.db    0x08,0x23
.db    0xCD,0xA7
.db    0x3A,0x2C
.db    0x20,0x66
.db    0x6F,0x72
.db    0x20,0x6C
.db    0x69,0x73
.db    0x74,0x20
.db    0x6F,0x66
.db    0x20,0x63
.db    0x6F,0x6D
.db    0x6D,0x61
.db    0x6E,0x64
.db    0x73,0x20
.db    0x65,0x6E
.db    0x74,0x65
.db    0x72,0x3A
.db    0xA0,0xAF
.db    0x21,0xD0
.db    0x01,0x23
.db    0xBE,0x20
.db    0xFC,0x2B
.db    0x2B,0x7E
.db    0xFE,0x20
.db    0x20,0xFA
.db    0x23,0x7E
.db    0xB7,0xCA
.db    0x2E,0x05
.db    0xCD,0x2C
.db    0x3B,0x18
.db    0xF5,0xFE
.db    0x3A,0xC8
.db    0xFE,0x3B
.db    0xC9,0x21
.db    0x01,0x00
.db    0x22,0x05
.db    0x11,0x3A
.db    0x23,0x16
.db    0xFE,0x33
.db    0xCA,0x47
.db    0x05,0xFE
.db    0x01,0x20
.db    0x08,0xCD
.db    0xEC,0x08
.db    0x28,0x57
.db    0xC3,0xBF
.db    0x08,0x2A
.db    0xEA,0x1E
.db    0x23,0x22
.db    0xEA,0x1E
.db    0xED,0x5B
.db    0x05,0x11
.db    0x1B,0x7A
.db    0xB3,0x20
.db    0x11,0x23
.db    0x36,0x01
.db    0x23,0x36
.db    0x31,0x23
.db    0x36,0x20
.db    0x23,0x77
.db    0x3E,0x4D
.db    0xFE,0x3F
.db    0x20,0x29
.db    0x3E,0x70
.db    0xFE,0x2A
.db    0x20,0x14
.db    0x2A,0xEA
.db    0x1E,0x23
.db    0x36,0x02
.db    0x23,0x36
.db    0x31,0x23
.db    0x36,0x2D
.db    0x23,0x36
.db    0x20,0x23
.db    0x36,0x00
.db    0x18,0x0F
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x73,0x65
.db    0x6C,0x65
.db    0x63,0x74
.db    0x3F,0xA0
.db    0xCD,0x2B
.db    0x38,0xCD
.db    0x48,0x0E
.db    0x2A,0xEA
.db    0x1E,0x23
.db    0x7E,0x2B
.db    0xB7,0x28
.db    0x4E,0x3E
.db    0x80,0x32
.db    0xDB,0x1E
.db    0x3A,0x23
.db    0x16,0xFE
.db    0x02,0xC2
.db    0x61,0x10
.db    0x3E,0x00
.db    0xB7,0xC2
.db    0xF8,0x0F
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x0D,0x64
.db    0x65,0x73
.db    0x74,0x69
.db    0x6E,0x61
.db    0x74,0x69
.db    0x6F,0x6E
.db    0x20,0x64
.db    0x72,0x69
.db    0x76,0x65
.db    0x20,0x61
.db    0x6E,0x64
.db    0x2F,0x6F
.db    0x72,0x20
.db    0x75,0x73
.db    0x65,0x72
.db    0x20,0xBA
.db    0x2A,0xEA
.db    0x1E,0xE5
.db    0x16,0x00
.db    0x3A,0x1D
.db    0x01,0x5F
.db    0x19,0x22
.db    0xEA,0x1E
.db    0xCD,0x2B
.db    0x38,0x2A
.db    0xEA,0x1E
.db    0x23,0x7E
.db    0xB7,0xCA
.db    0x2E,0x05
.db    0xCD,0xDB
.db    0x30,0x2B
.db    0xE5,0x23
.db    0x7E,0xCD
.db    0xD9,0x0E
.db    0x28,0x06
.db    0xB7,0x20
.db    0xF6,0x2B
.db    0x36,0x3A
.db    0xE1,0x23
.db    0x3A,0x57
.db    0x06,0x5F
.db    0xCD,0x82
.db    0x06,0xE1
.db    0x22,0xEA
.db    0x1E,0x3A
.db    0x57,0x06
.db    0xFE,0xFF
.db    0x20,0x08
.db    0x7B,0xFE
.db    0xFF,0x3A
.db    0xE8,0x0F
.db    0x28,0x05
.db    0xF6,0x80
.db    0x32,0xDB
.db    0x1E,0x3A
.db    0x50,0x06
.db    0xB7,0x28
.db    0x0A,0xF5
.db    0x3A,0xE8
.db    0x0F,0x32
.db    0x57,0x06
.db    0xF1,0x18
.db    0x15,0x3A
.db    0x57,0x06
.db    0x3C,0x3E
.db    0x80,0x32
.db    0x57,0x06
.db    0xCA,0x2E
.db    0x05,0x3A
.db    0x55,0x05
.db    0xB7,0x20
.db    0x03,0x3A
.db    0x5C,0x00
.db    0x32,0x2D
.db    0x3E,0x5F
.db    0x32,0x2D
.db    0x3E,0x5F
.db    0x21,0x5C
.db    0x00,0x56
.db    0x73,0xD5
.db    0xCD,0xA4
.db    0x31,0xD1
.db    0x3A,0x5E
.db    0x09,0xB7
.db    0xC2,0xC1
.db    0x32,0x72
.db    0x7A,0xBB
.db    0x20,0x68
.db    0x3A,0xF8
.db    0x11,0xB7
.db    0x20,0x62
.db    0x3A,0x9D
.db    0x11,0x5F
.db    0x3A,0xDB
.db    0x1E,0xBB
.db    0x20,0x1E
.db    0xCD,0xA7
.db    0x3A,0x03
.db    0x02,0x63
.db    0x6F,0x70
.db    0x79,0x20
.db    0x74,0x6F
.db    0x20,0x73
.db    0x61,0x6D
.db    0x65,0x20
.db    0x64,0x72
.db    0x69,0x76
.db    0xE5,0xAF
.db    0x32,0x5D
.db    0x0F,0xC3
.db    0x54,0x0F
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x28,0x43
.db    0x29,0x6F
.db    0x70,0x79
.db    0x20,0x6F
.db    0x72,0x20
.db    0x28,0x4D
.db    0x29,0x6F
.db    0x76,0x65
.db    0xBA,0xCD
.db    0x44,0x3A
.db    0x32,0x3F
.db    0x1E,0x18
.db    0x1D,0xF5
.db    0xAF,0x32
.db    0x2D,0x3E
.db    0x32,0xF8
.db    0x11,0xF1
.db    0xFE,0x04
.db    0x20,0x10
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x07,0x45
.db    0x52,0x41
.db    0x53,0xC5
.db    0xCD,0xB9
.db    0x1C,0xC2
.db    0x2E,0x05
.db    0xCD,0xA2
.db    0x3A,0xCD
.db    0x48,0x0E
.db    0x3A,0x23
.db    0x16,0xFE
.db    0x02,0x20
.db    0x03,0x32
.db    0x45,0x3B
.db    0x3A,0x2D
.db    0x3E,0xB7
.db    0x20,0x03
.db    0x3A,0x09
.db    0x3E,0xF5
.db    0xCD,0x6C
.db    0x34,0x2A
.db    0xEA,0x1E
.db    0x23,0x23
.db    0x22,0xB3
.db    0x10,0xAF
.db    0x6F,0x67
.db    0x32,0x12
.db    0x11,0x22
.db    0x1D,0x11
.db    0x22,0x5E
.db    0x11,0x22
.db    0x53,0x11
.db    0x21,0xC1
.db    0x3E,0xCD
.db    0xDC,0x30
.db    0x22,0xB3
.db    0x10,0xCA
.db    0x82,0x11
.db    0x11,0x00
.db    0x00,0xEB
.db    0x1A,0xD6
.db    0x30,0xA7
.db    0xFA,0xF3
.db    0x10,0xFE
.db    0x0A,0x3F
.db    0x38,0x14
.db    0x13,0x29
.db    0xE5,0x29
.db    0x29,0xC1
.db    0x09,0x4F
.db    0x06,0x00
.db    0x09,0x18
.db    0xE7,0x3E
.db    0xFF,0x32
.db    0xE3,0x10
.db    0x18,0xDC
.db    0x3E,0xFF
.db    0x3C,0xC8
.db    0xEB,0x23
.db    0x7E,0xB7
.db    0xCA,0x82
.db    0x11,0xFE
.db    0x20,0x20
.db    0xF6,0x18
.db    0xC2,0x3A
.db    0xE3,0x10
.db    0x3C,0xC8
.db    0x3A,0xDB
.db    0x1E,0xB7
.db    0xFA,0x00
.db    0x11,0xC0
.db    0xEB,0x1B
.db    0xE5,0xD5
.db    0x21,0x02
.db    0x00,0xCD
.db    0xDC,0x2C
.db    0xD1,0xE1
.db    0x22,0xB3
.db    0x10,0x38
.db    0xD6,0x3E
.db    0x00,0xFE
.db    0x2D,0x20
.db    0x09,0x13
.db    0xED,0x53
.db    0x5E,0x11
.db    0x11,0x00
.db    0x00,0x13
.db    0xCD,0xDC
.db    0x30,0x7E
.db    0x32,0x12
.db    0x11,0xFE
.db    0x2D,0x20
.db    0x10,0xCD
.db    0xDB,0x30
.db    0x22,0xB3
.db    0x10,0x20
.db    0x08,0xE5
.db    0x2A,0x05
.db    0x11,0x22
.db    0x5E,0x11
.db    0xE1,0xED
.db    0x53,0x1D
.db    0x11,0x13
.db    0x6B,0x62
.db    0x29,0xEB
.db    0x2A,0xEA
.db    0x0A,0x19
.db    0x5E,0x23
.db    0x56,0xEB
.db    0x23,0x7E
.db    0x2B,0xB6
.db    0x20,0x0B
.db    0x11,0x01
.db    0x00,0x13
.db    0xED,0x53
.db    0x53,0x11
.db    0x73,0x23
.db    0x72,0x21
.db    0x00,0x00
.db    0x7D,0xB4
.db    0xCA,0xB2
.db    0x10,0xEB
.db    0x2A,0x1D
.db    0x11,0x23
.db    0x22,0x1D
.db    0x11,0xE5
.db    0xCD,0xDC
.db    0x2C,0xE1
.db    0x5D,0x54
.db    0x38,0xC9
.db    0x2B,0x22
.db    0x1D,0x11
.db    0xED,0x62
.db    0x22,0x5E
.db    0x11,0xC3
.db    0xB2,0x10
.db    0x3A,0xDB
.db    0x1E,0xB7
.db    0xFA,0x8A
.db    0x11,0xC0
.db    0x21,0x00
.db    0x00,0x22
.db    0x12,0x1B
.db    0x2C,0x22
.db    0x05,0x11
.db    0x2A,0xEA
.db    0x0A,0x23
.db    0x23,0x22
.db    0xEA,0x1E
.db    0x3E,0x80
.db    0xB7,0xC4
.db    0xCB,0x34
.db    0x2A,0x0E
.db    0x03,0xCD
.db    0xA2,0x3A
.db    0x01,0x0D
.db    0x00,0x18
.db    0x01,0x09
.db    0x23,0x7E
.db    0x56,0x3C
.db    0xCA,0x2E
.db    0x05,0x2B
.db    0x5E,0xE5
.db    0x2A,0x05
.db    0x11,0xE5
.db    0xCD,0xDC
.db    0x2C,0x7C
.db    0xB5,0xD1
.db    0xE1,0x20
.db    0xE8,0x23
.db    0x77,0x2B
.db    0x77,0x13
.db    0xED,0x53
.db    0x05,0x11
.db    0x3A,0x2D
.db    0x3E,0xB7
.db    0x28,0x08
.db    0xCD,0xA8
.db    0x37,0x3E
.db    0x3D,0xCD
.db    0x2C,0x3B
.db    0x3A,0x5C
.db    0x00,0xCD
.db    0xA8,0x37
.db    0x11,0x0A
.db    0x3E,0x01
.db    0x2E,0x3E
.db    0x23,0x23
.db    0xCD,0xD5
.db    0x0C,0x2E
.db    0x18,0xAF
.db    0x02,0x12
.db    0x03,0x13
.db    0x2D,0x20
.db    0xF9,0x3E
.db    0x00,0xB7
.db    0x28,0x74
.db    0x21,0x2E
.db    0x3E,0x06
.db    0x0B,0x36
.db    0x3F,0x23
.db    0x10,0xFB
.db    0xCD,0xA7
.db    0x3A,0x09
.db    0x6E,0x65
.db    0x77,0x20
.db    0x6E,0x61
.db    0x6D,0x65
.db    0xBA,0xCD
.db    0x2B,0x38
.db    0x2A,0xEA
.db    0x1E,0x23
.db    0xCD,0xDB
.db    0x30,0x28
.db    0x21,0xCD
.db    0xAB,0x22
.db    0x20,0x16
.db    0xCD,0xA7
.db    0x3A,0x07
.db    0x20,0x69
.db    0x6C,0x6C
.db    0x65,0x67
.db    0x61,0x6C
.db    0x20,0x6E
.db    0x61,0x6D
.db    0x65,0x0D
.db    0x09,0x89
.db    0x18,0xCC
.db    0x01,0x2D
.db    0x3E,0xCD
.db    0x6C,0x22
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x20,0x20
.db    0x20,0x20
.db    0xA0,0x11
.db    0x0A,0x3E
.db    0x21,0x2E
.db    0x3E,0x06
.db    0x0B,0x7E
.db    0xFE,0x3F
.db    0x20,0x01
.db    0x1A,0xCD
.db    0x2C,0x3B
.db    0x4F,0x1A
.db    0xB7,0x79
.db    0xF2,0x63
.db    0x12,0xF6
.db    0x80,0x77
.db    0x13,0x23
.db    0x78,0xFE
.db    0x04,0x3E
.db    0x2E,0xCC
.db    0x2C,0x3B
.db    0x10,0xE1
.db    0x21,0x36
.db    0x3E,0x11
.db    0xF7,0x3D
.db    0x06,0x03
.db    0xCD,0xEE
.db    0x39,0x3A
.db    0x23,0x16
.db    0xFE,0x03
.db    0x28,0x0A
.db    0x3A,0x63
.db    0x01,0xB7
.db    0xC4,0xB9
.db    0x1C,0xC2
.db    0x9C,0x11
.db    0x3A,0x23
.db    0x16,0xFE
.db    0x09,0x20
.db    0x2C,0xF5
.db    0x3A,0x5C
.db    0x00,0x32
.db    0x09,0x3E
.db    0x3A,0x87
.db    0x14,0xB7
.db    0xFA,0xAC
.db    0x12,0xCD
.db    0xCB,0x34
.db    0x3A,0x9D
.db    0x11,0xE6
.db    0x7F,0x32
.db    0x87,0x14
.db    0x3A,0xC9
.db    0x08,0xB7
.db    0xFA,0xBE
.db    0x12,0xCD
.db    0xCB,0x34
.db    0x3A,0x50
.db    0x0F,0xE6
.db    0x7F,0x32
.db    0x87,0x14
.db    0xF1,0x11
.db    0x09,0x3E
.db    0xFE,0x17
.db    0xCA,0x56
.db    0x1A,0xFE
.db    0x0B,0xC4
.db    0xE0,0x33
.db    0x3A,0x2D
.db    0x3E,0xB7
.db    0xC2,0x35
.db    0x1D,0x67
.db    0x6F,0x32
.db    0x21,0x31
.db    0x22,0xE8
.db    0x1F,0x21
.db    0xF0,0x00
.db    0x22,0xB2
.db    0x1E,0xCD
.db    0xC6,0x33
.db    0x11,0x09
.db    0x3E,0x21
.db    0x12,0x3E
.db    0x3A,0x23
.db    0x16,0x4F
.db    0xFE,0x04
.db    0xCA,0x2C
.db    0x1B,0xFE
.db    0x0C,0xCA
.db    0xB0,0x14
.db    0xFE,0x0B
.db    0xCA,0x3C
.db    0x1C,0xFE
.db    0x03,0xCA
.db    0x5F,0x1B
.db    0xFE,0x10
.db    0xCA,0x11
.db    0x1D,0xFE
.db    0x13,0xCA
.db    0x27,0x1D
.db    0xFE,0x14
.db    0xCA,0x2B
.db    0x1D,0x23
.db    0xFE,0x12
.db    0xCA,0x27
.db    0x1D,0xFE
.db    0x11,0xCA
.db    0x2B,0x1D
.db    0xFE,0x09
.db    0xC2,0xA2
.db    0x14,0xD5
.db    0x3A,0x87
.db    0x14,0xFE
.db    0xFF,0x20
.db    0x07,0x3A
.db    0x57,0x06
.db    0xFE,0xFF
.db    0x28,0x0A
.db    0xF6,0x80
.db    0x32,0x9D
.db    0x11,0xE6
.db    0x7F,0x32
.db    0x87,0x14
.db    0xCD,0xA2
.db    0x3A,0xCD
.db    0x3C,0x1C
.db    0xD1,0xCD
.db    0xDD,0x34
.db    0xED,0x5B
.db    0x2A,0x3E
.db    0x2A,0xA5
.db    0x07,0x24
.db    0xD5,0xE5
.db    0xEB,0x21
.db    0x40,0x14
.db    0x3A,0x44
.db    0x26,0x32
.db    0x93,0x14
.db    0x06,0x5D
.db    0xCD,0xEE
.db    0x39,0xE1
.db    0xD1,0xE5
.db    0xD5,0x25
.db    0x25,0x0E
.db    0x80,0xCD
.db    0xDD,0x1C
.db    0xD1,0xCD
.db    0xDC,0x2C
.db    0xDA,0xC2
.db    0x30,0xAF
.db    0x32,0xB3
.db    0x1B,0xE1
.db    0x25,0xB6
.db    0xC4,0xDB
.db    0x30,0x28
.db    0x13,0x23
.db    0x7E,0x2B
.db    0xCD,0xD9
.db    0x0E,0x20
.db    0x0B,0x7E
.db    0xCD,0x4A
.db    0x3A,0xD6
.db    0x40,0x32
.db    0x96,0x13
.db    0x23,0x23
.db    0x3A,0xA6
.db    0x07,0x3C
.db    0x47,0x0E
.db    0x80,0x3E
.db    0x00,0x02
.db    0xCD,0x6C
.db    0x22,0xAF
.db    0x1E,0x05
.db    0x02,0x03
.db    0x1D,0x20
.db    0xFB,0xCD
.db    0xDB,0x30
.db    0x0B,0x23
.db    0x7E,0x2B
.db    0x28,0x0E
.db    0xCD,0xD9
.db    0x0E,0x20
.db    0x09,0x7E
.db    0xCD,0x4A
.db    0x3A,0xD6
.db    0x40,0x02
.db    0x23,0x23
.db    0xCD,0x6C
.db    0x22,0xAF
.db    0x1E,0x05
.db    0x02,0x03
.db    0x1D,0x20
.db    0xFB,0x21
.db    0x09,0x3E
.db    0x11,0x5C
.db    0x00,0xCD
.db    0xEC,0x39
.db    0x21,0xCB
.db    0x3D,0x11
.db    0x2D,0x3E
.db    0xD5,0xCD
.db    0xEC,0x39
.db    0xD1,0x3A
.db    0xF0,0x02
.db    0xB7,0xFA
.db    0x25,0x14
.db    0x20,0x03
.db    0x3A,0x44
.db    0x26,0x12
.db    0xD5,0x1E
.db    0xFF,0xCD
.db    0xCE,0x34
.db    0x32,0x1D
.db    0x14,0x3A
.db    0x87,0x14
.db    0xFE,0xFF
.db    0xC4,0xCB
.db    0x34,0xD1
.db    0xCD,0x1A
.db    0x33,0x20
.db    0x28,0xCD
.db    0xB0,0x33
.db    0x21,0xF0
.db    0x02,0x7E
.db    0xF5,0x54
.db    0x5D,0x06
.db    0xFF,0x23
.db    0x7E,0x04
.db    0xB7,0x20
.db    0xFA,0x78
.db    0x32,0xF0
.db    0x02,0xCD
.db    0xC9,0x33
.db    0xCD,0xB2
.db    0x37,0xCD
.db    0xFB,0x33
.db    0x3E,0x00
.db    0xCD,0xCB
.db    0x34,0xF1
.db    0x32,0xF0
.db    0x02,0x11
.db    0x5C,0x00
.db    0xCD,0xE0
.db    0x33,0x2A
.db    0xA5,0x07
.db    0x24,0x24
.db    0xF9,0x21
.db    0x00,0x00
.db    0xE5,0x2A
.db    0xA5,0x07
.db    0x24,0x11
.db    0x00,0x01
.db    0xCD,0x8B
.db    0x20,0xE9
.db    0xD5,0x0E
.db    0x1A,0xCD
.db    0x05,0x00
.db    0x11,0x5C
.db    0x00,0x0E
.db    0x14,0xCD
.db    0x05,0x00
.db    0xD1,0x21
.db    0x80,0x00
.db    0x19,0xEB
.db    0xB7,0x28
.db    0xE9,0x21
.db    0x00,0xA5
.db    0x2E,0x00
.db    0x25,0x25
.db    0x7E,0x11
.db    0x80,0x00
.db    0x12,0x3C
.db    0x47,0x23
.db    0x13,0x7E
.db    0x12,0x10
.db    0xFA,0xAF
.db    0x12,0x21
.db    0x00,0x00
.db    0x2E,0x80
.db    0x25,0x11
.db    0x5C,0x00
.db    0x06,0x24
.db    0x7E,0x12
.db    0x23,0x13
.db    0x10,0xFA
.db    0x11,0x80
.db    0x00,0x0E
.db    0x1A,0xCD
.db    0x05,0x00
.db    0x3E,0xFF
.db    0xFE,0x80
.db    0x30,0x06
.db    0x5F,0x0E
.db    0x20,0xCD
.db    0x05,0x00
.db    0x1E,0x00
.db    0x1D,0x0E
.db    0x0E,0xCD
.db    0x05,0x00
.db    0xC3,0x00
.db    0x01,0x3A
.db    0x00,0x3E
.db    0xB7,0xC9
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x8D,0x2A
.db    0xB2,0x1E
.db    0x7D,0xE6
.db    0x0F,0x32
.db    0x5E,0x16
.db    0x3A,0x23
.db    0x16,0xB7
.db    0xF2,0xBC
.db    0x14,0xE6
.db    0x7F,0xC3
.db    0x52,0x15
.db    0x11,0x09
.db    0x3E,0xCD
.db    0x1B,0x34
.db    0xB7,0xC2
.db    0xE0,0x1A
.db    0x3A,0x23
.db    0x16,0xFE
.db    0x05,0x28
.db    0x02,0xFE
.db    0x0C,0x28
.db    0x76,0x3A
.db    0x0C,0x01
.db    0xB7,0x28
.db    0x70,0x3A
.db    0x29,0x3E
.db    0x3D,0x6F
.db    0x26,0x00
.db    0x3A,0xFD
.db    0x3D,0x3C
.db    0x4F,0xCD
.db    0xDD,0x1C
.db    0x7B,0x32
.db    0x9F,0x34
.db    0x3A,0xFE
.db    0x3D,0x4F
.db    0x3A,0x15
.db    0x3E,0xA1
.db    0x4F,0x45
.db    0x21,0x19
.db    0x3E,0x28
.db    0x09,0x3E
.db    0x10,0xB7
.db    0x1F,0x0D
.db    0x20,0xFB
.db    0x80,0x47
.db    0x05,0xFA
.db    0x0F,0x15
.db    0x23,0xCD
.db    0x9D,0x14
.db    0x28,0xF6
.db    0x23,0x18
.db    0xF3,0x7E
.db    0x5E,0x32
.db    0x3C,0x36
.db    0xCD,0x9D
.db    0x14,0x57
.db    0x28,0x02
.db    0x23,0x56
.db    0x7A,0x32
.db    0x3D,0x36
.db    0xCD,0x95
.db    0x34,0xCD
.db    0x10,0x28
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x0D,0x8D
.db    0xCD,0xB1
.db    0x2A,0xCD
.db    0x2A,0x3B
.db    0x21,0x09
.db    0x3E,0x7E
.db    0xCD,0xA8
.db    0x37,0x23
.db    0xCD,0xD1
.db    0x0C,0xCD
.db    0x2A,0x3B
.db    0x7E,0xCD
.db    0x11,0x31
.db    0xCD,0xA2
.db    0x3A,0x21
.db    0x80,0x00
.db    0x3A,0x23
.db    0x16,0xFE
.db    0x0C,0xCA
.db    0xB1,0x16
.db    0xF5,0xFE
.db    0x06,0x28
.db    0x06,0xFE
.db    0x07,0x28
.db    0x02,0xFE
.db    0x08,0xCC
.db    0xC2,0x15
.db    0xF1,0xFE
.db    0x06,0xCA
.db    0xF9,0x15
.db    0xFE,0x07
.db    0xCA,0xF9
.db    0x15,0xFE
.db    0x08,0x28
.db    0x0C,0xFE
.db    0x05,0xCA
.db    0x6C,0x16
.db    0x3E,0x06
.db    0x32,0x23
.db    0x16,0x18
.db    0xD7,0x7E
.db    0xCD,0x61
.db    0x22,0x38
.db    0x71,0xCD
.db    0x7A,0x16
.db    0xCD,0x9E
.db    0x15,0x3A
.db    0x23,0x16
.db    0xE6,0x7F
.db    0xFE,0x06
.db    0x20,0xEB
.db    0x7D,0xE6
.db    0x0F,0x28
.db    0x61,0x3A
.db    0x18,0x01
.db    0x3D,0xCC
.db    0x2A,0x3B
.db    0x18,0xDD
.db    0x3A,0x23
.db    0x16,0xE6
.db    0x7F,0xFE
.db    0x06,0xC8
.db    0x3A,0x18
.db    0x01,0x3D
.db    0x28,0x12
.db    0xCD,0x2A
.db    0x3B,0x3A
.db    0x23,0x16
.db    0xE6,0x7F
.db    0xFE,0x07
.db    0x20,0x06
.db    0x7D,0xE6
.db    0x03,0xCC
.db    0x2A,0x3B
.db    0x7D,0xE6
.db    0x0F,0xC0
.db    0xCD,0xA2
.db    0x3A,0x3A
.db    0x23,0x16
.db    0xB7,0xF2
.db    0xD1,0x15
.db    0x22,0x3C
.db    0x2E,0x18
.db    0x0D,0xE5
.db    0x2A,0xB2
.db    0x1E,0xD5
.db    0x11,0x10
.db    0x00,0x19
.db    0xD1,0x22
.db    0xB2,0x1E
.db    0xCD,0x16
.db    0x31,0xAF
.db    0x32,0x21
.db    0x31,0xCD
.db    0xAB,0x37
.db    0xCD,0x2A
.db    0x3B,0x3A
.db    0x23,0x16
.db    0xB7,0xF8
.db    0xE1,0xC9
.db    0x3E,0x2E
.db    0x18,0x8B
.db    0xCD,0xC2
.db    0x15,0x7E
.db    0xE5,0xCD
.db    0x11,0x31
.db    0xE1,0x3A
.db    0x23,0x16
.db    0xE6,0x7F
.db    0xFE,0x06
.db    0x28,0x08
.db    0xCD,0x7D
.db    0x16,0xCD
.db    0x9E,0x15
.db    0x18,0xE9
.db    0x3A,0x18
.db    0x01,0x3D
.db    0x28,0x0B
.db    0x3C,0xCC
.db    0x2A,0x3B
.db    0x7D,0x3C
.db    0xE6,0x03
.db    0xCC,0x2A
.db    0x3B,0x23
.db    0x3E,0x1C
.db    0xB7,0xF2
.db    0x41,0x16
.db    0x1B,0x7A
.db    0xB3,0x20
.db    0x14,0xD5
.db    0x7D,0xE6
.db    0x0F,0x28
.db    0x13,0x7D
.db    0xEE,0x10
.db    0xE6,0x0F
.db    0x2F,0xE6
.db    0x0F,0x3C
.db    0x5F,0x19
.db    0xD1,0x18
.db    0x05,0x7D
.db    0xE6,0x0F
.db    0x20,0xB3
.db    0x3A,0x18
.db    0x01,0x3D
.db    0x20,0x09
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x2D,0x2D
.db    0x2D,0x2D
.db    0xBA,0xCD
.db    0x2A,0x3B
.db    0xD5,0x11
.db    0xF0,0xFF
.db    0x19,0x1E
.db    0x00,0xAF
.db    0x57,0x32
.db    0x5E,0x16
.db    0x19,0xD1
.db    0xC3,0x7B
.db    0x15,0xCD
.db    0x7A,0x16
.db    0x7E,0xFE
.db    0x1A,0x20
.db    0xF8,0x3A
.db    0x23,0x16
.db    0xB7,0xF2
.db    0x9C,0x11
.db    0x18,0x1B
.db    0xCD,0x2C
.db    0x3B,0x23
.db    0x3A,0x23
.db    0x16,0xB7
.db    0xF2,0x98
.db    0x16,0xE5
.db    0x2A,0xE8
.db    0x1F,0x2B
.db    0x22,0xE8
.db    0x1F,0x7C
.db    0xB5,0xEB
.db    0xE1,0xC0
.db    0x22,0x3C
.db    0x2E,0xC3
.db    0x2E,0x05
.db    0x3A,0xAB
.db    0x16,0xB7
.db    0x20,0x08
.db    0x3A,0x06
.db    0x01,0xFE
.db    0x0D,0xCA
.db    0xD5,0x1A
.db    0x7D,0xB7
.db    0xC0,0xE1
.db    0x3E,0x00
.db    0xB7,0xC0
.db    0xC3,0xB0
.db    0x14,0xED
.db    0x5B,0xE8
.db    0x1F,0x7B
.db    0x87,0xCB
.db    0x12,0x30
.db    0x0A,0x86
.db    0xEE,0x97
.db    0x5F,0x7A
.db    0xEE,0xA0
.db    0x57,0x18
.db    0x02,0x86
.db    0x5F,0x3A
.db    0x23,0x16
.db    0xB7,0x28
.db    0x04,0x2C
.db    0x20,0xE5
.db    0x2D,0xED
.db    0x53,0xE8
.db    0x1F,0xB7
.db    0xC8,0xCD
.db    0xF5,0x39
.db    0xCD,0x7D
.db    0x16,0x18
.db    0xD2,0xCD
.db    0xDC,0x30
.db    0xCD,0x4A
.db    0x3A,0x32
.db    0x74,0x17
.db    0xCD,0xA4
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0x03,0x05
.db    0x63,0x68
.db    0x65,0x63
.db    0x6B,0x73
.db    0x75,0x6D
.db    0x20,0x26
.db    0x20,0x74
.db    0x65,0x73
.db    0x74,0x8D
.db    0x3E,0x80
.db    0x32,0x50
.db    0x1F,0x3D
.db    0x32,0xBE
.db    0x17,0xCD
.db    0xC9,0x27
.db    0xEB,0x36
.db    0xFF,0x23
.db    0x22,0xCB
.db    0x17,0x11
.db    0x5C,0x00
.db    0x06,0x0B
.db    0x3A,0x0A
.db    0x01,0x13
.db    0x12,0x10
.db    0xFC,0x06
.db    0x15,0xAF
.db    0x32,0x45
.db    0x3B,0x13
.db    0x12,0x10
.db    0xFC,0x11
.db    0x5C,0x00
.db    0xCD,0x1D
.db    0x33,0x28
.db    0x20,0xCD
.db    0x86,0x31
.db    0x3A,0x8F
.db    0x0C,0xB7
.db    0xF2,0x4B
.db    0x17,0x3A
.db    0x65,0x00
.db    0xE6,0x7F
.db    0x32,0x65
.db    0x00,0x11
.db    0x5C,0x00
.db    0x0E,0x1E
.db    0xCD,0xD3
.db    0x34,0x11
.db    0x5C,0x00
.db    0xCD,0xC2
.db    0x33,0x3A
.db    0x0A,0x01
.db    0xEE,0x80
.db    0x32,0x65
.db    0x00,0x32
.db    0x66,0x00
.db    0xAF,0x32
.db    0x68,0x00
.db    0xCD,0xC9
.db    0x27,0xAF
.db    0x32,0x23
.db    0x16,0x67
.db    0x6F,0x22
.db    0xE8,0x1F
.db    0x22,0xB2
.db    0x1E,0x3C
.db    0x32,0xBE
.db    0x17,0x3E
.db    0x00,0xFE
.db    0x53,0x20
.db    0x07,0x22
.db    0x08,0x28
.db    0x23,0x22
.db    0x0E,0x28
.db    0xCD,0xC3
.db    0x2C,0x38
.db    0x38,0xCD
.db    0x07,0x28
.db    0x3E,0xFF
.db    0x32,0x21
.db    0x31,0x3A
.db    0x0C,0x01
.db    0xB7,0x28
.db    0x19,0x3E
.db    0x2A,0xF4
.db    0x2C,0x3B
.db    0xF2,0xAC
.db    0x17,0xCD
.db    0xB1,0x2A
.db    0x3E,0x0D
.db    0xCD,0x2C
.db    0x3B,0x3A
.db    0x8C,0x3B
.db    0xB7,0x3E
.db    0x0A,0xC4
.db    0x2C,0x3B
.db    0xCD,0x77
.db    0x35,0xCD
.db    0xF5,0x39
.db    0x21,0x80
.db    0x00,0xCD
.db    0xB1,0x16
.db    0xCD,0x84
.db    0x2A,0x30
.db    0xC3,0x3E
.db    0x00,0xB7
.db    0xF2,0x7B
.db    0x18,0xAF
.db    0x32,0xBE
.db    0x17,0x32
.db    0x28,0x18
.db    0x21,0x00
.db    0x00,0x22
.db    0x0D,0x18
.db    0xCD,0x9D
.db    0x14,0x3E
.db    0x08,0x20
.db    0x01,0x87
.db    0x32,0x2E
.db    0x18,0x2A
.db    0x0D,0x18
.db    0x7E,0x23
.db    0xB6,0xCA
.db    0x7B,0x18
.db    0x11,0x20
.db    0x00,0x2A
.db    0x0E,0x03
.db    0x7E,0xFE
.db    0xE5,0x28
.db    0x07,0x3C
.db    0xCA,0xC2
.db    0x37,0x19
.db    0x18,0xF4
.db    0xEB,0xD5
.db    0xAF,0x12
.db    0x13,0x21
.db    0x5D,0x00
.db    0x06,0x1F
.db    0xCD,0xEE
.db    0x39,0xD1
.db    0x21,0x10
.db    0x00,0x19
.db    0x22,0x39
.db    0x18,0xEB
.db    0x21,0x00
.db    0x00,0x4E
.db    0x23,0xCD
.db    0x9D,0x14
.db    0x28,0x03
.db    0x46,0x23
.db    0x78,0xB1
.db    0x28,0x37
.db    0xCD,0x9D
.db    0x14,0x79
.db    0x12,0x13
.db    0x28,0x03
.db    0x78,0x12
.db    0x13,0x3E
.db    0x00,0x3C
.db    0x32,0x28
.db    0x18,0xFE
.db    0x00,0x20
.db    0xDE,0x22
.db    0x0D,0x18
.db    0x3A,0xFE
.db    0x3D,0x4F
.db    0x21,0x00
.db    0x00,0x2B
.db    0x2B,0x2B
.db    0x2B,0x3A
.db    0x68,0x00
.db    0x81,0x77
.db    0x3C,0x32
.db    0x68,0x00
.db    0x23,0x23
.db    0x23,0x36
.db    0x80,0xAF
.db    0x32,0x28
.db    0x18,0x18
.db    0x88,0x3A
.db    0x28,0x18
.db    0x4F,0x3A
.db    0xFD,0x3D
.db    0x3C,0x47
.db    0x0D,0x28
.db    0x03,0x80
.db    0x18,0xFA
.db    0xFE,0x81
.db    0x38,0x02
.db    0xE6,0x7F
.db    0x2A,0x39
.db    0x18,0x2B
.db    0x77,0x2B
.db    0x2B,0x2B
.db    0x3A,0x68
.db    0x00,0x38
.db    0x05,0x4F
.db    0x3A,0xFE
.db    0x3D,0x89
.db    0x77,0x2A
.db    0xB2,0x1E
.db    0x7D,0xB4
.db    0x28,0x21
.db    0xAF,0x32
.db    0x50,0x1F
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x73,0x61
.db    0x76,0xE5
.db    0xCD,0xB9
.db    0x1C,0x20
.db    0x10,0x3E
.db    0x01,0x32
.db    0x50,0x1F
.db    0xCD,0xC9
.db    0x27,0x3E
.db    0xFF,0x32
.db    0xAF,0x31
.db    0xCD,0xA4
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0x0D,0x0D
.db    0x05,0x63
.db    0x68,0x65
.db    0x63,0x6B
.db    0x73,0x75
.db    0x6D,0x20
.db    0xA0,0x2A
.db    0xE8,0x1F
.db    0xCD,0x16
.db    0x31,0xAF
.db    0x32,0x21
.db    0x31,0x2A
.db    0xB2,0x1E
.db    0xCD,0x80
.db    0x30,0xCD
.db    0xA7,0x3A
.db    0x0D,0x62
.db    0x61,0x64
.db    0x20,0x62
.db    0x6C,0x6F
.db    0x63,0x6B
.db    0x73,0x20
.db    0x20,0x20
.db    0xA0,0xCD
.db    0x3A,0x31
.db    0x3A,0x50
.db    0x1F,0xB7
.db    0x28,0x52
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x0D,0x04
.db    0xA0,0x06
.db    0x08,0x3A
.db    0x0A,0x01
.db    0xCD,0x2C
.db    0x3B,0x10
.db    0xF8,0xF5
.db    0x3E,0x2E
.db    0xCD,0x2C
.db    0x3B,0xF1
.db    0xCD,0x2C
.db    0x3B,0xCD
.db    0x2C,0x3B
.db    0xCD,0x2C
.db    0x3B,0xCD
.db    0xA7,0x3A
.db    0x20,0x68
.db    0x61,0x73
.db    0x20,0x74
.db    0x68,0x65
.db    0x20,0x62
.db    0x61,0x64
.db    0x20,0x62
.db    0x6C,0x6F
.db    0x63,0x6B
.db    0x73,0x2E
.db    0x20,0x46
.db    0x69,0x6C
.db    0x65,0x20
.db    0x69,0x73
.db    0x20,0x73
.db    0x65,0x74
.db    0x20,0x74
.db    0x6F,0x20
.db    0x53,0x59
.db    0x53,0x20
.db    0x26,0x20
.db    0x52,0x2F
.db    0x4F,0xAE
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x0D,0x73
.db    0x68,0x6F
.db    0x77,0x20
.db    0x62,0x61
.db    0x64,0x20
.db    0x04,0xF3
.db    0xCD,0xB9
.db    0x1C,0xC2
.db    0xDD,0x19
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x0D,0x75
.db    0x73,0x65
.db    0x72,0x09
.db    0x04,0x09
.db    0x20,0x65
.db    0x78,0x74
.db    0x8D,0x2A
.db    0xEA,0x1E
.db    0x7E,0xFE
.db    0xE5,0x28
.db    0x4D,0x3C
.db    0x28,0x7B
.db    0x01,0x10
.db    0x00,0x09
.db    0xEB,0x2A
.db    0xCB,0x17
.db    0x3A,0x2E
.db    0x18,0x32
.db    0x92,0x19
.db    0x4E,0xCD
.db    0x9D,0x14
.db    0x28,0x04
.db    0x23,0x46
.db    0x78,0x2B
.db    0xB1,0x28
.db    0x2F,0x1A
.db    0x13,0xB9
.db    0x20,0x09
.db    0xCD,0x9D
.db    0x14,0x28
.db    0x31,0x1A
.db    0xB8,0x28
.db    0x2D,0xCD
.db    0x9D,0x14
.db    0x28,0x01
.db    0x13,0x3E
.db    0x00,0x3D
.db    0x32,0x92
.db    0x19,0x20
.db    0xD7,0x23
.db    0xCD,0x9D
.db    0x14,0x28
.db    0x01,0x23
.db    0xE5,0x2A
.db    0xEA,0x1E
.db    0x11,0x10
.db    0x00,0x19
.db    0xEB,0xE1
.db    0x18,0xBE
.db    0x2A,0xEA
.db    0x1E,0x11
.db    0x20,0x00
.db    0x19,0x22
.db    0xEA,0x1E
.db    0x18,0x9F
.db    0xCD,0x2A
.db    0x3B,0x2A
.db    0xEA,0x1E
.db    0x7E,0xE5
.db    0xCD,0xFB
.db    0x30,0xCD
.db    0x2A,0x3B
.db    0xE1,0xE5
.db    0x23,0xCD
.db    0xD1,0x0C
.db    0xCD,0x2A
.db    0x3B,0xE1
.db    0x11,0x0C
.db    0x00,0x19
.db    0x7E,0xCD
.db    0x11,0x31
.db    0xCD,0xA2
.db    0x3A,0x18
.db    0xCF,0xCD
.db    0xA7,0x3A
.db    0x0D,0x72
.db    0x65,0x70
.db    0x61,0x69
.db    0xF2,0xCD
.db    0xB9,0x1C
.db    0xC2,0x2E
.db    0x05,0x3E
.db    0x34,0x32
.db    0x23,0x16
.db    0x3A,0xFD
.db    0x3D,0x3C
.db    0x6F,0x26
.db    0x00,0x54
.db    0x22,0xE8
.db    0x1F,0x2A
.db    0xCB,0x17
.db    0x5E,0xCD
.db    0x9D,0x14
.db    0x28,0x02
.db    0x23,0x56
.db    0xCD,0x7A
.db    0x30,0xCD
.db    0x8D,0x34
.db    0xCD,0x07
.db    0x28,0xCD
.db    0x77,0x35
.db    0x2A,0xE8
.db    0x1F,0x2B
.db    0x22,0xE8
.db    0x1F,0x7D
.db    0xB4,0x28
.db    0x05,0xCD
.db    0x84,0x2A
.db    0x18,0xEA
.db    0x2A,0xCB
.db    0x17,0x23
.db    0xCD,0x9D
.db    0x14,0x28
.db    0x01,0x23
.db    0x22,0xCB
.db    0x17,0x18
.db    0xBF,0x21
.db    0x80,0x00
.db    0xCD,0x59
.db    0x35,0xCD
.db    0xA2,0x3A
.db    0xCD,0xB1
.db    0x2A,0x0E
.db    0x02,0xCD
.db    0xF2,0x35
.db    0xB7,0xCC
.db    0x7E,0x35
.db    0xB7,0xC8
.db    0xCD,0xA7
.db    0x3A,0x20
.db    0x02,0x72
.db    0x65,0x70
.db    0x61,0x69
.db    0xF2,0xC9
.db    0x3E,0x3F
.db    0x32,0x15
.db    0x3E,0x32
.db    0x17,0x3E
.db    0xCD,0x1D
.db    0x33,0xCD
.db    0x86,0x31
.db    0x11,0x0C
.db    0x00,0x19
.db    0xCD,0x2A
.db    0x3B,0x4E
.db    0x23,0x23
.db    0x5E,0x3A
.db    0xFD,0x3D
.db    0x3C,0xE5
.db    0x6F,0x26
.db    0x00,0x54
.db    0x44,0xC5
.db    0xCD,0x8C
.db    0x37,0xC1
.db    0x09,0xCD
.db    0x16,0x31
.db    0xE1,0xCD
.db    0xA7,0x3A
.db    0x3D,0xA0
.db    0x23,0xCD
.db    0x9D,0x14
.db    0x06,0x08
.db    0x20,0x02
.db    0x06,0x10
.db    0x23,0xCD
.db    0x9D,0x14
.db    0x28,0x11
.db    0x5E,0x23
.db    0x56,0x7B
.db    0xB2,0x28
.db    0x18,0xE5
.db    0xC5,0xEB
.db    0xCD,0x16
.db    0x31,0xC1
.db    0xE1,0x18
.db    0x09,0x7E
.db    0xB7,0x28
.db    0x0A,0xE5
.db    0xCD,0x11
.db    0x31,0xE1
.db    0xCD,0x2A
.db    0x3B,0x10
.db    0xDB,0xCD
.db    0xA8,0x33
.db    0xCA,0x9C
.db    0x11,0xF5
.db    0xCD,0xA2
.db    0x3A,0x06
.db    0x0E,0x3A
.db    0x63,0x01
.db    0xB7,0x28
.db    0x02,0x06
.db    0x19,0x3E
.db    0x20,0xCD
.db    0x2C,0x3B
.db    0x10,0xFB
.db    0xF1,0x18
.db    0x8C,0x2A
.db    0x0C,0x03
.db    0xF9,0xAF
.db    0x32,0xA2
.db    0x16,0xCD
.db    0x48,0x0E
.db    0x3A,0x23
.db    0x16,0xFE
.db    0x0C,0x28
.db    0x08,0xCD
.db    0xA7,0x3A
.db    0x0D,0x8D
.db    0xC3,0x9C
.db    0x11,0xCD
.db    0xA7,0x3A
.db    0x03,0x63
.db    0x68,0x65
.db    0x63,0x6B
.db    0x73,0x75
.db    0x6D,0x3A
.db    0xA0,0x2A
.db    0xE8,0x1F
.db    0xE5,0xCD
.db    0x16,0x31
.db    0xCD,0xA7
.db    0x3A,0x20
.db    0x20,0x74
.db    0x6F,0x74
.db    0x61,0x6C
.db    0x3A,0xA0
.db    0xD1,0x21
.db    0x00,0x00
.db    0x19,0x22
.db    0x12,0x1B
.db    0xE5,0xCD
.db    0x16,0x31
.db    0xCD,0xA7
.db    0x3A,0x20
.db    0x20,0x64
.db    0x65,0x63
.db    0x3A,0xA0
.db    0xE1,0xCD
.db    0x3A,0x31
.db    0x18,0xC0
.db    0x7E,0xB7
.db    0xFA,0xE8
.db    0x32,0xCD
.db    0xC2,0x33
.db    0x18,0xB6
.db    0x3A,0xB3
.db    0x1B,0xB7
.db    0xC2,0x28
.db    0x1E,0xCD
.db    0x2E,0x1E
.db    0x18,0x0F
.db    0xCD,0xA7
.db    0x3A,0x49
.db    0x6C,0x6C
.db    0x65,0x67
.db    0x61,0x6C
.db    0x20,0x6E
.db    0x61,0x6D
.db    0xE5,0xCD
.db    0xA2,0x3A
.db    0x21,0x09
.db    0x3E,0x7E
.db    0x23,0xCD
.db    0xA8,0x37
.db    0xCD,0xD1
.db    0x0C,0x3A
.db    0x12,0x3E
.db    0xB7,0xFA
.db    0xE8,0x32
.db    0xCD,0xA7
.db    0x3A,0x20
.db    0x3D,0xA0
.db    0x3A,0xB3
.db    0x1B,0xB7
.db    0x21,0x00
.db    0x00,0xFA
.db    0xA9,0x1B
.db    0xCD,0xA7
.db    0x3A,0x6E
.db    0x65,0x77
.db    0x20,0x6E
.db    0x61,0x6D
.db    0x65,0xBA
.db    0xCD,0x2B
.db    0x38,0x2A
.db    0xEA,0x1E
.db    0x23,0x7E
.db    0xB7,0xCA
.db    0x9C,0x11
.db    0xCD,0xA2
.db    0x3A,0xCD
.db    0xDB,0x30
.db    0xCD,0xAB
.db    0x22,0x32
.db    0xB3,0x1B
.db    0x20,0x0D
.db    0xCD,0xD9
.db    0x0E,0x20
.db    0xA1,0xCD
.db    0xDB,0x30
.db    0xCD,0xAB
.db    0x22,0x28
.db    0x99,0x22
.db    0x71,0x1B
.db    0x01,0x2D
.db    0x3E,0xCD
.db    0x6C,0x22
.db    0x3E,0x00
.db    0xFE,0x3A
.db    0x20,0x07
.db    0xF6,0x80
.db    0x32,0xB3
.db    0x1B,0x18
.db    0x95,0xB7
.db    0xFA,0xD4
.db    0x1B,0x21
.db    0x09,0x3E
.db    0x7E,0x23
.db    0xCD,0xA8
.db    0x37,0xCD
.db    0xD1,0x0C
.db    0xCD,0xA7
.db    0x3A,0x20
.db    0x3D,0xA0
.db    0x21,0x0A
.db    0x3E,0x11
.db    0x1A,0x3E
.db    0x06,0x0B
.db    0xD5,0xC5
.db    0xCD,0xEE
.db    0x39,0x21
.db    0x2E,0x3E
.db    0xC1,0xD1
.db    0x7E,0xFE
.db    0x3F,0x28
.db    0x0A,0x4F
.db    0x1A,0xB7
.db    0x79,0xF2
.db    0xF4,0x1B
.db    0xF6,0x80
.db    0x12,0x1A
.db    0xCD,0x2C
.db    0x3B,0x23
.db    0x13,0x78
.db    0xFE,0x04
.db    0x3E,0x2E
.db    0xCC,0x2C
.db    0x3B,0x10
.db    0xE1,0x11
.db    0x19,0x3E
.db    0x1A,0x32
.db    0x18,0x1C
.db    0x3A,0x09
.db    0x3E,0x12
.db    0xAF,0x32
.db    0x25,0x3E
.db    0xCD,0x1D
.db    0x33,0x3E
.db    0x00,0x12
.db    0xC2,0x36
.db    0x1B,0x3A
.db    0x63,0x01
.db    0xB7,0x28
.db    0x10,0xCD
.db    0xA7,0x3A
.db    0x20,0x20
.db    0x72,0x65
.db    0x6E,0x61
.db    0x6D,0xE5
.db    0xCD,0xB9
.db    0x1C,0x20
.db    0x06,0x11
.db    0x09,0x3E
.db    0xCD,0xDC
.db    0x33,0xC3
.db    0x9C,0x11
.db    0x11,0x09
.db    0x3E,0xCD
.db    0xDD,0x34
.db    0x3E,0x3F
.db    0x32,0x15
.db    0x3E,0x32
.db    0x15,0x3E
.db    0x0E,0x23
.db    0xCD,0xD3
.db    0x34,0x3A
.db    0x23,0x16
.db    0xFE,0x0B
.db    0xC0,0xCD
.db    0xA7,0x3A
.db    0x20,0xAD
.db    0x2A,0x2A
.db    0x3E,0xE5
.db    0xCD,0x3A
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0x20,0x81
.db    0xE1,0x0E
.db    0x08,0xCD
.db    0xDD,0x1C
.db    0x7B,0xB7
.db    0x28,0x01
.db    0x23,0xCD
.db    0xD1,0x26
.db    0x17,0x4F
.db    0xC5,0xCD
.db    0xDD,0x1C
.db    0xC1,0x7B
.db    0xB7,0x28
.db    0x01,0x23
.db    0x59,0x16
.db    0x00,0xCD
.db    0x8C,0x37
.db    0xE5,0x11
.db    0x08,0x00
.db    0xCD,0x8C
.db    0x37,0xED
.db    0x5B,0x2A
.db    0x3E,0xCD
.db    0xDC,0x2C
.db    0xCD,0x3A
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0x20,0x65
.db    0x6D,0x70
.db    0x74,0xF9
.db    0xD1,0xD5
.db    0x2A,0xB1
.db    0x1C,0x19
.db    0x22,0xB1
.db    0x1C,0xE1
.db    0xCD,0x86
.db    0x27,0xCD
.db    0x2A,0x3B
.db    0x21,0x00
.db    0x00,0xCD
.db    0x86,0x27
.db    0xC3,0x9C
.db    0x11,0xCD
.db    0x48,0x0E
.db    0xCD,0xA7
.db    0x3A,0x20
.db    0x28,0x59
.db    0x2F,0x4E
.db    0x29,0x20
.db    0xBF,0xCD
.db    0x44,0x3A
.db    0xFE,0x4E
.db    0x20,0x05
.db    0xCD,0xA7
.db    0x3A,0x6F
.db    0xA0,0xFE
.db    0x59,0xC0
.db    0xCD,0xA7
.db    0x3A,0x65
.db    0xF3,0xAF
.db    0xC9,0x11
.db    0x00,0x00
.db    0x42,0x79
.db    0xB7,0xC8
.db    0x3D,0xC8
.db    0xE5,0xED
.db    0x42,0x38
.db    0x05,0x13
.db    0xE3,0xE1
.db    0x18,0xF6
.db    0xE1,0xEB
.db    0xC9,0xCD
.db    0xA7,0x3A
.db    0x89,0x06
.db    0x0B,0x23
.db    0xCB,0x7E
.db    0x3E,0x2D
.db    0x28,0x02
.db    0x3E,0x49
.db    0xCD,0x2C
.db    0x3B,0x78
.db    0xFE,0x04
.db    0x3E,0x2E
.db    0xCC,0x2C
.db    0x3B,0x10
.db    0xEA,0x18
.db    0x21,0x21
.db    0x09,0x3E
.db    0x3A,0x15
.db    0x0A,0xB7
.db    0x28,0xD9
.db    0xF5,0xD5
.db    0xE6,0x0F
.db    0x5F,0x16
.db    0x00,0x19
.db    0xD1,0xF1
.db    0xFA,0x2B
.db    0x1D,0xCB
.db    0xFE,0x18
.db    0x02,0xCB
.db    0xBE,0x0E
.db    0x1E,0xCD
.db    0xD3,0x34
.db    0xC3,0x9C
.db    0x11,0x3A
.db    0x9D,0x11
.db    0xB7,0x3A
.db    0xDB,0x1E
.db    0xC4,0xCB
.db    0x34,0x11
.db    0x2D,0x3E
.db    0xCD,0x1D
.db    0x33,0xCA
.db    0x3E,0x1E
.db    0xCD,0x86
.db    0x31,0x3A
.db    0x8F,0x0C
.db    0xB7,0xFA
.db    0xE8,0x32
.db    0x3A,0x62
.db    0x01,0xB7
.db    0x28,0x36
.db    0xFE,0x02
.db    0xC2,0x24
.db    0x1E,0xCD
.db    0xA7,0x3A
.db    0x20,0x04
.db    0x20,0x65
.db    0x78,0x69
.db    0x73,0x74
.db    0x73,0x2C
.db    0x20,0x28
.db    0x42,0x29
.db    0x61,0x63
.db    0x6B,0x75
.db    0x70,0x2C
.db    0x20,0x28
.db    0x4F,0x29
.db    0x76,0x65
.db    0x72,0x77
.db    0x72,0x69
.db    0x74,0x65
.db    0x2C,0x20
.db    0x28,0x53
.db    0x29,0x6B
.db    0x69,0x70
.db    0xBA,0xCD
.db    0x44,0x3A
.db    0xFE,0x4F
.db    0xCA,0x3B
.db    0x1E,0xFE
.db    0x53,0x28
.db    0x9D,0xFE
.db    0x42,0x20
.db    0x99,0x21
.db    0x2E,0x3E
.db    0x11,0x3E
.db    0x3E,0x06
.db    0x08,0xCD
.db    0xEE,0x39
.db    0x3E,0x42
.db    0x12,0x13
.db    0x3E,0x41
.db    0x12,0x13
.db    0x3E,0x4B
.db    0x12,0x11
.db    0x3D,0x3E
.db    0x1A,0x32
.db    0x13,0x1E
.db    0x3A,0x2D
.db    0x3E,0x12
.db    0xCD,0x1A
.db    0x33,0x28
.db    0x53,0xD5
.db    0xCD,0x86
.db    0x31,0xD1
.db    0x3A,0x8F
.db    0x0C,0xB7
.db    0xF2,0xE2
.db    0x1D,0x3A
.db    0x62,0x01
.db    0xFE,0x02
.db    0xCC,0xA2
.db    0x3A,0xCD
.db    0xA7,0x3A
.db    0x20,0x6F
.db    0x6C,0x64
.db    0x20,0x2E
.db    0x42,0x41
.db    0xCB,0xC3
.db    0xE8,0x32
.db    0x3A,0x6E
.db    0x01,0xB7
.db    0x28,0x24
.db    0x3A,0x62
.db    0x01,0xFE
.db    0x02,0xCC
.db    0xA2,0x3A
.db    0xCD,0xA7
.db    0x3A,0x20
.db    0x6F,0x76
.db    0x65,0x72
.db    0x77,0x72
.db    0x69,0x74
.db    0x65,0x20
.db    0x6F,0x6C
.db    0x64,0x20
.db    0x2E,0x42
.db    0x41,0xCB
.db    0xCD,0xB9
.db    0x1C,0xC2
.db    0x9C,0x11
.db    0x11,0x3D
.db    0x3E,0xCD
.db    0xC2,0x33
.db    0x3E,0x00
.db    0x12,0xCD
.db    0xD9,0x33
.db    0x21,0x3E
.db    0x3E,0x06
.db    0x0B,0x36
.db    0x00,0x23
.db    0x10,0xFB
.db    0x18,0x1A
.db    0x3D,0xCA
.db    0x99,0x1D
.db    0xCD,0x2E
.db    0x1E,0xC3
.db    0x9C,0x11
.db    0xCD,0xA7
.db    0x3A,0x03
.db    0x04,0x20
.db    0x65,0x78
.db    0x69,0x73
.db    0x74,0xF3
.db    0xC9,0xCD
.db    0xBF,0x33
.db    0x3E,0x00
.db    0xFE,0x4D
.db    0xCA,0xF7
.db    0x1F,0x3E
.db    0x24,0x11
.db    0x36,0x3E
.db    0x12,0x13
.db    0x12,0x13
.db    0x12,0x11
.db    0x2D,0x3E
.db    0xCD,0x1A
.db    0x33,0x28
.db    0x28,0xD5
.db    0xCD,0x86
.db    0x31,0xD1
.db    0x3A,0x8F
.db    0x0C,0xB7
.db    0xF2,0x7F
.db    0x1E,0x3A
.db    0x62,0x01
.db    0xFE,0x02
.db    0xCC,0xA2
.db    0x3A,0xCD
.db    0xA7,0x3A
.db    0x20,0x6F
.db    0x6C,0x64
.db    0x20,0x74
.db    0x65,0x6D
.db    0x70,0x20
.db    0x2E,0x24
.db    0x24,0xA4
.db    0xC3,0xE8
.db    0x32,0xCD
.db    0xBF,0x33
.db    0xCD,0xB0
.db    0x33,0x3A
.db    0x67,0x01
.db    0xB7,0x11
.db    0x2D,0x3E
.db    0x0E,0x24
.db    0xC4,0x05
.db    0x00,0xAF
.db    0x32,0x50
.db    0x1F,0x67
.db    0x6F,0x22
.db    0xB2,0x1E
.db    0x22,0xE8
.db    0x1F,0x3A
.db    0x9D,0x11
.db    0xB7,0xC4
.db    0xCB,0x34
.db    0x3A,0x5C
.db    0x00,0xCD
.db    0x6C,0x34
.db    0xCD,0xF5
.db    0x39,0xED
.db    0x5B,0xEA
.db    0x1E,0x21
.db    0x00,0x1F
.db    0x19,0xE5
.db    0xEB,0xCD
.db    0xC9,0x33
.db    0xE1,0x3A
.db    0x59,0x14
.db    0x3D,0xBC
.db    0x28,0x18
.db    0x11,0x09
.db    0x3E,0xCD
.db    0x1B,0x34
.db    0xB7,0x20
.db    0x0C,0x2A
.db    0xB2,0x1E
.db    0x11,0x80
.db    0x00,0x19
.db    0x22,0xB2
.db    0x1E,0x18
.db    0xD3,0x32
.db    0x50,0x1F
.db    0x3E,0x00
.db    0xB7,0xC4
.db    0xCB,0x34
.db    0x3A,0x2D
.db    0x3E,0xCD
.db    0x6C,0x34
.db    0xCD,0xF5
.db    0x39,0x11
.db    0xAB,0x3E
.db    0x2A,0xE8
.db    0x1F,0x3A
.db    0xB3,0x1E
.db    0xBC,0x20
.db    0x04,0x3A
.db    0xB2,0x1E
.db    0xBD,0xC2
.db    0xE2,0x1F
.db    0x3A,0x67
.db    0x01,0xB7
.db    0x28,0x4D
.db    0xED,0x53
.db    0xE8,0x1F
.db    0x2A,0xB2
.db    0x1E,0x19
.db    0x22,0xB2
.db    0x1E,0xCD
.db    0xC6,0x33
.db    0xCD,0xF5
.db    0x39,0x11
.db    0x2D,0x3E
.db    0x0E,0x21
.db    0xCD,0xD3
.db    0x34,0xB7
.db    0x20,0x31
.db    0x2A,0xE8
.db    0x1F,0x11
.db    0x80,0x00
.db    0x1A,0xBE
.db    0xC2,0xD0
.db    0x1F,0x13
.db    0x23,0x7B
.db    0xB7,0x20
.db    0xF5,0x22
.db    0xE8,0x1F
.db    0xE5,0x2A
.db    0x4E,0x3E
.db    0x23,0x22
.db    0x4E,0x3E
.db    0xE1,0x3A
.db    0xB3,0x1E
.db    0xBC,0x20
.db    0xCF,0x3A
.db    0xB2,0x1E
.db    0xBD,0x20
.db    0xC9,0x11
.db    0x2D,0x3E
.db    0x0E,0x21
.db    0xCD,0xD3
.db    0x34,0x3E
.db    0x00,0xB7
.db    0xCA,0x91
.db    0x1E,0x3A
.db    0xDB,0x1E
.db    0xB7,0xFC
.db    0xCB,0x34
.db    0xCD,0xFB
.db    0x33,0x21
.db    0x2E,0x3E
.db    0x11,0x3E
.db    0x3E,0x06
.db    0x08,0xCD
.db    0xEE,0x39
.db    0x21,0xF7
.db    0x3D,0x06
.db    0x03,0xCD
.db    0xEE,0x39
.db    0x3A,0x6B
.db    0x01,0xB7
.db    0x28,0x0E
.db    0xFA,0x86
.db    0x1F,0xE6
.db    0x0F,0x21
.db    0x3E,0x3E
.db    0x5F,0x16
.db    0x00,0x19
.db    0xCB,0xFE
.db    0xCD,0xD9
.db    0x33,0x3A
.db    0x9D,0x11
.db    0xB7,0xC4
.db    0xCB,0x34
.db    0x3E,0x00
.db    0xB7,0x20
.db    0x14,0x3A
.db    0x6B,0x01
.db    0xB7,0xCA
.db    0x9C,0x11
.db    0xFA,0x9C
.db    0x11,0x11
.db    0x09,0x3E
.db    0x6F,0x26
.db    0x00,0x19
.db    0xC3,0x27
.db    0x1D,0x11
.db    0x09,0x3E
.db    0x3A,0x12
.db    0x3E,0xB7
.db    0xFA,0xB9
.db    0x1F,0xCD
.db    0xC2,0x33
.db    0xC3,0x9C
.db    0x11,0xCD
.db    0xA7,0x3A
.db    0x03,0x02
.db    0x64,0x65
.db    0x6C,0x65
.db    0x74,0x65
.db    0x20,0x73
.db    0x6F,0x75
.db    0x72,0x63
.db    0x65,0x20
.db    0x84,0xC3
.db    0xE8,0x32
.db    0xCD,0xA7
.db    0x3A,0x07
.db    0x03,0x76
.db    0x65,0x72
.db    0x69,0x66
.db    0x79,0x20
.db    0x65,0x72
.db    0x72,0x6F
.db    0x72,0x00
.db    0x19,0xEB
.db    0xCD,0xC9
.db    0x33,0x21
.db    0x3D,0x00
.db    0x11,0x80
.db    0x00,0x19
.db    0x22,0xE8
.db    0x1F,0xCD
.db    0xB2,0x37
.db    0xC3,0xE6
.db    0x1E,0x3A
.db    0x9D,0x11
.db    0xCD,0xCB
.db    0x34,0x3E
.db    0x3F,0x32
.db    0x15,0x3E
.db    0x32,0x17
.db    0x3E,0x11
.db    0x09,0x3E
.db    0xCD,0x1D
.db    0x33,0xCA
.db    0x9C,0x11
.db    0xCD,0x86
.db    0x31,0x3A
.db    0xDB,0x1E
.db    0xE6,0x7F
.db    0x77,0xCD
.db    0xB9,0x35
.db    0x3E,0xFF
.db    0x32,0xAF
.db    0x31,0x18
.db    0xE4,0xAF
.db    0x32,0x05
.db    0x06,0x3A
.db    0x6D,0x01
.db    0xB7,0x20
.db    0x24,0x3C
.db    0x32,0x5C
.db    0x00,0x32
.db    0xAF,0x31
.db    0xCD,0xA4
.db    0x31,0x3A
.db    0x50,0x06
.db    0xB7,0x28
.db    0x03,0x32
.db    0x55,0x05
.db    0xCD,0x8B
.db    0x20,0x3A
.db    0x6D,0x01
.db    0xB7,0x20
.db    0x08,0xCD
.db    0x57,0x20
.db    0x0E,0x00
.db    0xC3,0x05
.db    0x00,0xCD
.db    0x57,0x20
.db    0x2A,0x10
.db    0x01,0xF9
.db    0xC9,0x0E
.db    0x0B,0xCD
.db    0x05,0x00
.db    0xB7,0xC8
.db    0x0E,0x01
.db    0x18,0xEA
.db    0x11,0x68
.db    0x20,0xC3
.db    0x79,0x20
.db    0x43,0x50
.db    0x2F,0x4D
.db    0x20,0x32
.db    0x2E,0x78
.db    0x20,0x6F
.db    0x6E,0x6C
.db    0x79,0x24
.db    0x11,0x81
.db    0x20,0x0E
.db    0x09,0xCD
.db    0x05,0x00
.db    0xC3,0x41
.db    0x20,0x5A
.db    0x2D,0x38
.db    0x30,0x20
.db    0x6F,0x6E
.db    0x6C,0x79
.db    0x24,0x3A
.db    0x00,0x00
.db    0x4F,0x3A
.db    0x17,0x01
.db    0xB9,0x20
.db    0x05,0x3E
.db    0xC3,0x32
.db    0x00,0x00
.db    0x3A,0x9D
.db    0x11,0xE6
.db    0x7F,0x17
.db    0x17,0x17
.db    0x17,0x4F
.db    0x3A,0x55
.db    0x05,0xB7
.db    0x20,0x03
.db    0x3A,0x44
.db    0x26,0x3D
.db    0xB1,0x32
.db    0x04,0x00
.db    0xC9,0x11
.db    0x40,0x01
.db    0x18,0x0D
.db    0x11,0x48
.db    0x01,0x18
.db    0x08,0x11
.db    0x50,0x01
.db    0x18,0x03
.db    0x11,0x58
.db    0x01,0xEB
.db    0x18,0x2C
.db    0xCD,0x00
.db    0x21,0x22
.db    0xB2,0x1E
.db    0x2A,0x58
.db    0x14,0xE3
.db    0x21,0x00
.db    0x00,0xE5
.db    0x2A,0xB2
.db    0x1E,0xE5
.db    0xEB,0xE5
.db    0x11,0x81
.db    0x00,0x06
.db    0x00,0x7E
.db    0xB7,0x28
.db    0x06,0x12
.db    0x23,0x13
.db    0x04,0x20
.db    0xF6,0x78
.db    0x32,0x80
.db    0x00,0xE1
.db    0xC9,0xCD
.db    0x00,0x21
.db    0x22,0xB2
.db    0x1E,0x2A
.db    0x0C,0x03
.db    0xF9,0x21
.db    0x6A,0x04
.db    0x18,0xD5
.db    0xCD,0x33
.db    0x3D,0x11
.db    0x00,0x00
.db    0xEB,0x1A
.db    0xCD,0x4A
.db    0x3A,0xFE
.db    0x2C,0xC8
.db    0xFE,0x20
.db    0xC8,0xD6
.db    0x30,0x38
.db    0x0B,0xC6
.db    0xE9,0x38
.db    0x07,0xC6
.db    0x06,0xF2
.db    0x23,0x21
.db    0xC6,0x07
.db    0xDA,0x3E
.db    0x3D,0xC6
.db    0x0A,0xB7
.db    0x4F,0x06
.db    0x00,0x29
.db    0x29,0x29
.db    0x29,0x09
.db    0x13,0x18
.db    0xD6,0xCD
.db    0x00,0x21
.db    0xAF,0x32
.db    0x69,0x21
.db    0x32,0x59
.db    0x3B,0xE5
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x61,0x64
.db    0x64,0x72
.db    0x3A,0x48
.db    0x65,0x78
.db    0x20,0x44
.db    0x65,0x63
.db    0x20,0x20
.db    0x42,0x69
.db    0x6E,0x61
.db    0x72,0x79
.db    0x20,0x41
.db    0x73,0x63
.db    0x69,0x69
.db    0x20,0x45
.db    0x6E,0x74
.db    0x65,0xF2
.db    0xE1,0xCD
.db    0xA2,0x3A
.db    0xE5,0xCD
.db    0x16,0x31
.db    0x3E,0x00
.db    0xB7,0xF4
.db    0xAB,0x37
.db    0xF2,0x75
.db    0x21,0xCD
.db    0xA7,0x3A
.db    0xAD,0xCD
.db    0x2A,0x3B
.db    0xE1,0xE5
.db    0x7E,0x47
.db    0xCD,0x11
.db    0x31,0xCD
.db    0x2A,0x3B
.db    0x78,0xCD
.db    0x04,0x31
.db    0xCD,0x2A
.db    0x3B,0x78
.db    0xCD,0xE6
.db    0x30,0xCD
.db    0x2A,0x3B
.db    0x78,0xB7
.db    0x3E,0x20
.db    0xF2,0x99
.db    0x21,0x3E
.db    0x2D,0xCD
.db    0x2C,0x3B
.db    0x78,0xE6
.db    0x7F,0xFE
.db    0x20,0x38
.db    0x04,0xFE
.db    0x7F,0x38
.db    0x07,0xCD
.db    0x72,0x39
.db    0xC6,0x40
.db    0x18,0x05
.db    0xF5,0xCD
.db    0x2A,0x3B
.db    0xF1,0xCD
.db    0x2C,0x3B
.db    0xCD,0xA7
.db    0x3A,0x20
.db    0x20,0xBC
.db    0x3A,0x68
.db    0x01,0xCD
.db    0x2C,0x3B
.db    0xCD,0xA7
.db    0x3A,0xBE
.db    0xCD,0x2B
.db    0x38,0x2A
.db    0xEA,0x1E
.db    0x23,0xCD
.db    0xDB,0x30
.db    0x20,0x06
.db    0xE1,0xCD
.db    0x37,0x22
.db    0x18,0x89
.db    0x47,0x3A
.db    0x08,0x01
.db    0xB8,0x20
.db    0x24,0x23
.db    0x7E,0xCD
.db    0x4A,0x3A
.db    0xFE,0x42
.db    0x28,0x12
.db    0xFE,0x44
.db    0x28,0x0E
.db    0xFE,0x41
.db    0x28,0x0A
.db    0xFE,0x2E
.db    0xCA,0x2E
.db    0x05,0xFE
.db    0x48,0xC2
.db    0x3E,0x3D
.db    0x32,0x68
.db    0x01,0xCD
.db    0xDB,0x30
.db    0xCA,0x60
.db    0x21,0x22
.db    0xB3,0x10
.db    0x3A,0x68
.db    0x01,0xFE
.db    0x41,0x28
.db    0x33,0xFE
.db    0x42,0x28
.db    0x32,0xFE
.db    0x44,0x28
.db    0x44,0xCD
.db    0x00,0x21
.db    0x7C,0xB7
.db    0x20,0xDB
.db    0x7D,0xE1
.db    0x77,0xCD
.db    0x37,0x22
.db    0xEB,0x2A
.db    0xB3,0x10
.db    0x7E,0x23
.db    0xFE,0x20
.db    0x20,0xFA
.db    0xCD,0xDC
.db    0x30,0xEB
.db    0xCA,0x61
.db    0x21,0xE5
.db    0xEB,0x18
.db    0xA1,0x23
.db    0x3A,0x69
.db    0x21,0xB7
.db    0xF0,0x2B
.db    0x2B,0xC9
.db    0x6E,0x18
.db    0xD9,0x01
.db    0x00,0x08
.db    0x7E,0xFE
.db    0x30,0x28
.db    0x06,0xFE
.db    0x31,0xC2
.db    0x3E,0x3D
.db    0x37,0xCB
.db    0x11,0x23
.db    0x10,0xF0
.db    0x69,0x18
.db    0xC3,0xCD
.db    0xDB,0x10
.db    0xCD,0x3A
.db    0x3D,0x18
.db    0xBB,0xFE
.db    0x5F,0x28
.db    0x05,0xFE
.db    0x20,0xD8
.db    0xFE,0x7F
.db    0x3F,0xC9
.db    0x03,0x7E
.db    0xFE,0x2A
.db    0x20,0x07
.db    0x23,0x7E
.db    0xFE,0x2A
.db    0x28,0x01
.db    0x2B,0x32
.db    0x1B,0x0F
.db    0x1E,0x08
.db    0xCD,0x84
.db    0x22,0x23
.db    0x1E,0x03
.db    0x7E,0xFE
.db    0x2A,0x28
.db    0x30,0xFE
.db    0x2E,0x28
.db    0x1A,0xCD
.db    0xAB,0x22
.db    0x28,0x14
.db    0x57,0x3A
.db    0x6C,0x01
.db    0xB7,0x7A
.db    0xCC,0x4A
.db    0x3A,0x02
.db    0x1D,0x03
.db    0x23,0x20
.db    0xE3,0x7E
.db    0xFE,0x2E
.db    0x28,0x01
.db    0x2B,0x3E
.db    0x20,0x18
.db    0x17,0xFE
.db    0x20,0xC8
.db    0xFE,0x5B
.db    0xC8,0xFE
.db    0x5D,0xC8
.db    0xFE,0x3A
.db    0xC8,0xB7
.db    0xC9,0x23
.db    0x7E,0xFE
.db    0x2E,0x28
.db    0x01,0x2B
.db    0x3E,0x3F
.db    0x1C,0x1D
.db    0xC8,0x02
.db    0x03,0x18
.db    0xFA,0x3A
.db    0x61,0x01
.db    0xBB,0x38
.db    0x05,0x7B
.db    0xFE,0x10
.db    0x38,0x08
.db    0x3A,0xF9
.db    0x06,0xB7
.db    0x7B,0xCA
.db    0xFE,0x06
.db    0xFE,0x20
.db    0xD2,0x3E
.db    0x3D,0xC9
.db    0x3A,0x50
.db    0x06,0xB7
.db    0x28,0x03
.db    0x32,0x91
.db    0x01,0x3A
.db    0x57,0x06
.db    0xFE,0xFF
.db    0x28,0x13
.db    0x3A,0x9D
.db    0x11,0xE6
.db    0x7F,0x5F
.db    0x3A,0x90
.db    0x01,0xC6
.db    0x80,0x7B
.db    0x30,0x02
.db    0xF6,0x80
.db    0x32,0x90
.db    0x01,0xC3
.db    0x2E,0x05
.db    0xCD,0xA2
.db    0x3A,0xCD
.db    0x11,0x23
.db    0xC3,0x47
.db    0x05,0xCD
.db    0xDC,0x30
.db    0xCD,0x4A
.db    0x3A,0x32
.db    0x5E,0x23
.db    0xCD,0xA2
.db    0x3A,0x2A
.db    0x0E,0x03
.db    0x22,0xEA
.db    0x1E,0x21
.db    0x00,0x00
.db    0x22,0x05
.db    0x11,0x22
.db    0x75,0x0A
.db    0x11,0xCF
.db    0x01,0x2A
.db    0xEA,0x1E
.db    0x01,0x0B
.db    0x00,0x13
.db    0x1A,0xB7
.db    0xCA,0xC1
.db    0x23,0xFE
.db    0x20,0xCA
.db    0x35,0x23
.db    0xD5,0x1A
.db    0x13,0xB7
.db    0xF2,0x4D
.db    0x23,0xF5
.db    0x78,0xF6
.db    0x01,0x47
.db    0xF1,0xE6
.db    0x7F,0xFE
.db    0x7F,0x28
.db    0x20,0xFE
.db    0x20,0x28
.db    0x12,0x38
.db    0x04,0xFE
.db    0x61,0x38
.db    0xE4,0x3E
.db    0x53,0xFE
.db    0x3F,0x20
.db    0x10,0x78
.db    0xEE,0x80
.db    0x47,0x18
.db    0xD8,0x78
.db    0x1F,0x30
.db    0x0F,0x3A
.db    0xF9,0x06
.db    0xB7,0x20
.db    0x09,0xF1
.db    0x1A,0xFE
.db    0x20,0x28
.db    0xB6,0x13
.db    0x18,0xF8
.db    0xD1,0x36
.db    0x00,0x23
.db    0x36,0x00
.db    0x23,0x1A
.db    0xFE,0x20
.db    0x28,0x09
.db    0x1A,0xE6
.db    0x7F,0x77
.db    0x23,0x13
.db    0x0D,0x18
.db    0xF2,0x0D
.db    0xFA,0x9A
.db    0x23,0x36
.db    0x20,0x23
.db    0x18,0xF7
.db    0x78,0xB7
.db    0x28,0x16
.db    0x2B,0x2B
.db    0x78,0x1F
.db    0x30,0x06
.db    0x2B,0x7E
.db    0xEE,0x80
.db    0x77,0x23
.db    0x78,0x17
.db    0x30,0x04
.db    0x7E,0xEE
.db    0x80,0x77
.db    0x23,0x23
.db    0x22,0xEA
.db    0x1E,0x2A
.db    0x75,0x0A
.db    0x23,0x22
.db    0x75,0x0A
.db    0xC3,0x2F
.db    0x23,0x36
.db    0xFF,0x23
.db    0x36,0xFF
.db    0x3E,0x33
.db    0x32,0x23
.db    0x16,0xC3
.db    0x6B,0x0A
.db    0xCD,0xA2
.db    0x3A,0x3A
.db    0x62,0x01
.db    0xC6,0x41
.db    0xCD,0x2C
.db    0x3B,0xCD
.db    0xA7,0x3A
.db    0x09,0x69
.db    0x66,0x20
.db    0x04,0x20
.db    0x65,0x78
.db    0x69,0x73
.db    0x74,0x73
.db    0x20,0x41
.db    0x2D,0x6F
.db    0x76,0x65
.db    0x72,0x6C
.db    0x61,0x79
.db    0x2C,0x20
.db    0x42,0x2D
.db    0x62,0x61
.db    0x63,0x6B
.db    0x20,0x75
.db    0x70,0x2C
.db    0x20,0x43
.db    0x2D,0x61
.db    0x73,0x6B
.db    0x2C,0x20
.db    0x44,0x2D
.db    0x73,0x6B
.db    0x69,0x70
.db    0x8D,0x3A
.db    0x64,0x01
.db    0xF5,0xC6
.db    0x30,0xCD
.db    0x2C,0x3B
.db    0xCD,0xA7
.db    0x3A,0x09
.db    0x63,0x6F
.db    0x6C,0x75
.db    0x6D,0x6E
.db    0xF3,0xF1
.db    0x17,0x30
.db    0x0D,0xCD
.db    0xA7,0x3A
.db    0x20,0x2B
.db    0x31,0x20
.db    0x69,0x6E
.db    0x20,0x44
.db    0x49,0xD2
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0xD0,0x3A
.db    0x05,0x01
.db    0xED,0x44
.db    0xCD,0xA7
.db    0x26,0xCD
.db    0xA7,0x3A
.db    0x09,0x70
.db    0x61,0x67
.db    0x69,0x6E
.db    0x67,0x0D
.db    0xD2,0x3A
.db    0x63,0x01
.db    0xCD,0xA7
.db    0x26,0xCD
.db    0xA7,0x3A
.db    0x09,0x72
.db    0x65,0x71
.db    0x75,0x65
.db    0x73,0x74
.db    0x20,0x59
.db    0x2F,0x4E
.db    0x20,0x6F
.db    0x6E,0x20
.db    0x63,0x75
.db    0x72,0x72
.db    0x65,0x6E
.db    0x74,0x20
.db    0x04,0x09
.db    0x28,0x51
.db    0x2D,0x72
.db    0x65,0x71
.db    0x75,0x65
.db    0x73,0x74
.db    0x20,0x6E
.db    0x65,0x77
.db    0x20,0x6E
.db    0x61,0x6D
.db    0x65,0x29
.db    0x0D,0xD6
.db    0x3A,0x67
.db    0x01,0xCD
.db    0xA7,0x26
.db    0xCD,0xA7
.db    0x3A,0x09
.db    0x72,0x65
.db    0x61,0x64
.db    0x20,0x61
.db    0x66,0x74
.db    0x65,0x72
.db    0x20,0x77
.db    0x72,0x69
.db    0x74,0x65
.db    0x09,0x09
.db    0x28,0x5A
.db    0x2D,0x64
.db    0x65,0x6C
.db    0x65,0x74
.db    0x65,0x20
.db    0x73,0x6F
.db    0x75,0x72
.db    0x63,0x65
.db    0x20,0x04
.db    0x29,0x0D
.db    0xD3,0x3A
.db    0x65,0x01
.db    0xCD,0xA7
.db    0x26,0xCD
.db    0xA7,0x3A
.db    0x09,0x73
.db    0x68,0x6F
.db    0x77,0x20
.db    0x73,0x79
.db    0x73,0x74
.db    0x65,0x6D
.db    0x20,0x04
.db    0x73,0x0D
.db    0xD4,0x3A
.db    0x66,0x01
.db    0xCD,0xA7
.db    0x26,0xCD
.db    0xA7,0x3A
.db    0x09,0x73
.db    0x74,0x6F
.db    0x70,0x20
.db    0x69,0x66
.db    0x20,0x05
.db    0x69,0x73
.db    0x20,0x66
.db    0x75,0x6C
.db    0x6C,0x0D
.db    0xCD,0x3A
.db    0x6B,0x01
.db    0xB7,0x28
.db    0x01,0x2F
.db    0xCD,0xA7
.db    0x26,0xCD
.db    0xA7,0x3A
.db    0x09,0x6D
.db    0x61,0x72
.db    0x6B,0x20
.db    0x63,0x6F
.db    0x70,0x69
.db    0x65,0x64
.db    0x20,0x66
.db    0x69,0x6C
.db    0x65,0x73
.db    0x0D,0x58
.db    0x09,0x6C
.db    0x69,0x73
.db    0x74,0x20
.db    0x64,0x72
.db    0x69,0x76
.db    0x65,0x73
.db    0x20,0x18
.db    0x41,0xAD
.db    0x3A,0x60
.db    0x01,0x5F
.db    0x3A,0x7B
.db    0x36,0x57
.db    0xA3,0x7B
.db    0x20,0x02
.db    0x3E,0x10
.db    0xCD,0xAD
.db    0x37,0x7A
.db    0xA3,0x20
.db    0x0E,0xCD
.db    0xA7,0x3A
.db    0x20,0x69
.db    0x66,0x20
.db    0x6F,0x6E
.db    0x20,0x6C
.db    0x69,0x6E
.db    0xE5,0xCD
.db    0xA7,0x3A
.db    0x0D,0x55
.db    0x09,0x6C
.db    0x69,0x73
.db    0x74,0x20
.db    0x75,0x73
.db    0x65,0x72
.db    0x73,0x20
.db    0x20,0x18
.db    0x30,0xAD
.db    0x3A,0x61
.db    0x01,0xCD
.db    0xF7,0x30
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0xC6,0x3A
.db    0x90,0x01
.db    0x2F,0xCD
.db    0xA7,0x26
.db    0xCD,0xA7
.db    0x3A,0x09
.db    0x73,0x65
.db    0x61,0x72
.db    0x63,0x68
.db    0x20,0x64
.db    0x72,0x69
.db    0x76,0x65
.db    0xA0,0x3A
.db    0x91,0x01
.db    0xCD,0xA8
.db    0x37,0xCD
.db    0xA7,0x3A
.db    0x20,0x61
.db    0x6E,0x64
.db    0x20,0x75
.db    0x73,0x65
.db    0x72,0xA0
.db    0x3A,0x90
.db    0x01,0xE6
.db    0x7F,0xCD
.db    0xF7,0x30
.db    0xCD,0xA7
.db    0x3A,0x20
.db    0x74,0x6F
.db    0x20,0x72
.db    0x75,0x6E
.db    0x20,0x66
.db    0x69,0x6C
.db    0x65,0x0D
.db    0xA4,0x3A
.db    0xF0,0x02
.db    0x2F,0xCD
.db    0xA7,0x26
.db    0xCD,0xA7
.db    0x3A,0x09
.db    0x73,0x75
.db    0x62,0x6D
.db    0x69,0x74
.db    0xA0,0x21
.db    0xF0,0x02
.db    0x7E,0xB7
.db    0xF2,0xBF
.db    0x25,0xE6
.db    0x7F,0x20
.db    0x03,0x3A
.db    0x44,0x26
.db    0xCD,0xA8
.db    0x37,0xCD
.db    0xA7,0x3A
.db    0x24,0x24
.db    0x24,0x2E
.db    0x53,0x55
.db    0x42,0x83
.db    0x23,0x7E
.db    0xB7,0x28
.db    0x05,0xCD
.db    0x2C,0x3B
.db    0x18,0xF6
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x50,0x4F
.db    0x57,0x45
.db    0x52,0x89
.db    0x21,0x00
.db    0x01,0xCD
.db    0x16,0x31
.db    0xCD,0xA7
.db    0x3A,0x48
.db    0x83,0x3A
.db    0x1D,0x01
.db    0x6F,0x26
.db    0x00,0x29
.db    0xEB,0x13
.db    0x2A,0x0E
.db    0x03,0x19
.db    0xE5,0xCD
.db    0x16,0x31
.db    0xCD,0xA7
.db    0x3A,0x48
.db    0x0D,0x54
.db    0x50,0x41
.db    0x89,0xE1
.db    0x7D,0xB7
.db    0x11,0x80
.db    0x00,0x6A
.db    0x19,0xF2
.db    0x17,0x26
.db    0x19,0xE5
.db    0xCD,0x16
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0x48,0x83
.db    0x2A,0x58
.db    0x14,0x2B
.db    0xE5,0xCD
.db    0x16,0x31
.db    0xCD,0xA7
.db    0x3A,0x48
.db    0xA0,0xE1
.db    0x23,0xD1
.db    0xCD,0xDC
.db    0x2C,0x06
.db    0x07,0xCD
.db    0xD4,0x30
.db    0x10,0xFB
.db    0xCD,0x3A
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0x20,0x01
.db    0x00,0x3E
.db    0x01,0x32
.db    0x55,0x05
.db    0x0E,0x1D
.db    0xCD,0x05
.db    0x00,0xE5
.db    0x0E,0x18
.db    0xCD,0x05
.db    0x00,0xEB
.db    0xE1,0x01
.db    0x10,0x00
.db    0x0D,0xFA
.db    0x2E,0x05
.db    0x78,0xFE
.db    0x08,0x20
.db    0x02,0x6C
.db    0x5A,0x04
.db    0x7B,0x1F
.db    0x5F,0x30
.db    0x3A,0xE6
.db    0x7F,0xF5
.db    0xC5,0xD5
.db    0x78,0x32
.db    0x5C,0x00
.db    0xCD,0xA4
.db    0x31,0xCD
.db    0xA2,0x3A
.db    0xD1,0xC1
.db    0x78,0xCD
.db    0xA8,0x37
.db    0xCD,0xA7
.db    0x3A,0x18
.db    0x20,0x52
.db    0xAF,0x7D
.db    0x1F,0x6F
.db    0x3E,0x57
.db    0x30,0x02
.db    0x3E,0x4F
.db    0xCD,0x2C
.db    0x3B,0xCD
.db    0x2A,0x3B
.db    0xE5,0xD5
.db    0xC5,0xCD
.db    0xC0,0x26
.db    0xCD,0xD9
.db    0x26,0xC1
.db    0xD1,0xE1
.db    0xF1,0x18
.db    0xB5,0xCB
.db    0x1D,0x18
.db    0xB1,0xB7
.db    0x21,0x46
.db    0x46,0xF2
.db    0xB1,0x26
.db    0x21,0x4E
.db    0x20,0x22
.db    0xBB,0x26
.db    0xCD,0xA7
.db    0x3A,0x20
.db    0x28,0x18
.db    0x4F,0x4E
.db    0x20,0x17
.db    0xA9,0xC9
.db    0x2A,0xFF
.db    0x3D,0x23
.db    0xCD,0xD1
.db    0x26,0x28
.db    0x04,0x29
.db    0x3D,0x18
.db    0xFA,0x22
.db    0xE8,0x1F
.db    0xC9,0x3A
.db    0xFC,0x3D
.db    0xD6,0x03
.db    0xC0,0x37
.db    0xC9,0xCD
.db    0x59,0x0E
.db    0x38,0x26
.db    0x11,0xF7
.db    0x3D,0xCD
.db    0xC9,0x33
.db    0x0E,0x2E
.db    0x3A,0x5C
.db    0x00,0x3D
.db    0x5F,0xCD
.db    0x05,0x00
.db    0xCD,0xC0
.db    0x26,0x2A
.db    0xE8,0x1F
.db    0x22,0xB2
.db    0x1E,0x2A
.db    0xF7,0x3D
.db    0x0E,0x08
.db    0xCD,0xDD
.db    0x1C,0x22
.db    0xB2,0x1E
.db    0x18,0x3D
.db    0x21,0x00
.db    0x00,0x22
.db    0xB2,0x1E
.db    0x2A,0xFF
.db    0x3D,0x23
.db    0xEB,0x0E
.db    0x1B,0xD5
.db    0xCD,0x05
.db    0x00,0xD1
.db    0x06,0x08
.db    0x7E,0x07
.db    0x38,0x09
.db    0xE5,0x2A
.db    0xB2,0x1E
.db    0x23,0x22
.db    0xB2,0x1E
.db    0xE1,0xF5
.db    0x1B,0x7A
.db    0xB3,0x28
.db    0x06,0xF1
.db    0x10,0xEB
.db    0x23,0x18
.db    0xE5,0xF1
.db    0xCD,0xD1
.db    0x26,0x28
.db    0x0A,0x2A
.db    0xB2,0x1E
.db    0x29,0x22
.db    0xB2,0x1E
.db    0x3D,0x18
.db    0xF4,0xCD
.db    0xA7,0x3A
.db    0x55,0x73
.db    0x65,0x64
.db    0xBA,0xED
.db    0x5B,0xB2
.db    0x1E,0x2A
.db    0xE8,0x1F
.db    0xCD,0xDC
.db    0x2C,0xE5
.db    0x2A,0x01
.db    0x3E,0x23
.db    0x0E,0x20
.db    0xCD,0xDD
.db    0x1C,0xEB
.db    0xE1,0xCD
.db    0xDC,0x2C
.db    0xCD,0x86
.db    0x27,0xCD
.db    0xA7,0x3A
.db    0x2C,0x20
.db    0x46,0x72
.db    0x65,0x65
.db    0xBA,0x2A
.db    0xB2,0x1E
.db    0xCD,0x86
.db    0x27,0xCD
.db    0xA7,0x3A
.db    0x2C,0x20
.db    0x43,0x61
.db    0x70,0x61
.db    0x63,0x69
.db    0x74,0x79
.db    0xBA,0x2A
.db    0xE8,0x1F
.db    0xCD,0x3A
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0xCB,0xC9
.db    0xCD,0xDC
.db    0x30,0x28
.db    0x06,0x01
.db    0x09,0x3E
.db    0xCD,0x6C
.db    0x22,0xCD
.db    0xA7,0x3A
.db    0x03,0x64
.db    0x65,0x6C
.db    0x65,0x74
.db    0x65,0x64
.db    0x20,0x04
.db    0x73,0x09
.db    0x09,0x3C
.db    0x47,0x72
.db    0x6F,0x75
.db    0x70,0x20
.db    0x43,0x6F
.db    0x6E,0x66
.db    0x6C,0x69
.db    0x63,0x74
.db    0x3E,0x0D
.db    0x8D,0x11
.db    0x5C,0x00
.db    0xCD,0x1D
.db    0x33,0xCD
.db    0xA4,0x31
.db    0x3E,0x02
.db    0x32,0xE7
.db    0x35,0x2A
.db    0x07,0x3E
.db    0x22,0x08
.db    0x28,0x21
.db    0x01,0x00
.db    0x22,0x0E
.db    0x28,0x2A
.db    0x01,0x3E
.db    0x23,0xCD
.db    0xD4,0x30
.db    0xCD,0xD4
.db    0x30,0x44
.db    0x4D,0x2A
.db    0xEA,0x1E
.db    0xEB,0xC5
.db    0xD5,0x42
.db    0x4B,0x3A
.db    0x59,0x14
.db    0x3D,0x3D
.db    0xBA,0xDA
.db    0xC2,0x30
.db    0xCD,0xC9
.db    0x33,0xCD
.db    0x07,0x28
.db    0x3A,0x50
.db    0x1F,0x3D
.db    0x20,0x6E
.db    0x3D,0x32
.db    0xAF,0x31
.db    0xCD,0xB9
.db    0x35,0x18
.db    0x68,0x11
.db    0x00,0x00
.db    0xCD,0x2D
.db    0x34,0x11
.db    0x01,0x00
.db    0xE5,0xD5
.db    0x2A,0x07
.db    0x3E,0xEB
.db    0x22,0x0E
.db    0x28,0x2A
.db    0x08,0x28
.db    0xCD,0xDC
.db    0x2C,0xC1
.db    0x60,0x69
.db    0x30,0x08
.db    0x3E,0x01
.db    0xB7,0x20
.db    0x14,0x2B
.db    0x18,0x11
.db    0x21,0x00
.db    0x00,0xEB
.db    0x0B,0x3E
.db    0x10,0xCD
.db    0x30,0xBB
.db    0x3A,0xFB
.db    0x3D,0xB7
.db    0x20,0x01
.db    0x67,0x22
.db    0x24,0x32
.db    0x44,0x4D
.db    0xCD,0x59
.db    0x0E,0x38
.db    0x19,0x3E
.db    0x00,0xB7
.db    0x28,0x14
.db    0x3A,0xFD
.db    0x3D,0x3C
.db    0x4F,0x2A
.db    0x0E,0x28
.db    0x2B,0xCD
.db    0xDD,0x1C
.db    0x7B,0x32
.db    0x7F,0x35
.db    0x44,0x4D
.db    0x18,0x05
.db    0x3E,0xFF
.db    0x32,0x7F
.db    0x35,0x3E
.db    0x0B,0xCD
.db    0x21,0xBB
.db    0xE1,0xC9
.db    0xCD,0x77
.db    0x35,0xCD
.db    0x84,0x2A
.db    0xD1,0xC1
.db    0x21,0x80
.db    0x00,0x19
.db    0xEB,0x0B
.db    0x78,0xB1
.db    0xC2,0xE5
.db    0x27,0xD5
.db    0xCD,0xC6
.db    0x33,0xD1
.db    0x3A,0x50
.db    0x1F,0xB7
.db    0xC0,0xED
.db    0x4B,0x01
.db    0x3E,0x2A
.db    0xEA,0x1E
.db    0x11,0x20
.db    0x00,0x7E
.db    0xFE,0xE5
.db    0x23,0xC2
.db    0x76,0x2A
.db    0x23,0xBE
.db    0x28,0x01
.db    0xA6,0x2B
.db    0x2B,0xCA
.db    0x76,0x2A
.db    0x23,0xC5
.db    0xD5,0xE5
.db    0x11,0x0A
.db    0x3E,0x06
.db    0x0B,0xEB
.db    0x7E,0xFE
.db    0x3F,0x28
.db    0x07,0x1A
.db    0xE6,0x7F
.db    0xBE,0xC2
.db    0x73,0x2A
.db    0x13,0x23
.db    0x10,0xF0
.db    0xE1,0xD1
.db    0xC1,0x3A
.db    0x5C,0x00
.db    0xCD,0xA8
.db    0x37,0x5D
.db    0x54,0xC5
.db    0xD5,0xE5
.db    0xCD,0xD1
.db    0x0C,0xD1
.db    0xD5,0x1B
.db    0xD5,0x1A
.db    0x32,0x50
.db    0x1F,0x3A
.db    0x5C,0x00
.db    0xCD,0x6C
.db    0x34,0x12
.db    0xD5,0x21
.db    0x0C,0x00
.db    0x19,0x7E
.db    0x32,0x8F
.db    0x0C,0x36
.db    0x00,0x23
.db    0x23,0x7E
.db    0x32,0xF8
.db    0x28,0x36
.db    0x00,0xD1
.db    0xE5,0xCD
.db    0x1D,0x33
.db    0xE1,0x36
.db    0x00,0x2B
.db    0x2B,0x3A
.db    0x8F,0x0C
.db    0x77,0x3A
.db    0x50,0x1F
.db    0xD1,0x12
.db    0x28,0x19
.db    0xCD,0xA7
.db    0x3A,0x03
.db    0x02,0x72
.db    0x65,0x63
.db    0x6F,0x76
.db    0x65,0x72
.db    0x2C,0x20
.db    0x04,0x20
.db    0x65,0x78
.db    0x69,0x73
.db    0x74,0xF3
.db    0xC3,0x70
.db    0x2A,0x3A
.db    0xFE,0x3D
.db    0x4F,0x3A
.db    0x8F,0x0C
.db    0xB9,0x28
.db    0x29,0x81
.db    0xB9,0x28
.db    0x25,0xCD
.db    0xA7,0x3A
.db    0x03,0x02
.db    0x72,0x65
.db    0x63,0x6F
.db    0x76,0x65
.db    0x72,0x2C
.db    0x20,0x04
.db    0x20,0x77
.db    0x69,0x74
.db    0x68,0x20
.db    0x69,0x6C
.db    0x6C,0x65
.db    0x67,0x61
.db    0x6C,0x20
.db    0x65,0x78
.db    0x74,0x65
.db    0x6E,0xF4
.db    0x18,0xCA
.db    0xCD,0xA7
.db    0x3A,0x03
.db    0x72,0x65
.db    0x63,0x6F
.db    0x76,0x65
.db    0xF2,0xCD
.db    0xB9,0x1C
.db    0x20,0xBA
.db    0x32,0x0D
.db    0x2A,0xE1
.db    0xD1,0xC1
.db    0xC5,0xD5
.db    0xE5,0x2B
.db    0x22,0xE8
.db    0x1F,0x3A
.db    0x9D,0x11
.db    0xE6,0x7F
.db    0x77,0xE5
.db    0x11,0x09
.db    0x00,0x19
.db    0xCB,0xFE
.db    0x23,0x23
.db    0x23,0x7E
.db    0x32,0x8F
.db    0x0C,0x23
.db    0x23,0x7E
.db    0x32,0xF8
.db    0x28,0x23
.db    0xE5,0xD5
.db    0xC5,0xCD
.db    0x59,0x0E
.db    0x30,0x68
.db    0xE5,0x0E
.db    0x1B,0xCD
.db    0x05,0x00
.db    0xD1,0x13
.db    0xCD,0x9D
.db    0x14,0x3E
.db    0x08,0x20
.db    0x01,0x87
.db    0x32,0xA6
.db    0x29,0x3E
.db    0x00,0x3D
.db    0x32,0xA6
.db    0x29,0xFA
.db    0xFA,0x29
.db    0x1A,0x4F
.db    0xCD,0x9D
.db    0x14,0x47
.db    0x28,0x03
.db    0x13,0x1A
.db    0x47,0x13
.db    0x78,0xB1
.db    0x28,0x3C
.db    0xE5,0xD5
.db    0x69,0x60
.db    0x22,0xE7
.db    0x29,0x0E
.db    0x08,0xCD
.db    0xDD,0x1C
.db    0x4D,0x44
.db    0x7B,0xD1
.db    0xE1,0xE5
.db    0x09,0x4F
.db    0x3E,0x80
.db    0x0D,0xFA
.db    0xDB,0x29
.db    0x0F,0x18
.db    0xF9,0xB6
.db    0xBE,0x77
.db    0xE1,0x20
.db    0xC4,0xE5
.db    0xD5,0xCD
.db    0x2A,0x3B
.db    0x21,0x00
.db    0x00,0xCD
.db    0x9D,0x14
.db    0x28,0x05
.db    0xCD,0x16
.db    0x31,0x18
.db    0x03,0xCD
.db    0x11,0x31
.db    0xD1,0xE1
.db    0x18,0xAB
.db    0xC1,0xD1
.db    0xE1,0x7E
.db    0xFE,0x80
.db    0xE1,0x20
.db    0x5D,0x11
.db    0x20,0x00
.db    0x19,0x0B
.db    0x78,0xB1
.db    0x20,0x10
.db    0x3E,0x00
.db    0xB7,0x20
.db    0x4F,0x2F
.db    0x32,0x0D
.db    0x2A,0xED
.db    0x4B,0x01
.db    0x3E,0x2A
.db    0xEA,0x1E
.db    0x7E,0xFE
.db    0xE5,0x20
.db    0xE2,0x22
.db    0xB2,0x1E
.db    0xEB,0x2A
.db    0xE8,0x1F
.db    0xC5,0x0E
.db    0x0B,0x23
.db    0x13,0x1A
.db    0xBE,0x28
.db    0x05,0xF6
.db    0x80,0xBE
.db    0x20,0x23
.db    0x0D,0x20
.db    0xF2,0x23
.db    0x23,0x23
.db    0x3A,0xF8
.db    0x28,0x96
.db    0xFA,0x5F
.db    0x2A,0x20
.db    0x09,0x2B
.db    0x2B,0x3A
.db    0x8F,0x0C
.db    0x96,0xFA
.db    0x5F,0x2A
.db    0x2A,0xB2
.db    0x1E,0x79
.db    0x32,0x0D
.db    0x2A,0xC1
.db    0xC3,0x6F
.db    0x29,0xC1
.db    0x2A,0xB2
.db    0x1E,0x18
.db    0xA4,0xC1
.db    0x3E,0x01
.db    0x32,0x50
.db    0x1F,0xCD
.db    0xC9,0x27
.db    0x3E,0x80
.db    0x32,0x50
.db    0x1F,0xCD
.db    0xC9,0x27
.db    0xCD,0xA2
.db    0x3A,0xE1
.db    0xD1,0xC1
.db    0x2B,0x11
.db    0x20,0x00
.db    0x19,0x0B
.db    0x78,0xB1
.db    0xC2,0x93
.db    0x28,0xC3
.db    0x2E,0x05
.db    0xE5,0xD5
.db    0xED,0x5B
.db    0x0E,0x28
.db    0x13,0x2A
.db    0xFA,0x3D
.db    0xCD,0xDC
.db    0x2C,0xEB
.db    0x30,0x17
.db    0xED,0x5B
.db    0x08,0x28
.db    0x13,0x2A
.db    0x2F,0x34
.db    0xCD,0xDC
.db    0x2C,0x30
.db    0x03,0x11
.db    0x00,0x00
.db    0xED,0x53
.db    0x08,0x28
.db    0x21,0x01
.db    0x00,0x22
.db    0x0E,0x28
.db    0xD1,0xE1
.db    0xC9,0xE5
.db    0xCD,0x5F
.db    0x37,0xCD
.db    0xA7,0x3A
.db    0x47,0xBD
.db    0xED,0x5B
.db    0x07,0x3E
.db    0x2A,0x08
.db    0x28,0xCD
.db    0xDC,0x2C
.db    0x38,0x11
.db    0x2A,0x3C
.db    0x36,0xCD
.db    0x16,0x31
.db    0xCD,0xAB
.db    0x37,0x3A
.db    0x9F,0x34
.db    0xCD,0x11
.db    0x31,0x18
.db    0x0A,0xCD
.db    0xA7,0x3A
.db    0x2D,0x2D
.db    0x2D,0x2D
.db    0x3A,0x2D
.db    0xAD,0xCD
.db    0xA7,0x3A
.db    0x20,0x54
.db    0xBD,0x4F
.db    0x2A,0x08
.db    0x28,0xCD
.db    0x42,0x31
.db    0xCD,0xA7
.db    0x3A,0x20
.db    0x53,0xBD
.db    0x2A,0x0E
.db    0x28,0xCD
.db    0x48,0x31
.db    0xCD,0xA7
.db    0x3A,0x20
.db    0x50,0x53
.db    0xBD,0x2A
.db    0x24,0x32
.db    0xCD,0x48
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0x20,0x52
.db    0x65,0x63
.db    0xA3,0x21
.db    0x00,0x00
.db    0x23,0x22
.db    0x10,0x2B
.db    0xCD,0x3A
.db    0x31,0xE1
.db    0xC9,0x3A
.db    0x23,0x16
.db    0xFE,0x20
.db    0x3E,0x1E
.db    0x28,0x02
.db    0x3E,0x1F
.db    0x32,0x23
.db    0x16,0xCD
.db    0xA4,0x31
.db    0xCD,0x00
.db    0x21,0xCD
.db    0x3A,0x3D
.db    0xEB,0xE5
.db    0x2A,0xFF
.db    0x3D,0xCD
.db    0xDC,0x2C
.db    0xCD,0x8D
.db    0x34,0x21
.db    0x01,0x00
.db    0x22,0xE8
.db    0x1F,0x18
.db    0x28,0xCD
.db    0xA4,0x31
.db    0xCD,0x33
.db    0x3D,0xCD
.db    0xDB,0x10
.db    0xCD,0x3A
.db    0x3D,0x22
.db    0x08,0x28
.db    0x21,0x01
.db    0x00,0x22
.db    0xE8,0x1F
.db    0xEB,0xCD
.db    0x34,0x3D
.db    0xCD,0xDB
.db    0x10,0xCD
.db    0x3A,0x3D
.db    0xD5,0x22
.db    0x0E,0x28
.db    0x7D,0xB4
.db    0xCA,0xE0
.db    0x2C,0xE1
.db    0xCD,0xDB
.db    0x30,0x28
.db    0x5A,0x3A
.db    0x23,0x16
.db    0xFE,0x1E
.db    0x20,0x36
.db    0x7E,0xCD
.db    0x4A,0x3A
.db    0xFE,0x58
.db    0x20,0x2E
.db    0x3E,0x06
.db    0x32,0xAB
.db    0x16,0x23
.db    0x7E,0xCD
.db    0x4A,0x3A
.db    0xFE,0x20
.db    0x28,0x11
.db    0xFE,0x41
.db    0x20,0x04
.db    0x3E,0x08
.db    0x18,0x06
.db    0xFE,0x48
.db    0x20,0x05
.db    0x3E,0x07
.db    0x32,0xAB
.db    0x16,0xE5
.db    0x21,0x80
.db    0x00,0x22
.db    0xB2,0x1E
.db    0xE1,0xCD
.db    0xDB,0x30
.db    0x20,0x11
.db    0x18,0x23
.db    0xCD,0x00
.db    0x21,0xCD
.db    0x3A,0x3D
.db    0x22,0xB2
.db    0x1E,0xEB
.db    0xCD,0xDB
.db    0x30,0x28
.db    0x14,0xCD
.db    0xDB,0x10
.db    0xCD,0x3A
.db    0x3D,0x22
.db    0xE8,0x1F
.db    0xCD,0x80
.db    0x30,0x18
.db    0x06,0x21
.db    0x80,0x00
.db    0x22,0xB2
.db    0x1E,0x2A
.db    0xE8,0x1F
.db    0x3A,0x19
.db    0x01,0x3D
.db    0xFE,0xFF
.db    0x20,0x04
.db    0x3A,0xFC
.db    0x3D,0x3C
.db    0x5F,0x4F
.db    0x16,0x00
.db    0xCD,0xDC
.db    0x2C,0x3E
.db    0x03,0xDE
.db    0x01,0x32
.db    0xE7,0x35
.db    0x79,0x32
.db    0xB7,0x2C
.db    0xED,0x5B
.db    0xB2,0x1E
.db    0xCD,0xC9
.db    0x33,0xCD
.db    0xC3,0x2C
.db    0x38,0x17
.db    0xCD,0x07
.db    0x28,0x2A
.db    0xE8,0x1F
.db    0x2B,0x7D
.db    0xB4,0x28
.db    0x0C,0x3A
.db    0xAB,0x16
.db    0xB7,0x20
.db    0x06,0x3A
.db    0x0C,0x01
.db    0xB7,0x28
.db    0x20,0xCD
.db    0xA2,0x3A
.db    0xCD,0xB1
.db    0x2A,0xCD
.db    0xA7,0x3A
.db    0x20,0x41
.db    0x74,0xBA
.db    0x2A,0xB2
.db    0x1E,0xE5
.db    0xCD,0x16
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0xAD,0xE1
.db    0x11,0x7F
.db    0x00,0x19
.db    0xCD,0x16
.db    0x31,0xCD
.db    0xC3,0x2C
.db    0xDA,0xE0
.db    0x2C,0x3A
.db    0x23,0x16
.db    0xB7,0xCA
.db    0xE0,0x2C
.db    0xFE,0x1E
.db    0xF5,0xCC
.db    0x77,0x35
.db    0xF1,0xC4
.db    0xB9,0x35
.db    0x3A,0x23
.db    0x16,0xF5
.db    0x2A,0xB2
.db    0x1E,0xE5
.db    0x21,0x70
.db    0x00,0x22
.db    0xB2,0x1E
.db    0x21,0x80
.db    0x00,0x7D
.db    0xE6,0x0F
.db    0x32,0x5E
.db    0x16,0x3A
.db    0xAB,0x16
.db    0x32,0x23
.db    0x16,0xB7
.db    0x28,0x18
.db    0xF5,0x3A
.db    0x0C,0x01
.db    0xB7,0xF5
.db    0xC4,0xA2
.db    0x3A,0xCD
.db    0x4A,0x15
.db    0xF1,0x28
.db    0x05,0xCD
.db    0xA7,0x3A
.db    0x0D,0x8D
.db    0xF1,0xED
.db    0x62,0xE3
.db    0xE1,0x22
.db    0xB2,0x1E
.db    0xF1,0x32
.db    0x23,0x16
.db    0x2A,0xB2
.db    0x1E,0x11
.db    0x80,0x00
.db    0x19,0x22
.db    0xB2,0x1E
.db    0x2A,0xE8
.db    0x1F,0x2B
.db    0x22,0xE8
.db    0x1F,0xCD
.db    0x80,0x30
.db    0xCD,0x84
.db    0x2A,0x30
.db    0x0F,0xAF
.db    0x32,0x23
.db    0x16,0x67
.db    0x3A,0x25
.db    0x28,0x6F
.db    0x22,0x24
.db    0x32,0xC3
.db    0x17,0x2C
.db    0x3E,0x00
.db    0x3D,0x32
.db    0xB7,0x2C
.db    0xB7,0xCA
.db    0xD3,0x2B
.db    0xC3,0xF4
.db    0x2B,0xED
.db    0x5B,0x08
.db    0x28,0x2A
.db    0x2F,0x34
.db    0xCD,0xDC
.db    0x2C,0xD8
.db    0x7D,0xB4
.db    0xED,0x5B
.db    0x0E,0x28
.db    0x2A,0xFA
.db    0x3D,0x20
.db    0x03,0x21
.db    0x28,0x00
.db    0xAF,0xED
.db    0x52,0xC9
.db    0xCD,0xA7
.db    0x3A,0x07
.db    0x03,0x4F
.db    0x75,0x74
.db    0x20,0x6F
.db    0x66,0x20
.db    0x05,0x62
.db    0x6F,0x75
.db    0x6E,0x64
.db    0x73,0x00
.db    0xCD,0x84
.db    0x30,0x2A
.db    0xB2,0x1E
.db    0xE5,0xCD
.db    0x57,0x2D
.db    0xCD,0x33
.db    0x2D,0xCD
.db    0xA7,0x3A
.db    0x20,0x4C
.db    0x61,0x73
.db    0x74,0x20
.db    0x41,0x64
.db    0x64,0x72
.db    0x65,0x73
.db    0x73,0xBA
.db    0x2A,0xB2
.db    0x1E,0xD1
.db    0x7C,0xBA
.db    0x20,0x04
.db    0x7D,0xBB
.db    0x28,0x01
.db    0x2B,0xCD
.db    0x16,0x31
.db    0xCD,0xA7
.db    0x3A,0x48
.db    0xA0,0x2A
.db    0x2A,0x3E
.db    0xCD,0x3A
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0x20,0x01
.db    0x00,0x11
.db    0x5C,0x00
.db    0xCD,0xE0
.db    0x33,0xED
.db    0x5B,0xB2
.db    0x1E,0xCD
.db    0xC9,0x33
.db    0x11,0x5C
.db    0x00,0xCD
.db    0x1B,0x34
.db    0x3D,0xC8
.db    0x2A,0xB2
.db    0x1E,0x11
.db    0x80,0x00
.db    0x19,0x22
.db    0xB2,0x1E
.db    0x18,0xE5
.db    0xCD,0x84
.db    0x30,0x21
.db    0x5C,0x00
.db    0x11,0x2D
.db    0x3E,0xD5
.db    0xCD,0xEC
.db    0x39,0xE1
.db    0xE5,0x11
.db    0x09,0x3E
.db    0xCD,0xEC
.db    0x39,0xD1
.db    0xCD,0x1D
.db    0x33,0x20
.db    0x0A,0x3A
.db    0x23,0x16
.db    0xFE,0x1C
.db    0xC2,0xE9
.db    0x33,0x18
.db    0x2C,0xD5
.db    0xCD,0x86
.db    0x31,0xD1
.db    0xCD,0x3C
.db    0x1C,0x3A
.db    0x23,0x16
.db    0xFE,0x1C
.db    0xC0,0x3A
.db    0x8F,0x0C
.db    0xB7,0xF2
.db    0x93,0x2D
.db    0xCD,0xEE
.db    0x32,0x18
.db    0x41,0x2A
.db    0xE8,0x1F
.db    0x23,0x7D
.db    0xB4,0x20
.db    0x07,0x2A
.db    0x2A,0x3E
.db    0x23,0x22
.db    0xE8,0x1F
.db    0xCD,0xBF
.db    0x33,0x2A
.db    0xE8,0x1F
.db    0x23,0x7D
.db    0xB4,0xCA
.db    0x3E,0x3D
.db    0xCD,0xB0
.db    0x33,0x2A
.db    0xE8,0x1F
.db    0x2B,0x22
.db    0xE8,0x1F
.db    0x7D,0xB4
.db    0x28,0x15
.db    0xED,0x5B
.db    0xB2,0x1E
.db    0xD5,0xCD
.db    0xC9,0x33
.db    0xE1,0x11
.db    0x80,0x00
.db    0x19,0x22
.db    0xB2,0x1E
.db    0xCD,0xB2
.db    0x37,0x18
.db    0xE0,0xCD
.db    0xFB,0x33
.db    0xC3,0x2E
.db    0x05,0xCD
.db    0x84,0x30
.db    0xED,0x53
.db    0xE8,0x1F
.db    0x2A,0x0C
.db    0x03,0xF9
.db    0x21,0x65
.db    0x04,0xE5
.db    0x2A,0xB2
.db    0x1E,0xE5
.db    0xCD,0x33
.db    0x2D,0x2A
.db    0xE8,0x1F
.db    0xC9,0xCD
.db    0x91,0x2E
.db    0xCD,0x80
.db    0x30,0xE5
.db    0x2A,0xE8
.db    0x1F,0x78
.db    0xBC,0x38
.db    0x16,0x20
.db    0x04,0x79
.db    0xBD,0x38
.db    0x10,0xD1
.db    0x19,0xE5
.db    0x60,0x69
.db    0x19,0xD5
.db    0x54,0x5D
.db    0xC1,0xE1
.db    0x03,0xED
.db    0xB8,0x18
.db    0x08,0xD1
.db    0x13,0xD5
.db    0x59,0x50
.db    0xC1,0xED
.db    0xB0,0xC3
.db    0x2E,0x05
.db    0xCD,0xDC
.db    0x30,0x28
.db    0x13,0xFE
.db    0x2C,0x20
.db    0x1F,0xCD
.db    0xDB,0x30
.db    0x28,0x0A
.db    0xCD,0x00
.db    0x21,0x2B
.db    0xEB,0x2A
.db    0x3C,0x2E
.db    0x18,0x50
.db    0x11,0x70
.db    0x00,0x21
.db    0x00,0x00
.db    0x7D,0xE6
.db    0x0F,0x2F
.db    0xE6,0x0F
.db    0x83,0x5F
.db    0x18,0x40
.db    0xCD,0x00
.db    0x21,0x22
.db    0xE8,0x1F
.db    0xEB,0xFE
.db    0x2C,0x28
.db    0x14,0xD5
.db    0xCD,0xDC
.db    0x30,0xD1
.db    0x28,0x09
.db    0xFE,0x2C
.db    0x28,0x09
.db    0xCD,0x9B
.db    0x2E,0x18
.db    0x21,0xED
.db    0x62,0x18
.db    0x1D,0xCD
.db    0xDB,0x30
.db    0x28,0x06
.db    0xCD,0x00
.db    0x21,0x2B
.db    0x18,0x12
.db    0x21,0x70
.db    0x00,0x3A
.db    0xE8,0x1F
.db    0xE6,0x0F
.db    0x2F,0xE6
.db    0x0F,0x85
.db    0x6F,0x18
.db    0x03,0xCD
.db    0x91,0x2E
.db    0xEB,0x2A
.db    0xE8,0x1F
.db    0x22,0xB2
.db    0x1E,0x13
.db    0xED,0x53
.db    0xE8,0x1F
.db    0xC9,0xCD
.db    0x00,0x21
.db    0x22,0xE8
.db    0x1F,0xEB
.db    0xCD,0x34
.db    0x3D,0xCD
.db    0x00,0x21
.db    0x22,0xB2
.db    0x1E,0xEB
.db    0x3A,0x23
.db    0x16,0xFE
.db    0x26,0x28
.db    0x08,0xFE
.db    0x28,0x28
.db    0x04,0xFE
.db    0x27,0x20
.db    0x06,0xCD
.db    0x34,0x3D
.db    0xCD,0x00
.db    0x21,0xE5
.db    0xC1,0x2A
.db    0xB2,0x1E
.db    0xE5,0xED
.db    0x5B,0xE8
.db    0x1F,0xCD
.db    0xDC,0x2C
.db    0xD1,0xDA
.db    0x3E,0x3D
.db    0xC9,0xCD
.db    0x20,0x2E
.db    0x3E,0x85
.db    0x18,0x13
.db    0xCD,0x20
.db    0x2E,0x3E
.db    0x88,0x18
.db    0x0C,0xCD
.db    0x20,0x2E
.db    0x3E,0x86
.db    0x18,0x05
.db    0xCD,0x20
.db    0x2E,0x3E
.db    0x87,0x32
.db    0x23,0x16
.db    0xC3,0xA7
.db    0x14,0xCD
.db    0x81,0x2E
.db    0xAF,0x32
.db    0x50,0x1F
.db    0x2A,0x0E
.db    0x03,0x22
.db    0xEA,0x1E
.db    0x60,0x69
.db    0xCD,0x33
.db    0x3D,0x3A
.db    0x50,0x1F
.db    0xB7,0xF4
.db    0xDC,0x30
.db    0x28,0x60
.db    0xF2,0x0E
.db    0x2F,0x23
.db    0x7E,0x2B
.db    0xB7,0x28
.db    0x57,0x7E
.db    0x4F,0xFE
.db    0x22,0x28
.db    0x47,0x06
.db    0x00,0xFE
.db    0x3F,0x28
.db    0x18,0x3A
.db    0x50,0x1F
.db    0xB7,0xFA
.db    0x3D,0x2F
.db    0xCD,0x00
.db    0x21,0x7C
.db    0xB7,0xC2
.db    0x3E,0x3D
.db    0xCD,0x3A
.db    0x3D,0x4D
.db    0xEB,0x06
.db    0x80,0x18
.db    0x0C,0x06
.db    0x3F,0x3A
.db    0x50,0x1F
.db    0xB7,0xFA
.db    0x3D,0x2F
.db    0x06,0xBF
.db    0x23,0xE5
.db    0x2A,0xEA
.db    0x1E,0x71
.db    0x24,0x70
.db    0x23,0x70
.db    0x25,0x22
.db    0xEA,0x1E
.db    0xE1,0x3A
.db    0x50,0x1F
.db    0xB7,0xFA
.db    0x61,0x2F
.db    0x7E,0xFE
.db    0x20,0x28
.db    0xA4,0x23
.db    0x18,0xF8
.db    0x3A,0x50
.db    0x1F,0x2F
.db    0x32,0x50
.db    0x1F,0x23
.db    0x18,0x97
.db    0xED,0x5B
.db    0x0E,0x03
.db    0x2A,0xEA
.db    0x1E,0x42
.db    0x4B,0xCD
.db    0xDC,0x2C
.db    0xEB,0x2A
.db    0xB2,0x1E
.db    0xE5,0x2A
.db    0xE8,0x1F
.db    0x2B,0x22
.db    0xE8,0x1F
.db    0x23,0xD5
.db    0x7C,0xB5
.db    0xC4,0xDC
.db    0x2C,0xDA
.db    0x2E,0x05
.db    0xD1,0xE1
.db    0x0A,0xBE
.db    0x28,0x09
.db    0x04,0x0A
.db    0xE6,0x7F
.db    0x05,0xFE
.db    0x3F,0x20
.db    0x1A,0xE5
.db    0xD5,0xC5
.db    0x23,0x03
.db    0x1B,0x7A
.db    0xB3,0x28
.db    0x1B,0x0A
.db    0xBE,0x28
.db    0xF5,0x04
.db    0x0A,0x05
.db    0xE6,0x7F
.db    0xFE,0x3F
.db    0x28,0xEC
.db    0xC1,0xD1
.db    0xE1,0x23
.db    0xE5,0x2A
.db    0xE8,0x1F
.db    0xCD,0x80
.db    0x30,0xE1
.db    0x18,0xBA
.db    0xC1,0xD1
.db    0xE1,0xCD
.db    0xA2,0x3A
.db    0xCD,0x16
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0x3A,0xA0
.db    0xE5,0xD5
.db    0xC5,0x04
.db    0x0A,0xB7
.db    0xFA,0xD5
.db    0x2F,0xCD
.db    0xA7,0x3A
.db    0xA2,0x0A
.db    0xB7,0x7E
.db    0xF2,0xE5
.db    0x2F,0xE5
.db    0xCD,0x11
.db    0x31,0xCD
.db    0x2A,0x3B
.db    0xE1,0x18
.db    0x19,0xCD
.db    0x61,0x22
.db    0x30,0x11
.db    0xF5,0xCD
.db    0xA7,0x3A
.db    0xBC,0xF1
.db    0xE5,0xCD
.db    0x11,0x31
.db    0xE1,0xCD
.db    0xA7,0x3A
.db    0xBE,0x18
.db    0x03,0xCD
.db    0x2C,0x3B
.db    0x23,0xD5
.db    0x0A,0x07
.db    0xE6,0x01
.db    0x5F,0x03
.db    0x0A,0x07
.db    0xE6,0x01
.db    0xAB,0x28
.db    0x09,0xCD
.db    0xA7,0x3A
.db    0xA2,0x0A
.db    0xB7,0xFC
.db    0x2A,0x3B
.db    0xD1,0x1B
.db    0x7A,0xB3
.db    0x20,0xB9
.db    0x0A,0xB7
.db    0xFA,0x25
.db    0x30,0xCD
.db    0xA7,0x3A
.db    0xA2,0xC1
.db    0xD1,0xE1
.db    0x18,0x85
.db    0xCD,0x91
.db    0x2E,0xCD
.db    0x80,0x30
.db    0x23,0xEB
.db    0x2A,0xE8
.db    0x1F,0x0A
.db    0xBE,0x28
.db    0x25,0xE5
.db    0xF5,0x7E
.db    0xF5,0xCD
.db    0xA2,0x3A
.db    0xCD,0x16
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0x3A,0xA0
.db    0xF1,0xCD
.db    0x11,0x31
.db    0xCD,0x2A
.db    0x3B,0xF1
.db    0xCD,0x11
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0x20,0xBA
.db    0xC5,0xE1
.db    0xCD,0x16
.db    0x31,0xE1
.db    0x23,0x03
.db    0xCD,0x79
.db    0x30,0x18
.db    0xD0,0xCD
.db    0x91,0x2E
.db    0x78,0xB7
.db    0xC2,0x3E
.db    0x3D,0xEB
.db    0x13,0x2A
.db    0xE8,0x1F
.db    0x71,0x23
.db    0xCD,0x79
.db    0x30,0x18
.db    0xF9,0x1B
.db    0x7A,0xB3
.db    0xCA,0x2E
.db    0x05,0xC9
.db    0x7C,0xB5
.db    0x18,0xF8
.db    0x2A,0x0E
.db    0x03,0x23
.db    0x7E,0xFE
.db    0x20,0x20
.db    0xFA,0xCD
.db    0x34,0x3D
.db    0xCD,0xA4
.db    0x31,0x21
.db    0xFF,0xFF
.db    0x22,0xE8
.db    0x1F,0x21
.db    0xB8,0x3E
.db    0xCD,0x34
.db    0x3D,0xCD
.db    0x00,0x21
.db    0x22,0xB2
.db    0x1E,0x21
.db    0xFF,0xFF
.db    0x22,0xE8
.db    0x1F,0xEB
.db    0xCD,0xDB
.db    0x30,0xC8
.db    0x3A,0x23
.db    0x16,0xFE
.db    0x1C,0xC0
.db    0xCD,0xDB
.db    0x10,0x1A
.db    0xFE,0x20
.db    0xC0,0x23
.db    0x22,0xE8
.db    0x1F,0xC9
.db    0xCD,0xA7
.db    0x3A,0x03
.db    0x6D,0x65
.db    0x6D,0x6F
.db    0x72,0x79
.db    0x20,0x66
.db    0x75,0x6C
.db    0x6C,0x03
.db    0x0D,0x00
.db    0xB7,0xCB
.db    0x1C,0xCB
.db    0x1D,0x7D
.db    0xC9,0x23
.db    0x7E,0xFE
.db    0x20,0x28
.db    0xFA,0xFE
.db    0x3B,0xC8
.db    0xB7,0xC9
.db    0xC5,0x06
.db    0x08,0x07
.db    0xF5,0x3E
.db    0x30,0xCE
.db    0x00,0xCD
.db    0x2C,0x3B
.db    0xF1,0x10
.db    0xF4,0xC1
.db    0xC9,0x0E
.db    0x01,0x18
.db    0x02,0x0E
.db    0xFF,0xE6
.db    0x7F,0x6F
.db    0x26,0x00
.db    0x18,0x4A
.db    0x0E,0x30
.db    0xE5,0xD5
.db    0xC5,0x6F
.db    0x26,0x00
.db    0xCD,0x48
.db    0x31,0x18
.db    0x26,0x6F
.db    0xAF,0x67
.db    0x18,0x02
.db    0x3E,0xFF
.db    0x32,0x21
.db    0x31,0xE5
.db    0xD5,0xC5
.db    0x0E,0xFF
.db    0x3E,0x00
.db    0xB7,0x28
.db    0x0C,0x11
.db    0x00,0xF0
.db    0xCD,0x59
.db    0x31,0x11
.db    0x00,0xFF
.db    0xCD,0x59
.db    0x31,0x11
.db    0xF0,0xFF
.db    0xCD,0x51
.db    0x31,0xC3
.db    0x81,0x3A
.db    0x0E,0x30
.db    0x11,0xF0
.db    0xD8,0xCD
.db    0x59,0x31
.db    0x11,0x18
.db    0xFC,0xCD
.db    0x59,0x31
.db    0x11,0x9C
.db    0xFF,0xCD
.db    0x59,0x31
.db    0x11,0xF6
.db    0xFF,0xCD
.db    0x59,0x31
.db    0x11,0xFF
.db    0xFF,0x0E
.db    0xFF,0x06
.db    0x2F,0x22
.db    0x63,0x31
.db    0x04,0x19
.db    0x38,0xF9
.db    0x21,0x00
.db    0x00,0x78
.db    0xB9,0xCA
.db    0x2A,0x3B
.db    0x0D,0x28
.db    0x0C,0x0E
.db    0xFF,0xFE
.db    0x3A,0x38
.db    0x03,0xC6
.db    0x07,0x47
.db    0xC3,0x2C
.db    0x3B,0xF5
.db    0xD6,0x30
.db    0xB9,0x0E
.db    0x01,0x28
.db    0x03,0xF1
.db    0x18,0xE9
.db    0xF1,0xC9
.db    0xE6,0x03
.db    0x87,0x87
.db    0x87,0x87
.db    0x87,0x5F
.db    0x16,0x00
.db    0x21,0x80
.db    0x00,0x19
.db    0xE5,0x3E
.db    0x09,0x85
.db    0x6F,0x7E
.db    0x32,0x8F
.db    0x0C,0x23
.db    0x7E,0x32
.db    0xA0,0x0C
.db    0xE1,0xC9
.db    0x3A,0x5C
.db    0x00,0x32
.db    0x5C,0x00
.db    0xE5,0xCD
.db    0xC6,0x33
.db    0x3E,0x00
.db    0xB7,0x28
.db    0x15,0x3E
.db    0x01,0x32
.db    0x16,0x37
.db    0xAF,0x32
.db    0xAF,0x31
.db    0x5F,0xCD
.db    0x20,0x01
.db    0x11,0x16
.db    0x37,0x0E
.db    0x0D,0xCD
.db    0xD3,0x34
.db    0x3A,0x5C
.db    0x00,0x5F
.db    0x0E,0x18
.db    0xCD,0x05
.db    0x00,0x3A
.db    0x5C,0x00
.db    0x5F,0x01
.db    0x10,0x00
.db    0x0D,0xFA
.db    0xF0,0x31
.db    0x04,0xCD
.db    0xD4,0x30
.db    0x30,0xF6
.db    0x78,0xBB
.db    0x20,0xF2
.db    0x3A,0x5E
.db    0x09,0xBB
.db    0x28,0x04
.db    0x1E,0x01
.db    0x18,0x02
.db    0x1E,0x00
.db    0x3A,0x5C
.db    0x00,0xCD
.db    0x58,0x32
.db    0x28,0x19
.db    0x38,0x1A
.db    0x5E,0x23
.db    0x56,0x23
.db    0xED,0x53
.db    0x2D,0x28
.db    0x11,0x08
.db    0x00,0xCD
.db    0x59,0x0E
.db    0x38,0x02
.db    0x23,0x23
.db    0x19,0x7E
.db    0x23,0x66
.db    0x6F,0xCD
.db    0x46,0x34
.db    0xED,0x5B
.db    0x07,0x3E
.db    0xCD,0x2D
.db    0x34,0x11
.db    0x01,0x00
.db    0xCD,0x10
.db    0x28,0x21
.db    0x01,0x00
.db    0x7C,0xB5
.db    0x32,0x25
.db    0x28,0xAF
.db    0x32,0x48
.db    0x28,0xCD
.db    0x59,0x0E
.db    0x38,0x22
.db    0x3E,0x16
.db    0xCD,0x54
.db    0x3D,0x11
.db    0x00,0x00
.db    0x23,0x23
.db    0x23,0x7C
.db    0xB7,0x28
.db    0x09,0x3A
.db    0xFD,0x3D
.db    0x3C,0x32
.db    0x48,0x28
.db    0xB7,0x1F
.db    0x21,0x00
.db    0xA5,0x57
.db    0xCD,0xDC
.db    0x2C,0x22
.db    0x58,0x14
.db    0xE1,0xC9
.db    0x32,0x16
.db    0x37,0x3D
.db    0x4F,0x3A
.db    0x16,0x01
.db    0x3C,0x20
.db    0x02,0xCB
.db    0xF9,0x3E
.db    0x09,0xCD
.db    0x1B,0xBB
.db    0x3A,0xED
.db    0x08,0xB7
.db    0xC0,0x32
.db    0x5E,0x09
.db    0x7C,0xB5
.db    0xC0,0xCD
.db    0xA7,0x3A
.db    0x0D,0x07
.db    0x44,0x69
.db    0x73,0x6B
.db    0x20,0x6C
.db    0x6F,0x67
.db    0x20,0x45
.db    0x52,0x52
.db    0x4F,0x52
.db    0x20,0x6F
.db    0x6E,0xA0
.db    0x3A,0x5C
.db    0x00,0x32
.db    0x5E,0x09
.db    0xF5,0xCD
.db    0xA8,0x37
.db    0xCD,0xA7
.db    0x3A,0x2C
.db    0x20,0x6C
.db    0x6F,0x67
.db    0x67,0x69
.db    0x6E,0x67
.db    0x20,0x74
.db    0x6F,0x20
.db    0x64,0x72
.db    0x69,0x76
.db    0x65,0x20
.db    0x6F,0x6E
.db    0x6C,0xF9
.db    0xF1,0xB7
.db    0x3F,0xC9
.db    0x3A,0xED
.db    0x08,0xB7
.db    0x28,0x07
.db    0x2A,0x0C
.db    0x03,0xF9
.db    0xC3,0x09
.db    0x09,0xCD
.db    0xA7,0x3A
.db    0x0D,0x02
.db    0x4C,0x4F
.db    0xC7,0xCD
.db    0xA7,0x3A
.db    0x20,0x6F
.db    0x6E,0xA0
.db    0x3A,0x16
.db    0x37,0xB7
.db    0x20,0x03
.db    0x3A,0x5C
.db    0x00,0xCD
.db    0xA8,0x37
.db    0x3A,0x44
.db    0x26,0x32
.db    0x5C,0x00
.db    0xCD,0xA6
.db    0x38,0xC3
.db    0x2E,0x05
.db    0xCD,0xEE
.db    0x32,0xC3
.db    0x9C,0x11
.db    0xCD,0xA7
.db    0x3A,0x03
.db    0x04,0x20
.db    0x69,0x73
.db    0x20,0x52
.db    0x2F,0xCF
.db    0xC9,0xCD
.db    0x1A,0x33
.db    0xC0,0xCD
.db    0xEC,0x08
.db    0x28,0x04
.db    0xE1,0xC3
.db    0xBF,0x08
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x4E,0x6F
.db    0x20,0x04
.db    0x73,0xA0
.db    0x21,0x5D
.db    0x00,0xCD
.db    0xD1,0x0C
.db    0x18,0xAF
.db    0xCD,0xDD
.db    0x34,0x0E
.db    0x11,0xD5
.db    0xCD,0xAA
.db    0x33,0xD1
.db    0xF5,0x1A
.db    0xC6,0x40
.db    0x32,0x47
.db    0x33,0x1A
.db    0xCD,0x88
.db    0x33,0x30
.db    0x08,0xCD
.db    0x3B,0x33
.db    0x38,0x03
.db    0xF1,0x18
.db    0xE4,0xF1
.db    0xC9,0x3A
.db    0x6F,0x01
.db    0xB7,0x28
.db    0x39,0xCD
.db    0xA7,0x3A
.db    0x0D,0x05
.db    0x17,0x41
.db    0x3A,0x18
.db    0x20,0x69
.db    0x73,0x20
.db    0x52,0x2F
.db    0x4F,0x2C
.db    0x20,0x59
.db    0x3D,0x52
.db    0x65,0x73
.db    0x65,0x74
.db    0x2C,0x20
.db    0x4E,0x3D
.db    0x71,0x75
.db    0x69,0xF4
.db    0xCD,0xB9
.db    0x1C,0x28
.db    0x10,0xFE
.db    0x49,0x3E
.db    0xFF,0x32
.db    0x43,0x38
.db    0xC2,0x2E
.db    0x05,0xCD
.db    0xA2,0x3A
.db    0xAF,0x3F
.db    0xC9,0xCD
.db    0xA2,0x3A
.db    0x3E,0xFF
.db    0x32,0xAF
.db    0x31,0xC5
.db    0xD5,0xCD
.db    0xA4,0x31
.db    0xD1,0xC1
.db    0xAF,0xC9
.db    0xD5,0xC5
.db    0xE5,0xF5
.db    0x0E,0x1D
.db    0xCD,0x05
.db    0x00,0xF1
.db    0x3D,0xFE
.db    0x08,0x38
.db    0x03,0x6C
.db    0xD6,0x08
.db    0x47,0x7D
.db    0x05,0xFA
.db    0xA3,0x33
.db    0x1F,0x18
.db    0xF9,0x1F
.db    0xE1,0xC1
.db    0xD1,0xC9
.db    0x0E,0x12
.db    0xCD,0xD3
.db    0x34,0xFE
.db    0xFF,0xC9
.db    0x11,0x2D
.db    0x3E,0x0E
.db    0x16,0xCD
.db    0xDD,0x34
.db    0xCD,0xAA
.db    0x33,0xC0
.db    0xC3,0xC2
.db    0x37,0x11
.db    0x2D,0x3E
.db    0x0E,0x13
.db    0x18,0xE4
.db    0x11,0x80
.db    0x00,0x0E
.db    0x1A,0xD5
.db    0xED,0x53
.db    0x86,0x35
.db    0xCD,0x05
.db    0x00,0xC1
.db    0x3E,0x0C
.db    0xC3,0x54
.db    0x3D,0x11
.db    0x2D,0x3E
.db    0x0E,0x17
.db    0x18,0xCA
.db    0x0E,0x0F
.db    0xCD,0xDD
.db    0x34,0xCD
.db    0xAA,0x33
.db    0xC0,0xCD
.db    0xA7,0x3A
.db    0x03,0x04
.db    0x20,0x6E
.db    0x6F,0x74
.db    0x20,0x66
.db    0x6F,0x75
.db    0x6E,0xE4
.db    0xC3,0xC9
.db    0x32,0x11
.db    0x2D,0x3E
.db    0xD5,0xCD
.db    0xC6,0x33
.db    0xD1,0x0E
.db    0x10,0xCD
.db    0xAA,0x33
.db    0xC0,0xCD
.db    0xA7,0x3A
.db    0x03,0x02
.db    0x63,0x6C
.db    0x6F,0x73
.db    0x65,0x20
.db    0x84,0xCD
.db    0xA6,0x38
.db    0xC3,0xCF
.db    0x37,0x3E
.db    0xFE,0x32
.db    0xBE,0x17
.db    0x0E,0x14
.db    0xCD,0xD3
.db    0x34,0xF5
.db    0xAF,0x32
.db    0xBE,0x17
.db    0xF1,0xB7
.db    0xC9,0xE5
.db    0x21,0x9F
.db    0x00,0xCD
.db    0xDC,0x2C
.db    0xE1,0xDA
.db    0xE0,0x2C
.db    0xED,0x53
.db    0x08,0x28
.db    0x42,0x4B
.db    0xE5,0x3E
.db    0x0A,0xCD
.db    0x1E,0xBB
.db    0xE1,0xC9
.db    0x11,0xFA
.db    0x3D,0x06
.db    0x0F,0xCD
.db    0xEE,0x39
.db    0x21,0x9F
.db    0x34,0x7E
.db    0xF5,0x3A
.db    0xFD,0x3D
.db    0x77,0xE5
.db    0xED,0x5B
.db    0xFF,0x3D
.db    0xCD,0x95
.db    0x34,0x22
.db    0x2F,0x34
.db    0xED,0x53
.db    0xDA,0x2C
.db    0xE1,0xF1
.db    0x77,0x3A
.db    0x5C,0x00
.db    0xF5,0xE5
.db    0xD5,0xC5
.db    0x32,0x16
.db    0x37,0x11
.db    0x16,0x37
.db    0xCD,0xAF
.db    0x36,0x3D
.db    0x5F,0x0E
.db    0x0E,0xCD
.db    0x05,0x00
.db    0xCD,0x74
.db    0x36,0x3E
.db    0x08,0xCD
.db    0x18,0xBB
.db    0xC1,0xD1
.db    0xE1,0xF1
.db    0xC9,0xED
.db    0x53,0x3C
.db    0x36,0xAF
.db    0x32,0x9F
.db    0x34,0x62
.db    0x6B,0x3A
.db    0xFC,0x3D
.db    0x29,0x3D
.db    0x20,0xFC
.db    0x3E,0x00
.db    0x85,0x6F
.db    0xEB,0x2A
.db    0xFA,0x3D
.db    0x7D,0x2F
.db    0x6F,0x7C
.db    0x2F,0x67
.db    0x23,0xEB
.db    0x01,0x00
.db    0x00,0x03
.db    0x19,0x38
.db    0xFC,0x0B
.db    0xEB,0x2A
.db    0xFA,0x3D
.db    0x19,0xE5
.db    0x2A,0x07
.db    0x3E,0x09
.db    0xEB,0xE1
.db    0x23,0x22
.db    0x0E,0x28
.db    0xEB,0x22
.db    0x08,0x28
.db    0xC9,0xE6
.db    0x7F,0x5F
.db    0x0E,0x20
.db    0xC3,0x05
.db    0x00,0xCD
.db    0xAF,0x36
.db    0xCD,0x05
.db    0x00,0xCD
.db    0x74,0x36
.db    0xC9,0xE5
.db    0xC5,0x21
.db    0x0C,0x00
.db    0x19,0x06
.db    0x17,0x36
.db    0x00,0x23
.db    0x10,0xFB
.db    0xC1,0xE1
.db    0xC9,0x3A
.db    0x23,0x16
.db    0xFE,0x34
.db    0xCA,0x33
.db    0x1A,0xCD
.db    0xA7,0x3A
.db    0x03,0x62
.db    0x61,0x64
.db    0x20,0x73
.db    0x65,0x63
.db    0x74,0x6F
.db    0x72,0x20
.db    0x6F,0x6E
.db    0xA0,0x3A
.db    0xBE,0x17
.db    0xB7,0xCA
.db    0xD0,0x32
.db    0xFE,0xFE
.db    0xC2,0xFE
.db    0x35,0x3A
.db    0x1A,0x01
.db    0xB7,0x28
.db    0xF2,0xF5
.db    0x3A,0x23
.db    0x16,0xFE
.db    0x02,0x28
.db    0x05,0xFE
.db    0x1D,0xC2
.db    0xD0,0x32
.db    0x3A,0x44
.db    0x26,0x32
.db    0x55,0x05
.db    0xCD,0xA7
.db    0x3A,0x72
.db    0x65,0x61
.db    0xE4,0xF1
.db    0xFA,0x47
.db    0x35,0xCD
.db    0xA7,0x3A
.db    0x2C,0x20
.db    0x61,0x62
.db    0x6F,0x72
.db    0xF4,0xCD
.db    0xB9,0x1C
.db    0xCA,0x2E
.db    0x05,0xED
.db    0x5B,0xEA
.db    0x1E,0x3A
.db    0x23,0x16
.db    0xFE,0x02
.db    0x28,0x03
.db    0x11,0x00
.db    0x00,0x2A
.db    0xB2,0x1E
.db    0x19,0x0E
.db    0x80,0x3A
.db    0x1B,0x01
.db    0x77,0x23
.db    0x0D,0x20
.db    0xFB,0x3A
.db    0x23,0x16
.db    0xFE,0x34
.db    0xC8,0xCD
.db    0xA2,0x3A
.db    0x21,0x29
.db    0x3E,0x34
.db    0x21,0x7C
.db    0x00,0x34
.db    0x3E,0x00
.db    0xC9,0xE5
.db    0xCD,0x7E
.db    0x35,0xC3
.db    0xEC,0x35
.db    0x3E,0xFF
.db    0x3C,0xCA
.db    0xB4,0x35
.db    0xE5,0x21
.db    0x80,0x35
.db    0xE5,0xED
.db    0x5B,0x58
.db    0x14,0xCD
.db    0xC9,0x33
.db    0xCD,0xB4
.db    0x35,0xD1
.db    0xF5,0xCD
.db    0xC9,0x33
.db    0x3A,0x7F
.db    0x35,0x5F
.db    0x21,0x80
.db    0x00,0x54
.db    0xCD,0x8C
.db    0x37,0xED
.db    0x5B,0x58
.db    0x14,0x19
.db    0xED,0x5B
.db    0x86,0x35
.db    0x06,0x80
.db    0xCD,0xEE
.db    0x39,0xF1
.db    0xE1,0xC9
.db    0x3E,0x0D
.db    0xC3,0x27
.db    0xBB,0xE5
.db    0xC5,0x3A
.db    0x7F,0x35
.db    0x3C,0x28
.db    0x25,0x2A
.db    0x86,0x35
.db    0xE5,0xED
.db    0x5B,0x58
.db    0x14,0xCD
.db    0xC9,0x33
.db    0xCD,0xB4
.db    0x35,0x3A
.db    0x7F,0x35
.db    0x5F,0x21
.db    0x80,0x00
.db    0x54,0xCD
.db    0x8C,0x37
.db    0xED,0x5B
.db    0x58,0x14
.db    0x19,0xEB
.db    0xE1,0x06
.db    0x80,0xCD
.db    0xEE,0x39
.db    0x0E,0x01
.db    0xCD,0xF2
.db    0x35,0xC1
.db    0xB7,0xE1
.db    0xC2,0xED
.db    0x34,0xC9
.db    0xCD,0x59
.db    0x0E,0x38
.db    0x02,0xE5
.db    0xE1,0x3E
.db    0x0E,0xC3
.db    0x2A,0xBB
.db    0xED,0x5B
.db    0x07,0x3E
.db    0x2A,0x08
.db    0x28,0xCD
.db    0xDC,0x2C
.db    0x30,0x05
.db    0x3E,0x02
.db    0x32,0xBE
.db    0x17,0x3A
.db    0x0C,0x01
.db    0x3D,0xCC
.db    0xA2,0x3A
.db    0xCD,0xB1
.db    0x2A,0x3A
.db    0xBE,0x17
.db    0xB7,0xFA
.db    0x35,0x36
.db    0xFE,0x7F
.db    0xCA,0x39
.db    0x37,0xFE
.db    0x02,0xCA
.db    0x44,0x37
.db    0x2A,0xCB
.db    0x17,0xAF
.db    0x77,0x23
.db    0x77,0x3D
.db    0x32,0xBE
.db    0x17,0xCD
.db    0xA2,0x3A
.db    0xCD,0x5F
.db    0x37,0x01
.db    0x00,0x00
.db    0x2A,0xB2
.db    0x1E,0x23
.db    0x22,0xB2
.db    0x1E,0x2A
.db    0xCB,0x17
.db    0x2B,0xCD
.db    0x9D,0x14
.db    0x28,0x19
.db    0x23,0x7E
.db    0x23,0xB9
.db    0x20,0x03
.db    0x7E,0xB8
.db    0xC8,0x7E
.db    0x2B,0xB6
.db    0x23,0x20
.db    0xF1,0x70
.db    0x23,0x77
.db    0x23,0x77
.db    0x2B,0x2B
.db    0x2B,0x71
.db    0xC9,0x23
.db    0x7E,0xB9
.db    0xC8,0xB7
.db    0x20,0xF9
.db    0x71,0x23
.db    0x77,0x23
.db    0x77,0xC9
.db    0xF5,0xCD
.db    0x59,0x0E
.db    0x30,0x05
.db    0x3E,0xFF
.db    0x3C,0x28
.db    0x02,0xF1
.db    0xC9,0xF1
.db    0x22,0xFF
.db    0x36,0xE3
.db    0x22,0x8D
.db    0x36,0x31
.db    0xA5,0x3E
.db    0x21,0xDC
.db    0x34,0xE3
.db    0xD5,0xF5
.db    0x11,0x9B
.db    0xAD,0x2A
.db    0x06,0x00
.db    0x23,0x23
.db    0x23,0x73
.db    0x23,0x72
.db    0x23,0x11
.db    0xA7,0xAD
.db    0x73,0x23
.db    0x72,0x23
.db    0x11,0xAC
.db    0xAD,0x73
.db    0x23,0x72
.db    0xF1,0x18
.db    0x4E,0xF5
.db    0xCD,0x59
.db    0x0E,0x30
.db    0x06,0x3A
.db    0x7B,0x36
.db    0x3C,0x28
.db    0x02,0xF1
.db    0xC9,0xF1
.db    0x22,0xFF
.db    0x36,0x21
.db    0x00,0x00
.db    0x39,0x22
.db    0x8A,0x36
.db    0xD5,0xF5
.db    0x1A,0x32
.db    0x16,0x37
.db    0xF1,0x2A
.db    0x06,0x00
.db    0x23,0x23
.db    0x23,0x5E
.db    0x23,0x56
.db    0xED,0x53
.db    0x93,0x36
.db    0x23,0x5E
.db    0x23,0x56
.db    0xED,0x53
.db    0xA0,0x36
.db    0x23,0x5E
.db    0x23,0x56
.db    0xED,0x53
.db    0xA7,0x36
.db    0x11,0x1D
.db    0x37,0x72
.db    0x2B,0x73
.db    0x2B,0x11
.db    0x02,0x37
.db    0x72,0x2B
.db    0x73,0x2B
.db    0x72,0x2B
.db    0x73,0xD1
.db    0x21,0x00
.db    0x37,0xC9
.db    0xCD,0x74
.db    0x36,0x3A
.db    0xBE,0x17
.db    0xFE,0xFE
.db    0xCA,0xED
.db    0x34,0xB7
.db    0xC0,0x3A
.db    0x5C,0x00
.db    0xB7,0x20
.db    0x05,0x3E
.db    0x01,0x32
.db    0x5C,0x00
.db    0xC3,0xB4
.db    0x32,0xCD
.db    0x74,0x36
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x0D,0x50
.db    0x72,0x65
.db    0x73,0x73
.db    0x20,0x5E
.db    0x43,0x2C
.db    0x20,0x05
.db    0x69,0x73
.db    0x20,0x52
.db    0x2F,0xCF
.db    0xC3,0xC9
.db    0x32,0xCD
.db    0xA7,0x3A
.db    0x20,0x69
.db    0x6E,0x20
.db    0x64,0x69
.db    0x72,0x00
.db    0x3E,0x01
.db    0x32,0xBE
.db    0x17,0xCD
.db    0xA7,0x3A
.db    0x20,0x6F
.db    0x6E,0x20
.db    0x73,0x79
.db    0x73,0x74
.db    0x65,0x6D
.db    0x20,0x74
.db    0x72,0x61
.db    0x63,0x6B
.db    0x73,0x8D
.db    0xC9,0xED
.db    0x5B,0x07
.db    0x3E,0x2A
.db    0x08,0x28
.db    0xCD,0xDC
.db    0x2C,0xEB
.db    0x2A,0xFA
.db    0x3D,0xCD
.db    0x8C,0x37
.db    0xEB,0x2A
.db    0x0E,0x28
.db    0x2B,0x19
.db    0x3A,0xFD
.db    0x3D,0x47
.db    0x7D,0xA0
.db    0x32,0x9F
.db    0x34,0x3A
.db    0xFC,0x3D
.db    0x47,0xCD
.db    0xD4,0x30
.db    0x10,0xFB
.db    0x22,0x3C
.db    0x36,0xC9
.db    0xC5,0xD5
.db    0xEB,0x4D
.db    0x44,0x3E
.db    0x10,0x21
.db    0x00,0x00
.db    0x29,0xF5
.db    0x79,0x17
.db    0x4F,0x78
.db    0x17,0x47
.db    0x30,0x01
.db    0x19,0xF1
.db    0x3D,0x20
.db    0xF1,0xD1
.db    0xC1,0xC9
.db    0xCD,0xAD
.db    0x37,0x3E
.db    0xFA,0xC6
.db    0x40,0xC3
.db    0x2C,0x3B
.db    0x11,0x2D
.db    0x3E,0x0E
.db    0x15,0xCD
.db    0xD3,0x34
.db    0xB7,0xC8
.db    0x3D,0x28
.db    0x2F,0x3D
.db    0x28,0x3B
.db    0xCD,0xA7
.db    0x3A,0x07
.db    0x03,0x64
.db    0x69,0x72
.db    0x20,0x66
.db    0x75,0x6C
.db    0xEC,0xCD
.db    0xD5,0x37
.db    0xC3,0x2E
.db    0x05,0xCD
.db    0xA7,0x3A
.db    0x20,0x6F
.db    0x6E,0x20
.db    0x64,0x72
.db    0x69,0x76
.db    0x65,0xA0
.db    0xCD,0xE7
.db    0x37,0x18
.db    0xC1,0x0E
.db    0x19,0xCD
.db    0x05,0x00
.db    0x3C,0xC9
.db    0xCD,0xA7
.db    0x3A,0x03
.db    0x02,0x65
.db    0x78,0x74
.db    0x65,0x6E
.db    0x64,0x20
.db    0x84,0x18
.db    0xD2,0xCD
.db    0xA7,0x3A
.db    0x07,0x03
.db    0x05,0x66
.db    0x75,0x6C
.db    0x6C,0x20
.db    0x6F,0x6E
.db    0xA0,0x3A
.db    0x2D,0x3E
.db    0xCD,0xA8
.db    0x37,0xCD
.db    0xFB,0x33
.db    0xCD,0xBF
.db    0x33,0x3A
.db    0x66,0x01
.db    0xB7,0x20
.db    0xB5,0x3A
.db    0x23,0x16
.db    0xFE,0x1C
.db    0x28,0xAE
.db    0x2A,0x0C
.db    0x03,0xF9
.db    0xC3,0x9C
.db    0x11,0x3A
.db    0x1D,0x01
.db    0x32,0x92
.db    0x3B,0xED
.db    0x5B,0xEA
.db    0x1E,0x12
.db    0xF5,0xE5
.db    0xC5,0xD5
.db    0xD1,0xD5
.db    0xAF,0x32
.db    0x90,0x39
.db    0x13,0x12
.db    0x3E,0xFF
.db    0xB7,0xFA
.db    0xC3,0x38
.db    0xD5,0xCD
.db    0xC6,0x33
.db    0xCD,0x9A
.db    0x38,0x11
.db    0xCB,0x3D
.db    0xD5,0xCD
.db    0xE0,0x33
.db    0xD1,0x28
.db    0x66,0x3A
.db    0xDA,0x3D
.db    0x3D,0x32
.db    0xEB,0x3D
.db    0xFA,0xBF
.db    0x38,0xCD
.db    0x1B,0x34
.db    0x20,0x57
.db    0xD1,0xD5
.db    0x21,0x80
.db    0x00,0x46
.db    0x04,0xCD
.db    0xEE,0x39
.db    0xE1,0xE5
.db    0x46,0x23
.db    0x7E,0xCD
.db    0x2C,0x3B
.db    0x10,0xF9
.db    0x23,0x36
.db    0x20,0x23
.db    0xAF,0x77
.db    0x32,0x92
.db    0x3B,0x21
.db    0xD9,0x3D
.db    0x77,0x23
.db    0x35,0x11
.db    0xCB,0x3D
.db    0xCD,0xFE
.db    0x33,0x28
.db    0x2C,0xCD
.db    0xBA,0x38
.db    0xD1,0xC3
.db    0x88,0x34
.db    0x1E,0xFF
.db    0xCD,0xCE
.db    0x34,0x32
.db    0xBB,0x38
.db    0x3E,0x80
.db    0x18,0x16
.db    0x21,0x43
.db    0x38,0x7E
.db    0xB7,0xF8
.db    0x2F,0x77
.db    0xCD,0xC6
.db    0x33,0xCD
.db    0x9A,0x38
.db    0x11,0xCB
.db    0x3D,0xCD
.db    0xC2,0x33
.db    0x3E,0x00
.db    0xC3,0xCB
.db    0x34,0xCD
.db    0xA6,0x38
.db    0xD1,0x13
.db    0xEB,0xCD
.db    0x5A,0x3A
.db    0xFE,0x10
.db    0x28,0xF9
.db    0xFE,0x0D
.db    0xCA,0x1E
.db    0x39,0xFE
.db    0x5F,0x28
.db    0x69,0xFE
.db    0x7F,0x28
.db    0x65,0xFE
.db    0x08,0x28
.db    0x61,0xFE
.db    0x15,0xCA
.db    0xBA,0x39
.db    0xFE,0x12
.db    0xCA,0xC4
.db    0x39,0xFE
.db    0x05,0xCA
.db    0xE7,0x39
.db    0xFE,0x18
.db    0xCA,0xB5
.db    0x39,0xFE
.db    0x5E,0x20
.db    0x14,0xCD
.db    0x5A,0x3A
.db    0xFE,0x10
.db    0x28,0xF9
.db    0xCD,0x4A
.db    0x3A,0xFE
.db    0x21,0x38
.db    0xC9,0xFE
.db    0x5E,0x28
.db    0x02,0xD6
.db    0x40,0x47
.db    0x3A,0x09
.db    0x01,0xB8
.db    0x20,0x1B
.db    0x3A,0x23
.db    0x16,0xFE
.db    0x1A,0x20
.db    0x14,0x3A
.db    0x69,0x21
.db    0x2F,0x32
.db    0x69,0x21
.db    0x36,0x20
.db    0x23,0xF5
.db    0xAF,0x77
.db    0x32,0x92
.db    0x3B,0xF1
.db    0xC3,0x88
.db    0x34,0xEB
.db    0xE1,0xE5
.db    0x7E,0x23
.db    0x34,0xBE
.db    0xCA,0xDE
.db    0x39,0xEB
.db    0x70,0x78
.db    0xCD,0x7A
.db    0x39,0x23
.db    0x18,0x87
.db    0xCD,0x43
.db    0x39,0x18
.db    0x82,0xEB
.db    0xC1,0xE1
.db    0xE5,0xC5
.db    0x23,0x7E
.db    0xD6,0x01
.db    0x77,0x38
.db    0x36,0xEB
.db    0x2B,0x3A
.db    0x93,0x01
.db    0xB7,0x46
.db    0x36,0x20
.db    0x20,0x32
.db    0x3A,0x90
.db    0x39,0x3C
.db    0x3C,0x32
.db    0x90,0x39
.db    0x78,0xFE
.db    0x20,0x30
.db    0x1B,0xCD
.db    0xAD,0x37
.db    0x3A,0x90
.db    0x39,0x3C
.db    0x3C,0x32
.db    0x90,0x39
.db    0xF5,0x3E
.db    0x5E,0xCD
.db    0x2C,0x3B
.db    0xF1,0xC9
.db    0xFE,0x20
.db    0xDC,0x72
.db    0x39,0xDA
.db    0xAD,0x37
.db    0xC3,0x2C
.db    0x3B,0x33
.db    0x33,0x34
.db    0xEB,0xC3
.db    0xC5,0x38
.db    0xCD,0x9B
.db    0x39,0x3E
.db    0x00,0xB7
.db    0xC8,0x06
.db    0x20,0x3D
.db    0x32,0x90
.db    0x39,0x18
.db    0xF1,0x78
.db    0xFE,0x20
.db    0x3A,0x93
.db    0x01,0xDC
.db    0xA7,0x39
.db    0x3A,0x93
.db    0x01,0xCD
.db    0x2C,0x3B
.db    0x3E,0x20
.db    0xCD,0x2C
.db    0x3B,0x3A
.db    0x93,0x01
.db    0xC3,0x2C
.db    0x3B,0xCD
.db    0x43,0x39
.db    0x18,0xFB
.db    0xCD,0xA2
.db    0x3A,0xAF
.db    0x32,0x90
.db    0x39,0xC3
.db    0x3A,0x38
.db    0xD1,0xD5
.db    0x13,0x1A
.db    0x47,0xCD
.db    0xA7,0x3A
.db    0x23,0x8D
.db    0xAF,0x32
.db    0x90,0x39
.db    0xB0,0x28
.db    0x0F,0x13
.db    0x1A,0xCD
.db    0x7A,0x39
.db    0x10,0xF9
.db    0x18,0x06
.db    0xCD,0xA7
.db    0x3A,0x87
.db    0x35,0xEB
.db    0xC3,0xC5
.db    0x38,0xCD
.db    0xA2,0x3A
.db    0x18,0xF8
.db    0x06,0x24
.db    0x7E,0x12
.db    0x23,0x13
.db    0x10,0xFA
.db    0xC9,0xE5
.db    0xCD,0xFB
.db    0x39,0xE1
.db    0xC9,0x1E
.db    0xFF,0x0E
.db    0x06,0xCD
.db    0x05,0x00
.db    0xB7,0x28
.db    0x30,0xCD
.db    0x54,0x3A
.db    0x32,0x45
.db    0x3B,0xFE
.db    0x13,0x28
.db    0x4B,0xFE
.db    0x20,0x20
.db    0x07,0xF6
.db    0x80,0x32
.db    0x45,0x3B
.db    0xE6,0x7F
.db    0xC5,0x47
.db    0x3A,0x0F
.db    0x01,0xB8
.db    0x78,0xC1
.db    0x28,0x36
.db    0xCD,0x2E
.db    0x3A,0xD8
.db    0xE6,0x0F
.db    0x32,0x69
.db    0x01,0xC9
.db    0xFE,0x30
.db    0xD8,0xFE
.db    0x3A,0x3F
.db    0xC9,0xF6
.db    0x01,0xC9
.db    0xCD,0x33
.db    0x3D,0xCD
.db    0x24,0x3A
.db    0xDA,0x3E
.db    0x3D,0xC3
.db    0x2E,0x05
.db    0xCD,0x5A
.db    0x3A,0xCD
.db    0x2C,0x3B
.db    0xFE,0x61
.db    0xD8,0xFE
.db    0x7B,0x3F
.db    0xD8,0xE6
.db    0x5F,0xC9
.db    0xE5,0xD5
.db    0xC5,0xC3
.db    0x67,0x3A
.db    0xE5,0xD5
.db    0xC5,0x1E
.db    0xFF,0x0E
.db    0x06,0xCD
.db    0x05,0x00
.db    0xB7,0x28
.db    0xF6,0x32
.db    0xA2,0x16
.db    0xFE,0x03
.db    0xCA,0x96
.db    0x3A,0xFE
.db    0x10,0x28
.db    0x18,0x47
.db    0x3A,0x0B
.db    0x01,0xB8
.db    0x28,0x0B
.db    0x78,0xFE
.db    0x0A,0x20
.db    0x02,0x3E
.db    0x0D,0xC1
.db    0xD1,0xE1
.db    0xC9,0xCD
.db    0x48,0x0E
.db    0xC3,0x47
.db    0x05,0xF5
.db    0x3A,0x8C
.db    0x3B,0x2F
.db    0x32,0x8C
.db    0x3B,0xF1
.db    0x18,0xEB
.db    0xCD,0x7A
.db    0x39,0xCD
.db    0x48,0x0E
.db    0xCD,0xA6
.db    0x38,0xC3
.db    0x65,0x04
.db    0xCD,0xA7
.db    0x3A,0x8D
.db    0xC9,0x22
.db    0xFD,0x3A
.db    0xE3,0xD5
.db    0xCD,0x24
.db    0x0D,0x7E
.db    0xE6,0x7F
.db    0xCA,0x2E
.db    0x05,0x11
.db    0x09,0x3B
.db    0xFE,0x01
.db    0xCC,0x00
.db    0x3B,0x11
.db    0x11,0x3B
.db    0xFE,0x02
.db    0xCC,0x00
.db    0x3B,0x11
.db    0x1B,0x3B
.db    0xFE,0x03
.db    0xCC,0x00
.db    0x3B,0x11
.db    0x1F,0x3B
.db    0xFE,0x04
.db    0xCC,0x00
.db    0x3B,0x11
.db    0x24,0x3B
.db    0xFE,0x05
.db    0xCC,0x00
.db    0x3B,0xFE
.db    0x17,0xCC
.db    0x24,0x0D
.db    0xFE,0x18
.db    0xCC,0x1E
.db    0x0D,0xB7
.db    0xC4,0x2C
.db    0x3B,0xFE
.db    0x0D,0x3E
.db    0x0A,0xCC
.db    0x2C,0x3B
.db    0xCB,0x7E
.db    0x23,0x28
.db    0xB8,0xCD
.db    0x1E,0x0D
.db    0xD1,0xE3
.db    0x21,0x00
.db    0x00,0xC9
.db    0x1A,0xB7
.db    0xC8,0xCD
.db    0x2C,0x3B
.db    0x13,0x18
.db    0xF7,0x73
.db    0x65,0x63
.db    0x74,0x6F
.db    0x72,0x73
.db    0x00,0x07
.db    0x63,0x61
.db    0x6E,0x20
.db    0x6E,0x6F
.db    0x74,0x20
.db    0x00,0x20
.db    0x2D,0x20
.db    0x00,0x66
.db    0x69,0x6C
.db    0x65,0x00
.db    0x64,0x69
.db    0x73,0x6B
.db    0x20,0x00
.db    0x3E,0x20
.db    0xE5,0xD5
.db    0xC5,0xF5
.db    0xE6,0x7F
.db    0x5F,0xFE
.db    0x07,0x20
.db    0x07,0x3A
.db    0x12,0x01
.db    0xB7,0xC2
.db    0xAB,0x3B
.db    0x3A,0x1F
.db    0x01,0xBB
.db    0x20,0x41
.db    0x3E,0x20
.db    0x57,0xE6
.db    0x7F,0xFE
.db    0x20,0x20
.db    0x38,0x7A
.db    0xB7,0xFA
.db    0x71,0x3B
.db    0x3A,0x8C
.db    0x3B,0xB7
.db    0x20,0x2D
.db    0x3E,0x18
.db    0x3D,0xFA
.db    0x85,0x3B
.db    0x32,0x59
.db    0x3B,0x20
.db    0x22,0x3A
.db    0x05,0x01
.db    0xB7,0xF5
.db    0xE6,0x7F
.db    0x32,0x59
.db    0x3B,0xF1
.db    0xFA,0x85
.db    0x3B,0xCD
.db    0x5A,0x3A
.db    0x57,0xFE
.db    0x0D,0x3E
.db    0x20,0x28
.db    0x07,0x7A
.db    0xFE,0x20
.db    0x20,0x02
.db    0xEE,0x80
.db    0x32,0x45
.db    0x3B,0xCD
.db    0xAF,0x3B
.db    0xF1,0xF5
.db    0x5F,0x3E
.db    0x00,0xB7
.db    0xC4,0xB8
.db    0x3B,0x3E
.db    0x00,0xB7
.db    0xCC,0xF5
.db    0x39,0x3A
.db    0x69,0x01
.db    0xB7,0x28
.db    0x0E,0x57
.db    0x5F,0x62
.db    0x2E,0x00
.db    0x29,0x2B
.db    0x7C,0xB5
.db    0x20,0xFB
.db    0x1D,0x20
.db    0xF4,0xF1
.db    0xC3,0x81
.db    0x3A,0x3A
.db    0xD1,0x3B
.db    0x32,0xB9
.db    0x3B,0xAF
.db    0x18,0x07
.db    0x3E,0x06
.db    0x32,0xD1
.db    0x3B,0x3E
.db    0xFF,0x32
.db    0xF1,0x3B
.db    0x7B,0xF5
.db    0xFE,0x09
.db    0x28,0x08
.db    0xFE,0x0D
.db    0x20,0x14
.db    0x3E,0xFF
.db    0x18,0x19
.db    0x16,0x07
.db    0x3E,0x20
.db    0xCD,0xDF
.db    0x3B,0x14
.db    0x7A,0xFE
.db    0x08,0x20
.db    0xF5,0xF1
.db    0xC9,0xF5
.db    0x3A,0xD1
.db    0x3B,0x3C
.db    0xFE,0x08
.db    0x20,0x01
.db    0xAF,0x32
.db    0xD1,0x3B
.db    0xF1,0xF5
.db    0xD5,0x5F
.db    0x3E,0x00
.db    0xB7,0x0E
.db    0x06,0x28
.db    0x1D,0x3A
.db    0x94,0x01
.db    0xB7,0x28
.db    0x15,0xD9
.db    0x3E,0x0F
.db    0xCD,0x2D
.db    0xBB,0xD9
.db    0xB7,0x20
.db    0x0B,0xD9
.db    0xCD,0xF5
.db    0x39,0xD9
.db    0xFE,0x10
.db    0x20,0xED
.db    0x18,0x05
.db    0x0E,0x05
.db    0xCD,0x05
.db    0x00,0xD1
.db    0xF1,0xC9
.db    0xCD,0xA4
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0x0D,0x05
.db    0x63,0x61
.db    0x70,0x61
.db    0x63,0x69
.db    0x74,0x79
.db    0x3A,0x89
.db    0xCD,0xC0
.db    0x26,0xCD
.db    0x86,0x27
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x74,0x72
.db    0x61,0x63
.db    0x6B,0x73
.db    0x3A,0x09
.db    0x89,0x2A
.db    0x2F,0x34
.db    0x23,0xCD
.db    0x3A,0x31
.db    0x2A,0x07
.db    0x3E,0xE5
.db    0xCD,0x3A
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0x20,0x73
.db    0x79,0x73
.db    0x74,0x65
.db    0x6D,0x0D
.db    0x01,0x2F
.db    0x74,0x72
.db    0x61,0x63
.db    0x6B,0x3A
.db    0x89,0x2A
.db    0xFA,0x3D
.db    0xE5,0xCD
.db    0x3A,0x31
.db    0x2A,0xDA
.db    0x2C,0xCD
.db    0x3A,0x31
.db    0xCD,0xA7
.db    0x3A,0x20
.db    0x6C,0x61
.db    0x73,0x74
.db    0x09,0xA8
.db    0x2A,0x2D
.db    0x28,0x7C
.db    0xB5,0x20
.db    0x06,0xCD
.db    0xA7,0x3A
.db    0x4E,0x4F
.db    0xA0,0xCD
.db    0xA7,0x3A
.db    0x64,0x65
.db    0x62,0x6C
.db    0x6F,0x63
.db    0x6B,0x69
.db    0x6E,0x67
.db    0x29,0x0D
.db    0x01,0x2F
.db    0x73,0x79
.db    0x73,0x74
.db    0x65,0x6D
.db    0x3A,0x89
.db    0xD1,0xE1
.db    0xCD,0x8C
.db    0x37,0xCD
.db    0x3A,0x31
.db    0x2A,0x01
.db    0x3E,0x23
.db    0xE5,0x0E
.db    0x04,0xCD
.db    0xDD,0x1C
.db    0xCD,0x3A
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0x20,0x64
.db    0x69,0x72
.db    0x0D,0x64
.db    0x69,0x72
.db    0x20,0x65
.db    0x6E,0x74
.db    0x72,0x69
.db    0x65,0x73
.db    0x3A,0x89
.db    0xE1,0xE5
.db    0xCD,0x3A
.db    0x31,0xE1
.db    0x0E,0x20
.db    0xCD,0xDD
.db    0x1C,0xCD
.db    0x86,0x27
.db    0xCD,0xA7
.db    0x3A,0x0D
.db    0x01,0x2F
.db    0x67,0x72
.db    0x6F,0x75
.db    0x70,0x3A
.db    0x89,0x3A
.db    0xFD,0x3D
.db    0x3C,0x6F
.db    0x26,0x00
.db    0xCD,0x3A
.db    0x31,0xCD
.db    0xD1,0x26
.db    0x17,0x6F
.db    0x26,0x00
.db    0xCD,0x86
.db    0x27,0x2A
.db    0xFF,0x3D
.db    0x3E,0x30
.db    0x32,0x1F
.db    0x31,0xCD
.db    0x16,0x31
.db    0x3E,0xFF
.db    0x32,0x1F
.db    0x31,0xCD
.db    0xA7,0x3A
.db    0x48,0x20
.db    0x67,0x72
.db    0x6F,0x75
.db    0x70,0x73
.db    0x0D,0x6B
.db    0x62,0x79
.db    0x74,0x65
.db    0x73,0x2F
.db    0x65,0x78
.db    0x74,0x65
.db    0x6E,0x74
.db    0x3A,0x89
.db    0x21,0x08
.db    0x00,0x3A
.db    0xFE,0x3D
.db    0x29,0x3D
.db    0xF2,0x28
.db    0x3D,0xCD
.db    0x86,0x27
.db    0xC3,0x2E
.db    0x05,0x2B
.db    0xCD,0xDB
.db    0x30,0xC0
.db    0x18,0x04
.db    0x1A,0xFE
.db    0x20,0xC8
.db    0xCD,0xA7
.db    0x3A,0x07
.db    0x03,0x69
.db    0x6E,0x76
.db    0x61,0x6C
.db    0x69,0x64
.db    0x20,0x61
.db    0x72,0x67
.db    0x75,0x6D
.db    0x65,0x6E
.db    0x74,0x00
.db    0x32,0xEF
.db    0x3D,0x32
.db    0xF0,0x3D
.db    0x22,0xF5
.db    0x3D,0xED
.db    0x53,0xF3
.db    0x3D,0xED
.db    0x43,0xF1
.db    0x3D,0x11
.db    0xEF,0x3D
.db    0x0E,0x32
.db    0xC3,0x05
.db    0x00,0x33
.db    0x0B,0x23
.db    0x18,0xCE
.db    0x23,0x0D
.db    0x43,0x26
.db    0x1A,0x31
.db    0x21,0x1B
.db    0x38,0x3A
.db    0x1F,0x45
.db    0x2B,0x1E
.db    0x45,0x2B
.db    0x16,0x1A
.db    0x3C,0x0F
.db    0xDF,0x16
.db    0x15,0x8E
.db    0x27,0x0A
.db    0x21,0x20
.db    0x2A,0xC8
.db    0x20,0x2B
.db    0xF1,0x20
.db    0x19,0x66
.db    0x0E,0x2D
.db    0xB3,0x20
.db    0x2E,0xB8
.db    0x20,0x2F
.db    0xBD,0x20
.db    0x30,0xC2
.db    0x20,0x20
.db    0x1B,0x2B
.db    0x21,0x1B
.db    0x2B,0x24
.db    0xDE,0x2E
.db    0x25,0xD0
.db    0x2E,0x23
.db    0xD7,0x2E
.db    0x22,0xC9
.db    0x2E,0x26
.db    0xF1,0x2D
.db    0x27,0x65
.db    0x30,0x28
.db    0x2A,0x30
.db    0x29,0xE9
.db    0x2E,0x31
.db    0x9B,0x0B
.db    0x32,0x15
.db    0x07,0x0E
.db    0xE2,0x22
.db    0xFF,0x01
.db    0x24,0x24
.db    0x24,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x53,0x55
.db    0x42,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x0C
.db    0x0C,0x80
.db    0x3D,0x00
.db    0xBA,0x00
.db    0x00,0x43
.db    0x4F,0x4D
.db    0x28,0x00
.db    0x04,0x0F
.db    0x00,0x8F
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0x21,0x00
.db    0x00,0x06
.db    0x40,0x0E
.db    0x00,0xCD
.db    0x00,0x04
.db    0x18,0x03
.db    0xCD,0x4B
.db    0x01,0x11
.db    0xDC,0x01
.db    0xFE,0x00
.db    0x28,0x03
.db    0x11,0xEE
.db    0x01,0x0C
.db    0x79,0xFE
.db    0x0A,0x20
.db    0x11,0x0E
.db    0x00,0x3A
.db    0x02,0x02
.db    0x3C,0x32
.db    0x02,0x02
.db    0xC6,0x30
.db    0x32,0xDC
.db    0x01,0x32
.db    0xEE,0x01
.db    0x79,0xC6
.db    0x30,0x32
.db    0xDD,0x01
.db    0x32,0xEF
.db    0x01,0xC5
.db    0xE5,0x0E
.db    0x09,0xCD
.db    0x05,0x00
.db    0xE1,0xC1
.db    0x11,0x00
.db    0x04,0x19
.db    0x10,0xC4
.db    0xC3,0x00
.db    0x00,0xC5
.db    0xD5,0xE5
.db    0xDD,0xE5
.db    0xE5,0xDD
.db    0xE1,0x21
.db    0xFE,0x03
.db    0x1E,0x00
.db    0xDD,0x46
.db    0x00,0xDD
.db    0x4E,0x01
.db    0xDD,0x56
.db    0x02,0x3E
.db    0x55,0xDD
.db    0x77,0x00
.db    0xDD,0x77
.db    0x01,0xDD
.db    0x77,0x02
.db    0xDD,0xBE
.db    0x00,0x28
.db    0x02,0xCB
.db    0xC3,0xDD
.db    0xBE,0x01
.db    0x28,0x02
.db    0xCB,0xC3
.db    0xDD,0xBE
.db    0x02,0x28
.db    0x02,0xCB
.db    0xC3,0xDD
.db    0x36,0x01
.db    0xAA,0xDD
.db    0xBE,0x00
.db    0x28,0x02
.db    0xCB,0xD3
.db    0xDD,0xBE
.db    0x02,0x28
.db    0x02,0xCB
.db    0xDB,0x3E
.db    0xAA,0xDD
.db    0x77,0x00
.db    0xDD,0x77
.db    0x01,0xDD
.db    0x77,0x02
.db    0xDD,0xBE
.db    0x00,0x28
.db    0x02,0xCB
.db    0xCB,0xDD
.db    0xBE,0x01
.db    0x28,0x02
.db    0xCB,0xCB
.db    0xDD,0xBE
.db    0x02,0x28
.db    0x02,0xCB
.db    0xCB,0xDD
.db    0x36,0x01
.db    0x55,0xDD
.db    0xBE,0x00
.db    0x28,0x02
.db    0xCB,0xD3
.db    0xDD,0xBE
.db    0x02,0x28
.db    0x02,0xCB
.db    0xDB,0xDD
.db    0x70,0x00
.db    0xDD,0x71
.db    0x01,0xDD
.db    0x72,0x02
.db    0xDD,0x23
.db    0x2B,0x7C
.db    0xB5,0x20
.db    0x83,0x7B
.db    0xDD,0xE1
.db    0xE1,0xD1
.db    0xC1,0xC9
.db    0x20,0x20
.db    0x2E,0x20
.db    0x4B,0x2D
.db    0x42,0x59
.db    0x54,0x45
.db    0x20,0x49
.db    0x2E,0x4F
.db    0x2E,0x0D
.db    0x0A,0x24
.db    0x20,0x20
.db    0x2E,0x20
.db    0x4B,0x2D
.db    0x42,0x59
.db    0x54,0x45
.db    0x20,0x46
.db    0x45,0x48
.db    0x4C,0x45
.db    0x52,0x0D
.db    0x0A,0x24
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0xC5,0xD5
.db    0xE5,0xDD
.db    0xE5,0xE5
.db    0xDD,0xE1
.db    0x21,0xFE
.db    0x03,0x1E
.db    0x00,0xDD
.db    0x46,0x00
.db    0xDD,0x4E
.db    0x01,0xDD
.db    0x56,0x02
.db    0x3E,0x55
.db    0xDD,0x77
.db    0x00,0xDD
.db    0x77,0x01
.db    0xDD,0x77
.db    0x02,0xDD
.db    0xBE,0x00
.db    0x28,0x02
.db    0xCB,0xC3
.db    0xDD,0xBE
.db    0x01,0x28
.db    0x02,0xCB
.db    0xC3,0xDD
.db    0xBE,0x02
.db    0x28,0x02
.db    0xCB,0xC3
.db    0xDD,0x36
.db    0x01,0xAA
.db    0xDD,0xBE
.db    0x00,0x28
.db    0x02,0xCB
.db    0xD3,0xDD
.db    0xBE,0x02
.db    0x28,0x02
.db    0xCB,0xDB
.db    0x3E,0xAA
.db    0xDD,0x77
.db    0x00,0xDD
.db    0x77,0x01
.db    0xDD,0x77
.db    0x02,0xDD
.db    0xBE,0x00
.db    0x28,0x02
.db    0xCB,0xCB
.db    0xDD,0xBE
.db    0x01,0x28
.db    0x02,0xCB
.db    0xCB,0xDD
.db    0xBE,0x02
.db    0x28,0x02
.db    0xCB,0xCB
.db    0xDD,0x36
.db    0x01,0x55
.db    0xDD,0xBE
.db    0x00,0x28
.db    0x02,0xCB
.db    0xD3,0xDD
.db    0xBE,0x02
.db    0x28,0x02
.db    0xCB,0xDB
.db    0xDD,0x70
.db    0x00,0xDD
.db    0x71,0x01
.db    0xDD,0x72
.db    0x02,0xDD
.db    0x23,0x2B
.db    0x7C,0xB5
.db    0x20,0x83
.db    0x7B,0xDD
.db    0xE1,0xE1
.db    0xD1,0xC1
.db    0xC9,0x4E
.db    0x01,0xDD
.db    0x56,0x02
.db    0x3E,0x55
.db    0xDD,0x77
.db    0x00,0xDD
.db    0x77,0x01
.db    0xDD,0x77
.db    0x02,0xDD
.db    0xBE,0x00
.db    0x28,0x02
.db    0xCB,0xC3
.db    0xDD,0xBE
.db    0x01,0x28
.db    0x02,0xCB
.db    0xC3,0xDD
.db    0xBE,0x02
.db    0x28,0x02
.db    0xCB,0xC3
.db    0xDD,0x36
.db    0x01,0xAA
.db    0xDD,0xBE
.db    0x00,0x28
.db    0x02,0xCB
.db    0xD3,0xDD
.db    0xBE,0x02
.db    0x28,0x02
.db    0xCB,0xDB
.db    0x3E,0xAA
.db    0xDD,0x77
.db    0x00,0xDD
.db    0x77,0x01
.db    0xDD,0x77
.db    0x02,0xDD
.db    0xBE,0x00
.db    0x28,0x02
.db    0xCB,0xCB
.db    0xDD,0xBE
.db    0x01,0x28
.db    0x02,0xCB
.db    0xCB,0xDD
.db    0xBE,0x02
.db    0x28,0x02
.db    0xCB,0xCB
.db    0xDD,0x36
.db    0x01,0x55
.db    0xDD,0xBE
.db    0x00,0x28
.db    0x02,0xCB
.db    0xD3,0xDD
.db    0xBE,0x02
.db    0x28,0x02
.db    0xCB,0xDB
.db    0xDD,0x70
.db    0x00,0xDD
.db    0x71,0x01
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
 
; *** Konstanten-STRING-Liste ***
;
 
M_CONST_STRING_0:
 .db    3, "x01"
 
M_CONST_STRING_1:
 .db    3, "x03"
 
M_CONST_STRING_2:
 .db    3, "x07"
 
M_CONST_STRING_3:
 .db    3, "x09"
 
M_CONST_STRING_4:
 .db    3, "x02"
 
M_CONST_STRING_5:
 .db    0, " "
 
M_CONST_STRING_6:
 .db    1, "s"
 
M_CONST_STRING_7:
 .db    1, "u"
 
M_CONST_STRING_8:
 .db    3, "x04"
 
M_CONST_STRING_9:
 .db    1, "r"
 
M_CONST_STRING_10:
 .db    3, "x08"
 
M_CONST_STRING_11:
 .db    1, "v"
 
M_CONST_STRING_12:
 .db    3, "x05"
 
M_CONST_STRING_13:
 .db    3, "x06"
 
M_CONST_STRING_14:
 .db    1, "d"
 
M_CONST_STRING_15:
 .db    3, "x10"
 
M_CONST_STRING_16:
 .db    1, "o"
 
M_CONST_STRING_17:
 .db    1, "l"
 
