; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: VGA.PAS
 
.nolist
.INCLUDE "m1284Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        TAKTFREQUENZ  =  0x4E20 ; WORD
.equ        UBRR_VAL  =  0x01 ; BYTE
.equ        XON  =  0x11 ; BYTE
.equ        XOFF  =  0x13 ; BYTE
.equ        CTC_WERT  =  0x027B ; WORD
.equ        CTC_UMSCHALT_WERT  =  0x00C8 ; WORD
.equ        LAENGE_BWS  =  0x07CF ; WORD
.equ        ANZAHL_SPALTEN0  =  0x0029 ; WORD
.equ        ANZAHL_SPALTEN  =  0x002A ; WORD
.equ        ANZAHL_ZEILEN0  =  0x0018 ; WORD
.equ        ANZAHL_ZEILEN  =  0x0019 ; WORD
.equ        FNT_6X8  =  0x01 ; BYTE
.equ        FNT_8X8  =  0x02 ; BYTE
.equ        CL_WHITE  =  0xFF ; BYTE
.equ        CL_BLACK  =  0x00 ; BYTE
.equ        CL_RED  =  0x43 ; BYTE
.equ        CL_GREEN  =  0x4C ; BYTE
.equ        CL_BLUE  =  0xB0 ; BYTE
.equ        CL_YELLOW  =  0x4F ; BYTE
.equ        CL_PURPLE  =  0x73 ; BYTE
.equ        CL_AQUA  =  0x7C ; BYTE
.equ        CL_GRAY  =  0x6A ; BYTE
.equ        CL_DARKGRAY  =  0x2A ; BYTE
.equ        NORMAL_TM  =  0x00 ; BYTE
.equ        IBM_ESC_TM  =  0x01 ; BYTE
.equ        IBM_CSI_TM  =  0x02 ; BYTE
.equ        IBM_CSI_TM_PAR_1  =  0x03 ; BYTE
.equ        IBM_CSI_TM_PAR_2  =  0x04 ; BYTE
.equ        IBM_CSI_TM_PAR_3  =  0x05 ; BYTE
.equ        IBM_GRAFIK_PAR_1_TM  =  0x06 ; BYTE
.equ        IBM_GRAFIK_PAR_2_TM  =  0x07 ; BYTE
.equ        MONITOR_LEER  =  0x00 ; BYTE
.equ        MONITOR_LINKS  =  0x01 ; BYTE
.equ        MONITOR_RECHTS  =  0x02 ; BYTE
.equ        LAENGE_VLINE_ARRAY  =  0x020D ; WORD
 
; *** Variablentabelle ***
 
.dseg
 
STEUER_STRING:   ; String(20)
.byte     1     ; STRING-Laenge
.byte     20
WERT_YL:   ; Byte
.byte     1
WERT_YH:   ; Byte
.byte     1
WERT_R17:   ; Byte
.byte     1
SAVE_R16:   ; Byte
.byte     1
SAVE_R17:   ; Byte
.byte     1
SAVE_R28:   ; Byte
.byte     1
SAVE_R29:   ; Byte
.byte     1
SAVE_R30:   ; Byte
.byte     1
SAVE_R31:   ; Byte
.byte     1
SAVE_SREG:   ; Byte
.byte     1
SAVE_SP01:   ; Byte
.byte     1
SAVE_SP02:   ; Byte
.byte     1
SAVE_PORT_ADR_LOW:   ; Byte
.byte     1
SAVE_PORT_ADR_HIG:   ; Byte
.byte     1
SAVE_PORT_DAT:   ; Byte
.byte     1
SAVE_DDR_DAT:   ; Byte
.byte     1
SAVE_PORT_CONTROL:   ; Byte
.byte     1
ENDLOS_SP01:   ; Byte
.byte     1
ENDLOS_SP02:   ; Byte
.byte     1
ENDLOS_PORT_CONTROL:   ; Byte
.byte     1
ENDLOS_SREG:   ; Byte
.byte     1
ENDLOS_R16:   ; Byte
.byte     1
UP_SCHLEIFE_AKTIV:   ; Boolean
.byte     1
FCOLOR:   ; Byte
.byte     1
BCOLOR:   ; Byte
.byte     1
PIXCOLOR:   ; Byte
.byte     1
ZEICHEN:   ; Byte
.byte     1
X_KUR_POS:   ; Word
.byte     2
Y_KUR_POS:   ; Word
.byte     2
X_PIX_POS:   ; Word
.byte     2
Y_PIX_POS:   ; Word
.byte     2
X_END_POS:   ; Word
.byte     2
Y_END_POS:   ; Word
.byte     2
KURSOR_SCHLEIFE:   ; Word
.byte     2
KURSOR_SICHTBAR:   ; Boolean
.byte     1
KURSOR_EIN:   ; Boolean
.byte     1
KURARR_AKTUELL:   ; Boolean
.byte     1
ZEICHENBREITE:   ; Word
.byte     2
ZEICHENHOEHE:   ; Word
.byte     2
X_ANF:   ; Word
.byte     2
Y_ANF:   ; Word
.byte     2
MAX_SPALTEN0:   ; Word
.byte     2
MAX_ZEILEN0:   ; Word
.byte     2
MAX_SPALTEN:   ; Word
.byte     2
MAX_ZEILEN:   ; Word
.byte     2
FONT_BEZ:   ; Byte
.byte     1
FUELLBYTE:   ; Byte
.byte     1
BWS_POS:   ; Word
.byte     2
BWS_OFFSET:   ; Word
.byte     2
ESCAPE_SEQUENZ:   ; String(10)
.byte     1     ; STRING-Laenge
.byte     10
TERMMODE:   ; Byte
.byte     1
CSI_PARAMETER1:   ; Word
.byte     2
CSI_PARAMETER2:   ; Word
.byte     2
CSI_PARAMETER3:   ; Word
.byte     2
STARTBILDSCHIRM:   ; Boolean
.byte     1
GRAFIK_IM_BWS:   ; Boolean
.byte     1
WRITE_STRING:   ; String(50)
.byte     1     ; STRING-Laenge
.byte     50
 
BWS:
.byte     2000
BWS_FCOLOR:
.byte     2000
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; Timer/Counter1 Compare Match A
.ORG OC1Aaddr
        JMP        TIMER1_COMPA
 
; Timer/Counter3 Compare Match A
.ORG OC3Aaddr
        JMP        TIMER3_COMPA
 
; PROCEDURE - Anfang (TIMER0_AUS)
TIMER0_AUS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0A)
        OUT        TCCR0A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0B)
        OUT        TCCR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIMSK0)
        STS        TIMSK0, R16
 
; PROCEDURE - Ende (TIMER0_AUS)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER0_OVF)
INIT_TIMER0_OVF:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0A)
        OUT        TCCR0A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (TCCR0B)
        OUT        TCCR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TIMSK0)
        STS        TIMSK0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIFR0)
        OUT        TIFR0, R16
 
; PROCEDURE - Ende (INIT_TIMER0_OVF)
        RET
 
; PROCEDURE - Anfang (TIMER1_AUS)
TIMER1_AUS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR1A)
        STS        TCCR1A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR1B)
        STS        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIMSK1)
        STS        TIMSK1, R16
 
; PROCEDURE - Ende (TIMER1_AUS)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER1_COMPA)
INIT_TIMER1_COMPA:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR1A)
        STS        TCCR1A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x09)
        LDI        R16, 0x09
 
; Zuweisung Ziel /  VAR (TCCR1B)
        STS        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WERT)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WERT)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (OCR1AH)
        STS        OCR1AH, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (OCR1AL)
        STS        OCR1AL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (TIMSK1)
        STS        TIMSK1, R16
 
; PROCEDURE - Ende (INIT_TIMER1_COMPA)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER2_OVF)
INIT_TIMER2_OVF:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR2A)
        STS        TCCR2A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (TCCR2B)
        STS        TCCR2B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ASSR)
        STS        ASSR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TIMSK2)
        STS        TIMSK2, R16
 
; PROCEDURE - Ende (INIT_TIMER2_OVF)
        RET
 
; PROCEDURE - Anfang (TIMER3_AUS)
TIMER3_AUS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR3A)
        STS        TCCR3A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR3B)
        STS        TCCR3B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIMSK3)
        STS        TIMSK3, R16
 
; PROCEDURE - Ende (TIMER3_AUS)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER3_COMPA)
INIT_TIMER3_COMPA:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR3A)
        STS        TCCR3A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x09)
        LDI        R16, 0x09
 
; Zuweisung Ziel /  VAR (TCCR3B)
        STS        TCCR3B, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WERT)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WERT)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (OCR3AH)
        STS        OCR3AH, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (OCR3AL)
        STS        OCR3AL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIMSK3)
        STS        TIMSK3, R16
 
; PROCEDURE - Ende (INIT_TIMER3_COMPA)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOORMASKE)
BYTEPOSTOORMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_03
        RJMP       M_CASE_02
M_CASE_03:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_02:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_05
        RJMP       M_CASE_04
M_CASE_05:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x02
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_04:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_07
        RJMP       M_CASE_06
M_CASE_07:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x04
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_06:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_09
        RJMP       M_CASE_08
M_CASE_09:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x08
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_08:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_011
        RJMP       M_CASE_010
M_CASE_011:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x10
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_010:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_013
        RJMP       M_CASE_012
M_CASE_013:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x20
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_012:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_015
        RJMP       M_CASE_014
M_CASE_015:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x40
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_014:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_017
        RJMP       M_CASE_016
M_CASE_017:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x80
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
 
; CASE OF ELSE
M_CASE_016:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; ENDCASE;
M_CASE_01:
 
; Ende Byte - FUNCTION (BYTEPOSTOORMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOORMASKE)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOANDMASKE)
BYTEPOSTOANDMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_020
        RJMP       M_CASE_019
M_CASE_020:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_019:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_022
        RJMP       M_CASE_021
M_CASE_022:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFD
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_021:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_024
        RJMP       M_CASE_023
M_CASE_024:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFB
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_023:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_026
        RJMP       M_CASE_025
M_CASE_026:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xF7
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_025:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_028
        RJMP       M_CASE_027
M_CASE_028:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xEF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_027:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_030
        RJMP       M_CASE_029
M_CASE_030:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xDF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_029:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_032
        RJMP       M_CASE_031
M_CASE_032:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xBF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_031:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_034
        RJMP       M_CASE_033
M_CASE_034:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0x7F
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
 
; CASE OF ELSE
M_CASE_033:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; ENDCASE;
M_CASE_018:
 
; Ende Byte - FUNCTION (BYTEPOSTOANDMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOANDMASKE)
        RET
 
; FUNCTION - Anfang (READ_BIT_IN_BYTE)
READ_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (READ_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (READ_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_038
        CLR        R16
        RJMP       M_VERGL_039
M_VERGL_038:
        SER        R16
M_VERGL_039:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_035
        RJMP       M_IF_036
M_IF_035:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0x00
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_037
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_036:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0xFF
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_037:
 
; Ende Byte - FUNCTION (READ_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (READ_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (SET_BIT_IN_BYTE)
SET_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (SET_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (SET_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (CLEAR_BIT_IN_BYTE)
CLEAR_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOANDMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOANDMASKE)
        CALL       BYTEPOSTOANDMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (CLEAR_BIT_IN_BYTE)
        RET
 
; PROCEDURE - Anfang (WAIT_MS)
WAIT_MS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (ZEIT)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_040:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_041
        RJMP       M_FTD_042
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_041:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x00A6)
        LDI        R16, LOW(0x00A6)
        LDI        R17, HIGH(0x00A6)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_043:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_044
        RJMP       M_FTD_045
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_044:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_043
 
; FOR TO DO - Ende
M_FTD_045:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_040
 
; FOR TO DO - Ende
M_FTD_042:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (WAIT_MS)
        RET
 
; PROCEDURE - Anfang (BYTETOSTRING)
BYTETOSTRING:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_049
        CLR        R16
        RJMP       M_VERGL_050
M_VERGL_049:
        SER        R16
M_VERGL_050:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_046
        RJMP       M_IF_047
M_IF_046:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_048
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_047:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_048:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_051
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_051:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_053
        MOV        R16, R17
M_PRG_CONST_STRING_052:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_052
M_PRG_CONST_STRING_053:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_057
        CLR        R16
        RJMP       M_VERGL_058
M_VERGL_057:
        SER        R16
M_VERGL_058:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_054
        RJMP       M_IF_055
M_IF_054:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_056
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_055:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_056:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXLOW)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_059
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_059:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_061
M_PRG_CONST_STRING_060:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_060
M_PRG_CONST_STRING_061:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_062
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_062:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_064
        MOV        R16, R17
M_PRG_CONST_STRING_063:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_063
M_PRG_CONST_STRING_064:
        ST         -Z, R17
 
; PROCEDURE - Ende (BYTETOSTRING)
        RET
 
; FUNCTION - Anfang (STRINGTOBYTE)
STRINGTOBYTE:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_068
        CLR        R16
        RJMP       M_VERGL_069
M_VERGL_068:
        SER        R16
M_VERGL_069:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_065
        RJMP       M_IF_066
M_IF_065:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN - Ende
M_IF_066:
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_073
        CLR        R16
        RJMP       M_VERGL_074
M_VERGL_073:
        SER        R16
M_VERGL_074:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_070
        RJMP       M_IF_071
M_IF_070:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_071:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (STRINGTOBYTE)
        MOV        R0, R3
 
; Ende Byte - FUNCTION (STRINGTOBYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (STRINGTOBYTE)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFE)
        LDI        R16, 0xFE
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x70)
        LDI        R16, 0x70
 
; Zuweisung Ziel /  VAR (PORTD)
        OUT        PORTD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; PROCEDURE - Anfang (INIT_SER0_PORT)
INIT_SER0_PORT:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (UBRR0H)
        STS        UBRR0H, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (UBRR_VAL)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (UBRR0L)
        STS        UBRR0L, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x18)
        LDI        R16, 0x18
 
; Zuweisung Ziel /  VAR (UCSR0B)
        STS        UCSR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x86)
        LDI        R16, 0x86
 
; Zuweisung Ziel /  VAR (UCSR0C)
        STS        UCSR0C, R16
 
; PROCEDURE - Ende (INIT_SER0_PORT)
        RET
 
; ISR - Einsprung
TIMER1_COMPA:
        PUSH       R16
        IN         R16,SREG
        PUSH       R16
 
; ASM
.equ 	true		= 0xFF
.equ 	false		= 0x00


; Verwaltung der Ports
; ---------------------

; Verwaltung der Ports
.equ 	port_adr_low	= porta
.equ 	port_adr_hig	= portb
.equ 	port_dat	= portc
.equ 	ddr_dat	        = ddrc
.equ 	port_control	= portd




; *** port_control_d ***
.equ 	HSYNC		= 2			; Horizontale Synchronimpulse Pin 13
.equ 	VSYNC		= 3			; Vertikale Synchronimpulse Pin 14
.equ 	G		= 4			; /CE fuer 74HC244
.equ 	WE		= 5			; /WE fuer SRAM
.equ 	OE		= 6			; /OE fuer SRAM



; VERTICAL LINE CONTROL
.equ 	VL_RESET	= 0			; Ruecksetzen von VL
.equ 	VL_VER_IMP	= 1			;
.equ 	VL_OUT_VA	= 2			;
.equ 	VL_INC_VA	= 3			;
.equ 	VL_UP_ON	= 4			; Text und Grafik UP aktivieren
.equ 	VL_UP_OFF	= 5			; Text und Grafik UP abschalten



; Hier beginnt der VIDEO-Code

	lds        R16,tcnt1l
	cpi        R16,12
	brlo       LATFIX1

LATFIX1:
	cpi        R16,13
	brlo       LATFIX2

LATFIX2:
	cpi       R16,14
	brlo      LATFIX3

LATFIX3:
	cpi       R16,15
	brlo      LATFIX4

LATFIX4:

; HORIZONTAL SYNC auf LOW
	cbi	  port_control, HSYNC


; Sichern weiterer Register
	push	  R17

	push	  zl
	push	  zh
	push	  yl
	push	  yh


; Laden des letzten Standes wichtiger Register
	lds	  yl, Wert_yl
	lds	  yh, Wert_yh

	lds	  R17, Wert_R17



; setzen des Zeigers auf die VLINE-Tabelle
	ldi	  zl,low(2*VLINE)
	ldi	  zh,high(2*VLINE)



; berechnen der aktuellen Tabellen-Position
	add	  zl,yl
	adc	  zh,yh



; lesen des Bytes aus der VLINE-Tabelle in R16
	lpm	  R16,z



; ist VL_INC_VA gesetzt, so wird die vertikale Adresse erhoeht
	sbrs	  R16,VL_INC_VA
	inc	  R17



; ist VL_RESET gesetzt, so wird die vertikale Adresse auf 0FFH gesetzt
	sbrc	  R16,VL_RESET
	ser	  R17



; inkrementieren des Adress-Offsets der VLINE-Tabelle
; fuer den naechsten Durchlauf
	adiw	  yh:yl,1



; ist VL_RESET gesetzt, so wird auch der Adress-Offset der
; VLINE-Tabelle auf 0 gesetzt
	sbrc	  R16,VL_RESET
	clr	  yl
	sbrc	  R16,VL_RESET
	clr	  yh



; Abspeichern des Wertes fuer den Adress-Offset
; fuer den naechsten Durchlauf
      	sts	  Wert_yl, yl
	sts	  Wert_yh, yh



; ist VL_VER_IMP gesetzt, so wird VSYNC auf 0 gesetzt
; ansonsten wird es auf 1 gesetzt
	sbrc	  R16, VL_VER_IMP
	cbi	  port_control, VSYNC
	sbrs	  R16, VL_VER_IMP
	sbi	  port_control, VSYNC



; HORIZONTAL SYNC wird auf HIGH gesetzt
	sbi	  port_control, HSYNC



; ist VL_OUT_VA gesetzt, so wird die vertikale Adresse ausgegeben
	sbrc	  R16,VL_OUT_VA
	out	  port_adr_hig,R17



; Abspeichern des Wertes fuer die vertikale Adresse
; fuer den naechsten Durchlauf
	sts	  Wert_R17, R17



; ist VL_OUT_VA gesetzt, so befinden wir uns im unsichtbaren Teil
; der Anzeige und es wird auf NOVID gesprungen
; Ansonsten geht es im Progeramm weiter
	sbrs	  R16,VL_OUT_VA
	rjmp      NOVID


        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP



; Abschalten des SRAMs
; WE auf 1 setzen
;	sbi       port_control,WE        ;2
; OE auf 1 setzen
;	sbi       port_control,OE        ;2



; SRAM auf Lesen stellen
	cbi       port_control,OE        ;2


; Daten-Bus auf Eingang stellen
	clr       R16                    ;1
	out       ddr_dat,R16            ;1




; Ruecksetzen der horizontalen Adresse
	clr       R16                    ;1
	out       port_adr_low,R16       ;1



; Einschalten des Video-DAC mit den Farbsignalen
	cbi       port_control,G         ;2



; ab hier wird der Inhalt des SRAMs an den Video-DAC ausgegeben

; bei 20 MHz und 256 Pixeln (512 Takte) sind das genau 25,6 us (25,4 us laut VGA)



	; PIXEL 1-10
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 11-20
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 21-30
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 31-40
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 41-50
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 51-60
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 61-70
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 71-80
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 81-90
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 91-100
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1





	; PIXEL 101-110
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1


	; PIXEL 111-120
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 121-130
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 131-140
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 141-150
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 151-160
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 161-170
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 171-180
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 181-190
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 191-200
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1






	; PIXEL 201-210
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1


	; PIXEL 211-220
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 221-230
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 231-240
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 241-250
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1



	; PIXEL 251-256
       	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1
	inc       R16                    ;1
	out       port_adr_low,R16       ;1




; Abschalten des Video-DAC mit den Farbsignalen
	sbi       port_control,G         ;2


; Abschalten des SRAMs (Standby)
	sbi       port_control, OE       ;2


        rjmp      VIDEO_END

; -----------------------------------------------



; Einsprungpunkt fuer die Austastluecke (keine Ausgabe der Videosignale)
NOVID:

; ist VL_UP_ON gesetzt, so werden alle Register fuer die weitere
; Abarbeitung der Text und Grafik Unterprogramme geladen
; Ansonsten geht es zu NOVID_OFF

	sbrs	  R16,VL_UP_ON
	rjmp      NOVID_OFF

; VL_UP_ON
; --------

; 1. Aufraumen des Stacks - Sichern aller Register,
;                           die auf den Stack geladen wurden

; 1.1. die auf dem Stack gesicherten Register - aus dem Programm


	pop       yh
	pop       yl
	pop       zh
	pop       zl
	pop       r17

; 1.2. die auf dem Stack gesicherten Register - aus der ISR

	pop       r16
	sts	  Endlos_SREG, R16

	pop       r16
	sts	  Endlos_R16, R16


; 1.3. der auf dem Stack gesicherte ProgramCounter (2 Byte)


        pop       r16

        pop       r16



; 2. Sichern der IO-Register und ihrer Werte fuer Endlos


        in        R16, port_control
        sts       Endlos_port_control, R16




; 3. Laden der IO-Register und ihrer Werte fuer Programm

	lds	  R16, Save_port_adr_low
	out       port_adr_low, R16

	lds	  R16, Save_port_adr_hig
	out       port_adr_hig, R16

	lds	  R16, Save_port_dat
	out       port_dat, R16

	lds	  R16, Save_ddr_dat
	out       ddr_dat, R16

	lds	  R16, Save_port_control
	out       port_control, R16


; ist UP_SCHLEIFE_AKTIV aktiv
        lds	  R16, UP_SCHLEIFE_AKTIV
        cpi       R16, false

        breq      NOVID_T1


; Interrupt Timer 1 aus
        LDI        R16, 0x00
        STS        TIMSK1, R16

; Interrupt Timer 3 ein
        LDI        R16, 0x02
        STS        TIMSK3, R16


NOVID_T1:

; 4. Laden des Stacks

        lds	  R16, Save_SP01
        push      r16

        lds	  R16, Save_SP02
        push      r16

        lds	  R16, Save_R16
        push      r16

        lds	  R16, Save_SREG
        push      r16


        rjmp      ISR_END


NOVID_OFF:

; ist VL_UP_OFF gesetzt, so werden alle Register fuer die
; Abarbeitung der Text und Grafik Unterprogramme abgespeichert
; und es wird wieder die kleine Entlosschleife geladen
; Ansonsten geht es zu VIDEO_END

	sbrs	  R16,VL_UP_OFF
	rjmp      VIDEO_END

; VL_UP_OFF
; ---------

; 1. Aufraumen des Stacks - Sichern aller Register,
;                           die auf den Stack geladen wurden

; 1.1. die auf dem Stack gesicherten Register - aus dem Programm


	pop       yh
	sts	  Save_R29, R29

	pop       yl
	sts	  Save_R28, R28

	pop       zh
	sts	  Save_R31, R31

	pop       zl
	sts	  Save_R30, R30

	pop       r17
	sts	  Save_R17, R17


; 1.2. die auf dem Stack gesicherten Register - aus der ISR

	pop       r16
	sts	  Save_SREG, R16

	pop       r16
	sts	  Save_R16, R16


; 1.3. der auf dem Stack gesicherte PC (2 Byte)

        pop       r16
        sts       Save_SP02, R16

        pop       r16
        sts       Save_SP01, R16


; 2. Sichern der IO-Register und ihrer Werte vom Programm

        in        R16, port_adr_low
        sts       Save_port_adr_low, R16

        in        R16, port_adr_hig
        sts       Save_port_adr_hig, R16

        in        R16, port_dat
        sts       Save_port_dat, R16

        in        R16, ddr_dat
        sts       Save_ddr_dat, R16

        in        R16, port_control
        sts       Save_port_control, R16



; 3. Laden der IO-Register und ihrer Werte fuer Endlosschleife

	lds	  R16, Endlos_port_control
	out       port_control, R16



; Daten-Bus auf Ausgang stellen
	clr       R16
	out       ddr_dat, R16




; 4. Laden des Stacks

        lds	  R16, Endlos_SP01
        push      r16

        lds	  R16, Endlos_SP02
        push      r16

        lds	  R16, Endlos_R16
        push      r16

        lds	  R16, Endlos_SREG
        push      r16


        rjmp      ISR_END




VIDEO_END:

	pop       yh
	pop       yl
	pop       zh
	pop       zl

	pop       r17

ISR_END:



 
 
; ISR - Ende
        POP        R16
        OUT        SREG,R16
        POP        R16
        RETI
 
; ISR - Einsprung
TIMER3_COMPA:
        PUSH       R16
        IN         R16,SREG
        PUSH       R16
 
; ASM
; HORIZONTAL SYNC auf LOW
	cbi	  port_control, HSYNC


; Sichern weiterer Register

	push	  zl
	push	  zh
	push	  yl
	push	  yh


; Laden des letzten Standes wichtiger Register
	lds	  yl, Wert_yl
	lds	  yh, Wert_yh


; setzen des Zeigers auf die VLINE-Tabelle
	ldi	  zl,low(2*VLINE)
	ldi	  zh,high(2*VLINE)


; berechnen der aktuellen Tabellen-Position
	add	  zl,yl
	adc	  zh,yh


; lesen des Bytes aus der VLINE-Tabelle in R16
	lpm	  R16,z


; inkrementieren des Adress-Offsets der VLINE-Tabelle
; fuer den naechsten Durchlauf
	adiw	  yh:yl,1


; ist VL_RESET gesetzt, so wird auch der Adress-Offset der
; VLINE-Tabelle auf 0 gesetzt
	sbrc	  R16,VL_RESET
	clr	  yl
	sbrc	  R16,VL_RESET
	clr	  yh


; Abspeichern des Wertes fuer den Adress-Offset
; fuer den naechsten Durchlauf
      	sts	  Wert_yl, yl
	sts	  Wert_yh, yh


; ist VL_VER_IMP gesetzt, so wird VSYNC auf 0 gesetzt
; ansonsten wird es auf 1 gesetzt
	sbrc	  R16, VL_VER_IMP
	cbi	  port_control, VSYNC
	sbrs	  R16, VL_VER_IMP
	sbi	  port_control, VSYNC


; HORIZONTAL SYNC wird auf HIGH gesetzt
	sbi	  port_control, HSYNC


; ist VL_OUT_VA gesetzt, so befinden wir uns im unsichtbaren Teil
; der Anzeige und es wird auf NOVID gesprungen
; Ansonsten geht es im Progeramm weiter
	sbrc	  R16,VL_OUT_VA
        rjmp      VIDEO_END2


; -----------------------------------------------


; ist VL_UP_OFF gesetzt, so werden alle Register fuer die
; Abarbeitung der Text und Grafik Unterprogramme abgespeichert
; und es wird wieder die kleine Entlosschleife geladen
; Ansonsten geht es zu VIDEO_END2

	sbrs	  R16,VL_UP_OFF
	rjmp      VIDEO_END2


; VL_UP_OFF2
; ---------


; ist UP_SCHLEIFE_AKTIV deaktiviert,
; dann wird T3 beendet und T1 aktiviert
;
        lds	  R16, UP_SCHLEIFE_AKTIV
	sbrc	  R16, 0                  ; wenn false (R16=0) dann ...
	rjmp      VIDEO_END2


        ; ... Umschalten T3 und T1


; Interrupt Timer 1 ein
        LDI        R16, 0x02
        STS        TIMSK1, R16

; Interrupt Timer 3 aus
        LDI        R16, 0x00
        STS        TIMSK3, R16



; 1. Aufraumen des Stacks - Sichern aller Register,
;                           die auf den Stack geladen wurden

; 1.1. die auf dem Stack gesicherten Register - aus dem Programm


	pop       yh
	sts	  Save_R29, R29

	pop       yl
	sts	  Save_R28, R28

	pop       zh
	sts	  Save_R31, R31

	pop       zl
	sts	  Save_R30, R30



; 1.2. die auf dem Stack gesicherten Register - aus der ISR

	pop       r16
	sts	  Save_SREG, R16

	pop       r16
	sts	  Save_R16, R16


; 1.3. der auf dem Stack gesicherte PC (2 Byte)

        pop       r16
        sts       Save_SP02, R16

        pop       r16
        sts       Save_SP01, R16


; 2. Sichern der IO-Register und ihrer Werte vom Programm

        in        R16, port_adr_low
        sts       Save_port_adr_low, R16

        in        R16, port_adr_hig
        sts       Save_port_adr_hig, R16

        in        R16, port_dat
        sts       Save_port_dat, R16

        in        R16, ddr_dat
        sts       Save_ddr_dat, R16

        in        R16, port_control
        sts       Save_port_control, R16



; 3. Laden der IO-Register und ihrer Werte fuer Endlosschleife

	lds	  R16, Endlos_port_control
	out       port_control, R16



; Daten-Bus auf Ausgang stellen
	clr       R16
	out       ddr_dat, R16


; 4. Laden des Stacks

        lds	  R16, Endlos_SP01
        push      r16

        lds	  R16, Endlos_SP02
        push      r16

        lds	  R16, Endlos_R16
        push      r16

        lds	  R16, Endlos_SREG
        push      r16


        rjmp      ISR_END2



VIDEO_END2:

	pop       yh
	pop       yl
	pop       zh
	pop       zl


ISR_END2:



 
 
; ISR - Ende
        POP        R16
        OUT        SREG,R16
        POP        R16
        RETI
 
; PROCEDURE - Anfang (CLEAR_RAM)
CLEAR_RAM:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; SetBit(WE)
        SBI        PORTD, 5
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0100)
        LDI        R16, LOW(0x0100)
        LDI        R17, HIGH(0x0100)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_075:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_076
        RJMP       M_FTD_077
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_076:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X2)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x00F0)
        LDI        R16, LOW(0x00F0)
        LDI        R17, HIGH(0x00F0)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_078:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_079
        RJMP       M_FTD_080
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_079:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R5
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; ClearBit(WE)
        CBI        PORTD, 5
 
; INC(ADRESSE) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; SetBit(WE)
        SBI        PORTD, 5
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_078
 
; FOR TO DO - Ende
M_FTD_080:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_075
 
; FOR TO DO - Ende
M_FTD_077:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; SetBit(WE)
        SBI        PORTD, 5
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; PROCEDURE - Ende (CLEAR_RAM)
        RET
 
; PROCEDURE - Anfang (RESET_FORM)
RESET_FORM:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLACK)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_WHITE)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_ANF)
        LDS        R16, Y_ANF
        LDS        R17, Y_ANF+1
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; PROCEDURE - Ende (RESET_FORM)
        RET
 
; PROCEDURE - Anfang (SETZE_FONT)
SETZE_FONT:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (FONTGROESSE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (FONT_BEZ)
        STS        FONT_BEZ, R16
 
; CASE OF - lokaler Uebergabeparameter (FONTGROESSE)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (FNT_6X8)
        CPI        R16, 0x01
        BREQ       M_CASE_083
        RJMP       M_CASE_082
M_CASE_083:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0006)
        LDI        R16, LOW(0x0006)
        LDI        R17, HIGH(0x0006)
 
; Zuweisung Ziel /  VAR (ZEICHENBREITE)
        STS        ZEICHENBREITE, R16
        STS        ZEICHENBREITE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0009)
        LDI        R16, LOW(0x0009)
        LDI        R17, HIGH(0x0009)
 
; Zuweisung Ziel /  VAR (ZEICHENHOEHE)
        STS        ZEICHENHOEHE, R16
        STS        ZEICHENHOEHE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  VAR (X_ANF)
        STS        X_ANF, R16
        STS        X_ANF+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0005)
        LDI        R16, LOW(0x0005)
        LDI        R17, HIGH(0x0005)
 
; Zuweisung Ziel /  VAR (Y_ANF)
        STS        Y_ANF, R16
        STS        Y_ANF+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0029)
        LDI        R16, LOW(0x0029)
        LDI        R17, HIGH(0x0029)
 
; Zuweisung Ziel /  VAR (MAX_SPALTEN0)
        STS        MAX_SPALTEN0, R16
        STS        MAX_SPALTEN0+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x002A)
        LDI        R16, LOW(0x002A)
        LDI        R17, HIGH(0x002A)
 
; Zuweisung Ziel /  VAR (MAX_SPALTEN)
        STS        MAX_SPALTEN, R16
        STS        MAX_SPALTEN+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0018)
        LDI        R16, LOW(0x0018)
        LDI        R17, HIGH(0x0018)
 
; Zuweisung Ziel /  VAR (MAX_ZEILEN0)
        STS        MAX_ZEILEN0, R16
        STS        MAX_ZEILEN0+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0019)
        LDI        R16, LOW(0x0019)
        LDI        R17, HIGH(0x0019)
 
; Zuweisung Ziel /  VAR (MAX_ZEILEN)
        STS        MAX_ZEILEN, R16
        STS        MAX_ZEILEN+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_081
M_CASE_082:
 
; CASE OF - vergleiche Einzel-Element (FNT_8X8)
        CPI        R16, 0x02
        BREQ       M_CASE_085
        RJMP       M_CASE_084
M_CASE_085:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0008)
        LDI        R16, LOW(0x0008)
        LDI        R17, HIGH(0x0008)
 
; Zuweisung Ziel /  VAR (ZEICHENBREITE)
        STS        ZEICHENBREITE, R16
        STS        ZEICHENBREITE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0009)
        LDI        R16, LOW(0x0009)
        LDI        R17, HIGH(0x0009)
 
; Zuweisung Ziel /  VAR (ZEICHENHOEHE)
        STS        ZEICHENHOEHE, R16
        STS        ZEICHENHOEHE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  VAR (X_ANF)
        STS        X_ANF, R16
        STS        X_ANF+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0005)
        LDI        R16, LOW(0x0005)
        LDI        R17, HIGH(0x0005)
 
; Zuweisung Ziel /  VAR (Y_ANF)
        STS        Y_ANF, R16
        STS        Y_ANF+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x001F)
        LDI        R16, LOW(0x001F)
        LDI        R17, HIGH(0x001F)
 
; Zuweisung Ziel /  VAR (MAX_SPALTEN0)
        STS        MAX_SPALTEN0, R16
        STS        MAX_SPALTEN0+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0020)
        LDI        R16, LOW(0x0020)
        LDI        R17, HIGH(0x0020)
 
; Zuweisung Ziel /  VAR (MAX_SPALTEN)
        STS        MAX_SPALTEN, R16
        STS        MAX_SPALTEN+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0018)
        LDI        R16, LOW(0x0018)
        LDI        R17, HIGH(0x0018)
 
; Zuweisung Ziel /  VAR (MAX_ZEILEN0)
        STS        MAX_ZEILEN0, R16
        STS        MAX_ZEILEN0+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0019)
        LDI        R16, LOW(0x0019)
        LDI        R17, HIGH(0x0019)
 
; Zuweisung Ziel /  VAR (MAX_ZEILEN)
        STS        MAX_ZEILEN, R16
        STS        MAX_ZEILEN+1, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_081
 
; CASE OF ELSE
M_CASE_084:
 
; ENDCASE;
M_CASE_081:
 
; PROCEDURE - Ende (SETZE_FONT)
        RET
 
; PROCEDURE - Anfang (SCHREIBE_IMAGE_OT)
SCHREIBE_IMAGE_OT:
 
; SetBit(WE)
        SBI        PORTD, 5
 
; SetBit(OE)
        SBI        PORTD, 6
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R5, R16
        MOV        R6, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R5
        MOV        R17, R6
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0100)
        LDI        R18, LOW(0x0100)
        LDI        R19, HIGH(0x0100)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R5, R16
        MOV        R6, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R5
        MOV        R17, R6
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R5, R16
        MOV        R6, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_POINTER)
        MOV        R7, R16
        MOV        R8, R17
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B_POINTER)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CPM_ON_Z80)
        CLR        R28
        LDI        R29, Byte3(2*CPM_ON_Z80)
        LDI        ZL, LOW(2*CPM_ON_Z80)
        LDI        ZH, HIGH(2*CPM_ON_Z80)
        ADD        ZL, R16
        ADC        ZH, R17
        ADC        R29, R28
        OUT        RAMPZ, R29
        ELPM       R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_BIS)
        MOV        R2, R16
 
; INC(B_POINTER) - Word
        MOV        R24, R7
        MOV        R25, R8
        ADIW       R25:R24, 1
        MOV        R7, R24
        MOV        R8, R25
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(X_BIS)
        MOV        R16, R2
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (OFFSET)
        MOV        R9, R16
        MOV        R10, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Zahlenwert (0x0100)
        LDI        R16, LOW(0x0100)
        LDI        R17, HIGH(0x0100)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (OFFSET)
        MOV        R18, R9
        MOV        R19, R10
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (OFFSET)
        MOV        R9, R16
        MOV        R10, R17
 
; DEC(X_BIS) - Byte
        DEC        R2
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B_POINTER)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CPM_ON_Z80)
        CLR        R28
        LDI        R29, Byte3(2*CPM_ON_Z80)
        LDI        ZL, LOW(2*CPM_ON_Z80)
        LDI        ZH, HIGH(2*CPM_ON_Z80)
        ADD        ZL, R16
        ADC        ZH, R17
        ADC        R29, R28
        OUT        RAMPZ, R29
        ELPM       R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_BIS)
        MOV        R3, R16
 
; INC(B_POINTER) - Word
        MOV        R24, R7
        MOV        R25, R8
        ADIW       R25:R24, 1
        MOV        R7, R24
        MOV        R8, R25
 
; DEC(Y_BIS) - Byte
        DEC        R3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R1, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (Y_BIS)
        MOV        R16, R3
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R1
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_086:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_087
        RJMP       M_FTD_088
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_087:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (X_BIS)
        MOV        R16, R2
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_089:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_090
        RJMP       M_FTD_091
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_090:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B_POINTER)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CPM_ON_Z80)
        CLR        R28
        LDI        R29, Byte3(2*CPM_ON_Z80)
        LDI        ZL, LOW(2*CPM_ON_Z80)
        LDI        ZH, HIGH(2*CPM_ON_Z80)
        ADD        ZL, R16
        ADC        ZH, R17
        ADC        R29, R28
        OUT        RAMPZ, R29
        ELPM       R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R5
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R6
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; ClearBit(WE)
        CBI        PORTD, 5
 
; INC(ADRESSE) - Word
        MOV        R24, R5
        MOV        R25, R6
        ADIW       R25:R24, 1
        MOV        R5, R24
        MOV        R6, R25
 
; INC(B_POINTER) - Word
        MOV        R24, R7
        MOV        R25, R8
        ADIW       R25:R24, 1
        MOV        R7, R24
        MOV        R8, R25
 
; SetBit(WE)
        SBI        PORTD, 5
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_089
 
; FOR TO DO - Ende
M_FTD_091:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R5
        MOV        R17, R6
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (OFFSET)
        MOV        R18, R9
        MOV        R19, R10
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R5, R16
        MOV        R6, R17
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R1
        INC        R17
        MOV        R1, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_086
 
; FOR TO DO - Ende
M_FTD_088:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; SetBit(WE)
        SBI        PORTD, 5
 
; PROCEDURE - Ende (SCHREIBE_IMAGE_OT)
        RET
 
; PROCEDURE - Anfang (WRITE_CHAR_6X8)
WRITE_CHAR_6X8:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; SetBit(WE)
        SBI        PORTD, 5
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R16, ZEICHEN
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTPTR)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0020)
        LDI        R18, LOW(0x0020)
        LDI        R19, HIGH(0x0020)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTPTR)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0008)
        LDI        R18, LOW(0x0008)
        LDI        R19, HIGH(0x0008)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTPTR)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0100)
        LDI        R18, LOW(0x0100)
        LDI        R19, HIGH(0x0100)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0007)
        LDI        R16, LOW(0x0007)
        LDI        R17, HIGH(0x0007)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_092:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_093
        RJMP       M_FTD_094
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_093:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (FONT6X8)
        CLR        R28
        LDI        R29, Byte3(2*FONT6X8)
        LDI        ZL, LOW(2*FONT6X8)
        LDI        ZH, HIGH(2*FONT6X8)
        ADD        ZL, R16
        ADC        ZH, R17
        ADC        R29, R28
        OUT        RAMPZ, R29
        ELPM       R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R7, R16
 
; INC(FONTPTR) - Word
        MOV        R24, R0
        MOV        R25, R1
        ADIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; SHR(FONTZEILE) - Byte
        LSR        R7
 
; SHR(FONTZEILE) - Byte
        LSR        R7
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (ZEICHENBREITE)
        LDS        R16, ZEICHENBREITE
        LDS        R17, ZEICHENBREITE+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_095:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_096
        RJMP       M_FTD_097
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_096:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R16, R7
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0101
        CLR        R16
        RJMP       M_VERGL_0102
M_VERGL_0101:
        SER        R16
M_VERGL_0102:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_098
        RJMP       M_IF_099
M_IF_098:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (BCOLOR)
        LDS        R16, BCOLOR
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0100
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_099:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FCOLOR)
        LDS        R16, FCOLOR
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; IF_THEN_ELSE - Ende
M_IF_0100:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R8
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R9
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; ClearBit(WE)
        CBI        PORTD, 5
 
; SHR(FONTZEILE) - Byte
        LSR        R7
 
; INC(ADRESSE) - Word
        MOV        R24, R8
        MOV        R25, R9
        ADIW       R25:R24, 1
        MOV        R8, R24
        MOV        R9, R25
 
; SetBit(WE)
        SBI        PORTD, 5
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_095
 
; FOR TO DO - Ende
M_FTD_097:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x00FA)
        LDI        R18, LOW(0x00FA)
        LDI        R19, HIGH(0x00FA)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R8, R16
        MOV        R9, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_092
 
; FOR TO DO - Ende
M_FTD_094:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; SetBit(WE)
        SBI        PORTD, 5
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; PROCEDURE - Ende (WRITE_CHAR_6X8)
        RET
 
; PROCEDURE - Anfang (WRITE_CHAR_8X8)
WRITE_CHAR_8X8:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; SetBit(WE)
        SBI        PORTD, 5
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R16, ZEICHEN
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTPTR)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0020)
        LDI        R18, LOW(0x0020)
        LDI        R19, HIGH(0x0020)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTPTR)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0008)
        LDI        R18, LOW(0x0008)
        LDI        R19, HIGH(0x0008)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTPTR)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0100)
        LDI        R18, LOW(0x0100)
        LDI        R19, HIGH(0x0100)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_PIX_POS)
        LDS        R18, X_PIX_POS
        LDS        R19, X_PIX_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R8, R16
        MOV        R9, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y_CNT)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0007)
        LDI        R16, LOW(0x0007)
        LDI        R17, HIGH(0x0007)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0103:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0104
        RJMP       M_FTD_0105
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0104:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (FONTPTR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (FONT8X8)
        CLR        R28
        LDI        R29, Byte3(2*FONT8X8)
        LDI        ZL, LOW(2*FONT8X8)
        LDI        ZH, HIGH(2*FONT8X8)
        ADD        ZL, R16
        ADC        ZH, R17
        ADC        R29, R28
        OUT        RAMPZ, R29
        ELPM       R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R7, R16
 
; INC(FONTPTR) - Word
        MOV        R24, R0
        MOV        R25, R1
        ADIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X_CNT)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (ZEICHENBREITE)
        LDS        R16, ZEICHENBREITE
        LDS        R17, ZEICHENBREITE+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0106:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0107
        RJMP       M_FTD_0108
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0107:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTZEILE)
        MOV        R16, R7
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (FONTCOLOR)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0112
        CLR        R16
        RJMP       M_VERGL_0113
M_VERGL_0112:
        SER        R16
M_VERGL_0113:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0109
        RJMP       M_IF_0110
M_IF_0109:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (BCOLOR)
        LDS        R16, BCOLOR
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0111
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0110:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FCOLOR)
        LDS        R16, FCOLOR
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; IF_THEN_ELSE - Ende
M_IF_0111:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADRESSE)
        MOV        R16, R8
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADRESSE)
        MOV        R16, R9
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; ClearBit(WE)
        CBI        PORTD, 5
 
; SHR(FONTZEILE) - Byte
        LSR        R7
 
; INC(ADRESSE) - Word
        MOV        R24, R8
        MOV        R25, R9
        ADIW       R25:R24, 1
        MOV        R8, R24
        MOV        R9, R25
 
; SetBit(WE)
        SBI        PORTD, 5
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0106
 
; FOR TO DO - Ende
M_FTD_0108:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADRESSE)
        MOV        R16, R8
        MOV        R17, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x00F8)
        LDI        R18, LOW(0x00F8)
        LDI        R19, HIGH(0x00F8)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADRESSE)
        MOV        R8, R16
        MOV        R9, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0103
 
; FOR TO DO - Ende
M_FTD_0105:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; SetBit(WE)
        SBI        PORTD, 5
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; PROCEDURE - Ende (WRITE_CHAR_8X8)
        RET
 
; PROCEDURE - Anfang (WRITE_CHAR)
WRITE_CHAR:
 
; CASE OF - Byte-VAR (FONT_BEZ)
        LDS        R16, FONT_BEZ
 
; CASE OF - vergleiche Einzel-Element (FNT_6X8)
        CPI        R16, 0x01
        BREQ       M_CASE_0116
        RJMP       M_CASE_0115
M_CASE_0116:
 
; Aufruf PROCEDURE (WRITE_CHAR_6X8)
        CALL       WRITE_CHAR_6X8
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0114
M_CASE_0115:
 
; CASE OF - vergleiche Einzel-Element (FNT_8X8)
        CPI        R16, 0x02
        BREQ       M_CASE_0118
        RJMP       M_CASE_0117
M_CASE_0118:
 
; Aufruf PROCEDURE (WRITE_CHAR_8X8)
        CALL       WRITE_CHAR_8X8
 
; ENDCASE;
M_CASE_0117:
M_CASE_0114:
 
; PROCEDURE - Ende (WRITE_CHAR)
        RET
 
; PROCEDURE - Anfang (CURSOR_RIGHT)
CURSOR_RIGHT:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (MAX_SPALTEN0)
        LDS        R18, MAX_SPALTEN0
        LDS        R19, MAX_SPALTEN0+1
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0122
        CLR        R16
        RJMP       M_VERGL_0123
M_VERGL_0122:
        SER        R16
M_VERGL_0123:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0119
        RJMP       M_IF_0120
M_IF_0119:
 
; INC(X_KUR_POS) - Word
        LDS        R24, X_KUR_POS
        LDS        R25, X_KUR_POS+1
        ADIW       R25:R24, 1
        STS        X_KUR_POS, R24
        STS        X_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; IF_THEN - Ende
M_IF_0120:
 
; PROCEDURE - Ende (CURSOR_RIGHT)
        RET
 
; PROCEDURE - Anfang (CURSOR_UP)
CURSOR_UP:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0127
        CLR        R16
        RJMP       M_VERGL_0128
M_VERGL_0127:
        SER        R16
M_VERGL_0128:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0124
        RJMP       M_IF_0125
M_IF_0124:
 
; DEC(Y_KUR_POS) - Word
        LDS        R24, Y_KUR_POS
        LDS        R25, Y_KUR_POS+1
        SBIW       R25:R24, 1
        STS        Y_KUR_POS, R24
        STS        Y_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENHOEHE)
        LDS        R18, ZEICHENHOEHE
        LDS        R19, ZEICHENHOEHE+1
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; IF_THEN - Ende
M_IF_0125:
 
; PROCEDURE - Ende (CURSOR_UP)
        RET
 
; PROCEDURE - Anfang (CURSOR_DOWN)
CURSOR_DOWN:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (MAX_ZEILEN0)
        LDS        R18, MAX_ZEILEN0
        LDS        R19, MAX_ZEILEN0+1
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0132
        CLR        R16
        RJMP       M_VERGL_0133
M_VERGL_0132:
        SER        R16
M_VERGL_0133:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0129
        RJMP       M_IF_0130
M_IF_0129:
 
; INC(Y_KUR_POS) - Word
        LDS        R24, Y_KUR_POS
        LDS        R25, Y_KUR_POS+1
        ADIW       R25:R24, 1
        STS        Y_KUR_POS, R24
        STS        Y_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENHOEHE)
        LDS        R18, ZEICHENHOEHE
        LDS        R19, ZEICHENHOEHE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; IF_THEN - Ende
M_IF_0130:
 
; PROCEDURE - Ende (CURSOR_DOWN)
        RET
 
; PROCEDURE - Anfang (DELETE_EOL)
DELETE_EOL:
 
; PROCEDURE - Ende (DELETE_EOL)
        RET
 
; PROCEDURE - Anfang (ERASE_DOWN)
ERASE_DOWN:
 
; PROCEDURE - Ende (ERASE_DOWN)
        RET
 
; PROCEDURE - Anfang (DELETE_LINE)
DELETE_LINE:
 
; PROCEDURE - Ende (DELETE_LINE)
        RET
 
; PROCEDURE - Anfang (DELETE_BOL)
DELETE_BOL:
 
; PROCEDURE - Ende (DELETE_BOL)
        RET
 
; PROCEDURE - Anfang (INSERT_LINE_SCR_ROLL)
INSERT_LINE_SCR_ROLL:
 
; PROCEDURE - Ende (INSERT_LINE_SCR_ROLL)
        RET
 
; PROCEDURE - Anfang (DELETE_LINE_SCR_ROLL)
DELETE_LINE_SCR_ROLL:
 
; PROCEDURE - Ende (DELETE_LINE_SCR_ROLL)
        RET
 
; PROCEDURE - Anfang (SET_CURSOR_POSITION)
SET_CURSOR_POSITION:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (SPALTE)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (MAX_SPALTEN0)
        LDS        R18, MAX_SPALTEN0
        LDS        R19, MAX_SPALTEN0+1
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0137
        CLR        R16
        RJMP       M_VERGL_0138
M_VERGL_0137:
        SER        R16
M_VERGL_0138:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0134
        RJMP       M_IF_0135
M_IF_0134:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (MAX_SPALTEN0)
        LDS        R16, MAX_SPALTEN0
        LDS        R17, MAX_SPALTEN0+1
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; IF_THEN - Ende
M_IF_0135:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENBREITE)
        LDS        R18, ZEICHENBREITE
        LDS        R19, ZEICHENBREITE+1
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (X_PIX_POS)
        LDS        R16, X_PIX_POS
        LDS        R17, X_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_ANF)
        LDS        R18, X_ANF
        LDS        R19, X_ANF+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (ZEILE)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (MAX_ZEILEN0)
        LDS        R18, MAX_ZEILEN0
        LDS        R19, MAX_ZEILEN0+1
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0142
        CLR        R16
        RJMP       M_VERGL_0143
M_VERGL_0142:
        SER        R16
M_VERGL_0143:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0139
        RJMP       M_IF_0140
M_IF_0139:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (MAX_ZEILEN0)
        LDS        R16, MAX_ZEILEN0
        LDS        R17, MAX_ZEILEN0+1
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; IF_THEN - Ende
M_IF_0140:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENHOEHE)
        LDS        R18, ZEICHENHOEHE
        LDS        R19, ZEICHENHOEHE+1
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (Y_ANF)
        LDS        R18, Y_ANF
        LDS        R19, Y_ANF+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; PROCEDURE - Ende (SET_CURSOR_POSITION)
        RET
 
; PROCEDURE - Anfang (ANZEIGE_BWS)
ANZEIGE_BWS:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FCOLOR)
        LDS        R16, FCOLOR
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SICHERUNG_FCOLOR)
        MOV        R6, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (BWS_OFFSET)
        STS        BWS_OFFSET, R16
        STS        BWS_OFFSET+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (ANZEIGE_BWS)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf PROCEDURE (RESET_FORM)
        CALL       RESET_FORM
 
; Retten der Parameter-Register fuer PROCEDURE (ANZEIGE_BWS)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Word-VAR (BWS_OFFSET)
        LDS        R16, BWS_OFFSET
        LDS        R17, BWS_OFFSET+1
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (OFFSET_SPALTEN)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Y1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (MAX_ZEILEN)
        LDS        R16, MAX_ZEILEN
        LDS        R17, MAX_ZEILEN+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0144:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0145
        RJMP       M_FTD_0146
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0145:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X1)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Word-VAR (MAX_SPALTEN)
        LDS        R16, MAX_SPALTEN
        LDS        R17, MAX_SPALTEN+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0147:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0148
        RJMP       M_FTD_0149
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0148:
 
; ARRAY - Ausdruck / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; ARRAY - Ausdruck / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (BWS_FCOLOR)
        LDI        ZL, LOW(BWS_FCOLOR)
        LDI        ZH, HIGH(BWS_FCOLOR)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ANZEIGE_BWS)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (ANZEIGE_BWS)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (ANZEIGE_BWS)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf PROCEDURE (CURSOR_RIGHT)
        CALL       CURSOR_RIGHT
 
; Retten der Parameter-Register fuer PROCEDURE (ANZEIGE_BWS)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; INC(BWS_POS) - Word
        LDS        R24, BWS_POS
        LDS        R25, BWS_POS+1
        ADIW       R25:R24, 1
        STS        BWS_POS, R24
        STS        BWS_POS+1, R25
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0147
 
; FOR TO DO - Ende
M_FTD_0149:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ANZEIGE_BWS)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf PROCEDURE (CURSOR_DOWN)
        CALL       CURSOR_DOWN
 
; Retten der Parameter-Register fuer PROCEDURE (ANZEIGE_BWS)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0144
 
; FOR TO DO - Ende
M_FTD_0146:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ANZEIGE_BWS)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf PROCEDURE (RESET_FORM)
        CALL       RESET_FORM
 
; Retten der Parameter-Register fuer PROCEDURE (ANZEIGE_BWS)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Word-VAR (BWS_OFFSET)
        LDS        R16, BWS_OFFSET
        LDS        R17, BWS_OFFSET+1
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (SICHERUNG_FCOLOR)
        MOV        R16, R6
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; PROCEDURE - Ende (ANZEIGE_BWS)
        RET
 
; PROCEDURE - Anfang (SCHREIBE_ZEICHEN_IN_BWS)
SCHREIBE_ZEICHEN_IN_BWS:
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; VAR ARRAY Ziel Zeiger berechnen (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; Zuweisung Ziel /  VAR ARRAY (BWS)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; VAR ARRAY Ziel Zeiger berechnen (BWS_FCOLOR)
        LDI        ZL, LOW(BWS_FCOLOR)
        LDI        ZH, HIGH(BWS_FCOLOR)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FCOLOR)
        LDS        R16, FCOLOR
 
; Zuweisung Ziel /  VAR ARRAY (BWS_FCOLOR)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (LAENGE_BWS)
        LDI        R18, LOW(0x07CF)
        LDI        R19, HIGH(0x07CF)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0153
        CLR        R16
        RJMP       M_VERGL_0154
M_VERGL_0153:
        SER        R16
M_VERGL_0154:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0150
        RJMP       M_IF_0151
M_IF_0150:
 
; INC(BWS_POS) - Word
        LDS        R24, BWS_POS
        LDS        R25, BWS_POS+1
        ADIW       R25:R24, 1
        STS        BWS_POS, R24
        STS        BWS_POS+1, R25
 
; IF_THEN - Ende
M_IF_0151:
 
; PROCEDURE - Ende (SCHREIBE_ZEICHEN_IN_BWS)
        RET
 
; PROCEDURE - Anfang (SCREEN_ROLL_UP)
SCREEN_ROLL_UP:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Konstante CONST (ANZAHL_ZEILEN0)
        LDI        R16, LOW(0x0018)
        LDI        R17, HIGH(0x0018)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (ANZAHL_SPALTEN)
        LDI        R18, LOW(0x002A)
        LDI        R19, HIGH(0x002A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W3)
        MOV        R4, R16
        MOV        R5, R17
 
; DEC(W3) - Word
        MOV        R24, R4
        MOV        R25, R5
        SBIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ANZAHL_SPALTEN)
        LDI        R16, LOW(0x002A)
        LDI        R17, HIGH(0x002A)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (W3)
        MOV        R16, R4
        MOV        R17, R5
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0155:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0156
        RJMP       M_FTD_0157
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0156:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (W2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KOPIE_ZEICHEN)
        MOV        R6, R16
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (W2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (BWS_FCOLOR)
        LDI        ZL, LOW(BWS_FCOLOR)
        LDI        ZH, HIGH(BWS_FCOLOR)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KOPIE_FCOLOR)
        MOV        R7, R16
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (W1)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (KOPIE_ZEICHEN)
        MOV        R16, R6
 
; Zuweisung Ziel /  VAR ARRAY (BWS)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (W1)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (BWS_FCOLOR)
        LDI        ZL, LOW(BWS_FCOLOR)
        LDI        ZH, HIGH(BWS_FCOLOR)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (KOPIE_FCOLOR)
        MOV        R16, R7
 
; Zuweisung Ziel /  VAR ARRAY (BWS_FCOLOR)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(W2) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0155
 
; FOR TO DO - Ende
M_FTD_0157:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; INC(W3) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W3)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LAENGE_BWS)
        LDI        R16, LOW(0x07CF)
        LDI        R17, HIGH(0x07CF)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0158:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0159
        RJMP       M_FTD_0160
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0159:
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (W1)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FUELLBYTE)
        LDS        R16, FUELLBYTE
 
; Zuweisung Ziel /  VAR ARRAY (BWS)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (W1)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (BWS_FCOLOR)
        LDI        ZL, LOW(BWS_FCOLOR)
        LDI        ZH, HIGH(BWS_FCOLOR)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLACK)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR ARRAY (BWS_FCOLOR)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0158
 
; FOR TO DO - Ende
M_FTD_0160:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (W3)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; PROCEDURE - Ende (SCREEN_ROLL_UP)
        RET
 
; PROCEDURE - Anfang (LOESCHE_BWS)
LOESCHE_BWS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEICHEN_ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LAENGE_BWS)
        LDI        R16, LOW(0x07CF)
        LDI        R17, HIGH(0x07CF)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0161:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0162
        RJMP       M_FTD_0163
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0162:
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (ZEICHEN_ZAEHLER)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FUELLBYTE)
        LDS        R16, FUELLBYTE
 
; Zuweisung Ziel /  VAR ARRAY (BWS)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (ZEICHEN_ZAEHLER)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (BWS_FCOLOR)
        LDI        ZL, LOW(BWS_FCOLOR)
        LDI        ZH, HIGH(BWS_FCOLOR)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLACK)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR ARRAY (BWS_FCOLOR)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0161
 
; FOR TO DO - Ende
M_FTD_0163:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; PROCEDURE - Ende (LOESCHE_BWS)
        RET
 
; PROCEDURE - Anfang (BERECHNE_BWS_POS)
BERECHNE_BWS_POS:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (MAX_SPALTEN)
        LDS        R18, MAX_SPALTEN
        LDS        R19, MAX_SPALTEN+1
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (X_KUR_POS)
        LDS        R18, X_KUR_POS
        LDS        R19, X_KUR_POS+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; PROCEDURE - Ende (BERECHNE_BWS_POS)
        RET
 
; PROCEDURE - Anfang (SCHALTE_KURSOR_EIN)
SCHALTE_KURSOR_EIN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x5F)
        LDI        R16, 0x5F
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; PROCEDURE - Ende (SCHALTE_KURSOR_EIN)
        RET
 
; PROCEDURE - Anfang (SCHALTE_KURSOR_AUS)
SCHALTE_KURSOR_AUS:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ALTES_ZEICHEN)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHALTE_KURSOR_AUS)
        PUSH       R0
 
; Aufruf PROCEDURE (BERECHNE_BWS_POS)
        CALL       BERECHNE_BWS_POS
 
; Retten der Parameter-Register fuer PROCEDURE (SCHALTE_KURSOR_AUS)
        POP        R0
 
; ARRAY - Ausdruck / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHALTE_KURSOR_AUS)
        PUSH       R0
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (SCHALTE_KURSOR_AUS)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (ALTES_ZEICHEN)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; PROCEDURE - Ende (SCHALTE_KURSOR_AUS)
        RET
 
; PROCEDURE - Anfang (NORMAL_TERMINAL_MODE)
NORMAL_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Einzel-Element (MONITOR_LINKS)
        CPI        R16, 0x01
        BREQ       M_CASE_0166
        RJMP       M_CASE_0165
M_CASE_0166:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLACK)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0164
M_CASE_0165:
 
; CASE OF - vergleiche Einzel-Element (MONITOR_RECHTS)
        CPI        R16, 0x02
        BREQ       M_CASE_0168
        RJMP       M_CASE_0167
M_CASE_0168:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_RED)
        LDI        R16, 0x43
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0164
M_CASE_0167:
 
; CASE OF - vergleiche Einzel-Element ($0A)
        CPI        R16, 0x0A
        BREQ       M_CASE_0170
        RJMP       M_CASE_0169
M_CASE_0170:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (MAX_ZEILEN0)
        LDS        R18, MAX_ZEILEN0
        LDS        R19, MAX_ZEILEN0+1
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0174
        CLR        R16
        RJMP       M_VERGL_0175
M_VERGL_0174:
        SER        R16
M_VERGL_0175:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0171
        RJMP       M_IF_0172
M_IF_0171:
 
; INC(Y_KUR_POS) - Word
        LDS        R24, Y_KUR_POS
        LDS        R25, Y_KUR_POS+1
        ADIW       R25:R24, 1
        STS        Y_KUR_POS, R24
        STS        Y_KUR_POS+1, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENHOEHE)
        LDS        R18, ZEICHENHOEHE
        LDS        R19, ZEICHENHOEHE+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0173
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0172:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (UP_SCHLEIFE_AKTIV)
        STS        UP_SCHLEIFE_AKTIV, R16
 
; IF THEN - Ausdruck / Byte-VAR (GRAFIK_IM_BWS)
        LDS        R16, GRAFIK_IM_BWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0176
        RJMP       M_IF_0177
M_IF_0176:
 
; Retten der lokalen Parameter fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (CLEAR_RAM)
        CALL       CLEAR_RAM
 
; Retten der Parameter-Register fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (GRAFIK_IM_BWS)
        STS        GRAFIK_IM_BWS, R16
 
; IF_THEN - Ende
M_IF_0177:
 
; Retten der lokalen Parameter fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCREEN_ROLL_UP)
        CALL       SCREEN_ROLL_UP
 
; Retten der Parameter-Register fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (ANZEIGE_BWS)
        CALL       ANZEIGE_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (UP_SCHLEIFE_AKTIV)
        STS        UP_SCHLEIFE_AKTIV, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (MAX_ZEILEN0)
        LDS        R16, MAX_ZEILEN0
        LDS        R17, MAX_ZEILEN0+1
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (MAX_ZEILEN0)
        LDS        R16, MAX_ZEILEN0
        LDS        R17, MAX_ZEILEN0+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENHOEHE)
        LDS        R18, ZEICHENHOEHE
        LDS        R19, ZEICHENHOEHE+1
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (Y_ANF)
        LDS        R18, Y_ANF
        LDS        R19, Y_ANF+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; IF_THEN_ELSE - Ende
M_IF_0173:
 
; Retten der lokalen Parameter fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (BERECHNE_BWS_POS)
        CALL       BERECHNE_BWS_POS
 
; Retten der Parameter-Register fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0164
M_CASE_0169:
 
; CASE OF - vergleiche Einzel-Element ($0C)
        CPI        R16, 0x0C
        BREQ       M_CASE_0180
        RJMP       M_CASE_0179
M_CASE_0180:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (UP_SCHLEIFE_AKTIV)
        STS        UP_SCHLEIFE_AKTIV, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (LOESCHE_BWS)
        CALL       LOESCHE_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (ANZEIGE_BWS)
        CALL       ANZEIGE_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (RESET_FORM)
        CALL       RESET_FORM
 
; Retten der Parameter-Register fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck / Byte-VAR (STARTBILDSCHIRM)
        LDS        R16, STARTBILDSCHIRM
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0181
        RJMP       M_IF_0182
M_IF_0181:
 
; Retten der lokalen Parameter fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCHREIBE_IMAGE_OT)
        CALL       SCHREIBE_IMAGE_OT
 
; Retten der Parameter-Register fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0005)
        LDI        R16, LOW(0x0005)
        LDI        R17, HIGH(0x0005)
 
; Zuweisung Ziel /  VAR (Y_KUR_POS)
        STS        Y_KUR_POS, R16
        STS        Y_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_KUR_POS)
        LDS        R16, Y_KUR_POS
        LDS        R17, Y_KUR_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (ZEICHENHOEHE)
        LDS        R18, ZEICHENHOEHE
        LDS        R19, ZEICHENHOEHE+1
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (Y_PIX_POS)
        LDS        R16, Y_PIX_POS
        LDS        R17, Y_PIX_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Word-VAR (Y_ANF)
        LDS        R18, Y_ANF
        LDS        R19, Y_ANF+1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (STARTBILDSCHIRM)
        STS        STARTBILDSCHIRM, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (GRAFIK_IM_BWS)
        STS        GRAFIK_IM_BWS, R16
 
; IF_THEN - Ende
M_IF_0182:
 
; Retten der lokalen Parameter fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (BERECHNE_BWS_POS)
        CALL       BERECHNE_BWS_POS
 
; Retten der Parameter-Register fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (UP_SCHLEIFE_AKTIV)
        STS        UP_SCHLEIFE_AKTIV, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0164
M_CASE_0179:
 
; CASE OF - vergleiche Einzel-Element ($0D)
        CPI        R16, 0x0D
        BREQ       M_CASE_0185
        RJMP       M_CASE_0184
M_CASE_0185:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (X_KUR_POS)
        STS        X_KUR_POS, R16
        STS        X_KUR_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (X_ANF)
        LDS        R16, X_ANF
        LDS        R17, X_ANF+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (BERECHNE_BWS_POS)
        CALL       BERECHNE_BWS_POS
 
; Retten der Parameter-Register fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0164
M_CASE_0184:
 
; CASE OF - vergleiche Einzel-Element ($1B)
        CPI        R16, 0x1B
        BREQ       M_CASE_0187
        RJMP       M_CASE_0186
M_CASE_0187:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_ESC_TM)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0164
 
; CASE OF ELSE
M_CASE_0186:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x20)
        LDI        R18, 0x20
 
; Operator >=
        CP         R16, R18
        BRCC       M_VERGL_0191
        CLR        R16
        RJMP       M_VERGL_0192
M_VERGL_0191:
        SER        R16
M_VERGL_0192:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0188
        RJMP       M_IF_0189
M_IF_0188:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x7F)
        LDI        R18, 0x7F
 
; Operator <=
        CP         R18, R16
        BRCC       M_VERGL_0196
        CLR        R16
        RJMP       M_VERGL_0197
M_VERGL_0196:
        SER        R16
M_VERGL_0197:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0193
        RJMP       M_IF_0194
M_IF_0193:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (X_KUR_POS)
        LDS        R16, X_KUR_POS
        LDS        R17, X_KUR_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (MAX_SPALTEN0)
        LDS        R18, MAX_SPALTEN0
        LDS        R19, MAX_SPALTEN0+1
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0201
        CLR        R16
        RJMP       M_VERGL_0202
M_VERGL_0201:
        SER        R16
M_VERGL_0202:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0198
        RJMP       M_IF_0199
M_IF_0198:
 
; Retten der lokalen Parameter fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCHALTE_KURSOR_AUS)
        CALL       SCHALTE_KURSOR_AUS
 
; Retten der Parameter-Register fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_SICHTBAR)
        STS        KURSOR_SICHTBAR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KURSOR_SCHLEIFE)
        STS        KURSOR_SCHLEIFE, R16
        STS        KURSOR_SCHLEIFE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (KURARR_AKTUELL)
        STS        KURARR_AKTUELL, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (CURSOR_RIGHT)
        CALL       CURSOR_RIGHT
 
; Retten der Parameter-Register fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCHREIBE_ZEICHEN_IN_BWS)
        CALL       SCHREIBE_ZEICHEN_IN_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (BERECHNE_BWS_POS)
        CALL       BERECHNE_BWS_POS
 
; Retten der Parameter-Register fuer PROCEDURE (NORMAL_TERMINAL_MODE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0199:
 
; IF_THEN - Ende
M_IF_0194:
 
; IF_THEN - Ende
M_IF_0189:
 
; ENDCASE;
M_CASE_0164:
 
; PROCEDURE - Ende (NORMAL_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (ESCAPE_RESET)
ESCAPE_RESET:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER3)
        STS        CSI_PARAMETER3, R16
        STS        CSI_PARAMETER3+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NORMAL_TM)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (ESCAPE_SEQUENZ)=10
        LDI        R16, 10
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('')
        LDI        ZL, LOW(2*M_CONST_STRING_0)
        LDI        ZH, HIGH(2*M_CONST_STRING_0)
        LDI        R29, Byte3(2*M_CONST_STRING_0)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0203
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0203:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0205
M_PRG_CONST_STRING_0204:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0204
M_PRG_CONST_STRING_0205:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ESCAPE_SEQUENZ) - Laenge in R17
        LDI        ZL, LOW(ESCAPE_SEQUENZ)
        LDI        ZH, HIGH(ESCAPE_SEQUENZ)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0207
        MOV        R16, R17
M_PRG_CONST_STRING_0206:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0206
M_PRG_CONST_STRING_0207:
        ST         -Z, R17
 
; PROCEDURE - Ende (ESCAPE_RESET)
        RET
 
; PROCEDURE - Anfang (ESCAPE_FEHLER)
ESCAPE_FEHLER:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x45)
        LDI        R16, 0x45
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ESCAPE_FEHLER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (ESCAPE_FEHLER)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x53)
        LDI        R16, 0x53
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ESCAPE_FEHLER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (ESCAPE_FEHLER)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x43)
        LDI        R16, 0x43
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ESCAPE_FEHLER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (ESCAPE_FEHLER)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Length(ESCAPE_SEQUENZ)
        LDI        ZL, LOW(ESCAPE_SEQUENZ)
        LDI        ZH, HIGH(ESCAPE_SEQUENZ)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ESC_LAENGE)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ESC_ZAEHLER)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (ESC_LAENGE)
        MOV        R16, R1
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0208:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0209
        RJMP       M_FTD_0210
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0209:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ESC_ZAEHLER)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (ESCAPE_SEQUENZ)
        CLR        R17
        LDI        ZL, LOW(ESCAPE_SEQUENZ)
        LDI        ZH, HIGH(ESCAPE_SEQUENZ)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ESC_ZEICHEN)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(ESC_ZEICHEN)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ESCAPE_FEHLER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_CHAR)
        CALL       WRITE_CHAR
 
; Retten der Parameter-Register fuer PROCEDURE (ESCAPE_FEHLER)
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0208
 
; FOR TO DO - Ende
M_FTD_0210:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ESCAPE_FEHLER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (ESCAPE_FEHLER)
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (ESCAPE_FEHLER)
        RET
 
; PROCEDURE - Anfang (IBM_ESC_TERMINAL_MODE)
IBM_ESC_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Einzel-Element ($5B)
        CPI        R16, 0x5B
        BREQ       M_CASE_0213
        RJMP       M_CASE_0212
M_CASE_0213:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0211
M_CASE_0212:
 
; CASE OF - vergleiche Einzel-Element ($47)
        CPI        R16, 0x47
        BREQ       M_CASE_0215
        RJMP       M_CASE_0214
M_CASE_0215:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_GRAFIK_PAR_1_TM)
        LDI        R16, 0x06
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0211
 
; CASE OF ELSE
M_CASE_0214:
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; ENDCASE;
M_CASE_0211:
 
; PROCEDURE - Ende (IBM_ESC_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (SET_DISPLAY_ATTRIBUTES)
SET_DISPLAY_ATTRIBUTES:
 
; CASE OF - lokaler Uebergabeparameter (DISPATTR)
        MOV        R16, R0
        MOV        R17, R1
 
; CASE OF - vergleiche Einzel-Element (0)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0218
        RJMP       M_CASE_0217
M_CASE_0218:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLUE)
        LDI        R16, 0xB0
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0217:
 
; CASE OF - vergleiche Einzel-Element (1)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0220
        RJMP       M_CASE_0219
M_CASE_0220:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_GRAY)
        LDI        R16, 0x6A
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0219:
 
; CASE OF - vergleiche Einzel-Element (4)
        LDI        R18, LOW(0x0004)
        LDI        R19, HIGH(0x0004)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0222
        RJMP       M_CASE_0221
M_CASE_0222:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_PURPLE)
        LDI        R16, 0x73
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0221:
 
; CASE OF - vergleiche Einzel-Element (5)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0224
        RJMP       M_CASE_0223
M_CASE_0224:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_RED)
        LDI        R16, 0x43
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0223:
 
; CASE OF - vergleiche Einzel-Element (7)
        LDI        R18, LOW(0x0007)
        LDI        R19, HIGH(0x0007)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0226
        RJMP       M_CASE_0225
M_CASE_0226:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLACK)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0225:
 
; CASE OF - vergleiche Einzel-Element (8)
        LDI        R18, LOW(0x0008)
        LDI        R19, HIGH(0x0008)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0228
        RJMP       M_CASE_0227
M_CASE_0228:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_WHITE)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0227:
 
; CASE OF - vergleiche Einzel-Element (11)
        LDI        R18, LOW(0x000B)
        LDI        R19, HIGH(0x000B)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0230
        RJMP       M_CASE_0229
M_CASE_0230:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_FONT)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_FONT)
        CALL       SETZE_FONT
 
; Retten der Parameter-Register fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0229:
 
; CASE OF - vergleiche Einzel-Element (12)
        LDI        R18, LOW(0x000C)
        LDI        R19, HIGH(0x000C)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0232
        RJMP       M_CASE_0231
M_CASE_0232:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_FONT)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_FONT)
        CALL       SETZE_FONT
 
; Retten der Parameter-Register fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0231:
 
; CASE OF - vergleiche Einzel-Element (30)
        LDI        R18, LOW(0x001E)
        LDI        R19, HIGH(0x001E)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0234
        RJMP       M_CASE_0233
M_CASE_0234:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLACK)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0233:
 
; CASE OF - vergleiche Einzel-Element (31)
        LDI        R18, LOW(0x001F)
        LDI        R19, HIGH(0x001F)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0236
        RJMP       M_CASE_0235
M_CASE_0236:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_RED)
        LDI        R16, 0x43
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0235:
 
; CASE OF - vergleiche Einzel-Element (32)
        LDI        R18, LOW(0x0020)
        LDI        R19, HIGH(0x0020)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0238
        RJMP       M_CASE_0237
M_CASE_0238:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_GREEN)
        LDI        R16, 0x4C
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0237:
 
; CASE OF - vergleiche Einzel-Element (33)
        LDI        R18, LOW(0x0021)
        LDI        R19, HIGH(0x0021)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0240
        RJMP       M_CASE_0239
M_CASE_0240:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_YELLOW)
        LDI        R16, 0x4F
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0239:
 
; CASE OF - vergleiche Einzel-Element (34)
        LDI        R18, LOW(0x0022)
        LDI        R19, HIGH(0x0022)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0242
        RJMP       M_CASE_0241
M_CASE_0242:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLUE)
        LDI        R16, 0xB0
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0241:
 
; CASE OF - vergleiche Einzel-Element (35)
        LDI        R18, LOW(0x0023)
        LDI        R19, HIGH(0x0023)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0244
        RJMP       M_CASE_0243
M_CASE_0244:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_PURPLE)
        LDI        R16, 0x73
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0243:
 
; CASE OF - vergleiche Einzel-Element (36)
        LDI        R18, LOW(0x0024)
        LDI        R19, HIGH(0x0024)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0246
        RJMP       M_CASE_0245
M_CASE_0246:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_AQUA)
        LDI        R16, 0x7C
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0245:
 
; CASE OF - vergleiche Einzel-Element (37)
        LDI        R18, LOW(0x0025)
        LDI        R19, HIGH(0x0025)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0248
        RJMP       M_CASE_0247
M_CASE_0248:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_WHITE)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0247:
 
; CASE OF - vergleiche Einzel-Element (40)
        LDI        R18, LOW(0x0028)
        LDI        R19, HIGH(0x0028)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0250
        RJMP       M_CASE_0249
M_CASE_0250:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLACK)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0249:
 
; CASE OF - vergleiche Einzel-Element (41)
        LDI        R18, LOW(0x0029)
        LDI        R19, HIGH(0x0029)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0252
        RJMP       M_CASE_0251
M_CASE_0252:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_RED)
        LDI        R16, 0x43
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0251:
 
; CASE OF - vergleiche Einzel-Element (42)
        LDI        R18, LOW(0x002A)
        LDI        R19, HIGH(0x002A)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0254
        RJMP       M_CASE_0253
M_CASE_0254:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_GREEN)
        LDI        R16, 0x4C
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0253:
 
; CASE OF - vergleiche Einzel-Element (43)
        LDI        R18, LOW(0x002B)
        LDI        R19, HIGH(0x002B)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0256
        RJMP       M_CASE_0255
M_CASE_0256:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_YELLOW)
        LDI        R16, 0x4F
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0255:
 
; CASE OF - vergleiche Einzel-Element (44)
        LDI        R18, LOW(0x002C)
        LDI        R19, HIGH(0x002C)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0258
        RJMP       M_CASE_0257
M_CASE_0258:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_BLUE)
        LDI        R16, 0xB0
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0257:
 
; CASE OF - vergleiche Einzel-Element (45)
        LDI        R18, LOW(0x002D)
        LDI        R19, HIGH(0x002D)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0260
        RJMP       M_CASE_0259
M_CASE_0260:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_PURPLE)
        LDI        R16, 0x73
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0259:
 
; CASE OF - vergleiche Einzel-Element (46)
        LDI        R18, LOW(0x002E)
        LDI        R19, HIGH(0x002E)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0262
        RJMP       M_CASE_0261
M_CASE_0262:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_AQUA)
        LDI        R16, 0x7C
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
M_CASE_0261:
 
; CASE OF - vergleiche Einzel-Element (47)
        LDI        R18, LOW(0x002F)
        LDI        R19, HIGH(0x002F)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0264
        RJMP       M_CASE_0263
M_CASE_0264:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CL_WHITE)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0216
 
; CASE OF ELSE
M_CASE_0263:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; Retten der Parameter-Register fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0216:
 
; PROCEDURE - Ende (SET_DISPLAY_ATTRIBUTES)
        RET
 
; PROCEDURE - Anfang (IBM_CSI_TERMINAL_MODE)
IBM_CSI_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Byte-Element-Bereich <von> (48)
        CPI        R16, 0x30
        BRCC       M_CASE_0268
        RJMP       M_CASE_0266
M_CASE_0268:
 
; CASE OF - vergleiche Byte-Element-Bereich <bis> (57)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0267
        RJMP       M_CASE_0266
M_CASE_0267:
 
; Zuweisung Quelle - Ausdruck erster Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R16, ZEICHEN
        CLR        R17
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_1)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0265
M_CASE_0266:
 
; CASE OF - vergleiche Einzel-Element ($4B)
        CPI        R16, 0x4B
        BREQ       M_CASE_0270
        RJMP       M_CASE_0269
M_CASE_0270:
 
; Aufruf PROCEDURE (DELETE_EOL)
        CALL       DELETE_EOL
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0265
M_CASE_0269:
 
; CASE OF - vergleiche Einzel-Element ($66)
        CPI        R16, 0x66
        BREQ       M_CASE_0272
        RJMP       M_CASE_0271
M_CASE_0272:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (UP_SCHLEIFE_AKTIV)
        STS        UP_SCHLEIFE_AKTIV, R16
 
; Aufruf PROCEDURE (LOESCHE_BWS)
        CALL       LOESCHE_BWS
 
; Aufruf PROCEDURE (ANZEIGE_BWS)
        CALL       ANZEIGE_BWS
 
; Aufruf PROCEDURE (RESET_FORM)
        CALL       RESET_FORM
 
; IF THEN - Ausdruck / Byte-VAR (GRAFIK_IM_BWS)
        LDS        R16, GRAFIK_IM_BWS
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0273
        RJMP       M_IF_0274
M_IF_0273:
 
; Aufruf PROCEDURE (CLEAR_RAM)
        CALL       CLEAR_RAM
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (GRAFIK_IM_BWS)
        STS        GRAFIK_IM_BWS, R16
 
; IF_THEN - Ende
M_IF_0274:
 
; Aufruf PROCEDURE (BERECHNE_BWS_POS)
        CALL       BERECHNE_BWS_POS
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (UP_SCHLEIFE_AKTIV)
        STS        UP_SCHLEIFE_AKTIV, R16
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0265
M_CASE_0271:
 
; CASE OF - vergleiche Einzel-Element ($6D)
        CPI        R16, 0x6D
        BREQ       M_CASE_0277
        RJMP       M_CASE_0276
M_CASE_0277:
 
; Word-Parameter(1) fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        LDI        R16, LOW(0x0000)
        MOV        R0, R16
        LDI        R17, HIGH(0x0000)
        MOV        R1, R17
 
; Aufruf PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        CALL       SET_DISPLAY_ATTRIBUTES
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0265
M_CASE_0276:
 
; CASE OF - vergleiche Einzel-Element ($3F)
        CPI        R16, 0x3F
        BREQ       M_CASE_0279
        RJMP       M_CASE_0278
M_CASE_0279:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_1)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0265
M_CASE_0278:
 
; CASE OF - vergleiche Einzel-Element ($48)
        CPI        R16, 0x48
        BREQ       M_CASE_0281
        RJMP       M_CASE_0280
M_CASE_0281:
 
; Word-Parameter(1) fuer PROCEDURE (SET_CURSOR_POSITION)
        LDI        R16, LOW(0x0000)
        MOV        R0, R16
        LDI        R17, HIGH(0x0000)
        MOV        R1, R17
 
; Word-Parameter(2) fuer PROCEDURE (SET_CURSOR_POSITION)
        LDI        R16, LOW(0x0000)
        MOV        R2, R16
        LDI        R17, HIGH(0x0000)
        MOV        R3, R17
 
; Aufruf PROCEDURE (SET_CURSOR_POSITION)
        CALL       SET_CURSOR_POSITION
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0265
M_CASE_0280:
 
; CASE OF - vergleiche Einzel-Element ($4A)
        CPI        R16, 0x4A
        BREQ       M_CASE_0283
        RJMP       M_CASE_0282
M_CASE_0283:
 
; Aufruf PROCEDURE (ERASE_DOWN)
        CALL       ERASE_DOWN
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0265
M_CASE_0282:
 
; CASE OF - vergleiche Einzel-Element ($4D)
        CPI        R16, 0x4D
        BREQ       M_CASE_0285
        RJMP       M_CASE_0284
M_CASE_0285:
 
; Aufruf PROCEDURE (DELETE_LINE)
        CALL       DELETE_LINE
 
; Aufruf PROCEDURE (CURSOR_UP)
        CALL       CURSOR_UP
 
; Aufruf PROCEDURE (DELETE_LINE)
        CALL       DELETE_LINE
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0265
 
; CASE OF ELSE
M_CASE_0284:
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; ENDCASE;
M_CASE_0265:
 
; PROCEDURE - Ende (IBM_CSI_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_CSI_PAR_1_TERMINAL_MODE)
IBM_CSI_PAR_1_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Byte-Element-Bereich <von> (48)
        CPI        R16, 0x30
        BRCC       M_CASE_0289
        RJMP       M_CASE_0287
M_CASE_0289:
 
; CASE OF - vergleiche Byte-Element-Bereich <bis> (57)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0288
        RJMP       M_CASE_0287
M_CASE_0288:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R18, ZEICHEN
        CLR        R19
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_1)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0286
M_CASE_0287:
 
; CASE OF - vergleiche Einzel-Element ($3B)
        CPI        R16, 0x3B
        BREQ       M_CASE_0291
        RJMP       M_CASE_0290
M_CASE_0291:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_2)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0286
M_CASE_0290:
 
; CASE OF - vergleiche Einzel-Element ($4A)
        CPI        R16, 0x4A
        BREQ       M_CASE_0293
        RJMP       M_CASE_0292
M_CASE_0293:
 
; CASE OF - Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; CASE OF - vergleiche Einzel-Element (2)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0296
        RJMP       M_CASE_0295
M_CASE_0296:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (RESET_FORM)
        CALL       RESET_FORM
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0294
 
; CASE OF ELSE
M_CASE_0295:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0294:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0286
M_CASE_0292:
 
; CASE OF - vergleiche Einzel-Element ($4B)
        CPI        R16, 0x4B
        BREQ       M_CASE_0298
        RJMP       M_CASE_0297
M_CASE_0298:
 
; CASE OF - Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; CASE OF - vergleiche Einzel-Element (0)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0301
        RJMP       M_CASE_0300
M_CASE_0301:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DELETE_EOL)
        CALL       DELETE_EOL
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0299
M_CASE_0300:
 
; CASE OF - vergleiche Einzel-Element (1)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0303
        RJMP       M_CASE_0302
M_CASE_0303:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DELETE_BOL)
        CALL       DELETE_BOL
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0299
M_CASE_0302:
 
; CASE OF - vergleiche Einzel-Element (2)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0305
        RJMP       M_CASE_0304
M_CASE_0305:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DELETE_LINE)
        CALL       DELETE_LINE
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0299
 
; CASE OF ELSE
M_CASE_0304:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0299:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0286
M_CASE_0297:
 
; CASE OF - vergleiche Einzel-Element ($4C)
        CPI        R16, 0x4C
        BREQ       M_CASE_0307
        RJMP       M_CASE_0306
M_CASE_0307:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; FOR TO DO - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0308:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0309
        RJMP       M_FTD_0310
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0309:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (INSERT_LINE_SCR_ROLL)
        CALL       INSERT_LINE_SCR_ROLL
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0308
 
; FOR TO DO - Ende
M_FTD_0310:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0286
M_CASE_0306:
 
; CASE OF - vergleiche Einzel-Element ($4D)
        CPI        R16, 0x4D
        BREQ       M_CASE_0312
        RJMP       M_CASE_0311
M_CASE_0312:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; FOR TO DO - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0313:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0314
        RJMP       M_FTD_0315
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0314:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DELETE_LINE_SCR_ROLL)
        CALL       DELETE_LINE_SCR_ROLL
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0313
 
; FOR TO DO - Ende
M_FTD_0315:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0286
M_CASE_0311:
 
; CASE OF - vergleiche Einzel-Element ($6D)
        CPI        R16, 0x6D
        BREQ       M_CASE_0317
        RJMP       M_CASE_0316
M_CASE_0317:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Word-Parameter(1) fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        LDS        R0, CSI_PARAMETER1
        LDS        R1, CSI_PARAMETER1+1
 
; Aufruf PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        CALL       SET_DISPLAY_ATTRIBUTES
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0286
M_CASE_0316:
 
; CASE OF - vergleiche Einzel-Element ($6C)
        CPI        R16, 0x6C
        BREQ       M_CASE_0319
        RJMP       M_CASE_0318
M_CASE_0319:
 
; CASE OF - Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; CASE OF - vergleiche Einzel-Element (25)
        LDI        R18, LOW(0x0019)
        LDI        R19, HIGH(0x0019)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0322
        RJMP       M_CASE_0321
M_CASE_0322:
 
; IF THEN - Ausdruck / Byte-VAR (KURSOR_SICHTBAR)
        LDS        R16, KURSOR_SICHTBAR
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0323
        RJMP       M_IF_0324
M_IF_0323:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_SICHTBAR)
        STS        KURSOR_SICHTBAR, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (SCHALTE_KURSOR_AUS)
        CALL       SCHALTE_KURSOR_AUS
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0324:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_EIN)
        STS        KURSOR_EIN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0320
M_CASE_0321:
 
; CASE OF - vergleiche Einzel-Element (26)
        LDI        R18, LOW(0x001A)
        LDI        R19, HIGH(0x001A)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0327
        RJMP       M_CASE_0326
M_CASE_0327:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0320
 
; CASE OF ELSE
M_CASE_0326:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0320:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0286
M_CASE_0318:
 
; CASE OF - vergleiche Einzel-Element ($68)
        CPI        R16, 0x68
        BREQ       M_CASE_0329
        RJMP       M_CASE_0328
M_CASE_0329:
 
; CASE OF - Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; CASE OF - vergleiche Einzel-Element (25)
        LDI        R18, LOW(0x0019)
        LDI        R19, HIGH(0x0019)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0332
        RJMP       M_CASE_0331
M_CASE_0332:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KURSOR_SCHLEIFE)
        STS        KURSOR_SCHLEIFE, R16
        STS        KURSOR_SCHLEIFE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (KURSOR_EIN)
        STS        KURSOR_EIN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0330
M_CASE_0331:
 
; CASE OF - vergleiche Einzel-Element (26)
        LDI        R18, LOW(0x001A)
        LDI        R19, HIGH(0x001A)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0334
        RJMP       M_CASE_0333
M_CASE_0334:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0330
 
; CASE OF ELSE
M_CASE_0333:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0330:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0286
 
; CASE OF ELSE
M_CASE_0328:
 
; Retten der lokalen Parameter fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; Retten der Parameter-Register fuer PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0286:
 
; PROCEDURE - Ende (IBM_CSI_PAR_1_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_CSI_PAR_2_TERMINAL_MODE)
IBM_CSI_PAR_2_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Byte-Element-Bereich <von> (48)
        CPI        R16, 0x30
        BRCC       M_CASE_0338
        RJMP       M_CASE_0336
M_CASE_0338:
 
; CASE OF - vergleiche Byte-Element-Bereich <bis> (57)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0337
        RJMP       M_CASE_0336
M_CASE_0337:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R18, ZEICHEN
        CLR        R19
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_2)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0335
M_CASE_0336:
 
; CASE OF - vergleiche Einzel-Element ($3B)
        CPI        R16, 0x3B
        BREQ       M_CASE_0340
        RJMP       M_CASE_0339
M_CASE_0340:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_3)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0335
M_CASE_0339:
 
; CASE OF - vergleiche Einzel-Element ($48)
        CPI        R16, 0x48
        BREQ       M_CASE_0342
        RJMP       M_CASE_0341
M_CASE_0342:
 
; Word-Parameter(1) fuer PROCEDURE (SET_CURSOR_POSITION)
        LDS        R0, CSI_PARAMETER1
        LDS        R1, CSI_PARAMETER1+1
 
; Word-Parameter(2) fuer PROCEDURE (SET_CURSOR_POSITION)
        LDS        R2, CSI_PARAMETER2
        LDS        R3, CSI_PARAMETER2+1
 
; Aufruf PROCEDURE (SET_CURSOR_POSITION)
        CALL       SET_CURSOR_POSITION
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0335
M_CASE_0341:
 
; CASE OF - vergleiche Einzel-Element ($66)
        CPI        R16, 0x66
        BREQ       M_CASE_0344
        RJMP       M_CASE_0343
M_CASE_0344:
 
; Word-Parameter(1) fuer PROCEDURE (SET_CURSOR_POSITION)
        LDS        R0, CSI_PARAMETER1
        LDS        R1, CSI_PARAMETER1+1
 
; Word-Parameter(2) fuer PROCEDURE (SET_CURSOR_POSITION)
        LDS        R2, CSI_PARAMETER2
        LDS        R3, CSI_PARAMETER2+1
 
; Aufruf PROCEDURE (SET_CURSOR_POSITION)
        CALL       SET_CURSOR_POSITION
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0335
M_CASE_0343:
 
; CASE OF - vergleiche Einzel-Element ($6D)
        CPI        R16, 0x6D
        BREQ       M_CASE_0346
        RJMP       M_CASE_0345
M_CASE_0346:
 
; Word-Parameter(1) fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        LDS        R0, CSI_PARAMETER1
        LDS        R1, CSI_PARAMETER1+1
 
; Aufruf PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        CALL       SET_DISPLAY_ATTRIBUTES
 
; Word-Parameter(1) fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        LDS        R0, CSI_PARAMETER2
        LDS        R1, CSI_PARAMETER2+1
 
; Aufruf PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        CALL       SET_DISPLAY_ATTRIBUTES
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0335
 
; CASE OF ELSE
M_CASE_0345:
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; ENDCASE;
M_CASE_0335:
 
; PROCEDURE - Ende (IBM_CSI_PAR_2_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_CSI_PAR_3_TERMINAL_MODE)
IBM_CSI_PAR_3_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Byte-Element-Bereich <von> (48)
        CPI        R16, 0x30
        BRCC       M_CASE_0350
        RJMP       M_CASE_0348
M_CASE_0350:
 
; CASE OF - vergleiche Byte-Element-Bereich <bis> (57)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0349
        RJMP       M_CASE_0348
M_CASE_0349:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER3)
        LDS        R16, CSI_PARAMETER3
        LDS        R17, CSI_PARAMETER3+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER3)
        STS        CSI_PARAMETER3, R16
        STS        CSI_PARAMETER3+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER3)
        LDS        R16, CSI_PARAMETER3
        LDS        R17, CSI_PARAMETER3+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R18, ZEICHEN
        CLR        R19
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER3)
        STS        CSI_PARAMETER3, R16
        STS        CSI_PARAMETER3+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER3)
        LDS        R16, CSI_PARAMETER3
        LDS        R17, CSI_PARAMETER3+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER3)
        STS        CSI_PARAMETER3, R16
        STS        CSI_PARAMETER3+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_CSI_TM_PAR_3)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0347
M_CASE_0348:
 
; CASE OF - vergleiche Einzel-Element ($6D)
        CPI        R16, 0x6D
        BREQ       M_CASE_0352
        RJMP       M_CASE_0351
M_CASE_0352:
 
; CASE OF - Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; CASE OF - vergleiche Einzel-Element (48)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0355
        RJMP       M_CASE_0354
M_CASE_0355:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0359
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0360
M_VERGL_0359:
        SER        R16
M_VERGL_0360:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0356
        RJMP       M_IF_0357
M_IF_0356:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(CSI_PARAMETER3)
        LDS        R16, CSI_PARAMETER3
 
; Zuweisung Ziel /  VAR (BCOLOR)
        STS        BCOLOR, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0358
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0357:
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; IF_THEN_ELSE - Ende
M_IF_0358:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0353
M_CASE_0354:
 
; CASE OF - vergleiche Einzel-Element (38)
        LDI        R18, LOW(0x0026)
        LDI        R19, HIGH(0x0026)
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_CASE_0362
        RJMP       M_CASE_0361
M_CASE_0362:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0366
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0367
M_VERGL_0366:
        SER        R16
M_VERGL_0367:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0363
        RJMP       M_IF_0364
M_IF_0363:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(CSI_PARAMETER3)
        LDS        R16, CSI_PARAMETER3
 
; Zuweisung Ziel /  VAR (FCOLOR)
        STS        FCOLOR, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0365
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0364:
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; IF_THEN_ELSE - Ende
M_IF_0365:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0353
 
; CASE OF ELSE
M_CASE_0361:
 
; Word-Parameter(1) fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        LDS        R0, CSI_PARAMETER1
        LDS        R1, CSI_PARAMETER1+1
 
; Aufruf PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        CALL       SET_DISPLAY_ATTRIBUTES
 
; Word-Parameter(1) fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        LDS        R0, CSI_PARAMETER2
        LDS        R1, CSI_PARAMETER2+1
 
; Aufruf PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        CALL       SET_DISPLAY_ATTRIBUTES
 
; Word-Parameter(1) fuer PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        LDS        R0, CSI_PARAMETER3
        LDS        R1, CSI_PARAMETER3+1
 
; Aufruf PROCEDURE (SET_DISPLAY_ATTRIBUTES)
        CALL       SET_DISPLAY_ATTRIBUTES
 
; ENDCASE;
M_CASE_0353:
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0347
 
; CASE OF ELSE
M_CASE_0351:
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; ENDCASE;
M_CASE_0347:
 
; PROCEDURE - Ende (IBM_CSI_PAR_3_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_GRAFIK_PAR_1_TERMINAL_MODE)
IBM_GRAFIK_PAR_1_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Byte-Element-Bereich <von> (48)
        CPI        R16, 0x30
        BRCC       M_CASE_0371
        RJMP       M_CASE_0369
M_CASE_0371:
 
; CASE OF - vergleiche Byte-Element-Bereich <bis> (57)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0370
        RJMP       M_CASE_0369
M_CASE_0370:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R18, ZEICHEN
        CLR        R19
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER1)
        STS        CSI_PARAMETER1, R16
        STS        CSI_PARAMETER1+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_GRAFIK_PAR_1_TM)
        LDI        R16, 0x06
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0368
M_CASE_0369:
 
; CASE OF - vergleiche Einzel-Element ($3B)
        CPI        R16, 0x3B
        BREQ       M_CASE_0373
        RJMP       M_CASE_0372
M_CASE_0373:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_GRAFIK_PAR_2_TM)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0368
M_CASE_0372:
 
; CASE OF - vergleiche Einzel-Element ($43)
        CPI        R16, 0x43
        BREQ       M_CASE_0375
        RJMP       M_CASE_0374
M_CASE_0375:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
 
; Zuweisung Ziel /  VAR (PIXCOLOR)
        STS        PIXCOLOR, R16
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0368
M_CASE_0374:
 
; CASE OF - vergleiche Einzel-Element ($4B)
        CPI        R16, 0x4B
        BREQ       M_CASE_0377
        RJMP       M_CASE_0376
M_CASE_0377:
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0368
M_CASE_0376:
 
; CASE OF - vergleiche Einzel-Element ($56)
        CPI        R16, 0x56
        BREQ       M_CASE_0379
        RJMP       M_CASE_0378
M_CASE_0379:
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0368
 
; CASE OF ELSE
M_CASE_0378:
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; ENDCASE;
M_CASE_0368:
 
; PROCEDURE - Ende (IBM_GRAFIK_PAR_1_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (IBM_GRAFIK_PAR_2_TERMINAL_MODE)
IBM_GRAFIK_PAR_2_TERMINAL_MODE:
 
; CASE OF - Byte-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; CASE OF - vergleiche Byte-Element-Bereich <von> (48)
        CPI        R16, 0x30
        BRCC       M_CASE_0383
        RJMP       M_CASE_0381
M_CASE_0383:
 
; CASE OF - vergleiche Byte-Element-Bereich <bis> (57)
        LDI        R17, 0x39
        CP         R17, R16
        BRCC       M_CASE_0382
        RJMP       M_CASE_0381
M_CASE_0382:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x000A)
        LDI        R18, LOW(0x000A)
        LDI        R19, HIGH(0x000A)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor /; Zuweisung ByteToWord(ZEICHEN)
        LDS        R18, ZEICHEN
        CLR        R19
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0030)
        LDI        R18, LOW(0x0030)
        LDI        R19, HIGH(0x0030)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  VAR (CSI_PARAMETER2)
        STS        CSI_PARAMETER2, R16
        STS        CSI_PARAMETER2+1, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (IBM_GRAFIK_PAR_2_TM)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (TERMMODE)
        STS        TERMMODE, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0380
M_CASE_0381:
 
; CASE OF - vergleiche Einzel-Element ($47)
        CPI        R16, 0x47
        BREQ       M_CASE_0385
        RJMP       M_CASE_0384
M_CASE_0385:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0380
M_CASE_0384:
 
; CASE OF - vergleiche Einzel-Element ($50)
        CPI        R16, 0x50
        BREQ       M_CASE_0387
        RJMP       M_CASE_0386
M_CASE_0387:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Ziel /  VAR (X_PIX_POS)
        STS        X_PIX_POS, R16
        STS        X_PIX_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Ziel /  VAR (Y_PIX_POS)
        STS        Y_PIX_POS, R16
        STS        Y_PIX_POS+1, R17
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0380
M_CASE_0386:
 
; CASE OF - vergleiche Einzel-Element ($4C)
        CPI        R16, 0x4C
        BREQ       M_CASE_0389
        RJMP       M_CASE_0388
M_CASE_0389:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Ziel /  VAR (X_END_POS)
        STS        X_END_POS, R16
        STS        X_END_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Ziel /  VAR (Y_END_POS)
        STS        Y_END_POS, R16
        STS        Y_END_POS+1, R17
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0380
M_CASE_0388:
 
; CASE OF - vergleiche Einzel-Element ($52)
        CPI        R16, 0x52
        BREQ       M_CASE_0391
        RJMP       M_CASE_0390
M_CASE_0391:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Ziel /  VAR (X_END_POS)
        STS        X_END_POS, R16
        STS        X_END_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Ziel /  VAR (Y_END_POS)
        STS        Y_END_POS, R16
        STS        Y_END_POS+1, R17
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0380
M_CASE_0390:
 
; CASE OF - vergleiche Einzel-Element ($46)
        CPI        R16, 0x46
        BREQ       M_CASE_0393
        RJMP       M_CASE_0392
M_CASE_0393:
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER1)
        LDS        R16, CSI_PARAMETER1
        LDS        R17, CSI_PARAMETER1+1
 
; Zuweisung Ziel /  VAR (X_END_POS)
        STS        X_END_POS, R16
        STS        X_END_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (CSI_PARAMETER2)
        LDS        R16, CSI_PARAMETER2
        LDS        R17, CSI_PARAMETER2+1
 
; Zuweisung Ziel /  VAR (Y_END_POS)
        STS        Y_END_POS, R16
        STS        Y_END_POS+1, R17
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0380
 
; CASE OF ELSE
M_CASE_0392:
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; ENDCASE;
M_CASE_0380:
 
; PROCEDURE - Ende (IBM_GRAFIK_PAR_2_TERMINAL_MODE)
        RET
 
; PROCEDURE - Anfang (CONOUT)
CONOUT:
 
; IF THEN - Ausdruck / Byte-VAR (KURSOR_SICHTBAR)
        LDS        R16, KURSOR_SICHTBAR
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0394
        RJMP       M_IF_0395
M_IF_0394:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (SCHALTE_KURSOR_AUS)
        CALL       SCHALTE_KURSOR_AUS
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_SICHTBAR)
        STS        KURSOR_SICHTBAR, R16
 
; IF_THEN - Ende
M_IF_0395:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KURSOR_SCHLEIFE)
        STS        KURSOR_SCHLEIFE, R16
        STS        KURSOR_SCHLEIFE+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURARR_AKTUELL)
        STS        KURARR_AKTUELL, R16
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (TERMMODE)
        LDS        R16, TERMMODE
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NORMAL_TM)
        LDI        R18, 0x00
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0400
        CLR        R16
        RJMP       M_VERGL_0401
M_VERGL_0400:
        SER        R16
M_VERGL_0401:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0397
        RJMP       M_IF_0398
M_IF_0397:
 
; Zuweisung Quelle - Ausdruck / Char-VAR (ZEICHEN)
        LDS        R16, ZEICHEN
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C_ZEICHEN)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ESCAPE_SEQUENZ)=10
        LDI        R16, 10
        CLR        R17
        LDI        ZL, LOW(ESCAPE_SEQUENZ)
        LDI        ZH, HIGH(ESCAPE_SEQUENZ)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0402
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0402:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0404
M_PRG_CONST_STRING_0403:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0403
M_PRG_CONST_STRING_0404:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C_ZEICHEN)
        MOV        R19, R0
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0405
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0405:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ESCAPE_SEQUENZ) - Laenge in R17
        LDI        ZL, LOW(ESCAPE_SEQUENZ)
        LDI        ZH, HIGH(ESCAPE_SEQUENZ)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0407
        MOV        R16, R17
M_PRG_CONST_STRING_0406:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0406
M_PRG_CONST_STRING_0407:
        ST         -Z, R17
 
; IF_THEN - Ende
M_IF_0398:
 
; CASE OF - Byte-VAR (TERMMODE)
        LDS        R16, TERMMODE
 
; CASE OF - vergleiche Einzel-Element (NORMAL_TM)
        CPI        R16, 0x00
        BREQ       M_CASE_0410
        RJMP       M_CASE_0409
M_CASE_0410:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (NORMAL_TERMINAL_MODE)
        CALL       NORMAL_TERMINAL_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0408
M_CASE_0409:
 
; CASE OF - vergleiche Einzel-Element (IBM_ESC_TM)
        CPI        R16, 0x01
        BREQ       M_CASE_0412
        RJMP       M_CASE_0411
M_CASE_0412:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (IBM_ESC_TERMINAL_MODE)
        CALL       IBM_ESC_TERMINAL_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0408
M_CASE_0411:
 
; CASE OF - vergleiche Einzel-Element (IBM_CSI_TM)
        CPI        R16, 0x02
        BREQ       M_CASE_0414
        RJMP       M_CASE_0413
M_CASE_0414:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (IBM_CSI_TERMINAL_MODE)
        CALL       IBM_CSI_TERMINAL_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0408
M_CASE_0413:
 
; CASE OF - vergleiche Einzel-Element (IBM_CSI_TM_PAR_1)
        CPI        R16, 0x03
        BREQ       M_CASE_0416
        RJMP       M_CASE_0415
M_CASE_0416:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (IBM_CSI_PAR_1_TERMINAL_MODE)
        CALL       IBM_CSI_PAR_1_TERMINAL_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0408
M_CASE_0415:
 
; CASE OF - vergleiche Einzel-Element (IBM_CSI_TM_PAR_2)
        CPI        R16, 0x04
        BREQ       M_CASE_0418
        RJMP       M_CASE_0417
M_CASE_0418:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (IBM_CSI_PAR_2_TERMINAL_MODE)
        CALL       IBM_CSI_PAR_2_TERMINAL_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0408
M_CASE_0417:
 
; CASE OF - vergleiche Einzel-Element (IBM_CSI_TM_PAR_3)
        CPI        R16, 0x05
        BREQ       M_CASE_0420
        RJMP       M_CASE_0419
M_CASE_0420:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (IBM_CSI_PAR_3_TERMINAL_MODE)
        CALL       IBM_CSI_PAR_3_TERMINAL_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0408
M_CASE_0419:
 
; CASE OF - vergleiche Einzel-Element (IBM_GRAFIK_PAR_1_TM)
        CPI        R16, 0x06
        BREQ       M_CASE_0422
        RJMP       M_CASE_0421
M_CASE_0422:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (IBM_GRAFIK_PAR_1_TERMINAL_MODE)
        CALL       IBM_GRAFIK_PAR_1_TERMINAL_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0408
M_CASE_0421:
 
; CASE OF - vergleiche Einzel-Element (IBM_GRAFIK_PAR_2_TM)
        CPI        R16, 0x07
        BREQ       M_CASE_0424
        RJMP       M_CASE_0423
M_CASE_0424:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (IBM_GRAFIK_PAR_2_TERMINAL_MODE)
        CALL       IBM_GRAFIK_PAR_2_TERMINAL_MODE
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0408
 
; CASE OF ELSE
M_CASE_0423:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (ESCAPE_FEHLER)
        CALL       ESCAPE_FEHLER
 
; Retten der Parameter-Register fuer PROCEDURE (CONOUT)
        POP        R0
 
; ENDCASE;
M_CASE_0408:
 
; PROCEDURE - Ende (CONOUT)
        RET
 
; PROCEDURE - Anfang (TEXT_AN_CONOUT)
TEXT_AN_CONOUT:
 
; Zuweisung Quelle - Ausdruck / Length(WRITE_STRING)
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R1
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0425:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0426
        RJMP       M_FTD_0427
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0426:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B2)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (TEXT_AN_CONOUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (CONOUT)
        CALL       CONOUT
 
; Retten der Parameter-Register fuer PROCEDURE (TEXT_AN_CONOUT)
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R1
        INC        R17
        MOV        R1, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0425
 
; FOR TO DO - Ende
M_FTD_0427:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0D)
        LDI        R16, 0x0D
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (TEXT_AN_CONOUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (CONOUT)
        CALL       CONOUT
 
; Retten der Parameter-Register fuer PROCEDURE (TEXT_AN_CONOUT)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0A)
        LDI        R16, 0x0A
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (TEXT_AN_CONOUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (CONOUT)
        CALL       CONOUT
 
; Retten der Parameter-Register fuer PROCEDURE (TEXT_AN_CONOUT)
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (TEXT_AN_CONOUT)
        RET
 
; PROCEDURE - Anfang (SENDE_ZEICHEN)
SENDE_ZEICHEN:
 
; WHILE DO ...
M_WHILE_0428:
 
; WHILE - Ausdruck /; BitLow(UDRE0)
        LDS        R16, UCSR0A
        BST        R16, 5
        BRTC       M_VERGL_0431
        CLR        R16
        RJMP       M_VERGL_0432
M_VERGL_0431:
        SER        R16
M_VERGL_0432:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0429
        RJMP       M_WHILE_0430
M_WHILE_0429:
 
; WHILE DO ...
        RJMP       M_WHILE_0428
M_WHILE_0430:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (S_ZEICHEN)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (UDR0)
        STS        UDR0, R16
 
; PROCEDURE - Ende (SENDE_ZEICHEN)
        RET
 
; PROCEDURE - Anfang (RX_PUFFER_ABFRAGEN)
RX_PUFFER_ABFRAGEN:
 
; IF THEN - Ausdruck /; BitHigh(RXC0)
        LDS        R16, UCSR0A
        BST        R16, 7
        BRTS       M_VERGL_0436
        CLR        R16
        RJMP       M_VERGL_0437
M_VERGL_0436:
        SER        R16
M_VERGL_0437:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0433
        RJMP       M_IF_0434
M_IF_0433:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (UDR0)
        LDS        R16, UDR0
 
; Zuweisung Ziel /  VAR (ZEICHEN)
        STS        ZEICHEN, R16
 
; Aufruf PROCEDURE (CONOUT)
        CALL       CONOUT
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x11
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; IF_THEN - Ende
M_IF_0434:
 
; PROCEDURE - Ende (RX_PUFFER_ABFRAGEN)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0005)
        MOV        R0, R16
        LDI        R17, HIGH(0x0005)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; Aufruf PROCEDURE (INIT_SER0_PORT)
        CALL       INIT_SER0_PORT
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (UP_SCHLEIFE_AKTIV)
        STS        UP_SCHLEIFE_AKTIV, R16
 
; Word-Parameter(1) fuer PROCEDURE (INIT_TIMER1_COMPA)
        LDI        R16, LOW(0x027B)
        MOV        R0, R16
        LDI        R17, HIGH(0x027B)
        MOV        R1, R17
 
; Aufruf PROCEDURE (INIT_TIMER1_COMPA)
        CALL       INIT_TIMER1_COMPA
 
; Word-Parameter(1) fuer PROCEDURE (INIT_TIMER3_COMPA)
        LDI        R16, LOW(0x027B)
        MOV        R0, R16
        LDI        R17, HIGH(0x027B)
        MOV        R1, R17
 
; Aufruf PROCEDURE (INIT_TIMER3_COMPA)
        CALL       INIT_TIMER3_COMPA
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (STARTBILDSCHIRM)
        STS        STARTBILDSCHIRM, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (GRAFIK_IM_BWS)
        STS        GRAFIK_IM_BWS, R16
 
; ASM
	lds        zl, tcnt1l
	lds        zh, tcnt1h
        ldi        yl, 12
        ldi        yh, 0
	add	  zl,yl
	adc	  zh,yh

        nop

        sts       tcnt3h, zh
        sts       tcnt3l, zl

 
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (WERT_YL)
        STS        WERT_YL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (WERT_YH)
        STS        WERT_YH, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (WERT_R17)
        STS        WERT_R17, R16
 
; ClearBit(HSYNC)
        CBI        PORTD, 2
 
; ClearBit(VSYNC)
        CBI        PORTD, 3
 
; SetBit(G)
        SBI        PORTD, 4
 
; SetBit(WE)
        SBI        PORTD, 5
 
; SetBit(OE)
        SBI        PORTD, 6
 
; ClearBit(A16)
        CBI        PORTD, 7
 
; ASM
        ldi       R16, low(Anfangsmarke)
      	sts	  Save_SP01, R16

        ldi       R16, high(Anfangsmarke)
      	sts	  Save_SP02, R16


        ldi       R16, low(Endlosschleife)
      	sts	  Endlos_SP01, R16

        ldi       R16, high(Endlosschleife)
      	sts	  Endlos_SP02, R16


        in        R16, port_control
        sts       Endlos_port_control, R16


        in        R16, port_adr_low
        sts       Save_port_adr_low, R16

        in        R16, port_adr_hig
        sts       Save_port_adr_hig, R16

        in        R16, port_dat
        sts       Save_port_dat, R16

        in        R16, ddr_dat
        sts       Save_ddr_dat, R16

        in        R16, port_control
        sts       Save_port_control, R16


 
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x20)
        LDI        R16, 0x20
 
; Zuweisung Ziel /  VAR (FUELLBYTE)
        STS        FUELLBYTE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (BWS_OFFSET)
        STS        BWS_OFFSET, R16
        STS        BWS_OFFSET+1, R17
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_FONT)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_FONT)
        CALL       SETZE_FONT
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (KURSOR_EIN)
        STS        KURSOR_EIN, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_SICHTBAR)
        STS        KURSOR_SICHTBAR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURARR_AKTUELL)
        STS        KURARR_AKTUELL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KURSOR_SCHLEIFE)
        STS        KURSOR_SCHLEIFE, R16
        STS        KURSOR_SCHLEIFE+1, R17
 
; Aufruf PROCEDURE (RESET_FORM)
        CALL       RESET_FORM
 
; Aufruf PROCEDURE (CLEAR_RAM)
        CALL       CLEAR_RAM
 
; Aufruf PROCEDURE (LOESCHE_BWS)
        CALL       LOESCHE_BWS
 
; Aufruf PROCEDURE (ESCAPE_RESET)
        CALL       ESCAPE_RESET
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('INIT VGA ...')
        LDI        ZL, LOW(2*M_CONST_STRING_1)
        LDI        ZH, HIGH(2*M_CONST_STRING_1)
        LDI        R29, Byte3(2*M_CONST_STRING_1)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0438
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0438:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0440
M_PRG_CONST_STRING_0439:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0439
M_PRG_CONST_STRING_0440:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0442
        MOV        R16, R17
M_PRG_CONST_STRING_0441:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0441
M_PRG_CONST_STRING_0442:
        ST         -Z, R17
 
; Aufruf PROCEDURE (TEXT_AN_CONOUT)
        CALL       TEXT_AN_CONOUT
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN)
        LDI        R16, 0x11
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN)
        CALL       SENDE_ZEICHEN
 
; Interrupt erlauben
        SEI
 
; ASM
Anfangsmarke:

 
 
; LOOP - Start_Marke
M_LOOP_0443:
 
; Aufruf PROCEDURE (RX_PUFFER_ABFRAGEN)
        CALL       RX_PUFFER_ABFRAGEN
 
; INC(KURSOR_SCHLEIFE) - Word
        LDS        R24, KURSOR_SCHLEIFE
        LDS        R25, KURSOR_SCHLEIFE+1
        ADIW       R25:R24, 1
        STS        KURSOR_SCHLEIFE, R24
        STS        KURSOR_SCHLEIFE+1, R25
 
; IF THEN - Ausdruck / Byte-VAR (KURSOR_EIN)
        LDS        R16, KURSOR_EIN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0444
        RJMP       M_IF_0445
M_IF_0444:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KURSOR_SCHLEIFE)
        LDS        R16, KURSOR_SCHLEIFE
        LDS        R17, KURSOR_SCHLEIFE+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x2328)
        LDI        R18, LOW(0x2328)
        LDI        R19, HIGH(0x2328)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0450
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0451
M_VERGL_0450:
        SER        R16
M_VERGL_0451:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0447
        RJMP       M_IF_0448
M_IF_0447:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KURSOR_SCHLEIFE)
        STS        KURSOR_SCHLEIFE, R16
        STS        KURSOR_SCHLEIFE+1, R17
 
; IF THEN - Ausdruck / Byte-VAR (KURSOR_SICHTBAR)
        LDS        R16, KURSOR_SICHTBAR
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0452
        RJMP       M_IF_0453
M_IF_0452:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KURSOR_SICHTBAR)
        STS        KURSOR_SICHTBAR, R16
 
; Aufruf PROCEDURE (SCHALTE_KURSOR_AUS)
        CALL       SCHALTE_KURSOR_AUS
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0454
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0453:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (KURSOR_SICHTBAR)
        STS        KURSOR_SICHTBAR, R16
 
; Aufruf PROCEDURE (SCHALTE_KURSOR_EIN)
        CALL       SCHALTE_KURSOR_EIN
 
; IF_THEN_ELSE - Ende
M_IF_0454:
 
; IF_THEN - Ende
M_IF_0448:
 
; IF_THEN - Ende
M_IF_0445:
 
; LOOP - Ende
        RJMP       M_LOOP_0443
 
; ASM
Endlosschleife:

        rjmp      Endlosschleife


 
 
; *** Unterprogramm Bibliothek ***
; Multiplikation von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17 erster Faktor
;            R18:R19 zweiter Faktor
; Temporaere Register: R20,R21,R22,R23,R24 
;                      R2 ,R3  R4  R5  R6
ASM_UP_MUL16:
 
        PUSH       R0
        PUSH       R1

        CLR        R24
        MUL        R19, R17
        MOVW       R23:R22, R1:R0
        MUL        R18, R16
        MOVW       R21:R20, R1:R0
        MUL        R19, R16
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MUL        R17, R18
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MOVW       R17:R16, R21:R20       ; Produkt Low
        MOVW       R19:R18, R23:R22       ; Produkt High

        POP        R1
        POP        R0		

        RET






 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UDR1 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR1H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UBRR1L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; UCSR1A (V) BYTECONVAR
; UCSR1B (V) BYTECONVAR
; UCSR1C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; OCR3BL (V) BYTECONVAR
; OCR3BH (V) BYTECONVAR
; OCR3AH (V) BYTECONVAR
; OCR3AL (V) BYTECONVAR
; ICR3L (V) BYTECONVAR
; ICR3H (V) BYTECONVAR
; TCNT3L (V) BYTECONVAR
; TCNT3H (V) BYTECONVAR
; TCCR3C (V) BYTECONVAR
; TCCR3B (V) BYTECONVAR
; TCCR3A (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; TIMSK3 (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; PCMSK3 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; PRR1 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR3 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; RXC1 (B) BIT
; TXC1 (B) BIT
; UDRE1 (B) BIT
; TIMER0_AUS (P) 
; INIT_TIMER0_OVF (P) 
; TIMER1_AUS (P) 
; INIT_TIMER1_COMPA (P) 
; INIT_TIMER2_OVF (P) 
; TIMER3_AUS (P) 
; INIT_TIMER3_COMPA (P) 
; TAKTFREQUENZ (C) WORD Wert=0x4E20
; UBRR_VAL (C) BYTE Wert=0x01
; XON (C) BYTE Wert=0x11
; XOFF (C) BYTE Wert=0x13
; CTC_WERT (C) WORD Wert=0x027B
; CTC_UMSCHALT_WERT (C) WORD Wert=0x00C8
; LAENGE_BWS (C) WORD Wert=0x07CF
; ANZAHL_SPALTEN0 (C) WORD Wert=0x0029
; ANZAHL_SPALTEN (C) WORD Wert=0x002A
; ANZAHL_ZEILEN0 (C) WORD Wert=0x0018
; ANZAHL_ZEILEN (C) WORD Wert=0x0019
; FNT_6X8 (C) BYTE Wert=0x01
; FNT_8X8 (C) BYTE Wert=0x02
; CL_WHITE (C) BYTE Wert=0xFF
; CL_BLACK (C) BYTE Wert=0x00
; CL_RED (C) BYTE Wert=0x43
; CL_GREEN (C) BYTE Wert=0x4C
; CL_BLUE (C) BYTE Wert=0xB0
; CL_YELLOW (C) BYTE Wert=0x4F
; CL_PURPLE (C) BYTE Wert=0x73
; CL_AQUA (C) BYTE Wert=0x7C
; CL_GRAY (C) BYTE Wert=0x6A
; CL_DARKGRAY (C) BYTE Wert=0x2A
; NORMAL_TM (C) BYTE Wert=0x00
; IBM_ESC_TM (C) BYTE Wert=0x01
; IBM_CSI_TM (C) BYTE Wert=0x02
; IBM_CSI_TM_PAR_1 (C) BYTE Wert=0x03
; IBM_CSI_TM_PAR_2 (C) BYTE Wert=0x04
; IBM_CSI_TM_PAR_3 (C) BYTE Wert=0x05
; IBM_GRAFIK_PAR_1_TM (C) BYTE Wert=0x06
; IBM_GRAFIK_PAR_2_TM (C) BYTE Wert=0x07
; MONITOR_LEER (C) BYTE Wert=0x00
; MONITOR_LINKS (C) BYTE Wert=0x01
; MONITOR_RECHTS (C) BYTE Wert=0x02
; FONT6X8 (A) 
; FONT8X8 (A) 
; CPM_ON_Z80 (A) 
; LAENGE_VLINE_ARRAY (C) WORD Wert=0x020D
; VLINE (A) 
; HSYNC (B) BIT
; VSYNC (B) BIT
; G (B) BIT
; WE (B) BIT
; OE (B) BIT
; A16 (B) BIT
; STEUER_STRING (V) STRING
; WERT_YL (V) BYTE
; WERT_YH (V) BYTE
; WERT_R17 (V) BYTE
; SAVE_R16 (V) BYTE
; SAVE_R17 (V) BYTE
; SAVE_R28 (V) BYTE
; SAVE_R29 (V) BYTE
; SAVE_R30 (V) BYTE
; SAVE_R31 (V) BYTE
; SAVE_SREG (V) BYTE
; SAVE_SP01 (V) BYTE
; SAVE_SP02 (V) BYTE
; SAVE_PORT_ADR_LOW (V) BYTE
; SAVE_PORT_ADR_HIG (V) BYTE
; SAVE_PORT_DAT (V) BYTE
; SAVE_DDR_DAT (V) BYTE
; SAVE_PORT_CONTROL (V) BYTE
; ENDLOS_SP01 (V) BYTE
; ENDLOS_SP02 (V) BYTE
; ENDLOS_PORT_CONTROL (V) BYTE
; ENDLOS_SREG (V) BYTE
; ENDLOS_R16 (V) BYTE
; UP_SCHLEIFE_AKTIV (V) BOOLEAN
; FCOLOR (V) BYTE
; BCOLOR (V) BYTE
; PIXCOLOR (V) BYTE
; ZEICHEN (V) BYTE
; X_KUR_POS (V) WORD
; Y_KUR_POS (V) WORD
; X_PIX_POS (V) WORD
; Y_PIX_POS (V) WORD
; X_END_POS (V) WORD
; Y_END_POS (V) WORD
; KURSOR_SCHLEIFE (V) WORD
; KURSOR_SICHTBAR (V) BOOLEAN
; KURSOR_EIN (V) BOOLEAN
; KURARR_AKTUELL (V) BOOLEAN
; ZEICHENBREITE (V) WORD
; ZEICHENHOEHE (V) WORD
; X_ANF (V) WORD
; Y_ANF (V) WORD
; MAX_SPALTEN0 (V) WORD
; MAX_ZEILEN0 (V) WORD
; MAX_SPALTEN (V) WORD
; MAX_ZEILEN (V) WORD
; FONT_BEZ (V) BYTE
; FUELLBYTE (V) BYTE
; BWS (Y) BYTE
; BWS_POS (V) WORD
; BWS_FCOLOR (Y) BYTE
; BWS_OFFSET (V) WORD
; ESCAPE_SEQUENZ (V) STRING
; TERMMODE (V) BYTE
; CSI_PARAMETER1 (V) WORD
; CSI_PARAMETER2 (V) WORD
; CSI_PARAMETER3 (V) WORD
; STARTBILDSCHIRM (V) BOOLEAN
; GRAFIK_IM_BWS (V) BOOLEAN
; WRITE_STRING (V) STRING
; BYTEPOSTOORMASKE (F) 
; BYTEPOSTOANDMASKE (F) 
; READ_BIT_IN_BYTE (F) 
; SET_BIT_IN_BYTE (F) 
; CLEAR_BIT_IN_BYTE (F) 
; WAIT_MS (P) 
; BYTETOSTRING (P) 
; STRINGTOBYTE (F) 
; INITPORTS (P) 
; INIT_SER0_PORT (P) 
; CLEAR_RAM (P) 
; RESET_FORM (P) 
; SETZE_FONT (P) 
; SCHREIBE_IMAGE_OT (P) 
; WRITE_CHAR_6X8 (P) 
; WRITE_CHAR_8X8 (P) 
; WRITE_CHAR (P) 
; CURSOR_RIGHT (P) 
; CURSOR_UP (P) 
; CURSOR_DOWN (P) 
; DELETE_EOL (P) 
; ERASE_DOWN (P) 
; DELETE_LINE (P) 
; DELETE_BOL (P) 
; INSERT_LINE_SCR_ROLL (P) 
; DELETE_LINE_SCR_ROLL (P) 
; SET_CURSOR_POSITION (P) 
; ANZEIGE_BWS (P) 
; SCHREIBE_ZEICHEN_IN_BWS (P) 
; SCREEN_ROLL_UP (P) 
; LOESCHE_BWS (P) 
; BERECHNE_BWS_POS (P) 
; SCHALTE_KURSOR_EIN (P) 
; SCHALTE_KURSOR_AUS (P) 
; NORMAL_TERMINAL_MODE (P) 
; ESCAPE_RESET (P) 
; ESCAPE_FEHLER (P) 
; IBM_ESC_TERMINAL_MODE (P) 
; SET_DISPLAY_ATTRIBUTES (P) 
; IBM_CSI_TERMINAL_MODE (P) 
; IBM_CSI_PAR_1_TERMINAL_MODE (P) 
; IBM_CSI_PAR_2_TERMINAL_MODE (P) 
; IBM_CSI_PAR_3_TERMINAL_MODE (P) 
; IBM_GRAFIK_PAR_1_TERMINAL_MODE (P) 
; IBM_GRAFIK_PAR_2_TERMINAL_MODE (P) 
; CONOUT (P) 
; TEXT_AN_CONOUT (P) 
; SENDE_ZEICHEN (P) 
; RX_PUFFER_ABFRAGEN (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE TIMER0_AUS;
; PROCEDURE INIT_TIMER0_OVF;
; PROCEDURE TIMER1_AUS;
; PROCEDURE INIT_TIMER1_COMPA (WERT : WORD) (B_WERT_L : BYTE) (B_WERT_H : BYTE);
; PROCEDURE INIT_TIMER2_OVF;
; PROCEDURE TIMER3_AUS;
; PROCEDURE INIT_TIMER3_COMPA (WERT : WORD) (B_WERT_L : BYTE) (B_WERT_H : BYTE);
; FUNCTION BYTEPOSTOORMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION BYTEPOSTOANDMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION READ_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (VERGLEICH : BYTE) (MASKE : BYTE) : BOOLEAN;
; FUNCTION SET_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION CLEAR_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; PROCEDURE WAIT_MS (ZEIT : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE BYTETOSTRING (WERT_BYTE : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE) (C1 : CHAR);
; FUNCTION STRINGTOBYTE (HEXLOW : BYTE) (HEXHIGH : BYTE) (S2B : BYTE) (C1 : CHAR) : BYTE;
; PROCEDURE INITPORTS;
; PROCEDURE INIT_SER0_PORT;
; PROCEDURE CLEAR_RAM (X1 : WORD) (X2 : WORD) (ADRESSE : WORD);
; PROCEDURE RESET_FORM;
; PROCEDURE SETZE_FONT (FONTGROESSE : BYTE);
; PROCEDURE SCHREIBE_IMAGE_OT (X1 : BYTE) (Y1 : BYTE) (X_BIS : BYTE) (Y_BIS : BYTE) (B_WERT : BYTE) (ADRESSE : WORD) (B_POINTER : WORD) (OFFSET : WORD);
; PROCEDURE WRITE_CHAR_6X8 (FONTPTR : WORD) (X_CNT : WORD) (Y_CNT : WORD) (FONTCOLOR : BYTE) (FONTZEILE : BYTE) (ADRESSE : WORD);
; PROCEDURE WRITE_CHAR_8X8 (FONTPTR : WORD) (X_CNT : WORD) (Y_CNT : WORD) (FONTCOLOR : BYTE) (FONTZEILE : BYTE) (ADRESSE : WORD);
; PROCEDURE WRITE_CHAR;
; PROCEDURE CURSOR_RIGHT;
; PROCEDURE CURSOR_UP;
; PROCEDURE CURSOR_DOWN;
; PROCEDURE DELETE_EOL;
; PROCEDURE ERASE_DOWN;
; PROCEDURE DELETE_LINE;
; PROCEDURE DELETE_BOL;
; PROCEDURE INSERT_LINE_SCR_ROLL;
; PROCEDURE DELETE_LINE_SCR_ROLL;
; PROCEDURE SET_CURSOR_POSITION (ZEILE : WORD) (SPALTE : WORD);
; PROCEDURE ANZEIGE_BWS (X1 : WORD) (Y1 : WORD) (OFFSET_SPALTEN : WORD) (SICHERUNG_FCOLOR : BYTE);
; PROCEDURE SCHREIBE_ZEICHEN_IN_BWS;
; PROCEDURE SCREEN_ROLL_UP (W1 : WORD) (W2 : WORD) (W3 : WORD) (KOPIE_ZEICHEN : BYTE) (KOPIE_FCOLOR : BYTE);
; PROCEDURE LOESCHE_BWS (ZEICHEN_ZAEHLER : WORD);
; PROCEDURE BERECHNE_BWS_POS (P1 : WORD);
; PROCEDURE SCHALTE_KURSOR_EIN;
; PROCEDURE SCHALTE_KURSOR_AUS (ALTES_ZEICHEN : BYTE);
; PROCEDURE NORMAL_TERMINAL_MODE (X1 : WORD) (Y1 : WORD);
; PROCEDURE ESCAPE_RESET;
; PROCEDURE ESCAPE_FEHLER (ESC_ZAEHLER : BYTE) (ESC_LAENGE : BYTE) (ESC_ZEICHEN : CHAR);
; PROCEDURE IBM_ESC_TERMINAL_MODE;
; PROCEDURE SET_DISPLAY_ATTRIBUTES (DISPATTR : WORD);
; PROCEDURE IBM_CSI_TERMINAL_MODE;
; PROCEDURE IBM_CSI_PAR_1_TERMINAL_MODE (ZAEHLER : WORD);
; PROCEDURE IBM_CSI_PAR_2_TERMINAL_MODE;
; PROCEDURE IBM_CSI_PAR_3_TERMINAL_MODE;
; PROCEDURE IBM_GRAFIK_PAR_1_TERMINAL_MODE;
; PROCEDURE IBM_GRAFIK_PAR_2_TERMINAL_MODE;
; PROCEDURE CONOUT (C_ZEICHEN : CHAR);
; PROCEDURE TEXT_AN_CONOUT (B1 : BYTE) (B2 : BYTE) (C1 : CHAR);
; PROCEDURE SENDE_ZEICHEN (S_ZEICHEN : BYTE);
; PROCEDURE RX_PUFFER_ABFRAGEN;
 
; *** Konstanten-ARRAYs ***
;
 
FONT6X8:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x20,0x70
.db    0x70,0x20
.db    0x20,0x00
.db    0x20,0x00
.db    0xD8,0xD8
.db    0x48,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x50
.db    0xF8,0x50
.db    0x50,0xF8
.db    0x50,0x00
.db    0x10,0x70
.db    0x08,0x30
.db    0x40,0x38
.db    0x20,0x00
.db    0x98,0x98
.db    0x40,0x20
.db    0x10,0xC8
.db    0xC8,0x00
.db    0x10,0x28
.db    0x28,0x10
.db    0xA8,0x48
.db    0xB0,0x00
.db    0x30,0x30
.db    0x10,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x20,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x20,0x00
.db    0x10,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x10,0x00
.db    0x00,0x50
.db    0x70,0xF8
.db    0x70,0x50
.db    0x00,0x00
.db    0x00,0x20
.db    0x20,0xF8
.db    0x20,0x20
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x30
.db    0x30,0x10
.db    0x00,0x00
.db    0x00,0xF8
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x30
.db    0x30,0x00
.db    0x00,0x80
.db    0x40,0x20
.db    0x10,0x08
.db    0x00,0x00
.db    0x70,0x88
.db    0xC8,0xA8
.db    0x98,0x88
.db    0x70,0x00
.db    0x20,0x30
.db    0x20,0x20
.db    0x20,0x20
.db    0x70,0x00
.db    0x70,0x88
.db    0x80,0x60
.db    0x10,0x08
.db    0xF8,0x00
.db    0x70,0x88
.db    0x80,0x70
.db    0x80,0x88
.db    0x70,0x00
.db    0x40,0x60
.db    0x50,0x48
.db    0xF8,0x40
.db    0x40,0x00
.db    0xF8,0x08
.db    0x08,0x78
.db    0x80,0x88
.db    0x70,0x00
.db    0x60,0x10
.db    0x08,0x78
.db    0x88,0x88
.db    0x70,0x00
.db    0xF8,0x80
.db    0x40,0x20
.db    0x10,0x10
.db    0x10,0x00
.db    0x70,0x88
.db    0x88,0x70
.db    0x88,0x88
.db    0x70,0x00
.db    0x70,0x88
.db    0x88,0xF0
.db    0x80,0x40
.db    0x30,0x00
.db    0x00,0x00
.db    0x30,0x30
.db    0x00,0x30
.db    0x30,0x00
.db    0x00,0x00
.db    0x30,0x30
.db    0x00,0x30
.db    0x30,0x10
.db    0x40,0x20
.db    0x10,0x08
.db    0x10,0x20
.db    0x40,0x00
.db    0x00,0x00
.db    0xF8,0x00
.db    0x00,0xF8
.db    0x00,0x00
.db    0x10,0x20
.db    0x40,0x80
.db    0x40,0x20
.db    0x10,0x00
.db    0x70,0x88
.db    0x80,0x60
.db    0x20,0x00
.db    0x20,0x00
.db    0x70,0x88
.db    0xE8,0xA8
.db    0xE8,0x08
.db    0x70,0x00
.db    0x70,0x88
.db    0x88,0x88
.db    0xF8,0x88
.db    0x88,0x00
.db    0x78,0x88
.db    0x88,0x78
.db    0x88,0x88
.db    0x78,0x00
.db    0x70,0x88
.db    0x08,0x08
.db    0x08,0x88
.db    0x70,0x00
.db    0x78,0x88
.db    0x88,0x88
.db    0x88,0x88
.db    0x78,0x00
.db    0xF8,0x08
.db    0x08,0x78
.db    0x08,0x08
.db    0xF8,0x00
.db    0xF8,0x08
.db    0x08,0x78
.db    0x08,0x08
.db    0x08,0x00
.db    0x70,0x88
.db    0x08,0xE8
.db    0x88,0x88
.db    0xF0,0x00
.db    0x88,0x88
.db    0x88,0xF8
.db    0x88,0x88
.db    0x88,0x00
.db    0x70,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x70,0x00
.db    0x80,0x80
.db    0x80,0x80
.db    0x88,0x88
.db    0x70,0x00
.db    0x88,0x48
.db    0x28,0x18
.db    0x28,0x48
.db    0x88,0x00
.db    0x08,0x08
.db    0x08,0x08
.db    0x08,0x08
.db    0xF8,0x00
.db    0x88,0xD8
.db    0xA8,0x88
.db    0x88,0x88
.db    0x88,0x00
.db    0x88,0x98
.db    0xA8,0xC8
.db    0x88,0x88
.db    0x88,0x00
.db    0x70,0x88
.db    0x88,0x88
.db    0x88,0x88
.db    0x70,0x00
.db    0x78,0x88
.db    0x88,0x78
.db    0x08,0x08
.db    0x08,0x00
.db    0x70,0x88
.db    0x88,0x88
.db    0xA8,0x48
.db    0xB0,0x00
.db    0x78,0x88
.db    0x88,0x78
.db    0x48,0x88
.db    0x88,0x00
.db    0x70,0x88
.db    0x08,0x70
.db    0x80,0x88
.db    0x70,0x00
.db    0xF8,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x00
.db    0x88,0x88
.db    0x88,0x88
.db    0x88,0x88
.db    0x70,0x00
.db    0x88,0x88
.db    0x88,0x88
.db    0x88,0x50
.db    0x20,0x00
.db    0x88,0x88
.db    0xA8,0xA8
.db    0xA8,0xA8
.db    0x50,0x00
.db    0x88,0x88
.db    0x50,0x20
.db    0x50,0x88
.db    0x88,0x00
.db    0x88,0x88
.db    0x88,0x50
.db    0x20,0x20
.db    0x20,0x00
.db    0x78,0x40
.db    0x20,0x10
.db    0x08,0x08
.db    0x78,0x00
.db    0x70,0x10
.db    0x10,0x10
.db    0x10,0x10
.db    0x70,0x00
.db    0x00,0x08
.db    0x10,0x20
.db    0x40,0x80
.db    0x00,0x00
.db    0x70,0x40
.db    0x40,0x40
.db    0x40,0x40
.db    0x70,0x00
.db    0x20,0x50
.db    0x88,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0xFC
.db    0x30,0x30
.db    0x20,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x70,0x80
.db    0xF0,0x88
.db    0xF0,0x00
.db    0x08,0x08
.db    0x78,0x88
.db    0x88,0x88
.db    0x78,0x00
.db    0x00,0x00
.db    0x70,0x88
.db    0x08,0x88
.db    0x70,0x00
.db    0x80,0x80
.db    0xF0,0x88
.db    0x88,0x88
.db    0xF0,0x00
.db    0x00,0x00
.db    0x70,0x88
.db    0x78,0x08
.db    0x70,0x00
.db    0x60,0x10
.db    0x10,0x78
.db    0x10,0x10
.db    0x10,0x00
.db    0x00,0x00
.db    0xF0,0x88
.db    0x88,0xF0
.db    0x80,0x70
.db    0x08,0x08
.db    0x38,0x48
.db    0x48,0x48
.db    0x48,0x00
.db    0x20,0x00
.db    0x20,0x20
.db    0x20,0x20
.db    0x60,0x00
.db    0x40,0x00
.db    0x60,0x40
.db    0x40,0x40
.db    0x48,0x30
.db    0x08,0x08
.db    0x48,0x28
.db    0x18,0x28
.db    0x48,0x00
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x60,0x00
.db    0x00,0x00
.db    0x58,0xA8
.db    0xA8,0x88
.db    0x88,0x00
.db    0x00,0x00
.db    0x38,0x48
.db    0x48,0x48
.db    0x48,0x00
.db    0x00,0x00
.db    0x70,0x88
.db    0x88,0x88
.db    0x70,0x00
.db    0x00,0x00
.db    0x78,0x88
.db    0x88,0x88
.db    0x78,0x08
.db    0x00,0x00
.db    0xF0,0x88
.db    0x88,0x88
.db    0xF0,0x80
.db    0x00,0x00
.db    0x68,0x90
.db    0x10,0x10
.db    0x38,0x00
.db    0x00,0x00
.db    0x70,0x08
.db    0x70,0x80
.db    0x70,0x00
.db    0x00,0x10
.db    0x78,0x10
.db    0x10,0x50
.db    0x20,0x00
.db    0x00,0x00
.db    0x48,0x48
.db    0x48,0x68
.db    0x50,0x00
.db    0x00,0x00
.db    0x88,0x88
.db    0x88,0x50
.db    0x20,0x00
.db    0x00,0x00
.db    0x88,0x88
.db    0xA8,0xF8
.db    0x50,0x00
.db    0x00,0x00
.db    0x48,0x48
.db    0x30,0x48
.db    0x48,0x00
.db    0x00,0x00
.db    0x48,0x48
.db    0x48,0x70
.db    0x20,0x18
.db    0x00,0x00
.db    0x78,0x40
.db    0x30,0x08
.db    0x78,0x00
.db    0x60,0x10
.db    0x10,0x18
.db    0x10,0x10
.db    0x60,0x00
.db    0x20,0x20
.db    0x20,0x00
.db    0x20,0x20
.db    0x20,0x00
.db    0x30,0x40
.db    0x40,0xC0
.db    0x40,0x40
.db    0x30,0x00
.db    0x50,0x28
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x20,0x70
.db    0xD8,0x88
.db    0x88,0xF8
.db    0x00,0x00
 
FONT8X8:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x0C,0x1E
.db    0x1E,0x0C
.db    0x0C,0x00
.db    0x0C,0x00
.db    0x36,0x36
.db    0x36,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x36,0x36
.db    0x7F,0x36
.db    0x7F,0x36
.db    0x36,0x00
.db    0x0C,0x3E
.db    0x03,0x1E
.db    0x30,0x1F
.db    0x0C,0x00
.db    0x00,0x63
.db    0x33,0x18
.db    0x0C,0x66
.db    0x63,0x00
.db    0x1C,0x36
.db    0x1C,0x6E
.db    0x3B,0x33
.db    0x6E,0x00
.db    0x06,0x06
.db    0x03,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x18,0x0C
.db    0x06,0x06
.db    0x06,0x0C
.db    0x18,0x00
.db    0x06,0x0C
.db    0x18,0x18
.db    0x18,0x0C
.db    0x06,0x00
.db    0x00,0x66
.db    0x3C,0xFF
.db    0x3C,0x66
.db    0x00,0x00
.db    0x00,0x0C
.db    0x0C,0x3F
.db    0x0C,0x0C
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x0E
.db    0x0C,0x06
.db    0x00,0x00
.db    0x00,0x3F
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x0C
.db    0x0C,0x00
.db    0x60,0x30
.db    0x18,0x0C
.db    0x06,0x03
.db    0x01,0x00
.db    0x1E,0x33
.db    0x3B,0x3F
.db    0x37,0x33
.db    0x1E,0x00
.db    0x0C,0x0F
.db    0x0C,0x0C
.db    0x0C,0x0C
.db    0x3F,0x00
.db    0x1E,0x33
.db    0x30,0x1C
.db    0x06,0x33
.db    0x3F,0x00
.db    0x1E,0x33
.db    0x30,0x1C
.db    0x30,0x33
.db    0x1E,0x00
.db    0x38,0x3C
.db    0x36,0x33
.db    0x7F,0x30
.db    0x30,0x00
.db    0x3F,0x03
.db    0x1F,0x30
.db    0x30,0x33
.db    0x1E,0x00
.db    0x1C,0x06
.db    0x03,0x1F
.db    0x33,0x33
.db    0x1E,0x00
.db    0x3F,0x33
.db    0x30,0x18
.db    0x0C,0x06
.db    0x06,0x00
.db    0x1E,0x33
.db    0x33,0x1E
.db    0x33,0x33
.db    0x1E,0x00
.db    0x1E,0x33
.db    0x33,0x3E
.db    0x30,0x18
.db    0x0E,0x00
.db    0x00,0x00
.db    0x0C,0x0C
.db    0x00,0x0C
.db    0x0C,0x00
.db    0x00,0x00
.db    0x0C,0x0C
.db    0x00,0x0E
.db    0x0C,0x06
.db    0x18,0x0C
.db    0x06,0x03
.db    0x06,0x0C
.db    0x18,0x00
.db    0x00,0x00
.db    0x3F,0x00
.db    0x3F,0x00
.db    0x00,0x00
.db    0x06,0x0C
.db    0x18,0x30
.db    0x18,0x0C
.db    0x06,0x00
.db    0x1E,0x33
.db    0x30,0x18
.db    0x0C,0x00
.db    0x0C,0x00
.db    0x3E,0x63
.db    0x7B,0x7B
.db    0x7B,0x03
.db    0x1E,0x00
.db    0x0C,0x1E
.db    0x33,0x33
.db    0x3F,0x33
.db    0x33,0x00
.db    0x3F,0x66
.db    0x66,0x3E
.db    0x66,0x66
.db    0x3F,0x00
.db    0x3C,0x66
.db    0x03,0x03
.db    0x03,0x66
.db    0x3C,0x00
.db    0x3F,0x36
.db    0x66,0x66
.db    0x66,0x36
.db    0x3F,0x00
.db    0x7F,0x46
.db    0x16,0x1E
.db    0x16,0x46
.db    0x7F,0x00
.db    0x7F,0x46
.db    0x16,0x1E
.db    0x16,0x06
.db    0x0F,0x00
.db    0x3C,0x66
.db    0x03,0x03
.db    0x73,0x66
.db    0x7C,0x00
.db    0x33,0x33
.db    0x33,0x3F
.db    0x33,0x33
.db    0x33,0x00
.db    0x1E,0x0C
.db    0x0C,0x0C
.db    0x0C,0x0C
.db    0x1E,0x00
.db    0x78,0x30
.db    0x30,0x30
.db    0x33,0x33
.db    0x1E,0x00
.db    0x67,0x66
.db    0x36,0x1E
.db    0x36,0x66
.db    0x67,0x00
.db    0x0F,0x06
.db    0x06,0x06
.db    0x46,0x66
.db    0x7F,0x00
.db    0x63,0x77
.db    0x7F,0x6B
.db    0x63,0x63
.db    0x63,0x00
.db    0x63,0x67
.db    0x6F,0x7B
.db    0x73,0x63
.db    0x63,0x00
.db    0x1C,0x36
.db    0x63,0x63
.db    0x63,0x36
.db    0x1C,0x00
.db    0x3F,0x66
.db    0x66,0x3E
.db    0x06,0x06
.db    0x0F,0x00
.db    0x1E,0x33
.db    0x33,0x33
.db    0x3B,0x1E
.db    0x38,0x00
.db    0x3F,0x66
.db    0x66,0x3E
.db    0x1E,0x36
.db    0x67,0x00
.db    0x1E,0x33
.db    0x07,0x1C
.db    0x38,0x33
.db    0x1E,0x00
.db    0x3F,0x2D
.db    0x0C,0x0C
.db    0x0C,0x0C
.db    0x1E,0x00
.db    0x33,0x33
.db    0x33,0x33
.db    0x33,0x33
.db    0x3F,0x00
.db    0x33,0x33
.db    0x33,0x33
.db    0x33,0x1E
.db    0x0C,0x00
.db    0x63,0x63
.db    0x63,0x6B
.db    0x7F,0x77
.db    0x63,0x00
.db    0x63,0x63
.db    0x36,0x1C
.db    0x36,0x63
.db    0x63,0x00
.db    0x33,0x33
.db    0x33,0x1E
.db    0x0C,0x0C
.db    0x1E,0x00
.db    0x7F,0x33
.db    0x19,0x0C
.db    0x46,0x63
.db    0x7F,0x00
.db    0x1E,0x06
.db    0x06,0x06
.db    0x06,0x06
.db    0x1E,0x00
.db    0x03,0x06
.db    0x0C,0x18
.db    0x30,0x60
.db    0x40,0x00
.db    0x1E,0x18
.db    0x18,0x18
.db    0x18,0x18
.db    0x1E,0x00
.db    0x08,0x1C
.db    0x36,0x63
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0xFF
.db    0x0C,0x0C
.db    0x18,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1E,0x30
.db    0x3E,0x33
.db    0x6E,0x00
.db    0x07,0x06
.db    0x3E,0x66
.db    0x66,0x66
.db    0x3D,0x00
.db    0x00,0x00
.db    0x1E,0x33
.db    0x03,0x33
.db    0x1E,0x00
.db    0x38,0x30
.db    0x30,0x3E
.db    0x33,0x33
.db    0x6E,0x00
.db    0x00,0x00
.db    0x1E,0x33
.db    0x3F,0x03
.db    0x1E,0x00
.db    0x1C,0x36
.db    0x06,0x0F
.db    0x06,0x06
.db    0x0F,0x00
.db    0x00,0x00
.db    0x6E,0x33
.db    0x33,0x3E
.db    0x30,0x1F
.db    0x07,0x06
.db    0x36,0x6E
.db    0x66,0x66
.db    0x67,0x00
.db    0x0C,0x00
.db    0x0E,0x0C
.db    0x0C,0x0C
.db    0x1E,0x00
.db    0x18,0x00
.db    0x1E,0x18
.db    0x18,0x18
.db    0x1B,0x0E
.db    0x07,0x06
.db    0x66,0x36
.db    0x1E,0x36
.db    0x67,0x00
.db    0x0E,0x0C
.db    0x0C,0x0C
.db    0x0C,0x0C
.db    0x1E,0x00
.db    0x00,0x00
.db    0x37,0x7F
.db    0x6B,0x63
.db    0x63,0x00
.db    0x00,0x00
.db    0x1F,0x33
.db    0x33,0x33
.db    0x33,0x00
.db    0x00,0x00
.db    0x1E,0x33
.db    0x33,0x33
.db    0x1E,0x00
.db    0x00,0x00
.db    0x3B,0x66
.db    0x66,0x3E
.db    0x06,0x0F
.db    0x00,0x00
.db    0x6E,0x33
.db    0x33,0x3E
.db    0x30,0x78
.db    0x00,0x00
.db    0x1B,0x36
.db    0x36,0x06
.db    0x0F,0x00
.db    0x00,0x00
.db    0x3E,0x03
.db    0x1E,0x30
.db    0x1F,0x00
.db    0x08,0x0C
.db    0x3E,0x0C
.db    0x0C,0x2C
.db    0x18,0x00
.db    0x00,0x00
.db    0x33,0x33
.db    0x33,0x33
.db    0x6E,0x00
.db    0x00,0x00
.db    0x33,0x33
.db    0x33,0x1E
.db    0x0C,0x00
.db    0x00,0x00
.db    0x63,0x63
.db    0x6B,0x7F
.db    0x36,0x00
.db    0x00,0x00
.db    0x63,0x36
.db    0x1C,0x36
.db    0x63,0x00
.db    0x00,0x00
.db    0x33,0x33
.db    0x33,0x3E
.db    0x30,0x1F
.db    0x00,0x00
.db    0x3F,0x19
.db    0x0C,0x26
.db    0x3F,0x00
.db    0x38,0x0C
.db    0x0C,0x07
.db    0x0C,0x0C
.db    0x38,0x00
.db    0x18,0x18
.db    0x18,0x00
.db    0x18,0x18
.db    0x18,0x00
.db    0x07,0x0C
.db    0x0C,0x38
.db    0x0C,0x0C
.db    0x07,0x00
.db    0x6E,0x3B
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x08,0x1C
.db    0x36,0x63
.db    0x63,0x63
.db    0x7F,0x00
 
CPM_ON_Z80:
.db    0xFF,0x25
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF9,0xF8
.db    0xF8,0xF9
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF9
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFA
.db    0xF8,0xFE
.db    0xFF,0xFF
.db    0xFA,0xF8
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xDF,0xCF
.db    0xCF,0xCF
.db    0xEF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFE
.db    0xFA,0xF9
.db    0xF8,0xF8
.db    0xF8,0xF9
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF9
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFE
.db    0xF8,0xFF
.db    0xFF,0xF9
.db    0xF9,0xFA
.db    0xFF,0xF4
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0xEF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0xDF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF8
.db    0xF9,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF4
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0xB8,0xF9
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x78,0x78
.db    0x78,0xF9
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFA
.db    0xF8,0xFA
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF9
.db    0xB8,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF4,0xFF
.db    0xFF,0xF8
.db    0xFF,0xFF
.db    0xB8,0xFF
.db    0xFF,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0xEF,0xEF
.db    0xEF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0xEF
.db    0xFF,0xCF
.db    0xCF,0xCF
.db    0xFF,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF9
.db    0xB8,0x78
.db    0x78,0x78
.db    0xB8,0xB8
.db    0x78,0x78
.db    0xFA,0xFF
.db    0xFF,0xFF
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xB8
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF8,0x78
.db    0x78,0x78
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF9
.db    0x78,0x78
.db    0x78,0xFE
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFE
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xF8
.db    0xFF,0xF9
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF4,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEF,0xDF
.db    0xDF,0xDF
.db    0xEF,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0xEF,0xEF
.db    0xEF,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0xCF,0xCF
.db    0x8F,0x8F
.db    0xCF,0xCF
.db    0xDF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0xFF,0xDF
.db    0xEF,0xFF
.db    0xDF,0xFF
.db    0xEF,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF9,0xB8
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x78
.db    0x78,0x78
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0x78
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF4,0x78
.db    0x78,0x78
.db    0x7C,0xFF
.db    0xFF,0xFF
.db    0xF8,0xFF
.db    0xF9,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF4
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFB
.db    0xFB,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xDF,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xDF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xEF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0xDF,0xFF
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF8,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFE
.db    0x78,0x78
.db    0x78,0xF9
.db    0xFF,0xFF
.db    0xFF,0xFE
.db    0xF8,0xB8
.db    0x78,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF9
.db    0x78,0x78
.db    0x78,0xFE
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFA,0x78
.db    0x78,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xF8
.db    0xFF,0xFA
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF4,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xD7
.db    0x93,0x93
.db    0x93,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFB
.db    0xE7,0xD3
.db    0xD3,0xD3
.db    0xEB,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xDF,0xFF
.db    0xFF,0xFF
.db    0xEF,0xDF
.db    0xFF,0xDF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0xB8,0xB8
.db    0xB8,0x78
.db    0x78,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFE,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF4
.db    0x78,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF8
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xF8,0xFE
.db    0xFF,0xF9
.db    0xF8,0xF8
.db    0xF8,0xFF
.db    0xFA,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFB,0xD7
.db    0xD3,0x93
.db    0x93,0x93
.db    0xD3,0xE7
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x93,0x93
.db    0x93,0x93
.db    0xE7,0xFF
.db    0xFF,0xFF
.db    0xFF,0xD3
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xDF,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xCF,0xCF
.db    0xCF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xCF,0xDF
.db    0xEF,0xEF
.db    0xDF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xEF,0xFF
.db    0xFF,0xFF
.db    0xCF,0xFF
.db    0xEF,0xDF
.db    0xFF,0xDF
.db    0xFF,0xEF
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF4,0x78
.db    0x78,0x78
.db    0x78,0xB8
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFA,0x78
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFE
.db    0x78,0x78
.db    0x78,0xFE
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF4
.db    0x78,0x78
.db    0x78,0xFE
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFE,0x78
.db    0x78,0x78
.db    0xF9,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0xF9,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF9,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xF4,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF4
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFB
.db    0xD3,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xE7,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEB,0x93
.db    0x93,0x93
.db    0x93,0xD3
.db    0xFF,0xFF
.db    0xEB,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEF,0xDF
.db    0xDF,0xDF
.db    0xDF,0xDF
.db    0xDF,0xDF
.db    0xDF,0xDF
.db    0xDF,0xEF
.db    0xEF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0xEF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xDF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xEF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0xEF,0xFF
.db    0xEF,0xCF
.db    0xFF,0xFF
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF9,0x78
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFE,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x78
.db    0x78,0x78
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF4
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF8
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF8,0xF9
.db    0xFE,0xFA
.db    0xF8,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xE7
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xD3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x93,0x93
.db    0x93,0x93
.db    0xD3,0xFF
.db    0xEB,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xD3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xDF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0x8F,0x8F
.db    0x8F,0xDF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xEF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0xEF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0xEF,0xFF
.db    0xFF,0xFF
.db    0xCF,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFA,0x78
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF4,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFA
.db    0x78,0x78
.db    0x78,0xFE
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFE
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFA
.db    0xFA,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xE7
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xE7,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x93
.db    0x93,0x93
.db    0x93,0xD3
.db    0xEB,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xCF,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEF,0x8F
.db    0x8F,0x8F
.db    0xDF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xDF,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEF,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xDF
.db    0xCF,0xCF
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFA,0x78
.db    0x78,0x78
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF9,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF9,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEB
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xFB,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xD3
.db    0xEB,0xE7
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xEB
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xDF
.db    0x8F,0x8F
.db    0x8F,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF4
.db    0x78,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFA
.db    0x78,0x78
.db    0x78,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF8
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF9
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xFE
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xD3,0xEB
.db    0xFF,0xFF
.db    0xFF,0xE7
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xD3
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xD3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xE7
.db    0x93,0x93
.db    0x93,0x93
.db    0xD7,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xDF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xDF,0x8F
.db    0x8F,0x8F
.db    0xDF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFE
.db    0x78,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF9,0x78
.db    0x78,0x78
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF9,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF9
.db    0x78,0x78
.db    0x78,0xFE
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0x78
.db    0xB8,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF4,0x78
.db    0x78,0x78
.db    0xF8,0x78
.db    0x78,0x78
.db    0xF9,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xD7,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xE7,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEB
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xD3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFB,0x93
.db    0x93,0x93
.db    0x93,0xD3
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xDF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xDF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0xDF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xDF,0x8F
.db    0x8F,0x8F
.db    0xEF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xDF,0x8F
.db    0x8F,0x8F
.db    0xDF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0x78
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF9
.db    0x78,0x78
.db    0x7C,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFE,0x78
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0x7C,0xF9
.db    0x78,0x78
.db    0x78,0xF9
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0x7C,0xFE
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xD3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xE7
.db    0x93,0x93
.db    0x93,0x93
.db    0xE7,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x93,0x93
.db    0x93,0x93
.db    0xC3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xEF,0xFF
.db    0xFF,0xFF
.db    0xEF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFE,0x78
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF8,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF9,0x78
.db    0x78,0x78
.db    0x78,0xF9
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF9,0x78
.db    0x78,0x78
.db    0xF9,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x78,0x78
.db    0x78,0xB8
.db    0xFE,0x78
.db    0x78,0x78
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFA
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0x78
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xE7
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x93
.db    0x93,0x93
.db    0x93,0xD3
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xEB
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x93
.db    0x93,0x93
.db    0x93,0xC3
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xDF,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xCF,0xCF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xDF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF8
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF8
.db    0x78,0x78
.db    0xB8,0xFA
.db    0xFE,0xFF
.db    0xFA,0xF8
.db    0xB8,0x78
.db    0x78,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF9,0x78
.db    0x78,0x78
.db    0xF8,0xFF
.db    0x78,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF8,0x78
.db    0x78,0x78
.db    0xF9,0xFF
.db    0xB8,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xD3,0x93
.db    0x93,0x93
.db    0x93,0xE7
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xC3,0x93
.db    0x93,0x93
.db    0xD3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xD3
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x93,0x93
.db    0x93,0x93
.db    0xC3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xEF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0x78
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF4,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF9
.db    0x78,0x78
.db    0x78,0xFE
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0x78,0xF9
.db    0xFF,0xB8
.db    0x78,0x78
.db    0x78,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xF4
.db    0x78,0x78
.db    0x78,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xD3
.db    0x93,0x93
.db    0x93,0x93
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEB
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xFB,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x93
.db    0x93,0x93
.db    0x93,0xC3
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xDF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xCF,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x78
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xF9
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB4,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0x78
.db    0xFF,0xFF
.db    0xF8,0x78
.db    0x78,0x78
.db    0xF9,0xFF
.db    0xFF,0xFE
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xF9,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFB
.db    0x93,0x93
.db    0x93,0x93
.db    0xD3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xD3,0x93
.db    0x93,0x93
.db    0x93,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEB,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xD3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x93,0x93
.db    0x93,0x93
.db    0xC3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xDF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFA
.db    0x78,0x78
.db    0x78,0xF9
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xB8
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF8,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFE,0x78
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFA
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xF8,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFA
.db    0x78,0x78
.db    0x78,0xF9
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEB,0x93
.db    0x93,0x93
.db    0x93,0xD3
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xD3
.db    0x93,0x93
.db    0x93,0x93
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEB
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xEB
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x93
.db    0x93,0x93
.db    0x93,0xC3
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xDF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xDF,0xFF
.db    0xEF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEF,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF9,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0xF4,0xFE
.db    0xF9,0xF9
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x78
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF8
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0x78
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xFF,0x78
.db    0x78,0x78
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEB
.db    0x93,0x93
.db    0x93,0x93
.db    0xD7,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xD3,0x93
.db    0x93,0x93
.db    0x93,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xE7,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x93,0x93
.db    0x93,0x93
.db    0xC3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xEF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0x8F,0x8F
.db    0x8F,0xDF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF8
.db    0x78,0x78
.db    0x78,0xFE
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF4
.db    0x78,0x78
.db    0x78,0xFE
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0x78
.db    0xF9,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0x78
.db    0xFF,0xFA
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEB,0x93
.db    0x93,0x93
.db    0x93,0xD7
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xD3
.db    0x93,0x93
.db    0x93,0x93
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xE7
.db    0x93,0x93
.db    0x93,0x93
.db    0xD3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xDF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xEF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xDF,0x8F
.db    0x8F,0x8F
.db    0xEF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF9,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFE
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x78
.db    0x78,0x78
.db    0x78,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF4
.db    0x78,0x78
.db    0x78,0xF9
.db    0xF4,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0x78,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEB
.db    0x93,0x93
.db    0x93,0x93
.db    0xD7,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xD3,0x93
.db    0x93,0x93
.db    0x93,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xD3,0x93
.db    0x93,0x93
.db    0x93,0xE7
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xDF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xFF,0xFF
.db    0xFF,0xDF
.db    0x8F,0x8F
.db    0x8F,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF9
.db    0x78,0x78
.db    0x78,0xF9
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFE,0xFE
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF4,0x78
.db    0x78,0x78
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFA
.db    0x78,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFA,0x78
.db    0x78,0x78
.db    0xB8,0x78
.db    0x78,0x78
.db    0x7C,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF8,0x78
.db    0x78,0x78
.db    0xF9,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x93
.db    0x93,0x93
.db    0x93,0xD3
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x93
.db    0x93,0x93
.db    0x93,0xD3
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xD3
.db    0x93,0x93
.db    0x93,0x93
.db    0xE7,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xFF
.db    0xFF,0xFF
.db    0xEF,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFE,0x78
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF4,0x78
.db    0x78,0xF9
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x78
.db    0x78,0x78
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF8,0x78
.db    0x78,0x78
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFA
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEB
.db    0x93,0x93
.db    0x93,0x93
.db    0xE7,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xD3,0x93
.db    0x93,0x93
.db    0x93,0xEB
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0x8F,0x8F
.db    0x8F,0xDF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEF,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0x78
.db    0xF9,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFA
.db    0xB8,0x78
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF4
.db    0x78,0x78
.db    0x78,0xFE
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0x78,0xF9
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0xF9,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x78
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xD3
.db    0x93,0x93
.db    0x93,0x93
.db    0xE7,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xD3,0x93
.db    0x93,0x93
.db    0x93,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xD3
.db    0x93,0x93
.db    0x93,0x93
.db    0xEB,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xEB,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEF,0x8F
.db    0x8F,0x8F
.db    0xDF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0xDF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF9
.db    0x78,0x78
.db    0x78,0x78
.db    0xF9,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFE,0xF4
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x78,0x78
.db    0x78,0xF4
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x78,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF8,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xE7,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xFB,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xD3,0x93
.db    0x93,0x93
.db    0x93,0xD3
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xD3,0x93
.db    0x93,0x93
.db    0x93,0xEB
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xD3,0x93
.db    0x93,0x93
.db    0x93,0xE7
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEF,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0x78,0x78
.db    0xB8,0xF8
.db    0xF8,0xF8
.db    0xB8,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF8,0x78
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x78
.db    0x78,0x78
.db    0x78,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFA
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF4
.db    0x78,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xE7,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFB
.db    0xD3,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xFB,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xD3
.db    0x93,0x93
.db    0x93,0x93
.db    0xEB,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xD3
.db    0x93,0x93
.db    0x93,0x93
.db    0xD7,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xDF,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x7C,0xF9
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFA
.db    0x78,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB4
.db    0x78,0x78
.db    0x78,0x78
.db    0xF9,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF9,0x78
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xE7
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xD3
.db    0xD3,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xD3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xE7,0x93
.db    0x93,0x93
.db    0x93,0xE7
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xD7,0x93
.db    0x93,0x93
.db    0x93,0xD3
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xDF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xEF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEF,0xEF
.db    0xEF,0xEF
.db    0xEF,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xCF,0xEF
.db    0xFF,0xFF
.db    0xFF,0xDF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0xF8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF9
.db    0x78,0x78
.db    0x78,0xFA
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFA,0x78
.db    0x78,0x78
.db    0xF8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xF4,0x78
.db    0x78,0x78
.db    0xB8,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFE
.db    0x78,0x78
.db    0x78,0x78
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xD3
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xD3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xE7
.db    0x93,0x93
.db    0x93,0x93
.db    0xE7,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xE7
.db    0x93,0x93
.db    0x93,0x93
.db    0xD3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xCF,0xDF
.db    0xDF,0xCF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF9
.db    0xB8,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0xB8,0xF8
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF4
.db    0x78,0x78
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xB8,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFA
.db    0x78,0x78
.db    0x78,0xF9
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFE
.db    0x78,0x78
.db    0x78,0xF9
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0x78
.db    0x78,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xD3
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEB,0x93
.db    0x93,0x93
.db    0x93,0xE7
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEB,0x93
.db    0x93,0x93
.db    0x93,0xD3
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xCF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFA
.db    0xFA,0xFE
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFA
.db    0xFE,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF4
.db    0x78,0x78
.db    0xF9,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xB8
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFA
.db    0xF8,0xF9
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFA,0x78
.db    0x78,0xB8
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xE7
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0xD3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x93,0x93
.db    0x93,0x93
.db    0xEB,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x93,0x93
.db    0x93,0x93
.db    0xD3,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xCF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0xDF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0xCF,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0x8F,0x8F
.db    0xCF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF9
.db    0xF9,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFE,0xFA
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFB
.db    0xD3,0x93
.db    0x93,0x93
.db    0x93,0x93
.db    0x93,0xD3
.db    0xEB,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xE7
.db    0x93,0x93
.db    0xE7,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xD3
.db    0x93,0x93
.db    0x93,0xEB
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEF
.db    0xCF,0xCF
.db    0xCF,0xCF
.db    0xCF,0xCF
.db    0xCF,0xCF
.db    0xCF,0xCF
.db    0xCF,0xCF
.db    0xDF,0xDF
.db    0xDF,0xDF
.db    0xDF,0xDF
.db    0xDF,0xDF
.db    0xCF,0xDF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xDF
.db    0xCF,0xCF
.db    0xCF,0xCF
.db    0xCF,0xCF
.db    0xEF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xDF
.db    0xCF,0xCF
.db    0xDF,0xEF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xEB,0xEB
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xEB
.db    0xE7,0xFB
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0x00
 
VLINE:
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x04,0x0C
.db    0x10,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x02
.db    0x02,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x21,0x00
 
; *** Konstanten-STRING-Liste ***
;
 
M_CONST_STRING_0:
 .db    0, " "
 
M_CONST_STRING_1:
 .db    12, "INIT VGA ... "
 
; *** ISR-Liste ***
;
; Nummer=2    ORG=INT0addr     ISR=EI_INT0       Bemerkung=External Interrupt Request 0
; Nummer=3    ORG=INT1addr     ISR=EI_INT1       Bemerkung=External Interrupt Request 1
; Nummer=4    ORG=INT2addr     ISR=EI_INT2       Bemerkung=External Interrupt Request 1
; Nummer=5    ORG=PCI0addr     ISR=PCINT0        Bemerkung=Pin Change Interrupt Request 0
; Nummer=6    ORG=PCI1addr     ISR=PCINT1        Bemerkung=Pin Change Interrupt Request 1
; Nummer=7    ORG=PCI2addr     ISR=PCINT2        Bemerkung=Pin Change Interrupt Request 2
; Nummer=8    ORG=PCI3addr     ISR=PCINT3        Bemerkung=Pin Change Interrupt Request 3
; Nummer=9    ORG=WDTaddr      ISR=WDT           Bemerkung=Watchdog Time-out Interrupt
; Nummer=10   ORG=OC2Aaddr     ISR=TIMER2_COMPA  Bemerkung=Timer/Counter2 Compare Match A
; Nummer=11   ORG=OC2Baddr     ISR=TIMER2_COMPB  Bemerkung=Timer/Counter2 Compare Match B
; Nummer=12   ORG=OVF2addr     ISR=TIMER2_OVF    Bemerkung=Timer/Counter2 Overflow
; Nummer=13   ORG=ICP1addr     ISR=TIMER1_CAPT   Bemerkung=Timer/Counter1 Capture Event
; Nummer=14   ORG=OC1Aaddr     ISR=TIMER1_COMPA  Bemerkung=Timer/Counter1 Compare Match A
; Nummer=15   ORG=OC1Baddr     ISR=TIMER1_COMPB  Bemerkung=Timer/Counter1 Compare Match B
; Nummer=16   ORG=OVF1addr     ISR=TIMER1_OVF    Bemerkung=Timer/Counter1 Overflow
; Nummer=17   ORG=OC0Aaddr     ISR=TIMER0_COMPA  Bemerkung=Timer/Counter0 Compare Match A
; Nummer=18   ORG=OC0Baddr     ISR=TIMER0_COMPB  Bemerkung=Timer/Counter0 Compare Match B
; Nummer=19   ORG=OVF0addr     ISR=TIMER0_OVF    Bemerkung=Timer/Counter0 Overflow
; Nummer=20   ORG=SPIaddr      ISR=SPI_STC       Bemerkung=Serial Transfer Complete
; Nummer=21   ORG=URXC0addr    ISR=USART0_RXC    Bemerkung=USART0, Rx Complete
; Nummer=22   ORG=UDRE0addr    ISR=USART0_UDRE   Bemerkung=USART0 Data Register Empty
; Nummer=23   ORG=UTXC0addr    ISR=USART0_TXC    Bemerkung=USART0, Tx Complete
; Nummer=24   ORG=ACIaddr      ISR=ANA_COMP      Bemerkung=Analog Comparator
; Nummer=25   ORG=ADCCaddr     ISR=ADC_CC        Bemerkung=ADC Conversion Complete
; Nummer=26   ORG=ERDYaddr     ISR=EE_RDY        Bemerkung=EEPROM Ready
; Nummer=27   ORG=TWIaddr      ISR=TWI           Bemerkung=Two-wire Serial Interface
; Nummer=28   ORG=SPMRaddr     ISR=SPM_RDY       Bemerkung=Store Program Memory Ready
; Nummer=29   ORG=URXC1addr    ISR=USART1_RXC    Bemerkung=USART0, Rx Complete
; Nummer=30   ORG=UDRE1addr    ISR=USART1_UDRE   Bemerkung=USART0 Data Register Empty
; Nummer=31   ORG=UTXC1addr    ISR=USART1_TXC    Bemerkung=USART0, Tx Complete
; Nummer=32   ORG=ICP3addr     ISR=TIMER3_CAPT   Bemerkung=Timer/Counter3 Capture Event
; Nummer=33   ORG=OC3Aaddr     ISR=TIMER3_COMPA  Bemerkung=Timer/Counter3 Compare Match A
; Nummer=34   ORG=OC3Baddr     ISR=TIMER3_COMPB  Bemerkung=Timer/Counter3 Compare Match B
; Nummer=35   ORG=OVF3addr     ISR=TIMER3_OVF    Bemerkung=Timer/Counter3 Overflow
 
