; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: CONIO3.PAS
 
.nolist
.INCLUDE "m1284Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        ABTASTWERT  =  0x71 ; BYTE
.equ        TAKTFREQUENZ  =  0x4E20 ; WORD
.equ        UBRR_VAL_S0  =  0x01 ; BYTE
.equ        UBRR_VAL_S1  =  0x0A ; BYTE
.equ        XON  =  0x11 ; BYTE
.equ        XOFF  =  0x13 ; BYTE
.equ        CHAR_NULL  =  0x00 ; CHAR
.equ        PA_CONST  =  0x01 ; BYTE
.equ        PA_CONIN  =  0x02 ; BYTE
.equ        PA_CONOUT  =  0x03 ; BYTE
.equ        PA_LIST  =  0x04 ; BYTE
.equ        PA_SOUND  =  0x05 ; BYTE
.equ        PA_WRITE  =  0x06 ; BYTE
.equ        PA_READ  =  0x07 ; BYTE
.equ        PA_STD  =  0x08 ; BYTE
.equ        PA_KOMMENTAR  =  0x09 ; BYTE
.equ        PA_DUMMY  =  0x0A ; BYTE
.equ        PA_CPM_START  =  0x0B ; BYTE
.equ        MONITOR_LEER  =  0x00 ; BYTE
.equ        MONITOR_LINKS  =  0x01 ; BYTE
.equ        MONITOR_RECHTS  =  0x02 ; BYTE
.equ        NO_LED_STATE  =  0x00 ; BYTE
.equ        LEDSCROLL  =  0x01 ; BYTE
.equ        LEDNUM  =  0x02 ; BYTE
.equ        LEDCAPS  =  0x04 ; BYTE
.equ        KEYSTAT_BYTE1  =  0x01 ; BYTE
.equ        KEYSTAT_E0  =  0x02 ; BYTE
.equ        KEYSTAT_F0  =  0x03 ; BYTE
.equ        NO_SHIFTSTATE  =  0x00 ; BYTE
.equ        SHSHIFT  =  0x20 ; BYTE
.equ        SHCTRL  =  0x10 ; BYTE
.equ        SHALT  =  0x08 ; BYTE
.equ        SHCAPS  =  0x04 ; BYTE
.equ        SHNUM  =  0x02 ; BYTE
.equ        SHSCROLL  =  0x01 ; BYTE
.equ        KBDNUM  =  0x77 ; BYTE
.equ        KBDCAPS  =  0x58 ; BYTE
.equ        KBDSCROLL  =  0x7E ; BYTE
.equ        KBDALT  =  0x11 ; BYTE
.equ        KBDCTRL  =  0x14 ; BYTE
.equ        KBDLSHIFT  =  0x12 ; BYTE
.equ        KBDRSHIFT  =  0x59 ; BYTE
.equ        KBDENTER  =  0x5A ; BYTE
.equ        KBDSPACE  =  0x29 ; BYTE
.equ        KBDBS  =  0x66 ; BYTE
.equ        KBDTAB  =  0x0D ; BYTE
.equ        KBDESC  =  0x76 ; BYTE
.equ        KBDF1  =  0x05 ; BYTE
.equ        KBDF2  =  0x06 ; BYTE
.equ        KBDF3  =  0x04 ; BYTE
.equ        KBDF4  =  0x0C ; BYTE
.equ        KBDF5  =  0x03 ; BYTE
.equ        KBDF6  =  0x0B ; BYTE
.equ        KBDF7  =  0x83 ; BYTE
.equ        KBDF8  =  0x0A ; BYTE
.equ        KBDF9  =  0x01 ; BYTE
.equ        KBDF10  =  0x09 ; BYTE
.equ        KBDF11  =  0x78 ; BYTE
.equ        KBDF12  =  0x07 ; BYTE
.equ        KBDRGUI  =  0x27 ; BYTE
.equ        KBDLGUI  =  0x1F ; BYTE
.equ        KBDAPPS  =  0x2F ; BYTE
.equ        KBDEND  =  0x69 ; BYTE
.equ        KBDHOME  =  0x6C ; BYTE
.equ        KBDUP  =  0x75 ; BYTE
.equ        KBDDN  =  0x72 ; BYTE
.equ        KBDLEFT  =  0x6B ; BYTE
.equ        KBDRIGHT  =  0x74 ; BYTE
.equ        KBDPGUP  =  0x7D ; BYTE
.equ        KBDPGDN  =  0x7A ; BYTE
.equ        KBDINSERT  =  0x70 ; BYTE
.equ        KBDDELETE  =  0x71 ; BYTE
.equ        KBDPRINT  =  0x12 ; BYTE
.equ        KBDPAUSE  =  0xE1 ; BYTE
.equ        SCANBREAK  =  0xF0 ; BYTE
.equ        SCANEXT  =  0xE0 ; BYTE
.equ        HSTSCROLL  =  0x00 ; BYTE
.equ        HSTPRINT  =  0x10 ; BYTE
.equ        HSTINS  =  0x16 ; BYTE
.equ        HSTHOME  =  0x00 ; BYTE
.equ        HSTPGUP  =  0x12 ; BYTE
.equ        HSTPGDN  =  0x03 ; BYTE
.equ        HSTDEL  =  0x08 ; BYTE
.equ        HSTEND  =  0x00 ; BYTE
.equ        HSTLEFT  =  0x13 ; BYTE
.equ        HSTRIGHT  =  0x04 ; BYTE
.equ        HSTUP  =  0x05 ; BYTE
.equ        HSTDN  =  0x18 ; BYTE
.equ        HSTRGUI  =  0x00 ; BYTE
.equ        HSTLGUI  =  0x00 ; BYTE
.equ        HSTAPPS  =  0x00 ; BYTE
.equ        HSTF1  =  0x80 ; BYTE
.equ        HSTF2  =  0x81 ; BYTE
.equ        HSTF3  =  0x82 ; BYTE
.equ        HSTF4  =  0x83 ; BYTE
.equ        HSTF5  =  0x84 ; BYTE
.equ        HSTF6  =  0x85 ; BYTE
.equ        HSTF7  =  0x86 ; BYTE
.equ        HSTF8  =  0x87 ; BYTE
.equ        HSTF9  =  0x88 ; BYTE
.equ        HSTF10  =  0x89 ; BYTE
.equ        HSTF11  =  0x8A ; BYTE
.equ        HSTF12  =  0x8B ; BYTE
.equ        CPM_START_TAB_LAENGE  =  0x7384 ; WORD
.equ        WAITKON  =  0x0014 ; WORD
.equ        WAITKON2  =  0x0384 ; WORD
 
; *** Variablentabelle ***
 
.dseg
 
STEUER_STRING:   ; String(50)
.byte     1     ; STRING-Laenge
.byte     50
TEXT_STRING:   ; String(15)
.byte     1     ; STRING-Laenge
.byte     15
SEKTOR_PUFFER_ZEIGER:   ; Word
.byte     2
SECTOR:   ; Byte
.byte     1
TRACK_L:   ; Byte
.byte     1
TRACK_H:   ; Byte
.byte     1
DISKNO:   ; Byte
.byte     1
DATUM_GESETZT:   ; Boolean
.byte     1
ANZEIGE_STRING:   ; String(80)
.byte     1     ; STRING-Laenge
.byte     80
BITCNTR:   ; Byte
.byte     1
KEYBSTATE:   ; Byte
.byte     1
LEDSTATE:   ; Byte
.byte     1
LOCALBYTE:   ; Byte
.byte     1
KBSHIFTSTATE:   ; Byte
.byte     1
TMPBYTE:   ; Byte
.byte     1
CAPS_PRESSED:   ; Boolean
.byte     1
NUM_PRESSED:   ; Boolean
.byte     1
SCROLL_PRESSED:   ; Boolean
.byte     1
DOCLICK:   ; Boolean
.byte     1
INITFAILED:   ; Boolean
.byte     1
LOCALMODE:   ; Boolean
.byte     1
CH:   ; Char
.byte     1
SCANBUFFERPTR:   ; Word
.byte     2
KEYBUFFERPTR:   ; Word
.byte     2
SCAN_ZEICHEN:   ; Byte
.byte     1
TX_WARTEN:   ; Boolean
.byte     1
TASTATUR_ZEICHEN:   ; Byte
.byte     1
SOUND_BYTE:   ; Byte
.byte     1
ABTAST_WERT_T1:   ; Word
.byte     2
WERT_YL:   ; Byte
.byte     1
WERT_YH:   ; Byte
.byte     1
ZAEHLER_T1:   ; Word
.byte     2
MONITOR_VERSCHIEBEN:   ; Byte
.byte     1
WRITE_STRING:   ; String(50)
.byte     1     ; STRING-Laenge
.byte     50
SER0_ZEICHEN:   ; Byte
.byte     1
SER1_ZEICHEN:   ; Byte
.byte     1
 
SEKTOR_PUFFER:
.byte     128
SCANBUFFER:
.byte     33
KEYBUFFER:
.byte     33
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; External Interrupt Request 1
.ORG INT2addr
        JMP        EI_INT2
 
; Timer/Counter1 Compare Match A
.ORG OC1Aaddr
        JMP        TIMER1_COMPA
 
; Timer/Counter0 Compare Match A
.ORG OC0Aaddr
        JMP        TIMER0_COMPA
 
; PROCEDURE - Anfang (TIMER0_AUS)
TIMER0_AUS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0A)
        OUT        TCCR0A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0B)
        OUT        TCCR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIMSK0)
        STS        TIMSK0, R16
 
; PROCEDURE - Ende (TIMER0_AUS)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER0_COMPA)
INIT_TIMER0_COMPA:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (TCCR0A)
        OUT        TCCR0A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (TCCR0B)
        OUT        TCCR0B, R16
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (WERT)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (OCR0A)
        OUT        OCR0A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (TIMSK0)
        STS        TIMSK0, R16
 
; PROCEDURE - Ende (INIT_TIMER0_COMPA)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER0_OVF)
INIT_TIMER0_OVF:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0A)
        OUT        TCCR0A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (TCCR0B)
        OUT        TCCR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TIMSK0)
        STS        TIMSK0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIFR0)
        OUT        TIFR0, R16
 
; PROCEDURE - Ende (INIT_TIMER0_OVF)
        RET
 
; PROCEDURE - Anfang (TIMER1_AUS)
TIMER1_AUS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR1A)
        STS        TCCR1A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR1B)
        STS        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIMSK1)
        STS        TIMSK1, R16
 
; PROCEDURE - Ende (TIMER1_AUS)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER1_COMPA)
INIT_TIMER1_COMPA:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR1A)
        STS        TCCR1A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x09)
        LDI        R16, 0x09
 
; Zuweisung Ziel /  VAR (TCCR1B)
        STS        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WERT)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WERT)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (OCR1AH)
        STS        OCR1AH, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (OCR1AL)
        STS        OCR1AL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (TIMSK1)
        STS        TIMSK1, R16
 
; PROCEDURE - Ende (INIT_TIMER1_COMPA)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER2_OVF)
INIT_TIMER2_OVF:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR2A)
        STS        TCCR2A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (TCCR2B)
        STS        TCCR2B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ASSR)
        STS        ASSR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TIMSK2)
        STS        TIMSK2, R16
 
; PROCEDURE - Ende (INIT_TIMER2_OVF)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOORMASKE)
BYTEPOSTOORMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_03
        RJMP       M_CASE_02
M_CASE_03:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_02:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_05
        RJMP       M_CASE_04
M_CASE_05:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x02
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_04:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_07
        RJMP       M_CASE_06
M_CASE_07:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x04
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_06:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_09
        RJMP       M_CASE_08
M_CASE_09:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x08
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_08:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_011
        RJMP       M_CASE_010
M_CASE_011:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x10
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_010:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_013
        RJMP       M_CASE_012
M_CASE_013:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x20
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_012:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_015
        RJMP       M_CASE_014
M_CASE_015:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x40
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_014:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_017
        RJMP       M_CASE_016
M_CASE_017:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x80
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
 
; CASE OF ELSE
M_CASE_016:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; ENDCASE;
M_CASE_01:
 
; Ende Byte - FUNCTION (BYTEPOSTOORMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOORMASKE)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOANDMASKE)
BYTEPOSTOANDMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_020
        RJMP       M_CASE_019
M_CASE_020:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_019:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_022
        RJMP       M_CASE_021
M_CASE_022:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFD
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_021:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_024
        RJMP       M_CASE_023
M_CASE_024:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFB
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_023:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_026
        RJMP       M_CASE_025
M_CASE_026:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xF7
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_025:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_028
        RJMP       M_CASE_027
M_CASE_028:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xEF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_027:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_030
        RJMP       M_CASE_029
M_CASE_030:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xDF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_029:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_032
        RJMP       M_CASE_031
M_CASE_032:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xBF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_031:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_034
        RJMP       M_CASE_033
M_CASE_034:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0x7F
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
 
; CASE OF ELSE
M_CASE_033:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; ENDCASE;
M_CASE_018:
 
; Ende Byte - FUNCTION (BYTEPOSTOANDMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOANDMASKE)
        RET
 
; FUNCTION - Anfang (READ_BIT_IN_BYTE)
READ_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (READ_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (READ_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_038
        CLR        R16
        RJMP       M_VERGL_039
M_VERGL_038:
        SER        R16
M_VERGL_039:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_035
        RJMP       M_IF_036
M_IF_035:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0x00
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_037
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_036:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0xFF
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_037:
 
; Ende Byte - FUNCTION (READ_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (READ_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (SET_BIT_IN_BYTE)
SET_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (SET_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (SET_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (CLEAR_BIT_IN_BYTE)
CLEAR_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOANDMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOANDMASKE)
        CALL       BYTEPOSTOANDMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (CLEAR_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (NEGATION_BYTE)
NEGATION_BYTE:
 
; ASM
    COM    R0
 
 
; RESULT Byte-Variable - FUNCTION (NEGATION_BYTE)
        MOV        R1, R0
 
; Ende Byte - FUNCTION (NEGATION_BYTE)
        MOV        R16, R1
 
; FUNCTION - Ende (NEGATION_BYTE)
        RET
 
; PROCEDURE - Anfang (WAIT_MS)
WAIT_MS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (ZEIT)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_040:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_041
        RJMP       M_FTD_042
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_041:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (WAITKON2)
        LDI        R16, LOW(0x0384)
        LDI        R17, HIGH(0x0384)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_043:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_044
        RJMP       M_FTD_045
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_044:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_043
 
; FOR TO DO - Ende
M_FTD_045:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_040
 
; FOR TO DO - Ende
M_FTD_042:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (WAIT_MS)
        RET
 
; PROCEDURE - Anfang (BYTETOSTRING)
BYTETOSTRING:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_049
        CLR        R16
        RJMP       M_VERGL_050
M_VERGL_049:
        SER        R16
M_VERGL_050:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_046
        RJMP       M_IF_047
M_IF_046:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_048
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_047:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_048:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_051
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_051:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_053
        MOV        R16, R17
M_PRG_CONST_STRING_052:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_052
M_PRG_CONST_STRING_053:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_057
        CLR        R16
        RJMP       M_VERGL_058
M_VERGL_057:
        SER        R16
M_VERGL_058:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_054
        RJMP       M_IF_055
M_IF_054:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_056
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_055:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_056:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXLOW)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_059
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_059:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_061
M_PRG_CONST_STRING_060:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_060
M_PRG_CONST_STRING_061:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_062
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_062:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_064
        MOV        R16, R17
M_PRG_CONST_STRING_063:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_063
M_PRG_CONST_STRING_064:
        ST         -Z, R17
 
; PROCEDURE - Ende (BYTETOSTRING)
        RET
 
; FUNCTION - Anfang (STRINGTOBYTE)
STRINGTOBYTE:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_068
        CLR        R16
        RJMP       M_VERGL_069
M_VERGL_068:
        SER        R16
M_VERGL_069:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_065
        RJMP       M_IF_066
M_IF_065:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN - Ende
M_IF_066:
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_073
        CLR        R16
        RJMP       M_VERGL_074
M_VERGL_073:
        SER        R16
M_VERGL_074:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_070
        RJMP       M_IF_071
M_IF_070:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_071:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (STRINGTOBYTE)
        MOV        R0, R3
 
; Ende Byte - FUNCTION (STRINGTOBYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (STRINGTOBYTE)
        RET
 
; PROCEDURE - Anfang (INIT_SER0_PORT)
INIT_SER0_PORT:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (UBRR0H)
        STS        UBRR0H, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (UBRR_VAL_S0)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (UBRR0L)
        STS        UBRR0L, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x18)
        LDI        R16, 0x18
 
; Zuweisung Ziel /  VAR (UCSR0B)
        STS        UCSR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x86)
        LDI        R16, 0x86
 
; Zuweisung Ziel /  VAR (UCSR0C)
        STS        UCSR0C, R16
 
; PROCEDURE - Ende (INIT_SER0_PORT)
        RET
 
; PROCEDURE - Anfang (INIT_SER1_PORT)
INIT_SER1_PORT:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (UBRR1H)
        STS        UBRR1H, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (UBRR_VAL_S1)
        LDI        R16, 0x0A
 
; Zuweisung Ziel /  VAR (UBRR1L)
        STS        UBRR1L, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x18)
        LDI        R16, 0x18
 
; Zuweisung Ziel /  VAR (UCSR1B)
        STS        UCSR1B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x86)
        LDI        R16, 0x86
 
; Zuweisung Ziel /  VAR (UCSR1C)
        STS        UCSR1C, R16
 
; PROCEDURE - Ende (INIT_SER1_PORT)
        RET
 
; PROCEDURE - Anfang (RX0_PUFFER_ABFRAGEN)
RX0_PUFFER_ABFRAGEN:
 
; IF THEN - Ausdruck /; BitHigh(RXC0)
        LDS        R16, UCSR0A
        BST        R16, 7
        BRTS       M_VERGL_078
        CLR        R16
        RJMP       M_VERGL_079
M_VERGL_078:
        SER        R16
M_VERGL_079:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_075
        RJMP       M_IF_076
M_IF_075:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (UDR0)
        LDS        R16, UDR0
 
; Zuweisung Ziel /  VAR (SER0_ZEICHEN)
        STS        SER0_ZEICHEN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_077
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_076:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SER0_ZEICHEN)
        STS        SER0_ZEICHEN, R16
 
; IF_THEN_ELSE - Ende
M_IF_077:
 
; PROCEDURE - Ende (RX0_PUFFER_ABFRAGEN)
        RET
 
; PROCEDURE - Anfang (RX1_PUFFER_ABFRAGEN)
RX1_PUFFER_ABFRAGEN:
 
; IF THEN - Ausdruck /; BitHigh(RXC1)
        LDS        R16, UCSR1A
        BST        R16, 7
        BRTS       M_VERGL_083
        CLR        R16
        RJMP       M_VERGL_084
M_VERGL_083:
        SER        R16
M_VERGL_084:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_080
        RJMP       M_IF_081
M_IF_080:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (UDR1)
        LDS        R16, UDR1
 
; Zuweisung Ziel /  VAR (SER1_ZEICHEN)
        STS        SER1_ZEICHEN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_082
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_081:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SER1_ZEICHEN)
        STS        SER1_ZEICHEN, R16
 
; IF_THEN_ELSE - Ende
M_IF_082:
 
; PROCEDURE - Ende (RX1_PUFFER_ABFRAGEN)
        RET
 
; PROCEDURE - Anfang (SENDE_ZEICHEN0)
SENDE_ZEICHEN0:
 
; WHILE DO ...
M_WHILE_085:
 
; WHILE - Ausdruck /; BitLow(UDRE0)
        LDS        R16, UCSR0A
        BST        R16, 5
        BRTC       M_VERGL_088
        CLR        R16
        RJMP       M_VERGL_089
M_VERGL_088:
        SER        R16
M_VERGL_089:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_086
        RJMP       M_WHILE_087
M_WHILE_086:
 
; WHILE DO ...
        RJMP       M_WHILE_085
M_WHILE_087:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (S_ZEICHEN0)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (UDR0)
        STS        UDR0, R16
 
; PROCEDURE - Ende (SENDE_ZEICHEN0)
        RET
 
; PROCEDURE - Anfang (SENDE_ZEICHEN1)
SENDE_ZEICHEN1:
 
; WHILE DO ...
M_WHILE_090:
 
; WHILE - Ausdruck /; BitLow(UDRE1)
        LDS        R16, UCSR1A
        BST        R16, 5
        BRTC       M_VERGL_093
        CLR        R16
        RJMP       M_VERGL_094
M_VERGL_093:
        SER        R16
M_VERGL_094:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_091
        RJMP       M_WHILE_092
M_WHILE_091:
 
; WHILE DO ...
        RJMP       M_WHILE_090
M_WHILE_092:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (S_ZEICHEN1)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (UDR1)
        STS        UDR1, R16
 
; PROCEDURE - Ende (SENDE_ZEICHEN1)
        RET
 
; PROCEDURE - Anfang (WRITE_SER1)
WRITE_SER1:
 
; Zuweisung Quelle - Ausdruck / Length(WRITE_STRING)
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R1
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_095:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_096
        RJMP       M_FTD_097
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_096:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE_SER1)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (B2) retten
        MOV        R19, R3
 
; lokalen Parameter (B2) an Prozedur (SENDE_ZEICHEN1)
        MOV        R0, R19
 
; Aufruf PROCEDURE (SENDE_ZEICHEN1)
        CALL       SENDE_ZEICHEN1
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE_SER1)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_095
 
; FOR TO DO - Ende
M_FTD_097:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (WRITE_SER1)
        RET
 
; PROCEDURE - Anfang (WRITELN_SER1)
WRITELN_SER1:
 
; Aufruf PROCEDURE (WRITE_SER1)
        CALL       WRITE_SER1
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN1)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN1)
        CALL       SENDE_ZEICHEN1
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN1)
        LDI        R16, 0x0A
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN1)
        CALL       SENDE_ZEICHEN1
 
; PROCEDURE - Ende (WRITELN_SER1)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC2)
        LDI        R16, 0xC2
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTD)
        OUT        PORTD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; PROCEDURE - Anfang (INIT_INT2)
INIT_INT2:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (EICRA)
        LDS        R16, EICRA
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x20)
        LDI        R18, 0x20
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (EICRA)
        STS        EICRA, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG EIMSK
        IN         R16, EIMSK
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (EIMSK)
        OUT        EIMSK, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG EIFR
        IN         R16, EIFR
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (EIFR)
        OUT        EIFR, R16
 
; PROCEDURE - Ende (INIT_INT2)
        RET
 
; PROCEDURE - Anfang (TON_SIRENE)
TON_SIRENE:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (DAUER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FREQUENZ)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_098:
 
; FOR TO DO - Word-Vergleichsteil (DOWNTO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R18, R16
        CPC        R19, R17
        BRCC       M_FTD_099
        RJMP       M_FTD_0100
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_099:
 
; SetBit(SUMMER)
        SBI        PORTD, 7
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_SIRENE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (FREQUENZ) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (FREQUENZ) an Prozedur (WAIT_MS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_SIRENE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ClearBit(SUMMER)
        CBI        PORTD, 7
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_SIRENE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (FREQUENZ) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (FREQUENZ) an Prozedur (WAIT_MS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_SIRENE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-DEC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        SUB        R18, R20
        CLR        R20
        SBC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_098
 
; FOR TO DO - Ende
M_FTD_0100:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FREQUENZ)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (DAUER)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0101:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0102
        RJMP       M_FTD_0103
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0102:
 
; SetBit(SUMMER)
        SBI        PORTD, 7
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_SIRENE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (FREQUENZ) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (FREQUENZ) an Prozedur (WAIT_MS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_SIRENE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ClearBit(SUMMER)
        CBI        PORTD, 7
 
; Retten der lokalen Parameter fuer PROCEDURE (TON_SIRENE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (FREQUENZ) retten
        MOV        R18, R2
        MOV        R19, R3
 
; lokalen Parameter (FREQUENZ) an Prozedur (WAIT_MS)
        MOV        R0, R18
        MOV        R1, R19
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TON_SIRENE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0101
 
; FOR TO DO - Ende
M_FTD_0103:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (TON_SIRENE)
        RET
 
; PROCEDURE - Anfang (CLICK)
CLICK:
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0001)
        MOV        R0, R16
        LDI        R17, HIGH(0x0001)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; PROCEDURE - Ende (CLICK)
        RET
 
; PROCEDURE - Anfang (TON_FEHLER)
TON_FEHLER:
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0004)
        MOV        R0, R16
        LDI        R17, HIGH(0x0004)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0004)
        MOV        R0, R16
        LDI        R17, HIGH(0x0004)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0004)
        MOV        R0, R16
        LDI        R17, HIGH(0x0004)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; PROCEDURE - Ende (TON_FEHLER)
        RET
 
; PROCEDURE - Anfang (WRITE_SCAN)
WRITE_SCAN:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (SCANBUFFERPTR)
        LDS        R16, SCANBUFFERPTR
        LDS        R17, SCANBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0020)
        LDI        R18, LOW(0x0020)
        LDI        R19, HIGH(0x0020)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0107
        CLR        R16
        RJMP       M_VERGL_0108
M_VERGL_0107:
        SER        R16
M_VERGL_0108:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0104
        RJMP       M_IF_0105
M_IF_0104:
 
; INC(SCANBUFFERPTR) - Word
        LDS        R24, SCANBUFFERPTR
        LDS        R25, SCANBUFFERPTR+1
        ADIW       R25:R24, 1
        STS        SCANBUFFERPTR, R24
        STS        SCANBUFFERPTR+1, R25
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (SCANBUFFERPTR)
        LDS        R16, SCANBUFFERPTR
        LDS        R17, SCANBUFFERPTR+1
 
; VAR ARRAY Ziel Zeiger berechnen (SCANBUFFER)
        LDI        ZL, LOW(SCANBUFFER)
        LDI        ZH, HIGH(SCANBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (WRITE_SCAN_VALUE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR ARRAY (SCANBUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; IF_THEN - Ende
M_IF_0105:
 
; PROCEDURE - Ende (WRITE_SCAN)
        RET
 
; FUNCTION - Anfang (READ_SCAN)
READ_SCAN:
 
; ARRAY - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SCANBUFFER)
        LDI        ZL, LOW(SCANBUFFER)
        LDI        ZH, HIGH(SCANBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_SCAN_VALUE)
        MOV        R1, R16
 
; DEC(SCANBUFFERPTR) - Word
        LDS        R24, SCANBUFFERPTR
        LDS        R25, SCANBUFFERPTR+1
        SBIW       R25:R24, 1
        STS        SCANBUFFERPTR, R24
        STS        SCANBUFFERPTR+1, R25
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (SCANBUFFERPTR)
        LDS        R16, SCANBUFFERPTR
        LDS        R17, SCANBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0112
        CLR        R16
        RJMP       M_VERGL_0113
M_VERGL_0112:
        SER        R16
M_VERGL_0113:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0109
        RJMP       M_IF_0110
M_IF_0109:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SCAN_COUNTER)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (SCANBUFFERPTR)
        LDS        R16, SCANBUFFERPTR
        LDS        R17, SCANBUFFERPTR+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0114:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0115
        RJMP       M_FTD_0116
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0115:
 
; ARRAY - Ausdruck erster Faktor / lokale, dynamische Variable VAR (SCAN_COUNTER)
        MOV        R16, R2
        MOV        R17, R3
 
; ARRAY - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SCANBUFFER)
        LDI        ZL, LOW(SCANBUFFER)
        LDI        ZH, HIGH(SCANBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R4, R16
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (SCAN_COUNTER)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (SCANBUFFER)
        LDI        ZL, LOW(SCANBUFFER)
        LDI        ZH, HIGH(SCANBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR ARRAY (SCANBUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0114
 
; FOR TO DO - Ende
M_FTD_0116:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN - Ende
M_IF_0110:
 
; RESULT Byte-Variable - FUNCTION (READ_SCAN)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (READ_SCAN)
        MOV        R16, R0
 
; FUNCTION - Ende (READ_SCAN)
        RET
 
; FUNCTION - Anfang (READ_KEY)
READ_KEY:
 
; Interrupt verbieten
        CLI
 
; ARRAY - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (KEYBUFFER)
        LDI        ZL, LOW(KEYBUFFER)
        LDI        ZH, HIGH(KEYBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_KEY_VALUE)
        MOV        R1, R16
 
; DEC(KEYBUFFERPTR) - Word
        LDS        R24, KEYBUFFERPTR
        LDS        R25, KEYBUFFERPTR+1
        SBIW       R25:R24, 1
        STS        KEYBUFFERPTR, R24
        STS        KEYBUFFERPTR+1, R25
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0120
        CLR        R16
        RJMP       M_VERGL_0121
M_VERGL_0120:
        SER        R16
M_VERGL_0121:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0117
        RJMP       M_IF_0118
M_IF_0117:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (KEY_COUNTER)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0122:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0123
        RJMP       M_FTD_0124
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0123:
 
; ARRAY - Ausdruck erster Faktor / lokale, dynamische Variable VAR (KEY_COUNTER)
        MOV        R16, R2
        MOV        R17, R3
 
; ARRAY - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (KEYBUFFER)
        LDI        ZL, LOW(KEYBUFFER)
        LDI        ZH, HIGH(KEYBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R4, R16
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (KEY_COUNTER)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (KEYBUFFER)
        LDI        ZL, LOW(KEYBUFFER)
        LDI        ZH, HIGH(KEYBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR ARRAY (KEYBUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0122
 
; FOR TO DO - Ende
M_FTD_0124:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN - Ende
M_IF_0118:
 
; Interrupt erlauben
        SEI
 
; RESULT Byte-Variable - FUNCTION (READ_KEY)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (READ_KEY)
        MOV        R16, R0
 
; FUNCTION - Ende (READ_KEY)
        RET
 
; PROCEDURE - Anfang (WRITE_KEY)
WRITE_KEY:
 
; Interrupt verbieten
        CLI
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0020)
        LDI        R18, LOW(0x0020)
        LDI        R19, HIGH(0x0020)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0128
        CLR        R16
        RJMP       M_VERGL_0129
M_VERGL_0128:
        SER        R16
M_VERGL_0129:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0125
        RJMP       M_IF_0126
M_IF_0125:
 
; INC(KEYBUFFERPTR) - Word
        LDS        R24, KEYBUFFERPTR
        LDS        R25, KEYBUFFERPTR+1
        ADIW       R25:R24, 1
        STS        KEYBUFFERPTR, R24
        STS        KEYBUFFERPTR+1, R25
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; VAR ARRAY Ziel Zeiger berechnen (KEYBUFFER)
        LDI        ZL, LOW(KEYBUFFER)
        LDI        ZH, HIGH(KEYBUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (WRITE_KEY_VALUE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR ARRAY (KEYBUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; IF_THEN - Ende
M_IF_0126:
 
; Interrupt erlauben
        SEI
 
; PROCEDURE - Ende (WRITE_KEY)
        RET
 
; PROCEDURE - Anfang (WRITE_C_KEY)
WRITE_C_KEY:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(CKEY)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE_C_KEY)
        PUSH       R0
        PUSH       R1
 
; Parameter (B1) retten
        MOV        R17, R1
 
; lokalen Parameter (B1) an Prozedur (WRITE_KEY)
        MOV        R0, R17
 
; Aufruf PROCEDURE (WRITE_KEY)
        CALL       WRITE_KEY
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE_C_KEY)
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (WRITE_C_KEY)
        RET
 
; PROCEDURE - Anfang (WRITE_TEXT)
WRITE_TEXT:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZAEHLER)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Length(TEXT_STRING)
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        LD         R16, Z
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0130:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0131
        RJMP       M_FTD_0132
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0131:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ZAEHLER)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (TEXT_STRING)
        CLR        R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE_TEXT)
        PUSH       R0
        PUSH       R1
 
; Parameter (C1) retten
        MOV        R17, R1
 
; lokalen Parameter (C1) an Prozedur (WRITE_C_KEY)
        MOV        R0, R17
 
; Aufruf PROCEDURE (WRITE_C_KEY)
        CALL       WRITE_C_KEY
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE_TEXT)
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0130
 
; FOR TO DO - Ende
M_FTD_0132:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (WRITE_TEXT)
        RET
 
; PROCEDURE - Anfang (SENDKEY)
SENDKEY:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0D)
        LDI        R16, 0x0D
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(B1)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R1, R16
 
; CASE OF - lokaler Uebergabeparameter (SKEY)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element ($00)
        CPI        R16, 0x00
        BREQ       M_CASE_0135
        RJMP       M_CASE_0134
M_CASE_0135:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0014)
        MOV        R0, R16
        LDI        R17, HIGH(0x0014)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0133
M_CASE_0134:
 
; CASE OF - vergleiche Einzel-Element ($80)
        CPI        R16, 0x80
        BREQ       M_CASE_0137
        RJMP       M_CASE_0136
M_CASE_0137:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (MONITOR_LINKS)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (MONITOR_VERSCHIEBEN)
        STS        MONITOR_VERSCHIEBEN, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0133
M_CASE_0136:
 
; CASE OF - vergleiche Einzel-Element ($81)
        CPI        R16, 0x81
        BREQ       M_CASE_0139
        RJMP       M_CASE_0138
M_CASE_0139:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (MONITOR_RECHTS)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (MONITOR_VERSCHIEBEN)
        STS        MONITOR_VERSCHIEBEN, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0133
M_CASE_0138:
 
; CASE OF - vergleiche Einzel-Element ($82)
        CPI        R16, 0x82
        BREQ       M_CASE_0141
        RJMP       M_CASE_0140
M_CASE_0141:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('DIR')
        LDI        ZL, LOW(2*M_CONST_STRING_0)
        LDI        ZH, HIGH(2*M_CONST_STRING_0)
        LDI        R29, Byte3(2*M_CONST_STRING_0)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0142
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0142:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0144
M_PRG_CONST_STRING_0143:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0143
M_PRG_CONST_STRING_0144:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0145
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0145:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0147
        MOV        R16, R17
M_PRG_CONST_STRING_0146:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0146
M_PRG_CONST_STRING_0147:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0133
M_CASE_0140:
 
; CASE OF - vergleiche Einzel-Element ($83)
        CPI        R16, 0x83
        BREQ       M_CASE_0149
        RJMP       M_CASE_0148
M_CASE_0149:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('POWER')
        LDI        ZL, LOW(2*M_CONST_STRING_1)
        LDI        ZH, HIGH(2*M_CONST_STRING_1)
        LDI        R29, Byte3(2*M_CONST_STRING_1)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0150
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0150:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0152
M_PRG_CONST_STRING_0151:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0151
M_PRG_CONST_STRING_0152:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0153
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0153:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0155
        MOV        R16, R17
M_PRG_CONST_STRING_0154:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0154
M_PRG_CONST_STRING_0155:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0133
M_CASE_0148:
 
; CASE OF - vergleiche Einzel-Element ($84)
        CPI        R16, 0x84
        BREQ       M_CASE_0157
        RJMP       M_CASE_0156
M_CASE_0157:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('COPY')
        LDI        ZL, LOW(2*M_CONST_STRING_2)
        LDI        ZH, HIGH(2*M_CONST_STRING_2)
        LDI        R29, Byte3(2*M_CONST_STRING_2)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0158
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0158:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0160
M_PRG_CONST_STRING_0159:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0159
M_PRG_CONST_STRING_0160:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0161
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0161:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0163
        MOV        R16, R17
M_PRG_CONST_STRING_0162:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0162
M_PRG_CONST_STRING_0163:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0133
M_CASE_0156:
 
; CASE OF - vergleiche Einzel-Element ($85)
        CPI        R16, 0x85
        BREQ       M_CASE_0165
        RJMP       M_CASE_0164
M_CASE_0165:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('ERA')
        LDI        ZL, LOW(2*M_CONST_STRING_3)
        LDI        ZH, HIGH(2*M_CONST_STRING_3)
        LDI        R29, Byte3(2*M_CONST_STRING_3)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0166
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0166:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0168
M_PRG_CONST_STRING_0167:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0167
M_PRG_CONST_STRING_0168:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0169
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0169:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0171
        MOV        R16, R17
M_PRG_CONST_STRING_0170:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0170
M_PRG_CONST_STRING_0171:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0133
M_CASE_0164:
 
; CASE OF - vergleiche Einzel-Element ($86)
        CPI        R16, 0x86
        BREQ       M_CASE_0173
        RJMP       M_CASE_0172
M_CASE_0173:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('TYPEX')
        LDI        ZL, LOW(2*M_CONST_STRING_4)
        LDI        ZH, HIGH(2*M_CONST_STRING_4)
        LDI        R29, Byte3(2*M_CONST_STRING_4)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0174
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0174:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0176
M_PRG_CONST_STRING_0175:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0175
M_PRG_CONST_STRING_0176:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0177
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0177:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0179
        MOV        R16, R17
M_PRG_CONST_STRING_0178:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0178
M_PRG_CONST_STRING_0179:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0133
M_CASE_0172:
 
; CASE OF - vergleiche Einzel-Element ($87)
        CPI        R16, 0x87
        BREQ       M_CASE_0181
        RJMP       M_CASE_0180
M_CASE_0181:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('EXIT')
        LDI        ZL, LOW(2*M_CONST_STRING_5)
        LDI        ZH, HIGH(2*M_CONST_STRING_5)
        LDI        R29, Byte3(2*M_CONST_STRING_5)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0182
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0182:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0184
M_PRG_CONST_STRING_0183:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0183
M_PRG_CONST_STRING_0184:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0185
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0185:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0187
        MOV        R16, R17
M_PRG_CONST_STRING_0186:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0186
M_PRG_CONST_STRING_0187:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0133
M_CASE_0180:
 
; CASE OF - vergleiche Einzel-Element ($88)
        CPI        R16, 0x88
        BREQ       M_CASE_0189
        RJMP       M_CASE_0188
M_CASE_0189:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('TURBO')
        LDI        ZL, LOW(2*M_CONST_STRING_6)
        LDI        ZH, HIGH(2*M_CONST_STRING_6)
        LDI        R29, Byte3(2*M_CONST_STRING_6)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0190
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0190:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0192
M_PRG_CONST_STRING_0191:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0191
M_PRG_CONST_STRING_0192:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0193
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0193:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0195
        MOV        R16, R17
M_PRG_CONST_STRING_0194:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0194
M_PRG_CONST_STRING_0195:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0133
M_CASE_0188:
 
; CASE OF - vergleiche Einzel-Element ($89)
        CPI        R16, 0x89
        BREQ       M_CASE_0197
        RJMP       M_CASE_0196
M_CASE_0197:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (TEXT_STRING)=15
        LDI        R16, 15
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('TURBO')
        LDI        ZL, LOW(2*M_CONST_STRING_7)
        LDI        ZH, HIGH(2*M_CONST_STRING_7)
        LDI        R29, Byte3(2*M_CONST_STRING_7)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0198
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0198:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0200
M_PRG_CONST_STRING_0199:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0199
M_PRG_CONST_STRING_0200:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0201
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0201:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (TEXT_STRING) - Laenge in R17
        LDI        ZL, LOW(TEXT_STRING)
        LDI        ZH, HIGH(TEXT_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0203
        MOV        R16, R17
M_PRG_CONST_STRING_0202:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0202
M_PRG_CONST_STRING_0203:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_TEXT)
        CALL       WRITE_TEXT
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0133
 
; CASE OF ELSE
M_CASE_0196:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITE_KEY)
        CALL       WRITE_KEY
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEY)
        POP        R2
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0133:
 
; PROCEDURE - Ende (SENDKEY)
        RET
 
; PROCEDURE - Anfang (SENDKEYCHAR)
SENDKEYCHAR:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(SKEY)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDKEYCHAR)
        PUSH       R0
        PUSH       R1
 
; Parameter (B1) retten
        MOV        R17, R1
 
; lokalen Parameter (B1) an Prozedur (SENDKEY)
        MOV        R0, R17
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SENDKEYCHAR)
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (SENDKEYCHAR)
        RET
 
; ISR - Einsprung
EI_INT2:
        PUSH       R16
        IN         R16,SREG
        PUSH       R16
 
; ASM
  PUSH   R18
 
 
; IF THEN - Ausdruck / Byte-VAR (INITFAILED)
        LDS        R16, INITFAILED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0204
        RJMP       M_IF_0205
M_IF_0204:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0206
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0205:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (BITCNTR)
        LDS        R16, BITCNTR
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0210
        CLR        R16
        RJMP       M_VERGL_0211
M_VERGL_0210:
        SER        R16
M_VERGL_0211:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0207
        RJMP       M_IF_0208
M_IF_0207:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (BITCNTR)
        LDS        R16, BITCNTR
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0B)
        LDI        R18, 0x0B
 
; Operator <
        CP         R16, R18
        BRCS       M_VERGL_0215
        CLR        R16
        RJMP       M_VERGL_0216
M_VERGL_0215:
        SER        R16
M_VERGL_0216:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0212
        RJMP       M_IF_0213
M_IF_0212:
 
; SHR(TMPBYTE) - Byte
        LDS        R16, TMPBYTE
        LSR        R16
        STS        TMPBYTE, R16
 
; IF THEN - Ausdruck /; BitHigh(KEY_DAT_E)
        IN         R16, PINB
        BST        R16, 3
        BRTS       M_VERGL_0220
        CLR        R16
        RJMP       M_VERGL_0221
M_VERGL_0220:
        SER        R16
M_VERGL_0221:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0217
        RJMP       M_IF_0218
M_IF_0217:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (TMPBYTE)
        LDS        R16, TMPBYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x80)
        LDI        R18, 0x80
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (TMPBYTE)
        STS        TMPBYTE, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0219
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0218:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (TMPBYTE)
        LDS        R16, TMPBYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x7F)
        LDI        R18, 0x7F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  VAR (TMPBYTE)
        STS        TMPBYTE, R16
 
; IF_THEN_ELSE - Ende
M_IF_0219:
 
; IF_THEN - Ende
M_IF_0213:
 
; IF_THEN - Ende
M_IF_0208:
 
; DEC(BITCNTR) - Byte
        LDS        R16, BITCNTR
        DEC        R16
        STS        BITCNTR, R16
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (BITCNTR)
        LDS        R16, BITCNTR
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0225
        CLR        R16
        RJMP       M_VERGL_0226
M_VERGL_0225:
        SER        R16
M_VERGL_0226:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0222
        RJMP       M_IF_0223
M_IF_0222:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; Zuweisung Ziel /  VAR (BITCNTR)
        STS        BITCNTR, R16
 
; IF THEN - Ausdruck / Byte-VAR (LOCALMODE)
        LDS        R16, LOCALMODE
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0227
        RJMP       M_IF_0228
M_IF_0227:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (TMPBYTE)
        LDS        R16, TMPBYTE
 
; Zuweisung Ziel /  VAR (LOCALBYTE)
        STS        LOCALBYTE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LOCALMODE)
        STS        LOCALMODE, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0229
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0228:
 
; ASM
          PUSH   R0
          PUSH   R17
          PUSH   R19
          PUSH   R24
          PUSH   R25
          PUSH   ZL
          PUSH   ZH
 
 
; Byte-Parameter(1) fuer PROCEDURE (WRITE_SCAN)
        LDS        R0, TMPBYTE
 
; Aufruf PROCEDURE (WRITE_SCAN)
        CALL       WRITE_SCAN
 
; ASM
          POP   ZH
          POP   ZL
          POP   R25
          POP   R24
          POP   R19
          POP   R17
          POP   R0
 
 
; IF_THEN_ELSE - Ende
M_IF_0229:
 
; IF_THEN - Ende
M_IF_0223:
 
; IF_THEN_ELSE - Ende
M_IF_0206:
 
; ASM
  POP   R18
 
 
; ISR - Ende
        POP        R16
        OUT        SREG,R16
        POP        R16
        RETI
 
; PROCEDURE - Anfang (INITKEYB)
INITKEYB:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; Zuweisung Ziel /  VAR (BITCNTR)
        STS        BITCNTR, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_BYTE1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SCANBUFFERPTR)
        STS        SCANBUFFERPTR, R16
        STS        SCANBUFFERPTR+1, R17
 
; PROCEDURE - Ende (INITKEYB)
        RET
 
; PROCEDURE - Anfang (SET_KBD_CLK)
SET_KBD_CLK:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; Zuweisung Ziel /  VAR (BITCNTR)
        STS        BITCNTR, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG EIFR
        IN         R16, EIFR
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (EIFR)
        OUT        EIFR, R16
 
; SetBit(KEY_CLK_A)
        SBI        PORTB, 2
 
; ClearBit(KEY_CLK_D)
        CBI        DDRB, 2
 
; Interrupt erlauben
        SEI
 
; PROCEDURE - Ende (SET_KBD_CLK)
        RET
 
; PROCEDURE - Anfang (RESET_KBD_CLK)
RESET_KBD_CLK:
 
; Interrupt verbieten
        CLI
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; Zuweisung Ziel /  VAR (BITCNTR)
        STS        BITCNTR, R16
 
; ClearBit(KEY_CLK_A)
        CBI        PORTB, 2
 
; SetBit(KEY_CLK_D)
        SBI        DDRB, 2
 
; PROCEDURE - Ende (RESET_KBD_CLK)
        RET
 
; FUNCTION - Anfang (NOT_PARITY)
NOT_PARITY:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B3)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B4)
        MOV        R5, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R5
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0230:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0231
        RJMP       M_FTD_0232
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0231:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (DAS_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0236
        CLR        R16
        RJMP       M_VERGL_0237
M_VERGL_0236:
        SER        R16
M_VERGL_0237:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0233
        RJMP       M_IF_0234
M_IF_0233:
 
; INC(B3) - Byte
        INC        R4
 
; IF_THEN - Ende
M_IF_0234:
 
; SHR(DAS_BYTE) - Byte
        LSR        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R5
        INC        R17
        MOV        R5, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0230
 
; FOR TO DO - Ende
M_FTD_0232:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B3)
        MOV        R16, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0241
        CLR        R16
        RJMP       M_VERGL_0242
M_VERGL_0241:
        SER        R16
M_VERGL_0242:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0238
        RJMP       M_IF_0239
M_IF_0238:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0240
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0239:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_0240:
 
; RESULT Byte-Variable - FUNCTION (NOT_PARITY)
        MOV        R1, R2
 
; Ende Byte - FUNCTION (NOT_PARITY)
        MOV        R16, R1
 
; FUNCTION - Ende (NOT_PARITY)
        RET
 
; PROCEDURE - Anfang (SENDTOKBD)
SENDTOKBD:
 
; Interrupt verbieten
        CLI
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDTOKBD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf Funktion (NOT_PARITY)
        CALL       NOT_PARITY
 
; Retten der Parameter-Register fuer PROCEDURE (SENDTOKBD)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (P)
        MOV        R1, R16
 
; ClearBit(KEY_CLK_D)
        CBI        DDRB, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; WHILE DO ...
M_WHILE_0243:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0246
        CLR        R16
        RJMP       M_VERGL_0247
M_VERGL_0246:
        SER        R16
M_VERGL_0247:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0244
        RJMP       M_WHILE_0245
M_WHILE_0244:
 
; DEC(W) - Word
        MOV        R24, R2
        MOV        R25, R3
        SBIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PINB
        IN         R16, PINB
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0251
        CLR        R16
        RJMP       M_VERGL_0252
M_VERGL_0251:
        SER        R16
M_VERGL_0252:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0248
        RJMP       M_IF_0249
M_IF_0248:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN - Ende
M_IF_0249:
 
; WHILE DO ...
        RJMP       M_WHILE_0243
M_WHILE_0245:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0256
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0257
M_VERGL_0256:
        SER        R16
M_VERGL_0257:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0253
        RJMP       M_IF_0254
M_IF_0253:
 
; SetBit(KEY_CLK_D)
        SBI        DDRB, 2
 
; ClearBit(KEY_CLK_A)
        CBI        PORTB, 2
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDTOKBD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (SENDTOKBD)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ClearBit(KEY_DAT_A)
        CBI        PORTB, 3
 
; SetBit(KEY_DAT_D)
        SBI        DDRB, 3
 
; SetBit(KEY_CLK_A)
        SBI        PORTB, 2
 
; ClearBit(KEY_CLK_D)
        CBI        DDRB, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; WHILE DO ...
M_WHILE_0258:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0261
        CLR        R16
        RJMP       M_VERGL_0262
M_VERGL_0261:
        SER        R16
M_VERGL_0262:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0259
        RJMP       M_WHILE_0260
M_WHILE_0259:
 
; DEC(W) - Word
        MOV        R24, R2
        MOV        R25, R3
        SBIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PINB
        IN         R16, PINB
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0266
        CLR        R16
        RJMP       M_VERGL_0267
M_VERGL_0266:
        SER        R16
M_VERGL_0267:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0263
        RJMP       M_IF_0264
M_IF_0263:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN - Ende
M_IF_0264:
 
; WHILE DO ...
        RJMP       M_WHILE_0258
M_WHILE_0260:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0271
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0272
M_VERGL_0271:
        SER        R16
M_VERGL_0272:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0268
        RJMP       M_IF_0269
M_IF_0268:
 
; ASM
    MOV    R16, R0

    // Zaehler in R17
    LDI    R17, 8

M_tx_data:
    // Bit 0 in C
    ROR    R16

    // Set/reset the Data line to send the first data bit
    BRCS     M_tx_data0

    // set databit -> 0
    CBI    PortB, 3
    RJMP     M_tx_data1

M_tx_data0:
    // set databit -> 1
    SBI    PortB, 3

M_tx_data1:
    // Wait for the device to bring Clock high.
    SBIS   PINB, 2
    RJMP   M_tx_data1;         // wait till CLK rise

M_tx_data2:
    // Wait for the device to bring Clock low.
    SBIC   PINB, 2
    RJMP   M_tx_data2;         // now wait till CLK falls down

    // next bit please ...
    DEC    R17
    BRNE   M_tx_data


 
 
; IF THEN - Ausdruck / lokale, dynamische Variable VAR (P)
        MOV        R16, R1
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0273
        RJMP       M_IF_0274
M_IF_0273:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (REG)
        MOV        R16, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (REG)
        MOV        R5, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0275
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0274:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (REG)
        MOV        R16, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xFE)
        LDI        R18, 0xFE
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (REG)
        MOV        R5, R16
 
; IF_THEN_ELSE - Ende
M_IF_0275:
 
; ASM
    MOV    R16, R5

    ROR    R16
    BRCS   M_tx_data3

    // set databit -> 0
    CBI    PortB, 3
    RJMP   M_tx_data5

M_tx_data3:
    // set databit -> 1
    SBI    PortB, 3


M_tx_data5:
    // Wait for the device to bring Clock high.
    SBIS   PINB, 2
    RJMP   M_tx_data5;     // wait till CLK rise

    M_tx_data6:
    // Wait for the device to bring Clock low.
    SBIC   PINB, 2
    RJMP   M_tx_data6;     // now wait till CLK falls down

    // Getting stopbit
    SBI PortB, 3

    M_tx_data7:
    // waiting until clock will rise
    SBIS   PINB, 2
    RJMP   M_tx_data7;     // wait till CLK rise

    // Now release the Data line.
    //  DDRD.3 := 0;
    CBI    DDRB, 3;

 
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; WHILE DO ...
M_WHILE_0276:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0279
        CLR        R16
        RJMP       M_VERGL_0280
M_VERGL_0279:
        SER        R16
M_VERGL_0280:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0277
        RJMP       M_WHILE_0278
M_WHILE_0277:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PINB
        IN         R16, PINB
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0284
        CLR        R16
        RJMP       M_VERGL_0285
M_VERGL_0284:
        SER        R16
M_VERGL_0285:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0281
        RJMP       M_IF_0282
M_IF_0281:
 
; INC(W) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; IF_THEN - Ende
M_IF_0282:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PINB
        IN         R16, PINB
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0289
        CLR        R16
        RJMP       M_VERGL_0290
M_VERGL_0289:
        SER        R16
M_VERGL_0290:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0286
        RJMP       M_IF_0287
M_IF_0286:
 
; INC(W) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; IF_THEN - Ende
M_IF_0287:
 
; WHILE DO ...
        RJMP       M_WHILE_0276
M_WHILE_0278:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; WHILE DO ...
M_WHILE_0291:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_0294
        CLR        R16
        RJMP       M_VERGL_0295
M_VERGL_0294:
        SER        R16
M_VERGL_0295:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0292
        RJMP       M_WHILE_0293
M_WHILE_0292:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PINB
        IN         R16, PINB
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0299
        CLR        R16
        RJMP       M_VERGL_0300
M_VERGL_0299:
        SER        R16
M_VERGL_0300:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0296
        RJMP       M_IF_0297
M_IF_0296:
 
; INC(W) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; IF_THEN - Ende
M_IF_0297:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-REG PINB
        IN         R16, PINB
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (TEST)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0304
        CLR        R16
        RJMP       M_VERGL_0305
M_VERGL_0304:
        SER        R16
M_VERGL_0305:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0301
        RJMP       M_IF_0302
M_IF_0301:
 
; INC(W) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; IF_THEN - Ende
M_IF_0302:
 
; WHILE DO ...
        RJMP       M_WHILE_0291
M_WHILE_0293:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDTOKBD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf PROCEDURE (RESET_KBD_CLK)
        CALL       RESET_KBD_CLK
 
; Retten der Parameter-Register fuer PROCEDURE (SENDTOKBD)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (LOCALMODE)
        STS        LOCALMODE, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDTOKBD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf PROCEDURE (SET_KBD_CLK)
        CALL       SET_KBD_CLK
 
; Retten der Parameter-Register fuer PROCEDURE (SENDTOKBD)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; WHILE DO ...
M_WHILE_0306:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W)
        MOV        R16, R2
        MOV        R17, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0309
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0310
M_VERGL_0309:
        SER        R16
M_VERGL_0310:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0307
        RJMP       M_WHILE_0308
M_WHILE_0307:
 
; IF THEN - Ausdruck / Byte-VAR (LOCALMODE)
        LDS        R16, LOCALMODE
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0311
        RJMP       M_IF_0312
M_IF_0311:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0313
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0312:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN_ELSE - Ende
M_IF_0313:
 
; WHILE DO ...
        RJMP       M_WHILE_0306
M_WHILE_0308:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0270
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0269:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (INITFAILED)
        STS        INITFAILED, R16
 
; IF_THEN_ELSE - Ende
M_IF_0270:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0255
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0254:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (INITFAILED)
        STS        INITFAILED, R16
 
; IF_THEN_ELSE - Ende
M_IF_0255:
 
; PROCEDURE - Ende (SENDTOKBD)
        RET
 
; PROCEDURE - Anfang (SET_KBD_STATE)
SET_KBD_STATE:
 
; Byte-Parameter(1) fuer PROCEDURE (SENDTOKBD)
        LDI        R16, 0xED
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDTOKBD)
        CALL       SENDTOKBD
 
; Byte-Parameter(1) fuer PROCEDURE (SENDTOKBD)
        LDS        R0, LEDSTATE
 
; Aufruf PROCEDURE (SENDTOKBD)
        CALL       SENDTOKBD
 
; PROCEDURE - Ende (SET_KBD_STATE)
        RET
 
; PROCEDURE - Anfang (KBDRESET)
KBDRESET:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (INITFAILED)
        STS        INITFAILED, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Aufruf PROCEDURE (RESET_KBD_CLK)
        CALL       RESET_KBD_CLK
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x01F4)
        MOV        R0, R16
        LDI        R17, HIGH(0x01F4)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LOCALBYTE)
        STS        LOCALBYTE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WARTEN_AUF_TASTATUR)
        MOV        R0, R16
 
; WHILE DO ...
M_WHILE_0314:
 
; WHILE - Ausdruck / lokale, dynamische Variable VAR (WARTEN_AUF_TASTATUR)
        MOV        R16, R0
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0315
        RJMP       M_WHILE_0316
M_WHILE_0315:
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDTOKBD)
        LDI        R16, 0xFF
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDTOKBD)
        CALL       SENDTOKBD
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (LOCALBYTE)
        LDS        R16, LOCALBYTE
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xAA)
        LDI        R18, 0xAA
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0320
        CLR        R16
        RJMP       M_VERGL_0321
M_VERGL_0320:
        SER        R16
M_VERGL_0321:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0317
        RJMP       M_IF_0318
M_IF_0317:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WARTEN_AUF_TASTATUR)
        MOV        R0, R16
 
; IF_THEN - Ende
M_IF_0318:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (LOCALBYTE)
        LDS        R16, LOCALBYTE
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xFA)
        LDI        R18, 0xFA
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0325
        CLR        R16
        RJMP       M_VERGL_0326
M_VERGL_0325:
        SER        R16
M_VERGL_0326:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0322
        RJMP       M_IF_0323
M_IF_0322:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WARTEN_AUF_TASTATUR)
        MOV        R0, R16
 
; IF_THEN - Ende
M_IF_0323:
 
; IF THEN - Ausdruck / Byte-VAR (INITFAILED)
        LDS        R16, INITFAILED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0327
        RJMP       M_IF_0328
M_IF_0327:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WARTEN_AUF_TASTATUR)
        MOV        R0, R16
 
; IF_THEN - Ende
M_IF_0328:
 
; WHILE DO ...
        RJMP       M_WHILE_0314
M_WHILE_0316:
 
; IF THEN - Ausdruck / Byte-VAR (INITFAILED)
        LDS        R16, INITFAILED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0330
        RJMP       M_IF_0331
M_IF_0330:
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Aufruf PROCEDURE (SET_KBD_CLK)
        CALL       SET_KBD_CLK
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_LED_STATE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LEDSTATE)
        STS        LEDSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_SHIFTSTATE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KBSHIFTSTATE)
        STS        KBSHIFTSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_BYTE1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0332
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0331:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (LEDNUM)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (LEDSTATE)
        STS        LEDSTATE, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Aufruf PROCEDURE (SET_KBD_STATE)
        CALL       SET_KBD_STATE
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (KBDRESET)
        PUSH       R0
 
; Aufruf PROCEDURE (INITKEYB)
        CALL       INITKEYB
 
; Retten der Parameter-Register fuer PROCEDURE (KBDRESET)
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0332:
 
; PROCEDURE - Ende (KBDRESET)
        RET
 
; PROCEDURE - Anfang (START_KEYBOARD)
START_KEYBOARD:
 
; Aufruf PROCEDURE (INITKEYB)
        CALL       INITKEYB
 
; Aufruf PROCEDURE (KBDRESET)
        CALL       KBDRESET
 
; IF THEN - Ausdruck / Byte-VAR (INITFAILED)
        LDS        R16, INITFAILED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0333
        RJMP       M_IF_0334
M_IF_0333:
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0014)
        MOV        R0, R16
        LDI        R17, HIGH(0x0014)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0335
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0334:
 
; Word-Parameter(1) fuer PROCEDURE (TON_SIRENE)
        LDI        R16, LOW(0x0004)
        MOV        R0, R16
        LDI        R17, HIGH(0x0004)
        MOV        R1, R17
 
; Aufruf PROCEDURE (TON_SIRENE)
        CALL       TON_SIRENE
 
; IF_THEN_ELSE - Ende
M_IF_0335:
 
; PROCEDURE - Ende (START_KEYBOARD)
        RET
 
; PROCEDURE - Anfang (SETZE_BIT_IN_KBSHIFTSTATE)
SETZE_BIT_IN_KBSHIFTSTATE:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (SHIFT_TASTE)
        MOV        R18, R0
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (KBSHIFTSTATE)
        STS        KBSHIFTSTATE, R16
 
; PROCEDURE - Ende (SETZE_BIT_IN_KBSHIFTSTATE)
        RET
 
; PROCEDURE - Anfang (LOESCHE_BIT_IN_KBSHIFTSTATE)
LOESCHE_BIT_IN_KBSHIFTSTATE:
 
; Retten der lokalen Parameter fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (NEGATION_BYTE)
        CALL       NEGATION_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R18, R1
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  VAR (KBSHIFTSTATE)
        STS        KBSHIFTSTATE, R16
 
; PROCEDURE - Ende (LOESCHE_BIT_IN_KBSHIFTSTATE)
        RET
 
; PROCEDURE - Anfang (SETZE_BIT_IN_LEDSTATE)
SETZE_BIT_IN_LEDSTATE:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (LEDSTATE)
        LDS        R16, LEDSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (STATE_LED)
        MOV        R18, R0
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (LEDSTATE)
        STS        LEDSTATE, R16
 
; PROCEDURE - Ende (SETZE_BIT_IN_LEDSTATE)
        RET
 
; PROCEDURE - Anfang (LOESCHE_BIT_IN_LEDSTATE)
LOESCHE_BIT_IN_LEDSTATE:
 
; Retten der lokalen Parameter fuer PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (NEGATION_BYTE)
        CALL       NEGATION_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (LEDSTATE)
        LDS        R16, LEDSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R18, R1
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  VAR (LEDSTATE)
        STS        LEDSTATE, R16
 
; PROCEDURE - Ende (LOESCHE_BIT_IN_LEDSTATE)
        RET
 
; PROCEDURE - Anfang (SCAN_TO_KEY)
SCAN_TO_KEY:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(CURSCAN)
        MOV        R16, R0
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R2, R16
        MOV        R3, R17
 
; CASE OF - Byte-VAR (KEYBSTATE)
        LDS        R16, KEYBSTATE
 
; CASE OF - vergleiche Einzel-Element (KEYSTAT_BYTE1)
        CPI        R16, 0x01
        BREQ       M_CASE_0338
        RJMP       M_CASE_0337
M_CASE_0338:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE OF - lokaler Uebergabeparameter (CURSCAN)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (SCANEXT)
        CPI        R16, 0xE0
        BREQ       M_CASE_0341
        RJMP       M_CASE_0340
M_CASE_0341:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_E0)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0340:
 
; CASE OF - vergleiche Einzel-Element (SCANBREAK)
        CPI        R16, 0xF0
        BREQ       M_CASE_0343
        RJMP       M_CASE_0342
M_CASE_0343:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_F0)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0342:
 
; CASE OF - vergleiche Einzel-Element (KBDALT)
        CPI        R16, 0x11
        BREQ       M_CASE_0345
        RJMP       M_CASE_0344
M_CASE_0345:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x08
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0344:
 
; CASE OF - vergleiche Einzel-Element (KBDLSHIFT)
        CPI        R16, 0x12
        BREQ       M_CASE_0347
        RJMP       M_CASE_0346
M_CASE_0347:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x20
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0346:
 
; CASE OF - vergleiche Einzel-Element (KBDRSHIFT)
        CPI        R16, 0x59
        BREQ       M_CASE_0349
        RJMP       M_CASE_0348
M_CASE_0349:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x20
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0348:
 
; CASE OF - vergleiche Einzel-Element (KBDCTRL)
        CPI        R16, 0x14
        BREQ       M_CASE_0351
        RJMP       M_CASE_0350
M_CASE_0351:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x10
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0350:
 
; CASE OF - vergleiche Einzel-Element (KBDCAPS)
        CPI        R16, 0x58
        BREQ       M_CASE_0353
        RJMP       M_CASE_0352
M_CASE_0353:
 
; IF THEN - Ausdruck / Byte-VAR (CAPS_PRESSED)
        LDS        R16, CAPS_PRESSED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0354
        RJMP       M_IF_0355
M_IF_0354:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0356
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0355:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0360
        CLR        R16
        RJMP       M_VERGL_0361
M_VERGL_0360:
        SER        R16
M_VERGL_0361:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0357
        RJMP       M_IF_0358
M_IF_0357:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        CALL       LOESCHE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0359
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0358:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        CALL       SETZE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0359:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SET_KBD_STATE)
        CALL       SET_KBD_STATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (CAPS_PRESSED)
        STS        CAPS_PRESSED, R16
 
; IF_THEN_ELSE - Ende
M_IF_0356:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0352:
 
; CASE OF - vergleiche Einzel-Element (KBDNUM)
        CPI        R16, 0x77
        BREQ       M_CASE_0363
        RJMP       M_CASE_0362
M_CASE_0363:
 
; IF THEN - Ausdruck / Byte-VAR (NUM_PRESSED)
        LDS        R16, NUM_PRESSED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0364
        RJMP       M_IF_0365
M_IF_0364:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0366
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0365:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHNUM)
        LDI        R18, 0x02
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHNUM)
        LDI        R18, 0x02
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0370
        CLR        R16
        RJMP       M_VERGL_0371
M_VERGL_0370:
        SER        R16
M_VERGL_0371:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0367
        RJMP       M_IF_0368
M_IF_0367:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        CALL       LOESCHE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0369
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0368:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        LDI        R16, 0x02
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        CALL       SETZE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0369:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SET_KBD_STATE)
        CALL       SET_KBD_STATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (NUM_PRESSED)
        STS        NUM_PRESSED, R16
 
; IF_THEN_ELSE - Ende
M_IF_0366:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0362:
 
; CASE OF - vergleiche Einzel-Element (KBDSCROLL)
        CPI        R16, 0x7E
        BREQ       M_CASE_0373
        RJMP       M_CASE_0372
M_CASE_0373:
 
; IF THEN - Ausdruck / Byte-VAR (SCROLL_PRESSED)
        LDS        R16, SCROLL_PRESSED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0374
        RJMP       M_IF_0375
M_IF_0374:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0376
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0375:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHSCROLL)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHSCROLL)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0380
        CLR        R16
        RJMP       M_VERGL_0381
M_VERGL_0380:
        SER        R16
M_VERGL_0381:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0377
        RJMP       M_IF_0378
M_IF_0377:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_LEDSTATE)
        CALL       LOESCHE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0379
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0378:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_LEDSTATE)
        CALL       SETZE_BIT_IN_LEDSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0379:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SET_KBD_STATE)
        CALL       SET_KBD_STATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (SCROLL_PRESSED)
        STS        SCROLL_PRESSED, R16
 
; IF_THEN_ELSE - Ende
M_IF_0376:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0372:
 
; CASE OF - vergleiche Einzel-Element (KBDENTER)
        CPI        R16, 0x5A
        BREQ       M_CASE_0383
        RJMP       M_CASE_0382
M_CASE_0383:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0382:
 
; CASE OF - vergleiche Einzel-Element (KBDSPACE)
        CPI        R16, 0x29
        BREQ       M_CASE_0385
        RJMP       M_CASE_0384
M_CASE_0385:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEYCHAR)
        LDI        R16, ' '
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEYCHAR)
        CALL       SENDKEYCHAR
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0384:
 
; CASE OF - vergleiche Einzel-Element (KBDBS)
        CPI        R16, 0x66
        BREQ       M_CASE_0387
        RJMP       M_CASE_0386
M_CASE_0387:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x7F
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0386:
 
; CASE OF - vergleiche Einzel-Element (KBDTAB)
        CPI        R16, 0x0D
        BREQ       M_CASE_0389
        RJMP       M_CASE_0388
M_CASE_0389:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x09
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0388:
 
; CASE OF - vergleiche Einzel-Element (KBDESC)
        CPI        R16, 0x76
        BREQ       M_CASE_0391
        RJMP       M_CASE_0390
M_CASE_0391:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x1B
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0390:
 
; CASE OF - vergleiche Einzel-Element (KBDF1)
        CPI        R16, 0x05
        BREQ       M_CASE_0393
        RJMP       M_CASE_0392
M_CASE_0393:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x80
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0392:
 
; CASE OF - vergleiche Einzel-Element (KBDF2)
        CPI        R16, 0x06
        BREQ       M_CASE_0395
        RJMP       M_CASE_0394
M_CASE_0395:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x81
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0394:
 
; CASE OF - vergleiche Einzel-Element (KBDF3)
        CPI        R16, 0x04
        BREQ       M_CASE_0397
        RJMP       M_CASE_0396
M_CASE_0397:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x82
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0396:
 
; CASE OF - vergleiche Einzel-Element (KBDF4)
        CPI        R16, 0x0C
        BREQ       M_CASE_0399
        RJMP       M_CASE_0398
M_CASE_0399:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x83
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0398:
 
; CASE OF - vergleiche Einzel-Element (KBDF5)
        CPI        R16, 0x03
        BREQ       M_CASE_0401
        RJMP       M_CASE_0400
M_CASE_0401:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x84
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0400:
 
; CASE OF - vergleiche Einzel-Element (KBDF6)
        CPI        R16, 0x0B
        BREQ       M_CASE_0403
        RJMP       M_CASE_0402
M_CASE_0403:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x85
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0402:
 
; CASE OF - vergleiche Einzel-Element (KBDF7)
        CPI        R16, 0x83
        BREQ       M_CASE_0405
        RJMP       M_CASE_0404
M_CASE_0405:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x86
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0404:
 
; CASE OF - vergleiche Einzel-Element (KBDF8)
        CPI        R16, 0x0A
        BREQ       M_CASE_0407
        RJMP       M_CASE_0406
M_CASE_0407:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x87
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0406:
 
; CASE OF - vergleiche Einzel-Element (KBDF9)
        CPI        R16, 0x01
        BREQ       M_CASE_0409
        RJMP       M_CASE_0408
M_CASE_0409:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x88
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0408:
 
; CASE OF - vergleiche Einzel-Element (KBDF10)
        CPI        R16, 0x09
        BREQ       M_CASE_0411
        RJMP       M_CASE_0410
M_CASE_0411:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x89
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0410:
 
; CASE OF - vergleiche Einzel-Element (KBDF11)
        CPI        R16, 0x78
        BREQ       M_CASE_0413
        RJMP       M_CASE_0412
M_CASE_0413:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x8A
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0412:
 
; CASE OF - vergleiche Einzel-Element (KBDF12)
        CPI        R16, 0x07
        BREQ       M_CASE_0415
        RJMP       M_CASE_0414
M_CASE_0415:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x8B
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
M_CASE_0414:
 
; CASE OF - vergleiche Einzel-Element (KBDPAUSE)
        CPI        R16, 0xE1
        BREQ       M_CASE_0417
        RJMP       M_CASE_0416
M_CASE_0417:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0339
 
; CASE OF ELSE
M_CASE_0416:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CHAR_NULL)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHSHIFT)
        LDI        R18, 0x20
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHSHIFT)
        LDI        R18, 0x20
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0421
        CLR        R16
        RJMP       M_VERGL_0422
M_VERGL_0421:
        SER        R16
M_VERGL_0422:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0418
        RJMP       M_IF_0419
M_IF_0418:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0426
        CLR        R16
        RJMP       M_VERGL_0427
M_VERGL_0426:
        SER        R16
M_VERGL_0427:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0423
        RJMP       M_IF_0424
M_IF_0423:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_NORMAL)
        CLR        R28
        LDI        R29, Byte3(2*CODETAB_NORMAL)
        LDI        ZL, LOW(2*CODETAB_NORMAL)
        LDI        ZH, HIGH(2*CODETAB_NORMAL)
        ADD        ZL, R16
        ADC        ZH, R17
        ADC        R29, R28
        OUT        RAMPZ, R29
        ELPM       R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0425
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0424:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_SHIFT)
        CLR        R28
        LDI        R29, Byte3(2*CODETAB_SHIFT)
        LDI        ZL, LOW(2*CODETAB_SHIFT)
        LDI        ZH, HIGH(2*CODETAB_SHIFT)
        ADD        ZL, R16
        ADC        ZH, R17
        ADC        R29, R28
        OUT        RAMPZ, R29
        ELPM       R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Ende
M_IF_0425:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0420
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0419:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHCAPS)
        LDI        R18, 0x04
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0431
        CLR        R16
        RJMP       M_VERGL_0432
M_VERGL_0431:
        SER        R16
M_VERGL_0432:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0428
        RJMP       M_IF_0429
M_IF_0428:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_SHIFT)
        CLR        R28
        LDI        R29, Byte3(2*CODETAB_SHIFT)
        LDI        ZL, LOW(2*CODETAB_SHIFT)
        LDI        ZH, HIGH(2*CODETAB_SHIFT)
        ADD        ZL, R16
        ADC        ZH, R17
        ADC        R29, R28
        OUT        RAMPZ, R29
        ELPM       R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0430
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0429:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_NORMAL)
        CLR        R28
        LDI        R29, Byte3(2*CODETAB_NORMAL)
        LDI        ZL, LOW(2*CODETAB_NORMAL)
        LDI        ZH, HIGH(2*CODETAB_NORMAL)
        ADD        ZL, R16
        ADC        ZH, R17
        ADC        R29, R28
        OUT        RAMPZ, R29
        ELPM       R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN_ELSE - Ende
M_IF_0430:
 
; IF_THEN_ELSE - Ende
M_IF_0420:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHCTRL)
        LDI        R18, 0x10
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHCTRL)
        LDI        R18, 0x10
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0436
        CLR        R16
        RJMP       M_VERGL_0437
M_VERGL_0436:
        SER        R16
M_VERGL_0437:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0433
        RJMP       M_IF_0434
M_IF_0433:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_CTRL)
        CLR        R28
        LDI        R29, Byte3(2*CODETAB_CTRL)
        LDI        ZL, LOW(2*CODETAB_CTRL)
        LDI        ZH, HIGH(2*CODETAB_CTRL)
        ADD        ZL, R16
        ADC        ZH, R17
        ADC        R29, R28
        OUT        RAMPZ, R29
        ELPM       R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN - Ende
M_IF_0434:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (KBSHIFTSTATE)
        LDS        R16, KBSHIFTSTATE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (SHALT)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (SHALT)
        LDI        R18, 0x08
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0441
        CLR        R16
        RJMP       M_VERGL_0442
M_VERGL_0441:
        SER        R16
M_VERGL_0442:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0438
        RJMP       M_IF_0439
M_IF_0438:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (CURSCAN_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CODETAB_ALT)
        CLR        R28
        LDI        R29, Byte3(2*CODETAB_ALT)
        LDI        ZL, LOW(2*CODETAB_ALT)
        LDI        ZH, HIGH(2*CODETAB_ALT)
        ADD        ZL, R16
        ADC        ZH, R17
        ADC        R29, R28
        OUT        RAMPZ, R29
        ELPM       R16, Z
 
; Zuweisung Ziel /  VAR (CH)
        STS        CH, R16
 
; IF_THEN - Ende
M_IF_0439:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEYCHAR)
        LDS        R0, CH
 
; Aufruf PROCEDURE (SENDKEYCHAR)
        CALL       SENDKEYCHAR
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0339:
 
; IF THEN - Ausdruck / Byte-VAR (DOCLICK)
        LDS        R16, DOCLICK
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0443
        RJMP       M_IF_0444
M_IF_0443:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (CLICK)
        CALL       CLICK
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0444:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0336
M_CASE_0337:
 
; CASE OF - vergleiche Einzel-Element (KEYSTAT_E0)
        CPI        R16, 0x02
        BREQ       M_CASE_0447
        RJMP       M_CASE_0446
M_CASE_0447:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_BYTE1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE OF - lokaler Uebergabeparameter (CURSCAN)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (SCANBREAK)
        CPI        R16, 0xF0
        BREQ       M_CASE_0450
        RJMP       M_CASE_0449
M_CASE_0450:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_F0)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0449:
 
; CASE OF - vergleiche Einzel-Element (KBDALT)
        CPI        R16, 0x11
        BREQ       M_CASE_0452
        RJMP       M_CASE_0451
M_CASE_0452:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x08
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0451:
 
; CASE OF - vergleiche Einzel-Element (KBDCTRL)
        CPI        R16, 0x14
        BREQ       M_CASE_0454
        RJMP       M_CASE_0453
M_CASE_0454:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x10
        MOV        R0, R16
 
; Aufruf PROCEDURE (SETZE_BIT_IN_KBSHIFTSTATE)
        CALL       SETZE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DOCLICK)
        STS        DOCLICK, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0453:
 
; CASE OF - vergleiche Einzel-Element (KBDENTER)
        CPI        R16, 0x5A
        BREQ       M_CASE_0456
        RJMP       M_CASE_0455
M_CASE_0456:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0455:
 
; CASE OF - vergleiche Einzel-Element (KBDUP)
        CPI        R16, 0x75
        BREQ       M_CASE_0458
        RJMP       M_CASE_0457
M_CASE_0458:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x05
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0457:
 
; CASE OF - vergleiche Einzel-Element (KBDDN)
        CPI        R16, 0x72
        BREQ       M_CASE_0460
        RJMP       M_CASE_0459
M_CASE_0460:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x18
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0459:
 
; CASE OF - vergleiche Einzel-Element (KBDLEFT)
        CPI        R16, 0x6B
        BREQ       M_CASE_0462
        RJMP       M_CASE_0461
M_CASE_0462:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x13
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0461:
 
; CASE OF - vergleiche Einzel-Element (KBDRIGHT)
        CPI        R16, 0x74
        BREQ       M_CASE_0464
        RJMP       M_CASE_0463
M_CASE_0464:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0463:
 
; CASE OF - vergleiche Einzel-Element (KBDPGUP)
        CPI        R16, 0x7D
        BREQ       M_CASE_0466
        RJMP       M_CASE_0465
M_CASE_0466:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x12
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0465:
 
; CASE OF - vergleiche Einzel-Element (KBDPGDN)
        CPI        R16, 0x7A
        BREQ       M_CASE_0468
        RJMP       M_CASE_0467
M_CASE_0468:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x03
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0467:
 
; CASE OF - vergleiche Einzel-Element (KBDHOME)
        CPI        R16, 0x6C
        BREQ       M_CASE_0470
        RJMP       M_CASE_0469
M_CASE_0470:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0469:
 
; CASE OF - vergleiche Einzel-Element (KBDINSERT)
        CPI        R16, 0x70
        BREQ       M_CASE_0472
        RJMP       M_CASE_0471
M_CASE_0472:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x16
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0471:
 
; CASE OF - vergleiche Einzel-Element (KBDDELETE)
        CPI        R16, 0x71
        BREQ       M_CASE_0474
        RJMP       M_CASE_0473
M_CASE_0474:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x08
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0473:
 
; CASE OF - vergleiche Einzel-Element (KBDEND)
        CPI        R16, 0x69
        BREQ       M_CASE_0476
        RJMP       M_CASE_0475
M_CASE_0476:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0475:
 
; CASE OF - vergleiche Einzel-Element (KBDRGUI)
        CPI        R16, 0x27
        BREQ       M_CASE_0478
        RJMP       M_CASE_0477
M_CASE_0478:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0477:
 
; CASE OF - vergleiche Einzel-Element (KBDLGUI)
        CPI        R16, 0x1F
        BREQ       M_CASE_0480
        RJMP       M_CASE_0479
M_CASE_0480:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0479:
 
; CASE OF - vergleiche Einzel-Element (KBDAPPS)
        CPI        R16, 0x2F
        BREQ       M_CASE_0482
        RJMP       M_CASE_0481
M_CASE_0482:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (SENDKEY)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDKEY)
        CALL       SENDKEY
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0448
M_CASE_0481:
 
; CASE OF - vergleiche Einzel-Element (KBDPRINT)
        CPI        R16, 0x12
        BREQ       M_CASE_0484
        RJMP       M_CASE_0483
M_CASE_0484:
 
; ENDCASE;
M_CASE_0483:
M_CASE_0448:
 
; IF THEN - Ausdruck / Byte-VAR (DOCLICK)
        LDS        R16, DOCLICK
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0485
        RJMP       M_IF_0486
M_IF_0485:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (CLICK)
        CALL       CLICK
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0486:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0336
M_CASE_0446:
 
; CASE OF - vergleiche Einzel-Element (KEYSTAT_F0)
        CPI        R16, 0x03
        BREQ       M_CASE_0489
        RJMP       M_CASE_0488
M_CASE_0489:
 
; CASE OF - lokaler Uebergabeparameter (CURSCAN)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (KBDALT)
        CPI        R16, 0x11
        BREQ       M_CASE_0492
        RJMP       M_CASE_0491
M_CASE_0492:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x08
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0490
M_CASE_0491:
 
; CASE OF - vergleiche Einzel-Element (KBDLSHIFT)
        CPI        R16, 0x12
        BREQ       M_CASE_0494
        RJMP       M_CASE_0493
M_CASE_0494:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x20
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0490
M_CASE_0493:
 
; CASE OF - vergleiche Einzel-Element (KBDRSHIFT)
        CPI        R16, 0x59
        BREQ       M_CASE_0496
        RJMP       M_CASE_0495
M_CASE_0496:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x20
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0490
M_CASE_0495:
 
; CASE OF - vergleiche Einzel-Element (KBDCTRL)
        CPI        R16, 0x14
        BREQ       M_CASE_0498
        RJMP       M_CASE_0497
M_CASE_0498:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCAN_TO_KEY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        LDI        R16, 0x10
        MOV        R0, R16
 
; Aufruf PROCEDURE (LOESCHE_BIT_IN_KBSHIFTSTATE)
        CALL       LOESCHE_BIT_IN_KBSHIFTSTATE
 
; Retten der Parameter-Register fuer PROCEDURE (SCAN_TO_KEY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0490
M_CASE_0497:
 
; CASE OF - vergleiche Einzel-Element (KBDCAPS)
        CPI        R16, 0x58
        BREQ       M_CASE_0500
        RJMP       M_CASE_0499
M_CASE_0500:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CAPS_PRESSED)
        STS        CAPS_PRESSED, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0490
M_CASE_0499:
 
; CASE OF - vergleiche Einzel-Element (KBDNUM)
        CPI        R16, 0x77
        BREQ       M_CASE_0502
        RJMP       M_CASE_0501
M_CASE_0502:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (NUM_PRESSED)
        STS        NUM_PRESSED, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0490
M_CASE_0501:
 
; CASE OF - vergleiche Einzel-Element (KBDSCROLL)
        CPI        R16, 0x7E
        BREQ       M_CASE_0504
        RJMP       M_CASE_0503
M_CASE_0504:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SCROLL_PRESSED)
        STS        SCROLL_PRESSED, R16
 
; ENDCASE;
M_CASE_0503:
M_CASE_0490:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_BYTE1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; ENDCASE;
M_CASE_0488:
M_CASE_0336:
 
; PROCEDURE - Ende (SCAN_TO_KEY)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_TO_SECTOR)
STEUER_STRING_TO_SECTOR:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0F)
        LDI        R16, 0x0F
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0505:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0506
        RJMP       M_FTD_0507
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0506:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B2)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; INC(B2) - Byte
        INC        R1
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0508
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0508:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0510
        MOV        R16, R17
M_PRG_CONST_STRING_0509:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0509
M_PRG_CONST_STRING_0510:
        ST         -Z, R17
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B2)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; INC(B2) - Byte
        INC        R1
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0511
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0511:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0513
M_PRG_CONST_STRING_0512:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0512
M_PRG_CONST_STRING_0513:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0514
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0514:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0516
        MOV        R16, R17
M_PRG_CONST_STRING_0515:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0515
M_PRG_CONST_STRING_0516:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_SECTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (STRINGTOBYTE)
        CALL       STRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_SECTOR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B3)
        MOV        R2, R16
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B3)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR ARRAY (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(SEKTOR_PUFFER_ZEIGER) - Word
        LDS        R24, SEKTOR_PUFFER_ZEIGER
        LDS        R25, SEKTOR_PUFFER_ZEIGER+1
        ADIW       R25:R24, 1
        STS        SEKTOR_PUFFER_ZEIGER, R24
        STS        SEKTOR_PUFFER_ZEIGER+1, R25
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0505
 
; FOR TO DO - Ende
M_FTD_0507:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (STEUER_STRING_TO_SECTOR)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_TO_SECTOR_KOMP)
STEUER_STRING_TO_SECTOR_KOMP:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BITPOS_DB8)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB8)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (POS_SS)
        MOV        R6, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x26)
        LDI        R16, 0x26
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R6
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0517:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0518
        RJMP       M_FTD_0519
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0518:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (POS_SS)
        MOV        R16, R6
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R5
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB7)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BITPOS_DB7)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X2)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x06)
        LDI        R16, 0x06
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0520:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0521
        RJMP       M_FTD_0522
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0521:
 
; DEC(BITPOS_DB7) - Byte
        DEC        R4
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (DB7) retten
        MOV        R17, R1
 
; Parameter (BITPOS_DB7) retten
        MOV        R20, R4
 
; lokalen Parameter (DB7) an Funktion (READ_BIT_IN_BYTE)
        MOV        R0, R17
 
; lokalen Parameter (BITPOS_DB7) an Funktion (READ_BIT_IN_BYTE)
        MOV        R1, R20
 
; Aufruf Funktion (READ_BIT_IN_BYTE)
        CALL       READ_BIT_IN_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EIN_BIT)
        MOV        R7, R16
 
; IF THEN - Ausdruck / lokale, dynamische Variable VAR (EIN_BIT)
        MOV        R16, R7
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0523
        RJMP       M_IF_0524
M_IF_0523:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (DB8) retten
        MOV        R18, R2
 
; Parameter (BITPOS_DB8) retten
        MOV        R19, R3
 
; lokalen Parameter (DB8) an Funktion (SET_BIT_IN_BYTE)
        MOV        R0, R18
 
; lokalen Parameter (BITPOS_DB8) an Funktion (SET_BIT_IN_BYTE)
        MOV        R1, R19
 
; Aufruf Funktion (SET_BIT_IN_BYTE)
        CALL       SET_BIT_IN_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB8)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0525
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0524:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (DB8) retten
        MOV        R18, R2
 
; Parameter (BITPOS_DB8) retten
        MOV        R19, R3
 
; lokalen Parameter (DB8) an Funktion (CLEAR_BIT_IN_BYTE)
        MOV        R0, R18
 
; lokalen Parameter (BITPOS_DB8) an Funktion (CLEAR_BIT_IN_BYTE)
        MOV        R1, R19
 
; Aufruf Funktion (CLEAR_BIT_IN_BYTE)
        CALL       CLEAR_BIT_IN_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB8)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_0525:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (BITPOS_DB8)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0529
        CLR        R16
        RJMP       M_VERGL_0530
M_VERGL_0529:
        SER        R16
M_VERGL_0530:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0526
        RJMP       M_IF_0527
M_IF_0526:
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (DB8)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR ARRAY (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(SEKTOR_PUFFER_ZEIGER) - Word
        LDS        R24, SEKTOR_PUFFER_ZEIGER
        LDS        R25, SEKTOR_PUFFER_ZEIGER+1
        ADIW       R25:R24, 1
        STS        SEKTOR_PUFFER_ZEIGER, R24
        STS        SEKTOR_PUFFER_ZEIGER+1, R25
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BITPOS_DB8)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB8)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0528
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0527:
 
; DEC(BITPOS_DB8) - Byte
        DEC        R3
 
; IF_THEN_ELSE - Ende
M_IF_0528:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0520
 
; FOR TO DO - Ende
M_FTD_0522:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R6
        INC        R17
        MOV        R6, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0517
 
; FOR TO DO - Ende
M_FTD_0519:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (STEUER_STRING_TO_SECTOR_KOMP)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_TO_TIME)
STEUER_STRING_TO_TIME:
 
; ARRAY - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0531
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0531:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0533
        MOV        R16, R17
M_PRG_CONST_STRING_0532:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0532
M_PRG_CONST_STRING_0533:
        ST         -Z, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0534
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0534:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0536
M_PRG_CONST_STRING_0535:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0535
M_PRG_CONST_STRING_0536:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0537
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0537:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0539
        MOV        R16, R17
M_PRG_CONST_STRING_0538:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0538
M_PRG_CONST_STRING_0539:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_TIME)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (STRINGTOBYTE)
        CALL       STRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_TIME)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0540
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0540:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0542
        MOV        R16, R17
M_PRG_CONST_STRING_0541:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0541
M_PRG_CONST_STRING_0542:
        ST         -Z, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0543
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0543:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0545
M_PRG_CONST_STRING_0544:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0544
M_PRG_CONST_STRING_0545:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0546
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0546:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0548
        MOV        R16, R17
M_PRG_CONST_STRING_0547:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0547
M_PRG_CONST_STRING_0548:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_TIME)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (STRINGTOBYTE)
        CALL       STRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_TIME)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ARRAY - Ausdruck / Zahlenwert (0x06)
        LDI        R16, 0x06
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; ARRAY - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ARRAY - Ausdruck / Zahlenwert (0x08)
        LDI        R16, 0x08
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; ARRAY - Ausdruck / Zahlenwert (0x09)
        LDI        R16, 0x09
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ARRAY - Ausdruck / Zahlenwert (0x0A)
        LDI        R16, 0x0A
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; SHL(B1) - Byte
        LSL        R0
 
; ARRAY - Ausdruck / Zahlenwert (0x0B)
        LDI        R16, 0x0B
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DATUM_GESETZT)
        STS        DATUM_GESETZT, R16
 
; PROCEDURE - Ende (STEUER_STRING_TO_TIME)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_AUSWERTEN)
STEUER_STRING_AUSWERTEN:
 
; Zuweisung Quelle - Ausdruck / Length(STEUER_STRING)
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0552
        CLR        R16
        RJMP       M_VERGL_0553
M_VERGL_0552:
        SER        R16
M_VERGL_0553:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0549
        RJMP       M_IF_0550
M_IF_0549:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BUCHSTABE)
        MOV        R0, R16
 
; CASE OF - lokale, dynamische Variable VAR (BUCHSTABE)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (U)
        CPI        R16, 'U'
        BREQ       M_CASE_0556
        RJMP       M_CASE_0555
M_CASE_0556:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x21)
        LDI        R18, 0x21
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0560
        CLR        R16
        RJMP       M_VERGL_0561
M_VERGL_0560:
        SER        R16
M_VERGL_0561:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0557
        RJMP       M_IF_0558
M_IF_0557:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (STEUER_STRING_TO_SECTOR)
        CALL       STEUER_STRING_TO_SECTOR
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0559
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0558:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x03')
        LDI        ZL, LOW(2*M_CONST_STRING_8)
        LDI        ZH, HIGH(2*M_CONST_STRING_8)
        LDI        R29, Byte3(2*M_CONST_STRING_8)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0562
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0562:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0564
M_PRG_CONST_STRING_0563:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0563
M_PRG_CONST_STRING_0564:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0566
        MOV        R16, R17
M_PRG_CONST_STRING_0565:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0565
M_PRG_CONST_STRING_0566:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER1)
        CALL       WRITELN_SER1
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0559:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0554
M_CASE_0555:
 
; CASE OF - vergleiche Einzel-Element (R)
        CPI        R16, 'R'
        BREQ       M_CASE_0568
        RJMP       M_CASE_0567
M_CASE_0568:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x26)
        LDI        R18, 0x26
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0572
        CLR        R16
        RJMP       M_VERGL_0573
M_VERGL_0572:
        SER        R16
M_VERGL_0573:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0569
        RJMP       M_IF_0570
M_IF_0569:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        CALL       STEUER_STRING_TO_SECTOR_KOMP
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0571
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0570:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x07')
        LDI        ZL, LOW(2*M_CONST_STRING_9)
        LDI        ZH, HIGH(2*M_CONST_STRING_9)
        LDI        R29, Byte3(2*M_CONST_STRING_9)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0574
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0574:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0576
M_PRG_CONST_STRING_0575:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0575
M_PRG_CONST_STRING_0576:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0578
        MOV        R16, R17
M_PRG_CONST_STRING_0577:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0577
M_PRG_CONST_STRING_0578:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER1)
        CALL       WRITELN_SER1
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0571:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0554
M_CASE_0567:
 
; CASE OF - vergleiche Einzel-Element (D)
        CPI        R16, 'D'
        BREQ       M_CASE_0580
        RJMP       M_CASE_0579
M_CASE_0580:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0B)
        LDI        R18, 0x0B
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0584
        CLR        R16
        RJMP       M_VERGL_0585
M_VERGL_0584:
        SER        R16
M_VERGL_0585:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0581
        RJMP       M_IF_0582
M_IF_0581:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (STEUER_STRING_TO_TIME)
        CALL       STEUER_STRING_TO_TIME
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0583
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0582:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x09')
        LDI        ZL, LOW(2*M_CONST_STRING_10)
        LDI        ZH, HIGH(2*M_CONST_STRING_10)
        LDI        R29, Byte3(2*M_CONST_STRING_10)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0586
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0586:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0588
M_PRG_CONST_STRING_0587:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0587
M_PRG_CONST_STRING_0588:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0590
        MOV        R16, R17
M_PRG_CONST_STRING_0589:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0589
M_PRG_CONST_STRING_0590:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER1)
        CALL       WRITELN_SER1
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0583:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0554
 
; CASE OF ELSE
M_CASE_0579:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x02')
        LDI        ZL, LOW(2*M_CONST_STRING_11)
        LDI        ZH, HIGH(2*M_CONST_STRING_11)
        LDI        R29, Byte3(2*M_CONST_STRING_11)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0591
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0591:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0593
M_PRG_CONST_STRING_0592:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0592
M_PRG_CONST_STRING_0593:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0595
        MOV        R16, R17
M_PRG_CONST_STRING_0594:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0594
M_PRG_CONST_STRING_0595:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER1)
        CALL       WRITELN_SER1
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0554:
 
; IF_THEN - Ende
M_IF_0550:
 
; PROCEDURE - Ende (STEUER_STRING_AUSWERTEN)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_LESEN)
STEUER_STRING_LESEN:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (UDR1)
        LDS        R16, UDR1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EMPF_ZEICHEN)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (EMPF_ZEICHEN)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0D)
        LDI        R18, 0x0D
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0599
        CLR        R16
        RJMP       M_VERGL_0600
M_VERGL_0599:
        SER        R16
M_VERGL_0600:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0596
        RJMP       M_IF_0597
M_IF_0596:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (EMPF_ZEICHEN)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0A)
        LDI        R18, 0x0A
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0604
        CLR        R16
        RJMP       M_VERGL_0605
M_VERGL_0604:
        SER        R16
M_VERGL_0605:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0601
        RJMP       M_IF_0602
M_IF_0601:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_LESEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (STEUER_STRING_AUSWERTEN)
        CALL       STEUER_STRING_AUSWERTEN
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_LESEN)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (STEUER_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('')
        LDI        ZL, LOW(2*M_CONST_STRING_12)
        LDI        ZH, HIGH(2*M_CONST_STRING_12)
        LDI        R29, Byte3(2*M_CONST_STRING_12)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0606
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0606:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0608
M_PRG_CONST_STRING_0607:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0607
M_PRG_CONST_STRING_0608:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (STEUER_STRING) - Laenge in R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0610
        MOV        R16, R17
M_PRG_CONST_STRING_0609:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0609
M_PRG_CONST_STRING_0610:
        ST         -Z, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0603
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0602:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(EMPF_ZEICHEN)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (AKT_ZEICHEN)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (STEUER_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0611
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0611:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0613
M_PRG_CONST_STRING_0612:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0612
M_PRG_CONST_STRING_0613:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (AKT_ZEICHEN)
        MOV        R19, R0
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0614
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0614:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (STEUER_STRING) - Laenge in R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0616
        MOV        R16, R17
M_PRG_CONST_STRING_0615:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0615
M_PRG_CONST_STRING_0616:
        ST         -Z, R17
 
; IF_THEN_ELSE - Ende
M_IF_0603:
 
; IF_THEN - Ende
M_IF_0597:
 
; PROCEDURE - Ende (STEUER_STRING_LESEN)
        RET
 
; PROCEDURE - Anfang (SEKTOR_VON_PC_LESEN)
SEKTOR_VON_PC_LESEN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPZ)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0617:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0618
        RJMP       M_FTD_0619
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0618:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('u')
        LDI        ZL, LOW(2*M_CONST_STRING_13)
        LDI        ZH, HIGH(2*M_CONST_STRING_13)
        LDI        R29, Byte3(2*M_CONST_STRING_13)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0620
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0620:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0622
M_PRG_CONST_STRING_0621:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0621
M_PRG_CONST_STRING_0622:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0623
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0623:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0625
M_PRG_CONST_STRING_0624:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0624
M_PRG_CONST_STRING_0625:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0627
        MOV        R16, R17
M_PRG_CONST_STRING_0626:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0626
M_PRG_CONST_STRING_0627:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITELN_SER1)
        CALL       WRITELN_SER1
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; WHILE DO ...
M_WHILE_0628:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R4
        MOV        R17, R5
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0631
        CLR        R16
        RJMP       M_VERGL_0632
M_VERGL_0631:
        SER        R16
M_VERGL_0632:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0629
        RJMP       M_WHILE_0630
M_WHILE_0629:
 
; IF THEN - Ausdruck /; BitHigh(RXC1)
        LDS        R16, UCSR1A
        BST        R16, 7
        BRTS       M_VERGL_0636
        CLR        R16
        RJMP       M_VERGL_0637
M_VERGL_0636:
        SER        R16
M_VERGL_0637:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0633
        RJMP       M_IF_0634
M_IF_0633:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (SPZ)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0641
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0642
M_VERGL_0641:
        SER        R16
M_VERGL_0642:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0638
        RJMP       M_IF_0639
M_IF_0638:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0640
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0639:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPZ)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN_ELSE - Ende
M_IF_0640:
 
; IF_THEN - Ende
M_IF_0634:
 
; DEC(LESESCHLEIFE) - Word
        MOV        R24, R4
        MOV        R25, R5
        SBIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; WHILE DO ...
        RJMP       M_WHILE_0628
M_WHILE_0630:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0646
        CLR        R16
        RJMP       M_VERGL_0647
M_VERGL_0646:
        SER        R16
M_VERGL_0647:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0643
        RJMP       M_IF_0644
M_IF_0643:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x04')
        LDI        ZL, LOW(2*M_CONST_STRING_14)
        LDI        ZH, HIGH(2*M_CONST_STRING_14)
        LDI        R29, Byte3(2*M_CONST_STRING_14)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0648
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0648:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0650
M_PRG_CONST_STRING_0649:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0649
M_PRG_CONST_STRING_0650:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0652
        MOV        R16, R17
M_PRG_CONST_STRING_0651:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0651
M_PRG_CONST_STRING_0652:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITELN_SER1)
        CALL       WRITELN_SER1
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0644:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0617
 
; FOR TO DO - Ende
M_FTD_0619:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (SEKTOR_VON_PC_LESEN)
        RET
 
; PROCEDURE - Anfang (SEKTOR_VON_PC_LESEN_KOMP)
SEKTOR_VON_PC_LESEN_KOMP:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPZ)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0653:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0654
        RJMP       M_FTD_0655
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0654:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('r')
        LDI        ZL, LOW(2*M_CONST_STRING_15)
        LDI        ZH, HIGH(2*M_CONST_STRING_15)
        LDI        R29, Byte3(2*M_CONST_STRING_15)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0656
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0656:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0658
M_PRG_CONST_STRING_0657:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0657
M_PRG_CONST_STRING_0658:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0659
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0659:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0661
M_PRG_CONST_STRING_0660:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0660
M_PRG_CONST_STRING_0661:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0663
        MOV        R16, R17
M_PRG_CONST_STRING_0662:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0662
M_PRG_CONST_STRING_0663:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITELN_SER1)
        CALL       WRITELN_SER1
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; WHILE DO ...
M_WHILE_0664:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R4
        MOV        R17, R5
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0667
        CLR        R16
        RJMP       M_VERGL_0668
M_VERGL_0667:
        SER        R16
M_VERGL_0668:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0665
        RJMP       M_WHILE_0666
M_WHILE_0665:
 
; IF THEN - Ausdruck /; BitHigh(RXC1)
        LDS        R16, UCSR1A
        BST        R16, 7
        BRTS       M_VERGL_0672
        CLR        R16
        RJMP       M_VERGL_0673
M_VERGL_0672:
        SER        R16
M_VERGL_0673:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0669
        RJMP       M_IF_0670
M_IF_0669:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (SPZ)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0677
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0678
M_VERGL_0677:
        SER        R16
M_VERGL_0678:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0674
        RJMP       M_IF_0675
M_IF_0674:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0676
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0675:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPZ)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN_ELSE - Ende
M_IF_0676:
 
; IF_THEN - Ende
M_IF_0670:
 
; DEC(LESESCHLEIFE) - Word
        MOV        R24, R4
        MOV        R25, R5
        SBIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; WHILE DO ...
        RJMP       M_WHILE_0664
M_WHILE_0666:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0682
        CLR        R16
        RJMP       M_VERGL_0683
M_VERGL_0682:
        SER        R16
M_VERGL_0683:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0679
        RJMP       M_IF_0680
M_IF_0679:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x08')
        LDI        ZL, LOW(2*M_CONST_STRING_16)
        LDI        ZH, HIGH(2*M_CONST_STRING_16)
        LDI        R29, Byte3(2*M_CONST_STRING_16)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0684
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0684:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0686
M_PRG_CONST_STRING_0685:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0685
M_PRG_CONST_STRING_0686:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0688
        MOV        R16, R17
M_PRG_CONST_STRING_0687:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0687
M_PRG_CONST_STRING_0688:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITELN_SER1)
        CALL       WRITELN_SER1
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0680:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0653
 
; FOR TO DO - Ende
M_FTD_0655:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (SEKTOR_VON_PC_LESEN_KOMP)
        RET
 
; PROCEDURE - Anfang (SEKTOR_AN_PC_SENDEN)
SEKTOR_AN_PC_SENDEN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0689:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0690
        RJMP       M_FTD_0691
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0690:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_AN_PC_SENDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_AN_PC_SENDEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('v')
        LDI        ZL, LOW(2*M_CONST_STRING_17)
        LDI        ZH, HIGH(2*M_CONST_STRING_17)
        LDI        R29, Byte3(2*M_CONST_STRING_17)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0692
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0692:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0694
M_PRG_CONST_STRING_0693:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0693
M_PRG_CONST_STRING_0694:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0695
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0695:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0697
M_PRG_CONST_STRING_0696:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0696
M_PRG_CONST_STRING_0697:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0699
        MOV        R16, R17
M_PRG_CONST_STRING_0698:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0698
M_PRG_CONST_STRING_0699:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0F)
        LDI        R16, 0x0F
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R1
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0700:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0701
        RJMP       M_FTD_0702
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0701:
 
; ARRAY - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B3)
        MOV        R2, R16
 
; INC(SEKTOR_PUFFER_ZEIGER) - Word
        LDS        R24, SEKTOR_PUFFER_ZEIGER
        LDS        R25, SEKTOR_PUFFER_ZEIGER+1
        ADIW       R25:R24, 1
        STS        SEKTOR_PUFFER_ZEIGER, R24
        STS        SEKTOR_PUFFER_ZEIGER+1, R25
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_AN_PC_SENDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (B3) retten
        MOV        R18, R2
 
; lokalen Parameter (B3) an Prozedur (BYTETOSTRING)
        MOV        R0, R18
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_AN_PC_SENDEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0703
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0703:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0705
M_PRG_CONST_STRING_0704:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0704
M_PRG_CONST_STRING_0705:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0706
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0706:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0708
M_PRG_CONST_STRING_0707:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0707
M_PRG_CONST_STRING_0708:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0710
        MOV        R16, R17
M_PRG_CONST_STRING_0709:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0709
M_PRG_CONST_STRING_0710:
        ST         -Z, R17
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R1
        INC        R17
        MOV        R1, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0700
 
; FOR TO DO - Ende
M_FTD_0702:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0711
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0711:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0713
M_PRG_CONST_STRING_0712:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0712
M_PRG_CONST_STRING_0713:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0715
        MOV        R16, R17
M_PRG_CONST_STRING_0714:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0714
M_PRG_CONST_STRING_0715:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_AN_PC_SENDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITELN_SER1)
        CALL       WRITELN_SER1
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_AN_PC_SENDEN)
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0689
 
; FOR TO DO - Ende
M_FTD_0691:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (SEKTOR_AN_PC_SENDEN)
        RET
 
; PROCEDURE - Anfang (WARTE_KURZ)
WARTE_KURZ:
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; PROCEDURE - Ende (WARTE_KURZ)
        RET
 
; PROCEDURE - Anfang (Z80_RECEIVE_BYTE)
Z80_RECEIVE_BYTE:
 
; ASM
M_ASM_warte_solange_RECEIVE_Byte:

        LDS        R16, UCSR0A
        BST        R16, 7
        BRTC       M_ASM_warte_solange_RECEIVE_Byte

 
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (UDR0)
        LDS        R16, UDR0
 
; Zuweisung Ziel /  VAR (SER0_ZEICHEN)
        STS        SER0_ZEICHEN, R16
 
; PROCEDURE - Ende (Z80_RECEIVE_BYTE)
        RET
 
; PROCEDURE - Anfang (Z80_RECEIVE_WRITE)
Z80_RECEIVE_WRITE:
 
; Interrupt verbieten
        CLI
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x11
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Aufruf PROCEDURE (Z80_RECEIVE_BYTE)
        CALL       Z80_RECEIVE_BYTE
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0716:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0717
        RJMP       M_FTD_0718
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0717:
 
; ASM
M_ASM_warte_solange_RECEIVE_WRITE:

        LDS        R16, UCSR0A
        BST        R16, 7
        BRTC       M_ASM_warte_solange_RECEIVE_WRITE

 
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (UDR0)
        LDS        R16, UDR0
 
; Zuweisung Ziel /  VAR (SER0_ZEICHEN)
        STS        SER0_ZEICHEN, R16
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; Zuweisung Ziel /  VAR ARRAY (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        SEKTOR_PUFFER_ZEIGER, R18
        STS        SEKTOR_PUFFER_ZEIGER+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0716
 
; FOR TO DO - Ende
M_FTD_0718:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Interrupt erlauben
        SEI
 
; Aufruf PROCEDURE (SEKTOR_AN_PC_SENDEN)
        CALL       SEKTOR_AN_PC_SENDEN
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x11
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; PROCEDURE - Ende (Z80_RECEIVE_WRITE)
        RET
 
; PROCEDURE - Anfang (Z80_RECEIVE_READ)
Z80_RECEIVE_READ:
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80_RECEIVE_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (SEKTOR_VON_PC_LESEN_KOMP)
        CALL       SEKTOR_VON_PC_LESEN_KOMP
 
; Retten der Parameter-Register fuer PROCEDURE (Z80_RECEIVE_READ)
        POP        R0
 
; Interrupt verbieten
        CLI
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0719:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0720
        RJMP       M_FTD_0721
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0720:
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80_RECEIVE_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (WARTE_KURZ)
        CALL       WARTE_KURZ
 
; Retten der Parameter-Register fuer PROCEDURE (Z80_RECEIVE_READ)
        POP        R0
 
; ARRAY - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80_RECEIVE_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Retten der Parameter-Register fuer PROCEDURE (Z80_RECEIVE_READ)
        POP        R0
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        SEKTOR_PUFFER_ZEIGER, R18
        STS        SEKTOR_PUFFER_ZEIGER+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0719
 
; FOR TO DO - Ende
M_FTD_0721:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Interrupt erlauben
        SEI
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80_RECEIVE_READ)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x11
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Retten der Parameter-Register fuer PROCEDURE (Z80_RECEIVE_READ)
        POP        R0
 
; PROCEDURE - Ende (Z80_RECEIVE_READ)
        RET
 
; PROCEDURE - Anfang (STD_AN_PC_SENDEN)
STD_AN_PC_SENDEN:
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOSTRING)
        LDS        R0, SECTOR
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('s')
        LDI        ZL, LOW(2*M_CONST_STRING_18)
        LDI        ZH, HIGH(2*M_CONST_STRING_18)
        LDI        R29, Byte3(2*M_CONST_STRING_18)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0722
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0722:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0724
M_PRG_CONST_STRING_0723:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0723
M_PRG_CONST_STRING_0724:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0725
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0725:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0727
M_PRG_CONST_STRING_0726:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0726
M_PRG_CONST_STRING_0727:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0729
        MOV        R16, R17
M_PRG_CONST_STRING_0728:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0728
M_PRG_CONST_STRING_0729:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOSTRING)
        LDS        R0, TRACK_H
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0730
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0730:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0732
M_PRG_CONST_STRING_0731:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0731
M_PRG_CONST_STRING_0732:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0733
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0733:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0735
M_PRG_CONST_STRING_0734:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0734
M_PRG_CONST_STRING_0735:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0737
        MOV        R16, R17
M_PRG_CONST_STRING_0736:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0736
M_PRG_CONST_STRING_0737:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOSTRING)
        LDS        R0, TRACK_L
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0738
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0738:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0740
M_PRG_CONST_STRING_0739:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0739
M_PRG_CONST_STRING_0740:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0741
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0741:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0743
M_PRG_CONST_STRING_0742:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0742
M_PRG_CONST_STRING_0743:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0745
        MOV        R16, R17
M_PRG_CONST_STRING_0744:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0744
M_PRG_CONST_STRING_0745:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOSTRING)
        LDS        R0, DISKNO
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0746
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0746:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0748
M_PRG_CONST_STRING_0747:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0747
M_PRG_CONST_STRING_0748:
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0749
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0749:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0751
M_PRG_CONST_STRING_0750:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0750
M_PRG_CONST_STRING_0751:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0753
        MOV        R16, R17
M_PRG_CONST_STRING_0752:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0752
M_PRG_CONST_STRING_0753:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN_SER1)
        CALL       WRITELN_SER1
 
; PROCEDURE - Ende (STD_AN_PC_SENDEN)
        RET
 
; PROCEDURE - Anfang (Z80_RECEIVE_STD)
Z80_RECEIVE_STD:
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x11
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Aufruf PROCEDURE (Z80_RECEIVE_BYTE)
        CALL       Z80_RECEIVE_BYTE
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; Zuweisung Ziel /  VAR (SECTOR)
        STS        SECTOR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x11
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Aufruf PROCEDURE (Z80_RECEIVE_BYTE)
        CALL       Z80_RECEIVE_BYTE
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; Zuweisung Ziel /  VAR (TRACK_H)
        STS        TRACK_H, R16
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x11
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Aufruf PROCEDURE (Z80_RECEIVE_BYTE)
        CALL       Z80_RECEIVE_BYTE
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; Zuweisung Ziel /  VAR (TRACK_L)
        STS        TRACK_L, R16
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x11
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Aufruf PROCEDURE (Z80_RECEIVE_BYTE)
        CALL       Z80_RECEIVE_BYTE
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; Zuweisung Ziel /  VAR (DISKNO)
        STS        DISKNO, R16
 
; Aufruf PROCEDURE (STD_AN_PC_SENDEN)
        CALL       STD_AN_PC_SENDEN
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x11
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; PROCEDURE - Ende (Z80_RECEIVE_STD)
        RET
 
; PROCEDURE - Anfang (Z80_RECEIVE_CONST)
Z80_RECEIVE_CONST:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0757
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0758
M_VERGL_0757:
        SER        R16
M_VERGL_0758:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0754
        RJMP       M_IF_0755
M_IF_0754:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RECEIVE_MESSAGE)
        MOV        R0, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0756
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0755:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RECEIVE_MESSAGE)
        MOV        R0, R16
 
; IF_THEN_ELSE - Ende
M_IF_0756:
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80_RECEIVE_CONST)
        PUSH       R0
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Retten der Parameter-Register fuer PROCEDURE (Z80_RECEIVE_CONST)
        POP        R0
 
; PROCEDURE - Ende (Z80_RECEIVE_CONST)
        RET
 
; PROCEDURE - Anfang (Z80_RECEIVE_CONIN)
Z80_RECEIVE_CONIN:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (KEYBUFFERPTR)
        LDS        R16, KEYBUFFERPTR
        LDS        R17, KEYBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0762
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0763
M_VERGL_0762:
        SER        R16
M_VERGL_0763:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0759
        RJMP       M_IF_0760
M_IF_0759:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RECEIVE_MESSAGE)
        MOV        R0, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0761
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0760:
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80_RECEIVE_CONIN)
        PUSH       R0
 
; Aufruf Funktion (READ_KEY)
        CALL       READ_KEY
 
; Retten der Parameter-Register fuer PROCEDURE (Z80_RECEIVE_CONIN)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RECEIVE_MESSAGE)
        MOV        R0, R16
 
; IF_THEN_ELSE - Ende
M_IF_0761:
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80_RECEIVE_CONIN)
        PUSH       R0
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Retten der Parameter-Register fuer PROCEDURE (Z80_RECEIVE_CONIN)
        POP        R0
 
; PROCEDURE - Ende (Z80_RECEIVE_CONIN)
        RET
 
; PROCEDURE - Anfang (Z80_RECEIVE_KOMMENTAR)
Z80_RECEIVE_KOMMENTAR:
 
; ASM
M_ASM_warte_solange_RECEIVE_Kommentar_01:

        LDS        R16, UCSR0A
        BST        R16, 7
        BRTC       M_ASM_warte_solange_RECEIVE_Kommentar_01

 
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (UDR0)
        LDS        R16, UDR0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R0, R16
 
; DEC(LAENGE) - Byte
        DEC        R0
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(LAENGE)
        MOV        R16, R0
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE_WORD)
        MOV        R1, R16
        MOV        R2, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (LAENGE_WORD)
        MOV        R16, R1
        MOV        R17, R2
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0764:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0765
        RJMP       M_FTD_0766
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0765:
 
; ASM
M_ASM_warte_solange_RECEIVE_Kommentar_02:

        LDS        R16, UCSR0A
        BST        R16, 7
        BRTC       M_ASM_warte_solange_RECEIVE_Kommentar_02

 
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (UDR0)
        LDS        R16, UDR0
 
; Zuweisung Ziel /  VAR (SER0_ZEICHEN)
        STS        SER0_ZEICHEN, R16
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; Zuweisung Ziel /  VAR ARRAY (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        SEKTOR_PUFFER_ZEIGER, R18
        STS        SEKTOR_PUFFER_ZEIGER+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0764
 
; FOR TO DO - Ende
M_FTD_0766:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('y')
        LDI        ZL, LOW(2*M_CONST_STRING_19)
        LDI        ZH, HIGH(2*M_CONST_STRING_19)
        LDI        R29, Byte3(2*M_CONST_STRING_19)
        OUT        RAMPZ, R29
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        ELPM       R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0767
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0767:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0769
M_PRG_CONST_STRING_0768:
        ELPM       R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0768
M_PRG_CONST_STRING_0769:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0771
        MOV        R16, R17
M_PRG_CONST_STRING_0770:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0770
M_PRG_CONST_STRING_0771:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (LAENGE_WORD)
        MOV        R16, R1
        MOV        R17, R2
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0772:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0773
        RJMP       M_FTD_0774
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0773:
 
; ARRAY - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (SER0_ZEICHEN)
        STS        SER0_ZEICHEN, R16
 
; Zuweisung Quelle - Ausdruck / Char-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WRITE_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0775
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0775:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0777
M_PRG_CONST_STRING_0776:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0776
M_PRG_CONST_STRING_0777:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R4
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0778
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0778:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0780
        MOV        R16, R17
M_PRG_CONST_STRING_0779:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0779
M_PRG_CONST_STRING_0780:
        ST         -Z, R17
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        SEKTOR_PUFFER_ZEIGER, R18
        STS        SEKTOR_PUFFER_ZEIGER+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0772
 
; FOR TO DO - Ende
M_FTD_0774:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80_RECEIVE_KOMMENTAR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (WRITELN_SER1)
        CALL       WRITELN_SER1
 
; Retten der Parameter-Register fuer PROCEDURE (Z80_RECEIVE_KOMMENTAR)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80_RECEIVE_KOMMENTAR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x11
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Retten der Parameter-Register fuer PROCEDURE (Z80_RECEIVE_KOMMENTAR)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (Z80_RECEIVE_KOMMENTAR)
        RET
 
; PROCEDURE - Anfang (Z80_RECEIVE_CPM_START)
Z80_RECEIVE_CPM_START:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (ZAEHLER_T1)
        STS        ZAEHLER_T1, R16
        STS        ZAEHLER_T1+1, R17
 
; Word-Parameter(1) fuer PROCEDURE (INIT_TIMER1_COMPA)
        LDI        R16, LOW(0x04E2)
        MOV        R0, R16
        LDI        R17, HIGH(0x04E2)
        MOV        R1, R17
 
; Aufruf PROCEDURE (INIT_TIMER1_COMPA)
        CALL       INIT_TIMER1_COMPA
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x11
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; PROCEDURE - Ende (Z80_RECEIVE_CPM_START)
        RET
 
; PROCEDURE - Anfang (Z80_RECEIVE)
Z80_RECEIVE:
 
; CASE OF - Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; CASE OF - vergleiche Einzel-Element (PA_CONST)
        CPI        R16, 0x01
        BREQ       M_CASE_0783
        RJMP       M_CASE_0782
M_CASE_0783:
 
; Aufruf PROCEDURE (Z80_RECEIVE_CONST)
        CALL       Z80_RECEIVE_CONST
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0781
M_CASE_0782:
 
; CASE OF - vergleiche Einzel-Element (PA_CONIN)
        CPI        R16, 0x02
        BREQ       M_CASE_0785
        RJMP       M_CASE_0784
M_CASE_0785:
 
; Aufruf PROCEDURE (Z80_RECEIVE_CONIN)
        CALL       Z80_RECEIVE_CONIN
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0781
M_CASE_0784:
 
; CASE OF - vergleiche Einzel-Element (PA_CONOUT)
        CPI        R16, 0x03
        BREQ       M_CASE_0787
        RJMP       M_CASE_0786
M_CASE_0787:
 
; Aufruf PROCEDURE (TON_FEHLER)
        CALL       TON_FEHLER
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0781
M_CASE_0786:
 
; CASE OF - vergleiche Einzel-Element (PA_LIST)
        CPI        R16, 0x04
        BREQ       M_CASE_0789
        RJMP       M_CASE_0788
M_CASE_0789:
 
; Aufruf PROCEDURE (TON_FEHLER)
        CALL       TON_FEHLER
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0781
M_CASE_0788:
 
; CASE OF - vergleiche Einzel-Element (PA_SOUND)
        CPI        R16, 0x05
        BREQ       M_CASE_0791
        RJMP       M_CASE_0790
M_CASE_0791:
 
; Aufruf PROCEDURE (TON_FEHLER)
        CALL       TON_FEHLER
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0781
M_CASE_0790:
 
; CASE OF - vergleiche Einzel-Element (PA_WRITE)
        CPI        R16, 0x06
        BREQ       M_CASE_0793
        RJMP       M_CASE_0792
M_CASE_0793:
 
; Aufruf PROCEDURE (Z80_RECEIVE_WRITE)
        CALL       Z80_RECEIVE_WRITE
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0781
M_CASE_0792:
 
; CASE OF - vergleiche Einzel-Element (PA_READ)
        CPI        R16, 0x07
        BREQ       M_CASE_0795
        RJMP       M_CASE_0794
M_CASE_0795:
 
; Aufruf PROCEDURE (Z80_RECEIVE_READ)
        CALL       Z80_RECEIVE_READ
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0781
M_CASE_0794:
 
; CASE OF - vergleiche Einzel-Element (PA_STD)
        CPI        R16, 0x08
        BREQ       M_CASE_0797
        RJMP       M_CASE_0796
M_CASE_0797:
 
; Aufruf PROCEDURE (Z80_RECEIVE_STD)
        CALL       Z80_RECEIVE_STD
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0781
M_CASE_0796:
 
; CASE OF - vergleiche Einzel-Element (PA_KOMMENTAR)
        CPI        R16, 0x09
        BREQ       M_CASE_0799
        RJMP       M_CASE_0798
M_CASE_0799:
 
; Aufruf PROCEDURE (Z80_RECEIVE_KOMMENTAR)
        CALL       Z80_RECEIVE_KOMMENTAR
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0781
M_CASE_0798:
 
; CASE OF - vergleiche Einzel-Element (PA_CPM_START)
        CPI        R16, 0x0B
        BREQ       M_CASE_0801
        RJMP       M_CASE_0800
M_CASE_0801:
 
; Aufruf PROCEDURE (Z80_RECEIVE_CPM_START)
        CALL       Z80_RECEIVE_CPM_START
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0781
 
; CASE OF ELSE
M_CASE_0800:
 
; Aufruf PROCEDURE (TON_FEHLER)
        CALL       TON_FEHLER
 
; ENDCASE;
M_CASE_0781:
 
; PROCEDURE - Ende (Z80_RECEIVE)
        RET
 
; ISR - Einsprung
TIMER0_COMPA:
        PUSH       R16
        IN         R16,SREG
        PUSH       R16
 
; ASM
.equ 	port_dac	= porta


	lds	  R16, SOUND_Byte
        out       port_dac, R16


 
 
; ISR - Ende
        POP        R16
        OUT        SREG,R16
        POP        R16
        RETI
 
; ISR - Einsprung
TIMER1_COMPA:
        PUSH       R16
        IN         R16,SREG
        PUSH       R16
 
; ASM
	push      R17
	push      R18
	push      R19
	push      R24
        push      R25
        push      R28
        push      R29
        push      zl
        push      zh
 
 
; ARRAY - Ausdruck / Word-VAR (ZAEHLER_T1)
        LDS        R16, ZAEHLER_T1
        LDS        R17, ZAEHLER_T1+1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CPM_START_TAB)
        CLR        R28
        LDI        R29, Byte3(2*CPM_START_TAB)
        LDI        ZL, LOW(2*CPM_START_TAB)
        LDI        ZH, HIGH(2*CPM_START_TAB)
        ADD        ZL, R16
        ADC        ZH, R17
        ADC        R29, R28
        OUT        RAMPZ, R29
        ELPM       R16, Z
 
; Zuweisung Ziel /  VAR (SOUND_BYTE)
        STS        SOUND_BYTE, R16
 
; INC(ZAEHLER_T1) - Word
        LDS        R24, ZAEHLER_T1
        LDS        R25, ZAEHLER_T1+1
        ADIW       R25:R24, 1
        STS        ZAEHLER_T1, R24
        STS        ZAEHLER_T1+1, R25
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (ZAEHLER_T1)
        LDS        R16, ZAEHLER_T1
        LDS        R17, ZAEHLER_T1+1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (CPM_START_TAB_LAENGE)
        LDI        R18, LOW(0x7384)
        LDI        R19, HIGH(0x7384)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0805
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0806
M_VERGL_0805:
        SER        R16
M_VERGL_0806:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0802
        RJMP       M_IF_0803
M_IF_0802:
 
; Aufruf PROCEDURE (TIMER1_AUS)
        CALL       TIMER1_AUS
 
; IF_THEN - Ende
M_IF_0803:
 
; ASM
        pop       zh
        pop       zl
        pop       R29
        pop       R28
        pop       R25
        pop       R24
        pop       R19
        pop       R18
        pop       R17
 
 
; ISR - Ende
        POP        R16
        OUT        SREG,R16
        POP        R16
        RETI
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; ASM
.equ UBRR0 = UBRR0L
.equ UBRR1 = UBRR1L

 
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x000A)
        MOV        R0, R16
        LDI        R17, HIGH(0x000A)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; Aufruf PROCEDURE (INIT_INT2)
        CALL       INIT_INT2
 
; Aufruf PROCEDURE (INIT_SER0_PORT)
        CALL       INIT_SER0_PORT
 
; Aufruf PROCEDURE (INIT_SER1_PORT)
        CALL       INIT_SER1_PORT
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CAPS_PRESSED)
        STS        CAPS_PRESSED, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (NUM_PRESSED)
        STS        NUM_PRESSED, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SCROLL_PRESSED)
        STS        SCROLL_PRESSED, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_LED_STATE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LEDSTATE)
        STS        LEDSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (KEYSTAT_BYTE1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (KEYBSTATE)
        STS        KEYBSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_SHIFTSTATE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (KBSHIFTSTATE)
        STS        KBSHIFTSTATE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (KEYBUFFERPTR)
        STS        KEYBUFFERPTR, R16
        STS        KEYBUFFERPTR+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TX_WARTEN)
        STS        TX_WARTEN, R16
 
; ClearBit(SUMMER)
        CBI        PORTD, 7
 
; ClearBit(LED)
        CBI        PORTB, 1
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x7F)
        LDI        R16, 0x7F
 
; Zuweisung Ziel /  VAR (SOUND_BYTE)
        STS        SOUND_BYTE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (WERT_YL)
        STS        WERT_YL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (WERT_YH)
        STS        WERT_YH, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (MONITOR_LEER)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (MONITOR_VERSCHIEBEN)
        STS        MONITOR_VERSCHIEBEN, R16
 
; Aufruf PROCEDURE (START_KEYBOARD)
        CALL       START_KEYBOARD
 
; Byte-Parameter(1) fuer PROCEDURE (INIT_TIMER0_COMPA)
        LDI        R16, 0x71
        MOV        R0, R16
 
; Aufruf PROCEDURE (INIT_TIMER0_COMPA)
        CALL       INIT_TIMER0_COMPA
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x11
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN1)
        LDI        R16, 0x40
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN1)
        CALL       SENDE_ZEICHEN1
 
; LOOP - Start_Marke
M_LOOP_0807:
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (SCANBUFFERPTR)
        LDS        R16, SCANBUFFERPTR
        LDS        R17, SCANBUFFERPTR+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0811
        CLR        R16
        RJMP       M_VERGL_0812
M_VERGL_0811:
        SER        R16
M_VERGL_0812:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0808
        RJMP       M_IF_0809
M_IF_0808:
 
; Aufruf Funktion (READ_SCAN)
        CALL       READ_SCAN
 
; Zuweisung Ziel /  VAR (SCAN_ZEICHEN)
        STS        SCAN_ZEICHEN, R16
 
; Byte-Parameter(1) fuer PROCEDURE (SCAN_TO_KEY)
        LDS        R0, SCAN_ZEICHEN
 
; Aufruf PROCEDURE (SCAN_TO_KEY)
        CALL       SCAN_TO_KEY
 
; IF_THEN - Ende
M_IF_0809:
 
; Aufruf PROCEDURE (RX0_PUFFER_ABFRAGEN)
        CALL       RX0_PUFFER_ABFRAGEN
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0816
        CLR        R16
        RJMP       M_VERGL_0817
M_VERGL_0816:
        SER        R16
M_VERGL_0817:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0813
        RJMP       M_IF_0814
M_IF_0813:
 
; Aufruf PROCEDURE (Z80_RECEIVE)
        CALL       Z80_RECEIVE
 
; IF_THEN - Ende
M_IF_0814:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (MONITOR_VERSCHIEBEN)
        LDS        R16, MONITOR_VERSCHIEBEN
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (MONITOR_LEER)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0821
        CLR        R16
        RJMP       M_VERGL_0822
M_VERGL_0821:
        SER        R16
M_VERGL_0822:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0818
        RJMP       M_IF_0819
M_IF_0818:
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDS        R0, MONITOR_VERSCHIEBEN
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (MONITOR_LEER)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (MONITOR_VERSCHIEBEN)
        STS        MONITOR_VERSCHIEBEN, R16
 
; IF_THEN - Ende
M_IF_0819:
 
; LOOP - Ende
        RJMP       M_LOOP_0807
 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UDR1 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR1H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UBRR1L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; UCSR1A (V) BYTECONVAR
; UCSR1B (V) BYTECONVAR
; UCSR1C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; OCR3BL (V) BYTECONVAR
; OCR3BH (V) BYTECONVAR
; OCR3AH (V) BYTECONVAR
; OCR3AL (V) BYTECONVAR
; ICR3L (V) BYTECONVAR
; ICR3H (V) BYTECONVAR
; TCNT3L (V) BYTECONVAR
; TCNT3H (V) BYTECONVAR
; TCCR3C (V) BYTECONVAR
; TCCR3B (V) BYTECONVAR
; TCCR3A (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; TIMSK3 (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; PCMSK3 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; PRR1 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR3 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; RXC1 (B) BIT
; TXC1 (B) BIT
; UDRE1 (B) BIT
; TIMER0_AUS (P) 
; INIT_TIMER0_COMPA (P) 
; INIT_TIMER0_OVF (P) 
; TIMER1_AUS (P) 
; INIT_TIMER1_COMPA (P) 
; INIT_TIMER2_OVF (P) 
; ABTASTWERT (C) BYTE Wert=0x71
; TAKTFREQUENZ (C) WORD Wert=0x4E20
; UBRR_VAL_S0 (C) BYTE Wert=0x01
; UBRR_VAL_S1 (C) BYTE Wert=0x0A
; XON (C) BYTE Wert=0x11
; XOFF (C) BYTE Wert=0x13
; CHAR_NULL (C) CHAR Wert=0x00
; PA_CONST (C) BYTE Wert=0x01
; PA_CONIN (C) BYTE Wert=0x02
; PA_CONOUT (C) BYTE Wert=0x03
; PA_LIST (C) BYTE Wert=0x04
; PA_SOUND (C) BYTE Wert=0x05
; PA_WRITE (C) BYTE Wert=0x06
; PA_READ (C) BYTE Wert=0x07
; PA_STD (C) BYTE Wert=0x08
; PA_KOMMENTAR (C) BYTE Wert=0x09
; PA_DUMMY (C) BYTE Wert=0x0A
; PA_CPM_START (C) BYTE Wert=0x0B
; MONITOR_LEER (C) BYTE Wert=0x00
; MONITOR_LINKS (C) BYTE Wert=0x01
; MONITOR_RECHTS (C) BYTE Wert=0x02
; NO_LED_STATE (C) BYTE Wert=0x00
; LEDSCROLL (C) BYTE Wert=0x01
; LEDNUM (C) BYTE Wert=0x02
; LEDCAPS (C) BYTE Wert=0x04
; KEYSTAT_BYTE1 (C) BYTE Wert=0x01
; KEYSTAT_E0 (C) BYTE Wert=0x02
; KEYSTAT_F0 (C) BYTE Wert=0x03
; NO_SHIFTSTATE (C) BYTE Wert=0x00
; SHSHIFT (C) BYTE Wert=0x20
; SHCTRL (C) BYTE Wert=0x10
; SHALT (C) BYTE Wert=0x08
; SHCAPS (C) BYTE Wert=0x04
; SHNUM (C) BYTE Wert=0x02
; SHSCROLL (C) BYTE Wert=0x01
; CODETAB_NORMAL (A) 
; CODETAB_SHIFT (A) 
; CODETAB_CTRL (A) 
; CODETAB_ALT (A) 
; KBDNUM (C) BYTE Wert=0x77
; KBDCAPS (C) BYTE Wert=0x58
; KBDSCROLL (C) BYTE Wert=0x7E
; KBDALT (C) BYTE Wert=0x11
; KBDCTRL (C) BYTE Wert=0x14
; KBDLSHIFT (C) BYTE Wert=0x12
; KBDRSHIFT (C) BYTE Wert=0x59
; KBDENTER (C) BYTE Wert=0x5A
; KBDSPACE (C) BYTE Wert=0x29
; KBDBS (C) BYTE Wert=0x66
; KBDTAB (C) BYTE Wert=0x0D
; KBDESC (C) BYTE Wert=0x76
; KBDF1 (C) BYTE Wert=0x05
; KBDF2 (C) BYTE Wert=0x06
; KBDF3 (C) BYTE Wert=0x04
; KBDF4 (C) BYTE Wert=0x0C
; KBDF5 (C) BYTE Wert=0x03
; KBDF6 (C) BYTE Wert=0x0B
; KBDF7 (C) BYTE Wert=0x83
; KBDF8 (C) BYTE Wert=0x0A
; KBDF9 (C) BYTE Wert=0x01
; KBDF10 (C) BYTE Wert=0x09
; KBDF11 (C) BYTE Wert=0x78
; KBDF12 (C) BYTE Wert=0x07
; KBDRGUI (C) BYTE Wert=0x27
; KBDLGUI (C) BYTE Wert=0x1F
; KBDAPPS (C) BYTE Wert=0x2F
; KBDEND (C) BYTE Wert=0x69
; KBDHOME (C) BYTE Wert=0x6C
; KBDUP (C) BYTE Wert=0x75
; KBDDN (C) BYTE Wert=0x72
; KBDLEFT (C) BYTE Wert=0x6B
; KBDRIGHT (C) BYTE Wert=0x74
; KBDPGUP (C) BYTE Wert=0x7D
; KBDPGDN (C) BYTE Wert=0x7A
; KBDINSERT (C) BYTE Wert=0x70
; KBDDELETE (C) BYTE Wert=0x71
; KBDPRINT (C) BYTE Wert=0x12
; KBDPAUSE (C) BYTE Wert=0xE1
; SCANBREAK (C) BYTE Wert=0xF0
; SCANEXT (C) BYTE Wert=0xE0
; HSTSCROLL (C) BYTE Wert=0x00
; HSTPRINT (C) BYTE Wert=0x10
; HSTINS (C) BYTE Wert=0x16
; HSTHOME (C) BYTE Wert=0x00
; HSTPGUP (C) BYTE Wert=0x12
; HSTPGDN (C) BYTE Wert=0x03
; HSTDEL (C) BYTE Wert=0x08
; HSTEND (C) BYTE Wert=0x00
; HSTLEFT (C) BYTE Wert=0x13
; HSTRIGHT (C) BYTE Wert=0x04
; HSTUP (C) BYTE Wert=0x05
; HSTDN (C) BYTE Wert=0x18
; HSTRGUI (C) BYTE Wert=0x00
; HSTLGUI (C) BYTE Wert=0x00
; HSTAPPS (C) BYTE Wert=0x00
; HSTF1 (C) BYTE Wert=0x80
; HSTF2 (C) BYTE Wert=0x81
; HSTF3 (C) BYTE Wert=0x82
; HSTF4 (C) BYTE Wert=0x83
; HSTF5 (C) BYTE Wert=0x84
; HSTF6 (C) BYTE Wert=0x85
; HSTF7 (C) BYTE Wert=0x86
; HSTF8 (C) BYTE Wert=0x87
; HSTF9 (C) BYTE Wert=0x88
; HSTF10 (C) BYTE Wert=0x89
; HSTF11 (C) BYTE Wert=0x8A
; HSTF12 (C) BYTE Wert=0x8B
; PIPE_ORGAN_TAB (A) 
; SINTAB (A) 
; CPM_START_TAB_LAENGE (C) WORD Wert=0x7384
; CPM_START_TAB (A) 
; SUMMER (B) BIT
; LED (B) BIT
; KEY_CLK_A (B) BIT
; KEY_CLK_E (B) BIT
; KEY_CLK_D (B) BIT
; KEY_DAT_A (B) BIT
; KEY_DAT_E (B) BIT
; KEY_DAT_D (B) BIT
; STEUER_STRING (V) STRING
; TEXT_STRING (V) STRING
; SEKTOR_PUFFER (Y) BYTE
; SEKTOR_PUFFER_ZEIGER (V) WORD
; SECTOR (V) BYTE
; TRACK_L (V) BYTE
; TRACK_H (V) BYTE
; DISKNO (V) BYTE
; DATUM_GESETZT (V) BOOLEAN
; ANZEIGE_STRING (V) STRING
; BITCNTR (V) BYTE
; KEYBSTATE (V) BYTE
; LEDSTATE (V) BYTE
; LOCALBYTE (V) BYTE
; KBSHIFTSTATE (V) BYTE
; TMPBYTE (V) BYTE
; CAPS_PRESSED (V) BOOLEAN
; NUM_PRESSED (V) BOOLEAN
; SCROLL_PRESSED (V) BOOLEAN
; DOCLICK (V) BOOLEAN
; INITFAILED (V) BOOLEAN
; LOCALMODE (V) BOOLEAN
; CH (V) CHAR
; SCANBUFFER (Y) BYTE
; SCANBUFFERPTR (V) WORD
; KEYBUFFER (Y) BYTE
; KEYBUFFERPTR (V) WORD
; SCAN_ZEICHEN (V) BYTE
; TX_WARTEN (V) BOOLEAN
; TASTATUR_ZEICHEN (V) BYTE
; SOUND_BYTE (V) BYTE
; ABTAST_WERT_T1 (V) WORD
; WERT_YL (V) BYTE
; WERT_YH (V) BYTE
; ZAEHLER_T1 (V) WORD
; MONITOR_VERSCHIEBEN (V) BYTE
; WAITKON (C) WORD Wert=0x0014
; WAITKON2 (C) WORD Wert=0x0384
; WRITE_STRING (V) STRING
; BYTEPOSTOORMASKE (F) 
; BYTEPOSTOANDMASKE (F) 
; READ_BIT_IN_BYTE (F) 
; SET_BIT_IN_BYTE (F) 
; CLEAR_BIT_IN_BYTE (F) 
; NEGATION_BYTE (F) 
; WAIT_MS (P) 
; BYTETOSTRING (P) 
; STRINGTOBYTE (F) 
; SER0_ZEICHEN (V) BYTE
; SER1_ZEICHEN (V) BYTE
; INIT_SER0_PORT (P) 
; INIT_SER1_PORT (P) 
; RX0_PUFFER_ABFRAGEN (P) 
; RX1_PUFFER_ABFRAGEN (P) 
; SENDE_ZEICHEN0 (P) 
; SENDE_ZEICHEN1 (P) 
; WRITE_SER1 (P) 
; WRITELN_SER1 (P) 
; INITPORTS (P) 
; INIT_INT2 (P) 
; TON_SIRENE (P) 
; CLICK (P) 
; TON_FEHLER (P) 
; WRITE_SCAN (P) 
; READ_SCAN (F) 
; READ_KEY (F) 
; WRITE_KEY (P) 
; WRITE_C_KEY (P) 
; WRITE_TEXT (P) 
; SENDKEY (P) 
; SENDKEYCHAR (P) 
; INITKEYB (P) 
; SET_KBD_CLK (P) 
; RESET_KBD_CLK (P) 
; NOT_PARITY (F) 
; SENDTOKBD (P) 
; SET_KBD_STATE (P) 
; KBDRESET (P) 
; START_KEYBOARD (P) 
; SETZE_BIT_IN_KBSHIFTSTATE (P) 
; LOESCHE_BIT_IN_KBSHIFTSTATE (P) 
; SETZE_BIT_IN_LEDSTATE (P) 
; LOESCHE_BIT_IN_LEDSTATE (P) 
; SCAN_TO_KEY (P) 
; STEUER_STRING_TO_SECTOR (P) 
; STEUER_STRING_TO_SECTOR_KOMP (P) 
; STEUER_STRING_TO_TIME (P) 
; STEUER_STRING_AUSWERTEN (P) 
; STEUER_STRING_LESEN (P) 
; SEKTOR_VON_PC_LESEN (P) 
; SEKTOR_VON_PC_LESEN_KOMP (P) 
; SEKTOR_AN_PC_SENDEN (P) 
; WARTE_KURZ (P) 
; Z80_RECEIVE_BYTE (P) 
; Z80_RECEIVE_WRITE (P) 
; Z80_RECEIVE_READ (P) 
; STD_AN_PC_SENDEN (P) 
; Z80_RECEIVE_STD (P) 
; Z80_RECEIVE_CONST (P) 
; Z80_RECEIVE_CONIN (P) 
; Z80_RECEIVE_KOMMENTAR (P) 
; Z80_RECEIVE_CPM_START (P) 
; Z80_RECEIVE (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE TIMER0_AUS;
; PROCEDURE INIT_TIMER0_COMPA (WERT : BYTE);
; PROCEDURE INIT_TIMER0_OVF;
; PROCEDURE TIMER1_AUS;
; PROCEDURE INIT_TIMER1_COMPA (WERT : WORD) (B_WERT_L : BYTE) (B_WERT_H : BYTE);
; PROCEDURE INIT_TIMER2_OVF;
; FUNCTION BYTEPOSTOORMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION BYTEPOSTOANDMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION READ_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (VERGLEICH : BYTE) (MASKE : BYTE) : BOOLEAN;
; FUNCTION SET_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION CLEAR_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION NEGATION_BYTE (DAS_BYTE : BYTE) : BYTE;
; PROCEDURE WAIT_MS (ZEIT : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE BYTETOSTRING (WERT_BYTE : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE) (C1 : CHAR);
; FUNCTION STRINGTOBYTE (HEXLOW : BYTE) (HEXHIGH : BYTE) (S2B : BYTE) (C1 : CHAR) : BYTE;
; PROCEDURE INIT_SER0_PORT;
; PROCEDURE INIT_SER1_PORT;
; PROCEDURE RX0_PUFFER_ABFRAGEN;
; PROCEDURE RX1_PUFFER_ABFRAGEN;
; PROCEDURE SENDE_ZEICHEN0 (S_ZEICHEN0 : BYTE);
; PROCEDURE SENDE_ZEICHEN1 (S_ZEICHEN1 : BYTE);
; PROCEDURE WRITE_SER1 (C1 : CHAR) (LAENGE : BYTE) (B1 : BYTE) (B2 : BYTE);
; PROCEDURE WRITELN_SER1;
; PROCEDURE INITPORTS;
; PROCEDURE INIT_INT2;
; PROCEDURE TON_SIRENE (DAUER : WORD) (FREQUENZ : WORD);
; PROCEDURE CLICK;
; PROCEDURE TON_FEHLER;
; PROCEDURE WRITE_SCAN (WRITE_SCAN_VALUE : BYTE);
; FUNCTION READ_SCAN (READ_SCAN_VALUE : BYTE) (SCAN_COUNTER : WORD) (B1 : BYTE) : BYTE;
; FUNCTION READ_KEY (READ_KEY_VALUE : BYTE) (KEY_COUNTER : WORD) (B1 : BYTE) : BYTE;
; PROCEDURE WRITE_KEY (WRITE_KEY_VALUE : BYTE);
; PROCEDURE WRITE_C_KEY (CKEY : CHAR) (B1 : BYTE);
; PROCEDURE WRITE_TEXT (ZAEHLER : BYTE) (C1 : CHAR);
; PROCEDURE SENDKEY (SKEY : BYTE) (C1 : CHAR) (B1 : BYTE);
; PROCEDURE SENDKEYCHAR (SKEY : CHAR) (B1 : BYTE);
; PROCEDURE INITKEYB;
; PROCEDURE SET_KBD_CLK;
; PROCEDURE RESET_KBD_CLK;
; FUNCTION NOT_PARITY (DAS_BYTE : BYTE) (ERGEBNIS : BOOLEAN) (B2 : BYTE) (B3 : BYTE) (B4 : BYTE) : BOOLEAN;
; PROCEDURE SENDTOKBD (B1 : BYTE) (P : BOOLEAN) (W : WORD) (CNT : BYTE) (REG : BYTE) (TEST : BYTE);
; PROCEDURE SET_KBD_STATE;
; PROCEDURE KBDRESET (WARTEN_AUF_TASTATUR : BOOLEAN);
; PROCEDURE START_KEYBOARD;
; PROCEDURE SETZE_BIT_IN_KBSHIFTSTATE (SHIFT_TASTE : BYTE);
; PROCEDURE LOESCHE_BIT_IN_KBSHIFTSTATE (SHIFT_TASTE : BYTE) (B1 : BYTE);
; PROCEDURE SETZE_BIT_IN_LEDSTATE (STATE_LED : BYTE);
; PROCEDURE LOESCHE_BIT_IN_LEDSTATE (STATE_LED : BYTE) (B1 : BYTE);
; PROCEDURE SCAN_TO_KEY (CURSCAN : BYTE) (B1 : BYTE) (CURSCAN_WORD : WORD);
; PROCEDURE STEUER_STRING_TO_SECTOR (B1 : BYTE) (B2 : BYTE) (B3 : BYTE) (C1 : CHAR);
; PROCEDURE STEUER_STRING_TO_SECTOR_KOMP (X2 : BYTE) (DB7 : BYTE) (DB8 : BYTE) (BITPOS_DB8 : BYTE) (BITPOS_DB7 : BYTE) (C1 : CHAR) (POS_SS : BYTE) (EIN_BIT : BOOLEAN);
; PROCEDURE STEUER_STRING_TO_TIME (B1 : BYTE) (B2 : BYTE) (C1 : CHAR);
; PROCEDURE STEUER_STRING_AUSWERTEN (BUCHSTABE : CHAR) (ZEICHEN_1 : CHAR) (ZEICHEN_2 : CHAR) (LAENGE : BYTE);
; PROCEDURE STEUER_STRING_LESEN (AKT_ZEICHEN : CHAR) (EMPF_ZEICHEN : BYTE);
; PROCEDURE SEKTOR_VON_PC_LESEN (B1 : BYTE) (B2 : BYTE) (SPZ : WORD) (LESESCHLEIFE : WORD);
; PROCEDURE SEKTOR_VON_PC_LESEN_KOMP (B1 : BYTE) (B2 : BYTE) (SPZ : WORD) (LESESCHLEIFE : WORD);
; PROCEDURE SEKTOR_AN_PC_SENDEN (B1 : BYTE) (B2 : BYTE) (B3 : BYTE);
; PROCEDURE WARTE_KURZ;
; PROCEDURE Z80_RECEIVE_BYTE;
; PROCEDURE Z80_RECEIVE_WRITE;
; PROCEDURE Z80_RECEIVE_READ (B1 : BYTE);
; PROCEDURE STD_AN_PC_SENDEN;
; PROCEDURE Z80_RECEIVE_STD;
; PROCEDURE Z80_RECEIVE_CONST (RECEIVE_MESSAGE : BYTE);
; PROCEDURE Z80_RECEIVE_CONIN (RECEIVE_MESSAGE : BYTE);
; PROCEDURE Z80_RECEIVE_KOMMENTAR (LAENGE : BYTE) (LAENGE_WORD : WORD) (B1 : BYTE) (C1 : CHAR);
; PROCEDURE Z80_RECEIVE_CPM_START;
; PROCEDURE Z80_RECEIVE;
 
; *** Konstanten-ARRAYs ***
;
 
CODETAB_NORMAL:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    '^',0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'q'
.db    '1',0x00
.db    0x00,0x00
.db    'y','s'
.db    'a','w'
.db    '2',0x00
.db    0x00,'c'
.db    'x','d'
.db    'e','4'
.db    '3',0x00
.db    0x00,' '
.db    'v','f'
.db    't','r'
.db    '5',0x00
.db    0x00,'n'
.db    'b','h'
.db    'g','z'
.db    '6',0x00
.db    0x00,0x00
.db    'm','j'
.db    'u','7'
.db    '8',0x00
.db    0x00,','
.db    'k','i'
.db    'o','0'
.db    '9',0x00
.db    0x00,'.'
.db    '-','l'
.db    'o','p'
.db    0x5C,0x00
.db    0x00,0x00
.db    'a',0x00
.db    'u',0x27
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,'+'
.db    0x00,'#'
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
CODETAB_SHIFT:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    '^',0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'Q'
.db    '!',0x00
.db    0x00,0x00
.db    'Y','S'
.db    'A','W'
.db    '"',0x00
.db    0x00,'C'
.db    'X','D'
.db    'E','$'
.db    '#',0x00
.db    0x00,' '
.db    'V','F'
.db    'T','R'
.db    '%',0x00
.db    0x00,'N'
.db    'B','H'
.db    'G','Z'
.db    '&',0x00
.db    0x00,0x00
.db    'M','J'
.db    'U','/'
.db    '(',0x00
.db    0x00,';'
.db    'K','I'
.db    'O','='
.db    ')',0x00
.db    0x00,':'
.db    '_','L'
.db    'O','P'
.db    '?',0x00
.db    0x00,0x00
.db    'A',0x00
.db    'U',0x60
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,'*'
.db    0x00,0x27
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
CODETAB_CTRL:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    0x1E,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x11
.db    0x00,0x00
.db    0x00,0x00
.db    0x19,0x13
.db    0x01,0x17
.db    0x00,0x00
.db    0x00,0x03
.db    0x18,0x04
.db    0x05,0x00
.db    0x00,0x00
.db    0x00,' '
.db    0x16,0x06
.db    0x14,0x12
.db    0x00,0x00
.db    0x00,0x0E
.db    0x02,0x08
.db    0x07,0x1A
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,0x0A
.db    0x15,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x0B,0x09
.db    0x0F,0x00
.db    0x1D,0x00
.db    0x00,0x00
.db    0x00,0x0C
.db    0x0F,0x10
.db    0x1C,0x00
.db    0x00,0x00
.db    0x01,0x00
.db    0x15,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
CODETAB_ALT:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x09
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'@'
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x24,0x00
.db    '#',0x00
.db    0x00,' '
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'{'
.db    '[',0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,'}'
.db    ']',0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x5C,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x0D,'~'
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x1B,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
PIPE_ORGAN_TAB:
.db    0x81,0x6E
.db    0x5C,0x4B
.db    0x3A,0x2E
.db    0x2C,0x30
.db    0x36,0x3C
.db    0x41,0x43
.db    0x42,0x3E
.db    0x30,0x20
.db    0x11,0x07
.db    0x02,0x04
.db    0x0C,0x19
.db    0x2C,0x43
.db    0x58,0x68
.db    0x75,0x7E
.db    0x84,0x85
.db    0x80,0x78
.db    0x6F,0x67
.db    0x61,0x5C
.db    0x59,0x5B
.db    0x65,0x75
.db    0x87,0x96
.db    0xA4,0xAD
.db    0xB4,0xB4
.db    0xAA,0x9E
.db    0x94,0x8E
.db    0x8C,0x91
.db    0x9C,0xAB
.db    0xBF,0xD6
.db    0xE8,0xF4
.db    0xFC,0xFF
.db    0xFF,0xFB
.db    0xED,0xDC
.db    0xCB,0xBA
.db    0xAA,0x9C
.db    0x8F,0x88
.db    0x8C,0x92
.db    0x99,0xA0
.db    0xA4,0xA5
.db    0xA2,0x98
.db    0x88,0x75
.db    0x66,0x5B
.db    0x57,0x59
.db    0x5F,0x6D
.db    0x7F,0x93
.db    0xA2,0xAC
.db    0xB1,0xB4
.db    0xB2,0xAB
.db    0x9D,0x8D
.db    0x7F,0x71
.db    0x66,0x5B
.db    0x54,0x55
.db    0x5E,0x6A
.db    0x76,0x81
.db    0x8A,0x8F
.db    0x8F,0x8A
.db    0x7B,0x6E
.db    0x63,0x5D
.db    0x5C,0x60
.db    0x6A,0x79
.db    0x8D,0xA0
.db    0xAC,0xB5
.db    0xB8,0xB8
.db    0xB3,0xA8
.db    0x96,0x82
 
SINTAB:
.db    0x80,0x86
.db    0x8C,0x91
.db    0x97,0x9D
.db    0xA3,0xA9
.db    0xAE,0xB4
.db    0xB9,0xBE
.db    0xC4,0xC8
.db    0xCD,0xD2
.db    0xD6,0xDA
.db    0xDE,0xE2
.db    0xE5,0xE9
.db    0xEC,0xEE
.db    0xF1,0xF3
.db    0xF5,0xF6
.db    0xF8,0xF9
.db    0xF9,0xFA
.db    0xFA,0xFA
.db    0xF9,0xF9
.db    0xF8,0xF6
.db    0xF5,0xF3
.db    0xF1,0xEE
.db    0xEC,0xE9
.db    0xE5,0xE2
.db    0xDE,0xDA
.db    0xD6,0xD2
.db    0xCD,0xC8
.db    0xC4,0xBE
.db    0xB9,0xB4
.db    0xAE,0xA9
.db    0xA3,0x9D
.db    0x97,0x91
.db    0x8C,0x86
.db    0x80,0x79
.db    0x73,0x6E
.db    0x68,0x62
.db    0x5C,0x56
.db    0x51,0x4B
.db    0x46,0x41
.db    0x3B,0x37
.db    0x32,0x2D
.db    0x29,0x25
.db    0x21,0x1D
.db    0x1A,0x16
.db    0x13,0x11
.db    0x0E,0x0C
.db    0x0A,0x09
.db    0x07,0x06
.db    0x06,0x05
.db    0x05,0x05
.db    0x06,0x06
.db    0x07,0x09
.db    0x0A,0x0C
.db    0x0E,0x11
.db    0x13,0x16
.db    0x1A,0x1D
.db    0x21,0x25
.db    0x29,0x2D
.db    0x32,0x37
.db    0x3B,0x41
.db    0x46,0x4B
.db    0x51,0x56
.db    0x5C,0x62
.db    0x68,0x6E
.db    0x73,0x79
 
CPM_START_TAB:
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x81,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7E,0x7E
.db    0x80,0x81
.db    0x7F,0x7F
.db    0x7D,0x81
.db    0x7D,0x80
.db    0x7D,0x81
.db    0x7F,0x7F
.db    0x7F,0x7E
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x81,0x7F
.db    0x7A,0x7F
.db    0x80,0x81
.db    0x80,0x7F
.db    0x7F,0x7E
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7E,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7E,0x7F
.db    0x7F,0x7E
.db    0x7F,0x7E
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7E,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x81
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7E
.db    0x7F,0x7F
.db    0x7F,0x7E
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x80,0x7F
.db    0x80,0x7F
.db    0x7F,0x7E
.db    0x80,0x7E
.db    0x80,0x7F
.db    0x80,0x7C
.db    0x82,0x7F
.db    0x80,0x7F
.db    0x7C,0x83
.db    0x7E,0x7E
.db    0x80,0x7E
.db    0x81,0x7E
.db    0x7E,0x80
.db    0x80,0x7B
.db    0x81,0x7C
.db    0x85,0x7D
.db    0x7F,0x7F
.db    0x7F,0x7E
.db    0x80,0x7F
.db    0x80,0x7F
.db    0x7D,0x80
.db    0x7F,0x7F
.db    0x7F,0x82
.db    0x7B,0x80
.db    0x7D,0x81
.db    0x80,0x7E
.db    0x7F,0x7D
.db    0x80,0x7E
.db    0x81,0x7D
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7E
.db    0x80,0x7F
.db    0x81,0x79
.db    0x82,0x7C
.db    0x81,0x7F
.db    0x7E,0x7F
.db    0x7C,0x86
.db    0x7D,0x82
.db    0x7A,0x7E
.db    0x84,0x7E
.db    0x80,0x7E
.db    0x80,0x7B
.db    0x82,0x7D
.db    0x83,0x7E
.db    0x7A,0x86
.db    0x7D,0x80
.db    0x7F,0x7C
.db    0x87,0x7D
.db    0x7C,0x82
.db    0x7C,0x85
.db    0x7B,0x7E
.db    0x86,0x7C
.db    0x7F,0x7E
.db    0x7D,0x83
.db    0x7E,0x7B
.db    0x84,0x7F
.db    0x7E,0x81
.db    0x7E,0x85
.db    0x7A,0x80
.db    0x7E,0x80
.db    0x7D,0x81
.db    0x80,0x7C
.db    0x80,0x7C
.db    0x80,0x7E
.db    0x82,0x7E
.db    0x7E,0x83
.db    0x7D,0x81
.db    0x7B,0x7D
.db    0x86,0x7D
.db    0x7C,0x82
.db    0x80,0x80
.db    0x7D,0x81
.db    0x7E,0x80
.db    0x7B,0x87
.db    0x7C,0x80
.db    0x7F,0x80
.db    0x80,0x7E
.db    0x7C,0x80
.db    0x81,0x81
.db    0x7A,0x7E
.db    0x83,0x7E
.db    0x85,0x76
.db    0x80,0x8B
.db    0x74,0x84
.db    0x75,0x83
.db    0x86,0x76
.db    0x84,0x71
.db    0x8A,0x7E
.db    0x82,0x7D
.db    0x72,0x8D
.db    0x7A,0x83
.db    0x7D,0x82
.db    0x74,0x84
.db    0x7E,0x81
.db    0x7F,0x81
.db    0x7D,0x7C
.db    0x87,0x7C
.db    0x86,0x76
.db    0x7D,0x8E
.db    0x76,0x7B
.db    0x85,0x7E
.db    0x80,0x81
.db    0x80,0x76
.db    0x83,0x7B
.db    0x87,0x7B
.db    0x85,0x78
.db    0x84,0x77
.db    0x82,0x82
.db    0x7A,0x7D
.db    0x8E,0x71
.db    0x79,0x8D
.db    0x78,0x8F
.db    0x6F,0x83
.db    0x7B,0x82
.db    0x82,0x76
.db    0x82,0x7E
.db    0x82,0x80
.db    0x72,0x89
.db    0x7D,0x83
.db    0x7B,0x88
.db    0x74,0x82
.db    0x7B,0x81
.db    0x89,0x73
.db    0x84,0x6C
.db    0x8C,0x74
.db    0x95,0x77
.db    0x84,0x75
.db    0x7C,0x8C
.db    0x76,0x88
.db    0x72,0x82
.db    0x7A,0x86
.db    0x81,0x74
.db    0x85,0x76
.db    0x96,0x78
.db    0x72,0x89
.db    0x7B,0x8C
.db    0x76,0x8C
.db    0x65,0x87
.db    0x77,0x8D
.db    0x81,0x6A
.db    0x87,0x78
.db    0x8B,0x78
.db    0x8B,0x73
.db    0x7E,0x8C
.db    0x79,0x80
.db    0x7E,0x7B
.db    0x8E,0x73
.db    0x84,0x70
.db    0x86,0x82
.db    0x7D,0x80
.db    0x7D,0x7D
.db    0x81,0x75
.db    0x7F,0x8E
.db    0x6D,0x7E
.db    0x88,0x7D
.db    0x87,0x6E
.db    0x84,0x80
.db    0x7B,0x7F
.db    0x85,0x7C
.db    0x79,0x8B
.db    0x7A,0x89
.db    0x72,0x7E
.db    0x87,0x7A
.db    0x8C,0x6E
.db    0x84,0x77
.db    0x88,0x82
.db    0x76,0x7E
.db    0x89,0x71
.db    0x83,0x81
.db    0x7B,0x83
.db    0x79,0x80
.db    0x7E,0x7C
.db    0x7D,0x87
.db    0x7C,0x7B
.db    0x86,0x7F
.db    0x77,0x88
.db    0x84,0x6D
.db    0x86,0x70
.db    0x97,0x79
.db    0x72,0x8B
.db    0x78,0x91
.db    0x73,0x82
.db    0x7D,0x7C
.db    0x81,0x7E
.db    0x77,0x94
.db    0x76,0x83
.db    0x7B,0x7D
.db    0x80,0x80
.db    0x84,0x72
.db    0x88,0x70
.db    0x92,0x81
.db    0x6B,0x86
.db    0x7E,0x85
.db    0x7E,0x71
.db    0x8D,0x80
.db    0x75,0x81
.db    0x7F,0x84
.db    0x7A,0x77
.db    0x8B,0x77
.db    0x7F,0x81
.db    0x7F,0x82
.db    0x82,0x6C
.db    0x8D,0x7E
.db    0x83,0x7A
.db    0x7A,0x85
.db    0x77,0x97
.db    0x70,0x85
.db    0x69,0x85
.db    0x8A,0x79
.db    0x84,0x69
.db    0x8C,0x78
.db    0x84,0x7F
.db    0x76,0x86
.db    0x80,0x77
.db    0x82,0x7B
.db    0x87,0x79
.db    0x80,0x81
.db    0x80,0x82
.db    0x7B,0x78
.db    0x8D,0x78
.db    0x81,0x86
.db    0x72,0x97
.db    0x76,0x7C
.db    0x81,0x7D
.db    0x7E,0x81
.db    0x81,0x77
.db    0x82,0x82
.db    0x7A,0x80
.db    0x7B,0x80
.db    0x80,0x80
.db    0x80,0x7A
.db    0x82,0x7C
.db    0x86,0x78
.db    0x76,0xA1
.db    0x6F,0x83
.db    0x77,0x7A
.db    0x93,0x78
.db    0x84,0x6F
.db    0x84,0x82
.db    0x86,0x76
.db    0x88,0x7C
.db    0x68,0x9C
.db    0x75,0x94
.db    0x63,0x82
.db    0x80,0x81
.db    0x87,0x74
.db    0x85,0x66
.db    0x93,0x74
.db    0x97,0x76
.db    0x78,0x85
.db    0x76,0x9A
.db    0x6B,0x80
.db    0x7B,0x83
.db    0x85,0x75
.db    0x82,0x73
.db    0x87,0x80
.db    0x85,0x7D
.db    0x6E,0x8F
.db    0x74,0x96
.db    0x75,0x81
.db    0x70,0x7E
.db    0x90,0x77
.db    0x7F,0x7E
.db    0x7F,0x80
.db    0x75,0x7F
.db    0x90,0x75
.db    0x81,0x77
.db    0x84,0x7D
.db    0x80,0x85
.db    0x75,0x80
.db    0x7B,0x8F
.db    0x78,0x83
.db    0x76,0x83
.db    0x84,0x7A
.db    0x83,0x81
.db    0x7F,0x80
.db    0x76,0x7D
.db    0x94,0x70
.db    0x83,0x6D
.db    0x86,0x8E
.db    0x6E,0x8A
.db    0x6E,0x84
.db    0x83,0x79
.db    0x7D,0x8A
.db    0x76,0x82
.db    0x77,0x82
.db    0x83,0x76
.db    0x77,0xA7
.db    0x64,0x8A
.db    0x61,0x88
.db    0x7B,0x8C
.db    0x7B,0x89
.db    0x73,0x76
.db    0x89,0x7B
.db    0x88,0x78
.db    0x85,0x75
.db    0x84,0x80
.db    0x75,0x88
.db    0x72,0x88
.db    0x7C,0x88
.db    0x74,0x7E
.db    0x82,0x79
.db    0x91,0x71
.db    0x7F,0x7B
.db    0x80,0x80
.db    0x88,0x78
.db    0x86,0x78
.db    0x74,0x9A
.db    0x74,0x87
.db    0x68,0x80
.db    0x91,0x73
.db    0x84,0x78
.db    0x83,0x72
.db    0x8E,0x78
.db    0x80,0x7D
.db    0x77,0x95
.db    0x7B,0x7F
.db    0x74,0x8A
.db    0x63,0x8A
.db    0x81,0x7B
.db    0x81,0x69
.db    0x91,0x7C
.db    0x77,0x84
.db    0x88,0x77
.db    0x78,0x81
.db    0x7F,0x80
.db    0x6D,0x83
.db    0x8D,0x71
.db    0x88,0x6A
.db    0x8C,0x79
.db    0x80,0x83
.db    0x6F,0x92
.db    0x7B,0x81
.db    0x78,0x7F
.db    0x7E,0x7A
.db    0x85,0x7A
.db    0x80,0x7D
.db    0x80,0x7C
.db    0x7C,0x7C
.db    0x8D,0x77
.db    0x7F,0x8C
.db    0x79,0x81
.db    0x6A,0x88
.db    0x82,0x80
.db    0x7D,0x7E
.db    0x80,0x7D
.db    0x85,0x7D
.db    0x67,0x93
.db    0x83,0x67
.db    0x88,0x71
.db    0x91,0x7A
.db    0x72,0x8B
.db    0x7B,0x7C
.db    0x82,0x84
.db    0x7A,0x7D
.db    0x7E,0x7B
.db    0x84,0x7A
.db    0x86,0x8B
.db    0x71,0x7D
.db    0x87,0x79
.db    0x8A,0x6C
.db    0x7C,0x9D
.db    0x67,0x81
.db    0x82,0x78
.db    0x9B,0x51
.db    0x83,0x9A
.db    0x6D,0x7E
.db    0x7F,0x80
.db    0x8C,0x68
.db    0x83,0x87
.db    0x7D,0x80
.db    0x71,0x88
.db    0x80,0x84
.db    0x7E,0x67
.db    0x90,0x86
.db    0x69,0x84
.db    0x86,0x7B
.db    0x8A,0x4B
.db    0x97,0x7C
.db    0x7E,0x7D
.db    0x81,0x80
.db    0x82,0x6E
.db    0x86,0x88
.db    0x6D,0x80
.db    0x79,0x87
.db    0x7F,0x7A
.db    0x85,0x73
.db    0x79,0x7F
.db    0x91,0x74
.db    0x7B,0x90
.db    0x75,0x8E
.db    0x6A,0x83
.db    0x86,0x7D
.db    0x78,0x8E
.db    0x82,0x58
.db    0x9C,0x88
.db    0x5F,0x87
.db    0x69,0xAC
.db    0x74,0x6B
.db    0x92,0x7D
.db    0x64,0x8E
.db    0x7F,0x88
.db    0x7C,0x6E
.db    0x8B,0x6A
.db    0x9F,0x79
.db    0x88,0x70
.db    0x83,0x79
.db    0x82,0x81
.db    0x86,0x82
.db    0x6F,0x87
.db    0x79,0x7E
.db    0x88,0x83
.db    0x7F,0x7B
.db    0x74,0x8D
.db    0x75,0x8D
.db    0x72,0x78
.db    0x9A,0x74
.db    0x89,0x77
.db    0x79,0x7F
.db    0x86,0x87
.db    0x6B,0x87
.db    0x6E,0x8C
.db    0x88,0x4B
.db    0x93,0x84
.db    0x76,0x7F
.db    0x7F,0x84
.db    0x7C,0x81
.db    0x7E,0x7C
.db    0x7C,0x80
.db    0x85,0x81
.db    0x7A,0x84
.db    0x80,0x71
.db    0x95,0x77
.db    0x7B,0x80
.db    0x78,0x8B
.db    0x7B,0x82
.db    0x7B,0x8A
.db    0x6E,0x84
.db    0x7C,0x87
.db    0x87,0x5C
.db    0x9B,0x7D
.db    0x77,0x7D
.db    0x73,0x97
.db    0x75,0x92
.db    0x71,0x7C
.db    0x71,0x8A
.db    0x8F,0x61
.db    0x88,0x75
.db    0x86,0x73
.db    0xA9,0x6C
.db    0x8A,0x68
.db    0x77,0x9F
.db    0x71,0x8B
.db    0x69,0x88
.db    0x6B,0x95
.db    0x7C,0x6A
.db    0x8A,0x7B
.db    0x84,0x74
.db    0x97,0x65
.db    0x84,0x79
.db    0x82,0x92
.db    0x6B,0x7F
.db    0x66,0x92
.db    0x73,0xA2
.db    0x6D,0x72
.db    0x89,0x74
.db    0x9C,0x6B
.db    0x8D,0x57
.db    0x8A,0x86
.db    0x7E,0x82
.db    0x6C,0x82
.db    0x7C,0x84
.db    0x7A,0x85
.db    0x79,0x7C
.db    0x85,0x79
.db    0x8A,0x70
.db    0x82,0x70
.db    0x92,0x7A
.db    0x7E,0x82
.db    0x74,0x88
.db    0x79,0x8A
.db    0x77,0x7C
.db    0x79,0x89
.db    0x85,0x6A
.db    0x85,0x74
.db    0x88,0x84
.db    0x81,0x75
.db    0x88,0x69
.db    0x7C,0x91
.db    0x7A,0x93
.db    0x44,0x8E
.db    0x82,0x82
.db    0x7D,0x76
.db    0x7D,0x82
.db    0x85,0x76
.db    0x80,0x88
.db    0x7F,0x70
.db    0x88,0x7D
.db    0x7B,0x7F
.db    0x7C,0x8B
.db    0x73,0x83
.db    0x82,0x7B
.db    0x7D,0x7C
.db    0x7E,0x81
.db    0x79,0x8C
.db    0x80,0x6C
.db    0xA7,0x6E
.db    0x84,0x78
.db    0x76,0x90
.db    0x79,0x81
.db    0x73,0x78
.db    0x99,0x76
.db    0x79,0x79
.db    0x82,0x8C
.db    0x6C,0x78
.db    0x8C,0x78
.db    0x7A,0x85
.db    0x81,0x86
.db    0x7D,0x84
.db    0x5F,0x89
.db    0x7E,0x81
.db    0x85,0x7A
.db    0x7E,0x81
.db    0x73,0x83
.db    0x8C,0x69
.db    0x87,0x68
.db    0x86,0x70
.db    0xA5,0x70
.db    0x7A,0x8B
.db    0x73,0x89
.db    0x7F,0x8B
.db    0x71,0x82
.db    0x6C,0x8D
.db    0x80,0x6D
.db    0x8B,0x80
.db    0x73,0x7F
.db    0x80,0x87
.db    0x74,0x86
.db    0x82,0x7F
.db    0x6F,0x84
.db    0x7E,0x83
.db    0x7B,0x8D
.db    0x74,0x78
.db    0x8A,0x77
.db    0x8D,0x74
.db    0x7A,0x97
.db    0x78,0x85
.db    0x6C,0x7B
.db    0x98,0x66
.db    0x80,0x81
.db    0x7C,0x79
.db    0x85,0x76
.db    0x87,0x82
.db    0x7C,0x81
.db    0x80,0x62
.db    0x93,0x83
.db    0x71,0x87
.db    0x78,0x87
.db    0x7C,0x78
.db    0x8C,0x85
.db    0x64,0x89
.db    0x71,0x8F
.db    0x80,0x6F
.db    0x81,0x7C
.db    0x85,0x78
.db    0x8D,0x6D
.db    0x80,0x7D
.db    0x80,0x82
.db    0x7C,0x82
.db    0x7A,0x81
.db    0x89,0x76
.db    0x82,0x6E
.db    0x88,0x80
.db    0x75,0x8A
.db    0x84,0x65
.db    0x88,0x7B
.db    0x8E,0x82
.db    0x66,0x9A
.db    0x72,0x89
.db    0x76,0x78
.db    0x89,0x83
.db    0x8E,0x5D
.db    0x7F,0x92
.db    0x79,0x83
.db    0x7C,0x8A
.db    0x6C,0x78
.db    0x74,0xA4
.db    0x74,0x74
.db    0x8B,0x79
.db    0x80,0x7C
.db    0x82,0x77
.db    0x7E,0x7E
.db    0x90,0x76
.db    0x7A,0x82
.db    0x80,0x78
.db    0x81,0x77
.db    0x84,0x78
.db    0x88,0x79
.db    0x70,0x91
.db    0x7F,0x7F
.db    0x7F,0x7E
.db    0x75,0x88
.db    0x78,0x84
.db    0x79,0x95
.db    0x7A,0x7F
.db    0x6A,0x86
.db    0x82,0x7C
.db    0x82,0x79
.db    0x79,0x73
.db    0x9A,0x80
.db    0x75,0x84
.db    0x78,0x90
.db    0x73,0x78
.db    0x8A,0x80
.db    0x82,0x7C
.db    0x81,0x7C
.db    0x80,0x7C
.db    0x8A,0x7A
.db    0x8B,0x6E
.db    0x7D,0x8C
.db    0x79,0x88
.db    0x7C,0x79
.db    0x86,0x7B
.db    0x84,0x80
.db    0x7C,0x8A
.db    0x7A,0x84
.db    0x78,0x75
.db    0x8A,0x68
.db    0x88,0x92
.db    0x64,0x86
.db    0x60,0x92
.db    0x85,0x85
.db    0x7D,0x68
.db    0x90,0x70
.db    0x96,0x72
.db    0x89,0x83
.db    0x7A,0x71
.db    0x86,0x7B
.db    0x88,0x7F
.db    0x6E,0x98
.db    0x7C,0x6C
.db    0x88,0x7F
.db    0x83,0x79
.db    0x7F,0x81
.db    0x80,0x67
.db    0x8A,0x82
.db    0x75,0x7B
.db    0x8E,0x6F
.db    0x90,0x62
.db    0x83,0x8F
.db    0x53,0x91
.db    0x6E,0x8B
.db    0x7E,0x79
.db    0x81,0x79
.db    0x7C,0x8D
.db    0x71,0x84
.db    0x79,0x91
.db    0x7B,0x70
.db    0x90,0x79
.db    0x7A,0x89
.db    0x6F,0x9A
.db    0x77,0x6F
.db    0x9D,0x75
.db    0x7D,0x81
.db    0x72,0x94
.db    0x76,0x6E
.db    0x95,0x77
.db    0x73,0x94
.db    0x6D,0x98
.db    0x75,0x86
.db    0x72,0x7E
.db    0x85,0x7E
.db    0x7C,0x85
.db    0x80,0x77
.db    0x88,0x77
.db    0x81,0x83
.db    0x73,0x96
.db    0x77,0x71
.db    0x8C,0x77
.db    0x84,0x81
.db    0x81,0x83
.db    0x7E,0x6E
.db    0x8B,0x83
.db    0x6F,0x77
.db    0x9A,0x5D
.db    0x82,0x7A
.db    0x81,0x89
.db    0x6B,0x83
.db    0x92,0x61
.db    0x83,0x75
.db    0x88,0x83
.db    0x7F,0x7F
.db    0x6E,0x88
.db    0x7D,0x83
.db    0x7C,0x87
.db    0x66,0x8C
.db    0x61,0x9F
.db    0x7F,0x69
.db    0x82,0x7F
.db    0x8F,0x79
.db    0x87,0x78
.db    0x7B,0x72
.db    0x87,0x81
.db    0x7F,0x78
.db    0x8B,0x71
.db    0x78,0x93
.db    0x71,0x77
.db    0x95,0x79
.db    0x8C,0x73
.db    0x7E,0x79
.db    0x8C,0x6F
.db    0x83,0x84
.db    0x69,0x81
.db    0x7E,0x7A
.db    0x7A,0x8D
.db    0x75,0x86
.db    0x6D,0x87
.db    0x85,0x6F
.db    0x7D,0x80
.db    0x8A,0x7D
.db    0x91,0x71
.db    0x7A,0x90
.db    0x76,0x8D
.db    0x79,0x88
.db    0x75,0x77
.db    0x89,0x79
.db    0x84,0x74
.db    0x80,0x8E
.db    0x64,0x87
.db    0x84,0x78
.db    0x83,0x69
.db    0x86,0x86
.db    0x70,0x83
.db    0x77,0x7F
.db    0x7B,0x83
.db    0x84,0x85
.db    0x74,0x7C
.db    0x8B,0x7B
.db    0x76,0x8C
.db    0x82,0x81
.db    0x8B,0x6E
.db    0x9D,0x63
.db    0x7C,0x8A
.db    0x7F,0x90
.db    0x5F,0x89
.db    0x72,0x85
.db    0x77,0x8E
.db    0x7E,0x82
.db    0x6A,0x86
.db    0x88,0x6F
.db    0x8D,0x64
.db    0x87,0x8B
.db    0x6D,0x87
.db    0x61,0x8D
.db    0x80,0x74
.db    0x81,0x8A
.db    0x70,0x80
.db    0x7E,0x7E
.db    0x90,0x60
.db    0x87,0x7C
.db    0x7E,0x85
.db    0x58,0x8F
.db    0x86,0x75
.db    0x81,0x72
.db    0x89,0x80
.db    0x6F,0x81
.db    0x84,0x88
.db    0x89,0x6E
.db    0x81,0x75
.db    0x8A,0x7D
.db    0x6F,0x8E
.db    0x85,0x67
.db    0x8F,0x7C
.db    0x86,0x79
.db    0x79,0x93
.db    0x7E,0x6B
.db    0x8F,0x77
.db    0x81,0x81
.db    0x7D,0x82
.db    0x8E,0x7A
.db    0x6F,0x83
.db    0x7D,0x7A
.db    0x87,0x7E
.db    0x87,0x68
.db    0x83,0x8A
.db    0x71,0x7D
.db    0x88,0x84
.db    0x80,0x75
.db    0x84,0x74
.db    0x89,0x87
.db    0x76,0x78
.db    0x7C,0xA0
.db    0x72,0x7D
.db    0x75,0x85
.db    0x84,0x76
.db    0x72,0x8C
.db    0x7F,0x8C
.db    0x66,0x7F
.db    0x94,0x74
.db    0x81,0x81
.db    0x7F,0x7F
.db    0x7D,0x7F
.db    0x81,0x7D
.db    0x8A,0x75
.db    0x7C,0x8C
.db    0x80,0x80
.db    0x83,0x7A
.db    0x86,0x6B
.db    0x82,0x96
.db    0x72,0x8B
.db    0x6A,0x7A
.db    0x90,0x6F
.db    0x84,0x7A
.db    0x82,0x85
.db    0x6A,0x76
.db    0x95,0x78
.db    0x81,0x70
.db    0x8B,0x85
.db    0x6A,0x84
.db    0x70,0x8F
.db    0x83,0x71
.db    0x81,0x8A
.db    0x82,0x7D
.db    0x64,0x8F
.db    0x7A,0x85
.db    0x84,0x83
.db    0x7B,0x82
.db    0x73,0x7C
.db    0x86,0x71
.db    0x85,0x7C
.db    0x75,0x88
.db    0x6E,0x7E
.db    0x89,0x70
.db    0x8B,0x63
.db    0x8C,0x82
.db    0x6E,0x84
.db    0x75,0x8B
.db    0x7D,0x76
.db    0x82,0x7F
.db    0x77,0x80
.db    0x7C,0x83
.db    0x86,0x85
.db    0x64,0x80
.db    0x8B,0x7E
.db    0x85,0x6A
.db    0x8F,0x78
.db    0x79,0x80
.db    0x93,0x78
.db    0x75,0x8C
.db    0x7D,0x77
.db    0x89,0x6B
.db    0x9D,0x7E
.db    0x72,0x91
.db    0x70,0x93
.db    0x84,0x62
.db    0x9A,0x82
.db    0x70,0x8C
.db    0x7B,0x78
.db    0x86,0x7B
.db    0x7E,0x8C
.db    0x54,0xAA
.db    0x79,0x7B
.db    0x76,0x83
.db    0x7F,0x7F
.db    0x85,0x7B
.db    0x77,0x93
.db    0x7F,0x7C
.db    0x8A,0x6D
.db    0x9C,0x70
.db    0x7D,0x80
.db    0x8B,0x72
.db    0x78,0x86
.db    0x7C,0x86
.db    0x84,0x87
.db    0x7A,0x6D
.db    0x88,0x6F
.db    0x8F,0x89
.db    0x86,0x71
.db    0x7B,0x7A
.db    0x8E,0x76
.db    0x76,0x91
.db    0x76,0x93
.db    0x6A,0x7E
.db    0x8A,0x78
.db    0x9B,0x78
.db    0x8A,0x76
.db    0x78,0x89
.db    0x77,0x87
.db    0x8D,0x7F
.db    0x8A,0x7D
.db    0x67,0x99
.db    0x81,0x91
.db    0x6C,0x85
.db    0x76,0x89
.db    0x86,0x6F
.db    0x82,0x7C
.db    0x92,0x76
.db    0x97,0x71
.db    0x7B,0x7F
.db    0x6F,0x9F
.db    0x74,0x72
.db    0x85,0x8B
.db    0x6E,0x91
.db    0x6D,0x87
.db    0x81,0x7E
.db    0x87,0x6A
.db    0x84,0x6B
.db    0x8D,0x64
.db    0x91,0x84
.db    0x65,0x8E
.db    0x6E,0x7F
.db    0x90,0x74
.db    0x81,0x83
.db    0x63,0x9C
.db    0x76,0x70
.db    0x8D,0x64
.db    0x94,0x6E
.db    0x97,0x80
.db    0x91,0x5E
.db    0x7E,0x7C
.db    0x86,0x82
.db    0x88,0x7D
.db    0x74,0x8F
.db    0x6A,0x93
.db    0x6F,0x8A
.db    0x7C,0x81
.db    0x66,0x9C
.db    0x73,0x8B
.db    0x7F,0x7F
.db    0x8A,0x7B
.db    0x83,0x7B
.db    0x7B,0xA0
.db    0x72,0x76
.db    0x9C,0x6E
.db    0x88,0x76
.db    0x82,0x8E
.db    0x78,0x7F
.db    0x7A,0x82
.db    0x85,0x70
.db    0x92,0x70
.db    0x81,0x7A
.db    0x78,0x88
.db    0x76,0x89
.db    0x7D,0x82
.db    0x7F,0x6B
.db    0x8F,0x83
.db    0x7B,0x97
.db    0x72,0x72
.db    0x8B,0x70
.db    0x8C,0x81
.db    0x83,0x8A
.db    0x6C,0x87
.db    0x7C,0x78
.db    0x93,0x7F
.db    0x84,0x73
.db    0x75,0x96
.db    0x6E,0x8F
.db    0x8D,0x74
.db    0x91,0x72
.db    0x7F,0x8E
.db    0x7B,0x8E
.db    0x73,0x7A
.db    0x8A,0x81
.db    0x82,0x7D
.db    0x85,0x8C
.db    0x79,0x87
.db    0x78,0x76
.db    0x89,0x76
.db    0x86,0x7C
.db    0x79,0x8C
.db    0x77,0x7A
.db    0x81,0x73
.db    0x87,0x81
.db    0x6D,0x87
.db    0x6F,0x7E
.db    0x79,0x7C
.db    0x82,0x78
.db    0x75,0x7B
.db    0x6F,0x7D
.db    0x80,0x6E
.db    0x8D,0x6D
.db    0x83,0x72
.db    0x6E,0x80
.db    0x8A,0x72
.db    0x80,0x76
.db    0x8C,0x73
.db    0x88,0x86
.db    0x74,0x7A
.db    0x80,0x77
.db    0x8F,0x80
.db    0x77,0x86
.db    0x69,0x95
.db    0x75,0x96
.db    0x82,0x88
.db    0x74,0x88
.db    0x7D,0x8F
.db    0x7B,0x84
.db    0x88,0x78
.db    0x89,0x84
.db    0x82,0x82
.db    0x7E,0x7B
.db    0x83,0x7C
.db    0x98,0x74
.db    0x8B,0x85
.db    0x7D,0x83
.db    0x7F,0x82
.db    0x84,0x7C
.db    0x7A,0x84
.db    0x70,0x86
.db    0x7B,0x82
.db    0x83,0x72
.db    0x8B,0x78
.db    0x85,0x78
.db    0x84,0x79
.db    0x84,0x77
.db    0x85,0x78
.db    0x87,0x83
.db    0x7C,0x83
.db    0x72,0x86
.db    0x89,0x7C
.db    0x6D,0x83
.db    0x7B,0x8A
.db    0x78,0x80
.db    0x7B,0x73
.db    0x81,0x8A
.db    0x71,0x8B
.db    0x76,0x89
.db    0x77,0x74
.db    0x8D,0x7A
.db    0x7F,0x85
.db    0x7A,0x7E
.db    0x82,0x84
.db    0x7A,0x79
.db    0x90,0x71
.db    0x7A,0x8A
.db    0x7E,0x79
.db    0x75,0x84
.db    0x8C,0x74
.db    0x7F,0x88
.db    0x74,0x7D
.db    0x87,0x86
.db    0x85,0x81
.db    0x89,0x75
.db    0x86,0x7A
.db    0x8B,0x82
.db    0x8A,0x6F
.db    0x89,0x73
.db    0x8A,0x88
.db    0x7B,0x7D
.db    0x77,0x8D
.db    0x79,0x8A
.db    0x77,0x88
.db    0x72,0x7C
.db    0x83,0x8C
.db    0x73,0x81
.db    0x83,0x85
.db    0x71,0x8A
.db    0x83,0x7E
.db    0x77,0x94
.db    0x7E,0x73
.db    0x88,0x83
.db    0x86,0x7D
.db    0x82,0x89
.db    0x81,0x72
.db    0x8B,0x7B
.db    0x89,0x80
.db    0x85,0x71
.db    0x82,0x88
.db    0x7A,0x7C
.db    0x85,0x7D
.db    0x8A,0x79
.db    0x7D,0x82
.db    0x7A,0x7F
.db    0x73,0x84
.db    0x82,0x82
.db    0x7E,0x75
.db    0x7C,0x7F
.db    0x78,0x88
.db    0x78,0x81
.db    0x7A,0x77
.db    0x7E,0x78
.db    0x81,0x81
.db    0x77,0x7F
.db    0x83,0x7C
.db    0x7C,0x7B
.db    0x8A,0x7A
.db    0x80,0x7D
.db    0x79,0x80
.db    0x77,0x83
.db    0x75,0x78
.db    0x80,0x7B
.db    0x79,0x84
.db    0x7F,0x77
.db    0x84,0x81
.db    0x7C,0x78
.db    0x78,0x7F
.db    0x7D,0x7D
.db    0x80,0x74
.db    0x72,0x7A
.db    0x77,0x7D
.db    0x7A,0x71
.db    0x7C,0x79
.db    0x7E,0x7B
.db    0x7C,0x7D
.db    0x80,0x7E
.db    0x87,0x88
.db    0x86,0x8A
.db    0x89,0x90
.db    0x86,0x9A
.db    0x95,0x96
.db    0x95,0x91
.db    0x9A,0x99
.db    0x97,0x99
.db    0x9B,0x98
.db    0x9A,0x96
.db    0x94,0x91
.db    0x93,0x92
.db    0x89,0x8B
.db    0x8E,0x89
.db    0x84,0x80
.db    0x7C,0x7D
.db    0x7D,0x78
.db    0x78,0x71
.db    0x6F,0x6F
.db    0x6C,0x6E
.db    0x6F,0x67
.db    0x61,0x5E
.db    0x61,0x5F
.db    0x5F,0x63
.db    0x5B,0x5B
.db    0x5F,0x5E
.db    0x5E,0x57
.db    0x58,0x5F
.db    0x60,0x63
.db    0x60,0x5E
.db    0x64,0x63
.db    0x68,0x65
.db    0x65,0x74
.db    0x73,0x7C
.db    0x81,0x83
.db    0x87,0x8D
.db    0x92,0x98
.db    0x9D,0xA5
.db    0xAB,0xAB
.db    0xAE,0xB4
.db    0xB3,0xB3
.db    0xB9,0xBD
.db    0xB5,0xAF
.db    0xB2,0xAB
.db    0xAC,0xAA
.db    0xA7,0x9B
.db    0x94,0x91
.db    0x8C,0x88
.db    0x84,0x7A
.db    0x75,0x72
.db    0x70,0x6C
.db    0x68,0x68
.db    0x6A,0x68
.db    0x67,0x66
.db    0x61,0x69
.db    0x6C,0x6D
.db    0x6E,0x6C
.db    0x6C,0x71
.db    0x73,0x76
.db    0x78,0x75
.db    0x77,0x76
.db    0x74,0x72
.db    0x71,0x72
.db    0x6E,0x70
.db    0x6E,0x62
.db    0x59,0x5C
.db    0x63,0x5D
.db    0x55,0x55
.db    0x4F,0x48
.db    0x4E,0x55
.db    0x4F,0x4F
.db    0x52,0x53
.db    0x4C,0x57
.db    0x66,0x70
.db    0x75,0x7B
.db    0x7D,0x7A
.db    0x86,0x9F
.db    0xAD,0xAF
.db    0xB2,0xB0
.db    0xB7,0xC0
.db    0xD2,0xD4
.db    0xD4,0xD2
.db    0xD2,0xCF
.db    0xD0,0xCF
.db    0xCB,0xCC
.db    0xC6,0xBB
.db    0xB0,0xA5
.db    0xA2,0x9F
.db    0x99,0x92
.db    0x80,0x79
.db    0x76,0x75
.db    0x6F,0x69
.db    0x60,0x5E
.db    0x5A,0x60
.db    0x5F,0x59
.db    0x59,0x58
.db    0x5B,0x5C
.db    0x63,0x67
.db    0x6A,0x68
.db    0x6F,0x68
.db    0x69,0x73
.db    0x74,0x7A
.db    0x72,0x73
.db    0x6F,0x6B
.db    0x6D,0x6E
.db    0x69,0x67
.db    0x61,0x5C
.db    0x55,0x57
.db    0x59,0x50
.db    0x50,0x58
.db    0x4D,0x3F
.db    0x40,0x57
.db    0x69,0x67
.db    0x6C,0x62
.db    0x64,0x75
.db    0x8F,0xA2
.db    0xA0,0x9A
.db    0xA2,0xA5
.db    0xBF,0xD3
.db    0xD6,0xD4
.db    0xCB,0xD4
.db    0xD3,0xD6
.db    0xE4,0xDF
.db    0xD7,0xCD
.db    0xC2,0xBD
.db    0xB8,0xB8
.db    0xB3,0xA2
.db    0x92,0x83
.db    0x7B,0x81
.db    0x7F,0x78
.db    0x6A,0x57
.db    0x53,0x55
.db    0x5C,0x62
.db    0x59,0x52
.db    0x4F,0x51
.db    0x56,0x5C
.db    0x65,0x67
.db    0x61,0x5F
.db    0x61,0x6C
.db    0x72,0x77
.db    0x76,0x6D
.db    0x6B,0x70
.db    0x71,0x70
.db    0x6F,0x6B
.db    0x62,0x5C
.db    0x61,0x5D
.db    0x59,0x5A
.db    0x53,0x4C
.db    0x52,0x53
.db    0x4D,0x3E
.db    0x52,0x67
.db    0x67,0x66
.db    0x65,0x66
.db    0x6F,0x8B
.db    0xA2,0x99
.db    0x96,0xA5
.db    0xB0,0xBF
.db    0xD2,0xD9
.db    0xCF,0xCF
.db    0xDA,0xE1
.db    0xDB,0xE3
.db    0xE2,0xDA
.db    0xD5,0xD0
.db    0xC0,0xBE
.db    0xBE,0xB5
.db    0x9C,0x8E
.db    0x8B,0x82
.db    0x7E,0x7B
.db    0x69,0x55
.db    0x52,0x55
.db    0x52,0x4B
.db    0x4D,0x44
.db    0x3F,0x44
.db    0x4A,0x4A
.db    0x50,0x55
.db    0x55,0x52
.db    0x5A,0x66
.db    0x6C,0x6D
.db    0x71,0x71
.db    0x70,0x75
.db    0x7B,0x7E
.db    0x7A,0x74
.db    0x6F,0x6C
.db    0x6F,0x73
.db    0x6D,0x65
.db    0x5E,0x5A
.db    0x53,0x58
.db    0x62,0x53
.db    0x42,0x4E
.db    0x62,0x67
.db    0x66,0x66
.db    0x65,0x6C
.db    0x87,0x97
.db    0x98,0x94
.db    0x9F,0xB2
.db    0xC4,0xD5
.db    0xD4,0xD1
.db    0xD2,0xE3
.db    0xEC,0xEA
.db    0xE8,0xE2
.db    0xDE,0xDB
.db    0xD8,0xD2
.db    0xC3,0xBC
.db    0xB3,0x9D
.db    0x91,0x8A
.db    0x86,0x7B
.db    0x6F,0x61
.db    0x51,0x4E
.db    0x50,0x49
.db    0x45,0x3E
.db    0x38,0x35
.db    0x3C,0x47
.db    0x47,0x45
.db    0x48,0x4A
.db    0x4F,0x5B
.db    0x66,0x6B
.db    0x6A,0x69
.db    0x6B,0x74
.db    0x7C,0x80
.db    0x7D,0x76
.db    0x73,0x76
.db    0x78,0x71
.db    0x6B,0x6B
.db    0x66,0x5E
.db    0x5C,0x5A
.db    0x54,0x55
.db    0x58,0x49
.db    0x3E,0x50
.db    0x67,0x69
.db    0x65,0x63
.db    0x61,0x74
.db    0x96,0xA2
.db    0x97,0x94
.db    0xA8,0xBE
.db    0xCF,0xDD
.db    0xDA,0xCF
.db    0xD9,0xEE
.db    0xF7,0xF0
.db    0xEB,0xE3
.db    0xD9,0xDC
.db    0xE0,0xD4
.db    0xC2,0xBB
.db    0xB0,0x9C
.db    0x91,0x93
.db    0x8B,0x7A
.db    0x6B,0x5E
.db    0x55,0x57
.db    0x5A,0x54
.db    0x44,0x3D
.db    0x3E,0x44
.db    0x49,0x4B
.db    0x49,0x48
.db    0x4B,0x52
.db    0x59,0x5D
.db    0x62,0x64
.db    0x68,0x6A
.db    0x6B,0x6F
.db    0x73,0x75
.db    0x72,0x6C
.db    0x6B,0x6C
.db    0x6E,0x67
.db    0x5F,0x5E
.db    0x56,0x54
.db    0x54,0x51
.db    0x48,0x44
.db    0x4B,0x46
.db    0x37,0x3F
.db    0x55,0x64
.db    0x5E,0x5B
.db    0x60,0x64
.db    0x84,0x9F
.db    0x9F,0x94
.db    0x9D,0xB6
.db    0xC8,0xD5
.db    0xE2,0xDA
.db    0xD5,0xE6
.db    0xF4,0xF3
.db    0xF0,0xEE
.db    0xE7,0xDF
.db    0xE2,0xDF
.db    0xD1,0xC6
.db    0xBD,0xAF
.db    0xA0,0x9F
.db    0x9A,0x89
.db    0x74,0x6E
.db    0x6B,0x67
.db    0x61,0x56
.db    0x49,0x45
.db    0x4C,0x4F
.db    0x4A,0x40
.db    0x3E,0x45
.db    0x4B,0x51
.db    0x53,0x52
.db    0x52,0x57
.db    0x5E,0x65
.db    0x68,0x6C
.db    0x6B,0x69
.db    0x69,0x6A
.db    0x6F,0x73
.db    0x73,0x69
.db    0x5F,0x61
.db    0x65,0x61
.db    0x5E,0x5E
.db    0x55,0x4A
.db    0x4E,0x56
.db    0x51,0x42
.db    0x4C,0x5F
.db    0x65,0x61
.db    0x64,0x69
.db    0x6F,0x87
.db    0x9B,0x97
.db    0x94,0xA1
.db    0xB7,0xC3
.db    0xD1,0xDA
.db    0xD5,0xD8
.db    0xE2,0xE9
.db    0xED,0xEE
.db    0xEC,0xE2
.db    0xDA,0xDB
.db    0xD7,0xD3
.db    0xC6,0xB5
.db    0xA7,0x9C
.db    0x96,0x94
.db    0x85,0x74
.db    0x65,0x5D
.db    0x59,0x56
.db    0x50,0x42
.db    0x3B,0x3D
.db    0x3F,0x3D
.db    0x3B,0x3B
.db    0x3E,0x43
.db    0x49,0x4D
.db    0x50,0x55
.db    0x5D,0x63
.db    0x6B,0x6F
.db    0x71,0x73
.db    0x79,0x7C
.db    0x7C,0x7E
.db    0x7F,0x7B
.db    0x76,0x71
.db    0x72,0x72
.db    0x6C,0x61
.db    0x5D,0x5C
.db    0x56,0x56
.db    0x58,0x4C
.db    0x38,0x48
.db    0x61,0x66
.db    0x5E,0x5A
.db    0x5C,0x6D
.db    0x8B,0x99
.db    0x8D,0x8B
.db    0x9E,0xB9
.db    0xC7,0xCE
.db    0xD0,0xCF
.db    0xD7,0xE8
.db    0xF1,0xE7
.db    0xE3,0xE8
.db    0xE1,0xDA
.db    0xDC,0xD8
.db    0xC9,0xBB
.db    0xB3,0xA6
.db    0x9D,0x9A
.db    0x8E,0x7C
.db    0x6F,0x68
.db    0x66,0x61
.db    0x58,0x4D
.db    0x43,0x44
.db    0x46,0x46
.db    0x45,0x41
.db    0x3E,0x41
.db    0x49,0x4E
.db    0x52,0x53
.db    0x53,0x58
.db    0x5F,0x65
.db    0x6A,0x6E
.db    0x6F,0x6E
.db    0x71,0x75
.db    0x77,0x77
.db    0x73,0x70
.db    0x6F,0x70
.db    0x6E,0x67
.db    0x64,0x63
.db    0x60,0x5D
.db    0x5B,0x5C
.db    0x55,0x4A
.db    0x4B,0x62
.db    0x6F,0x68
.db    0x5E,0x5E
.db    0x6C,0x82
.db    0x99,0x95
.db    0x83,0x90
.db    0xAE,0xC2
.db    0xC7,0xC4
.db    0xC8,0xC8
.db    0xDC,0xEB
.db    0xE4,0xDE
.db    0xE0,0xE0
.db    0xDB,0xDA
.db    0xDD,0xCB
.db    0xBB,0xBC
.db    0xB2,0xA3
.db    0x9F,0x98
.db    0x84,0x70
.db    0x70,0x73
.db    0x6A,0x5E
.db    0x52,0x45
.db    0x46,0x52
.db    0x52,0x46
.db    0x3E,0x41
.db    0x48,0x4F
.db    0x54,0x54
.db    0x54,0x56
.db    0x60,0x69
.db    0x6C,0x71
.db    0x76,0x75
.db    0x76,0x7E
.db    0x85,0x82
.db    0x80,0x7E
.db    0x7B,0x7B
.db    0x7B,0x7E
.db    0x70,0x61
.db    0x62,0x64
.db    0x65,0x61
.db    0x53,0x4A
.db    0x44,0x46
.db    0x4C,0x54
.db    0x5E,0x53
.db    0x45,0x4B
.db    0x60,0x7B
.db    0x82,0x78
.db    0x74,0x7E
.db    0x9C,0xB3
.db    0xBA,0xB6
.db    0xB7,0xC2
.db    0xD3,0xE0
.db    0xE6,0xDF
.db    0xDB,0xDC
.db    0xE1,0xE2
.db    0xDE,0xD6
.db    0xCA,0xBD
.db    0xB5,0xB5
.db    0xB2,0xA4
.db    0x8E,0x7D
.db    0x7A,0x7B
.db    0x79,0x6D
.db    0x59,0x4D
.db    0x51,0x5B
.db    0x58,0x4C
.db    0x45,0x45
.db    0x4C,0x5A
.db    0x5A,0x54
.db    0x53,0x5C
.db    0x64,0x6C
.db    0x72,0x73
.db    0x71,0x74
.db    0x7D,0x81
.db    0x81,0x80
.db    0x7D,0x79
.db    0x79,0x7D
.db    0x7B,0x72
.db    0x66,0x65
.db    0x61,0x62
.db    0x62,0x5A
.db    0x51,0x4A
.db    0x4D,0x4A
.db    0x44,0x55
.db    0x61,0x57
.db    0x4E,0x54
.db    0x6D,0x7C
.db    0x85,0x86
.db    0x7B,0x88
.db    0xAA,0xB9
.db    0xBD,0xB6
.db    0xBE,0xCB
.db    0xDA,0xE8
.db    0xE1,0xD4
.db    0xD6,0xDE
.db    0xE6,0xDF
.db    0xD8,0xCC
.db    0xBF,0xBA
.db    0xBB,0xB3
.db    0xA9,0x96
.db    0x84,0x7F
.db    0x7F,0x7E
.db    0x71,0x5F
.db    0x56,0x53
.db    0x57,0x5A
.db    0x51,0x4B
.db    0x47,0x4C
.db    0x51,0x54
.db    0x56,0x51
.db    0x53,0x5D
.db    0x63,0x67
.db    0x66,0x68
.db    0x69,0x6D
.db    0x79,0x79
.db    0x75,0x71
.db    0x71,0x76
.db    0x77,0x76
.db    0x70,0x69
.db    0x66,0x64
.db    0x67,0x63
.db    0x57,0x55
.db    0x55,0x54
.db    0x53,0x54
.db    0x50,0x41
.db    0x40,0x59
.db    0x6D,0x66
.db    0x53,0x53
.db    0x6D,0x84
.db    0x92,0x8E
.db    0x80,0x8C
.db    0xA9,0xBF
.db    0xC1,0xBB
.db    0xBF,0xC8
.db    0xD6,0xE7
.db    0xE2,0xD6
.db    0xD6,0xD8
.db    0xE0,0xDE
.db    0xD8,0xCD
.db    0xBC,0xB9
.db    0xB7,0xB3
.db    0xAB,0x97
.db    0x88,0x84
.db    0x82,0x7D
.db    0x70,0x65
.db    0x5C,0x59
.db    0x5D,0x5D
.db    0x53,0x4A
.db    0x49,0x51
.db    0x55,0x55
.db    0x55,0x4E
.db    0x53,0x5C
.db    0x61,0x66
.db    0x66,0x62
.db    0x63,0x6B
.db    0x76,0x77
.db    0x73,0x70
.db    0x6E,0x70
.db    0x76,0x77
.db    0x74,0x6C
.db    0x66,0x65
.db    0x65,0x66
.db    0x64,0x5B
.db    0x58,0x56
.db    0x53,0x52
.db    0x58,0x57
.db    0x47,0x45
.db    0x5B,0x6E
.db    0x68,0x5A
.db    0x5A,0x6F
.db    0x84,0x94
.db    0x8C,0x7D
.db    0x90,0xB1
.db    0xBF,0xB9
.db    0xB6,0xC1
.db    0xCD,0xD8
.db    0xDC,0xD7
.db    0xD8,0xDA
.db    0xD8,0xD7
.db    0xD1,0xD5
.db    0xD0,0xBB
.db    0xAF,0xAF
.db    0xB0,0xAA
.db    0x98,0x84
.db    0x7C,0x7E
.db    0x7D,0x70
.db    0x63,0x5D
.db    0x5C,0x5A
.db    0x56,0x50
.db    0x51,0x54
.db    0x53,0x51
.db    0x51,0x54
.db    0x5A,0x5C
.db    0x5E,0x5F
.db    0x60,0x65
.db    0x69,0x6D
.db    0x6F,0x73
.db    0x74,0x71
.db    0x73,0x78
.db    0x78,0x78
.db    0x76,0x70
.db    0x6F,0x71
.db    0x72,0x6D
.db    0x66,0x5E
.db    0x5A,0x5B
.db    0x5D,0x56
.db    0x53,0x51
.db    0x45,0x49
.db    0x50,0x51
.db    0x44,0x49
.db    0x61,0x63
.db    0x5A,0x59
.db    0x68,0x80
.db    0x88,0x8B
.db    0x85,0x92
.db    0xAB,0xBE
.db    0xC0,0xBC
.db    0xC3,0xD5
.db    0xDE,0xE2
.db    0xE1,0xDD
.db    0xE1,0xE5
.db    0xDE,0xD9
.db    0xDA,0xCF
.db    0xC0,0xB9
.db    0xB6,0xAA
.db    0x9F,0x96
.db    0x8A,0x7D
.db    0x74,0x6F
.db    0x69,0x5D
.db    0x54,0x53
.db    0x51,0x4B
.db    0x46,0x46
.db    0x48,0x4C
.db    0x4D,0x4B
.db    0x4D,0x51
.db    0x53,0x5E
.db    0x65,0x61
.db    0x62,0x69
.db    0x73,0x76
.db    0x76,0x77
.db    0x7A,0x81
.db    0x80,0x7D
.db    0x7B,0x7D
.db    0x81,0x7B
.db    0x73,0x71
.db    0x71,0x70
.db    0x6A,0x63
.db    0x5D,0x5A
.db    0x59,0x58
.db    0x54,0x4E
.db    0x47,0x4E
.db    0x54,0x49
.db    0x46,0x5D
.db    0x69,0x5E
.db    0x5B,0x6B
.db    0x7F,0x89
.db    0x8E,0x92
.db    0x94,0xA4
.db    0xC2,0xC5
.db    0xC0,0xC8
.db    0xD9,0xE0
.db    0xE7,0xE8
.db    0xE6,0xE4
.db    0xE9,0xE9
.db    0xE1,0xD7
.db    0xD9,0xD7
.db    0xC1,0xB3
.db    0xB3,0xAE
.db    0xA3,0x8F
.db    0x82,0x78
.db    0x79,0x76
.db    0x61,0x53
.db    0x52,0x52
.db    0x54,0x48
.db    0x40,0x44
.db    0x46,0x47
.db    0x49,0x47
.db    0x49,0x4C
.db    0x55,0x57
.db    0x56,0x5D
.db    0x63,0x69
.db    0x6B,0x6A
.db    0x72,0x7B
.db    0x79,0x78
.db    0x7A,0x7E
.db    0x7F,0x7D
.db    0x7D,0x78
.db    0x74,0x76
.db    0x74,0x6E
.db    0x69,0x64
.db    0x61,0x5E
.db    0x5D,0x58
.db    0x52,0x4C
.db    0x4B,0x52
.db    0x4F,0x4C
.db    0x45,0x3D
.db    0x55,0x6C
.db    0x61,0x50
.db    0x59,0x79
.db    0x8A,0x85
.db    0x89,0x8C
.db    0x97,0xB4
.db    0xC7,0xB9
.db    0xB9,0xD1
.db    0xDF,0xE2
.db    0xE3,0xE6
.db    0xEC,0xE9
.db    0xE6,0xEE
.db    0xE7,0xE4
.db    0xE0,0xD1
.db    0xC3,0xCB
.db    0xC5,0xB0
.db    0xA2,0x95
.db    0x8E,0x8B
.db    0x81,0x73
.db    0x63,0x59
.db    0x58,0x58
.db    0x4D,0x44
.db    0x40,0x3F
.db    0x3E,0x41
.db    0x42,0x3F
.db    0x3E,0x45
.db    0x4F,0x4F
.db    0x4E,0x58
.db    0x62,0x62
.db    0x64,0x6D
.db    0x71,0x77
.db    0x7D,0x7C
.db    0x79,0x7F
.db    0x89,0x85
.db    0x80,0x7C
.db    0x7B,0x7B
.db    0x79,0x79
.db    0x6D,0x62
.db    0x64,0x63
.db    0x5B,0x54
.db    0x53,0x50
.db    0x45,0x41
.db    0x44,0x4A
.db    0x4B,0x38
.db    0x30,0x56
.db    0x66,0x57
.db    0x47,0x52
.db    0x78,0x88
.db    0x7D,0x80
.db    0x8F,0xA2
.db    0xB5,0xBD
.db    0xBC,0xC5
.db    0xD9,0xD8
.db    0xE4,0xEF
.db    0xEF,0xEF
.db    0xEE,0xEC
.db    0xF8,0xF4
.db    0xE8,0xDD
.db    0xDA,0xD6
.db    0xD2,0xC2
.db    0xB2,0xA8
.db    0xA0,0x95
.db    0x90,0x84
.db    0x6D,0x67
.db    0x66,0x5C
.db    0x52,0x4A
.db    0x45,0x45
.db    0x3D,0x3E
.db    0x42,0x3A
.db    0x3E,0x44
.db    0x45,0x49
.db    0x4E,0x53
.db    0x57,0x5A
.db    0x66,0x69
.db    0x69,0x6D
.db    0x7C,0x82
.db    0x7C,0x78
.db    0x82,0x87
.db    0x85,0x84
.db    0x7F,0x7B
.db    0x7B,0x79
.db    0x78,0x73
.db    0x64,0x5E
.db    0x63,0x61
.db    0x58,0x4D
.db    0x48,0x4A
.db    0x4D,0x49
.db    0x3A,0x3C
.db    0x4E,0x4F
.db    0x49,0x46
.db    0x58,0x6C
.db    0x6F,0x66
.db    0x73,0x88
.db    0x93,0xA8
.db    0xA5,0x9B
.db    0xBC,0xD1
.db    0xD2,0xCF
.db    0xD5,0xE4
.db    0xF2,0xE7
.db    0xE8,0xF1
.db    0xEC,0xEB
.db    0xEF,0xD9
.db    0xD6,0xDB
.db    0xD4,0xC3
.db    0xAB,0xA9
.db    0xAD,0xA2
.db    0x8E,0x76
.db    0x6E,0x75
.db    0x6B,0x60
.db    0x4A,0x40
.db    0x4A,0x44
.db    0x3C,0x38
.db    0x38,0x37
.db    0x38,0x3A
.db    0x41,0x41
.db    0x41,0x41
.db    0x52,0x58
.db    0x5C,0x57
.db    0x5C,0x6A
.db    0x70,0x76
.db    0x75,0x72
.db    0x77,0x7F
.db    0x80,0x83
.db    0x7B,0x73
.db    0x75,0x7E
.db    0x7C,0x77
.db    0x60,0x66
.db    0x6E,0x66
.db    0x5E,0x56
.db    0x56,0x55
.db    0x48,0x5B
.db    0x66,0x53
.db    0x46,0x53
.db    0x65,0x74
.db    0x6F,0x5E
.db    0x6F,0x85
.db    0x86,0x9C
.db    0x96,0x90
.db    0xAD,0xBA
.db    0xBD,0xC9
.db    0xC7,0xC8
.db    0xDC,0xDE
.db    0xDD,0xE9
.db    0xE2,0xD6
.db    0xE4,0xDF
.db    0xDB,0xD7
.db    0xC7,0xBE
.db    0xC0,0xB4
.db    0xAE,0xA8
.db    0x92,0x87
.db    0x89,0x84
.db    0x77,0x6B
.db    0x58,0x5A
.db    0x5D,0x57
.db    0x4C,0x42
.db    0x3C,0x4B
.db    0x49,0x41
.db    0x3B,0x3F
.db    0x45,0x4C
.db    0x4C,0x48
.db    0x4A,0x51
.db    0x56,0x61
.db    0x5B,0x5B
.db    0x61,0x65
.db    0x65,0x68
.db    0x6D,0x6C
.db    0x65,0x61
.db    0x6B,0x73
.db    0x68,0x60
.db    0x61,0x62
.db    0x67,0x66
.db    0x63,0x57
.db    0x4B,0x69
.db    0x82,0x6B
.db    0x51,0x5A
.db    0x7F,0x92
.db    0x85,0x70
.db    0x82,0x97
.db    0xA5,0xB3
.db    0xA5,0x99
.db    0xBD,0xCE
.db    0xCF,0xD0
.db    0xCC,0xD0
.db    0xDF,0xDA
.db    0xE6,0xE6
.db    0xDC,0xD5
.db    0xD9,0xD3
.db    0xDC,0xCC
.db    0xBA,0xB3
.db    0xB2,0xAB
.db    0xA7,0x93
.db    0x8F,0x7B
.db    0x74,0x78
.db    0x78,0x65
.db    0x52,0x4B
.db    0x4E,0x58
.db    0x53,0x3C
.db    0x33,0x3C
.db    0x41,0x50
.db    0x41,0x34
.db    0x39,0x48
.db    0x53,0x4C
.db    0x46,0x4A
.db    0x57,0x5F
.db    0x53,0x5C
.db    0x5F,0x5D
.db    0x5D,0x64
.db    0x64,0x68
.db    0x57,0x59
.db    0x6A,0x62
.db    0x5B,0x56
.db    0x51,0x5C
.db    0x62,0x5B
.db    0x52,0x42
.db    0x61,0x7A
.db    0x6B,0x52
.db    0x5B,0x7D
.db    0x8B,0x8C
.db    0x79,0x83
.db    0x9C,0xAE
.db    0xB9,0xAD
.db    0xA9,0xC8
.db    0xD6,0xD5
.db    0xD7,0xD6
.db    0xDC,0xEA
.db    0xE5,0xED
.db    0xE4,0xD8
.db    0xDF,0xDD
.db    0xD5,0xD2
.db    0xC0,0xB7
.db    0xB9,0xAA
.db    0xA5,0x9C
.db    0x85,0x7E
.db    0x83,0x7F
.db    0x6E,0x5B
.db    0x5B,0x59
.db    0x5D,0x4E
.db    0x4B,0x46
.db    0x43,0x4D
.db    0x4C,0x43
.db    0x46,0x48
.db    0x50,0x4B
.db    0x4F,0x59
.db    0x54,0x53
.db    0x61,0x61
.db    0x64,0x64
.db    0x62,0x69
.db    0x65,0x6A
.db    0x71,0x67
.db    0x5E,0x5D
.db    0x68,0x6A
.db    0x5E,0x54
.db    0x55,0x5A
.db    0x63,0x5D
.db    0x4D,0x42
.db    0x5D,0x7C
.db    0x6D,0x4B
.db    0x50,0x79
.db    0x93,0x80
.db    0x71,0x82
.db    0x8A,0xA3
.db    0xB8,0xA4
.db    0x9C,0xB5
.db    0xD1,0xD7
.db    0xC2,0xC2
.db    0xDB,0xE5
.db    0xD4,0xDF
.db    0xDF,0xD3
.db    0xD5,0xE1
.db    0xC8,0xC5
.db    0xC1,0xC1
.db    0xB9,0x9D
.db    0x97,0xA9
.db    0x8D,0x79
.db    0x80,0x7E
.db    0x6A,0x61
.db    0x5C,0x5D
.db    0x57,0x4B
.db    0x4A,0x4F
.db    0x41,0x42
.db    0x48,0x44
.db    0x41,0x49
.db    0x45,0x4C
.db    0x4F,0x4C
.db    0x4F,0x56
.db    0x53,0x5F
.db    0x5F,0x5E
.db    0x5C,0x58
.db    0x69,0x67
.db    0x5F,0x5B
.db    0x66,0x5A
.db    0x54,0x63
.db    0x64,0x5B
.db    0x55,0x5B
.db    0x66,0x5B
.db    0x44,0x73
.db    0x84,0x68
.db    0x5F,0x6D
.db    0x89,0xA0
.db    0x92,0x81
.db    0x97,0xA9
.db    0xC0,0xCB
.db    0xB3,0xB0
.db    0xD4,0xDB
.db    0xE1,0xE5
.db    0xD8,0xD9
.db    0xEC,0xE7
.db    0xF0,0xE6
.db    0xD4,0xD5
.db    0xD2,0xD0
.db    0xD7,0xC0
.db    0xA4,0xA3
.db    0xA6,0xA1
.db    0x91,0x7B
.db    0x6A,0x7B
.db    0x6E,0x63
.db    0x52,0x43
.db    0x48,0x57
.db    0x45,0x35
.db    0x31,0x38
.db    0x47,0x41
.db    0x33,0x34
.db    0x46,0x49
.db    0x4C,0x49
.db    0x48,0x54
.db    0x5D,0x5C
.db    0x61,0x64
.db    0x63,0x5F
.db    0x6A,0x6A
.db    0x6C,0x65
.db    0x62,0x68
.db    0x62,0x60
.db    0x57,0x5D
.db    0x63,0x60
.db    0x53,0x41
.db    0x4D,0x77
.db    0x71,0x55
.db    0x40,0x63
.db    0x88,0x8F
.db    0x77,0x69
.db    0x84,0x9D
.db    0xBB,0xBA
.db    0x9E,0x9D
.db    0xC7,0xE0
.db    0xEB,0xD4
.db    0xC7,0xD9
.db    0xF7,0xF5
.db    0xED,0xDE
.db    0xDE,0xE3
.db    0xE8,0xDB
.db    0xD0,0xBD
.db    0xBB,0xC3
.db    0xAB,0x97
.db    0x8F,0x92
.db    0x7B,0x70
.db    0x6E,0x6D
.db    0x5C,0x4B
.db    0x4D,0x4F
.db    0x47,0x43
.db    0x3E,0x39
.db    0x3B,0x40
.db    0x49,0x40
.db    0x39,0x41
.db    0x4E,0x52
.db    0x50,0x4F
.db    0x57,0x57
.db    0x5B,0x5D
.db    0x5E,0x58
.db    0x5C,0x60
.db    0x59,0x58
.db    0x51,0x4F
.db    0x52,0x48
.db    0x46,0x4A
.db    0x4D,0x46
.db    0x3E,0x30
.db    0x4A,0x6A
.db    0x58,0x44
.db    0x42,0x5C
.db    0x82,0x8A
.db    0x70,0x74
.db    0x87,0xA1
.db    0xC0,0xBC
.db    0xA9,0xB6
.db    0xCD,0xEA
.db    0xF2,0xDF
.db    0xDB,0xF2
.db    0xFA,0xFB
.db    0xF5,0xEB
.db    0xED,0xF0
.db    0xE4,0xD7
.db    0xD3,0xC9
.db    0xC5,0xB0
.db    0x9F,0x9D
.db    0x9A,0x83
.db    0x6F,0x69
.db    0x79,0x6F
.db    0x54,0x3C
.db    0x47,0x57
.db    0x54,0x47
.db    0x38,0x33
.db    0x45,0x54
.db    0x53,0x42
.db    0x3C,0x50
.db    0x65,0x5F
.db    0x54,0x53
.db    0x64,0x6D
.db    0x6E,0x69
.db    0x65,0x64
.db    0x69,0x6F
.db    0x68,0x64
.db    0x5D,0x5E
.db    0x5A,0x54
.db    0x50,0x55
.db    0x59,0x51
.db    0x42,0x31
.db    0x5A,0x70
.db    0x61,0x46
.db    0x44,0x5C
.db    0x83,0x89
.db    0x7D,0x79
.db    0x7B,0x98
.db    0xBE,0xB6
.db    0xA5,0xB1
.db    0xC5,0xE6
.db    0xE4,0xD2
.db    0xD1,0xE9
.db    0xEE,0xFA
.db    0xE8,0xDA
.db    0xDB,0xE5
.db    0xDF,0xD3
.db    0xC3,0xBE
.db    0xBD,0xAE
.db    0x9C,0x92
.db    0x89,0x88
.db    0x80,0x71
.db    0x69,0x59
.db    0x56,0x56
.db    0x57,0x53
.db    0x43,0x40
.db    0x41,0x44
.db    0x48,0x4E
.db    0x4D,0x3C
.db    0x3E,0x4E
.db    0x5D,0x5D
.db    0x57,0x4E
.db    0x53,0x5A
.db    0x66,0x69
.db    0x57,0x54
.db    0x5C,0x64
.db    0x60,0x4E
.db    0x4C,0x57
.db    0x58,0x50
.db    0x49,0x4F
.db    0x51,0x4C
.db    0x41,0x50
.db    0x6A,0x68
.db    0x59,0x59
.db    0x65,0x81
.db    0x8F,0x97
.db    0x97,0x8C
.db    0x91,0xC1
.db    0xD6,0xD0
.db    0xC6,0xC4
.db    0xDF,0xF4
.db    0xFB,0xF2
.db    0xE9,0xE2
.db    0xF9,0xFE
.db    0xF1,0xE2
.db    0xDD,0xDD
.db    0xDD,0xC9
.db    0xBB,0xB7
.db    0xA6,0xA1
.db    0x97,0x82
.db    0x74,0x71
.db    0x6A,0x6B
.db    0x52,0x47
.db    0x48,0x4B
.db    0x43,0x3E
.db    0x34,0x36
.db    0x41,0x3F
.db    0x3C,0x3B
.db    0x3B,0x41
.db    0x4B,0x4E
.db    0x50,0x50
.db    0x53,0x56
.db    0x5A,0x5E
.db    0x61,0x5D
.db    0x5D,0x60
.db    0x63,0x5A
.db    0x54,0x54
.db    0x56,0x58
.db    0x51,0x4C
.db    0x50,0x51
.db    0x4E,0x40
.db    0x4A,0x69
.db    0x6A,0x5B
.db    0x52,0x62
.db    0x79,0x87
.db    0x8C,0x8E
.db    0x8E,0x90
.db    0xA9,0xC3
.db    0xC4,0xBF
.db    0xC4,0xCF
.db    0xDF,0xE9
.db    0xE5,0xE8
.db    0xE1,0xE5
.db    0xF0,0xEE
.db    0xDE,0xDE
.db    0xD6,0xD4
.db    0xCB,0xBD
.db    0xB2,0xAF
.db    0xA4,0x9C
.db    0x8E,0x7D
.db    0x74,0x75
.db    0x6F,0x65
.db    0x5C,0x50
.db    0x54,0x50
.db    0x49,0x4C
.db    0x4E,0x48
.db    0x45,0x43
.db    0x48,0x4F
.db    0x50,0x50
.db    0x54,0x51
.db    0x50,0x5C
.db    0x64,0x61
.db    0x5D,0x5B
.db    0x5F,0x63
.db    0x64,0x65
.db    0x62,0x5A
.db    0x51,0x55
.db    0x55,0x58
.db    0x57,0x51
.db    0x4E,0x4A
.db    0x40,0x44
.db    0x5E,0x69
.db    0x62,0x50
.db    0x53,0x6B
.db    0x80,0x85
.db    0x8A,0x8F
.db    0x8C,0x9D
.db    0xAE,0xBA
.db    0xBE,0xC7
.db    0xD1,0xD9
.db    0xD6,0xD5
.db    0xE8,0xEF
.db    0xED,0xE8
.db    0xE8,0xE0
.db    0xDC,0xD8
.db    0xDE,0xD8
.db    0xC4,0xB5
.db    0xAE,0xA9
.db    0xA1,0x9D
.db    0x8F,0x7D
.db    0x71,0x69
.db    0x6D,0x67
.db    0x5F,0x58
.db    0x52,0x47
.db    0x41,0x46
.db    0x4D,0x4F
.db    0x46,0x3F
.db    0x41,0x48
.db    0x4A,0x50
.db    0x52,0x52
.db    0x54,0x55
.db    0x56,0x56
.db    0x59,0x5E
.db    0x63,0x5D
.db    0x59,0x56
.db    0x54,0x52
.db    0x55,0x54
.db    0x51,0x4C
.db    0x48,0x4E
.db    0x51,0x45
.db    0x43,0x50
.db    0x62,0x68
.db    0x60,0x5C
.db    0x68,0x75
.db    0x7F,0x8D
.db    0x96,0x98
.db    0x9F,0xA7
.db    0xB2,0xBE
.db    0xC1,0xC9
.db    0xD7,0xDA
.db    0xD9,0xDA
.db    0xDD,0xE0
.db    0xE3,0xDF
.db    0xDE,0xDB
.db    0xCF,0xCA
.db    0xC3,0xB9
.db    0xB3,0xAD
.db    0xA6,0x9A
.db    0x8D,0x82
.db    0x7C,0x75
.db    0x6F,0x6A
.db    0x64,0x5D
.db    0x59,0x58
.db    0x57,0x51
.db    0x4C,0x50
.db    0x55,0x57
.db    0x55,0x57
.db    0x5A,0x5A
.db    0x5B,0x60
.db    0x63,0x66
.db    0x66,0x67
.db    0x69,0x6C
.db    0x6C,0x6A
.db    0x67,0x67
.db    0x69,0x6D
.db    0x6E,0x6C
.db    0x66,0x65
.db    0x69,0x6C
.db    0x6D,0x6D
.db    0x6F,0x71
.db    0x74,0x78
.db    0x7E,0x7D
.db    0x7E,0x81
.db    0x86,0x8A
.db    0x89,0x8B
.db    0x90,0x94
.db    0x90,0x93
.db    0x92,0x91
.db    0x95,0x9C
.db    0x9C,0x98
.db    0x94,0x96
.db    0x9B,0x9D
.db    0x9D,0x9D
.db    0x9A,0x9A
.db    0x9B,0x9A
.db    0x9A,0x9D
.db    0x9D,0x9B
.db    0x98,0x96
.db    0x97,0x99
.db    0x96,0x94
.db    0x94,0x93
.db    0x91,0x8B
.db    0x8E,0x8E
.db    0x8B,0x87
.db    0x88,0x85
.db    0x81,0x7E
.db    0x7F,0x7E
.db    0x7A,0x77
.db    0x76,0x74
.db    0x73,0x71
.db    0x6F,0x6E
.db    0x6D,0x6A
.db    0x68,0x6B
.db    0x6A,0x68
.db    0x64,0x65
.db    0x68,0x68
.db    0x67,0x65
.db    0x65,0x67
.db    0x66,0x68
.db    0x6A,0x6A
.db    0x69,0x68
.db    0x69,0x6E
.db    0x6E,0x6C
.db    0x6D,0x70
.db    0x70,0x70
.db    0x70,0x73
.db    0x75,0x73
.db    0x75,0x76
.db    0x77,0x78
.db    0x7A,0x7A
.db    0x7B,0x7D
.db    0x7D,0x7D
.db    0x7E,0x80
.db    0x81,0x80
.db    0x7F,0x81
.db    0x82,0x81
.db    0x83,0x82
.db    0x82,0x80
.db    0x82,0x83
.db    0x83,0x80
.db    0x82,0x83
.db    0x83,0x82
.db    0x83,0x84
.db    0x83,0x83
.db    0x85,0x85
.db    0x86,0x85
.db    0x84,0x84
.db    0x86,0x88
.db    0x87,0x86
.db    0x86,0x88
.db    0x87,0x88
.db    0x89,0x88
.db    0x87,0x89
.db    0x89,0x88
.db    0x86,0x88
.db    0x89,0x86
.db    0x85,0x85
.db    0x85,0x84
.db    0x84,0x83
.db    0x82,0x81
.db    0x81,0x81
.db    0x81,0x7F
.db    0x7F,0x7F
.db    0x7E,0x7E
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x81
.db    0x81,0x80
.db    0x81,0x81
.db    0x81,0x82
.db    0x84,0x84
.db    0x83,0x82
.db    0x82,0x84
.db    0x86,0x86
.db    0x85,0x85
.db    0x84,0x84
.db    0x85,0x86
.db    0x86,0x85
.db    0x85,0x84
.db    0x84,0x85
.db    0x85,0x83
.db    0x83,0x84
.db    0x84,0x84
.db    0x84,0x84
.db    0x83,0x82
.db    0x83,0x83
.db    0x83,0x83
.db    0x83,0x83
.db    0x82,0x80
.db    0x80,0x80
.db    0x81,0x81
.db    0x81,0x81
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7D
.db    0x7D,0x7D
.db    0x7C,0x7B
.db    0x7B,0x7B
.db    0x7B,0x7B
.db    0x7A,0x7A
.db    0x7A,0x7A
.db    0x7A,0x7B
.db    0x7B,0x79
.db    0x79,0x7B
.db    0x7B,0x7B
.db    0x7B,0x7B
.db    0x7B,0x7C
.db    0x7C,0x7C
.db    0x7C,0x7C
.db    0x7E,0x7E
.db    0x7C,0x7C
.db    0x7D,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7D
.db    0x7D,0x7D
.db    0x7D,0x7D
.db    0x7D,0x7F
.db    0x7D,0x7D
.db    0x7C,0x7D
.db    0x7D,0x7D
.db    0x7D,0x7E
.db    0x7F,0x7E
.db    0x7E,0x7F
.db    0x80,0x7F
.db    0x7E,0x7F
.db    0x80,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7E
.db    0x7E,0x7E
.db    0x7F,0x7F
.db    0x7D,0x7D
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7F,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7F
.db    0x7F,0x7F
.db    0x7E,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7E
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7E
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x80
.db    0x80,0x80
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x81,0x81
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7E,0x7E
.db    0x7E,0x7F
.db    0x80,0x81
.db    0x81,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7E
.db    0x7D,0x7D
.db    0x7E,0x7F
.db    0x7F,0x7E
.db    0x7E,0x7F
.db    0x7F,0x80
.db    0x80,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7F,0x80
.db    0x80,0x7E
.db    0x7D,0x7D
.db    0x7E,0x7E
.db    0x7E,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7D,0x7C
.db    0x7C,0x7E
.db    0x7F,0x81
.db    0x81,0x80
.db    0x7F,0x7E
.db    0x7E,0x7F
.db    0x7F,0x7E
.db    0x7E,0x7F
.db    0x80,0x81
.db    0x80,0x7F
.db    0x7E,0x7D
.db    0x7D,0x7E
.db    0x7F,0x80
.db    0x81,0x80
.db    0x80,0x7F
.db    0x7E,0x7E
.db    0x7E,0x7F
.db    0x80,0x82
.db    0x83,0x81
.db    0x80,0x7F
.db    0x7E,0x7D
.db    0x7E,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7D,0x80
.db    0x81,0x81
.db    0x82,0x81
.db    0x7E,0x7F
.db    0x80,0x83
.db    0x85,0x81
.db    0x7F,0x7D
.db    0x7E,0x83
.db    0x84,0x84
.db    0x84,0x80
.db    0x7D,0x82
.db    0x82,0x81
.db    0x84,0x82
.db    0x80,0x81
.db    0x81,0x83
.db    0x83,0x82
.db    0x80,0x81
.db    0x80,0x83
.db    0x83,0x83
.db    0x81,0x81
.db    0x80,0x84
.db    0x82,0x82
.db    0x84,0x7E
.db    0x80,0x82
.db    0x83,0x84
.db    0x81,0x84
.db    0x84,0x83
.db    0x85,0x86
.db    0x86,0x89
.db    0x88,0x87
.db    0x84,0x82
.db    0x82,0x88
.db    0x8F,0x92
.db    0x91,0x8F
.db    0x90,0x92
.db    0x80,0x89
.db    0xAB,0xB3
.db    0xA5,0x7A
.db    0x5A,0x44
.db    0x50,0x75
.db    0x86,0x69
.db    0x50,0x71
.db    0x79,0x82
.db    0x6B,0x61
.db    0x6A,0x6B
.db    0x76,0x8F
.db    0x9F,0xA0
.db    0x8E,0x73
.db    0x66,0x55
.db    0x64,0x7E
.db    0x8F,0x91
.db    0x90,0x89
.db    0x7B,0x70
.db    0x6C,0x70
.db    0x75,0x7E
.db    0x83,0x81
.db    0x78,0x62
.db    0x55,0x5C
.db    0x72,0x7F
.db    0x87,0x87
.db    0x76,0x62
.db    0x5B,0x67
.db    0x7A,0x85
.db    0x8B,0x84
.db    0x72,0x67
.db    0x65,0x76
.db    0x8A,0x8B
.db    0x86,0x79
.db    0x71,0x74
.db    0x76,0x83
.db    0x88,0x84
.db    0x7D,0x74
.db    0x74,0x79
.db    0x7D,0x83
.db    0x85,0x82
.db    0x7C,0x7B
.db    0x7A,0x82
.db    0x84,0x85
.db    0x7D,0x7B
.db    0x7A,0x83
.db    0x8A,0x8B
.db    0x86,0x7C
.db    0x72,0x7B
.db    0x8F,0x91
.db    0x8B,0x80
.db    0x7A,0x80
.db    0x8B,0x95
.db    0x94,0x84
.db    0x84,0x86
.db    0x7E,0x82
.db    0x8F,0x94
.db    0x8F,0x83
.db    0x84,0x84
.db    0x83,0x8D
.db    0x8A,0x84
.db    0x8F,0x96
.db    0x92,0x86
.db    0x7B,0x7E
.db    0x83,0x93
.db    0x97,0x98
.db    0x91,0x81
.db    0x73,0x73
.db    0x80,0x91
.db    0xA6,0xA3
.db    0x86,0x7B
.db    0x70,0x6B
.db    0x7E,0xA1
.db    0xB5,0x97
.db    0x7E,0x75
.db    0x6A,0x78
.db    0x89,0x96
.db    0xA3,0x93
.db    0x7A,0x67
.db    0x6A,0x7D
.db    0x90,0xA3
.db    0xA2,0x7E
.db    0x66,0x68
.db    0x77,0x8A
.db    0x9D,0xA5
.db    0x90,0x74
.db    0x66,0x65
.db    0x7D,0x91
.db    0x99,0x9E
.db    0x80,0x6A
.db    0x65,0x67
.db    0x7F,0x8A
.db    0x94,0x96
.db    0x75,0x58
.db    0x57,0x6A
.db    0x87,0x9B
.db    0x8F,0x79
.db    0x58,0x4B
.db    0x58,0x7D
.db    0x9B,0xA1
.db    0x87,0x67
.db    0x46,0x46
.db    0x71,0xA9
.db    0xA8,0x88
.db    0x62,0x52
.db    0x5A,0x6E
.db    0x92,0x8D
.db    0x80,0x66
.db    0x5B,0x62
.db    0x6F,0x81
.db    0x8B,0x70
.db    0x5C,0x5B
.db    0x76,0x82
.db    0x87,0x80
.db    0x69,0x5A
.db    0x67,0x89
.db    0x95,0x8F
.db    0x6F,0x63
.db    0x65,0x7A
.db    0x85,0x94
.db    0x8C,0x71
.db    0x68,0x67
.db    0x76,0x89
.db    0x92,0x8E
.db    0x79,0x69
.db    0x6B,0x73
.db    0x8B,0x8E
.db    0x87,0x79
.db    0x71,0x6F
.db    0x7D,0x88
.db    0x80,0x81
.db    0x85,0x7F
.db    0x70,0x79
.db    0x85,0x8B
.db    0x8B,0x7E
.db    0x6A,0x78
.db    0x8C,0x93
.db    0x91,0x7F
.db    0x6C,0x6E
.db    0x84,0x8F
.db    0x8F,0x84
.db    0x80,0x78
.db    0x7D,0x7B
.db    0x79,0x86
.db    0x93,0x86
.db    0x7F,0x7B
.db    0x6E,0x7B
.db    0x90,0x89
.db    0x89,0x86
.db    0x80,0x7E
.db    0x7C,0x8A
.db    0x88,0x8B
.db    0x8C,0x84
.db    0x7B,0x85
.db    0x86,0x85
.db    0x89,0x88
.db    0x7C,0x7E
.db    0x7E,0x81
.db    0x97,0x85
.db    0x66,0x7C
.db    0x8A,0x8A
.db    0x80,0x75
.db    0x82,0x8B
.db    0x84,0x75
.db    0x77,0x89
.db    0x87,0x86
.db    0x86,0x7C
.db    0x6F,0x7F
.db    0x88,0x90
.db    0x91,0x82
.db    0x76,0x78
.db    0x7F,0x88
.db    0x8D,0x85
.db    0x7A,0x80
.db    0x7C,0x78
.db    0x80,0x89
.db    0x8B,0x77
.db    0x77,0x7F
.db    0x82,0x82
.db    0x7A,0x7A
.db    0x80,0x79
.db    0x83,0x8F
.db    0x86,0x75
.db    0x6F,0x7E
.db    0x8F,0x8D
.db    0x89,0x6E
.db    0x74,0x84
.db    0x83,0x84
.db    0x7A,0x75
.db    0x80,0x80
.db    0x7B,0x79
.db    0x79,0x7D
.db    0x7E,0x7C
.db    0x7C,0x74
.db    0x7C,0x8D
.db    0x80,0x73
.db    0x74,0x77
.db    0x81,0x80
.db    0x80,0x88
.db    0x81,0x69
.db    0x6C,0x7F
.db    0x8E,0x94
.db    0x86,0x78
.db    0x68,0x6C
.db    0x8C,0x9A
.db    0x8C,0x7D
.db    0x63,0x64
.db    0x90,0x91
.db    0x8A,0x84
.db    0x69,0x71
.db    0x83,0x7E
.db    0x84,0x89
.db    0x7F,0x64
.db    0x65,0x8B
.db    0x8C,0x76
.db    0x74,0x78
.db    0x7B,0x82
.db    0x7F,0x7F
.db    0x89,0x78
.db    0x78,0x7F
.db    0x87,0x7E
.db    0x77,0x8A
.db    0x86,0x78
.db    0x7E,0x7E
.db    0x77,0x8C
.db    0x8A,0x78
.db    0x78,0x75
.db    0x79,0x7E
.db    0x83,0x80
.db    0x76,0x6F
.db    0x76,0x82
.db    0x84,0x7A
.db    0x6B,0x80
.db    0x8C,0x78
.db    0x81,0x80
.db    0x7A,0x7F
.db    0x82,0x88
.db    0x80,0x80
.db    0x88,0x7D
.db    0x81,0x85
.db    0x7D,0x83
.db    0x85,0x73
.db    0x84,0x8F
.db    0x7F,0x7F
.db    0x7C,0x77
.db    0x7E,0x8A
.db    0x8E,0x79
.db    0x7A,0x80
.db    0x7B,0x82
.db    0x88,0x84
.db    0x74,0x77
.db    0x82,0x98
.db    0x8D,0x71
.db    0x6D,0x85
.db    0x93,0x8C
.db    0x89,0x7D
.db    0x79,0x7C
.db    0x81,0x8D
.db    0x89,0x7F
.db    0x76,0x76
.db    0x83,0x90
.db    0x8F,0x79
.db    0x64,0x7A
.db    0x94,0x8A
.db    0x7A,0x7C
.db    0x7C,0x7F
.db    0x83,0x8B
.db    0x85,0x7C
.db    0x74,0x78
.db    0x89,0x93
.db    0x7E,0x76
.db    0x77,0x80
.db    0x86,0x88
.db    0x7D,0x79
.db    0x85,0x83
.db    0x82,0x7B
.db    0x80,0x7F
.db    0x7F,0x89
.db    0x7C,0x72
.db    0x7C,0x82
.db    0x82,0x88
.db    0x7B,0x76
.db    0x70,0x70
.db    0x90,0x94
.db    0x7D,0x70
.db    0x72,0x79
.db    0x84,0x85
.db    0x7F,0x7E
.db    0x7A,0x7F
.db    0x7F,0x7E
.db    0x78,0x78
.db    0x84,0x81
.db    0x7A,0x86
.db    0x7E,0x70
.db    0x7A,0x83
.db    0x8C,0x89
.db    0x79,0x74
.db    0x7E,0x80
.db    0x88,0x8A
.db    0x7B,0x74
.db    0x75,0x80
.db    0x89,0x86
.db    0x7C,0x74
.db    0x76,0x89
.db    0x93,0x81
.db    0x75,0x77
.db    0x82,0x88
.db    0x8A,0x7E
.db    0x7B,0x7B
.db    0x7E,0x7E
.db    0x86,0x88
.db    0x79,0x78
.db    0x85,0x83
.db    0x7D,0x85
.db    0x86,0x7E
.db    0x7C,0x81
.db    0x7D,0x86
.db    0x87,0x81
.db    0x80,0x7A
.db    0x76,0x86
.db    0x89,0x7B
.db    0x6F,0x89
.db    0x88,0x77
.db    0x78,0x85
.db    0x7E,0x80
.db    0x80,0x7B
.db    0x7C,0x88
.db    0x8A,0x7F
.db    0x79,0x71
.db    0x84,0x95
.db    0x7D,0x76
.db    0x7E,0x82
.db    0x80,0x81
.db    0x7C,0x7B
.db    0x7D,0x8B
.db    0x7B,0x72
.db    0x7E,0x81
.db    0x83,0x7F
.db    0x74,0x79
.db    0x81,0x84
.db    0x80,0x70
.db    0x72,0x7F
.db    0x85,0x80
.db    0x6D,0x72
.db    0x80,0x7F
.db    0x7A,0x75
.db    0x7D,0x7D
.db    0x79,0x83
.db    0x7C,0x80
.db    0x84,0x72
.db    0x7D,0x84
.db    0x83,0x82
.db    0x79,0x7D
.db    0x7E,0x80
.db    0x82,0x80
.db    0x7F,0x81
.db    0x74,0x7D
.db    0x95,0x7F
.db    0x74,0x7F
.db    0x7F,0x83
.db    0x82,0x7C
.db    0x7F,0x7A
.db    0x75,0x80
.db    0x85,0x84
.db    0x79,0x72
.db    0x7C,0x7E
.db    0x85,0x85
.db    0x71,0x72
.db    0x88,0x86
.db    0x7E,0x72
.db    0x7B,0x89
.db    0x83,0x78
.db    0x78,0x84
.db    0x87,0x82
.db    0x78,0x79
.db    0x85,0x89
.db    0x80,0x80
.db    0x86,0x84
.db    0x7D,0x7D
.db    0x89,0x8C
.db    0x83,0x7B
.db    0x7D,0x8A
.db    0x86,0x78
.db    0x7A,0x80
.db    0x83,0x83
.db    0x79,0x7C
.db    0x7C,0x7D
.db    0x85,0x81
.db    0x82,0x80
.db    0x7A,0x79
.db    0x84,0x8E
.db    0x8A,0x7A
.db    0x76,0x7B
.db    0x8E,0x8E
.db    0x84,0x7C
.db    0x84,0x84
.db    0x84,0x8A
.db    0x81,0x83
.db    0x89,0x8B
.db    0x7B,0x7A
.db    0x8E,0x8A
.db    0x7B,0x7F
.db    0x84,0x83
.db    0x7E,0x82
.db    0x89,0x79
.db    0x7F,0x7F
.db    0x85,0x81
.db    0x75,0x78
.db    0x81,0x83
.db    0x7D,0x7E
.db    0x78,0x79
.db    0x87,0x83
.db    0x78,0x79
.db    0x86,0x84
.db    0x7F,0x78
.db    0x7D,0x82
.db    0x88,0x7E
.db    0x79,0x80
.db    0x7E,0x86
.db    0x83,0x7A
.db    0x83,0x7D
.db    0x7C,0x80
.db    0x81,0x84
.db    0x7B,0x77
.db    0x7C,0x7C
.db    0x7C,0x78
.db    0x7A,0x7E
.db    0x74,0x7A
.db    0x7B,0x77
.db    0x7E,0x7C
.db    0x73,0x7F
.db    0x82,0x7F
.db    0x7E,0x7D
.db    0x7B,0x87
.db    0x8A,0x7A
.db    0x75,0x83
.db    0x83,0x86
.db    0x83,0x74
.db    0x75,0x87
.db    0x87,0x77
.db    0x7A,0x80
.db    0x82,0x7D
.db    0x80,0x7B
.db    0x79,0x7F
.db    0x82,0x7D
.db    0x77,0x7D
.db    0x85,0x7A
.db    0x7A,0x7F
.db    0x7A,0x7D
.db    0x83,0x79
.db    0x78,0x76
.db    0x79,0x7D
.db    0x81,0x7C
.db    0x74,0x78
.db    0x7F,0x7F
.db    0x7A,0x76
.db    0x7E,0x89
.db    0x7C,0x79
.db    0x87,0x7E
.db    0x7F,0x84
.db    0x84,0x81
.db    0x84,0x88
.db    0x82,0x78
.db    0x90,0x8F
.db    0x7E,0x76
.db    0x80,0x90
.db    0x83,0x7A
.db    0x81,0x7F
.db    0x7D,0x7B
.db    0x89,0x82
.db    0x71,0x7A
.db    0x88,0x85
.db    0x7B,0x76
.db    0x7E,0x81
.db    0x83,0x85
.db    0x79,0x7B
.db    0x87,0x80
.db    0x81,0x81
.db    0x86,0x86
.db    0x7A,0x7D
.db    0x85,0x87
.db    0x82,0x7F
.db    0x86,0x81
.db    0x7C,0x81
.db    0x8C,0x83
.db    0x7B,0x7F
.db    0x82,0x85
.db    0x87,0x7D
.db    0x79,0x7D
.db    0x86,0x89
.db    0x7D,0x7B
.db    0x7F,0x7E
.db    0x84,0x80
.db    0x7F,0x7C
.db    0x7E,0x84
.db    0x83,0x7C
.db    0x7B,0x81
.db    0x85,0x7C
.db    0x7C,0x7C
.db    0x87,0x87
.db    0x79,0x7A
.db    0x83,0x86
.db    0x84,0x81
.db    0x7F,0x82
.db    0x83,0x83
.db    0x7F,0x79
.db    0x84,0x89
.db    0x81,0x79
.db    0x7A,0x80
.db    0x86,0x81
.db    0x7B,0x7D
.db    0x80,0x82
.db    0x81,0x7D
.db    0x79,0x79
.db    0x7D,0x7F
.db    0x7F,0x7F
.db    0x7A,0x6C
.db    0x78,0x8E
.db    0x87,0x74
.db    0x74,0x7F
.db    0x89,0x86
.db    0x7B,0x7B
.db    0x84,0x88
.db    0x84,0x7C
.db    0x7A,0x85
.db    0x88,0x7F
.db    0x78,0x82
.db    0x84,0x7E
.db    0x7B,0x77
.db    0x82,0x82
.db    0x7B,0x7A
.db    0x7D,0x7B
.db    0x79,0x79
.db    0x79,0x7C
.db    0x74,0x77
.db    0x7F,0x77
.db    0x7B,0x7C
.db    0x7F,0x7D
.db    0x7B,0x80
.db    0x81,0x7A
.db    0x80,0x7D
.db    0x7C,0x83
.db    0x84,0x7F
.db    0x7D,0x7F
.db    0x85,0x81
.db    0x78,0x79
.db    0x89,0x88
.db    0x77,0x7A
.db    0x81,0x81
.db    0x7C,0x80
.db    0x80,0x7A
.db    0x7A,0x86
.db    0x86,0x75
.db    0x77,0x82
.db    0x83,0x81
.db    0x7C,0x7D
.db    0x84,0x82
.db    0x80,0x7E
.db    0x77,0x89
.db    0x86,0x77
.db    0x7D,0x7F
.db    0x8A,0x83
.db    0x79,0x7F
.db    0x84,0x90
.db    0x83,0x76
.db    0x7B,0x86
.db    0x8A,0x83
.db    0x77,0x7B
.db    0x85,0x88
.db    0x83,0x79
.db    0x78,0x89
.db    0x8D,0x7D
.db    0x79,0x7F
.db    0x87,0x8A
.db    0x85,0x7B
.db    0x80,0x87
.db    0x85,0x7E
.db    0x80,0x7E
.db    0x82,0x83
.db    0x7D,0x76
.db    0x7C,0x88
.db    0x80,0x76
.db    0x77,0x81
.db    0x85,0x7C
.db    0x77,0x78
.db    0x7B,0x7D
.db    0x80,0x76
.db    0x73,0x7F
.db    0x80,0x75
.db    0x75,0x79
.db    0x7F,0x80
.db    0x7B,0x74
.db    0x77,0x7F
.db    0x82,0x7D
.db    0x76,0x78
.db    0x86,0x84
.db    0x7C,0x77
.db    0x7C,0x84
.db    0x88,0x7F
.db    0x7A,0x80
.db    0x7F,0x8E
.db    0x88,0x79
.db    0x80,0x88
.db    0x8A,0x82
.db    0x7A,0x8C
.db    0x8D,0x87
.db    0x84,0x82
.db    0x86,0x8E
.db    0x87,0x83
.db    0x89,0x8D
.db    0x85,0x82
.db    0x82,0x8A
.db    0x8D,0x86
.db    0x7B,0x80
.db    0x8A,0x8F
.db    0x84,0x79
.db    0x80,0x89
.db    0x8A,0x85
.db    0x7E,0x7D
.db    0x84,0x85
.db    0x83,0x7E
.db    0x7A,0x7F
.db    0x81,0x7D
.db    0x76,0x77
.db    0x78,0x78
.db    0x75,0x74
.db    0x73,0x70
.db    0x6F,0x6D
.db    0x6A,0x6D
.db    0x70,0x64
.db    0x5F,0x68
.db    0x6E,0x66
.db    0x65,0x69
.db    0x66,0x66
.db    0x67,0x69
.db    0x72,0x6F
.db    0x6D,0x6F
.db    0x70,0x74
.db    0x7C,0x80
.db    0x7F,0x78
.db    0x7A,0x86
.db    0x8E,0x8A
.db    0x86,0x88
.db    0x8F,0x92
.db    0x95,0x91
.db    0x92,0x99
.db    0x95,0x98
.db    0x9A,0x97
.db    0x98,0x97
.db    0x97,0x98
.db    0x9B,0x94
.db    0x91,0x94
.db    0x95,0x9A
.db    0x91,0x8C
.db    0x8E,0x90
.db    0x95,0x8F
.db    0x8D,0x86
.db    0x84,0x91
.db    0x93,0x86
.db    0x7F,0x84
.db    0x8A,0x89
.db    0x84,0x80
.db    0x7F,0x7B
.db    0x7E,0x81
.db    0x79,0x75
.db    0x72,0x70
.db    0x76,0x73
.db    0x6C,0x66
.db    0x62,0x65
.db    0x68,0x66
.db    0x5D,0x58
.db    0x58,0x5C
.db    0x5F,0x5C
.db    0x54,0x50
.db    0x56,0x61
.db    0x5E,0x56
.db    0x56,0x5A
.db    0x62,0x68
.db    0x66,0x64
.db    0x65,0x6C
.db    0x76,0x7E
.db    0x76,0x75
.db    0x7F,0x8E
.db    0x8C,0x91
.db    0x96,0x93
.db    0x98,0xA4
.db    0xAB,0xAB
.db    0xA2,0xAC
.db    0xB9,0xB6
.db    0xB6,0xB5
.db    0xB9,0xB8
.db    0xBD,0xC2
.db    0xBB,0xB5
.db    0xB4,0xBA
.db    0xBA,0xB0
.db    0xAC,0xAC
.db    0xA7,0xA5
.db    0xA1,0x9D
.db    0x93,0x8A
.db    0x8C,0x88
.db    0x7F,0x7C
.db    0x72,0x6B
.db    0x6A,0x66
.db    0x62,0x5E
.db    0x55,0x51
.db    0x51,0x4C
.db    0x48,0x47
.db    0x42,0x42
.db    0x40,0x40
.db    0x41,0x41
.db    0x3F,0x40
.db    0x42,0x46
.db    0x4B,0x4C
.db    0x4B,0x4B
.db    0x53,0x5E
.db    0x5D,0x5C
.db    0x5E,0x65
.db    0x71,0x72
.db    0x73,0x76
.db    0x79,0x85
.db    0x8B,0x8E
.db    0x8F,0x93
.db    0xA5,0xA5
.db    0xA4,0xAF
.db    0xBB,0xBC
.db    0xBC,0xC2
.db    0xCD,0xD5
.db    0xD1,0xCC
.db    0xD1,0xD8
.db    0xD8,0xD8
.db    0xCF,0xC3
.db    0xCA,0xCD
.db    0xC3,0xB7
.db    0xAA,0xA9
.db    0xA8,0x9D
.db    0x92,0x86
.db    0x78,0x75
.db    0x76,0x6A
.db    0x56,0x4F
.db    0x4C,0x4A
.db    0x44,0x3C
.db    0x36,0x31
.db    0x2C,0x30
.db    0x32,0x2F
.db    0x29,0x28
.db    0x30,0x33
.db    0x37,0x39
.db    0x36,0x37
.db    0x43,0x4F
.db    0x4E,0x49
.db    0x4E,0x58
.db    0x5F,0x5D
.db    0x63,0x6A
.db    0x6C,0x6E
.db    0x79,0x7B
.db    0x7C,0x85
.db    0x8E,0x92
.db    0x95,0x9B
.db    0xA5,0xAD
.db    0xAF,0xB1
.db    0xB8,0xC2
.db    0xCD,0xCC
.db    0xC2,0xCE
.db    0xE2,0xDF
.db    0xCF,0xD8
.db    0xE0,0xDE
.db    0xD4,0xD1
.db    0xD6,0xCE
.db    0xC1,0xC1
.db    0xBD,0xAC
.db    0xA4,0x9D
.db    0x96,0x8E
.db    0x83,0x76
.db    0x6C,0x64
.db    0x61,0x59
.db    0x4B,0x3F
.db    0x3E,0x3E
.db    0x39,0x2F
.db    0x29,0x2A
.db    0x2E,0x2D
.db    0x29,0x29
.db    0x2C,0x31
.db    0x33,0x34
.db    0x37,0x3A
.db    0x41,0x4A
.db    0x46,0x44
.db    0x4F,0x5A
.db    0x5B,0x59
.db    0x5E,0x68
.db    0x6D,0x6A
.db    0x72,0x7E
.db    0x84,0x88
.db    0x8B,0x91
.db    0x9F,0xA5
.db    0xA9,0xAC
.db    0xB0,0xBD
.db    0xCA,0xC8
.db    0xC5,0xCE
.db    0xD8,0xD9
.db    0xD5,0xD5
.db    0xE9,0xE2
.db    0xCB,0xCD
.db    0xD9,0xDB
.db    0xCE,0xB6
.db    0xB0,0xB9
.db    0xB2,0xA8
.db    0x98,0x85
.db    0x82,0x85
.db    0x79,0x6A
.db    0x5E,0x56
.db    0x52,0x52
.db    0x48,0x40
.db    0x38,0x36
.db    0x39,0x37
.db    0x2E,0x30
.db    0x35,0x33
.db    0x30,0x34
.db    0x3A,0x3E
.db    0x3C,0x3D
.db    0x47,0x4D
.db    0x4F,0x51
.db    0x4E,0x52
.db    0x5E,0x6B
.db    0x68,0x5E
.db    0x5C,0x6E
.db    0x83,0x83
.db    0x75,0x77
.db    0x8A,0x9A
.db    0x9D,0x99
.db    0x9E,0xA8
.db    0xAE,0xB7
.db    0xC5,0xBF
.db    0xC0,0xCA
.db    0xD2,0xD7
.db    0xD7,0xD3
.db    0xDA,0xDF
.db    0xDF,0xD4
.db    0xCD,0xD2
.db    0xD9,0xCC
.db    0xB8,0xB3
.db    0xB9,0xB2
.db    0xA4,0x93
.db    0x86,0x87
.db    0x84,0x78
.db    0x67,0x5D
.db    0x5D,0x5C
.db    0x52,0x46
.db    0x45,0x43
.db    0x40,0x3C
.db    0x3B,0x3C
.db    0x3A,0x35
.db    0x3B,0x3F
.db    0x40,0x40
.db    0x3B,0x3F
.db    0x47,0x4E
.db    0x4F,0x4A
.db    0x44,0x4F
.db    0x5B,0x5F
.db    0x58,0x52
.db    0x52,0x69
.db    0x78,0x6E
.db    0x62,0x6B
.db    0x87,0x94
.db    0x8B,0x84
.db    0x92,0xA2
.db    0xAF,0xB0
.db    0xB0,0xB7
.db    0xC2,0xCB
.db    0xCA,0xCB
.db    0xD2,0xDA
.db    0xDF,0xD7
.db    0xD1,0xD0
.db    0xDB,0xDA
.db    0xCD,0xBD
.db    0xB8,0xC0
.db    0xBB,0xA7
.db    0x99,0x92
.db    0x94,0x89
.db    0x79,0x73
.db    0x70,0x61
.db    0x56,0x55
.db    0x50,0x4E
.db    0x47,0x3E
.db    0x39,0x35
.db    0x3A,0x3F
.db    0x37,0x30
.db    0x32,0x3C
.db    0x3F,0x3C
.db    0x38,0x3C
.db    0x48,0x4F
.db    0x49,0x44
.db    0x48,0x56
.db    0x61,0x5E
.db    0x54,0x54
.db    0x6D,0x78
.db    0x75,0x6D
.db    0x74,0x8E
.db    0x94,0x91
.db    0x95,0x9B
.db    0xAA,0xB4
.db    0xB8,0xBA
.db    0xBC,0xC7
.db    0xD1,0xD3
.db    0xD4,0xD6
.db    0xD5,0xD7
.db    0xE1,0xE4
.db    0xD8,0xC6
.db    0xC6,0xD3
.db    0xCF,0xBD
.db    0xA9,0xA1
.db    0xA2,0x9F
.db    0x94,0x82
.db    0x71,0x6E
.db    0x6D,0x67
.db    0x56,0x48
.db    0x45,0x4A
.db    0x44,0x3B
.db    0x35,0x34
.db    0x35,0x2E
.db    0x30,0x39
.db    0x37,0x2F
.db    0x2F,0x38
.db    0x48,0x44
.db    0x3E,0x3F
.db    0x4C,0x55
.db    0x53,0x4F
.db    0x54,0x62
.db    0x68,0x5E
.db    0x5E,0x76
.db    0x82,0x7A
.db    0x79,0x7F
.db    0x91,0x9F
.db    0x9A,0x9F
.db    0xA5,0xA7
.db    0xBA,0xC3
.db    0xBB,0xBF
.db    0xCB,0xCC
.db    0xD1,0xD4
.db    0xD0,0xD4
.db    0xD1,0xDB
.db    0xE0,0xC8
.db    0xBE,0xC9
.db    0xCE,0xC3
.db    0xB1,0xA4
.db    0xA6,0xA3
.db    0x99,0x8C
.db    0x7E,0x77
.db    0x74,0x6F
.db    0x63,0x59
.db    0x53,0x52
.db    0x4E,0x45
.db    0x41,0x42
.db    0x40,0x39
.db    0x35,0x3A
.db    0x3E,0x3B
.db    0x3A,0x39
.db    0x40,0x44
.db    0x43,0x42
.db    0x43,0x4D
.db    0x56,0x53
.db    0x4C,0x52
.db    0x5D,0x61
.db    0x5C,0x63
.db    0x6F,0x74
.db    0x6D,0x73
.db    0x81,0x8B
.db    0x91,0x8F
.db    0x97,0x9F
.db    0xA1,0xAF
.db    0xB9,0xB9
.db    0xB9,0xC5
.db    0xCA,0xCD
.db    0xD1,0xCD
.db    0xD4,0xD7
.db    0xD7,0xDD
.db    0xD2,0xC4
.db    0xC9,0xD1
.db    0xC6,0xBA
.db    0xAA,0xA6
.db    0xA9,0xA1
.db    0x91,0x85
.db    0x7A,0x78
.db    0x79,0x6F
.db    0x5E,0x58
.db    0x55,0x53
.db    0x4E,0x49
.db    0x44,0x40
.db    0x3B,0x3C
.db    0x3D,0x3C
.db    0x3B,0x39
.db    0x3B,0x39
.db    0x3D,0x41
.db    0x42,0x40
.db    0x46,0x48
.db    0x49,0x48
.db    0x51,0x57
.db    0x52,0x4F
.db    0x61,0x6E
.db    0x6E,0x66
.db    0x6B,0x82
.db    0x8F,0x94
.db    0x92,0x91
.db    0x9F,0xB4
.db    0xBB,0xB9
.db    0xBB,0xC4
.db    0xCD,0xD1
.db    0xD6,0xD5
.db    0xD6,0xD7
.db    0xD5,0xE2
.db    0xE3,0xCF
.db    0xC4,0xC5
.db    0xCE,0xCA
.db    0xB3,0xA2
.db    0xA2,0x9F
.db    0x99,0x8D
.db    0x7B,0x70
.db    0x6E,0x6A
.db    0x63,0x56
.db    0x4D,0x46
.db    0x43,0x44
.db    0x41,0x38
.db    0x32,0x33
.db    0x33,0x34
.db    0x33,0x37
.db    0x38,0x35
.db    0x32,0x3A
.db    0x41,0x44
.db    0x46,0x48
.db    0x48,0x4C
.db    0x51,0x5E
.db    0x61,0x53
.db    0x59,0x72
.db    0x80,0x7B
.db    0x71,0x78
.db    0x95,0xA3
.db    0xA4,0xA0
.db    0x99,0xB0
.db    0xC8,0xC4
.db    0xC3,0xC5
.db    0xC9,0xDB
.db    0xD6,0xD8
.db    0xDD,0xD3
.db    0xD5,0xE2
.db    0xDC,0xD5
.db    0xC5,0xC1
.db    0xCA,0xC4
.db    0xB4,0xA6
.db    0x9D,0x98
.db    0x96,0x8B
.db    0x79,0x70
.db    0x69,0x65
.db    0x60,0x53
.db    0x4D,0x44
.db    0x40,0x3F
.db    0x3E,0x39
.db    0x35,0x30
.db    0x2F,0x30
.db    0x32,0x38
.db    0x36,0x32
.db    0x33,0x37
.db    0x40,0x44
.db    0x44,0x43
.db    0x45,0x4C
.db    0x56,0x5B
.db    0x57,0x51
.db    0x60,0x73
.db    0x7C,0x75
.db    0x74,0x81
.db    0x93,0x9D
.db    0x9F,0xAB
.db    0xAB,0xAA
.db    0xBF,0xC8
.db    0xCD,0xCF
.db    0xCB,0xCE
.db    0xDB,0xDE
.db    0xE2,0xD5
.db    0xC8,0xD9
.db    0xDF,0xD9
.db    0xC8,0xBD
.db    0xBC,0xBB
.db    0xB7,0xAF
.db    0x9C,0x8D
.db    0x8B,0x8D
.db    0x83,0x72
.db    0x67,0x60
.db    0x5D,0x59
.db    0x53,0x4B
.db    0x42,0x3D
.db    0x3D,0x3C
.db    0x3C,0x3B
.db    0x34,0x31
.db    0x33,0x36
.db    0x3E,0x43
.db    0x3B,0x35
.db    0x39,0x46
.db    0x4F,0x51
.db    0x4B,0x4A
.db    0x50,0x5F
.db    0x69,0x5F
.db    0x5E,0x6B
.db    0x7C,0x7F
.db    0x7C,0x7F
.db    0x92,0x9C
.db    0x99,0x9F
.db    0xA5,0xB2
.db    0xBA,0xB8
.db    0xB4,0xC3
.db    0xD1,0xD0
.db    0xC6,0xBC
.db    0xC9,0xD7
.db    0xD1,0xC5
.db    0xC2,0xC1
.db    0xC5,0xC4
.db    0xB4,0xAC
.db    0xAE,0xA7
.db    0x9E,0x95
.db    0x8B,0x8A
.db    0x82,0x77
.db    0x70,0x69
.db    0x64,0x62
.db    0x59,0x4E
.db    0x4B,0x48
.db    0x48,0x45
.db    0x3C,0x3A
.db    0x39,0x38
.db    0x3A,0x38
.db    0x36,0x37
.db    0x37,0x3B
.db    0x3C,0x3E
.db    0x3E,0x45
.db    0x4D,0x4C
.db    0x4F,0x57
.db    0x5B,0x59
.db    0x63,0x75
.db    0x7C,0x78
.db    0x7C,0x8B
.db    0x99,0xA3
.db    0xA7,0xAE
.db    0xAB,0xB6
.db    0xCA,0xCD
.db    0xC5,0xC7
.db    0xD0,0xD8
.db    0xDE,0xD0
.db    0xCC,0xD4
.db    0xCF,0xCF
.db    0xCD,0xBE
.db    0xC5,0xBF
.db    0xAE,0xB3
.db    0xAB,0x9F
.db    0x99,0x87
.db    0x89,0x89
.db    0x76,0x6E
.db    0x67,0x5F
.db    0x60,0x57
.db    0x50,0x4C
.db    0x42,0x43
.db    0x42,0x3D
.db    0x3B,0x35
.db    0x38,0x38
.db    0x37,0x34
.db    0x34,0x38
.db    0x3C,0x3D
.db    0x3C,0x3A
.db    0x41,0x4A
.db    0x4F,0x4B
.db    0x4A,0x59
.db    0x61,0x5E
.db    0x5C,0x6C
.db    0x7D,0x83
.db    0x7F,0x7D
.db    0x8F,0xA0
.db    0xAE,0xAC
.db    0xA2,0xB0
.db    0xC5,0xCC
.db    0xCC,0xC7
.db    0xC8,0xD8
.db    0xD8,0xDA
.db    0xDA,0xCB
.db    0xCD,0xD3
.db    0xD0,0xCD
.db    0xBF,0xB9
.db    0xBD,0xB7
.db    0xA7,0xA1
.db    0x9B,0x98
.db    0x8D,0x7F
.db    0x77,0x74
.db    0x6B,0x62
.db    0x5B,0x55
.db    0x54,0x4D
.db    0x44,0x45
.db    0x3F,0x40
.db    0x40,0x3B
.db    0x3D,0x3E
.db    0x3B,0x3B
.db    0x3D,0x42
.db    0x45,0x46
.db    0x44,0x47
.db    0x48,0x50
.db    0x54,0x57
.db    0x59,0x5E
.db    0x61,0x65
.db    0x66,0x6C
.db    0x79,0x7B
.db    0x82,0x88
.db    0x8B,0x99
.db    0xA3,0xA8
.db    0xAB,0xAC
.db    0xBE,0xCA
.db    0xC6,0xC6
.db    0xCF,0xD2
.db    0xD5,0xD2
.db    0xD3,0xD4
.db    0xC6,0xC7
.db    0xC7,0xBF
.db    0xBB,0xAE
.db    0xAD,0xAB
.db    0xA1,0x98
.db    0x93,0x89
.db    0x87,0x84
.db    0x7A,0x71
.db    0x6B,0x6A
.db    0x65,0x5F
.db    0x5C,0x5A
.db    0x53,0x51
.db    0x4F,0x4F
.db    0x4A,0x4A
.db    0x4A,0x47
.db    0x46,0x48
.db    0x45,0x45
.db    0x49,0x45
.db    0x45,0x47
.db    0x47,0x47
.db    0x44,0x44
.db    0x4C,0x49
.db    0x4D,0x55
.db    0x52,0x53
.db    0x5A,0x67
.db    0x6F,0x73
.db    0x75,0x81
.db    0x8D,0x98
.db    0xA6,0xAA
.db    0xAB,0xBB
.db    0xC4,0xD0
.db    0xDA,0xD9
.db    0xDA,0xDD
.db    0xE0,0xEE
.db    0xEA,0xDB
.db    0xD8,0xD7
.db    0xD4,0xCF
.db    0xC6,0xBD
.db    0xB5,0xA8
.db    0xA3,0xA0
.db    0x94,0x8B
.db    0x7F,0x76
.db    0x74,0x72
.db    0x6B,0x61
.db    0x56,0x58
.db    0x5A,0x58
.db    0x53,0x4E
.db    0x4E,0x51
.db    0x53,0x55
.db    0x53,0x52
.db    0x55,0x58
.db    0x59,0x57
.db    0x58,0x5C
.db    0x5E,0x59
.db    0x57,0x57
.db    0x58,0x52
.db    0x4D,0x53
.db    0x4F,0x4C
.db    0x45,0x4B
.db    0x51,0x4D
.db    0x49,0x4B
.db    0x55,0x60
.db    0x6B,0x6B
.db    0x6D,0x76
.db    0x88,0x9B
.db    0xA0,0xA3
.db    0xAA,0xBB
.db    0xCA,0xCF
.db    0xD3,0xD6
.db    0xDC,0xDC
.db    0xDE,0xE1
.db    0xDF,0xD7
.db    0xCE,0xCA
.db    0xC4,0xC0
.db    0xB4,0xAA
.db    0x9A,0x96
.db    0x8B,0x88
.db    0x7E,0x73
.db    0x69,0x6A
.db    0x66,0x63
.db    0x5C,0x57
.db    0x5B,0x5B
.db    0x5C,0x5D
.db    0x59,0x5D
.db    0x65,0x67
.db    0x65,0x67
.db    0x69,0x71
.db    0x72,0x73
.db    0x74,0x6E
.db    0x6E,0x76
.db    0x74,0x6E
.db    0x64,0x60
.db    0x63,0x5A
.db    0x52,0x54
.db    0x53,0x42
.db    0x35,0x3E
.db    0x4A,0x46
.db    0x36,0x35
.db    0x45,0x53
.db    0x5B,0x5E
.db    0x58,0x6C
.db    0x85,0x92
.db    0x98,0x97
.db    0xAF,0xC3
.db    0xBF,0xC5
.db    0xD9,0xE6
.db    0xE9,0xD7
.db    0xD8,0xE0
.db    0xEB,0xED
.db    0xD5,0xBB
.db    0xBD,0xCC
.db    0xC8,0xA8
.db    0x8D,0x8E
.db    0x8D,0x8D
.db    0x81,0x68
.db    0x65,0x63
.db    0x60,0x5E
.db    0x59,0x5F
.db    0x58,0x49
.db    0x56,0x67
.db    0x65,0x66
.db    0x64,0x66
.db    0x6F,0x77
.db    0x80,0x7C
.db    0x72,0x7B
.db    0x8B,0x84
.db    0x7A,0x79
.db    0x7A,0x78
.db    0x74,0x6E
.db    0x66,0x58
.db    0x59,0x5D
.db    0x4B,0x3B
.db    0x39,0x3D
.db    0x30,0x2B
.db    0x33,0x33
.db    0x27,0x23
.db    0x37,0x47
.db    0x4A,0x4B
.db    0x52,0x64
.db    0x7F,0x8D
.db    0x91,0x99
.db    0xAB,0xC6
.db    0xD7,0xDA
.db    0xDC,0xE6
.db    0xF6,0xF9
.db    0xF7,0xF2
.db    0xF6,0xEE
.db    0xE5,0xD7
.db    0xD5,0xCE
.db    0xBC,0xAA
.db    0x9E,0x95
.db    0x88,0x7C
.db    0x6E,0x5F
.db    0x52,0x56
.db    0x59,0x45
.db    0x3C,0x3D
.db    0x41,0x48
.db    0x48,0x54
.db    0x4B,0x52
.db    0x62,0x70
.db    0x76,0x73
.db    0x7D,0x8B
.db    0x96,0x9A
.db    0x96,0x98
.db    0x9F,0xA9
.db    0xA8,0xA0
.db    0x98,0x98
.db    0x98,0x96
.db    0x88,0x83
.db    0x7C,0x71
.db    0x66,0x5C
.db    0x5C,0x55
.db    0x49,0x3D
.db    0x36,0x36
.db    0x31,0x33
.db    0x2D,0x24
.db    0x1F,0x27
.db    0x34,0x35
.db    0x2E,0x33
.db    0x40,0x47
.db    0x45,0x78
.db    0x8C,0x82
.db    0x7B,0x8A
.db    0xB7,0xD4
.db    0xD5,0xD7
.db    0xC4,0xCE
.db    0xFA,0xFC
.db    0xF4,0xE0
.db    0xD7,0xE4
.db    0xDF,0xD7
.db    0xCC,0xAE
.db    0xA6,0xA4
.db    0x96,0x87
.db    0x79,0x6E
.db    0x60,0x4E
.db    0x4A,0x53
.db    0x4A,0x40
.db    0x3A,0x39
.db    0x41,0x48
.db    0x50,0x52
.db    0x56,0x5F
.db    0x65,0x6C
.db    0x7F,0x89
.db    0x89,0x8C
.db    0x93,0xA6
.db    0xAD,0xA9
.db    0xA4,0xA6
.db    0xAD,0xB0
.db    0xAE,0xA4
.db    0x9B,0x97
.db    0x95,0x91
.db    0x8D,0x86
.db    0x7B,0x6E
.db    0x67,0x6A
.db    0x6E,0x67
.db    0x5A,0x4F
.db    0x51,0x58
.db    0x59,0x57
.db    0x50,0x4A
.db    0x4C,0x50
.db    0x59,0x58
.db    0x51,0x4F
.db    0x50,0x52
.db    0x54,0x55
.db    0x5A,0x51
.db    0x4E,0x4F
.db    0x5D,0x66
.db    0x5C,0x59
.db    0x6B,0x83
.db    0x8E,0x84
.db    0x86,0x9C
.db    0xB1,0xBB
.db    0xBE,0xB8
.db    0xBD,0xCF
.db    0xDF,0xDD
.db    0xCA,0xC8
.db    0xD8,0xD7
.db    0xD0,0xC1
.db    0xB6,0xB5
.db    0xB0,0xA8
.db    0x99,0x88
.db    0x83,0x82
.db    0x71,0x60
.db    0x58,0x59
.db    0x5A,0x4E
.db    0x46,0x44
.db    0x45,0x4D
.db    0x55,0x54
.db    0x52,0x5A
.db    0x6D,0x74
.db    0x73,0x81
.db    0x8B,0x90
.db    0x99,0xA2
.db    0xA6,0xA8
.db    0xAF,0xB6
.db    0xB6,0xAE
.db    0xAE,0xAC
.db    0xA4,0xA4
.db    0xA1,0x93
.db    0x88,0x7E
.db    0x80,0x78
.db    0x6B,0x68
.db    0x5D,0x5B
.db    0x63,0x59
.db    0x52,0x52
.db    0x5C,0x6A
.db    0x60,0x59
.db    0x63,0x71
.db    0x7F,0x7A
.db    0x70,0x79
.db    0x86,0x92
.db    0x8B,0x87
.db    0x93,0x94
.db    0x8D,0x92
.db    0x94,0x96
.db    0x92,0x91
.db    0x8F,0x82
.db    0x7D,0x86
.db    0x8A,0x82
.db    0x75,0x6B
.db    0x64,0x6D
.db    0x82,0x74
.db    0x5D,0x4F
.db    0x61,0x78
.db    0x72,0x68
.db    0x62,0x62
.db    0x6D,0x78
.db    0x80,0x7B
.db    0x71,0x7A
.db    0x7D,0x81
.db    0x8C,0x8B
.db    0x85,0x7E
.db    0x7D,0x87
.db    0x89,0x86
.db    0x82,0x7C
.db    0x79,0x7B
.db    0x7E,0x80
.db    0x72,0x77
.db    0x71,0x6C
.db    0x75,0x77
.db    0x70,0x6A
.db    0x67,0x70
.db    0x6D,0x6D
.db    0x70,0x6F
.db    0x6F,0x6E
.db    0x71,0x7A
.db    0x79,0x7C
.db    0x7A,0x79
.db    0x81,0x87
.db    0x88,0x82
.db    0x81,0x87
.db    0x89,0x8A
.db    0x89,0x83
.db    0x83,0x81
.db    0x81,0x80
.db    0x7D,0x7D
.db    0x7C,0x75
.db    0x76,0x75
.db    0x77,0x7F
.db    0x7E,0x7C
.db    0x77,0x7D
.db    0x8C,0x8F
.db    0x8E,0x8C
.db    0x8F,0x98
.db    0x9C,0xA2
.db    0xA2,0x9E
.db    0xA3,0xA2
.db    0xA4,0xA6
.db    0xA4,0xA1
.db    0x9A,0x99
.db    0x9B,0x96
.db    0x91,0x8E
.db    0x8A,0x89
.db    0x84,0x83
.db    0x82,0x80
.db    0x7F,0x7A
.db    0x7A,0x7E
.db    0x83,0x83
.db    0x7D,0x7E
.db    0x82,0x84
.db    0x87,0x89
.db    0x85,0x82
.db    0x81,0x86
.db    0x84,0x7C
.db    0x7A,0x7A
.db    0x78,0x70
.db    0x69,0x6A
.db    0x67,0x5E
.db    0x58,0x57
.db    0x5B,0x5A
.db    0x51,0x4F
.db    0x50,0x5C
.db    0x68,0x6C
.db    0x69,0x6C
.db    0x77,0x8E
.db    0x97,0x9B
.db    0xA0,0xA9
.db    0xB4,0xBD
.db    0xC3,0xC6
.db    0xC4,0xC3
.db    0xC4,0xC2
.db    0xBD,0xB9
.db    0xB0,0xA2
.db    0x94,0x90
.db    0x8C,0x80
.db    0x73,0x67
.db    0x60,0x59
.db    0x55,0x55
.db    0x50,0x4B
.db    0x4B,0x4C
.db    0x51,0x58
.db    0x61,0x67
.db    0x67,0x6D
.db    0x7B,0x88
.db    0x90,0x92
.db    0x97,0x9E
.db    0xA5,0xAB
.db    0xAB,0xAA
.db    0xA9,0xA8
.db    0xA5,0xA0
.db    0x9A,0x94
.db    0x8C,0x87
.db    0x7F,0x74
.db    0x6D,0x66
.db    0x63,0x5B
.db    0x55,0x54
.db    0x4F,0x4E
.db    0x50,0x4F
.db    0x51,0x54
.db    0x5A,0x60
.db    0x62,0x6B
.db    0x71,0x77
.db    0x7E,0x82
.db    0x88,0x8D
.db    0x94,0x99
.db    0x97,0x97
.db    0x98,0x98
.db    0x99,0x96
.db    0x90,0x8A
.db    0x83,0x82
.db    0x7D,0x75
.db    0x71,0x6B
.db    0x66,0x61
.db    0x5E,0x5E
.db    0x5B,0x5B
.db    0x5C,0x5C
.db    0x5F,0x63
.db    0x68,0x6C
.db    0x71,0x77
.db    0x7E,0x81
.db    0x86,0x8A
.db    0x8E,0x92
.db    0x95,0x96
.db    0x96,0x96
.db    0x96,0x94
.db    0x92,0x8D
.db    0x8B,0x88
.db    0x85,0x81
.db    0x7D,0x79
.db    0x77,0x76
.db    0x75,0x74
.db    0x71,0x70
.db    0x73,0x74
.db    0x76,0x77
.db    0x79,0x7B
.db    0x7E,0x81
.db    0x82,0x84
.db    0x88,0x8A
.db    0x89,0x89
.db    0x8B,0x8C
.db    0x8C,0x8D
.db    0x8C,0x89
.db    0x87,0x87
.db    0x86,0x84
.db    0x83,0x81
.db    0x7F,0x7D
.db    0x7D,0x7D
.db    0x7C,0x7B
.db    0x7B,0x7A
.db    0x7A,0x7B
.db    0x7D,0x7F
.db    0x7F,0x80
.db    0x81,0x82
.db    0x84,0x87
.db    0x88,0x88
.db    0x88,0x89
.db    0x89,0x8A
.db    0x8A,0x89
.db    0x87,0x87
.db    0x85,0x83
.db    0x82,0x80
.db    0x7E,0x7E
.db    0x7E,0x7B
.db    0x7B,0x7A
.db    0x7A,0x7B
.db    0x7C,0x7C
.db    0x7C,0x7D
.db    0x7F,0x80
.db    0x81,0x81
.db    0x82,0x83
.db    0x85,0x86
.db    0x84,0x84
.db    0x85,0x86
.db    0x85,0x84
.db    0x85,0x84
.db    0x83,0x81
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7E,0x7C
.db    0x7A,0x7A
.db    0x7B,0x7D
.db    0x7D,0x7B
.db    0x7A,0x7B
.db    0x7E,0x80
.db    0x80,0x7E
.db    0x7E,0x80
.db    0x81,0x82
.db    0x82,0x81
.db    0x81,0x83
.db    0x83,0x83
.db    0x83,0x82
.db    0x80,0x80
.db    0x81,0x80
.db    0x7F,0x7E
.db    0x7D,0x7C
.db    0x7C,0x7D
.db    0x7B,0x7A
.db    0x7A,0x7B
.db    0x7B,0x7A
.db    0x79,0x79
.db    0x7A,0x7D
.db    0x7E,0x7D
.db    0x7D,0x7E
.db    0x7F,0x81
.db    0x84,0x84
.db    0x84,0x82
.db    0x81,0x81
.db    0x84,0x84
.db    0x81,0x7F
.db    0x7F,0x7E
.db    0x7C,0x7C
.db    0x7C,0x7B
.db    0x78,0x78
.db    0x78,0x7A
.db    0x79,0x77
.db    0x79,0x79
.db    0x79,0x7A
.db    0x7B,0x7D
.db    0x7D,0x7E
.db    0x7F,0x80
.db    0x80,0x82
.db    0x83,0x81
.db    0x80,0x81
.db    0x80,0x80
.db    0x81,0x81
.db    0x80,0x7E
.db    0x7D,0x7C
.db    0x7C,0x7C
.db    0x7F,0x7E
.db    0x7D,0x7C
.db    0x7B,0x7E
.db    0x80,0x76
.db    0x78,0x8E
.db    0x92,0x85
.db    0x79,0x75
.db    0x84,0x8C
.db    0x90,0x86
.db    0x72,0x6E
.db    0x79,0x85
.db    0x84,0x77
.db    0x70,0x68
.db    0x6A,0x72
.db    0x74,0x73
.db    0x6A,0x63
.db    0x65,0x65
.db    0x69,0x6F
.db    0x72,0x6E
.db    0x67,0x67
.db    0x70,0x6F
.db    0x6F,0x86
.db    0x9B,0x91
.db    0x81,0x7F
.db    0x8F,0xA4
.db    0xB2,0xAE
.db    0x9D,0x90
.db    0x96,0xAA
.db    0xB1,0xA8
.db    0x99,0x8D
.db    0x89,0x8E
.db    0x8F,0x8B
.db    0x81,0x74
.db    0x6C,0x6B
.db    0x6B,0x6D
.db    0x6F,0x69
.db    0x61,0x5C
.db    0x61,0x6E
.db    0x75,0x76
.db    0x76,0x73
.db    0x78,0x84
.db    0x90,0x93
.db    0x93,0x92
.db    0x93,0x97
.db    0x9B,0x9F
.db    0x9F,0x98
.db    0x93,0x8F
.db    0x8F,0x90
.db    0x89,0x82
.db    0x7D,0x77
.db    0x73,0x73
.db    0x73,0x6E
.db    0x67,0x65
.db    0x66,0x69
.db    0x6D,0x6E
.db    0x6E,0x6F
.db    0x72,0x77
.db    0x7B,0x7F
.db    0x82,0x86
.db    0x89,0x89
.db    0x8B,0x8D
.db    0x8F,0x8F
.db    0x8D,0x8D
.db    0x8C,0x89
.db    0x87,0x84
.db    0x81,0x7C
.db    0x79,0x79
.db    0x77,0x73
.db    0x71,0x6F
.db    0x6D,0x6C
.db    0x6F,0x71
.db    0x72,0x71
.db    0x71,0x74
.db    0x78,0x7E
.db    0x82,0x84
.db    0x85,0x84
.db    0x88,0x8D
.db    0x8F,0x90
.db    0x8F,0x8D
.db    0x8A,0x88
.db    0x88,0x88
.db    0x86,0x81
.db    0x7D,0x78
.db    0x74,0x73
.db    0x77,0x78
.db    0x72,0x6F
.db    0x6E,0x6F
.db    0x73,0x76
.db    0x79,0x77
.db    0x77,0x7A
.db    0x7D,0x80
.db    0x85,0x88
.db    0x88,0x88
.db    0x88,0x88
.db    0x89,0x8A
.db    0x8A,0x87
.db    0x83,0x81
.db    0x80,0x80
.db    0x7E,0x7C
.db    0x7A,0x77
.db    0x77,0x75
.db    0x75,0x75
.db    0x75,0x76
.db    0x78,0x78
.db    0x78,0x7A
.db    0x7B,0x7E
.db    0x81,0x85
.db    0x87,0x87
.db    0x87,0x89
.db    0x8A,0x8C
.db    0x8B,0x8A
.db    0x87,0x87
.db    0x87,0x85
.db    0x82,0x7F
.db    0x7D,0x7D
.db    0x7D,0x7C
.db    0x7A,0x77
.db    0x77,0x79
.db    0x7A,0x7B
.db    0x7A,0x7A
.db    0x7A,0x7E
.db    0x80,0x82
.db    0x83,0x82
.db    0x83,0x84
.db    0x85,0x85
.db    0x85,0x87
.db    0x86,0x85
.db    0x83,0x81
.db    0x81,0x82
.db    0x81,0x7F
.db    0x7E,0x7E
.db    0x7D,0x7D
.db    0x7E,0x7E
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x81
.db    0x82,0x82
.db    0x82,0x81
.db    0x80,0x80
.db    0x82,0x82
.db    0x81,0x80
.db    0x7E,0x7D
.db    0x7D,0x7F
.db    0x7F,0x7C
.db    0x7C,0x7C
.db    0x7D,0x7F
.db    0x7E,0x7E
.db    0x7E,0x7F
.db    0x82,0x82
.db    0x80,0x80
.db    0x82,0x83
.db    0x83,0x83
.db    0x82,0x82
.db    0x82,0x82
.db    0x82,0x80
.db    0x80,0x82
.db    0x83,0x81
.db    0x81,0x7F
.db    0x7F,0x81
.db    0x83,0x83
.db    0x82,0x80
.db    0x80,0x82
.db    0x83,0x83
.db    0x83,0x83
.db    0x83,0x83
.db    0x84,0x84
.db    0x83,0x82
.db    0x83,0x84
.db    0x83,0x83
.db    0x82,0x81
.db    0x81,0x81
.db    0x81,0x80
.db    0x7F,0x81
.db    0x83,0x82
.db    0x80,0x7F
.db    0x80,0x80
.db    0x81,0x82
.db    0x7F,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7F,0x7F
.db    0x7D,0x7C
.db    0x7C,0x7E
.db    0x7E,0x7E
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x82,0x82
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7E,0x7D
.db    0x7B,0x79
.db    0x79,0x77
.db    0x76,0x71
.db    0x72,0x70
.db    0x71,0x78
.db    0x75,0x74
.db    0x75,0x7D
.db    0x7E,0x67
.db    0x88,0xA1
.db    0x9B,0x8F
.db    0x77,0x7F
.db    0x8E,0x96
.db    0xA8,0x8C
.db    0x78,0x68
.db    0x74,0x8C
.db    0x7D,0x75
.db    0x6D,0x5E
.db    0x5F,0x59
.db    0x65,0x6E
.db    0x66,0x64
.db    0x58,0x59
.db    0x5F,0x66
.db    0x74,0x72
.db    0x68,0x62
.db    0x61,0x68
.db    0x6E,0x76
.db    0x73,0x6A
.db    0x65,0x64
.db    0x68,0x68
.db    0x68,0x6B
.db    0x68,0x68
.db    0x6A,0x66
.db    0x62,0x6D
.db    0x84,0x97
.db    0x9A,0x96
.db    0x90,0x94
.db    0xA9,0xBC
.db    0xC0,0xBB
.db    0xB0,0xAD
.db    0xB0,0xB4
.db    0xB6,0xAC
.db    0xA4,0x99
.db    0x8E,0x8A
.db    0x87,0x87
.db    0x85,0x7E
.db    0x79,0x75
.db    0x76,0x7B
.db    0x80,0x82
.db    0x84,0x85
.db    0x88,0x8A
.db    0x8C,0x94
.db    0x97,0x9A
.db    0x99,0x95
.db    0x97,0x97
.db    0x95,0x96
.db    0x93,0x8F
.db    0x87,0x87
.db    0x85,0x7E
.db    0x7B,0x76
.db    0x73,0x72
.db    0x73,0x74
.db    0x75,0x76
.db    0x72,0x70
.db    0x72,0x75
.db    0x7B,0x7B
.db    0x77,0x75
.db    0x76,0x7B
.db    0x7A,0x7A
.db    0x7A,0x7A
.db    0x7C,0x7C
.db    0x7E,0x7D
.db    0x7A,0x7F
.db    0x82,0x7F
.db    0x80,0x7F
.db    0x7E,0x77
.db    0x7B,0x87
.db    0x8B,0x83
.db    0x7C,0x7E
.db    0x82,0x82
.db    0x86,0x80
.db    0x78,0x72
.db    0x70,0x74
.db    0x73,0x6B
.db    0x67,0x67
.db    0x64,0x5D
.db    0x5D,0x60
.db    0x5C,0x5C
.db    0x57,0x52
.db    0x54,0x56
.db    0x5C,0x5B
.db    0x58,0x55
.db    0x53,0x55
.db    0x57,0x58
.db    0x57,0x58
.db    0x5C,0x52
.db    0x51,0x57
.db    0x5D,0x62
.db    0x5E,0x5B
.db    0x5E,0x5E
.db    0x62,0x67
.db    0x66,0x66
.db    0x6A,0x77
.db    0x7D,0x7E
.db    0x7A,0x7F
.db    0x9B,0xBE
.db    0xC7,0xC8
.db    0xBD,0xB8
.db    0xC7,0xE1
.db    0xF2,0xEB
.db    0xD5,0xC5
.db    0xBC,0xC5
.db    0xC3,0xC3
.db    0xBA,0xA5
.db    0x9C,0x8D
.db    0x87,0x88
.db    0x8F,0x8F
.db    0x87,0x7F
.db    0x79,0x79
.db    0x7F,0x86
.db    0x92,0x95
.db    0x91,0x8B
.db    0x8B,0x91
.db    0x9C,0xA4
.db    0xA6,0xA5
.db    0x9E,0x95
.db    0x96,0x95
.db    0x92,0x98
.db    0x97,0x8F
.db    0x89,0x81
.db    0x7C,0x7B
.db    0x7A,0x7F
.db    0x81,0x7B
.db    0x75,0x73
.db    0x6E,0x71
.db    0x7B,0x80
.db    0x7E,0x79
.db    0x78,0x75
.db    0x74,0x78
.db    0x7A,0x7E
.db    0x7D,0x79
.db    0x71,0x66
.db    0x6B,0x71
.db    0x77,0x76
.db    0x69,0x63
.db    0x5F,0x60
.db    0x64,0x61
.db    0x5B,0x53
.db    0x4E,0x51
.db    0x4F,0x4B
.db    0x48,0x45
.db    0x49,0x47
.db    0x42,0x3C
.db    0x3A,0x40
.db    0x47,0x4A
.db    0x4A,0x42
.db    0x42,0x45
.db    0x4F,0x5E
.db    0x68,0x6E
.db    0x73,0x70
.db    0x67,0x7C
.db    0xB5,0xD7
.db    0xDC,0xD9
.db    0xC6,0xC8
.db    0xDC,0xF6
.db    0xFF,0xFC
.db    0xE1,0xC6
.db    0xC4,0xD0
.db    0xC8,0xC7
.db    0xBC,0xA4
.db    0x92,0x7F
.db    0x7F,0x84
.db    0x85,0x87
.db    0x84,0x7A
.db    0x67,0x63
.db    0x7D,0x8C
.db    0x93,0x8D
.db    0x82,0x7E
.db    0x7C,0x86
.db    0x96,0x9B
.db    0x99,0x95
.db    0x8C,0x80
.db    0x7B,0x84
.db    0x90,0x93
.db    0x88,0x78
.db    0x73,0x71
.db    0x74,0x80
.db    0x81,0x78
.db    0x6E,0x67
.db    0x67,0x6B
.db    0x6F,0x71
.db    0x72,0x6F
.db    0x66,0x64
.db    0x67,0x76
.db    0x81,0x81
.db    0x80,0x7C
.db    0x7B,0x7D
.db    0x83,0x8A
.db    0x86,0x81
.db    0x7D,0x78
.db    0x72,0x6B
.db    0x77,0x79
.db    0x72,0x6E
.db    0x64,0x5F
.db    0x5B,0x5C
.db    0x65,0x61
.db    0x5B,0x4F
.db    0x48,0x48
.db    0x3E,0x44
.db    0x50,0x51
.db    0x4A,0x3C
.db    0x34,0x31
.db    0x37,0x45
.db    0x53,0x56
.db    0x46,0x40
.db    0x48,0x55
.db    0x6B,0x7F
.db    0x84,0x75
.db    0x7D,0xA9
.db    0xCB,0xDB
.db    0xD7,0xD1
.db    0xD3,0xDC
.db    0xEE,0xFC
.db    0xF8,0xE3
.db    0xD1,0xCD
.db    0xC3,0xBA
.db    0xB1,0xB0
.db    0xB2,0xA3
.db    0x8D,0x83
.db    0x7B,0x7D
.db    0x86,0x96
.db    0x9A,0x8B
.db    0x80,0x7D
.db    0x86,0x91
.db    0x96,0x9B
.db    0x9B,0x93
.db    0x8D,0x91
.db    0x9E,0xA0
.db    0x9E,0x9B
.db    0x98,0x96
.db    0x90,0x8B
.db    0x91,0x95
.db    0x98,0x94
.db    0x8D,0x85
.db    0x7F,0x80
.db    0x86,0x87
.db    0x88,0x82
.db    0x7F,0x7D
.db    0x7A,0x76
.db    0x79,0x81
.db    0x85,0x82
.db    0x80,0x78
.db    0x78,0x78
.db    0x78,0x7D
.db    0x7A,0x79
.db    0x71,0x61
.db    0x60,0x61
.db    0x66,0x68
.db    0x5C,0x56
.db    0x4B,0x43
.db    0x41,0x42
.db    0x42,0x42
.db    0x41,0x3A
.db    0x33,0x2F
.db    0x2A,0x31
.db    0x38,0x39
.db    0x31,0x2C
.db    0x2E,0x39
.db    0x40,0x42
.db    0x43,0x48
.db    0x57,0x66
.db    0x71,0x76
.db    0x7D,0x7D
.db    0x79,0x8E
.db    0xB3,0xC9
.db    0xD3,0xCF
.db    0xD0,0xD2
.db    0xD5,0xE1
.db    0xEF,0xF5
.db    0xF1,0xE2
.db    0xE7,0xDD
.db    0xD4,0xC9
.db    0xC4,0xC8
.db    0xC5,0xB5
.db    0xB1,0xA4
.db    0x9C,0x9B
.db    0x9A,0xA0
.db    0x9E,0x9A
.db    0x9C,0x96
.db    0x94,0x94
.db    0x90,0x91
.db    0x91,0x90
.db    0x91,0x92
.db    0x94,0x93
.db    0x8B,0x8A
.db    0x8A,0x8C
.db    0x8B,0x89
.db    0x89,0x85
.db    0x81,0x80
.db    0x7D,0x79
.db    0x73,0x72
.db    0x75,0x76
.db    0x71,0x70
.db    0x70,0x70
.db    0x6D,0x6C
.db    0x6E,0x70
.db    0x75,0x76
.db    0x74,0x72
.db    0x6C,0x6D
.db    0x70,0x6F
.db    0x6F,0x6D
.db    0x6E,0x69
.db    0x65,0x64
.db    0x5E,0x5C
.db    0x5A,0x59
.db    0x59,0x55
.db    0x50,0x4B
.db    0x49,0x4C
.db    0x48,0x4B
.db    0x4C,0x4B
.db    0x4F,0x4E
.db    0x4E,0x50
.db    0x51,0x54
.db    0x56,0x5C
.db    0x60,0x67
.db    0x6C,0x71
.db    0x74,0x78
.db    0x7F,0x88
.db    0x91,0x8E
.db    0x90,0x96
.db    0x9F,0xA5
.db    0xA8,0xAC
.db    0xB2,0xB3
.db    0xB4,0xB3
.db    0xB4,0xB8
.db    0xB3,0xB8
.db    0xB7,0xBA
.db    0xBF,0xB7
.db    0xB8,0xB5
.db    0xAE,0xAD
.db    0xB6,0xA9
.db    0xAC,0xA8
.db    0xA5,0xA4
.db    0xA4,0x9E
.db    0x97,0x96
.db    0x94,0x92
.db    0x8C,0x87
.db    0x85,0x81
.db    0x82,0x7F
.db    0x79,0x79
.db    0x7B,0x78
.db    0x74,0x74
.db    0x72,0x71
.db    0x70,0x71
.db    0x73,0x72
.db    0x74,0x75
.db    0x75,0x77
.db    0x78,0x7B
.db    0x7E,0x7D
.db    0x7D,0x7C
.db    0x7D,0x81
.db    0x82,0x85
.db    0x82,0x81
.db    0x81,0x7F
.db    0x80,0x83
.db    0x7E,0x7E
.db    0x7B,0x7A
.db    0x7A,0x78
.db    0x76,0x72
.db    0x70,0x6D
.db    0x68,0x64
.db    0x5E,0x59
.db    0x55,0x4E
.db    0x4C,0x43
.db    0x3D,0x37
.db    0x32,0x33
.db    0x31,0x2E
.db    0x2F,0x2B
.db    0x2D,0x30
.db    0x33,0x36
.db    0x38,0x3F
.db    0x43,0x48
.db    0x50,0x55
.db    0x5D,0x63
.db    0x6C,0x78
.db    0x7D,0x85
.db    0x8B,0x95
.db    0xA0,0xAD
.db    0xB9,0xC3
.db    0xC9,0xCD
.db    0xD1,0xD2
.db    0xD8,0xDA
.db    0xDF,0xE5
.db    0xE8,0xE9
.db    0xE5,0xE2
.db    0xE0,0xDB
.db    0xDA,0xD7
.db    0xD3,0xCE
.db    0xC6,0xC1
.db    0xB9,0xB3
.db    0xAC,0xA2
.db    0x9D,0x94
.db    0x8D,0x87
.db    0x83,0x80
.db    0x7C,0x79
.db    0x78,0x78
.db    0x76,0x75
.db    0x75,0x75
.db    0x74,0x75
.db    0x76,0x7B
.db    0x7D,0x80
.db    0x86,0x86
.db    0x89,0x8C
.db    0x8F,0x94
.db    0x95,0x96
.db    0x97,0x96
.db    0x96,0x94
.db    0x91,0x8F
.db    0x8B,0x86
.db    0x81,0x7E
.db    0x79,0x72
.db    0x6E,0x69
.db    0x63,0x5D
.db    0x57,0x51
.db    0x4B,0x45
.db    0x3D,0x38
.db    0x32,0x2B
.db    0x27,0x24
.db    0x20,0x1E
.db    0x1E,0x1D
.db    0x1C,0x1E
.db    0x21,0x25
.db    0x28,0x2D
.db    0x33,0x37
.db    0x3C,0x45
.db    0x4C,0x55
.db    0x5F,0x66
.db    0x6F,0x77
.db    0x82,0x8F
.db    0x9B,0xA9
.db    0xB3,0xB9
.db    0xC1,0xC6
.db    0xCD,0xD4
.db    0xDA,0xE3
.db    0xE6,0xE9
.db    0xE9,0xE6
.db    0xE8,0xE4
.db    0xE3,0xE1
.db    0xDD,0xD9
.db    0xD2,0xCB
.db    0xC8,0xC1
.db    0xBC,0xB4
.db    0xAA,0xA3
.db    0x9A,0x93
.db    0x90,0x89
.db    0x86,0x81
.db    0x7D,0x79
.db    0x75,0x74
.db    0x73,0x70
.db    0x6E,0x6D
.db    0x6D,0x6E
.db    0x6F,0x71
.db    0x73,0x74
.db    0x77,0x7A
.db    0x7A,0x7D
.db    0x7E,0x80
.db    0x82,0x81
.db    0x84,0x81
.db    0x80,0x81
.db    0x7F,0x7F
.db    0x7D,0x7B
.db    0x79,0x75
.db    0x75,0x71
.db    0x6D,0x6B
.db    0x66,0x63
.db    0x5B,0x55
.db    0x51,0x4C
.db    0x4B,0x47
.db    0x44,0x41
.db    0x3C,0x3B
.db    0x38,0x39
.db    0x3A,0x3B
.db    0x3C,0x3D
.db    0x3E,0x41
.db    0x43,0x4B
.db    0x50,0x57
.db    0x5E,0x63
.db    0x6A,0x72
.db    0x7D,0x8B
.db    0x94,0xA2
.db    0xAB,0xAF
.db    0xB8,0xBE
.db    0xC9,0xD1
.db    0xD4,0xDF
.db    0xE2,0xE4
.db    0xEA,0xEA
.db    0xEE,0xEE
.db    0xEC,0xEC
.db    0xE6,0xE3
.db    0xDE,0xDA
.db    0xD7,0xD1
.db    0xCC,0xC5
.db    0xBA,0xB2
.db    0xA9,0xA2
.db    0x9C,0x97
.db    0x92,0x8D
.db    0x86,0x81
.db    0x7C,0x77
.db    0x74,0x71
.db    0x6E,0x6E
.db    0x6C,0x6B
.db    0x6A,0x69
.db    0x6C,0x6B
.db    0x6B,0x6D
.db    0x6B,0x6E
.db    0x6D,0x6E
.db    0x71,0x71
.db    0x70,0x6F
.db    0x6F,0x6F
.db    0x6E,0x6D
.db    0x6B,0x6A
.db    0x68,0x66
.db    0x66,0x62
.db    0x5F,0x5A
.db    0x55,0x51
.db    0x4C,0x4B
.db    0x48,0x45
.db    0x43,0x3F
.db    0x3E,0x3B
.db    0x39,0x3A
.db    0x39,0x3B
.db    0x3F,0x42
.db    0x45,0x47
.db    0x4B,0x4F
.db    0x55,0x5B
.db    0x62,0x67
.db    0x6E,0x77
.db    0x82,0x8D
.db    0x95,0xA0
.db    0xA7,0xAC
.db    0xB3,0xBA
.db    0xC3,0xC9
.db    0xCD,0xD2
.db    0xD4,0xD8
.db    0xDA,0xDA
.db    0xDC,0xDC
.db    0xDE,0xDF
.db    0xDC,0xD9
.db    0xD4,0xCF
.db    0xCC,0xC7
.db    0xC3,0xBD
.db    0xB5,0xAF
.db    0xA8,0xA3
.db    0x9E,0x99
.db    0x94,0x8F
.db    0x89,0x85
.db    0x80,0x7C
.db    0x78,0x73
.db    0x71,0x70
.db    0x6D,0x6C
.db    0x69,0x69
.db    0x68,0x68
.db    0x68,0x66
.db    0x65,0x64
.db    0x64,0x63
.db    0x62,0x61
.db    0x5F,0x5F
.db    0x5D,0x5C
.db    0x5B,0x58
.db    0x58,0x56
.db    0x56,0x56
.db    0x54,0x53
.db    0x50,0x4E
.db    0x4E,0x4B
.db    0x4B,0x49
.db    0x47,0x48
.db    0x46,0x47
.db    0x48,0x47
.db    0x49,0x49
.db    0x4B,0x4D
.db    0x4E,0x52
.db    0x54,0x57
.db    0x5B,0x5F
.db    0x65,0x67
.db    0x6C,0x72
.db    0x7A,0x84
.db    0x8C,0x95
.db    0x9D,0xA4
.db    0xAD,0xB1
.db    0xB9,0xBE
.db    0xC1,0xC7
.db    0xCA,0xCE
.db    0xD2,0xD3
.db    0xD8,0xD9
.db    0xD9,0xDB
.db    0xD7,0xD6
.db    0xD3,0xCF
.db    0xCC,0xC8
.db    0xC2,0xBE
.db    0xB6,0xB0
.db    0xAA,0xA4
.db    0xA1,0x9A
.db    0x95,0x91
.db    0x8C,0x87
.db    0x84,0x7F
.db    0x7B,0x75
.db    0x73,0x71
.db    0x6D,0x6C
.db    0x6C,0x6A
.db    0x6A,0x6A
.db    0x6A,0x6B
.db    0x6A,0x6B
.db    0x6B,0x69
.db    0x69,0x67
.db    0x67,0x66
.db    0x64,0x64
.db    0x63,0x61
.db    0x60,0x5D
.db    0x5C,0x5B
.db    0x59,0x59
.db    0x56,0x54
.db    0x52,0x4F
.db    0x4E,0x4D
.db    0x4A,0x49
.db    0x48,0x48
.db    0x47,0x47
.db    0x47,0x47
.db    0x46,0x47
.db    0x49,0x4B
.db    0x4D,0x50
.db    0x53,0x56
.db    0x5A,0x5D
.db    0x61,0x66
.db    0x6E,0x78
.db    0x81,0x8B
.db    0x95,0x9C
.db    0xA4,0xAB
.db    0xB1,0xB8
.db    0xBE,0xC5
.db    0xC9,0xCE
.db    0xD3,0xD8
.db    0xDC,0xDF
.db    0xE1,0xE3
.db    0xE2,0xE1
.db    0xDE,0xDB
.db    0xD7,0xD4
.db    0xCF,0xCB
.db    0xC5,0xC0
.db    0xBB,0xB5
.db    0xB0,0xAB
.db    0xA5,0x9E
.db    0x98,0x92
.db    0x8D,0x88
.db    0x84,0x7F
.db    0x7B,0x78
.db    0x76,0x72
.db    0x70,0x6E
.db    0x6D,0x6A
.db    0x69,0x67
.db    0x66,0x64
.db    0x63,0x62
.db    0x60,0x5F
.db    0x5E,0x5C
.db    0x5B,0x5A
.db    0x5A,0x58
.db    0x56,0x55
.db    0x54,0x53
.db    0x52,0x50
.db    0x4F,0x4D
.db    0x4B,0x4A
.db    0x47,0x46
.db    0x44,0x43
.db    0x43,0x42
.db    0x42,0x41
.db    0x40,0x42
.db    0x42,0x42
.db    0x44,0x44
.db    0x45,0x47
.db    0x4A,0x4E
.db    0x51,0x58
.db    0x61,0x6A
.db    0x75,0x7F
.db    0x89,0x92
.db    0x99,0xA2
.db    0xA8,0xAD
.db    0xB3,0xBA
.db    0xC2,0xC9
.db    0xD2,0xDA
.db    0xDF,0xE4
.db    0xE8,0xEA
.db    0xE9,0xE8
.db    0xE7,0xE4
.db    0xE1,0xDE
.db    0xDB,0xD6
.db    0xD1,0xCB
.db    0xC6,0xBF
.db    0xB8,0xAF
.db    0xA8,0x9F
.db    0x98,0x91
.db    0x8C,0x87
.db    0x81,0x7D
.db    0x79,0x74
.db    0x6E,0x6C
.db    0x69,0x66
.db    0x63,0x62
.db    0x60,0x5E
.db    0x5D,0x5C
.db    0x5B,0x59
.db    0x58,0x58
.db    0x56,0x54
.db    0x52,0x52
.db    0x51,0x50
.db    0x50,0x50
.db    0x4E,0x4D
.db    0x4B,0x4B
.db    0x49,0x48
.db    0x48,0x47
.db    0x44,0x43
.db    0x43,0x43
.db    0x42,0x42
.db    0x43,0x43
.db    0x43,0x43
.db    0x45,0x46
.db    0x47,0x4A
.db    0x4E,0x50
.db    0x54,0x5A
.db    0x65,0x6E
.db    0x78,0x81
.db    0x8A,0x91
.db    0x98,0xA0
.db    0xA3,0xA9
.db    0xB0,0xB7
.db    0xC0,0xC8
.db    0xD1,0xD7
.db    0xDC,0xE1
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE3,0xE0
.db    0xDC,0xDA
.db    0xD6,0xD4
.db    0xCF,0xCB
.db    0xC5,0xC0
.db    0xB8,0xB0
.db    0xA7,0xA0
.db    0x9A,0x93
.db    0x8E,0x87
.db    0x83,0x7E
.db    0x79,0x74
.db    0x6F,0x6C
.db    0x68,0x65
.db    0x61,0x5F
.db    0x5C,0x5B
.db    0x59,0x57
.db    0x55,0x54
.db    0x53,0x51
.db    0x4F,0x4E
.db    0x4D,0x4C
.db    0x4B,0x4B
.db    0x4B,0x4A
.db    0x4A,0x49
.db    0x49,0x47
.db    0x46,0x46
.db    0x45,0x44
.db    0x43,0x44
.db    0x44,0x44
.db    0x44,0x45
.db    0x46,0x47
.db    0x48,0x49
.db    0x49,0x4B
.db    0x4E,0x52
.db    0x54,0x59
.db    0x61,0x69
.db    0x72,0x7D
.db    0x86,0x8E
.db    0x96,0x9E
.db    0xA4,0xAA
.db    0xAF,0xB6
.db    0xBC,0xC4
.db    0xCB,0xD1
.db    0xD7,0xDC
.db    0xE2,0xE4
.db    0xE5,0xE6
.db    0xE4,0xE2
.db    0xDF,0xDC
.db    0xD7,0xD2
.db    0xD0,0xCC
.db    0xC5,0xBD
.db    0xB6,0xAE
.db    0xA5,0x9E
.db    0x98,0x91
.db    0x8A,0x86
.db    0x81,0x7B
.db    0x75,0x71
.db    0x6C,0x67
.db    0x62,0x5E
.db    0x5B,0x59
.db    0x57,0x56
.db    0x55,0x54
.db    0x53,0x52
.db    0x50,0x4D
.db    0x4B,0x4A
.db    0x4A,0x48
.db    0x47,0x47
.db    0x47,0x46
.db    0x45,0x45
.db    0x44,0x42
.db    0x40,0x3E
.db    0x3D,0x3C
.db    0x3B,0x3B
.db    0x3B,0x3D
.db    0x3F,0x41
.db    0x42,0x42
.db    0x44,0x44
.db    0x46,0x49
.db    0x4A,0x4D
.db    0x55,0x5E
.db    0x68,0x72
.db    0x7C,0x86
.db    0x8F,0x97
.db    0x9E,0xA2
.db    0xA6,0xAC
.db    0xB5,0xBB
.db    0xC2,0xCA
.db    0xD2,0xD9
.db    0xE0,0xE4
.db    0xE6,0xE7
.db    0xE7,0xE6
.db    0xE3,0xDF
.db    0xDC,0xDA
.db    0xD6,0xD3
.db    0xCF,0xCA
.db    0xC2,0xBB
.db    0xB4,0xAE
.db    0xA6,0xA0
.db    0x9B,0x96
.db    0x90,0x8B
.db    0x86,0x81
.db    0x7A,0x76
.db    0x72,0x6E
.db    0x6A,0x65
.db    0x63,0x60
.db    0x5D,0x5C
.db    0x5B,0x58
.db    0x56,0x54
.db    0x52,0x50
.db    0x4E,0x4D
.db    0x4B,0x49
.db    0x48,0x47
.db    0x46,0x45
.db    0x43,0x42
.db    0x41,0x40
.db    0x3F,0x3E
.db    0x3E,0x3E
.db    0x3E,0x3F
.db    0x40,0x40
.db    0x40,0x40
.db    0x41,0x42
.db    0x44,0x46
.db    0x48,0x4B
.db    0x51,0x58
.db    0x61,0x69
.db    0x72,0x7B
.db    0x82,0x89
.db    0x91,0x97
.db    0x9C,0xA1
.db    0xAA,0xB1
.db    0xB8,0xC0
.db    0xC8,0xCE
.db    0xD4,0xDB
.db    0xDF,0xE1
.db    0xE3,0xE3
.db    0xE2,0xDE
.db    0xDA,0xD7
.db    0xD3,0xCF
.db    0xCA,0xC4
.db    0xBC,0xB4
.db    0xAD,0xA7
.db    0x9F,0x98
.db    0x91,0x8C
.db    0x86,0x7F
.db    0x7A,0x74
.db    0x6F,0x69
.db    0x64,0x60
.db    0x5C,0x59
.db    0x56,0x53
.db    0x51,0x4E
.db    0x4C,0x4B
.db    0x49,0x47
.db    0x46,0x44
.db    0x43,0x43
.db    0x41,0x41
.db    0x40,0x3F
.db    0x3F,0x3C
.db    0x3B,0x3A
.db    0x3A,0x3A
.db    0x3A,0x3A
.db    0x3B,0x3F
.db    0x3F,0x41
.db    0x42,0x43
.db    0x43,0x44
.db    0x47,0x4A
.db    0x4C,0x4F
.db    0x56,0x5E
.db    0x68,0x71
.db    0x7D,0x84
.db    0x8C,0x94
.db    0x9D,0xA1
.db    0xA5,0xAB
.db    0xB2,0xB7
.db    0xBD,0xC5
.db    0xCD,0xD4
.db    0xDA,0xE2
.db    0xE5,0xE7
.db    0xE9,0xEA
.db    0xE9,0xE5
.db    0xE1,0xDF
.db    0xDC,0xD7
.db    0xD1,0xCC
.db    0xC2,0xBB
.db    0xB4,0xAD
.db    0xA5,0x9E
.db    0x99,0x93
.db    0x8E,0x87
.db    0x82,0x7C
.db    0x77,0x71
.db    0x6D,0x67
.db    0x61,0x5D
.db    0x5A,0x57
.db    0x55,0x52
.db    0x50,0x4D
.db    0x4A,0x47
.db    0x45,0x43
.db    0x41,0x3F
.db    0x3E,0x3D
.db    0x3C,0x3C
.db    0x3A,0x39
.db    0x38,0x38
.db    0x37,0x36
.db    0x36,0x37
.db    0x39,0x3A
.db    0x3D,0x3E
.db    0x3F,0x41
.db    0x44,0x48
.db    0x4B,0x4D
.db    0x52,0x59
.db    0x60,0x68
.db    0x73,0x7D
.db    0x86,0x8F
.db    0x99,0xA1
.db    0xA5,0xAB
.db    0xB1,0xB8
.db    0xBD,0xC4
.db    0xCC,0xD2
.db    0xD7,0xDE
.db    0xE3,0xE5
.db    0xE6,0xE8
.db    0xE8,0xE5
.db    0xE1,0xDF
.db    0xD9,0xD5
.db    0xD0,0xCC
.db    0xC5,0xBD
.db    0xB5,0xAE
.db    0xA5,0x9E
.db    0x97,0x90
.db    0x8A,0x84
.db    0x7E,0x76
.db    0x71,0x6B
.db    0x66,0x60
.db    0x5C,0x57
.db    0x53,0x4F
.db    0x4C,0x49
.db    0x47,0x44
.db    0x42,0x3F
.db    0x3E,0x3B
.db    0x3A,0x37
.db    0x37,0x37
.db    0x37,0x36
.db    0x36,0x36
.db    0x36,0x35
.db    0x35,0x35
.db    0x36,0x37
.db    0x3B,0x3D
.db    0x40,0x42
.db    0x45,0x47
.db    0x4B,0x4F
.db    0x54,0x57
.db    0x5B,0x61
.db    0x69,0x71
.db    0x7B,0x87
.db    0x91,0x9A
.db    0xA3,0xAC
.db    0xB1,0xB7
.db    0xBD,0xC4
.db    0xC7,0xCD
.db    0xD3,0xD8
.db    0xDD,0xE1
.db    0xE6,0xE8
.db    0xEA,0xEB
.db    0xEB,0xE8
.db    0xE2,0xDD
.db    0xD8,0xD1
.db    0xCC,0xC5
.db    0xBE,0xB5
.db    0xAE,0xA5
.db    0x9E,0x97
.db    0x91,0x8A
.db    0x84,0x7E
.db    0x79,0x73
.db    0x6E,0x68
.db    0x63,0x5E
.db    0x5A,0x56
.db    0x52,0x4F
.db    0x4C,0x49
.db    0x46,0x44
.db    0x43,0x41
.db    0x3F,0x3C
.db    0x3B,0x3A
.db    0x39,0x39
.db    0x38,0x38
.db    0x38,0x38
.db    0x38,0x38
.db    0x38,0x38
.db    0x3B,0x3C
.db    0x3E,0x40
.db    0x42,0x44
.db    0x47,0x4B
.db    0x4D,0x51
.db    0x54,0x57
.db    0x5C,0x63
.db    0x6A,0x73
.db    0x7E,0x86
.db    0x8F,0x98
.db    0xA0,0xA7
.db    0xAC,0xB1
.db    0xB7,0xBC
.db    0xC1,0xC6
.db    0xCB,0xD0
.db    0xD4,0xDA
.db    0xDE,0xE1
.db    0xE2,0xE3
.db    0xE1,0xDE
.db    0xDA,0xD6
.db    0xD2,0xCD
.db    0xC8,0xC2
.db    0xBA,0xB3
.db    0xAC,0xA6
.db    0x9F,0x9A
.db    0x94,0x8F
.db    0x8A,0x85
.db    0x80,0x7A
.db    0x76,0x71
.db    0x6C,0x68
.db    0x63,0x5F
.db    0x5B,0x58
.db    0x55,0x51
.db    0x4F,0x4D
.db    0x4A,0x47
.db    0x45,0x43
.db    0x41,0x3F
.db    0x3F,0x3E
.db    0x3D,0x3B
.db    0x3B,0x3B
.db    0x3A,0x3A
.db    0x3B,0x3C
.db    0x3C,0x3F
.db    0x3F,0x40
.db    0x43,0x44
.db    0x46,0x48
.db    0x4B,0x4D
.db    0x51,0x55
.db    0x5C,0x63
.db    0x6B,0x74
.db    0x7C,0x86
.db    0x8E,0x98
.db    0x9E,0xA5
.db    0xAB,0xB1
.db    0xB6,0xBC
.db    0xC2,0xC7
.db    0xCC,0xD1
.db    0xD8,0xDA
.db    0xDD,0xE1
.db    0xE4,0xE4
.db    0xE3,0xE0
.db    0xDD,0xD7
.db    0xD4,0xCC
.db    0xC6,0xBC
.db    0xB6,0xB0
.db    0xAB,0xA2
.db    0x9C,0x97
.db    0x92,0x8C
.db    0x86,0x80
.db    0x7B,0x76
.db    0x71,0x6B
.db    0x66,0x62
.db    0x5C,0x56
.db    0x53,0x4F
.db    0x4D,0x4A
.db    0x47,0x44
.db    0x41,0x40
.db    0x3D,0x3A
.db    0x39,0x39
.db    0x39,0x37
.db    0x37,0x37
.db    0x37,0x36
.db    0x37,0x38
.db    0x3A,0x3B
.db    0x3D,0x3E
.db    0x40,0x43
.db    0x46,0x49
.db    0x4C,0x50
.db    0x52,0x57
.db    0x5C,0x63
.db    0x6A,0x74
.db    0x7A,0x85
.db    0x8C,0x94
.db    0x9B,0xA2
.db    0xA7,0xAE
.db    0xB3,0xBA
.db    0xC0,0xC1
.db    0xC8,0xCE
.db    0xD1,0xD6
.db    0xDA,0xE0
.db    0xE1,0xE1
.db    0xE0,0xDF
.db    0xDC,0xD9
.db    0xD6,0xD1
.db    0xCA,0xC1
.db    0xBB,0xB4
.db    0xAE,0xA8
.db    0xA3,0x9C
.db    0x98,0x93
.db    0x8D,0x87
.db    0x81,0x7D
.db    0x78,0x72
.db    0x6D,0x67
.db    0x62,0x5D
.db    0x58,0x54
.db    0x50,0x4B
.db    0x48,0x45
.db    0x41,0x3F
.db    0x3C,0x3A
.db    0x38,0x37
.db    0x36,0x35
.db    0x35,0x35
.db    0x34,0x33
.db    0x33,0x33
.db    0x35,0x38
.db    0x3A,0x3C
.db    0x3F,0x42
.db    0x44,0x48
.db    0x4B,0x50
.db    0x51,0x55
.db    0x5A,0x5F
.db    0x63,0x6D
.db    0x74,0x80
.db    0x87,0x8F
.db    0x96,0x9C
.db    0xA3,0xA7
.db    0xAD,0xAF
.db    0xB3,0xB9
.db    0xBB,0xBE
.db    0xBF,0xC5
.db    0xC9,0xCE
.db    0xD0,0xD2
.db    0xD2,0xD4
.db    0xD1,0xD3
.db    0xCC,0xD0
.db    0xC9,0xC7
.db    0xBE,0xB8
.db    0xB3,0xB0
.db    0xAB,0xA8
.db    0xA2,0x90
.db    0x99,0x83
.db    0xA2,0x87
.db    0x9F,0x7A
.db    0x7C,0x68
.db    0x69,0x64
.db    0x63,0x5E
.db    0x5A,0x52
.db    0x4D,0x49
.db    0x44,0x43
.db    0x3F,0x40
.db    0x3B,0x3C
.db    0x38,0x3B
.db    0x38,0x38
.db    0x39,0x37
.db    0x39,0x3A
.db    0x39,0x3F
.db    0x3E,0x46
.db    0x45,0x4D
.db    0x50,0x53
.db    0x57,0x5C
.db    0x60,0x65
.db    0x68,0x6E
.db    0x73,0x78
.db    0x82,0x89
.db    0x94,0x9C
.db    0xA6,0xB0
.db    0xB7,0xC0
.db    0xC4,0xCA
.db    0xCB,0xD1
.db    0xD0,0xD3
.db    0xD2,0xD5
.db    0xD5,0xD3
.db    0xD4,0xD1
.db    0xD3,0xCE
.db    0xCF,0xC9
.db    0xC7,0xC2
.db    0xBE,0xB9
.db    0xB2,0xAB
.db    0xA7,0xA0
.db    0x9A,0x93
.db    0x8B,0x86
.db    0x80,0x7F
.db    0x7A,0x76
.db    0x76,0x6E
.db    0x6D,0x61
.db    0x61,0x5F
.db    0x57,0x56
.db    0x4A,0x4D
.db    0x48,0x43
.db    0x42,0x3B
.db    0x3D,0x38
.db    0x36,0x36
.db    0x31,0x36
.db    0x34,0x35
.db    0x37,0x37
.db    0x3B,0x38
.db    0x3B,0x39
.db    0x3D,0x3E
.db    0x40,0x43
.db    0x43,0x49
.db    0x4A,0x52
.db    0x56,0x5A
.db    0x62,0x66
.db    0x6F,0x72
.db    0x7B,0x80
.db    0x88,0x8E
.db    0x96,0x9F
.db    0xA6,0xAF
.db    0xB7,0xBF
.db    0xC6,0xCA
.db    0xCD,0xD1
.db    0xD4,0xD5
.db    0xD6,0xD7
.db    0xD7,0xD7
.db    0xD6,0xD3
.db    0xD3,0xD1
.db    0xD1,0xD1
.db    0xCE,0xCD
.db    0xC5,0xBF
.db    0xB6,0xAD
.db    0xA6,0x9B
.db    0x93,0x8E
.db    0x85,0x80
.db    0x77,0x71
.db    0x72,0x65
.db    0x65,0x59
.db    0x58,0x54
.db    0x49,0x45
.db    0x3E,0x3B
.db    0x37,0x30
.db    0x2E,0x30
.db    0x2B,0x2E
.db    0x2B,0x2E
.db    0x34,0x2E
.db    0x36,0x38
.db    0x3C,0x41
.db    0x3A,0x45
.db    0x47,0x4A
.db    0x4D,0x46
.db    0x53,0x53
.db    0x59,0x5B
.db    0x5D,0x60
.db    0x63,0x65
.db    0x69,0x6F
.db    0x6E,0x77
.db    0x78,0x83
.db    0x87,0x8C
.db    0x92,0x97
.db    0xA0,0xA7
.db    0xAA,0xB4
.db    0xBA,0xBE
.db    0xC2,0xC4
.db    0xCC,0xCC
.db    0xCE,0xCE
.db    0xD0,0xCF
.db    0xCD,0xCB
.db    0xCB,0xCB
.db    0xC6,0xCB
.db    0xC4,0xC9
.db    0xC0,0xBD
.db    0xB6,0xAE
.db    0xAC,0xA0
.db    0x9D,0x93
.db    0x91,0x8C
.db    0x87,0x85
.db    0x81,0x7F
.db    0x7B,0x7A
.db    0x77,0x75
.db    0x70,0x6E
.db    0x69,0x68
.db    0x62,0x62
.db    0x5C,0x5B
.db    0x57,0x54
.db    0x52,0x4F
.db    0x50,0x4B
.db    0x4D,0x4A
.db    0x4C,0x4B
.db    0x4A,0x4B
.db    0x4B,0x4A
.db    0x4B,0x4A
.db    0x4B,0x4C
.db    0x4A,0x4E
.db    0x4C,0x52
.db    0x51,0x55
.db    0x57,0x59
.db    0x5D,0x60
.db    0x63,0x67
.db    0x6A,0x6D
.db    0x72,0x75
.db    0x7B,0x7F
.db    0x85,0x8B
.db    0x90,0x98
.db    0x9D,0xA3
.db    0xA6,0xAD
.db    0xB1,0xB4
.db    0xB8,0xB9
.db    0xBB,0xBB
.db    0xBC,0xBE
.db    0xBD,0xC1
.db    0xC1,0xC2
.db    0xC1,0xBF
.db    0xC1,0xBE
.db    0xBC,0xB7
.db    0xB1,0xB0
.db    0xA8,0xA5
.db    0x9B,0x96
.db    0x94,0x8B
.db    0x89,0x7E
.db    0x7E,0x75
.db    0x75,0x6E
.db    0x68,0x65
.db    0x5B,0x5F
.db    0x55,0x55
.db    0x4D,0x49
.db    0x49,0x45
.db    0x46,0x3E
.db    0x41,0x3C
.db    0x41,0x3D
.db    0x41,0x3F
.db    0x41,0x42
.db    0x42,0x48
.db    0x47,0x4D
.db    0x49,0x50
.db    0x50,0x56
.db    0x56,0x5A
.db    0x5B,0x60
.db    0x63,0x65
.db    0x69,0x6E
.db    0x72,0x75
.db    0x7A,0x80
.db    0x87,0x88
.db    0x8C,0x93
.db    0x96,0x9E
.db    0xA0,0xA8
.db    0xA7,0xAE
.db    0xAF,0xB5
.db    0xB7,0xBA
.db    0xBC,0xBF
.db    0xBF,0xC1
.db    0xC1,0xC1
.db    0xBF,0xBF
.db    0xBD,0xBC
.db    0xBA,0xB7
.db    0xB2,0xB2
.db    0xB1,0xAA
.db    0xA6,0x9F
.db    0xA2,0x9B
.db    0x92,0x91
.db    0x8C,0x86
.db    0x84,0x79
.db    0x7B,0x73
.db    0x74,0x6E
.db    0x6C,0x64
.db    0x62,0x5E
.db    0x5D,0x5A
.db    0x59,0x53
.db    0x52,0x50
.db    0x4E,0x4D
.db    0x4C,0x4C
.db    0x4B,0x4A
.db    0x4A,0x4A
.db    0x4B,0x49
.db    0x4D,0x4B
.db    0x4F,0x4E
.db    0x52,0x50
.db    0x53,0x58
.db    0x58,0x5C
.db    0x5A,0x60
.db    0x62,0x65
.db    0x68,0x6E
.db    0x6F,0x72
.db    0x76,0x7A
.db    0x7F,0x82
.db    0x85,0x8C
.db    0x8D,0x92
.db    0x98,0x99
.db    0x9D,0xA2
.db    0xA5,0xAA
.db    0xAB,0xAF
.db    0xB2,0xB4
.db    0xB7,0xB8
.db    0xBA,0xBC
.db    0xBD,0xBC
.db    0xBC,0xBD
.db    0xBA,0xB9
.db    0xB6,0xB5
.db    0xB2,0xB0
.db    0xAC,0xAA
.db    0xA2,0xA5
.db    0x9E,0x9E
.db    0x94,0x93
.db    0x90,0x8A
.db    0x84,0x7F
.db    0x7F,0x77
.db    0x71,0x6D
.db    0x6A,0x6A
.db    0x64,0x5E
.db    0x5F,0x57
.db    0x59,0x55
.db    0x54,0x54
.db    0x4B,0x50
.db    0x4D,0x4C
.db    0x4D,0x48
.db    0x4C,0x4A
.db    0x4B,0x4B
.db    0x4A,0x4E
.db    0x4F,0x56
.db    0x50,0x53
.db    0x56,0x58
.db    0x60,0x5B
.db    0x61,0x63
.db    0x67,0x6A
.db    0x6B,0x6E
.db    0x77,0x75
.db    0x79,0x7F
.db    0x80,0x86
.db    0x85,0x8C
.db    0x90,0x92
.db    0x94,0x9B
.db    0x9C,0xA1
.db    0xA0,0xA2
.db    0xA6,0xA7
.db    0xAA,0xA8
.db    0xAC,0xAD
.db    0xAD,0xAE
.db    0xAE,0xAF
.db    0xAE,0xAE
.db    0xAC,0xAD
.db    0xA7,0xA5
.db    0xA7,0xA3
.db    0xA0,0x9E
.db    0x97,0x9B
.db    0x93,0x93
.db    0x8F,0x8D
.db    0x8C,0x86
.db    0x85,0x7B
.db    0x7F,0x7D
.db    0x7A,0x75
.db    0x72,0x70
.db    0x70,0x6E
.db    0x6C,0x68
.db    0x66,0x66
.db    0x67,0x61
.db    0x62,0x63
.db    0x60,0x62
.db    0x5E,0x61
.db    0x5F,0x5F
.db    0x5E,0x64
.db    0x5F,0x5E
.db    0x60,0x61
.db    0x66,0x5E
.db    0x60,0x62
.db    0x66,0x68
.db    0x66,0x65
.db    0x66,0x69
.db    0x69,0x69
.db    0x68,0x6B
.db    0x6A,0x6D
.db    0x6F,0x6D
.db    0x71,0x72
.db    0x77,0x78
.db    0x78,0x7C
.db    0x7E,0x84
.db    0x84,0x87
.db    0x89,0x8B
.db    0x8D,0x8D
.db    0x91,0x93
.db    0x96,0x97
.db    0x99,0x9A
.db    0x9C,0x9F
.db    0xA3,0xA1
.db    0xA0,0xA0
.db    0xA2,0xA3
.db    0xA7,0xA4
.db    0xA4,0xA0
.db    0x9D,0x9F
.db    0x9D,0x99
.db    0x9C,0x99
.db    0x98,0x94
.db    0x91,0x95
.db    0x90,0x8E
.db    0x8A,0x89
.db    0x84,0x82
.db    0x80,0x7D
.db    0x7A,0x77
.db    0x77,0x74
.db    0x6F,0x6D
.db    0x6A,0x6E
.db    0x6A,0x6B
.db    0x63,0x62
.db    0x66,0x63
.db    0x63,0x61
.db    0x61,0x63
.db    0x5F,0x5F
.db    0x63,0x61
.db    0x61,0x60
.db    0x61,0x62
.db    0x64,0x66
.db    0x62,0x6A
.db    0x63,0x6A
.db    0x6C,0x68
.db    0x71,0x67
.db    0x71,0x6E
.db    0x72,0x72
.db    0x75,0x78
.db    0x78,0x7A
.db    0x7E,0x82
.db    0x7F,0x86
.db    0x86,0x8C
.db    0x87,0x8A
.db    0x8D,0x90
.db    0x92,0x95
.db    0x97,0x98
.db    0x96,0x9D
.db    0x95,0x9B
.db    0x9C,0xA1
.db    0x9C,0x9F
.db    0x9B,0x9D
.db    0x9C,0x9C
.db    0xA0,0x99
.db    0xA1,0x96
.db    0x9A,0x8F
.db    0x98,0x92
.db    0x92,0x92
.db    0x8C,0x95
.db    0x8B,0x88
.db    0x87,0x85
.db    0x88,0x83
.db    0x83,0x7E
.db    0x7E,0x83
.db    0x7B,0x7A
.db    0x72,0x76
.db    0x79,0x76
.db    0x71,0x73
.db    0x6D,0x6E
.db    0x71,0x70
.db    0x68,0x6A
.db    0x69,0x71
.db    0x6B,0x65
.db    0x65,0x65
.db    0x63,0x69
.db    0x67,0x61
.db    0x64,0x63
.db    0x6A,0x66
.db    0x63,0x69
.db    0x6A,0x67
.db    0x6A,0x68
.db    0x67,0x68
.db    0x69,0x70
.db    0x6D,0x70
.db    0x75,0x71
.db    0x72,0x73
.db    0x79,0x7A
.db    0x7C,0x7C
.db    0x80,0x80
.db    0x86,0x89
.db    0x87,0x88
.db    0x8F,0x95
.db    0x8E,0x92
.db    0x8F,0x94
.db    0x95,0x93
.db    0x9A,0x8F
.db    0x94,0x99
.db    0x97,0x99
.db    0x97,0x97
.db    0x98,0x99
.db    0x97,0x93
.db    0x91,0x96
.db    0x92,0x90
.db    0x8C,0x8D
.db    0x8C,0x8F
.db    0x8D,0x8E
.db    0x87,0x86
.db    0x8E,0x82
.db    0x87,0x7F
.db    0x81,0x84
.db    0x7F,0x82
.db    0x81,0x79
.db    0x7E,0x7D
.db    0x7B,0x73
.db    0x77,0x74
.db    0x79,0x70
.db    0x6E,0x73
.db    0x6E,0x6C
.db    0x6B,0x6A
.db    0x68,0x6B
.db    0x6A,0x65
.db    0x69,0x67
.db    0x70,0x6A
.db    0x64,0x6A
.db    0x6E,0x6C
.db    0x70,0x69
.db    0x71,0x6F
.db    0x75,0x73
.db    0x75,0x77
.db    0x78,0x79
.db    0x75,0x7C
.db    0x7B,0x79
.db    0x74,0x7B
.db    0x7C,0x7E
.db    0x7F,0x7C
.db    0x81,0x7C
.db    0x86,0x87
.db    0x89,0x88
.db    0x8F,0x8E
.db    0x90,0x92
.db    0x8C,0x92
.db    0x95,0x91
.db    0x92,0x98
.db    0x99,0x95
.db    0x91,0x96
.db    0x93,0x94
.db    0x96,0x9A
.db    0x8C,0x8F
.db    0x8C,0x93
.db    0x8E,0x8B
.db    0x8B,0x93
.db    0x8C,0x86
.db    0x86,0x85
.db    0x85,0x7E
.db    0x82,0x82
.db    0x82,0x7A
.db    0x81,0x76
.db    0x7A,0x75
.db    0x78,0x78
.db    0x72,0x78
.db    0x75,0x70
.db    0x6D,0x7A
.db    0x6F,0x71
.db    0x6E,0x6F
.db    0x6E,0x6C
.db    0x6B,0x6B
.db    0x69,0x6A
.db    0x69,0x67
.db    0x67,0x66
.db    0x68,0x62
.db    0x65,0x6B
.db    0x60,0x64
.db    0x68,0x6B
.db    0x6D,0x65
.db    0x6D,0x72
.db    0x6F,0x6B
.db    0x70,0x73
.db    0x78,0x75
.db    0x71,0x72
.db    0x78,0x73
.db    0x7F,0x82
.db    0x7E,0x82
.db    0x7C,0x81
.db    0x83,0x84
.db    0x90,0x8C
.db    0x8E,0x8A
.db    0x8F,0x91
.db    0x93,0x9A
.db    0x9B,0xA2
.db    0xA6,0xA2
.db    0xA0,0xA0
.db    0x9D,0x9C
.db    0x9A,0x9E
.db    0x9E,0xA0
.db    0x9F,0x94
.db    0xA0,0x9C
.db    0xA0,0x9A
.db    0x96,0x98
.db    0x99,0x98
.db    0x90,0x8F
.db    0x92,0x8C
.db    0x84,0x7F
.db    0x80,0x80
.db    0x7C,0x7A
.db    0x76,0x72
.db    0x7B,0x7B
.db    0x74,0x69
.db    0x6D,0x70
.db    0x74,0x72
.db    0x6C,0x6F
.db    0x74,0x6B
.db    0x6B,0x65
.db    0x64,0x66
.db    0x5F,0x5F
.db    0x5E,0x63
.db    0x60,0x63
.db    0x62,0x61
.db    0x60,0x5D
.db    0x64,0x5B
.db    0x58,0x5D
.db    0x63,0x57
.db    0x5A,0x5C
.db    0x64,0x5E
.db    0x63,0x64
.db    0x66,0x68
.db    0x67,0x6D
.db    0x6C,0x6A
.db    0x72,0x7B
.db    0x7A,0x7F
.db    0x7F,0x80
.db    0x88,0x84
.db    0x8C,0x8A
.db    0x8E,0x8D
.db    0x95,0x9C
.db    0x9F,0xA3
.db    0xAD,0xB7
.db    0xB0,0xA7
.db    0xA5,0xAA
.db    0xB3,0xB8
.db    0xB5,0xB2
.db    0xAC,0xAD
.db    0xAF,0xB4
.db    0xB4,0xB2
.db    0xAA,0xA6
.db    0xA3,0xA4
.db    0xA1,0x9D
.db    0x96,0x98
.db    0x93,0x95
.db    0x8E,0x86
.db    0x84,0x80
.db    0x7B,0x75
.db    0x77,0x72
.db    0x6B,0x67
.db    0x66,0x65
.db    0x66,0x66
.db    0x66,0x64
.db    0x65,0x61
.db    0x60,0x5D
.db    0x5E,0x5D
.db    0x58,0x57
.db    0x53,0x4D
.db    0x51,0x4D
.db    0x51,0x50
.db    0x51,0x51
.db    0x50,0x4E
.db    0x4C,0x51
.db    0x54,0x56
.db    0x60,0x5A
.db    0x5A,0x65
.db    0x67,0x67
.db    0x69,0x71
.db    0x79,0x72
.db    0x70,0x6D
.db    0x6A,0x74
.db    0x7A,0x7C
.db    0x7A,0x81
.db    0x86,0x8F
.db    0x94,0x98
.db    0xA8,0xAC
.db    0xB0,0xB2
.db    0xB4,0xBD
.db    0xBF,0xC2
.db    0xBF,0xBF
.db    0xC8,0xC7
.db    0xCA,0xC5
.db    0xC1,0xBC
.db    0xBB,0xB7
.db    0xB4,0xB0
.db    0xAB,0xA6
.db    0xA5,0xA0
.db    0xA0,0x99
.db    0x9A,0x99
.db    0x95,0x92
.db    0x8D,0x8D
.db    0x84,0x7A
.db    0x80,0x7C
.db    0x72,0x70
.db    0x71,0x70
.db    0x6C,0x66
.db    0x62,0x5F
.db    0x56,0x56
.db    0x52,0x51
.db    0x4C,0x4B
.db    0x46,0x42
.db    0x44,0x46
.db    0x47,0x46
.db    0x4B,0x4B
.db    0x4A,0x4C
.db    0x46,0x44
.db    0x43,0x45
.db    0x40,0x3F
.db    0x45,0x43
.db    0x4A,0x4C
.db    0x4B,0x4E
.db    0x55,0x60
.db    0x67,0x66
.db    0x66,0x62
.db    0x5F,0x64
.db    0x65,0x6A
.db    0x74,0x78
.db    0x7E,0x7B
.db    0x83,0x8A
.db    0x94,0x9D
.db    0xA4,0xAB
.db    0xBB,0xBF
.db    0xCC,0xD0
.db    0xDA,0xDD
.db    0xE4,0xEB
.db    0xE9,0xE8
.db    0xE5,0xE4
.db    0xDD,0xD5
.db    0xCD,0xC8
.db    0xC0,0xBD
.db    0xB5,0xAE
.db    0xA7,0xA1
.db    0x9A,0x9A
.db    0x96,0x93
.db    0x91,0x8F
.db    0x92,0x90
.db    0x8A,0x84
.db    0x7F,0x7D
.db    0x79,0x75
.db    0x74,0x73
.db    0x74,0x71
.db    0x73,0x75
.db    0x7A,0x7F
.db    0x87,0x87
.db    0x87,0x85
.db    0x81,0x7B
.db    0x73,0x6F
.db    0x6B,0x64
.db    0x5F,0x58
.db    0x51,0x4D
.db    0x4C,0x4A
.db    0x48,0x49
.db    0x45,0x44
.db    0x40,0x3C
.db    0x38,0x3A
.db    0x38,0x35
.db    0x39,0x38
.db    0x36,0x38
.db    0x3B,0x39
.db    0x39,0x3B
.db    0x3B,0x3B
.db    0x3D,0x3D
.db    0x3C,0x41
.db    0x49,0x50
.db    0x56,0x5C
.db    0x61,0x64
.db    0x6F,0x77
.db    0x80,0x88
.db    0x91,0x99
.db    0xA3,0xAE
.db    0xB8,0xC5
.db    0xD0,0xDC
.db    0xE4,0xED
.db    0xF2,0xF4
.db    0xF3,0xF5
.db    0xF0,0xEB
.db    0xE4,0xD7
.db    0xCC,0xC2
.db    0xBA,0xB0
.db    0xA5,0x9F
.db    0x94,0x88
.db    0x81,0x7B
.db    0x78,0x74
.db    0x72,0x6D
.db    0x67,0x62
.db    0x60,0x5F
.db    0x60,0x62
.db    0x63,0x66
.db    0x6A,0x70
.db    0x71,0x76
.db    0x80,0x86
.db    0x8B,0x92
.db    0x97,0x9C
.db    0x9F,0xA0
.db    0xA1,0x9D
.db    0x9B,0x95
.db    0x92,0x8C
.db    0x84,0x7D
.db    0x74,0x6E
.db    0x65,0x60
.db    0x5A,0x57
.db    0x55,0x54
.db    0x50,0x4E
.db    0x4E,0x4B
.db    0x4B,0x4B
.db    0x4D,0x4B
.db    0x4B,0x49
.db    0x45,0x40
.db    0x3F,0x3D
.db    0x3B,0x3B
.db    0x3A,0x3B
.db    0x3D,0x40
.db    0x46,0x4C
.db    0x50,0x57
.db    0x5C,0x64
.db    0x6A,0x72
.db    0x7B,0x83
.db    0x90,0x9C
.db    0xA7,0xB2
.db    0xBF,0xCB
.db    0xD9,0xE4
.db    0xF2,0xF9
.db    0xFD,0xFF
.db    0xFF,0xFF
.db    0xFD,0xF8
.db    0xEF,0xE3
.db    0xD5,0xC8
.db    0xB9,0xAA
.db    0x9C,0x8F
.db    0x83,0x76
.db    0x6E,0x67
.db    0x5F,0x59
.db    0x57,0x54
.db    0x51,0x52
.db    0x56,0x59
.db    0x5B,0x60
.db    0x62,0x68
.db    0x6C,0x73
.db    0x78,0x7F
.db    0x86,0x8B
.db    0x93,0x9D
.db    0xA5,0xAA
.db    0xAF,0xB4
.db    0xBA,0xBC
.db    0xC0,0xBE
.db    0xBA,0xB5
.db    0xAF,0xA7
.db    0x9D,0x92
.db    0x88,0x7B
.db    0x70,0x64
.db    0x5A,0x51
.db    0x4B,0x46
.db    0x41,0x40
.db    0x3E,0x3D
.db    0x3D,0x3D
.db    0x3E,0x3F
.db    0x41,0x43
.db    0x43,0x41
.db    0x40,0x3E
.db    0x3C,0x38
.db    0x36,0x35
.db    0x34,0x34
.db    0x36,0x3A
.db    0x3E,0x42
.db    0x4B,0x54
.db    0x5C,0x68
.db    0x74,0x80
.db    0x8C,0x99
.db    0xA6,0xB3
.db    0xBF,0xCC
.db    0xD8,0xE2
.db    0xEA,0xF0
.db    0xF5,0xF8
.db    0xF7,0xF6
.db    0xF3,0xED
.db    0xE4,0xDB
.db    0xD3,0xC7
.db    0xBC,0xB0
.db    0xA4,0x99
.db    0x8F,0x85
.db    0x7C,0x73
.db    0x6A,0x63
.db    0x5C,0x57
.db    0x50,0x4C
.db    0x4C,0x4C
.db    0x4D,0x4F
.db    0x51,0x55
.db    0x59,0x5F
.db    0x67,0x6E
.db    0x76,0x7E
.db    0x87,0x90
.db    0x98,0x9F
.db    0xA6,0xAC
.db    0xB2,0xB4
.db    0xB5,0xB3
.db    0xB1,0xAF
.db    0xA9,0xA3
.db    0x9B,0x92
.db    0x88,0x7F
.db    0x74,0x6A
.db    0x61,0x59
.db    0x51,0x4A
.db    0x44,0x3F
.db    0x3B,0x38
.db    0x37,0x36
.db    0x38,0x38
.db    0x3B,0x3D
.db    0x40,0x44
.db    0x46,0x48
.db    0x49,0x4A
.db    0x4A,0x4B
.db    0x4B,0x4A
.db    0x4B,0x49
.db    0x47,0x48
.db    0x49,0x4B
.db    0x4E,0x52
.db    0x54,0x59
.db    0x62,0x6B
.db    0x72,0x7D
.db    0x8A,0x98
.db    0xA5,0xB4
.db    0xC2,0xCD
.db    0xDA,0xE6
.db    0xEE,0xF5
.db    0xF7,0xF8
.db    0xF5,0xF0
.db    0xE7,0xDB
.db    0xCF,0xC3
.db    0xB5,0xA8
.db    0x9C,0x8F
.db    0x86,0x7E
.db    0x76,0x70
.db    0x6B,0x68
.db    0x66,0x63
.db    0x62,0x60
.db    0x5E,0x5E
.db    0x5E,0x5F
.db    0x5F,0x60
.db    0x63,0x66
.db    0x6B,0x71
.db    0x78,0x81
.db    0x8A,0x93
.db    0x9D,0xA6
.db    0xB0,0xB6
.db    0xBC,0xC2
.db    0xC3,0xC3
.db    0xC0,0xBD
.db    0xB7,0xAE
.db    0xA5,0x9C
.db    0x92,0x87
.db    0x7D,0x75
.db    0x6D,0x65
.db    0x5F,0x5A
.db    0x55,0x51
.db    0x4E,0x4C
.db    0x48,0x46
.db    0x44,0x43
.db    0x41,0x40
.db    0x41,0x40
.db    0x3F,0x3F
.db    0x40,0x3F
.db    0x3F,0x40
.db    0x40,0x41
.db    0x41,0x41
.db    0x42,0x44
.db    0x45,0x47
.db    0x4A,0x4E
.db    0x52,0x58
.db    0x5E,0x63
.db    0x6C,0x77
.db    0x80,0x8A
.db    0x97,0xA6
.db    0xB3,0xC2
.db    0xD1,0xDE
.db    0xE8,0xF4
.db    0xFC,0xFF
.db    0xFF,0xFE
.db    0xF9,0xF1
.db    0xE5,0xD9
.db    0xCA,0xBA
.db    0xAB,0x9E
.db    0x90,0x81
.db    0x79,0x72
.db    0x6B,0x66
.db    0x64,0x61
.db    0x60,0x60
.db    0x60,0x60
.db    0x5F,0x5F
.db    0x5F,0x60
.db    0x60,0x60
.db    0x61,0x65
.db    0x68,0x6D
.db    0x74,0x7B
.db    0x83,0x8C
.db    0x97,0xA0
.db    0xA9,0xB1
.db    0xB9,0xBE
.db    0xC1,0xC3
.db    0xC2,0xBF
.db    0xBA,0xB4
.db    0xAB,0xA2
.db    0x98,0x8F
.db    0x85,0x7C
.db    0x74,0x6F
.db    0x69,0x66
.db    0x64,0x63
.db    0x63,0x63
.db    0x64,0x65
.db    0x65,0x65
.db    0x64,0x62
.db    0x5F,0x5C
.db    0x57,0x52
.db    0x4D,0x48
.db    0x43,0x3F
.db    0x3C,0x3B
.db    0x38,0x38
.db    0x37,0x37
.db    0x37,0x38
.db    0x39,0x39
.db    0x39,0x39
.db    0x3A,0x3B
.db    0x3C,0x3D
.db    0x3E,0x45
.db    0x4C,0x56
.db    0x61,0x70
.db    0x81,0x92
.db    0xA5,0xBA
.db    0xCC,0xDD
.db    0xED,0xFC
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFB
.db    0xEF,0xE0
.db    0xCF,0xBC
.db    0xAD,0x9B
.db    0x8D,0x7F
.db    0x74,0x6B
.db    0x65,0x5F
.db    0x5C,0x5B
.db    0x5B,0x5B
.db    0x5D,0x5D
.db    0x5E,0x5F
.db    0x60,0x62
.db    0x62,0x63
.db    0x68,0x6D
.db    0x71,0x77
.db    0x80,0x88
.db    0x90,0x9B
.db    0xA4,0xAD
.db    0xB4,0xBB
.db    0xBF,0xC2
.db    0xC1,0xBF
.db    0xBA,0xB4
.db    0xAB,0xA1
.db    0x97,0x8C
.db    0x81,0x77
.db    0x6E,0x67
.db    0x60,0x5D
.db    0x5C,0x5C
.db    0x5E,0x61
.db    0x64,0x69
.db    0x6C,0x6F
.db    0x71,0x73
.db    0x73,0x70
.db    0x6E,0x6B
.db    0x66,0x60
.db    0x5B,0x55
.db    0x50,0x4B
.db    0x48,0x45
.db    0x41,0x3F
.db    0x3F,0x3F
.db    0x3E,0x3C
.db    0x3D,0x3D
.db    0x3B,0x39
.db    0x39,0x39
.db    0x39,0x38
.db    0x3B,0x3D
.db    0x41,0x4A
.db    0x58,0x63
.db    0x6F,0x86
.db    0x9B,0xB0
.db    0xC5,0xDD
.db    0xEE,0xFC
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFE,0xEE
.db    0xD9,0xC4
.db    0xB0,0x9A
.db    0x86,0x77
.db    0x69,0x5C
.db    0x55,0x53
.db    0x51,0x50
.db    0x53,0x57
.db    0x5B,0x5F
.db    0x61,0x64
.db    0x65,0x66
.db    0x67,0x67
.db    0x67,0x68
.db    0x6A,0x70
.db    0x74,0x79
.db    0x84,0x8F
.db    0x97,0xA2
.db    0xAD,0xB4
.db    0xB9,0xC0
.db    0xC2,0xBE
.db    0xB9,0xB2
.db    0xA9,0x9E
.db    0x91,0x87
.db    0x7A,0x70
.db    0x65,0x5D
.db    0x5A,0x57
.db    0x55,0x58
.db    0x5C,0x60
.db    0x65,0x6B
.db    0x70,0x76
.db    0x7B,0x7D
.db    0x7D,0x7D
.db    0x7B,0x78
.db    0x74,0x6F
.db    0x6A,0x65
.db    0x5E,0x59
.db    0x56,0x52
.db    0x4E,0x4B
.db    0x4A,0x47
.db    0x47,0x46
.db    0x43,0x41
.db    0x40,0x3D
.db    0x3B,0x38
.db    0x37,0x36
.db    0x34,0x36
.db    0x3B,0x3F
.db    0x42,0x4F
.db    0x5F,0x6A
.db    0x7C,0x93
.db    0xAA,0xBB
.db    0xD1,0xE6
.db    0xF5,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFF
.db    0xFF,0xF5
.db    0xE5,0xD4
.db    0xC1,0xAF
.db    0x9F,0x8F
.db    0x86,0x7C
.db    0x73,0x6F
.db    0x6F,0x6E
.db    0x6B,0x6C
.db    0x6C,0x69
.db    0x67,0x65
.db    0x61,0x5E
.db    0x5B,0x5B
.db    0x5A,0x5C
.db    0x60,0x67
.db    0x70,0x7C
.db    0x88,0x95
.db    0xA0,0xAE
.db    0xB9,0xBF
.db    0xC6,0xCC
.db    0xC9,0xC5
.db    0xC1,0xB9
.db    0xAD,0xA1
.db    0x97,0x89
.db    0x7D,0x73
.db    0x6A,0x61
.db    0x5A,0x57
.db    0x5A,0x59
.db    0x5A,0x5F
.db    0x66,0x69
.db    0x70,0x75
.db    0x78,0x79
.db    0x7C,0x7A
.db    0x78,0x76
.db    0x70,0x6D
.db    0x68,0x64
.db    0x60,0x5C
.db    0x59,0x58
.db    0x58,0x54
.db    0x52,0x4F
.db    0x4D,0x4A
.db    0x49,0x43
.db    0x3E,0x3A
.db    0x37,0x30
.db    0x2D,0x2C
.db    0x29,0x29
.db    0x2B,0x31
.db    0x38,0x3F
.db    0x48,0x59
.db    0x6A,0x79
.db    0x8A,0xA0
.db    0xB2,0xC3
.db    0xD6,0xE9
.db    0xF0,0xF8
.db    0xFE,0xFF
.db    0xFF,0xFD
.db    0xF9,0xEE
.db    0xE1,0xD7
.db    0xC9,0xBB
.db    0xAE,0xA2
.db    0x99,0x92
.db    0x88,0x81
.db    0x7D,0x77
.db    0x70,0x6D
.db    0x68,0x61
.db    0x5E,0x59
.db    0x56,0x52
.db    0x52,0x53
.db    0x57,0x5A
.db    0x60,0x69
.db    0x73,0x7E
.db    0x88,0x94
.db    0x9F,0xA6
.db    0xAD,0xB3
.db    0xB7,0xB5
.db    0xB2,0xAF
.db    0xA8,0xA1
.db    0x98,0x90
.db    0x87,0x7F
.db    0x79,0x73
.db    0x6F,0x6D
.db    0x6B,0x6A
.db    0x6D,0x6F
.db    0x6F,0x70
.db    0x72,0x74
.db    0x77,0x77
.db    0x79,0x79
.db    0x7A,0x7C
.db    0x7E,0x7D
.db    0x7C,0x7B
.db    0x79,0x77
.db    0x74,0x70
.db    0x6B,0x66
.db    0x60,0x5A
.db    0x54,0x4C
.db    0x47,0x40
.db    0x39,0x32
.db    0x30,0x2B
.db    0x28,0x27
.db    0x26,0x26
.db    0x29,0x2C
.db    0x32,0x3A
.db    0x43,0x4A
.db    0x51,0x65
.db    0x74,0x82
.db    0x92,0xA9
.db    0xB8,0xCB
.db    0xDE,0xEE
.db    0xF7,0xFF
.db    0xFF,0xFF
.db    0xFF,0xFC
.db    0xF6,0xE8
.db    0xDB,0xCE
.db    0xC2,0xB3
.db    0xA7,0x9D
.db    0x98,0x8E
.db    0x85,0x81
.db    0x7B,0x77
.db    0x6E,0x68
.db    0x62,0x5C
.db    0x54,0x51
.db    0x4E,0x4D
.db    0x4E,0x50
.db    0x57,0x5D
.db    0x65,0x6F
.db    0x7E,0x8A
.db    0x95,0xA2
.db    0xAB,0xB1
.db    0xB3,0xB8
.db    0xB2,0xAB
.db    0xA6,0x9E
.db    0x96,0x8C
.db    0x85,0x7E
.db    0x7A,0x77
.db    0x76,0x75
.db    0x73,0x70
.db    0x70,0x71
.db    0x6F,0x6A
.db    0x6A,0x68
.db    0x67,0x68
.db    0x69,0x69
.db    0x6A,0x6C
.db    0x6F,0x70
.db    0x71,0x71
.db    0x6F,0x6D
.db    0x69,0x66
.db    0x60,0x5B
.db    0x53,0x4E
.db    0x49,0x44
.db    0x40,0x3D
.db    0x39,0x39
.db    0x37,0x36
.db    0x36,0x36
.db    0x36,0x37
.db    0x37,0x37
.db    0x3C,0x3D
.db    0x42,0x4A
.db    0x49,0x59
.db    0x68,0x76
.db    0x87,0xA0
.db    0xB0,0xC4
.db    0xDC,0xE8
.db    0xF3,0xFF
.db    0xFF,0xFE
.db    0xFB,0xF3
.db    0xE4,0xD7
.db    0xCD,0xBC
.db    0xB1,0xAA
.db    0x9F,0x9A
.db    0x97,0x8F
.db    0x88,0x86
.db    0x7B,0x73
.db    0x6C,0x60
.db    0x54,0x4E
.db    0x47,0x43
.db    0x43,0x44
.db    0x4B,0x55
.db    0x62,0x6E
.db    0x81,0x8F
.db    0x9A,0xA4
.db    0xB1,0xB5
.db    0xB7,0xB9
.db    0xB5,0xB0
.db    0xAF,0xAD
.db    0xAB,0xA4
.db    0xA2,0xA1
.db    0x9E,0x9A
.db    0x96,0x8F
.db    0x88,0x82
.db    0x77,0x6F
.db    0x68,0x5F
.db    0x5A,0x58
.db    0x57,0x58
.db    0x5E,0x66
.db    0x6A,0x6D
.db    0x75,0x77
.db    0x77,0x75
.db    0x6F,0x67
.db    0x63,0x5A
.db    0x54,0x50
.db    0x4B,0x49
.db    0x49,0x4B
.db    0x4B,0x48
.db    0x48,0x45
.db    0x3E,0x3C
.db    0x37,0x2F
.db    0x28,0x26
.db    0x24,0x22
.db    0x24,0x2B
.db    0x33,0x3D
.db    0x4B,0x55
.db    0x63,0x78
.db    0x84,0x97
.db    0xAB,0xB8
.db    0xC8,0xDA
.db    0xE4,0xEC
.db    0xF2,0xF1
.db    0xF6,0xF2
.db    0xEC,0xE7
.db    0xDD,0xD3
.db    0xCC,0xC2
.db    0xBA,0xB1
.db    0xA6,0x9C
.db    0x93,0x8B
.db    0x81,0x74
.db    0x6D,0x64
.db    0x5B,0x5B
.db    0x56,0x51
.db    0x56,0x5B
.db    0x5D,0x67
.db    0x6F,0x74
.db    0x7E,0x86
.db    0x8D,0x95
.db    0x99,0x9F
.db    0xA4,0xA6
.db    0xAC,0xAE
.db    0xAF,0xB1
.db    0xB2,0xB2
.db    0xB2,0xAF
.db    0xAA,0xA5
.db    0xA0,0x9A
.db    0x91,0x89
.db    0x86,0x80
.db    0x7F,0x7C
.db    0x79,0x7C
.db    0x7C,0x7C
.db    0x7B,0x7B
.db    0x7A,0x77
.db    0x72,0x6D
.db    0x69,0x64
.db    0x60,0x5B
.db    0x56,0x54
.db    0x51,0x4E
.db    0x4D,0x49
.db    0x46,0x43
.db    0x3E,0x35
.db    0x2F,0x2A
.db    0x26,0x23
.db    0x21,0x21
.db    0x1F,0x22
.db    0x26,0x28
.db    0x2C,0x32
.db    0x36,0x40
.db    0x4B,0x4D
.db    0x58,0x68
.db    0x75,0x8C
.db    0xA0,0xAD
.db    0xC3,0xD7
.db    0xE5,0xF0
.db    0xF9,0xF3
.db    0xF6,0xF5
.db    0xF1,0xE9
.db    0xE2,0xD9
.db    0xD3,0xD2
.db    0xCC,0xC2
.db    0xBB,0xB2
.db    0xA3,0x9C
.db    0x8E,0x81
.db    0x76,0x6A
.db    0x5E,0x5E
.db    0x5B,0x58
.db    0x5D,0x5D
.db    0x60,0x6C
.db    0x6F,0x70
.db    0x77,0x79
.db    0x7D,0x86
.db    0x8B,0x8D
.db    0x96,0x9D
.db    0xA4,0xAA
.db    0xB0,0xB2
.db    0xB4,0xB2
.db    0xAF,0xAA
.db    0xA5,0x9B
.db    0x95,0x8F
.db    0x8C,0x8B
.db    0x87,0x83
.db    0x83,0x82
.db    0x81,0x7C
.db    0x77,0x72
.db    0x6E,0x6B
.db    0x65,0x60
.db    0x5C,0x5B
.db    0x5B,0x59
.db    0x56,0x52
.db    0x4E,0x4A
.db    0x46,0x40
.db    0x3A,0x35
.db    0x30,0x2C
.db    0x2A,0x2B
.db    0x2B,0x2B
.db    0x2B,0x2C
.db    0x2B,0x2D
.db    0x2F,0x2E
.db    0x2F,0x35
.db    0x3B,0x47
.db    0x54,0x5D
.db    0x69,0x78
.db    0x8D,0xA0
.db    0xB0,0xBA
.db    0xC4,0xD0
.db    0xDD,0xE6
.db    0xE5,0xE5
.db    0xE7,0xE8
.db    0xEB,0xE8
.db    0xE1,0xDC
.db    0xD5,0xCE
.db    0xC6,0xB8
.db    0xAE,0xA0
.db    0x95,0x8B
.db    0x84,0x7F
.db    0x77,0x71
.db    0x6D,0x6A
.db    0x69,0x69
.db    0x66,0x5F
.db    0x61,0x63
.db    0x68,0x70
.db    0x74,0x79
.db    0x82,0x8A
.db    0x93,0x99
.db    0x9A,0x9E
.db    0xA1,0xA3
.db    0xA6,0xA5
.db    0xA1,0xA2
.db    0xA1,0xA0
.db    0x9F,0x9A
.db    0x95,0x8E
.db    0x89,0x85
.db    0x7F,0x7E
.db    0x79,0x75
.db    0x72,0x70
.db    0x6A,0x67
.db    0x5E,0x59
.db    0x55,0x51
.db    0x4C,0x4A
.db    0x45,0x44
.db    0x46,0x43
.db    0x40,0x3D
.db    0x3A,0x36
.db    0x33,0x2F
.db    0x2C,0x2B
.db    0x2D,0x30
.db    0x33,0x36
.db    0x36,0x39
.db    0x3B,0x41
.db    0x45,0x49
.db    0x4F,0x58
.db    0x63,0x6D
.db    0x78,0x84
.db    0x90,0xA2
.db    0xB0,0xBD
.db    0xC6,0xCC
.db    0xD0,0xD2
.db    0xD6,0xD7
.db    0xD8,0xD8
.db    0xD6,0xD5
.db    0xD2,0xCD
.db    0xCA,0xC2
.db    0xBB,0xB3
.db    0xA9,0xA0
.db    0x96,0x90
.db    0x8B,0x89
.db    0x87,0x87
.db    0x83,0x82
.db    0x81,0x80
.db    0x80,0x82
.db    0x83,0x87
.db    0x89,0x89
.db    0x8A,0x8E
.db    0x92,0x96
.db    0x97,0x97
.db    0x97,0x95
.db    0x93,0x93
.db    0x92,0x91
.db    0x90,0x8D
.db    0x89,0x87
.db    0x83,0x80
.db    0x7E,0x7A
.db    0x78,0x76
.db    0x73,0x71
.db    0x71,0x71
.db    0x71,0x70
.db    0x6F,0x70
.db    0x71,0x70
.db    0x71,0x70
.db    0x71,0x71
.db    0x71,0x72
.db    0x71,0x71
.db    0x72,0x70
.db    0x6E,0x6B
.db    0x6B,0x6A
.db    0x6A,0x68
.db    0x67,0x66
.db    0x65,0x65
.db    0x65,0x64
.db    0x63,0x62
.db    0x60,0x60
.db    0x60,0x61
.db    0x63,0x63
.db    0x63,0x63
.db    0x63,0x66
.db    0x65,0x68
.db    0x69,0x6A
.db    0x6D,0x6E
.db    0x71,0x73
.db    0x76,0x7A
.db    0x7C,0x7E
.db    0x80,0x82
.db    0x85,0x85
.db    0x89,0x8B
.db    0x8D,0x8F
.db    0x91,0x92
.db    0x95,0x95
.db    0x97,0x9A
.db    0x9B,0x9C
.db    0x9D,0x9D
.db    0x9E,0x9E
.db    0xA0,0x9F
.db    0x9F,0x9F
.db    0x9F,0x9E
.db    0x9D,0x9D
.db    0x9C,0x9A
.db    0x9A,0x98
.db    0x96,0x96
.db    0x93,0x93
.db    0x90,0x8F
.db    0x8D,0x89
.db    0x89,0x87
.db    0x85,0x84
.db    0x81,0x80
.db    0x7E,0x7B
.db    0x7B,0x79
.db    0x77,0x77
.db    0x74,0x74
.db    0x72,0x72
.db    0x71,0x6F
.db    0x6D,0x6C
.db    0x6C,0x69
.db    0x68,0x67
.db    0x65,0x65
.db    0x64,0x62
.db    0x62,0x61
.db    0x60,0x5F
.db    0x5E,0x5E
.db    0x5E,0x5D
.db    0x5D,0x5D
.db    0x5D,0x5E
.db    0x5F,0x61
.db    0x61,0x63
.db    0x64,0x67
.db    0x69,0x6B
.db    0x6F,0x71
.db    0x73,0x78
.db    0x7B,0x7D
.db    0x81,0x85
.db    0x87,0x8D
.db    0x8F,0x93
.db    0x97,0x97
.db    0x9F,0x9F
.db    0xA2,0xA6
.db    0xA6,0xA9
.db    0xAB,0xAC
.db    0xAC,0xAF
.db    0xAE,0xAE
.db    0xB1,0xAD
.db    0xB1,0xAD
.db    0xAC,0xAD
.db    0xA7,0xAB
.db    0xA4,0xA5
.db    0xA1,0xA0
.db    0xA1,0x98
.db    0x98,0x9D
.db    0x8F,0x9C
.db    0x8B,0x97
.db    0x8E,0x7B
.db    0x93,0x6C
.db    0x83,0x6E
.db    0x72,0x73
.db    0x64,0x72
.db    0x67,0x66
.db    0x64,0x63
.db    0x65,0x60
.db    0x66,0x61
.db    0x66,0x64
.db    0x61,0x66
.db    0x59,0x66
.db    0x51,0x6A
.db    0x4F,0x68
.db    0x58,0x61
.db    0x5F,0x57
.db    0x68,0x55
.db    0x66,0x54
.db    0x62,0x5A
.db    0x5B,0x61
.db    0x55,0x6A
.db    0x58,0x6C
.db    0x60,0x6D
.db    0x69,0x6B
.db    0x6B,0x73
.db    0x6C,0x7B
.db    0x70,0x82
.db    0x7A,0x7D
.db    0x86,0x7A
.db    0x8C,0x7D
.db    0x8C,0x82
.db    0x8C,0x88
.db    0x8E,0x8F
.db    0x8F,0x95
.db    0x96,0x97
.db    0x97,0x9C
.db    0x94,0x9E
.db    0x98,0x9A
.db    0x9E,0x9B
.db    0x9E,0x9D
.db    0x9D,0x9B
.db    0xA0,0x9A
.db    0x9D,0x97
.db    0x9C,0x95
.db    0x9A,0x95
.db    0x94,0x94
.db    0x92,0x92
.db    0x90,0x90
.db    0x8C,0x8D
.db    0x87,0x8A
.db    0x84,0x85
.db    0x83,0x80
.db    0x83,0x7B
.db    0x80,0x7A
.db    0x7A,0x79
.db    0x78,0x75
.db    0x75,0x74
.db    0x73,0x70
.db    0x70,0x6E
.db    0x70,0x6C
.db    0x6B,0x6B
.db    0x69,0x69
.db    0x6A,0x6B
.db    0x69,0x69
.db    0x68,0x6A
.db    0x6A,0x6B
.db    0x6A,0x6C
.db    0x6D,0x6C
.db    0x6E,0x6C
.db    0x6D,0x6F
.db    0x70,0x70
.db    0x71,0x75
.db    0x78,0x76
.db    0x74,0x75
.db    0x78,0x7C
.db    0x7E,0x7D
.db    0x7E,0x7D
.db    0x80,0x81
.db    0x84,0x86
.db    0x86,0x87
.db    0x86,0x89
.db    0x8A,0x8A
.db    0x8A,0x8C
.db    0x8D,0x8F
.db    0x8F,0x8F
.db    0x8E,0x8E
.db    0x8E,0x8E
.db    0x8E,0x8C
.db    0x8A,0x8B
.db    0x8B,0x8C
.db    0x8B,0x8A
.db    0x89,0x85
.db    0x83,0x83
.db    0x85,0x86
.db    0x85,0x85
.db    0x84,0x82
.db    0x82,0x81
.db    0x82,0x81
.db    0x7C,0x7A
.db    0x7E,0x82
.db    0x7F,0x7B
.db    0x76,0x75
.db    0x76,0x7C
.db    0x7A,0x77
.db    0x76,0x78
.db    0x7A,0x78
.db    0x77,0x77
.db    0x78,0x7B
.db    0x79,0x75
.db    0x77,0x7D
.db    0x7D,0x77
.db    0x75,0x78
.db    0x7B,0x78
.db    0x78,0x78
.db    0x7B,0x7D
.db    0x7C,0x7B
.db    0x7B,0x76
.db    0x77,0x7B
.db    0x7C,0x7B
.db    0x7A,0x78
.db    0x7A,0x7C
.db    0x7E,0x7C
.db    0x7B,0x7C
.db    0x7C,0x7C
.db    0x7D,0x7D
.db    0x7D,0x7B
.db    0x78,0x79
.db    0x78,0x80
.db    0x84,0x7F
.db    0x79,0x79
.db    0x81,0x83
.db    0x83,0x86
.db    0x89,0x8A
.db    0x88,0x86
.db    0x88,0x8C
.db    0x90,0x93
.db    0x94,0x95
.db    0x98,0x97
.db    0x99,0x9B
.db    0x99,0x98
.db    0x96,0x98
.db    0x9A,0x9A
.db    0x95,0x8D
.db    0x88,0x87
.db    0x85,0x84
.db    0x87,0x87
.db    0x7E,0x7B
.db    0x7D,0x76
.db    0x70,0x72
.db    0x73,0x76
.db    0x75,0x75
.db    0x74,0x74
.db    0x74,0x76
.db    0x7B,0x77
.db    0x73,0x71
.db    0x78,0x80
.db    0x81,0x7F
.db    0x7C,0x82
.db    0x79,0x64
.db    0x71,0xA2
.db    0xBB,0xA1
.db    0x6E,0x4E
.db    0x6C,0x8B
.db    0x7F,0x66
.db    0x6E,0xA5
.db    0xB6,0x92
.db    0x54,0x38
.db    0x5E,0x83
.db    0x83,0x6B
.db    0x60,0x68
.db    0x62,0x57
.db    0x4C,0x42
.db    0x4C,0x72
.db    0x86,0x7D
.db    0x72,0x6D
.db    0x76,0x6F
.db    0x6B,0x6F
.db    0x7A,0x87
.db    0x90,0xA0
.db    0xA3,0x8B
.db    0x80,0x84
.db    0x99,0xA0
.db    0x86,0x78
.db    0xA4,0xB9
.db    0x9C,0x77
.db    0x7E,0x94
.db    0x8D,0x7E
.db    0x76,0x88
.db    0xA2,0x97
.db    0x78,0x7A
.db    0x8F,0x8F
.db    0x79,0x75
.db    0x88,0x9A
.db    0x9A,0x85
.db    0x7C,0x8A
.db    0x86,0x76
.db    0x71,0x7B
.db    0x8A,0x8D
.db    0x83,0x81
.db    0x76,0x75
.db    0x77,0x6D
.db    0x69,0x79
.db    0x8C,0x86
.db    0x6F,0x67
.db    0x6A,0x67
.db    0x64,0x67
.db    0x6C,0x70
.db    0x6C,0x63
.db    0x5E,0x5C
.db    0x5A,0x5E
.db    0x5F,0x61
.db    0x68,0x71
.db    0x6C,0x60
.db    0x61,0x6A
.db    0x71,0x72
.db    0x78,0x7F
.db    0x7E,0x7D
.db    0x7B,0x80
.db    0x85,0x85
.db    0x85,0x89
.db    0x90,0x91
.db    0x90,0x8E
.db    0x90,0x93
.db    0x95,0x92
.db    0x94,0x98
.db    0x9C,0x9B
.db    0x98,0x98
.db    0x99,0x9C
.db    0x9A,0x99
.db    0x9E,0xA3
.db    0xA4,0x9F
.db    0x9B,0x9B
.db    0x9B,0x9D
.db    0xA0,0xA1
.db    0xA1,0x9E
.db    0x98,0x96
.db    0x93,0x90
.db    0x8D,0x8A
.db    0x8A,0x8B
.db    0x87,0x82
.db    0x7D,0x78
.db    0x75,0x74
.db    0x72,0x6D
.db    0x6D,0x6B
.db    0x67,0x63
.db    0x64,0x63
.db    0x62,0x5E
.db    0x5B,0x5B
.db    0x5B,0x5A
.db    0x5A,0x5D
.db    0x5C,0x5B
.db    0x58,0x57
.db    0x55,0x56
.db    0x59,0x5A
.db    0x5B,0x5B
.db    0x5D,0x5F
.db    0x5F,0x5E
.db    0x5E,0x64
.db    0x6C,0x73
.db    0x73,0x71
.db    0x75,0x80
.db    0x88,0x8A
.db    0x8B,0x91
.db    0x99,0xA2
.db    0xAB,0xAC
.db    0xAC,0xAF
.db    0xB7,0xBC
.db    0xBF,0xBD
.db    0xBA,0xBB
.db    0xBA,0xB9
.db    0xBB,0xB8
.db    0xB0,0xAB
.db    0xA7,0xA4
.db    0xA1,0x9D
.db    0x9C,0x98
.db    0x91,0x8B
.db    0x8A,0x89
.db    0x86,0x81
.db    0x7F,0x7E
.db    0x7E,0x7D
.db    0x7A,0x77
.db    0x72,0x71
.db    0x72,0x72
.db    0x6D,0x67
.db    0x66,0x6A
.db    0x6F,0x69
.db    0x61,0x5D
.db    0x5F,0x61
.db    0x61,0x60
.db    0x5B,0x5B
.db    0x5E,0x5D
.db    0x5D,0x5C
.db    0x5C,0x5F
.db    0x60,0x63
.db    0x64,0x63
.db    0x63,0x61
.db    0x5E,0x66
.db    0x6D,0x6D
.db    0x6A,0x62
.db    0x67,0x6F
.db    0x78,0x78
.db    0x75,0x76
.db    0x7D,0x82
.db    0x81,0x84
.db    0x8A,0x8B
.db    0x8E,0x94
.db    0x99,0x9F
.db    0xA2,0xA3
.db    0xA3,0x9E
.db    0xA2,0xAA
.db    0xBC,0xC0
.db    0xB3,0xAB
.db    0xA6,0x9F
.db    0x90,0xB6
.db    0xED,0xFA
.db    0xBF,0x66
.db    0x3A,0x66
.db    0xA8,0xC5
.db    0xAA,0x6D
.db    0x41,0x51
.db    0x76,0x85
.db    0x77,0x55
.db    0x4D,0x5E
.db    0x68,0x69
.db    0x4E,0x46
.db    0x46,0x58
.db    0x65,0x5A
.db    0x52,0x49
.db    0x4C,0x61
.db    0x68,0x66
.db    0x5E,0x48
.db    0x5F,0x6B
.db    0x74,0x63
.db    0x3D,0x2F
.db    0x57,0x7D
.db    0x74,0x54
.db    0x37,0x37
.db    0x42,0x53
.db    0x4C,0x36
.db    0x44,0x51
.db    0x71,0x68
.db    0x58,0x4B
.db    0x51,0x74
.db    0x81,0x93
.db    0x8F,0x91
.db    0xA3,0xAB
.db    0xA1,0x97
.db    0x95,0xA7
.db    0xB0,0xC5
.db    0xCD,0xC8
.db    0xC0,0xAA
.db    0xA6,0xA6
.db    0xA4,0xA6
.db    0x9A,0xB3
.db    0xC4,0xC1
.db    0xA2,0x73
.db    0x6E,0x8D
.db    0x9D,0xA6
.db    0x93,0x7E
.db    0x8C,0x88
.db    0x80,0x6C
.db    0x6D,0x7E
.db    0x84,0x7E
.db    0x6C,0x6D
.db    0x5B,0x5E
.db    0x63,0x62
.db    0x6B,0x49
.db    0x40,0x44
.db    0x46,0x53
.db    0x37,0x2C
.db    0x3A,0x45
.db    0x47,0x32
.db    0x29,0x37
.db    0x48,0x59
.db    0x5D,0x61
.db    0x65,0x63
.db    0x64,0x67
.db    0x7C,0x97
.db    0xA9,0xB1
.db    0xB7,0xB8
.db    0xB2,0xA8
.db    0xAC,0xBC
.db    0xCC,0xDA
.db    0xD7,0xD7
.db    0xCD,0xBC
.db    0xA4,0xA1
.db    0xA9,0xB9
.db    0xBB,0xAE
.db    0x9F,0x8F
.db    0x89,0x7B
.db    0x71,0x6C
.db    0x6F,0x72
.db    0x71,0x6C
.db    0x5E,0x4D
.db    0x3F,0x4B
.db    0x5D,0x6E
.db    0x6A,0x60
.db    0x5C,0x66
.db    0x70,0x6F
.db    0x68,0x71
.db    0x86,0x9B
.db    0xA0,0x8B
.db    0x7B,0x7C
.db    0x8F,0x9B
.db    0x99,0x87
.db    0x81,0x83
.db    0x8A,0x84
.db    0x79,0x6C
.db    0x6A,0x6C
.db    0x6B,0x63
.db    0x57,0x51
.db    0x4A,0x4A
.db    0x4D,0x44
.db    0x3A,0x3B
.db    0x3F,0x48
.db    0x48,0x39
.db    0x2D,0x3C
.db    0x5C,0x71
.db    0x72,0x6C
.db    0x6C,0x76
.db    0x8E,0x9B
.db    0xA2,0xB4
.db    0xC6,0xD0
.db    0xCC,0xCA
.db    0xC2,0xC7
.db    0xD6,0xE5
.db    0xE2,0xD7
.db    0xCA,0xBF
.db    0xB8,0xB9
.db    0xAF,0xA3
.db    0xA8,0xA8
.db    0xA8,0x97
.db    0x87,0x75
.db    0x72,0x7A
.db    0x83,0x83
.db    0x80,0x79
.db    0x72,0x73
.db    0x73,0x6F
.db    0x68,0x71
.db    0x79,0x7D
.db    0x75,0x6A
.db    0x67,0x6B
.db    0x74,0x70
.db    0x67,0x62
.db    0x67,0x6B
.db    0x6C,0x68
.db    0x64,0x60
.db    0x5D,0x5D
.db    0x5C,0x5C
.db    0x5F,0x5E
.db    0x5A,0x55
.db    0x4E,0x47
.db    0x43,0x47
.db    0x4D,0x50
.db    0x50,0x4D
.db    0x48,0x4C
.db    0x55,0x5E
.db    0x69,0x7B
.db    0x8C,0x99
.db    0xA3,0xAA
.db    0xB1,0xBD
.db    0xCF,0xDC
.db    0xE5,0xED
.db    0xEF,0xE9
.db    0xE4,0xE1
.db    0xDC,0xD7
.db    0xD3,0xC9
.db    0xBA,0xAA
.db    0x99,0x87
.db    0x79,0x71
.db    0x67,0x5C
.db    0x52,0x47
.db    0x3C,0x3A
.db    0x38,0x33
.db    0x32,0x37
.db    0x39,0x3A
.db    0x3C,0x42
.db    0x47,0x4E
.db    0x51,0x50
.db    0x54,0x5D
.db    0x63,0x65
.db    0x6D,0x73
.db    0x73,0x73
.db    0x73,0x73
.db    0x75,0x79
.db    0x7A,0x79
.db    0x7B,0x78
.db    0x73,0x71
.db    0x74,0x77
.db    0x7A,0x7D
.db    0x76,0x6B
.db    0x66,0x69
.db    0x6A,0x6C
.db    0x6E,0x70
.db    0x73,0x76
.db    0x6F,0x70
.db    0x83,0x98
.db    0x9E,0xA7
.db    0xB3,0xBA
.db    0xC0,0xC4
.db    0xCC,0xDF
.db    0xF1,0xF1
.db    0xED,0xF3
.db    0xF4,0xE7
.db    0xDC,0xD8
.db    0xDA,0xD5
.db    0xC9,0xB8
.db    0xAD,0xA0
.db    0x96,0x87
.db    0x7A,0x6C
.db    0x66,0x62
.db    0x62,0x5A
.db    0x51,0x46
.db    0x47,0x45
.db    0x47,0x4D
.db    0x53,0x56
.db    0x54,0x56
.db    0x5A,0x61
.db    0x62,0x5F
.db    0x63,0x6D
.db    0x73,0x73
.db    0x71,0x72
.db    0x75,0x74
.db    0x6F,0x6D
.db    0x6C,0x6D
.db    0x6D,0x6A
.db    0x65,0x60
.db    0x5C,0x52
.db    0x4F,0x4E
.db    0x4E,0x47
.db    0x46,0x46
.db    0x3E,0x37
.db    0x38,0x39
.db    0x39,0x3A
.db    0x40,0x47
.db    0x4D,0x54
.db    0x4B,0x51
.db    0x64,0x83
.db    0x91,0x9E
.db    0xA1,0xA9
.db    0xB8,0xCA
.db    0xCF,0xDE
.db    0xE8,0xEF
.db    0xF3,0xFD
.db    0xF9,0xEE
.db    0xEB,0xEE
.db    0xF1,0xEE
.db    0xE2,0xD0
.db    0xC6,0xBE
.db    0xB5,0xA7
.db    0x99,0x8D
.db    0x89,0x82
.db    0x79,0x68
.db    0x5D,0x57
.db    0x57,0x55
.db    0x53,0x53
.db    0x56,0x57
.db    0x56,0x52
.db    0x53,0x5C
.db    0x63,0x67
.db    0x69,0x72
.db    0x77,0x77
.db    0x76,0x79
.db    0x7D,0x81
.db    0x81,0x80
.db    0x80,0x7D
.db    0x78,0x76
.db    0x72,0x6D
.db    0x67,0x63
.db    0x5F,0x57
.db    0x50,0x4C
.db    0x48,0x40
.db    0x3C,0x36
.db    0x31,0x2F
.db    0x31,0x2E
.db    0x2D,0x30
.db    0x35,0x3A
.db    0x43,0x45
.db    0x3D,0x49
.db    0x60,0x7A
.db    0x88,0x98
.db    0x9C,0xA1
.db    0xAF,0xBE
.db    0xC7,0xD6
.db    0xE1,0xE8
.db    0xF1,0xF7
.db    0xF1,0xE6
.db    0xEB,0xEA
.db    0xEA,0xE4
.db    0xE0,0xD0
.db    0xC6,0xB8
.db    0xAD,0xA5
.db    0x9D,0x90
.db    0x89,0x81
.db    0x74,0x69
.db    0x66,0x5E
.db    0x57,0x58
.db    0x57,0x56
.db    0x54,0x5A
.db    0x58,0x53
.db    0x55,0x5C
.db    0x62,0x67
.db    0x70,0x77
.db    0x78,0x76
.db    0x79,0x7C
.db    0x80,0x83
.db    0x87,0x87
.db    0x88,0x87
.db    0x84,0x7D
.db    0x76,0x73
.db    0x70,0x6D
.db    0x67,0x63
.db    0x5D,0x56
.db    0x51,0x49
.db    0x45,0x43
.db    0x42,0x3D
.db    0x39,0x36
.db    0x35,0x34
.db    0x36,0x38
.db    0x3E,0x46
.db    0x4B,0x46
.db    0x43,0x50
.db    0x64,0x79
.db    0x85,0x94
.db    0x97,0x9E
.db    0xA6,0xB7
.db    0xC5,0xCD
.db    0xD6,0xE3
.db    0xE9,0xEE
.db    0xE8,0xE4
.db    0xE0,0xE7
.db    0xEB,0xEB
.db    0xE1,0xCF
.db    0xC2,0xBE
.db    0xBA,0xAD
.db    0xA2,0x9A
.db    0x91,0x89
.db    0x83,0x78
.db    0x6A,0x61
.db    0x60,0x60
.db    0x63,0x60
.db    0x5D,0x5B
.db    0x5A,0x5A
.db    0x5A,0x5C
.db    0x5D,0x64
.db    0x6C,0x70
.db    0x73,0x73
.db    0x74,0x78
.db    0x7E,0x81
.db    0x84,0x82
.db    0x81,0x80
.db    0x83,0x82
.db    0x7F,0x7B
.db    0x79,0x77
.db    0x73,0x6E
.db    0x6C,0x66
.db    0x5F,0x5B
.db    0x5C,0x56
.db    0x50,0x4C
.db    0x48,0x42
.db    0x41,0x42
.db    0x41,0x3C
.db    0x3A,0x39
.db    0x40,0x45
.db    0x48,0x48
.db    0x49,0x4A
.db    0x59,0x6E
.db    0x78,0x81
.db    0x8B,0x94
.db    0x9A,0xAB
.db    0xB7,0xBB
.db    0xC8,0xD6
.db    0xDF,0xE6
.db    0xE9,0xE1
.db    0xE2,0xE8
.db    0xE6,0xE6
.db    0xE6,0xDB
.db    0xCD,0xCC
.db    0xC5,0xB6
.db    0xAB,0xA1
.db    0x96,0x92
.db    0x8D,0x80
.db    0x73,0x69
.db    0x5F,0x5C
.db    0x58,0x56
.db    0x52,0x52
.db    0x50,0x52
.db    0x51,0x51
.db    0x53,0x57
.db    0x5A,0x62
.db    0x6A,0x6D
.db    0x6E,0x74
.db    0x78,0x79
.db    0x7D,0x81
.db    0x84,0x87
.db    0x88,0x87
.db    0x85,0x83
.db    0x83,0x82
.db    0x7F,0x7B
.db    0x7A,0x78
.db    0x71,0x6D
.db    0x69,0x63
.db    0x60,0x60
.db    0x5D,0x57
.db    0x55,0x55
.db    0x50,0x4F
.db    0x4E,0x4C
.db    0x49,0x4E
.db    0x52,0x56
.db    0x55,0x57
.db    0x5B,0x5A
.db    0x5D,0x69
.db    0x75,0x7C
.db    0x81,0x8F
.db    0x92,0x96
.db    0x9C,0xA7
.db    0xA9,0xB4
.db    0xBF,0xC3
.db    0xC3,0xC9
.db    0xC9,0xC7
.db    0xCB,0xCE
.db    0xCC,0xCD
.db    0xCC,0xC8
.db    0xC3,0xBB
.db    0xB5,0xB1
.db    0xAC,0xA4
.db    0xA2,0x9D
.db    0x93,0x8A
.db    0x87,0x7E
.db    0x79,0x75
.db    0x70,0x6D
.db    0x6B,0x68
.db    0x63,0x63
.db    0x62,0x5E
.db    0x5C,0x5C
.db    0x5F,0x62
.db    0x65,0x65
.db    0x65,0x67
.db    0x6A,0x6B
.db    0x70,0x71
.db    0x71,0x72
.db    0x77,0x76
.db    0x78,0x79
.db    0x7A,0x77
.db    0x79,0x79
.db    0x75,0x74
.db    0x75,0x73
.db    0x72,0x71
.db    0x6E,0x6B
.db    0x6B,0x68
.db    0x65,0x64
.db    0x64,0x61
.db    0x61,0x62
.db    0x61,0x61
.db    0x5F,0x5E
.db    0x60,0x63
.db    0x65,0x65
.db    0x67,0x69
.db    0x6A,0x6D
.db    0x71,0x77
.db    0x7A,0x7F
.db    0x83,0x88
.db    0x8A,0x8C
.db    0x91,0x96
.db    0x9A,0x9F
.db    0xA3,0xA8
.db    0xA9,0xAB
.db    0xAC,0xB0
.db    0xB1,0xB3
.db    0xB6,0xB6
.db    0xB5,0xB5
.db    0xB6,0xB3
.db    0xAF,0xAE
.db    0xAB,0xAA
.db    0xA6,0xA2
.db    0x9C,0x98
.db    0x96,0x8E
.db    0x8C,0x89
.db    0x84,0x81
.db    0x7F,0x7C
.db    0x77,0x77
.db    0x72,0x70
.db    0x70,0x70
.db    0x70,0x6F
.db    0x70,0x6E
.db    0x6F,0x70
.db    0x70,0x6E
.db    0x71,0x72
.db    0x73,0x73
.db    0x75,0x76
.db    0x76,0x76
.db    0x76,0x76
.db    0x77,0x77
.db    0x77,0x77
.db    0x78,0x78
.db    0x76,0x76
.db    0x75,0x74
.db    0x73,0x73
.db    0x71,0x71
.db    0x70,0x6F
.db    0x6F,0x6D
.db    0x6C,0x6B
.db    0x6A,0x6A
.db    0x69,0x69
.db    0x69,0x68
.db    0x69,0x69
.db    0x69,0x69
.db    0x6A,0x6A
.db    0x6C,0x6C
.db    0x6E,0x6F
.db    0x70,0x71
.db    0x73,0x76
.db    0x78,0x79
.db    0x7B,0x7D
.db    0x7F,0x82
.db    0x85,0x87
.db    0x8A,0x8C
.db    0x8E,0x90
.db    0x93,0x94
.db    0x97,0x99
.db    0x9C,0x9D
.db    0x9E,0x9F
.db    0x9F,0x9F
.db    0x9F,0x9F
.db    0x9F,0x9F
.db    0x9D,0x9C
.db    0x99,0x97
.db    0x95,0x94
.db    0x91,0x8F
.db    0x8E,0x8B
.db    0x8B,0x88
.db    0x87,0x85
.db    0x84,0x82
.db    0x81,0x80
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7B,0x7B
.db    0x7A,0x79
.db    0x79,0x79
.db    0x79,0x78
.db    0x77,0x77
.db    0x77,0x77
.db    0x77,0x77
.db    0x78,0x77
.db    0x77,0x77
.db    0x78,0x77
.db    0x77,0x77
.db    0x77,0x78
.db    0x79,0x79
.db    0x79,0x79
.db    0x78,0x77
.db    0x77,0x78
.db    0x78,0x78
.db    0x77,0x77
.db    0x76,0x75
.db    0x75,0x75
.db    0x75,0x74
.db    0x74,0x74
.db    0x74,0x73
.db    0x72,0x72
.db    0x72,0x72
.db    0x72,0x73
.db    0x73,0x73
.db    0x73,0x73
.db    0x73,0x74
.db    0x76,0x76
.db    0x77,0x78
.db    0x79,0x7A
.db    0x7B,0x7C
.db    0x7D,0x7E
.db    0x7F,0x81
.db    0x83,0x85
.db    0x86,0x86
.db    0x87,0x87
.db    0x88,0x8A
.db    0x8C,0x8D
.db    0x8E,0x8E
.db    0x8F,0x90
.db    0x90,0x90
.db    0x91,0x91
.db    0x91,0x91
.db    0x92,0x92
.db    0x91,0x91
.db    0x90,0x8F
.db    0x8F,0x8F
.db    0x8E,0x8D
.db    0x8C,0x8B
.db    0x8A,0x89
.db    0x89,0x88
.db    0x86,0x86
.db    0x85,0x84
.db    0x83,0x82
.db    0x82,0x81
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7E,0x7E
.db    0x7D,0x7D
.db    0x7C,0x7C
.db    0x7C,0x7B
.db    0x7B,0x7B
.db    0x7B,0x7B
.db    0x7B,0x7B
.db    0x7B,0x7B
.db    0x7B,0x7B
.db    0x7A,0x7A
.db    0x7A,0x7A
.db    0x7A,0x7A
.db    0x7A,0x79
.db    0x79,0x7A
.db    0x7A,0x7A
.db    0x7A,0x7A
.db    0x7A,0x79
.db    0x7A,0x7A
.db    0x79,0x79
.db    0x79,0x79
.db    0x79,0x79
.db    0x79,0x79
.db    0x79,0x79
.db    0x79,0x79
.db    0x79,0x79
.db    0x7A,0x7A
.db    0x7A,0x7A
.db    0x7A,0x7A
.db    0x7B,0x7B
.db    0x7C,0x7C
.db    0x7D,0x7D
.db    0x7E,0x7E
.db    0x7E,0x7F
.db    0x7F,0x80
.db    0x80,0x81
.db    0x81,0x82
.db    0x82,0x82
.db    0x82,0x83
.db    0x83,0x83
.db    0x84,0x85
.db    0x85,0x85
.db    0x85,0x84
.db    0x84,0x84
.db    0x84,0x85
.db    0x85,0x84
.db    0x84,0x84
.db    0x83,0x83
.db    0x83,0x83
.db    0x83,0x83
.db    0x83,0x82
.db    0x82,0x82
.db    0x82,0x82
.db    0x82,0x81
.db    0x81,0x81
.db    0x81,0x81
.db    0x81,0x81
.db    0x81,0x81
.db    0x81,0x80
.db    0x80,0x80
.db    0x80,0x81
.db    0x81,0x81
.db    0x81,0x80
.db    0x80,0x80
.db    0x80,0x81
.db    0x81,0x81
.db    0x81,0x81
.db    0x81,0x80
.db    0x80,0x80
.db    0x81,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x81
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x81,0x81
.db    0x81,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x81,0x81
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x80,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x80
.db    0x81,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x81,0x81
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x81
.db    0x80,0x7F
.db    0x7E,0x7E
.db    0x81,0x81
.db    0x80,0x80
.db    0x7F,0x7E
.db    0x7E,0x80
.db    0x80,0x81
.db    0x80,0x80
.db    0x81,0x80
.db    0x7F,0x7E
.db    0x7E,0x7D
.db    0x7E,0x7E
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7E,0x7F
.db    0x7F,0x80
.db    0x80,0x82
.db    0x81,0x7E
.db    0x7E,0x7D
.db    0x7D,0x7E
.db    0x7E,0x80
.db    0x83,0x83
.db    0x82,0x81
.db    0x80,0x7A
.db    0x7D,0x7C
.db    0x7E,0x80
.db    0x83,0x81
.db    0x82,0x81
.db    0x7F,0x7B
.db    0x7E,0x7E
.db    0x7D,0x80
.db    0x85,0x7E
.db    0x7D,0x84
.db    0x7C,0x7D
.db    0x7F,0x82
.db    0x7E,0x82
.db    0x83,0x7F
.db    0x7D,0x83
.db    0x7E,0x84
.db    0x7C,0x81
.db    0x7D,0x7C
.db    0x7C,0x7C
.db    0x80,0x81
.db    0x7F,0x81
.db    0x80,0x7F
.db    0x7F,0x7D
.db    0x7E,0x7F
.db    0x80,0x7D
.db    0x7F,0x83
.db    0x82,0x83
.db    0x7F,0x80
.db    0x81,0x7A
.db    0x80,0x81
.db    0x81,0x7F
.db    0x82,0x7F
.db    0x81,0x7B
.db    0x80,0x7E
.db    0x82,0x84
.db    0x85,0x81
.db    0x83,0x7B
.db    0x7E,0x7F
.db    0x7F,0x7F
.db    0x80,0x83
.db    0x80,0x7F
.db    0x80,0x7E
.db    0x81,0x8A
.db    0x81,0x7C
.db    0x80,0x84
.db    0x76,0x5A
.db    0xAF,0x96
.db    0x74,0x8A
.db    0x9A,0x70
.db    0x65,0x98
.db    0x78,0x68
.db    0x80,0x75
.db    0x69,0x74
.db    0x8E,0x66
.db    0x77,0x93
.db    0x7C,0x6E
.db    0x8F,0x85
.db    0x6B,0x78
.db    0x83,0x71
.db    0x78,0x8F
.db    0x7F,0x79
.db    0x83,0x88
.db    0x67,0x86
.db    0xA5,0x89
.db    0x7A,0x80
.db    0x7A,0x72
.db    0x77,0x82
.db    0x92,0x88
.db    0x8E,0x88
.db    0x82,0x7B
.db    0x78,0x7C
.db    0x7F,0x81
.db    0x85,0x87
.db    0x88,0x87
.db    0x86,0x8C
.db    0x7C,0x7E
.db    0x77,0x7B
.db    0x7A,0x81
.db    0x87,0x89
.db    0x86,0x7C
.db    0x73,0x67
.db    0x80,0x81
.db    0x82,0x83
.db    0x82,0x81
.db    0x77,0x6A
.db    0x98,0x89
.db    0x87,0x82
.db    0x93,0x76
.db    0x65,0x7B
.db    0x61,0x65
.db    0x6D,0x8A
.db    0x7D,0x8F
.db    0xA0,0x8C
.db    0x82,0x80
.db    0x6E,0x62
.db    0x73,0x7D
.db    0x79,0x8A
.db    0xA1,0x83
.db    0x82,0x7D
.db    0x81,0x6C
.db    0x7B,0x83
.db    0x81,0x85
.db    0x93,0x87
.db    0x85,0x82
.db    0x7B,0x75
.db    0x77,0x76
.db    0x87,0x8D
.db    0x91,0x91
.db    0x8A,0x85
.db    0x69,0x72
.db    0x72,0x79
.db    0x82,0x8A
.db    0x91,0x84
.db    0x7C,0x81
.db    0x6C,0x7D
.db    0x7E,0x82
.db    0x76,0x88
.db    0x89,0x77
.db    0x85,0x92
.db    0x85,0x78
.db    0x81,0x74
.db    0x7D,0x82
.db    0x94,0x7A
.db    0x89,0x75
.db    0x6B,0x68
.db    0x6E,0x75
.db    0x67,0x80
.db    0x7F,0x7D
.db    0x77,0x75
.db    0x7E,0x7C
.db    0x89,0x89
.db    0x7B,0x91
.db    0x87,0x88
.db    0x73,0x88
.db    0x81,0x81
.db    0x93,0x88
.db    0x8D,0x8A
.db    0x93,0x7F
.db    0x79,0x87
.db    0x75,0x76
.db    0x80,0x8E
.db    0x88,0x83
.db    0x91,0x84
.db    0x7D,0x7D
.db    0x7D,0x70
.db    0x79,0x77
.db    0x7F,0x75
.db    0x87,0x79
.db    0x77,0x7E
.db    0x78,0x79
.db    0x6F,0x7A
.db    0x78,0x80
.db    0x81,0x7D
.db    0x7B,0x7E
.db    0x7D,0x7E
.db    0x79,0x8A
.db    0x88,0x8C
.db    0x83,0x86
.db    0x81,0x7F
.db    0x86,0x81
.db    0x85,0x81
.db    0x85,0x7B
.db    0x83,0x83
.db    0x81,0x80
.db    0x82,0x86
.db    0x80,0x84
.db    0x83,0x82
.db    0x81,0x80
.db    0x80,0x7C
.db    0x7D,0x7D
.db    0x7D,0x7D
.db    0x80,0x7D
.db    0x7A,0x7A
.db    0x78,0x77
.db    0x76,0x78
.db    0x79,0x7A
.db    0x7A,0x79
.db    0x79,0x79
.db    0x7A,0x7B
.db    0x7E,0x81
.db    0x82,0x85
.db    0x86,0x86
.db    0x86,0x8B
.db    0x8F,0x91
.db    0x92,0x94
.db    0x94,0x92
.db    0x93,0x93
.db    0x93,0x94
.db    0x93,0x93
.db    0x91,0x90
.db    0x8E,0x8C
.db    0x89,0x88
.db    0x88,0x88
.db    0x86,0x84
.db    0x83,0x83
.db    0x81,0x7F
.db    0x7F,0x7D
.db    0x7C,0x7E
.db    0x7E,0x7F
.db    0x7F,0x7E
.db    0x7C,0x7B
.db    0x7A,0x7D
.db    0x7D,0x7E
.db    0x7D,0x7E
.db    0x7F,0x7E
.db    0x7E,0x7F
.db    0x7A,0x78
.db    0x77,0x7A
.db    0x79,0x78
.db    0x79,0x7A
.db    0x78,0x77
.db    0x77,0x77
.db    0x72,0x6F
.db    0x6C,0x6E
.db    0x70,0x6F
.db    0x70,0x6F
.db    0x6E,0x6E
.db    0x6D,0x6F
.db    0x6C,0x6A
.db    0x68,0x69
.db    0x6E,0x6E
.db    0x6F,0x6F
.db    0x6C,0x6A
.db    0x6B,0x6D
.db    0x6E,0x6E
.db    0x6E,0x6F
.db    0x6D,0x6E
.db    0x71,0x6E
.db    0x69,0x6B
.db    0x6F,0x70
.db    0x71,0x79
.db    0x78,0x76
.db    0x79,0x83
.db    0x84,0x7C
.db    0x87,0x96
.db    0x97,0xA5
.db    0xB2,0xB7
.db    0xAF,0xB2
.db    0xBD,0xBB
.db    0xBD,0xCD
.db    0xCD,0xCA
.db    0xCB,0xD2
.db    0xCB,0xC4
.db    0xC3,0xC1
.db    0xB2,0xAF
.db    0xAF,0xA8
.db    0x9B,0x95
.db    0x8D,0x86
.db    0x76,0x70
.db    0x6B,0x65
.db    0x5D,0x60
.db    0x60,0x5B
.db    0x51,0x54
.db    0x50,0x51
.db    0x59,0x62
.db    0x63,0x67
.db    0x6D,0x71
.db    0x6F,0x7B
.db    0x81,0x82
.db    0x89,0x94
.db    0x97,0x99
.db    0x9F,0x9F
.db    0x97,0x98
.db    0x98,0x95
.db    0x96,0x9C
.db    0x9C,0x97
.db    0x92,0x8A
.db    0x80,0x7F
.db    0x7D,0x7C
.db    0x79,0x75
.db    0x6E,0x66
.db    0x63,0x61
.db    0x5D,0x5C
.db    0x58,0x50
.db    0x4D,0x4A
.db    0x46,0x46
.db    0x45,0x42
.db    0x3B,0x36
.db    0x35,0x2F
.db    0x2D,0x31
.db    0x32,0x36
.db    0x34,0x34
.db    0x35,0x31
.db    0x36,0x3D
.db    0x3F,0x45
.db    0x48,0x4E
.db    0x59,0x64
.db    0x71,0x75
.db    0x7B,0x87
.db    0x91,0xA1
.db    0xB8,0xC8
.db    0xC7,0xCF
.db    0xD8,0xD7
.db    0xE1,0xEE
.db    0xF2,0xEA
.db    0xE8,0xF2
.db    0xE9,0xE4
.db    0xE9,0xDB
.db    0xCA,0xBF
.db    0xB7,0xB0
.db    0xA7,0xA4
.db    0x9B,0x8B
.db    0x86,0x7D
.db    0x72,0x6C
.db    0x65,0x5F
.db    0x61,0x62
.db    0x65,0x66
.db    0x69,0x6A
.db    0x6B,0x6F
.db    0x78,0x7C
.db    0x81,0x88
.db    0x8C,0x91
.db    0x9A,0x9E
.db    0xA3,0xA4
.db    0xA7,0xA7
.db    0xA7,0xA9
.db    0xA9,0xA4
.db    0xA4,0xA2
.db    0x9D,0x99
.db    0x92,0x90
.db    0x8F,0x8D
.db    0x91,0x8E
.db    0x86,0x81
.db    0x79,0x78
.db    0x78,0x76
.db    0x75,0x71
.db    0x6C,0x68
.db    0x62,0x63
.db    0x61,0x5C
.db    0x58,0x56
.db    0x52,0x50
.db    0x4B,0x48
.db    0x44,0x40
.db    0x3D,0x3B
.db    0x36,0x36
.db    0x33,0x37
.db    0x38,0x39
.db    0x3B,0x3B
.db    0x39,0x3D
.db    0x45,0x53
.db    0x58,0x60
.db    0x6A,0x70
.db    0x75,0x81
.db    0x98,0xAF
.db    0xB4,0xC3
.db    0xCE,0xCF
.db    0xD1,0xDA
.db    0xE8,0xE7
.db    0xE2,0xEA
.db    0xE7,0xDF
.db    0xDE,0xDB
.db    0xD2,0xBF
.db    0xBB,0xB2
.db    0xA0,0x97
.db    0x91,0x87
.db    0x78,0x6E
.db    0x6D,0x5F
.db    0x54,0x50
.db    0x4D,0x48
.db    0x47,0x4B
.db    0x4F,0x49
.db    0x4B,0x54
.db    0x58,0x5C
.db    0x63,0x6E
.db    0x74,0x74
.db    0x7E,0x89
.db    0x8D,0x8E
.db    0x94,0x9B
.db    0x99,0x98
.db    0x9F,0x9F
.db    0x9B,0x99
.db    0x9B,0x91
.db    0x8A,0x8D
.db    0x88,0x7C
.db    0x79,0x7B
.db    0x75,0x6D
.db    0x76,0x7B
.db    0x72,0x70
.db    0x75,0x76
.db    0x6C,0x6C
.db    0x72,0x6B
.db    0x67,0x6B
.db    0x6A,0x6D
.db    0x69,0x68
.db    0x63,0x5B
.db    0x5B,0x55
.db    0x51,0x53
.db    0x4F,0x4D
.db    0x49,0x49
.db    0x47,0x3E
.db    0x3F,0x3F
.db    0x3C,0x42
.db    0x47,0x4E
.db    0x4F,0x4B
.db    0x50,0x55
.db    0x61,0x68
.db    0x6D,0x7A
.db    0x80,0x88
.db    0x96,0xAE
.db    0xC4,0xCD
.db    0xD5,0xDE
.db    0xDB,0xDD
.db    0xE8,0xF2
.db    0xF2,0xED
.db    0xEE,0xE7
.db    0xDF,0xDD
.db    0xD6,0xCA
.db    0xB8,0xA9
.db    0xA5,0x99
.db    0x93,0x89
.db    0x7E,0x75
.db    0x6A,0x62
.db    0x5F,0x59
.db    0x55,0x53
.db    0x55,0x5D
.db    0x5E,0x5F
.db    0x65,0x69
.db    0x6D,0x6F
.db    0x79,0x85
.db    0x87,0x8C
.db    0x96,0x9E
.db    0x9F,0xA2
.db    0xAB,0xAC
.db    0xA5,0xAA
.db    0xAD,0xA6
.db    0xA1,0xA8
.db    0xA9,0x9B
.db    0x95,0x97
.db    0x90,0x84
.db    0x84,0x84
.db    0x7A,0x6E
.db    0x73,0x7A
.db    0x79,0x7A
.db    0x82,0x82
.db    0x75,0x6E
.db    0x6D,0x6E
.db    0x6B,0x67
.db    0x68,0x62
.db    0x57,0x54
.db    0x4E,0x4C
.db    0x44,0x3A
.db    0x31,0x26
.db    0x24,0x21
.db    0x1D,0x1E
.db    0x18,0x18
.db    0x1C,0x1A
.db    0x1A,0x17
.db    0x1A,0x21
.db    0x23,0x2E
.db    0x37,0x3D
.db    0x44,0x46
.db    0x51,0x5E
.db    0x65,0x71
.db    0x77,0x83
.db    0x8D,0x9B
.db    0xB7,0xC8
.db    0xD1,0xD8
.db    0xDB,0xE5
.db    0xE5,0xEB
.db    0xF8,0xF5
.db    0xF3,0xF0
.db    0xEF,0xF3
.db    0xEA,0xE3
.db    0xDA,0xC9
.db    0xC3,0xB6
.db    0xB1,0xAD
.db    0xA7,0xA3
.db    0x93,0x89
.db    0x8A,0x7D
.db    0x7B,0x78
.db    0x74,0x73
.db    0x6E,0x76
.db    0x7A,0x79
.db    0x79,0x7A
.db    0x7B,0x83
.db    0x88,0x8F
.db    0x91,0x93
.db    0x97,0x96
.db    0x9B,0x9F
.db    0x9D,0x9A
.db    0x9B,0x9D
.db    0x9B,0x94
.db    0x96,0x97
.db    0x8E,0x84
.db    0x82,0x83
.db    0x7B,0x75
.db    0x77,0x75
.db    0x6E,0x6B
.db    0x70,0x79
.db    0x7A,0x7A
.db    0x78,0x73
.db    0x6F,0x6C
.db    0x6D,0x6D
.db    0x69,0x65
.db    0x58,0x52
.db    0x50,0x4D
.db    0x44,0x38
.db    0x31,0x2B
.db    0x23,0x21
.db    0x21,0x1E
.db    0x19,0x16
.db    0x17,0x15
.db    0x15,0x13
.db    0x14,0x1A
.db    0x23,0x2E
.db    0x39,0x45
.db    0x47,0x49
.db    0x4D,0x56
.db    0x62,0x6E
.db    0x78,0x7D
.db    0x86,0x8D
.db    0x99,0xA5
.db    0xB4,0xC3
.db    0xCC,0xD1
.db    0xDB,0xE0
.db    0xE5,0xE9
.db    0xEB,0xEF
.db    0xED,0xEC
.db    0xE9,0xE4
.db    0xE1,0xDF
.db    0xD7,0xCD
.db    0xC3,0xBC
.db    0xB0,0xA8
.db    0xA5,0x9D
.db    0x95,0x90
.db    0x8B,0x81
.db    0x77,0x76
.db    0x73,0x71
.db    0x72,0x6F
.db    0x6F,0x70
.db    0x73,0x78
.db    0x73,0x75
.db    0x79,0x7A
.db    0x81,0x89
.db    0x8F,0x91
.db    0x91,0x99
.db    0x9B,0x96
.db    0x93,0x93
.db    0x97,0x97
.db    0x93,0x8F
.db    0x8C,0x8D
.db    0x86,0x82
.db    0x7E,0x79
.db    0x77,0x6F
.db    0x72,0x74
.db    0x74,0x77
.db    0x7B,0x76
.db    0x73,0x6F
.db    0x71,0x72
.db    0x71,0x6D
.db    0x67,0x64
.db    0x64,0x5D
.db    0x5A,0x5A
.db    0x53,0x4D
.db    0x41,0x38
.db    0x38,0x35
.db    0x33,0x34
.db    0x35,0x31
.db    0x2C,0x27
.db    0x26,0x29
.db    0x2C,0x27
.db    0x2B,0x3A
.db    0x40,0x47
.db    0x4A,0x55
.db    0x5A,0x54
.db    0x5C,0x65
.db    0x74,0x84
.db    0x88,0x98
.db    0x9C,0x9C
.db    0xA3,0xA3
.db    0xB5,0xC4
.db    0xD0,0xD8
.db    0xDC,0xE3
.db    0xE2,0xE5
.db    0xE1,0xDE
.db    0xDB,0xDC
.db    0xDB,0xDB
.db    0xD8,0xD6
.db    0xD0,0xCB
.db    0xC2,0xB6
.db    0xB2,0xAB
.db    0xA0,0x98
.db    0x95,0x99
.db    0x97,0x91
.db    0x89,0x81
.db    0x75,0x72
.db    0x6F,0x6F
.db    0x7B,0x81
.db    0x7D,0x75
.db    0x75,0x77
.db    0x7B,0x81
.db    0x84,0x7E
.db    0x80,0x8A
.db    0x8F,0x8E
.db    0x90,0x96
.db    0x90,0x89
.db    0x86,0x8F
.db    0x98,0x95
.db    0x8A,0x81
.db    0x88,0x8B
.db    0x8A,0x7E
.db    0x7A,0x82
.db    0x83,0x80
.db    0x7F,0x7E
.db    0x7C,0x79
.db    0x73,0x76
.db    0x7E,0x7B
.db    0x71,0x6A
.db    0x61,0x62
.db    0x5C,0x55
.db    0x55,0x55
.db    0x50,0x45
.db    0x42,0x3C
.db    0x3E,0x41
.db    0x39,0x38
.db    0x37,0x2E
.db    0x2A,0x30
.db    0x2E,0x30
.db    0x2E,0x35
.db    0x30,0x36
.db    0x3E,0x33
.db    0x2C,0x37
.db    0x46,0x50
.db    0x56,0x52
.db    0x5D,0x59
.db    0x5B,0x6B
.db    0x68,0x69
.db    0x72,0x7D
.db    0x86,0x95
.db    0x9B,0x9B
.db    0x9A,0x8F
.db    0x97,0xAE
.db    0xBB,0xCC
.db    0xD4,0xCC
.db    0xD2,0xD3
.db    0xD7,0xCF
.db    0xC7,0xCB
.db    0xD6,0xE1
.db    0xE5,0xE7
.db    0xD9,0xD0
.db    0xC5,0xBC
.db    0xBE,0xC4
.db    0xC0,0xB4
.db    0xAA,0xA8
.db    0xA9,0xA8
.db    0x9D,0x8E
.db    0x86,0x8E
.db    0x86,0x88
.db    0x86,0x86
.db    0x89,0x80
.db    0x79,0x7C
.db    0x83,0x8D
.db    0x85,0x78
.db    0x7A,0x83
.db    0x81,0x85
.db    0x83,0x79
.db    0x78,0x74
.db    0x7E,0x83
.db    0x88,0x7F
.db    0x74,0x69
.db    0x66,0x77
.db    0x76,0x70
.db    0x70,0x77
.db    0x80,0x85
.db    0x85,0x77
.db    0x5E,0x5B
.db    0x63,0x69
.db    0x74,0x7A
.db    0x73,0x6E
.db    0x6A,0x5E
.db    0x52,0x4D
.db    0x58,0x54
.db    0x4E,0x64
.db    0x65,0x55
.db    0x41,0x37
.db    0x41,0x42
.db    0x4B,0x54
.db    0x55,0x48
.db    0x39,0x31
.db    0x3B,0x46
.db    0x44,0x48
.db    0x4D,0x4E
.db    0x55,0x4A
.db    0x3E,0x3D
.db    0x4E,0x5E
.db    0x57,0x4F
.db    0x53,0x60
.db    0x65,0x6B
.db    0x6E,0x69
.db    0x6E,0x74
.db    0x74,0x72
.db    0x63,0x7C
.db    0x9D,0x97
.db    0x98,0x8B
.db    0x87,0xA2
.db    0x9D,0x9D
.db    0xAA,0xAD
.db    0xB9,0xB1
.db    0xB6,0xC5
.db    0xBE,0xC9
.db    0xD1,0xCD
.db    0xC3,0xC7
.db    0xC9,0xCE
.db    0xCD,0xCF
.db    0xC9,0xC4
.db    0xCD,0xCB
.db    0xBD,0xBC
.db    0xC3,0xC8
.db    0xB0,0x99
.db    0xAA,0xBD
.db    0xBD,0xAB
.db    0xA8,0x95
.db    0x8F,0x9E
.db    0x98,0x9A
.db    0x9E,0x8E
.db    0x9C,0x9F
.db    0x97,0xA3
.db    0x8E,0x89
.db    0x85,0x8D
.db    0x92,0x8B
.db    0x98,0x84
.db    0x86,0x91
.db    0x8C,0x99
.db    0x85,0x7A
.db    0x73,0x6E
.db    0x70,0x65
.db    0x70,0x81
.db    0x84,0x70
.db    0x54,0x4A
.db    0x53,0x5B
.db    0x57,0x55
.db    0x5F,0x65
.db    0x5B,0x45
.db    0x34,0x44
.db    0x4D,0x4C
.db    0x53,0x52
.db    0x5C,0x60
.db    0x4B,0x33
.db    0x39,0x4F
.db    0x56,0x4F
.db    0x43,0x55
.db    0x59,0x56
.db    0x54,0x4C
.db    0x68,0x72
.db    0x41,0x48
.db    0x4F,0x52
.db    0x66,0x6C
.db    0x62,0x64
.db    0x7D,0x64
.db    0x44,0x5E
.db    0x67,0x7A
.db    0x7E,0x76
.db    0x88,0x85
.db    0x78,0x6A
.db    0x6D,0x88
.db    0x82,0x90
.db    0x94,0x9B
.db    0xB1,0xA7
.db    0x94,0x7C
.db    0x78,0x98
.db    0xA5,0x99
.db    0xB8,0xC1
.db    0xAE,0xAE
.db    0x95,0x86
.db    0xA4,0x8E
.db    0x98,0xAE
.db    0xBD,0xC6
.db    0xB1,0x83
.db    0xA8,0xB2
.db    0xA9,0x9F
.db    0x86,0x89
.db    0x8B,0x99
.db    0x99,0xA2
.db    0xA8,0x93
.db    0xA4,0x91
.db    0x6F,0x7F
.db    0x80,0xA8
.db    0x99,0x89
.db    0x8D,0x78
.db    0x7A,0x6A
.db    0x7B,0xAC
.db    0x99,0x74
.db    0x8A,0x85
.db    0x8C,0x66
.db    0x48,0x86
.db    0x9B,0x82
.db    0x71,0x79
.db    0x7A,0x89
.db    0x7A,0x5B
.db    0x6B,0x6B
.db    0x8F,0x75
.db    0x6E,0x7D
.db    0x71,0x65
.db    0x5E,0x63
.db    0x8D,0xA0
.db    0x74,0x4B
.db    0x3A,0x71
.db    0x82,0x6D
.db    0x6F,0x7C
.db    0x59,0x5F
.db    0x81,0x63
.db    0x53,0x74
.db    0x73,0x81
.db    0x70,0x48
.db    0x6E,0x76
.db    0x7B,0x4B
.db    0x41,0x72
.db    0x74,0x86
.db    0x6F,0x45
.db    0x56,0x6C
.db    0x80,0x7C
.db    0x57,0x64
.db    0x8B,0x7A
.db    0x67,0x84
.db    0x7C,0x74
.db    0x70,0x83
.db    0x95,0x78
.db    0x87,0x85
.db    0x8D,0x6A
.db    0x79,0x87
.db    0x92,0x9E
.db    0x83,0x8D
.db    0x84,0x68
.db    0x7B,0x8B
.db    0x8C,0x8E
.db    0x8E,0x84
.db    0x93,0x8F
.db    0x9C,0x80
.db    0x52,0x76
.db    0x94,0xB7
.db    0x9D,0x8D
.db    0xA4,0x94
.db    0x9D,0x76
.db    0x6E,0x94
.db    0x9E,0x86
.db    0x92,0xA0
.db    0xB2,0x9E
.db    0x92,0x67
.db    0x78,0x90
.db    0x97,0xB8
.db    0xA6,0x7E
.db    0x9C,0x9D
.db    0x8E,0x78
.db    0x78,0x8D
.db    0x85,0x96
.db    0x9C,0x9B
.db    0x90,0x96
.db    0x91,0x78
.db    0x80,0x8F
.db    0x98,0xA8
.db    0x86,0x5D
.db    0x7F,0x88
.db    0x86,0xAF
.db    0x78,0x71
.db    0x80,0x74
.db    0x8A,0x9E
.db    0x52,0x64
.db    0x92,0x92
.db    0x8F,0x6E
.db    0x76,0x85
.db    0x79,0x60
.db    0x63,0x6A
.db    0x6D,0xAA
.db    0x9F,0x75
.db    0x6B,0x5C
.db    0x6E,0x7F
.db    0x69,0x58
.db    0x72,0x9D
.db    0x91,0x62
.db    0x53,0x6E
.db    0x75,0x79
.db    0x6B,0x6A
.db    0x8A,0x96
.db    0x85,0x4D
.db    0x4A,0x69
.db    0x7E,0x89
.db    0x84,0x98
.db    0x60,0x71
.db    0x64,0x36
.db    0x82,0x8C
.db    0x6E,0x81
.db    0x86,0x7B
.db    0x5F,0x53
.db    0x82,0x51
.db    0x7B,0xA5
.db    0x8B,0x6E
.db    0x44,0x5E
.db    0x9F,0x88
.db    0x4E,0x70
.db    0x96,0xA8
.db    0x70,0x44
.db    0x60,0x86
.db    0x84,0xA6
.db    0x92,0x71
.db    0x6C,0x84
.db    0x78,0x4D
.db    0x7D,0xB7
.db    0x99,0x87
.db    0x70,0x53
.db    0xB9,0x94
.db    0x47,0x79
.db    0xA8,0xA3
.db    0x79,0x74
.db    0x84,0x86
.db    0x7F,0x94
.db    0xA3,0x9F
.db    0x5F,0x6F
.db    0x62,0x76
.db    0x8F,0x7E
.db    0x9D,0xA9
.db    0x80,0x7E
.db    0x6F,0x5B
.db    0x87,0x98
.db    0x76,0x96
.db    0xA8,0x87
.db    0x51,0x63
.db    0x95,0x97
.db    0x7A,0x90
.db    0x93,0x7E
.db    0x8C,0x67
.db    0x68,0x99
.db    0x7C,0x8D
.db    0xBD,0x7B
.db    0x8F,0x9D
.db    0x5A,0x57
.db    0x8A,0x76
.db    0x96,0xA8
.db    0x87,0x79
.db    0x7D,0x7B
.db    0x9B,0x6C
.db    0x7E,0x9D
.db    0x7C,0x5F
.db    0x8A,0x8F
.db    0x8A,0x8D
.db    0x7D,0x7C
.db    0x9D,0x7F
.db    0x68,0x65
.db    0x81,0xAC
.db    0x88,0x77
.db    0x73,0x85
.db    0x6C,0x90
.db    0x7E,0x71
.db    0xA4,0xA0
.db    0x7D,0x52
.db    0x4F,0x7B
.db    0x8B,0xB1
.db    0xAD,0x75
.db    0x83,0x74
.db    0x67,0x58
.db    0x40,0x86
.db    0xC2,0xB9
.db    0x99,0x46
.db    0x61,0x93
.db    0x68,0x63
.db    0x59,0x94
.db    0xB3,0x94
.db    0x68,0x4F
.db    0x78,0x85
.db    0x78,0x63
.db    0x6D,0x84
.db    0xAC,0x8D
.db    0x54,0x4E
.db    0x7D,0x99
.db    0x6F,0x71
.db    0x88,0x93
.db    0x7C,0x70
.db    0x75,0x5C
.db    0x69,0x79
.db    0xA8,0xAE
.db    0x71,0x52
.db    0x7C,0x8F
.db    0x68,0x75
.db    0x85,0x69
.db    0x83,0xC3
.db    0x81,0x57
.db    0x4E,0x79
.db    0xA5,0x87
.db    0x78,0x75
.db    0x87,0x9C
.db    0x62,0x5D
.db    0x9F,0x8D
.db    0x63,0x79
.db    0x81,0x8F
.db    0x9D,0x6C
.db    0xAF,0x8E
.db    0x61,0x7F
.db    0x64,0x78
.db    0x6F,0x85
.db    0xB9,0x97
.db    0x9A,0x8C
.db    0x86,0x56
.db    0x59,0x74
.db    0x4A,0x73
.db    0xBA,0x8C
.db    0x8C,0x87
.db    0xA4,0x9F
.db    0x58,0x47
.db    0x77,0x8F
.db    0x7C,0x95
.db    0x83,0x95
.db    0x9B,0x80
.db    0x80,0x8C
.db    0x7E,0x7C
.db    0x7C,0x77
.db    0x67,0x7E
.db    0x73,0x9A
.db    0x9D,0x95
.db    0x88,0x62
.db    0x65,0x98
.db    0x9A,0x6E
.db    0x65,0x83
.db    0x79,0x98
.db    0xBC,0x98
.db    0x59,0x74
.db    0x81,0x99
.db    0x8E,0x73
.db    0x53,0xA1
.db    0x8A,0x72
.db    0x72,0x68
.db    0xA3,0x95
.db    0x82,0x6C
.db    0x7D,0x73
.db    0x84,0x84
.db    0x82,0xA1
.db    0x7D,0x67
.db    0x88,0x6F
.db    0x58,0x79
.db    0x94,0x9E
.db    0xA1,0x88
.db    0x73,0x6B
.db    0x66,0x88
.db    0x5E,0x77
.db    0xA1,0x90
.db    0xC0,0x6D
.db    0x73,0x8A
.db    0x58,0x7A
.db    0x81,0x67
.db    0x77,0x90
.db    0xB1,0xA6
.db    0x75,0x72
.db    0x4F,0x58
.db    0x7B,0x80
.db    0x81,0x8F
.db    0x9C,0xA4
.db    0x6A,0x52
.db    0x7E,0x7B
.db    0x6E,0x7F
.db    0x84,0x61
.db    0xA3,0x98
.db    0x5A,0x67
.db    0x7E,0x80
.db    0x73,0x66
.db    0x8D,0x9D
.db    0xA6,0x6A
.db    0x86,0x88
.db    0x6A,0x70
.db    0x57,0x65
.db    0xAD,0x9B
.db    0x93,0x7A
.db    0x74,0x8C
.db    0x79,0x61
.db    0x7E,0x6E
.db    0x7D,0xA3
.db    0x79,0x63
.db    0x77,0x83
.db    0xAA,0x8D
.db    0x65,0x73
.db    0x86,0x66
.db    0x75,0x65
.db    0x72,0x9E
.db    0x8B,0x95
.db    0x82,0x73
.db    0x96,0xB2
.db    0x78,0x43
.db    0x34,0x94
.db    0x75,0x7A
.db    0xA3,0xA3
.db    0xA2,0x84
.db    0x41,0x70
.db    0x7B,0x64
.db    0x79,0xA1
.db    0xA3,0x71
.db    0x6B,0x73
.db    0x72,0xAF
.db    0x6C,0x78
.db    0xA9,0x8A
.db    0x69,0x85
.db    0x66,0x85
.db    0x7F,0x68
.db    0x8A,0x9A
.db    0x97,0x7B
.db    0x62,0x76
.db    0x9B,0x8B
.db    0x6F,0x84
.db    0x7A,0x7A
.db    0x7D,0x64
.db    0x87,0x96
.db    0x75,0x97
.db    0x8F,0x7C
.db    0x6F,0x7A
.db    0x68,0x6D
.db    0x81,0x70
.db    0x8C,0x94
.db    0x96,0x73
.db    0x81,0x7A
.db    0x7F,0x66
.db    0x6B,0x7F
.db    0x85,0x8B
.db    0x77,0x89
.db    0x91,0x60
.db    0x72,0x82
.db    0x6A,0x72
.db    0x8A,0x77
.db    0x8D,0x9A
.db    0x87,0x52
.db    0x65,0x85
.db    0x83,0x80
.db    0x72,0x77
.db    0xAE,0xA9
.db    0x72,0x51
.db    0x5C,0x7C
.db    0x78,0x96
.db    0x81,0x95
.db    0xB1,0x9A
.db    0x57,0x4B
.db    0x5B,0x7A
.db    0x92,0x7B
.db    0x6F,0xA4
.db    0xA5,0x70
.db    0x71,0x72
.db    0x60,0x8B
.db    0x79,0x7A
.db    0x89,0x64
.db    0x91,0x8B
.db    0x72,0x8D
.db    0x7D,0x7F
.db    0x91,0x7B
.db    0x7D,0x55
.db    0x7E,0x80
.db    0x6F,0x91
.db    0x9B,0x74
.db    0x89,0x8C
.db    0x75,0x57
.db    0x7B,0x80
.db    0x65,0x70
.db    0x92,0x90
.db    0x7F,0x93
.db    0x8F,0x6F
.db    0x5C,0x6E
.db    0x89,0x8F
.db    0x94,0x6A
.db    0x76,0x98
.db    0x75,0x6D
.db    0x51,0x93
.db    0xA4,0x98
.db    0x78,0x79
.db    0x94,0x87
.db    0x6A,0x7C
.db    0x6C,0x71
.db    0x6F,0xA0
.db    0x79,0x74
.db    0xAE,0x87
.db    0x75,0x6B
.db    0x65,0x72
.db    0x66,0x9D
.db    0x8E,0x7B
.db    0x75,0x85
.db    0x85,0x66
.db    0xAB,0x84
.db    0x76,0x6F
.db    0x74,0xA3
.db    0x9C,0x4A
.db    0x63,0x8F
.db    0xC2,0x6F
.db    0x5B,0x8B
.db    0xA7,0x95
.db    0x71,0x49
.db    0x66,0x7D
.db    0x8A,0x86
.db    0x9D,0x8B
.db    0x7A,0x81
.db    0x7F,0x50
.db    0x63,0x93
.db    0xAD,0x9B
.db    0x7F,0x63
.db    0x57,0x72
.db    0x73,0x94
.db    0x98,0xAA
.db    0x80,0x88
.db    0x8E,0x51
.db    0x57,0x6D
.db    0x82,0x94
.db    0x9C,0x98
.db    0x61,0x8D
.db    0x95,0x6F
.db    0x56,0x55
.db    0x8C,0x99
.db    0x90,0x80
.db    0x8D,0x96
.db    0x6C,0x8F
.db    0x6E,0x7A
.db    0x69,0x95
.db    0x9B,0x60
.db    0x74,0x73
.db    0x8C,0xA4
.db    0x7B,0x5E
.db    0x6C,0x87
.db    0x97,0x8F
.db    0x59,0x80
.db    0xD0,0x7B
.db    0x3E,0x7F
.db    0x66,0x4E
.db    0x95,0x94
.db    0x8A,0xAF
.db    0xB3,0x6B
.db    0x2E,0x27
.db    0x60,0xB1
.db    0xAD,0x8E
.db    0xBE,0xAA
.db    0x6E,0x35
.db    0x39,0x75
.db    0xA1,0x85
.db    0x9D,0xC3
.db    0x71,0x8D
.db    0x54,0x40
.db    0x6C,0x84
.db    0xAD,0x89
.db    0x90,0x94
.db    0x7E,0x5F
.db    0x74,0x63
.db    0x8B,0x9B
.db    0x8C,0x73
.db    0x66,0x7F
.db    0xBB,0x8F
.db    0x46,0x53
.db    0x96,0xA4
.db    0x98,0x6A
.db    0x57,0x70
.db    0x91,0x8C
.db    0x71,0x68
.db    0x8F,0xB7
.db    0xB7,0x40
.db    0x48,0x77
.db    0x80,0x7F
.db    0x92,0x72
.db    0x80,0xA2
.db    0xAF,0x58
.db    0x48,0xA0
.db    0x7D,0x84
.db    0x8D,0x77
.db    0x8A,0xA6
.db    0x74,0x2F
.db    0x62,0x81
.db    0x8E,0xCB
.db    0xA4,0x4A
.db    0x4B,0x92
.db    0x62,0x37
.db    0x9E,0xA6
.db    0xAF,0x9F
.db    0x3E,0x6B
.db    0x76,0x8C
.db    0x70,0x51
.db    0xA1,0xC7
.db    0x84,0x4B
.db    0x3F,0xAF
.db    0x8F,0x7C
.db    0x85,0x86
.db    0x7A,0x6E
.db    0x60,0xA7
.db    0x96,0x79
.db    0x61,0xB2
.db    0x5A,0x52
.db    0x6A,0x55
.db    0x9F,0xD0
.db    0x8A,0x6D
.db    0x95,0x7A
.db    0x39,0x73
.db    0x82,0xAB
.db    0x7F,0x95
.db    0xA8,0x8D
.db    0x55,0x23
.db    0x86,0x8B
.db    0x8E,0x8A
.db    0xA3,0x73
.db    0x6A,0x88
.db    0x8E,0x55
.db    0x4A,0xA0
.db    0xC8,0xA9
.db    0x68,0x3C
.db    0x68,0x73
.db    0x8F,0x90
.db    0x59,0xA6
.db    0xA6,0x7B
.db    0x5C,0x2E
.db    0x83,0x8A
.db    0x78,0xA3
.db    0xAE,0x84
.db    0x49,0x97
.db    0x7A,0x3C
.db    0x6B,0xAD
.db    0xD5,0xB4
.db    0x61,0x18
.db    0x6E,0x7A
.db    0x58,0x77
.db    0xB1,0xA3
.db    0xAC,0x65
.db    0x6A,0x59
.db    0x5A,0x6A
.db    0x9E,0xBA
.db    0xA3,0x2A
.db    0x51,0xB6
.db    0xA6,0x7D
.db    0x5D,0x5E
.db    0xAA,0x8C
.db    0x6C,0x43
.db    0x73,0x9B
.db    0xAF,0x83
.db    0x76,0x80
.db    0x8D,0x76
.db    0x59,0x88
.db    0x72,0x6E
.db    0xBA,0xA8
.db    0x5F,0x63
.db    0x86,0x77
.db    0x65,0x64
.db    0x97,0xDA
.db    0xA9,0x4E
.db    0x33,0x8D
.db    0x80,0x65
.db    0x4B,0xB0
.db    0xB1,0xAA
.db    0x70,0x4A
.db    0x8E,0x80
.db    0x4B,0x55
.db    0x9D,0xCA
.db    0x7A,0x62
.db    0x96,0x8B
.db    0x60,0x6E
.db    0x7B,0x79
.db    0x93,0x77
.db    0x77,0x81
.db    0xA1,0x67
.db    0x89,0x99
.db    0x78,0x38
.db    0x9D,0x79
.db    0x87,0x9D
.db    0x88,0x89
.db    0x85,0x72
.db    0x4E,0x7B
.db    0x91,0x8C
.db    0x79,0x72
.db    0x9D,0x8D
.db    0x89,0x60
.db    0x5A,0x67
.db    0xA6,0xA0
.db    0x69,0x7F
.db    0x8A,0x95
.db    0x73,0x65
.db    0x7C,0x93
.db    0x7F,0xA0
.db    0x7A,0x65
.db    0x80,0x72
.db    0x85,0x87
.db    0x84,0xBA
.db    0x7C,0x82
.db    0x6D,0x74
.db    0x77,0x59
.db    0x8F,0x81
.db    0x81,0xB1
.db    0x66,0x7C
.db    0x73,0x72
.db    0x8D,0x83
.db    0x60,0x90
.db    0x63,0x95
.db    0x80,0x60
.db    0xA4,0x96
.db    0x4E,0x6B
.db    0x97,0x7E
.db    0x87,0x7D
.db    0x7F,0x92
.db    0x8A,0x5E
.db    0x6F,0x83
.db    0x60,0x99
.db    0xA6,0x92
.db    0x56,0x76
.db    0x82,0x77
.db    0x7D,0x91
.db    0x6A,0xA0
.db    0x9B,0x63
.db    0x58,0x95
.db    0x96,0x7B
.db    0x67,0x90
.db    0x6D,0x93
.db    0x92,0x6E
.db    0x85,0x7A
.db    0x74,0xA0
.db    0x77,0x66
.db    0x87,0x7A
.db    0xBA,0x81
.db    0x50,0x76
.db    0x8B,0x90
.db    0x90,0x5B
.db    0x75,0x97
.db    0x99,0x70
.db    0x79,0x47
.db    0x97,0x9F
.db    0x74,0x65
.db    0x79,0x8A
.db    0x87,0x75
.db    0x97,0x79
.db    0x89,0x82
.db    0x6B,0x5E
.db    0x86,0x9A
.db    0x7D,0x7F
.db    0xAE,0x83
.db    0x6B,0x6D
.db    0x71,0x77
.db    0x88,0x8D
.db    0x8B,0x8B
.db    0x85,0x76
.db    0x79,0x65
.db    0x82,0x89
.db    0x7E,0x7C
.db    0x7F,0x93
.db    0x84,0x6F
.db    0x7C,0x7B
.db    0x7A,0x8A
.db    0x82,0x71
.db    0x8B,0x99
.db    0x67,0x76
.db    0x89,0x88
.db    0x69,0x85
.db    0x92,0x7E
.db    0x76,0x6D
.db    0x83,0x85
.db    0x7E,0x7C
.db    0x7A,0x8F
.db    0x8B,0x79
.db    0x7A,0x7A
.db    0x7F,0x82
.db    0x76,0x77
.db    0x92,0x8A
.db    0x73,0x76
.db    0x88,0x79
.db    0x88,0x8D
.db    0x7B,0x75
.db    0x79,0x82
.db    0x87,0x79
.db    0x77,0x83
.db    0x89,0x8C
.db    0x73,0x7A
.db    0x8B,0x7D
.db    0x82,0x7C
.db    0x7F,0x7F
.db    0x76,0x87
.db    0x7C,0x7D
.db    0x89,0x8A
.db    0x7D,0x7D
.db    0x7A,0x77
.db    0x77,0x7F
.db    0x88,0x8A
.db    0x8C,0x83
.db    0x72,0x71
.db    0x7B,0x7B
.db    0x7B,0x8E
.db    0x8E,0x83
.db    0x7F,0x74
.db    0x76,0x7D
.db    0x7B,0x7F
.db    0x82,0x82
.db    0x85,0x7D
.db    0x7D,0x83
.db    0x7B,0x79
.db    0x80,0x79
.db    0x82,0x81
.db    0x7A,0x7D
.db    0x7F,0x88
.db    0x82,0x7A
.db    0x7C,0x7F
.db    0x7D,0x7C
.db    0x7D,0x7E
.db    0x82,0x84
.db    0x81,0x7C
.db    0x81,0x7D
.db    0x78,0x81
.db    0x82,0x7E
.db    0x7D,0x81
.db    0x82,0x7F
.db    0x79,0x7E
.db    0x84,0x81
.db    0x7C,0x7F
.db    0x82,0x7D
.db    0x7D,0x7E
.db    0x7F,0x82
.db    0x80,0x80
.db    0x7F,0x82
.db    0x80,0x7C
.db    0x7D,0x82
.db    0x82,0x7C
.db    0x7D,0x81
.db    0x82,0x80
.db    0x7E,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x80,0x81
.db    0x80,0x7F
.db    0x81,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x81
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7E,0x7E
.db    0x7F,0x80
.db    0x80,0x7E
.db    0x7E,0x7E
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7F,0x7F
.db    0x7E,0x7E
.db    0x7E,0x7F
.db    0x7F,0x7F
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7F,0x7E
.db    0x7E,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7F
.db    0x7F,0x7F
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7D,0x7D
.db    0x7E,0x7F
.db    0x7E,0x7D
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7F
.db    0x7F,0x7E
.db    0x7E,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7E,0x7E
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x81
.db    0x80,0x80
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x81,0x82
.db    0x81,0x80
.db    0x80,0x81
.db    0x80,0x80
.db    0x82,0x82
.db    0x81,0x82
.db    0x82,0x82
.db    0x81,0x80
.db    0x80,0x81
.db    0x82,0x81
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x81,0x83
.db    0x82,0x7E
.db    0x7F,0x80
.db    0x80,0x82
.db    0x83,0x83
.db    0x82,0x81
.db    0x82,0x83
.db    0x83,0x84
.db    0x84,0x82
.db    0x80,0x81
.db    0x83,0x81
.db    0x80,0x83
.db    0x84,0x84
.db    0x81,0x83
.db    0x84,0x82
.db    0x82,0x85
.db    0x88,0x84
.db    0x81,0x86
.db    0x85,0x85
.db    0x83,0x86
.db    0x86,0x87
.db    0x83,0x83
.db    0x86,0x84
.db    0x82,0x83
.db    0x84,0x84
.db    0x83,0x83
.db    0x84,0x84
.db    0x81,0x7F
.db    0x86,0x85
.db    0x7F,0x86
.db    0x8D,0x8D
.db    0x84,0x83
.db    0x86,0x86
.db    0x8A,0x96
.db    0x8E,0x85
.db    0x7F,0x8A
.db    0x81,0x4D
.db    0xB0,0xE8
.db    0xAF,0x68
.db    0x4D,0x83
.db    0x67,0x8A
.db    0xBB,0xA2
.db    0x52,0x3C
.db    0x57,0x73
.db    0x8A,0x7E
.db    0x6D,0x66
.db    0x61,0x43
.db    0x36,0x5E
.db    0x70,0x59
.db    0x48,0x4E
.db    0x52,0x6E
.db    0x9C,0x9B
.db    0x7B,0x65
.db    0x69,0x6E
.db    0x7B,0x72
.db    0x6F,0x6D
.db    0x62,0x54
.db    0x4E,0x4C
.db    0x4C,0x62
.db    0x73,0x7B
.db    0x71,0x61
.db    0x62,0x65
.db    0x69,0x71
.db    0x80,0x80
.db    0x7C,0x83
.db    0x90,0x8A
.db    0x7B,0x8F
.db    0xAE,0xAF
.db    0x9C,0xA0
.db    0xA0,0xA2
.db    0xA9,0xAA
.db    0x9F,0x90
.db    0x90,0x97
.db    0x94,0x88
.db    0x85,0x7D
.db    0x7C,0x81
.db    0x7D,0x77
.db    0x72,0x72
.db    0x78,0x7C
.db    0x7A,0x76
.db    0x72,0x75
.db    0x79,0x76
.db    0x7B,0x7A
.db    0x78,0x77
.db    0x77,0x7E
.db    0x7E,0x79
.db    0x76,0x70
.db    0x6D,0x6C
.db    0x6C,0x72
.db    0x6D,0x5D
.db    0x59,0x5B
.db    0x5B,0x61
.db    0x65,0x64
.db    0x65,0x68
.db    0x63,0x60
.db    0x69,0x76
.db    0x77,0x80
.db    0x93,0x99
.db    0x8E,0x95
.db    0xB7,0xCB
.db    0xD9,0xEA
.db    0xE4,0xE3
.db    0xE0,0xD7
.db    0xD9,0xD7
.db    0xD8,0xD8
.db    0xCB,0xB9
.db    0xAC,0xA2
.db    0x9A,0x92
.db    0x93,0x92
.db    0x85,0x7F
.db    0x7F,0x83
.db    0x87,0x80
.db    0x85,0x89
.db    0x8F,0x98
.db    0x9C,0x9F
.db    0x9D,0x9A
.db    0x98,0x99
.db    0x99,0x97
.db    0x97,0x99
.db    0xA0,0x9A
.db    0x93,0x8C
.db    0x86,0x81
.db    0x78,0x78
.db    0x78,0x7C
.db    0x7C,0x73
.db    0x67,0x65
.db    0x64,0x61
.db    0x6A,0x74
.db    0x73,0x78
.db    0x7F,0x7E
.db    0x81,0x81
.db    0x83,0x81
.db    0x7A,0x75
.db    0x70,0x69
.db    0x62,0x56
.db    0x4F,0x4A
.db    0x44,0x44
.db    0x49,0x47
.db    0x40,0x3C
.db    0x3B,0x38
.db    0x32,0x34
.db    0x35,0x2F
.db    0x31,0x31
.db    0x2D,0x24
.db    0x1F,0x20
.db    0x29,0x37
.db    0x3A,0x3F
.db    0x41,0x37
.db    0x3E,0x49
.db    0x4E,0x56
.db    0x60,0x6A
.db    0x73,0x73
.db    0x6B,0x80
.db    0xAB,0xC4
.db    0xD6,0xE1
.db    0xDC,0xE1
.db    0xDA,0xC2
.db    0xBF,0xBB
.db    0xB6,0xB3
.db    0xA6,0x93
.db    0x7A,0x73
.db    0x71,0x6D
.db    0x73,0x74
.db    0x7E,0x8D
.db    0x8C,0x8B
.db    0x93,0x9F
.db    0xAE,0xB2
.db    0xB2,0xB6
.db    0xB3,0xB3
.db    0xB1,0xB3
.db    0xAC,0x9E
.db    0x9C,0x96
.db    0x8F,0x92
.db    0x91,0x84
.db    0x7E,0x81
.db    0x81,0x7D
.db    0x80,0x85
.db    0x84,0x89
.db    0x8F,0x8F
.db    0x8F,0x95
.db    0x9A,0x93
.db    0x91,0x97
.db    0x94,0x94
.db    0x9B,0xA4
.db    0xA0,0x8D
.db    0x8D,0x90
.db    0x8C,0x86
.db    0x7C,0x7C
.db    0x7A,0x6A
.db    0x65,0x5D
.db    0x55,0x56
.db    0x56,0x58
.db    0x58,0x5A
.db    0x61,0x60
.db    0x5C,0x5C
.db    0x5E,0x5D
.db    0x5A,0x5A
.db    0x55,0x4D
.db    0x4E,0x4B
.db    0x3F,0x37
.db    0x3F,0x4C
.db    0x48,0x46
.db    0x48,0x51
.db    0x60,0x62
.db    0x68,0x74
.db    0x85,0x93
.db    0x98,0x88
.db    0x7A,0xAA
.db    0xD5,0xDF
.db    0xF4,0xF7
.db    0xE9,0xE7
.db    0xD9,0xBC
.db    0xAA,0xB1
.db    0xBC,0xBC
.db    0xAB,0x8E
.db    0x7F,0x7B
.db    0x72,0x72
.db    0x80,0x88
.db    0x98,0xA8
.db    0xAE,0xAE
.db    0xAC,0xAC
.db    0xA9,0xA5
.db    0xAC,0xAF
.db    0xB0,0xA3
.db    0x93,0x88
.db    0x7A,0x6A
.db    0x65,0x66
.db    0x64,0x62
.db    0x6D,0x71
.db    0x6D,0x68
.db    0x6F,0x7A
.db    0x7C,0x85
.db    0x8F,0x92
.db    0x92,0x8F
.db    0x8A,0x81
.db    0x76,0x73
.db    0x77,0x74
.db    0x74,0x72
.db    0x6C,0x6D
.db    0x6F,0x6A
.db    0x74,0x85
.db    0x88,0x88
.db    0x87,0x7D
.db    0x78,0x79
.db    0x76,0x72
.db    0x73,0x6F
.db    0x61,0x5B
.db    0x58,0x59
.db    0x57,0x4E
.db    0x4B,0x48
.db    0x42,0x42
.db    0x46,0x45
.db    0x44,0x42
.db    0x40,0x38
.db    0x37,0x3E
.db    0x3F,0x40
.db    0x44,0x47
.db    0x4B,0x42
.db    0x3D,0x46
.db    0x47,0x46
.db    0x4A,0x55
.db    0x65,0x6B
.db    0x80,0x99
.db    0x92,0x7A
.db    0xA5,0xDA
.db    0xF0,0xFF
.db    0xFD,0xF5
.db    0xE0,0xC7
.db    0xAC,0x86
.db    0x77,0x7C
.db    0x8A,0x8B
.db    0x76,0x67
.db    0x6D,0x72
.db    0x7C,0x91
.db    0xA5,0xB9
.db    0xBC,0xCD
.db    0xDB,0xCE
.db    0xBC,0xAF
.db    0xB2,0xA8
.db    0x98,0x90
.db    0x84,0x7A
.db    0x6C,0x60
.db    0x59,0x5A
.db    0x63,0x74
.db    0x83,0x92
.db    0x9E,0x9B
.db    0x99,0x9A
.db    0x93,0x9A
.db    0x9F,0x95
.db    0x91,0x8A
.db    0x75,0x6D
.db    0x6B,0x5A
.db    0x5A,0x64
.db    0x66,0x67
.db    0x6E,0x76
.db    0x7B,0x88
.db    0x8D,0x87
.db    0x8A,0x98
.db    0x99,0x84
.db    0x86,0xA9
.db    0xB0,0x95
.db    0x8B,0x91
.db    0x88,0x7A
.db    0x60,0x4F
.db    0x54,0x4D
.db    0x4D,0x50
.db    0x43,0x46
.db    0x57,0x55
.db    0x4A,0x47
.db    0x4B,0x57
.db    0x5A,0x58
.db    0x52,0x49
.db    0x44,0x46
.db    0x3C,0x28
.db    0x25,0x35
.db    0x38,0x36
.db    0x3B,0x3C
.db    0x3C,0x40
.db    0x51,0x59
.db    0x57,0x6B
.db    0x97,0xAB
.db    0x93,0xAF
.db    0xEE,0xFF
.db    0xFF,0xFE
.db    0xF3,0xD9
.db    0xB6,0x94
.db    0x67,0x4D
.db    0x52,0x6C
.db    0x79,0x72
.db    0x77,0x7F
.db    0x89,0x9D
.db    0xA0,0xA9
.db    0xCA,0xE3
.db    0xE3,0xE2
.db    0xD0,0xB2
.db    0x9D,0x90
.db    0x7C,0x6B
.db    0x70,0x77
.db    0x82,0x86
.db    0x84,0x84
.db    0x88,0x8F
.db    0x91,0x94
.db    0x98,0xA5
.db    0xAD,0xA6
.db    0xA0,0x9E
.db    0x94,0x8F
.db    0x8D,0x8A
.db    0x82,0x80
.db    0x88,0x8C
.db    0x7F,0x7E
.db    0x83,0x84
.db    0x86,0x7F
.db    0x7D,0x82
.db    0x87,0x82
.db    0x7D,0x8B
.db    0x92,0x85
.db    0x87,0x8D
.db    0x87,0x7D
.db    0x7C,0x85
.db    0x86,0x7B
.db    0x74,0x73
.db    0x7F,0x85
.db    0x7F,0x74
.db    0x69,0x6A
.db    0x5D,0x51
.db    0x51,0x3F
.db    0x3F,0x4A
.db    0x4E,0x53
.db    0x4C,0x50
.db    0x5A,0x57
.db    0x4C,0x4C
.db    0x4D,0x3F
.db    0x40,0x49
.db    0x40,0x31
.db    0x2C,0x2D
.db    0x28,0x25
.db    0x25,0x24
.db    0x2B,0x34
.db    0x3B,0x44
.db    0x4B,0x5F
.db    0x7B,0x99
.db    0x92,0x75
.db    0xA9,0xE4
.db    0xE8,0xF7
.db    0xF5,0xDF
.db    0xD6,0xBB
.db    0x86,0x70
.db    0x69,0x64
.db    0x79,0x7B
.db    0x7D,0x8B
.db    0x99,0xA7
.db    0xAA,0xB2
.db    0xB5,0xBF
.db    0xCE,0xD7
.db    0xD6,0xC8
.db    0xBB,0xA8
.db    0x8B,0x7C
.db    0x7C,0x82
.db    0x89,0x95
.db    0xA1,0xAD
.db    0xAB,0xB4
.db    0xB3,0xA3
.db    0xA0,0x9E
.db    0xA3,0xA0
.db    0x9A,0x93
.db    0x8F,0x82
.db    0x81,0x89
.db    0x85,0x84
.db    0x90,0x93
.db    0x90,0x84
.db    0x81,0x7D
.db    0x65,0x65
.db    0x77,0x7C
.db    0x7D,0x83
.db    0x84,0x81
.db    0x81,0x83
.db    0x79,0x76
.db    0x7C,0x87
.db    0x93,0x8B
.db    0x84,0x84
.db    0x7F,0x71
.db    0x76,0x82
.db    0x7B,0x7A
.db    0x82,0x8F
.db    0x92,0x87
.db    0x87,0x87
.db    0x81,0x80
.db    0x76,0x6A
.db    0x60,0x56
.db    0x53,0x4F
.db    0x4A,0x4C
.db    0x54,0x4D
.db    0x40,0x34
.db    0x2E,0x2F
.db    0x2A,0x26
.db    0x32,0x39
.db    0x32,0x35
.db    0x3B,0x33
.db    0x33,0x30
.db    0x32,0x3B
.db    0x3F,0x4A
.db    0x4E,0x52
.db    0x65,0x77
.db    0x59,0x5F
.db    0xA1,0xBE
.db    0xD0,0xE4
.db    0xE2,0xD3
.db    0xC9,0xAC
.db    0x81,0x71
.db    0x5E,0x6F
.db    0x8B,0x87
.db    0x96,0xAB
.db    0xB5,0xB4
.db    0xAE,0xB1
.db    0xB1,0xB0
.db    0xAE,0xB5
.db    0xBA,0xAC
.db    0xA3,0x97
.db    0x8C,0x81
.db    0x7A,0x85
.db    0x91,0x94
.db    0xA4,0xA7
.db    0xA7,0xA8
.db    0x9E,0x98
.db    0x95,0x90
.db    0x87,0x8B
.db    0x80,0x7D
.db    0x8A,0x8A
.db    0x86,0x89
.db    0x93,0x9A
.db    0x9E,0xA5
.db    0xA9,0xA5
.db    0xA1,0x9F
.db    0x99,0x8F
.db    0x90,0x8C
.db    0x87,0x80
.db    0x74,0x73
.db    0x74,0x77
.db    0x78,0x73
.db    0x75,0x79
.db    0x7F,0x97
.db    0x98,0x87
.db    0x81,0x89
.db    0x99,0x84
.db    0x68,0x69
.db    0x6A,0x68
.db    0x60,0x54
.db    0x52,0x55
.db    0x5B,0x5E
.db    0x58,0x51
.db    0x56,0x5B
.db    0x4F,0x42
.db    0x3D,0x3C
.db    0x3D,0x33
.db    0x28,0x2C
.db    0x2F,0x38
.db    0x40,0x35
.db    0x37,0x41
.db    0x4D,0x5B
.db    0x5A,0x6B
.db    0x6E,0x6A
.db    0x81,0x8C
.db    0x78,0x66
.db    0x8D,0xBD
.db    0xCE,0xDF
.db    0xE8,0xED
.db    0xE0,0xC3
.db    0xA3,0x83
.db    0x6E,0x73
.db    0x7A,0x7F
.db    0x85,0x8E
.db    0x98,0x97
.db    0x94,0x91
.db    0x90,0xA3
.db    0xAF,0xB5
.db    0xC2,0xC1
.db    0xB5,0xA6
.db    0x89,0x6B
.db    0x67,0x77
.db    0x7B,0x84
.db    0x88,0x87
.db    0x8A,0x87
.db    0x7E,0x76
.db    0x73,0x7D
.db    0x8C,0x93
.db    0x9A,0x9D
.db    0x9D,0xA1
.db    0x9F,0x89
.db    0x88,0x93
.db    0x97,0x9A
.db    0x95,0x98
.db    0x99,0x93
.db    0x87,0x7A
.db    0x7C,0x82
.db    0x8C,0x90
.db    0x84,0x8D
.db    0x9F,0x95
.db    0x98,0xA4
.db    0x9E,0x96
.db    0x93,0x96
.db    0xA1,0x99
.db    0x7E,0x7F
.db    0x75,0x60
.db    0x64,0x51
.db    0x48,0x50
.db    0x48,0x4D
.db    0x51,0x47
.db    0x4B,0x4E
.db    0x46,0x44
.db    0x45,0x40
.db    0x3F,0x3C
.db    0x38,0x39
.db    0x38,0x35
.db    0x3E,0x40
.db    0x3A,0x3C
.db    0x3C,0x3E
.db    0x33,0x3C
.db    0x57,0x63
.db    0x69,0x75
.db    0x82,0x73
.db    0x88,0xB1
.db    0xBD,0xCD
.db    0xE3,0xFB
.db    0xF0,0xD4
.db    0xBA,0x92
.db    0x79,0x69
.db    0x6E,0x78
.db    0x75,0x7D
.db    0x9A,0xAB
.db    0xAC,0xA7
.db    0xA9,0xB2
.db    0xB3,0xAB
.db    0xAE,0xB2
.db    0xA7,0x9C
.db    0x91,0x7F
.db    0x73,0x77
.db    0x7E,0x85
.db    0x88,0x93
.db    0xAA,0xA9
.db    0x94,0x90
.db    0x93,0x90
.db    0x8B,0x8A
.db    0x93,0x97
.db    0x99,0xA5
.db    0xA7,0x93
.db    0x91,0x9A
.db    0x94,0x8B
.db    0x87,0x8D
.db    0x9A,0x98
.db    0x95,0x92
.db    0x8A,0x82
.db    0x82,0x85
.db    0x81,0x81
.db    0x99,0x9D
.db    0x8F,0x87
.db    0x87,0x91
.db    0x8A,0x71
.db    0x6F,0x6D
.db    0x60,0x5B
.db    0x56,0x54
.db    0x59,0x56
.db    0x4D,0x45
.db    0x42,0x44
.db    0x45,0x3C
.db    0x35,0x3B
.db    0x3B,0x33
.db    0x33,0x2C
.db    0x29,0x29
.db    0x24,0x2C
.db    0x35,0x31
.db    0x34,0x3A
.db    0x3A,0x33
.db    0x33,0x38
.db    0x4A,0x62
.db    0x72,0x7D
.db    0x6F,0x71
.db    0xA1,0xB4
.db    0xBF,0xE3
.db    0xFC,0xFA
.db    0xF0,0xDE
.db    0xBC,0xA2
.db    0x85,0x6C
.db    0x65,0x61
.db    0x70,0x91
.db    0xA2,0xA5
.db    0xB5,0xBF
.db    0xBA,0xB2
.db    0xA4,0xA1
.db    0xAA,0xAD
.db    0xA2,0x9B
.db    0x9A,0x8F
.db    0x89,0x8A
.db    0x8C,0x8C
.db    0x86,0x8F
.db    0xA4,0xA9
.db    0xA4,0x9C
.db    0xA2,0xA7
.db    0xA0,0x94
.db    0x8C,0x89
.db    0x8E,0x98
.db    0x88,0x81
.db    0x8F,0x98
.db    0x96,0x82
.db    0x81,0x8D
.db    0x8C,0x88
.db    0x89,0x8E
.db    0x90,0x91
.db    0x8F,0x83
.db    0x77,0x7B
.db    0x87,0x7F
.db    0x75,0x6B
.db    0x73,0x79
.db    0x6C,0x65
.db    0x67,0x6B
.db    0x6D,0x68
.db    0x5D,0x5D
.db    0x5E,0x5D
.db    0x57,0x46
.db    0x48,0x4D
.db    0x47,0x41
.db    0x38,0x31
.db    0x33,0x37
.db    0x32,0x2F
.db    0x35,0x3F
.db    0x3E,0x3D
.db    0x3F,0x3F
.db    0x3F,0x42
.db    0x4D,0x4D
.db    0x61,0x79
.db    0x6C,0x71
.db    0x95,0xA2
.db    0xB0,0xC0
.db    0xCB,0xDB
.db    0xDA,0xBE
.db    0xC0,0xB1
.db    0x8F,0x8C
.db    0x87,0x80
.db    0x89,0x8C
.db    0x99,0xA9
.db    0xAA,0xAB
.db    0xB1,0xA5
.db    0x9E,0x9D
.db    0xA8,0xAB
.db    0xA1,0x99
.db    0xA3,0xA3
.db    0x91,0x8B
.db    0x91,0x8F
.db    0x89,0x8D
.db    0x95,0x9A
.db    0x8E,0x92
.db    0x9E,0x91
.db    0x95,0x9B
.db    0x8E,0x8F
.db    0x97,0x8D
.db    0x89,0x8E
.db    0x86,0x8C
.db    0x8C,0x87
.db    0x98,0x95
.db    0x8D,0x8C
.db    0x86,0x8A
.db    0x8B,0x7F
.db    0x7B,0x82
.db    0x85,0x80
.db    0x78,0x79
.db    0x7C,0x77
.db    0x70,0x6C
.db    0x68,0x64
.db    0x62,0x61
.db    0x5B,0x5A
.db    0x5C,0x58
.db    0x50,0x4B
.db    0x48,0x48
.db    0x43,0x3F
.db    0x45,0x4C
.db    0x4E,0x4B
.db    0x46,0x4F
.db    0x51,0x3D
.db    0x37,0x3A
.db    0x42,0x4B
.db    0x45,0x51
.db    0x66,0x71
.db    0x76,0x7F
.db    0x92,0xA0
.db    0xB1,0xC5
.db    0xD2,0xD1
.db    0xDB,0xD1
.db    0xBA,0xAC
.db    0x94,0x88
.db    0x8D,0x89
.db    0x88,0x98
.db    0x9F,0xA9
.db    0xAB,0xA7
.db    0xA0,0xA2
.db    0xA8,0xA4
.db    0x9D,0x97
.db    0x98,0x9D
.db    0x9B,0x88
.db    0x82,0x85
.db    0x87,0x7E
.db    0x80,0x87
.db    0x91,0x92
.db    0x8C,0x93
.db    0x96,0x85
.db    0x7F,0x8F
.db    0x8A,0x7A
.db    0x80,0x8B
.db    0x92,0x93
.db    0x8E,0x96
.db    0xA0,0x99
.db    0x95,0x93
.db    0x92,0x92
.db    0x93,0x8C
.db    0x80,0x7D
.db    0x83,0x86
.db    0x74,0x6F
.db    0x73,0x74
.db    0x6F,0x64
.db    0x5F,0x61
.db    0x68,0x62
.db    0x5C,0x57
.db    0x5B,0x5A
.db    0x52,0x48
.db    0x49,0x4F
.db    0x47,0x3D
.db    0x46,0x4C
.db    0x47,0x47
.db    0x47,0x54
.db    0x50,0x40
.db    0x40,0x4A
.db    0x4D,0x4A
.db    0x51,0x68
.db    0x7B,0x77
.db    0x81,0x97
.db    0xA3,0xB4
.db    0xC5,0xD1
.db    0xE2,0xE6
.db    0xD9,0xD7
.db    0xC4,0xA6
.db    0x94,0x8E
.db    0x8B,0x86
.db    0x8C,0x9E
.db    0xAE,0xA8
.db    0xAB,0xB3
.db    0xA6,0xA5
.db    0xA8,0x9E
.db    0xA2,0xA0
.db    0x9D,0x9D
.db    0x91,0x80
.db    0x88,0x8C
.db    0x7E,0x78
.db    0x8A,0x92
.db    0x8B,0x81
.db    0x84,0x91
.db    0x83,0x70
.db    0x71,0x7D
.db    0x83,0x82
.db    0x7A,0x86
.db    0x96,0x90
.db    0x85,0x7B
.db    0x7C,0x88
.db    0x81,0x70
.db    0x76,0x7F
.db    0x84,0x7F
.db    0x70,0x71
.db    0x78,0x71
.db    0x69,0x5D
.db    0x5A,0x63
.db    0x66,0x60
.db    0x58,0x55
.db    0x5B,0x59
.db    0x4C,0x46
.db    0x44,0x4C
.db    0x45,0x38
.db    0x3D,0x3F
.db    0x43,0x45
.db    0x40,0x43
.db    0x47,0x3E
.db    0x3C,0x37
.db    0x33,0x36
.db    0x3A,0x50
.db    0x68,0x78
.db    0x84,0x91
.db    0x9F,0xAC
.db    0xA1,0x98
.db    0xA4,0xBC
.db    0xCE,0xDA
.db    0xD8,0xF2
.db    0xFF,0xE1
.db    0xCE,0xA7
.db    0xAD,0xA1
.db    0x8D,0x94
.db    0x9D,0xBD
.db    0xC9,0xD3
.db    0xCE,0xCB
.db    0xB2,0xB3
.db    0xA3,0x80
.db    0x88,0x86
.db    0x98,0x9C
.db    0x9B,0xA1
.db    0xA5,0x9D
.db    0x87,0x7F
.db    0x69,0x78
.db    0x72,0x74
.db    0x79,0x77
.db    0x91,0x83
.db    0x83,0x71
.db    0x63,0x6A
.db    0x62,0x63
.db    0x79,0x8A
.db    0x86,0x97
.db    0x97,0x8C
.db    0x84,0x74
.db    0x6E,0x69
.db    0x5A,0x57
.db    0x59,0x5C
.db    0x62,0x5C
.db    0x59,0x5A
.db    0x5D,0x5C
.db    0x53,0x50
.db    0x4C,0x4D
.db    0x46,0x40
.db    0x3E,0x42
.db    0x4C,0x48
.db    0x4F,0x51
.db    0x4D,0x55
.db    0x4A,0x37
.db    0x34,0x31
.db    0x2F,0x31
.db    0x3E,0x60
.db    0x70,0x78
.db    0x98,0xA2
.db    0xA9,0xAD
.db    0xA4,0xAF
.db    0xAB,0xAE
.db    0xB7,0xBF
.db    0xD2,0xCF
.db    0xD1,0xD2
.db    0xBE,0xA7
.db    0xA2,0x8E
.db    0x88,0x8E
.db    0x8A,0x9E
.db    0xAA,0xAF
.db    0xB4,0xB6
.db    0xAA,0xA8
.db    0x9B,0x83
.db    0x88,0x83
.db    0x90,0x99
.db    0x97,0x9C
.db    0xA5,0xA7
.db    0x8B,0x81
.db    0x8A,0x80
.db    0x73,0x70
.db    0x72,0x81
.db    0x80,0x79
.db    0x83,0x87
.db    0x7D,0x78
.db    0x80,0x7F
.db    0x76,0x80
.db    0x82,0x85
.db    0x87,0x7D
.db    0x86,0x87
.db    0x76,0x77
.db    0x75,0x69
.db    0x66,0x5C
.db    0x5B,0x57
.db    0x4E,0x4D
.db    0x4F,0x50
.db    0x49,0x43
.db    0x4A,0x45
.db    0x3E,0x3D
.db    0x37,0x3C
.db    0x3E,0x3C
.db    0x40,0x39
.db    0x38,0x3D
.db    0x3B,0x38
.db    0x3A,0x44
.db    0x4F,0x53
.db    0x4F,0x54
.db    0x62,0x79
.db    0x82,0x91
.db    0xAF,0xBD
.db    0xD9,0xE2
.db    0xD2,0xDB
.db    0xDD,0xCA
.db    0xC4,0xBB
.db    0xB3,0xBA
.db    0xB8,0xB8
.db    0xB2,0xA9
.db    0xAF,0xA8
.db    0xA2,0x9C
.db    0x98,0xAC
.db    0xAC,0xA9
.db    0xAF,0xB0
.db    0xA8,0xAC
.db    0xA4,0x95
.db    0x91,0x87
.db    0x8D,0x8C
.db    0x85,0x92
.db    0x99,0x8F
.db    0x93,0x8D
.db    0x7E,0x80
.db    0x77,0x74
.db    0x79,0x72
.db    0x79,0x83
.db    0x82,0x8C
.db    0x80,0x86
.db    0x8A,0x82
.db    0x83,0x7E
.db    0x84,0x83
.db    0x80,0x7D
.db    0x78,0x6E
.db    0x68,0x64
.db    0x5D,0x5D
.db    0x5C,0x5C
.db    0x5A,0x54
.db    0x50,0x4F
.db    0x45,0x3F
.db    0x45,0x42
.db    0x4B,0x4F
.db    0x49,0x4E
.db    0x48,0x3A
.db    0x2F,0x27
.db    0x1F,0x29
.db    0x31,0x2E
.db    0x3B,0x4B
.db    0x59,0x59
.db    0x5C,0x5E
.db    0x78,0x7C
.db    0x86,0xAE
.db    0xB4,0xC1
.db    0xD4,0xD8
.db    0xD4,0xBF
.db    0xB1,0xC2
.db    0xC1,0xA3
.db    0xA4,0xBF
.db    0xC0,0xB3
.db    0xA9,0xA6
.db    0xB1,0xA3
.db    0x99,0xA9
.db    0xA9,0xB2
.db    0xBE,0xBE
.db    0xBB,0xB0
.db    0xA1,0xA1
.db    0x8E,0x7B
.db    0x91,0x8F
.db    0x92,0xA2
.db    0xA3,0xA9
.db    0xA3,0x94
.db    0x95,0x8D
.db    0x72,0x78
.db    0x76,0x7E
.db    0x89,0x85
.db    0x8B,0x91
.db    0x8B,0x84
.db    0x7F,0x7F
.db    0x7A,0x83
.db    0x91,0x90
.db    0x8C,0x8C
.db    0x89,0x7A
.db    0x66,0x55
.db    0x55,0x4E
.db    0x48,0x4B
.db    0x49,0x47
.db    0x46,0x3C
.db    0x2C,0x25
.db    0x1D,0x1D
.db    0x23,0x24
.db    0x2F,0x38
.db    0x38,0x3A
.db    0x34,0x2F
.db    0x32,0x27
.db    0x25,0x2F
.db    0x38,0x44
.db    0x45,0x45
.db    0x5F,0x6E
.db    0x68,0x7B
.db    0x99,0xAA
.db    0xBE,0xD0
.db    0xD1,0xD5
.db    0xD9,0xD3
.db    0xCD,0xB7
.db    0xB5,0xC8
.db    0xBD,0xB6
.db    0xB9,0xBB
.db    0xC1,0xB8
.db    0xAB,0xA5
.db    0xAE,0xA9
.db    0xB5,0xB4
.db    0xAE,0xB7
.db    0xC3,0xB8
.db    0xB0,0xA8
.db    0xA6,0xAD
.db    0xA4,0xA3
.db    0xA7,0xB3
.db    0xAC,0xAE
.db    0xA7,0x9A
.db    0x90,0x83
.db    0x7A,0x72
.db    0x73,0x79
.db    0x85,0x88
.db    0x89,0x8B
.db    0x8B,0x8C
.db    0x83,0x7D
.db    0x76,0x76
.db    0x77,0x77
.db    0x74,0x72
.db    0x6C,0x61
.db    0x4D,0x44
.db    0x3D,0x37
.db    0x38,0x38
.db    0x3B,0x39
.db    0x36,0x34
.db    0x2C,0x22
.db    0x20,0x1E
.db    0x1D,0x20
.db    0x28,0x2B
.db    0x34,0x36
.db    0x3A,0x3C
.db    0x31,0x34
.db    0x3B,0x3F
.db    0x4A,0x5C
.db    0x74,0x89
.db    0x91,0xA2
.db    0xB5,0xBE
.db    0xB8,0xBC
.db    0xCF,0xC7
.db    0xC8,0xD1
.db    0xD1,0xE0
.db    0xD8,0xD4
.db    0xD6,0xC5
.db    0xBA,0xBB
.db    0xB3,0xAE
.db    0xB4,0xBE
.db    0xC6,0xC4
.db    0xBF,0xC3
.db    0xC8,0xBB
.db    0xAA,0xAA
.db    0xA2,0xA6
.db    0xA6,0x95
.db    0xA6,0xA6
.db    0x9B,0xA0
.db    0x96,0x88
.db    0x92,0x8D
.db    0x80,0x7D
.db    0x7E,0x8B
.db    0x8F,0x82
.db    0x7F,0x85
.db    0x7B,0x71
.db    0x6E,0x6B
.db    0x6E,0x6D
.db    0x67,0x64
.db    0x65,0x65
.db    0x66,0x5C
.db    0x50,0x48
.db    0x40,0x37
.db    0x2D,0x23
.db    0x22,0x29
.db    0x2B,0x2A
.db    0x33,0x2D
.db    0x2B,0x28
.db    0x25,0x26
.db    0x24,0x23
.db    0x1E,0x1F
.db    0x23,0x34
.db    0x36,0x3C
.db    0x4F,0x5C
.db    0x6A,0x7F
.db    0x9A,0xAA
.db    0xBD,0xC4
.db    0xC1,0xC1
.db    0xC4,0xCC
.db    0xC1,0xC1
.db    0xC5,0xCE
.db    0xD2,0xD1
.db    0xCE,0xC7
.db    0xC7,0xC4
.db    0xBC,0xB9
.db    0xC2,0xCD
.db    0xD1,0xCF
.db    0xD5,0xD8
.db    0xC8,0xBE
.db    0xAD,0x9C
.db    0x92,0x93
.db    0x8F,0x91
.db    0x8F,0x99
.db    0x95,0x8F
.db    0x9A,0x87
.db    0x81,0x79
.db    0x74,0x71
.db    0x6C,0x79
.db    0x72,0x71
.db    0x74,0x73
.db    0x73,0x6B
.db    0x67,0x60
.db    0x5D,0x61
.db    0x5F,0x5A
.db    0x67,0x66
.db    0x5D,0x56
.db    0x46,0x46
.db    0x3D,0x30
.db    0x2C,0x25
.db    0x31,0x39
.db    0x38,0x3A
.db    0x38,0x37
.db    0x35,0x31
.db    0x37,0x2F
.db    0x30,0x2E
.db    0x2C,0x2F
.db    0x30,0x3F
.db    0x3E,0x4A
.db    0x55,0x63
.db    0x7F,0x90
.db    0xAC,0xC7
.db    0xCB,0xD2
.db    0xCE,0xC4
.db    0xB3,0xB7
.db    0xB2,0xB0
.db    0xCE,0xCC
.db    0xDD,0xEA
.db    0xDC,0xDD
.db    0xD6,0xBE
.db    0xBC,0xAE
.db    0xB1,0xBA
.db    0xC4,0xCF
.db    0xDC,0xCD
.db    0xCB,0xB8
.db    0xA3,0x9A
.db    0x91,0x8D
.db    0x95,0x98
.db    0xA5,0xAA
.db    0xA4,0xAC
.db    0xAA,0x92
.db    0x88,0x76
.db    0x6E,0x76
.db    0x6E,0x74
.db    0x90,0x98
.db    0x92,0x9A
.db    0x81,0x6E
.db    0x68,0x52
.db    0x45,0x46
.db    0x45,0x58
.db    0x5F,0x5E
.db    0x5D,0x5F
.db    0x5C,0x4D
.db    0x45,0x33
.db    0x31,0x35
.db    0x2B,0x34
.db    0x42,0x3A
.db    0x3D,0x35
.db    0x27,0x21
.db    0x1D,0x13
.db    0x14,0x13
.db    0x15,0x1F
.db    0x29,0x34
.db    0x4F,0x5A
.db    0x69,0x7A
.db    0x83,0x90
.db    0x9B,0xB7
.db    0xBE,0xBB
.db    0xC9,0xD2
.db    0xC4,0xCB
.db    0xD3,0xCB
.db    0xD1,0xC2
.db    0xCD,0xD1
.db    0xC6,0xCA
.db    0xC5,0xC4
.db    0xC8,0xC5
.db    0xC6,0xB9
.db    0xC6,0xBE
.db    0xBB,0xBE
.db    0xAB,0xB1
.db    0xA7,0xA3
.db    0xA3,0xA0
.db    0xAB,0xA3
.db    0xA2,0xA3
.db    0x9D,0x99
.db    0x94,0x86
.db    0x7F,0x78
.db    0x74,0x75
.db    0x79,0x80
.db    0x81,0x7D
.db    0x80,0x7A
.db    0x79,0x74
.db    0x6F,0x6F
.db    0x6B,0x63
.db    0x61,0x57
.db    0x4E,0x4C
.db    0x4A,0x40
.db    0x3E,0x3B
.db    0x3A,0x36
.db    0x38,0x43
.db    0x3B,0x3E
.db    0x42,0x44
.db    0x44,0x3A
.db    0x3A,0x39
.db    0x30,0x2D
.db    0x25,0x1F
.db    0x2A,0x2E
.db    0x31,0x3F
.db    0x4C,0x54
.db    0x62,0x6B
.db    0x73,0x7B
.db    0x89,0x8C
.db    0x8A,0x94
.db    0x91,0x98
.db    0xB0,0xA6
.db    0xB3,0xC0
.db    0xBC,0xC6
.db    0xC3,0xC2
.db    0xC3,0xC0
.db    0xC9,0xBE
.db    0xBD,0xC3
.db    0xB5,0xB7
.db    0xB7,0xA7
.db    0xA6,0xA2
.db    0xA3,0x9B
.db    0xA9,0xA5
.db    0xA4,0xA8
.db    0xA0,0xA4
.db    0xA4,0x94
.db    0x90,0x8D
.db    0x8E,0x8E
.db    0x8D,0x8A
.db    0x81,0x88
.db    0x82,0x77
.db    0x7A,0x75
.db    0x71,0x6C
.db    0x6C,0x69
.db    0x5F,0x66
.db    0x60,0x5C
.db    0x66,0x58
.db    0x65,0x6A
.db    0x5B,0x6B
.db    0x60,0x59
.db    0x66,0x6B
.db    0x76,0x66
.db    0x63,0x7D
.db    0x6D,0x7B
.db    0x83,0x77
.db    0x85,0x7C
.db    0x7A,0x94
.db    0x75,0x88
.db    0x6D,0x7A
.db    0x84,0x7B
.db    0x8D,0x7C
.db    0x83,0x7E
.db    0x78,0x8C
.db    0x80,0x90
.db    0x90,0x81
.db    0x92,0x83
.db    0x8E,0x91
.db    0x99,0x89
.db    0x8F,0x93
.db    0x81,0x8D
.db    0x98,0x95
.db    0xAC,0x98
.db    0x7E,0x60
.db    0x92,0xB2
.db    0xA0,0xAA
.db    0x96,0x7E
.db    0x85,0x93
.db    0x99,0x9A
.db    0x9F,0x93
.db    0x8C,0x8A
.db    0x98,0x84
.db    0x85,0x96
.db    0x71,0x69
.db    0x62,0x96
.db    0x7D,0x5B
.db    0x70,0x65
.db    0x68,0x61
.db    0x51,0x61
.db    0x63,0x53
.db    0x5F,0x63
.db    0x68,0x53
.db    0x63,0x67
.db    0x5B,0x72
.db    0x7A,0x6D
.db    0x66,0x71
.db    0x77,0x7E
.db    0x80,0x74
.db    0x7E,0x79
.db    0x76,0x89
.db    0x77,0x86
.db    0x72,0x7E
.db    0x7E,0x88
.db    0x73,0x76
.db    0x77,0x84
.db    0x66,0x85
.db    0x71,0x70
.db    0x68,0x68
.db    0x78,0x7C
.db    0x76,0x6A
.db    0x6D,0x6B
.db    0x6D,0x7C
.db    0x82,0x7D
.db    0x77,0x76
.db    0x72,0x76
.db    0x80,0x84
.db    0x7F,0x7E
.db    0x7B,0x87
.db    0x82,0x84
.db    0x90,0x92
.db    0x88,0x80
.db    0x83,0x7D
.db    0x7F,0x8E
.db    0x89,0x8A
.db    0x86,0x88
.db    0x80,0x7E
.db    0x8A,0x82
.db    0x86,0x84
.db    0x87,0x80
.db    0x85,0x7E
.db    0x81,0x7C
.db    0x86,0x82
.db    0x85,0x82
.db    0x86,0x83
.db    0x84,0x83
.db    0x87,0x89
.db    0x82,0x87
.db    0x83,0x86
.db    0x8A,0x88
.db    0x8D,0x8B
.db    0x84,0x88
.db    0x8C,0x8D
.db    0x94,0x94
.db    0x93,0x8F
.db    0x8B,0x8C
.db    0x93,0x8E
.db    0x8E,0x8C
.db    0x86,0x84
.db    0x8B,0x86
.db    0x87,0x8B
.db    0x90,0x85
.db    0x83,0x80
.db    0x84,0x85
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7D,0x81
.db    0x88,0x80
.db    0x8B,0x7E
.db    0x7F,0x7E
.db    0x7B,0x83
.db    0x84,0x7F
.db    0x82,0x81
.db    0x80,0x7D
.db    0x82,0x7F
.db    0x7D,0x7D
.db    0x7C,0x7B
.db    0x7F,0x7C
.db    0x7F,0x7F
.db    0x82,0x7F
.db    0x7E,0x7D
.db    0x7D,0x7E
.db    0x79,0x7B
.db    0x7D,0x7B
.db    0x76,0x7E
.db    0x76,0x7B
.db    0x7B,0x79
.db    0x78,0x7A
.db    0x7B,0x77
.db    0x74,0x7C
.db    0x7A,0x79
.db    0x7B,0x7B
.db    0x7A,0x78
.db    0x78,0x7F
.db    0x7C,0x7B
.db    0x7B,0x7C
.db    0x7B,0x7A
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7D,0x7D
.db    0x7F,0x83
.db    0x80,0x7F
.db    0x7B,0x7E
.db    0x7F,0x7E
.db    0x7F,0x81
.db    0x7D,0x7E
.db    0x7B,0x7A
.db    0x7B,0x7D
.db    0x7E,0x7E
.db    0x7D,0x7D
.db    0x7D,0x7C
.db    0x7D,0x7B
.db    0x80,0x7C
.db    0x7E,0x81
.db    0x7E,0x7F
.db    0x80,0x7B
.db    0x7E,0x7D
.db    0x7E,0x7F
.db    0x81,0x81
.db    0x7C,0x7C
.db    0x7D,0x7E
.db    0x80,0x7F
.db    0x7B,0x7E
.db    0x7E,0x7E
.db    0x80,0x7F
.db    0x80,0x7D
.db    0x7C,0x7E
.db    0x7E,0x7E
.db    0x80,0x82
.db    0x81,0x7D
.db    0x7E,0x81
.db    0x7F,0x80
.db    0x81,0x84
.db    0x7D,0x80
.db    0x80,0x80
.db    0x81,0x81
.db    0x81,0x82
.db    0x7C,0x81
.db    0x80,0x7E
.db    0x7F,0x7E
.db    0x7E,0x7D
.db    0x7D,0x80
.db    0x7D,0x7C
.db    0x7E,0x7D
.db    0x7C,0x7C
.db    0x7D,0x7C
.db    0x7D,0x7C
.db    0x7D,0x7F
.db    0x7F,0x7E
.db    0x80,0x7F
.db    0x7E,0x7E
.db    0x7E,0x81
.db    0x7F,0x81
.db    0x81,0x82
.db    0x82,0x83
.db    0x83,0x81
.db    0x7F,0x80
.db    0x82,0x82
.db    0x84,0x83
.db    0x82,0x80
.db    0x7F,0x7F
.db    0x81,0x80
.db    0x81,0x81
.db    0x7D,0x7D
.db    0x7F,0x7E
.db    0x7F,0x82
.db    0x80,0x7C
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7C
.db    0x7E,0x80
.db    0x82,0x81
.db    0x80,0x7F
.db    0x7E,0x80
.db    0x82,0x80
.db    0x81,0x82
.db    0x80,0x80
.db    0x81,0x82
.db    0x82,0x7F
.db    0x82,0x81
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7E,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7E
.db    0x80,0x80
.db    0x7E,0x7F
.db    0x7D,0x7C
.db    0x7E,0x7E
.db    0x7E,0x80
.db    0x7E,0x7E
.db    0x7D,0x7D
.db    0x80,0x80
.db    0x81,0x80
.db    0x80,0x7D
.db    0x7E,0x7F
.db    0x80,0x80
.db    0x81,0x7E
.db    0x7D,0x7E
.db    0x7D,0x7E
.db    0x80,0x81
.db    0x80,0x80
.db    0x7E,0x7F
.db    0x81,0x7E
.db    0x7E,0x80
.db    0x7F,0x7F
.db    0x7D,0x7D
.db    0x7E,0x80
.db    0x80,0x80
.db    0x81,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7F
.db    0x81,0x80
.db    0x80,0x7E
.db    0x7E,0x7D
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7D,0x7E
.db    0x7E,0x7F
.db    0x80,0x81
.db    0x80,0x81
.db    0x7F,0x7F
.db    0x81,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x81
.db    0x80,0x80
.db    0x80,0x81
.db    0x80,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7E,0x7E
.db    0x7F,0x7D
.db    0x7D,0x80
.db    0x80,0x80
.db    0x80,0x7E
.db    0x7E,0x7E
.db    0x81,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x82,0x80
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x80,0x82
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x81
.db    0x81,0x80
.db    0x7F,0x7E
.db    0x7E,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7E,0x7F
.db    0x7F,0x7E
.db    0x7E,0x7F
.db    0x7E,0x7E
.db    0x7F,0x7F
.db    0x7F,0x7E
.db    0x7F,0x7F
.db    0x7E,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x81
.db    0x81,0x80
.db    0x80,0x81
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x81
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x80,0x7F
.db    0x80,0x80
.db    0x7F,0x80
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x7F,0x80
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x80,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x7E
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x7E
.db    0x7F,0x7E
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7E,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x80,0x7D
.db    0x80,0x7E
.db    0x7F,0x80
.db    0x80,0x7E
.db    0x7F,0x7E
.db    0x7F,0x7E
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7E,0x7E
.db    0x80,0x7E
.db    0x7F,0x80
.db    0x7F,0x7E
.db    0x7E,0x7F
.db    0x81,0x7F
.db    0x7D,0x7F
.db    0x7E,0x7E
.db    0x7E,0x7F
.db    0x7E,0x7E
.db    0x7D,0x7F
.db    0x7E,0x7D
.db    0x7F,0x7E
.db    0x7E,0x7F
.db    0x7D,0x7E
.db    0x7E,0x7F
.db    0x7F,0x7F
.db    0x7E,0x7F
.db    0x7F,0x7D
.db    0x7F,0x7F
.db    0x7E,0x7F
.db    0x7E,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x81,0x7E
.db    0x81,0x80
.db    0x7F,0x80
.db    0x7F,0x80
.db    0x81,0x80
.db    0x7F,0x81
.db    0x7F,0x7F
.db    0x82,0x7F
.db    0x80,0x81
.db    0x7F,0x7F
.db    0x80,0x82
.db    0x7F,0x82
.db    0x7F,0x81
.db    0x7D,0x7E
.db    0x82,0x82
.db    0x82,0x7F
.db    0x82,0x7F
.db    0x83,0x7F
.db    0x83,0x82
.db    0x81,0x81
.db    0x7F,0x80
.db    0x81,0x7F
.db    0x85,0x84
.db    0x84,0x7E
.db    0x81,0x80
.db    0x7C,0x83
.db    0x87,0x7A
.db    0x8C,0x78
.db    0x80,0x81
.db    0x7F,0x83
.db    0x8A,0x7E
.db    0x82,0x84
.db    0x7F,0x81
.db    0x80,0x87
.db    0x81,0x7F
.db    0x80,0x86
.db    0x83,0x85
.db    0x89,0x7D
.db    0x87,0x7C
.db    0x7E,0x91
.db    0x88,0x85
.db    0x85,0x85
.db    0x8C,0x82
.db    0x5B,0xA2
.db    0xB1,0x92
.db    0x75,0x7A
.db    0x80,0x72
.db    0x61,0xAB
.db    0xA9,0x86
.db    0x7B,0x79
.db    0x72,0x88
.db    0x87,0x87
.db    0x7D,0x7F
.db    0x58,0x49
.db    0xA3,0x9C
.db    0x8F,0x71
.db    0x68,0x4E
.db    0x5B,0x64
.db    0x84,0x7C
.db    0x79,0x71
.db    0x6E,0x56
.db    0x87,0x85
.db    0x95,0x8A
.db    0x7A,0x61
.db    0x6B,0x9C
.db    0xA7,0x98
.db    0x8B,0x89
.db    0x88,0x68
.db    0x7B,0x63
.db    0x89,0x5A
.db    0x67,0x76
.db    0x28,0x73
.db    0x5E,0x90
.db    0x77,0x54
.db    0x5A,0x65
.db    0x3A,0x78
.db    0x83,0x7A
.db    0x57,0x5F
.db    0x69,0x6D
.db    0x85,0x78
.db    0x9E,0x87
.db    0x78,0x69
.db    0x6F,0x6A
.db    0x6F,0x7C
.db    0x75,0x7E
.db    0x63,0x79
.db    0x71,0x70
.db    0x90,0x9C
.db    0x8E,0x86
.db    0x82,0x92
.db    0x89,0x8B
.db    0x9D,0x8C
.db    0xA1,0x9A
.db    0x87,0x61
.db    0x8E,0x8D
.db    0x86,0x8B
.db    0x75,0x71
.db    0x7B,0x73
.db    0x8A,0xA2
.db    0x6A,0x83
.db    0x88,0x77
.db    0x84,0x87
.db    0x7A,0x7C
.db    0x76,0x7A
.db    0x89,0x67
.db    0x8F,0x8F
.db    0x98,0x8A
.db    0x87,0xA4
.db    0x79,0x97
.db    0xA1,0x8E
.db    0x9A,0x80
.db    0x9E,0x89
.db    0x72,0xAC
.db    0x83,0x97
.db    0x8B,0x66
.db    0x9E,0x7A
.db    0x8D,0x9C
.db    0x87,0x85
.db    0x7D,0x99
.db    0x7E,0x86
.db    0x95,0x7F
.db    0x87,0x74
.db    0x8E,0x92
.db    0x91,0x9C
.db    0x8B,0x8F
.db    0x80,0x88
.db    0x88,0xA1
.db    0x76,0xA0
.db    0x82,0x72
.db    0xA0,0x86
.db    0x8C,0xA1
.db    0x8A,0x9D
.db    0x82,0x85
.db    0x89,0x6E
.db    0x8A,0x59
.db    0x86,0x5D
.db    0x64,0x6A
.db    0x50,0x6B
.db    0x48,0x87
.db    0x5C,0x45
.db    0x7C,0x5D
.db    0x63,0x70
.db    0x75,0x69
.db    0x87,0x6B
.db    0x7F,0x7C
.db    0x6B,0x77
.db    0x9B,0x64
.db    0x77,0x82
.db    0x70,0x70
.db    0x70,0x89
.db    0x7B,0x7D
.db    0x7A,0x8D
.db    0x69,0x73
.db    0x82,0x7B
.db    0x97,0x76
.db    0x80,0x7E
.db    0x58,0x82
.db    0xAC,0x90
.db    0x90,0xA0
.db    0x78,0x8F
.db    0x90,0x9A
.db    0xC0,0xA7
.db    0x99,0xB1
.db    0x83,0x8D
.db    0x9C,0xA1
.db    0xB3,0xB3
.db    0xA2,0x8C
.db    0x7C,0x75
.db    0xAE,0xA8
.db    0x9B,0xA1
.db    0x7D,0x76
.db    0x75,0x83
.db    0x83,0x93
.db    0x8D,0x78
.db    0x6C,0x50
.db    0x6A,0x73
.db    0x71,0x74
.db    0x66,0x4E
.db    0x3B,0x48
.db    0x49,0x60
.db    0x65,0x52
.db    0x42,0x2C
.db    0x3C,0x4F
.db    0x50,0x61
.db    0x52,0x39
.db    0x3B,0x35
.db    0x41,0x57
.db    0x5B,0x63
.db    0x4F,0x45
.db    0x4C,0x50
.db    0x57,0x72
.db    0x7A,0x7A
.db    0x63,0x5D
.db    0x70,0x78
.db    0x9E,0xA6
.db    0xA3,0xA0
.db    0x99,0xA2
.db    0xB6,0xC5
.db    0xD8,0xDA
.db    0xCF,0xC5
.db    0xC2,0xCB
.db    0xCE,0xDB
.db    0xE7,0xD6
.db    0xC5,0xBB
.db    0xB1,0xAF
.db    0xC1,0xD2
.db    0xC3,0x9C
.db    0x8A,0x8A
.db    0x95,0x8D
.db    0x8F,0x89
.db    0x7A,0x6C
.db    0x6A,0x69
.db    0x69,0x78
.db    0x7D,0x70
.db    0x7B,0x76
.db    0x64,0x70
.db    0x86,0x96
.db    0x94,0x79
.db    0x80,0x89
.db    0x88,0x95
.db    0x98,0x93
.db    0x8E,0x8C
.db    0x90,0x89
.db    0x89,0x8B
.db    0x89,0x7F
.db    0x77,0x70
.db    0x6A,0x64
.db    0x64,0x5D
.db    0x4F,0x48
.db    0x3F,0x3B
.db    0x35,0x2F
.db    0x2A,0x1D
.db    0x17,0x1B
.db    0x17,0x18
.db    0x19,0x11
.db    0x12,0x11
.db    0x16,0x2B
.db    0x33,0x39
.db    0x41,0x3B
.db    0x3E,0x5B
.db    0x69,0x83
.db    0x92,0x8E
.db    0x98,0xA1
.db    0xAF,0xCD
.db    0xD7,0xE6
.db    0xE5,0xE2
.db    0xE8,0xE3
.db    0xEC,0xF7
.db    0xF5,0xF1
.db    0xE8,0xDD
.db    0xD1,0xC2
.db    0xBE,0xC5
.db    0xC0,0xAE
.db    0xA2,0x88
.db    0x7A,0x87
.db    0x84,0x83
.db    0x7D,0x6E
.db    0x68,0x6A
.db    0x65,0x6E
.db    0x73,0x76
.db    0x81,0x7E
.db    0x75,0x77
.db    0x80,0x84
.db    0x8F,0x9C
.db    0x8F,0x8E
.db    0x96,0x93
.db    0x95,0x97
.db    0x98,0x9C
.db    0x91,0x91
.db    0x94,0x90
.db    0x88,0x8A
.db    0x8F,0x87
.db    0x7B,0x86
.db    0x83,0x79
.db    0x75,0x74
.db    0x6C,0x62
.db    0x67,0x67
.db    0x5F,0x49
.db    0x46,0x49
.db    0x3E,0x30
.db    0x35,0x35
.db    0x2D,0x2A
.db    0x28,0x2B
.db    0x1E,0x1E
.db    0x2B,0x35
.db    0x34,0x35
.db    0x42,0x44
.db    0x54,0x5F
.db    0x6B,0x81
.db    0x89,0xA3
.db    0xBD,0xB7
.db    0xCC,0xE2
.db    0xE0,0xE9
.db    0xEF,0xFB
.db    0xFF,0xF9
.db    0xF1,0xE6
.db    0xD9,0xDB
.db    0xD9,0xD9
.db    0xC1,0xA8
.db    0x9B,0x89
.db    0x85,0x85
.db    0x72,0x67
.db    0x5E,0x58
.db    0x59,0x51
.db    0x4D,0x56
.db    0x56,0x59
.db    0x63,0x69
.db    0x73,0x71
.db    0x79,0x91
.db    0x92,0x97
.db    0x9C,0x98
.db    0xA6,0xAD
.db    0xAD,0xAA
.db    0x92,0xA6
.db    0xA3,0x8B
.db    0x96,0x8D
.db    0x80,0x7B
.db    0x78,0x72
.db    0x68,0x65
.db    0x67,0x62
.db    0x5D,0x61
.db    0x70,0x69
.db    0x5E,0x72
.db    0x71,0x70
.db    0x79,0x71
.db    0x69,0x67
.db    0x61,0x5B
.db    0x59,0x55
.db    0x48,0x41
.db    0x35,0x2E
.db    0x23,0x1D
.db    0x22,0x1F
.db    0x1F,0x1D
.db    0x10,0x0E
.db    0x13,0x29
.db    0x3D,0x49
.db    0x50,0x4F
.db    0x43,0x5C
.db    0x97,0xBC
.db    0xCD,0xD8
.db    0xCB,0xCF
.db    0xE0,0xF7
.db    0xFF,0xFF
.db    0xFF,0xFE
.db    0xF4,0xDE
.db    0xCB,0xD4
.db    0xD8,0xCD
.db    0xC1,0x99
.db    0x76,0x65
.db    0x5F,0x73
.db    0x7C,0x6A
.db    0x59,0x41
.db    0x37,0x40
.db    0x52,0x66
.db    0x69,0x6B
.db    0x67,0x65
.db    0x6D,0x77
.db    0x8F,0xA4
.db    0xAD,0xAA
.db    0x9F,0x97
.db    0x9B,0xA6
.db    0xB7,0xBB
.db    0xAA,0x99
.db    0x8D,0x88
.db    0x8A,0x90
.db    0x89,0x7B
.db    0x6D,0x62
.db    0x5B,0x5A
.db    0x5A,0x60
.db    0x5F,0x5A
.db    0x58,0x59
.db    0x69,0x75
.db    0x78,0x83
.db    0x7B,0x7C
.db    0x80,0x84
.db    0x89,0x7B
.db    0x71,0x68
.db    0x5A,0x53
.db    0x49,0x4C
.db    0x44,0x2E
.db    0x2B,0x1F
.db    0x15,0x1A
.db    0x24,0x27
.db    0x1E,0x1A
.db    0x1D,0x28
.db    0x35,0x45
.db    0x5A,0x62
.db    0x5F,0x6E
.db    0x90,0xAE
.db    0xC5,0xDD
.db    0xE6,0xE5
.db    0xE3,0xEB
.db    0xFB,0xFF
.db    0xFF,0xFF
.db    0xF5,0xDB
.db    0xC6,0xC2
.db    0xC8,0xBF
.db    0xB2,0xA4
.db    0x7E,0x6B
.db    0x60,0x5C
.db    0x66,0x6B
.db    0x5F,0x53
.db    0x46,0x3E
.db    0x45,0x5D
.db    0x6F,0x79
.db    0x7E,0x78
.db    0x78,0x8B
.db    0x99,0xA7
.db    0xB2,0xB1
.db    0xAD,0xAD
.db    0xAF,0xAF
.db    0xAF,0xAA
.db    0xAC,0xA8
.db    0x8F,0x88
.db    0x8C,0x89
.db    0x83,0x76
.db    0x71,0x6D
.db    0x63,0x69
.db    0x65,0x5F
.db    0x63,0x6C
.db    0x78,0x6C
.db    0x79,0x85
.db    0x83,0x9E
.db    0xA2,0xA4
.db    0xA9,0x96
.db    0xA0,0xA3
.db    0x97,0x8D
.db    0x7A,0x71
.db    0x56,0x4F
.db    0x4F,0x41
.db    0x39,0x24
.db    0x1E,0x14
.db    0x05,0x1A
.db    0x1C,0x1D
.db    0x1C,0x12
.db    0x1B,0x23
.db    0x3B,0x51
.db    0x58,0x60
.db    0x5F,0x72
.db    0x81,0x98
.db    0xC7,0xD3
.db    0xD7,0xDF
.db    0xD7,0xD4
.db    0xE1,0xF6
.db    0xFE,0xF4
.db    0xDB,0xBD
.db    0xAC,0xAA
.db    0xAD,0xB1
.db    0xA2,0x86
.db    0x71,0x65
.db    0x62,0x5E
.db    0x66,0x6E
.db    0x6B,0x6C
.db    0x5F,0x52
.db    0x59,0x6C
.db    0x88,0x92
.db    0x8C,0x88
.db    0x88,0x94
.db    0x9C,0xAC
.db    0xB4,0xAD
.db    0xAC,0xA5
.db    0xA2,0x9E
.db    0x92,0x9A
.db    0x9B,0x8A
.db    0x86,0x79
.db    0x66,0x63
.db    0x6B,0x76
.db    0x6E,0x60
.db    0x58,0x57
.db    0x5D,0x65
.db    0x77,0x7E
.db    0x72,0x76
.db    0x80,0x83
.db    0x89,0x97
.db    0xA6,0xA6
.db    0xA9,0xA7
.db    0xA3,0xA9
.db    0xA5,0xA3
.db    0x9F,0x8F
.db    0x77,0x63
.db    0x5D,0x4F
.db    0x46,0x46
.db    0x39,0x27
.db    0x12,0x07
.db    0x10,0x19
.db    0x25,0x2D
.db    0x24,0x14
.db    0x12,0x24
.db    0x40,0x55
.db    0x5F,0x60
.db    0x61,0x6F
.db    0x76,0x84
.db    0xB1,0xCE
.db    0xD6,0xDB
.db    0xD9,0xCA
.db    0xC2,0xD7
.db    0xF4,0xF9
.db    0xEC,0xD0
.db    0xB3,0x9E
.db    0x96,0xAA
.db    0xAF,0x99
.db    0x87,0x79
.db    0x66,0x5C
.db    0x5E,0x6F
.db    0x76,0x77
.db    0x79,0x71
.db    0x69,0x63
.db    0x73,0x93
.db    0x9D,0x98
.db    0x95,0x96
.db    0x97,0x98
.db    0xA1,0xA7
.db    0xAA,0xB1
.db    0xA9,0x94
.db    0x83,0x86
.db    0x8C,0x8F
.db    0x90,0x88
.db    0x7C,0x6A
.db    0x61,0x66
.db    0x70,0x76
.db    0x74,0x75
.db    0x6E,0x65
.db    0x6C,0x79
.db    0x87,0x90
.db    0x96,0x92
.db    0x8B,0x8B
.db    0x8A,0x9C
.db    0xB3,0xB0
.db    0xAA,0xA7
.db    0x9C,0x93
.db    0x97,0x97
.db    0x90,0x88
.db    0x72,0x5D
.db    0x4B,0x3B
.db    0x38,0x3B
.db    0x35,0x25
.db    0x17,0x0D
.db    0x05,0x0D
.db    0x1D,0x2A
.db    0x30,0x28
.db    0x24,0x24
.db    0x28,0x37
.db    0x4E,0x69
.db    0x71,0x6A
.db    0x70,0x72
.db    0x73,0x88
.db    0xB6,0xD9
.db    0xDD,0xD9
.db    0xCF,0xC1
.db    0xC9,0xE1
.db    0xFF,0xFF
.db    0xE7,0xCE
.db    0xBB,0xAF
.db    0xB2,0xC0
.db    0xBE,0xAB
.db    0x9A,0x87
.db    0x75,0x68
.db    0x6B,0x78
.db    0x84,0x87
.db    0x7A,0x65
.db    0x5A,0x64
.db    0x78,0x86
.db    0x93,0x9A
.db    0x8C,0x7C
.db    0x84,0x96
.db    0xA1,0xAB
.db    0xAE,0xAD
.db    0xA6,0x96
.db    0x95,0xA2
.db    0x9F,0x9D
.db    0xA4,0x98
.db    0x7D,0x71
.db    0x76,0x80
.db    0x78,0x72
.db    0x74,0x69
.db    0x5E,0x62
.db    0x6A,0x6A
.db    0x6A,0x6E
.db    0x73,0x77
.db    0x74,0x76
.db    0x82,0x84
.db    0x87,0x8F
.db    0x88,0x89
.db    0x90,0x98
.db    0xA8,0xA1
.db    0x94,0x8B
.db    0x84,0x8C
.db    0x88,0x7A
.db    0x6F,0x5B
.db    0x4A,0x38
.db    0x36,0x35
.db    0x24,0x20
.db    0x1E,0x0F
.db    0x02,0x00
.db    0x0C,0x19
.db    0x1C,0x1D
.db    0x0C,0x08
.db    0x10,0x26
.db    0x40,0x47
.db    0x52,0x5A
.db    0x59,0x65
.db    0x77,0x98
.db    0xB6,0xCC
.db    0xE1,0xE1
.db    0xD7,0xD7
.db    0xDF,0xF3
.db    0xFF,0xFF
.db    0xF8,0xDB
.db    0xC5,0xC2
.db    0xBF,0xB7
.db    0xBC,0xB8
.db    0xA0,0x90
.db    0x80,0x73
.db    0x74,0x7F
.db    0x86,0x81
.db    0x76,0x74
.db    0x71,0x6F
.db    0x76,0x87
.db    0x8E,0x92
.db    0x99,0x90
.db    0x89,0x8C
.db    0x98,0xA7
.db    0xA4,0xA3
.db    0x9D,0x90
.db    0x8B,0x87
.db    0x93,0x94
.db    0x86,0x83
.db    0x7C,0x72
.db    0x6F,0x72
.db    0x73,0x75
.db    0x73,0x6A
.db    0x6A,0x6D
.db    0x6D,0x70
.db    0x7C,0x7A
.db    0x74,0x7C
.db    0x7F,0x87
.db    0x88,0x8B
.db    0x96,0x94
.db    0x98,0x91
.db    0x93,0xA2
.db    0xA5,0xB8
.db    0xB0,0x9C
.db    0x98,0x8B
.db    0x96,0x97
.db    0x8E,0x81
.db    0x67,0x5B
.db    0x48,0x44
.db    0x46,0x3C
.db    0x3B,0x2D
.db    0x1F,0x16
.db    0x0F,0x1B
.db    0x20,0x27
.db    0x22,0x18
.db    0x1B,0x19
.db    0x22,0x30
.db    0x32,0x3C
.db    0x46,0x50
.db    0x54,0x5B
.db    0x6B,0x7E
.db    0x9B,0xAB
.db    0xBB,0xC0
.db    0xAF,0xC0
.db    0xCB,0xD5
.db    0xE0,0xD8
.db    0xDC,0xCC
.db    0xC1,0xC7
.db    0xBB,0xB9
.db    0xBA,0xB5
.db    0xA8,0x97
.db    0x8F,0x82
.db    0x84,0x8F
.db    0x89,0x84
.db    0x78,0x6D
.db    0x6E,0x6D
.db    0x7A,0x88
.db    0x88,0x88
.db    0x7F,0x7D
.db    0x8F,0x91
.db    0x9B,0xA5
.db    0xA1,0xA0
.db    0x96,0x93
.db    0x9A,0x99
.db    0x9B,0x9E
.db    0xA1,0x98
.db    0x88,0x86
.db    0x84,0x83
.db    0x8B,0x8B
.db    0x81,0x72
.db    0x6D,0x72
.db    0x71,0x6F
.db    0x6E,0x6E
.db    0x6A,0x68
.db    0x6F,0x78
.db    0x7E,0x80
.db    0x80,0x81
.db    0x7A,0x7F
.db    0x91,0xA0
.db    0xA7,0xA7
.db    0x9C,0x88
.db    0x85,0x92
.db    0x9D,0x9F
.db    0x8C,0x77
.db    0x62,0x51
.db    0x50,0x57
.db    0x59,0x50
.db    0x3F,0x30
.db    0x20,0x1A
.db    0x22,0x2E
.db    0x36,0x33
.db    0x29,0x22
.db    0x15,0x1A
.db    0x2D,0x40
.db    0x4F,0x4F
.db    0x4A,0x4C
.db    0x58,0x66
.db    0x72,0x8F
.db    0xA5,0xA9
.db    0xAB,0xB9
.db    0xBD,0xBB
.db    0xD3,0xE0
.db    0xE0,0xDA
.db    0xCA,0xC8
.db    0xC6,0xC6
.db    0xD3,0xD4
.db    0xBD,0xA7
.db    0xA7,0x9F
.db    0x99,0x9B
.db    0x99,0x99
.db    0x8A,0x87
.db    0x88,0x79
.db    0x7C,0x83
.db    0x87,0x88
.db    0x81,0x81
.db    0x7F,0x7C
.db    0x87,0x92
.db    0x8B,0x82
.db    0x84,0x88
.db    0x87,0x87
.db    0x92,0x92
.db    0x85,0x81
.db    0x86,0x8A
.db    0x87,0x89
.db    0x88,0x83
.db    0x7C,0x78
.db    0x81,0x80
.db    0x79,0x79
.db    0x70,0x6D
.db    0x72,0x74
.db    0x77,0x70
.db    0x74,0x7D
.db    0x77,0x72
.db    0x75,0x7B
.db    0x81,0x87
.db    0x87,0x80
.db    0x7C,0x83
.db    0x95,0xA3
.db    0xA6,0x9C
.db    0x8D,0x84
.db    0x88,0x96
.db    0x9A,0x8F
.db    0x83,0x6C
.db    0x5F,0x5E
.db    0x59,0x58
.db    0x54,0x4F
.db    0x44,0x2F
.db    0x25,0x26
.db    0x2B,0x36
.db    0x35,0x29
.db    0x1B,0x14
.db    0x1C,0x2A
.db    0x32,0x36
.db    0x38,0x37
.db    0x3E,0x4E
.db    0x61,0x69
.db    0x6C,0x74
.db    0x8A,0x9C
.db    0x9A,0xA9
.db    0xBB,0xBF
.db    0xCB,0xCB
.db    0xCC,0xCF
.db    0xCD,0xDE
.db    0xDD,0xCF
.db    0xC4,0xB2
.db    0xB5,0xB9
.db    0xB6,0xB1
.db    0x9D,0x91
.db    0x8E,0x8D
.db    0x95,0x91
.db    0x86,0x88
.db    0x81,0x7E
.db    0x7F,0x7E
.db    0x7E,0x7C
.db    0x89,0x8F
.db    0x84,0x7C
.db    0x81,0x92
.db    0x93,0x92
.db    0x97,0x93
.db    0x96,0x9B
.db    0x99,0x97
.db    0x8F,0x90
.db    0x95,0x90
.db    0x90,0x89
.db    0x7E,0x79
.db    0x7B,0x7F
.db    0x79,0x71
.db    0x6D,0x6B
.db    0x6A,0x69
.db    0x67,0x67
.db    0x6C,0x71
.db    0x70,0x6F
.db    0x71,0x77
.db    0x7E,0x80
.db    0x85,0x8D
.db    0x8D,0x88
.db    0x8D,0x9B
.db    0xA8,0xA8
.db    0xA1,0x9B
.db    0x93,0x94
.db    0x9B,0x97
.db    0x88,0x7B
.db    0x70,0x61
.db    0x57,0x51
.db    0x4E,0x45
.db    0x3E,0x39
.db    0x2B,0x1E
.db    0x20,0x27
.db    0x27,0x29
.db    0x28,0x20
.db    0x1A,0x20
.db    0x2D,0x31
.db    0x32,0x3C
.db    0x42,0x45
.db    0x50,0x60
.db    0x66,0x6C
.db    0x75,0x81
.db    0x93,0x9D
.db    0xA4,0xAD
.db    0xAE,0xB6
.db    0xC6,0xC8
.db    0xC3,0xC6
.db    0xCB,0xD1
.db    0xCF,0xC5
.db    0xC1,0xBC
.db    0xB6,0xBE
.db    0xBC,0xB4
.db    0xA6,0x98
.db    0x9D,0x9C
.db    0x95,0x9B
.db    0x92,0x88
.db    0x8A,0x87
.db    0x85,0x80
.db    0x81,0x88
.db    0x87,0x85
.db    0x88,0x81
.db    0x7D,0x86
.db    0x8C,0x8F
.db    0x95,0x92
.db    0x8C,0x8B
.db    0x8C,0x93
.db    0x98,0x92
.db    0x90,0x8D
.db    0x85,0x85
.db    0x87,0x83
.db    0x80,0x7F
.db    0x7D,0x7A
.db    0x75,0x6F
.db    0x6F,0x72
.db    0x74,0x74
.db    0x6F,0x6A
.db    0x6A,0x6E
.db    0x74,0x73
.db    0x73,0x74
.db    0x74,0x75
.db    0x75,0x76
.db    0x78,0x7A
.db    0x7E,0x82
.db    0x83,0x7D
.db    0x79,0x7A
.db    0x7E,0x82
.db    0x84,0x7E
.db    0x78,0x71
.db    0x74,0x75
.db    0x73,0x6E
.db    0x70,0x70
.db    0x6B,0x6A
.db    0x6A,0x68
.db    0x66,0x6D
.db    0x6F,0x6A
.db    0x66,0x64
.db    0x67,0x70
.db    0x6A,0x69
.db    0x6D,0x63
.db    0x64,0x6E
.db    0x67,0x67
.db    0x6E,0x6A
.db    0x6E,0x70
.db    0x6A,0x72
.db    0x71,0x72
.db    0x78,0x77
.db    0x78,0x76
.db    0x79,0x7B
.db    0x7E,0x81
.db    0x81,0x81
.db    0x81,0x84
.db    0x86,0x89
.db    0x87,0x88
.db    0x8A,0x8B
.db    0x8B,0x8F
.db    0x8E,0x8F
.db    0x90,0x92
.db    0x92,0x94
.db    0x93,0x92
.db    0x96,0x95
.db    0x95,0x97
.db    0x93,0x95
.db    0x96,0x96
.db    0x96,0x96
.db    0x93,0x93
.db    0x94,0x94
.db    0x92,0x90
.db    0x8F,0x8E
.db    0x8E,0x8F
.db    0x8D,0x8B
.db    0x8A,0x87
.db    0x88,0x88
.db    0x85,0x85
.db    0x84,0x83
.db    0x84,0x82
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7E
.db    0x7C,0x7B
.db    0x7B,0x7B
.db    0x7A,0x7A
.db    0x79,0x78
.db    0x78,0x78
.db    0x79,0x78
.db    0x78,0x77
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x77
.db    0x77,0x78
.db    0x78,0x79
.db    0x78,0x78
.db    0x78,0x78
.db    0x78,0x78
.db    0x77,0x77
.db    0x77,0x77
.db    0x78,0x78
.db    0x77,0x78
.db    0x78,0x78
.db    0x79,0x79
.db    0x78,0x78
.db    0x79,0x7A
.db    0x7A,0x79
.db    0x79,0x79
.db    0x7A,0x7A
.db    0x7A,0x7A
.db    0x79,0x7A
.db    0x7A,0x7B
.db    0x7B,0x7B
.db    0x7A,0x7A
.db    0x7B,0x7B
.db    0x7B,0x7C
.db    0x7B,0x7B
.db    0x7C,0x7C
.db    0x7C,0x7C
.db    0x7C,0x7C
.db    0x7D,0x7D
.db    0x7C,0x7C
.db    0x7C,0x7D
.db    0x7D,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x81,0x82
.db    0x82,0x82
.db    0x82,0x83
.db    0x83,0x84
.db    0x84,0x84
.db    0x84,0x85
.db    0x85,0x85
.db    0x85,0x85
.db    0x85,0x85
.db    0x85,0x86
.db    0x85,0x85
.db    0x85,0x85
.db    0x85,0x84
.db    0x84,0x85
.db    0x85,0x85
.db    0x85,0x84
.db    0x84,0x84
.db    0x85,0x85
.db    0x85,0x84
.db    0x84,0x84
.db    0x84,0x84
.db    0x84,0x84
.db    0x84,0x84
.db    0x84,0x84
.db    0x83,0x83
.db    0x83,0x83
.db    0x83,0x83
.db    0x83,0x83
.db    0x82,0x82
.db    0x82,0x82
.db    0x82,0x81
.db    0x81,0x81
.db    0x81,0x81
.db    0x81,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7D
.db    0x7D,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7D,0x7E
.db    0x7D,0x7D
.db    0x7E,0x7D
.db    0x7D,0x7D
.db    0x7D,0x7D
.db    0x7D,0x7D
.db    0x7D,0x7C
.db    0x7C,0x7D
.db    0x7D,0x7D
.db    0x7D,0x7D
.db    0x7D,0x7D
.db    0x7D,0x7D
.db    0x7D,0x7D
.db    0x7D,0x7D
.db    0x7E,0x7D
.db    0x7E,0x7E
.db    0x7D,0x7E
.db    0x7D,0x7E
.db    0x7D,0x7C
.db    0x80,0x7A
.db    0x7D,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7E,0x7E
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7E
.db    0x80,0x81
.db    0x7D,0x7F
.db    0x82,0x7E
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7E
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x81,0x80
.db    0x7E,0x7F
.db    0x7F,0x81
.db    0x7E,0x7F
.db    0x80,0x7F
.db    0x7F,0x7E
.db    0x80,0x80
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7E,0x7F
.db    0x81,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7E,0x7F
.db    0x81,0x7F
.db    0x7F,0x7E
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x7E,0x7F
.db    0x7E,0x7F
.db    0x7E,0x82
.db    0x81,0x7D
.db    0x7F,0x7E
.db    0x7F,0x80
.db    0x7E,0x7F
.db    0x7F,0x80
.db    0x7F,0x7D
.db    0x7E,0x7E
.db    0x7D,0x80
.db    0x81,0x7E
.db    0x7F,0x7D
.db    0x80,0x7E
.db    0x81,0x7E
.db    0x82,0x7D
.db    0x81,0x80
.db    0x80,0x7E
.db    0x7E,0x80
.db    0x82,0x84
.db    0x80,0x79
.db    0x7B,0x80
.db    0x7F,0x84
.db    0x81,0x83
.db    0x82,0x7F
.db    0x7E,0x7D
.db    0x7D,0x83
.db    0x88,0x7E
.db    0x85,0x85
.db    0x7D,0x62
.db    0x76,0xB3
.db    0x90,0x84
.db    0x83,0x77
.db    0x76,0x71
.db    0x6B,0x81
.db    0x7D,0x79
.db    0x76,0x6F
.db    0x71,0x70
.db    0x79,0x89
.db    0x7B,0x72
.db    0x76,0x72
.db    0x75,0x75
.db    0x7F,0x81
.db    0x7B,0x84
.db    0x7E,0x78
.db    0x84,0x75
.db    0x7E,0x90
.db    0x80,0x87
.db    0x8A,0x73
.db    0x88,0x84
.db    0x7D,0x87
.db    0x84,0x81
.db    0x8C,0x7A
.db    0x79,0x7E
.db    0x75,0x85
.db    0x7D,0x7C
.db    0x7B,0x80
.db    0x7B,0x7A
.db    0x82,0x74
.db    0x7C,0x7A
.db    0x7E,0x7B
.db    0x85,0x76
.db    0x79,0x77
.db    0x7E,0x81
.db    0x84,0x77
.db    0x88,0x8B
.db    0x72,0x84
.db    0x74,0x81
.db    0x8B,0x7B
.db    0x83,0x84
.db    0x80,0x72
.db    0x8E,0x81
.db    0x8B,0x85
.db    0x86,0x76
.db    0x8B,0x81
.db    0x83,0x7F
.db    0x7A,0x84
.db    0x84,0x81
.db    0x7F,0x8E
.db    0x73,0x7F
.db    0x85,0x88
.db    0x87,0x98
.db    0x6D,0x8C
.db    0x7C,0x7C
.db    0x88,0x7E
.db    0x6F,0x7A
.db    0x83,0x67
.db    0x9C,0x76
.db    0x7B,0x8F
.db    0x7F,0x73
.db    0x8E,0x7B
.db    0x76,0x89
.db    0x7D,0x8A
.db    0x87,0x70
.db    0x82,0x94
.db    0x6F,0x7C
.db    0x8B,0x7D
.db    0x7F,0xA1
.db    0x7C,0x9E
.db    0x6D,0x7A
.db    0x85,0xB2
.db    0x77,0xA5
.db    0x7A,0x7F
.db    0x71,0x68
.db    0x61,0x80
.db    0x5B,0x73
.db    0x6C,0x75
.db    0x5D,0x58
.db    0x9E,0x72
.db    0xBA,0x8C
.db    0x94,0xAE
.db    0x6B,0x8C
.db    0x79,0x88
.db    0x9F,0x88
.db    0x90,0x62
.db    0x6A,0x5B
.db    0x45,0x84
.db    0x72,0x8A
.db    0x88,0x52
.db    0x75,0x4C
.db    0x87,0x62
.db    0xA4,0x71
.db    0x7A,0x85
.db    0x58,0x70
.db    0x68,0x60
.db    0x7D,0x7F
.db    0x78,0x80
.db    0x77,0x61
.db    0x7D,0x79
.db    0x80,0x89
.db    0x8B,0x68
.db    0x95,0x5B
.db    0x82,0x77
.db    0x8C,0x75
.db    0x86,0x86
.db    0x71,0xA7
.db    0x55,0x8E
.db    0x70,0x7C
.db    0x86,0x89
.db    0x78,0x82
.db    0x73,0x70
.db    0x74,0x79
.db    0x67,0x7C
.db    0x7A,0x62
.db    0x9B,0x60
.db    0x87,0x83
.db    0x67,0x9F
.db    0x7F,0xA0
.db    0x83,0x98
.db    0x6C,0x89
.db    0x8B,0x81
.db    0x97,0x9A
.db    0x76,0x94
.db    0x87,0x71
.db    0xA7,0x67
.db    0x9D,0x74
.db    0x8C,0x71
.db    0x86,0x73
.db    0x7E,0x92
.db    0x79,0x9A
.db    0x84,0x69
.db    0x87,0x79
.db    0x75,0x9F
.db    0x85,0x7E
.db    0x93,0x70
.db    0x71,0x85
.db    0x7E,0x71
.db    0x96,0x78
.db    0x73,0x91
.db    0x6D,0x71
.db    0x8E,0x7E
.db    0x8E,0x9E
.db    0x7E,0x8C
.db    0x67,0x8A
.db    0x65,0x93
.db    0x89,0x83
.db    0x8B,0x6B
.db    0x84,0x69
.db    0x7E,0x8A
.db    0x6E,0x96
.db    0x84,0x72
.db    0x8C,0x73
.db    0x6F,0x8C
.db    0x74,0x96
.db    0x7A,0x96
.db    0x76,0x75
.db    0x8F,0x65
.db    0x9C,0x72
.db    0x88,0x84
.db    0x71,0x86
.db    0x72,0x71
.db    0x89,0x7A
.db    0x7C,0x95
.db    0x79,0x71
.db    0x88,0x70
.db    0x73,0x97
.db    0x7C,0x8D
.db    0x81,0x8B
.db    0x59,0x8C
.db    0x82,0x62
.db    0xAF,0x62
.db    0x86,0x7B
.db    0x73,0x70
.db    0x81,0x89
.db    0x83,0x8A
.db    0x8B,0x63
.db    0x7B,0x77
.db    0x68,0x96
.db    0x80,0x95
.db    0x7D,0x78
.db    0x78,0x6E
.db    0x83,0x88
.db    0x89,0x93
.db    0x7B,0x82
.db    0x6C,0x7E
.db    0x7A,0x76
.db    0x98,0x75
.db    0x8C,0x71
.db    0x79,0x61
.db    0x83,0x92
.db    0x79,0xA0
.db    0x8A,0x68
.db    0x79,0x73
.db    0x78,0x83
.db    0x94,0x83
.db    0x7D,0x8B
.db    0x5D,0x84
.db    0x81,0x72
.db    0x94,0x98
.db    0x73,0x80
.db    0x79,0x8A
.db    0x7F,0x74
.db    0x95,0x70
.db    0x95,0x7A
.db    0x79,0x83
.db    0x6F,0x7E
.db    0x85,0x86
.db    0x81,0x90
.db    0x81,0x6E
.db    0x7A,0x77
.db    0x69,0x94
.db    0x8A,0x76
.db    0x87,0x78
.db    0x6D,0x8A
.db    0x55,0x9E
.db    0x7E,0x66
.db    0xA2,0x50
.db    0x7A,0x86
.db    0x94,0x7B
.db    0x83,0x80
.db    0x88,0x92
.db    0x7B,0x79
.db    0x9A,0x71
.db    0x7E,0x8D
.db    0x80,0x71
.db    0x80,0x85
.db    0x73,0x6A
.db    0x89,0x78
.db    0x8E,0x80
.db    0x91,0x80
.db    0x7A,0x72
.db    0x79,0x9C
.db    0x79,0x86
.db    0x8F,0x60
.db    0x96,0x71
.db    0x87,0x73
.db    0x88,0x85
.db    0x82,0x80
.db    0x70,0x82
.db    0x75,0x62
.db    0x96,0x7D
.db    0x88,0x8E
.db    0x6C,0x80
.db    0x3D,0x89
.db    0x84,0xAC
.db    0x84,0x7F
.db    0x94,0x62
.db    0x5E,0x7B
.db    0x85,0x8F
.db    0x93,0x88
.db    0x70,0x6E
.db    0x63,0x83
.db    0x84,0xA2
.db    0x95,0x95
.db    0x78,0x71
.db    0x6D,0x79
.db    0x85,0xA3
.db    0x7C,0x7B
.db    0x68,0x68
.db    0x7D,0x80
.db    0x7E,0xB6
.db    0x75,0x78
.db    0x80,0x6F
.db    0x84,0x85
.db    0x9C,0x7F
.db    0x80,0x78
.db    0x67,0x8C
.db    0x58,0x9F
.db    0x76,0x6B
.db    0x8C,0x6C
.db    0x84,0x61
.db    0xA4,0x86
.db    0x85,0x7E
.db    0x75,0x87
.db    0x7D,0x8C
.db    0x8F,0x71
.db    0x73,0x81
.db    0x84,0x62
.db    0x8B,0x7D
.db    0x88,0x7A
.db    0x77,0x85
.db    0x6B,0x92
.db    0x85,0x84
.db    0x6E,0x8D
.db    0x7F,0x7D
.db    0x80,0x7F
.db    0x84,0x6C
.db    0x97,0x85
.db    0x76,0x86
.db    0x75,0x88
.db    0x61,0x83
.db    0x91,0x71
.db    0x8C,0x83
.db    0x7F,0x63
.db    0x88,0x80
.db    0x64,0x92
.db    0x65,0x9B
.db    0x68,0x77
.db    0x88,0x5D
.db    0x8E,0x84
.db    0x90,0x7A
.db    0x6E,0x88
.db    0x7B,0x82
.db    0x76,0x97
.db    0x70,0x8D
.db    0x70,0x7E
.db    0x7F,0x7C
.db    0x9B,0x73
.db    0x90,0x6F
.db    0x84,0x74
.db    0x6B,0x88
.db    0x84,0x6E
.db    0x7D,0x87
.db    0x7F,0x6E
.db    0x78,0x83
.db    0x88,0x85
.db    0x88,0x8D
.db    0x69,0x7E
.db    0x82,0x8E
.db    0x7E,0x6F
.db    0x8C,0x81
.db    0x7E,0x75
.db    0x83,0x75
.db    0x81,0x86
.db    0x77,0x84
.db    0x84,0x79
.db    0x90,0x7A
.db    0x7B,0x84
.db    0x69,0x78
.db    0x9E,0x6F
.db    0x83,0x87
.db    0x69,0x98
.db    0x5E,0x8D
.db    0x87,0x85
.db    0x7D,0x76
.db    0x81,0x6D
.db    0x83,0x74
.db    0x8D,0x8D
.db    0x76,0x8F
.db    0x76,0x5E
.db    0x98,0x76
.db    0xA5,0x7D
.db    0x62,0x9F
.db    0x78,0x81
.db    0x7A,0x83
.db    0x83,0x83
.db    0x7F,0x7D
.db    0x83,0x5E
.db    0x88,0x86
.db    0x86,0x77
.db    0x81,0x7D
.db    0x82,0x80
.db    0x7A,0x7F
.db    0x8E,0x75
.db    0x96,0x76
.db    0x85,0x8C
.db    0x66,0x7F
.db    0x7F,0x8D
.db    0x81,0x7D
.db    0x83,0x66
.db    0x76,0x7B
.db    0x84,0x82
.db    0x80,0x81
.db    0x7F,0x53
.db    0x7D,0x7F
.db    0x84,0x87
.db    0x92,0x81
.db    0x74,0x7E
.db    0x7F,0x7E
.db    0x91,0x84
.db    0x83,0x98
.db    0x5D,0x85
.db    0x8F,0x71
.db    0x86,0x85
.db    0x77,0x87
.db    0x72,0x89
.db    0x74,0x95
.db    0x84,0x88
.db    0x6E,0x63
.db    0x88,0x6B
.db    0x82,0x86
.db    0x83,0x73
.db    0x78,0x7A
.db    0x83,0x96
.db    0x7B,0xA5
.db    0x71,0x7C
.db    0x8E,0x78
.db    0x77,0x84
.db    0x94,0x72
.db    0x7B,0x84
.db    0x73,0x7F
.db    0x79,0x84
.db    0x95,0x7E
.db    0x80,0x6E
.db    0x6F,0x7C
.db    0x88,0x90
.db    0x7D,0x90
.db    0x70,0x6F
.db    0x7D,0x7A
.db    0x91,0x7E
.db    0x9A,0x83
.db    0x7C,0x7B
.db    0x62,0x89
.db    0x95,0x81
.db    0x7C,0x84
.db    0x75,0x7F
.db    0x7E,0x6D
.db    0x6E,0x7C
.db    0x8A,0x65
.db    0x89,0x7A
.db    0x7B,0x81
.db    0x74,0x93
.db    0x93,0x86
.db    0x7A,0x8F
.db    0x81,0x70
.db    0x83,0x6D
.db    0x73,0x89
.db    0x7F,0x77
.db    0x73,0x79
.db    0x80,0x71
.db    0x7E,0x81
.db    0x83,0x82
.db    0x7D,0x86
.db    0x77,0x82
.db    0x6A,0x6F
.db    0x85,0x87
.db    0x98,0x7C
.db    0x76,0x82
.db    0x70,0x75
.db    0x6B,0x8E
.db    0x8F,0x88
.db    0x89,0x6C
.db    0x6A,0x69
.db    0x7F,0x8C
.db    0x91,0x96
.db    0x82,0x7B
.db    0x61,0x7C
.db    0x88,0x76
.db    0x86,0x94
.db    0x86,0x7F
.db    0x72,0x6A
.db    0x75,0x7D
.db    0x85,0x83
.db    0x82,0x77
.db    0x7A,0x84
.db    0x76,0x77
.db    0x89,0x7E
.db    0x97,0x88
.db    0x84,0x84
.db    0x74,0x72
.db    0x81,0x87
.db    0x84,0x8F
.db    0x87,0x7E
.db    0x80,0x73
.db    0x7B,0x7D
.db    0x75,0x8B
.db    0x84,0x7D
.db    0x7A,0x77
.db    0x76,0x85
.db    0x8E,0x84
.db    0x93,0x88
.db    0x7F,0x87
.db    0x76,0x82
.db    0x7E,0x7E
.db    0x96,0x92
.db    0x87,0x77
.db    0x74,0x71
.db    0x7E,0x92
.db    0x8A,0x82
.db    0x83,0x7F
.db    0x77,0x6E
.db    0x73,0x79
.db    0x92,0x7E
.db    0x7A,0x7E
.db    0x74,0x74
.db    0x84,0x84
.db    0x80,0x8D
.db    0x84,0x7F
.db    0x93,0x6F
.db    0x7E,0x8B
.db    0x6E,0x80
.db    0x88,0x87
.db    0x7D,0x87
.db    0x78,0x84
.db    0x85,0x7D
.db    0x95,0x84
.db    0x74,0x7E
.db    0x80,0x6A
.db    0x6F,0x87
.db    0x76,0x72
.db    0x79,0x7C
.db    0x7B,0x72
.db    0x80,0x82
.db    0x78,0x82
.db    0x7B,0x88
.db    0x7E,0x7F
.db    0x8E,0x84
.db    0x7D,0x82
.db    0x7F,0x7A
.db    0x77,0x89
.db    0x7D,0x81
.db    0x83,0x6E
.db    0x7C,0x78
.db    0x78,0x8E
.db    0x78,0x7B
.db    0x85,0x83
.db    0x7F,0x83
.db    0x7D,0x7F
.db    0x89,0x82
.db    0x82,0x7F
.db    0x70,0x78
.db    0x88,0x7C
.db    0x7C,0x7A
.db    0x79,0x82
.db    0x84,0x7E
.db    0x83,0x77
.db    0x7B,0x80
.db    0x7A,0x73
.db    0x7F,0x80
.db    0x83,0x88
.db    0x73,0x76
.db    0x79,0x7B
.db    0x8C,0x94
.db    0x74,0x82
.db    0x7A,0x77
.db    0x89,0x85
.db    0x79,0x87
.db    0x8C,0x81
.db    0x8C,0x7F
.db    0x7B,0x80
.db    0x73,0x84
.db    0x7E,0x77
.db    0x80,0x85
.db    0x7C,0x73
.db    0x84,0x75
.db    0x7D,0x88
.db    0x85,0x7D
.db    0x81,0x80
.db    0x76,0x7F
.db    0x83,0x82
.db    0x88,0x89
.db    0x7C,0x83
.db    0x81,0x77
.db    0x8C,0x85
.db    0x78,0x8B
.db    0x80,0x82
.db    0x95,0x74
.db    0x76,0x89
.db    0x7B,0x77
.db    0x8C,0x80
.db    0x7A,0x8D
.db    0x78,0x78
.db    0x7D,0x75
.db    0x86,0x89
.db    0x72,0x84
.db    0x7F,0x69
.db    0x86,0x8A
.db    0x7D,0x80
.db    0x87,0x87
.db    0x84,0x84
.db    0x76,0x7A
.db    0x7E,0x7B
.db    0x8B,0x80
.db    0x80,0x7F
.db    0x82,0x81
.db    0x78,0x7B
.db    0x88,0x87
.db    0x7E,0x82
.db    0x7A,0x76
.db    0x81,0x80
.db    0x7F,0x7E
.db    0x87,0x81
.db    0x80,0x79
.db    0x7B,0x7B
.db    0x7F,0x83
.db    0x88,0x7B
.db    0x81,0x81
.db    0x78,0x85
.db    0x7E,0x81
.db    0x7D,0x86
.db    0x85,0x82
.db    0x7B,0x7B
.db    0x7F,0x7E
.db    0x83,0x81
.db    0x83,0x78
.db    0x78,0x7E
.db    0x7D,0x7C
.db    0x78,0x80
.db    0x80,0x81
.db    0x83,0x7F
.db    0x7D,0x78
.db    0x7C,0x86
.db    0x7E,0x81
.db    0x85,0x82
.db    0x7A,0x78
.db    0x82,0x7E
.db    0x7C,0x89
.db    0x88,0x7F
.db    0x7E,0x7E
.db    0x73,0x7C
.db    0x84,0x80
.db    0x7C,0x7E
.db    0x7C,0x7F
.db    0x7D,0x7C
.db    0x7E,0x7D
.db    0x81,0x8A
.db    0x80,0x83
.db    0x85,0x80
.db    0x7D,0x7D
.db    0x7C,0x86
.db    0x84,0x81
.db    0x84,0x7D
.db    0x76,0x76
.db    0x7B,0x7B
.db    0x7E,0x86
.db    0x86,0x7E
.db    0x73,0x79
.db    0x7D,0x7D
.db    0x86,0x85
.db    0x83,0x80
.db    0x7D,0x7F
.db    0x7E,0x7C
.db    0x80,0x85
.db    0x85,0x7C
.db    0x82,0x7C
.db    0x7B,0x7F
.db    0x7E,0x7D
.db    0x7D,0x7E
.db    0x7D,0x7D
.db    0x7D,0x7E
.db    0x7E,0x7F
.db    0x80,0x83
.db    0x82,0x84
.db    0x82,0x80
.db    0x7E,0x7D
.db    0x7D,0x81
.db    0x86,0x81
.db    0x7D,0x7A
.db    0x7A,0x7B
.db    0x81,0x81
.db    0x80,0x7F
.db    0x7E,0x7D
.db    0x7F,0x81
.db    0x80,0x82
.db    0x7F,0x7E
.db    0x7D,0x80
.db    0x80,0x7F
.db    0x83,0x80
.db    0x7E,0x7C
.db    0x7C,0x7D
.db    0x80,0x84
.db    0x84,0x85
.db    0x7D,0x7B
.db    0x7B,0x7C
.db    0x80,0x82
.db    0x84,0x7F
.db    0x7D,0x7B
.db    0x7A,0x7B
.db    0x7F,0x84
.db    0x85,0x82
.db    0x7E,0x7F
.db    0x7D,0x7D
.db    0x82,0x83
.db    0x83,0x84
.db    0x7F,0x7C
.db    0x7C,0x7B
.db    0x7E,0x83
.db    0x83,0x83
.db    0x81,0x7F
.db    0x7C,0x7B
.db    0x7E,0x83
.db    0x83,0x83
.db    0x81,0x7F
.db    0x7B,0x7A
.db    0x7C,0x7F
.db    0x80,0x81
.db    0x82,0x7F
.db    0x7C,0x7C
.db    0x7E,0x7F
.db    0x7F,0x80
.db    0x81,0x80
.db    0x7E,0x7F
.db    0x80,0x7D
.db    0x7E,0x80
.db    0x80,0x7F
.db    0x81,0x81
.db    0x80,0x7D
.db    0x7C,0x7E
.db    0x80,0x80
.db    0x81,0x83
.db    0x80,0x7D
.db    0x7D,0x7F
.db    0x7F,0x7E
.db    0x80,0x81
.db    0x81,0x7E
.db    0x7F,0x7F
.db    0x7D,0x7D
.db    0x7F,0x82
.db    0x81,0x80
.db    0x80,0x7E
.db    0x7D,0x7C
.db    0x7F,0x80
.db    0x80,0x82
.db    0x83,0x80
.db    0x7D,0x7D
.db    0x7E,0x7E
.db    0x81,0x81
.db    0x81,0x7F
.db    0x7E,0x7E
.db    0x7D,0x7C
.db    0x80,0x82
.db    0x81,0x80
.db    0x81,0x7E
.db    0x7D,0x7E
.db    0x7F,0x80
.db    0x81,0x7F
.db    0x80,0x7F
.db    0x7E,0x7F
.db    0x81,0x81
.db    0x80,0x80
.db    0x81,0x80
.db    0x7E,0x7F
.db    0x80,0x80
.db    0x7E,0x7E
.db    0x7F,0x7F
.db    0x7E,0x7F
.db    0x80,0x7F
.db    0x7E,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7D
.db    0x7E,0x80
.db    0x80,0x80
.db    0x80,0x82
.db    0x7F,0x7E
.db    0x7E,0x7F
.db    0x80,0x81
.db    0x82,0x81
.db    0x80,0x7D
.db    0x7D,0x7E
.db    0x7F,0x80
.db    0x82,0x81
.db    0x7E,0x7D
.db    0x7D,0x7D
.db    0x7F,0x80
.db    0x80,0x81
.db    0x7F,0x7E
.db    0x7F,0x7F
.db    0x80,0x81
.db    0x81,0x81
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7E
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x7F,0x80
.db    0x80,0x80
.db    0x81,0x80
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x81,0x80
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x7F,0x7E
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x7F,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x7F
.db    0x7F,0x7F
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x7F,0x80
.db    0x7F,0x7F
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x80
.db    0x80,0x00
 
; *** Konstanten-STRING-Liste ***
;
 
M_CONST_STRING_0:
 .db    3, "DIR"
 
M_CONST_STRING_1:
 .db    5, "POWER"
 
M_CONST_STRING_2:
 .db    4, "COPY "
 
M_CONST_STRING_3:
 .db    3, "ERA"
 
M_CONST_STRING_4:
 .db    5, "TYPEX"
 
M_CONST_STRING_5:
 .db    4, "EXIT "
 
M_CONST_STRING_6:
 .db    5, "TURBO"
 
M_CONST_STRING_7:
 .db    5, "TURBO"
 
M_CONST_STRING_8:
 .db    3, "x03"
 
M_CONST_STRING_9:
 .db    3, "x07"
 
M_CONST_STRING_10:
 .db    3, "x09"
 
M_CONST_STRING_11:
 .db    3, "x02"
 
M_CONST_STRING_12:
 .db    0, " "
 
M_CONST_STRING_13:
 .db    1, "u"
 
M_CONST_STRING_14:
 .db    3, "x04"
 
M_CONST_STRING_15:
 .db    1, "r"
 
M_CONST_STRING_16:
 .db    3, "x08"
 
M_CONST_STRING_17:
 .db    1, "v"
 
M_CONST_STRING_18:
 .db    1, "s"
 
M_CONST_STRING_19:
 .db    1, "y"
 
; *** ISR-Liste ***
;
; Nummer=2    ORG=INT0addr     ISR=EI_INT0       Bemerkung=External Interrupt Request 0
; Nummer=3    ORG=INT1addr     ISR=EI_INT1       Bemerkung=External Interrupt Request 1
; Nummer=4    ORG=INT2addr     ISR=EI_INT2       Bemerkung=External Interrupt Request 1
; Nummer=5    ORG=PCI0addr     ISR=PCINT0        Bemerkung=Pin Change Interrupt Request 0
; Nummer=6    ORG=PCI1addr     ISR=PCINT1        Bemerkung=Pin Change Interrupt Request 1
; Nummer=7    ORG=PCI2addr     ISR=PCINT2        Bemerkung=Pin Change Interrupt Request 2
; Nummer=8    ORG=PCI3addr     ISR=PCINT3        Bemerkung=Pin Change Interrupt Request 3
; Nummer=9    ORG=WDTaddr      ISR=WDT           Bemerkung=Watchdog Time-out Interrupt
; Nummer=10   ORG=OC2Aaddr     ISR=TIMER2_COMPA  Bemerkung=Timer/Counter2 Compare Match A
; Nummer=11   ORG=OC2Baddr     ISR=TIMER2_COMPB  Bemerkung=Timer/Counter2 Compare Match B
; Nummer=12   ORG=OVF2addr     ISR=TIMER2_OVF    Bemerkung=Timer/Counter2 Overflow
; Nummer=13   ORG=ICP1addr     ISR=TIMER1_CAPT   Bemerkung=Timer/Counter1 Capture Event
; Nummer=14   ORG=OC1Aaddr     ISR=TIMER1_COMPA  Bemerkung=Timer/Counter1 Compare Match A
; Nummer=15   ORG=OC1Baddr     ISR=TIMER1_COMPB  Bemerkung=Timer/Counter1 Compare Match B
; Nummer=16   ORG=OVF1addr     ISR=TIMER1_OVF    Bemerkung=Timer/Counter1 Overflow
; Nummer=17   ORG=OC0Aaddr     ISR=TIMER0_COMPA  Bemerkung=Timer/Counter0 Compare Match A
; Nummer=18   ORG=OC0Baddr     ISR=TIMER0_COMPB  Bemerkung=Timer/Counter0 Compare Match B
; Nummer=19   ORG=OVF0addr     ISR=TIMER0_OVF    Bemerkung=Timer/Counter0 Overflow
; Nummer=20   ORG=SPIaddr      ISR=SPI_STC       Bemerkung=Serial Transfer Complete
; Nummer=21   ORG=URXC0addr    ISR=USART0_RXC    Bemerkung=USART0, Rx Complete
; Nummer=22   ORG=UDRE0addr    ISR=USART0_UDRE   Bemerkung=USART0 Data Register Empty
; Nummer=23   ORG=UTXC0addr    ISR=USART0_TXC    Bemerkung=USART0, Tx Complete
; Nummer=24   ORG=ACIaddr      ISR=ANA_COMP      Bemerkung=Analog Comparator
; Nummer=25   ORG=ADCCaddr     ISR=ADC_CC        Bemerkung=ADC Conversion Complete
; Nummer=26   ORG=ERDYaddr     ISR=EE_RDY        Bemerkung=EEPROM Ready
; Nummer=27   ORG=TWIaddr      ISR=TWI           Bemerkung=Two-wire Serial Interface
; Nummer=28   ORG=SPMRaddr     ISR=SPM_RDY       Bemerkung=Store Program Memory Ready
; Nummer=29   ORG=URXC1addr    ISR=USART1_RXC    Bemerkung=USART0, Rx Complete
; Nummer=30   ORG=UDRE1addr    ISR=USART1_UDRE   Bemerkung=USART0 Data Register Empty
; Nummer=31   ORG=UTXC1addr    ISR=USART1_TXC    Bemerkung=USART0, Tx Complete
; Nummer=32   ORG=ICP3addr     ISR=TIM3_CAPT     Bemerkung=Timer/Counter3 Capture Event
; Nummer=33   ORG=OC3Aaddr     ISR=TIM3_COMPA    Bemerkung=Timer/Counter3 Compare Match A
; Nummer=34   ORG=OC3Baddr     ISR=TIM3_COMPB    Bemerkung=Timer/Counter3 Compare Match B
; Nummer=35   ORG=OVF3addr     ISR=TIM3_OVF      Bemerkung=Timer/Counter3 Overflow
 
