; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: CPD8_CORE.PAS
 
.nolist
.INCLUDE "m32def.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        TAKTFREQUENZ  =  0x399A ; WORD
.equ        UBRR_VAL  =  0x07 ; BYTE
.equ        IORQ_LED_EIN  =  0x01 ; BYTE
.equ        IORQ_LED_AUS  =  0x02 ; BYTE
.equ        IORQ_CONOUT  =  0x03 ; BYTE
.equ        IORQ_CONIN  =  0x04 ; BYTE
.equ        IORQ_CONST  =  0x05 ; BYTE
.equ        IORQ_START_PROG  =  0x06 ; BYTE
.equ        IORQ_RAM2ARR  =  0x07 ; BYTE
.equ        IORQ_ARR2RAM  =  0x08 ; BYTE
.equ        IORQ_STD2UC  =  0x09 ; BYTE
.equ        IORQ_RD_PC2ARR  =  0x0A ; BYTE
.equ        IORQ_BDOS2RAM  =  0x0B ; BYTE
.equ        IORQ_CCP2RAM  =  0x0C ; BYTE
.equ        IORQ_WR_ARR2PC  =  0x0E ; BYTE
.equ        IORQ_DISK2RAM  =  0x0F ; BYTE
.equ        IORQ_LIST  =  0x10 ; BYTE
.equ        IORQ_TIME  =  0x11 ; BYTE
.equ        IORQ_WR_ARR2I2C  =  0x12 ; BYTE
.equ        IORQ_RD_I2C2ARR  =  0x13 ; BYTE
.equ        IORQ_RD_ITP32ARR  =  0x14 ; BYTE
.equ        IORQ_WR_ARR2ITP3  =  0x15 ; BYTE
.equ        NUL  =  0x00 ; BYTE
.equ        XON  =  0x11 ; BYTE
.equ        XOFF  =  0x13 ; BYTE
.equ        UART_WHO_AM_I  =  0x01 ; BYTE
.equ        UART_ERROR_CODE  =  0x02 ; BYTE
.equ        UART_CONOUT  =  0x03 ; BYTE
.equ        UART_CONST  =  0x04 ; BYTE
.equ        UART_CONIN  =  0x05 ; BYTE
.equ        UART_READ  =  0x06 ; BYTE
.equ        UART_WRITE  =  0x07 ; BYTE
.equ        UART_STD  =  0x08 ; BYTE
.equ        LAENGE_CPD8_ARRAY  =  0x0AFF ; WORD
.equ        LAENGE_BDOS_ARRAY  =  0x0DFF ; WORD
.equ        LAENGE_CCP_ARRAY  =  0x07FF ; WORD
.equ        LAENGE_DISK_ARRAY  =  0x088F ; WORD
.equ        WAITKON  =  0x000E ; WORD
.equ        WAITKON2  =  0x0276 ; WORD
.equ        ADR_AT24C512  =  0x54 ; BYTE
.equ        ITP3_WHO_ARE_YOU  =  0x01 ; BYTE
.equ        ITP3_ERROR_CODE  =  0x02 ; BYTE
.equ        ITP3_CONOUT  =  0x03 ; BYTE
.equ        ITP3_CONST  =  0x04 ; BYTE
.equ        ITP3_CONIN  =  0x05 ; BYTE
.equ        ITP3_STD  =  0x06 ; BYTE
.equ        ITP3_RD_SEC  =  0x07 ; BYTE
.equ        ITP3_WR_SEC  =  0x08 ; BYTE
.equ        DEV_DS0  =  0x00 ; BYTE
.equ        DEV_DS1  =  0x01 ; BYTE
.equ        DEV_DS2  =  0x02 ; BYTE
.equ        DEV_DS3  =  0x03 ; BYTE
 
; *** Variablentabelle ***
 
.dseg
 
DBG_ANFANG_VAR_TABELLE:
 
ARRAY_POS:   ; Word
.byte     2
CONSOLEIN:   ; Byte
.byte     1
CONSOLEIN_GELESEN:   ; Boolean
.byte     1
CONSOLEOUT:   ; Byte
.byte     1
STEUER_STRING:   ; String(50)
.byte     1     ; STRING-Laenge
.byte     50
ANZEIGE_STRING:   ; String(80)
.byte     1     ; STRING-Laenge
.byte     80
SEKTOR_PUFFER_ZEIGER:   ; Word
.byte     2
SECTOR:   ; Byte
.byte     1
TRACK_L:   ; Byte
.byte     1
TRACK_H:   ; Byte
.byte     1
DISKNO:   ; Byte
.byte     1
DATUM_GESETZT:   ; Boolean
.byte     1
SERIAL_DEVICE_CONNECTED:   ; Byte
.byte     1
BYTE_STRING:   ; String(2)
.byte     1     ; STRING-Laenge
.byte     2
WORD_STRING:   ; String(4)
.byte     1     ; STRING-Laenge
.byte     4
DWORD_STRING:   ; String(8)
.byte     1     ; STRING-Laenge
.byte     8
SER0_ZEICHEN:   ; Byte
.byte     1
SER0_STRING:   ; String(40)
.byte     1     ; STRING-Laenge
.byte     40
SER0_WAIT_BEFORE_SENDING:   ; Boolean
.byte     1
XON_AKTIV:   ; Boolean
.byte     1
SER0_DETECTED:   ; Boolean
.byte     1
FLASH_ADDRESS:   ; Word
.byte     2
FLASH_A0:   ; Boolean
.byte     1
FLASH_A1:   ; Boolean
.byte     1
DEV_NR:   ; Byte
.byte     1
CONOUT_DEVICE:   ; Byte
.byte     1
CONIN_DEVICE:   ; Byte
.byte     1
LIST_DEVICE:   ; Byte
.byte     1
SOUND_DEVICE:   ; Byte
.byte     1
DRIVE_D_DEVICE:   ; Byte
.byte     1
 
SEKTOR_PUFFER:
.byte     128
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; FUNCTION - Anfang (BYTEPOSTOORMASKE)
BYTEPOSTOORMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_03
        RJMP       M_CASE_02
M_CASE_03:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_02:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_05
        RJMP       M_CASE_04
M_CASE_05:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x02
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_04:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_07
        RJMP       M_CASE_06
M_CASE_07:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x04
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_06:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_09
        RJMP       M_CASE_08
M_CASE_09:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x08
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_08:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_011
        RJMP       M_CASE_010
M_CASE_011:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x10
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_010:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_013
        RJMP       M_CASE_012
M_CASE_013:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x20
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_012:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_015
        RJMP       M_CASE_014
M_CASE_015:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x40
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_014:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_017
        RJMP       M_CASE_016
M_CASE_017:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x80
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
 
; CASE OF ELSE
M_CASE_016:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; ENDCASE;
M_CASE_01:
 
; Ende Byte - FUNCTION (BYTEPOSTOORMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOORMASKE)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOANDMASKE)
BYTEPOSTOANDMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_020
        RJMP       M_CASE_019
M_CASE_020:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_019:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_022
        RJMP       M_CASE_021
M_CASE_022:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFD
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_021:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_024
        RJMP       M_CASE_023
M_CASE_024:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFB
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_023:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_026
        RJMP       M_CASE_025
M_CASE_026:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xF7
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_025:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_028
        RJMP       M_CASE_027
M_CASE_028:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xEF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_027:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_030
        RJMP       M_CASE_029
M_CASE_030:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xDF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_029:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_032
        RJMP       M_CASE_031
M_CASE_032:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xBF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_031:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_034
        RJMP       M_CASE_033
M_CASE_034:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0x7F
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
 
; CASE OF ELSE
M_CASE_033:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; ENDCASE;
M_CASE_018:
 
; Ende Byte - FUNCTION (BYTEPOSTOANDMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOANDMASKE)
        RET
 
; FUNCTION - Anfang (READ_BIT_IN_BYTE)
READ_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (READ_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (READ_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_038
        CLR        R16
        RJMP       M_VERGL_039
M_VERGL_038:
        SER        R16
M_VERGL_039:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_035
        RJMP       M_IF_036
M_IF_035:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0x00
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_037
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_036:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0xFF
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_037:
 
; Ende Byte - FUNCTION (READ_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (READ_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (SET_BIT_IN_BYTE)
SET_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (SET_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (SET_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (CLEAR_BIT_IN_BYTE)
CLEAR_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOANDMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOANDMASKE)
        CALL       BYTEPOSTOANDMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (CLEAR_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (NEGATION_BYTE)
NEGATION_BYTE:
 
; ASM
    COM    R0
 
 
; RESULT Byte-Variable - FUNCTION (NEGATION_BYTE)
        MOV        R1, R0
 
; Ende Byte - FUNCTION (NEGATION_BYTE)
        MOV        R16, R1
 
; FUNCTION - Ende (NEGATION_BYTE)
        RET
 
; PROCEDURE - Anfang (WAIT_MS)
WAIT_MS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (ZEIT)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_040:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_041
        RJMP       M_FTD_042
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_041:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (WAITKON2)
        LDI        R16, LOW(0x0276)
        LDI        R17, HIGH(0x0276)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_043:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_044
        RJMP       M_FTD_045
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_044:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_043
 
; FOR TO DO - Ende
M_FTD_045:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_040
 
; FOR TO DO - Ende
M_FTD_042:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (WAIT_MS)
        RET
 
; PROCEDURE - Anfang (BYTETOSTRING)
BYTETOSTRING:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_049
        CLR        R16
        RJMP       M_VERGL_050
M_VERGL_049:
        SER        R16
M_VERGL_050:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_046
        RJMP       M_IF_047
M_IF_046:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_048
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_047:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_048:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_051
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_051:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_053
        MOV        R16, R17
M_PRG_CONST_STRING_052:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_052
M_PRG_CONST_STRING_053:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_057
        CLR        R16
        RJMP       M_VERGL_058
M_VERGL_057:
        SER        R16
M_VERGL_058:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_054
        RJMP       M_IF_055
M_IF_054:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_056
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_055:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_056:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXLOW)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_059
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_059:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_061
M_PRG_CONST_STRING_060:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_060
M_PRG_CONST_STRING_061:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_062
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_062:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_064
        MOV        R16, R17
M_PRG_CONST_STRING_063:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_063
M_PRG_CONST_STRING_064:
        ST         -Z, R17
 
; PROCEDURE - Ende (BYTETOSTRING)
        RET
 
; FUNCTION - Anfang (STRINGTOBYTE)
STRINGTOBYTE:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (BYTE_STRING)
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_068
        CLR        R16
        RJMP       M_VERGL_069
M_VERGL_068:
        SER        R16
M_VERGL_069:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_065
        RJMP       M_IF_066
M_IF_065:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN - Ende
M_IF_066:
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (BYTE_STRING)
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_073
        CLR        R16
        RJMP       M_VERGL_074
M_VERGL_073:
        SER        R16
M_VERGL_074:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_070
        RJMP       M_IF_071
M_IF_070:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_071:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (STRINGTOBYTE)
        MOV        R0, R3
 
; Ende Byte - FUNCTION (STRINGTOBYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (STRINGTOBYTE)
        RET
 
; PROCEDURE - Anfang (WORDTOSTRING)
WORDTOSTRING:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WERT_WORD)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BYTE_LOW)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WERT_WORD)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BYTE_HIGH)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WORDTOSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (BYTE_HIGH) retten
        MOV        R19, R3
 
; lokalen Parameter (BYTE_HIGH) an Prozedur (BYTETOSTRING)
        MOV        R0, R19
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (WORDTOSTRING)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WORD_STRING)=4
        LDI        R16, 4
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_075
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_075:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_077
M_PRG_CONST_STRING_076:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_076
M_PRG_CONST_STRING_077:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WORD_STRING) - Laenge in R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_079
        MOV        R16, R17
M_PRG_CONST_STRING_078:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_078
M_PRG_CONST_STRING_079:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (WORDTOSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (BYTE_LOW) retten
        MOV        R18, R2
 
; lokalen Parameter (BYTE_LOW) an Prozedur (BYTETOSTRING)
        MOV        R0, R18
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (WORDTOSTRING)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WORD_STRING)=4
        LDI        R16, 4
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_080
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_080:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_082
M_PRG_CONST_STRING_081:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_081
M_PRG_CONST_STRING_082:
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_083
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_083:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_085
M_PRG_CONST_STRING_084:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_084
M_PRG_CONST_STRING_085:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WORD_STRING) - Laenge in R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_087
        MOV        R16, R17
M_PRG_CONST_STRING_086:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_086
M_PRG_CONST_STRING_087:
        ST         -Z, R17
 
; PROCEDURE - Ende (WORDTOSTRING)
        RET
 
; FUNCTION - Anfang (STRINGTOWORD)
STRINGTOWORD:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_088
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_088:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_090
        MOV        R16, R17
M_PRG_CONST_STRING_089:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_089
M_PRG_CONST_STRING_090:
        ST         -Z, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_091
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_091:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_093
M_PRG_CONST_STRING_092:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_092
M_PRG_CONST_STRING_093:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_094
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_094:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_096
        MOV        R16, R17
M_PRG_CONST_STRING_095:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_095
M_PRG_CONST_STRING_096:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STRINGTOWORD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf Funktion (STRINGTOBYTE)
        CALL       STRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STRINGTOWORD)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(S2B)
        MOV        R16, R5
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (S2W)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0100)
        LDI        R18, LOW(0x0100)
        LDI        R19, HIGH(0x0100)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_097
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_097:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_099
        MOV        R16, R17
M_PRG_CONST_STRING_098:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_098
M_PRG_CONST_STRING_099:
        ST         -Z, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0100
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0100:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0102
M_PRG_CONST_STRING_0101:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0101
M_PRG_CONST_STRING_0102:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0103
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0103:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0105
        MOV        R16, R17
M_PRG_CONST_STRING_0104:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0104
M_PRG_CONST_STRING_0105:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STRINGTOWORD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf Funktion (STRINGTOBYTE)
        CALL       STRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STRINGTOWORD)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(S2B)
        MOV        R16, R5
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W2)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (S2W)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (S2W2)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; RESULT Word-Variable - FUNCTION (STRINGTOWORD)
        MOV        R0, R3
        MOV        R1, R4
 
; Ende Word - FUNCTION (STRINGTOWORD)
        MOV        R16, R0
        MOV        R17, R1
 
; FUNCTION - Ende (STRINGTOWORD)
        RET
 
; PROCEDURE - Anfang (DWORDTOSTRING)
DWORDTOSTRING:
 
; Zuweisung Quelle - Ausdruck / DWLow(WERT_DWORD)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WORD_LOW)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / DWHigh(WERT_DWORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WORD_HIGH)
        MOV        R6, R16
        MOV        R7, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (DWORDTOSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (WORD_HIGH) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (WORD_HIGH) an Prozedur (WORDTOSTRING)
        MOV        R0, R22
        MOV        R1, R23
 
; Aufruf PROCEDURE (WORDTOSTRING)
        CALL       WORDTOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (DWORDTOSTRING)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (DWORD_STRING)=8
        LDI        R16, 8
        CLR        R17
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0106
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0106:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0108
M_PRG_CONST_STRING_0107:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0107
M_PRG_CONST_STRING_0108:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (DWORD_STRING) - Laenge in R17
        LDI        ZL, LOW(DWORD_STRING)
        LDI        ZH, HIGH(DWORD_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0110
        MOV        R16, R17
M_PRG_CONST_STRING_0109:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0109
M_PRG_CONST_STRING_0110:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (DWORDTOSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (WORD_LOW) retten
        MOV        R20, R4
        MOV        R21, R5
 
; lokalen Parameter (WORD_LOW) an Prozedur (WORDTOSTRING)
        MOV        R0, R20
        MOV        R1, R21
 
; Aufruf PROCEDURE (WORDTOSTRING)
        CALL       WORDTOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (DWORDTOSTRING)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (DWORD_STRING)=8
        LDI        R16, 8
        CLR        R17
        LDI        ZL, LOW(DWORD_STRING)
        LDI        ZH, HIGH(DWORD_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0111
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0111:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0113
M_PRG_CONST_STRING_0112:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0112
M_PRG_CONST_STRING_0113:
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0114
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0114:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0116
M_PRG_CONST_STRING_0115:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0115
M_PRG_CONST_STRING_0116:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (DWORD_STRING) - Laenge in R17
        LDI        ZL, LOW(DWORD_STRING)
        LDI        ZH, HIGH(DWORD_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0118
        MOV        R16, R17
M_PRG_CONST_STRING_0117:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0117
M_PRG_CONST_STRING_0118:
        ST         -Z, R17
 
; PROCEDURE - Ende (DWORDTOSTRING)
        RET
 
; PROCEDURE - Anfang (INIT_SER0_PORT)
INIT_SER0_PORT:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (UBRRH)
        OUT        UBRRH, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (UBRR_VAL)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR (UBRRL)
        OUT        UBRRL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x18)
        LDI        R16, 0x18
 
; Zuweisung Ziel /  VAR (UCSRB)
        OUT        UCSRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x86)
        LDI        R16, 0x86
 
; Zuweisung Ziel /  VAR (UCSRC)
        OUT        UCSRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SER0_WAIT_BEFORE_SENDING)
        STS        SER0_WAIT_BEFORE_SENDING, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (XON_AKTIV)
        STS        XON_AKTIV, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SER0_DETECTED)
        STS        SER0_DETECTED, R16
 
; PROCEDURE - Ende (INIT_SER0_PORT)
        RET
 
; PROCEDURE - Anfang (RX0_PUFFER_ABFRAGEN)
RX0_PUFFER_ABFRAGEN:
 
; IF THEN - Ausdruck /; BitHigh(RXC)
        IN         R16, UCSRA
        BST        R16, 7
        BRTS       M_VERGL_0122
        CLR        R16
        RJMP       M_VERGL_0123
M_VERGL_0122:
        SER        R16
M_VERGL_0123:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0119
        RJMP       M_IF_0120
M_IF_0119:
 
; Zuweisung Quelle - Ausdruck / Byte-REG UDR
        IN         R16, UDR
 
; Zuweisung Ziel /  VAR (SER0_ZEICHEN)
        STS        SER0_ZEICHEN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0121
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0120:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SER0_ZEICHEN)
        STS        SER0_ZEICHEN, R16
 
; IF_THEN_ELSE - Ende
M_IF_0121:
 
; PROCEDURE - Ende (RX0_PUFFER_ABFRAGEN)
        RET
 
; PROCEDURE - Anfang (RX0_WAIT_BEFORE_SENDING_ABFRAGEN)
RX0_WAIT_BEFORE_SENDING_ABFRAGEN:
 
; Aufruf PROCEDURE (RX0_PUFFER_ABFRAGEN)
        CALL       RX0_PUFFER_ABFRAGEN
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (XON)
        LDI        R18, 0x11
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0127
        CLR        R16
        RJMP       M_VERGL_0128
M_VERGL_0127:
        SER        R16
M_VERGL_0128:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0124
        RJMP       M_IF_0125
M_IF_0124:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SER0_WAIT_BEFORE_SENDING)
        STS        SER0_WAIT_BEFORE_SENDING, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (XON_AKTIV)
        STS        XON_AKTIV, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (SER0_DETECTED)
        STS        SER0_DETECTED, R16
 
; IF_THEN - Ende
M_IF_0125:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (XOFF)
        LDI        R18, 0x13
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0132
        CLR        R16
        RJMP       M_VERGL_0133
M_VERGL_0132:
        SER        R16
M_VERGL_0133:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0129
        RJMP       M_IF_0130
M_IF_0129:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (SER0_WAIT_BEFORE_SENDING)
        STS        SER0_WAIT_BEFORE_SENDING, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (XON_AKTIV)
        STS        XON_AKTIV, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (SER0_DETECTED)
        STS        SER0_DETECTED, R16
 
; IF_THEN - Ende
M_IF_0130:
 
; PROCEDURE - Ende (RX0_WAIT_BEFORE_SENDING_ABFRAGEN)
        RET
 
; PROCEDURE - Anfang (SENDE_ZEICHEN0)
SENDE_ZEICHEN0:
 
; IF THEN - Ausdruck / Byte-VAR (XON_AKTIV)
        LDS        R16, XON_AKTIV
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0134
        RJMP       M_IF_0135
M_IF_0134:
 
; WHILE DO ...
M_WHILE_0137:
 
; WHILE - Ausdruck / Byte-VAR (SER0_WAIT_BEFORE_SENDING)
        LDS        R16, SER0_WAIT_BEFORE_SENDING
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0138
        RJMP       M_WHILE_0139
M_WHILE_0138:
 
; Retten der lokalen Parameter fuer PROCEDURE (SENDE_ZEICHEN0)
        PUSH       R0
 
; Aufruf PROCEDURE (RX0_PUFFER_ABFRAGEN)
        CALL       RX0_PUFFER_ABFRAGEN
 
; Retten der Parameter-Register fuer PROCEDURE (SENDE_ZEICHEN0)
        POP        R0
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (XON)
        LDI        R18, 0x11
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0143
        CLR        R16
        RJMP       M_VERGL_0144
M_VERGL_0143:
        SER        R16
M_VERGL_0144:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0140
        RJMP       M_IF_0141
M_IF_0140:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SER0_WAIT_BEFORE_SENDING)
        STS        SER0_WAIT_BEFORE_SENDING, R16
 
; IF_THEN - Ende
M_IF_0141:
 
; WHILE DO ...
        RJMP       M_WHILE_0137
M_WHILE_0139:
 
; IF_THEN - Ende
M_IF_0135:
 
; WHILE DO ...
M_WHILE_0145:
 
; WHILE - Ausdruck /; BitLow(UDRE)
        IN         R16, UCSRA
        BST        R16, 5
        BRTC       M_VERGL_0148
        CLR        R16
        RJMP       M_VERGL_0149
M_VERGL_0148:
        SER        R16
M_VERGL_0149:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0146
        RJMP       M_WHILE_0147
M_WHILE_0146:
 
; WHILE DO ...
        RJMP       M_WHILE_0145
M_WHILE_0147:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (S_ZEICHEN0)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (UDR)
        OUT        UDR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (SER0_WAIT_BEFORE_SENDING)
        STS        SER0_WAIT_BEFORE_SENDING, R16
 
; PROCEDURE - Ende (SENDE_ZEICHEN0)
        RET
 
; PROCEDURE - Anfang (WRITE_SER0)
WRITE_SER0:
 
; Zuweisung Quelle - Ausdruck / Length(SER0_STRING)
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R1
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0150:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0151
        RJMP       M_FTD_0152
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0151:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (SER0_STRING)
        CLR        R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE_SER0)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (B2) retten
        MOV        R19, R3
 
; lokalen Parameter (B2) an Prozedur (SENDE_ZEICHEN0)
        MOV        R0, R19
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE_SER0)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0150
 
; FOR TO DO - Ende
M_FTD_0152:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (WRITE_SER0)
        RET
 
; PROCEDURE - Anfang (WRITELN_SER0)
WRITELN_SER0:
 
; Aufruf PROCEDURE (WRITE_SER0)
        CALL       WRITE_SER0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x0A
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; PROCEDURE - Ende (WRITELN_SER0)
        RET
 
; PROCEDURE - Anfang (SDA_SET)
SDA_SET:
 
; SetBit(SDA_I2C_A)
        SBI        PORTD, 3
 
; PROCEDURE - Ende (SDA_SET)
        RET
 
; PROCEDURE - Anfang (SCL_SET)
SCL_SET:
 
; SetBit(SCL_I2C_A)
        SBI        PORTD, 2
 
; PROCEDURE - Ende (SCL_SET)
        RET
 
; PROCEDURE - Anfang (SDA_CLEAR)
SDA_CLEAR:
 
; ClearBit(SDA_I2C_A)
        CBI        PORTD, 3
 
; PROCEDURE - Ende (SDA_CLEAR)
        RET
 
; PROCEDURE - Anfang (SCL_CLEAR)
SCL_CLEAR:
 
; ClearBit(SCL_I2C_A)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (SCL_CLEAR)
        RET
 
; PROCEDURE - Anfang (SDA_OUT)
SDA_OUT:
 
; SetBit(SDA_I2C_D)
        SBI        DDRD, 3
 
; PROCEDURE - Ende (SDA_OUT)
        RET
 
; PROCEDURE - Anfang (SDA_IN)
SDA_IN:
 
; ClearBit(SDA_I2C_D)
        CBI        DDRD, 3
 
; PROCEDURE - Ende (SDA_IN)
        RET
 
; PROCEDURE - Anfang (SCL_OUT)
SCL_OUT:
 
; SetBit(SCL_I2C_D)
        SBI        DDRD, 2
 
; PROCEDURE - Ende (SCL_OUT)
        RET
 
; FUNCTION - Anfang (SDA_READ)
SDA_READ:
 
; IF THEN - Ausdruck /; BitHigh(SDA_I2C_E)
        IN         R16, PIND
        BST        R16, 3
        BRTS       M_VERGL_0156
        CLR        R16
        RJMP       M_VERGL_0157
M_VERGL_0156:
        SER        R16
M_VERGL_0157:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0153
        RJMP       M_IF_0154
M_IF_0153:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0155
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0154:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_0155:
 
; RESULT Byte-Variable - FUNCTION (SDA_READ)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (SDA_READ)
        MOV        R16, R0
 
; FUNCTION - Ende (SDA_READ)
        RET
 
; PROCEDURE - Anfang (INIT_I2C)
INIT_I2C:
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Aufruf PROCEDURE (SDA_OUT)
        CALL       SDA_OUT
 
; Aufruf PROCEDURE (SCL_OUT)
        CALL       SCL_OUT
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (FLASH_A0)
        STS        FLASH_A0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (FLASH_A1)
        STS        FLASH_A1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; PROCEDURE - Ende (INIT_I2C)
        RET
 
; FUNCTION - Anfang (DS_SHIFT_IN_NACK)
DS_SHIFT_IN_NACK:
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_IN)
        CALL       SDA_IN
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_DATA)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_COUTER)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0158:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0159
        RJMP       M_FTD_0160
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0159:
 
; SHL(DS_DATA) - Byte
        LSL        R1
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (SDA_READ)
        CALL       SDA_READ
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0161
        RJMP       M_IF_0162
M_IF_0161:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (DS_DATA)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_DATA)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0162:
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0158
 
; FOR TO DO - Ende
M_FTD_0160:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_OUT)
        CALL       SDA_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; RESULT Byte-Variable - FUNCTION (DS_SHIFT_IN_NACK)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (DS_SHIFT_IN_NACK)
        MOV        R16, R0
 
; FUNCTION - Ende (DS_SHIFT_IN_NACK)
        RET
 
; FUNCTION - Anfang (DS_SHIFT_IN_ACK)
DS_SHIFT_IN_ACK:
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_IN)
        CALL       SDA_IN
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_DATA)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_COUTER)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0164:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0165
        RJMP       M_FTD_0166
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0165:
 
; SHL(DS_DATA) - Byte
        LSL        R1
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (SDA_READ)
        CALL       SDA_READ
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0167
        RJMP       M_IF_0168
M_IF_0167:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (DS_DATA)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_DATA)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0168:
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0164
 
; FOR TO DO - Ende
M_FTD_0166:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_OUT)
        CALL       SDA_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; RESULT Byte-Variable - FUNCTION (DS_SHIFT_IN_ACK)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (DS_SHIFT_IN_ACK)
        MOV        R16, R0
 
; FUNCTION - Ende (DS_SHIFT_IN_ACK)
        RET
 
; FUNCTION - Anfang (DS_SHIFT_OUT)
DS_SHIFT_OUT:
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_OUT)
        CALL       SDA_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_COUTER)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0170:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0171
        RJMP       M_FTD_0172
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0171:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (DS_DATA)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x80)
        LDI        R18, 0x80
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_DATA_2)
        MOV        R4, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (DS_DATA_2)
        MOV        R16, R4
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0176
        CLR        R16
        RJMP       M_VERGL_0177
M_VERGL_0176:
        SER        R16
M_VERGL_0177:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0173
        RJMP       M_IF_0174
M_IF_0173:
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0175
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0174:
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0175:
 
; SHL(DS_DATA) - Byte
        LSL        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0170
 
; FOR TO DO - Ende
M_FTD_0172:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_IN)
        CALL       SDA_IN
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf Funktion (SDA_READ)
        CALL       SDA_READ
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0178
        RJMP       M_IF_0179
M_IF_0178:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_RESULT)
        MOV        R3, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0180
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0179:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_RESULT)
        MOV        R3, R16
 
; IF_THEN_ELSE - Ende
M_IF_0180:
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_OUT)
        CALL       SDA_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; RESULT Byte-Variable - FUNCTION (DS_SHIFT_OUT)
        MOV        R1, R3
 
; Ende Byte - FUNCTION (DS_SHIFT_OUT)
        MOV        R16, R1
 
; FUNCTION - Ende (DS_SHIFT_OUT)
        RET
 
; FUNCTION - Anfang (I2C_DEVICE_ADDRESS_TO_WRITE)
I2C_DEVICE_ADDRESS_TO_WRITE:
 
; SHL(I2C_ADDRESS) - Byte
        LSL        R0
 
; IF THEN - Ausdruck / Byte-VAR (FLASH_A1)
        LDS        R16, FLASH_A1
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0181
        RJMP       M_IF_0182
M_IF_0181:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (I2C_ADDRESS)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokaler Uebergabeparameter (I2C_ADDRESS)
        MOV        R0, R16
 
; IF_THEN - Ende
M_IF_0182:
 
; IF THEN - Ausdruck / Byte-VAR (FLASH_A0)
        LDS        R16, FLASH_A0
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0184
        RJMP       M_IF_0185
M_IF_0184:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (I2C_ADDRESS)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokaler Uebergabeparameter (I2C_ADDRESS)
        MOV        R0, R16
 
; IF_THEN - Ende
M_IF_0185:
 
; Retten der lokalen Parameter fuer PROCEDURE (I2C_DEVICE_ADDRESS_TO_WRITE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (I2C_DEVICE_ADDRESS_TO_WRITE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_RESULT)
        MOV        R2, R16
 
; RESULT Byte-Variable - FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        MOV        R1, R2
 
; Ende Byte - FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        MOV        R16, R1
 
; FUNCTION - Ende (I2C_DEVICE_ADDRESS_TO_WRITE)
        RET
 
; FUNCTION - Anfang (I2C_DEVICE_ADDRESS_TO_READ)
I2C_DEVICE_ADDRESS_TO_READ:
 
; SHL(I2C_ADDRESS) - Byte
        LSL        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (I2C_ADDRESS)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokaler Uebergabeparameter (I2C_ADDRESS)
        MOV        R0, R16
 
; IF THEN - Ausdruck / Byte-VAR (FLASH_A1)
        LDS        R16, FLASH_A1
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0187
        RJMP       M_IF_0188
M_IF_0187:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (I2C_ADDRESS)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokaler Uebergabeparameter (I2C_ADDRESS)
        MOV        R0, R16
 
; IF_THEN - Ende
M_IF_0188:
 
; IF THEN - Ausdruck / Byte-VAR (FLASH_A0)
        LDS        R16, FLASH_A0
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0190
        RJMP       M_IF_0191
M_IF_0190:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (I2C_ADDRESS)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokaler Uebergabeparameter (I2C_ADDRESS)
        MOV        R0, R16
 
; IF_THEN - Ende
M_IF_0191:
 
; Retten der lokalen Parameter fuer PROCEDURE (I2C_DEVICE_ADDRESS_TO_READ)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (I2C_DEVICE_ADDRESS_TO_READ)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_RESULT)
        MOV        R2, R16
 
; RESULT Byte-Variable - FUNCTION (I2C_DEVICE_ADDRESS_TO_READ)
        MOV        R1, R2
 
; Ende Byte - FUNCTION (I2C_DEVICE_ADDRESS_TO_READ)
        MOV        R16, R1
 
; FUNCTION - Ende (I2C_DEVICE_ADDRESS_TO_READ)
        RET
 
; PROCEDURE - Anfang (AT_DATA_WRITE_WORD_ADDRESS)
AT_DATA_WRITE_WORD_ADDRESS:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        LDI        R16, 0x54
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_WRITE)
        CALL       I2C_DEVICE_ADDRESS_TO_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (AT_DATA_WRITE_WORD_ADDRESS)
        RET
 
; PROCEDURE - Anfang (AT_READ_DATA_ARRAY)
AT_READ_DATA_ARRAY:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        CALL       AT_DATA_WRITE_WORD_ADDRESS
 
; Retten der Parameter-Register fuer PROCEDURE (AT_READ_DATA_ARRAY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_READ_DATA_ARRAY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_READ_DATA_ARRAY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_READ)
        LDI        R16, 0x54
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_READ)
        CALL       I2C_DEVICE_ADDRESS_TO_READ
 
; Retten der Parameter-Register fuer PROCEDURE (AT_READ_DATA_ARRAY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RBA_COUNTER)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007E)
        LDI        R16, LOW(0x007E)
        LDI        R17, HIGH(0x007E)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0193:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0194
        RJMP       M_FTD_0195
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0194:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (DS_SHIFT_IN_ACK)
        CALL       DS_SHIFT_IN_ACK
 
; Retten der Parameter-Register fuer PROCEDURE (AT_READ_DATA_ARRAY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RBA_DATA)
        MOV        R0, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (RBA_COUNTER)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (RBA_DATA)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0193
 
; FOR TO DO - Ende
M_FTD_0195:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (DS_SHIFT_IN_NACK)
        CALL       DS_SHIFT_IN_NACK
 
; Retten der Parameter-Register fuer PROCEDURE (AT_READ_DATA_ARRAY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RBA_DATA)
        MOV        R0, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (RBA_DATA)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_READ_DATA_ARRAY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_READ_DATA_ARRAY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (AT_READ_DATA_ARRAY)
        RET
 
; PROCEDURE - Anfang (AT_WRITE_DATA_ARRAY_WAIT)
AT_WRITE_DATA_ARRAY_WAIT:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        LDI        R16, 0x54
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_WRITE)
        CALL       I2C_DEVICE_ADDRESS_TO_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (DATA_BYTE) retten
        MOV        R19, R3
 
; lokalen Parameter (DATA_BYTE) an Funktion (DS_SHIFT_OUT)
        MOV        R0, R19
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (DATA_BYTE) retten
        MOV        R19, R3
 
; lokalen Parameter (DATA_BYTE) an Funktion (DS_SHIFT_OUT)
        MOV        R0, R19
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R1, R16
        MOV        R2, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R1
        MOV        R19, R2
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0196:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0197
        RJMP       M_FTD_0198
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0197:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R16, R1
        MOV        R17, R2
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (DATA_BYTE) retten
        MOV        R19, R3
 
; lokalen Parameter (DATA_BYTE) an Funktion (DS_SHIFT_OUT)
        MOV        R0, R19
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R0, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R1
        MOV        R19, R2
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R1, R18
        MOV        R2, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0196
 
; FOR TO DO - Ende
M_FTD_0198:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        LDI        R16, 0x54
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_WRITE)
        CALL       I2C_DEVICE_ADDRESS_TO_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; WHILE DO ...
M_WHILE_0199:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R16, R0
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0202
        CLR        R16
        RJMP       M_VERGL_0203
M_VERGL_0202:
        SER        R16
M_VERGL_0203:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0200
        RJMP       M_WHILE_0201
M_WHILE_0200:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        LDI        R16, 0x54
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_WRITE)
        CALL       I2C_DEVICE_ADDRESS_TO_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; WHILE DO ...
        RJMP       M_WHILE_0199
M_WHILE_0201:
 
; PROCEDURE - Ende (AT_WRITE_DATA_ARRAY_WAIT)
        RET
 
; FUNCTION - Anfang (AT_DATA_READ_ONE_BYTE)
AT_DATA_READ_ONE_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        CALL       AT_DATA_WRITE_WORD_ADDRESS
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_READ)
        LDI        R16, 0x54
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_READ)
        CALL       I2C_DEVICE_ADDRESS_TO_READ
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (DS_SHIFT_IN_NACK)
        CALL       DS_SHIFT_IN_NACK
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_DATA)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; RESULT Byte-Variable - FUNCTION (AT_DATA_READ_ONE_BYTE)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (AT_DATA_READ_ONE_BYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (AT_DATA_READ_ONE_BYTE)
        RET
 
; PROCEDURE - Anfang (BERECHNE_I2C_ADDRESS)
BERECHNE_I2C_ADDRESS:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (TRACK_L)
        LDS        R16, TRACK_L
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0207
        CLR        R16
        RJMP       M_VERGL_0208
M_VERGL_0207:
        SER        R16
M_VERGL_0208:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0204
        RJMP       M_IF_0205
M_IF_0204:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (FLASH_A0)
        STS        FLASH_A0, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0206
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0205:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (FLASH_A0)
        STS        FLASH_A0, R16
 
; IF_THEN_ELSE - Ende
M_IF_0206:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (TRACK_L)
        LDS        R16, TRACK_L
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x10)
        LDI        R18, 0x10
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0212
        CLR        R16
        RJMP       M_VERGL_0213
M_VERGL_0212:
        SER        R16
M_VERGL_0213:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0209
        RJMP       M_IF_0210
M_IF_0209:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (FLASH_A1)
        STS        FLASH_A1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0211
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0210:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (FLASH_A1)
        STS        FLASH_A1, R16
 
; IF_THEN_ELSE - Ende
M_IF_0211:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(TRACK_L)
        LDS        R16, TRACK_L
        CLR        R17
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; SHL(FLASH_ADDRESS) - Word
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
        LSL        R16
        ROL        R17
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; SHL(FLASH_ADDRESS) - Word
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
        LSL        R16
        ROL        R17
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; SHL(FLASH_ADDRESS) - Word
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
        LSL        R16
        ROL        R17
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; SHL(FLASH_ADDRESS) - Word
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
        LSL        R16
        ROL        R17
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; SHL(FLASH_ADDRESS) - Word
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
        LSL        R16
        ROL        R17
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; SHL(FLASH_ADDRESS) - Word
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
        LSL        R16
        ROL        R17
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(SECTOR)
        LDS        R16, SECTOR
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FLASH_ADDRESS_TEMP)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (FLASH_ADDRESS_TEMP)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; SHL(FLASH_ADDRESS) - Word
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
        LSL        R16
        ROL        R17
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; SHL(FLASH_ADDRESS) - Word
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
        LSL        R16
        ROL        R17
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; SHL(FLASH_ADDRESS) - Word
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
        LSL        R16
        ROL        R17
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; SHL(FLASH_ADDRESS) - Word
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
        LSL        R16
        ROL        R17
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; SHL(FLASH_ADDRESS) - Word
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
        LSL        R16
        ROL        R17
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; SHL(FLASH_ADDRESS) - Word
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
        LSL        R16
        ROL        R17
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; SHL(FLASH_ADDRESS) - Word
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
        LSL        R16
        ROL        R17
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; PROCEDURE - Ende (BERECHNE_I2C_ADDRESS)
        RET
 
; PROCEDURE - Anfang (INIT_FLASH_FLOPPY)
INIT_FLASH_FLOPPY:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x1FFF)
        LDI        R16, LOW(0x1FFF)
        LDI        R17, HIGH(0x1FFF)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (INIT_FLASH_FLOPPY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf Funktion (AT_DATA_READ_ONE_BYTE)
        CALL       AT_DATA_READ_ONE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (INIT_FLASH_FLOPPY)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xE5)
        LDI        R18, 0xE5
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0217
        CLR        R16
        RJMP       M_VERGL_0218
M_VERGL_0217:
        SER        R16
M_VERGL_0218:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0214
        RJMP       M_IF_0215
M_IF_0214:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R1, R16
        MOV        R2, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R1
        MOV        R19, R2
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0219:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0220
        RJMP       M_FTD_0221
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0220:
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R16, R1
        MOV        R17, R2
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xE5)
        LDI        R16, 0xE5
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R1
        MOV        R19, R2
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R1, R18
        MOV        R2, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0219
 
; FOR TO DO - Ende
M_FTD_0221:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R1, R16
        MOV        R2, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x001F)
        LDI        R16, LOW(0x001F)
        LDI        R17, HIGH(0x001F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R1
        MOV        R19, R2
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0222:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0223
        RJMP       M_FTD_0224
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0223:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R16, R1
        MOV        R17, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_WERT)
        MOV        R3, R16
        MOV        R4, R17
 
; SHL(ADDRESS_WERT) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADDRESS_WERT) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADDRESS_WERT) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADDRESS_WERT) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADDRESS_WERT) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADDRESS_WERT) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADDRESS_WERT) - Word
        LSL        R3
        ROL        R4
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_WERT)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (INIT_FLASH_FLOPPY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        CALL       AT_WRITE_DATA_ARRAY_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (INIT_FLASH_FLOPPY)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R1
        MOV        R19, R2
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R1, R18
        MOV        R2, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0222
 
; FOR TO DO - Ende
M_FTD_0224:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN - Ende
M_IF_0215:
 
; PROCEDURE - Ende (INIT_FLASH_FLOPPY)
        RET
 
; PROCEDURE - Anfang (I2C_LOAD_ADDRESS_LIST)
I2C_LOAD_ADDRESS_LIST:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0225:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0226
        RJMP       M_FTD_0227
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0226:
 
; Retten der lokalen Parameter fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADDRESS_COUNTER)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_VALUE)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Parameter (ADDRESS_VALUE) retten
        MOV        R18, R2
 
; lokalen Parameter (ADDRESS_VALUE) an Funktion (I2C_DEVICE_ADDRESS_TO_WRITE)
        MOV        R0, R18
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_WRITE)
        CALL       I2C_DEVICE_ADDRESS_TO_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R4, R16
 
; IF THEN - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R16, R4
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0228
        RJMP       M_IF_0229
M_IF_0228:
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0230
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0229:
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; IF_THEN_ELSE - Ende
M_IF_0230:
 
; Retten der lokalen Parameter fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0225
 
; FOR TO DO - Ende
M_FTD_0227:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('')
        LDI        ZL, LOW(2*M_CONST_STRING_0)
        LDI        ZH, HIGH(2*M_CONST_STRING_0)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0231
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0231:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0233
M_PRG_CONST_STRING_0232:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0232
M_PRG_CONST_STRING_0233:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0235
        MOV        R16, R17
M_PRG_CONST_STRING_0234:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0234
M_PRG_CONST_STRING_0235:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0001)
        MOV        R0, R16
        LDI        R17, HIGH(0x0001)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('XX 00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F')
        LDI        ZL, LOW(2*M_CONST_STRING_1)
        LDI        ZH, HIGH(2*M_CONST_STRING_1)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0236
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0236:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0238
M_PRG_CONST_STRING_0237:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0237
M_PRG_CONST_STRING_0238:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0240
        MOV        R16, R17
M_PRG_CONST_STRING_0239:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0239
M_PRG_CONST_STRING_0240:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0001)
        MOV        R0, R16
        LDI        R17, HIGH(0x0001)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_LINE)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('00')
        LDI        ZL, LOW(2*M_CONST_STRING_2)
        LDI        ZH, HIGH(2*M_CONST_STRING_2)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0241
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0241:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0243
M_PRG_CONST_STRING_0242:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0242
M_PRG_CONST_STRING_0243:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0245
        MOV        R16, R17
M_PRG_CONST_STRING_0244:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0244
M_PRG_CONST_STRING_0245:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_VALUE)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0246:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0247
        RJMP       M_FTD_0248
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0247:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B2)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0252
        CLR        R16
        RJMP       M_VERGL_0253
M_VERGL_0252:
        SER        R16
M_VERGL_0253:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0249
        RJMP       M_IF_0250
M_IF_0249:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0254
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0254:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0256
M_PRG_CONST_STRING_0255:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0255
M_PRG_CONST_STRING_0256:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack (' ')
        LDI        ZL, LOW(2*M_CONST_STRING_3)
        LDI        ZH, HIGH(2*M_CONST_STRING_3)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0257
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0257:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0259
M_PRG_CONST_STRING_0258:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0258
M_PRG_CONST_STRING_0259:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0261
        MOV        R16, R17
M_PRG_CONST_STRING_0260:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0260
M_PRG_CONST_STRING_0261:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADDRESS_COUNTER)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R5, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Parameter (B1) retten
        MOV        R21, R5
 
; lokalen Parameter (B1) an Prozedur (BYTETOSTRING)
        MOV        R0, R21
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0262
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0262:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0264
M_PRG_CONST_STRING_0263:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0263
M_PRG_CONST_STRING_0264:
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0265
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0265:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0267
M_PRG_CONST_STRING_0266:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0266
M_PRG_CONST_STRING_0267:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0269
        MOV        R16, R17
M_PRG_CONST_STRING_0268:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0268
M_PRG_CONST_STRING_0269:
        ST         -Z, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0251
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0250:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0270
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0270:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0272
M_PRG_CONST_STRING_0271:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0271
M_PRG_CONST_STRING_0272:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack (' ..')
        LDI        ZL, LOW(2*M_CONST_STRING_4)
        LDI        ZH, HIGH(2*M_CONST_STRING_4)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0273
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0273:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0275
M_PRG_CONST_STRING_0274:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0274
M_PRG_CONST_STRING_0275:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0277
        MOV        R16, R17
M_PRG_CONST_STRING_0276:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0276
M_PRG_CONST_STRING_0277:
        ST         -Z, R17
 
; IF_THEN_ELSE - Ende
M_IF_0251:
 
; INC(ADDRESS_LINE) - Byte
        INC        R3
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADDRESS_LINE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x10)
        LDI        R18, 0x10
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0281
        CLR        R16
        RJMP       M_VERGL_0282
M_VERGL_0281:
        SER        R16
M_VERGL_0282:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0278
        RJMP       M_IF_0279
M_IF_0278:
 
; Retten der lokalen Parameter fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_LINE)
        MOV        R3, R16
 
; INC(ADDRESS_VALUE) - Byte
        INC        R2
 
; Retten der lokalen Parameter fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
 
; Parameter (ADDRESS_VALUE) retten
        MOV        R18, R2
 
; lokalen Parameter (ADDRESS_VALUE) an Prozedur (BYTETOSTRING)
        MOV        R0, R18
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0283
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0283:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0285
M_PRG_CONST_STRING_0284:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0284
M_PRG_CONST_STRING_0285:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0287
        MOV        R16, R17
M_PRG_CONST_STRING_0286:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0286
M_PRG_CONST_STRING_0287:
        ST         -Z, R17
 
; IF_THEN - Ende
M_IF_0279:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0246
 
; FOR TO DO - Ende
M_FTD_0248:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (I2C_LOAD_ADDRESS_LIST)
        RET
 
; PROCEDURE - Anfang (AT_ZEIGE_EIN_BYTE)
AT_ZEIGE_EIN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_ZEIGE_EIN_BYTE)
        PUSH       R0
 
; Aufruf Funktion (AT_DATA_READ_ONE_BYTE)
        CALL       AT_DATA_READ_ONE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (AT_ZEIGE_EIN_BYTE)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('Adresse=')
        LDI        ZL, LOW(2*M_CONST_STRING_5)
        LDI        ZH, HIGH(2*M_CONST_STRING_5)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0288
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0288:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0290
M_PRG_CONST_STRING_0289:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0289
M_PRG_CONST_STRING_0290:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0292
        MOV        R16, R17
M_PRG_CONST_STRING_0291:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0291
M_PRG_CONST_STRING_0292:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_ZEIGE_EIN_BYTE)
        PUSH       R0
 
; Word-Parameter(1) fuer PROCEDURE (WORDTOSTRING)
        LDS        R0, FLASH_ADDRESS
        LDS        R1, FLASH_ADDRESS+1
 
; Aufruf PROCEDURE (WORDTOSTRING)
        CALL       WORDTOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (AT_ZEIGE_EIN_BYTE)
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0293
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0293:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0295
M_PRG_CONST_STRING_0294:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0294
M_PRG_CONST_STRING_0295:
        LDI        ZL, LOW(WORD_STRING)
        LDI        ZH, HIGH(WORD_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0296
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0296:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0298
M_PRG_CONST_STRING_0297:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0297
M_PRG_CONST_STRING_0298:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0300
        MOV        R16, R17
M_PRG_CONST_STRING_0299:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0299
M_PRG_CONST_STRING_0300:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_ZEIGE_EIN_BYTE)
        PUSH       R0
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (AT_ZEIGE_EIN_BYTE)
        POP        R0
 
; IF THEN - Ausdruck / Byte-VAR (FLASH_A0)
        LDS        R16, FLASH_A0
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0301
        RJMP       M_IF_0302
M_IF_0301:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('A0=1')
        LDI        ZL, LOW(2*M_CONST_STRING_6)
        LDI        ZH, HIGH(2*M_CONST_STRING_6)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0304
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0304:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0306
M_PRG_CONST_STRING_0305:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0305
M_PRG_CONST_STRING_0306:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0308
        MOV        R16, R17
M_PRG_CONST_STRING_0307:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0307
M_PRG_CONST_STRING_0308:
        ST         -Z, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0303
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0302:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('A0=0')
        LDI        ZL, LOW(2*M_CONST_STRING_7)
        LDI        ZH, HIGH(2*M_CONST_STRING_7)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0309
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0309:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0311
M_PRG_CONST_STRING_0310:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0310
M_PRG_CONST_STRING_0311:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0313
        MOV        R16, R17
M_PRG_CONST_STRING_0312:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0312
M_PRG_CONST_STRING_0313:
        ST         -Z, R17
 
; IF_THEN_ELSE - Ende
M_IF_0303:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_ZEIGE_EIN_BYTE)
        PUSH       R0
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (AT_ZEIGE_EIN_BYTE)
        POP        R0
 
; IF THEN - Ausdruck / Byte-VAR (FLASH_A1)
        LDS        R16, FLASH_A1
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0314
        RJMP       M_IF_0315
M_IF_0314:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('A1=1')
        LDI        ZL, LOW(2*M_CONST_STRING_8)
        LDI        ZH, HIGH(2*M_CONST_STRING_8)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0317
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0317:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0319
M_PRG_CONST_STRING_0318:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0318
M_PRG_CONST_STRING_0319:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0321
        MOV        R16, R17
M_PRG_CONST_STRING_0320:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0320
M_PRG_CONST_STRING_0321:
        ST         -Z, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0316
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0315:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('A1=0')
        LDI        ZL, LOW(2*M_CONST_STRING_9)
        LDI        ZH, HIGH(2*M_CONST_STRING_9)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0322
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0322:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0324
M_PRG_CONST_STRING_0323:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0323
M_PRG_CONST_STRING_0324:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0326
        MOV        R16, R17
M_PRG_CONST_STRING_0325:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0325
M_PRG_CONST_STRING_0326:
        ST         -Z, R17
 
; IF_THEN_ELSE - Ende
M_IF_0316:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_ZEIGE_EIN_BYTE)
        PUSH       R0
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (AT_ZEIGE_EIN_BYTE)
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('Daten=')
        LDI        ZL, LOW(2*M_CONST_STRING_10)
        LDI        ZH, HIGH(2*M_CONST_STRING_10)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0327
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0327:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0329
M_PRG_CONST_STRING_0328:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0328
M_PRG_CONST_STRING_0329:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0331
        MOV        R16, R17
M_PRG_CONST_STRING_0330:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0330
M_PRG_CONST_STRING_0331:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_ZEIGE_EIN_BYTE)
        PUSH       R0
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (AT_ZEIGE_EIN_BYTE)
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0332
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0332:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0334
M_PRG_CONST_STRING_0333:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0333
M_PRG_CONST_STRING_0334:
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0335
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0335:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0337
M_PRG_CONST_STRING_0336:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0336
M_PRG_CONST_STRING_0337:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0339
        MOV        R16, R17
M_PRG_CONST_STRING_0338:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0338
M_PRG_CONST_STRING_0339:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_ZEIGE_EIN_BYTE)
        PUSH       R0
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (AT_ZEIGE_EIN_BYTE)
        POP        R0
 
; PROCEDURE - Ende (AT_ZEIGE_EIN_BYTE)
        RET
 
; PROCEDURE - Anfang (AT_DATA_WRITE_ONE_BYTE)
AT_DATA_WRITE_ONE_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        LDI        R16, 0x54
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_WRITE)
        CALL       I2C_DEVICE_ADDRESS_TO_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (B1) retten
        MOV        R18, R2
 
; lokalen Parameter (B1) an Funktion (DS_SHIFT_OUT)
        MOV        R0, R18
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (B1) retten
        MOV        R18, R2
 
; lokalen Parameter (B1) an Funktion (DS_SHIFT_OUT)
        MOV        R0, R18
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (AT_DATA_WRITE_ONE_BYTE)
        RET
 
; PROCEDURE - Anfang (ITP3_INIT)
ITP3_INIT:
 
; ClearBit(ITP3_D0_D)
        CBI        DDRA, 0
 
; ClearBit(ITP3_D1_D)
        CBI        DDRA, 1
 
; ClearBit(ITP3_D2_D)
        CBI        DDRA, 2
 
; ClearBit(ITP3_D3_D)
        CBI        DDRA, 3
 
; SetBit(ITP3_DS0_A)
        SBI        PORTA, 4
 
; SetBit(ITP3_DS0_D)
        SBI        DDRA, 4
 
; SetBit(ITP3_DS1_A)
        SBI        PORTA, 5
 
; SetBit(ITP3_DS1_D)
        SBI        DDRA, 5
 
; SetBit(ITP3_DS2_A)
        SBI        PORTA, 6
 
; SetBit(ITP3_DS2_D)
        SBI        DDRA, 6
 
; SetBit(ITP3_DS3_A)
        SBI        PORTA, 7
 
; SetBit(ITP3_DS3_D)
        SBI        DDRA, 7
 
; ClearBit(ITP3_DR_D)
        CBI        DDRB, 0
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS0)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x64)
        LDI        R16, 0x64
 
; Zuweisung Ziel /  VAR (CONOUT_DEVICE)
        STS        CONOUT_DEVICE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x64)
        LDI        R16, 0x64
 
; Zuweisung Ziel /  VAR (CONIN_DEVICE)
        STS        CONIN_DEVICE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x64)
        LDI        R16, 0x64
 
; Zuweisung Ziel /  VAR (LIST_DEVICE)
        STS        LIST_DEVICE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x64)
        LDI        R16, 0x64
 
; Zuweisung Ziel /  VAR (SOUND_DEVICE)
        STS        SOUND_DEVICE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x64)
        LDI        R16, 0x64
 
; Zuweisung Ziel /  VAR (DRIVE_D_DEVICE)
        STS        DRIVE_D_DEVICE, R16
 
; PROCEDURE - Ende (ITP3_INIT)
        RET
 
; PROCEDURE - Anfang (DEV_NR_CLEARBIT)
DEV_NR_CLEARBIT:
 
; CASE OF - Byte-VAR (DEV_NR)
        LDS        R16, DEV_NR
 
; CASE OF - vergleiche Einzel-Element (DEV_DS0)
        CPI        R16, 0x00
        BREQ       M_CASE_0342
        RJMP       M_CASE_0341
M_CASE_0342:
 
; ClearBit(ITP3_DS0_A)
        CBI        PORTA, 4
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0340
M_CASE_0341:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS1)
        CPI        R16, 0x01
        BREQ       M_CASE_0344
        RJMP       M_CASE_0343
M_CASE_0344:
 
; ClearBit(ITP3_DS1_A)
        CBI        PORTA, 5
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0340
M_CASE_0343:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS2)
        CPI        R16, 0x02
        BREQ       M_CASE_0346
        RJMP       M_CASE_0345
M_CASE_0346:
 
; ClearBit(ITP3_DS2_A)
        CBI        PORTA, 6
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0340
M_CASE_0345:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS3)
        CPI        R16, 0x03
        BREQ       M_CASE_0348
        RJMP       M_CASE_0347
M_CASE_0348:
 
; ClearBit(ITP3_DS3_A)
        CBI        PORTA, 7
 
; ENDCASE;
M_CASE_0347:
M_CASE_0340:
 
; PROCEDURE - Ende (DEV_NR_CLEARBIT)
        RET
 
; PROCEDURE - Anfang (DEV_NR_SETBIT)
DEV_NR_SETBIT:
 
; CASE OF - Byte-VAR (DEV_NR)
        LDS        R16, DEV_NR
 
; CASE OF - vergleiche Einzel-Element (DEV_DS0)
        CPI        R16, 0x00
        BREQ       M_CASE_0351
        RJMP       M_CASE_0350
M_CASE_0351:
 
; SetBit(ITP3_DS0_A)
        SBI        PORTA, 4
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0349
M_CASE_0350:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS1)
        CPI        R16, 0x01
        BREQ       M_CASE_0353
        RJMP       M_CASE_0352
M_CASE_0353:
 
; SetBit(ITP3_DS1_A)
        SBI        PORTA, 5
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0349
M_CASE_0352:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS2)
        CPI        R16, 0x02
        BREQ       M_CASE_0355
        RJMP       M_CASE_0354
M_CASE_0355:
 
; SetBit(ITP3_DS2_A)
        SBI        PORTA, 6
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0349
M_CASE_0354:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS3)
        CPI        R16, 0x03
        BREQ       M_CASE_0357
        RJMP       M_CASE_0356
M_CASE_0357:
 
; SetBit(ITP3_DS3_A)
        SBI        PORTA, 7
 
; ENDCASE;
M_CASE_0356:
M_CASE_0349:
 
; PROCEDURE - Ende (DEV_NR_SETBIT)
        RET
 
; PROCEDURE - Anfang (ITP3_SENDE_HALBBYTE)
ITP3_SENDE_HALBBYTE:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0361
        CLR        R16
        RJMP       M_VERGL_0362
M_VERGL_0361:
        SER        R16
M_VERGL_0362:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0358
        RJMP       M_IF_0359
M_IF_0358:
 
; ClearBit(ITP3_D0_A)
        CBI        PORTA, 0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0360
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0359:
 
; SetBit(ITP3_D0_A)
        SBI        PORTA, 0
 
; IF_THEN_ELSE - Ende
M_IF_0360:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0366
        CLR        R16
        RJMP       M_VERGL_0367
M_VERGL_0366:
        SER        R16
M_VERGL_0367:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0363
        RJMP       M_IF_0364
M_IF_0363:
 
; ClearBit(ITP3_D1_A)
        CBI        PORTA, 1
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0365
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0364:
 
; SetBit(ITP3_D1_A)
        SBI        PORTA, 1
 
; IF_THEN_ELSE - Ende
M_IF_0365:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0371
        CLR        R16
        RJMP       M_VERGL_0372
M_VERGL_0371:
        SER        R16
M_VERGL_0372:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0368
        RJMP       M_IF_0369
M_IF_0368:
 
; ClearBit(ITP3_D2_A)
        CBI        PORTA, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0370
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0369:
 
; SetBit(ITP3_D2_A)
        SBI        PORTA, 2
 
; IF_THEN_ELSE - Ende
M_IF_0370:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0376
        CLR        R16
        RJMP       M_VERGL_0377
M_VERGL_0376:
        SER        R16
M_VERGL_0377:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0373
        RJMP       M_IF_0374
M_IF_0373:
 
; ClearBit(ITP3_D3_A)
        CBI        PORTA, 3
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0375
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0374:
 
; SetBit(ITP3_D3_A)
        SBI        PORTA, 3
 
; IF_THEN_ELSE - Ende
M_IF_0375:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_HALBBYTE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DEV_NR_CLEARBIT)
        CALL       DEV_NR_CLEARBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_HALBBYTE)
        POP        R1
        POP        R0
 
; WHILE DO ...
M_WHILE_0378:
 
; WHILE - Ausdruck /; BitHigh(ITP3_DR_E)
        IN         R16, PINB
        BST        R16, 0
        BRTS       M_VERGL_0381
        CLR        R16
        RJMP       M_VERGL_0382
M_VERGL_0381:
        SER        R16
M_VERGL_0382:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0379
        RJMP       M_WHILE_0380
M_WHILE_0379:
 
; WHILE DO ...
        RJMP       M_WHILE_0378
M_WHILE_0380:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_HALBBYTE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DEV_NR_SETBIT)
        CALL       DEV_NR_SETBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_HALBBYTE)
        POP        R1
        POP        R0
 
; WHILE DO ...
M_WHILE_0383:
 
; WHILE - Ausdruck /; BitLow(ITP3_DR_E)
        IN         R16, PINB
        BST        R16, 0
        BRTC       M_VERGL_0386
        CLR        R16
        RJMP       M_VERGL_0387
M_VERGL_0386:
        SER        R16
M_VERGL_0387:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0384
        RJMP       M_WHILE_0385
M_WHILE_0384:
 
; WHILE DO ...
        RJMP       M_WHILE_0383
M_WHILE_0385:
 
; PROCEDURE - Ende (ITP3_SENDE_HALBBYTE)
        RET
 
; PROCEDURE - Anfang (ITP3_SENDE_BYTE)
ITP3_SENDE_BYTE:
 
; SetBit(ITP3_D0_D)
        SBI        DDRA, 0
 
; SetBit(ITP3_D1_D)
        SBI        DDRA, 1
 
; SetBit(ITP3_D2_D)
        SBI        DDRA, 2
 
; SetBit(ITP3_D3_D)
        SBI        DDRA, 3
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_BYTE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DEV_NR_SETBIT)
        CALL       DEV_NR_SETBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_BYTE)
        POP        R1
        POP        R0
 
; ClearBit(ITP3_DR_D)
        CBI        DDRB, 0
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_BYTE)
        PUSH       R0
        PUSH       R1
 
; Parameter (B1) retten
        MOV        R17, R1
 
; lokalen Parameter (B1) an Prozedur (ITP3_SENDE_HALBBYTE)
        MOV        R0, R17
 
; Aufruf PROCEDURE (ITP3_SENDE_HALBBYTE)
        CALL       ITP3_SENDE_HALBBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_BYTE)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; SHR(B1) - Byte
        LSR        R1
 
; SHR(B1) - Byte
        LSR        R1
 
; SHR(B1) - Byte
        LSR        R1
 
; SHR(B1) - Byte
        LSR        R1
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_BYTE)
        PUSH       R0
        PUSH       R1
 
; Parameter (B1) retten
        MOV        R17, R1
 
; lokalen Parameter (B1) an Prozedur (ITP3_SENDE_HALBBYTE)
        MOV        R0, R17
 
; Aufruf PROCEDURE (ITP3_SENDE_HALBBYTE)
        CALL       ITP3_SENDE_HALBBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_BYTE)
        POP        R1
        POP        R0
 
; ClearBit(ITP3_D0_D)
        CBI        DDRA, 0
 
; ClearBit(ITP3_D1_D)
        CBI        DDRA, 1
 
; ClearBit(ITP3_D2_D)
        CBI        DDRA, 2
 
; ClearBit(ITP3_D3_D)
        CBI        DDRA, 3
 
; PROCEDURE - Ende (ITP3_SENDE_BYTE)
        RET
 
; FUNCTION - Anfang (ITP3_SENDE_TEST_HALBBYTE)
ITP3_SENDE_TEST_HALBBYTE:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0391
        CLR        R16
        RJMP       M_VERGL_0392
M_VERGL_0391:
        SER        R16
M_VERGL_0392:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0388
        RJMP       M_IF_0389
M_IF_0388:
 
; ClearBit(ITP3_D0_A)
        CBI        PORTA, 0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0390
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0389:
 
; SetBit(ITP3_D0_A)
        SBI        PORTA, 0
 
; IF_THEN_ELSE - Ende
M_IF_0390:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0396
        CLR        R16
        RJMP       M_VERGL_0397
M_VERGL_0396:
        SER        R16
M_VERGL_0397:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0393
        RJMP       M_IF_0394
M_IF_0393:
 
; ClearBit(ITP3_D1_A)
        CBI        PORTA, 1
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0395
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0394:
 
; SetBit(ITP3_D1_A)
        SBI        PORTA, 1
 
; IF_THEN_ELSE - Ende
M_IF_0395:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0401
        CLR        R16
        RJMP       M_VERGL_0402
M_VERGL_0401:
        SER        R16
M_VERGL_0402:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0398
        RJMP       M_IF_0399
M_IF_0398:
 
; ClearBit(ITP3_D2_A)
        CBI        PORTA, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0400
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0399:
 
; SetBit(ITP3_D2_A)
        SBI        PORTA, 2
 
; IF_THEN_ELSE - Ende
M_IF_0400:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0406
        CLR        R16
        RJMP       M_VERGL_0407
M_VERGL_0406:
        SER        R16
M_VERGL_0407:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0403
        RJMP       M_IF_0404
M_IF_0403:
 
; ClearBit(ITP3_D3_A)
        CBI        PORTA, 3
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0405
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0404:
 
; SetBit(ITP3_D3_A)
        SBI        PORTA, 3
 
; IF_THEN_ELSE - Ende
M_IF_0405:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_TEST_HALBBYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (DEV_NR_CLEARBIT)
        CALL       DEV_NR_CLEARBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_TEST_HALBBYTE)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WAIT_COUNTER)
        MOV        R3, R16
        MOV        R4, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R5, R16
 
; WHILE DO ...
M_WHILE_0408:
 
; WHILE - Ausdruck / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R5
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0409
        RJMP       M_WHILE_0410
M_WHILE_0409:
 
; IF THEN - Ausdruck /; BitLow(ITP3_DR_E)
        IN         R16, PINB
        BST        R16, 0
        BRTC       M_VERGL_0414
        CLR        R16
        RJMP       M_VERGL_0415
M_VERGL_0414:
        SER        R16
M_VERGL_0415:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0411
        RJMP       M_IF_0412
M_IF_0411:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R5, R16
 
; IF_THEN - Ende
M_IF_0412:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (WAIT_COUNTER)
        MOV        R16, R3
        MOV        R17, R4
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xEA60)
        LDI        R18, LOW(0xEA60)
        LDI        R19, HIGH(0xEA60)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0419
        CLR        R16
        RJMP       M_VERGL_0420
M_VERGL_0419:
        SER        R16
M_VERGL_0420:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0416
        RJMP       M_IF_0417
M_IF_0416:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R5, R16
 
; IF_THEN - Ende
M_IF_0417:
 
; INC(WAIT_COUNTER) - Word
        MOV        R24, R3
        MOV        R25, R4
        ADIW       R25:R24, 1
        MOV        R3, R24
        MOV        R4, R25
 
; WHILE DO ...
        RJMP       M_WHILE_0408
M_WHILE_0410:
 
; IF THEN - Ausdruck /; BitLow(ITP3_DR_E)
        IN         R16, PINB
        BST        R16, 0
        BRTC       M_VERGL_0424
        CLR        R16
        RJMP       M_VERGL_0425
M_VERGL_0424:
        SER        R16
M_VERGL_0425:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0421
        RJMP       M_IF_0422
M_IF_0421:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_TEST_HALBBYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (DEV_NR_SETBIT)
        CALL       DEV_NR_SETBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_TEST_HALBBYTE)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R5, R16
 
; WHILE DO ...
M_WHILE_0426:
 
; WHILE - Ausdruck /; BitLow(ITP3_DR_E)
        IN         R16, PINB
        BST        R16, 0
        BRTC       M_VERGL_0429
        CLR        R16
        RJMP       M_VERGL_0430
M_VERGL_0429:
        SER        R16
M_VERGL_0430:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0427
        RJMP       M_WHILE_0428
M_WHILE_0427:
 
; WHILE DO ...
        RJMP       M_WHILE_0426
M_WHILE_0428:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0423
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0422:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_TEST_HALBBYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (DEV_NR_SETBIT)
        CALL       DEV_NR_SETBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_TEST_HALBBYTE)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R5, R16
 
; IF_THEN_ELSE - Ende
M_IF_0423:
 
; RESULT Byte-Variable - FUNCTION (ITP3_SENDE_TEST_HALBBYTE)
        MOV        R1, R5
 
; Ende Byte - FUNCTION (ITP3_SENDE_TEST_HALBBYTE)
        MOV        R16, R1
 
; FUNCTION - Ende (ITP3_SENDE_TEST_HALBBYTE)
        RET
 
; FUNCTION - Anfang (ITP3_SENDE_TEST_BYTE)
ITP3_SENDE_TEST_BYTE:
 
; SetBit(ITP3_D0_D)
        SBI        DDRA, 0
 
; SetBit(ITP3_D1_D)
        SBI        DDRA, 1
 
; SetBit(ITP3_D2_D)
        SBI        DDRA, 2
 
; SetBit(ITP3_D3_D)
        SBI        DDRA, 3
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_TEST_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (DEV_NR_SETBIT)
        CALL       DEV_NR_SETBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_TEST_BYTE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ClearBit(ITP3_DR_D)
        CBI        DDRB, 0
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_TEST_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (B1) retten
        MOV        R17, R2
 
; lokalen Parameter (B1) an Funktion (ITP3_SENDE_TEST_HALBBYTE)
        MOV        R0, R17
 
; Aufruf Funktion (ITP3_SENDE_TEST_HALBBYTE)
        CALL       ITP3_SENDE_TEST_HALBBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_TEST_BYTE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R3, R16
 
; IF THEN - Ausdruck / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R3
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0431
        RJMP       M_IF_0432
M_IF_0431:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; SHR(B1) - Byte
        LSR        R2
 
; SHR(B1) - Byte
        LSR        R2
 
; SHR(B1) - Byte
        LSR        R2
 
; SHR(B1) - Byte
        LSR        R2
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_TEST_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (B1) retten
        MOV        R17, R2
 
; lokalen Parameter (B1) an Prozedur (ITP3_SENDE_HALBBYTE)
        MOV        R0, R17
 
; Aufruf PROCEDURE (ITP3_SENDE_HALBBYTE)
        CALL       ITP3_SENDE_HALBBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_TEST_BYTE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0432:
 
; ClearBit(ITP3_D0_D)
        CBI        DDRA, 0
 
; ClearBit(ITP3_D1_D)
        CBI        DDRA, 1
 
; ClearBit(ITP3_D2_D)
        CBI        DDRA, 2
 
; ClearBit(ITP3_D3_D)
        CBI        DDRA, 3
 
; RESULT Byte-Variable - FUNCTION (ITP3_SENDE_TEST_BYTE)
        MOV        R1, R3
 
; Ende Byte - FUNCTION (ITP3_SENDE_TEST_BYTE)
        MOV        R16, R1
 
; FUNCTION - Ende (ITP3_SENDE_TEST_BYTE)
        RET
 
; FUNCTION - Anfang (ITP3_EMPFANGE_HALBBYTE)
ITP3_EMPFANGE_HALBBYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_HALBBYTE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DEV_NR_CLEARBIT)
        CALL       DEV_NR_CLEARBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_HALBBYTE)
        POP        R1
        POP        R0
 
; WHILE DO ...
M_WHILE_0434:
 
; WHILE - Ausdruck /; BitHigh(ITP3_DR_E)
        IN         R16, PINB
        BST        R16, 0
        BRTS       M_VERGL_0437
        CLR        R16
        RJMP       M_VERGL_0438
M_VERGL_0437:
        SER        R16
M_VERGL_0438:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0435
        RJMP       M_WHILE_0436
M_WHILE_0435:
 
; WHILE DO ...
        RJMP       M_WHILE_0434
M_WHILE_0436:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; IF THEN - Ausdruck /; BitHigh(ITP3_D0_E)
        IN         R16, PINA
        BST        R16, 0
        BRTS       M_VERGL_0442
        CLR        R16
        RJMP       M_VERGL_0443
M_VERGL_0442:
        SER        R16
M_VERGL_0443:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0439
        RJMP       M_IF_0440
M_IF_0439:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0440:
 
; IF THEN - Ausdruck /; BitHigh(ITP3_D1_E)
        IN         R16, PINA
        BST        R16, 1
        BRTS       M_VERGL_0447
        CLR        R16
        RJMP       M_VERGL_0448
M_VERGL_0447:
        SER        R16
M_VERGL_0448:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0444
        RJMP       M_IF_0445
M_IF_0444:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0445:
 
; IF THEN - Ausdruck /; BitHigh(ITP3_D2_E)
        IN         R16, PINA
        BST        R16, 2
        BRTS       M_VERGL_0452
        CLR        R16
        RJMP       M_VERGL_0453
M_VERGL_0452:
        SER        R16
M_VERGL_0453:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0449
        RJMP       M_IF_0450
M_IF_0449:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0450:
 
; IF THEN - Ausdruck /; BitHigh(ITP3_D3_E)
        IN         R16, PINA
        BST        R16, 3
        BRTS       M_VERGL_0457
        CLR        R16
        RJMP       M_VERGL_0458
M_VERGL_0457:
        SER        R16
M_VERGL_0458:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0454
        RJMP       M_IF_0455
M_IF_0454:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0455:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_HALBBYTE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DEV_NR_SETBIT)
        CALL       DEV_NR_SETBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_HALBBYTE)
        POP        R1
        POP        R0
 
; WHILE DO ...
M_WHILE_0459:
 
; WHILE - Ausdruck /; BitLow(ITP3_DR_E)
        IN         R16, PINB
        BST        R16, 0
        BRTC       M_VERGL_0462
        CLR        R16
        RJMP       M_VERGL_0463
M_VERGL_0462:
        SER        R16
M_VERGL_0463:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0460
        RJMP       M_WHILE_0461
M_WHILE_0460:
 
; WHILE DO ...
        RJMP       M_WHILE_0459
M_WHILE_0461:
 
; RESULT Byte-Variable - FUNCTION (ITP3_EMPFANGE_HALBBYTE)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ITP3_EMPFANGE_HALBBYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_EMPFANGE_HALBBYTE)
        RET
 
; FUNCTION - Anfang (ITP3_EMPFANGE_BYTE)
ITP3_EMPFANGE_BYTE:
 
; ClearBit(ITP3_D0_D)
        CBI        DDRA, 0
 
; ClearBit(ITP3_D1_D)
        CBI        DDRA, 1
 
; ClearBit(ITP3_D2_D)
        CBI        DDRA, 2
 
; ClearBit(ITP3_D3_D)
        CBI        DDRA, 3
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (DEV_NR_SETBIT)
        CALL       DEV_NR_SETBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (ITP3_EMPFANGE_HALBBYTE)
        CALL       ITP3_EMPFANGE_HALBBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE_01)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (ITP3_EMPFANGE_HALBBYTE)
        CALL       ITP3_EMPFANGE_HALBBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE_02)
        MOV        R2, R16
 
; SHL(RESULT_BYTE_02) - Byte
        LSL        R2
 
; SHL(RESULT_BYTE_02) - Byte
        LSL        R2
 
; SHL(RESULT_BYTE_02) - Byte
        LSL        R2
 
; SHL(RESULT_BYTE_02) - Byte
        LSL        R2
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE_01)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (RESULT_BYTE_02)
        MOV        R18, R2
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE_01)
        MOV        R1, R16
 
; RESULT Byte-Variable - FUNCTION (ITP3_EMPFANGE_BYTE)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ITP3_EMPFANGE_BYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_EMPFANGE_BYTE)
        RET
 
; PROCEDURE - Anfang (ITP3_SENDE_CONOUT)
ITP3_SENDE_CONOUT:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_CONOUT)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDI        R16, 0x03
        MOV        R0, R16
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_CONOUT)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_CONOUT)
        POP        R0
 
; PROCEDURE - Ende (ITP3_SENDE_CONOUT)
        RET
 
; FUNCTION - Anfang (ITP3_EMPFANGE_CONST)
ITP3_EMPFANGE_CONST:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_CONST)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_CONST)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_CONST)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (ITP3_EMPFANGE_BYTE)
        CALL       ITP3_EMPFANGE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_CONST)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; RESULT Byte-Variable - FUNCTION (ITP3_EMPFANGE_CONST)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ITP3_EMPFANGE_CONST)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_EMPFANGE_CONST)
        RET
 
; FUNCTION - Anfang (ITP3_EMPFANGE_CONIN)
ITP3_EMPFANGE_CONIN:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_CONIN)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDI        R16, 0x05
        MOV        R0, R16
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_CONIN)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_CONIN)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (ITP3_EMPFANGE_BYTE)
        CALL       ITP3_EMPFANGE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_CONIN)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; RESULT Byte-Variable - FUNCTION (ITP3_EMPFANGE_CONIN)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ITP3_EMPFANGE_CONIN)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_EMPFANGE_CONIN)
        RET
 
; PROCEDURE - Anfang (ITP3_CONIN_SCHLEIFE)
ITP3_CONIN_SCHLEIFE:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; WHILE DO ...
M_WHILE_0464:
 
; WHILE - Ausdruck erster Faktor / Byte-VAR (CONSOLEIN)
        LDS        R16, CONSOLEIN
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0467
        CLR        R16
        RJMP       M_VERGL_0468
M_VERGL_0467:
        SER        R16
M_VERGL_0468:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0465
        RJMP       M_WHILE_0466
M_WHILE_0465:
 
; Aufruf Funktion (ITP3_EMPFANGE_CONST)
        CALL       ITP3_EMPFANGE_CONST
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; WHILE DO ...
        RJMP       M_WHILE_0464
M_WHILE_0466:
 
; Aufruf Funktion (ITP3_EMPFANGE_CONIN)
        CALL       ITP3_EMPFANGE_CONIN
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; PROCEDURE - Ende (ITP3_CONIN_SCHLEIFE)
        RET
 
; PROCEDURE - Anfang (ITP3_SENDE_STD)
ITP3_SENDE_STD:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (DRIVE_D_DEVICE)
        LDS        R16, DRIVE_D_DEVICE
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x64)
        LDI        R18, 0x64
 
; Operator <
        CP         R16, R18
        BRCS       M_VERGL_0472
        CLR        R16
        RJMP       M_VERGL_0473
M_VERGL_0472:
        SER        R16
M_VERGL_0473:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0469
        RJMP       M_IF_0470
M_IF_0469:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (DRIVE_D_DEVICE)
        LDS        R16, DRIVE_D_DEVICE
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDI        R16, 0x06
        MOV        R0, R16
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDS        R0, SECTOR
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDS        R0, TRACK_L
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDS        R0, TRACK_H
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDS        R0, DISKNO
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; IF_THEN - Ende
M_IF_0470:
 
; PROCEDURE - Ende (ITP3_SENDE_STD)
        RET
 
; PROCEDURE - Anfang (ITP3_SEKTOR_LESEN)
ITP3_SEKTOR_LESEN:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (DRIVE_D_DEVICE)
        LDS        R16, DRIVE_D_DEVICE
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x64)
        LDI        R18, 0x64
 
; Operator <
        CP         R16, R18
        BRCS       M_VERGL_0477
        CLR        R16
        RJMP       M_VERGL_0478
M_VERGL_0477:
        SER        R16
M_VERGL_0478:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0474
        RJMP       M_IF_0475
M_IF_0474:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (DRIVE_D_DEVICE)
        LDS        R16, DRIVE_D_DEVICE
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SEKTOR_LESEN)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDI        R16, 0x07
        MOV        R0, R16
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SEKTOR_LESEN)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0479:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0480
        RJMP       M_FTD_0481
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0480:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SEKTOR_LESEN)
        PUSH       R0
 
; Aufruf Funktion (ITP3_EMPFANGE_BYTE)
        CALL       ITP3_EMPFANGE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SEKTOR_LESEN)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        SEKTOR_PUFFER_ZEIGER, R18
        STS        SEKTOR_PUFFER_ZEIGER+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0479
 
; FOR TO DO - Ende
M_FTD_0481:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN - Ende
M_IF_0475:
 
; PROCEDURE - Ende (ITP3_SEKTOR_LESEN)
        RET
 
; PROCEDURE - Anfang (ITP3_SEKTOR_SCHREIBEN)
ITP3_SEKTOR_SCHREIBEN:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (DRIVE_D_DEVICE)
        LDS        R16, DRIVE_D_DEVICE
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x64)
        LDI        R18, 0x64
 
; Operator <
        CP         R16, R18
        BRCS       M_VERGL_0485
        CLR        R16
        RJMP       M_VERGL_0486
M_VERGL_0485:
        SER        R16
M_VERGL_0486:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0482
        RJMP       M_IF_0483
M_IF_0482:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (DRIVE_D_DEVICE)
        LDS        R16, DRIVE_D_DEVICE
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SEKTOR_SCHREIBEN)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDI        R16, 0x08
        MOV        R0, R16
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SEKTOR_SCHREIBEN)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0487:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0488
        RJMP       M_FTD_0489
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0488:
 
; ARRAY - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SEKTOR_SCHREIBEN)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SEKTOR_SCHREIBEN)
        POP        R0
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        SEKTOR_PUFFER_ZEIGER, R18
        STS        SEKTOR_PUFFER_ZEIGER+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0487
 
; FOR TO DO - Ende
M_FTD_0489:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; IF_THEN - Ende
M_IF_0483:
 
; PROCEDURE - Ende (ITP3_SEKTOR_SCHREIBEN)
        RET
 
; PROCEDURE - Anfang (ITP3_PRUEFE_EINEN_ANSCHLUSS)
ITP3_PRUEFE_EINEN_ANSCHLUSS:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer FUNCTION (ITP3_SENDE_TEST_BYTE)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf Funktion (ITP3_SENDE_TEST_BYTE)
        CALL       ITP3_SENDE_TEST_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (OK_BYTE)
        MOV        R0, R16
 
; IF THEN - Ausdruck / lokale, dynamische Variable VAR (OK_BYTE)
        MOV        R16, R0
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0490
        RJMP       M_IF_0491
M_IF_0490:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (ITP3_EMPFANGE_BYTE)
        CALL       ITP3_EMPFANGE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WHO_ARE_YOU_BYTE)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (WHO_ARE_YOU_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x80)
        LDI        R18, 0x80
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0496
        CLR        R16
        RJMP       M_VERGL_0497
M_VERGL_0496:
        SER        R16
M_VERGL_0497:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0493
        RJMP       M_IF_0494
M_IF_0493:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (DEV_NR)
        LDS        R16, DEV_NR
 
; Zuweisung Ziel /  VAR (CONOUT_DEVICE)
        STS        CONOUT_DEVICE, R16
 
; IF_THEN - Ende
M_IF_0494:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (WHO_ARE_YOU_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x40)
        LDI        R18, 0x40
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0501
        CLR        R16
        RJMP       M_VERGL_0502
M_VERGL_0501:
        SER        R16
M_VERGL_0502:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0498
        RJMP       M_IF_0499
M_IF_0498:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (DEV_NR)
        LDS        R16, DEV_NR
 
; Zuweisung Ziel /  VAR (CONIN_DEVICE)
        STS        CONIN_DEVICE, R16
 
; IF_THEN - Ende
M_IF_0499:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (WHO_ARE_YOU_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x20)
        LDI        R18, 0x20
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0506
        CLR        R16
        RJMP       M_VERGL_0507
M_VERGL_0506:
        SER        R16
M_VERGL_0507:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0503
        RJMP       M_IF_0504
M_IF_0503:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (DEV_NR)
        LDS        R16, DEV_NR
 
; Zuweisung Ziel /  VAR (LIST_DEVICE)
        STS        LIST_DEVICE, R16
 
; IF_THEN - Ende
M_IF_0504:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (WHO_ARE_YOU_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x10)
        LDI        R18, 0x10
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0511
        CLR        R16
        RJMP       M_VERGL_0512
M_VERGL_0511:
        SER        R16
M_VERGL_0512:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0508
        RJMP       M_IF_0509
M_IF_0508:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (DEV_NR)
        LDS        R16, DEV_NR
 
; Zuweisung Ziel /  VAR (SOUND_DEVICE)
        STS        SOUND_DEVICE, R16
 
; IF_THEN - Ende
M_IF_0509:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (WHO_ARE_YOU_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0516
        CLR        R16
        RJMP       M_VERGL_0517
M_VERGL_0516:
        SER        R16
M_VERGL_0517:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0513
        RJMP       M_IF_0514
M_IF_0513:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (DEV_NR)
        LDS        R16, DEV_NR
 
; Zuweisung Ziel /  VAR (DRIVE_D_DEVICE)
        STS        DRIVE_D_DEVICE, R16
 
; IF_THEN - Ende
M_IF_0514:
 
; IF_THEN - Ende
M_IF_0491:
 
; PROCEDURE - Ende (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        RET
 
; PROCEDURE - Anfang (ITP3_PRUEFE_ANSCHLUESSE)
ITP3_PRUEFE_ANSCHLUESSE:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS0)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS2)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS3)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS0)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS2)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS3)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS0)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS2)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS3)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; PROCEDURE - Ende (ITP3_PRUEFE_ANSCHLUESSE)
        RET
 
; PROCEDURE - Anfang (STD_AN_UART_SENDEN)
STD_AN_UART_SENDEN:
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOSTRING)
        LDS        R0, SECTOR
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('s')
        LDI        ZL, LOW(2*M_CONST_STRING_11)
        LDI        ZH, HIGH(2*M_CONST_STRING_11)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0518
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0518:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0520
M_PRG_CONST_STRING_0519:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0519
M_PRG_CONST_STRING_0520:
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0521
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0521:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0523
M_PRG_CONST_STRING_0522:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0522
M_PRG_CONST_STRING_0523:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0525
        MOV        R16, R17
M_PRG_CONST_STRING_0524:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0524
M_PRG_CONST_STRING_0525:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOSTRING)
        LDS        R0, TRACK_H
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0526
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0526:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0528
M_PRG_CONST_STRING_0527:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0527
M_PRG_CONST_STRING_0528:
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0529
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0529:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0531
M_PRG_CONST_STRING_0530:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0530
M_PRG_CONST_STRING_0531:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0533
        MOV        R16, R17
M_PRG_CONST_STRING_0532:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0532
M_PRG_CONST_STRING_0533:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOSTRING)
        LDS        R0, TRACK_L
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0534
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0534:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0536
M_PRG_CONST_STRING_0535:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0535
M_PRG_CONST_STRING_0536:
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0537
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0537:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0539
M_PRG_CONST_STRING_0538:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0538
M_PRG_CONST_STRING_0539:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0541
        MOV        R16, R17
M_PRG_CONST_STRING_0540:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0540
M_PRG_CONST_STRING_0541:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOSTRING)
        LDS        R0, DISKNO
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0542
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0542:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0544
M_PRG_CONST_STRING_0543:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0543
M_PRG_CONST_STRING_0544:
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0545
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0545:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0547
M_PRG_CONST_STRING_0546:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0546
M_PRG_CONST_STRING_0547:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0549
        MOV        R16, R17
M_PRG_CONST_STRING_0548:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0548
M_PRG_CONST_STRING_0549:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; PROCEDURE - Ende (STD_AN_UART_SENDEN)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_TO_SECTOR)
STEUER_STRING_TO_SECTOR:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0F)
        LDI        R16, 0x0F
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0550:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0551
        RJMP       M_FTD_0552
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0551:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B2)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; INC(B2) - Byte
        INC        R1
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0553
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0553:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0555
        MOV        R16, R17
M_PRG_CONST_STRING_0554:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0554
M_PRG_CONST_STRING_0555:
        ST         -Z, R17
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B2)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; INC(B2) - Byte
        INC        R1
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0556
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0556:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0558
M_PRG_CONST_STRING_0557:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0557
M_PRG_CONST_STRING_0558:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0559
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0559:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0561
        MOV        R16, R17
M_PRG_CONST_STRING_0560:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0560
M_PRG_CONST_STRING_0561:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_SECTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (STRINGTOBYTE)
        CALL       STRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_SECTOR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B3)
        MOV        R2, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B3)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(SEKTOR_PUFFER_ZEIGER) - Word
        LDS        R24, SEKTOR_PUFFER_ZEIGER
        LDS        R25, SEKTOR_PUFFER_ZEIGER+1
        ADIW       R25:R24, 1
        STS        SEKTOR_PUFFER_ZEIGER, R24
        STS        SEKTOR_PUFFER_ZEIGER+1, R25
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0550
 
; FOR TO DO - Ende
M_FTD_0552:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (STEUER_STRING_TO_SECTOR)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_TO_SECTOR_KOMP)
STEUER_STRING_TO_SECTOR_KOMP:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BITPOS_DB8)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB8)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (POS_SS)
        MOV        R6, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x26)
        LDI        R16, 0x26
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R6
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0562:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0563
        RJMP       M_FTD_0564
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0563:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (POS_SS)
        MOV        R16, R6
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R5
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB7)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BITPOS_DB7)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X2)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x06)
        LDI        R16, 0x06
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0565:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0566
        RJMP       M_FTD_0567
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0566:
 
; DEC(BITPOS_DB7) - Byte
        DEC        R4
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (DB7) retten
        MOV        R17, R1
 
; Parameter (BITPOS_DB7) retten
        MOV        R20, R4
 
; lokalen Parameter (DB7) an Funktion (READ_BIT_IN_BYTE)
        MOV        R0, R17
 
; lokalen Parameter (BITPOS_DB7) an Funktion (READ_BIT_IN_BYTE)
        MOV        R1, R20
 
; Aufruf Funktion (READ_BIT_IN_BYTE)
        CALL       READ_BIT_IN_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EIN_BIT)
        MOV        R7, R16
 
; IF THEN - Ausdruck / lokale, dynamische Variable VAR (EIN_BIT)
        MOV        R16, R7
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0568
        RJMP       M_IF_0569
M_IF_0568:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (DB8) retten
        MOV        R18, R2
 
; Parameter (BITPOS_DB8) retten
        MOV        R19, R3
 
; lokalen Parameter (DB8) an Funktion (SET_BIT_IN_BYTE)
        MOV        R0, R18
 
; lokalen Parameter (BITPOS_DB8) an Funktion (SET_BIT_IN_BYTE)
        MOV        R1, R19
 
; Aufruf Funktion (SET_BIT_IN_BYTE)
        CALL       SET_BIT_IN_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB8)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0570
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0569:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (DB8) retten
        MOV        R18, R2
 
; Parameter (BITPOS_DB8) retten
        MOV        R19, R3
 
; lokalen Parameter (DB8) an Funktion (CLEAR_BIT_IN_BYTE)
        MOV        R0, R18
 
; lokalen Parameter (BITPOS_DB8) an Funktion (CLEAR_BIT_IN_BYTE)
        MOV        R1, R19
 
; Aufruf Funktion (CLEAR_BIT_IN_BYTE)
        CALL       CLEAR_BIT_IN_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB8)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_0570:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (BITPOS_DB8)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0574
        CLR        R16
        RJMP       M_VERGL_0575
M_VERGL_0574:
        SER        R16
M_VERGL_0575:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0571
        RJMP       M_IF_0572
M_IF_0571:
 
; VAR ARRAY-1D POSITION - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (DB8)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(SEKTOR_PUFFER_ZEIGER) - Word
        LDS        R24, SEKTOR_PUFFER_ZEIGER
        LDS        R25, SEKTOR_PUFFER_ZEIGER+1
        ADIW       R25:R24, 1
        STS        SEKTOR_PUFFER_ZEIGER, R24
        STS        SEKTOR_PUFFER_ZEIGER+1, R25
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BITPOS_DB8)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB8)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0573
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0572:
 
; DEC(BITPOS_DB8) - Byte
        DEC        R3
 
; IF_THEN_ELSE - Ende
M_IF_0573:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0565
 
; FOR TO DO - Ende
M_FTD_0567:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R6
        INC        R17
        MOV        R6, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0562
 
; FOR TO DO - Ende
M_FTD_0564:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (STEUER_STRING_TO_SECTOR_KOMP)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_AUSWERTEN)
STEUER_STRING_AUSWERTEN:
 
; Zuweisung Quelle - Ausdruck / Length(STEUER_STRING)
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0579
        CLR        R16
        RJMP       M_VERGL_0580
M_VERGL_0579:
        SER        R16
M_VERGL_0580:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0576
        RJMP       M_IF_0577
M_IF_0576:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BUCHSTABE)
        MOV        R0, R16
 
; CASE OF - lokale, dynamische Variable VAR (BUCHSTABE)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (T)
        CPI        R16, 'T'
        BREQ       M_CASE_0583
        RJMP       M_CASE_0582
M_CASE_0583:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x03)
        LDI        R18, 0x03
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0587
        CLR        R16
        RJMP       M_VERGL_0588
M_VERGL_0587:
        SER        R16
M_VERGL_0588:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0584
        RJMP       M_IF_0585
M_IF_0584:
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEICHEN_1)
        MOV        R1, R16
 
; ARRAY - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEICHEN_2)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ZEICHEN_1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0589
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0589:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (ZEICHEN_2)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0590
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0590:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0592
        MOV        R16, R17
M_PRG_CONST_STRING_0591:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0591
M_PRG_CONST_STRING_0592:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (STRINGTOBYTE)
        CALL       STRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (CONSOLEIN_GELESEN)
        STS        CONSOLEIN_GELESEN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0586
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0585:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x01')
        LDI        ZL, LOW(2*M_CONST_STRING_12)
        LDI        ZH, HIGH(2*M_CONST_STRING_12)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0593
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0593:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0595
M_PRG_CONST_STRING_0594:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0594
M_PRG_CONST_STRING_0595:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0597
        MOV        R16, R17
M_PRG_CONST_STRING_0596:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0596
M_PRG_CONST_STRING_0597:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0586:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0581
M_CASE_0582:
 
; CASE OF - vergleiche Einzel-Element (U)
        CPI        R16, 'U'
        BREQ       M_CASE_0599
        RJMP       M_CASE_0598
M_CASE_0599:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x21)
        LDI        R18, 0x21
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0603
        CLR        R16
        RJMP       M_VERGL_0604
M_VERGL_0603:
        SER        R16
M_VERGL_0604:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0600
        RJMP       M_IF_0601
M_IF_0600:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (STEUER_STRING_TO_SECTOR)
        CALL       STEUER_STRING_TO_SECTOR
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0602
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0601:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x03')
        LDI        ZL, LOW(2*M_CONST_STRING_13)
        LDI        ZH, HIGH(2*M_CONST_STRING_13)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0605
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0605:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0607
M_PRG_CONST_STRING_0606:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0606
M_PRG_CONST_STRING_0607:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0609
        MOV        R16, R17
M_PRG_CONST_STRING_0608:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0608
M_PRG_CONST_STRING_0609:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0602:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0581
M_CASE_0598:
 
; CASE OF - vergleiche Einzel-Element (R)
        CPI        R16, 'R'
        BREQ       M_CASE_0611
        RJMP       M_CASE_0610
M_CASE_0611:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x26)
        LDI        R18, 0x26
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0615
        CLR        R16
        RJMP       M_VERGL_0616
M_VERGL_0615:
        SER        R16
M_VERGL_0616:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0612
        RJMP       M_IF_0613
M_IF_0612:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        CALL       STEUER_STRING_TO_SECTOR_KOMP
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0614
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0613:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x07')
        LDI        ZL, LOW(2*M_CONST_STRING_14)
        LDI        ZH, HIGH(2*M_CONST_STRING_14)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0617
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0617:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0619
M_PRG_CONST_STRING_0618:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0618
M_PRG_CONST_STRING_0619:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0621
        MOV        R16, R17
M_PRG_CONST_STRING_0620:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0620
M_PRG_CONST_STRING_0621:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0614:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0581
 
; CASE OF ELSE
M_CASE_0610:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x02')
        LDI        ZL, LOW(2*M_CONST_STRING_15)
        LDI        ZH, HIGH(2*M_CONST_STRING_15)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0622
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0622:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0624
M_PRG_CONST_STRING_0623:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0623
M_PRG_CONST_STRING_0624:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0626
        MOV        R16, R17
M_PRG_CONST_STRING_0625:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0625
M_PRG_CONST_STRING_0626:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0581:
 
; IF_THEN - Ende
M_IF_0577:
 
; PROCEDURE - Ende (STEUER_STRING_AUSWERTEN)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_LESEN)
STEUER_STRING_LESEN:
 
; Zuweisung Quelle - Ausdruck / Byte-REG UDR
        IN         R16, UDR
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EMPF_ZEICHEN)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (EMPF_ZEICHEN)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0D)
        LDI        R18, 0x0D
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0630
        CLR        R16
        RJMP       M_VERGL_0631
M_VERGL_0630:
        SER        R16
M_VERGL_0631:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0627
        RJMP       M_IF_0628
M_IF_0627:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (EMPF_ZEICHEN)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0A)
        LDI        R18, 0x0A
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0635
        CLR        R16
        RJMP       M_VERGL_0636
M_VERGL_0635:
        SER        R16
M_VERGL_0636:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0632
        RJMP       M_IF_0633
M_IF_0632:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_LESEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (STEUER_STRING_AUSWERTEN)
        CALL       STEUER_STRING_AUSWERTEN
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_LESEN)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (STEUER_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('')
        LDI        ZL, LOW(2*M_CONST_STRING_16)
        LDI        ZH, HIGH(2*M_CONST_STRING_16)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0637
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0637:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0639
M_PRG_CONST_STRING_0638:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0638
M_PRG_CONST_STRING_0639:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (STEUER_STRING) - Laenge in R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0641
        MOV        R16, R17
M_PRG_CONST_STRING_0640:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0640
M_PRG_CONST_STRING_0641:
        ST         -Z, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0634
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0633:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(EMPF_ZEICHEN)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (AKT_ZEICHEN)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (STEUER_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0642
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0642:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0644
M_PRG_CONST_STRING_0643:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0643
M_PRG_CONST_STRING_0644:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (AKT_ZEICHEN)
        MOV        R19, R0
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0645
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0645:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (STEUER_STRING) - Laenge in R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0647
        MOV        R16, R17
M_PRG_CONST_STRING_0646:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0646
M_PRG_CONST_STRING_0647:
        ST         -Z, R17
 
; IF_THEN_ELSE - Ende
M_IF_0634:
 
; IF_THEN - Ende
M_IF_0628:
 
; PROCEDURE - Ende (STEUER_STRING_LESEN)
        RET
 
; PROCEDURE - Anfang (SEKTOR_VON_UART_LESEN)
SEKTOR_VON_UART_LESEN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPZ)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0648:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0649
        RJMP       M_FTD_0650
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0649:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_UART_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('u')
        LDI        ZL, LOW(2*M_CONST_STRING_17)
        LDI        ZH, HIGH(2*M_CONST_STRING_17)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0651
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0651:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0653
M_PRG_CONST_STRING_0652:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0652
M_PRG_CONST_STRING_0653:
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0654
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0654:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0656
M_PRG_CONST_STRING_0655:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0655
M_PRG_CONST_STRING_0656:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0658
        MOV        R16, R17
M_PRG_CONST_STRING_0657:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0657
M_PRG_CONST_STRING_0658:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_UART_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; WHILE DO ...
M_WHILE_0659:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R4
        MOV        R17, R5
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0662
        CLR        R16
        RJMP       M_VERGL_0663
M_VERGL_0662:
        SER        R16
M_VERGL_0663:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0660
        RJMP       M_WHILE_0661
M_WHILE_0660:
 
; IF THEN - Ausdruck /; BitHigh(RXC)
        IN         R16, UCSRA
        BST        R16, 7
        BRTS       M_VERGL_0667
        CLR        R16
        RJMP       M_VERGL_0668
M_VERGL_0667:
        SER        R16
M_VERGL_0668:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0664
        RJMP       M_IF_0665
M_IF_0664:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_UART_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (SPZ)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0672
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0673
M_VERGL_0672:
        SER        R16
M_VERGL_0673:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0669
        RJMP       M_IF_0670
M_IF_0669:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0671
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0670:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPZ)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN_ELSE - Ende
M_IF_0671:
 
; IF_THEN - Ende
M_IF_0665:
 
; DEC(LESESCHLEIFE) - Word
        MOV        R24, R4
        MOV        R25, R5
        SBIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; WHILE DO ...
        RJMP       M_WHILE_0659
M_WHILE_0661:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0677
        CLR        R16
        RJMP       M_VERGL_0678
M_VERGL_0677:
        SER        R16
M_VERGL_0678:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0674
        RJMP       M_IF_0675
M_IF_0674:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x04')
        LDI        ZL, LOW(2*M_CONST_STRING_18)
        LDI        ZH, HIGH(2*M_CONST_STRING_18)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0679
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0679:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0681
M_PRG_CONST_STRING_0680:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0680
M_PRG_CONST_STRING_0681:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0683
        MOV        R16, R17
M_PRG_CONST_STRING_0682:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0682
M_PRG_CONST_STRING_0683:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_UART_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0675:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0648
 
; FOR TO DO - Ende
M_FTD_0650:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (SEKTOR_VON_UART_LESEN)
        RET
 
; PROCEDURE - Anfang (SEKTOR_VON_UART_LESEN_KOMP)
SEKTOR_VON_UART_LESEN_KOMP:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPZ)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0684:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0685
        RJMP       M_FTD_0686
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0685:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('r')
        LDI        ZL, LOW(2*M_CONST_STRING_19)
        LDI        ZH, HIGH(2*M_CONST_STRING_19)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0687
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0687:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0689
M_PRG_CONST_STRING_0688:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0688
M_PRG_CONST_STRING_0689:
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0690
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0690:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0692
M_PRG_CONST_STRING_0691:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0691
M_PRG_CONST_STRING_0692:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0694
        MOV        R16, R17
M_PRG_CONST_STRING_0693:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0693
M_PRG_CONST_STRING_0694:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; WHILE DO ...
M_WHILE_0695:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R4
        MOV        R17, R5
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0698
        CLR        R16
        RJMP       M_VERGL_0699
M_VERGL_0698:
        SER        R16
M_VERGL_0699:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0696
        RJMP       M_WHILE_0697
M_WHILE_0696:
 
; IF THEN - Ausdruck /; BitHigh(RXC)
        IN         R16, UCSRA
        BST        R16, 7
        BRTS       M_VERGL_0703
        CLR        R16
        RJMP       M_VERGL_0704
M_VERGL_0703:
        SER        R16
M_VERGL_0704:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0700
        RJMP       M_IF_0701
M_IF_0700:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (SPZ)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0708
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0709
M_VERGL_0708:
        SER        R16
M_VERGL_0709:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0705
        RJMP       M_IF_0706
M_IF_0705:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0707
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0706:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPZ)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN_ELSE - Ende
M_IF_0707:
 
; IF_THEN - Ende
M_IF_0701:
 
; DEC(LESESCHLEIFE) - Word
        MOV        R24, R4
        MOV        R25, R5
        SBIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; WHILE DO ...
        RJMP       M_WHILE_0695
M_WHILE_0697:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0713
        CLR        R16
        RJMP       M_VERGL_0714
M_VERGL_0713:
        SER        R16
M_VERGL_0714:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0710
        RJMP       M_IF_0711
M_IF_0710:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x08')
        LDI        ZL, LOW(2*M_CONST_STRING_20)
        LDI        ZH, HIGH(2*M_CONST_STRING_20)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0715
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0715:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0717
M_PRG_CONST_STRING_0716:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0716
M_PRG_CONST_STRING_0717:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0719
        MOV        R16, R17
M_PRG_CONST_STRING_0718:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0718
M_PRG_CONST_STRING_0719:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0711:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0684
 
; FOR TO DO - Ende
M_FTD_0686:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (SEKTOR_VON_UART_LESEN_KOMP)
        RET
 
; PROCEDURE - Anfang (SEKTOR_AN_UART_SENDEN)
SEKTOR_AN_UART_SENDEN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0720:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0721
        RJMP       M_FTD_0722
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0721:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_AN_UART_SENDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_AN_UART_SENDEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('v')
        LDI        ZL, LOW(2*M_CONST_STRING_21)
        LDI        ZH, HIGH(2*M_CONST_STRING_21)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0723
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0723:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0725
M_PRG_CONST_STRING_0724:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0724
M_PRG_CONST_STRING_0725:
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0726
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0726:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0728
M_PRG_CONST_STRING_0727:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0727
M_PRG_CONST_STRING_0728:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0730
        MOV        R16, R17
M_PRG_CONST_STRING_0729:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0729
M_PRG_CONST_STRING_0730:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0F)
        LDI        R16, 0x0F
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R1
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0731:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0732
        RJMP       M_FTD_0733
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0732:
 
; ARRAY - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B3)
        MOV        R2, R16
 
; INC(SEKTOR_PUFFER_ZEIGER) - Word
        LDS        R24, SEKTOR_PUFFER_ZEIGER
        LDS        R25, SEKTOR_PUFFER_ZEIGER+1
        ADIW       R25:R24, 1
        STS        SEKTOR_PUFFER_ZEIGER, R24
        STS        SEKTOR_PUFFER_ZEIGER+1, R25
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_AN_UART_SENDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (B3) retten
        MOV        R18, R2
 
; lokalen Parameter (B3) an Prozedur (BYTETOSTRING)
        MOV        R0, R18
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_AN_UART_SENDEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0734
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0734:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0736
M_PRG_CONST_STRING_0735:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0735
M_PRG_CONST_STRING_0736:
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0737
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0737:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0739
M_PRG_CONST_STRING_0738:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0738
M_PRG_CONST_STRING_0739:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0741
        MOV        R16, R17
M_PRG_CONST_STRING_0740:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0740
M_PRG_CONST_STRING_0741:
        ST         -Z, R17
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R1
        INC        R17
        MOV        R1, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0731
 
; FOR TO DO - Ende
M_FTD_0733:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0742
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0742:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0744
M_PRG_CONST_STRING_0743:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0743
M_PRG_CONST_STRING_0744:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0746
        MOV        R16, R17
M_PRG_CONST_STRING_0745:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0745
M_PRG_CONST_STRING_0746:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_AN_UART_SENDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_AN_UART_SENDEN)
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0720
 
; FOR TO DO - Ende
M_FTD_0722:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (SEKTOR_AN_UART_SENDEN)
        RET
 
; PROCEDURE - Anfang (CONST_VON_UART_LESEN)
CONST_VON_UART_LESEN:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('j')
        LDI        ZL, LOW(2*M_CONST_STRING_22)
        LDI        ZH, HIGH(2*M_CONST_STRING_22)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0747
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0747:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0749
M_PRG_CONST_STRING_0748:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0748
M_PRG_CONST_STRING_0749:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0751
        MOV        R16, R17
M_PRG_CONST_STRING_0750:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0750
M_PRG_CONST_STRING_0751:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (CONST_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (CONST_VON_UART_LESEN)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONSOLEIN_GELESEN)
        STS        CONSOLEIN_GELESEN, R16
 
; WHILE DO ...
M_WHILE_0752:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R0
        MOV        R17, R1
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0755
        CLR        R16
        RJMP       M_VERGL_0756
M_VERGL_0755:
        SER        R16
M_VERGL_0756:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0753
        RJMP       M_WHILE_0754
M_WHILE_0753:
 
; IF THEN - Ausdruck /; BitHigh(RXC)
        IN         R16, UCSRA
        BST        R16, 7
        BRTS       M_VERGL_0760
        CLR        R16
        RJMP       M_VERGL_0761
M_VERGL_0760:
        SER        R16
M_VERGL_0761:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0757
        RJMP       M_IF_0758
M_IF_0757:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONST_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (CONST_VON_UART_LESEN)
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck / Byte-VAR (CONSOLEIN_GELESEN)
        LDS        R16, CONSOLEIN_GELESEN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0762
        RJMP       M_IF_0763
M_IF_0762:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0764
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0763:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
 
; IF_THEN_ELSE - Ende
M_IF_0764:
 
; IF_THEN - Ende
M_IF_0758:
 
; DEC(LESESCHLEIFE) - Word
        MOV        R24, R0
        MOV        R25, R1
        SBIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; WHILE DO ...
        RJMP       M_WHILE_0752
M_WHILE_0754:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R0
        MOV        R17, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0768
        CLR        R16
        RJMP       M_VERGL_0769
M_VERGL_0768:
        SER        R16
M_VERGL_0769:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0765
        RJMP       M_IF_0766
M_IF_0765:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x11')
        LDI        ZL, LOW(2*M_CONST_STRING_23)
        LDI        ZH, HIGH(2*M_CONST_STRING_23)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0770
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0770:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0772
M_PRG_CONST_STRING_0771:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0771
M_PRG_CONST_STRING_0772:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0774
        MOV        R16, R17
M_PRG_CONST_STRING_0773:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0773
M_PRG_CONST_STRING_0774:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (CONST_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (CONST_VON_UART_LESEN)
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0766:
 
; PROCEDURE - Ende (CONST_VON_UART_LESEN)
        RET
 
; PROCEDURE - Anfang (CONIN_VON_UART_LESEN)
CONIN_VON_UART_LESEN:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('i')
        LDI        ZL, LOW(2*M_CONST_STRING_24)
        LDI        ZH, HIGH(2*M_CONST_STRING_24)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0775
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0775:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0777
M_PRG_CONST_STRING_0776:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0776
M_PRG_CONST_STRING_0777:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0779
        MOV        R16, R17
M_PRG_CONST_STRING_0778:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0778
M_PRG_CONST_STRING_0779:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (CONIN_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (CONIN_VON_UART_LESEN)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONSOLEIN_GELESEN)
        STS        CONSOLEIN_GELESEN, R16
 
; WHILE DO ...
M_WHILE_0780:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R0
        MOV        R17, R1
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0783
        CLR        R16
        RJMP       M_VERGL_0784
M_VERGL_0783:
        SER        R16
M_VERGL_0784:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0781
        RJMP       M_WHILE_0782
M_WHILE_0781:
 
; IF THEN - Ausdruck /; BitHigh(RXC)
        IN         R16, UCSRA
        BST        R16, 7
        BRTS       M_VERGL_0788
        CLR        R16
        RJMP       M_VERGL_0789
M_VERGL_0788:
        SER        R16
M_VERGL_0789:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0785
        RJMP       M_IF_0786
M_IF_0785:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONIN_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (CONIN_VON_UART_LESEN)
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck / Byte-VAR (CONSOLEIN_GELESEN)
        LDS        R16, CONSOLEIN_GELESEN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0790
        RJMP       M_IF_0791
M_IF_0790:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0792
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0791:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
 
; IF_THEN_ELSE - Ende
M_IF_0792:
 
; IF_THEN - Ende
M_IF_0786:
 
; DEC(LESESCHLEIFE) - Word
        MOV        R24, R0
        MOV        R25, R1
        SBIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; WHILE DO ...
        RJMP       M_WHILE_0780
M_WHILE_0782:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R0
        MOV        R17, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0796
        CLR        R16
        RJMP       M_VERGL_0797
M_VERGL_0796:
        SER        R16
M_VERGL_0797:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0793
        RJMP       M_IF_0794
M_IF_0793:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x12')
        LDI        ZL, LOW(2*M_CONST_STRING_25)
        LDI        ZH, HIGH(2*M_CONST_STRING_25)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0798
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0798:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0800
M_PRG_CONST_STRING_0799:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0799
M_PRG_CONST_STRING_0800:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0802
        MOV        R16, R17
M_PRG_CONST_STRING_0801:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0801
M_PRG_CONST_STRING_0802:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (CONIN_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (CONIN_VON_UART_LESEN)
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0794:
 
; PROCEDURE - Ende (CONIN_VON_UART_LESEN)
        RET
 
; PROCEDURE - Anfang (UART_CONIN_SCHLEIFE)
UART_CONIN_SCHLEIFE:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; WHILE DO ...
M_WHILE_0803:
 
; WHILE - Ausdruck erster Faktor / Byte-VAR (CONSOLEIN)
        LDS        R16, CONSOLEIN
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0806
        CLR        R16
        RJMP       M_VERGL_0807
M_VERGL_0806:
        SER        R16
M_VERGL_0807:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0804
        RJMP       M_WHILE_0805
M_WHILE_0804:
 
; Aufruf PROCEDURE (CONST_VON_UART_LESEN)
        CALL       CONST_VON_UART_LESEN
 
; WHILE DO ...
        RJMP       M_WHILE_0803
M_WHILE_0805:
 
; Aufruf PROCEDURE (CONIN_VON_UART_LESEN)
        CALL       CONIN_VON_UART_LESEN
 
; PROCEDURE - Ende (UART_CONIN_SCHLEIFE)
        RET
 
; PROCEDURE - Anfang (UART_CONOUT_SENDEN)
UART_CONOUT_SENDEN:
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOSTRING)
        LDS        R0, CONSOLEOUT
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SER0_STRING)=40
        LDI        R16, 40
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('o')
        LDI        ZL, LOW(2*M_CONST_STRING_26)
        LDI        ZH, HIGH(2*M_CONST_STRING_26)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0808
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0808:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0810
M_PRG_CONST_STRING_0809:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0809
M_PRG_CONST_STRING_0810:
        LDI        ZL, LOW(BYTE_STRING)
        LDI        ZH, HIGH(BYTE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0811
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0811:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0813
M_PRG_CONST_STRING_0812:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0812
M_PRG_CONST_STRING_0813:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0815
        MOV        R16, R17
M_PRG_CONST_STRING_0814:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0814
M_PRG_CONST_STRING_0815:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; PROCEDURE - Ende (UART_CONOUT_SENDEN)
        RET
 
; PROCEDURE - Anfang (UART_ABFRAGESCHLEIFE_SER0)
UART_ABFRAGESCHLEIFE_SER0:
 
; WHILE DO ...
M_WHILE_0816:
 
; WHILE - Ausdruck erster Faktor / Byte-VAR (SER0_DETECTED)
        LDS        R16, SER0_DETECTED
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0819
        CLR        R16
        RJMP       M_VERGL_0820
M_VERGL_0819:
        SER        R16
M_VERGL_0820:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0817
        RJMP       M_WHILE_0818
M_WHILE_0817:
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (XON_AKTIV)
        STS        XON_AKTIV, R16
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; WHILE DO ...
M_WHILE_0821:
 
; WHILE - Ausdruck /; BitHigh(RXC)
        IN         R16, UCSRA
        BST        R16, 7
        BRTS       M_VERGL_0824
        CLR        R16
        RJMP       M_VERGL_0825
M_VERGL_0824:
        SER        R16
M_VERGL_0825:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0822
        RJMP       M_WHILE_0823
M_WHILE_0822:
 
; Aufruf PROCEDURE (RX0_WAIT_BEFORE_SENDING_ABFRAGEN)
        CALL       RX0_WAIT_BEFORE_SENDING_ABFRAGEN
 
; WHILE DO ...
        RJMP       M_WHILE_0821
M_WHILE_0823:
 
; WHILE DO ...
        RJMP       M_WHILE_0816
M_WHILE_0818:
 
; PROCEDURE - Ende (UART_ABFRAGESCHLEIFE_SER0)
        RET
 
; PROCEDURE - Anfang (WARTE_SOLANGE_RD_HIGH)
WARTE_SOLANGE_RD_HIGH:
 
; WHILE DO ...
M_WHILE_0826:
 
; WHILE - Ausdruck /; BitHigh(RD_Z80_E)
        IN         R16, PIND
        BST        R16, 4
        BRTS       M_VERGL_0829
        CLR        R16
        RJMP       M_VERGL_0830
M_VERGL_0829:
        SER        R16
M_VERGL_0830:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0827
        RJMP       M_WHILE_0828
M_WHILE_0827:
 
; IF THEN - Ausdruck /; BitHigh(RD_Z80_E)
        IN         R16, PIND
        BST        R16, 4
        BRTS       M_VERGL_0834
        CLR        R16
        RJMP       M_VERGL_0835
M_VERGL_0834:
        SER        R16
M_VERGL_0835:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0831
        RJMP       M_IF_0832
M_IF_0831:
 
; SetBit(CLK_Z80)
        SBI        PORTD, 7
 
; IF_THEN - Ende
M_IF_0832:
 
; IF THEN - Ausdruck /; BitHigh(RD_Z80_E)
        IN         R16, PIND
        BST        R16, 4
        BRTS       M_VERGL_0839
        CLR        R16
        RJMP       M_VERGL_0840
M_VERGL_0839:
        SER        R16
M_VERGL_0840:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0836
        RJMP       M_IF_0837
M_IF_0836:
 
; ClearBit(CLK_Z80)
        CBI        PORTD, 7
 
; IF_THEN - Ende
M_IF_0837:
 
; WHILE DO ...
        RJMP       M_WHILE_0826
M_WHILE_0828:
 
; PROCEDURE - Ende (WARTE_SOLANGE_RD_HIGH)
        RET
 
; PROCEDURE - Anfang (WARTE_SOLANGE_RD_LOW)
WARTE_SOLANGE_RD_LOW:
 
; WHILE DO ...
M_WHILE_0841:
 
; WHILE - Ausdruck /; BitLow(RD_Z80_E)
        IN         R16, PIND
        BST        R16, 4
        BRTC       M_VERGL_0844
        CLR        R16
        RJMP       M_VERGL_0845
M_VERGL_0844:
        SER        R16
M_VERGL_0845:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0842
        RJMP       M_WHILE_0843
M_WHILE_0842:
 
; SetBit(CLK_Z80)
        SBI        PORTD, 7
 
; NOP
        NOP
 
; ClearBit(CLK_Z80)
        CBI        PORTD, 7
 
; WHILE DO ...
        RJMP       M_WHILE_0841
M_WHILE_0843:
 
; PROCEDURE - Ende (WARTE_SOLANGE_RD_LOW)
        RET
 
; PROCEDURE - Anfang (WARTE_SOLANGE_IORQ_HIGH)
WARTE_SOLANGE_IORQ_HIGH:
 
; WHILE DO ...
M_WHILE_0846:
 
; WHILE - Ausdruck /; BitHigh(IORQ_Z80_E)
        IN         R16, PINB
        BST        R16, 1
        BRTS       M_VERGL_0849
        CLR        R16
        RJMP       M_VERGL_0850
M_VERGL_0849:
        SER        R16
M_VERGL_0850:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0847
        RJMP       M_WHILE_0848
M_WHILE_0847:
 
; IF THEN - Ausdruck /; BitHigh(IORQ_Z80_E)
        IN         R16, PINB
        BST        R16, 1
        BRTS       M_VERGL_0854
        CLR        R16
        RJMP       M_VERGL_0855
M_VERGL_0854:
        SER        R16
M_VERGL_0855:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0851
        RJMP       M_IF_0852
M_IF_0851:
 
; SetBit(CLK_Z80)
        SBI        PORTD, 7
 
; IF_THEN - Ende
M_IF_0852:
 
; IF THEN - Ausdruck /; BitHigh(IORQ_Z80_E)
        IN         R16, PINB
        BST        R16, 1
        BRTS       M_VERGL_0859
        CLR        R16
        RJMP       M_VERGL_0860
M_VERGL_0859:
        SER        R16
M_VERGL_0860:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0856
        RJMP       M_IF_0857
M_IF_0856:
 
; ClearBit(CLK_Z80)
        CBI        PORTD, 7
 
; IF_THEN - Ende
M_IF_0857:
 
; WHILE DO ...
        RJMP       M_WHILE_0846
M_WHILE_0848:
 
; PROCEDURE - Ende (WARTE_SOLANGE_IORQ_HIGH)
        RET
 
; PROCEDURE - Anfang (WARTE_SOLANGE_IORQ_LOW)
WARTE_SOLANGE_IORQ_LOW:
 
; WHILE DO ...
M_WHILE_0861:
 
; WHILE - Ausdruck /; BitLow(IORQ_Z80_E)
        IN         R16, PINB
        BST        R16, 1
        BRTC       M_VERGL_0864
        CLR        R16
        RJMP       M_VERGL_0865
M_VERGL_0864:
        SER        R16
M_VERGL_0865:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0862
        RJMP       M_WHILE_0863
M_WHILE_0862:
 
; SetBit(CLK_Z80)
        SBI        PORTD, 7
 
; NOP
        NOP
 
; ClearBit(CLK_Z80)
        CBI        PORTD, 7
 
; WHILE DO ...
        RJMP       M_WHILE_0861
M_WHILE_0863:
 
; PROCEDURE - Ende (WARTE_SOLANGE_IORQ_LOW)
        RET
 
; PROCEDURE - Anfang (SETZE_RAM_PAGE)
SETZE_RAM_PAGE:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (RAM_ADR)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_PORT)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RAM_PORT)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0869
        CLR        R16
        RJMP       M_VERGL_0870
M_VERGL_0869:
        SER        R16
M_VERGL_0870:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0866
        RJMP       M_IF_0867
M_IF_0866:
 
; ClearBit(A16_RAM)
        CBI        PORTB, 5
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0868
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0867:
 
; SetBit(A16_RAM)
        SBI        PORTB, 5
 
; IF_THEN_ELSE - Ende
M_IF_0868:
 
; SetBit(A17_RAM)
        SBI        PORTB, 6
 
; ClearBit(A18_RAM)
        CBI        PORTB, 7
 
; PROCEDURE - Ende (SETZE_RAM_PAGE)
        RET
 
; PROCEDURE - Anfang (START_RAM2ARR)
START_RAM2ARR:
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_ADR)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(G_RAMSW)
        SBI        PORTB, 4
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; SetBit(OE_RAM_D)
        SBI        DDRB, 2
 
; SetBit(WE_RAM_D)
        SBI        DDRB, 3
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (RAM_ADR) retten
        MOV        R19, R3
 
; lokalen Parameter (RAM_ADR) an Prozedur (SETZE_RAM_PAGE)
        MOV        R0, R19
 
; Aufruf PROCEDURE (SETZE_RAM_PAGE)
        CALL       SETZE_RAM_PAGE
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0871:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0872
        RJMP       M_FTD_0873
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0872:
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ClearBit(OE_RAM_A)
        CBI        PORTB, 2
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R2, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0871
 
; FOR TO DO - Ende
M_FTD_0873:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; ClearBit(A16_RAM)
        CBI        PORTB, 5
 
; SetBit(A17_RAM)
        SBI        PORTB, 6
 
; ClearBit(A18_RAM)
        CBI        PORTB, 7
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC9)
        LDI        R16, 0xC9
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; ClearBit(OE_RAM_D)
        CBI        DDRB, 2
 
; ClearBit(WE_RAM_D)
        CBI        DDRB, 3
 
; ClearBit(G_RAMSW)
        CBI        PORTB, 4
 
; PROCEDURE - Ende (START_RAM2ARR)
        RET
 
; PROCEDURE - Anfang (START_ARR2RAM)
START_ARR2RAM:
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_ADR)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(G_RAMSW)
        SBI        PORTB, 4
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; SetBit(OE_RAM_D)
        SBI        DDRB, 2
 
; SetBit(WE_RAM_D)
        SBI        DDRB, 3
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (RAM_ADR) retten
        MOV        R19, R3
 
; lokalen Parameter (RAM_ADR) an Prozedur (SETZE_RAM_PAGE)
        MOV        R0, R19
 
; Aufruf PROCEDURE (SETZE_RAM_PAGE)
        CALL       SETZE_RAM_PAGE
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0874:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0875
        RJMP       M_FTD_0876
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0875:
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE_RAM_A)
        CBI        PORTB, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0874
 
; FOR TO DO - Ende
M_FTD_0876:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; ClearBit(A16_RAM)
        CBI        PORTB, 5
 
; SetBit(A17_RAM)
        SBI        PORTB, 6
 
; ClearBit(A18_RAM)
        CBI        PORTB, 7
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC9)
        LDI        R16, 0xC9
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; ClearBit(OE_RAM_D)
        CBI        DDRB, 2
 
; ClearBit(WE_RAM_D)
        CBI        DDRB, 3
 
; ClearBit(G_RAMSW)
        CBI        PORTB, 4
 
; PROCEDURE - Ende (START_ARR2RAM)
        RET
 
; PROCEDURE - Anfang (START_BDOS2RAM)
START_BDOS2RAM:
 
; Retten der lokalen Parameter fuer PROCEDURE (START_BDOS2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_BDOS2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_BDOS2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_BDOS2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_BDOS2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_BDOS2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(G_RAMSW)
        SBI        PORTB, 4
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; SetBit(OE_RAM_D)
        SBI        DDRB, 2
 
; SetBit(WE_RAM_D)
        SBI        DDRB, 3
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; ClearBit(A16_RAM)
        CBI        PORTB, 5
 
; SetBit(A17_RAM)
        SBI        PORTB, 6
 
; ClearBit(A18_RAM)
        CBI        PORTB, 7
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LAENGE_BDOS_ARRAY)
        LDI        R16, LOW(0x0DFF)
        LDI        R17, HIGH(0x0DFF)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0877:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0878
        RJMP       M_FTD_0879
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0878:
 
; Retten der lokalen Parameter fuer PROCEDURE (START_BDOS2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_BDOS2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (BDOS_ARR)
        LDI        ZL, LOW(2*BDOS_ARR)
        LDI        ZH, HIGH(2*BDOS_ARR)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE_RAM_A)
        CBI        PORTB, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_BDOS2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_BDOS2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0877
 
; FOR TO DO - Ende
M_FTD_0879:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_BDOS2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_BDOS2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC9)
        LDI        R16, 0xC9
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_BDOS2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_BDOS2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; ClearBit(OE_RAM_D)
        CBI        DDRB, 2
 
; ClearBit(WE_RAM_D)
        CBI        DDRB, 3
 
; ClearBit(G_RAMSW)
        CBI        PORTB, 4
 
; PROCEDURE - Ende (START_BDOS2RAM)
        RET
 
; PROCEDURE - Anfang (START_CCP2RAM)
START_CCP2RAM:
 
; Retten der lokalen Parameter fuer PROCEDURE (START_CCP2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_CCP2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_CCP2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_CCP2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_CCP2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_CCP2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(G_RAMSW)
        SBI        PORTB, 4
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; SetBit(OE_RAM_D)
        SBI        DDRB, 2
 
; SetBit(WE_RAM_D)
        SBI        DDRB, 3
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; ClearBit(A16_RAM)
        CBI        PORTB, 5
 
; SetBit(A17_RAM)
        SBI        PORTB, 6
 
; ClearBit(A18_RAM)
        CBI        PORTB, 7
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LAENGE_CCP_ARRAY)
        LDI        R16, LOW(0x07FF)
        LDI        R17, HIGH(0x07FF)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0880:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0881
        RJMP       M_FTD_0882
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0881:
 
; Retten der lokalen Parameter fuer PROCEDURE (START_CCP2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_CCP2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CCP_ARR)
        LDI        ZL, LOW(2*CCP_ARR)
        LDI        ZH, HIGH(2*CCP_ARR)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE_RAM_A)
        CBI        PORTB, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_CCP2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_CCP2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0880
 
; FOR TO DO - Ende
M_FTD_0882:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_CCP2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_CCP2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC9)
        LDI        R16, 0xC9
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_CCP2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_CCP2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; ClearBit(OE_RAM_D)
        CBI        DDRB, 2
 
; ClearBit(WE_RAM_D)
        CBI        DDRB, 3
 
; ClearBit(G_RAMSW)
        CBI        PORTB, 4
 
; PROCEDURE - Ende (START_CCP2RAM)
        RET
 
; PROCEDURE - Anfang (COPY_DISK_TO_RAM)
COPY_DISK_TO_RAM:
 
; Retten der lokalen Parameter fuer PROCEDURE (COPY_DISK_TO_RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (COPY_DISK_TO_RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (COPY_DISK_TO_RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (COPY_DISK_TO_RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (COPY_DISK_TO_RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (COPY_DISK_TO_RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(G_RAMSW)
        SBI        PORTB, 4
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; SetBit(OE_RAM_D)
        SBI        DDRB, 2
 
; SetBit(WE_RAM_D)
        SBI        DDRB, 3
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; SetBit(A16_RAM)
        SBI        PORTB, 5
 
; SetBit(A17_RAM)
        SBI        PORTB, 6
 
; ClearBit(A18_RAM)
        CBI        PORTB, 7
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LAENGE_DISK_ARRAY)
        LDI        R16, LOW(0x088F)
        LDI        R17, HIGH(0x088F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0883:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0884
        RJMP       M_FTD_0885
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0884:
 
; Retten der lokalen Parameter fuer PROCEDURE (COPY_DISK_TO_RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (COPY_DISK_TO_RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (DISK_ARR)
        LDI        ZL, LOW(2*DISK_ARR)
        LDI        ZH, HIGH(2*DISK_ARR)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE_RAM_A)
        CBI        PORTB, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (COPY_DISK_TO_RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (COPY_DISK_TO_RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0883
 
; FOR TO DO - Ende
M_FTD_0885:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (COPY_DISK_TO_RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (COPY_DISK_TO_RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC9)
        LDI        R16, 0xC9
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (COPY_DISK_TO_RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (COPY_DISK_TO_RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ClearBit(A16_RAM)
        CBI        PORTB, 5
 
; SetBit(A17_RAM)
        SBI        PORTB, 6
 
; ClearBit(A18_RAM)
        CBI        PORTB, 7
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; ClearBit(OE_RAM_D)
        CBI        DDRB, 2
 
; ClearBit(WE_RAM_D)
        CBI        DDRB, 3
 
; ClearBit(G_RAMSW)
        CBI        PORTB, 4
 
; PROCEDURE - Ende (COPY_DISK_TO_RAM)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xF0)
        LDI        R16, 0xF0
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xF0)
        LDI        R16, 0xF0
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xF0)
        LDI        R16, 0xF0
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x50)
        LDI        R16, 0x50
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC2)
        LDI        R16, 0xC2
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x40)
        LDI        R16, 0x40
 
; Zuweisung Ziel /  VAR (PORTD)
        OUT        PORTD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; PROCEDURE - Anfang (SENDE_50_TAKTE)
SENDE_50_TAKTE:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZAEHLER)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x64)
        LDI        R16, 0x64
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0886:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0887
        RJMP       M_FTD_0888
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0887:
 
; SetBit(CLK_Z80)
        SBI        PORTD, 7
 
; NOP
        NOP
 
; NOP
        NOP
 
; ClearBit(CLK_Z80)
        CBI        PORTD, 7
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0886
 
; FOR TO DO - Ende
M_FTD_0888:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (SENDE_50_TAKTE)
        RET
 
; PROCEDURE - Anfang (LADE_CPD8_ARRAY_IN_RAM)
LADE_CPD8_ARRAY_IN_RAM:
 
; SetBit(G_RAMSW)
        SBI        PORTB, 4
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; SetBit(OE_RAM_D)
        SBI        DDRB, 2
 
; SetBit(WE_RAM_D)
        SBI        DDRB, 3
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (ARRAY_POS)
        STS        ARRAY_POS, R16
        STS        ARRAY_POS+1, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LAENGE_CPD8_ARRAY)
        LDI        R16, LOW(0x0AFF)
        LDI        R17, HIGH(0x0AFF)
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, ARRAY_POS
        LDS        R19, ARRAY_POS+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0889:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0890
        RJMP       M_FTD_0891
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0890:
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ARRAY - Ausdruck / Word-VAR (ARRAY_POS)
        LDS        R16, ARRAY_POS
        LDS        R17, ARRAY_POS+1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CPD8_ARR)
        LDI        ZL, LOW(2*CPD8_ARR)
        LDI        ZH, HIGH(2*CPD8_ARR)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; ClearBit(WE_RAM_A)
        CBI        PORTB, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, ARRAY_POS
        LDS        R19, ARRAY_POS+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        ARRAY_POS, R18
        STS        ARRAY_POS+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0889
 
; FOR TO DO - Ende
M_FTD_0891:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; ClearBit(OE_RAM_D)
        CBI        DDRB, 2
 
; ClearBit(WE_RAM_D)
        CBI        DDRB, 3
 
; ClearBit(G_RAMSW)
        CBI        PORTB, 4
 
; PROCEDURE - Ende (LADE_CPD8_ARRAY_IN_RAM)
        RET
 
; PROCEDURE - Anfang (Z80_RESET_UND_URLOAD)
Z80_RESET_UND_URLOAD:
 
; SetBit(RESET_Z80)
        SBI        PORTD, 6
 
; Aufruf PROCEDURE (SENDE_50_TAKTE)
        CALL       SENDE_50_TAKTE
 
; ClearBit(RESET_Z80)
        CBI        PORTD, 6
 
; Aufruf PROCEDURE (SENDE_50_TAKTE)
        CALL       SENDE_50_TAKTE
 
; SetBit(RESET_Z80)
        SBI        PORTD, 6
 
; Aufruf PROCEDURE (LADE_CPD8_ARRAY_IN_RAM)
        CALL       LADE_CPD8_ARRAY_IN_RAM
 
; ClearBit(RESET_Z80)
        CBI        PORTD, 6
 
; Aufruf PROCEDURE (SENDE_50_TAKTE)
        CALL       SENDE_50_TAKTE
 
; SetBit(RESET_Z80)
        SBI        PORTD, 6
 
; PROCEDURE - Ende (Z80_RESET_UND_URLOAD)
        RET
 
; PROCEDURE - Anfang (IORQ_ENDE)
IORQ_ENDE:
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; PROCEDURE - Ende (IORQ_ENDE)
        RET
 
; PROCEDURE - Anfang (Z80_CONOUT)
Z80_CONOUT:
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  VAR (CONSOLEOUT)
        STS        CONSOLEOUT, R16
 
; Aufruf PROCEDURE (IORQ_ENDE)
        CALL       IORQ_ENDE
 
; PROCEDURE - Ende (Z80_CONOUT)
        RET
 
; PROCEDURE - Anfang (Z80_LIST)
Z80_LIST:
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80_LIST)
        PUSH       R0
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (Z80_LIST)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80_LIST)
        PUSH       R0
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (Z80_LIST)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (IO_WERT)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80_LIST)
        PUSH       R0
 
; Aufruf PROCEDURE (BYTETOSTRING)
        CALL       BYTETOSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (Z80_LIST)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80_LIST)
        PUSH       R0
 
; Aufruf PROCEDURE (IORQ_ENDE)
        CALL       IORQ_ENDE
 
; Retten der Parameter-Register fuer PROCEDURE (Z80_LIST)
        POP        R0
 
; PROCEDURE - Ende (Z80_LIST)
        RET
 
; PROCEDURE - Anfang (Z80_CONIN)
Z80_CONIN:
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (CONSOLEIN)
        LDS        R16, CONSOLEIN
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Aufruf PROCEDURE (IORQ_ENDE)
        CALL       IORQ_ENDE
 
; PROCEDURE - Ende (Z80_CONIN)
        RET
 
; PROCEDURE - Anfang (STD_AN_UC)
STD_AN_UC:
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  VAR (SECTOR)
        STS        SECTOR, R16
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  VAR (TRACK_L)
        STS        TRACK_L, R16
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  VAR (TRACK_H)
        STS        TRACK_H, R16
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  VAR (DISKNO)
        STS        DISKNO, R16
 
; Aufruf PROCEDURE (IORQ_ENDE)
        CALL       IORQ_ENDE
 
; PROCEDURE - Ende (STD_AN_UC)
        RET
 
; PROCEDURE - Anfang (I2C_AN_SEKTOR_SENDEN)
I2C_AN_SEKTOR_SENDEN:
 
; Aufruf PROCEDURE (BERECHNE_I2C_ADDRESS)
        CALL       BERECHNE_I2C_ADDRESS
 
; Aufruf PROCEDURE (AT_READ_DATA_ARRAY)
        CALL       AT_READ_DATA_ARRAY
 
; PROCEDURE - Ende (I2C_AN_SEKTOR_SENDEN)
        RET
 
; PROCEDURE - Anfang (SEKTOR_AN_I2C_SENDEN)
SEKTOR_AN_I2C_SENDEN:
 
; Aufruf PROCEDURE (BERECHNE_I2C_ADDRESS)
        CALL       BERECHNE_I2C_ADDRESS
 
; Aufruf PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        CALL       AT_WRITE_DATA_ARRAY_WAIT
 
; PROCEDURE - Ende (SEKTOR_AN_I2C_SENDEN)
        RET
 
; PROCEDURE - Anfang (CONOUT_TO_DEVICE)
CONOUT_TO_DEVICE:
 
; Aufruf PROCEDURE (Z80_CONOUT)
        CALL       Z80_CONOUT
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (CONOUT_DEVICE)
        LDS        R16, CONOUT_DEVICE
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x64)
        LDI        R18, 0x64
 
; Operator <
        CP         R16, R18
        BRCS       M_VERGL_0895
        CLR        R16
        RJMP       M_VERGL_0896
M_VERGL_0895:
        SER        R16
M_VERGL_0896:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0892
        RJMP       M_IF_0893
M_IF_0892:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (CONOUT_DEVICE)
        LDS        R16, CONOUT_DEVICE
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_CONOUT)
        LDS        R0, CONSOLEOUT
 
; Aufruf PROCEDURE (ITP3_SENDE_CONOUT)
        CALL       ITP3_SENDE_CONOUT
 
; IF_THEN - Ende
M_IF_0893:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (CONOUT_DEVICE)
        LDS        R16, CONOUT_DEVICE
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0900
        CLR        R16
        RJMP       M_VERGL_0901
M_VERGL_0900:
        SER        R16
M_VERGL_0901:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0897
        RJMP       M_IF_0898
M_IF_0897:
 
; Aufruf PROCEDURE (UART_CONOUT_SENDEN)
        CALL       UART_CONOUT_SENDEN
 
; IF_THEN - Ende
M_IF_0898:
 
; PROCEDURE - Ende (CONOUT_TO_DEVICE)
        RET
 
; PROCEDURE - Anfang (CONST_TO_DEVICE)
CONST_TO_DEVICE:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (CONIN_DEVICE)
        LDS        R16, CONIN_DEVICE
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x64)
        LDI        R18, 0x64
 
; Operator <
        CP         R16, R18
        BRCS       M_VERGL_0905
        CLR        R16
        RJMP       M_VERGL_0906
M_VERGL_0905:
        SER        R16
M_VERGL_0906:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0902
        RJMP       M_IF_0903
M_IF_0902:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (CONIN_DEVICE)
        LDS        R16, CONIN_DEVICE
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf Funktion (ITP3_EMPFANGE_CONST)
        CALL       ITP3_EMPFANGE_CONST
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0904
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0903:
 
; Aufruf PROCEDURE (CONST_VON_UART_LESEN)
        CALL       CONST_VON_UART_LESEN
 
; IF_THEN_ELSE - Ende
M_IF_0904:
 
; Aufruf PROCEDURE (Z80_CONIN)
        CALL       Z80_CONIN
 
; PROCEDURE - Ende (CONST_TO_DEVICE)
        RET
 
; PROCEDURE - Anfang (CONIN_TO_DEVICE)
CONIN_TO_DEVICE:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (CONIN_DEVICE)
        LDS        R16, CONIN_DEVICE
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x64)
        LDI        R18, 0x64
 
; Operator <
        CP         R16, R18
        BRCS       M_VERGL_0910
        CLR        R16
        RJMP       M_VERGL_0911
M_VERGL_0910:
        SER        R16
M_VERGL_0911:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0907
        RJMP       M_IF_0908
M_IF_0907:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (CONIN_DEVICE)
        LDS        R16, CONIN_DEVICE
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_CONIN_SCHLEIFE)
        CALL       ITP3_CONIN_SCHLEIFE
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0909
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0908:
 
; Aufruf PROCEDURE (UART_CONIN_SCHLEIFE)
        CALL       UART_CONIN_SCHLEIFE
 
; IF_THEN_ELSE - Ende
M_IF_0909:
 
; Aufruf PROCEDURE (Z80_CONIN)
        CALL       Z80_CONIN
 
; PROCEDURE - Ende (CONIN_TO_DEVICE)
        RET
 
; PROCEDURE - Anfang (LIST_TO_DEVICE)
LIST_TO_DEVICE:
 
; Aufruf PROCEDURE (Z80_LIST)
        CALL       Z80_LIST
 
; PROCEDURE - Ende (LIST_TO_DEVICE)
        RET
 
; PROCEDURE - Anfang (START_PROG)
START_PROG:
 
; Aufruf PROCEDURE (I2C_LOAD_ADDRESS_LIST)
        CALL       I2C_LOAD_ADDRESS_LIST
 
; Aufruf PROCEDURE (IORQ_ENDE)
        CALL       IORQ_ENDE
 
; PROCEDURE - Ende (START_PROG)
        RET
 
; PROCEDURE - Anfang (AUSWERTEN_IORQ)
AUSWERTEN_IORQ:
 
; IF THEN - Ausdruck /; BitLow(WR_Z80_E)
        IN         R16, PIND
        BST        R16, 5
        BRTC       M_VERGL_0915
        CLR        R16
        RJMP       M_VERGL_0916
M_VERGL_0915:
        SER        R16
M_VERGL_0916:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0912
        RJMP       M_IF_0913
M_IF_0912:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (IO_WERT)
        MOV        R0, R16
 
; CASE OF - lokale, dynamische Variable VAR (IO_WERT)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (IORQ_CONOUT)
        CPI        R16, 0x03
        BREQ       M_CASE_0919
        RJMP       M_CASE_0918
M_CASE_0919:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (CONOUT_TO_DEVICE)
        CALL       CONOUT_TO_DEVICE
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0918:
 
; CASE OF - vergleiche Einzel-Element (IORQ_CONIN)
        CPI        R16, 0x04
        BREQ       M_CASE_0921
        RJMP       M_CASE_0920
M_CASE_0921:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (CONIN_TO_DEVICE)
        CALL       CONIN_TO_DEVICE
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0920:
 
; CASE OF - vergleiche Einzel-Element (IORQ_CONST)
        CPI        R16, 0x05
        BREQ       M_CASE_0923
        RJMP       M_CASE_0922
M_CASE_0923:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (CONST_TO_DEVICE)
        CALL       CONST_TO_DEVICE
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0922:
 
; CASE OF - vergleiche Einzel-Element (IORQ_LIST)
        CPI        R16, 0x10
        BREQ       M_CASE_0925
        RJMP       M_CASE_0924
M_CASE_0925:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (LIST_TO_DEVICE)
        CALL       LIST_TO_DEVICE
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0924:
 
; CASE OF - vergleiche Einzel-Element (IORQ_RD_ITP32ARR)
        CPI        R16, 0x14
        BREQ       M_CASE_0927
        RJMP       M_CASE_0926
M_CASE_0927:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_STD)
        CALL       ITP3_SENDE_STD
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SEKTOR_LESEN)
        CALL       ITP3_SEKTOR_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0926:
 
; CASE OF - vergleiche Einzel-Element (IORQ_WR_ARR2ITP3)
        CPI        R16, 0x15
        BREQ       M_CASE_0929
        RJMP       M_CASE_0928
M_CASE_0929:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_STD)
        CALL       ITP3_SENDE_STD
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SEKTOR_SCHREIBEN)
        CALL       ITP3_SEKTOR_SCHREIBEN
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0928:
 
; CASE OF - vergleiche Einzel-Element (IORQ_RD_PC2ARR)
        CPI        R16, 0x0A
        BREQ       M_CASE_0931
        RJMP       M_CASE_0930
M_CASE_0931:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (STD_AN_UART_SENDEN)
        CALL       STD_AN_UART_SENDEN
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        CALL       SEKTOR_VON_UART_LESEN_KOMP
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0930:
 
; CASE OF - vergleiche Einzel-Element (IORQ_WR_ARR2PC)
        CPI        R16, 0x0E
        BREQ       M_CASE_0933
        RJMP       M_CASE_0932
M_CASE_0933:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (STD_AN_UART_SENDEN)
        CALL       STD_AN_UART_SENDEN
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (SEKTOR_AN_UART_SENDEN)
        CALL       SEKTOR_AN_UART_SENDEN
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0932:
 
; CASE OF - vergleiche Einzel-Element (IORQ_RAM2ARR)
        CPI        R16, 0x07
        BREQ       M_CASE_0935
        RJMP       M_CASE_0934
M_CASE_0935:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (START_RAM2ARR)
        CALL       START_RAM2ARR
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0934:
 
; CASE OF - vergleiche Einzel-Element (IORQ_ARR2RAM)
        CPI        R16, 0x08
        BREQ       M_CASE_0937
        RJMP       M_CASE_0936
M_CASE_0937:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (START_ARR2RAM)
        CALL       START_ARR2RAM
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0936:
 
; CASE OF - vergleiche Einzel-Element (IORQ_STD2UC)
        CPI        R16, 0x09
        BREQ       M_CASE_0939
        RJMP       M_CASE_0938
M_CASE_0939:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (STD_AN_UC)
        CALL       STD_AN_UC
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0938:
 
; CASE OF - vergleiche Einzel-Element (IORQ_BDOS2RAM)
        CPI        R16, 0x0B
        BREQ       M_CASE_0941
        RJMP       M_CASE_0940
M_CASE_0941:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (START_BDOS2RAM)
        CALL       START_BDOS2RAM
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0940:
 
; CASE OF - vergleiche Einzel-Element (IORQ_CCP2RAM)
        CPI        R16, 0x0C
        BREQ       M_CASE_0943
        RJMP       M_CASE_0942
M_CASE_0943:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (START_CCP2RAM)
        CALL       START_CCP2RAM
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0942:
 
; CASE OF - vergleiche Einzel-Element (IORQ_DISK2RAM)
        CPI        R16, 0x0F
        BREQ       M_CASE_0945
        RJMP       M_CASE_0944
M_CASE_0945:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (COPY_DISK_TO_RAM)
        CALL       COPY_DISK_TO_RAM
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0944:
 
; CASE OF - vergleiche Einzel-Element (IORQ_RD_I2C2ARR)
        CPI        R16, 0x13
        BREQ       M_CASE_0947
        RJMP       M_CASE_0946
M_CASE_0947:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (I2C_AN_SEKTOR_SENDEN)
        CALL       I2C_AN_SEKTOR_SENDEN
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0946:
 
; CASE OF - vergleiche Einzel-Element (IORQ_WR_ARR2I2C)
        CPI        R16, 0x12
        BREQ       M_CASE_0949
        RJMP       M_CASE_0948
M_CASE_0949:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (SEKTOR_AN_I2C_SENDEN)
        CALL       SEKTOR_AN_I2C_SENDEN
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0948:
 
; CASE OF - vergleiche Einzel-Element (IORQ_LED_EIN)
        CPI        R16, 0x01
        BREQ       M_CASE_0951
        RJMP       M_CASE_0950
M_CASE_0951:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (IORQ_ENDE)
        CALL       IORQ_ENDE
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0950:
 
; CASE OF - vergleiche Einzel-Element (IORQ_LED_AUS)
        CPI        R16, 0x02
        BREQ       M_CASE_0953
        RJMP       M_CASE_0952
M_CASE_0953:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (IORQ_ENDE)
        CALL       IORQ_ENDE
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0917
M_CASE_0952:
 
; CASE OF - vergleiche Einzel-Element (IORQ_START_PROG)
        CPI        R16, 0x06
        BREQ       M_CASE_0955
        RJMP       M_CASE_0954
M_CASE_0955:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (START_PROG)
        CALL       START_PROG
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; ENDCASE;
M_CASE_0954:
M_CASE_0917:
 
; IF_THEN - Ende
M_IF_0913:
 
; PROCEDURE - Ende (AUSWERTEN_IORQ)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; Aufruf PROCEDURE (ITP3_INIT)
        CALL       ITP3_INIT
 
; Aufruf PROCEDURE (INIT_SER0_PORT)
        CALL       INIT_SER0_PORT
 
; Aufruf PROCEDURE (INIT_I2C)
        CALL       INIT_I2C
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONSOLEOUT)
        STS        CONSOLEOUT, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (STEUER_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('')
        LDI        ZL, LOW(2*M_CONST_STRING_27)
        LDI        ZH, HIGH(2*M_CONST_STRING_27)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0956
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0956:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0958
M_PRG_CONST_STRING_0957:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0957
M_PRG_CONST_STRING_0958:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (STEUER_STRING) - Laenge in R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0960
        MOV        R16, R17
M_PRG_CONST_STRING_0959:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0959
M_PRG_CONST_STRING_0960:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DATUM_GESETZT)
        STS        DATUM_GESETZT, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONSOLEIN_GELESEN)
        STS        CONSOLEIN_GELESEN, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SERIAL_DEVICE_CONNECTED)
        STS        SERIAL_DEVICE_CONNECTED, R16
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x40
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Aufruf PROCEDURE (Z80_RESET_UND_URLOAD)
        CALL       Z80_RESET_UND_URLOAD
 
; Aufruf PROCEDURE (ITP3_PRUEFE_ANSCHLUESSE)
        CALL       ITP3_PRUEFE_ANSCHLUESSE
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (CONOUT_DEVICE)
        LDS        R16, CONOUT_DEVICE
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0964
        CLR        R16
        RJMP       M_VERGL_0965
M_VERGL_0964:
        SER        R16
M_VERGL_0965:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0961
        RJMP       M_IF_0962
M_IF_0961:
 
; Aufruf PROCEDURE (UART_ABFRAGESCHLEIFE_SER0)
        CALL       UART_ABFRAGESCHLEIFE_SER0
 
; IF_THEN - Ende
M_IF_0962:
 
; LOOP - Start_Marke
M_LOOP_0966:
 
; SetBit(CLK_Z80)
        SBI        PORTD, 7
 
; ASM
    LDS      R16, UCSRA
    SBRC     R16, 7

    // fuer RPI, sonst ignoriert
    CALL     RX0_wait_before_sending_abfragen;


 
 
; ClearBit(CLK_Z80)
        CBI        PORTD, 7
 
; ASM
    SBIS     PinB, 1
    CALL     AUSWERTEN_IORQ

 
 
; LOOP - Ende
        RJMP       M_LOOP_0966
 
; *** Unterprogramm Bibliothek ***
; Multiplikation von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17 erster Faktor
;            R18:R19 zweiter Faktor
; Temporaere Register: R20,R21,R22,R23,R24 
;                      R2 ,R3  R4  R5  R6
ASM_UP_MUL16:
 
        PUSH       R0
        PUSH       R1

        CLR        R24
        MUL        R19, R17
        MOVW       R23:R22, R1:R0
        MUL        R18, R16
        MOVW       R21:R20, R1:R0
        MUL        R19, R16
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MUL        R17, R18
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MOVW       R17:R16, R21:R20       ; Produkt Low
        MOVW       R19:R18, R23:R22       ; Produkt High

        POP        R1
        POP        R0		

        RET






 
; *** Namen-Liste ***
;
; SREG (V) BYTECONREG
; SPH (V) BYTECONREG
; SPL (V) BYTECONREG
; OCR0 (V) BYTECONREG
; OCR2 (V) BYTECONREG
; GICR (V) BYTECONREG
; GIFR (V) BYTECONREG
; TIMSK (V) BYTECONREG
; TIFR (V) BYTECONREG
; SPMCR (V) BYTECONREG
; TWCR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUCSR (V) BYTECONREG
; TCCR0 (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; OSCCAL (V) BYTECONREG
; SFIOR (V) BYTECONREG
; OCDR (V) BYTECONREG
; TCCR1A (V) BYTECONREG
; TCCR1B (V) BYTECONREG
; TCNT1H (V) BYTECONREG
; TCNT1L (V) BYTECONREG
; OCR1AH (V) BYTECONREG
; OCR1AL (V) BYTECONREG
; OCR1BH (V) BYTECONREG
; OCR1BL (V) BYTECONREG
; ICR1H (V) BYTECONREG
; ICR1L (V) BYTECONREG
; TCCR2 (V) BYTECONREG
; TCNT2 (V) BYTECONREG
; ASSR (V) BYTECONREG
; WDTCR (V) BYTECONREG
; UBRRH (V) BYTECONREG
; UBRRL (V) BYTECONREG
; UCSRC (V) BYTECONREG
; UDR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; UCSRA (V) BYTECONREG
; UCSRB (V) BYTECONREG
; ACSR (V) BYTECONREG
; ADMUX (V) BYTECONREG
; ADCSRA (V) BYTECONREG
; ADCH (V) BYTECONREG
; ADCL (V) BYTECONREG
; TWDR (V) BYTECONREG
; TWAR (V) BYTECONREG
; TWSR (V) BYTECONREG
; TWBR (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; UBRR0 (V) WORDCONVAR
; RXC (B) BIT
; TXC (B) BIT
; UDRE (B) BIT
; TAKTFREQUENZ (C) WORD Wert=0x399A
; UBRR_VAL (C) BYTE Wert=0x07
; IORQ_LED_EIN (C) BYTE Wert=0x01
; IORQ_LED_AUS (C) BYTE Wert=0x02
; IORQ_CONOUT (C) BYTE Wert=0x03
; IORQ_CONIN (C) BYTE Wert=0x04
; IORQ_CONST (C) BYTE Wert=0x05
; IORQ_START_PROG (C) BYTE Wert=0x06
; IORQ_RAM2ARR (C) BYTE Wert=0x07
; IORQ_ARR2RAM (C) BYTE Wert=0x08
; IORQ_STD2UC (C) BYTE Wert=0x09
; IORQ_RD_PC2ARR (C) BYTE Wert=0x0A
; IORQ_BDOS2RAM (C) BYTE Wert=0x0B
; IORQ_CCP2RAM (C) BYTE Wert=0x0C
; IORQ_WR_ARR2PC (C) BYTE Wert=0x0E
; IORQ_DISK2RAM (C) BYTE Wert=0x0F
; IORQ_LIST (C) BYTE Wert=0x10
; IORQ_TIME (C) BYTE Wert=0x11
; IORQ_WR_ARR2I2C (C) BYTE Wert=0x12
; IORQ_RD_I2C2ARR (C) BYTE Wert=0x13
; IORQ_RD_ITP32ARR (C) BYTE Wert=0x14
; IORQ_WR_ARR2ITP3 (C) BYTE Wert=0x15
; NUL (C) BYTE Wert=0x00
; XON (C) BYTE Wert=0x11
; XOFF (C) BYTE Wert=0x13
; UART_WHO_AM_I (C) BYTE Wert=0x01
; UART_ERROR_CODE (C) BYTE Wert=0x02
; UART_CONOUT (C) BYTE Wert=0x03
; UART_CONST (C) BYTE Wert=0x04
; UART_CONIN (C) BYTE Wert=0x05
; UART_READ (C) BYTE Wert=0x06
; UART_WRITE (C) BYTE Wert=0x07
; UART_STD (C) BYTE Wert=0x08
; DR_ITP3_A (B) BIT
; DR_ITP3_E (B) BIT
; DR_ITP3_D (B) BIT
; IORQ_Z80_E (B) BIT
; OE_RAM_A (B) BIT
; OE_RAM_D (B) BIT
; WE_RAM_A (B) BIT
; WE_RAM_D (B) BIT
; G_RAMSW (B) BIT
; A16_RAM (B) BIT
; A17_RAM (B) BIT
; A18_RAM (B) BIT
; SCL_I2C_A (B) BIT
; SCL_I2C_E (B) BIT
; SCL_I2C_D (B) BIT
; SDA_I2C_A (B) BIT
; SDA_I2C_E (B) BIT
; SDA_I2C_D (B) BIT
; RD_Z80_E (B) BIT
; WR_Z80_E (B) BIT
; RESET_Z80 (B) BIT
; CLK_Z80 (B) BIT
; ARRAY_POS (V) WORD
; CONSOLEIN (V) BYTE
; CONSOLEIN_GELESEN (V) BOOLEAN
; CONSOLEOUT (V) BYTE
; STEUER_STRING (V) STRING
; ANZEIGE_STRING (V) STRING
; SEKTOR_PUFFER (Y) BYTE
; SEKTOR_PUFFER_ZEIGER (V) WORD
; SECTOR (V) BYTE
; TRACK_L (V) BYTE
; TRACK_H (V) BYTE
; DISKNO (V) BYTE
; DATUM_GESETZT (V) BOOLEAN
; SERIAL_DEVICE_CONNECTED (V) BYTE
; LAENGE_CPD8_ARRAY (C) WORD Wert=0x0AFF
; CPD8_ARR (A) 
; LAENGE_BDOS_ARRAY (C) WORD Wert=0x0DFF
; BDOS_ARR (A) 
; LAENGE_CCP_ARRAY (C) WORD Wert=0x07FF
; CCP_ARR (A) 
; LAENGE_DISK_ARRAY (C) WORD Wert=0x088F
; DISK_ARR (A) 
; WAITKON (C) WORD Wert=0x000E
; WAITKON2 (C) WORD Wert=0x0276
; BYTE_STRING (V) STRING
; WORD_STRING (V) STRING
; DWORD_STRING (V) STRING
; BYTEPOSTOORMASKE (F) 
; BYTEPOSTOANDMASKE (F) 
; READ_BIT_IN_BYTE (F) 
; SET_BIT_IN_BYTE (F) 
; CLEAR_BIT_IN_BYTE (F) 
; NEGATION_BYTE (F) 
; WAIT_MS (P) 
; BYTETOSTRING (P) 
; STRINGTOBYTE (F) 
; WORDTOSTRING (P) 
; STRINGTOWORD (F) 
; DWORDTOSTRING (P) 
; SER0_ZEICHEN (V) BYTE
; SER0_STRING (V) STRING
; SER0_WAIT_BEFORE_SENDING (V) BOOLEAN
; XON_AKTIV (V) BOOLEAN
; SER0_DETECTED (V) BOOLEAN
; INIT_SER0_PORT (P) 
; RX0_PUFFER_ABFRAGEN (P) 
; RX0_WAIT_BEFORE_SENDING_ABFRAGEN (P) 
; SENDE_ZEICHEN0 (P) 
; WRITE_SER0 (P) 
; WRITELN_SER0 (P) 
; ADR_AT24C512 (C) BYTE Wert=0x54
; FLASH_ADDRESS (V) WORD
; FLASH_A0 (V) BOOLEAN
; FLASH_A1 (V) BOOLEAN
; SDA_SET (P) 
; SCL_SET (P) 
; SDA_CLEAR (P) 
; SCL_CLEAR (P) 
; SDA_OUT (P) 
; SDA_IN (P) 
; SCL_OUT (P) 
; SDA_READ (F) 
; INIT_I2C (P) 
; DS_SHIFT_IN_NACK (F) 
; DS_SHIFT_IN_ACK (F) 
; DS_SHIFT_OUT (F) 
; I2C_DEVICE_ADDRESS_TO_WRITE (F) 
; I2C_DEVICE_ADDRESS_TO_READ (F) 
; AT_DATA_WRITE_WORD_ADDRESS (P) 
; AT_READ_DATA_ARRAY (P) 
; AT_WRITE_DATA_ARRAY_WAIT (P) 
; AT_DATA_READ_ONE_BYTE (F) 
; BERECHNE_I2C_ADDRESS (P) 
; INIT_FLASH_FLOPPY (P) 
; I2C_LOAD_ADDRESS_LIST (P) 
; AT_ZEIGE_EIN_BYTE (P) 
; AT_DATA_WRITE_ONE_BYTE (P) 
; ITP3_D0_A (B) BIT
; ITP3_D1_A (B) BIT
; ITP3_D2_A (B) BIT
; ITP3_D3_A (B) BIT
; ITP3_D0_D (B) BIT
; ITP3_D1_D (B) BIT
; ITP3_D2_D (B) BIT
; ITP3_D3_D (B) BIT
; ITP3_DR_D (B) BIT
; ITP3_D0_E (B) BIT
; ITP3_D1_E (B) BIT
; ITP3_D2_E (B) BIT
; ITP3_D3_E (B) BIT
; ITP3_DR_E (B) BIT
; ITP3_DS0_A (B) BIT
; ITP3_DS0_D (B) BIT
; ITP3_DS0_E (B) BIT
; ITP3_DS1_A (B) BIT
; ITP3_DS1_D (B) BIT
; ITP3_DS1_E (B) BIT
; ITP3_DS2_A (B) BIT
; ITP3_DS2_D (B) BIT
; ITP3_DS2_E (B) BIT
; ITP3_DS3_A (B) BIT
; ITP3_DS3_D (B) BIT
; ITP3_DS3_E (B) BIT
; ITP3_WHO_ARE_YOU (C) BYTE Wert=0x01
; ITP3_ERROR_CODE (C) BYTE Wert=0x02
; ITP3_CONOUT (C) BYTE Wert=0x03
; ITP3_CONST (C) BYTE Wert=0x04
; ITP3_CONIN (C) BYTE Wert=0x05
; ITP3_STD (C) BYTE Wert=0x06
; ITP3_RD_SEC (C) BYTE Wert=0x07
; ITP3_WR_SEC (C) BYTE Wert=0x08
; DEV_DS0 (C) BYTE Wert=0x00
; DEV_DS1 (C) BYTE Wert=0x01
; DEV_DS2 (C) BYTE Wert=0x02
; DEV_DS3 (C) BYTE Wert=0x03
; DEV_NR (V) BYTE
; CONOUT_DEVICE (V) BYTE
; CONIN_DEVICE (V) BYTE
; LIST_DEVICE (V) BYTE
; SOUND_DEVICE (V) BYTE
; DRIVE_D_DEVICE (V) BYTE
; ITP3_INIT (P) 
; DEV_NR_CLEARBIT (P) 
; DEV_NR_SETBIT (P) 
; ITP3_SENDE_HALBBYTE (P) 
; ITP3_SENDE_BYTE (P) 
; ITP3_SENDE_TEST_HALBBYTE (F) 
; ITP3_SENDE_TEST_BYTE (F) 
; ITP3_EMPFANGE_HALBBYTE (F) 
; ITP3_EMPFANGE_BYTE (F) 
; ITP3_SENDE_CONOUT (P) 
; ITP3_EMPFANGE_CONST (F) 
; ITP3_EMPFANGE_CONIN (F) 
; ITP3_CONIN_SCHLEIFE (P) 
; ITP3_SENDE_STD (P) 
; ITP3_SEKTOR_LESEN (P) 
; ITP3_SEKTOR_SCHREIBEN (P) 
; ITP3_PRUEFE_EINEN_ANSCHLUSS (P) 
; ITP3_PRUEFE_ANSCHLUESSE (P) 
; STD_AN_UART_SENDEN (P) 
; STEUER_STRING_TO_SECTOR (P) 
; STEUER_STRING_TO_SECTOR_KOMP (P) 
; STEUER_STRING_AUSWERTEN (P) 
; STEUER_STRING_LESEN (P) 
; SEKTOR_VON_UART_LESEN (P) 
; SEKTOR_VON_UART_LESEN_KOMP (P) 
; SEKTOR_AN_UART_SENDEN (P) 
; CONST_VON_UART_LESEN (P) 
; CONIN_VON_UART_LESEN (P) 
; UART_CONIN_SCHLEIFE (P) 
; UART_CONOUT_SENDEN (P) 
; UART_ABFRAGESCHLEIFE_SER0 (P) 
; WARTE_SOLANGE_RD_HIGH (P) 
; WARTE_SOLANGE_RD_LOW (P) 
; WARTE_SOLANGE_IORQ_HIGH (P) 
; WARTE_SOLANGE_IORQ_LOW (P) 
; SETZE_RAM_PAGE (P) 
; START_RAM2ARR (P) 
; START_ARR2RAM (P) 
; START_BDOS2RAM (P) 
; START_CCP2RAM (P) 
; COPY_DISK_TO_RAM (P) 
; INITPORTS (P) 
; SENDE_50_TAKTE (P) 
; LADE_CPD8_ARRAY_IN_RAM (P) 
; Z80_RESET_UND_URLOAD (P) 
; IORQ_ENDE (P) 
; Z80_CONOUT (P) 
; Z80_LIST (P) 
; Z80_CONIN (P) 
; STD_AN_UC (P) 
; I2C_AN_SEKTOR_SENDEN (P) 
; SEKTOR_AN_I2C_SENDEN (P) 
; CONOUT_TO_DEVICE (P) 
; CONST_TO_DEVICE (P) 
; CONIN_TO_DEVICE (P) 
; LIST_TO_DEVICE (P) 
; START_PROG (P) 
; AUSWERTEN_IORQ (P) 
 
; *** Prozedur/Function-Liste ***
;
; FUNCTION BYTEPOSTOORMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION BYTEPOSTOANDMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION READ_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (VERGLEICH : BYTE) (MASKE : BYTE) : BOOLEAN;
; FUNCTION SET_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION CLEAR_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION NEGATION_BYTE (DAS_BYTE : BYTE) : BYTE;
; PROCEDURE WAIT_MS (ZEIT : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE BYTETOSTRING (WERT_BYTE : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE) (C1 : CHAR);
; FUNCTION STRINGTOBYTE (HEXLOW : BYTE) (HEXHIGH : BYTE) (S2B : BYTE) (C1 : CHAR) : BYTE;
; PROCEDURE WORDTOSTRING (WERT_WORD : WORD) (BYTE_LOW : BYTE) (BYTE_HIGH : BYTE);
; FUNCTION STRINGTOWORD (C1 : CHAR) (S2W : WORD) (S2B : BYTE) (S2W2 : WORD) : WORD;
; PROCEDURE DWORDTOSTRING (WERT_DWORD : DWORD) (WORD_LOW : WORD) (WORD_HIGH : WORD);
; PROCEDURE INIT_SER0_PORT;
; PROCEDURE RX0_PUFFER_ABFRAGEN;
; PROCEDURE RX0_WAIT_BEFORE_SENDING_ABFRAGEN;
; PROCEDURE SENDE_ZEICHEN0 (S_ZEICHEN0 : BYTE);
; PROCEDURE WRITE_SER0 (C1 : CHAR) (LAENGE : BYTE) (B1 : BYTE) (B2 : BYTE);
; PROCEDURE WRITELN_SER0;
; PROCEDURE SDA_SET;
; PROCEDURE SCL_SET;
; PROCEDURE SDA_CLEAR;
; PROCEDURE SCL_CLEAR;
; PROCEDURE SDA_OUT;
; PROCEDURE SDA_IN;
; PROCEDURE SCL_OUT;
; FUNCTION SDA_READ (B1 : BOOLEAN) : BOOLEAN;
; PROCEDURE INIT_I2C;
; FUNCTION DS_SHIFT_IN_NACK (DS_DATA : BYTE) (DS_COUTER : BYTE) : BYTE;
; FUNCTION DS_SHIFT_IN_ACK (DS_DATA : BYTE) (DS_COUTER : BYTE) : BYTE;
; FUNCTION DS_SHIFT_OUT (DS_DATA : BYTE) (DS_COUTER : BYTE) (DS_RESULT : BOOLEAN) (DS_DATA_2 : BYTE) : BOOLEAN;
; FUNCTION I2C_DEVICE_ADDRESS_TO_WRITE (I2C_ADDRESS : BYTE) (DS_RESULT : BOOLEAN) : BOOLEAN;
; FUNCTION I2C_DEVICE_ADDRESS_TO_READ (I2C_ADDRESS : BYTE) (DS_RESULT : BOOLEAN) : BOOLEAN;
; PROCEDURE AT_DATA_WRITE_WORD_ADDRESS (B1 : BYTE) (ADDRESS_ACK : BOOLEAN);
; PROCEDURE AT_READ_DATA_ARRAY (RBA_DATA : BYTE) (ADDRESS_ACK : BOOLEAN) (RBA_COUNTER : WORD);
; PROCEDURE AT_WRITE_DATA_ARRAY_WAIT (ADDRESS_ACK : BOOLEAN) (ADDRESS_COUNTER : WORD) (DATA_BYTE : BYTE);
; FUNCTION AT_DATA_READ_ONE_BYTE (DS_DATA : BYTE) (ADDRESS_ACK : BOOLEAN) : BYTE;
; PROCEDURE BERECHNE_I2C_ADDRESS (FLASH_ADDRESS_TEMP : WORD) (B1 : BYTE);
; PROCEDURE INIT_FLASH_FLOPPY (B1 : BYTE) (ADDRESS_COUNTER : WORD) (ADDRESS_WERT : WORD);
; PROCEDURE I2C_LOAD_ADDRESS_LIST (ADDRESS_COUNTER : WORD) (ADDRESS_VALUE : BYTE) (ADDRESS_LINE : BYTE) (ADDRESS_ACK : BOOLEAN) (B1 : BYTE) (B2 : BYTE);
; PROCEDURE AT_ZEIGE_EIN_BYTE (B1 : BYTE);
; PROCEDURE AT_DATA_WRITE_ONE_BYTE (DATA_BYTE : BYTE) (ADDRESS_ACK : BOOLEAN) (B1 : BYTE);
; PROCEDURE ITP3_INIT;
; PROCEDURE DEV_NR_CLEARBIT;
; PROCEDURE DEV_NR_SETBIT;
; PROCEDURE ITP3_SENDE_HALBBYTE (SB : BYTE) (B1 : BYTE);
; PROCEDURE ITP3_SENDE_BYTE (SB : BYTE) (B1 : BYTE);
; FUNCTION ITP3_SENDE_TEST_HALBBYTE (SB : BYTE) (B1 : BYTE) (WAIT_COUNTER : WORD) (RESULT_BYTE : BOOLEAN) : BOOLEAN;
; FUNCTION ITP3_SENDE_TEST_BYTE (SB : BYTE) (B1 : BYTE) (RESULT_BYTE : BOOLEAN) : BOOLEAN;
; FUNCTION ITP3_EMPFANGE_HALBBYTE (RESULT_BYTE : BYTE) : BYTE;
; FUNCTION ITP3_EMPFANGE_BYTE (RESULT_BYTE_01 : BYTE) (RESULT_BYTE_02 : BYTE) : BYTE;
; PROCEDURE ITP3_SENDE_CONOUT (CO_BYTE : BYTE);
; FUNCTION ITP3_EMPFANGE_CONST (RESULT_BYTE : BYTE) : BYTE;
; FUNCTION ITP3_EMPFANGE_CONIN (RESULT_BYTE : BYTE) : BYTE;
; PROCEDURE ITP3_CONIN_SCHLEIFE;
; PROCEDURE ITP3_SENDE_STD;
; PROCEDURE ITP3_SEKTOR_LESEN (B1 : BYTE);
; PROCEDURE ITP3_SEKTOR_SCHREIBEN (B1 : BYTE);
; PROCEDURE ITP3_PRUEFE_EINEN_ANSCHLUSS (OK_BYTE : BOOLEAN) (WHO_ARE_YOU_BYTE : BYTE) (B1 : BYTE);
; PROCEDURE ITP3_PRUEFE_ANSCHLUESSE;
; PROCEDURE STD_AN_UART_SENDEN;
; PROCEDURE STEUER_STRING_TO_SECTOR (B1 : BYTE) (B2 : BYTE) (B3 : BYTE) (C1 : CHAR);
; PROCEDURE STEUER_STRING_TO_SECTOR_KOMP (X2 : BYTE) (DB7 : BYTE) (DB8 : BYTE) (BITPOS_DB8 : BYTE) (BITPOS_DB7 : BYTE) (C1 : CHAR) (POS_SS : BYTE) (EIN_BIT : BOOLEAN);
; PROCEDURE STEUER_STRING_AUSWERTEN (BUCHSTABE : CHAR) (ZEICHEN_1 : CHAR) (ZEICHEN_2 : CHAR) (LAENGE : BYTE);
; PROCEDURE STEUER_STRING_LESEN (AKT_ZEICHEN : CHAR) (EMPF_ZEICHEN : BYTE);
; PROCEDURE SEKTOR_VON_UART_LESEN (B1 : BYTE) (B2 : BYTE) (SPZ : WORD) (LESESCHLEIFE : WORD);
; PROCEDURE SEKTOR_VON_UART_LESEN_KOMP (B1 : BYTE) (B2 : BYTE) (SPZ : WORD) (LESESCHLEIFE : WORD);
; PROCEDURE SEKTOR_AN_UART_SENDEN (B1 : BYTE) (B2 : BYTE) (B3 : BYTE);
; PROCEDURE CONST_VON_UART_LESEN (LESESCHLEIFE : WORD);
; PROCEDURE CONIN_VON_UART_LESEN (LESESCHLEIFE : WORD);
; PROCEDURE UART_CONIN_SCHLEIFE;
; PROCEDURE UART_CONOUT_SENDEN;
; PROCEDURE UART_ABFRAGESCHLEIFE_SER0;
; PROCEDURE WARTE_SOLANGE_RD_HIGH;
; PROCEDURE WARTE_SOLANGE_RD_LOW;
; PROCEDURE WARTE_SOLANGE_IORQ_HIGH;
; PROCEDURE WARTE_SOLANGE_IORQ_LOW;
; PROCEDURE SETZE_RAM_PAGE (RAM_ADR : BYTE) (RAM_PORT : BYTE);
; PROCEDURE START_RAM2ARR (SP_ZAEHLER : WORD) (RAM_WERT : BYTE) (RAM_ADR : BYTE);
; PROCEDURE START_ARR2RAM (SP_ZAEHLER : WORD) (RAM_WERT : BYTE) (RAM_ADR : BYTE);
; PROCEDURE START_BDOS2RAM (SP_ZAEHLER : WORD) (RAM_WERT : BYTE) (RAM_ADR : BYTE);
; PROCEDURE START_CCP2RAM (SP_ZAEHLER : WORD) (RAM_WERT : BYTE) (RAM_ADR : BYTE);
; PROCEDURE COPY_DISK_TO_RAM (SP_ZAEHLER : WORD) (RAM_WERT : BYTE) (RAM_ADR : BYTE);
; PROCEDURE INITPORTS;
; PROCEDURE SENDE_50_TAKTE (ZAEHLER : BYTE);
; PROCEDURE LADE_CPD8_ARRAY_IN_RAM;
; PROCEDURE Z80_RESET_UND_URLOAD;
; PROCEDURE IORQ_ENDE;
; PROCEDURE Z80_CONOUT;
; PROCEDURE Z80_LIST (IO_WERT : BYTE);
; PROCEDURE Z80_CONIN;
; PROCEDURE STD_AN_UC;
; PROCEDURE I2C_AN_SEKTOR_SENDEN;
; PROCEDURE SEKTOR_AN_I2C_SENDEN;
; PROCEDURE CONOUT_TO_DEVICE;
; PROCEDURE CONST_TO_DEVICE;
; PROCEDURE CONIN_TO_DEVICE;
; PROCEDURE LIST_TO_DEVICE;
; PROCEDURE START_PROG;
; PROCEDURE AUSWERTEN_IORQ (IO_WERT : BYTE);
 
; *** Konstanten-ARRAYs ***
;
 
CPD8_ARR:
.db    0xF3,0x31
.db    0x80,0xFE
.db    0x21,0x12
.db    0x00,0x11
.db    0x00,0xF0
.db    0x01,0xC3
.db    0x0A,0xED
.db    0xB0,0xC3
.db    0x00,0xF0
.db    0xC3,0xE7
.db    0xF6,0xC3
.db    0x21,0xF7
.db    0xC3,0x4B
.db    0xF7,0xC3
.db    0x58,0xF7
.db    0xC3,0x63
.db    0xF7,0xC3
.db    0x6B,0xF7
.db    0xC3,0x73
.db    0xF7,0xC3
.db    0x74,0xF7
.db    0xC3,0x75
.db    0xF7,0xC3
.db    0x7B,0xF7
.db    0xC3,0x91
.db    0xF7,0xC3
.db    0x96,0xF7
.db    0xC3,0x9B
.db    0xF7,0xC3
.db    0xA0,0xF7
.db    0xC3,0x02
.db    0xF8,0xC3
.db    0x64,0xF8
.db    0xC3,0x67
.db    0xF8,0x00
.db    0x02,0x00
.db    0x00,0x80
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x0C
.db    0x43,0x50
.db    0x2F,0x4D
.db    0x20,0x32
.db    0x2E,0x32
.db    0x20,0x43
.db    0x6F,0x70
.db    0x79,0x72
.db    0x69,0x67
.db    0x68,0x74
.db    0x20,0x31
.db    0x39,0x37
.db    0x39,0x20
.db    0x28,0x63
.db    0x29,0x20
.db    0x62,0x79
.db    0x20,0x44
.db    0x69,0x67
.db    0x69,0x74
.db    0x61,0x6C
.db    0x20,0x52
.db    0x65,0x73
.db    0x65,0x61
.db    0x72,0x63
.db    0x68,0x0D
.db    0x0A,0x42
.db    0x49,0x4F
.db    0x53,0x2D
.db    0x4D,0x6F
.db    0x6E,0x69
.db    0x74,0x6F
.db    0x72,0x20
.db    0x32,0x30
.db    0x31,0x39
.db    0x20,0x77
.db    0x72,0x69
.db    0x74,0x74
.db    0x65,0x6E
.db    0x20,0x62
.db    0x79,0x20
.db    0x52,0x6F
.db    0x6E,0x61
.db    0x6C,0x64
.db    0x20,0x44
.db    0x61,0x6C
.db    0x65,0x73
.db    0x6B,0x65
.db    0x0D,0x0A
.db    0x0D,0x0A
.db    0x00,0x0D
.db    0x0A,0x42
.db    0x49,0x4F
.db    0x53,0x20
.db    0x46,0x65
.db    0x68,0x6C
.db    0x65,0x72
.db    0x20,0x2D
.db    0x20,0x4C
.db    0x61,0x75
.db    0x66,0x77
.db    0x65,0x72
.db    0x6B,0x20
.db    0x6E,0x69
.db    0x63,0x68
.db    0x74,0x20
.db    0x76,0x6F
.db    0x72,0x68
.db    0x61,0x6E
.db    0x64,0x65
.db    0x6E,0x20
.db    0x2E,0x2E
.db    0x2E,0x0D
.db    0x0A,0x00
.db    0x00,0x00
.db    0x00,0x04
.db    0x00,0x04
.db    0x00,0x80
.db    0x00,0xE7
.db    0xF1,0x8B
.db    0xF1,0xE7
.db    0xF2,0x67
.db    0xF2,0x00
.db    0x00,0x04
.db    0x00,0x04
.db    0x00,0x80
.db    0x00,0xE7
.db    0xF1,0xA2
.db    0xF1,0xA7
.db    0xF3,0x27
.db    0xF3,0x00
.db    0x00,0x04
.db    0x00,0x04
.db    0x00,0x80
.db    0x00,0xE7
.db    0xF1,0xB9
.db    0xF1,0xE7
.db    0xF4,0xE7
.db    0xF3,0x00
.db    0x00,0x04
.db    0x00,0x04
.db    0x00,0x80
.db    0x00,0xE7
.db    0xF1,0xD0
.db    0xF1,0x27
.db    0xF6,0x27
.db    0xF5,0x20
.db    0x00,0x03
.db    0x07,0x00
.db    0x3F,0x00
.db    0x3F,0x00
.db    0xC0,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x40,0x00
.db    0x04,0x0F
.db    0x00,0x7F
.db    0x00,0x7F
.db    0x00,0xF0
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x40
.db    0x00,0x04
.db    0x0F,0x00
.db    0xFF,0x07
.db    0xFF,0x01
.db    0xFF,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x40,0x00
.db    0x04,0x0F
.db    0x00,0xFF
.db    0x07,0xFF
.db    0x01,0xFF
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x31
.db    0x80,0xFE
.db    0x21,0xB9
.db    0xF0,0xCD
.db    0x6A,0xF8
.db    0x3E,0x00
.db    0x32,0x36
.db    0xF0,0x21
.db    0x00,0x00
.db    0x22,0x34
.db    0xF0,0x3E
.db    0x3F,0x32
.db    0x33,0xF0
.db    0x21,0x80
.db    0x00,0x22
.db    0x37,0xF0
.db    0xCD,0xA0
.db    0xF7,0x3A
.db    0xFE,0x00
.db    0xFE,0xE5
.db    0x20,0x07
.db    0x3A,0xFF
.db    0x00,0xFE
.db    0xE5,0x28
.db    0x03,0xCD
.db    0xD0,0xF8
.db    0xAF,0x32
.db    0x03,0x00
.db    0x32,0x04
.db    0x00,0x31
.db    0x80,0xFE
.db    0xCD,0xBC
.db    0xF8,0xCD
.db    0xC6,0xF8
.db    0x3E,0xC3
.db    0x32,0x00
.db    0x00,0x21
.db    0x03,0xF0
.db    0x22,0x01
.db    0x00,0x32
.db    0x05,0x00
.db    0x21,0x06
.db    0xE2,0x22
.db    0x06,0x00
.db    0x01,0x80
.db    0x00,0xCD
.db    0x9B,0xF7
.db    0x3A,0x04
.db    0x00,0x4F
.db    0xC3,0x03
.db    0xDA,0x3E
.db    0x05,0xD3
.db    0x00,0xDB
.db    0x00,0xFE
.db    0x00,0x28
.db    0x02,0x3E
.db    0xFF,0xC9
.db    0x3E,0x04
.db    0xD3,0x00
.db    0xDB,0x00
.db    0xFE,0x00
.db    0x28,0xF6
.db    0xC9,0x3E
.db    0x03,0xD3
.db    0x00,0x79
.db    0xD3,0x00
.db    0xC9,0x3E
.db    0x10,0xD3
.db    0x00,0x79
.db    0xD3,0x00
.db    0xC9,0xC9
.db    0xC9,0x0E
.db    0x00,0xCD
.db    0x91,0xF7
.db    0xC9,0x21
.db    0x00,0x00
.db    0x79,0xFE
.db    0x04,0xD0
.db    0x32,0x36
.db    0xF0,0x6F
.db    0x26,0x00
.db    0x29,0x29
.db    0x29,0x29
.db    0x11,0x4B
.db    0xF1,0x19
.db    0xC9,0xED
.db    0x43,0x34
.db    0xF0,0xC9
.db    0x79,0x32
.db    0x33,0xF0
.db    0xC9,0xED
.db    0x43,0x37
.db    0xF0,0xC9
.db    0x3A,0x36
.db    0xF0,0xFE
.db    0x00,0x20
.db    0x11,0xCD
.db    0x37,0xF9
.db    0xCD,0x8F
.db    0xF8,0x0E
.db    0x00,0x2A
.db    0x37,0xF0
.db    0xCD,0x99
.db    0xF8,0xC3
.db    0x00,0xF8
.db    0xFE,0x01
.db    0x20,0x12
.db    0xCD,0xA3
.db    0xF8,0x3E
.db    0x13,0xD3
.db    0x00,0x0E
.db    0x00,0x2A
.db    0x37,0xF0
.db    0xCD,0x99
.db    0xF8,0xC3
.db    0x00,0xF8
.db    0xFE,0x02
.db    0x20,0x12
.db    0xCD,0xA3
.db    0xF8,0x3E
.db    0x0A,0xD3
.db    0x00,0x0E
.db    0x00,0x2A
.db    0x37,0xF0
.db    0xCD,0x99
.db    0xF8,0xC3
.db    0x00,0xF8
.db    0xFE,0x03
.db    0x20,0x12
.db    0xCD,0xA3
.db    0xF8,0x3E
.db    0x14,0xD3
.db    0x00,0x0E
.db    0x00,0x2A
.db    0x37,0xF0
.db    0xCD,0x99
.db    0xF8,0xC3
.db    0x00,0xF8
.db    0x21,0x1B
.db    0xF1,0xCD
.db    0x6A,0xF8
.db    0xAF,0xC9
.db    0x3A,0x36
.db    0xF0,0xFE
.db    0x00,0x20
.db    0x11,0x0E
.db    0x00,0x2A
.db    0x37,0xF0
.db    0xCD,0x8F
.db    0xF8,0xCD
.db    0x37,0xF9
.db    0xCD,0x99
.db    0xF8,0xC3
.db    0x62,0xF8
.db    0xFE,0x01
.db    0x20,0x12
.db    0x0E,0x00
.db    0x2A,0x37
.db    0xF0,0xCD
.db    0x8F,0xF8
.db    0xCD,0xA3
.db    0xF8,0x3E
.db    0x12,0xD3
.db    0x00,0xC3
.db    0x62,0xF8
.db    0xFE,0x02
.db    0x20,0x12
.db    0x0E,0x00
.db    0x2A,0x37
.db    0xF0,0xCD
.db    0x8F,0xF8
.db    0xCD,0xA3
.db    0xF8,0x3E
.db    0x0E,0xD3
.db    0x00,0xC3
.db    0x62,0xF8
.db    0xFE,0x03
.db    0x20,0x12
.db    0x0E,0x00
.db    0x2A,0x37
.db    0xF0,0xCD
.db    0x8F,0xF8
.db    0xCD,0xA3
.db    0xF8,0x3E
.db    0x15,0xD3
.db    0x00,0xC3
.db    0x62,0xF8
.db    0x21,0x1B
.db    0xF1,0xCD
.db    0x6A,0xF8
.db    0xAF,0xC9
.db    0x3E,0xFF
.db    0xC9,0x60
.db    0x69,0xC9
.db    0x7E,0xB7
.db    0xC8,0x4F
.db    0xE5,0xCD
.db    0x63,0xF7
.db    0xE1,0x23
.db    0x18,0xF4
.db    0x0E,0x0D
.db    0xCD,0x63
.db    0xF7,0x0E
.db    0x0A,0xCD
.db    0x63,0xF7
.db    0xC9,0x0E
.db    0xD4,0x06
.db    0xFE,0x05
.db    0x20,0xFD
.db    0x0D,0x20
.db    0xF8,0x3D
.db    0x20,0xF3
.db    0xC9,0x3E
.db    0x07,0xD3
.db    0x00,0x79
.db    0xD3,0x00
.db    0xE9,0x00
.db    0x00,0x3E
.db    0x08,0xD3
.db    0x00,0x79
.db    0xD3,0x00
.db    0xE9,0x00
.db    0x00,0x3E
.db    0x09,0xD3
.db    0x00,0x3A
.db    0x33,0xF0
.db    0xD3,0x00
.db    0x3A,0x34
.db    0xF0,0xD3
.db    0x00,0x3A
.db    0x35,0xF0
.db    0xD3,0x00
.db    0x3A,0x36
.db    0xF0,0xD3
.db    0x00,0xC9
.db    0x21,0x00
.db    0xE2,0x3E
.db    0x0B,0xD3
.db    0x00,0xE9
.db    0x00,0x00
.db    0x21,0x00
.db    0xDA,0x3E
.db    0x0C,0xD3
.db    0x00,0xE9
.db    0x00,0x00
.db    0x21,0x00
.db    0x00,0x3E
.db    0x0F,0xD3
.db    0x00,0xE9
.db    0x00,0x00
.db    0x3E,0x11
.db    0xD3,0x00
.db    0xDB,0x00
.db    0x77,0x23
.db    0xDB,0x00
.db    0x77,0x23
.db    0xDB,0x00
.db    0x77,0x23
.db    0xDB,0x00
.db    0x77,0x23
.db    0xDB,0x00
.db    0x77,0x23
.db    0xC9,0x3E
.db    0xE5,0x06
.db    0x80,0x21
.db    0x80,0x00
.db    0x77,0x23
.db    0x10,0xFC
.db    0x21,0x80
.db    0x00,0x22
.db    0x37,0xF0
.db    0x3E,0x00
.db    0x32,0x36
.db    0xF0,0x01
.db    0x00,0x00
.db    0xED,0x5B
.db    0x8B,0xF1
.db    0x16,0x00
.db    0xED,0x43
.db    0x34,0xF0
.db    0x7A,0x32
.db    0x33,0xF0
.db    0xC5,0xD5
.db    0xCD,0x02
.db    0xF8,0xD1
.db    0xC1,0x14
.db    0x7A,0xBB
.db    0x20,0xF0
.db    0xC5,0xD5
.db    0xCD,0x8E
.db    0xFA,0xD1
.db    0xC1,0x0C
.db    0x3E,0x02
.db    0xB9,0x20
.db    0xDD,0xCD
.db    0x76,0xF8
.db    0xC9,0xED
.db    0x4B,0x34
.db    0xF0,0x41
.db    0xED,0x5B
.db    0x8B,0xF1
.db    0x21,0x00
.db    0x00,0xAF
.db    0xB8,0x28
.db    0x03,0x19
.db    0x10,0xFD
.db    0x3A,0x33
.db    0xF0,0x5F
.db    0x19,0x0E
.db    0x00,0x06
.db    0x07,0xCB
.db    0x25,0xCB
.db    0x14,0xCB
.db    0x11,0x10
.db    0xF8,0x0C
.db    0xC9,0x3E
.db    0xE5,0x06
.db    0x80,0x21
.db    0x80,0x00
.db    0x77,0x23
.db    0x10,0xFC
.db    0x21,0x80
.db    0x00,0x22
.db    0x37,0xF0
.db    0x3E,0x01
.db    0x32,0x36
.db    0xF0,0x01
.db    0x00,0x00
.db    0xED,0x5B
.db    0xA2,0xF1
.db    0x16,0x00
.db    0xED,0x43
.db    0x34,0xF0
.db    0x7A,0x32
.db    0x33,0xF0
.db    0xC5,0xD5
.db    0xCD,0x02
.db    0xF8,0xD1
.db    0xC1,0x14
.db    0x7A,0xBB
.db    0x20,0xF0
.db    0xC5,0xD5
.db    0xCD,0x8E
.db    0xFA,0xD1
.db    0xC1,0x0C
.db    0x3E,0x02
.db    0xB9,0x20
.db    0xDD,0xCD
.db    0x76,0xF8
.db    0xC9,0xCD
.db    0xD1,0xF9
.db    0xD5,0xC5
.db    0x48,0xCD
.db    0x63,0xF7
.db    0xC1,0xCD
.db    0x63,0xF7
.db    0xD1,0xD5
.db    0x4A,0xCD
.db    0x63,0xF7
.db    0xD1,0x4B
.db    0xCD,0x63
.db    0xF7,0x0E
.db    0x48,0xCD
.db    0x63,0xF7
.db    0xC9,0xCD
.db    0xE0,0xF9
.db    0xC5,0x48
.db    0xCD,0x63
.db    0xF7,0xC1
.db    0xCD,0x63
.db    0xF7,0x0E
.db    0x48,0xCD
.db    0x63,0xF7
.db    0xC9,0x7C
.db    0xE5,0xCD
.db    0xE0,0xF9
.db    0xE1,0xC5
.db    0x7D,0xCD
.db    0xE0,0xF9
.db    0x50,0x59
.db    0xC1,0xC9
.db    0xF5,0xE6
.db    0x0F,0xCD
.db    0xF5,0xF9
.db    0x4F,0xF1
.db    0xCB,0x3F
.db    0xCB,0x3F
.db    0xCB,0x3F
.db    0xCB,0x3F
.db    0xCD,0xF5
.db    0xF9,0x47
.db    0xC9,0xC6
.db    0x30,0xFE
.db    0x3A,0xD8
.db    0xC6,0x07
.db    0xC9,0x3E
.db    0x08,0xF5
.db    0xCD,0x08
.db    0xFA,0xF1
.db    0x3D,0x20
.db    0xF8,0xC9
.db    0xE5,0xCD
.db    0xA1,0xF9
.db    0x0E,0x2C
.db    0xCD,0x63
.db    0xF7,0xE1
.db    0x3E,0x10
.db    0xF5,0x7E
.db    0x23,0xE5
.db    0xCD,0xBF
.db    0xF9,0x0E
.db    0x2C,0xCD
.db    0x63,0xF7
.db    0xE1,0xF1
.db    0x3D,0x20
.db    0xEF,0xE5
.db    0xCD,0x76
.db    0xF8,0xE1
.db    0xC9,0x0D
.db    0x0A,0x53
.db    0x65,0x6B
.db    0x74,0x6F
.db    0x72,0x3D
.db    0x00,0x20
.db    0x20,0x53
.db    0x70,0x75
.db    0x72,0x3D
.db    0x00,0x20
.db    0x20,0x4C
.db    0x61,0x75
.db    0x66,0x77
.db    0x65,0x72
.db    0x6B,0x3D
.db    0x00,0x21
.db    0x2B,0xFA
.db    0xCD,0x6A
.db    0xF8,0x3A
.db    0x33,0xF0
.db    0xCD,0xBF
.db    0xF9,0x21
.db    0x35,0xFA
.db    0xCD,0x6A
.db    0xF8,0x2A
.db    0x34,0xF0
.db    0xCD,0xA1
.db    0xF9,0x21
.db    0x3D,0xFA
.db    0xCD,0x6A
.db    0xF8,0x3A
.db    0x36,0xF0
.db    0xCD,0xBF
.db    0xF9,0xCD
.db    0x76,0xF8
.db    0xC9,0x0D
.db    0x53,0x70
.db    0x75,0x72
.db    0x3A,0x00
.db    0x20,0x77
.db    0x75,0x72
.db    0x64,0x65
.db    0x20,0x66
.db    0x6F,0x72
.db    0x6D,0x61
.db    0x74,0x69
.db    0x65,0x72
.db    0x74,0x20
.db    0x2E,0x2E
.db    0x2E,0x00
.db    0x21,0x71
.db    0xFA,0xCD
.db    0x6A,0xF8
.db    0x2A,0x34
.db    0xF0,0xCD
.db    0xA1,0xF9
.db    0x21,0x78
.db    0xFA,0xCD
.db    0x6A,0xF8
.db    0xC9,0x0D
.db    0x0A,0x5A
.db    0x65,0x69
.db    0x74,0x3A
.db    0x00,0xE5
.db    0x21,0xA1
.db    0xFA,0xCD
.db    0x6A,0xF8
.db    0xE1,0x3E
.db    0x05,0xF5
.db    0x7E,0x23
.db    0xE5,0xCD
.db    0xBF,0xF9
.db    0xE1,0xF1
.db    0x3D,0x20
.db    0xF4,0xCD
.db    0x76,0xF8
.db    0xC9,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
BDOS_ARR:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0xC3,0x11
.db    0xE2,0x99
.db    0xE2,0xA5
.db    0xE2,0xAB
.db    0xE2,0xB1
.db    0xE2,0xEB
.db    0x22,0x43
.db    0xE5,0xEB
.db    0x7B,0x32
.db    0xD6,0xEF
.db    0x21,0x00
.db    0x00,0x22
.db    0x45,0xE5
.db    0x39,0x22
.db    0x0F,0xE5
.db    0x31,0x41
.db    0xE5,0xAF
.db    0x32,0xE0
.db    0xEF,0x32
.db    0xDE,0xEF
.db    0x21,0x74
.db    0xEF,0xE5
.db    0x79,0xFE
.db    0x29,0xD0
.db    0x4B,0x21
.db    0x47,0xE2
.db    0x5F,0x16
.db    0x00,0x19
.db    0x19,0x5E
.db    0x23,0x56
.db    0x2A,0x43
.db    0xE5,0xEB
.db    0xE9,0x03
.db    0xF0,0xC8
.db    0xE4,0x90
.db    0xE3,0xCE
.db    0xE4,0x12
.db    0xF0,0x0F
.db    0xF0,0xD4
.db    0xE4,0xED
.db    0xE4,0xF3
.db    0xE4,0xF8
.db    0xE4,0xE1
.db    0xE3,0xFE
.db    0xE4,0x7E
.db    0xEE,0x83
.db    0xEE,0x45
.db    0xEE,0x9C
.db    0xEE,0xA5
.db    0xEE,0xAB
.db    0xEE,0xC8
.db    0xEE,0xD7
.db    0xEE,0xE0
.db    0xEE,0xE6
.db    0xEE,0xEC
.db    0xEE,0xF5
.db    0xEE,0xFE
.db    0xEE,0x04
.db    0xEF,0x0A
.db    0xEF,0x11
.db    0xEF,0x2C
.db    0xE7,0x17
.db    0xEF,0x1D
.db    0xEF,0x26
.db    0xEF,0x2D
.db    0xEF,0x41
.db    0xEF,0x47
.db    0xEF,0x4D
.db    0xEF,0x0E
.db    0xEE,0x53
.db    0xEF,0x04
.db    0xE5,0x04
.db    0xE5,0x9B
.db    0xEF,0x21
.db    0xCA,0xE2
.db    0xCD,0xE5
.db    0xE2,0xFE
.db    0x03,0xCA
.db    0x00,0x00
.db    0xC9,0x21
.db    0xD5,0xE2
.db    0xC3,0xB4
.db    0xE2,0x21
.db    0xE1,0xE2
.db    0xC3,0xB4
.db    0xE2,0x21
.db    0xDC,0xE2
.db    0xCD,0xE5
.db    0xE2,0xC3
.db    0x00,0x00
.db    0x42,0x64
.db    0x6F,0x73
.db    0x20,0x45
.db    0x72,0x72
.db    0x20,0x4F
.db    0x6E,0x20
.db    0x20,0x3A
.db    0x20,0x24
.db    0x42,0x61
.db    0x64,0x20
.db    0x53,0x65
.db    0x63,0x74
.db    0x6F,0x72
.db    0x24,0x53
.db    0x65,0x6C
.db    0x65,0x63
.db    0x74,0x24
.db    0x46,0x69
.db    0x6C,0x65
.db    0x20,0x52
.db    0x2F,0x4F
.db    0x24,0xE5
.db    0xCD,0xC9
.db    0xE3,0x3A
.db    0x42,0xE5
.db    0xC6,0x41
.db    0x32,0xC6
.db    0xE2,0x01
.db    0xBA,0xE2
.db    0xCD,0xD3
.db    0xE3,0xC1
.db    0xCD,0xD3
.db    0xE3,0x21
.db    0x0E,0xE5
.db    0x7E,0x36
.db    0x00,0xB7
.db    0xC0,0xC3
.db    0x09,0xF0
.db    0xCD,0xFB
.db    0xE2,0xCD
.db    0x14,0xE3
.db    0xD8,0xF5
.db    0x4F,0xCD
.db    0x90,0xE3
.db    0xF1,0xC9
.db    0xFE,0x0D
.db    0xC8,0xFE
.db    0x0A,0xC8
.db    0xFE,0x09
.db    0xC8,0xFE
.db    0x08,0xC8
.db    0xFE,0x20
.db    0xC9,0x3A
.db    0x0E,0xE5
.db    0xB7,0xC2
.db    0x45,0xE3
.db    0xCD,0x06
.db    0xF0,0xE6
.db    0x01,0xC8
.db    0xCD,0x09
.db    0xF0,0xFE
.db    0x13,0xC2
.db    0x42,0xE3
.db    0xCD,0x09
.db    0xF0,0xFE
.db    0x03,0xCA
.db    0x00,0x00
.db    0xAF,0xC9
.db    0x32,0x0E
.db    0xE5,0x3E
.db    0x01,0xC9
.db    0x3A,0x0A
.db    0xE5,0xB7
.db    0xC2,0x62
.db    0xE3,0xC5
.db    0xCD,0x23
.db    0xE3,0xC1
.db    0xC5,0xCD
.db    0x0C,0xF0
.db    0xC1,0xC5
.db    0x3A,0x0D
.db    0xE5,0xB7
.db    0xC4,0x0F
.db    0xF0,0xC1
.db    0x79,0x21
.db    0x0C,0xE5
.db    0xFE,0x7F
.db    0xC8,0x34
.db    0xFE,0x20
.db    0xD0,0x35
.db    0x7E,0xB7
.db    0xC8,0x79
.db    0xFE,0x08
.db    0xC2,0x79
.db    0xE3,0x35
.db    0xC9,0xFE
.db    0x0A,0xC0
.db    0x36,0x00
.db    0xC9,0x79
.db    0xCD,0x14
.db    0xE3,0xD2
.db    0x90,0xE3
.db    0xF5,0x0E
.db    0x5E,0xCD
.db    0x48,0xE3
.db    0xF1,0xF6
.db    0x40,0x4F
.db    0x79,0xFE
.db    0x09,0xC2
.db    0x48,0xE3
.db    0x0E,0x20
.db    0xCD,0x48
.db    0xE3,0x3A
.db    0x0C,0xE5
.db    0xE6,0x07
.db    0xC2,0x96
.db    0xE3,0xC9
.db    0xCD,0xAC
.db    0xE3,0x0E
.db    0x20,0xCD
.db    0x0C,0xF0
.db    0x0E,0x08
.db    0xC3,0x0C
.db    0xF0,0x0E
.db    0x23,0xCD
.db    0x48,0xE3
.db    0xCD,0xC9
.db    0xE3,0x3A
.db    0x0C,0xE5
.db    0x21,0x0B
.db    0xE5,0xBE
.db    0xD0,0x0E
.db    0x20,0xCD
.db    0x48,0xE3
.db    0xC3,0xB9
.db    0xE3,0x0E
.db    0x0D,0xCD
.db    0x48,0xE3
.db    0x0E,0x0A
.db    0xC3,0x48
.db    0xE3,0x0A
.db    0xFE,0x24
.db    0xC8,0x03
.db    0xC5,0x4F
.db    0xCD,0x90
.db    0xE3,0xC1
.db    0xC3,0xD3
.db    0xE3,0x3A
.db    0x0C,0xE5
.db    0x32,0x0B
.db    0xE5,0x2A
.db    0x43,0xE5
.db    0x4E,0x23
.db    0xE5,0x06
.db    0x00,0xC5
.db    0xE5,0xCD
.db    0xFB,0xE2
.db    0xE6,0x7F
.db    0xE1,0xC1
.db    0xFE,0x0D
.db    0xCA,0xC1
.db    0xE4,0xFE
.db    0x0A,0xCA
.db    0xC1,0xE4
.db    0xFE,0x08
.db    0xC2,0x16
.db    0xE4,0x78
.db    0xB7,0xCA
.db    0xEF,0xE3
.db    0x05,0x3A
.db    0x0C,0xE5
.db    0x32,0x0A
.db    0xE5,0xC3
.db    0x70,0xE4
.db    0xFE,0x7F
.db    0xC2,0x26
.db    0xE4,0x78
.db    0xB7,0xCA
.db    0xEF,0xE3
.db    0x7E,0x05
.db    0x2B,0xC3
.db    0xA9,0xE4
.db    0xFE,0x05
.db    0xC2,0x37
.db    0xE4,0xC5
.db    0xE5,0xCD
.db    0xC9,0xE3
.db    0xAF,0x32
.db    0x0B,0xE5
.db    0xC3,0xF1
.db    0xE3,0xFE
.db    0x10,0xC2
.db    0x48,0xE4
.db    0xE5,0x21
.db    0x0D,0xE5
.db    0x3E,0x01
.db    0x96,0x77
.db    0xE1,0xC3
.db    0xEF,0xE3
.db    0xFE,0x18
.db    0xC2,0x5F
.db    0xE4,0xE1
.db    0x3A,0x0B
.db    0xE5,0x21
.db    0x0C,0xE5
.db    0xBE,0xD2
.db    0xE1,0xE3
.db    0x35,0xCD
.db    0xA4,0xE3
.db    0xC3,0x4E
.db    0xE4,0xFE
.db    0x15,0xC2
.db    0x6B,0xE4
.db    0xCD,0xB1
.db    0xE3,0xE1
.db    0xC3,0xE1
.db    0xE3,0xFE
.db    0x12,0xC2
.db    0xA6,0xE4
.db    0xC5,0xCD
.db    0xB1,0xE3
.db    0xC1,0xE1
.db    0xE5,0xC5
.db    0x78,0xB7
.db    0xCA,0x8A
.db    0xE4,0x23
.db    0x4E,0x05
.db    0xC5,0xE5
.db    0xCD,0x7F
.db    0xE3,0xE1
.db    0xC1,0xC3
.db    0x78,0xE4
.db    0xE5,0x3A
.db    0x0A,0xE5
.db    0xB7,0xCA
.db    0xF1,0xE3
.db    0x21,0x0C
.db    0xE5,0x96
.db    0x32,0x0A
.db    0xE5,0xCD
.db    0xA4,0xE3
.db    0x21,0x0A
.db    0xE5,0x35
.db    0xC2,0x99
.db    0xE4,0xC3
.db    0xF1,0xE3
.db    0x23,0x77
.db    0x04,0xC5
.db    0xE5,0x4F
.db    0xCD,0x7F
.db    0xE3,0xE1
.db    0xC1,0x7E
.db    0xFE,0x03
.db    0x78,0xC2
.db    0xBD,0xE4
.db    0xFE,0x01
.db    0xCA,0x00
.db    0x00,0xB9
.db    0xDA,0xEF
.db    0xE3,0xE1
.db    0x70,0x0E
.db    0x0D,0xC3
.db    0x48,0xE3
.db    0xCD,0x06
.db    0xE3,0xC3
.db    0x01,0xE5
.db    0xCD,0x15
.db    0xF0,0xC3
.db    0x01,0xE5
.db    0x79,0x3C
.db    0xCA,0xE0
.db    0xE4,0x3C
.db    0xCA,0x06
.db    0xF0,0xC3
.db    0x0C,0xF0
.db    0xCD,0x06
.db    0xF0,0xB7
.db    0xCA,0x91
.db    0xEF,0xCD
.db    0x09,0xF0
.db    0xC3,0x01
.db    0xE5,0x3A
.db    0x03,0x00
.db    0xC3,0x01
.db    0xE5,0x21
.db    0x03,0x00
.db    0x71,0xC9
.db    0xEB,0x4D
.db    0x44,0xC3
.db    0xD3,0xE3
.db    0xCD,0x23
.db    0xE3,0x32
.db    0x45,0xE5
.db    0xC9,0x3E
.db    0x01,0xC3
.db    0x01,0xE5
.db    0x00,0x02
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x21
.db    0x0B,0xE2
.db    0x5E,0x23
.db    0x56,0xEB
.db    0xE9,0x0C
.db    0x0D,0xC8
.db    0x1A,0x77
.db    0x13,0x23
.db    0xC3,0x50
.db    0xE5,0x3A
.db    0x42,0xE5
.db    0x4F,0xCD
.db    0x1B,0xF0
.db    0x7C,0xB5
.db    0xC8,0x5E
.db    0x23,0x56
.db    0x23,0x22
.db    0xB3,0xEF
.db    0x23,0x23
.db    0x22,0xB5
.db    0xEF,0x23
.db    0x23,0x22
.db    0xB7,0xEF
.db    0x23,0x23
.db    0xEB,0x22
.db    0xD0,0xEF
.db    0x21,0xB9
.db    0xEF,0x0E
.db    0x08,0xCD
.db    0x4F,0xE5
.db    0x2A,0xBB
.db    0xEF,0xEB
.db    0x21,0xC1
.db    0xEF,0x0E
.db    0x0F,0xCD
.db    0x4F,0xE5
.db    0x2A,0xC6
.db    0xEF,0x7C
.db    0x21,0xDD
.db    0xEF,0x36
.db    0xFF,0xB7
.db    0xCA,0x9D
.db    0xE5,0x36
.db    0x00,0x3E
.db    0xFF,0xB7
.db    0xC9,0xCD
.db    0x18,0xF0
.db    0xAF,0x2A
.db    0xB5,0xEF
.db    0x77,0x23
.db    0x77,0x2A
.db    0xB7,0xEF
.db    0x77,0x23
.db    0x77,0xC9
.db    0xCD,0x27
.db    0xF0,0xC3
.db    0xBB,0xE5
.db    0xCD,0x2A
.db    0xF0,0xB7
.db    0xC8,0x21
.db    0x09,0xE2
.db    0xC3,0x4A
.db    0xE5,0x2A
.db    0xEA,0xEF
.db    0x0E,0x02
.db    0xCD,0xEA
.db    0xE6,0x22
.db    0xE5,0xEF
.db    0x22,0xEC
.db    0xEF,0x21
.db    0xE5,0xEF
.db    0x4E,0x23
.db    0x46,0x2A
.db    0xB7,0xEF
.db    0x5E,0x23
.db    0x56,0x2A
.db    0xB5,0xEF
.db    0x7E,0x23
.db    0x66,0x6F
.db    0x79,0x93
.db    0x78,0x9A
.db    0xD2,0xFA
.db    0xE5,0xE5
.db    0x2A,0xC1
.db    0xEF,0x7B
.db    0x95,0x5F
.db    0x7A,0x9C
.db    0x57,0xE1
.db    0x2B,0xC3
.db    0xE4,0xE5
.db    0xE5,0x2A
.db    0xC1,0xEF
.db    0x19,0xDA
.db    0x0F,0xE6
.db    0x79,0x95
.db    0x78,0x9C
.db    0xDA,0x0F
.db    0xE6,0xEB
.db    0xE1,0x23
.db    0xC3,0xFA
.db    0xE5,0xE1
.db    0xC5,0xD5
.db    0xE5,0xEB
.db    0x2A,0xCE
.db    0xEF,0x19
.db    0x44,0x4D
.db    0xCD,0x1E
.db    0xF0,0xD1
.db    0x2A,0xB5
.db    0xEF,0x73
.db    0x23,0x72
.db    0xD1,0x2A
.db    0xB7,0xEF
.db    0x73,0x23
.db    0x72,0xC1
.db    0x79,0x93
.db    0x4F,0x78
.db    0x9A,0x47
.db    0x2A,0xD0
.db    0xEF,0xEB
.db    0xCD,0x30
.db    0xF0,0x4D
.db    0x44,0xC3
.db    0x21,0xF0
.db    0x21,0xC3
.db    0xEF,0x4E
.db    0x3A,0xE3
.db    0xEF,0xB7
.db    0x1F,0x0D
.db    0xC2,0x45
.db    0xE6,0x47
.db    0x3E,0x08
.db    0x96,0x4F
.db    0x3A,0xE2
.db    0xEF,0x0D
.db    0xCA,0x5C
.db    0xE6,0xB7
.db    0x17,0xC3
.db    0x53,0xE6
.db    0x80,0xC9
.db    0x2A,0x43
.db    0xE5,0x11
.db    0x10,0x00
.db    0x19,0x09
.db    0x3A,0xDD
.db    0xEF,0xB7
.db    0xCA,0x71
.db    0xE6,0x6E
.db    0x26,0x00
.db    0xC9,0x09
.db    0x5E,0x23
.db    0x56,0xEB
.db    0xC9,0xCD
.db    0x3E,0xE6
.db    0x4F,0x06
.db    0x00,0xCD
.db    0x5E,0xE6
.db    0x22,0xE5
.db    0xEF,0xC9
.db    0x2A,0xE5
.db    0xEF,0x7D
.db    0xB4,0xC9
.db    0x3A,0xC3
.db    0xEF,0x2A
.db    0xE5,0xEF
.db    0x29,0x3D
.db    0xC2,0x90
.db    0xE6,0x22
.db    0xE7,0xEF
.db    0x3A,0xC4
.db    0xEF,0x4F
.db    0x3A,0xE3
.db    0xEF,0xA1
.db    0xB5,0x6F
.db    0x22,0xE5
.db    0xEF,0xC9
.db    0x2A,0x43
.db    0xE5,0x11
.db    0x0C,0x00
.db    0x19,0xC9
.db    0x2A,0x43
.db    0xE5,0x11
.db    0x0F,0x00
.db    0x19,0xEB
.db    0x21,0x11
.db    0x00,0x19
.db    0xC9,0xCD
.db    0xAE,0xE6
.db    0x7E,0x32
.db    0xE3,0xEF
.db    0xEB,0x7E
.db    0x32,0xE1
.db    0xEF,0xCD
.db    0xA6,0xE6
.db    0x3A,0xC5
.db    0xEF,0xA6
.db    0x32,0xE2
.db    0xEF,0xC9
.db    0xCD,0xAE
.db    0xE6,0x3A
.db    0xD5,0xEF
.db    0xFE,0x02
.db    0xC2,0xDE
.db    0xE6,0xAF
.db    0x4F,0x3A
.db    0xE3,0xEF
.db    0x81,0x77
.db    0xEB,0x3A
.db    0xE1,0xEF
.db    0x77,0xC9
.db    0x0C,0x0D
.db    0xC8,0x7C
.db    0xB7,0x1F
.db    0x67,0x7D
.db    0x1F,0x6F
.db    0xC3,0xEB
.db    0xE6,0x0E
.db    0x80,0x2A
.db    0xB9,0xEF
.db    0xAF,0x86
.db    0x23,0x0D
.db    0xC2,0xFD
.db    0xE6,0xC9
.db    0x0C,0x0D
.db    0xC8,0x29
.db    0xC3,0x05
.db    0xE7,0xC5
.db    0x3A,0x42
.db    0xE5,0x4F
.db    0x21,0x01
.db    0x00,0xCD
.db    0x04,0xE7
.db    0xC1,0x79
.db    0xB5,0x6F
.db    0x78,0xB4
.db    0x67,0xC9
.db    0x2A,0xAD
.db    0xEF,0x3A
.db    0x42,0xE5
.db    0x4F,0xCD
.db    0xEA,0xE6
.db    0x7D,0xE6
.db    0x01,0xC9
.db    0x21,0xAD
.db    0xEF,0x4E
.db    0x23,0x46
.db    0xCD,0x0B
.db    0xE7,0x22
.db    0xAD,0xEF
.db    0x2A,0xC8
.db    0xEF,0x23
.db    0xEB,0x2A
.db    0xB3,0xEF
.db    0x73,0x23
.db    0x72,0xC9
.db    0xCD,0x5E
.db    0xE7,0x11
.db    0x09,0x00
.db    0x19,0x7E
.db    0x17,0xD0
.db    0x21,0x0F
.db    0xE2,0xC3
.db    0x4A,0xE5
.db    0xCD,0x1E
.db    0xE7,0xC8
.db    0x21,0x0D
.db    0xE2,0xC3
.db    0x4A,0xE5
.db    0x2A,0xB9
.db    0xEF,0x3A
.db    0xE9,0xEF
.db    0x85,0x6F
.db    0xD0,0x24
.db    0xC9,0x2A
.db    0x43,0xE5
.db    0x11,0x0E
.db    0x00,0x19
.db    0x7E,0xC9
.db    0xCD,0x69
.db    0xE7,0x36
.db    0x00,0xC9
.db    0xCD,0x69
.db    0xE7,0xF6
.db    0x80,0x77
.db    0xC9,0x2A
.db    0xEA,0xEF
.db    0xEB,0x2A
.db    0xB3,0xEF
.db    0x7B,0x96
.db    0x23,0x7A
.db    0x9E,0xC9
.db    0xCD,0x7F
.db    0xE7,0xD8
.db    0x13,0x72
.db    0x2B,0x73
.db    0xC9,0x7B
.db    0x95,0x6F
.db    0x7A,0x9C
.db    0x67,0xC9
.db    0x0E,0xFF
.db    0x2A,0xEC
.db    0xEF,0xEB
.db    0x2A,0xCC
.db    0xEF,0xCD
.db    0x95,0xE7
.db    0xD0,0xC5
.db    0xCD,0xF7
.db    0xE6,0x2A
.db    0xBD,0xEF
.db    0xEB,0x2A
.db    0xEC,0xEF
.db    0x19,0xC1
.db    0x0C,0xCA
.db    0xC4,0xE7
.db    0xBE,0xC8
.db    0xCD,0x7F
.db    0xE7,0xD0
.db    0xCD,0x2C
.db    0xE7,0xC9
.db    0x77,0xC9
.db    0xCD,0x9C
.db    0xE7,0xCD
.db    0xE0,0xE7
.db    0x0E,0x01
.db    0xCD,0xB8
.db    0xE5,0xC3
.db    0xDA,0xE7
.db    0xCD,0xE0
.db    0xE7,0xCD
.db    0xB2,0xE5
.db    0x21,0xB1
.db    0xEF,0xC3
.db    0xE3,0xE7
.db    0x21,0xB9
.db    0xEF,0x4E
.db    0x23,0x46
.db    0xC3,0x24
.db    0xF0,0x2A
.db    0xB9,0xEF
.db    0xEB,0x2A
.db    0xB1,0xEF
.db    0x0E,0x80
.db    0xC3,0x4F
.db    0xE5,0x21
.db    0xEA,0xEF
.db    0x7E,0x23
.db    0xBE,0xC0
.db    0x3C,0xC9
.db    0x21,0xFF
.db    0xFF,0x22
.db    0xEA,0xEF
.db    0xC9,0x2A
.db    0xC8,0xEF
.db    0xEB,0x2A
.db    0xEA,0xEF
.db    0x23,0x22
.db    0xEA,0xEF
.db    0xCD,0x95
.db    0xE7,0xD2
.db    0x19,0xE8
.db    0xC3,0xFE
.db    0xE7,0x3A
.db    0xEA,0xEF
.db    0xE6,0x03
.db    0x06,0x05
.db    0x87,0x05
.db    0xC2,0x20
.db    0xE8,0x32
.db    0xE9,0xEF
.db    0xB7,0xC0
.db    0xC5,0xCD
.db    0xC3,0xE5
.db    0xCD,0xD4
.db    0xE7,0xC1
.db    0xC3,0x9E
.db    0xE7,0x79
.db    0xE6,0x07
.db    0x3C,0x5F
.db    0x57,0x79
.db    0x0F,0x0F
.db    0x0F,0xE6
.db    0x1F,0x4F
.db    0x78,0x87
.db    0x87,0x87
.db    0x87,0x87
.db    0xB1,0x4F
.db    0x78,0x0F
.db    0x0F,0x0F
.db    0xE6,0x1F
.db    0x47,0x2A
.db    0xBF,0xEF
.db    0x09,0x7E
.db    0x07,0x1D
.db    0xC2,0x56
.db    0xE8,0xC9
.db    0xD5,0xCD
.db    0x35,0xE8
.db    0xE6,0xFE
.db    0xC1,0xB1
.db    0x0F,0x15
.db    0xC2,0x64
.db    0xE8,0x77
.db    0xC9,0xCD
.db    0x5E,0xE7
.db    0x11,0x10
.db    0x00,0x19
.db    0xC5,0x0E
.db    0x11,0xD1
.db    0x0D,0xC8
.db    0xD5,0x3A
.db    0xDD,0xEF
.db    0xB7,0xCA
.db    0x88,0xE8
.db    0xC5,0xE5
.db    0x4E,0x06
.db    0x00,0xC3
.db    0x8E,0xE8
.db    0x0D,0xC5
.db    0x4E,0x23
.db    0x46,0xE5
.db    0x79,0xB0
.db    0xCA,0x9D
.db    0xE8,0x2A
.db    0xC6,0xEF
.db    0x7D,0x91
.db    0x7C,0x98
.db    0xD4,0x5C
.db    0xE8,0xE1
.db    0x23,0xC1
.db    0xC3,0x75
.db    0xE8,0x2A
.db    0xC6,0xEF
.db    0x0E,0x03
.db    0xCD,0xEA
.db    0xE6,0x23
.db    0x44,0x4D
.db    0x2A,0xBF
.db    0xEF,0x36
.db    0x00,0x23
.db    0x0B,0x78
.db    0xB1,0xC2
.db    0xB1,0xE8
.db    0x2A,0xCA
.db    0xEF,0xEB
.db    0x2A,0xBF
.db    0xEF,0x73
.db    0x23,0x72
.db    0xCD,0xA1
.db    0xE5,0x2A
.db    0xB3,0xEF
.db    0x36,0x03
.db    0x23,0x36
.db    0x00,0xCD
.db    0xFE,0xE7
.db    0x0E,0xFF
.db    0xCD,0x05
.db    0xE8,0xCD
.db    0xF5,0xE7
.db    0xC8,0xCD
.db    0x5E,0xE7
.db    0x3E,0xE5
.db    0xBE,0xCA
.db    0xD2,0xE8
.db    0x3A,0x41
.db    0xE5,0xBE
.db    0xC2,0xF6
.db    0xE8,0x23
.db    0x7E,0xD6
.db    0x24,0xC2
.db    0xF6,0xE8
.db    0x3D,0x32
.db    0x45,0xE5
.db    0x0E,0x01
.db    0xCD,0x6B
.db    0xE8,0xCD
.db    0x8C,0xE7
.db    0xC3,0xD2
.db    0xE8,0x3A
.db    0xD4,0xEF
.db    0xC3,0x01
.db    0xE5,0xC5
.db    0xF5,0x3A
.db    0xC5,0xEF
.db    0x2F,0x47
.db    0x79,0xA0
.db    0x4F,0xF1
.db    0xA0,0x91
.db    0xE6,0x1F
.db    0xC1,0xC9
.db    0x3E,0xFF
.db    0x32,0xD4
.db    0xEF,0x21
.db    0xD8,0xEF
.db    0x71,0x2A
.db    0x43,0xE5
.db    0x22,0xD9
.db    0xEF,0xCD
.db    0xFE,0xE7
.db    0xCD,0xA1
.db    0xE5,0x0E
.db    0x00,0xCD
.db    0x05,0xE8
.db    0xCD,0xF5
.db    0xE7,0xCA
.db    0x94,0xE9
.db    0x2A,0xD9
.db    0xEF,0xEB
.db    0x1A,0xFE
.db    0xE5,0xCA
.db    0x4A,0xE9
.db    0xD5,0xCD
.db    0x7F,0xE7
.db    0xD1,0xD2
.db    0x94,0xE9
.db    0xCD,0x5E
.db    0xE7,0x3A
.db    0xD8,0xEF
.db    0x4F,0x06
.db    0x00,0x79
.db    0xB7,0xCA
.db    0x83,0xE9
.db    0x1A,0xFE
.db    0x3F,0xCA
.db    0x7C,0xE9
.db    0x78,0xFE
.db    0x0D,0xCA
.db    0x7C,0xE9
.db    0xFE,0x0C
.db    0x1A,0xCA
.db    0x73,0xE9
.db    0x96,0xE6
.db    0x7F,0xC2
.db    0x2D,0xE9
.db    0xC3,0x7C
.db    0xE9,0xC5
.db    0x4E,0xCD
.db    0x07,0xE9
.db    0xC1,0xC2
.db    0x2D,0xE9
.db    0x13,0x23
.db    0x04,0x0D
.db    0xC3,0x53
.db    0xE9,0x3A
.db    0xEA,0xEF
.db    0xE6,0x03
.db    0x32,0x45
.db    0xE5,0x21
.db    0xD4,0xEF
.db    0x7E,0x17
.db    0xD0,0xAF
.db    0x77,0xC9
.db    0xCD,0xFE
.db    0xE7,0x3E
.db    0xFF,0xC3
.db    0x01,0xE5
.db    0xCD,0x54
.db    0xE7,0x0E
.db    0x0C,0xCD
.db    0x18,0xE9
.db    0xCD,0xF5
.db    0xE7,0xC8
.db    0xCD,0x44
.db    0xE7,0xCD
.db    0x5E,0xE7
.db    0x36,0xE5
.db    0x0E,0x00
.db    0xCD,0x6B
.db    0xE8,0xCD
.db    0xC6,0xE7
.db    0xCD,0x2D
.db    0xE9,0xC3
.db    0xA4,0xE9
.db    0x50,0x59
.db    0x79,0xB0
.db    0xCA,0xD1
.db    0xE9,0x0B
.db    0xD5,0xC5
.db    0xCD,0x35
.db    0xE8,0x1F
.db    0xD2,0xEC
.db    0xE9,0xC1
.db    0xD1,0x2A
.db    0xC6,0xEF
.db    0x7B,0x95
.db    0x7A,0x9C
.db    0xD2,0xF4
.db    0xE9,0x13
.db    0xC5,0xD5
.db    0x42,0x4B
.db    0xCD,0x35
.db    0xE8,0x1F
.db    0xD2,0xEC
.db    0xE9,0xD1
.db    0xC1,0xC3
.db    0xC0,0xE9
.db    0x17,0x3C
.db    0xCD,0x64
.db    0xE8,0xE1
.db    0xD1,0xC9
.db    0x79,0xB0
.db    0xC2,0xC0
.db    0xE9,0x21
.db    0x00,0x00
.db    0xC9,0x0E
.db    0x00,0x1E
.db    0x20,0xD5
.db    0x06,0x00
.db    0x2A,0x43
.db    0xE5,0x09
.db    0xEB,0xCD
.db    0x5E,0xE7
.db    0xC1,0xCD
.db    0x4F,0xE5
.db    0xCD,0xC3
.db    0xE5,0xC3
.db    0xC6,0xE7
.db    0xCD,0x54
.db    0xE7,0x0E
.db    0x0C,0xCD
.db    0x18,0xE9
.db    0x2A,0x43
.db    0xE5,0x7E
.db    0x11,0x10
.db    0x00,0x19
.db    0x77,0xCD
.db    0xF5,0xE7
.db    0xC8,0xCD
.db    0x44,0xE7
.db    0x0E,0x10
.db    0x1E,0x0C
.db    0xCD,0x01
.db    0xEA,0xCD
.db    0x2D,0xE9
.db    0xC3,0x27
.db    0xEA,0x0E
.db    0x0C,0xCD
.db    0x18,0xE9
.db    0xCD,0xF5
.db    0xE7,0xC8
.db    0x0E,0x00
.db    0x1E,0x0C
.db    0xCD,0x01
.db    0xEA,0xCD
.db    0x2D,0xE9
.db    0xC3,0x40
.db    0xEA,0x0E
.db    0x0F,0xCD
.db    0x18,0xE9
.db    0xCD,0xF5
.db    0xE7,0xC8
.db    0xCD,0xA6
.db    0xE6,0x7E
.db    0xF5,0xE5
.db    0xCD,0x5E
.db    0xE7,0xEB
.db    0x2A,0x43
.db    0xE5,0x0E
.db    0x20,0xD5
.db    0xCD,0x4F
.db    0xE5,0xCD
.db    0x78,0xE7
.db    0xD1,0x21
.db    0x0C,0x00
.db    0x19,0x4E
.db    0x21,0x0F
.db    0x00,0x19
.db    0x46,0xE1
.db    0xF1,0x77
.db    0x79,0xBE
.db    0x78,0xCA
.db    0x8B,0xEA
.db    0x3E,0x00
.db    0xDA,0x8B
.db    0xEA,0x3E
.db    0x80,0x2A
.db    0x43,0xE5
.db    0x11,0x0F
.db    0x00,0x19
.db    0x77,0xC9
.db    0x7E,0x23
.db    0xB6,0x2B
.db    0xC0,0x1A
.db    0x77,0x13
.db    0x23,0x1A
.db    0x77,0x1B
.db    0x2B,0xC9
.db    0xAF,0x32
.db    0x45,0xE5
.db    0x32,0xEA
.db    0xEF,0x32
.db    0xEB,0xEF
.db    0xCD,0x1E
.db    0xE7,0xC0
.db    0xCD,0x69
.db    0xE7,0xE6
.db    0x80,0xC0
.db    0x0E,0x0F
.db    0xCD,0x18
.db    0xE9,0xCD
.db    0xF5,0xE7
.db    0xC8,0x01
.db    0x10,0x00
.db    0xCD,0x5E
.db    0xE7,0x09
.db    0xEB,0x2A
.db    0x43,0xE5
.db    0x09,0x0E
.db    0x10,0x3A
.db    0xDD,0xEF
.db    0xB7,0xCA
.db    0xE8,0xEA
.db    0x7E,0xB7
.db    0x1A,0xC2
.db    0xDB,0xEA
.db    0x77,0xB7
.db    0xC2,0xE1
.db    0xEA,0x7E
.db    0x12,0xBE
.db    0xC2,0x1F
.db    0xEB,0xC3
.db    0xFD,0xEA
.db    0xCD,0x94
.db    0xEA,0xEB
.db    0xCD,0x94
.db    0xEA,0xEB
.db    0x1A,0xBE
.db    0xC2,0x1F
.db    0xEB,0x13
.db    0x23,0x1A
.db    0xBE,0xC2
.db    0x1F,0xEB
.db    0x0D,0x13
.db    0x23,0x0D
.db    0xC2,0xCD
.db    0xEA,0x01
.db    0xEC,0xFF
.db    0x09,0xEB
.db    0x09,0x1A
.db    0xBE,0xDA
.db    0x17,0xEB
.db    0x77,0x01
.db    0x03,0x00
.db    0x09,0xEB
.db    0x09,0x7E
.db    0x12,0x3E
.db    0xFF,0x32
.db    0xD2,0xEF
.db    0xC3,0x10
.db    0xEA,0x21
.db    0x45,0xE5
.db    0x35,0xC9
.db    0xCD,0x54
.db    0xE7,0x2A
.db    0x43,0xE5
.db    0xE5,0x21
.db    0xAC,0xEF
.db    0x22,0x43
.db    0xE5,0x0E
.db    0x01,0xCD
.db    0x18,0xE9
.db    0xCD,0xF5
.db    0xE7,0xE1
.db    0x22,0x43
.db    0xE5,0xC8
.db    0xEB,0x21
.db    0x0F,0x00
.db    0x19,0x0E
.db    0x11,0xAF
.db    0x77,0x23
.db    0x0D,0xC2
.db    0x46,0xEB
.db    0x21,0x0D
.db    0x00,0x19
.db    0x77,0xCD
.db    0x8C,0xE7
.db    0xCD,0xFD
.db    0xE9,0xC3
.db    0x78,0xE7
.db    0xAF,0x32
.db    0xD2,0xEF
.db    0xCD,0xA2
.db    0xEA,0xCD
.db    0xF5,0xE7
.db    0xC8,0x2A
.db    0x43,0xE5
.db    0x01,0x0C
.db    0x00,0x09
.db    0x7E,0x3C
.db    0xE6,0x1F
.db    0x77,0xCA
.db    0x83,0xEB
.db    0x47,0x3A
.db    0xC5,0xEF
.db    0xA0,0x21
.db    0xD2,0xEF
.db    0xA6,0xCA
.db    0x8E,0xEB
.db    0xC3,0xAC
.db    0xEB,0x01
.db    0x02,0x00
.db    0x09,0x34
.db    0x7E,0xE6
.db    0x0F,0xCA
.db    0xB6,0xEB
.db    0x0E,0x0F
.db    0xCD,0x18
.db    0xE9,0xCD
.db    0xF5,0xE7
.db    0xC2,0xAC
.db    0xEB,0x3A
.db    0xD3,0xEF
.db    0x3C,0xCA
.db    0xB6,0xEB
.db    0xCD,0x24
.db    0xEB,0xCD
.db    0xF5,0xE7
.db    0xCA,0xB6
.db    0xEB,0xC3
.db    0xAF,0xEB
.db    0xCD,0x5A
.db    0xEA,0xCD
.db    0xBB,0xE6
.db    0xAF,0xC3
.db    0x01,0xE5
.db    0xCD,0x05
.db    0xE5,0xC3
.db    0x78,0xE7
.db    0x3E,0x01
.db    0x32,0xD5
.db    0xEF,0x3E
.db    0xFF,0x32
.db    0xD3,0xEF
.db    0xCD,0xBB
.db    0xE6,0x3A
.db    0xE3,0xEF
.db    0x21,0xE1
.db    0xEF,0xBE
.db    0xDA,0xE6
.db    0xEB,0xFE
.db    0x80,0xC2
.db    0xFB,0xEB
.db    0xCD,0x5A
.db    0xEB,0xAF
.db    0x32,0xE3
.db    0xEF,0x3A
.db    0x45,0xE5
.db    0xB7,0xC2
.db    0xFB,0xEB
.db    0xCD,0x77
.db    0xE6,0xCD
.db    0x84,0xE6
.db    0xCA,0xFB
.db    0xEB,0xCD
.db    0x8A,0xE6
.db    0xCD,0xD1
.db    0xE5,0xCD
.db    0xB2,0xE5
.db    0xC3,0xD2
.db    0xE6,0xC3
.db    0x05,0xE5
.db    0x3E,0x01
.db    0x32,0xD5
.db    0xEF,0x3E
.db    0x00,0x32
.db    0xD3,0xEF
.db    0xCD,0x54
.db    0xE7,0x2A
.db    0x43,0xE5
.db    0xCD,0x47
.db    0xE7,0xCD
.db    0xBB,0xE6
.db    0x3A,0xE3
.db    0xEF,0xFE
.db    0x80,0xD2
.db    0x05,0xE5
.db    0xCD,0x77
.db    0xE6,0xCD
.db    0x84,0xE6
.db    0x0E,0x00
.db    0xC2,0x6E
.db    0xEC,0xCD
.db    0x3E,0xE6
.db    0x32,0xD7
.db    0xEF,0x01
.db    0x00,0x00
.db    0xB7,0xCA
.db    0x3B,0xEC
.db    0x4F,0x0B
.db    0xCD,0x5E
.db    0xE6,0x44
.db    0x4D,0xCD
.db    0xBE,0xE9
.db    0x7D,0xB4
.db    0xC2,0x48
.db    0xEC,0x3E
.db    0x02,0xC3
.db    0x01,0xE5
.db    0x22,0xE5
.db    0xEF,0xEB
.db    0x2A,0x43
.db    0xE5,0x01
.db    0x10,0x00
.db    0x09,0x3A
.db    0xDD,0xEF
.db    0xB7,0x3A
.db    0xD7,0xEF
.db    0xCA,0x64
.db    0xEC,0xCD
.db    0x64,0xE7
.db    0x73,0xC3
.db    0x6C,0xEC
.db    0x4F,0x06
.db    0x00,0x09
.db    0x09,0x73
.db    0x23,0x72
.db    0x0E,0x02
.db    0x3A,0x45
.db    0xE5,0xB7
.db    0xC0,0xC5
.db    0xCD,0x8A
.db    0xE6,0x3A
.db    0xD5,0xEF
.db    0x3D,0x3D
.db    0xC2,0xBB
.db    0xEC,0xC1
.db    0xC5,0x79
.db    0x3D,0x3D
.db    0xC2,0xBB
.db    0xEC,0xE5
.db    0x2A,0xB9
.db    0xEF,0x57
.db    0x77,0x23
.db    0x14,0xF2
.db    0x8C,0xEC
.db    0xCD,0xE0
.db    0xE7,0x2A
.db    0xE7,0xEF
.db    0x0E,0x02
.db    0x22,0xE5
.db    0xEF,0xC5
.db    0xCD,0xD1
.db    0xE5,0xC1
.db    0xCD,0xB8
.db    0xE5,0x2A
.db    0xE5,0xEF
.db    0x0E,0x00
.db    0x3A,0xC4
.db    0xEF,0x47
.db    0xA5,0xB8
.db    0x23,0xC2
.db    0x9A,0xEC
.db    0xE1,0x22
.db    0xE5,0xEF
.db    0xCD,0xDA
.db    0xE7,0xCD
.db    0xD1,0xE5
.db    0xC1,0xC5
.db    0xCD,0xB8
.db    0xE5,0xC1
.db    0x3A,0xE3
.db    0xEF,0x21
.db    0xE1,0xEF
.db    0xBE,0xDA
.db    0xD2,0xEC
.db    0x77,0x34
.db    0x0E,0x02
.db    0x00,0x00
.db    0x21,0x00
.db    0xDA,0xF5
.db    0xCD,0x69
.db    0xE7,0xE6
.db    0x7F,0x77
.db    0xF1,0xFE
.db    0x7F,0xC2
.db    0x00,0xED
.db    0x3A,0xD5
.db    0xEF,0xFE
.db    0x01,0xC2
.db    0x00,0xED
.db    0xCD,0xD2
.db    0xE6,0xCD
.db    0x5A,0xEB
.db    0x21,0x45
.db    0xE5,0x7E
.db    0xB7,0xC2
.db    0xFE,0xEC
.db    0x3D,0x32
.db    0xE3,0xEF
.db    0x36,0x00
.db    0xC3,0xD2
.db    0xE6,0xAF
.db    0x32,0xD5
.db    0xEF,0xC5
.db    0x2A,0x43
.db    0xE5,0xEB
.db    0x21,0x21
.db    0x00,0x19
.db    0x7E,0xE6
.db    0x7F,0xF5
.db    0x7E,0x17
.db    0x23,0x7E
.db    0x17,0xE6
.db    0x1F,0x4F
.db    0x7E,0x1F
.db    0x1F,0x1F
.db    0x1F,0xE6
.db    0x0F,0x47
.db    0xF1,0x23
.db    0x6E,0x2C
.db    0x2D,0x2E
.db    0x06,0xC2
.db    0x8B,0xED
.db    0x21,0x20
.db    0x00,0x19
.db    0x77,0x21
.db    0x0C,0x00
.db    0x19,0x79
.db    0x96,0xC2
.db    0x47,0xED
.db    0x21,0x0E
.db    0x00,0x19
.db    0x78,0x96
.db    0xE6,0x7F
.db    0xCA,0x7F
.db    0xED,0xC5
.db    0xD5,0xCD
.db    0xA2,0xEA
.db    0xD1,0xC1
.db    0x2E,0x03
.db    0x3A,0x45
.db    0xE5,0x3C
.db    0xCA,0x84
.db    0xED,0x21
.db    0x0C,0x00
.db    0x19,0x71
.db    0x21,0x0E
.db    0x00,0x19
.db    0x70,0xCD
.db    0x51,0xEA
.db    0x3A,0x45
.db    0xE5,0x3C
.db    0xC2,0x7F
.db    0xED,0xC1
.db    0xC5,0x2E
.db    0x04,0x0C
.db    0xCA,0x84
.db    0xED,0xCD
.db    0x24,0xEB
.db    0x2E,0x05
.db    0x3A,0x45
.db    0xE5,0x3C
.db    0xCA,0x84
.db    0xED,0xC1
.db    0xAF,0xC3
.db    0x01,0xE5
.db    0xE5,0xCD
.db    0x69,0xE7
.db    0x36,0xC0
.db    0xE1,0xC1
.db    0x7D,0x32
.db    0x45,0xE5
.db    0xC3,0x78
.db    0xE7,0x0E
.db    0xFF,0xCD
.db    0x03,0xED
.db    0xCC,0xC1
.db    0xEB,0xC9
.db    0x0E,0x00
.db    0xCD,0x03
.db    0xED,0xCC
.db    0x03,0xEC
.db    0xC9,0xEB
.db    0x19,0x4E
.db    0x06,0x00
.db    0x21,0x0C
.db    0x00,0x19
.db    0x7E,0x0F
.db    0xE6,0x80
.db    0x81,0x4F
.db    0x3E,0x00
.db    0x88,0x47
.db    0x7E,0x0F
.db    0xE6,0x0F
.db    0x80,0x47
.db    0x21,0x0E
.db    0x00,0x19
.db    0x7E,0x87
.db    0x87,0x87
.db    0x87,0xF5
.db    0x80,0x47
.db    0xF5,0xE1
.db    0x7D,0xE1
.db    0xB5,0xE6
.db    0x01,0xC9
.db    0x0E,0x0C
.db    0xCD,0x18
.db    0xE9,0x2A
.db    0x43,0xE5
.db    0x11,0x21
.db    0x00,0x19
.db    0xE5,0x72
.db    0x23,0x72
.db    0x23,0x72
.db    0xCD,0xF5
.db    0xE7,0xCA
.db    0x0C,0xEE
.db    0xCD,0x5E
.db    0xE7,0x11
.db    0x0F,0x00
.db    0xCD,0xA5
.db    0xED,0xE1
.db    0xE5,0x5F
.db    0x79,0x96
.db    0x23,0x78
.db    0x9E,0x23
.db    0x7B,0x9E
.db    0xDA,0x06
.db    0xEE,0x73
.db    0x2B,0x70
.db    0x2B,0x71
.db    0xCD,0x2D
.db    0xE9,0xC3
.db    0xE4,0xED
.db    0xE1,0xC9
.db    0x2A,0x43
.db    0xE5,0x11
.db    0x20,0x00
.db    0xCD,0xA5
.db    0xED,0x21
.db    0x21,0x00
.db    0x19,0x71
.db    0x23,0x70
.db    0x23,0x77
.db    0xC9,0x2A
.db    0xAF,0xEF
.db    0x3A,0x42
.db    0xE5,0x4F
.db    0xCD,0xEA
.db    0xE6,0xE5
.db    0xEB,0xCD
.db    0x59,0xE5
.db    0xE1,0xCC
.db    0x47,0xE5
.db    0x7D,0x1F
.db    0xD8,0x2A
.db    0xAF,0xEF
.db    0x4D,0x44
.db    0xCD,0x0B
.db    0xE7,0x22
.db    0xAF,0xEF
.db    0xC3,0xA3
.db    0xE8,0x3A
.db    0xD6,0xEF
.db    0x21,0x42
.db    0xE5,0xBE
.db    0xC8,0x77
.db    0xC3,0x21
.db    0xEE,0x3E
.db    0xFF,0x32
.db    0xDE,0xEF
.db    0x2A,0x43
.db    0xE5,0x7E
.db    0xE6,0x1F
.db    0x3D,0x32
.db    0xD6,0xEF
.db    0xFE,0x1E
.db    0xD2,0x75
.db    0xEE,0x3A
.db    0x42,0xE5
.db    0x32,0xDF
.db    0xEF,0x7E
.db    0x32,0xE0
.db    0xEF,0xE6
.db    0xE0,0x77
.db    0xCD,0x45
.db    0xEE,0x3A
.db    0x41,0xE5
.db    0x2A,0x43
.db    0xE5,0xB6
.db    0x77,0xC9
.db    0x3E,0x22
.db    0xC3,0x01
.db    0xE5,0x21
.db    0x00,0x00
.db    0x22,0xAD
.db    0xEF,0x22
.db    0xAF,0xEF
.db    0xAF,0x32
.db    0x42,0xE5
.db    0x21,0x80
.db    0x00,0x22
.db    0xB1,0xEF
.db    0xCD,0xDA
.db    0xE7,0xC3
.db    0x21,0xEE
.db    0xCD,0x72
.db    0xE7,0xCD
.db    0x51,0xEE
.db    0xC3,0x51
.db    0xEA,0xCD
.db    0x51,0xEE
.db    0xC3,0xA2
.db    0xEA,0x0E
.db    0x00,0xEB
.db    0x7E,0xFE
.db    0x3F,0xCA
.db    0xC2,0xEE
.db    0xCD,0xA6
.db    0xE6,0x7E
.db    0xFE,0x3F
.db    0xC4,0x72
.db    0xE7,0xCD
.db    0x51,0xEE
.db    0x0E,0x0F
.db    0xCD,0x18
.db    0xE9,0xC3
.db    0xE9,0xE7
.db    0x2A,0xD9
.db    0xEF,0x22
.db    0x43,0xE5
.db    0xCD,0x51
.db    0xEE,0xCD
.db    0x2D,0xE9
.db    0xC3,0xE9
.db    0xE7,0xCD
.db    0x51,0xEE
.db    0xCD,0x9C
.db    0xE9,0xC3
.db    0x01,0xE9
.db    0xCD,0x51
.db    0xEE,0xC3
.db    0xBC,0xEB
.db    0xCD,0x51
.db    0xEE,0xC3
.db    0xFE,0xEB
.db    0xCD,0x72
.db    0xE7,0xCD
.db    0x51,0xEE
.db    0xC3,0x24
.db    0xEB,0xCD
.db    0x51,0xEE
.db    0xCD,0x16
.db    0xEA,0xC3
.db    0x01,0xE9
.db    0x2A,0xAF
.db    0xEF,0xC3
.db    0x29,0xEF
.db    0x3A,0x42
.db    0xE5,0xC3
.db    0x01,0xE5
.db    0xEB,0x22
.db    0xB1,0xEF
.db    0xC3,0xDA
.db    0xE7,0x2A
.db    0xBF,0xEF
.db    0xC3,0x29
.db    0xEF,0x2A
.db    0xAD,0xEF
.db    0xC3,0x29
.db    0xEF,0xCD
.db    0x51,0xEE
.db    0xCD,0x3B
.db    0xEA,0xC3
.db    0x01,0xE9
.db    0x2A,0xBB
.db    0xEF,0x22
.db    0x45,0xE5
.db    0xC9,0x3A
.db    0xD6,0xEF
.db    0xFE,0xFF
.db    0xC2,0x3B
.db    0xEF,0x3A
.db    0x41,0xE5
.db    0xC3,0x01
.db    0xE5,0xE6
.db    0x1F,0x32
.db    0x41,0xE5
.db    0xC9,0xCD
.db    0x51,0xEE
.db    0xC3,0x93
.db    0xED,0xCD
.db    0x51,0xEE
.db    0xC3,0x9C
.db    0xED,0xCD
.db    0x51,0xEE
.db    0xC3,0xD2
.db    0xED,0x2A
.db    0x43,0xE5
.db    0x7D,0x2F
.db    0x5F,0x7C
.db    0x2F,0x2A
.db    0xAF,0xEF
.db    0xA4,0x57
.db    0x7D,0xA3
.db    0x5F,0x2A
.db    0xAD,0xEF
.db    0xEB,0x22
.db    0xAF,0xEF
.db    0x7D,0xA3
.db    0x6F,0x7C
.db    0xA2,0x67
.db    0x22,0xAD
.db    0xEF,0xC9
.db    0x3A,0xDE
.db    0xEF,0xB7
.db    0xCA,0x91
.db    0xEF,0x2A
.db    0x43,0xE5
.db    0x36,0x00
.db    0x3A,0xE0
.db    0xEF,0xB7
.db    0xCA,0x91
.db    0xEF,0x77
.db    0x3A,0xDF
.db    0xEF,0x32
.db    0xD6,0xEF
.db    0xCD,0x45
.db    0xEE,0x2A
.db    0x0F,0xE5
.db    0xF9,0x2A
.db    0x45,0xE5
.db    0x7D,0x44
.db    0xC9,0xCD
.db    0x51,0xEE
.db    0x3E,0x02
.db    0x32,0xD5
.db    0xEF,0x0E
.db    0x00,0xCD
.db    0x07,0xED
.db    0xCC,0x03
.db    0xEC,0xC9
.db    0xE5,0x00
.db    0x00,0x00
.db    0x00,0x80
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
CCP_ARR:
.db    0xC3,0x5C
.db    0xDD,0xC3
.db    0x58,0xDD
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x20,0x20
.db    0x43,0x4F
.db    0x50,0x59
.db    0x52,0x49
.db    0x47,0x48
.db    0x54,0x20
.db    0x28,0x43
.db    0x29,0x20
.db    0x31,0x39
.db    0x37,0x39
.db    0x2C,0x20
.db    0x44,0x49
.db    0x47,0x49
.db    0x54,0x41
.db    0x4C,0x20
.db    0x52,0x45
.db    0x53,0x45
.db    0x41,0x52
.db    0x43,0x48
.db    0x20,0x20
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x08,0xDA
.db    0x08,0xDA
.db    0x5F,0x0E
.db    0x02,0xC3
.db    0x05,0x00
.db    0xC5,0xCD
.db    0x8C,0xDA
.db    0xC1,0xC9
.db    0x3E,0x0D
.db    0xCD,0x92
.db    0xDA,0x3E
.db    0x0A,0xC3
.db    0x92,0xDA
.db    0x3E,0x20
.db    0xC3,0x92
.db    0xDA,0xC5
.db    0xCD,0x98
.db    0xDA,0xE1
.db    0x7E,0xB7
.db    0xC8,0x23
.db    0xE5,0xCD
.db    0x8C,0xDA
.db    0xE1,0xC3
.db    0xAC,0xDA
.db    0x0E,0x0D
.db    0xC3,0x05
.db    0x00,0x5F
.db    0x0E,0x0E
.db    0xC3,0x05
.db    0x00,0xCD
.db    0x05,0x00
.db    0x32,0xEE
.db    0xE1,0x3C
.db    0xC9,0x0E
.db    0x0F,0xC3
.db    0xC3,0xDA
.db    0xAF,0x32
.db    0xED,0xE1
.db    0x11,0xCD
.db    0xE1,0xC3
.db    0xCB,0xDA
.db    0x0E,0x10
.db    0xC3,0xC3
.db    0xDA,0x0E
.db    0x11,0xC3
.db    0xC3,0xDA
.db    0x0E,0x12
.db    0xC3,0xC3
.db    0xDA,0x11
.db    0xCD,0xE1
.db    0xC3,0xDF
.db    0xDA,0x0E
.db    0x13,0xC3
.db    0x05,0x00
.db    0xCD,0x05
.db    0x00,0xB7
.db    0xC9,0x0E
.db    0x14,0xC3
.db    0xF4,0xDA
.db    0x11,0xCD
.db    0xE1,0xC3
.db    0xF9,0xDA
.db    0x0E,0x15
.db    0xC3,0xF4
.db    0xDA,0x0E
.db    0x16,0xC3
.db    0xC3,0xDA
.db    0x0E,0x17
.db    0xC3,0x05
.db    0x00,0x1E
.db    0xFF,0x0E
.db    0x20,0xC3
.db    0x05,0x00
.db    0xCD,0x13
.db    0xDB,0x87
.db    0x87,0x87
.db    0x87,0x21
.db    0xEF,0xE1
.db    0xB6,0x32
.db    0x04,0x00
.db    0xC9,0x3A
.db    0xEF,0xE1
.db    0x32,0x04
.db    0x00,0xC9
.db    0xFE,0x61
.db    0xD8,0xFE
.db    0x7B,0xD0
.db    0xE6,0x5F
.db    0xC9,0x3A
.db    0xAB,0xE1
.db    0xB7,0xCA
.db    0x96,0xDB
.db    0x3A,0xEF
.db    0xE1,0xB7
.db    0x3E,0x00
.db    0xC4,0xBD
.db    0xDA,0x11
.db    0xAC,0xE1
.db    0xCD,0xCB
.db    0xDA,0xCA
.db    0x96,0xDB
.db    0x3A,0xBB
.db    0xE1,0x3D
.db    0x32,0xCC
.db    0xE1,0x11
.db    0xAC,0xE1
.db    0xCD,0xF9
.db    0xDA,0xC2
.db    0x96,0xDB
.db    0x11,0x07
.db    0xDA,0x21
.db    0x80,0x00
.db    0x06,0x80
.db    0xCD,0x42
.db    0xDE,0x21
.db    0xBA,0xE1
.db    0x36,0x00
.db    0x23,0x35
.db    0x11,0xAC
.db    0xE1,0xCD
.db    0xDA,0xDA
.db    0xCA,0x96
.db    0xDB,0x3A
.db    0xEF,0xE1
.db    0xB7,0xC4
.db    0xBD,0xDA
.db    0x21,0x08
.db    0xDA,0xCD
.db    0xAC,0xDA
.db    0xCD,0xC2
.db    0xDB,0xCA
.db    0xA7,0xDB
.db    0xCD,0xDD
.db    0xDB,0xC3
.db    0x82,0xDD
.db    0xCD,0xDD
.db    0xDB,0xCD
.db    0x1A,0xDB
.db    0x0E,0x0A
.db    0x11,0x06
.db    0xDA,0xCD
.db    0x05,0x00
.db    0xCD,0x29
.db    0xDB,0x21
.db    0x07,0xDA
.db    0x46,0x23
.db    0x78,0xB7
.db    0xCA,0xBA
.db    0xDB,0x7E
.db    0xCD,0x30
.db    0xDB,0x77
.db    0x05,0xC3
.db    0xAB,0xDB
.db    0x77,0x21
.db    0x08,0xDA
.db    0x22,0x88
.db    0xDA,0xC9
.db    0x0E,0x0B
.db    0xCD,0x05
.db    0x00,0xB7
.db    0xC8,0x0E
.db    0x01,0xCD
.db    0x05,0x00
.db    0xB7,0xC9
.db    0x0E,0x19
.db    0xC3,0x05
.db    0x00,0x11
.db    0x80,0x00
.db    0x0E,0x1A
.db    0xC3,0x05
.db    0x00,0x21
.db    0xAB,0xE1
.db    0x7E,0xB7
.db    0xC8,0x36
.db    0x00,0xAF
.db    0xCD,0xBD
.db    0xDA,0x11
.db    0xAC,0xE1
.db    0xCD,0xEF
.db    0xDA,0x3A
.db    0xEF,0xE1
.db    0xC3,0xBD
.db    0xDA,0x11
.db    0x28,0xDD
.db    0x21,0x00
.db    0xE2,0x06
.db    0x06,0x1A
.db    0xBE,0xC2
.db    0xCF,0xDD
.db    0x13,0x23
.db    0x05,0xC2
.db    0xFD,0xDB
.db    0xC9,0xCD
.db    0x98,0xDA
.db    0x2A,0x8A
.db    0xDA,0x7E
.db    0xFE,0x20
.db    0xCA,0x22
.db    0xDC,0xB7
.db    0xCA,0x22
.db    0xDC,0xE5
.db    0xCD,0x8C
.db    0xDA,0xE1
.db    0x23,0xC3
.db    0x0F,0xDC
.db    0x3E,0x3F
.db    0xCD,0x8C
.db    0xDA,0xCD
.db    0x98,0xDA
.db    0xCD,0xDD
.db    0xDB,0xC3
.db    0x82,0xDD
.db    0x1A,0xB7
.db    0xC8,0xFE
.db    0x20,0xDA
.db    0x09,0xDC
.db    0xC8,0xFE
.db    0x3D,0xC8
.db    0xFE,0x5F
.db    0xC8,0xFE
.db    0x2E,0xC8
.db    0xFE,0x3A
.db    0xC8,0xFE
.db    0x3B,0xC8
.db    0xFE,0x3C
.db    0xC8,0xFE
.db    0x3E,0xC8
.db    0xC9,0x1A
.db    0xB7,0xC8
.db    0xFE,0x20
.db    0xC0,0x13
.db    0xC3,0x4F
.db    0xDC,0x85
.db    0x6F,0xD0
.db    0x24,0xC9
.db    0x3E,0x00
.db    0x21,0xCD
.db    0xE1,0xCD
.db    0x59,0xDC
.db    0xE5,0xE5
.db    0xAF,0x32
.db    0xF0,0xE1
.db    0x2A,0x88
.db    0xDA,0xEB
.db    0xCD,0x4F
.db    0xDC,0xEB
.db    0x22,0x8A
.db    0xDA,0xEB
.db    0xE1,0x1A
.db    0xB7,0xCA
.db    0x89,0xDC
.db    0xDE,0x40
.db    0x47,0x13
.db    0x1A,0xFE
.db    0x3A,0xCA
.db    0x90,0xDC
.db    0x1B,0x3A
.db    0xEF,0xE1
.db    0x77,0xC3
.db    0x96,0xDC
.db    0x78,0x32
.db    0xF0,0xE1
.db    0x70,0x13
.db    0x06,0x08
.db    0xCD,0x30
.db    0xDC,0xCA
.db    0xB9,0xDC
.db    0x23,0xFE
.db    0x2A,0xC2
.db    0xA9,0xDC
.db    0x36,0x3F
.db    0xC3,0xAB
.db    0xDC,0x77
.db    0x13,0x05
.db    0xC2,0x98
.db    0xDC,0xCD
.db    0x30,0xDC
.db    0xCA,0xC0
.db    0xDC,0x13
.db    0xC3,0xAF
.db    0xDC,0x23
.db    0x36,0x20
.db    0x05,0xC2
.db    0xB9,0xDC
.db    0x06,0x03
.db    0xFE,0x2E
.db    0xC2,0xE9
.db    0xDC,0x13
.db    0xCD,0x30
.db    0xDC,0xCA
.db    0xE9,0xDC
.db    0x23,0xFE
.db    0x2A,0xC2
.db    0xD9,0xDC
.db    0x36,0x3F
.db    0xC3,0xDB
.db    0xDC,0x77
.db    0x13,0x05
.db    0xC2,0xC8
.db    0xDC,0xCD
.db    0x30,0xDC
.db    0xCA,0xF0
.db    0xDC,0x13
.db    0xC3,0xDF
.db    0xDC,0x23
.db    0x36,0x20
.db    0x05,0xC2
.db    0xE9,0xDC
.db    0x06,0x03
.db    0x23,0x36
.db    0x00,0x05
.db    0xC2,0xF2
.db    0xDC,0xEB
.db    0x22,0x88
.db    0xDA,0xE1
.db    0x01,0x0B
.db    0x00,0x23
.db    0x7E,0xFE
.db    0x3F,0xC2
.db    0x09,0xDD
.db    0x04,0x0D
.db    0xC2,0x01
.db    0xDD,0x78
.db    0xB7,0xC9
.db    0x44,0x49
.db    0x52,0x20
.db    0x45,0x52
.db    0x41,0x20
.db    0x54,0x59
.db    0x50,0x45
.db    0x53,0x41
.db    0x56,0x45
.db    0x52,0x45
.db    0x4E,0x20
.db    0x55,0x53
.db    0x45,0x52
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x21,0x10
.db    0xDD,0x0E
.db    0x00,0x79
.db    0xFE,0x06
.db    0xD0,0x11
.db    0xCE,0xE1
.db    0x06,0x04
.db    0x1A,0xBE
.db    0xC2,0x4F
.db    0xDD,0x13
.db    0x23,0x05
.db    0xC2,0x3C
.db    0xDD,0x1A
.db    0xFE,0x20
.db    0xC2,0x54
.db    0xDD,0x79
.db    0xC9,0x23
.db    0x05,0xC2
.db    0x4F,0xDD
.db    0x0C,0xC3
.db    0x33,0xDD
.db    0xAF,0x32
.db    0x07,0xDA
.db    0x31,0xAB
.db    0xE1,0xC5
.db    0x79,0x1F
.db    0x1F,0x1F
.db    0x1F,0xE6
.db    0x0F,0x5F
.db    0xCD,0x15
.db    0xDB,0xCD
.db    0xB8,0xDA
.db    0x32,0xAB
.db    0xE1,0xC1
.db    0x79,0xE6
.db    0x0F,0x32
.db    0xEF,0xE1
.db    0xCD,0xBD
.db    0xDA,0x3A
.db    0x07,0xDA
.db    0xB7,0xC2
.db    0x98,0xDD
.db    0x31,0xAB
.db    0xE1,0xCD
.db    0x98,0xDA
.db    0xCD,0xD0
.db    0xDB,0xC6
.db    0x41,0xCD
.db    0x8C,0xDA
.db    0x3E,0x3E
.db    0xCD,0x8C
.db    0xDA,0xCD
.db    0x39,0xDB
.db    0x11,0x80
.db    0x00,0xCD
.db    0xD8,0xDB
.db    0xCD,0xD0
.db    0xDB,0x32
.db    0xEF,0xE1
.db    0xCD,0x5E
.db    0xDC,0xC4
.db    0x09,0xDC
.db    0x3A,0xF0
.db    0xE1,0xB7
.db    0xC2,0xA5
.db    0xE0,0xCD
.db    0x2E,0xDD
.db    0x21,0xC1
.db    0xDD,0x5F
.db    0x16,0x00
.db    0x19,0x19
.db    0x7E,0x23
.db    0x66,0x6F
.db    0xE9,0x77
.db    0xDE,0x1F
.db    0xDF,0x5D
.db    0xDF,0xAD
.db    0xDF,0x10
.db    0xE0,0x8E
.db    0xE0,0xA5
.db    0xE0,0x3E
.db    0x43,0xCD
.db    0x8C,0xDA
.db    0x3E,0x58
.db    0x00,0x18
.db    0xF8,0x01
.db    0xDF,0xDD
.db    0xC3,0xA7
.db    0xDA,0x52
.db    0x45,0x41
.db    0x44,0x20
.db    0x45,0x52
.db    0x52,0x4F
.db    0x52,0x00
.db    0x01,0xF0
.db    0xDD,0xC3
.db    0xA7,0xDA
.db    0x4E,0x4F
.db    0x20,0x46
.db    0x49,0x4C
.db    0x45,0x00
.db    0xCD,0x5E
.db    0xDC,0x3A
.db    0xF0,0xE1
.db    0xB7,0xC2
.db    0x09,0xDC
.db    0x21,0xCE
.db    0xE1,0x01
.db    0x0B,0x00
.db    0x7E,0xFE
.db    0x20,0xCA
.db    0x33,0xDE
.db    0x23,0xD6
.db    0x30,0xFE
.db    0x0A,0xD2
.db    0x09,0xDC
.db    0x57,0x78
.db    0xE6,0xE0
.db    0xC2,0x09
.db    0xDC,0x78
.db    0x07,0x07
.db    0x07,0x80
.db    0xDA,0x09
.db    0xDC,0x80
.db    0xDA,0x09
.db    0xDC,0x82
.db    0xDA,0x09
.db    0xDC,0x47
.db    0x0D,0xC2
.db    0x08,0xDE
.db    0xC9,0x7E
.db    0xFE,0x20
.db    0xC2,0x09
.db    0xDC,0x23
.db    0x0D,0xC2
.db    0x33,0xDE
.db    0x78,0xC9
.db    0x06,0x03
.db    0x7E,0x12
.db    0x23,0x13
.db    0x05,0xC2
.db    0x42,0xDE
.db    0xC9,0x21
.db    0x80,0x00
.db    0x81,0xCD
.db    0x59,0xDC
.db    0x7E,0xC9
.db    0xAF,0x32
.db    0xCD,0xE1
.db    0x3A,0xF0
.db    0xE1,0xB7
.db    0xC8,0x3D
.db    0x21,0xEF
.db    0xE1,0xBE
.db    0xC8,0xC3
.db    0xBD,0xDA
.db    0x3A,0xF0
.db    0xE1,0xB7
.db    0xC8,0x3D
.db    0x21,0xEF
.db    0xE1,0xBE
.db    0xC8,0x3A
.db    0xEF,0xE1
.db    0xC3,0xBD
.db    0xDA,0xCD
.db    0x5E,0xDC
.db    0xCD,0x54
.db    0xDE,0x21
.db    0xCE,0xE1
.db    0x7E,0xFE
.db    0x20,0xC2
.db    0x8F,0xDE
.db    0x06,0x0B
.db    0x36,0x3F
.db    0x23,0x05
.db    0xC2,0x88
.db    0xDE,0x1E
.db    0x00,0xD5
.db    0xCD,0xE9
.db    0xDA,0xCC
.db    0xEA,0xDD
.db    0xCA,0x1B
.db    0xDF,0x3A
.db    0xEE,0xE1
.db    0x0F,0x0F
.db    0x0F,0xE6
.db    0x60,0x4F
.db    0x3E,0x0A
.db    0xCD,0x4B
.db    0xDE,0x17
.db    0xDA,0x0F
.db    0xDF,0xD1
.db    0x7B,0x1C
.db    0xD5,0xE6
.db    0x03,0xF5
.db    0xC2,0xCC
.db    0xDE,0xCD
.db    0x98,0xDA
.db    0xC5,0xCD
.db    0xD0,0xDB
.db    0xC1,0xC6
.db    0x41,0xCD
.db    0x92,0xDA
.db    0x3E,0x3A
.db    0xCD,0x92
.db    0xDA,0xC3
.db    0xD4,0xDE
.db    0xCD,0xA2
.db    0xDA,0x3E
.db    0x3A,0xCD
.db    0x92,0xDA
.db    0xCD,0xA2
.db    0xDA,0x06
.db    0x01,0x78
.db    0xCD,0x4B
.db    0xDE,0xE6
.db    0x7F,0xFE
.db    0x20,0xC2
.db    0xF9,0xDE
.db    0xF1,0xF5
.db    0xFE,0x03
.db    0xC2,0xF7
.db    0xDE,0x3E
.db    0x09,0xCD
.db    0x4B,0xDE
.db    0xE6,0x7F
.db    0xFE,0x20
.db    0xCA,0x0E
.db    0xDF,0x3E
.db    0x20,0xCD
.db    0x92,0xDA
.db    0x04,0x78
.db    0xFE,0x0C
.db    0xD2,0x0E
.db    0xDF,0xFE
.db    0x09,0xC2
.db    0xD9,0xDE
.db    0xCD,0xA2
.db    0xDA,0xC3
.db    0xD9,0xDE
.db    0xF1,0xCD
.db    0xC2,0xDB
.db    0xC2,0x1B
.db    0xDF,0xCD
.db    0xE4,0xDA
.db    0xC3,0x98
.db    0xDE,0xD1
.db    0xC3,0x86
.db    0xE1,0xCD
.db    0x5E,0xDC
.db    0xFE,0x0B
.db    0xC2,0x42
.db    0xDF,0x01
.db    0x52,0xDF
.db    0xCD,0xA7
.db    0xDA,0xCD
.db    0x39,0xDB
.db    0x21,0x07
.db    0xDA,0x35
.db    0xC2,0x82
.db    0xDD,0x23
.db    0x7E,0xFE
.db    0x59,0xC2
.db    0x82,0xDD
.db    0x23,0x22
.db    0x88,0xDA
.db    0xCD,0x54
.db    0xDE,0x11
.db    0xCD,0xE1
.db    0xCD,0xEF
.db    0xDA,0x3C
.db    0xCC,0xEA
.db    0xDD,0xC3
.db    0x86,0xE1
.db    0x41,0x4C
.db    0x4C,0x20
.db    0x28,0x59
.db    0x2F,0x4E
.db    0x29,0x3F
.db    0x00,0xCD
.db    0x5E,0xDC
.db    0xC2,0x09
.db    0xDC,0xCD
.db    0x54,0xDE
.db    0xCD,0xD0
.db    0xDA,0xCA
.db    0xA7,0xDF
.db    0xCD,0x98
.db    0xDA,0x21
.db    0xF1,0xE1
.db    0x36,0xFF
.db    0x21,0xF1
.db    0xE1,0x7E
.db    0xFE,0x80
.db    0xDA,0x87
.db    0xDF,0xE5
.db    0xCD,0xFE
.db    0xDA,0xE1
.db    0xC2,0xA0
.db    0xDF,0xAF
.db    0x77,0x34
.db    0x21,0x80
.db    0x00,0xCD
.db    0x59,0xDC
.db    0x7E,0xFE
.db    0x1A,0xCA
.db    0x86,0xE1
.db    0xCD,0x8C
.db    0xDA,0xCD
.db    0xC2,0xDB
.db    0xC2,0x86
.db    0xE1,0xC3
.db    0x74,0xDF
.db    0x3D,0xCA
.db    0x86,0xE1
.db    0xCD,0xD9
.db    0xDD,0xCD
.db    0x66,0xDE
.db    0xC3,0x09
.db    0xDC,0xCD
.db    0xF8,0xDD
.db    0xF5,0xCD
.db    0x5E,0xDC
.db    0xC2,0x09
.db    0xDC,0xCD
.db    0x54,0xDE
.db    0x11,0xCD
.db    0xE1,0xD5
.db    0xCD,0xEF
.db    0xDA,0xD1
.db    0xCD,0x09
.db    0xDB,0xCA
.db    0xFB,0xDF
.db    0xAF,0x32
.db    0xED,0xE1
.db    0xF1,0x6F
.db    0x26,0x00
.db    0x29,0x11
.db    0x00,0x01
.db    0x7C,0xB5
.db    0xCA,0xF1
.db    0xDF,0x2B
.db    0xE5,0x21
.db    0x80,0x00
.db    0x19,0xE5
.db    0xCD,0xD8
.db    0xDB,0x11
.db    0xCD,0xE1
.db    0xCD,0x04
.db    0xDB,0xD1
.db    0xE1,0xC2
.db    0xFB,0xDF
.db    0xC3,0xD4
.db    0xDF,0x11
.db    0xCD,0xE1
.db    0xCD,0xDA
.db    0xDA,0x3C
.db    0xC2,0x01
.db    0xE0,0x01
.db    0x07,0xE0
.db    0xCD,0xA7
.db    0xDA,0xCD
.db    0xD5,0xDB
.db    0xC3,0x86
.db    0xE1,0x4E
.db    0x4F,0x20
.db    0x53,0x50
.db    0x41,0x43
.db    0x45,0x00
.db    0xCD,0x5E
.db    0xDC,0xC2
.db    0x09,0xDC
.db    0x3A,0xF0
.db    0xE1,0xF5
.db    0xCD,0x54
.db    0xDE,0xCD
.db    0xE9,0xDA
.db    0xC2,0x79
.db    0xE0,0x21
.db    0xCD,0xE1
.db    0x11,0xDD
.db    0xE1,0x06
.db    0x10,0xCD
.db    0x42,0xDE
.db    0x2A,0x88
.db    0xDA,0xEB
.db    0xCD,0x4F
.db    0xDC,0xFE
.db    0x3D,0xCA
.db    0x3F,0xE0
.db    0xFE,0x5F
.db    0xC2,0x73
.db    0xE0,0xEB
.db    0x23,0x22
.db    0x88,0xDA
.db    0xCD,0x5E
.db    0xDC,0xC2
.db    0x73,0xE0
.db    0xF1,0x47
.db    0x21,0xF0
.db    0xE1,0x7E
.db    0xB7,0xCA
.db    0x59,0xE0
.db    0xB8,0x70
.db    0xC2,0x73
.db    0xE0,0x70
.db    0xAF,0x32
.db    0xCD,0xE1
.db    0xCD,0xE9
.db    0xDA,0xCA
.db    0x6D,0xE0
.db    0x11,0xCD
.db    0xE1,0xCD
.db    0x0E,0xDB
.db    0xC3,0x86
.db    0xE1,0xCD
.db    0xEA,0xDD
.db    0xC3,0x86
.db    0xE1,0xCD
.db    0x66,0xDE
.db    0xC3,0x09
.db    0xDC,0x01
.db    0x82,0xE0
.db    0xCD,0xA7
.db    0xDA,0xC3
.db    0x86,0xE1
.db    0x46,0x49
.db    0x4C,0x45
.db    0x20,0x45
.db    0x58,0x49
.db    0x53,0x54
.db    0x53,0x00
.db    0xCD,0xF8
.db    0xDD,0xFE
.db    0x10,0xD2
.db    0x09,0xDC
.db    0x5F,0x3A
.db    0xCE,0xE1
.db    0xFE,0x20
.db    0xCA,0x09
.db    0xDC,0xCD
.db    0x15,0xDB
.db    0xC3,0x89
.db    0xE1,0xCD
.db    0xF5,0xDB
.db    0x3A,0xCE
.db    0xE1,0xFE
.db    0x20,0xC2
.db    0xC4,0xE0
.db    0x3A,0xF0
.db    0xE1,0xB7
.db    0xCA,0x89
.db    0xE1,0x3D
.db    0x32,0xEF
.db    0xE1,0xCD
.db    0x29,0xDB
.db    0xCD,0xBD
.db    0xDA,0xC3
.db    0x89,0xE1
.db    0x11,0xD6
.db    0xE1,0x1A
.db    0xFE,0x20
.db    0xC2,0x09
.db    0xDC,0xD5
.db    0xCD,0x54
.db    0xDE,0xD1
.db    0x21,0x83
.db    0xE1,0xCD
.db    0x40,0xDE
.db    0xCD,0xD0
.db    0xDA,0xCA
.db    0x6B,0xE1
.db    0x21,0x00
.db    0x01,0xE5
.db    0xEB,0xCD
.db    0xD8,0xDB
.db    0x11,0xCD
.db    0xE1,0xCD
.db    0xF9,0xDA
.db    0xC2,0x01
.db    0xE1,0xE1
.db    0x11,0x80
.db    0x00,0x19
.db    0x11,0x00
.db    0xDA,0x7D
.db    0x93,0x7C
.db    0x9A,0xD2
.db    0x71,0xE1
.db    0xC3,0xE1
.db    0xE0,0xE1
.db    0x3D,0xC2
.db    0x71,0xE1
.db    0xCD,0x66
.db    0xDE,0xCD
.db    0x5E,0xDC
.db    0x21,0xF0
.db    0xE1,0xE5
.db    0x7E,0x32
.db    0xCD,0xE1
.db    0x3E,0x10
.db    0xCD,0x60
.db    0xDC,0xE1
.db    0x7E,0x32
.db    0xDD,0xE1
.db    0xAF,0x32
.db    0xED,0xE1
.db    0x11,0x5C
.db    0x00,0x21
.db    0xCD,0xE1
.db    0x06,0x21
.db    0xCD,0x42
.db    0xDE,0x21
.db    0x08,0xDA
.db    0x7E,0xB7
.db    0xCA,0x3E
.db    0xE1,0xFE
.db    0x20,0xCA
.db    0x3E,0xE1
.db    0x23,0xC3
.db    0x30,0xE1
.db    0x06,0x00
.db    0x11,0x81
.db    0x00,0x7E
.db    0x12,0xB7
.db    0xCA,0x4F
.db    0xE1,0x04
.db    0x23,0x13
.db    0xC3,0x43
.db    0xE1,0x78
.db    0x32,0x80
.db    0x00,0xCD
.db    0x98,0xDA
.db    0xCD,0xD5
.db    0xDB,0xCD
.db    0x1A,0xDB
.db    0xCD,0x00
.db    0x01,0x31
.db    0xAB,0xE1
.db    0xCD,0x29
.db    0xDB,0xCD
.db    0xBD,0xDA
.db    0xC3,0x82
.db    0xDD,0xCD
.db    0x66,0xDE
.db    0xC3,0x09
.db    0xDC,0x01
.db    0x7A,0xE1
.db    0xCD,0xA7
.db    0xDA,0xC3
.db    0x86,0xE1
.db    0x42,0x41
.db    0x44,0x20
.db    0x4C,0x4F
.db    0x41,0x44
.db    0x00,0x43
.db    0x4F,0x4D
.db    0xCD,0x66
.db    0xDE,0xCD
.db    0x5E,0xDC
.db    0x3A,0xCE
.db    0xE1,0xD6
.db    0x20,0x21
.db    0xF0,0xE1
.db    0xB6,0xC2
.db    0x09,0xDC
.db    0xC3,0x82
.db    0xDD,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x24
.db    0x24,0x24
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x53
.db    0x55,0x42
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x00
.db    0x00,0x00
.db    0x2B,0x00
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x01,0x00
.db    0x00,0x4E
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
DISK_ARR:
.db    0x00,0x48
.db    0x57,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x43
.db    0x4F,0x4D
.db    0x00,0x00
.db    0x00,0x01
.db    0x02,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0x11,0x0B
.db    0x01,0x0E
.db    0x09,0xCD
.db    0x05,0x00
.db    0xC3,0x00
.db    0x00,0x48
.db    0x61,0x6C
.db    0x6C,0x6F
.db    0x20,0x57
.db    0x65,0x6C
.db    0x74,0x21
.db    0x21,0x0D
.db    0x0A,0x24
.db    0x86,0xF1
.db    0x01,0x5C
.db    0xCA,0x6C
.db    0x3A,0x08
.db    0x44,0x20
.db    0xD0,0x50
.db    0x92,0x70
.db    0x00,0x00
.db    0x9E,0x1A
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
.db    0xE5,0xE5
 
; *** Konstanten-STRING-Liste ***
;
 
M_CONST_STRING_0:
 .db    0, " "
 
M_CONST_STRING_1:
 .db    50, "XX 00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F "
 
M_CONST_STRING_2:
 .db    2, "00 "
 
M_CONST_STRING_3:
 .db    1, " "
 
M_CONST_STRING_4:
 .db    3, " .."
 
M_CONST_STRING_5:
 .db    8, "Adresse= "
 
M_CONST_STRING_6:
 .db    4, "A0=1 "
 
M_CONST_STRING_7:
 .db    4, "A0=0 "
 
M_CONST_STRING_8:
 .db    4, "A1=1 "
 
M_CONST_STRING_9:
 .db    4, "A1=0 "
 
M_CONST_STRING_10:
 .db    6, "Daten= "
 
M_CONST_STRING_11:
 .db    1, "s"
 
M_CONST_STRING_12:
 .db    3, "x01"
 
M_CONST_STRING_13:
 .db    3, "x03"
 
M_CONST_STRING_14:
 .db    3, "x07"
 
M_CONST_STRING_15:
 .db    3, "x02"
 
M_CONST_STRING_16:
 .db    0, " "
 
M_CONST_STRING_17:
 .db    1, "u"
 
M_CONST_STRING_18:
 .db    3, "x04"
 
M_CONST_STRING_19:
 .db    1, "r"
 
M_CONST_STRING_20:
 .db    3, "x08"
 
M_CONST_STRING_21:
 .db    1, "v"
 
M_CONST_STRING_22:
 .db    1, "j"
 
M_CONST_STRING_23:
 .db    3, "x11"
 
M_CONST_STRING_24:
 .db    1, "i"
 
M_CONST_STRING_25:
 .db    3, "x12"
 
M_CONST_STRING_26:
 .db    1, "o"
 
M_CONST_STRING_27:
 .db    0, " "
 
